package com.yihu.jw.application.dao;

import com.yihu.jw.entity.base.application.BaseApplicationMenuDO;
import com.yihu.jw.entity.base.area.BaseCityDO;
import com.yihu.jw.entity.base.dict.DictIcd10DO;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Query;

import java.util.List;


/**
 */
public interface BaseApplicationMenuDao extends JpaRepository<BaseApplicationMenuDO, String>, JpaSpecificationExecutor<BaseApplicationMenuDO> {

    @Query("select p from BaseApplicationMenuDO p where p.type = ?1 and p.status=1 order by p.menuSort desc")
    List<BaseApplicationMenuDO> getParentList(String type);

    @Query("from BaseApplicationMenuDO p where  p.name like %?2% and  p.type = ?1  and p.status=1 order by p.menuSort desc")
    List<BaseApplicationMenuDO> getTypeAndNameList(String type,String name);

    @Query("select p from BaseApplicationMenuDO p where p.type = ?1 and p.parentId=?2 and p.status=1 order by p.menuSort desc ")
    List<BaseApplicationMenuDO> getChildBuParent(String type,String parentId);

}