package com.yihu.jw.area.dao;

import com.yihu.jw.entity.base.area.BaseTownDO;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

import java.util.List;

/**
 * 区县字典 数据库访问层
 *
 * @version <pre>
 *          Author	Version		Date		Changes
 *          litaohong 	1.0  		2018年08月31日 	Created
 *
 *          </pre>
 * @since 1.
 */
public interface BaseTownDao extends JpaRepository<BaseTownDO, Integer>, JpaSpecificationExecutor<BaseTownDO> {

    @Query("select name from BaseTownDO where code =:code")
    String getNameByCode(@Param("code") String code);


    @Query("select p from BaseTownDO p where p.code = ?1")
    BaseTownDO findByCode(String code);


    @Query("select a from BaseTownDO a where a.city = ?1 order by id")
    List<BaseTownDO> findByCityCode(String city);



    @Query("select a from BaseTownDO a where a.city = ?1 order by id")
    Iterable<BaseTownDO> findByCity(String province);

    @Query("select p from BaseTownDO p where p.name = ?1")
    BaseTownDO findByName(String name);

    @Query("select p from BaseTownDO p where p.name = ?1 and p.city = ?2")
    BaseTownDO findByNameAndCity(String name,String city);


}