package com.yihu.jw.area.service;

import com.alibaba.fastjson.JSONObject;
import com.yihu.jw.area.dao.BaseInpatientAreaDao;
import com.yihu.jw.area.dao.BaseInpatientAreaDoctorDao;
import com.yihu.jw.contant.CommonContant;
import com.yihu.jw.doctor.dao.BaseDoctorRoleDao;
import com.yihu.jw.entity.base.area.BaseInpatientAreaDO;
import com.yihu.jw.entity.base.area.BaseInpatientAreaDoctorDO;
import com.yihu.jw.entity.base.doctor.BaseDoctorRoleDO;
import com.yihu.jw.mysql.query.BaseJpaService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * Created by yeshijie on 2022/12/2.
 */
@Service
public class BaseInpatientAreaService  extends BaseJpaService<BaseInpatientAreaDO, BaseInpatientAreaDao> {

    @Autowired
    private BaseInpatientAreaDao inpatientAreaDao;
    @Autowired
    private BaseDoctorRoleDao doctorRoleDao;
    @Autowired
    private BaseInpatientAreaDoctorDao inpatientAreaDoctorDao;

    @Transactional(rollbackFor = Exception.class)
    public void updDel(String id,Integer del){
        BaseInpatientAreaDoctorDO areaDoctorDO = inpatientAreaDoctorDao.findById(id).orElse(null);
        if(areaDoctorDO!=null){
            areaDoctorDO.setDel(del);
            inpatientAreaDoctorDao.save(areaDoctorDO);
            doctorRoleDao.updDel(areaDoctorDO.getDoctorCode(),CommonContant.DR_INPATIENTAREA,del);
        }
    }

    @Transactional(rollbackFor = Exception.class)
    public void delAreaDoctor(String id){
        BaseInpatientAreaDoctorDO areaDoctorDO = inpatientAreaDoctorDao.findById(id).orElse(null);
        if(areaDoctorDO!=null){
            String doctor = areaDoctorDO.getDoctorCode();
            List<BaseInpatientAreaDoctorDO> areaDoctorDOS = inpatientAreaDoctorDao.findListByDoctor(doctor,1);
            if(areaDoctorDOS.size()<=1){
                //删除角色
                doctorRoleDao.delRole(doctor, CommonContant.DR_INPATIENTAREA);
            }
            inpatientAreaDoctorDao.deleteById(id);
        }
    }


    @Transactional(rollbackFor = Exception.class)
    public BaseInpatientAreaDoctorDO addAreaDoctor(JSONObject json,String roleCode){
        String inpatientAreaId = json.getString("inpatientAreaId");
        String doctorCode = json.getString("doctorCode");

        BaseInpatientAreaDoctorDO areaDoctorDO = inpatientAreaDoctorDao.findByDoctorAndInpatientAreaId(doctorCode,inpatientAreaId);
        if(areaDoctorDO==null){
            areaDoctorDO = new BaseInpatientAreaDoctorDO();
            areaDoctorDO.setDoctorCode(doctorCode);
            areaDoctorDO.setInpatientAreaId(inpatientAreaId);
        }
        areaDoctorDO.setDel(1);
        inpatientAreaDoctorDao.save(areaDoctorDO);

        //添加角色
        BaseDoctorRoleDO roleDO = doctorRoleDao.findByDoctorCodeAndRoleCode(doctorCode,roleCode);
        if(roleDO==null){
            roleDO = new BaseDoctorRoleDO();
            roleDO.setDel(1);
            roleDO.setRoleCode(roleCode);
            roleDO.setDoctorCode(doctorCode);
        }else {
            roleDO.setDel(1);
        }
        doctorRoleDao.save(roleDO);
        return areaDoctorDO;
    }

}
