package com.yihu.jw.article.dao;

import com.yihu.jw.entity.hospital.article.KnowledgeArticleDictDO;
import com.yihu.jw.entity.hospital.article.KnowledgeArticleDoctorDO;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import javax.persistence.Transient;
import java.util.List;


/**
 * 医生文章关系表
 */
public interface KnowledgeArticleDoctorDao extends JpaRepository<KnowledgeArticleDoctorDO, String>, JpaSpecificationExecutor<KnowledgeArticleDoctorDO> {

    @Query("select a from KnowledgeArticleDoctorDO a where a.baseArticleDoctorId=?1 and a.type=?2 order by a.createTime desc")
    List<KnowledgeArticleDoctorDO> findByBaseArticleDoctorIdAndType(String baseArticleDoctorId,Integer type);

    @Query("select a from KnowledgeArticleDoctorDO a where a.relationCode=?1 and a.type=?2 and a.user=?3 and (a.baseArticleDoctorId is null or a.baseArticleDoctorId ='') order by a.createTime desc")
    List<KnowledgeArticleDoctorDO> findByRelationCodeAndTypeAndUser(String relationCode,Integer type,String user);//根据业务code获取医生文章/医生关系

    @Query("select a from KnowledgeArticleDoctorDO a where a.relationCode=?1 and a.type=?2 and a.user=?3 and a.baseArticleDoctorId=?4 order by a.createTime desc")
    List<KnowledgeArticleDoctorDO> findByBaseArticleDoctorIdAndRelationCodeAndTypeAndUser(String relationCode,Integer type,String user,String baseArticleDoctorId);//根据业务code获取医生文章/医生关系

    @Modifying
    @Query("delete from KnowledgeArticleDoctorDO  where baseArticleDoctorId=?1 and user=?2 and type=?3")
    void deletByBaseArticleDoctorIdAndType(String baseArticleDoctorId,String user,Integer type);

    @Modifying
    @Query("delete from KnowledgeArticleDoctorDO  where relationCode=?1 and user=?2 and type=?3 ")
    void deletByRelationCodeAndType(String relationCode,String user,Integer type);

    @Query("select a from KnowledgeArticleDoctorDO a where a.relationCode=?1 and a.type=?2 order by a.createTime desc")
    List<KnowledgeArticleDoctorDO> findByRelationCodeAndType(String relationCode,Integer type);


}
