package com.yihu.jw.dailyReport.dao;

import com.yihu.jw.entity.dailyReport.BaseDailyReportUploadDO;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Query;

import java.util.Date;
import java.util.List;

/**
 * Created by Bing on 2022/7/25.
 */
public interface BaseDailyReportUploadDao extends JpaRepository<BaseDailyReportUploadDO, String>,
        JpaSpecificationExecutor<BaseDailyReportUploadDO> {

    List<BaseDailyReportUploadDO> findByDoctorId(String doctorID);

    @Query("select b from BaseDailyReportUploadDO b where b.doctorId=?1 and b.reportDate=?2")
    BaseDailyReportUploadDO findByDoctorIdAndReportDate(String doctorID,String reportDate);

    @Query("select b from BaseDailyReportUploadDO b where b.doctorId=?1 order by b.reportDate desc")
    List<BaseDailyReportUploadDO> findByDoctorIdLastOne(String doctorID);

    @Query("select a from BaseDailyReportUploadDO a where a.doctorId=?1 and a.reportDate>=?2 and a.reportDate<=?3 order by a.reportDate desc")
    Page<BaseDailyReportUploadDO> selectDailyReportByDoctorAndDateAndPage(String doctor, String startDate, String endDate, Pageable pageRequest);

    @Query("select a from BaseDailyReportUploadDO a where a.doctorId=?1 and a.reportDate>=?2 and a.reportDate<=?3 order by a.reportDate desc")
    List<BaseDailyReportUploadDO> selectDailyReportByDoctorAndDate(String doctor, String startDate, String endDate);

    @Query("select a from BaseDailyReportUploadDO a where a.doctorId=?1 order by a.reportDate desc")
    Page<BaseDailyReportUploadDO> selectDailyReportByDoctorAndPage(String doctor, Pageable pageRequest);

    @Query("select a from BaseDailyReportUploadDO a where a.doctorId=?1 order by a.reportDate desc")
    List<BaseDailyReportUploadDO> selectDailyReportByDoctor(String doctor);
}
