package com.yihu.jw.dict.dao;

import com.yihu.jw.entity.base.dict.DictDoctorDutyDO;
import org.hibernate.validator.constraints.EAN;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.repository.PagingAndSortingRepository;

import java.util.List;


/**
 * 
 * 医生职务字典 数据库访问层
 * 
 * @version 
 * <pre>
 * Author	Version		Date		Changes
 * litaohong 	1.0  		2018年10月19日 	Created
 *
 * </pre>
 * @since 1.
 */
public interface DictDoctorDutyDao extends JpaRepository<DictDoctorDutyDO, Integer>, JpaSpecificationExecutor<DictDoctorDutyDO>  {

    boolean existsByCode(String code);

    DictDoctorDutyDO findByCode(String code);

    List<DictDoctorDutyDO> findByName(String name);
}