package com.yihu.jw.dict.service;

import com.yihu.jw.area.dao.BaseCityDao;
import com.yihu.jw.dict.dao.DictHospitalDeptDao;
import com.yihu.jw.entity.base.area.BaseCityDO;
import com.yihu.jw.entity.base.dict.DictHospitalDeptDO;
import com.yihu.jw.mysql.query.BaseJpaService;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.BeanPropertyRowMapper;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;

import java.util.List;


@Service
public class HospitalDeptService extends BaseJpaService<BaseCityDO, BaseCityDao> {
    @Autowired
    private DictHospitalDeptDao dictHospitalDeptDao;
    @Autowired
    private JdbcTemplate jdbcTemplate;

    // 基于机构编码，获取该机构下所有的科室列表
    public List<DictHospitalDeptDO> getHosDeptByCode(String orgCode,String consultDeptFlag,String name) {
        String sql = "select * from dict_hospital_dept where 1=1";
        if(StringUtils.isNotBlank(orgCode)){
            sql+=" and org_code = '"+orgCode+"' ";
        }
        if(StringUtils.isNotBlank(consultDeptFlag)){
            sql += " and consult_dept_flag = '"+consultDeptFlag+"' ";
        }
        if(StringUtils.isNotBlank(name)){
            sql += " and name like '%"+name+"%' ";
        }
        return jdbcTemplate.query(sql,new BeanPropertyRowMapper<>(DictHospitalDeptDO.class));
    }


}
