package com.yihu.jw.doctor.dao;

import com.yihu.jw.entity.base.doctor.BaseDoctorRoleDO;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;

import java.util.List;
import java.util.Set;


/**
 * 
 * 医生与业务模块角色关联信息 数据库访问层
 * 
 * @version 
 * <pre>
 * Author	Version		Date		Changes
 * litaohong 	1.0  		2018年10月25日 	Created
 *
 * </pre>
 * @since 1.
 */
public interface BaseDoctorRoleDao extends JpaRepository<BaseDoctorRoleDO, Integer>, JpaSpecificationExecutor<BaseDoctorRoleDO>  {

    @Query("from BaseDoctorRoleDO where roleCode = ?1 and del=1")
    List<BaseDoctorRoleDO> findByRoleCode(String roleCode);

    @Query("select id from BaseDoctorRoleDO where doctorCode = ?1 and del=1")
    Set<Object> findIdListByDoctorCode(String doctorCode);

    @Query("from BaseDoctorRoleDO where doctorCode = ?1 and del=1")
    List<BaseDoctorRoleDO> findByDoctorCode(String doctorCode);

    @Query("from BaseDoctorRoleDO where doctorCode = ?1 and roleCode = ?2 and del=1")
    BaseDoctorRoleDO findByDoctorCodeAndRoleCode(String doctorCode,String roleCode);

    @Query("from BaseDoctorRoleDO where doctorCode = ?1 and roleCode = ?2 and del=?3")
    BaseDoctorRoleDO findByDoctorCodeAndRoleCodeAndDel(String doctorCode,String roleCode,Integer del);

    @Modifying
    @Query("update BaseDoctorRoleDO set del=?3 where doctorCode = ?1 and roleCode = ?2")
    int updDel(String doctorCode,String roleCode,Integer del);

    @Modifying
    @Query("delete from BaseDoctorRoleDO where doctorCode = ?1 and roleCode = ?2")
    int delRole(String doctorCode,String roleCode);
}
