package com.yihu.jw.doctor.service;


import com.yihu.jw.doctor.dao.BaseDoctorRoleDao;
import com.yihu.jw.entity.base.doctor.BaseDoctorRoleDO;
import com.yihu.jw.mysql.query.BaseJpaService;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.PageEnvelop;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;

import java.util.*;
import java.util.stream.Collectors;

/**
 * 
 * 医生与业务模块角色关联信息服务service
 * 
 * @version 
 * <pre>
 * Author	Version		Date		Changes
 * litaohong    1.0  2018年10月25日 Created
 *
 * </pre>
 * @since 1.
 */
@Service
public class BaseDoctorRoleService extends BaseJpaService<BaseDoctorRoleDO, BaseDoctorRoleDao> {
    @Autowired
    private BaseDoctorRoleDao baseDoctorRoleDao;
    @Autowired
    private JdbcTemplate jdbcTemplate;

    public Envelop page (String roleCode,String name,String idcard,int page,int size) {

        String sql = "SELECT r.role_code roleCode,d.id doctorCode,d.name,d.idcard,d.mobile  " ;
        String countSql = " select count(d.id) ";
        String from = " from base_doctor_role r,base_doctor d";
        String filters = " where r.role_code = '"+roleCode+"' and r.doctor_code = d.id";
        String limit = " limit "+(page-1)+","+size;
        if("inpatientArea".equals(roleCode)){
            sql += ",aa.id,cast(aa.del as UNSIGNED) del,aa.name inpatientAreaName";
            from += ",(SELECT a.name,ad.* from base_inpatient_area a,base_inpatient_area_doctor ad " +
                    "WHERE a.id=ad.inpatient_area_id and a.del=1) aa";
            filters += " and r.doctor_code = aa.doctor_code";
        }else {
            sql += ",r.id,cast(r.del as UNSIGNED) del";
        }
        if(StringUtils.isNotBlank(idcard)){
            filters += " and d.idcard like '%"+idcard+"%'";
        }
        if(StringUtils.isNotBlank(name)){
            filters += " and d.name like '%"+name+"%'";
        }

        List<Map<String,Object>> list = jdbcTemplate.queryForList(sql+from+filters+limit);

        Long count = jdbcTemplate.queryForObject(countSql+from+filters+limit,Long.class);
        return PageEnvelop.getSuccessListWithPage("获取成功",list, page, size, count);
    }


    /**
     * 根据医生标识获取医生相关联的角色Id列表
     *
     * @param doctorCode
     * @return
     */
    public Set<Object> findRoleIdList(String doctorCode) {
        Set<Object> result = new HashSet<>();
        if (StringUtils.isEmpty(doctorCode)) {
            return result;
        }
        return baseDoctorRoleDao.findIdListByDoctorCode(doctorCode);
    }

    /**
     * 根据医生标识获取医生相关联的角色Id列表
     *
     * @param doctorCode
     * @return
     */
    public List<BaseDoctorRoleDO> queryDoctorRoleList(String doctorCode) {
        List<BaseDoctorRoleDO> result = new ArrayList<>();
        if (StringUtils.isEmpty(doctorCode)) {
            return result;
        }
        return baseDoctorRoleDao.findByDoctorCode(doctorCode);
    }

    /**
     * 获取医生角色
     * @param doctorId
     * @return
     */
    public Map<String,Boolean> getDoctorRole(String doctorId,String roleCode){
        Map<String,Boolean> map = new HashMap<>();
        List<BaseDoctorRoleDO> result = baseDoctorRoleDao.findByDoctorCode(doctorId);
        List<String> roleList = result.stream().map(p->p.getRoleCode()).collect(Collectors.toList());
        if(StringUtils.isNotBlank(roleCode)){
            map.put(roleCode,roleList.contains(roleCode));
        }else {
            map.put("inpatientArea",roleList.contains("inpatientArea"));
            map.put("articleReviewer",roleList.contains("articleReviewer"));
        }
        return map;
    }
}
