package com.yihu.jw.healthUpload.dao;

import com.yihu.jw.entity.healthUpload.BaseDoctorMemberDO;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 *
 * 医生成员表
 *
 * @version
 * <pre>
 * Author	Version		Date		Changes
 * litaohong 	1.0  		2018年08月31日 	Created
 *
 * </pre>
 * @since 1.
 */
@Transactional
public interface BaseDoctorMemberDao extends JpaRepository<BaseDoctorMemberDO, String>, JpaSpecificationExecutor<BaseDoctorMemberDO>  {

    @Query("from BaseDoctorMemberDO d where d.id = ?1 AND d.del ='1'")
    BaseDoctorMemberDO findByIdAndDel(String id);

    @Query("from BaseDoctorMemberDO d where  d.del ='1' and d.doctorId=?1")
    List<BaseDoctorMemberDO> findByDoctorIdAndDel(String doctorId);

    @Query("from BaseDoctorMemberDO d where  d.del ='1' and d.doctorId=?1 and d.memberId=?2 ")
    BaseDoctorMemberDO findByDoctorIdAndMemberIdAndDel(String doctorId,String memberId);


}
