package com.yihu.jw.healthUpload.dao;

import com.yihu.jw.entity.healthUpload.BasePatientHealthUploadDO;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Query;

import java.util.Date;
import java.util.List;

/**
 * Created by yeshijie on 2022/12/6.
 */
public interface BasePatientHealthUploadDao  extends JpaRepository<BasePatientHealthUploadDO, String>,
        JpaSpecificationExecutor<BasePatientHealthUploadDO> {

    @Query(value = "select d.* from base_patient_health_upload d where d.patient_id = ?1 order by d.create_time desc limit 1",nativeQuery = true)
    BasePatientHealthUploadDO findByPatientIdRecently(String patientId);

    @Query("from BasePatientHealthUploadDO d where d.patientId = ?1 ")
    List<BasePatientHealthUploadDO> findByPatientId(String patientId);

    @Query("from BasePatientHealthUploadDO d where d.patientId = ?1 and d.consumer= ?2 order by d.createTime desc")
    List<BasePatientHealthUploadDO> findByPatientIdAndConsumer(String patientId,String consumer);

    @Query("select a from BasePatientHealthUploadDO a where a.patientId=?1 order by a.createTime desc")
    List<BasePatientHealthUploadDO> selectHealthUploadInfoByPatientId(String patientId, Pageable pageRequest);

    @Query("select a from BasePatientHealthUploadDO a where a.patientId=?1 and a.createTime>=?2 and a.createTime<=?3 order by a.createTime desc")
    List<BasePatientHealthUploadDO> selectHealthUploadInfoByPatientIdAndDate(String patientId, Date startDate, Date endDate, Pageable pageRequest);

    @Query("select a from BasePatientHealthUploadDO a where a.patientId=?1 and a.createTime>=?2 and a.createTime<=?3 order by a.createTime desc")
    List<BasePatientHealthUploadDO> selectHealthUploadInfoByPatientIdAndStartAndEnd(String patientId, Date startDate,Date endDate);


}
