package com.yihu.jw.hospital.integrate.dao;

import com.yihu.jw.entity.hospital.integrate.BaseHospitalGoodsExchageDO;
import com.yihu.jw.entity.hospital.integrate.BaseHospitalUserActivityDO;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;

import java.util.List;

/**
 * wangzhinan 20230523
 */
public interface BaseHospitalUserActivityDao extends JpaRepository<BaseHospitalUserActivityDO, String>, JpaSpecificationExecutor<BaseHospitalUserActivityDO> {

    @Query("from BaseHospitalUserActivityDO p where p.user = ?1 and p.relationCode=?2 ")
    BaseHospitalUserActivityDO selectByUserAndRelationCode(String user, String relationCode);

    @Query("from BaseHospitalUserActivityDO p where p.relationCode = ?1 order by p.createTime desc")
    List<BaseHospitalUserActivityDO> selectByRelationCode(String relationCode);

    @Modifying
    @Query("delete from BaseHospitalUserActivityDO  where relationCode = ?1")
    void deleteByRelationCode(String relationCode);
}
