package com.yihu.jw.hospital.jw;

import com.yihu.jw.util.http.HttpClientUtil;
import org.apache.commons.lang3.StringUtils;
import org.apache.http.NameValuePair;
import org.apache.http.message.BasicNameValuePair;
import org.json.JSONArray;
import org.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;

/**
 * @author suqinyi
 * @Date 2023/10/19
 */
@Service
@Transactional
public class JwArchiveRecordBaseService {

    @Autowired
    private HttpClientUtil HttpClientUtil;
//    @Value("${sign.check_upload}")
    private String jwUrl;
//    @Value("${testPattern.sign}")
    private String isClose;

    /**
     * 查询居民健康档案信息接口
     * @param idcard
     * @return
     * @throws Exception
     */
    public JSONArray getSickArchiveRecord(String idcard)  throws Exception
    {
        JSONArray re = new JSONArray();
        String url = jwUrl + "/third/archives/getSickArchiveRecord";

        List<NameValuePair> params = new ArrayList<>();
        params.add(new BasicNameValuePair("idcard", idcard));
        String response = null;
        if (isClose.equalsIgnoreCase("0")){
            response = HttpClientUtil.post(url, params, "UTF-8");
        }else {
            response = "{\"status\":200,\"msg\":\"查询居民健康档案信息接口！\",\"data\":\"{\\\"CODE\\\":\\\"1\\\",\\\"DATA\\\":[{\\\"ARCHIVE_ID\\\":\\\"478717\\\",\\\"SICK_NAME\\\":\\\"巫子明\\\",\\\"SICK_SEX\\\":\\\"1\\\",\\\"BIRTHDAY\\\":\\\"1942-01-01 00:00:00\\\",\\\"IDENTITY_CARD_NO\\\":\\\"350424194201010812\\\",\\\"ZONE_CODE\\\":\\\"3502050121\\\",\\\"HOME_ADDRESS\\\":\\\"G.厦门市海沧区嵩屿南二里星园美帝62梯1002室（高友网）\\\",\\\"INSUR_CARD_NO\\\":\\\"123456\\\"}," +
                    "{\\\"ARCHIVE_ID\\\":\\\"478717\\\",\\\"SICK_NAME\\\":\\\"测试\\\",\\\"SICK_SEX\\\":\\\"1\\\",\\\"BIRTHDAY\\\":\\\"1942-01-01 00:00:00\\\",\\\"IDENTITY_CARD_NO\\\":\\\"35040319850707201X\\\",\\\"ZONE_CODE\\\":\\\"3502050121\\\",\\\"HOME_ADDRESS\\\":\\\"G.厦门市海沧区嵩屿南二里星园美帝62梯1002室（高友网）\\\",\\\"INSUR_CARD_NO\\\":\\\"123456\\\"}]}\"}";
        }
        if(!StringUtils.isEmpty(response))
        {
            JSONObject json = new JSONObject(response);
            System.out.println("查询基卫档案==="+json.optString("status"));
            System.out.println("查询基卫档案，返回信息==="+json.optString("msg"));
            if (!"200".equals(json.optString("status"))) {
                throw new RuntimeException(json.optString("msg"));
            }else{
                String dataStr = json.getString("data");
                if(!StringUtils.isEmpty(dataStr)){
                    JSONObject data = new JSONObject(dataStr);
                    if("1".equals(data.optString("CODE")))
                    {
                        JSONArray jsonArray = data.getJSONArray("DATA");
                        // {"ARCHIVE_ID":"档案ID","SICK_NAME":"病人姓名","SICK_SEX":"性别","BIRTHDAY":"出生日期","IDENTITY_CARD_NO":"身份证号码","ZONE_CODE":"归属辖区","HOME_ADDRESS":"现住址","INSUR_CARD_NO":"医保卡号"}
                        jsonArray.forEach(one->{
                            JSONObject jsonObject = (JSONObject)one;
                            JSONObject js = new JSONObject();
                            js.put("archiveId",jsonObject.get("ARCHIVE_ID"));
                            js.put("sickName",jsonObject.get("SICK_NAME"));
                            js.put("sickSex",jsonObject.get("SICK_SEX"));
                            js.put("birthday",jsonObject.get("BIRTHDAY"));
                            js.put("idCard",jsonObject.get("IDENTITY_CARD_NO"));
                            js.put("zoneCode",jsonObject.get("ZONE_CODE"));
                            js.put("homeAddress",jsonObject.get("HOME_ADDRESS"));
                            js.put("ssc",jsonObject.get("INSUR_CARD_NO"));
                            if(!jsonObject.isNull("ARCHIVE_STATUS")){
                                js.put("archiveStatus",jsonObject.get("ARCHIVE_STATUS"));//补充一个字段
                            }
                            re.put(js);
                        });
                    }
                    else{
                        throw new RuntimeException(json.optString("MESSAGE"));
                    }
                }else{
                    throw new RuntimeException("返回结果为空！");
                }
            }
        }
        else{
            throw new RuntimeException("返回结果为空！");
        }
        return re;
    }
}
