package com.yihu.jw.hospital.prescription.dao;

import com.yihu.jw.entity.hospital.prescription.WlyyPrescriptionLogDO;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Query;

import java.util.List;

/**
 * Created by Trick on 2019/5/17.
 */
public interface PrescriptionLogDao extends JpaRepository<WlyyPrescriptionLogDO, String>, JpaSpecificationExecutor<WlyyPrescriptionLogDO> {

    List<WlyyPrescriptionLogDO> findByOutpatientIdOrderByCreateTimeDesc(String outpatientId);

    List<WlyyPrescriptionLogDO> findByPrescriptionCodeOrderByCreateTimeDesc(String prescriptionCode);

    @Query("select a from WlyyPrescriptionLogDO a where a.prescriptionCode = ?1 and a.status in(20,30,10,100)  order by a.createTime asc ")
    List<WlyyPrescriptionLogDO> findByPrescriptionCodeByStatus(String prescriptionCode);

    @Query(" from WlyyPrescriptionLogDO l where l.prescriptionCode=?1 and l.status in ?2 order by createTime desc")
    List<WlyyPrescriptionLogDO> findPrescriptionLogsByPrescriptionCode(String prescriptionCode, Integer[] types);

    @Query(" from WlyyPrescriptionLogDO l where l.prescriptionCode=?1 and l.status = ?2 ")
    List<WlyyPrescriptionLogDO> findByPrescriptionCodeAndStutas(String prescriptionCode, int status);
}
