package com.yihu.jw.hospital.prescription.service;

import com.yihu.jw.entity.hospital.prescription.WlyyPrescriptionExpressageLogDO;
import com.yihu.jw.hospital.prescription.dao.PrescriptionExpressageLogDao;
import com.yihu.jw.mysql.query.BaseJpaService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 *  门诊物流日志服务
 * lith 2019.06.04
 */

@Service
public class PrescriptionExpressageLogService extends BaseJpaService<WlyyPrescriptionExpressageLogDO, PrescriptionExpressageLogDao> {

    @Autowired
    private PrescriptionExpressageLogDao prescriptionExpressageLogDao;

    /**
     * 根据处方号获取该处方的物流配送日志,按路由节点发生的时间倒序排序
     * @param prescriptionCode
     * @return
     */
    public List<WlyyPrescriptionExpressageLogDO> findByPrescriptionCode(String prescriptionCode){
        return prescriptionExpressageLogDao.queryByOutpatientId(prescriptionCode);
    }
}
