package com.yihu.jw.inpatient.dao;

import com.yihu.jw.entity.base.inpatient.BaseInpatientRegistrationDO;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Query;

import java.util.List;

/**
 * Created by yeshijie on 2022/12/5.
 */
public interface BaseInpatientRegistrationDao extends JpaRepository<BaseInpatientRegistrationDO, String>,
        JpaSpecificationExecutor<BaseInpatientRegistrationDO> {

    @Query("from BaseInpatientRegistrationDO where idcard=?1 and name=?2 and status in ('2','3') order by createTime desc")
    List<BaseInpatientRegistrationDO> findByIdcardAndName(String idcard,String name);

    @Query("from BaseInpatientRegistrationDO where patient=?1 and status in ('2','3') order by createTime desc")
    List<BaseInpatientRegistrationDO> findByPatient(String patient);

    @Query(value = "select count(a.id) from base_inpatient_registration a where a.status=?1",nativeQuery = true)
    int countByStatus(String status);
}
