package com.yihu.jw.knowledge.dao;

import com.yihu.jw.entity.knowledge.BaseKnowledgeDict;
import com.yihu.jw.entity.knowledge.BaseKnowledgeQuestion;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * 知识库-字典dao
 * @wangzhinan
 */
@Transactional
public interface BaseKnowledgeDictDao extends JpaRepository<BaseKnowledgeDict, String>, JpaSpecificationExecutor<BaseKnowledgeDict> {

    @Modifying
    @Query("update BaseKnowledgeDict p set p.del = ?2 where p.id = ?1")
    void updateDelById(String id,Integer del);

    @Query("from BaseKnowledgeDict p where p.sort = ?1 and p.del=1 ")
    BaseKnowledgeDict selectBySort(Integer sort);


    @Query(value = "select p.* from base_knowledge_dict p where p.del=1 order by p.sort limit ?1 ",nativeQuery = true)
    List<BaseKnowledgeDict> findTopList(Integer limit);
}