package com.yihu.jw.knowledge.dao;

import com.yihu.jw.entity.knowledge.BaseKnowledgeDictRelation;
import com.yihu.jw.entity.knowledge.BaseKnowledgeQuestionsRelation;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * 知识库-字典关联dao
 * @wangzhinan
 */
@Transactional
public interface BaseKnowledgeDictRelationDao extends JpaRepository<BaseKnowledgeDictRelation, String>, JpaSpecificationExecutor<BaseKnowledgeDictRelation> {


    @Query("from BaseKnowledgeDictRelation p where p.dictId = ?1 ")
    List<BaseKnowledgeDictRelation> selectListByDictId(String dictId);

    @Query("from BaseKnowledgeDictRelation p where p.dictId = ?1 ")
    BaseKnowledgeDictRelation selectByDictId(String dictId);

    @Modifying
    @Query("delete from BaseKnowledgeDictRelation p where p.dictId=?1 ")
    void deleteByDictId(String dictId);
}