package com.yihu.jw.knowledge.dao;

import com.yihu.jw.entity.knowledge.BaseKnowledgeFlowConfigurationRelation;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * 知识库-流程问题配置关联dao
 * @wangzhinan
 */
@Transactional
public interface BaseKnowledgeFlowConfigurationRelationDao extends JpaRepository<BaseKnowledgeFlowConfigurationRelation, String>, JpaSpecificationExecutor<BaseKnowledgeFlowConfigurationRelation> {

    @Query("from BaseKnowledgeFlowConfigurationRelation p where p.questionId = ?1 order by p.sort asc")
    List<BaseKnowledgeFlowConfigurationRelation> selectByQuestionId(String questionId);

    @Modifying
    @Query("delete from BaseKnowledgeFlowConfigurationRelation p where p.questionId = ?1")
    void deleteByQuestionId(String questionId);
}