package com.yihu.jw.knowledge.dao;

import com.yihu.jw.entity.knowledge.BaseKnowledgeQuestion;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * 知识库-常见问题dao
 * @wangzhinan
 */
@Transactional
public interface BaseKnowledgeQuestionDao extends JpaRepository<BaseKnowledgeQuestion, String>, JpaSpecificationExecutor<BaseKnowledgeQuestion> {

    @Modifying
    @Query("update BaseKnowledgeQuestion p set p.del = ?2 where p.id = ?1")
    void updateDelById(String id,Integer del);

    @Modifying
    @Query("update BaseKnowledgeQuestion p set p.flag = ?2 where p.id = ?1")
    void updateFlagById(String id,Integer flag);

    @Query("from BaseKnowledgeQuestion p where p.sort = ?1 and p.del=1")
    BaseKnowledgeQuestion selectBySort(Integer sort);

    @Query(value = "select p.* from base_knowledge_question p where p.status = 1 and p.del=1 and (p.time=1 or (p.time=2 and p.date<?1))  order by sort limit ?2 ",nativeQuery = true)
    List<BaseKnowledgeQuestion> findTopList(String date,Integer limit);
}