package com.yihu.jw.knowledge.dao;

import com.yihu.jw.entity.knowledge.BaseKnowledgeQuestions;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * 知识库-问题集dao
 * @wangzhinan
 */
@Transactional
public interface BaseKnowledgeQuestionsDao extends JpaRepository<BaseKnowledgeQuestions, String>, JpaSpecificationExecutor<BaseKnowledgeQuestions> {

    @Query("from BaseKnowledgeQuestions p where p.sort = ?1 and p.del=1 ")
    BaseKnowledgeQuestions selectBySort(Integer sort);

    @Modifying
    @Query("update BaseKnowledgeQuestions p set p.del = ?2 where p.id = ?1")
    void updateDelById(String id,Integer del);

    @Query(value = "select p.* from base_knowledge_questions p where p.status = 1 and p.del=1 and (p.time=1 or (p.time=2 and p.date<?1)) order by sort limit ?2 ",nativeQuery = true)
    List<BaseKnowledgeQuestions> findTopList(String date, Integer limit);
}