package com.yihu.jw.knowledge.dao;

import com.yihu.jw.entity.knowledge.BaseKnowledgeQuestion;
import com.yihu.jw.entity.knowledge.BaseKnowledgeQuestionsRelation;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * 知识库-常见问题集关联关系dao
 * @wangzhinan
 */
@Transactional
public interface BaseKnowledgeQuestionsRelationDao extends JpaRepository<BaseKnowledgeQuestionsRelation, String>, JpaSpecificationExecutor<BaseKnowledgeQuestionsRelation> {

    @Query("from BaseKnowledgeQuestionsRelation p where p.questionsId = ?1 ")
    List<BaseKnowledgeQuestionsRelation> selectByQuestionsId(String questionsId);

    @Modifying
    @Query("delete from BaseKnowledgeQuestionsRelation p where p.questionsId=?1 ")
    void deleteByQuestionsId(String questionsId);

}