package com.yihu.jw.knowledge.dao;

import com.yihu.jw.entity.knowledge.BaseSystemDialogSetting;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Query;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * 系统会话设置dao
 * @wangzhinan
 */
@Transactional
public interface BaseSystemDialogSettingDao extends JpaRepository<BaseSystemDialogSetting, String>, JpaSpecificationExecutor<BaseSystemDialogSettingDao> {

    @Query("from BaseSystemDialogSetting p where p.systemType = ?1 ")
    List<BaseSystemDialogSetting> selectBySystemType(String systemType);

    @Query("from BaseSystemDialogSetting p where p.systemType = ?1 and p.flag=?2")
    List<BaseSystemDialogSetting> selectBySystemTypeAndFlag(String systemType,Integer flag);

    @Query("from BaseSystemDialogSetting p where p.functionType = ?1 and p.flag=?2")
    List<BaseSystemDialogSetting> selectByFunctionTypeAndFlag(String functionType,Integer flag);

    @Query("from BaseSystemDialogSetting p where p.systemType = ?1 and p.functionType = ?2 and p.flag=?3")
    BaseSystemDialogSetting findBySystemTypeAndFunctionType(String systemType,String functionType,Integer flag);
}