package com.yihu.jw.login.service;

import com.yihu.jw.entity.base.login.BaseLoginAppDO;
import com.yihu.jw.entity.base.login.BaseLoginComponentDO;
import com.yihu.jw.login.dao.BaseLoginAppDao;
import com.yihu.jw.login.dao.BaseLoginComponentDao;
import com.yihu.jw.mysql.query.BaseJpaService;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

/**
 * Created by yeshijie on 2022/11/28.
 */
@Service
public class BaseLoginAppService extends BaseJpaService<BaseLoginAppDO, BaseLoginAppDao> {

    @Autowired
    private BaseLoginComponentDao logingComponentDao;
    @Autowired
    private BaseLoginAppDao loginAppDao;

    public List<BaseLoginComponentDO> findByLoginAppId(String loginAppId){
        return logingComponentDao.findByLoginAppId(loginAppId);
    }


    public BaseLoginAppDO createLoginApp(BaseLoginAppDO loginAppDO){
        if(StringUtils.isNotBlank(loginAppDO.getId())){
            BaseLoginAppDO old = loginAppDao.findById(loginAppDO.getId()).orElse(null);
            if(old!=null){
                loginAppDO.setCreateTime(old.getCreateTime());
            }
        }else {
            loginAppDO.setCreateTime(new Date());
        }
        return loginAppDao.save(loginAppDO);
    }

    public BaseLoginAppDO loginAppStatus(String id,Integer del){
        BaseLoginAppDO baseLoginAppDO = loginAppDao.findById(id).orElse(null);
        if(baseLoginAppDO!=null){
            baseLoginAppDO.setDel(del);
            loginAppDao.save(baseLoginAppDO);
        }
        return baseLoginAppDO;
    }

    public void loginAppDelete(String id){
        loginAppDao.deleteById(id);
    }

    public void loginComponentDelete(String id){
        logingComponentDao.deleteById(id);
    }

    public BaseLoginComponentDO createLoginCompoent(BaseLoginComponentDO loginAppDO){
        if(StringUtils.isNotBlank(loginAppDO.getId())){
            BaseLoginComponentDO old = logingComponentDao.findById(loginAppDO.getId()).orElse(null);
            if(old!=null){
                loginAppDO.setCreateTime(old.getCreateTime());
            }
        }else {
            loginAppDO.setCreateTime(new Date());
        }
        return logingComponentDao.save(loginAppDO);
    }
}
