package com.yihu.jw.nurse.dao;

import com.yihu.jw.entity.base.nurse.BaseNursingCardDO;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Query;

import java.util.List;

/**
 * Created by yeshijie on 2022/11/16.
 */
public interface BaseNursingCardDao extends JpaRepository<BaseNursingCardDO, String>, JpaSpecificationExecutor<BaseNursingCardDO> {

    List<BaseNursingCardDO> findByPatientAndStatus(String patient,Integer status);

    @Query(value = "select count(a.id) from base_nursing_card a where a.patient=?1 and (a.status=0 or (a.status=1 and a.end_time>now()))",nativeQuery = true)
    int countByPatientAndStatus(String patient);

    @Query(value = "select count(a.id) from base_nursing_card a where a.inpatient_area_id=?1 and (a.status=0 or (a.status=1 and a.end_time>now()))",nativeQuery = true)
    int countByInpatientAreaIdAndStatus(String inpatientAreaId);

    @Query(value = "select count(a.id) from base_nursing_card a where a.status=?1",nativeQuery = true)
    int countByStatus(Integer status);

}
