package com.yihu.jw.order.dao;

import com.yihu.jw.entity.base.im.ConsultTeamDo;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;

import java.util.Date;

/**
 * 咨询扩展表DAO类
 * @author huangwenjie
 */
public interface ConsultTeamOrderDao extends JpaRepository<ConsultTeamDo, String>, JpaSpecificationExecutor<ConsultTeamDo> {
	// 根據consult查詢咨询记录
	ConsultTeamDo findByConsult(String consult);
	
//	// 关闭咨询
//	@Modifying
//	@Query("update ConsultTeam a set a.status = 1 where a.consult = ?1")
//	int updateStatusByConsult(String consult);
//
//	@Query("select a from ConsultTeamDo a,ConsultTeamDoctor b where a.consult = b.consult and a.patient = ?1 and b.to = ?2 and a.del = '1' and a.type<>8 and a.status = 0")
//	List<ConsultTeamDo> findUnfinishedConsultType(String patient,String doctor);

	@Query("select count(id) from  ConsultTeamDo a where a.type = ?1 and a.doctor = ?2 and a.czrq >=?3 and a.czrq <=?4")
	Integer  countByTime(int type, String doctor, Date startTime, Date endTime);

	ConsultTeamDo queryByRelationCode(String relationCode);


	//名医咨询 -我咨询的 带symptoms 根据status
	@Query("select a from ConsultTeamDo a, ConsultTeamDoctorDo b where a.consult = b.consult and (a.type=6 or a.type=7 ) and a.patient = ?1 and a.status=?2 and a.id < ?3 and a.symptoms like ?4 and a.del = '1' and b.del = '1' and b.from is null")
	Page<ConsultTeamDo> findMyFamousDoctorListByStatus(String uid, int status, long id, String title, Pageable pageRequest);

	//名医咨询 -我咨询的 带symptoms 根据status
	@Query("select a from ConsultTeamDo a, ConsultTeamDoctorDo b where a.consult = b.consult and (a.type=6 or a.type=7 ) and a.patient = ?1 and a.status=?2  and a.symptoms like ?3 and a.del = '1' and b.del = '1' and b.from is null")
	Page<ConsultTeamDo> findMyFamousDoctorListByStatus(String uid, int status, String title, Pageable pageRequest);

	//名医咨询 -我咨询的 带symptoms根据status
	@Query("select a from ConsultTeamDo a, ConsultTeamDoctorDo b where a.consult = b.consult and (a.type=6 or a.type=7 ) and a.patient = ?1 and a.status=?2  and a.id < ?3 and  a.del = '1' and b.del = '1' and b.from is null")
	Page<ConsultTeamDo> findMyFamousDoctorListByStatus(String uid, int status, long id, Pageable pageRequest);

	//名医咨询 -我咨询的 带symptoms根据status
	@Query("select a from ConsultTeamDo a, ConsultTeamDoctorDo b where a.consult = b.consult and (a.type=6 or a.type=7 ) and a.patient = ?1 and a.status=?2  and a.del = '1' and b.del = '1' and b.from is null")
	Page<ConsultTeamDo> findMyFamousDoctorListByStatus(String uid, int status, Pageable pageRequest);

}
