package com.yihu.jw.patient.dao;

import com.yihu.jw.entity.base.patient.BasePatientDO;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Query;

import java.util.List;
import java.util.Map;

/**
 * Created by Trick on 2018/8/31.
 */
public interface BasePatientDao extends JpaRepository<BasePatientDO, String>, JpaSpecificationExecutor<BasePatientDO> {


    @Query("select p from BasePatientDO p where p.openid=?1 and p.del='1'")
    BasePatientDO findByOpenid(String openid);

    BasePatientDO findByIdcardAndDel(String Idcard,String del);

    @Query(value = "select p.* from base_patient p,patient_medicare_card c where c.code=?1 and c.patient_code=p.id and c.type='A_01' limit 1",nativeQuery = true)
    BasePatientDO findBySsc(String ssc);

    @Query("select id as id,idcard as idcard,name as name,case sex when 1 then '男' when 2 then '女' else '未知' end as sex,mobile as phone,committeeName as committeeName,concat(provinceName,cityName,townName,streetName) as address from BasePatientDO where idcard like ?1")
    List<Map<String,Object>> findByIdcard(String idcard, Pageable pageable);

    @Query("select id as id,idcard as idcard,name as name,case sex when 1 then '男' when 2 then '女' else '未知' end as sex,mobile as phone,committeeName as committeeName,concat(provinceName,cityName,townName,streetName) as address from BasePatientDO where name like ?1")
    List<Map<String,Object>> findByName(String name, Pageable pageable);

    @Query("select id as id,idcard as idcard,name as name,case sex when 1 then '男' when 2 then '女' else '未知' end as sex,mobile as phone,committeeName as committeeName,concat(provinceName,cityName,townName,streetName) as address from BasePatientDO")
    List<Map<String,Object>> findBaseInfo(Pageable pageable);

    boolean existsByIdcardAndIdNotAndDel(String idcard,String id,String del);

    boolean existsByIdcardAndDel(String idcard,String del);

    @Query("from BasePatientDO where mobile = ?1")
    List<BasePatientDO> findByMobile(String mobile);

    @Query("from BasePatientDO where del = 1")
    List<BasePatientDO> findAllByDel();

    @Query("from BasePatientDO where del = 1 and id = ?1")
    List<BasePatientDO> findAllByDelAndId(String user);

    @Query("from BasePatientDO p where p.mobile = ?1 and p.del=?2")
    List<BasePatientDO> findByMobileAndDel(String mobile,String del);
    
    BasePatientDO findByIdcard(String idcard);

    @Query("from BasePatientDO p where p.mobile = ?1 and p.mobile = ?2 and p.del=1")
    BasePatientDO findByIdcardAndMobile(String idcard,String mobile);
//    @Modifying
//    @Query(" update BasePatientDO a set a.openid=?2 where a.id=?1 ")
//    int updateOpenId(String id, String openId);

    BasePatientDO findByIdAndDel(String id,String del);

    List<BasePatientDO> findByNameAndIdcard(String name,String idcard);

    @Query("select p from BasePatientDO p where (p.idcard = ?1 or p.ssc = ?1 )  and p.del = '1'")
    List<BasePatientDO> getPatientByIdcardOrSsc(String patientInfo);
}
