package com.yihu.jw.team;

import com.yihu.jw.entity.base.team.BaseTeamRelationDO;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;

import java.util.List;

/**
 * Created by yeshijie on 2023/4/24.
 */
public interface BaseTeamRelationDao extends JpaRepository<BaseTeamRelationDO, String>, JpaSpecificationExecutor<BaseTeamRelationDO> {

    @Query(value = "select t from BaseTeamRelationDO t where t.teamId=?1 and t.adminTeamId=?2")
    List<BaseTeamRelationDO> findAdminTeamById(String teamId, Integer adminTeamId);

    @Query(value = "select t from BaseTeamRelationDO t where t.adminTeamId=?1")
    List<BaseTeamRelationDO> findAdminTeamById(Integer adminTeamId);

    @Modifying
    @Query(value = "delete from BaseTeamRelationDO  where teamId=?1 and adminTeamId=?2")
    void delTeam(String teamId,Integer adminTeamId);
}
