package com.yihu.jw.thirdUpload;

import com.yihu.jw.entity.thirdUpload.UpAppointmentOnlineDO;
import com.yihu.jw.entity.thirdUpload.UpMedicalOnlineDO;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;

import java.util.Date;
import java.util.List;

public interface UpMedicalOnlineDao extends JpaRepository<UpMedicalOnlineDO, String>, JpaSpecificationExecutor<UpMedicalOnlineDO> {
    @Query("from UpMedicalOnlineDO t where t.is_del='1' and t.create_time>=?1 and t.create_time<=?2")
    List<UpMedicalOnlineDO> findByCreateTime(Date startTime, Date endTime);
    @Query("from UpMedicalOnlineDO")
    List<UpMedicalOnlineDO> findAll();

    @Query("from UpMedicalOnlineDO t where t.create_time>=?1 and t.create_time<=?2")
    List<UpMedicalOnlineDO> finAllByDate(Date startTime, Date endTime);

    @Query("select count(1) from UpMedicalOnlineDO t where t.create_time>=?1 and t.create_time<=?2")
    String findCount(Date startTime, Date endTime);

}
