package com.yihu.jw.im.dao;

import com.yihu.jw.entity.base.im.ConsultDo;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;


/**
 * 咨询表DAO类
 * @author huangwenjie
 */
public interface ConsultDao extends JpaRepository<ConsultDo, String>, JpaSpecificationExecutor<ConsultDo> {

	ConsultDo findByCode(String code);

	@Query("from ConsultDo a where a.relationCode = ?1")
	ConsultDo findByRelationCode(String outpatientid);

//	// 查询患者咨询记录
//	Page<Object> findByPatient(String patient, String title, String id, PageRequest pageRequest);
//
//	// 查询患者咨询记录
//	Page<Object> findByPatient(String patient, String title, PageRequest pageRequest);
//
//	// 查询患者咨询记录
//	@Query("select a.id,a.type,a.code,a.title,a.symptoms,a.czrq,b.status,b.doctor,b.team,b.evaluate,a.signCode  from ConsultDo a,ConsultTeamDo b where a.code = b.consult and a.patient = ?1 and a.id < ?2 and a.del = '1' and a.type<>8 order by a.czrq desc")
//	Page<Object> findByPatient(String patient, String id, Pageable pageRequest);
//
//	// 查询患者咨询记录
//	@Query("select a.id,a.type,a.code,a.title,a.symptoms,a.czrq,b.status,b.doctor,b.team,b.evaluate,a.signCode  from ConsultDo a,ConsultTeamDo b where a.code = b.consult and a.patient = ?1 and a.del = '1' and a.type<>8 order by a.czrq desc")
//	Page<Object> findByPatient(String patient, Pageable pageRequest);

	ConsultDo queryByRelationCode(String relationCode);

	ConsultDo queryByIdAndType(String id,Integer type);

	/*@Query(value = "select a.id,a.type,a.title,a.symptoms,a.czrq,b.status,b.doctor,b.evaluate,a.relation_code from wlyy_consult a,wlyy_consult_team b where a.code = b.consult and a.patient = ?1 and a.del = '1' and a.type=?3 and a.symptoms like ?2 order by a.czrq desc",nativeQuery = true)
	Page<Object> findByPatientAndType(String patient, String title, Integer type, Pageable pageRequest);

	@Query(value = "select a.id,a.type,a.title,a.symptoms,a.czrq,b.status,b.doctor,b.evaluate,a.relation_code  from wlyy_consult a,wlyy_consult_team b where a.code = b.consult and a.patient = ?1 and a.del = '1' and a.type=?2 order by a.czrq desc",nativeQuery = true)
	Page<Object> findByPatientAndType(String patient,Integer type, Pageable pageRequest);*/
}
