package com.yihu.jw.followup;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.searchbox.annotations.JestId;
import org.springframework.data.annotation.CreatedDate;

import java.util.Date;

/**
 * 慢性阻塞性肺病--首次问卷
 * @author hmf
 * @date 2020/3/17
 */
public class COPDFirstTimeQuestionnaireES {

    @JestId
    private String id;
    private String followup_id;             //随访记录ID
    private String followup_project;        //随访详情分类ID
    private String version;//版本号
    private String problemId;//健康问题id(肺癌1001 慢性胃肠病1002 冠心病1003 慢性前列腺疾病1004 慢性乳腺疾病1005  慢性阻塞性肺病1006 脂肪肝1007 慢性妇科炎症1008 脑卒中1009 慢性肾病1010)

    private String symptomNo;//症状_无
    private String symptomCough;//症状_咳嗽
    private String symptomExpectoration;//症状_咳痰
    private String symptomHemoptysis;//症状_咯血
    private String symptomAnhelationAcAf;//症状_气促_活动后
    private String symptomAnhelationCalm;//症状_气促_平静时
    private String symptomChestAcAf;//症状_胸闷_活动后
    private String symptomChestCalm;//症状_胸闷_平静时
    private String symptomChestPainAcAf;//症状_胸痛_活动后
    private String symptomChestPainCalm;//症状_胸痛_平静时
    private String symptomFeverLess;//症状_发热<=38摄氏度
    private String symptomFeverGreater;//症状_发热>=39摄氏度
    private String symptomDrowsiness;//症状_发热>=嗜睡
    private String symptomOther;//症状_其它

    private String symptomAcuteNum;//急性加重次数评估
    //个人信息及病史
    private String historyEducation;//个人信息及病史_受教育水平
    private String historyOccupaExposure;//个人信息及病史_有无职业暴露史
    private String historyIndoorPollution;//个人信息及病史_室内环境空气污染
    private String historyWorkPollution;//个人信息及病史_工作环境污染暴露
    private String historySmokingStatus;//个人信息及病史_吸烟现状
    private String historyTherioma;//个人信息及病史_家族性存在恶性肿瘤病史
    private String historyHeredopathia;//个人信息及病史_家族性存在遗传病史
    private String historyChronicAirway;//个人信息及病史_家族性慢性气道病史

    private String sickSign;//体征_体征
    //个人基本信息
    private String pulseRate;//脉率
    private String heartRate;//心率
    private String bloodPressureU;//血压（收缩压）
    private String bloodPressureD;//血压（舒张压）
    private String bloodPressureStatus;//血压状态
    private String height;//身高
    private String weight;//体重
    private String spo;//末梢血氧饱和度（spo2）
    private String dr;//dr胸片（半年一次）
    private String lung;//慢阻肺
    private String lungType;//慢阻肺类型
    private String pdm;//fev1/fvc参考结论
    private String fev;//fev1占预计的百分比
    private String fvc;//fvc占预计的百分比
    //生活方式
    private String dailySmokingQuantity;//日吸烟量
    private String dailySmokingStartYear;//吸烟初始年龄
    private String dailySmokingYearNum;//吸烟年数
    private String dailySmokingIndex;//吸烟指数
    private String everyAlcoholTolerance;//日饮酒量
    private String sports;//运动
    private String oralHormone;//口服激素
    private String complianceBehavior;//遵医行为
    private String drugCompliance;//服药依从性
    private String drugAdverseReaction;//药物不良反应
    private String medicationSituation;//用药情况
    private String validFlag;//有效标志
    private String remark;//备注
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyyMMdd'T'HHmmss.SSS'Z'")
    @CreatedDate
    private Date createTime;//创建时间
    private String createOperator;//创建人
    private String createOperatorName;//创建人
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyyMMdd'T'HHmmss.SSS'Z'")
    @CreatedDate
    private Date modifyTime;//修改时间
    private String modifyOperator;//修改人
    private String modifyOperatorName;//修改人

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getFollowup_id() {
        return followup_id;
    }

    public void setFollowup_id(String followup_id) {
        this.followup_id = followup_id;
    }

    public String getFollowup_project() {
        return followup_project;
    }

    public void setFollowup_project(String followup_project) {
        this.followup_project = followup_project;
    }

    public String getVersion() {
        return version;
    }

    public void setVersion(String version) {
        this.version = version;
    }

    public String getProblemId() {
        return problemId;
    }

    public void setProblemId(String problemId) {
        this.problemId = problemId;
    }

    public String getSymptomNo() {
        return symptomNo;
    }

    public void setSymptomNo(String symptomNo) {
        this.symptomNo = symptomNo;
    }

    public String getSymptomCough() {
        return symptomCough;
    }

    public void setSymptomCough(String symptomCough) {
        this.symptomCough = symptomCough;
    }

    public String getSymptomExpectoration() {
        return symptomExpectoration;
    }

    public void setSymptomExpectoration(String symptomExpectoration) {
        this.symptomExpectoration = symptomExpectoration;
    }

    public String getSymptomHemoptysis() {
        return symptomHemoptysis;
    }

    public void setSymptomHemoptysis(String symptomHemoptysis) {
        this.symptomHemoptysis = symptomHemoptysis;
    }

    public String getSymptomAnhelationAcAf() {
        return symptomAnhelationAcAf;
    }

    public void setSymptomAnhelationAcAf(String symptomAnhelationAcAf) {
        this.symptomAnhelationAcAf = symptomAnhelationAcAf;
    }

    public String getSymptomAnhelationCalm() {
        return symptomAnhelationCalm;
    }

    public void setSymptomAnhelationCalm(String symptomAnhelationCalm) {
        this.symptomAnhelationCalm = symptomAnhelationCalm;
    }

    public String getSymptomChestAcAf() {
        return symptomChestAcAf;
    }

    public void setSymptomChestAcAf(String symptomChestAcAf) {
        this.symptomChestAcAf = symptomChestAcAf;
    }

    public String getSymptomChestCalm() {
        return symptomChestCalm;
    }

    public void setSymptomChestCalm(String symptomChestCalm) {
        this.symptomChestCalm = symptomChestCalm;
    }

    public String getSymptomChestPainAcAf() {
        return symptomChestPainAcAf;
    }

    public void setSymptomChestPainAcAf(String symptomChestPainAcAf) {
        this.symptomChestPainAcAf = symptomChestPainAcAf;
    }

    public String getSymptomChestPainCalm() {
        return symptomChestPainCalm;
    }

    public void setSymptomChestPainCalm(String symptomChestPainCalm) {
        this.symptomChestPainCalm = symptomChestPainCalm;
    }

    public String getSymptomFeverLess() {
        return symptomFeverLess;
    }

    public void setSymptomFeverLess(String symptomFeverLess) {
        this.symptomFeverLess = symptomFeverLess;
    }

    public String getSymptomFeverGreater() {
        return symptomFeverGreater;
    }

    public void setSymptomFeverGreater(String symptomFeverGreater) {
        this.symptomFeverGreater = symptomFeverGreater;
    }

    public String getSymptomDrowsiness() {
        return symptomDrowsiness;
    }

    public void setSymptomDrowsiness(String symptomDrowsiness) {
        this.symptomDrowsiness = symptomDrowsiness;
    }

    public String getSymptomOther() {
        return symptomOther;
    }

    public void setSymptomOther(String symptomOther) {
        this.symptomOther = symptomOther;
    }

    public String getSymptomAcuteNum() {
        return symptomAcuteNum;
    }

    public void setSymptomAcuteNum(String symptomAcuteNum) {
        this.symptomAcuteNum = symptomAcuteNum;
    }

    public String getHistoryEducation() {
        return historyEducation;
    }

    public void setHistoryEducation(String historyEducation) {
        this.historyEducation = historyEducation;
    }

    public String getHistoryOccupaExposure() {
        return historyOccupaExposure;
    }

    public void setHistoryOccupaExposure(String historyOccupaExposure) {
        this.historyOccupaExposure = historyOccupaExposure;
    }

    public String getHistoryIndoorPollution() {
        return historyIndoorPollution;
    }

    public void setHistoryIndoorPollution(String historyIndoorPollution) {
        this.historyIndoorPollution = historyIndoorPollution;
    }

    public String getHistoryWorkPollution() {
        return historyWorkPollution;
    }

    public void setHistoryWorkPollution(String historyWorkPollution) {
        this.historyWorkPollution = historyWorkPollution;
    }

    public String getHistorySmokingStatus() {
        return historySmokingStatus;
    }

    public void setHistorySmokingStatus(String historySmokingStatus) {
        this.historySmokingStatus = historySmokingStatus;
    }

    public String getHistoryTherioma() {
        return historyTherioma;
    }

    public void setHistoryTherioma(String historyTherioma) {
        this.historyTherioma = historyTherioma;
    }

    public String getHistoryHeredopathia() {
        return historyHeredopathia;
    }

    public void setHistoryHeredopathia(String historyHeredopathia) {
        this.historyHeredopathia = historyHeredopathia;
    }

    public String getHistoryChronicAirway() {
        return historyChronicAirway;
    }

    public void setHistoryChronicAirway(String historyChronicAirway) {
        this.historyChronicAirway = historyChronicAirway;
    }

    public String getSickSign() {
        return sickSign;
    }

    public void setSickSign(String sickSign) {
        this.sickSign = sickSign;
    }

    public String getPulseRate() {
        return pulseRate;
    }

    public void setPulseRate(String pulseRate) {
        this.pulseRate = pulseRate;
    }

    public String getHeartRate() {
        return heartRate;
    }

    public void setHeartRate(String heartRate) {
        this.heartRate = heartRate;
    }

    public String getBloodPressureU() {
        return bloodPressureU;
    }

    public void setBloodPressureU(String bloodPressureU) {
        this.bloodPressureU = bloodPressureU;
    }

    public String getBloodPressureD() {
        return bloodPressureD;
    }

    public void setBloodPressureD(String bloodPressureD) {
        this.bloodPressureD = bloodPressureD;
    }

    public String getBloodPressureStatus() {
        return bloodPressureStatus;
    }

    public void setBloodPressureStatus(String bloodPressureStatus) {
        this.bloodPressureStatus = bloodPressureStatus;
    }

    public String getHeight() {
        return height;
    }

    public void setHeight(String height) {
        this.height = height;
    }

    public String getWeight() {
        return weight;
    }

    public void setWeight(String weight) {
        this.weight = weight;
    }

    public String getSpo() {
        return spo;
    }

    public void setSpo(String spo) {
        this.spo = spo;
    }

    public String getDr() {
        return dr;
    }

    public void setDr(String dr) {
        this.dr = dr;
    }

    public String getLung() {
        return lung;
    }

    public void setLung(String lung) {
        this.lung = lung;
    }

    public String getLungType() {
        return lungType;
    }

    public void setLungType(String lungType) {
        this.lungType = lungType;
    }

    public String getPdm() {
        return pdm;
    }

    public void setPdm(String pdm) {
        this.pdm = pdm;
    }

    public String getFev() {
        return fev;
    }

    public void setFev(String fev) {
        this.fev = fev;
    }

    public String getFvc() {
        return fvc;
    }

    public void setFvc(String fvc) {
        this.fvc = fvc;
    }

    public String getDailySmokingQuantity() {
        return dailySmokingQuantity;
    }

    public void setDailySmokingQuantity(String dailySmokingQuantity) {
        this.dailySmokingQuantity = dailySmokingQuantity;
    }

    public String getDailySmokingStartYear() {
        return dailySmokingStartYear;
    }

    public void setDailySmokingStartYear(String dailySmokingStartYear) {
        this.dailySmokingStartYear = dailySmokingStartYear;
    }

    public String getDailySmokingYearNum() {
        return dailySmokingYearNum;
    }

    public void setDailySmokingYearNum(String dailySmokingYearNum) {
        this.dailySmokingYearNum = dailySmokingYearNum;
    }

    public String getDailySmokingIndex() {
        return dailySmokingIndex;
    }

    public void setDailySmokingIndex(String dailySmokingIndex) {
        this.dailySmokingIndex = dailySmokingIndex;
    }

    public String getEveryAlcoholTolerance() {
        return everyAlcoholTolerance;
    }

    public void setEveryAlcoholTolerance(String everyAlcoholTolerance) {
        this.everyAlcoholTolerance = everyAlcoholTolerance;
    }

    public String getSports() {
        return sports;
    }

    public void setSports(String sports) {
        this.sports = sports;
    }

    public String getOralHormone() {
        return oralHormone;
    }

    public void setOralHormone(String oralHormone) {
        this.oralHormone = oralHormone;
    }

    public String getComplianceBehavior() {
        return complianceBehavior;
    }

    public void setComplianceBehavior(String complianceBehavior) {
        this.complianceBehavior = complianceBehavior;
    }

    public String getDrugCompliance() {
        return drugCompliance;
    }

    public void setDrugCompliance(String drugCompliance) {
        this.drugCompliance = drugCompliance;
    }

    public String getDrugAdverseReaction() {
        return drugAdverseReaction;
    }

    public void setDrugAdverseReaction(String drugAdverseReaction) {
        this.drugAdverseReaction = drugAdverseReaction;
    }

    public String getMedicationSituation() {
        return medicationSituation;
    }

    public void setMedicationSituation(String medicationSituation) {
        this.medicationSituation = medicationSituation;
    }

    public String getValidFlag() {
        return validFlag;
    }

    public void setValidFlag(String validFlag) {
        this.validFlag = validFlag;
    }

    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }

    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    public String getCreateOperator() {
        return createOperator;
    }

    public void setCreateOperator(String createOperator) {
        this.createOperator = createOperator;
    }

    public String getCreateOperatorName() {
        return createOperatorName;
    }

    public void setCreateOperatorName(String createOperatorName) {
        this.createOperatorName = createOperatorName;
    }

    public Date getModifyTime() {
        return modifyTime;
    }

    public void setModifyTime(Date modifyTime) {
        this.modifyTime = modifyTime;
    }

    public String getModifyOperator() {
        return modifyOperator;
    }

    public void setModifyOperator(String modifyOperator) {
        this.modifyOperator = modifyOperator;
    }

    public String getModifyOperatorName() {
        return modifyOperatorName;
    }

    public void setModifyOperatorName(String modifyOperatorName) {
        this.modifyOperatorName = modifyOperatorName;
    }
}
