package com.yihu.jw.followup;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.searchbox.annotations.JestId;
import org.springframework.data.annotation.CreatedDate;

import java.util.Date;

/**
 * 妇科炎症随访档案
 * @author hmf
 * @date 2020/3/20
 */
public class GynecologicalInflammationFollowupArchivesES {
    @JestId
    private String id;
    private String followup_id;             //随访记录ID
    private String followup_project;        //随访详情分类ID
    private String version;//版本号
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyyMMdd'T'HHmmss.SSS'Z'")
    @CreatedDate
    private Date createTime;//创建时间
    private String createOperator;//创建人
    private String createOperatorName;//创建人
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyyMMdd'T'HHmmss.SSS'Z'")
    @CreatedDate
    private Date modifyTime;//修改时间
    private String modifyOperator;//修改人
    private String modifyOperatorName;//修改人
    private String problemId;//健康问题id(肺癌1001 慢性胃肠病1002 冠心病1003 慢性前列腺疾病1004 慢性乳腺疾病1005  慢性阻塞性肺病1006 脂肪肝1007 慢性妇科炎症1008 脑卒中1009 慢性肾病1010)
    private String validFlag;//有效标志
    private String remark;//备注

    private String symptomNo;//症状_无
    private String symptomPv;//症状_外阴瘙痒
    private String symptomDoap;//症状_腹痛程度
    private String bloodPressureD;//血压（舒张压）
    private String bloodPressureU;//血压（收缩压）
    private String height;//身高
    private String weight;//体重
    private String bmi;//体质指数
    private String heartRate;//心率

    private String leukorrheaWs;//白带_水样
    private String leukorrheaThick;//白带_稠
    private String leukorrheaCurd;//白带_凝乳或豆腐渣样
    private String leukorrheaSpum;//白带_泡沫状
    private String leukorrheaWhite;//白带_白色
    private String leukorrheaKelly;//白带_黄绿色
    private String leukorrheaPuru;//白带_脓性
    private String leukorrheaOdour;//白带_臭味
    private String leukorrheaCau;//白带_血性

    private String unCs;//宫颈_常大
    private String unPlump;//宫颈_肥大
    private String unLs;//宫颈_轻糜
    private String unMs;//宫颈_中糜
    private String unS;//宫颈_重糜
    private String unCb;//宫颈_接触性出血
    private String unLp;//宫颈_举痛
    private String ubCs;//宫体_常大
    private String ubM;//宫体_增大
    private String ubT;//宫体_压痛
    private String ubRt;//宫体_反跳痛

    private String aaLeftG;//附件区_左_肿物
    private String aaLeftT;//附件区_左_压痛
    private String aaLeftRt;//附件区_左_反跳痛
    private String aaRightG;//附件区_右_肿物
    private String aaRightT;//附件区_右_压痛
    private String aaRightRt;//附件区_右_反跳痛
    private String aeEm;//辅助检查_阴道微生态
    private String aeSc;//辅助检查_分泌物培养
    private String aeRbt;//辅助检查_血常规
    private String aeCrp;//辅助检查Crp
    private String aeCdu;//辅助检查_彩超
    private String aeLe;//辅助检查_白带检查
    private String aeOther;//辅助检查_其他
    private String aeResult;//辅助检查_结果登记
    private String heAoa;//健康宣教_是否滥用抗生素
    private String heCyua;//健康宣教_是否单独清洁内裤
    private String heFuodsl;//健康宣教_是否频繁使用药字号洗液、消毒护垫
    private String heLwttfalt;//健康宣教_是否长时间穿着厚紧身裤
    private String drugTimeStart1;//开始用药时间_1
    private String drugTimeEnd1;//结束用药时间_1
    private String drugName1;//药物名称_1
    private String drugResult1;//用药效果_1
    private String drugTimeStart2;//开始用药时间_2
    private String drugTimeEnd2;//结束用药时间_2
    private String drugName2;//药物名称_2
    private String drugResult2;//用药效果_2
    private String drugTimeStart3;//开始用药时间_3
    private String drugTimeEnd3;//结束用药时间_3
    private String drugName3;//药物名称_3
    private String drugResult3;//用药效果_3
    private String drugTimeStart4;//开始用药时间_4
    private String drugTimeEnd4;//结束用药时间_4
    private String drugName4;//药物名称_4
    private String drugResult4;//用药效果_4
    private String drugTimeStart5;//开始用药时间_5
    private String drugTimeEnd5;//结束用药时间_5
    private String drugName5;//药物名称_5
    private String drugResult5;//用药效果_5
    private String drugTimeStart6;//开始用药时间_6
    private String drugTimeEnd6;//结束用药时间_6
    private String drugName6;//药物名称_6
    private String drugResult6;//用药效果_6

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getFollowup_id() {
        return followup_id;
    }

    public void setFollowup_id(String followup_id) {
        this.followup_id = followup_id;
    }

    public String getFollowup_project() {
        return followup_project;
    }

    public void setFollowup_project(String followup_project) {
        this.followup_project = followup_project;
    }

    public String getVersion() {
        return version;
    }

    public void setVersion(String version) {
        this.version = version;
    }

    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    public String getCreateOperator() {
        return createOperator;
    }

    public void setCreateOperator(String createOperator) {
        this.createOperator = createOperator;
    }

    public String getCreateOperatorName() {
        return createOperatorName;
    }

    public void setCreateOperatorName(String createOperatorName) {
        this.createOperatorName = createOperatorName;
    }

    public Date getModifyTime() {
        return modifyTime;
    }

    public void setModifyTime(Date modifyTime) {
        this.modifyTime = modifyTime;
    }

    public String getModifyOperator() {
        return modifyOperator;
    }

    public void setModifyOperator(String modifyOperator) {
        this.modifyOperator = modifyOperator;
    }

    public String getModifyOperatorName() {
        return modifyOperatorName;
    }

    public void setModifyOperatorName(String modifyOperatorName) {
        this.modifyOperatorName = modifyOperatorName;
    }

    public String getProblemId() {
        return problemId;
    }

    public void setProblemId(String problemId) {
        this.problemId = problemId;
    }

    public String getValidFlag() {
        return validFlag;
    }

    public void setValidFlag(String validFlag) {
        this.validFlag = validFlag;
    }

    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }

    public String getSymptomNo() {
        return symptomNo;
    }

    public void setSymptomNo(String symptomNo) {
        this.symptomNo = symptomNo;
    }

    public String getSymptomPv() {
        return symptomPv;
    }

    public void setSymptomPv(String symptomPv) {
        this.symptomPv = symptomPv;
    }

    public String getSymptomDoap() {
        return symptomDoap;
    }

    public void setSymptomDoap(String symptomDoap) {
        this.symptomDoap = symptomDoap;
    }

    public String getBloodPressureD() {
        return bloodPressureD;
    }

    public void setBloodPressureD(String bloodPressureD) {
        this.bloodPressureD = bloodPressureD;
    }

    public String getBloodPressureU() {
        return bloodPressureU;
    }

    public void setBloodPressureU(String bloodPressureU) {
        this.bloodPressureU = bloodPressureU;
    }

    public String getHeight() {
        return height;
    }

    public void setHeight(String height) {
        this.height = height;
    }

    public String getWeight() {
        return weight;
    }

    public void setWeight(String weight) {
        this.weight = weight;
    }

    public String getBmi() {
        return bmi;
    }

    public void setBmi(String bmi) {
        this.bmi = bmi;
    }

    public String getHeartRate() {
        return heartRate;
    }

    public void setHeartRate(String heartRate) {
        this.heartRate = heartRate;
    }

    public String getLeukorrheaWs() {
        return leukorrheaWs;
    }

    public void setLeukorrheaWs(String leukorrheaWs) {
        this.leukorrheaWs = leukorrheaWs;
    }

    public String getLeukorrheaThick() {
        return leukorrheaThick;
    }

    public void setLeukorrheaThick(String leukorrheaThick) {
        this.leukorrheaThick = leukorrheaThick;
    }

    public String getLeukorrheaCurd() {
        return leukorrheaCurd;
    }

    public void setLeukorrheaCurd(String leukorrheaCurd) {
        this.leukorrheaCurd = leukorrheaCurd;
    }

    public String getLeukorrheaSpum() {
        return leukorrheaSpum;
    }

    public void setLeukorrheaSpum(String leukorrheaSpum) {
        this.leukorrheaSpum = leukorrheaSpum;
    }

    public String getLeukorrheaWhite() {
        return leukorrheaWhite;
    }

    public void setLeukorrheaWhite(String leukorrheaWhite) {
        this.leukorrheaWhite = leukorrheaWhite;
    }

    public String getLeukorrheaKelly() {
        return leukorrheaKelly;
    }

    public void setLeukorrheaKelly(String leukorrheaKelly) {
        this.leukorrheaKelly = leukorrheaKelly;
    }

    public String getLeukorrheaPuru() {
        return leukorrheaPuru;
    }

    public void setLeukorrheaPuru(String leukorrheaPuru) {
        this.leukorrheaPuru = leukorrheaPuru;
    }

    public String getLeukorrheaOdour() {
        return leukorrheaOdour;
    }

    public void setLeukorrheaOdour(String leukorrheaOdour) {
        this.leukorrheaOdour = leukorrheaOdour;
    }

    public String getLeukorrheaCau() {
        return leukorrheaCau;
    }

    public void setLeukorrheaCau(String leukorrheaCau) {
        this.leukorrheaCau = leukorrheaCau;
    }

    public String getUnCs() {
        return unCs;
    }

    public void setUnCs(String unCs) {
        this.unCs = unCs;
    }

    public String getUnPlump() {
        return unPlump;
    }

    public void setUnPlump(String unPlump) {
        this.unPlump = unPlump;
    }

    public String getUnLs() {
        return unLs;
    }

    public void setUnLs(String unLs) {
        this.unLs = unLs;
    }

    public String getUnMs() {
        return unMs;
    }

    public void setUnMs(String unMs) {
        this.unMs = unMs;
    }

    public String getUnS() {
        return unS;
    }

    public void setUnS(String unS) {
        this.unS = unS;
    }

    public String getUnCb() {
        return unCb;
    }

    public void setUnCb(String unCb) {
        this.unCb = unCb;
    }

    public String getUnLp() {
        return unLp;
    }

    public void setUnLp(String unLp) {
        this.unLp = unLp;
    }

    public String getUbCs() {
        return ubCs;
    }

    public void setUbCs(String ubCs) {
        this.ubCs = ubCs;
    }

    public String getUbM() {
        return ubM;
    }

    public void setUbM(String ubM) {
        this.ubM = ubM;
    }

    public String getUbT() {
        return ubT;
    }

    public void setUbT(String ubT) {
        this.ubT = ubT;
    }

    public String getUbRt() {
        return ubRt;
    }

    public void setUbRt(String ubRt) {
        this.ubRt = ubRt;
    }

    public String getAaLeftG() {
        return aaLeftG;
    }

    public void setAaLeftG(String aaLeftG) {
        this.aaLeftG = aaLeftG;
    }

    public String getAaLeftT() {
        return aaLeftT;
    }

    public void setAaLeftT(String aaLeftT) {
        this.aaLeftT = aaLeftT;
    }

    public String getAaLeftRt() {
        return aaLeftRt;
    }

    public void setAaLeftRt(String aaLeftRt) {
        this.aaLeftRt = aaLeftRt;
    }

    public String getAaRightG() {
        return aaRightG;
    }

    public void setAaRightG(String aaRightG) {
        this.aaRightG = aaRightG;
    }

    public String getAaRightT() {
        return aaRightT;
    }

    public void setAaRightT(String aaRightT) {
        this.aaRightT = aaRightT;
    }

    public String getAaRightRt() {
        return aaRightRt;
    }

    public void setAaRightRt(String aaRightRt) {
        this.aaRightRt = aaRightRt;
    }

    public String getAeEm() {
        return aeEm;
    }

    public void setAeEm(String aeEm) {
        this.aeEm = aeEm;
    }

    public String getAeSc() {
        return aeSc;
    }

    public void setAeSc(String aeSc) {
        this.aeSc = aeSc;
    }

    public String getAeRbt() {
        return aeRbt;
    }

    public void setAeRbt(String aeRbt) {
        this.aeRbt = aeRbt;
    }

    public String getAeCrp() {
        return aeCrp;
    }

    public void setAeCrp(String aeCrp) {
        this.aeCrp = aeCrp;
    }

    public String getAeCdu() {
        return aeCdu;
    }

    public void setAeCdu(String aeCdu) {
        this.aeCdu = aeCdu;
    }

    public String getAeLe() {
        return aeLe;
    }

    public void setAeLe(String aeLe) {
        this.aeLe = aeLe;
    }

    public String getAeOther() {
        return aeOther;
    }

    public void setAeOther(String aeOther) {
        this.aeOther = aeOther;
    }

    public String getAeResult() {
        return aeResult;
    }

    public void setAeResult(String aeResult) {
        this.aeResult = aeResult;
    }

    public String getHeAoa() {
        return heAoa;
    }

    public void setHeAoa(String heAoa) {
        this.heAoa = heAoa;
    }

    public String getHeCyua() {
        return heCyua;
    }

    public void setHeCyua(String heCyua) {
        this.heCyua = heCyua;
    }

    public String getHeFuodsl() {
        return heFuodsl;
    }

    public void setHeFuodsl(String heFuodsl) {
        this.heFuodsl = heFuodsl;
    }

    public String getHeLwttfalt() {
        return heLwttfalt;
    }

    public void setHeLwttfalt(String heLwttfalt) {
        this.heLwttfalt = heLwttfalt;
    }

    public String getDrugTimeStart1() {
        return drugTimeStart1;
    }

    public void setDrugTimeStart1(String drugTimeStart1) {
        this.drugTimeStart1 = drugTimeStart1;
    }

    public String getDrugTimeEnd1() {
        return drugTimeEnd1;
    }

    public void setDrugTimeEnd1(String drugTimeEnd1) {
        this.drugTimeEnd1 = drugTimeEnd1;
    }

    public String getDrugName1() {
        return drugName1;
    }

    public void setDrugName1(String drugName1) {
        this.drugName1 = drugName1;
    }

    public String getDrugResult1() {
        return drugResult1;
    }

    public void setDrugResult1(String drugResult1) {
        this.drugResult1 = drugResult1;
    }

    public String getDrugTimeStart2() {
        return drugTimeStart2;
    }

    public void setDrugTimeStart2(String drugTimeStart2) {
        this.drugTimeStart2 = drugTimeStart2;
    }

    public String getDrugTimeEnd2() {
        return drugTimeEnd2;
    }

    public void setDrugTimeEnd2(String drugTimeEnd2) {
        this.drugTimeEnd2 = drugTimeEnd2;
    }

    public String getDrugName2() {
        return drugName2;
    }

    public void setDrugName2(String drugName2) {
        this.drugName2 = drugName2;
    }

    public String getDrugResult2() {
        return drugResult2;
    }

    public void setDrugResult2(String drugResult2) {
        this.drugResult2 = drugResult2;
    }

    public String getDrugTimeStart3() {
        return drugTimeStart3;
    }

    public void setDrugTimeStart3(String drugTimeStart3) {
        this.drugTimeStart3 = drugTimeStart3;
    }

    public String getDrugTimeEnd3() {
        return drugTimeEnd3;
    }

    public void setDrugTimeEnd3(String drugTimeEnd3) {
        this.drugTimeEnd3 = drugTimeEnd3;
    }

    public String getDrugName3() {
        return drugName3;
    }

    public void setDrugName3(String drugName3) {
        this.drugName3 = drugName3;
    }

    public String getDrugResult3() {
        return drugResult3;
    }

    public void setDrugResult3(String drugResult3) {
        this.drugResult3 = drugResult3;
    }

    public String getDrugTimeStart4() {
        return drugTimeStart4;
    }

    public void setDrugTimeStart4(String drugTimeStart4) {
        this.drugTimeStart4 = drugTimeStart4;
    }

    public String getDrugTimeEnd4() {
        return drugTimeEnd4;
    }

    public void setDrugTimeEnd4(String drugTimeEnd4) {
        this.drugTimeEnd4 = drugTimeEnd4;
    }

    public String getDrugName4() {
        return drugName4;
    }

    public void setDrugName4(String drugName4) {
        this.drugName4 = drugName4;
    }

    public String getDrugResult4() {
        return drugResult4;
    }

    public void setDrugResult4(String drugResult4) {
        this.drugResult4 = drugResult4;
    }

    public String getDrugTimeStart5() {
        return drugTimeStart5;
    }

    public void setDrugTimeStart5(String drugTimeStart5) {
        this.drugTimeStart5 = drugTimeStart5;
    }

    public String getDrugTimeEnd5() {
        return drugTimeEnd5;
    }

    public void setDrugTimeEnd5(String drugTimeEnd5) {
        this.drugTimeEnd5 = drugTimeEnd5;
    }

    public String getDrugName5() {
        return drugName5;
    }

    public void setDrugName5(String drugName5) {
        this.drugName5 = drugName5;
    }

    public String getDrugResult5() {
        return drugResult5;
    }

    public void setDrugResult5(String drugResult5) {
        this.drugResult5 = drugResult5;
    }

    public String getDrugTimeStart6() {
        return drugTimeStart6;
    }

    public void setDrugTimeStart6(String drugTimeStart6) {
        this.drugTimeStart6 = drugTimeStart6;
    }

    public String getDrugTimeEnd6() {
        return drugTimeEnd6;
    }

    public void setDrugTimeEnd6(String drugTimeEnd6) {
        this.drugTimeEnd6 = drugTimeEnd6;
    }

    public String getDrugName6() {
        return drugName6;
    }

    public void setDrugName6(String drugName6) {
        this.drugName6 = drugName6;
    }

    public String getDrugResult6() {
        return drugResult6;
    }

    public void setDrugResult6(String drugResult6) {
        this.drugResult6 = drugResult6;
    }
}
