package com.yihu.jw.followup;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.searchbox.annotations.JestId;
import lombok.Data;
import org.springframework.data.annotation.CreatedDate;

import java.util.Date;

/**
 * 老年人健康体检随访记录表
 * create by hmf on 2019/4/18
 */
@Data
public class OlderPeopleHealthCheckRecordES {

    @JestId
    private String id;
    private String followup_id;             //随访记录ID
    private String followup_project;        //随访详情分类ID
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyyMMdd'T'HHmmss.SSS'Z'")
    @CreatedDate
    private Date create_time;
    private String create_user;
    private String create_user_name;
    private String version;//版本号

    private String name;//老人姓名
    private String idcard;//身份证
    private String number;//体检编号
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+08:00")
    private Date duty;//体检日期
    private String responsibility_doctor_name;//责任医生

    /**********  症状  **********/
    private String symptom;//症状,多个用逗号隔开（1无症状 2头痛 3头晕 4心悸 5胸闷 6胸痛 7慢性咳嗽 8咳痰 9呼吸困难 10多饮
    // 11多尿 12体重下降 13乏力 14 关节肿痛 15视力模糊 16手脚麻木 17尿急 18尿痛 19便秘 20腹泻 21恶心呕吐 22眼花 23 耳鸣 24乳房胀痛 25其他）
    private String symptom_other;//其他症状说明

    /**********  一般情况  **********/
    private Double temperature;//体温
    private String pulse_frequency;//心率 次/分钟
    private String breath_frequency;//呼吸频率 次/分钟

    private Integer blood_pressure_left_low;//血压左侧低值
    private Integer blood_pressure_left_high;//血压左侧高值
    private Integer blood_pressure_right_low;//血压右侧低值
    private Integer blood_pressure_right_high;//血压右侧高值

    private Double height;//身高,cm
    private Double weight;//体重,kg
    private Double waistline;//腰围,cm
    private Double BMI;//体质组数,kg/m2

    private Integer health_status;//老年人健康状态自我评估(1满意 2基本满意 3说不清楚 4不太满意 5不满意)
    private Integer selfcare_ability;//老年人生活自理能力自我评估(1、可自理0~3分 2、轻度依赖4~8分 3、中度依赖9~18分 4、不能自理≥19分)
    private Integer cognitive_function;//认知功能（1粗筛阴性 2粗筛阳性）
    private Integer cognitive_function_score;//简易智力状态检查，总分
    private Integer emotional_state;//情感状态（1粗筛阴性 2粗筛阳性）
    private Integer emotional_state_score;//简易抑郁评分检查，总分

    /**********  生活方式  **********/

    //体育锻炼
    private Integer exercise_frequency;//锻炼频率（1每天 2每周一次以上 3偶尔 4不锻炼）
    private Integer exercise_time;//每次锻炼时间 ，分钟
    private String sustain_exercise_time;//坚持锻炼时间，年
    private String exercise_type;//锻炼方式

    private String dietary_habit;//饮食习惯(1荤素均衡 2荤食为主 3素食为主 4嗜盐 5嗜油 6嗜糖)

    //吸烟情况
    private Integer smoking_state;//吸烟状况（1从不吸烟 2已戒烟 3吸烟）
    private Integer smoking_daily;//日吸烟量，支
    private Integer start_smoking_age;//开始吸烟年龄，岁
    private Integer stop_smoking_age;//戒烟年龄，岁

    //饮酒情况
    private Integer drinking_frequency;//饮酒频率（1从不 2偶尔 3经常 4每天）
    private Integer drinking_daily;//日饮酒量，两
    private Integer is_stop_drinking;//是否戒酒（1否，2是）
    private Integer stop_drinking_age;//戒酒年龄，岁
    private Integer start_drinking_age;//开始饮酒年龄
    private Integer drunkenness;//近一年是否曾醉酒（1是 2否）
    private String drinking_type;//饮酒品种（1白酒 2啤酒 3红酒 4黄酒 5其他）
    private String other_drinking_type;//其他的饮酒品种

    //职业病危害因素接触史
    private String dust;//粉尘
    private Integer dust_protective_measures;//是否有粉尘防护措施（1无 2有）
    private String dust_protective_measures_has;//粉尘防护措施
    private String radiogen;//放射物质
    private Integer radiogen_protective_measures;//是否有放射物质防护措施（1无 2有）
    private String radiogen_protective_measures_has;//放射物质防护措施
    private String physical_factor;//物理因素
    private Integer physical_protective_measures;//是否有物理因素防护措施（1无 2有）
    private String physical_protective_measures_has;//物理因素防护措施
    private String chemical_factor;//化学因素
    private Integer chemical_protective_measures;//是否有化学因素防护措施（1无 2有）
    private String chemical_protective_measures_has;//化学因素防护措施
    private String other_hazard_factors;//其他危害因素
    private Integer other_hazard_protective_measures;//是否有其他危害因素防护措施（1无 2有）
    private String other_hazard_protective_measures_has;//其他危害因素防护措施

    /**********  脏器功能  **********/
    //口腔
    private Integer lip;//口唇（1红润 2苍白 3发钳 4皲裂 5疱疹）
    private Integer dentition;//齿列（1正常 2缺齿 3龋齿 4义齿，假牙）
    private Integer oropharynx;//咽部（1无充血 2充血 3淋巴滤泡增生）

    private Double left_eyesight;//左眼视力
    private Double right_eyesight;//右眼视力
    private Double left_correctional_eyesight;//左眼矫正视力
    private Double right_correctional_eyesight;//右眼矫正视力

    private Integer hearing;//听力（1听见 2听不清或无法听见）

    private Integer motor_function;//运动功能（1可顺利完成 2无法独立完成任何一个动作）

    /**********  查体  **********/
    private Integer fundus;//眼底（1正常 2异常）
    private String fundus_abnormal;//眼底异常表现

    private Integer skin;//皮肤（1正常 2潮红 3苍白 4发钳 5黄染 6色素沉着 7其他）
    private String skin_other;//皮肤其他状态描述

    private Integer sclera;//巩膜（1正常 2黄染 3充血 4其他）
    private String sclera_other;//巩膜其他状态描述

    private Integer lymphaden;//淋巴结（1未触及 2锁骨上 3腋窝 4其他 ）
    private String lymphaden_other;//淋巴结其他位置

    //肺
    private Integer barrel_chest;//桶状胸（1否 2是）
    private Integer breath_sounds;//呼吸音（1正常 2异常）
    private String breath_sounds_abnormal;//呼吸异常描述
    private Integer rale;//罗音（1无 2干罗音 3湿罗音 4其他）
    private String rale_abnormal;//其他罗音描述

    //心脏
    private Integer heart_rate;//心率，次/分钟
    private Integer heart_rhythm;//心律（1齐 2不齐 3绝对不齐）
    private Integer heart_noise;//杂音（1无 2有）
    private String heart_noise_has;//有杂音描述

    //腹部
    private Integer abdominal_tenderness;//是否压痛（1无 2有）
    private String tenderness_has;//有压痛描述
    private Integer abdominal_mass;//是否腹部包块（1无 2有）
    private String mass_has;//有腹部包块描述
    private Integer abdominal_hepatomegaly;//是否腹部肝大（1无 2有）
    private String hepatomegaly_has;//腹部肝大描述
    private Integer abdominal_spleen_big;//是否腹部脾大（1无 2有）
    private String spleen_big_has;//腹部脾大
    private Integer abdominal_shifting_dullness;//是否移动性浊音（1无 2有）
    private String shifting_dullness_has;//移动性浊音

    private Integer crura_edema;//下肢水肿（1无 2单侧 3双侧不对称 4双侧对称）
    private Integer dorsal_foot_pulse;//足背动脉搏动（1未接触 2触及双侧对称 3触及左侧弱或消失 4触及右侧弱或消失 ）
    private Integer anus_dre;//肛门指诊（1未见异常 2触痛 3包块 4前列腺异常 5其他）
    private String anus_dre_other;//肛门指诊其他现象
    private String breast;//乳腺（1未见异常 2乳房切除 3异常泌乳 4乳腺包块 5其他）
    private String breast_other;//乳腺其他现象

    //妇科
    private Integer vulva;//外阴（1未见异常 2异常）
    private String vulva_abnormal;//外阴异常描述
    private Integer vagina;//阴道（1未见异常 2异常）
    private String vagina_abnormal;//阴道异常描述
    private Integer cervical;//宫颈（1未见异常 2异常）
    private String cervical_abnormal;//宫颈异常描述
    private Integer corpus;//宫体（1未见异常 2异常）
    private String corpus_abnormal;//宫体异常描述
    private Integer gynecologic_appendix;//妇科附件（1未见异常 2异常）
    private String appendix_abnormal;//附件异常描述

    private String physical_examination_other;//查体其他信息

    /**********  辅助检查  **********/
    //血常规
    private Double hemoglobin;//血红蛋白
    private Double leukocyte;//白细胞
    private Double thrombocyte;//血小板
    private String blood_routine_other;//其他血常规

    //尿常规
    private String urine_protein;//尿蛋白
    private String urine_sugar;//尿糖
    private String urine_acetone_bodies;//尿酮体
    private String urine_occult_blood;//尿潜血
    private String urine_routine_other;//其他尿常规

    private Double fasting_blood_glucose_L;//空腹血糖,单位mmol/L
    private Double fasting_blood_glucose_dL;//空腹血糖,单位mg/dL

    private Integer electrocardiogram;//心电图(1正常 2异常)
    private String electrocardiogram_abnormal;//心电图异常

    private Double microalbuminuria;//尿微量白蛋白， mg/dL
    private Integer occult_blood_in_stool;//大便潜血（1阴性 2阳性）
    private Double glycated_hemoglobin;//糖化血红蛋白
    private Integer HBsAg;//乙型肝炎表面抗原（1阴性 2阳性）

    //肝功能
    private Double ALT;//血清谷丙转氨酶
    private Double SGOT;//血清谷草转氨酶
    private Double albumin;//白蛋白
    private Double total_bilirubin;//总胆红素
    private Double conjugated_bilirubin;//结合胆红素

    //肾功能
    private Double serum_creatinine;//血清肌酐
    private Double blood_urea_nitrogen;//血尿素氮
    private Double blood_potassium_concentration;//血钾浓度
    private Double blood_Na_concentration;//血钠浓度
    private Double uric_acid;//尿酸

    //血脂
    private Double total_cholesterol;//总胆固醇
    private Double triglyceride;//甘油三酯
    private Double LDL_cholesterol;//血清低密度脂蛋白胆固醇
    private Double HDL_cholesterol;//血清高密度脂蛋白胆固醇

    private Double alpha_fetal_protein;//甲胎蛋白

    private Integer chest_Xray;//胸部X线片(1正常 2异常)
    private String chest_Xray_abnormal;//胸部X线片异常

    //B超
    private Integer abdomen_B_ultrasonic;//腹部b超(1正常 2异常)
    private String abdomen_B_ultrasonic_abnormal;//腹部b超异常描述
    private Integer B_ultrasonic_other;//b超其他部位(1正常 2异常)
    private String B_ultrasonic_other_abnormal;//b超其他部位异常描述

    private Integer cervical_smear;//宫颈涂片(1正常 2异常)
    private String cervical_smear_abnormal;//宫颈涂片异常描述

    private String  auxiliary_examination_other;//其他辅助检查

    /**********  中医体质辨识  **********/
    private Integer mild_physical;//平和质（1是 2基本是）
    private Integer qi_deficiency;//气虚质（1是 2倾向是）
    private Integer  yang_deficiency;//阳虚质（1是 2倾向是）
    private Integer yin_deficiency ;//阴虚质（1是 2倾向是）
    private Integer phlegm_dampness;//痰湿质（1是 2倾向是）
    private Integer dampness_heat;//湿热质（1是 2倾向是）
    private Integer blood_stasis;//血瘀质（1是 2倾向是）
    private Integer logistic_regression;//气郁质（1是 2倾向是）
    private Integer grasp_quality;//特秉质（1是 2倾向是）

    /**********  现存主要健康问题  **********/
    //脑血管疾病
    private String cerebrovascular_disease;//脑血管疾病（1未发现 2缺血性卒中 3脑出血 4蛛网膜下腔出血 5短暂性脑缺血发作 6其他）
    private String cerebrovascular_disease_other;//其他脑血管疾病

    private String nephropathy;//肾脏疾病（1未发现 2糖尿病肾病 3 肾功能衰竭 4急性肾炎 5慢性肾炎 6其他）
    private String nephropathy_other;//其他肾脏疾病

    private String heart_disease;//心脏疾病（1未发现 2心肌梗死 3心绞痛 4冠状动脉血运重建 5充血性心力衰竭 6心前区疼痛 7其他）
    private String heart_disease_other;//其他心脏疾病

    private String vascular_disease;//血管疾病（1未发现 2夹层动脉瘤 3动脉闭塞性疾病 4其他）
    private String vascular_disease_other;//其他血管疾病

    private String eye_disease;//眼部疾病（1未发现 2视网膜出血或渗出 3视乳头水肿 4白内障 5其他）
    private String eye_disease_other;//其他眼部疾病

    private Integer nervous_system_disease;//神经系统疾病（1未发现 2有）
    private String nervous_system_disease_has;//有神经系统疾病

    private Integer other_system_disease;//其他系统疾病（1未发现 2有）
    private String other_system_disease_has;//有其他系统疾病说明

    /**********  住院治疗情况  **********/
    //住院史
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+08:00")
    private Date admission_date1;//入院日期
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+08:00")
    private Date discharge_date1;//出院日期
    private String admission_reason1;//入院原因
    private String admission_hospital_name1;//入院医疗机构名称
    private String admission_number1;//病案号

    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+08:00")
    private Date admission_date2;//入院日期
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+08:00")
    private Date discharge_date2;//出院日期
    private String admission_reason2;//入院原因
    private String admission_hospital_name2;//入院医疗机构名称
    private String admission_number2;//病案号

    //家庭病床史
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+08:00")
    private Date building_bed_date1;//建床日期
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+08:00")
    private Date cancel_bed_date1;//撤床日期
    private String building_bed_reason1;//建床原因
    private String building_bed_hospiatl_name1;//医疗机构名称
    private String building_bed_number1;//建床病案号

    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+08:00")
    private Date building_bed_date2;//建床日期
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+08:00")
    private Date cancel_bed_date2;//撤床日期
    private String building_bed_reason2;//建床原因
    private String building_bed_hospiatl_name2;//医疗机构名称
    private String building_bed_number2;//建床病案号

    /**********  主要用药情况  **********/
    private String medicine1;//药物名称
    private String medicine1_use;//用法
    private String medicine1_dosage;//用量
    private String medication1_time;//用药时间
    private Integer medication1_compliance;//服药依从性(1规律 2间断 3不服药)

    private String medicine2;//药物名称
    private String medicine2_use;//用法
    private String medicine2_dosage;//用量
    private String medication2_time;//用药时间
    private Integer medication2_compliance;//服药依从性(1规律 2间断 3不服药)

    private String medicine3;//药物名称
    private String medicine3_use;//用法
    private String medicine3_dosage;//用量
    private String medication3_time;//用药时间
    private Integer medication3_compliance;//服药依从性(1规律 2间断 3不服药)

    private String medicine4;//药物名称
    private String medicine4_use;//用法
    private String medicine4_dosage;//用量
    private String medication4_time;//用药时间
    private Integer medication4_compliance;//服药依从性(1规律 2间断 3不服药)

    private String medicine5;//药物名称
    private String medicine5_use;//用法
    private String medicine5_dosage;//用量
    private String medication5_time;//用药时间
    private Integer medication5_compliance;//服药依从性(1规律 2间断 3不服药)

    private String medicine6;//药物名称
    private String medicine6_use;//用法
    private String medicine6_dosage;//用量
    private String medication6_time;//用药时间
    private Integer medication6_compliance;//服药依从性(1规律 2间断 3不服药)

    /**********  非免疫规划预防接种史  **********/
    private String vaccination_name1;//预防接种名称
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+08:00")
    private Date vaccination_date1;//预防接种日期
    private String vaccination_hospital_name1;//预防接种机构

    private String vaccination_name2;//预防接种名称
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+08:00")
    private Date vaccination_date2;//预防接种日期
    private String vaccination_hospital_name2;//预防接种机构

    private String vaccination_name3;//预防接种名称
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+08:00")
    private Date vaccination_date3;//预防接种日期
    private String vaccination_hospital_name3;//预防接种机构

    /**********  健康评价  **********/
    private Integer health_examination;//体检是否异常（1无 2有）
    private String health_examination_abnormal1;//体检异常1
    private String health_examination_abnormal2;//体检异常2
    private String health_examination_abnormal3;//体检异常3
    private String health_examination_abnormal4;//体检异常4

    /**********  健康指导  **********/
    private Integer regular_followup;//定期随访（1无，2有）
    private Integer chronic_health_management;//纳入慢性病患者健康管理（1无，2有）
    private Integer suggest_recheck;//建议复查（1无，2有）
    private Integer suggest_referral;//建议转诊（1无，2有）
    private Integer other_health_guidance;//其他健康指导（1无，2有）
    private String other_health_guidance_description;//其他健康指导内容（1无，2有）

    /**********  危险因素控制  **********/
    private Integer stop_smoking;//戒烟（1无，2有）
    private Integer healthy_drinking;//健康饮酒（1无，2有）
    private Integer diet;//饮食（1无，2有）
    private Integer exercise;//锻炼（1无，2有）
    private Integer lose_weight;//减肥（1无，2有）
    private Double goal_weight;//目标体重
    private String recommended_vaccination;//建议接种疫苗（1无，2有）
    private Integer other_advice;//是否有其他建议（1无，2有）
    private String other_advice_description;//其他建议内容

    /**********  老人自理能力评估内容  **********/
    private String assessment_number;//评估编号
    private String assessment_doctorName;//评估医生
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+08:00")
    private Date assessment_time;//评估日期
    private Integer eat;//进餐（1独立完成0-3分 2轻度依赖4-8分 3中度依赖9-18分 4不能自理≥19分）
    private Integer wash;//梳洗（1独立完成0-3分 2轻度依赖4-8分 3中度依赖9-18分 4不能自理≥19分
    private Integer dress;//穿衣（1独立完成0-3分 2轻度依赖4-8分 3中度依赖9-18分 4不能自理≥19分
    private Integer toilet;//如厕（1独立完成0-3分 2轻度依赖4-8分 3中度依赖9-18分 4不能自理≥19分
    private Integer activity;//活动（1独立完成0-3分 2轻度依赖4-8分 3中度依赖9-18分 4不能自理≥19分
    private Integer score;//总评分

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getFollowup_id() {
        return followup_id;
    }

    public void setFollowup_id(String followup_id) {
        this.followup_id = followup_id;
    }

    public String getFollowup_project() {
        return followup_project;
    }

    public void setFollowup_project(String followup_project) {
        this.followup_project = followup_project;
    }

    public Date getCreate_time() {
        return create_time;
    }

    public void setCreate_time(Date create_time) {
        this.create_time = create_time;
    }

    public String getCreate_user() {
        return create_user;
    }

    public void setCreate_user(String create_user) {
        this.create_user = create_user;
    }

    public String getCreate_user_name() {
        return create_user_name;
    }

    public void setCreate_user_name(String create_user_name) {
        this.create_user_name = create_user_name;
    }

    public String getVersion() {
        return version;
    }

    public void setVersion(String version) {
        this.version = version;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getIdcard() {
        return idcard;
    }

    public void setIdcard(String idcard) {
        this.idcard = idcard;
    }

    public String getNumber() {
        return number;
    }

    public void setNumber(String number) {
        this.number = number;
    }

    public Date getDuty() {
        return duty;
    }

    public void setDuty(Date duty) {
        this.duty = duty;
    }

    public String getResponsibility_doctor_name() {
        return responsibility_doctor_name;
    }

    public void setResponsibility_doctor_name(String responsibility_doctor_name) {
        this.responsibility_doctor_name = responsibility_doctor_name;
    }

    public String getSymptom() {
        return symptom;
    }

    public void setSymptom(String symptom) {
        this.symptom = symptom;
    }

    public String getSymptom_other() {
        return symptom_other;
    }

    public void setSymptom_other(String symptom_other) {
        this.symptom_other = symptom_other;
    }

    public Double getTemperature() {
        return temperature;
    }

    public void setTemperature(Double temperature) {
        this.temperature = temperature;
    }

    public String getPulse_frequency() {
        return pulse_frequency;
    }

    public void setPulse_frequency(String pulse_frequency) {
        this.pulse_frequency = pulse_frequency;
    }

    public String getBreath_frequency() {
        return breath_frequency;
    }

    public void setBreath_frequency(String breath_frequency) {
        this.breath_frequency = breath_frequency;
    }

    public Integer getBlood_pressure_left_low() {
        return blood_pressure_left_low;
    }

    public void setBlood_pressure_left_low(Integer blood_pressure_left_low) {
        this.blood_pressure_left_low = blood_pressure_left_low;
    }

    public Integer getBlood_pressure_left_high() {
        return blood_pressure_left_high;
    }

    public void setBlood_pressure_left_high(Integer blood_pressure_left_high) {
        this.blood_pressure_left_high = blood_pressure_left_high;
    }

    public Integer getBlood_pressure_right_low() {
        return blood_pressure_right_low;
    }

    public void setBlood_pressure_right_low(Integer blood_pressure_right_low) {
        this.blood_pressure_right_low = blood_pressure_right_low;
    }

    public Integer getBlood_pressure_right_high() {
        return blood_pressure_right_high;
    }

    public void setBlood_pressure_right_high(Integer blood_pressure_right_high) {
        this.blood_pressure_right_high = blood_pressure_right_high;
    }

    public Double getHeight() {
        return height;
    }

    public void setHeight(Double height) {
        this.height = height;
    }

    public Double getWeight() {
        return weight;
    }

    public void setWeight(Double weight) {
        this.weight = weight;
    }

    public Double getWaistline() {
        return waistline;
    }

    public void setWaistline(Double waistline) {
        this.waistline = waistline;
    }

    public Double getBMI() {
        return BMI;
    }

    public void setBMI(Double BMI) {
        this.BMI = BMI;
    }

    public Integer getHealth_status() {
        return health_status;
    }

    public void setHealth_status(Integer health_status) {
        this.health_status = health_status;
    }

    public Integer getSelfcare_ability() {
        return selfcare_ability;
    }

    public void setSelfcare_ability(Integer selfcare_ability) {
        this.selfcare_ability = selfcare_ability;
    }

    public Integer getCognitive_function() {
        return cognitive_function;
    }

    public void setCognitive_function(Integer cognitive_function) {
        this.cognitive_function = cognitive_function;
    }

    public Integer getCognitive_function_score() {
        return cognitive_function_score;
    }

    public void setCognitive_function_score(Integer cognitive_function_score) {
        this.cognitive_function_score = cognitive_function_score;
    }

    public Integer getEmotional_state() {
        return emotional_state;
    }

    public void setEmotional_state(Integer emotional_state) {
        this.emotional_state = emotional_state;
    }

    public Integer getEmotional_state_score() {
        return emotional_state_score;
    }

    public void setEmotional_state_score(Integer emotional_state_score) {
        this.emotional_state_score = emotional_state_score;
    }

    public Integer getExercise_frequency() {
        return exercise_frequency;
    }

    public void setExercise_frequency(Integer exercise_frequency) {
        this.exercise_frequency = exercise_frequency;
    }

    public Integer getExercise_time() {
        return exercise_time;
    }

    public void setExercise_time(Integer exercise_time) {
        this.exercise_time = exercise_time;
    }

    public String getSustain_exercise_time() {
        return sustain_exercise_time;
    }

    public void setSustain_exercise_time(String sustain_exercise_time) {
        this.sustain_exercise_time = sustain_exercise_time;
    }

    public String getExercise_type() {
        return exercise_type;
    }

    public void setExercise_type(String exercise_type) {
        this.exercise_type = exercise_type;
    }

    public String getDietary_habit() {
        return dietary_habit;
    }

    public void setDietary_habit(String dietary_habit) {
        this.dietary_habit = dietary_habit;
    }

    public Integer getSmoking_state() {
        return smoking_state;
    }

    public void setSmoking_state(Integer smoking_state) {
        this.smoking_state = smoking_state;
    }

    public Integer getSmoking_daily() {
        return smoking_daily;
    }

    public void setSmoking_daily(Integer smoking_daily) {
        this.smoking_daily = smoking_daily;
    }

    public Integer getStart_smoking_age() {
        return start_smoking_age;
    }

    public void setStart_smoking_age(Integer start_smoking_age) {
        this.start_smoking_age = start_smoking_age;
    }

    public Integer getStop_smoking_age() {
        return stop_smoking_age;
    }

    public void setStop_smoking_age(Integer stop_smoking_age) {
        this.stop_smoking_age = stop_smoking_age;
    }

    public Integer getDrinking_frequency() {
        return drinking_frequency;
    }

    public void setDrinking_frequency(Integer drinking_frequency) {
        this.drinking_frequency = drinking_frequency;
    }

    public Integer getDrinking_daily() {
        return drinking_daily;
    }

    public void setDrinking_daily(Integer drinking_daily) {
        this.drinking_daily = drinking_daily;
    }

    public Integer getIs_stop_drinking() {
        return is_stop_drinking;
    }

    public void setIs_stop_drinking(Integer is_stop_drinking) {
        this.is_stop_drinking = is_stop_drinking;
    }

    public Integer getStop_drinking_age() {
        return stop_drinking_age;
    }

    public void setStop_drinking_age(Integer stop_drinking_age) {
        this.stop_drinking_age = stop_drinking_age;
    }

    public Integer getStart_drinking_age() {
        return start_drinking_age;
    }

    public void setStart_drinking_age(Integer start_drinking_age) {
        this.start_drinking_age = start_drinking_age;
    }

    public Integer getDrunkenness() {
        return drunkenness;
    }

    public void setDrunkenness(Integer drunkenness) {
        this.drunkenness = drunkenness;
    }

    public String getDrinking_type() {
        return drinking_type;
    }

    public void setDrinking_type(String drinking_type) {
        this.drinking_type = drinking_type;
    }

    public String getOther_drinking_type() {
        return other_drinking_type;
    }

    public void setOther_drinking_type(String other_drinking_type) {
        this.other_drinking_type = other_drinking_type;
    }

    public String getDust() {
        return dust;
    }

    public void setDust(String dust) {
        this.dust = dust;
    }

    public Integer getDust_protective_measures() {
        return dust_protective_measures;
    }

    public void setDust_protective_measures(Integer dust_protective_measures) {
        this.dust_protective_measures = dust_protective_measures;
    }

    public String getDust_protective_measures_has() {
        return dust_protective_measures_has;
    }

    public void setDust_protective_measures_has(String dust_protective_measures_has) {
        this.dust_protective_measures_has = dust_protective_measures_has;
    }

    public String getRadiogen() {
        return radiogen;
    }

    public void setRadiogen(String radiogen) {
        this.radiogen = radiogen;
    }

    public Integer getRadiogen_protective_measures() {
        return radiogen_protective_measures;
    }

    public void setRadiogen_protective_measures(Integer radiogen_protective_measures) {
        this.radiogen_protective_measures = radiogen_protective_measures;
    }

    public String getRadiogen_protective_measures_has() {
        return radiogen_protective_measures_has;
    }

    public void setRadiogen_protective_measures_has(String radiogen_protective_measures_has) {
        this.radiogen_protective_measures_has = radiogen_protective_measures_has;
    }

    public String getPhysical_factor() {
        return physical_factor;
    }

    public void setPhysical_factor(String physical_factor) {
        this.physical_factor = physical_factor;
    }

    public Integer getPhysical_protective_measures() {
        return physical_protective_measures;
    }

    public void setPhysical_protective_measures(Integer physical_protective_measures) {
        this.physical_protective_measures = physical_protective_measures;
    }

    public String getPhysical_protective_measures_has() {
        return physical_protective_measures_has;
    }

    public void setPhysical_protective_measures_has(String physical_protective_measures_has) {
        this.physical_protective_measures_has = physical_protective_measures_has;
    }

    public String getChemical_factor() {
        return chemical_factor;
    }

    public void setChemical_factor(String chemical_factor) {
        this.chemical_factor = chemical_factor;
    }

    public Integer getChemical_protective_measures() {
        return chemical_protective_measures;
    }

    public void setChemical_protective_measures(Integer chemical_protective_measures) {
        this.chemical_protective_measures = chemical_protective_measures;
    }

    public String getChemical_protective_measures_has() {
        return chemical_protective_measures_has;
    }

    public void setChemical_protective_measures_has(String chemical_protective_measures_has) {
        this.chemical_protective_measures_has = chemical_protective_measures_has;
    }

    public String getOther_hazard_factors() {
        return other_hazard_factors;
    }

    public void setOther_hazard_factors(String other_hazard_factors) {
        this.other_hazard_factors = other_hazard_factors;
    }

    public Integer getOther_hazard_protective_measures() {
        return other_hazard_protective_measures;
    }

    public void setOther_hazard_protective_measures(Integer other_hazard_protective_measures) {
        this.other_hazard_protective_measures = other_hazard_protective_measures;
    }

    public String getOther_hazard_protective_measures_has() {
        return other_hazard_protective_measures_has;
    }

    public void setOther_hazard_protective_measures_has(String other_hazard_protective_measures_has) {
        this.other_hazard_protective_measures_has = other_hazard_protective_measures_has;
    }

    public Integer getLip() {
        return lip;
    }

    public void setLip(Integer lip) {
        this.lip = lip;
    }

    public Integer getDentition() {
        return dentition;
    }

    public void setDentition(Integer dentition) {
        this.dentition = dentition;
    }

    public Integer getOropharynx() {
        return oropharynx;
    }

    public void setOropharynx(Integer oropharynx) {
        this.oropharynx = oropharynx;
    }

    public Double getLeft_eyesight() {
        return left_eyesight;
    }

    public void setLeft_eyesight(Double left_eyesight) {
        this.left_eyesight = left_eyesight;
    }

    public Double getRight_eyesight() {
        return right_eyesight;
    }

    public void setRight_eyesight(Double right_eyesight) {
        this.right_eyesight = right_eyesight;
    }

    public Double getLeft_correctional_eyesight() {
        return left_correctional_eyesight;
    }

    public void setLeft_correctional_eyesight(Double left_correctional_eyesight) {
        this.left_correctional_eyesight = left_correctional_eyesight;
    }

    public Double getRight_correctional_eyesight() {
        return right_correctional_eyesight;
    }

    public void setRight_correctional_eyesight(Double right_correctional_eyesight) {
        this.right_correctional_eyesight = right_correctional_eyesight;
    }

    public Integer getHearing() {
        return hearing;
    }

    public void setHearing(Integer hearing) {
        this.hearing = hearing;
    }

    public Integer getMotor_function() {
        return motor_function;
    }

    public void setMotor_function(Integer motor_function) {
        this.motor_function = motor_function;
    }

    public Integer getFundus() {
        return fundus;
    }

    public void setFundus(Integer fundus) {
        this.fundus = fundus;
    }

    public String getFundus_abnormal() {
        return fundus_abnormal;
    }

    public void setFundus_abnormal(String fundus_abnormal) {
        this.fundus_abnormal = fundus_abnormal;
    }

    public Integer getSkin() {
        return skin;
    }

    public void setSkin(Integer skin) {
        this.skin = skin;
    }

    public String getSkin_other() {
        return skin_other;
    }

    public void setSkin_other(String skin_other) {
        this.skin_other = skin_other;
    }

    public Integer getSclera() {
        return sclera;
    }

    public void setSclera(Integer sclera) {
        this.sclera = sclera;
    }

    public String getSclera_other() {
        return sclera_other;
    }

    public void setSclera_other(String sclera_other) {
        this.sclera_other = sclera_other;
    }

    public Integer getLymphaden() {
        return lymphaden;
    }

    public void setLymphaden(Integer lymphaden) {
        this.lymphaden = lymphaden;
    }

    public String getLymphaden_other() {
        return lymphaden_other;
    }

    public void setLymphaden_other(String lymphaden_other) {
        this.lymphaden_other = lymphaden_other;
    }

    public Integer getBarrel_chest() {
        return barrel_chest;
    }

    public void setBarrel_chest(Integer barrel_chest) {
        this.barrel_chest = barrel_chest;
    }

    public Integer getBreath_sounds() {
        return breath_sounds;
    }

    public void setBreath_sounds(Integer breath_sounds) {
        this.breath_sounds = breath_sounds;
    }

    public String getBreath_sounds_abnormal() {
        return breath_sounds_abnormal;
    }

    public void setBreath_sounds_abnormal(String breath_sounds_abnormal) {
        this.breath_sounds_abnormal = breath_sounds_abnormal;
    }

    public Integer getRale() {
        return rale;
    }

    public void setRale(Integer rale) {
        this.rale = rale;
    }

    public String getRale_abnormal() {
        return rale_abnormal;
    }

    public void setRale_abnormal(String rale_abnormal) {
        this.rale_abnormal = rale_abnormal;
    }

    public Integer getHeart_rate() {
        return heart_rate;
    }

    public void setHeart_rate(Integer heart_rate) {
        this.heart_rate = heart_rate;
    }

    public Integer getHeart_rhythm() {
        return heart_rhythm;
    }

    public void setHeart_rhythm(Integer heart_rhythm) {
        this.heart_rhythm = heart_rhythm;
    }

    public Integer getHeart_noise() {
        return heart_noise;
    }

    public void setHeart_noise(Integer heart_noise) {
        this.heart_noise = heart_noise;
    }

    public String getHeart_noise_has() {
        return heart_noise_has;
    }

    public void setHeart_noise_has(String heart_noise_has) {
        this.heart_noise_has = heart_noise_has;
    }

    public Integer getAbdominal_tenderness() {
        return abdominal_tenderness;
    }

    public void setAbdominal_tenderness(Integer abdominal_tenderness) {
        this.abdominal_tenderness = abdominal_tenderness;
    }

    public String getTenderness_has() {
        return tenderness_has;
    }

    public void setTenderness_has(String tenderness_has) {
        this.tenderness_has = tenderness_has;
    }

    public Integer getAbdominal_mass() {
        return abdominal_mass;
    }

    public void setAbdominal_mass(Integer abdominal_mass) {
        this.abdominal_mass = abdominal_mass;
    }

    public String getMass_has() {
        return mass_has;
    }

    public void setMass_has(String mass_has) {
        this.mass_has = mass_has;
    }

    public Integer getAbdominal_hepatomegaly() {
        return abdominal_hepatomegaly;
    }

    public void setAbdominal_hepatomegaly(Integer abdominal_hepatomegaly) {
        this.abdominal_hepatomegaly = abdominal_hepatomegaly;
    }

    public String getHepatomegaly_has() {
        return hepatomegaly_has;
    }

    public void setHepatomegaly_has(String hepatomegaly_has) {
        this.hepatomegaly_has = hepatomegaly_has;
    }

    public Integer getAbdominal_spleen_big() {
        return abdominal_spleen_big;
    }

    public void setAbdominal_spleen_big(Integer abdominal_spleen_big) {
        this.abdominal_spleen_big = abdominal_spleen_big;
    }

    public String getSpleen_big_has() {
        return spleen_big_has;
    }

    public void setSpleen_big_has(String spleen_big_has) {
        this.spleen_big_has = spleen_big_has;
    }

    public Integer getAbdominal_shifting_dullness() {
        return abdominal_shifting_dullness;
    }

    public void setAbdominal_shifting_dullness(Integer abdominal_shifting_dullness) {
        this.abdominal_shifting_dullness = abdominal_shifting_dullness;
    }

    public String getShifting_dullness_has() {
        return shifting_dullness_has;
    }

    public void setShifting_dullness_has(String shifting_dullness_has) {
        this.shifting_dullness_has = shifting_dullness_has;
    }

    public Integer getCrura_edema() {
        return crura_edema;
    }

    public void setCrura_edema(Integer crura_edema) {
        this.crura_edema = crura_edema;
    }

    public Integer getDorsal_foot_pulse() {
        return dorsal_foot_pulse;
    }

    public void setDorsal_foot_pulse(Integer dorsal_foot_pulse) {
        this.dorsal_foot_pulse = dorsal_foot_pulse;
    }

    public Integer getAnus_dre() {
        return anus_dre;
    }

    public void setAnus_dre(Integer anus_dre) {
        this.anus_dre = anus_dre;
    }

    public String getAnus_dre_other() {
        return anus_dre_other;
    }

    public void setAnus_dre_other(String anus_dre_other) {
        this.anus_dre_other = anus_dre_other;
    }

    public String getBreast() {
        return breast;
    }

    public void setBreast(String breast) {
        this.breast = breast;
    }

    public String getBreast_other() {
        return breast_other;
    }

    public void setBreast_other(String breast_other) {
        this.breast_other = breast_other;
    }

    public Integer getVulva() {
        return vulva;
    }

    public void setVulva(Integer vulva) {
        this.vulva = vulva;
    }

    public String getVulva_abnormal() {
        return vulva_abnormal;
    }

    public void setVulva_abnormal(String vulva_abnormal) {
        this.vulva_abnormal = vulva_abnormal;
    }

    public Integer getVagina() {
        return vagina;
    }

    public void setVagina(Integer vagina) {
        this.vagina = vagina;
    }

    public String getVagina_abnormal() {
        return vagina_abnormal;
    }

    public void setVagina_abnormal(String vagina_abnormal) {
        this.vagina_abnormal = vagina_abnormal;
    }

    public Integer getCervical() {
        return cervical;
    }

    public void setCervical(Integer cervical) {
        this.cervical = cervical;
    }

    public String getCervical_abnormal() {
        return cervical_abnormal;
    }

    public void setCervical_abnormal(String cervical_abnormal) {
        this.cervical_abnormal = cervical_abnormal;
    }

    public Integer getCorpus() {
        return corpus;
    }

    public void setCorpus(Integer corpus) {
        this.corpus = corpus;
    }

    public String getCorpus_abnormal() {
        return corpus_abnormal;
    }

    public void setCorpus_abnormal(String corpus_abnormal) {
        this.corpus_abnormal = corpus_abnormal;
    }

    public Integer getGynecologic_appendix() {
        return gynecologic_appendix;
    }

    public void setGynecologic_appendix(Integer gynecologic_appendix) {
        this.gynecologic_appendix = gynecologic_appendix;
    }

    public String getAppendix_abnormal() {
        return appendix_abnormal;
    }

    public void setAppendix_abnormal(String appendix_abnormal) {
        this.appendix_abnormal = appendix_abnormal;
    }

    public String getPhysical_examination_other() {
        return physical_examination_other;
    }

    public void setPhysical_examination_other(String physical_examination_other) {
        this.physical_examination_other = physical_examination_other;
    }

    public Double getHemoglobin() {
        return hemoglobin;
    }

    public void setHemoglobin(Double hemoglobin) {
        this.hemoglobin = hemoglobin;
    }

    public Double getLeukocyte() {
        return leukocyte;
    }

    public void setLeukocyte(Double leukocyte) {
        this.leukocyte = leukocyte;
    }

    public Double getThrombocyte() {
        return thrombocyte;
    }

    public void setThrombocyte(Double thrombocyte) {
        this.thrombocyte = thrombocyte;
    }

    public String getBlood_routine_other() {
        return blood_routine_other;
    }

    public void setBlood_routine_other(String blood_routine_other) {
        this.blood_routine_other = blood_routine_other;
    }

    public String getUrine_protein() {
        return urine_protein;
    }

    public void setUrine_protein(String urine_protein) {
        this.urine_protein = urine_protein;
    }

    public String getUrine_sugar() {
        return urine_sugar;
    }

    public void setUrine_sugar(String urine_sugar) {
        this.urine_sugar = urine_sugar;
    }

    public String getUrine_acetone_bodies() {
        return urine_acetone_bodies;
    }

    public void setUrine_acetone_bodies(String urine_acetone_bodies) {
        this.urine_acetone_bodies = urine_acetone_bodies;
    }

    public String getUrine_occult_blood() {
        return urine_occult_blood;
    }

    public void setUrine_occult_blood(String urine_occult_blood) {
        this.urine_occult_blood = urine_occult_blood;
    }

    public String getUrine_routine_other() {
        return urine_routine_other;
    }

    public void setUrine_routine_other(String urine_routine_other) {
        this.urine_routine_other = urine_routine_other;
    }

    public Double getFasting_blood_glucose_L() {
        return fasting_blood_glucose_L;
    }

    public void setFasting_blood_glucose_L(Double fasting_blood_glucose_L) {
        this.fasting_blood_glucose_L = fasting_blood_glucose_L;
    }

    public Double getFasting_blood_glucose_dL() {
        return fasting_blood_glucose_dL;
    }

    public void setFasting_blood_glucose_dL(Double fasting_blood_glucose_dL) {
        this.fasting_blood_glucose_dL = fasting_blood_glucose_dL;
    }

    public Integer getElectrocardiogram() {
        return electrocardiogram;
    }

    public void setElectrocardiogram(Integer electrocardiogram) {
        this.electrocardiogram = electrocardiogram;
    }

    public String getElectrocardiogram_abnormal() {
        return electrocardiogram_abnormal;
    }

    public void setElectrocardiogram_abnormal(String electrocardiogram_abnormal) {
        this.electrocardiogram_abnormal = electrocardiogram_abnormal;
    }

    public Double getMicroalbuminuria() {
        return microalbuminuria;
    }

    public void setMicroalbuminuria(Double microalbuminuria) {
        this.microalbuminuria = microalbuminuria;
    }

    public Integer getOccult_blood_in_stool() {
        return occult_blood_in_stool;
    }

    public void setOccult_blood_in_stool(Integer occult_blood_in_stool) {
        this.occult_blood_in_stool = occult_blood_in_stool;
    }

    public Double getGlycated_hemoglobin() {
        return glycated_hemoglobin;
    }

    public void setGlycated_hemoglobin(Double glycated_hemoglobin) {
        this.glycated_hemoglobin = glycated_hemoglobin;
    }

    public Integer getHBsAg() {
        return HBsAg;
    }

    public void setHBsAg(Integer HBsAg) {
        this.HBsAg = HBsAg;
    }

    public Double getALT() {
        return ALT;
    }

    public void setALT(Double ALT) {
        this.ALT = ALT;
    }

    public Double getSGOT() {
        return SGOT;
    }

    public void setSGOT(Double SGOT) {
        this.SGOT = SGOT;
    }

    public Double getAlbumin() {
        return albumin;
    }

    public void setAlbumin(Double albumin) {
        this.albumin = albumin;
    }

    public Double getTotal_bilirubin() {
        return total_bilirubin;
    }

    public void setTotal_bilirubin(Double total_bilirubin) {
        this.total_bilirubin = total_bilirubin;
    }

    public Double getConjugated_bilirubin() {
        return conjugated_bilirubin;
    }

    public void setConjugated_bilirubin(Double conjugated_bilirubin) {
        this.conjugated_bilirubin = conjugated_bilirubin;
    }

    public Double getSerum_creatinine() {
        return serum_creatinine;
    }

    public void setSerum_creatinine(Double serum_creatinine) {
        this.serum_creatinine = serum_creatinine;
    }

    public Double getBlood_urea_nitrogen() {
        return blood_urea_nitrogen;
    }

    public void setBlood_urea_nitrogen(Double blood_urea_nitrogen) {
        this.blood_urea_nitrogen = blood_urea_nitrogen;
    }

    public Double getBlood_potassium_concentration() {
        return blood_potassium_concentration;
    }

    public void setBlood_potassium_concentration(Double blood_potassium_concentration) {
        this.blood_potassium_concentration = blood_potassium_concentration;
    }

    public Double getBlood_Na_concentration() {
        return blood_Na_concentration;
    }

    public void setBlood_Na_concentration(Double blood_Na_concentration) {
        this.blood_Na_concentration = blood_Na_concentration;
    }

    public Double getUric_acid() {
        return uric_acid;
    }

    public void setUric_acid(Double uric_acid) {
        this.uric_acid = uric_acid;
    }

    public Double getTotal_cholesterol() {
        return total_cholesterol;
    }

    public void setTotal_cholesterol(Double total_cholesterol) {
        this.total_cholesterol = total_cholesterol;
    }

    public Double getTriglyceride() {
        return triglyceride;
    }

    public void setTriglyceride(Double triglyceride) {
        this.triglyceride = triglyceride;
    }

    public Double getLDL_cholesterol() {
        return LDL_cholesterol;
    }

    public void setLDL_cholesterol(Double LDL_cholesterol) {
        this.LDL_cholesterol = LDL_cholesterol;
    }

    public Double getHDL_cholesterol() {
        return HDL_cholesterol;
    }

    public void setHDL_cholesterol(Double HDL_cholesterol) {
        this.HDL_cholesterol = HDL_cholesterol;
    }

    public Double getAlpha_fetal_protein() {
        return alpha_fetal_protein;
    }

    public void setAlpha_fetal_protein(Double alpha_fetal_protein) {
        this.alpha_fetal_protein = alpha_fetal_protein;
    }

    public Integer getChest_Xray() {
        return chest_Xray;
    }

    public void setChest_Xray(Integer chest_Xray) {
        this.chest_Xray = chest_Xray;
    }

    public String getChest_Xray_abnormal() {
        return chest_Xray_abnormal;
    }

    public void setChest_Xray_abnormal(String chest_Xray_abnormal) {
        this.chest_Xray_abnormal = chest_Xray_abnormal;
    }

    public Integer getAbdomen_B_ultrasonic() {
        return abdomen_B_ultrasonic;
    }

    public void setAbdomen_B_ultrasonic(Integer abdomen_B_ultrasonic) {
        this.abdomen_B_ultrasonic = abdomen_B_ultrasonic;
    }

    public String getAbdomen_B_ultrasonic_abnormal() {
        return abdomen_B_ultrasonic_abnormal;
    }

    public void setAbdomen_B_ultrasonic_abnormal(String abdomen_B_ultrasonic_abnormal) {
        this.abdomen_B_ultrasonic_abnormal = abdomen_B_ultrasonic_abnormal;
    }

    public Integer getB_ultrasonic_other() {
        return B_ultrasonic_other;
    }

    public void setB_ultrasonic_other(Integer b_ultrasonic_other) {
        B_ultrasonic_other = b_ultrasonic_other;
    }

    public String getB_ultrasonic_other_abnormal() {
        return B_ultrasonic_other_abnormal;
    }

    public void setB_ultrasonic_other_abnormal(String b_ultrasonic_other_abnormal) {
        B_ultrasonic_other_abnormal = b_ultrasonic_other_abnormal;
    }

    public Integer getCervical_smear() {
        return cervical_smear;
    }

    public void setCervical_smear(Integer cervical_smear) {
        this.cervical_smear = cervical_smear;
    }

    public String getCervical_smear_abnormal() {
        return cervical_smear_abnormal;
    }

    public void setCervical_smear_abnormal(String cervical_smear_abnormal) {
        this.cervical_smear_abnormal = cervical_smear_abnormal;
    }

    public String getAuxiliary_examination_other() {
        return auxiliary_examination_other;
    }

    public void setAuxiliary_examination_other(String auxiliary_examination_other) {
        this.auxiliary_examination_other = auxiliary_examination_other;
    }

    public Integer getMild_physical() {
        return mild_physical;
    }

    public void setMild_physical(Integer mild_physical) {
        this.mild_physical = mild_physical;
    }

    public Integer getQi_deficiency() {
        return qi_deficiency;
    }

    public void setQi_deficiency(Integer qi_deficiency) {
        this.qi_deficiency = qi_deficiency;
    }

    public Integer getYang_deficiency() {
        return yang_deficiency;
    }

    public void setYang_deficiency(Integer yang_deficiency) {
        this.yang_deficiency = yang_deficiency;
    }

    public Integer getYin_deficiency() {
        return yin_deficiency;
    }

    public void setYin_deficiency(Integer yin_deficiency) {
        this.yin_deficiency = yin_deficiency;
    }

    public Integer getPhlegm_dampness() {
        return phlegm_dampness;
    }

    public void setPhlegm_dampness(Integer phlegm_dampness) {
        this.phlegm_dampness = phlegm_dampness;
    }

    public Integer getDampness_heat() {
        return dampness_heat;
    }

    public void setDampness_heat(Integer dampness_heat) {
        this.dampness_heat = dampness_heat;
    }

    public Integer getBlood_stasis() {
        return blood_stasis;
    }

    public void setBlood_stasis(Integer blood_stasis) {
        this.blood_stasis = blood_stasis;
    }

    public Integer getLogistic_regression() {
        return logistic_regression;
    }

    public void setLogistic_regression(Integer logistic_regression) {
        this.logistic_regression = logistic_regression;
    }

    public Integer getGrasp_quality() {
        return grasp_quality;
    }

    public void setGrasp_quality(Integer grasp_quality) {
        this.grasp_quality = grasp_quality;
    }

    public String getCerebrovascular_disease() {
        return cerebrovascular_disease;
    }

    public void setCerebrovascular_disease(String cerebrovascular_disease) {
        this.cerebrovascular_disease = cerebrovascular_disease;
    }

    public String getCerebrovascular_disease_other() {
        return cerebrovascular_disease_other;
    }

    public void setCerebrovascular_disease_other(String cerebrovascular_disease_other) {
        this.cerebrovascular_disease_other = cerebrovascular_disease_other;
    }

    public String getNephropathy() {
        return nephropathy;
    }

    public void setNephropathy(String nephropathy) {
        this.nephropathy = nephropathy;
    }

    public String getNephropathy_other() {
        return nephropathy_other;
    }

    public void setNephropathy_other(String nephropathy_other) {
        this.nephropathy_other = nephropathy_other;
    }

    public String getHeart_disease() {
        return heart_disease;
    }

    public void setHeart_disease(String heart_disease) {
        this.heart_disease = heart_disease;
    }

    public String getHeart_disease_other() {
        return heart_disease_other;
    }

    public void setHeart_disease_other(String heart_disease_other) {
        this.heart_disease_other = heart_disease_other;
    }

    public String getVascular_disease() {
        return vascular_disease;
    }

    public void setVascular_disease(String vascular_disease) {
        this.vascular_disease = vascular_disease;
    }

    public String getVascular_disease_other() {
        return vascular_disease_other;
    }

    public void setVascular_disease_other(String vascular_disease_other) {
        this.vascular_disease_other = vascular_disease_other;
    }

    public String getEye_disease() {
        return eye_disease;
    }

    public void setEye_disease(String eye_disease) {
        this.eye_disease = eye_disease;
    }

    public String getEye_disease_other() {
        return eye_disease_other;
    }

    public void setEye_disease_other(String eye_disease_other) {
        this.eye_disease_other = eye_disease_other;
    }

    public Integer getNervous_system_disease() {
        return nervous_system_disease;
    }

    public void setNervous_system_disease(Integer nervous_system_disease) {
        this.nervous_system_disease = nervous_system_disease;
    }

    public String getNervous_system_disease_has() {
        return nervous_system_disease_has;
    }

    public void setNervous_system_disease_has(String nervous_system_disease_has) {
        this.nervous_system_disease_has = nervous_system_disease_has;
    }

    public Integer getOther_system_disease() {
        return other_system_disease;
    }

    public void setOther_system_disease(Integer other_system_disease) {
        this.other_system_disease = other_system_disease;
    }

    public String getOther_system_disease_has() {
        return other_system_disease_has;
    }

    public void setOther_system_disease_has(String other_system_disease_has) {
        this.other_system_disease_has = other_system_disease_has;
    }

    public Date getAdmission_date1() {
        return admission_date1;
    }

    public void setAdmission_date1(Date admission_date1) {
        this.admission_date1 = admission_date1;
    }

    public Date getDischarge_date1() {
        return discharge_date1;
    }

    public void setDischarge_date1(Date discharge_date1) {
        this.discharge_date1 = discharge_date1;
    }

    public String getAdmission_reason1() {
        return admission_reason1;
    }

    public void setAdmission_reason1(String admission_reason1) {
        this.admission_reason1 = admission_reason1;
    }

    public String getAdmission_hospital_name1() {
        return admission_hospital_name1;
    }

    public void setAdmission_hospital_name1(String admission_hospital_name1) {
        this.admission_hospital_name1 = admission_hospital_name1;
    }

    public String getAdmission_number1() {
        return admission_number1;
    }

    public void setAdmission_number1(String admission_number1) {
        this.admission_number1 = admission_number1;
    }

    public Date getAdmission_date2() {
        return admission_date2;
    }

    public void setAdmission_date2(Date admission_date2) {
        this.admission_date2 = admission_date2;
    }

    public Date getDischarge_date2() {
        return discharge_date2;
    }

    public void setDischarge_date2(Date discharge_date2) {
        this.discharge_date2 = discharge_date2;
    }

    public String getAdmission_reason2() {
        return admission_reason2;
    }

    public void setAdmission_reason2(String admission_reason2) {
        this.admission_reason2 = admission_reason2;
    }

    public String getAdmission_hospital_name2() {
        return admission_hospital_name2;
    }

    public void setAdmission_hospital_name2(String admission_hospital_name2) {
        this.admission_hospital_name2 = admission_hospital_name2;
    }

    public String getAdmission_number2() {
        return admission_number2;
    }

    public void setAdmission_number2(String admission_number2) {
        this.admission_number2 = admission_number2;
    }

    public Date getBuilding_bed_date1() {
        return building_bed_date1;
    }

    public void setBuilding_bed_date1(Date building_bed_date1) {
        this.building_bed_date1 = building_bed_date1;
    }

    public Date getCancel_bed_date1() {
        return cancel_bed_date1;
    }

    public void setCancel_bed_date1(Date cancel_bed_date1) {
        this.cancel_bed_date1 = cancel_bed_date1;
    }

    public String getBuilding_bed_reason1() {
        return building_bed_reason1;
    }

    public void setBuilding_bed_reason1(String building_bed_reason1) {
        this.building_bed_reason1 = building_bed_reason1;
    }

    public String getBuilding_bed_hospiatl_name1() {
        return building_bed_hospiatl_name1;
    }

    public void setBuilding_bed_hospiatl_name1(String building_bed_hospiatl_name1) {
        this.building_bed_hospiatl_name1 = building_bed_hospiatl_name1;
    }

    public String getBuilding_bed_number1() {
        return building_bed_number1;
    }

    public void setBuilding_bed_number1(String building_bed_number1) {
        this.building_bed_number1 = building_bed_number1;
    }

    public Date getBuilding_bed_date2() {
        return building_bed_date2;
    }

    public void setBuilding_bed_date2(Date building_bed_date2) {
        this.building_bed_date2 = building_bed_date2;
    }

    public Date getCancel_bed_date2() {
        return cancel_bed_date2;
    }

    public void setCancel_bed_date2(Date cancel_bed_date2) {
        this.cancel_bed_date2 = cancel_bed_date2;
    }

    public String getBuilding_bed_reason2() {
        return building_bed_reason2;
    }

    public void setBuilding_bed_reason2(String building_bed_reason2) {
        this.building_bed_reason2 = building_bed_reason2;
    }

    public String getBuilding_bed_hospiatl_name2() {
        return building_bed_hospiatl_name2;
    }

    public void setBuilding_bed_hospiatl_name2(String building_bed_hospiatl_name2) {
        this.building_bed_hospiatl_name2 = building_bed_hospiatl_name2;
    }

    public String getBuilding_bed_number2() {
        return building_bed_number2;
    }

    public void setBuilding_bed_number2(String building_bed_number2) {
        this.building_bed_number2 = building_bed_number2;
    }

    public String getMedicine1() {
        return medicine1;
    }

    public void setMedicine1(String medicine1) {
        this.medicine1 = medicine1;
    }

    public String getMedicine1_use() {
        return medicine1_use;
    }

    public void setMedicine1_use(String medicine1_use) {
        this.medicine1_use = medicine1_use;
    }

    public String getMedicine1_dosage() {
        return medicine1_dosage;
    }

    public void setMedicine1_dosage(String medicine1_dosage) {
        this.medicine1_dosage = medicine1_dosage;
    }

    public String getMedication1_time() {
        return medication1_time;
    }

    public void setMedication1_time(String medication1_time) {
        this.medication1_time = medication1_time;
    }

    public Integer getMedication1_compliance() {
        return medication1_compliance;
    }

    public void setMedication1_compliance(Integer medication1_compliance) {
        this.medication1_compliance = medication1_compliance;
    }

    public String getMedicine2() {
        return medicine2;
    }

    public void setMedicine2(String medicine2) {
        this.medicine2 = medicine2;
    }

    public String getMedicine2_use() {
        return medicine2_use;
    }

    public void setMedicine2_use(String medicine2_use) {
        this.medicine2_use = medicine2_use;
    }

    public String getMedicine2_dosage() {
        return medicine2_dosage;
    }

    public void setMedicine2_dosage(String medicine2_dosage) {
        this.medicine2_dosage = medicine2_dosage;
    }

    public String getMedication2_time() {
        return medication2_time;
    }

    public void setMedication2_time(String medication2_time) {
        this.medication2_time = medication2_time;
    }

    public Integer getMedication2_compliance() {
        return medication2_compliance;
    }

    public void setMedication2_compliance(Integer medication2_compliance) {
        this.medication2_compliance = medication2_compliance;
    }

    public String getMedicine3() {
        return medicine3;
    }

    public void setMedicine3(String medicine3) {
        this.medicine3 = medicine3;
    }

    public String getMedicine3_use() {
        return medicine3_use;
    }

    public void setMedicine3_use(String medicine3_use) {
        this.medicine3_use = medicine3_use;
    }

    public String getMedicine3_dosage() {
        return medicine3_dosage;
    }

    public void setMedicine3_dosage(String medicine3_dosage) {
        this.medicine3_dosage = medicine3_dosage;
    }

    public String getMedication3_time() {
        return medication3_time;
    }

    public void setMedication3_time(String medication3_time) {
        this.medication3_time = medication3_time;
    }

    public Integer getMedication3_compliance() {
        return medication3_compliance;
    }

    public void setMedication3_compliance(Integer medication3_compliance) {
        this.medication3_compliance = medication3_compliance;
    }

    public String getMedicine4() {
        return medicine4;
    }

    public void setMedicine4(String medicine4) {
        this.medicine4 = medicine4;
    }

    public String getMedicine4_use() {
        return medicine4_use;
    }

    public void setMedicine4_use(String medicine4_use) {
        this.medicine4_use = medicine4_use;
    }

    public String getMedicine4_dosage() {
        return medicine4_dosage;
    }

    public void setMedicine4_dosage(String medicine4_dosage) {
        this.medicine4_dosage = medicine4_dosage;
    }

    public String getMedication4_time() {
        return medication4_time;
    }

    public void setMedication4_time(String medication4_time) {
        this.medication4_time = medication4_time;
    }

    public Integer getMedication4_compliance() {
        return medication4_compliance;
    }

    public void setMedication4_compliance(Integer medication4_compliance) {
        this.medication4_compliance = medication4_compliance;
    }

    public String getMedicine5() {
        return medicine5;
    }

    public void setMedicine5(String medicine5) {
        this.medicine5 = medicine5;
    }

    public String getMedicine5_use() {
        return medicine5_use;
    }

    public void setMedicine5_use(String medicine5_use) {
        this.medicine5_use = medicine5_use;
    }

    public String getMedicine5_dosage() {
        return medicine5_dosage;
    }

    public void setMedicine5_dosage(String medicine5_dosage) {
        this.medicine5_dosage = medicine5_dosage;
    }

    public String getMedication5_time() {
        return medication5_time;
    }

    public void setMedication5_time(String medication5_time) {
        this.medication5_time = medication5_time;
    }

    public Integer getMedication5_compliance() {
        return medication5_compliance;
    }

    public void setMedication5_compliance(Integer medication5_compliance) {
        this.medication5_compliance = medication5_compliance;
    }

    public String getMedicine6() {
        return medicine6;
    }

    public void setMedicine6(String medicine6) {
        this.medicine6 = medicine6;
    }

    public String getMedicine6_use() {
        return medicine6_use;
    }

    public void setMedicine6_use(String medicine6_use) {
        this.medicine6_use = medicine6_use;
    }

    public String getMedicine6_dosage() {
        return medicine6_dosage;
    }

    public void setMedicine6_dosage(String medicine6_dosage) {
        this.medicine6_dosage = medicine6_dosage;
    }

    public String getMedication6_time() {
        return medication6_time;
    }

    public void setMedication6_time(String medication6_time) {
        this.medication6_time = medication6_time;
    }

    public Integer getMedication6_compliance() {
        return medication6_compliance;
    }

    public void setMedication6_compliance(Integer medication6_compliance) {
        this.medication6_compliance = medication6_compliance;
    }

    public String getVaccination_name1() {
        return vaccination_name1;
    }

    public void setVaccination_name1(String vaccination_name1) {
        this.vaccination_name1 = vaccination_name1;
    }

    public Date getVaccination_date1() {
        return vaccination_date1;
    }

    public void setVaccination_date1(Date vaccination_date1) {
        this.vaccination_date1 = vaccination_date1;
    }

    public String getVaccination_hospital_name1() {
        return vaccination_hospital_name1;
    }

    public void setVaccination_hospital_name1(String vaccination_hospital_name1) {
        this.vaccination_hospital_name1 = vaccination_hospital_name1;
    }

    public String getVaccination_name2() {
        return vaccination_name2;
    }

    public void setVaccination_name2(String vaccination_name2) {
        this.vaccination_name2 = vaccination_name2;
    }

    public Date getVaccination_date2() {
        return vaccination_date2;
    }

    public void setVaccination_date2(Date vaccination_date2) {
        this.vaccination_date2 = vaccination_date2;
    }

    public String getVaccination_hospital_name2() {
        return vaccination_hospital_name2;
    }

    public void setVaccination_hospital_name2(String vaccination_hospital_name2) {
        this.vaccination_hospital_name2 = vaccination_hospital_name2;
    }

    public String getVaccination_name3() {
        return vaccination_name3;
    }

    public void setVaccination_name3(String vaccination_name3) {
        this.vaccination_name3 = vaccination_name3;
    }

    public Date getVaccination_date3() {
        return vaccination_date3;
    }

    public void setVaccination_date3(Date vaccination_date3) {
        this.vaccination_date3 = vaccination_date3;
    }

    public String getVaccination_hospital_name3() {
        return vaccination_hospital_name3;
    }

    public void setVaccination_hospital_name3(String vaccination_hospital_name3) {
        this.vaccination_hospital_name3 = vaccination_hospital_name3;
    }

    public Integer getHealth_examination() {
        return health_examination;
    }

    public void setHealth_examination(Integer health_examination) {
        this.health_examination = health_examination;
    }

    public String getHealth_examination_abnormal1() {
        return health_examination_abnormal1;
    }

    public void setHealth_examination_abnormal1(String health_examination_abnormal1) {
        this.health_examination_abnormal1 = health_examination_abnormal1;
    }

    public String getHealth_examination_abnormal2() {
        return health_examination_abnormal2;
    }

    public void setHealth_examination_abnormal2(String health_examination_abnormal2) {
        this.health_examination_abnormal2 = health_examination_abnormal2;
    }

    public String getHealth_examination_abnormal3() {
        return health_examination_abnormal3;
    }

    public void setHealth_examination_abnormal3(String health_examination_abnormal3) {
        this.health_examination_abnormal3 = health_examination_abnormal3;
    }

    public String getHealth_examination_abnormal4() {
        return health_examination_abnormal4;
    }

    public void setHealth_examination_abnormal4(String health_examination_abnormal4) {
        this.health_examination_abnormal4 = health_examination_abnormal4;
    }

    public Integer getRegular_followup() {
        return regular_followup;
    }

    public void setRegular_followup(Integer regular_followup) {
        this.regular_followup = regular_followup;
    }

    public Integer getChronic_health_management() {
        return chronic_health_management;
    }

    public void setChronic_health_management(Integer chronic_health_management) {
        this.chronic_health_management = chronic_health_management;
    }

    public Integer getSuggest_recheck() {
        return suggest_recheck;
    }

    public void setSuggest_recheck(Integer suggest_recheck) {
        this.suggest_recheck = suggest_recheck;
    }

    public Integer getSuggest_referral() {
        return suggest_referral;
    }

    public void setSuggest_referral(Integer suggest_referral) {
        this.suggest_referral = suggest_referral;
    }

    public Integer getOther_health_guidance() {
        return other_health_guidance;
    }

    public void setOther_health_guidance(Integer other_health_guidance) {
        this.other_health_guidance = other_health_guidance;
    }

    public String getOther_health_guidance_description() {
        return other_health_guidance_description;
    }

    public void setOther_health_guidance_description(String other_health_guidance_description) {
        this.other_health_guidance_description = other_health_guidance_description;
    }

    public Integer getStop_smoking() {
        return stop_smoking;
    }

    public void setStop_smoking(Integer stop_smoking) {
        this.stop_smoking = stop_smoking;
    }

    public Integer getHealthy_drinking() {
        return healthy_drinking;
    }

    public void setHealthy_drinking(Integer healthy_drinking) {
        this.healthy_drinking = healthy_drinking;
    }

    public Integer getDiet() {
        return diet;
    }

    public void setDiet(Integer diet) {
        this.diet = diet;
    }

    public Integer getExercise() {
        return exercise;
    }

    public void setExercise(Integer exercise) {
        this.exercise = exercise;
    }

    public Integer getLose_weight() {
        return lose_weight;
    }

    public void setLose_weight(Integer lose_weight) {
        this.lose_weight = lose_weight;
    }

    public Double getGoal_weight() {
        return goal_weight;
    }

    public void setGoal_weight(Double goal_weight) {
        this.goal_weight = goal_weight;
    }

    public String getRecommended_vaccination() {
        return recommended_vaccination;
    }

    public void setRecommended_vaccination(String recommended_vaccination) {
        this.recommended_vaccination = recommended_vaccination;
    }

    public Integer getOther_advice() {
        return other_advice;
    }

    public void setOther_advice(Integer other_advice) {
        this.other_advice = other_advice;
    }

    public String getOther_advice_description() {
        return other_advice_description;
    }

    public void setOther_advice_description(String other_advice_description) {
        this.other_advice_description = other_advice_description;
    }

    public String getAssessment_number() {
        return assessment_number;
    }

    public void setAssessment_number(String assessment_number) {
        this.assessment_number = assessment_number;
    }

    public String getAssessment_doctorName() {
        return assessment_doctorName;
    }

    public void setAssessment_doctorName(String assessment_doctorName) {
        this.assessment_doctorName = assessment_doctorName;
    }

    public Date getAssessment_time() {
        return assessment_time;
    }

    public void setAssessment_time(Date assessment_time) {
        this.assessment_time = assessment_time;
    }

    public Integer getEat() {
        return eat;
    }

    public void setEat(Integer eat) {
        this.eat = eat;
    }

    public Integer getWash() {
        return wash;
    }

    public void setWash(Integer wash) {
        this.wash = wash;
    }

    public Integer getDress() {
        return dress;
    }

    public void setDress(Integer dress) {
        this.dress = dress;
    }

    public Integer getToilet() {
        return toilet;
    }

    public void setToilet(Integer toilet) {
        this.toilet = toilet;
    }

    public Integer getActivity() {
        return activity;
    }

    public void setActivity(Integer activity) {
        this.activity = activity;
    }

    public Integer getScore() {
        return score;
    }

    public void setScore(Integer score) {
        this.score = score;
    }
}
