package com.yihu.jw.followup.phthisis_followup;

import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.data.annotation.CreatedDate;

import java.util.Date;

/**
 * 肺结核患者第一次入户随访
 */
public class PhthisisFirstFollowupES {

    private String followup_id;             //随访记录ID
    private String followup_project;        //随访详情分类ID
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyyMMdd'T'HHmmss.SSS'Z'")
    @CreatedDate
    private Date create_time;
    private String create_user;
    private String create_user_name;
    private String version;//版本号
    /**
     * 患者信息
     */
    private PhthisisFollowupPatientInfoES patient;

    /**
     * 随访编号
     */
    private String number;

    /**
     * 随访日期
     */
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+08:00")
    private Date followup_date;

    /**
     * 随访方式：1-门诊，2-家庭
     */
    private Byte way;

    /**
     * 患者类型：1-初治，2-复治
     */
    private Byte patient_type;

    /**
     * 痰菌情况：1-阳性，2-阴性，3-未查痰
     */
    private Byte sputum_bacterium;

    /**
     * 耐药情况：1-耐药，2-非耐药，3-未检测
     */
    private Byte drug_resistant;

    /**
     * 症状及体征（,多个用逗号隔开）：0-没有症状，1-咳嗽咳痰，2-低热盗汗，3-咯血或血痰，4-胸痛消瘦，5-恶心纳差，6-头痛失眠，7-视物模糊，8-皮肤瘙痒、皮疹，9-耳鸣、听力下降
     */
    private String symptom;

    /**
     * 症状及体征其他描述
     */
    private String symptom_other_desc;

    /**
     * 督导人员
     */

    private PhthisisFollowupSuperviserES superviser;

    /**
     * 用药情况
     */
    private PhthisisFollowupDrugUseES drug_use;

    /**
     * 家庭居住环境
     */
    private PhthisisFollowupHomeEnvironmentES home_environment;

    /**
     * 生活方式
     */
    private PhthisisFollowupLifeStyleES life_style;

    /**
     * 健康教育及培训
     */
    private PhthisisFollowupHealthEduES health_edu;

    /**
     * 下次随访时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+08:00")
    private String next_followup_date;

    /**
     * 评估医生code
     */
    private String signature_doctor;

    /**
     * 评估医生签名
     */
    private String signature_doctor_name;

    public String getFollowup_id() {
        return followup_id;
    }

    public void setFollowup_id(String followup_id) {
        this.followup_id = followup_id;
    }

    public String getFollowup_project() {
        return followup_project;
    }

    public void setFollowup_project(String followup_project) {
        this.followup_project = followup_project;
    }

    public Date getCreate_time() {
        return create_time;
    }

    public void setCreate_time(Date create_time) {
        this.create_time = create_time;
    }

    public String getCreate_user() {
        return create_user;
    }

    public void setCreate_user(String create_user) {
        this.create_user = create_user;
    }

    public String getCreate_user_name() {
        return create_user_name;
    }

    public void setCreate_user_name(String create_user_name) {
        this.create_user_name = create_user_name;
    }

    public PhthisisFollowupPatientInfoES getPatient() {
        return patient;
    }

    public void setPatient(PhthisisFollowupPatientInfoES patient) {
        this.patient = patient;
    }

    public String getNumber() {
        return number;
    }

    public void setNumber(String number) {
        this.number = number;
    }

    public Date getFollowup_date() {
        return followup_date;
    }

    public void setFollowup_date(Date followup_date) {
        this.followup_date = followup_date;
    }

    public Byte getWay() {
        return way;
    }

    public void setWay(Byte way) {
        this.way = way;
    }

    public Byte getPatient_type() {
        return patient_type;
    }

    public void setPatient_type(Byte patient_type) {
        this.patient_type = patient_type;
    }

    public Byte getSputum_bacterium() {
        return sputum_bacterium;
    }

    public void setSputum_bacterium(Byte sputum_bacterium) {
        this.sputum_bacterium = sputum_bacterium;
    }

    public Byte getDrug_resistant() {
        return drug_resistant;
    }

    public void setDrug_resistant(Byte drug_resistant) {
        this.drug_resistant = drug_resistant;
    }

    public String getSymptom() {
        return symptom;
    }

    public void setSymptom(String symptom) {
        this.symptom = symptom;
    }

    public String getSymptom_other_desc() {
        return symptom_other_desc;
    }

    public void setSymptom_other_desc(String symptom_other_desc) {
        this.symptom_other_desc = symptom_other_desc;
    }

    public PhthisisFollowupSuperviserES getSuperviser() {
        return superviser;
    }

    public void setSuperviser(PhthisisFollowupSuperviserES superviser) {
        this.superviser = superviser;
    }

    public PhthisisFollowupDrugUseES getDrug_use() {
        return drug_use;
    }

    public void setDrug_use(PhthisisFollowupDrugUseES drug_use) {
        this.drug_use = drug_use;
    }

    public PhthisisFollowupHomeEnvironmentES getHome_environment() {
        return home_environment;
    }

    public void setHome_environment(PhthisisFollowupHomeEnvironmentES home_environment) {
        this.home_environment = home_environment;
    }

    public PhthisisFollowupLifeStyleES getLife_style() {
        return life_style;
    }

    public void setLife_style(PhthisisFollowupLifeStyleES life_style) {
        this.life_style = life_style;
    }

    public PhthisisFollowupHealthEduES getHealth_edu() {
        return health_edu;
    }

    public void setHealth_edu(PhthisisFollowupHealthEduES health_edu) {
        this.health_edu = health_edu;
    }

    public String getNext_followup_date() {
        return next_followup_date;
    }

    public void setNext_followup_date(String next_followup_date) {
        this.next_followup_date = next_followup_date;
    }

    public String getSignature_doctor() {
        return signature_doctor;
    }

    public void setSignature_doctor(String signature_doctor) {
        this.signature_doctor = signature_doctor;
    }

    public String getSignature_doctor_name() {
        return signature_doctor_name;
    }

    public void setSignature_doctor_name(String signature_doctor_name) {
        this.signature_doctor_name = signature_doctor_name;
    }

    public String getVersion() {
        return version;
    }

    public void setVersion(String version) {
        this.version = version;
    }
}
