package com.yihu.jw.followup.phthisis_followup;

import com.fasterxml.jackson.annotation.JsonFormat;
import org.springframework.data.annotation.CreatedDate;

import java.util.Date;

/**
 * 肺结核患者第一次入户随访
 */
public class PhthisisNTimesFollowupDataES {

    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyyMMdd'T'HHmmss.SSS'Z'")
    @CreatedDate
    private Date create_time;
    private String create_user;
    private String create_user_name;

    /**
     * 随访日期
     */
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+08:00")
    private Date followup_date;

    /**
     * 治疗月序
     */
    private short treate_month;

    /**
     * 随访方式：1-门诊，2-家庭
     */
    private Byte way;

    /**
     * 症状及体征（,多个用逗号隔开）：0-没有症状，1-咳嗽咳痰，2-低热盗汗，3-咯血或血痰，4-胸痛消瘦，5-恶心纳差，6-头痛失眠，7-视物模糊，8-皮肤瘙痒、皮疹，9-耳鸣、听力下降
     */
    private String symptom;

    /**
     * 症状及体征其他描述
     */
    private String symptom_other_desc;

    /**
     * 督导人员
     */

    private PhthisisFollowupSuperviserES superviser;

    /**
     * 生活方式
     */
    private PhthisisFollowupLifeStyleES life_style;

    /**
     * 用药情况
     */
    private PhthisisFollowupDrugUseES drug_use;

    /**
     * 药物不良反应 1-无，2-有
     */
    private byte drug_bad_reaction;

    /**
     * 药物不良反应描述
     */
    private String drug_bad_reaction_detail;

    /**
     * 并发症 1-无，2-有
     */
    private byte complication;

    /**
     * 并发症描述
     */
    private String complication_detail;

    /**
     * 转诊
     */
    private PhthisisFollowupTransOrgES trans_org;

    /**
     * 处理意见
     */
    private String process_opinion;

    /**
     * 下次随访时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+08:00")
    private String next_followup_date;

    /**
     * 随访医生code
     */
    private String followup_doctor;

    /**
     * 随访医生名称
     */
    private String followup_doctor_name;


    public Date getCreate_time() {
        return create_time;
    }

    public void setCreate_time(Date create_time) {
        this.create_time = create_time;
    }

    public String getCreate_user() {
        return create_user;
    }

    public void setCreate_user(String create_user) {
        this.create_user = create_user;
    }

    public String getCreate_user_name() {
        return create_user_name;
    }

    public void setCreate_user_name(String create_user_name) {
        this.create_user_name = create_user_name;
    }

    public Date getFollowup_date() {
        return followup_date;
    }

    public void setFollowup_date(Date followup_date) {
        this.followup_date = followup_date;
    }

    public Byte getWay() {
        return way;
    }

    public void setWay(Byte way) {
        this.way = way;
    }

    public String getSymptom() {
        return symptom;
    }

    public void setSymptom(String symptom) {
        this.symptom = symptom;
    }

    public String getSymptom_other_desc() {
        return symptom_other_desc;
    }

    public void setSymptom_other_desc(String symptom_other_desc) {
        this.symptom_other_desc = symptom_other_desc;
    }

    public PhthisisFollowupSuperviserES getSuperviser() {
        return superviser;
    }

    public void setSuperviser(PhthisisFollowupSuperviserES superviser) {
        this.superviser = superviser;
    }

    public PhthisisFollowupDrugUseES getDrug_use() {
        return drug_use;
    }

    public void setDrug_use(PhthisisFollowupDrugUseES drug_use) {
        this.drug_use = drug_use;
    }

    public PhthisisFollowupLifeStyleES getLife_style() {
        return life_style;
    }

    public void setLife_style(PhthisisFollowupLifeStyleES life_style) {
        this.life_style = life_style;
    }

    public short getTreate_month() {
        return treate_month;
    }

    public void setTreate_month(short treate_month) {
        this.treate_month = treate_month;
    }

    public byte getDrug_bad_reaction() {
        return drug_bad_reaction;
    }

    public void setDrug_bad_reaction(byte drug_bad_reaction) {
        this.drug_bad_reaction = drug_bad_reaction;
    }

    public byte getComplication() {
        return complication;
    }

    public void setComplication(byte complication) {
        this.complication = complication;
    }

    public PhthisisFollowupTransOrgES getTrans_org() {
        return trans_org;
    }

    public void setTrans_org(PhthisisFollowupTransOrgES trans_org) {
        this.trans_org = trans_org;
    }

    public String getProcess_opinion() {
        return process_opinion;
    }

    public void setProcess_opinion(String process_opinion) {
        this.process_opinion = process_opinion;
    }

    public String getNext_followup_date() {
        return next_followup_date;
    }

    public void setNext_followup_date(String next_followup_date) {
        this.next_followup_date = next_followup_date;
    }

    public String getFollowup_doctor() {
        return followup_doctor;
    }

    public void setFollowup_doctor(String followup_doctor) {
        this.followup_doctor = followup_doctor;
    }

    public String getFollowup_doctor_name() {
        return followup_doctor_name;
    }

    public void setFollowup_doctor_name(String followup_doctor_name) {
        this.followup_doctor_name = followup_doctor_name;
    }

    public String getDrug_bad_reaction_detail() {
        return drug_bad_reaction_detail;
    }

    public void setDrug_bad_reaction_detail(String drug_bad_reaction_detail) {
        this.drug_bad_reaction_detail = drug_bad_reaction_detail;
    }

    public String getComplication_detail() {
        return complication_detail;
    }

    public void setComplication_detail(String complication_detail) {
        this.complication_detail = complication_detail;
    }
}
