package com.yihu.jw.entity.base.application;

import com.yihu.jw.entity.UuidIdentityEntityWithOperator;

import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.util.List;


/**
 *
 * 应用菜单资源配置
 * @author Administrator on  2018年09月05日
 *
 */
@Entity
@Table(name = "base_application_menu")
public class BaseApplicationMenuDO extends UuidIdentityEntityWithOperator {

    private String saasId;//租户id
    private String orgCode;//机构id
    private String identify;//应用端标识（V_APPLICATION_IDENTIFY）
    private String parentId;//父级节点
    private String menuSort;//菜单排序
    private String code;//菜单编码
    private String name;//菜单名称
    private String type;//角色类型（字典V_APPLICATION_ROLE_DICT）
    private Integer status;//是否生效(1生效0失效)
    private String icon;//图标
    private String url;//url地址
    private String urlParam;//地址参数
    private String description;//描述

    private List<BaseApplicationMenuDO> children;

    @Transient
    public List<BaseApplicationMenuDO> getChildren() {
        return children;
    }

    public void setChildren(List<BaseApplicationMenuDO> children) {
        this.children = children;
    }

    public String getSaasId() {
        return saasId;
    }

    public void setSaasId(String saasId) {
        this.saasId = saasId;
    }

    public String getOrgCode() {
        return orgCode;
    }

    public void setOrgCode(String orgCode) {
        this.orgCode = orgCode;
    }

    public String getIdentify() {
        return identify;
    }

    public void setIdentify(String identify) {
        this.identify = identify;
    }

    public String getParentId() {
        return parentId;
    }

    public void setParentId(String parentId) {
        this.parentId = parentId;
    }

    public String getMenuSort() {
        return menuSort;
    }

    public void setMenuSort(String menuSort) {
        this.menuSort = menuSort;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public Integer getStatus() {
        return status;
    }

    public void setStatus(Integer status) {
        this.status = status;
    }

    public String getIcon() {
        return icon;
    }

    public void setIcon(String icon) {
        this.icon = icon;
    }

    public String getUrl() {
        return url;
    }

    public void setUrl(String url) {
        this.url = url;
    }

    public String getUrlParam() {
        return urlParam;
    }

    public void setUrlParam(String urlParam) {
        this.urlParam = urlParam;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }
}