package com.yihu.jw.entity.base.device;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.yihu.jw.entity.IdEntity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import java.util.Date;

/**
 * 医生预警值方案
 * @author huangwenjie
 * @date 2017/9/14 21:08
 */
@Entity
@Table(name = "wlyy_doctor_health_standard")
@SequenceGenerator(name = "id_generated", sequenceName = "wlyy_doctor_health_standard")
public class DoctorHealthStandard extends IdEntity {
    private static final long serialVersionUID = -8343925049051333359L;

    // 患者标识
    private String doctor;
    // 健康指标类型：1血糖，2血压，3体重，4腰围
    private Integer type;
    // 最低安全值(血糖餐前\收缩压\BMI\腰围)
    private Double minValue1;
    // 最高安全值(血糖餐前\收缩压\BMI\腰围)
    private Double maxValue1;
    // 最低安全值(血糖餐后\舒张压\步数)
    private Double minValue2;
    // 最高安全值(血糖餐后\舒张压\步数)
    private Double maxValue2;
    // 设置时间
    private Date czrq;

    public String getDoctor() {
        return doctor;
    }

    public void setDoctor(String doctor) {
        this.doctor = doctor;
    }

    public Integer getType() {
        return type;
    }

    public void setType(Integer type) {
        this.type = type;
    }

    @Column(name = "min_value_1")
    public Double getMinValue1() {
        return minValue1;
    }

    public void setMinValue1(Double minValue) {
        this.minValue1 = minValue;
    }

    @Column(name = "max_value_1")
    public Double getMaxValue1() {
        return maxValue1;
    }

    public void setMaxValue1(Double maxValue) {
        this.maxValue1 = maxValue;
    }

    @Column(name = "min_value_2")
    public Double getMinValue2() {
        return minValue2;
    }

    public void setMinValue2(Double minValue) {
        this.minValue2 = minValue;
    }

    @Column(name = "max_value_2")
    public Double getMaxValue2() {
        return maxValue2;
    }

    public void setMaxValue2(Double maxValue) {
        this.maxValue2 = maxValue;
    }

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
    public Date getCzrq() {
        return czrq;
    }

    public void setCzrq(Date czrq) {
        this.czrq = czrq;
    }
}
