package com.yihu.jw.entity.base.inpatient;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.yihu.jw.entity.UuidIdentityEntityWithCreateTime;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.util.Date;

/**
 * 住院登记
 * Created by yeshijie on 2022/12/5.
 */
@Entity
@Table(name = "base_inpatient_registration")
public class BaseInpatientRegistrationDO extends UuidIdentityEntityWithCreateTime {

    private String patient;
    private String name;//居民姓名/就诊人
    private String billingDate;//开单日期
    private String outpatientNo;//门诊号码
    private String inpatientType;//住院性质（1医保） 字典编码inpatient_nature
    private String inpatientTypeName;
    private String idcard;//身份证
    private String sex;//性别
    private String mobile;//患者手机号
    private String address;//现居地址
    private String contacts;//联系人
    private String contactsMobile;//联系人电话
    private String doctor;
    private String doctorName;//开单医生
    private String status;//状态（0未提交/立即登记，1已提交，2已登记 3已入院 4已出院） 字典编码inpatientRegist_status
    private String statusName;//状态名称 inpatientRegist_status

    private Date inpatientTime;//入院时间
    private String bedNo;//床位号
    private String attendingDoctor;
    private String attendingDoctorName;//主治医师
    private String inpatientAreaId;//病区id
    private String inpatientAreaName;//病区名称


    private Date updateTime;//提交时间

    private Object data;//临时存续方信息

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
    @Column(name = "update_time")
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    @Column(name = "patient")
    public String getPatient() {
        return patient;
    }

    public void setPatient(String patient) {
        this.patient = patient;
    }

    @Column(name = "name")
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    @Column(name = "billing_date")
    public String getBillingDate() {
        return billingDate;
    }

    public void setBillingDate(String billingDate) {
        this.billingDate = billingDate;
    }

    @Column(name = "outpatient_no")
    public String getOutpatientNo() {
        return outpatientNo;
    }

    public void setOutpatientNo(String outpatientNo) {
        this.outpatientNo = outpatientNo;
    }

    @Column(name = "inpatient_type")
    public String getInpatientType() {
        return inpatientType;
    }

    public void setInpatientType(String inpatientType) {
        this.inpatientType = inpatientType;
    }

    @Column(name = "idcard")
    public String getIdcard() {
        return idcard;
    }

    public void setIdcard(String idcard) {
        this.idcard = idcard;
    }

    @Column(name = "sex")
    public String getSex() {
        return sex;
    }

    public void setSex(String sex) {
        this.sex = sex;
    }

    @Column(name = "mobile")
    public String getMobile() {
        return mobile;
    }

    public void setMobile(String mobile) {
        this.mobile = mobile;
    }

    @Column(name = "address")
    public String getAddress() {
        return address;
    }

    public void setAddress(String address) {
        this.address = address;
    }

    @Column(name = "contacts")
    public String getContacts() {
        return contacts;
    }

    public void setContacts(String contacts) {
        this.contacts = contacts;
    }

    @Column(name = "contacts_mobile")
    public String getContactsMobile() {
        return contactsMobile;
    }

    public void setContactsMobile(String contactsMobile) {
        this.contactsMobile = contactsMobile;
    }

    @Column(name = "doctor")
    public String getDoctor() {
        return doctor;
    }

    public void setDoctor(String doctor) {
        this.doctor = doctor;
    }

    @Column(name = "doctor_name")
    public String getDoctorName() {
        return doctorName;
    }

    public void setDoctorName(String doctorName) {
        this.doctorName = doctorName;
    }

    @Column(name = "status")
    public String getStatus() {
        return status;
    }

    public void setStatus(String status) {
        this.status = status;
    }

    @Column(name = "inpatient_time")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
    public Date getInpatientTime() {
        return inpatientTime;
    }

    public void setInpatientTime(Date inpatientTime) {
        this.inpatientTime = inpatientTime;
    }

    @Column(name = "bed_no")
    public String getBedNo() {
        return bedNo;
    }

    public void setBedNo(String bedNo) {
        this.bedNo = bedNo;
    }

    @Column(name = "attending_doctor")
    public String getAttendingDoctor() {
        return attendingDoctor;
    }

    public void setAttendingDoctor(String attendingDoctor) {
        this.attendingDoctor = attendingDoctor;
    }

    @Column(name = "attending_doctor_name")
    public String getAttendingDoctorName() {
        return attendingDoctorName;
    }

    public void setAttendingDoctorName(String attendingDoctorName) {
        this.attendingDoctorName = attendingDoctorName;
    }

    @Column(name = "inpatient_area_id")
    public String getInpatientAreaId() {
        return inpatientAreaId;
    }

    public void setInpatientAreaId(String inpatientAreaId) {
        this.inpatientAreaId = inpatientAreaId;
    }

    @Column(name = "inpatient_area_name")
    public String getInpatientAreaName() {
        return inpatientAreaName;
    }

    public void setInpatientAreaName(String inpatientAreaName) {
        this.inpatientAreaName = inpatientAreaName;
    }

    @Transient
    public String getInpatientTypeName() {
        return inpatientTypeName;
    }

    public void setInpatientTypeName(String inpatientTypeName) {
        this.inpatientTypeName = inpatientTypeName;
    }

    @Transient
    public String getStatusName() {
        return statusName;
    }

    public void setStatusName(String statusName) {
        this.statusName = statusName;
    }

    @Transient
    public Object getData() {
        return data;
    }

    public void setData(Object data) {
        this.data = data;
    }
}
