package com.yihu.jw.entity.base.menu;

import com.yihu.jw.entity.UuidIdentityEntityWithCreateTime;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.util.ArrayList;
import java.util.List;

/**
 * app端菜单配置
 * Created by yeshijie on 2022/9/27.
 */
@Entity
@Table(name = "base_app_menu")
public class BaseAppMenu extends UuidIdentityEntityWithCreateTime {

    public final static String topPid = "0";//顶级父id

    private String pid;//父类id（第一级pid为0）
    private String name;//菜单名称
    private String code;//菜单编码
    private String img;//图标
    private String url;//跳转链接
    private Integer type;//类型 1医生 2居民
    private Integer del;//删除标志 1正常0删除
    private Integer status;//状态（1有效，0失效）
    private String statusName;
    private Integer sort;//排序字段
    private String remark;//备注

    private List<BaseAppMenu> children = new ArrayList<>(); // 子节点

    @Column(name = "pid")
    public String getPid() {
        return pid;
    }

    public void setPid(String pid) {
        this.pid = pid;
    }

    @Column(name = "name")
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    @Column(name = "code")
    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    @Column(name = "img")
    public String getImg() {
        return img;
    }

    public void setImg(String img) {
        this.img = img;
    }

    @Column(name = "url")
    public String getUrl() {
        return url;
    }

    public void setUrl(String url) {
        this.url = url;
    }

    @Column(name = "status")
    public Integer getStatus() {
        return status;
    }

    public void setStatus(Integer status) {
        this.status = status;
    }

    @Column(name = "sort")
    public Integer getSort() {
        return sort;
    }

    public void setSort(Integer sort) {
        this.sort = sort;
    }

    @Column(name = "remark")
    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }

    @Transient
    public List<BaseAppMenu> getChildren() {
        return children;
    }

    public void setChildren(List<BaseAppMenu> children) {
        this.children = children;
    }

    @Column(name = "type")
    public Integer getType() {
        return type;
    }

    public void setType(Integer type) {
        this.type = type;
    }

    @Column(name = "del")
    public Integer getDel() {
        return del;
    }

    public void setDel(Integer del) {
        this.del = del;
    }

    @Transient
    public String getStatusName() {
        return statusName;
    }

    public void setStatusName(String statusName) {
        this.statusName = statusName;
    }
}
