package com.yihu.jw.entity.base.menu;

import com.yihu.jw.entity.UuidIdentityEntityWithOperator;
import com.yihu.jw.entity.base.doctor.BaseDoctorDO;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.util.List;

@Entity
@Table(name = "base_menu_dict")
public class BaseMenuDictDO extends UuidIdentityEntityWithOperator {
    private String parentId;//父id
    private String name;//名称
    private Integer menuSort;//排序
    private String icon;//菜单图标
    private String url;//url
    private String isShow;//是否展示（1是，2否）
    private Integer status;//状态 -1 已删除 0不可用 1可用
    private String remark;//别再
    private Integer menuLevel;//菜单层级
    private String functionType;//功能类型01单页，02列表页，03幻灯轮播
    private String menuLocation;//01导航栏，02首页分区，03友情链接
    private String menuImg;//可放多个图片逗号隔开
    private String functionName;//
    private String locaTionName;//
    private String showName;//
    private String statusName;//
    private String parentName;//
    private String isDel;//删除标识 1正常 0删除
    private String bgImg;//背景图片
    private String menuTitle;//标题
    private String describtion;//描述
    private Integer type;//类型 1 官网菜单 2app文章菜单

    private List<BaseDoctorDO> doctorList;//推荐医生
    private Integer collection;//收藏数量
    private Integer fabulous;//点赞数量
    private String isCollection;//是否收藏 1是0否
    private String isFabulous;//是否点赞  1是0否

    @Column(name = "bg_img")
    public String getBgImg() {
        return bgImg;
    }

    public void setBgImg(String bgImg) {
        this.bgImg = bgImg;
    }
    @Column(name = "menu_title")
    public String getMenuTitle() {
        return menuTitle;
    }

    public void setMenuTitle(String menuTitle) {
        this.menuTitle = menuTitle;
    }

    @Column(name = "describtion")
    public String getDescribtion() {
        return describtion;
    }

    public void setDescribtion(String describtion) {
        this.describtion = describtion;
    }

    public String getIsDel() {
        return isDel;
    }

    public void setIsDel(String isDel) {
        this.isDel = isDel;
    }

    @Transient
    public String getParentName() {
        return parentName;
    }

    public void setParentName(String parentName) {
        this.parentName = parentName;
    }

    @Transient
    public String getFunctionName() {
        return functionName;
    }

    public void setFunctionName(String functionName) {
        this.functionName = functionName;
    }
    @Transient
    public String getLocaTionName() {
        return locaTionName;
    }

    public void setLocaTionName(String locaTionName) {
        this.locaTionName = locaTionName;
    }
    @Transient
    public String getShowName() {
        return showName;
    }

    public void setShowName(String showName) {
        this.showName = showName;
    }
    @Transient
    public String getStatusName() {
        return statusName;
    }

    public void setStatusName(String statusName) {
        this.statusName = statusName;
    }




    @Column(name = "parent_id")
    public String getParentId() {
        return parentId;
    }

    public void setParentId(String parentId) {
        this.parentId = parentId;
    }
    @Column(name = "name")
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }
    @Column(name = "menu_sort")
    public Integer getMenuSort() {
        return menuSort;
    }

    public void setMenuSort(Integer menuSort) {
        this.menuSort = menuSort;
    }
    @Column(name = "icon")
    public String getIcon() {
        return icon;
    }

    public void setIcon(String icon) {
        this.icon = icon;
    }
    @Column(name = "url")
    public String getUrl() {
        return url;
    }

    public void setUrl(String url) {
        this.url = url;
    }
    @Column(name = "is_show")
    public String getIsShow() {
        return isShow;
    }

    public void setIsShow(String isShow) {
        this.isShow = isShow;
    }
    @Column(name = "status")
    public Integer getStatus() {
        return status;
    }

    public void setStatus(Integer status) {
        this.status = status;
    }
    @Column(name = "remark")
    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }
    @Column(name = "menu_level")
    public Integer getMenuLevel() {
        return menuLevel;
    }

    public void setMenuLevel(Integer menuLevel) {
        this.menuLevel = menuLevel;
    }
    @Column(name = "function_type")
    public String getFunctionType() {
        return functionType;
    }

    public void setFunctionType(String functionType) {
        this.functionType = functionType;
    }
    @Column(name = "menu_location")
    public String getMenuLocation() {
        return menuLocation;
    }

    public void setMenuLocation(String menuLocation) {
        this.menuLocation = menuLocation;
    }
    @Column(name = "menu_img")
    public String getMenuImg() {
        return menuImg;
    }

    public void setMenuImg(String menuImg) {
        this.menuImg = menuImg;
    }

    @Column(name = "type")
    public Integer getType() {
        return type;
    }

    public void setType(Integer type) {
        this.type = type;
    }


    @Transient
    public List<BaseDoctorDO> getDoctorList() {
        return doctorList;
    }

    public void setDoctorList(List<BaseDoctorDO> doctorList) {
        this.doctorList = doctorList;
    }

    @Transient
    public Integer getCollection() {
        return collection;
    }

    public void setCollection(Integer collection) {
        this.collection = collection;
    }

    @Transient
    public Integer getFabulous() {
        return fabulous;
    }

    public void setFabulous(Integer fabulous) {
        this.fabulous = fabulous;
    }

    @Transient
    public String getIsCollection() {
        return isCollection;
    }

    public void setIsCollection(String isCollection) {
        this.isCollection = isCollection;
    }

    @Transient
    public String getIsFabulous() {
        return isFabulous;
    }

    public void setIsFabulous(String isFabulous) {
        this.isFabulous = isFabulous;
    }
}
