package com.yihu.jw.entity.base.processGuidance;

import com.yihu.jw.entity.UuidIdentityEntityWithCreateTime;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.util.List;

/**
 * 全流程指引-预设流程
 * Created by yeshijie on 2022/9/30.
 */
@Entity
@Table(name = "base_process_guidance")
public class BaseProcessGuidanceDO extends UuidIdentityEntityWithCreateTime {

    private String name;
    private Integer status;//状态（1生效 0失效）
    private Integer isAllDept;//是否全部科室 1是0否
    private String statusName;

    private List<BaseProcessGuidanceDeptDO> deptDOList;//关联部门
    private List<BaseProcessGuidancePresetDO> presetDOList;//预设流程节点

    @Column(name = "name")
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    @Column(name = "status")
    public Integer getStatus() {
        return status;
    }

    public void setStatus(Integer status) {
        this.status = status;
    }

    @Column(name = "is_all_dept")
    public Integer getIsAllDept() {
        return isAllDept;
    }

    public void setIsAllDept(Integer isAllDept) {
        this.isAllDept = isAllDept;
    }

    @Transient
    public String getStatusName() {
        return statusName;
    }

    public void setStatusName(String statusName) {
        this.statusName = statusName;
    }

    @Transient
    public List<BaseProcessGuidanceDeptDO> getDeptDOList() {
        return deptDOList;
    }

    public void setDeptDOList(List<BaseProcessGuidanceDeptDO> deptDOList) {
        this.deptDOList = deptDOList;
    }

    @Transient
    public List<BaseProcessGuidancePresetDO> getPresetDOList() {
        return presetDOList;
    }

    public void setPresetDOList(List<BaseProcessGuidancePresetDO> presetDOList) {
        this.presetDOList = presetDOList;
    }
}
