package com.yihu.jw.entity.base.servicePackage;

import com.yihu.jw.entity.UuidIdentityEntityWithCreateTime;
import com.yihu.jw.entity.followup.Followup;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;

/**
 * 服务项执行计划
 * Created by yeshijie on 2023/10/28.
 */
@Entity
@Table(name = "base_service_item_plan")
public class ServiceItemPlanDO extends UuidIdentityEntityWithCreateTime {

    private String patient;//居民id
    private String status;//状态0未完成 1已完成
    private String planTime;//计划时间
    private String completeTime;//完成时间
    private String doctor;//医生id
    private String doctorName;//医生姓名
    private String planId;//康复计划id
    private String planDetailId;//康复计划明细id
    private String name;//服务项名称
    private String relationCode;//关联业务id
    private String relationType;//关联业务类型 1电话/短信关怀 2康复咨询 3康复咨询 4上门服务 5康复指导 6康复随访 7康复复诊

    private String guidanceMessage;//指导留言
    private Followup followup;//随访

    @Column(name = "patient")
    public String getPatient() {
        return patient;
    }

    public void setPatient(String patient) {
        this.patient = patient;
    }

    @Column(name = "status")
    public String getStatus() {
        return status;
    }

    public void setStatus(String status) {
        this.status = status;
    }

    @Column(name = "doctor")
    public String getDoctor() {
        return doctor;
    }

    public void setDoctor(String doctor) {
        this.doctor = doctor;
    }
    @Column(name = "doctor_name")
    public String getDoctorName() {
        return doctorName;
    }

    public void setDoctorName(String doctorName) {
        this.doctorName = doctorName;
    }
    @Column(name = "plan_id")
    public String getPlanId() {
        return planId;
    }

    public void setPlanId(String planId) {
        this.planId = planId;
    }
    @Column(name = "plan_detail_id")
    public String getPlanDetailId() {
        return planDetailId;
    }

    public void setPlanDetailId(String planDetailId) {
        this.planDetailId = planDetailId;
    }
    @Column(name = "name")
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }
    @Column(name = "relation_code")
    public String getRelationCode() {
        return relationCode;
    }

    public void setRelationCode(String relationCode) {
        this.relationCode = relationCode;
    }
    @Column(name = "relation_type")
    public String getRelationType() {
        return relationType;
    }

    public void setRelationType(String relationType) {
        this.relationType = relationType;
    }

    public String getPlanTime() {
        return planTime;
    }
    @Column(name = "plan_time")
    public void setPlanTime(String planTime) {
        this.planTime = planTime;
    }

    public String getCompleteTime() {
        return completeTime;
    }
    @Column(name = "complete_time")
    public void setCompleteTime(String completeTime) {
        this.completeTime = completeTime;
    }

    @Transient
    public String getGuidanceMessage() {
        return guidanceMessage;
    }

    public void setGuidanceMessage(String guidanceMessage) {
        this.guidanceMessage = guidanceMessage;
    }

    @Transient
    public Followup getFollowup() {
        return followup;
    }

    public void setFollowup(Followup followup) {
        this.followup = followup;
    }
}
