package com.yihu.jw.entity.base.team;

import com.yihu.jw.entity.UuidIdentityEntityWithOperator;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;


/**
 * 团队信息实体
 *
 * @author litaohong on  2018年08月31日
 */
@Entity
@Table(name = "base_team")
public class BaseTeamDO extends UuidIdentityEntityWithOperator {

    /**
     * 机构代码
     */
    private String orgCode;

    /**
     * 机构名称
     */
    private String orgName;

    /**
     * 团队名称
     */
    private String name;

    /**
     * 领导医生标识
     */
    private String leaderCode;

    /**
     * 团队人数
     */
    private String teamNum;

    /**
     * 团队二维码
     */
    private String qrcode;

    /**
     * 作废标识，1正常，0作废
     */
    private String del;

    private String intro;//团队简介
    private String recommend;//推荐 1是0否
    private String recommendDoctor;//推荐医生code
    private String recommendDoctorName;//推荐医生姓名
    private String dept;//科室code
    private String deptName;//科室名称
    private String img;//图片

    @Column(name = "org_code")
    public String getOrgCode() {
        return orgCode;
    }

    public void setOrgCode(String orgCode) {
        this.orgCode = orgCode;
    }
    @Column(name = "org_name")
    public String getOrgName() {
        return orgName;
    }

    public void setOrgName(String orgName) {
        this.orgName = orgName;
    }

    @Column(name = "name")
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    @Column(name = "leader_code")
    public String getLeaderCode() {
        return leaderCode;
    }

    public void setLeaderCode(String leaderCode) {
        this.leaderCode = leaderCode;
    }

    @Column(name = "team_num")
    public String getTeamNum() {
        return teamNum;
    }

    public void setTeamNum(String teamNum) {
        this.teamNum = teamNum;
    }

    @Column(name = "qrcode")
    public String getQrcode() {
        return qrcode;
    }

    public void setQrcode(String qrcode) {
        this.qrcode = qrcode;
    }

    @Column(name = "del")
    public String getDel() {
        return del;
    }

    public void setDel(String del) {
        this.del = del;
    }

    @Column(name = "intro")
    public String getIntro() {
        return intro;
    }

    public void setIntro(String intro) {
        this.intro = intro;
    }

    @Column(name = "recommend")
    public String getRecommend() {
        return recommend;
    }

    public void setRecommend(String recommend) {
        this.recommend = recommend;
    }

    @Column(name = "recommend_doctor")
    public String getRecommendDoctor() {
        return recommendDoctor;
    }

    public void setRecommendDoctor(String recommendDoctor) {
        this.recommendDoctor = recommendDoctor;
    }

    @Column(name = "recommend_doctor_name")
    public String getRecommendDoctorName() {
        return recommendDoctorName;
    }

    public void setRecommendDoctorName(String recommendDoctorName) {
        this.recommendDoctorName = recommendDoctorName;
    }

    @Column(name = "dept")
    public String getDept() {
        return dept;
    }

    public void setDept(String dept) {
        this.dept = dept;
    }

    @Column(name = "dept_name")
    public String getDeptName() {
        return deptName;
    }

    public void setDeptName(String deptName) {
        this.deptName = deptName;
    }

    @Column(name = "img")
    public String getImg() {
        return img;
    }

    public void setImg(String img) {
        this.img = img;
    }
}
