package com.yihu.jw.entity.care.device;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.yihu.jw.entity.IdEntity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import java.util.Date;

/**
 * Created by Bing on 2022/4/25.
 * 居民设备监测日志
 */
@Entity
@Table(name = "base_patient_monitor_data")
@SequenceGenerator(name="id_generated", sequenceName="seq_base_patient_monitor_data")
public class BasePatientMonitorDataDO extends IdEntity {
    private String patient;
    private String patientName;
    private String categoryCode;
    private String deviceSn;
    /**
     * 当前已用TYPE类型：
     *  1血糖测量 2血压测量，5心率，7呼吸，8步数，9定位上传，10温度（烟感），11床带状态更新（睡眠带）,14燃气浓度,15烟雾浓度，
     *  20紧急呼叫 22安防预警
     */
    private Integer type;
    private String deviceInfo;
    private String relationCode;
    private Date createTime;

    public String getPatient() {
        return patient;
    }

    public void setPatient(String patient) {
        this.patient = patient;
    }

    public String getPatientName() {
        return patientName;
    }

    public void setPatientName(String patientName) {
        this.patientName = patientName;
    }

    public String getCategoryCode() {
        return categoryCode;
    }

    public void setCategoryCode(String categoryCode) {
        this.categoryCode = categoryCode;
    }

    public String getDeviceSn() {
        return deviceSn;
    }

    public void setDeviceSn(String deviceSn) {
        this.deviceSn = deviceSn;
    }

    public Integer getType() {
        return type;
    }

    public void setType(Integer type) {
        this.type = type;
    }

    public String getDeviceInfo() {
        return deviceInfo;
    }

    public void setDeviceInfo(String deviceInfo) {
        this.deviceInfo = deviceInfo;
    }

    public String getRelationCode() {
        return relationCode;
    }

    public void setRelationCode(String relationCode) {
        this.relationCode = relationCode;
    }

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
    @Column(name = "create_time")
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }
}
