package com.yihu.jw.entity.care.device;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.yihu.jw.entity.UuidIdentityEntity;
import org.springframework.data.annotation.CreatedDate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.util.Date;

/**
 * Created by Bing on 2022/1/7.
 * 手表睡眠数据
 */
@Entity
@Table(name="base_sleep_x1device")
public class BaseSleepX1device extends UuidIdentityEntity {
    private String patient;
    private String deviceSn;
    private String sleepTime; //睡眠时长 分钟
    private String deepSleep; //深睡时长 分钟
    private String lightSleep; //浅睡时长 分钟
    private String awakeTime; // 清醒时长 分钟
    private Date createTime; // 开始时间
    private Date endTime;   //结束时间
    private Integer intervalTime; //固定30分钟
    private Integer total; // 检测次数
    private Integer del;  //是否有效 1有效 0无效

    @Column(name = "patient")
    public String getPatient() {
        return patient;
    }

    public void setPatient(String patient) {
        this.patient = patient;
    }

    @Column(name = "device_sn")
    public String getDeviceSn() {
        return deviceSn;
    }

    public void setDeviceSn(String deviceSn) {
        this.deviceSn = deviceSn;
    }

    @Column(name = "sleep_time")
    public String getSleepTime() {
        return sleepTime;
    }

    public void setSleepTime(String sleepTime) {
        this.sleepTime = sleepTime;
    }

    @Column(name = "deep_sleep")
    public String getDeepSleep() {
        return deepSleep;
    }

    public void setDeepSleep(String deepSleep) {
        this.deepSleep = deepSleep;
    }

    @Column(name = "light_sleep")
    public String getLightSleep() {
        return lightSleep;
    }

    public void setLightSleep(String lightSleep) {
        this.lightSleep = lightSleep;
    }

    @Column(name = "awake_time")
    public String getAwakeTime() {
        return awakeTime;
    }

    public void setAwakeTime(String awakeTime) {
        this.awakeTime = awakeTime;
    }

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
    @Column(name = "create_time")
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
    @Column(name = "end_time")
    public Date getEndTime() {
        return endTime;
    }

    public void setEndTime(Date endTime) {
        this.endTime = endTime;
    }

    @Column(name = "interval_time")
    public Integer getIntervalTime() {
        return intervalTime;
    }

    public void setIntervalTime(Integer intervalTime) {
        this.intervalTime = intervalTime;
    }

    @Column(name = "total")
    public Integer getTotal() {
        return total;
    }

    public void setTotal(Integer total) {
        this.total = total;
    }

    @Column(name = "del")
    public Integer getDel() {
        return del;
    }

    public void setDel(Integer del) {
        this.del = del;
    }
}
