package com.yihu.jw.entity.care.label;

import com.yihu.jw.entity.UuidIdentityEntityWithCreateTime;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 能力状况记录表
 */
@Entity
@Table(name = "base_capacity_label")
public class BaseCapacityLabelDO extends UuidIdentityEntityWithCreateTime {

    private String patient;
    private String family;//是否有家属 1是0否
    private String hypertension;//高血压 1是 0否
    private String hyperglycemia;//高血糖 1是 0否
    private String heartDisease;//心脏疾病 1是 0否
    private String workStatus;//行走状态 1迟缓 2一般 3健步如飞
    private String disability;//残疾 1是 0否
    private String disabledPart;//残疾部位
    private String visualCondition;//视觉状况 1看不见 2近距离 3正常
    private String auditoryCondition;//听觉状况 1听不见 2大声量 3正常
    private String communication;//交流情况 1不善于 2一般 3善于
    private String mentalIllness;//精神类疾病 1是 0否
    private String oftenGoOut;//经常外出 1是 0否
    private String usePhone;//会使用智能手机 1是 0否
    private String takeExercise;//参加锻炼 1是 0否

    @Column(name = "patient")
    public String getPatient() {
        return patient;
    }

    public void setPatient(String patient) {
        this.patient = patient;
    }

    @Column(name = "family")
    public String getFamily() {
        return family;
    }

    public void setFamily(String family) {
        this.family = family;
    }

    @Column(name = "hypertension")
    public String getHypertension() {
        return hypertension;
    }

    public void setHypertension(String hypertension) {
        this.hypertension = hypertension;
    }

    @Column(name = "hyperglycemia")
    public String getHyperglycemia() {
        return hyperglycemia;
    }

    public void setHyperglycemia(String hyperglycemia) {
        this.hyperglycemia = hyperglycemia;
    }

    @Column(name = "heart_disease")
    public String getHeartDisease() {
        return heartDisease;
    }

    public void setHeartDisease(String heartDisease) {
        this.heartDisease = heartDisease;
    }

    @Column(name = "work_status")
    public String getWorkStatus() {
        return workStatus;
    }

    public void setWorkStatus(String workStatus) {
        this.workStatus = workStatus;
    }

    @Column(name = "disability")
    public String getDisability() {
        return disability;
    }

    public void setDisability(String disability) {
        this.disability = disability;
    }

    @Column(name = "disabled_part")
    public String getDisabledPart() {
        return disabledPart;
    }

    public void setDisabledPart(String disabledPart) {
        this.disabledPart = disabledPart;
    }

    @Column(name = "visual_condition")
    public String getVisualCondition() {
        return visualCondition;
    }

    public void setVisualCondition(String visualCondition) {
        this.visualCondition = visualCondition;
    }

    @Column(name = "auditory_condition")
    public String getAuditoryCondition() {
        return auditoryCondition;
    }

    public void setAuditoryCondition(String auditoryCondition) {
        this.auditoryCondition = auditoryCondition;
    }

    @Column(name = "communication")
    public String getCommunication() {
        return communication;
    }

    public void setCommunication(String communication) {
        this.communication = communication;
    }

    @Column(name = "mental_illness")
    public String getMentalIllness() {
        return mentalIllness;
    }

    public void setMentalIllness(String mentalIllness) {
        this.mentalIllness = mentalIllness;
    }

    @Column(name = "often_go_out")
    public String getOftenGoOut() {
        return oftenGoOut;
    }

    public void setOftenGoOut(String oftenGoOut) {
        this.oftenGoOut = oftenGoOut;
    }

    @Column(name = "use_phone")
    public String getUsePhone() {
        return usePhone;
    }

    public void setUsePhone(String usePhone) {
        this.usePhone = usePhone;
    }

    @Column(name = "take_exercise")
    public String getTakeExercise() {
        return takeExercise;
    }

    public void setTakeExercise(String takeExercise) {
        this.takeExercise = takeExercise;
    }

    @Transient
    public List<Map<String,Object>> getCapacityLabels(){
        List<Map<String,Object>> list = new ArrayList<>();
        Map<String,Object> tmp = new HashMap<>();
        if ("1".equals(hypertension)){
            tmp = new HashMap<>();
            tmp.put("txt","高血压:是");
            tmp.put("value",hypertension);
            tmp.put("code","hypertension");
            list.add(tmp);
        }
        if ("1".equals(hyperglycemia)){
            tmp = new HashMap<>();
            tmp.put("txt","高血糖:是");
            tmp.put("value",hyperglycemia);
            tmp.put("code","hyperglycemia");
            list.add(tmp);
        }
        if ("1".equals(heartDisease)){
            tmp = new HashMap<>();
            tmp.put("txt","心脏疾病:是");
            tmp.put("value",heartDisease);
            tmp.put("code","heartDisease");
            list.add(tmp);
        }
        if(null!=workStatus){
            switch (workStatus){
                case "1":
                    tmp = new HashMap<>();
                    tmp.put("txt","行走状态:迟缓");
                    tmp.put("value",workStatus);
                    tmp.put("code","workStatus");
                    list.add(tmp);
                    break;
                case "2":
                    tmp = new HashMap<>();
                    tmp.put("txt","行走状态:一般");
                    tmp.put("value",workStatus);
                    tmp.put("code","workStatus");
                    list.add(tmp);
                    break;
                case "3":
                    tmp = new HashMap<>();
                    tmp.put("txt","行走状态:健步如飞");
                    tmp.put("value",workStatus);
                    tmp.put("code","workStatus");
                    list.add(tmp);
                    break;
            }
        }
        if(null!=visualCondition){
            switch (visualCondition){
                case "1":
                    tmp = new HashMap<>();
                    tmp.put("txt","视觉状况:看不见");
                    tmp.put("value",visualCondition);
                    tmp.put("code","visualCondition");
                    list.add(tmp);
                    break;
                case "2":
                    tmp = new HashMap<>();
                    tmp.put("txt","视觉状况:近距离");
                    tmp.put("value",visualCondition);
                    tmp.put("code","visualCondition");
                    list.add(tmp);
                    break;
                case "3":
                    tmp = new HashMap<>();
                    tmp.put("txt","视觉状况:正常");
                    tmp.put("value",visualCondition);
                    tmp.put("code","visualCondition");
                    list.add(tmp);
                    break;
            }
        }
        if(null!=auditoryCondition){
            switch (auditoryCondition){
                case "1":
                    tmp = new HashMap<>();
                    tmp.put("txt","行走状态:迟缓");
                    tmp.put("value",auditoryCondition);
                    tmp.put("code","auditoryCondition");
                    list.add(tmp);
                    break;
                case "2":
                    tmp = new HashMap<>();
                    tmp.put("txt","行走状态:一般");
                    tmp.put("value",auditoryCondition);
                    tmp.put("code","auditoryCondition");
                    list.add(tmp);
                    break;
                case "3":
                    tmp = new HashMap<>();
                    tmp.put("txt","行走状态:健步如飞");
                    tmp.put("value",auditoryCondition);
                    tmp.put("code","auditoryCondition");
                    list.add(tmp);
                    break;
            }
        }
        if(null!=communication){
            switch (communication){
                case "1":
                    tmp = new HashMap<>();
                    tmp.put("txt","交流情况:不善于");
                    tmp.put("value",communication);
                    tmp.put("code","communication");
                    list.add(tmp);
                    break;
                case "2":
                    tmp = new HashMap<>();
                    tmp.put("txt","交流情况:一般");
                    tmp.put("value",communication);
                    tmp.put("code",communication);
                    list.add(tmp);
                    break;
                case "3":
                    tmp = new HashMap<>();
                    tmp.put("txt","交流情况:善于");
                    tmp.put("value",communication);
                    tmp.put("code","communication");
                    list.add(tmp);
                    break;
            }
        }
        if ("1".equals(mentalIllness)){
            tmp = new HashMap<>();
            tmp.put("txt","精神类疾病:是");
            tmp.put("value",mentalIllness);
            tmp.put("code","mentalIllness");
            list.add(tmp);
        }
        if ("1".equals(oftenGoOut)){
            tmp = new HashMap<>();
            tmp.put("txt","经常外出:是");
            tmp.put("value",oftenGoOut);
            tmp.put("code","oftenGoOut");
            list.add(tmp);
        }
        if ("1".equals(usePhone)){
            tmp = new HashMap<>();
            tmp.put("txt","会使用智能手机:是");
            tmp.put("value",usePhone);
            tmp.put("code","usePhone");
            list.add(tmp);
        }
        if ("1".equals(takeExercise)){
            tmp = new HashMap<>();
            tmp.put("txt","参加锻炼:是");
            tmp.put("value",takeExercise);
            tmp.put("code","takeExercise");
            list.add(tmp);
        }
        return list;
    }
}
