package com.yihu.jw.entity.dailyReport;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.yihu.jw.entity.UuidIdentityEntityWithOperator;

import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.util.Date;

/**
 * Created by Bing on 2022/7/25.
 * 上报内容
 */
@Entity
@Table(name="base_daily_report_detail")
public class BaseDailyReportDetailDO extends UuidIdentityEntityWithOperator {

    private String reportId;//每日日报id
    private Integer sort;//序号
    private String reportContent;//上报内容事项
    private String completionSchedule;//完成进度
    private String completionHour;//完成时长
    private Integer state;//是否核实 0未核实1已核实
    private Date verificationTime;//核实时间
    private String verificationUser;//核实人
    private String verificationUserName;//核实人姓名
    private String remark; //备注内容
    private Integer doubt; //疑惑0无疑惑1存疑
    private Integer doubtType; //存疑类型，1不饱和存疑 2效率存疑
    private Integer doubtState; //疑惑核实状态0未核实1已核实
    private String doubtRemark; //疑惑核实备注
    private String actualCompletionHour; //实际完成时长
    private String reportItemId;//日报项目id
    private String reportItemName;//日报项目名称

    private boolean reportItemFlag;
    private String reportItemTitle;
    private String projectCode;
    private String projectName;

    public String getReportId() {
        return reportId;
    }

    public void setReportId(String reportId) {
        this.reportId = reportId;
    }

    public Integer getSort() {
        return sort;
    }

    public void setSort(Integer sort) {
        this.sort = sort;
    }

    public String getReportContent() {
        return reportContent;
    }

    public void setReportContent(String reportContent) {
        this.reportContent = reportContent;
    }

    public String getCompletionSchedule() {
        return completionSchedule;
    }

    public void setCompletionSchedule(String completionSchedule) {
        this.completionSchedule = completionSchedule;
    }

    public String getCompletionHour() {
        return completionHour;
    }

    public void setCompletionHour(String completionHour) {
        this.completionHour = completionHour;
    }

    public Integer getState() {
        return state;
    }

    public void setState(Integer state) {
        this.state = state;
    }

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
    public Date getVerificationTime() {
        return verificationTime;
    }

    public void setVerificationTime(Date verificationTime) {
        this.verificationTime = verificationTime;
    }

    public String getVerificationUser() {
        return verificationUser;
    }

    public void setVerificationUser(String verificationUser) {
        this.verificationUser = verificationUser;
    }

    public String getVerificationUserName() {
        return verificationUserName;
    }

    public void setVerificationUserName(String verificationUserName) {
        this.verificationUserName = verificationUserName;
    }

    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }

    public Integer getDoubt() {
        return doubt;
    }

    public void setDoubt(Integer doubt) {
        this.doubt = doubt;
    }

    public Integer getDoubtType() {
        return doubtType;
    }

    public void setDoubtType(Integer doubtType) {
        this.doubtType = doubtType;
    }

    public Integer getDoubtState() {
        return doubtState;
    }

    public void setDoubtState(Integer doubtState) {
        this.doubtState = doubtState;
    }

    public String getDoubtRemark() {
        return doubtRemark;
    }

    public void setDoubtRemark(String doubtRemark) {
        this.doubtRemark = doubtRemark;
    }

    public String getActualCompletionHour() {
        return actualCompletionHour;
    }

    public void setActualCompletionHour(String actualCompletionHour) {
        this.actualCompletionHour = actualCompletionHour;
    }

    public String getReportItemId() {
        return reportItemId;
    }

    public void setReportItemId(String reportItemId) {
        this.reportItemId = reportItemId;
    }

    public String getReportItemName() {
        return reportItemName;
    }

    public void setReportItemName(String reportItemName) {
        this.reportItemName = reportItemName;
    }

    @Transient
    public boolean isReportItemFlag() {
        return reportItemFlag;
    }

    public void setReportItemFlag(boolean reportItemFlag) {
        this.reportItemFlag = reportItemFlag;
    }

    @Transient
    public String getReportItemTitle() {
        return reportItemTitle;
    }

    public void setReportItemTitle(String reportItemTitle) {
        this.reportItemTitle = reportItemTitle;
    }

    @Transient
    public String getProjectCode() {
        return projectCode;
    }

    public void setProjectCode(String projectCode) {
        this.projectCode = projectCode;
    }

    @Transient
    public String getProjectName() {
        return projectName;
    }

    public void setProjectName(String projectName) {
        this.projectName = projectName;
    }
}
