package com.yihu.jw.entity.dailyReport;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.yihu.jw.entity.UuidIdentityEntity;
import com.yihu.jw.entity.UuidIdentityEntityWithOperator;
import org.springframework.data.annotation.CreatedBy;
import org.springframework.data.annotation.LastModifiedBy;
import org.springframework.data.annotation.LastModifiedDate;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.util.Date;
import java.util.List;

/**
 * Created by Bing on 2022/7/25.
 * 每日日报项目
 */
@Entity
@Table(name="base_daily_report_item")
public class BaseDailyReportItemDO extends UuidIdentityEntity {

    private String title;//项目标题
    private String content;//项目内容
    private Integer state;//完成状态 -1取消，0待办，1已完成
    private String beginTime;//项目开始时间
    private String endTime;//项目结束时间
    private String completionHour;//完成时长
    private String completionUser;//完成人
    private Date completionTime;//完成时间
    private Integer del;//1有效0无效

    protected Date createTime;
    protected String createUser;
    protected String createUserName;
    protected Date updateTime;
    protected String updateUser;
    protected String updateUserName;
    private String completionUserName;
    private String projectCode;
    private String projectName;
    private String acBeginTime;//项目实际开始时间
    private String dept;
    private String deptName;

    private List<BaseDailyReportItemMembersDO> itemMembersDOList;

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public String getContent() {
        return content;
    }

    public void setContent(String content) {
        this.content = content;
    }

    public Integer getState() {
        return state;
    }

    public void setState(Integer state) {
        this.state = state;
    }

    public String getBeginTime() {
        return beginTime;
    }

    public void setBeginTime(String beginTime) {
        this.beginTime = beginTime;
    }

    public String getEndTime() {
        return endTime;
    }

    public void setEndTime(String endTime) {
        this.endTime = endTime;
    }

    public String getCompletionHour() {
        return completionHour;
    }

    public void setCompletionHour(String completionHour) {
        this.completionHour = completionHour;
    }

    public String getCompletionUser() {
        return completionUser;
    }

    public void setCompletionUser(String completionUser) {
        this.completionUser = completionUser;
    }

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
    public Date getCompletionTime() {
        return completionTime;
    }

    public void setCompletionTime(Date completionTime) {
        this.completionTime = completionTime;
    }

    public Integer getDel() {
        return del;
    }

    public void setDel(Integer del) {
        this.del = del;
    }

    @Transient
    public List<BaseDailyReportItemMembersDO> getItemMembersDOList() {
        return itemMembersDOList;
    }

    public void setItemMembersDOList(List<BaseDailyReportItemMembersDO> itemMembersDOList) {
        this.itemMembersDOList = itemMembersDOList;
    }

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Column(name = "create_user",updatable = false)
    public String getCreateUser() {
        return createUser;
    }

    public void setCreateUser(String createUser) {
        this.createUser = createUser;
    }

    @Column(name = "create_user_name",updatable = false)
    public String getCreateUserName() {
        return createUserName;
    }

    public void setCreateUserName(String createUserName) {
        this.createUserName = createUserName;
    }

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    public String getUpdateUser() {
        return updateUser;
    }

    public void setUpdateUser(String updateUser) {
        this.updateUser = updateUser;
    }

    public String getUpdateUserName() {
        return updateUserName;
    }

    public void setUpdateUserName(String updateUserName) {
        this.updateUserName = updateUserName;
    }

    public String getCompletionUserName() {
        return completionUserName;
    }

    public void setCompletionUserName(String completionUserName) {
        this.completionUserName = completionUserName;
    }

    public String getProjectCode() {
        return projectCode;
    }

    public void setProjectCode(String projectCode) {
        this.projectCode = projectCode;
    }

    public String getProjectName() {
        return projectName;
    }

    public void setProjectName(String projectName) {
        this.projectName = projectName;
    }

    public String getAcBeginTime() {
        return acBeginTime;
    }

    public void setAcBeginTime(String acBeginTime) {
        this.acBeginTime = acBeginTime;
    }

    public String getDept() {
        return dept;
    }

    public void setDept(String dept) {
        this.dept = dept;
    }

    public String getDeptName() {
        return deptName;
    }

    public void setDeptName(String deptName) {
        this.deptName = deptName;
    }
}
