package com.yihu.jw.entity.healthUpload;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.yihu.jw.entity.UuidIdentityEntityWithOperator;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.util.Date;


/**
 * 健康上报表-居民
 *
 * Created by yeshijie on 2022/12/6.
 *
 */
@Entity
@Table(name = "base_patient_health_upload")
public class BasePatientHealthUploadDO extends UuidIdentityEntityWithOperator {
    private String provinceName;
    private String cityName;
    private String townName;
    private String streetName;
    private String address;
    private String temperature;
    private Integer healthCode;
    private String healthCodeUrl;
    private Integer tourCode;
    private String tourCodeUrl;
    private Integer isSymptoms;
    private String abnormalSymptoms;
    private Integer isEpidemic;
    private String epidemicPerson;
    private Integer  isOutside;
    private String outsideProvinceCode;
    private String outsideProvinceName;
    private String outsideCityCode;
    private String outsideCityName;
    private String outsideTownCode;
    private String outsideTownName;
    private String outsideStreetName;
    private String outsideStreetCode;
    private String outsideAddress;
    private Date outsideDate;
    private Integer isNucleate;
    private String nucleateCodeUrl;
    private Integer  isOutsideHigh;
    private String outsideHighProvinceCode;
    private String outsideHighProvinceName;
    private String outsideHighCityCode;
    private String outsideHighCityName;
    private String outsideHighTownCode;
    private String outsideHighTownName;
    private String outsideHighStreetName;
    private String outsideHighStreetCode;
    private String outsideHighAddress;
    private Date outsideHighDate;
    private String patientId;
    private String patientName;
    private String idCard;
    private String mobile;
    private String consumer;
    private String consumerName;
    private String healthCodeDesc;
    private Integer outsideHighNucleate;
    private String abnormalSymptomsOther;
    private Integer scheduleStatus;//1本地2出差3外出
    private String startProvinceName;
    private String startCityName;
    private String startTownName;
    private String startStreetName;//开始市
    private String endProvinceName;//终止省
    private String endCityName;//终止市
    private String endTownName;//终止区
    private String endStreetName;//终止街道
    private Integer transportType;//交通方式(1自驾2火车3飞机)
    private String licenseNumber;//车牌号
    private String number;//座位
    private Integer isHigh;//1是2否

    public Integer getScheduleStatus() {
        return scheduleStatus;
    }

    public void setScheduleStatus(Integer scheduleStatus) {
        this.scheduleStatus = scheduleStatus;
    }

    public String getStartProvinceName() {
        return startProvinceName;
    }

    public void setStartProvinceName(String startProvinceName) {
        this.startProvinceName = startProvinceName;
    }

    public String getStartCityName() {
        return startCityName;
    }

    public void setStartCityName(String startCityName) {
        this.startCityName = startCityName;
    }

    public String getStartTownName() {
        return startTownName;
    }

    public void setStartTownName(String startTownName) {
        this.startTownName = startTownName;
    }

    public String getStartStreetName() {
        return startStreetName;
    }

    public void setStartStreetName(String startStreetName) {
        this.startStreetName = startStreetName;
    }

    public String getEndProvinceName() {
        return endProvinceName;
    }

    public void setEndProvinceName(String endProvinceName) {
        this.endProvinceName = endProvinceName;
    }

    public String getEndCityName() {
        return endCityName;
    }

    public void setEndCityName(String endCityName) {
        this.endCityName = endCityName;
    }

    public String getEndTownName() {
        return endTownName;
    }

    public void setEndTownName(String endTownName) {
        this.endTownName = endTownName;
    }

    public String getEndStreetName() {
        return endStreetName;
    }

    public void setEndStreetName(String endStreetName) {
        this.endStreetName = endStreetName;
    }

    public Integer getTransportType() {
        return transportType;
    }

    public void setTransportType(Integer transportType) {
        this.transportType = transportType;
    }

    public String getLicenseNumber() {
        return licenseNumber;
    }

    public void setLicenseNumber(String licenseNumber) {
        this.licenseNumber = licenseNumber;
    }

    public String getNumber() {
        return number;
    }

    public void setNumber(String number) {
        this.number = number;
    }

    public Integer getIsHigh() {
        return isHigh;
    }

    public void setIsHigh(Integer isHigh) {
        this.isHigh = isHigh;
    }

    public String getAbnormalSymptomsOther() {
        return abnormalSymptomsOther;
    }

    public void setAbnormalSymptomsOther(String abnormalSymptomsOther) {
        this.abnormalSymptomsOther = abnormalSymptomsOther;
    }

    public Integer getOutsideHighNucleate() {
        return outsideHighNucleate;
    }

    public void setOutsideHighNucleate(Integer outsideHighNucleate) {
        this.outsideHighNucleate = outsideHighNucleate;
    }

    public String getHealthCodeDesc() {
        return healthCodeDesc;
    }

    public void setHealthCodeDesc(String healthCodeDesc) {
        this.healthCodeDesc = healthCodeDesc;
    }

    public String getNucleateCodeUrl() {
        return nucleateCodeUrl;
    }

    public void setNucleateCodeUrl(String nucleateCodeUrl) {
        this.nucleateCodeUrl = nucleateCodeUrl;
    }

    public String getProvinceName() {
        return provinceName;
    }

    public void setProvinceName(String provinceName) {
        this.provinceName = provinceName;
    }

    public String getCityName() {
        return cityName;
    }

    public void setCityName(String cityName) {
        this.cityName = cityName;
    }

    public String getTownName() {
        return townName;
    }

    public void setTownName(String townName) {
        this.townName = townName;
    }

    public String getStreetName() {
        return streetName;
    }

    public void setStreetName(String streetName) {
        this.streetName = streetName;
    }

    public String getAddress() {
        return address;
    }

    public void setAddress(String address) {
        this.address = address;
    }

    public String getTemperature() {
        return temperature;
    }

    public void setTemperature(String temperature) {
        this.temperature = temperature;
    }

    public Integer getHealthCode() {
        return healthCode;
    }

    public void setHealthCode(Integer healthCode) {
        this.healthCode = healthCode;
    }

    public String getHealthCodeUrl() {
        return healthCodeUrl;
    }

    public void setHealthCodeUrl(String healthCodeUrl) {
        this.healthCodeUrl = healthCodeUrl;
    }

    public Integer getTourCode() {
        return tourCode;
    }

    public void setTourCode(Integer tourCode) {
        this.tourCode = tourCode;
    }

    public String getTourCodeUrl() {
        return tourCodeUrl;
    }

    public void setTourCodeUrl(String tourCodeUrl) {
        this.tourCodeUrl = tourCodeUrl;
    }

    public Integer getIsSymptoms() {
        return isSymptoms;
    }

    public void setIsSymptoms(Integer isSymptoms) {
        this.isSymptoms = isSymptoms;
    }

    public String getAbnormalSymptoms() {
        return abnormalSymptoms;
    }

    public void setAbnormalSymptoms(String abnormalSymptoms) {
        this.abnormalSymptoms = abnormalSymptoms;
    }

    public Integer getIsEpidemic() {
        return isEpidemic;
    }

    public void setIsEpidemic(Integer isEpidemic) {
        this.isEpidemic = isEpidemic;
    }

    public String getEpidemicPerson() {
        return epidemicPerson;
    }

    public void setEpidemicPerson(String epidemicPerson) {
        this.epidemicPerson = epidemicPerson;
    }

    public Integer getIsOutside() {
        return isOutside;
    }

    public void setIsOutside(Integer isOutside) {
        this.isOutside = isOutside;
    }

    public String getOutsideProvinceCode() {
        return outsideProvinceCode;
    }

    public void setOutsideProvinceCode(String outsideProvinceCode) {
        this.outsideProvinceCode = outsideProvinceCode;
    }

    public String getOutsideProvinceName() {
        return outsideProvinceName;
    }

    public void setOutsideProvinceName(String outsideProvinceName) {
        this.outsideProvinceName = outsideProvinceName;
    }

    public String getOutsideCityCode() {
        return outsideCityCode;
    }

    public void setOutsideCityCode(String outsideCityCode) {
        this.outsideCityCode = outsideCityCode;
    }

    public String getOutsideCityName() {
        return outsideCityName;
    }

    public void setOutsideCityName(String outsideCityName) {
        this.outsideCityName = outsideCityName;
    }

    public String getOutsideTownCode() {
        return outsideTownCode;
    }

    public void setOutsideTownCode(String outsideTownCode) {
        this.outsideTownCode = outsideTownCode;
    }

    public String getOutsideTownName() {
        return outsideTownName;
    }

    public void setOutsideTownName(String outsideTownName) {
        this.outsideTownName = outsideTownName;
    }

    public String getOutsideStreetName() {
        return outsideStreetName;
    }

    public void setOutsideStreetName(String outsideStreetName) {
        this.outsideStreetName = outsideStreetName;
    }

    public String getOutsideStreetCode() {
        return outsideStreetCode;
    }

    public void setOutsideStreetCode(String outsideStreetCode) {
        this.outsideStreetCode = outsideStreetCode;
    }

    public String getOutsideAddress() {
        return outsideAddress;
    }

    public void setOutsideAddress(String outsideAddress) {
        this.outsideAddress = outsideAddress;
    }

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
    @Column(name = "outside_date", nullable = false, length = 0,updatable = false)
    public Date getOutsideDate() {
        return outsideDate;
    }

    public void setOutsideDate(Date outsideDate) {
        this.outsideDate = outsideDate;
    }

    public Integer getIsNucleate() {
        return isNucleate;
    }

    public void setIsNucleate(Integer isNucleate) {
        this.isNucleate = isNucleate;
    }

    public Integer getIsOutsideHigh() {
        return isOutsideHigh;
    }

    public void setIsOutsideHigh(Integer isOutsideHigh) {
        this.isOutsideHigh = isOutsideHigh;
    }

    public String getOutsideHighProvinceCode() {
        return outsideHighProvinceCode;
    }

    public void setOutsideHighProvinceCode(String outsideHighProvinceCode) {
        this.outsideHighProvinceCode = outsideHighProvinceCode;
    }

    public String getOutsideHighProvinceName() {
        return outsideHighProvinceName;
    }

    public void setOutsideHighProvinceName(String outsideHighProvinceName) {
        this.outsideHighProvinceName = outsideHighProvinceName;
    }

    public String getOutsideHighCityCode() {
        return outsideHighCityCode;
    }

    public void setOutsideHighCityCode(String outsideHighCityCode) {
        this.outsideHighCityCode = outsideHighCityCode;
    }

    public String getOutsideHighCityName() {
        return outsideHighCityName;
    }

    public void setOutsideHighCityName(String outsideHighCityName) {
        this.outsideHighCityName = outsideHighCityName;
    }

    public String getOutsideHighTownCode() {
        return outsideHighTownCode;
    }

    public void setOutsideHighTownCode(String outsideHighTownCode) {
        this.outsideHighTownCode = outsideHighTownCode;
    }

    public String getOutsideHighTownName() {
        return outsideHighTownName;
    }

    public void setOutsideHighTownName(String outsideHighTownName) {
        this.outsideHighTownName = outsideHighTownName;
    }

    public String getOutsideHighStreetName() {
        return outsideHighStreetName;
    }

    public void setOutsideHighStreetName(String outsideHighStreetName) {
        this.outsideHighStreetName = outsideHighStreetName;
    }

    public String getOutsideHighStreetCode() {
        return outsideHighStreetCode;
    }

    public void setOutsideHighStreetCode(String outsideHighStreetCode) {
        this.outsideHighStreetCode = outsideHighStreetCode;
    }

    public String getOutsideHighAddress() {
        return outsideHighAddress;
    }

    public void setOutsideHighAddress(String outsideHighAddress) {
        this.outsideHighAddress = outsideHighAddress;
    }

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
    @Column(name = "outside_high_date", nullable = false, length = 0,updatable = false)
    public Date getOutsideHighDate() {
        return outsideHighDate;
    }

    public void setOutsideHighDate(Date outsideHighDate) {
        this.outsideHighDate = outsideHighDate;
    }

    public String getPatientId() {
        return patientId;
    }

    public void setPatientId(String patientId) {
        this.patientId = patientId;
    }

    public String getPatientName() {
        return patientName;
    }

    public void setPatientName(String patientName) {
        this.patientName = patientName;
    }

    public String getIdCard() {
        return idCard;
    }

    public void setIdCard(String idCard) {
        this.idCard = idCard;
    }

    public String getMobile() {
        return mobile;
    }

    public void setMobile(String mobile) {
        this.mobile = mobile;
    }

    public String getConsumer() {
        return consumer;
    }

    public void setConsumer(String consumer) {
        this.consumer = consumer;
    }

    public String getConsumerName() {
        return consumerName;
    }

    public void setConsumerName(String consumerName) {
        this.consumerName = consumerName;
    }
}