package com.yihu.jw.entity.hospital.integrate;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.yihu.jw.entity.UuidIdentityEntityWithOperator;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.util.Date;

@Entity
@Table(name = "base_hospital_activity")
public class BaseHospitalActivityDO extends UuidIdentityEntityWithOperator {

    private String type;//活动类型(字典HOSPITAL_ACTIVITY_TYPE)
    private String title;//活动标题
    private String banner;//活动图片
    private Integer count;//人数
    private String organizerOrgCode;//主办方机构code
    private String organizerOrgName;//主办机构名称
    private String organizerDeptCode;//主办科室code
    private String organizerDeptName;//主办科室名称
    private String location;//活动地点
    private Integer status;//活动状态（0未开始1开始2结束）
    private Integer flag;//0禁用1启用
    private Integer del;//0删除1正常
    private Date startTime;//开始时间
    private Date endTime;//结束时间
    private String info;//报名信息
    private String content;//活动详情
    private Integer participantsType;//参与对象类型：0全部1医生2患者
    private String participantsArea;//参与对象区域0全院1部分科室
    private String participantsCode;//参与对象code 多个逗号隔开
    private Integer sort;//排序
    private String manager;//活动负责人code逗号隔开
    private String managerName;//活动负责人名称逗号隔开
    private Integer registrationType;//0自动报名1手动报名
    private Date registrationStartTime;//报名开始时间
    private Date registrationEndTime;//报名结束时间
    private Integer isTask;//是否关联任务1是0否
    private String taskCode;//任务code(字典HOSPITAL_TASK_BUSINESS_DICT)
    private String taskName;//任务名称(字典HOSPITAL_TASK_BUSINESS_DICT)
    private String businessCode;//业务code(字典HOSPITAL_TASK_BUSINESS_DICT)
    private String businessName;//业务名称(字典HOSPITAL_TASK_BUSINESS_DICT)
    private Integer isIntegrate;//是否配置积分1配置0未配置

    private BaseHospitalIntegrateDO integrateDO;//积分配置对象

    @Transient
    public BaseHospitalIntegrateDO getIntegrateDO() {
        return integrateDO;
    }

    public void setIntegrateDO(BaseHospitalIntegrateDO integrateDO) {
        this.integrateDO = integrateDO;
    }

    public Integer getRegistrationType() {
        return registrationType;
    }

    public void setRegistrationType(Integer registrationType) {
        this.registrationType = registrationType;
    }

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
    @Column(name = "registration_start_time")
    public Date getRegistrationStartTime() {
        return registrationStartTime;
    }

    public void setRegistrationStartTime(Date registrationStartTime) {
        this.registrationStartTime = registrationStartTime;
    }

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
    @Column(name = "registration_end_time")
    public Date getRegistrationEndTime() {
        return registrationEndTime;
    }

    public void setRegistrationEndTime(Date registrationEndTime) {
        this.registrationEndTime = registrationEndTime;
    }

    public Integer getIsTask() {
        return isTask;
    }

    public void setIsTask(Integer isTask) {
        this.isTask = isTask;
    }

    public String getTaskCode() {
        return taskCode;
    }

    public void setTaskCode(String taskCode) {
        this.taskCode = taskCode;
    }

    public String getTaskName() {
        return taskName;
    }

    public void setTaskName(String taskName) {
        this.taskName = taskName;
    }

    public String getBusinessCode() {
        return businessCode;
    }

    public void setBusinessCode(String businessCode) {
        this.businessCode = businessCode;
    }

    public String getBusinessName() {
        return businessName;
    }

    public void setBusinessName(String businessName) {
        this.businessName = businessName;
    }

    public Integer getIsIntegrate() {
        return isIntegrate;
    }

    public void setIsIntegrate(Integer isIntegrate) {
        this.isIntegrate = isIntegrate;
    }

    public String getManager() {
        return manager;
    }
    public void setManager(String manager) {
        this.manager = manager;
    }

    public String getManagerName() {
        return managerName;
    }

    public void setManagerName(String managerName) {
        this.managerName = managerName;
    }

    public Integer getSort() {
        return sort;
    }

    public void setSort(Integer sort) {
        this.sort = sort;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public String getBanner() {
        return banner;
    }

    public void setBanner(String banner) {
        this.banner = banner;
    }

    public Integer getCount() {
        return count;
    }

    public void setCount(Integer count) {
        this.count = count;
    }

    public String getOrganizerOrgCode() {
        return organizerOrgCode;
    }

    public void setOrganizerOrgCode(String organizerOrgCode) {
        this.organizerOrgCode = organizerOrgCode;
    }

    public String getOrganizerOrgName() {
        return organizerOrgName;
    }

    public void setOrganizerOrgName(String organizerOrgName) {
        this.organizerOrgName = organizerOrgName;
    }

    public String getOrganizerDeptCode() {
        return organizerDeptCode;
    }

    public void setOrganizerDeptCode(String organizerDeptCode) {
        this.organizerDeptCode = organizerDeptCode;
    }

    public String getOrganizerDeptName() {
        return organizerDeptName;
    }

    public void setOrganizerDeptName(String organizerDeptName) {
        this.organizerDeptName = organizerDeptName;
    }

    public String getLocation() {
        return location;
    }

    public void setLocation(String location) {
        this.location = location;
    }

    public Integer getStatus() {
        return status;
    }

    public void setStatus(Integer status) {
        this.status = status;
    }

    public Integer getFlag() {
        return flag;
    }

    public void setFlag(Integer flag) {
        this.flag = flag;
    }

    public Integer getDel() {
        return del;
    }

    public void setDel(Integer del) {
        this.del = del;
    }

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
    @Column(name = "start_time")
    public Date getStartTime() {
        return startTime;
    }

    public void setStartTime(Date startTime) {
        this.startTime = startTime;
    }

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
    @Column(name = "end_time")
    public Date getEndTime() {
        return endTime;
    }

    public void setEndTime(Date endTime) {
        this.endTime = endTime;
    }

    public String getInfo() {
        return info;
    }

    public void setInfo(String info) {
        this.info = info;
    }

    public String getContent() {
        return content;
    }

    public void setContent(String content) {
        this.content = content;
    }

    public Integer getParticipantsType() {
        return participantsType;
    }

    public void setParticipantsType(Integer participantsType) {
        this.participantsType = participantsType;
    }

    public String getParticipantsArea() {
        return participantsArea;
    }

    public void setParticipantsArea(String participantsArea) {
        this.participantsArea = participantsArea;
    }

    public String getParticipantsCode() {
        return participantsCode;
    }

    public void setParticipantsCode(String participantsCode) {
        this.participantsCode = participantsCode;
    }
}
