package com.yihu.jw.entity.hospital.message;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.yihu.jw.entity.UuidIdentityEntity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.util.Date;

/**
 * @author zmk
 * @vsrsion 1.0
 * Created at 2019/11/13
 */
@Entity
@Table(name = "base_system_message")
public class SystemMessageDO extends UuidIdentityEntity {

    /**
     *消息类型 上门服务400开头，生活照料500开头 ,安防监控600开头, 上门辅导700开头,紧急救助800开头
     * 人文关怀系统消息 41
     * 体征设备测量系统消息 42
     * 设备离线系统消息 43   推送给家属 社工  助老员
     * 监护确认消息 44
     * 家属紧急预警系统消息 50
     * 新生儿在线咨询 850
     * 老人在线咨询 851
     * 老人健康咨询 852
     *
     * 智能手表佩戴提示 991
     * 智能手表电量提示 992
     * 报警器电量提示 993
     * 设备离线提示 994   推送给 老人Pad
     * 天气预报 995
     * 整点定时发送 996
     * 人工手动系统推送 999
     *
     * 类型详情见 base_system_message_type
     */
    /** type
     *  消息类型（1.是家庭签约信息  2.体征消息  3分配健管师 4.随访提醒 5.咨询回复提醒,6.续方咨询待审核提醒,7.续方消息待取药
     *  8.续方支付成功后团队长分配健管师,9线下调整完成,10意见反馈 11账号申诉，12.协同服务 13.孕检提醒 14.文章提交审核消息  15、健康文章审核结果
     *  16.专科医生申请签约消息,17、家庭医生转诊预约消息,18、专科医生共管通知，:19 受理提醒，20 待办工作提醒 21 服务进展提醒-已完成 22 服务进展提醒-未完成
     *  23 服务进展提醒-待完成 24 收到协同任务 25 在线助手已接收 26 在线助手已退回 27 协同服务已完成  28 居民生日提醒 29 康复计划-中止消息 30 健康文章审核不通过
     *  31 在线复诊咨询待审核提醒 33 续方支付完成提醒医生 34 远程协诊提醒医生 35疾病筛查通知 36康复下转居民推送提醒
     *  101患者申请取消签约、102患者同意取消签约、103患者拒绝取消签约、104患者填写了血糖记录、105患者填写了血压记录、106患者填写了体重记录、
     *  107患者填写了腰围记录、108患者填写了运动记录、109患者填写了用药记录、110患者填写了饮食记录、111患者提交了问卷随访、112请求添加好友消息、
     *  113入群消息、114群解散消息、115踢出群消息、116新的网络咨询、117网络咨询追问、
     *  201医生拒绝签约、202医生同意签约、203医生申请取消签约、204医生同意取消签约、205医生拒绝取消签约、206新的问卷随访、207新的健康干预、
     *  208请求添加好友消息、209入群消息、210群解散消息、211踢出群消息、212聊天消息提醒、213群聊天消息、214医生回复了网络咨询、215请求添加为家人）
     *	301解绑消息 302解绑审核消息
     * 	401居民资质审核-调度员
     * 上门服务工单- 首页 -调度员：
     * 			402 服务工单派单（新增预约）403 代预约服务工单重新派单
     * 			404 服务工单拒单待重新派单
     * 上门服务工单-医生：
     * 			407 服务工单待接单
     * 上门服务工单-派单-实时工单消息-调度员：
     *          430 居民提交工单申请                -- 张三提交了服务工单12345678申请
     *          431 调度员派单（派给本社区医生）      -- 李四已将服务工单12345678指派给王五医生
     *          432 调度员拒单                      -- 李四拒绝了张三的服务工单12345678
     *          433 调度员派单（转给其他机构）        -- 李四已将服务工单12345678]转给中山医院
     *          434 医生接单                        -- 王五接受了服务工单12345678
     *          435 医生拒单                        -- 王五拒绝了服务工单12345678
     *          408居民资质审核-家医
     *          409 ca认证消息
     *  500 发起协同门诊
     *  600 病情跟踪
     */
    private String type;
    /**
     *消息标题
     */
    private String title;
    /**
     *消息发送者
     */
    private String sender;
    /**
     *发送者名称
     */
    private String senderName;
    /**
     *消息接收者
     */
    private String receiver;
    /**
     *接收者名称
     */
    private String receiverName;
    /**
     *业务关联code
     */
    private String relationCode;
    /**
     *拓展json字段
     */
    private String data;
    /**
     *是否已读
     */
    private String isRead;
    /**
     *是否删除
     */
    private String del;
    private String over;//是否操作结束 是否操作结束 1否，0是
    /**
     *已读时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
    private Date readTime;
    /**
     *创建时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
    private Date createTime;

    private String content;
    private Integer state;
    private Integer readonly;
    private String reason;
    private String code;
    private String senderPhoto;
    private String audioUrl; //音频地址

    private String prescriptionStatus;//type=6续方审核状态 0待审核，1审核通过，2审核失败，3居民取消|type=7续方状态 0待取药，1已取药


    @Column(name = "audio_url")
    public String getAudioUrl() {
        return audioUrl;
    }

    public void setAudioUrl(String audioUrl) {
        this.audioUrl = audioUrl;
    }

    @Column(name = "content")
    public String getContent() {
        return content;
    }

    public void setContent(String content) {
        this.content = content;
    }
    @Column(name = "state")
    public Integer getState() {
        return state;
    }

    public void setState(Integer state) {
        this.state = state;
    }
    @Column(name = "readonly")
    public Integer getReadonly() {
        return readonly;
    }

    public void setReadonly(Integer readonly) {
        this.readonly = readonly;
    }
    @Column(name = "reason")
    public String getReason() {
        return reason;
    }

    public void setReason(String reason) {
        this.reason = reason;
    }
    @Column(name = "sender_photo")
    public String getSenderPhoto() {
        return senderPhoto;
    }

    public void setSenderPhoto(String senderPhoto) {
        this.senderPhoto = senderPhoto;
    }

    @Column(name = "type")
    public String getType() {
        return type;
    }
    public void setType(String type) {
        this.type = type;
    }

    @Column(name = "title")
    public String getTitle() {
        return title;
    }
    public void setTitle(String title) {
        this.title = title;
    }

    @Column(name = "sender")
    public String getSender() {
        return sender;
    }
    public void setSender(String sender) {
        this.sender = sender;
    }

    @Column(name = "sender_name")
    public String getSenderName() {
        return senderName;
    }
    public void setSenderName(String senderName) {
        this.senderName = senderName;
    }

    @Column(name = "receiver")
    public String getReceiver() {
        return receiver;
    }
    public void setReceiver(String receiver) {
        this.receiver = receiver;
    }

    @Column(name = "receiver_name")
    public String getReceiverName() {
        return receiverName;
    }
    public void setReceiverName(String receiverName) {
        this.receiverName = receiverName;
    }

    @Column(name = "relation_code")
    public String getRelationCode() {
        return relationCode;
    }
    public void setRelationCode(String relationCode) {
        this.relationCode = relationCode;
    }

    @Column(name = "data")
    public String getData() {
        return data;
    }
    public void setData(String data) {
        this.data = data;
    }

    @Column(name = "is_read")
    public String getIsRead() {
        return isRead;
    }
    public void setIsRead(String isRead) {
        this.isRead = isRead;
    }

    @Column(name = "del")
    public String getDel() {
        return del;
    }
    public void setDel(String del) {
        this.del = del;
    }

    @Column(name = "read_time")
    public Date getReadTime() {
        return readTime;
    }
    public void setReadTime(Date readTime) {
        this.readTime = readTime;
    }

    @Column(name = "create_time")
    public Date getCreateTime() {
        return createTime;
    }
    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Column(name = "is_over")
    public String getOver() {
        return over;
    }

    public void setOver(String over) {
        this.over = over;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getPrescriptionStatus() {
        return prescriptionStatus;
    }

    public void setPrescriptionStatus(String prescriptionStatus) {
        this.prescriptionStatus = prescriptionStatus;
    }
}
