package com.yihu.jw.entity.hospital.prescription;

import com.yihu.jw.entity.UuidIdentityEntityWithCreateTime;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.util.List;

/**
 * 居民用药计划
 * Created by yeshijie on 2022/11/24.
 */
@Entity
@Table(name = "base_drugs_plan")
public class BaseDrugsPlanDO extends UuidIdentityEntityWithCreateTime {

    private String title;//标题默认 用药计划',
    private String patient;
    private String patientName;
    private String doctor;
    private String doctorName;
    private String type;//关联类型 1处方
    private String relationId;//关联id

    //用药明细
    private List<BaseDrugsPlanDetailDO> detailList;

    @Column(name = "title")
    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    @Column(name = "patient")
    public String getPatient() {
        return patient;
    }

    public void setPatient(String patient) {
        this.patient = patient;
    }

    @Column(name = "patient_name")
    public String getPatientName() {
        return patientName;
    }

    public void setPatientName(String patientName) {
        this.patientName = patientName;
    }

    @Column(name = "doctor")
    public String getDoctor() {
        return doctor;
    }

    public void setDoctor(String doctor) {
        this.doctor = doctor;
    }

    @Column(name = "doctor_name")
    public String getDoctorName() {
        return doctorName;
    }

    public void setDoctorName(String doctorName) {
        this.doctorName = doctorName;
    }

    @Column(name = "type")
    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    @Column(name = "relation_id")
    public String getRelationId() {
        return relationId;
    }

    public void setRelationId(String relationId) {
        this.relationId = relationId;
    }

    @Transient
    public List<BaseDrugsPlanDetailDO> getDetailList() {
        return detailList;
    }

    public void setDetailList(List<BaseDrugsPlanDetailDO> detailList) {
        this.detailList = detailList;
    }
}
