package com.yihu.jw.entity.hospital.prescription;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.yihu.jw.entity.IdEntity;

import javax.persistence.*;
import java.util.Date;

/**
 * 续方咨询随访问卷表
 * @author huangwenjie
 * @date 2017/11/1 12:05
 */
@Entity
@Table(name = "wlyy_prescription_followup_content")
@SequenceGenerator(name="id_generated", sequenceName="wlyy_prescription_followup_content")
public class PrescriptionFollowupContent extends IdEntity {
	private String code;
	private String prescriptionCode;  //续方COE
	private String followupId;        //随访记录ID
	private String followupProject;   //随访问卷详情类型ID（目前有1-10，和随访信息详情分类一致）
	private String followupKey;       //随访问卷详情指标KEY（和随访记录一致）
	private String followupValue;     //随访问卷详情指标值（和随访记录一致）
	private String patientCode;       //患者CODE
	private Date createTime;
	
	@Basic
	@Column(name = "code")
	public String getCode() {
		return code;
	}
	
	public void setCode(String code) {
		this.code = code;
	}
	
	@Basic
	@Column(name = "prescription_code")
	public String getPrescriptionCode() {
		return prescriptionCode;
	}
	
	public void setPrescriptionCode(String prescriptionCode) {
		this.prescriptionCode = prescriptionCode;
	}
	
	@Basic
	@Column(name = "followup_id")
	public String getFollowupId() {
		return followupId;
	}
	
	public void setFollowupId(String followupId) {
		this.followupId = followupId;
	}
	
	@Basic
	@Column(name = "followup_project")
	public String getFollowupProject() {
		return followupProject;
	}
	
	public void setFollowupProject(String followupProject) {
		this.followupProject = followupProject;
	}
	
	@Basic
	@Column(name = "followup_key")
	public String getFollowupKey() {
		return followupKey;
	}
	
	public void setFollowupKey(String followupKey) {
		this.followupKey = followupKey;
	}
	
	@Basic
	@Column(name = "followup_value")
	public String getFollowupValue() {
		return followupValue;
	}
	
	public void setFollowupValue(String followupValue) {
		this.followupValue = followupValue;
	}
	
	@Basic
	@Column(name = "create_time")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
	public Date getCreateTime() {
		return createTime;
	}
	
	public void setCreateTime(Date createTime) {
		this.createTime = createTime;
	}
	
	@Basic
	@Column(name = "patient_code")
	public String getPatientCode() {
		return patientCode;
	}
	
	public void setPatientCode(String patientCode) {
		this.patientCode = patientCode;
	}
}
