package com.yihu.jw.entity.hospital.prescription;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.yihu.jw.entity.UuidIdentityEntity;

import javax.persistence.Entity;
import javax.persistence.Table;
import java.util.Date;


/**
* 处方流程步骤记录表实体
*
* @author Administrator on  2019年05月16日
*
*/
@Entity
@Table(name = "wlyy_prescription_log")
public class WlyyPrescriptionLogDO extends UuidIdentityEntity {

    public enum PrescriptionLogType {
        zy("智业对接", 1),
        ylz("易联众对接", 2),
        create("创建处方", 3),
        reviewed("审核", 4),
        pay("支付", 5),
        expressage("配送", 6),
        finish("已完成", 7),
        sf("顺丰对接", 8),
        patientConfirm("居民确认收药", 9),
        jobConfirm("系统确认收药", 10);
        private String name;
        private int value;

        PrescriptionLogType(String name, int value) {
            this.name = name;
            this.value = value;
        }

        public String getName() {
            return name;
        }

        public void setName(String name) {
            this.name = name;
        }

        public int getValue() {
            return value;
        }

        public void setValue(int value) {
            this.value = value;
        }
    }

    //状态枚举
    public enum PrescriptionLogStatus {

        pay_cancle("线下取消",-5),

        pay_refund("线下退费",-4),
        //续方取消
        pay_outtime("支付超时", -3),
        patient_canel("患者自己取消", -2),

        // 审核不通过
        no_reviewed("审核不通过", -1),

        //审核中
        revieweding("待审核", 0),
        changeing("调整中", 2),
        change_success("调整成功",3),
        change_error("调整失败",4),
        reviewed_success(" 医生审核(CA)通过", 10),

        //药师审核中
        Pharmacist_examination("药师审核中",20),
        Pharmacist_examination_error("药师审核失败",21),

        //开方中/药师审核成功
        adding("开方中/药师审核成功",30),
        add_error("开方失败",31),

        //待支付
        wait_pay("开方完成/待支付", 40),
        pay_error("支付失败", 41),

        //配药中
        pay_success("支付成功/待配药", 50),

        //等待领药
        wait_expressage("配药成功/待配送", 60),

        //配送中
        expressageing_error("配送失败", 61),
        expressageJGS("分配健管师", 62),
        expressageing("配送中", 65),
        expressage2hospital("配送到服务站", 69),

        //已完成
        finish("配送到患者手中/已完成", 100);

        private String name;
        private int value;

        PrescriptionLogStatus(String name, int value) {
            this.name = name;
            this.value = value;
        }

        public String getName() {
            return name;
        }

        public void setName(String name) {
            this.name = name;
        }

        public int getValue() {
            return value;
        }

        public void setValue(int value) {
            this.value = value;
        }
    }

    private String outpatientId;//
    private String prescriptionCode;//处方code 关联表wlyy_prescription id',
    private String datajson;//附加信息展示字段',
    private Integer status;//续方取消：-3 支付过期取消，-2 患者自己取消 ，-1 医生取消 ;候诊中：0 候诊中;就诊中：10 诊断中，11 药师审核失败 / 调整中，12  药师审核完成，13  开方失败/调整中;待支付：20 诊断完成/开方成功/待支付，21 支付失败/待支付中;待取药：30 支付成功/等待配药，31 配药成功/等待取药，32 配送中;已完成：100 已完成',
    private Integer userType;//1 患者 2医生',
    private String userCode;//医生或者患者code',
    private String userName;//医生或者患者name',
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
    private Date createTime;//创建时间',

    public String getOutpatientId() {
        return outpatientId;
    }

    public void setOutpatientId(String outpatientId) {
        this.outpatientId = outpatientId;
    }

    public String getPrescriptionCode() {
        return prescriptionCode;
    }

    public void setPrescriptionCode(String prescriptionCode) {
        this.prescriptionCode = prescriptionCode;
    }

    public String getDatajson() {
        return datajson;
    }

    public void setDatajson(String datajson) {
        this.datajson = datajson;
    }

    public Integer getStatus() {
        return status;
    }

    public void setStatus(Integer status) {
        this.status = status;
    }

    public Integer getUserType() {
        return userType;
    }

    public void setUserType(Integer userType) {
        this.userType = userType;
    }

    public String getUserCode() {
        return userCode;
    }

    public void setUserCode(String userCode) {
        this.userCode = userCode;
    }

    public String getUserName() {
        return userName;
    }

    public void setUserName(String userName) {
        this.userName = userName;
    }

    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }
}