package com.yihu.jw.entity.hospital.team;

import com.fasterxml.jackson.annotation.JsonFormat;

import com.yihu.jw.entity.IdEntity;
import org.apache.commons.lang3.builder.ToStringBuilder;
import org.springframework.stereotype.Component;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.util.Date;

/**
 * 医生行政团队。
 *
 * @author Sand
 */
@Component
@Entity
@Table(name = "wlyy_admin_team")
public class WlyyAdminTeamDO extends IdEntity {
    private String name;
    private Date createTime;
    private String leaderCode;
    private boolean available;
    private String orgCode;
    private String orgName;
    private String townCode;
    private String townName;
    private String mappingCode;
    private String specialCode;
    private String specialName;
    private String phone;//团队电话
    private String phoneStatus;//是否对外开放电话 1是0否
    private Integer acceptType;//是否接受下转 0接受 1拒绝
    private String signLimit;//签约上限

    public String getName() {
        return name;
    }

    @Column(name = "name")
    public void setName(String name) {
        this.name = name;
    }

    @JsonFormat(pattern = "yyyy-MM-dd hh:mm", timezone = "GMT+08:00")
    public Date getCreateTime() {
        return createTime;
    }

    @Column(name = "create_time")
    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    public String getOrgCode() {
        return orgCode;
    }

    @Column(name = "org_code")
    public void setOrgCode(String orgCode) {
        this.orgCode = orgCode;
    }

    @Override
    public String toString() {
        return ToStringBuilder.reflectionToString(this);
    }

    public String getLeaderCode() {
        return leaderCode;
    }

    @Column(name = "leader_id")
    public void setLeaderCode(String leaderCode) {
        this.leaderCode = leaderCode;
    }

    public boolean isAvailable() {
        return available;
    }

    @Column(name = "available")
    public void setAvailable(boolean available) {
        this.available = available;
    }

    @Column(name = "mapping_code")
    public String getMappingCode() {
        return mappingCode;
    }

    public void setMappingCode(String mappingCode) {
        this.mappingCode = mappingCode;
    }

    @Transient
    public String getOrgName() {
        return orgName;
    }

    public void setOrgName(String orgName) {
        this.orgName = orgName;
    }

    @Transient
    public String getTownCode() {
        return townCode;
    }

    public void setTownCode(String townCode) {
        this.townCode = townCode;
    }

    @Transient
    public String getTownName() {
        return townName;
    }

    public void setTownName(String townName) {
        this.townName = townName;
    }

    public String getSpecialCode() {
        return specialCode;
    }

    public void setSpecialCode(String specialCode) {
        this.specialCode = specialCode;
    }

    public String getSpecialName() {
        return specialName;
    }

    public void setSpecialName(String specialName) {
        this.specialName = specialName;
    }
    @Column(name = "accept_type")
    public Integer getAcceptType() {
        return acceptType;
    }

    public void setAcceptType(Integer acceptType) {
        this.acceptType = acceptType;
    }

    public String getPhone() {
        return phone;
    }

    public void setPhone(String phone) {
        this.phone = phone;
    }

    @Column(name = "phone_status")
    public String getPhoneStatus() {
        return phoneStatus;
    }

    public void setPhoneStatus(String phoneStatus) {
        this.phoneStatus = phoneStatus;
    }

    @Column(name = "sign_limit")
    public String getSignLimit() {
        return signLimit;
    }

    public void setSignLimit(String signLimit) {
        this.signLimit = signLimit;
    }
}
