package com.yihu.jw.entity.knowledge;

import com.yihu.jw.entity.UuidIdentityEntityWithOperator;

import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.util.List;

/**
 * 知识库-字典
 * @wangzhinan
 *
 */
@Entity
@Table(name = "base_knowledge_dict")
public class BaseKnowledgeDict extends UuidIdentityEntityWithOperator {

	private String type;//所属分类关联字典wlyy_hospital_sys_dict（dictTypeDict） {"disease":"疾病症状"}
	private String name; //名称
	private String description; //描述
	private Integer status;//1已设置0未设置
	private Integer sort;//排序
	private Integer del;//0删除1正常


	private List<BaseKnowledgeDictRelation> dictRelations;

	@Transient
	public List<BaseKnowledgeDictRelation> getDictRelations() {
		return dictRelations;
	}

	public void setDictRelations(List<BaseKnowledgeDictRelation> dictRelations) {
		this.dictRelations = dictRelations;
	}

	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public Integer getStatus() {
		return status;
	}

	public void setStatus(Integer status) {
		this.status = status;
	}

	public Integer getSort() {
		return sort;
	}

	public void setSort(Integer sort) {
		this.sort = sort;
	}

	public Integer getDel() {
		return del;
	}

	public void setDel(Integer del) {
		this.del = del;
	}
}