package com.yihu.jw.entity.knowledge;

import com.yihu.jw.entity.UuidIdentityEntityWithOperator;

import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.util.Date;

/**
 * 流程配置关联关系
 *
 * @wangzhinan
 */
@Entity
@Table(name = "base_knowledge_flow_configuration_relation")
public class BaseKnowledgeFlowConfigurationRelation extends UuidIdentityEntityWithOperator {

    private String questionId;//问题id
    private String relationType;//关联类型（1常见问题、2字典中心、3问题集）
    private String relationCode;//关联code
    private String relationName;//关联名称

    private Integer sort;//排序

    private Integer status;//1开启0关闭

    private BaseKnowledgeQuestion question;//常见问题

    private BaseKnowledgeDict dict;//问题字典

    private BaseKnowledgeQuestions questions;//问题集


    public String getRelationName() {
        return relationName;
    }

    public void setRelationName(String relationName) {
        this.relationName = relationName;
    }

    public Integer getStatus() {
        return status;
    }

    public void setStatus(Integer status) {
        this.status = status;
    }

    @Transient
    public BaseKnowledgeQuestion getQuestion() {
        return question;
    }

    public void setQuestion(BaseKnowledgeQuestion question) {
        this.question = question;
    }

    @Transient
    public BaseKnowledgeDict getDict() {
        return dict;
    }

    public void setDict(BaseKnowledgeDict dict) {
        this.dict = dict;
    }

    @Transient
    public BaseKnowledgeQuestions getQuestions() {
        return questions;
    }

    public void setQuestions(BaseKnowledgeQuestions questions) {
        this.questions = questions;
    }

    public String getQuestionId() {
        return questionId;
    }

    public void setQuestionId(String questionId) {
        this.questionId = questionId;
    }

    public String getRelationType() {
        return relationType;
    }

    public void setRelationType(String relationType) {
        this.relationType = relationType;
    }

    public String getRelationCode() {
        return relationCode;
    }

    public void setRelationCode(String relationCode) {
        this.relationCode = relationCode;
    }

    public Integer getSort() {
        return sort;
    }

    public void setSort(Integer sort) {
        this.sort = sort;
    }
}