package com.yihu.jw.entity.knowledge;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.yihu.jw.entity.UuidIdentityEntityWithOperator;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.util.Date;

/**
 * 常见问题
 * @wangzhinan
 */
@Entity
@Table(name = "base_knowledge_question")
public class BaseKnowledgeQuestion extends UuidIdentityEntityWithOperator {

	private String type;//所属分类关联字典wlyy_hospital_sys_dict（questionTypeDict）
	private String questionName; //标准问题
	private String similarQuestionName; //相似问题
	private String answer;//答案

	private Integer flag;//是否关联（1关联0未关联）
	private Integer status;//1开启0关闭
	private Integer time;//时效（1永久有效 2自定义有效期）
	private Date date;//时间
	private Integer sort;//排序
	private Integer del;//0删除1正常

	public Integer getFlag() {
		return flag;
	}

	public void setFlag(Integer flag) {
		this.flag = flag;
	}

	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}

	public String getQuestionName() {
		return questionName;
	}

	public void setQuestionName(String questionName) {
		this.questionName = questionName;
	}

	public String getSimilarQuestionName() {
		return similarQuestionName;
	}

	public void setSimilarQuestionName(String similarQuestionName) {
		this.similarQuestionName = similarQuestionName;
	}

	public String getAnswer() {
		return answer;
	}

	public void setAnswer(String answer) {
		this.answer = answer;
	}

	public Integer getStatus() {
		return status;
	}

	public void setStatus(Integer status) {
		this.status = status;
	}

	public Integer getTime() {
		return time;
	}

	public void setTime(Integer time) {
		this.time = time;
	}

	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
	@Column(name = "date", nullable = false, length = 0)
	public Date getDate() {
		return date;
	}

	public void setDate(Date date) {
		this.date = date;
	}

	public Integer getSort() {
		return sort;
	}

	public void setSort(Integer sort) {
		this.sort = sort;
	}

	public Integer getDel() {
		return del;
	}

	public void setDel(Integer del) {
		this.del = del;
	}
}