package com.yihu.jw.entity.knowledge;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.yihu.jw.entity.UuidIdentityEntityWithOperator;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.util.Date;
import java.util.List;

/**
 * 问题集
 *
 * @wangzhinan
 */
@Entity
@Table(name = "base_knowledge_questions")
public class BaseKnowledgeQuestions extends UuidIdentityEntityWithOperator {

	private String businessType;//业务类型wlyy_hospital_sys_dict（businessTypeDict）
	private String questionsName; //问题集名称
	private Integer count; //问题数量
	private String description;//问题集描述
	private Integer status;//1开启0关闭
	private Integer time;//时效（1永久有效 2自定义有效期）
	private Date date;//时间
	private Integer sort;//排序
	private Integer del;//0删除1正常

	private List<BaseKnowledgeQuestionsRelation> questionsRelations;

	@Transient
	public List<BaseKnowledgeQuestionsRelation> getQuestionsRelations() {
		return questionsRelations;
	}

	public void setQuestionsRelations(List<BaseKnowledgeQuestionsRelation> questionsRelations) {
		this.questionsRelations = questionsRelations;
	}

	public String getBusinessType() {
		return businessType;
	}

	public void setBusinessType(String businessType) {
		this.businessType = businessType;
	}

	public String getQuestionsName() {
		return questionsName;
	}

	public void setQuestionsName(String questionsName) {
		this.questionsName = questionsName;
	}

	public Integer getCount() {
		return count;
	}

	public void setCount(Integer count) {
		this.count = count;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}

	public Integer getStatus() {
		return status;
	}

	public void setStatus(Integer status) {
		this.status = status;
	}

	public Integer getTime() {
		return time;
	}

	public void setTime(Integer time) {
		this.time = time;
	}

	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
	@Column(name = "date", nullable = false, length = 0)
	public Date getDate() {
		return date;
	}

	public void setDate(Date date) {
		this.date = date;
	}

	public Integer getSort() {
		return sort;
	}

	public void setSort(Integer sort) {
		this.sort = sort;
	}

	public Integer getDel() {
		return del;
	}

	public void setDel(Integer del) {
		this.del = del;
	}
}