package com.yihu.jw.entity.knowledge;

import com.yihu.jw.entity.UuidIdentityEntityWithOperator;
import com.yihu.jw.entity.vo.DictVO;

import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.util.List;

/**
 * 系统会话设置
 * @wangzhinan
 *
 */
@Entity
@Table(name = "base_system_dialog_setting")
public class BaseSystemDialogSetting extends UuidIdentityEntityWithOperator {

	private String systemType;//系统业务类型（字典systemBusinessType）//{"1":"在线导诊","2":"专属服务引导","3":"在线候诊室","4":"在线候诊"}
	private String systemName;//系统业务名称
	private String functionType;//业务类型（字典 sessionFunctionType）//{"1":"欢迎消息","2":"欢迎消息关联问题","3":"客服无应答时消息","4":"用户无应答时消息","5":"会话结束","6":"系统自动结束会话","7":"系统自动回复"}
	private String functionName;//业务名称
	private Integer flag;//1开0关
	private Integer relationType;//1关联文本（对应content）2关联业务（对应relaitonCode）
	private Integer relaitonCodeType;//1常见问题2字典中心3问题集
	private String relationCode;//relationType2对应业务code，多个逗号隔开
	private String content;//文本
	private String time;//超时时间

	private String timeUnit;//时间单位code（字典timeUnitDict）
	private List<BaseKnowledgeQuestion> questions;//问题列表
	private List<BaseKnowledgeQuestions> questionsList;//问题集列表
	private List<DictVO> dictList;//字典列表

	public String getTimeUnit() {
		return timeUnit;
	}

	public void setTimeUnit(String timeUnit) {
		this.timeUnit = timeUnit;
	}

	@Transient
	public List<BaseKnowledgeQuestion> getQuestions() {
		return questions;
	}

	public void setQuestions(List<BaseKnowledgeQuestion> questions) {
		this.questions = questions;
	}

	@Transient
	public List<BaseKnowledgeQuestions> getQuestionsList() {
		return questionsList;
	}

	public void setQuestionsList(List<BaseKnowledgeQuestions> questionsList) {
		this.questionsList = questionsList;
	}

	@Transient
	public List<DictVO> getDictList() {
		return dictList;
	}

	public void setDictList(List<DictVO> dictList) {
		this.dictList = dictList;
	}

	public String getSystemType() {
		return systemType;
	}

	public void setSystemType(String systemType) {
		this.systemType = systemType;
	}

	public String getSystemName() {
		return systemName;
	}

	public void setSystemName(String systemName) {
		this.systemName = systemName;
	}

	public String getFunctionType() {
		return functionType;
	}

	public void setFunctionType(String functionType) {
		this.functionType = functionType;
	}

	public String getFunctionName() {
		return functionName;
	}

	public void setFunctionName(String functionName) {
		this.functionName = functionName;
	}

	public Integer getFlag() {
		return flag;
	}

	public void setFlag(Integer flag) {
		this.flag = flag;
	}

	public Integer getRelationType() {
		return relationType;
	}

	public void setRelationType(Integer relationType) {
		this.relationType = relationType;
	}

	public Integer getRelaitonCodeType() {
		return relaitonCodeType;
	}

	public void setRelaitonCodeType(Integer relaitonCodeType) {
		this.relaitonCodeType = relaitonCodeType;
	}

	public String getRelationCode() {
		return relationCode;
	}

	public void setRelationCode(String relationCode) {
		this.relationCode = relationCode;
	}

	public String getContent() {
		return content;
	}

	public void setContent(String content) {
		this.content = content;
	}

	public String getTime() {
		return time;
	}

	public void setTime(String time) {
		this.time = time;
	}
}