package com.yihu.jw.entity.specialist;

import com.yihu.jw.entity.UuidIdentityEntityWithOperator;



import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.util.List;
import java.util.Map;

/**
 * @author wangzhinan
 * @create 2023-05-15
 * @desc 专病中心
 **/
@Entity
@Table(name = "base_disease_hospital")
public class BaseDiseaseHospitalDO extends UuidIdentityEntityWithOperator {

    private String name;//专病名称
    private String photo;//专病图标
    private String banner;//专病主图
    private String description;//专病描述
    private Integer status;//1启动0禁止
    private String dept;//关联科室逗号隔开
    private String deptName;//关联科室名称逗号隔开
    private String diagnosis;//诊断编码逗号隔开
    private String diagnosisName;//诊断名称逗号隔开
    private Integer isDisease;//是否开通专病教育频道(0未开通1开通)
    private String articleRelation;//文章关联
    private String articleRelationName;//文章标题关联
    private Integer isFamily;//是否关联三师共管专病(1是0否)
    private String familyRelation;//关联专病code

    private String familyRelationName;//关联专病名称

    private Integer sort;//排序

    private List<Map<String,Object>> articleRelationList;//文章关联列表

    /**
     * 新增字段
     */
    private String rehabilitationType;// '是否开通诊后康复 0否 1是'
    private String rehabilitationDownType;//康复下转 0自动 1手动
    private String rehabilitationTemplateId;//康复计划模板id

    public String getRehabilitationType() {
        return rehabilitationType;
    }

    public void setRehabilitationType(String rehabilitationType) {
        this.rehabilitationType = rehabilitationType;
    }

    public String getRehabilitationDownType() {
        return rehabilitationDownType;
    }

    public void setRehabilitationDownType(String rehabilitationDownType) {
        this.rehabilitationDownType = rehabilitationDownType;
    }

    public String getRehabilitationTemplateId() {
        return rehabilitationTemplateId;
    }

    public void setRehabilitationTemplateId(String rehabilitationTemplateId) {
        this.rehabilitationTemplateId = rehabilitationTemplateId;
    }

    @Transient
    public List<Map<String, Object>> getArticleRelationList() {
        return articleRelationList;
    }

    public void setArticleRelationList(List<Map<String, Object>> articleRelationList) {
        this.articleRelationList = articleRelationList;
    }

    @Override
    public String getId() {
        return id;
    }

    @Override
    public void setId(String id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getPhoto() {
        return photo;
    }

    public void setPhoto(String photo) {
        this.photo = photo;
    }

    public String getBanner() {
        return banner;
    }

    public void setBanner(String banner) {
        this.banner = banner;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public Integer getStatus() {
        return status;
    }

    public void setStatus(Integer status) {
        this.status = status;
    }

    public String getDept() {
        return dept;
    }

    public void setDept(String dept) {
        this.dept = dept;
    }

    public String getDeptName() {
        return deptName;
    }

    public void setDeptName(String deptName) {
        this.deptName = deptName;
    }

    public String getDiagnosis() {
        return diagnosis;
    }

    public void setDiagnosis(String diagnosis) {
        this.diagnosis = diagnosis;
    }

    public String getDiagnosisName() {
        return diagnosisName;
    }

    public void setDiagnosisName(String diagnosisName) {
        this.diagnosisName = diagnosisName;
    }

    public Integer getIsDisease() {
        return isDisease;
    }

    public void setIsDisease(Integer isDisease) {
        this.isDisease = isDisease;
    }

    public String getArticleRelation() {
        return articleRelation;
    }

    public void setArticleRelation(String articleRelation) {
        this.articleRelation = articleRelation;
    }

    public Integer getIsFamily() {
        return isFamily;
    }

    public void setIsFamily(Integer isFamily) {
        this.isFamily = isFamily;
    }

    public String getFamilyRelation() {
        return familyRelation;
    }

    public void setFamilyRelation(String familyRelation) {
        this.familyRelation = familyRelation;
    }

    public Integer getSort() {
        return sort;
    }

    public void setSort(Integer sort) {
        this.sort = sort;
    }

    public String getArticleRelationName() {
        return articleRelationName;
    }

    public void setArticleRelationName(String articleRelationName) {
        this.articleRelationName = articleRelationName;
    }

    public String getFamilyRelationName() {
        return familyRelationName;
    }

    public void setFamilyRelationName(String familyRelationName) {
        this.familyRelationName = familyRelationName;
    }
}
