package com.yihu.jw.entity.specialist.rehabilitation;


import com.yihu.jw.entity.UuidIdentityEntityWithOperatorAES;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.io.Serializable;
import java.util.List;

/**
 * Created by humingfen on 2018/8/15.
 */
@Entity
@Table(name = "wlyy_rehabilitation_plan_template")
public class RehabilitationPlanTemplateDO extends UuidIdentityEntityWithOperatorAES implements Serializable {

    @Column(name = "saas_id")
    private String saasId;

    @Column(name = "title")
    private String title;//模板名称

    @Column(name = "hospital")
    private String hospital;//医院标识

    @Column(name = "hospital_name")
    private String hospitalName;//医院名称

    @Column(name = "admin_team_code")
    private Long adminTeamCode;//行政团队id

    @Column(name = "del")
    private Integer del;//是否删除（0是，1否）

    /**
     * 新增字段
     */
//    @Column(name = "disease_id")
    private String diseaseId;//病种code

//    @Column(name = "disease_name")
    private String diseaseName;

    @Column(name = "status")
    private String status;

    @Column(name = "type")
    private String type;//1表示模板，2表示计划
    @Column(name = "plan_doctor")
    private String planDoctor;//康复计划负责人
    @Column(name = "plan_doctor_name")
    private String planDoctorName;//康复计划负责人姓名
    //---------------------------------


    //非数据库字段
    private Integer isFamily;//是否关联三师共管专病(1是0否)
    private String familyRelation;//关联专病code
    private List<RehabilitationTemplateDetailDO> detailDOList;

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public String getStatus() {
        return status;
    }

    public void setStatus(String status) {
        this.status = status;
    }

    @Column(name = "saas_id")
    public String getSaasId() {
        return saasId;
    }


    @Transient
    public String getDiseaseId() {
        return diseaseId;
    }

    public void setDiseaseId(String diseaseId) {
        this.diseaseId = diseaseId;
    }

    @Transient
    public String getDiseaseName() {
        return diseaseName;
    }

    public void setDiseaseName(String diseaseName) {
        this.diseaseName = diseaseName;
    }

    public void setSaasId(String saasId) {
        this.saasId = saasId;
    }

    @Column(name = "title")
    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    @Column(name = "hospital")
    public String getHospital() {
        return hospital;
    }

    public void setHospital(String hospital) {
        this.hospital = hospital;
    }

    @Column(name = "hospital_name")
    public String getHospitalName() {
        return hospitalName;
    }

    public void setHospitalName(String hospitalName) {
        this.hospitalName = hospitalName;
    }

    @Column(name = "admin_team_code")
    public Long getAdminTeamCode() {
        return adminTeamCode;
    }

    public void setAdminTeamCode(Long adminTeamCode) {
        this.adminTeamCode = adminTeamCode;
    }

    @Column(name = "del")
    public Integer getDel() {
        return del;
    }

    public void setDel(Integer del) {
        this.del = del;
    }

    @Column(name = "plan_doctor")
    public String getPlanDoctor() {
        return planDoctor;
    }

    public void setPlanDoctor(String planDoctor) {
        this.planDoctor = planDoctor;
    }

    @Column(name = "plan_doctor_name")
    public String getPlanDoctorName() {
        return planDoctorName;
    }

    public void setPlanDoctorName(String planDoctorName) {
        this.planDoctorName = planDoctorName;
    }

    @Transient
    public Integer getIsFamily() {
        return isFamily;
    }

    public void setIsFamily(Integer isFamily) {
        this.isFamily = isFamily;
    }

    @Transient
    public String getFamilyRelation() {
        return familyRelation;
    }

    public void setFamilyRelation(String familyRelation) {
        this.familyRelation = familyRelation;
    }

    @Transient
    public List<RehabilitationTemplateDetailDO> getDetailDOList() {
        return detailDOList;
    }

    public void setDetailDOList(List<RehabilitationTemplateDetailDO> detailDOList) {
        this.detailDOList = detailDOList;
    }
}
