package com.yihu.jw.entity.specialist.rehabilitation;


import com.yihu.jw.entity.UuidIdentityEntityWithOperatorAES;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.io.Serializable;

/**
 * Created by humingfen on 2018/8/15.
 */
@Entity
@Table(name = "wlyy_rehabilitation_template_detail")
public class RehabilitationTemplateDetailDO extends UuidIdentityEntityWithOperatorAES implements Serializable {

    @Column(name = "saas_id")
    private String saasId;
    @Column(name = "template_id")
    private String templateId;//康复套餐模板id
    @Column(name = "hospital_service_item_id")
    private String hospitalServiceItemId;//机构服务项目id

    private Integer type;//执行者类型（1家医，2行政团队）
    private String executeTimes;//服务项目执行时间
    private String frequencyCode;//频次
    private String frequencyName;//频次名称
    private String dateName;//日期名称
    private String dateCode;//日期code
    private Integer timeType;//时间类型
    private String remark;//备注

    private String name;//服务项名称
    private Integer expense;//费用

    /**
     * 新增字段
     */
    @Column(name = "assess_type")
    private String assessType;//是否项目评价

    @Column(name = "booking_type")
    private String bookingType;//是否预约

    @Column(name = "late_serve_type")
    private String lateServeType;//是否运行逾期服务

    @Column(name = "plan_start_time_type")
    private String planStartTimeType;//计划开始时间类型【1默认系统生成康复计划的时间、2患者就诊时间、3患者出院时间】

    @Column(name = "server_time_type")
    private String serverTimeType;//服务方法 1饭前、2饭后、3睡前

    @Column(name = "server_count")
    private String serverCount;//服务次数

    @Column(name = "pricing_units_code")
    private String pricingUnitsCode;//计价单位

    @Column(name = "pricing_units_name")
    private String pricingUnitsName;//计价单位名称

    @Column(name = "template_type")
    private String templateType;

    @Column(name = "template_code")
    private String templateCode;

    public String getTemplateType() {
        return templateType;
    }

    public void setTemplateType(String templateType) {
        this.templateType = templateType;
    }

    public String getTemplateCode() {
        return templateCode;
    }

    public void setTemplateCode(String templateCode) {
        this.templateCode = templateCode;
    }

    //-----------------------------------------------------

    public String getPricingUnitsCode() {
        return pricingUnitsCode;
    }

    public void setPricingUnitsCode(String pricingUnitsCode) {
        this.pricingUnitsCode = pricingUnitsCode;
    }

    public String getPricingUnitsName() {
        return pricingUnitsName;
    }

    public void setPricingUnitsName(String pricingUnitsName) {
        this.pricingUnitsName = pricingUnitsName;
    }

    public String getAssessType() {
        return assessType;
    }

    public void setAssessType(String assessType) {
        this.assessType = assessType;
    }

    public String getBookingType() {
        return bookingType;
    }

    public void setBookingType(String bookingType) {
        this.bookingType = bookingType;
    }

    public String getLateServeType() {
        return lateServeType;
    }

    public void setLateServeType(String lateServeType) {
        this.lateServeType = lateServeType;
    }

    public String getPlanStartTimeType() {
        return planStartTimeType;
    }

    public void setPlanStartTimeType(String planStartTimeType) {
        this.planStartTimeType = planStartTimeType;
    }

    public String getServerTimeType() {
        return serverTimeType;
    }

    public void setServerTimeType(String serverTimeType) {
        this.serverTimeType = serverTimeType;
    }

    public String getServerCount() {
        return serverCount;
    }

    public void setServerCount(String serverCount) {
        this.serverCount = serverCount;
    }

    @Column(name = "saas_id")
    public String getSaasId() {
        return saasId;
    }

    public void setSaasId(String saasId) {
        this.saasId = saasId;
    }

    @Column(name = "template_id")
    public String getTemplateId() {
        return templateId;
    }

    public void setTemplateId(String templateId) {
        this.templateId = templateId;
    }

    @Column(name = "hospital_service_item_id")
    public String getHospitalServiceItemId() {
        return hospitalServiceItemId;
    }

    public void setHospitalServiceItemId(String hospitalServiceItemId) {
        this.hospitalServiceItemId = hospitalServiceItemId;
    }

    @Column(name = "execute_times")
    public String getExecuteTimes() {
        return executeTimes;
    }

    public void setExecuteTimes(String executeTimes) {
        this.executeTimes = executeTimes;
    }

    @Column(name = "type")
    public Integer getType() {
        return type;
    }

    public void setType(Integer type) {
        this.type = type;
    }

    @Column(name = "frequency_code")
    public String getFrequencyCode() {
        return frequencyCode;
    }

    public void setFrequencyCode(String frequencyCode) {
        this.frequencyCode = frequencyCode;
    }

    @Column(name = "time_type")
    public Integer getTimeType() {
        return timeType;
    }

    public void setTimeType(Integer timeType) {
        this.timeType = timeType;
    }

    @Column(name = "remark")
    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }

    @Column(name = "frequency_name")
    public String getFrequencyName() {
        return frequencyName;
    }

    public void setFrequencyName(String frequencyName) {
        this.frequencyName = frequencyName;
    }

    @Column(name = "date_name")
    public String getDateName() {
        return dateName;
    }

    public void setDateName(String dateName) {
        this.dateName = dateName;
    }

    @Column(name = "date_code")
    public String getDateCode() {
        return dateCode;
    }

    public void setDateCode(String dateCode) {
        this.dateCode = dateCode;
    }

    @Transient
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Integer getExpense() {
        return expense;
    }

    public void setExpense(Integer expense) {
        this.expense = expense;
    }
}
