package com.yihu.jw.entity.util;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.yihu.jw.entity.IdEntity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;
import java.util.Date;

/**
 * Created by wsl on 2022/6/29
 * 杭州接口
 */

@Entity
@Table(name = "base_hz_interface_dict")
@SequenceGenerator(name="id_generated", sequenceName="seq_base_hz_interface_dict")
public class BaseHzInterfaceDictEntity extends IdEntity {

    private String url;//接口地址
    private String code;//接口code
    private String name;//接口名字
    private Integer status;//状态（1生效，0失效）
    private Date createTime;//创建时间
    private String appKey;//APP_KEY
    private String appPwd;//APP秘钥
    private String  refreshSecret;//刷新秘钥
    private Date refreshSecretEndTime;//刷新秘钥过期时间
    private String  requestSecret;//请求秘钥
    private Date requestSecretEndTime;//请求秘钥过期时间

    public String getUrl() {
        return url;
    }

    public void setUrl(String url) {
        this.url = url;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Integer getStatus() {
        return status;
    }

    public void setStatus(Integer status) {
        this.status = status;
    }

    @Column(name = "create_time")
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Column(name = "app_key")
    public String getAppKey() {
        return appKey;
    }

    public void setAppKey(String appKey) {
        this.appKey = appKey;
    }

    @Column(name = "app_pwd")
    public String getAppPwd() {
        return appPwd;
    }

    public void setAppPwd(String appPwd) {
        this.appPwd = appPwd;
    }

    @Column(name = "refresh_secret")
    public String getRefreshSecret() {
        return refreshSecret;
    }

    public void setRefreshSecret(String refreshSecret) {
        this.refreshSecret = refreshSecret;
    }

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
    @Column(name = "refresh_secret_end_time")
    public Date getRefreshSecretEndTime() {
        return refreshSecretEndTime;
    }

    public void setRefreshSecretEndTime(Date refreshSecretEndTime) {
        this.refreshSecretEndTime = refreshSecretEndTime;
    }

    @Column(name = "request_secret")
    public String getRequestSecret() {
        return requestSecret;
    }

    public void setRequestSecret(String requestSecret) {
        this.requestSecret = requestSecret;
    }

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
    @Column(name = "request_secret_end_time")
    public Date getRequestSecretEndTime() {
        return requestSecretEndTime;
    }

    public void setRequestSecretEndTime(Date requestSecretEndTime) {
        this.requestSecretEndTime = requestSecretEndTime;
    }
}
