package com.yihu.jw.rm.base;

/**
 * Created by chenweida on 2017/5/19.
 * 基础模块的静态变量
 */
public class BaseRequestMapping {

    @Deprecated
    public static final String api_base_common = "/svr-bases";

    /**
     * 基础请求地址
     */
    private abstract static class Basic {
        public static final String CREATE =  "/create";
        public static final String DELETE = "/delete";
        public static final String UPDATE = "/update";
        public static final String PAGE = "/page";
        public static final String PAGE2 = "/page2";
        public static final String LIST = "/list";
        public static final String FINDBYID = "/findById";
        public static final String FIND_MODULE_BY_SAASID = "/findModuleBySaasId";
        public static final String STATUS = "/status";
    }

    /**
     * SAAS
     */
    public static class Saas extends Basic {
        public static final String PREFIX  = "/saas";
        public static final String SYSTEM_CONFIGURATION  = "/system_configuration";
        public static final String THEME_STYLE  = "/theme_style";
        public static final String RESET_SECRET  = "/reset_secret";
        public static final String AUDIT  = "/audit";
    }

    /**
     * 注册saas
     */
    public static class RegisterSaas extends Basic {
        public static final String PREFIX  = "/open/saas";
        public static final String REGISTER  = "/register";
        public static final String SEND_EMAIL  = "/sendEmail";
        public static final String NAME_IS_EXIST  = "/nameIsExist";
        public static final String FIND_BY_ID  = "/findById";
        public static final String SAAS_TYPE_DICT  = "/saasTypeDict";

    }

    /**
     * SAAS默认模块
     */
    public static class SaasDefaultModuleFunction extends Basic {
        public static final String PREFIX  = "/saas_default_module_function";
    }

    /**
     * Saas模块功能
     */
    public static class SaasModuleFunction extends Basic {
        public static final String PREFIX  = "/saas_module_function";
    }

    /**
     * SAAS名片
     */
    public static class SaasBusinessCard extends Basic {
        public static final String PREFIX  = "/saas_business_card";
        public static final String GENERATE = "/generate";
    }

    /**
     * SAAS类型
     */
    public static class SaasTypeDict extends Basic {
        public static final String PREFIX  = "/saas_type_dict";
        public static final String STATUS  = "/status";
        public static final String FIND_ALL_EXIST_CHECKED  = "/findAllExistChecked";
    }

    /**
     * 模块
     */
    public static class Module extends Basic {
        public static final String PREFIX  = "/module";
        public static final String STATUS  = "/status";
        public static final String IS_NAME_EXIST  = "/isNameExist";
        public static final String FIND_ALL  = "/findAll";
        public static final String GET_TREE  = "/getTree";

    }

    /**
     * 接口
     */
    public static class Interface extends Basic {
        public static final String PREFIX  = "/interface";
        public static final String STATUS  = "/status";
        public static final String IS_NAME_EXIST  = "/isNameExist";
        public static final String FIND_ALL  = "/findAll";
    }

    /**
     * 租户接口
     */
    public static class SaasInterface extends Basic {
        public static final String PREFIX  = "/saasInterface";
        public static final String STATUS  = "/status";
        public static final String IS_NAME_EXIST  = "/isNameExist";
        public static final String FIND_ALL  = "/findAll";
    }

    /**
     * 功能
     */
    public static class Function extends Basic {
        public static final String PREFIX  = "/function";
    }

    /**
     * 模块功能
     */
    public static class ModuleFunction extends Basic {
        public static final String PREFIX  = "/module_function";
    }

    /**
     * 主题
     */
    public static class Theme extends Basic {
        public static final String PREFIX  = "/theme";
        public static final String CHECK_STYLE = "/check_style";
    }

    /**
     * 系统字典
     */
    public static class SystemDict extends Basic {
        public static final String PREFIX  = "/system_dict";
        public static final String ALL  = "/query_all";
        public static final String QUERY_BY_SAASID = "/queryBySaasId";
        public static final String QUERY_BY_TYPE  = "/query_by_type";
        public static final String CREATE_BY_TYPE = "/createByType";
    }

    /**
     * 系统字典项
     */
    public static class SystemDictEntry extends Basic {
        public static final String PREFIX  = "/system_dict_entry";
        public static final String PAGE_SAASID  = "/pageSaasId";
    }

    /**
     * 用户
     */
    public static class User extends Basic {
        public static final String PREFIX  = "/user";
        public static final String api_success ="success";
        public static final String CHECK_USERNAME = "/check_username";
        public static final String CHECK_MOBILE = "/check_mobile";
        public static final String findUserBaseInfo = "/findUserBaseInfo";
        public static final String resetPwd = "/resetPwd";
        public static final String updatePwd = "/updatePwd";
        public static final String queryOne = "/queryOne";
        public static final String orgTreeInfo = "/orgTreeInfo";
        public static final String userInfoList = "/userInfoList";
        public static final String lockOrUnlock = "/lockOrUnlock";
        public static final String orgChoiceInfo = "/orgChoiceInfo";
    }

    /**
     * 用户设备管理
     */
    public static class UserEquipment extends Basic {
        public static final String PREFIX  = "/userEquipment";
    }

    /**
     * 巨米第三方接口
     */
    public static class JumiApi extends Basic {
        public static final String PREFIX  = "/jumiApi";
        public static final String getEquipmentList  = "/getEquipmentList";
        public static final String getEquipmentInfo = "/getEquipmentInfo";
    }


    /**
     * 设备管理
     */
    public static class Equipment extends Basic {
        public static final String PREFIX  = "/equipment";
        public static final String selectByHospitalOrTown  = "/selectByHospitalOrTown";
        public static final String selectEquipment = "/selectEquipment";
    }

    /**
     * 设备管理
     */
    public static class UserInterface extends Basic {
        public static final String PREFIX  = "/userInterface";
        public static final String userSaveAndUpdate  = "/userSaveAndUpdate";
        public static final String userInterfaceSaveAndUpdate = "/userInterfaceSaveAndUpdate";
        public static final String userInterfaceStandardsaveAndUpdate = "/userInterfaceStandardsaveAndUpdate";
        public static final String userInterfaceLogsaveAndUpdate = "/userInterfaceLogsaveAndUpdate";
        public static final String findUserById = "/findUserById";
        public static final String findUserInterfaceById = "/findUserInterfaceById";
        public static final String findUserInterfaceStandardById = "/findUserInterfaceStandardById";
        public static final String findUserInterfaceLogById = "/findUserInterfaceLogById";
        public static final String selectUserByCondition = "/selectUserByCondition";
        public static final String selectUserInterfaceByCondition = "/selectUserInterfaceByCondition";
        public static final String selectUserInterfaceStandardByCondition = "/selectUserInterfaceStandardByCondition";
        public static final String selectUserInterfaceLogByCondition = "/selectUserInterfaceLogByCondition";
    }

    /**
     * 用户角色
     */
    public static class UserRole extends Basic {
        public static final String PREFIX  = "/user_role";
    }

    /**
     * 用户取消的模块或者功能
     */
    public static class UserHideModuleFunction extends Basic {
        public static final String PREFIX  = "/user_hide_module_function";
    }

    /**
     * 角色
     */
    public static class Role extends Basic {
        public static final String PREFIX  = "/role";
        public static final String api_success ="success";
        public static final String saveRole ="/saveRole";
        public static final String findRoleNameExist ="/findRoleNameExist";
        public static final String wlyyUserRole ="/wlyyUserRole";
    }

    /**
     * 菜单
     */
    public static class Menu extends Basic {
        public static final String PREFIX  = "/menu";
        public static final String STATUS  = "/status";
        public static final String IS_NAME_EXIST  = "/isNameExist";
        public static final String MOVE_UP  = "/moveUp";
        public static final String MOVE_DOWN  = "/moveDown";
        public static final String GET_TREE  = "/getTree";
        public static final String FIND_ALL  = "/findAll";
        public static final String findRoleMenuTree  = "/findRoleMenuTree";
        public static final String findLoginRoleMenuTree  = "/findLoginRoleMenuTree";
    }

    /**
     * 首页菜单字典
     */
    public static class MenuDict extends Basic {
        public static final String PREFIX  = "/baseMenuDict";
        public static final String createMenuDict  = "/createMenuDict";
        public static final String STATUS  = "/status";
        public static final String MOVE_UP  = "/moveUp";
        public static final String MOVE_DOWN  = "/moveDown";
        public static final String findOneMenuDict  = "/findOneMenuDict";
        public static final String deleteMenuDict  = "/deleteMenuDict";
    }
    /**
     * 首页菜单免登录
     */
    public static class MenuNologin extends Basic {
        public static final String PREFIX  = "/open/noLogin/article";
        public static final String findAllMenu  = "/findAllMenu";
        public static final String findMenuByParentId  = "/findMenuByParentId";
        public static final String findArticleByMenuId= "/findArticleByMenuId";
        public static final String queryById= "/queryById";
        public static final String insertBrowseDO="/insertBrowseDO";
    }

    /**
     * 友情链接
     */
    public static class LinkDict extends Basic {
        public static final String PREFIX  = "/baseLinkDict";
        public static final String createLinkDict = "/createLinkDict";
        public static final String linkStatus  = "/linkStatus";
        public static final String linkShow  = "/linkShow";
        public static final String MOVELinkUP  = "/moveLinkUp";
        public static final String MOVELinkDOWN  = "/moveLinkDown";
        public static final String findLinkDictALL  = "/findLinkDictALL";
        public static final String findOneLink  = "/findOneLink";
        public static final String deleteLink  = "/deleteLink";
    }
    /**
     * 首页菜单
     */
    public static class MenuShow extends Basic {
        public static final String PREFIX  = "/baseLinkDict";
        public static final String createMenuShow = "/createMenuShow";
        public static final String menuShowstatus  = "/menuShowstatus";
        public static final String MOVEMenuShowUP  = "/moveMenuShowUp";
        public static final String MOVEMenuShowDOWN  = "/moveMenuShowDown";
        public static final String findMenuShow  = "/findMenuShow";
        public static final String findMenuShowDict  = "/findMenuShowDict";
        public static final String findRoleMenuTree  = "/findRoleMenuTree";
        public static final String findLoginRoleMenuTree  = "/findLoginRoleMenuTree";
    }

    /**
     * 错误码
     */
    public static class ErrorCode extends Basic {
        public static final String PREFIX  = "/error";
        public static final String INIT_WITHOUT_CONDITION  = "/initWithoutCondition";
    }


    /**
     * 随访
     */
    public static class Follow extends Basic {
        public static final String PREFIX_TEMPLATE  = "/followupTemplate";
    }

    /**
     * 通知公告
     */
    public static class Notice extends Basic {
        public static final String PREFIX  = "/notice";
        public static final String RELEASE  = "/release";
    }

    /**
     * 用户通知公告
     */
    public static class UserNotice extends Basic {
        public static final String PREFIX  = "/userNotice";
        public static final String COUNT  = "/count";
    }

    /**
     * 文件上传
     */
    public static class FileUpload extends Basic {
        public static final String PREFIX  = "/open/fileUpload";
        public static final String UPLOAD_STREAM_IMG  = "/upload_stream_img";
        public static final String UPLOAD_STREAM  = "/upload_stream";
        public static final String UPLOAD_STREAM_video  = "/upload_stream_video";
        public static final String UPLOAD_STRING  = "/upload_string";
        public static final String UPLOAD_STRINGBASE64  = "/UPLOAD_STRINGBASE64";
        public static final String UPLOAD_STREAM_ATTACHMENT  = "/upload_stream_attachment";

        public static final String DELETE_FILE = "/DELETE_FILE";
    }

    /**
     * 角色权限
     */
    public static class RoleAuthority extends Basic {
        public static final String PREFIX  = "/role_authority";
    }

    /**
     * 微信
     */
    public static class WeChat extends Basic {
        public static final String PREFIX  = "/wechat";
        public static final String wechat_base ="/wechatBase";
        public static final String api_success ="success";

        public static final String getWechatInfos ="/getWechatInfos";
        public static final String saveWxAndSaas ="/saveWxAndSaas";
        public static final String updateWxAndSaas ="/updateWxAndSaas";
        public static final String findWxWechatSingle ="/findWxWechatSingle";
        public static final String findWxWechatExist ="/findWxWechatExist";
        public static final String findWechatCombo ="/findWechatCombo";

        public static final String findWechatImgGroup ="/findWechatImgGroup";
        public static final String createImgGroup ="/createImgGroup";
        public static final String findImgGroupExist ="/findImgGroupExist";
        public static final String updateImgGroup ="/updateImgGroup";
        public static final String deleteImgGroup ="/deleteImgGroup";
        public static final String saveImg ="/saveImg";
        public static final String findImg ="/findImg";
        public static final String findGraphicMessageSingle ="/findGraphicMessageSingle";
        public static final String saveImgGroup ="/saveImgGroup";
        public static final String deleteImgGroupRelation ="/deleteImgGroupRelation";

        public static final String saveWxReplyScene ="/saveWxReplyScene";
        public static final String findDefaultReply ="/findDefaultReply";
        public static final String findWxReplySceneExist ="/findWxReplySceneExist";
        public static final String findWxReplyScene ="/findWxReplyScene";
        public static final String saveWxTemp ="/saveWxTemp";
        public static final String findWxTempExist ="/findWxTempExist";
        public static final String findWxTempNameExist ="/findWxTempNameExist";
        public static final String findWxtemp ="/findWxtemp";
        public static final String saveWxTempConfig ="/saveWxTempConfig";
        public static final String findWxTempConfigList ="/findWxTempConfigList";
        public static final String findWxTemplateConfig ="/findWxTemplateConfig";
        public static final String findWxTemplateConfigExist ="/findWxTemplateConfigExist";
        public static final String getAllTemp ="/getAllTemp";
        public static final String getFansTitle ="/getFansTitle";
        public static final String getusersummary ="/getusersummary";
        public static final String getusercumulate ="/getusercumulate";

    }

    /**
     * 短信网关
     */
    public static class SmsGateway extends Basic {
        public static final String PREFIX  = "/sms_gateway";
        public static final String SEND  = "/send";
    }

    /**
     * 短信模板
     */
    public static class SmsTemplate extends Basic {
        public static final String PREFIX  = "/sms_template";
    }

    /**
     * 短信模板
     */
    public static class Sms extends Basic {
        public static final String PREFIX  = "/sms";
    }

    /**
     * 服务包
     */
    public static class ServicePackage extends Basic{
        public static final String PREFIX  = "/servicepackage";
    }

    /**
     * 服务包类目
     */
    public static class ServicePackageNormcat extends Basic{
        public static final String PREFIX  = "/service_package_normcat";
    }

    /**
     * 生活照料
     */
    public static class LifeCare extends Basic{
        public static final String PREFIX  = "/life_care";
    }

    /**
     * 康复计划
     */
    public static class BaseRehabilitation extends Basic{
        public static final String PREFIX  = "/base_rehabilitation";
        public static final String CREATELOG  = "/createlog";
        public static final String FINDBYID  = "/findFinishById";
    }

    /**
     * 统计指标
     */
    public static class Quota extends Basic{
        public static final String PREFIX  = "/quota";
    }

    /**
     * 统计维度
     */
    public static class Dimension extends Basic{
        public static final String PREFIX  = "/dimension";
    }

    /**
     * job
     */
    public static class JobConfig extends Basic{
        public static final String PREFIX  = "/job_config";
    }

    /**
     * im
     */
    public static class ImGetuiConfig extends Basic{
        public static final String PREFIX  = "/im_getui";
    }
    /**
     * 家庭成员管理
     */
    public static class PatientMember extends Basic{
        public static final String PREFIX = "/patient_member";
    }

    /**
     * 医生评价
     */
    public static class Score extends Basic{
        public static final String PREFIX = "/score";
    }

    /**
     * 团队
     */
    public static class team extends Basic{
        public static final String PREFIX = "/team";
    }


    /**
     * 城市字典
     */
    public static class BaseCity extends Basic {
        public static final String PREFIX  = "/baseCity";
    }


    /**
     * 医生基础信息  BaseSensitive
     */
    public static class BaseDoctor extends Basic {
            public static final String PREFIX  = "/baseDoctor";
        public static final String DOCINFO  = "/docInfo";
        public static final String CREATE  = "/create";
        public static final String getOrgListByTown  = "/getOrgListByTown";
        public static final String enableOrDis  = "/enableOrDis";
        public static final String docFullInfo  = "/docFullInfo";
        public static final String docOrgDutyTreeInfo  = "/docOrgDutyTreeInfo";
        public static final String docOrgDeptTreeInfo  = "/docOrgDeptTreeInfo";
        public static final String getDoctorListByDept  = "/getDoctorListByDept";
        public static final String DOCTOR_INFO_IMPORT  = "/baseDoctorInfoImport";
        public static final String findIncentive  = "/findIncentive";
        public static final String findIncentiveById  = "/findIncentiveById";
        public static final String deleteIncentiveById  = "/deleteIncentiveById";
        public static final String saveIncentiveById  = "/saveIncentiveById";
        public static final String saveDoctorIncentive  = "/saveDoctorIncentive";
        public static final String findDoctorIncentive  = "/findDoctorIncentive";
        public static final String findDoctorOtherIncentive  = "/findDoctorOtherIncentive";
        public static final String removeIncentive  = "/removeIncentive";
        public static final String resetDoctorPwd  = "/resetDoctorPwd";
    }


    public static class BaseSensitive extends Basic {
        public static final String PREFIX  = "/baseSensitive";
        public static final String createSensitiveWords = "/createSensitiveWords";
        public static final String updateSensitiveWords = "/updateSensitiveWords";
        public static final String delSensitiveWords = "/delSensitiveWords";
        public static final String updateSensitiveWordsStatus = "/updateSensitiveWordsStatus";
        public static final String findSensitiveWords = "/findSensitiveWords";
        public static final String importSensitiveWords = "/importSensitiveWords";
        public static final String exportSensitiveWordsLog = "/exportSensitiveWordsLog";
        public static final String filterSensitiveWords = "/filterSensitiveWords";
    }


    /**
     * 医生职业信息
     */
    public static class BaseDoctorHospital extends Basic {
        public static final String PREFIX  = "/baseDoctorHospital";
    }


    /**
     * 医生角色字典
     */
    public static class BaseDoctorRoleInfo extends Basic {
        public static final String PREFIX  = "/baseDoctorRoleInfo";
        public static final String enableOrDis  = "/enableOrDis";
        public static final String checkRoleName  = "/checkRoleName";
        public static final String queryOne  = "/queryOne";
        public static final String moduleTree  = "/moduleTree";
    }
/**
     * 医生模块角色关联表
     */
    public static class BaseModuleRole extends Basic {
        public static final String PREFIX  = "/baseModuleRole";
    }

 /**
     * 医生角色关联关系
     */
    public static class BaseDoctorRole extends Basic {
        public static final String PREFIX  = "/baseDoctorRole";
    }


    /**
     * 机构信息
     */
    public static class BaseOrg extends Basic {
        public static final String PREFIX  = "/baseOrg";
        public static final String baseInfoList  = "/baseInfoList";
        public static final String check_code  = "/check_code";
        public static final String getOrgAreaTree  = "/getOrgAreaTree";
        public static final String queryOneById  = "/queryOneById";
        public static final String enableOrDis  = "/enableOrDis";
        public static final String queryDrugStore  = "/queryDrugStore";
        public static final String queryDrugStoreById  = "/queryDrugStoreById";
        public static final String deleteDrugStore  = "/deleteDrugStore";
        public static final String usedDrugStore  = "/usedDrugStore";
        public static final String saveDrugStore  = "/saveDrugStore";
        public static final String queryOrgCodeAndNameListBySaasId  = "/queryOrgCodeAndNameListBySaasId";
    }


    /**
     * 居民信息
     */
    public static class BasePatient extends Basic {
        public static final String PREFIX  = "/basePatient";
        public static final String getPatientById  = "/getPatientById";
        public static final String getBaseInfo  = "/getBaseInfo";
        public static final String sendCaptcha  = "/sendCaptcha";
        public static final String iscompleted  = "/iscompleted";
        public static final String completeInfo  = "/completeInfo";
        public static final String getCompletedInfo  = "/getCompletedInfo";
        public static final String idcardOccupied  = "/idcardOccupied";
        public static final String updateMobile  = "/updateMobile";
        public static final String resetPassword  = "/resetPassword";
        public static final String ForgetPwd  = "/forgetPwd";
        public static final String Regist = "regist";
        public static final String GetKey = "getKey";
        public static final String Login = "login";
        public static final String updatePatientPw = "/updatePatientPw";
        public static final String getPatientCountByDoctor  = "/getPatientCountByDoctor";
        public static final String getPatientEmrByDoctor  = "/getPatientEmrByDoctor";
        public static final String findPaitentPrescription  = "/findPaitentPrescription";
        public static final String createPatientGroupDict  = "/createPatientGroupDict";
        public static final String deletePatientGroupDict  = "/deletePatientGroupDict";
        public static final String findGroupByDoctor  = "/findGroupByDoctor";
        public static final String movePatientToGroup  = "/movePatientToGroup";
        public static final String delPatientGroup  = "/delPatientGroup";
        public static final String findPatientGroup  = "/findPatientGroup";
        public static final String findPatientGroupNum  = "/findPatientGroupNum";
        public static final String findOnePatientInfo  = "/findOnePatientInfo";
    }

   /**
     * 居民卡包信息
     */
    public static class PatientMedicareCard extends Basic {
        public static final String PREFIX  = "/patientMedicareCard";
        public static final String queryCardById  = "/queryCardById";
        public static final String bindMedicareCard  = "/bindMedicareCard";
        public static final String bindPatientIDCard  = "/bindPatientIDCard";
        public static final String bindSocialSecurityCard  = "/bindSocialSecurityCard";
        public static final String unBindCard  = "/unBindCard";
        public static final String cardList  = "/cardList";
        public static final String cardOrgList  = "/cardOrgList";
        public static final String sortProList  = "/sortProList";
        public static final String sortCityList  = "/sortCityList";
        public static final String isCardExist  = "/isCardExist";
    }


    /**
     * 居民账号申诉
     */
    public static class AccountAppeal extends Basic {
        public static final String PREFIX  = "/accountAppeal";
    }

    /**
     * 居民问题反馈
     */
    public static class Feedback extends Basic {
        public static final String PREFIX  = "/feedback";
    }

    /**
     * 居民帮助中心
     */
    public static class HelpCenter extends Basic {
        public static final String PREFIX  = "/helpCenter";
        public static final String getAnswerByType  = "/getAnswerByType";
        public static final String commentAnswer  = "/commentAnswer";
    }


    /**
     * 基础人口基数
     */
    public static class BasePopulation extends Basic {
        public static final String PREFIX  = "/basePopulation";
        public static final String CHECK_POPULATION_IS_EXIST  = "/checkBasePopulationIsExist";
        public static final String POPULATION_BATCH_IMPORT  = "/basePopulationBatchImport";
        public static final String POPULATION_BATCH_ERROR_DOENLOAD  = "/basePopulationBatchErrorDownLoad";
        public static final String POPULATION_BODY_BATCH_IMPORT  = "/basePopulationBodyBatchImport";

    }

    /**
     * 年份
     */
    public static class BaseYear extends Basic {
        public static final String PREFIX  = "/baseYear";
    }


    /**
     * 省份字典
     */
    public static class BaseProvince extends Basic {
        public static final String PREFIX  = "/baseProvince";
    }

    /**
     * 团队信息
     */
    public static class BaseTeam extends Basic {
        public static final String PREFIX  = "/baseTeam";
        public static final String queryMemberList  = "/queryMemberList";
        public static final String queryOne  = "/getTeamById";
        public static final String getTeamTree  = "/getTeamTree";
        public static final String teamInfoList  = "/teamInfoList";
        public static final String enableOrDis  = "/enableOrDis";
    }


    /**
     * 街道字典
     */
    public static class BaseStreet extends Basic {
        public static final String PREFIX  = "/baseStreet";
    }

    /**
     * 居委会字典
     */
    public static class BaseCommittee extends Basic {
        public static final String PREFIX  = "/baseCommittee";
    }


    /**
     * 团队成员
     */
    public static class BaseTeamMember extends Basic {
        public static final String PREFIX  = "/baseTeamMember";
    }


    /**
     * 区县字典
     */
    public static class BaseTown extends Basic {
        public static final String PREFIX  = "/baseTown";
    }

    /**
     * 区县字典
     */
    public static class BaseHospital extends Basic {
        public static final String PREFIX  = "/BaseHospital";
    }


    /**
     * 健康问题字典
     */
    public static class DictHealthProblem extends Basic {
        public static final String PREFIX  = "/dictHealthProblem";
    }

    /**
     * 健康问题字典
     */
    public static class DictDisease extends Basic {
        public static final String PREFIX  = "/dictDisease";
    }
    /**
     * 健康问题字典
     */
    public static class DiseaseManage extends Basic {
        public static final String PREFIX  = "/diseaseManage";
        public static final String createDisease = "/createDisease";
        public static final String saveDisease = "/saveDisease";
        public static final String findSingleDisease = "/findSingleDisease";
        public static final String updateDiseaseStatus = "/updateDiseaseStatus";
        public static final String findDiseaseList = "/findDiseaseList";
    }

    /**
     * 医院科室字典
     */
    public static class DictHospitalDept extends Basic {
        public static final String PREFIX  = "/dictHospitalDept";
        public static final String queryDeptByOrg  = "/queryDeptByOrg";
        public static final String queryDeptDoctor  = "/queryDeptDoctor";
        public static final String saveDeptDoctor  = "/saveDeptDoctor";
        public static final String saveDept = "/saveDept";
        public static final String findSingleDept = "/findSingleDept";
        public static final String unUsedDept = "/unUsedDept";
        public static final String findDept = "/findDept";
    }


    /**
     * ICD10字典
     */
    public static class DictIcd10 extends Basic {
        public static final String PREFIX  = "/dictIcd10";
    }


    /**
     * 医生职称字典
     */
    public static class DictJobTitle extends Basic {
        public static final String PREFIX  = "/dictJobTitle";
    }


    /**
     * 医生职务字典
     */
    public static class DictDoctorDuty extends Basic {
        public static final String PREFIX  = "/dictDoctorDuty";
    }


    /**
     * 药品字典
     */
    public static class DictMedicine extends Basic {
        public static final String PREFIX  = "/dictMedicine";
    }
   /**
     * 药品剂型
     */
    public static class DictMedicineDosageForm extends Basic {
        public static final String PREFIX  = "/dictMedicineDosageForm";
    }
   /**
     * 药品字典科目类别
     */
    public static class DictMedicineSubject extends Basic {
        public static final String PREFIX  = "/dictMedicineSubject";
    }
   /**
     * 药品分发机构
     */
    public static class DictMedicineDistributeOrg extends Basic {
        public static final String PREFIX  = "/dictMedicineDistributeOrg";
    }

    /**
     * app版本升级
     */
    public static class AppVersion extends Basic {
        public static final String PREFIX  = "/appVersion";
    }

    /**
     * 基础消息
     */
    public static class BaseMessage extends Basic {
        public static final String PREFIX  = "/baseMessage";
    }
    /**
     * 基础消息
     */
    public static class SyncData extends Basic {
        public static final String PREFIX  = "/syncData";
        public static final String findAllSyncData  = "/findAllSyncData";
        public static final String syncComplete  = "/syncComplete";
        public static final String findDataByTime  = "/findDataByTime";
    }

    /**
     * 基础消息类型
     */
    public static class BaseMessageType extends Basic {
        public static final String PREFIX  = "/baseMessageType";
    }

    /**
     * 基于MQ的消息推送
     */
    public static class MqMessage extends Basic {
        public static final String PREFIX  = "/mq_message";
    }

    /**
     * 基于MQ的消息推送订阅者
     */
    public static class MqMessageSubscriber extends Basic {
        public static final String PREFIX  = "/mq_message_subscriber";
    }

    /**
     * 功能菜单角色
     */
    public static class BaseRoleMenu extends Basic {
        public static final String PREFIX  = "/baseRoleMenu";
    }
    
    /**
     * 系统日志
     */
    public static class BaseMethodLog extends Basic{
        public static final String PREFIX  = "/baseMethodLog";
        public static final String getLog  = "/getLog";
    }

    /**ThirdInterface
     * 多码融合
     */
    public static class ThirdInterface extends Basic{
        public static final String PREFIX  = "/thirdInterface";
        public static final String selectHealthIdCard  = "/selectHealthIdCard";
        public static final String queryHealthIdCard  = "/queryHealthIdCard";
    }



    /**
     * 药店管理接口
     */
    public static class drugStoreManage extends Basic {
        public static final String PREFIX  = "/drugStore";
        public static final String findDrugstore  = "/findDrugstore";
        public static final String findDrugstoreByDistance  = "/findDrugstoreByDistance";
        public static final String findDrugstoreById  = "/findDrugstoreById";
    }

    /*
    * 查新查重服务接口
    */
    public static class ClientSearch extends Basic {
        public static final String PREFIX = "/open/noLogin/clientSearch";
        public static final String DELETEBYID = "/deleteById";
        public static final String FINDBYSEARCHDATA = "/findbysearchdata";
        public static final String FINDALL = "/findAll";
        public static final String CHANGESTATUS = "/changestatus";
        public static final String REPLY = "/reply";
        public static final String FILEDOWNLOAD = "/fileDownLoad";
        public static final String FILEUPLOAD = "/fileUpLoad";
        public static final String SHOWTYPE = "/showType";
    }


    public static class Resource extends Basic{
        public static final String PREFIX = "/resources";
        public static final String DictList = "/dict/list";
        public static final String DictBatch = "/dict/batch";
        public static final String Dict = "/dict/{id}";
        public static final String DictCode = "/dict/code";
        public static final String DictExistence = "/dict/existence";
        public static final String DictEntryBatch = "/dict/entry/batch";
        public static final String DictCodesExistence = "/dict/codes/existence";
        public static final String DictEntries = "/dict_entries";
        public static final String NoPageDictEntries = "/noPage_dict_entries";
        public static final String DictEntry = "/dict_entries/{id}";
        public static final String DictEntriesByDictCode = "/dict/code/dict_entries";
        public static final String DictEntriesExistence = "/dict_entries/existence";

        public static final String CategoryUpdate = "/resources/category/update";
        public static final String Category = "/resources/category/{id}";
        public static final String CategoriesByPid = "/resources/categories/pid";
        public static final String CategoriesByCodeAndPid = "/resources/categories/codeAndPid";
        public static final String CategoryTree = "/resources/categories/tree";
        public static final String CategoryExitSelfAndParent = "/resources/categories/selfAndParent";
        public static final String CategoriesAll = "/resources/categories/all";
        public static final String CategoriesSearch = "/resources/categories/search";

    }


    /*
     * 应用角色菜单资源
     */
    public static class ApplicationMenu extends Basic {
        public static final String PREFIX = "/applicationMenu";
        public static final String insertAndUpdateMenu = "/insertAndUpdateMenu";
        public static final String deleteById = "/deleteById";
        public static final String findById = "/findById";
        public static final String getMenuTree = "/getMenuTree";
        public static final String selectByCondition = "/selectByCondition";
    }

    /*
     * 应用角色
     */
    public static class ApplicationRoleDict extends Basic {
        public static final String PREFIX = "/applicationRoleId";
        public static final String insertAndUpdateRole = "/insertAndUpdateRole";
        public static final String deleteById = "/deleteById";
        public static final String findById = "/findById";
        public static final String selectUserByRoleId = "/selectUserByRoleId";
        public static final String selectByCondition = "/selectByCondition";
        public static final String insertRoleUser ="/insertRoleUser";

        public static final String removeRoleUser="/removeRoleUser";
        public static final String selectMenuByRoleId="/selectMenuByRoleId";
        public static final String insertRoleMenu = "/insertRoleMenu";
    }
}
