package com.yihu.jw.rm.hospital;


import org.omg.CORBA.PUBLIC_MEMBER;

/**
 * Created by Trick on 2019/5/16.
 */
public class BaseHospitalRequestMapping {

    /**
     * 基础请求地址
     */
    private abstract static class Basic {
        public static final String api_success ="success";
        public static final String CREATE =  "/create";
        public static final String DELETE = "/delete";
        public static final String UPDATE = "/update";
        public static final String PAGE = "/page";
        public static final String LIST = "/list";
        public static final String FINDBYID = "/findById";
        public static final String FIND_MODULE_BY_SAASID = "/findModuleBySaasId";
        public static final String STATUS = "/status";
    }

    public static class Appointment extends BaseHospitalRequestMapping.Basic{
        public static final String PREFIX  = "/appointment";

        public static final String getDoctorSchedule = "/getDoctorSchedule";
        public static final String getDoctorScheduleTime = "/getDoctorScheduleTime";
        public static final String getAppointmentList = "/getAppointmentList";
        public static final String makeAppointment = "/makeAppointment";
        public static final String cancelAppointment = "/cancelAppointment";
        public static final String getDoctorByMappingCode = "/getDoctorByMappingCode";
        public static final String findAllSpecialDisease = "/findAllSpecialDisease";

    }

    public static class Prescription extends BaseHospitalRequestMapping.Basic {

        public static final String PREFIX  = "/prescription";
        public static final String findDoctorByIdCard = "/findDoctorByIdCard";
        public static final String testJpush = "/testJpush";
        public static final String findYkCardCharge = "/findYkCardCharge";
        public static final String pushYkCardCharge = "/pushYkCardCharge";
        public static final String zsMsgFlowTest = "/zsMsgFlowTest";

        public static final String updateChannelId = "/updateChannelId";
        //=====================start=======================================
        /**
         * 获取门诊记录
         */
        public static final String findOutpatientList = "/findOutpatientList";
        /**
         * 修改居民信息
         */
        public static final String updatePatientInfo = "/updatePatientInfo";

        /**
         * 查询单条门诊记录接口
         */
        public static final String findOutpatientInfo ="/findOutpatientInfo";
        /**
         * 同步医生信息
         */
        public static final String synDoctorInfo = "/synDoctorInfo";
        /**
         * 查询单条复诊信息全部接口
         */
        public static final String findReOutpatientInfo = "/findReOutpatientInfo";
        /**
         * 获取复诊记录类别
         */
        public static final String findReOutpatientList ="/findReOutpatientList";

        /**
         * 查询患者就诊卡
         */
        public static final String findPatientCard = "/findPatientCard";

        /**
         * 处方支付
         */
        public static final String prescriptionPay = "/prescriptionPay";
        /**
         * 查询患者所有处方信息
         */
        public static final String findPatientAllPrescription = "/findPatientAllPrescription";

        /**
         * 查看取药地址
         */
        public static final String findDrugAddress = "/findDrugAddress";
        /**
         * 查询患者问诊信息
         */
        public static final String findPatientAllOutpatient = "/findPatientAllOutpatient";


        /**
         * 查询患者就诊卡
         */
        public static final String synYkIcd10 = "/synYkIcd10";

        /**
         * 判断是否可用发起门诊
         */
        public static final String checkOutpatient ="/checkOutpatient";

        /**
         * 居民发起复诊
         */
        public static final String appointmentRevisit = "/appointmentRevisit";
        /**
         * 上门复诊
         */
        public static final String appointmentRevisitOnDoor = "/appointmentRevisitOnDoor";
        /**
         * 查询业务字典
         */
        public static final String findJobCategory ="/findJobCategory";
        /**
         * 查询getNatRecords
         */
        public static final String getNatRecords ="/getNatRecords";
        /**
         * 查询getNatRecords
         */
        public static final String findBaseAddress ="/findBaseAddress";
        /**
         * 查询所有机构
         */
        public static final String findAllHospital ="/findAllHospital";

        /**
         * 查询机构底下部门
         */
        public static final String findDeptByHospital ="/findDeptByHospital";


        /**
         * 查询机构底下部门
         */
        public static final String findDeptDescByDeptCodeAndOrgCode ="/findDeptDescByDeptCodeAndOrgCode";


        /**
         * 查询机构底下部门
         */
        public static final String findDeptByOrgCode ="/findDeptByOrgCode";

        /**
         * 查询有所有已开放的科室
         */
        public static final String findDeptByKeyWord ="/findDeptByKeyWord";

        /**
         * 查询部门下医生
         */
        public static final String findDoctorByHospitalAndDept = "/findDoctorByHospitalAndDept";

        /**
         * 根据疾病名称，热门部门查询医生
         */
        public static final String findDoctorByHospitalAndDiseaseAndDept = "/findDoctorByHospitalAndDiseaseAndDept";

        /**
         * 居民关注医院
         */
        public static final String followOrgByPatient = "/followOrgByPatient";

        /**
         * 查询导诊助手
         */
        public static final String selectByGuidance = "/selectByGuidance";

        /**
         * 获取常见疾病、热门部门、医生拒绝接诊原因 字典
         */
        public static final String findHotDeptAndDiseaseDict = "/findHotDeptAndDiseaseDict";

        /**
         * 挂号
         */
        public static final String registerOutPatient ="/registerOutPatient";

        /**
         * 获取ICD10诊断编码
         */
        public static final String getICD10 ="/getICD10";

        /**
         * 获取药品字典
         */
        public static final String getDrugDictionary ="/getDrugDictionary";

        /**
         * 获取用药方式
         */
        public static final String getDrugUse ="/getDrugUse";
        /**
         * 获取用药频次
         */
        public static final String getDrugFrequency="/getDrugFrequency";
        /**
         * 删除处方草稿
         */
        public static final String deletePrescriptionByid="/deletePrescriptionByid";

        /**
         * 下诊断
         */
        public static final String makeDiagnosis="/makeDiagnosis";

        /**
         * 获取订单列表
         */
        public static final String findExpressageList="/findExpressageList";

        /**
         * 设置订单
         */
        public static final String setMailno="/setMailno";

        /**
         * 订单导出
         */
        public static final String pushListWrite="/pushListWrite";

        /**
         * 财务报表导出
         */
        public static final String pushListDrug="/pushListDrug";

        /**
         * 财务报表导出
         */
        public static final String selectListDrug="/selectListDrug";

        /**
         *咨询导出
         */
        public static final String searchRecordWrite="/searchRecordWrite";

        /**
         * 获取号别字典
         */
        public static final String findByDeptTypeCode="/findByDeptTypeCode";

        /**
         * 获取卡信息
         */
        public static final String getCardInfo="/getCardInfo";

        /**
         * 查询医生带排班
         */
        public static final String findDoctorWithWork="/findDoctorWithWork";

        /**
         * 获取具体号源
         */
        public static final String findWorkTimeInfo="/findWorkTimeInfo";

        /**
         * 获取获取医生信息
         */
        public static final String findDoctorInfo="/findDoctorInfo";

        public static final String updateDoctorInfo="/updateDoctorInfo";

        public static final String findDoctorBaseInfo="/findDoctorBaseInfo";
        /**
         * 取消门诊
         */
        public static final String cancelOutPatient="/cancelOutPatient";

        /**
         * 居民取消原因字典
         */
        public static final String findCancelReasonList="/findCancelReasonList";

        /**
         * 獲取快速咨詢時間
         */
        public static final String findFastRegisterDate="/findFastRegisterDate";
        /**
         * 获取快速咨询时间分段
         */
        public static final String findByTimeSlot="/findByTimeSlot";

        /**
         * 获取医生列表，带当月排班状态
         */
        public static final String findDoctorWithMouthWork="/findDoctorWithMouthWork";

        /**
         * 查询某个医生某个月份排班记录
         */
        public static final String findDoctorWorkTimeByMonth="/findDoctorWorkTimeByMonth";

        /**
         * 查询排班规则
         */
        public static final String findWorkRule="/findWorkRule";

        /**
         * 保存排班规则
         */
        public static final String updateWorkRule="/updateWorkRule";

        /**
         * 排班批量保存接口
         */
        public static final String saveDoctorWorkTimeJson="/saveDoctorWorkTimeJson";

        /**
         * 医生自主排班
         */
        public static final String doctorSaveWorkTimeJson="/doctorSaveWorkTimeJson";

        /**
         * 医生自主删除排班
         */
        public static final String deleteWorkTime="/deleteWorkTime";

        /**
         * 医生自主编辑排班
         */
        public static final String updateWorkTime="/updateWorkTime";

        /**
         * 获取居民基础信息
         */
        public static final String findPatientInfo = "/findPatientInfo";

        /**
         * 保存医生在线排班
         */
        public static final String saveDoctorOnlineWork = "/saveDoctorOnlineWork";
        /**
         * 删除医生在线排班
         */
        public static final String delDoctorOnlineWork = "/delDoctorOnlineWork";

        /**
         *查询医生在线排班列表
         */
        public static final String findDoctorOnlineWorkList = "/findDoctorOnlineWorkList";

        /**
         * 发起协同门诊
         */
        public static final String cooperativeOutpatient = "/cooperativeOutpatient";

        /**
         * 设置门诊医生
         */
        public static final String saveOutpatientDoctor = "/saveOutpatientDoctor";

        /**
         * 验证授权
         */
        public static final String checkOauthQRCode = "/checkOauthQRCode";

        /**
         * 全科医生协同门诊列表
         */
        public static final String findByGeneralDoctor = "/findByGeneralDoctor";

        /**
         * 全科医生首页统计信息
         */
        public static final String findGeneralDoctorInfo = "/findGeneralDoctorInfo";

        /**
         * 发送i健康系统消息
         */
        public static final String sendWlyyOutpatientMes = "/sendWlyyOutpatientMes";

        /**
         * 设置I健康消息已读
         */
        public static final String readWlyyOutpatientMes = "/readWlyyOutpatientMes";

        /**
         * 厦门I健康签约信息接口
         */
        public static final String findWlyyPatient = "/findWlyyPatient";

        /**
         *  厦门I健康获取居民身份证
         */
        public static final String findPatientListBySscOrIdCard = "/findPatientListBySscOrIdCard";

        /**
         * 获取Base64医生头像
         */
        public static final String makeBase64Qrcode = "/makeBase64Qrcode";
        //=================end=======================================

        /**
         * 原处方记录
         */
        public static final String findOriginPrescriptionList = "/getOriginPrescriptionList";
        /**
         * 获取原来处方详情
         */
        public static final String findOriginPrescription = "/getOriginPrescriptionInfo";
        /**
         * 续方记录
         */
        public static final String findPrescriptionList = "/findPrescriptionList";
        /**
         * 获取所有居民相关信息，续方信息，物流信息，药品信息
         */
        public static final String findPrescriptionInfo ="/findPrescriptionInfo";

        /**
         * 判断是否可续方
         */
        public static final String checkPrescription = "/checkPrescription";

        /**
         * 居民取消续方
         */
        public static final String cancelPrescription ="/cancelPrescription";

        //居民获取当日就诊列表
        public static final String getTodayOutpatinetList ="/getTodayOutpatinetList";

        //获取医生
        public static final String getDoctorMapping ="/getDoctorMapping";

        //获取检查检验接口
        public static final String getInspectionDictionary ="/getInspectionDictionary";

        public static final String findPrescriptionLogByPreId = "/findPrescriptionLogByPreId";

        public static final String findByPrescriptionCodeByStatus = "/findByPrescriptionCodeByStatus";

        public static final String findByPartsCode = "/findByPartsCode";
        public static final String xzzxFindByPartsCode = "/xzzxFindByPartsCode";
        //检查项目查询
        public static final String xzzxSelectExamApply = "/xzzxSelectExamApply";
        public static final String xzzxSelectLisApply = "/xzzxSelectLisApply";
        //合理用药审核接口
        public static final String xzzxCheckInfo = "/xzzxCheckInfo";
        //审药通过后保存接口
        public static final String xzzxSaveCheckInfo = "/xzzxSaveCheckInfo";
        //作废处方接口
        public static final String xzzxDeleteCheckInfo = "/xzzxDeleteCheckInfo";
        public static final String findDictByName = "/findDictByName";

        public static final String updatePatientDiagnosis = "/updatePatientDiagnosis";
        //删除his处方信息
        public static final String delHisPrescriptionByHisNo = "/delHisPrescriptionByHisNo";
        //保存电子病历
        public static final String saveEmr = "/saveEmr";

        public static final String getJcmb="/getJcmb";
        public static final String getJymb="/getJymb";
        public static final String getTcxz="/getTcxz";
        public static final String getTcChild="/getTcChild";
        public static final String getInsChild="/getInsChild";

        public static final String getDoctorPreSign ="/getDoctorPreSign";

        public static final String getDoctorIntroduction ="/getDoctorIntroduction";

        public static final String findByDict ="/findByDict";

        //根据居民CODE换取居民请求秘钥
        public static final String getPatientAccetokenByIdcard="/getPatientAccetokenByIdcard";

        //医生待办事项列表
        public static final String doctorUpcomingList = "/doctorUpcomingList";

        //医生待办事项列表 不关联处方
        public static final String doctorUpcomingList2 = "/doctorUpcomingList2";

        public static final String setRecord = "/setRecord";

        public static final String findPatientRecord = "/findPatientRecord";

        public static final String findDoctorByName = "/findDoctorByName";

        public static final String findDeptWithDoctorWorkTime = "/findDeptWithDoctorWorkTime";

        public static final String findWorkTimeRule = "/findWorkTimeRule";

        public static final String saveWorkTimeRule = "/saveWorkTimeRule";

        public static final String checkDoctorWork = "/checkDoctorWork";

        public static final String importDoctorWork = "/importDoctorWork";

        public static final String selectOrderByRelationCode = "/selectOrderByRelationCode";

        public static final String ylzRechargeJson="ylzRechargeJson";
        public static final String ylzRechargePre="ylzRechargePre";
        public static final String yktMedicalCardTopUp="/yktMedicalCardTopUp";


        public static final String ylzRefund = "/ylzRefund";

        public static final String tradeQuery= "/tradeQuery";

        public static final String selectOrderStatus="/selectOrderStatus";
        public static final String selectOrderStatusById="/selectOrderStatusById";
        public static final String selectOrderListStatus="/selectOrderListStatus";

        public static final String selectPrescriptionList = "/selectPrescriptionList";

        public static final String updateStatus  = "/updateStatus";

        public static final String updateMailNoById = "/updateMailNoById";

        public static final  String prescriptionCheck = "/prescriptionCheck";

        public static final  String prescriptionCheckList = "/prescriptionCheckList";

        public static final  String selectByPrescriptionId = "/selectByPrescriptionId";

        public static final String savePrescriptionCheck = "/savePrescriptionCheck";

        public static final String deleteById = "/deleteById";

        public static final String selectExpireTime = "/selectExpireTime";


        public static final String saveEmrToEntrance="/saveEmrToEntrance";
        //处方管理
        public static final String prescriptionManage="/prescriptionManage";

        public static final String findEmrByPrescriptionId="/findEmrByPrescriptionId";
        //作废处方
        public static final String disablePrescription="/disablePrescription";

        public static final String selectMzRecord = "/selectMzRecord";

        public static final String selectZyRecord = "/selectZyRecord";

        public static final String findJKTA_V_ZKSG_HZCX_HIS = "/findJKTA_V_ZKSG_HZCX_HIS";

        public static final String findJKTA_ZY_RECORD = "/findJKTA_ZY_RECORD";

        /*
        关注医生信息
         */
        public static final String attentionDoctor="/attentionDoctor";
        public static final String findAllAttentionDoctor="/findAllAttentionDoctor";
        public static final String findHisEmr="/findHisEmr";
        public static final String findHisEmrXml= "/findHisEmrXml";
        public static final String outpatient="/outpatient";
        public static final String outpmedicaldoc="/outpmedicaldoc";
        public static final String getPatInfoDataXml="/getPatInfoDataXml";


        public static final String findTown="/findTown";
        public static final String findCommity="/findCommity";
        public static final String findProvince="/findProvince";
        public static final String findCity="/findCity";
        public static final String findPatientOpenId="/findPatientOpenId";
        public static final String popularityIncrease="/popularityIncrease";

        public static final String selectByUrl="/selectByUrl";

        public static final String updatePayStatus = "/updatePayStatus";

        public static final String findPatNoByPatient = "/findPatNoByPatient";

        public static final String appletSign= "/appletSign";
        public static final String yxToken20= "/yxToken2.0";
        public static final String doorServiceTest= "/doorServiceTest";
        public static final String saveNationalDrug = "/saveNationalDrug";//保存药品字典
        public static final String getNationalDrugList = "/getNationalDrugList";//获取药品字典
        public static final String updateNationalDrugStatus = "/updateNationalDrugStatus";//更新药品字典状态
        public static final String getNationalDrugById = "/getNationalDrugById";//根据id获取药品信息
    }

    public static class YkyyPrescription extends BaseHospitalRequestMapping.Basic {

        public static final String PREFIX  = "/ykyyPrescription";

        //=====================start=======================================
        public static final String yktPay ="/yktPay";

        public static final String getSql = "/getSql";
        public static final String findDeptByOrgCode = "/findDeptByOrgCode";
        /**
         * 获取门诊记录
         */
        public static final String findOutpatientList = "/findOutpatientList";

        /**
         * 查询单条门诊记录接口
         */
        public static final String findOutpatientInfo ="/findOutpatientInfo";
        /**
         * 查询单条复诊信息全部接口
         */
        public static final String findReOutpatientInfo = "/findReOutpatientInfo";
        /**
         * 获取复诊记录类别
         */
        public static final String findReOutpatientList ="/findReOutpatientList";

        /**
         * 查询患者就诊卡
         */
        public static final String findPatientCard = "/findPatientCard";

        /**
         * 判断是否可用发起门诊
         */
        public static final String checkOutpatient ="/checkOutpatient";

        /**
         * 居民发起复诊
         */
        public static final String appointmentRevisit = "/appointmentRevisit";

        /**
         * 查询所有机构
         */
        public static final String findAllHospital ="/findAllHospital";

        /**
         * 查询机构底下部门
         */
        public static final String findDeptByHospital ="/findDeptByHospital";

        /**
         * 查询有所有已开放的科室
         */
        public static final String findDeptByKeyWord ="/findDeptByKeyWord";

        /**
         * 查询部门下医生
         */
        public static final String findDoctorByHospitalAndDept = "/findDoctorByHospitalAndDept";

        /**
         * 根据疾病名称，热门部门查询医生
         */
        public static final String findDoctorByHospitalAndDiseaseAndDept = "/findDoctorByHospitalAndDiseaseAndDept";

        /**
         * 居民关注医院
         */
        public static final String followOrgByPatient = "/followOrgByPatient";

        /**
         * 获取常见疾病、热门部门、医生拒绝接诊原因 字典
         */
        public static final String findHotDeptAndDiseaseDict = "/findHotDeptAndDiseaseDict";

        /**
         * 挂号
         */
        public static final String registerOutPatient ="/registerOutPatient";

        /**
         * 获取ICD10诊断编码
         */
        public static final String getICD10 ="/getICD10";

        /**
         * 获取药品字典
         */
        public static final String getDrugDictionary ="/getDrugDictionary";

        /**
         * 获取用药方式
         */
        public static final String getDrugUse ="/getDrugUse";
        /**
         * 获取用药频次
         */
        public static final String getDrugFrequency="/getDrugFrequency";

        /**
         * 下诊断
         */
        public static final String makeDiagnosis="/makeDiagnosis";

        /**
         * 获取订单列表
         */
        public static final String findExpressageList="/findExpressageList";

        /**
         * 设置订单
         */
        public static final String setMailno="/setMailno";

        /**
         * 订单导出
         */
        public static final String pushListWrite="/pushListWrite";

        /**
         * 获取号别字典
         */
        public static final String findByDeptTypeCode="/findByDeptTypeCode";

        /**
         * 获取卡信息
         */
        public static final String getCardInfo="/getCardInfo";

        /**
         * 查询医生带排班
         */
        public static final String findDoctorWithWork="/findDoctorWithWork";

        /**
         * 获取具体号源
         */
        public static final String findWorkTimeInfo="/findWorkTimeInfo";

        /**
         * 获取获取医生信息
         */
        public static final String findDoctorInfo="/findDoctorInfo";

        public static final String findDoctorBaseInfo="/findDoctorBaseInfo";
        /**
         * 取消门诊
         */
        public static final String cancelOutPatient="/cancelOutPatient";

        /**
         * 居民取消原因字典
         */
        public static final String findCancelReasonList="/findCancelReasonList";

        /**
         * 獲取快速咨詢時間
         */
        public static final String findFastRegisterDate="/findFastRegisterDate";
        /**
         * 获取快速咨询时间分段
         */
        public static final String findByTimeSlot="/findByTimeSlot";

        /**
         * 获取医生列表，带当月排班状态
         */
        public static final String findDoctorWithMouthWork="/findDoctorWithMouthWork";

        /**
         * 查询某个医生某个月份排班记录
         */
        public static final String findDoctorWorkTimeByMonth="/findDoctorWorkTimeByMonth";

        /**
         * 查询排班规则
         */
        public static final String findWorkRule="/findWorkRule";

        /**
         * 保存排班规则
         */
        public static final String updateWorkRule="/updateWorkRule";

        /**
         * 排班批量保存接口
         */
        public static final String saveDoctorWorkTimeJson="/saveDoctorWorkTimeJson";

        /**
         * 获取居民基础信息
         */
        public static final String findPatientInfo = "/findPatientInfo";

        /**
         * 保存医生在线排班
         */
        public static final String saveDoctorOnlineWork = "/saveDoctorOnlineWork";
        /**
         * 删除医生在线排班
         */
        public static final String delDoctorOnlineWork = "/delDoctorOnlineWork";

        /**
         *查询医生在线排班列表
         */
        public static final String findDoctorOnlineWorkList = "/findDoctorOnlineWorkList";

        /**
         * 发起协同门诊
         */
        public static final String cooperativeOutpatient = "/cooperativeOutpatient";

        /**
         * 设置门诊医生
         */
        public static final String saveOutpatientDoctor = "/saveOutpatientDoctor";

        /**
         * 验证授权
         */
        public static final String checkOauthQRCode = "/checkOauthQRCode";

        /**
         * 全科医生协同门诊列表
         */
        public static final String findByGeneralDoctor = "/findByGeneralDoctor";

        /**
         * 全科医生首页统计信息
         */
        public static final String findGeneralDoctorInfo = "/findGeneralDoctorInfo";

        /**
         * 发送i健康系统消息
         */
        public static final String sendWlyyOutpatientMes = "/sendWlyyOutpatientMes";

        /**
         * 设置I健康消息已读
         */
        public static final String readWlyyOutpatientMes = "/readWlyyOutpatientMes";

        /**
         * 厦门I健康签约信息接口
         */
        public static final String findWlyyPatient = "/findWlyyPatient";

        /**
         *  厦门I健康获取居民身份证
         */
        public static final String findPatientListBySscOrIdCard = "/findPatientListBySscOrIdCard";

        /**
         * 获取Base64医生头像
         */
        public static final String makeBase64Qrcode = "/makeBase64Qrcode";
        //=================end=======================================

        /**
         * 原处方记录
         */
        public static final String findOriginPrescriptionList = "/getOriginPrescriptionList";
        /**
         * 获取原来处方详情
         */
        public static final String findOriginPrescription = "/getOriginPrescriptionInfo";
        /**
         * 续方记录
         */
        public static final String findPrescriptionList = "/findPrescriptionList";
        /**
         * 获取所有居民相关信息，续方信息，物流信息，药品信息
         */
        public static final String findPrescriptionInfo ="/findPrescriptionInfo";

        /**
         * 判断是否可续方
         */
        public static final String checkPrescription = "/checkPrescription";

        /**
         * 居民取消续方
         */
        public static final String cancelPrescription ="/cancelPrescription";

        //居民获取当日就诊列表
        public static final String getTodayOutpatinetList ="/getTodayOutpatinetList";

        //获取医生
        public static final String getDoctorMapping ="/getDoctorMapping";

        //获取检查检验接口
        public static final String getInspectionDictionary ="/getInspectionDictionary";

        public static final String findPrescriptionLogByPreId = "/findPrescriptionLogByPreId";

        public static final String findByPartsCode = "/findByPartsCode";

        public static final String findDictByName = "/findDictByName";

        public static final String getJcmb="/getJcmb";
        public static final String getJymb="/getJymb";
        public static final String getTcxz="/getTcxz";
        public static final String getTcChild="/getTcChild";
        public static final String getInsChild="/getInsChild";

        public static final String getDoctorPreSign ="/getDoctorPreSign";

        public static final String getDoctorIntroduction ="/getDoctorIntroduction";

        public static final String findByDict ="/findByDict";

        //根据居民CODE换取居民请求秘钥
        public static final String getPatientAccetokenByIdcard="/getPatientAccetokenByIdcard";

        //医生待办事项列表
        public static final String doctorUpcomingList = "/doctorUpcomingList";

        public static final String setRecord = "/setRecord";

        public static final String findPatientRecord = "/findPatientRecord";

        public static final String findDoctorByName = "/findDoctorByName";

        public static final String findDeptWithDoctorWorkTime = "/findDeptWithDoctorWorkTime";

        public static final String findWorkTimeRule = "/findWorkTimeRule";

        public static final String saveWorkTimeRule = "/saveWorkTimeRule";

        public static final String checkDoctorWork = "/checkDoctorWork";

        public static final String importDoctorWork = "/importDoctorWork";

    }


    /**
     * 门诊处方物流
     */
    public static class Expressage extends Basic {
        public static final String PREFIX  = "/expressage";
    }
    
    /**
     * 居民端-咨询IM
     */
    public static class PatientIM extends Basic{
        public static final String PREFIX  = "/im/patient";
    
        //患者咨询记录查询
        public static final String records ="/records";
    
        //查询居民与某个医生是否存在未结束的咨询
        public static final String isExistsUnfinishedConsult ="/isExistsUnfinishedConsult";
        //查询居民与某个医生是否存在未结束的咨询
        public static final String isExistsUnfinishedOutpatient ="/isExistsUnfinishedOutpatient";
        
        //获取会话成员
        public static final String participants ="/participants";
        
        //根据会话ID获取消息记录
        public static final String getSessionMessage ="/getSessionMessage";
        
        //根据咨询CODE进入会话
        public static final String intoTopic ="/intoTopic";
        
        //居民咨询发消息（追问接口）
        public static final String append ="/append";
        
        //居民添加咨询接口
        public static final String add = "/add";
        
        //居民详情
        public static final String patientInfo = "/patientInfo";
        
        //结束咨询id
        public static final String finish = "/finish";
    
        //根据咨询CODE获取session_id
        public static final String getTopic = "/getTopic";
        
        //根据复诊记录ID获取咨询CODE
        public static final String getConsultCodeByOutpatientId = "/getConsultCodeByOutpatientId";
        
        //评价咨询
        public static final String evaluationByConsultCode = "/evaluationByConsultCode";
        
        //根据咨询CODE返回评价详情
        public static final String getEvaluationByConsultCode = "getEvaluationByConsultCode";
    
        //获取微信签名
        public static final String getSign ="/getSign";

        //获取企业微信签名
        public static final String getEnterpriseSign ="/getEnterpriseSign";
        
        //获取居民-导诊的咨询对话
        public static final String getPatientGuaidenceConsult = "getPatientGuaidenceConsult";
        
        //更新会话成员（新增或删除）
        public static final String updateConsultParticipant = "updateConsultParticipant";
        
        // 居民导诊会话发送消息
        public static final String patientGuaidenceAppend = "patientGuaidenceAppend";
    
        //居民端：查询正医生当前咨询人数
        public static final String getDoctorConsultCount="getDoctorConsultCount";

        public static final String sessionIsExist = "sessionIsExist";

    }
    
    /**
     * 医生端-咨询IM&诊室&导诊台相关接口
     */
    public static class DodtorIM extends Basic{
        public static final String PREFIX  = "/im/doctor";

        //医生咨询记录查询
        public static final String records ="/records";
        //医生咨询记录查询
        public static final String records2 ="/records2";
        
        //添加(复诊咨询,协同门诊)
        public static final String addPrescriptionConsult ="/addPrescriptionConsult";

        public static final String refundRegisterNo = "/refundRegisterNo";

        public static final String addConsult= "addConsult";
    
        //全科医生发起求助专科医生的专家咨询
        public static final String generalAddExpertConsult = "/generalAddExpertConsult";
    
        //查询全科医生与专科医生是否存在未结束的咨询
        public static final String isExistsUnfinishedConsult ="/isExistsUnfinishedConsult";
        
        //(健康咨询)医生咨询记录查询
        public static final String expertConsultRecords ="/expertConsultRecords";
    
        //(健康咨询)根据i健康居民身份证号获取互联网医院居民CODE
        public static final String getPatientCodeByWlyyIdcard ="/getPatientCodeByWlyyIdcard";
    
        //(健康咨询)请求转发的消息内容
        public static final String getMessageForward ="/getMessageForward";
    
        //(健康咨询)转发消息
        public static final String postMessageForward ="/postMessageForward";
        
        //医生可接单列表(图文复诊、视频复诊、协同门诊)
        public static final String findWaitingRoomOutpatientByDoctor = "findWaitingRoomOutpatientByDoctor";
    
        //导诊台居民列表
        public static final String findWaitingRoomPatient = "findWaitingRoomPatient";
        
        //导诊台顶部数据状态
        public static final String findWaitingRoomStatusCount = "findWaitingRoomStatusCount";
    
        //导诊台诊室列表
        public static final String findClinicRoomList = "findClinicRoomList";
    
        //查询单个医生诊室状态
        public static final String findClinicRoomStatus = "findClinicRoomStatus";
    
        //结束咨询id
        public static final String finish = "/finish";
    
        //获取咨询问题，图片，居民信息
        public static final String getConsultInfoAndPatientInfo = "/getConsultInfoAndPatientInfo";
        
        //根据咨询CODE获取就诊记录ID
        public static final String getOutpatientidByConsoultCode = "/getOutpatientidByConsoultCode";
        
        //获取正在进行中的视频复诊/协同门诊
        public static final String getVideoPrescriptionByDoctor ="getVideoPrescriptionByDoctor";
    
        //获取等待就诊的视频复诊/协同门诊
        public static final String getWaitingForVisitVideoPrescriptionByDoctor ="getWaitingForVisitVideoPrescriptionByDoctor";
    
        //医生抢单(视频)
        public static final String pickVideoPrescripitonWaitingPeople= "pickVideoPrescripitonWaitingPeople";
    
        //修改医生咨询在线状态
        public static final String updateDoctorConsultStatus= "updateDoctorConsultStatus";
        
        //复诊图文咨询人数，视频咨询人数、协同门诊人数，可抢单人数
        public static final String doctorIndexConsultCount="doctorIndexConsultCount";
    
        //测试发送处方消息
        public static final String testSendPrescriptionIM = "testSendPrescriptionIM";
        
        //全科医生等候协同门诊，排队数量
        public static final String generalDoctorWaitingNumber = "generalDoctorWaitingNumber";
    
        //查询医生所有可抢单的数量
        public static final String findWaitingRoomOutpatientNumberByDoctor = "findWaitingRoomOutpatientNumberByDoctor";
        
        //专科医生拒绝接诊
        public static final String refuseOutpatientByDoctor = "refuseOutpatientByDoctor";
    
        //测试发送外层SOCKET消息
        public static final String testSendWaiSocketMessage = "testSendWaiSocketMessage";
    
        //医生端：进行中的专家咨询数量
        public static final String doctorSpecialistConsultCount="doctorSpecialistConsultCount";

        //医生端：进行中的专家咨询人数
        public static final String doctorSpecialistConsultCountNew="doctorSpecialistConsultCountNew";
        //医生端：进行中的专家咨询人数
        public static final String doctorSpecialistConsultCountNew2="doctorSpecialistConsultCountNew2";
    
        //医生端：图文复诊、视频复诊咨询数量、协同门诊候诊数量
        public static final String doctorReviewConsultCount="doctorReviewConsultCount";
    
        //医生端：可抢单数量
        public static final String doctorPickCount="doctorPickCount";
    
        //医生端：医生提醒居民上线
        public static final String alertPatientOnline="alertPatientOnline";
    
        //医生端：发起/断开 会话视频邀请
        public static final String videoInviteStatus="videoInviteStatus";
    
        //医生端：查询会话视频邀请状态
        public static final String getVideoInviteStatus="getVideoInviteStatus";
    
        //医生端：发起/断开 会话小程序视频邀请
        public static final String videoInviteMiniProgram="videoInviteMiniProgram";
    
        //医生端：发送咨询建议
        public static final String sendOutPatientSuggest = "sendOutPatientSuggest";
        
        //医生端：获取咨询建议
        public static final String getConsultSuggest = "getConsultSuggest";
    
        //医生端：发送医生取消IM消息
        public static final String sendOutPatientCancle = "sendOutPatientCancle";

        //导诊助手结束咨询
        public static final String guidanceFinishConsult = "guidanceFinishConsult";

        public static final String doctorReplyUpdateYktState = "doctorReplyUpdateYktState";
        public static final String outPatientOrder = "/outPatientOrder";
        public static final String findYzztByGslb = "/findYzztByGslb";
        public static final String findZtmxByid = "/findZtmxByid";
        public static final String findZlxm = "/findZlxm";
        public static final String findZlxmMx = "/findZlxmMx";
        public static final String getPrevious = "/getPrevious";
        public static final String findRecordByDoctor = "/findRecordByDoctor";
        public static final String findRecordCountByDoctor = "/findRecordCountByDoctor";


    }

    /**
     * 居民收获地址
     */
    public static class WlyyPatientExpressageAddr extends Basic {
        public static final String PREFIX  = "/expressageAddr";
        public static final String setDefault  = "/setDefault";
        public static final String hasDefault  = "/hasDefault";
    }
    /**
     * 设备管理
     */
    public static class IotEquipmentManage extends Basic {
        public static final String equipmentManage  = "/equipmentManage";
        public static final String createEquipment  = "/createEquipment";
        public static final String updateEquipment  = "/updateEquipment";
        public static final String deleteEquipment  = "/deleteEquipment";
        public static final String getEquipment  = "/getEquipment";
        public static final String getEquipmentAndCount  = "/getEquipmentAndCount";
        public static final String getHospital  = "/getHospital";
        public static final String getTest  = "/getTest";

    }
    
    /**
     * 健康文章
     */
    public static class KnowledgeArticle extends Basic {
        public static final String PREFIX  = "/article";
        //获取文章列表
        public static final String searchKnowledgePageList  = "/searchKnowledgePageList";
        //获取文章列表
        public static final String searchKnowledgeList  = "/searchKnowledgeList";
        //获取我的文章列表
        public static final String searchMyPageList  = "/searchMyPageList";
    
        //根据id查询文章
        public static final String queryById  = "/queryById";
    
        //根据id删除文章
        public static final String deleteById  = "/deleteById";
    
        //添加/修改文章
        public static final String saveArticle  = "/saveArticle";

        //修改文章是否展示首页
        public static final String updateIsShow  = "/updateIsShow";

        //审核/退回文章
        public static final String reviewArticle  = "/reviewArticle";
    
        //新增/修改分类
        public static final String saveCategory  = "/saveCategory";
        
        //获取分类列表
        public static final String searchCategoryList  = "/searchCategoryList";
        
        //根据分类code删除分类
        public static final String updateDel  = "/updateDel";
    
        //设置文章发送的科室
        public static final String saveArticleDept  = "/saveArticleDept";
    
        //根据文章查找科室
        public static final String findDeptByArticle  = "/findDeptByArticle";
    
        //根据科室查找文章
        public static final String findArticleByDept  = "/findArticleByDept";
    
        //设置部门发送文章
        public static final String saveDeptArticle  = "/saveDeptArticle";

        //发送居民业务
        public static final String sendPatientBusiness  = "/sendPatientBusiness";

        //设置为常用/不常用
        public static final String setArticleUsed  = "/setArticleUsed";

        //获取患者文章列表
        public static final String searchPatientArticle  = "/searchPatientArticle";

        //查询文章收藏，转发，点赞
        public static final String searchArticleByStatus  = "/searchArticleByStatus";


        //设置文章状态
        public static final String setArticleCollection  = "/setArticleCollection";

        //根据医生id生成二维码
        public static final String setQrCode  = "/setQrCode";
        public static final String setUrlCode="/setUrlCode";
        //生成所有医生二维码
        public static final String setAllCode  = "/setAllCode";
        public static final String findArticleByCategoryAndName  = "/findArticleByCategoryAndName";
        public static final String getArticleGroup  = "/getArticleGroup";
        public static final String findPatientFavorite  = "/findPatientFavorite";

        public static final String updateArticleUser= "/updateArticleUser";

        public static final String selectMenuList= "/selectMenuList";

        public static final String selectArticleListByCategory= "/selectArticleListByCategory";

        public static final String findArticleUserById= "/findArticleUserById";

        public static final String insertArticleOperate= "/insertArticleOperate";

        public static final String selectArticleDoctorById= "/selectArticleDoctorById";

        public static final String selectArticleDoctorByArticleIdAndUser= "/selectArticleDoctorByArticleIdAndUser";

        public static final String deleteArticleDoctorById= "/deleteArticleDoctorById";

        public static final String findArticleStaticsByDoctorId="/findArticleStaticsByDoctorId";
    }

    /**
     * 问卷调查
     */
    public static class WlyySurvey extends Basic{
        public static final String PREFIX  = "/survey";

        public static final String findSurveyLabel  = "/findSurveyLabel";
        public static final String findSurveyQuestion  = "/findSurveyQuestion";
        public static final String findBySurveyId  = "/findBySurveyId";
        public static final String saveSurveyQuestion  = "/saveSurveyQuestion";
        public static final String updataSurveyQuestion  = "/updataSurveyQuestion";
        public static final String delSurveyQuestion  = "/delSurveyQuestion";

        public static final String findSurveyTemplate  = "/findSurveyTemplate";
        public static final String findSurveyTemplateById  = "/findSurveyTemplateById";
        public static final String saveSurveyTemplate  = "/saveSurveyTemplate";
        public static final String delSurveyTemplate  = "/delSurveyTemplate";

        public static final String saveSurveyDept  = "/saveSurveyDept";
        public static final String saveDeptSurvey  = "/saveDeptSurvey";

        public static final String findSurveyByDept  = "/findSurveyByDept";
        public static final String findSurveyByDeptAndPatient  = "/findSurveyByDeptAndPatient";
        public static final String findDeptBySurvey  = "/findDeptBySurvey";
        public static final String saveSurveyAnswer  = "/saveSurveyAnswer";
        public static final String findAnswerBySurveyTempCode  = "/findAnswerBySurveyTempCode";

        public static final String findSurveyTemplateResult  = "/findSurveyTemplateResult";
        public static final String findQuestionInfoList  = "/findQuestionInfoList";
        public static final String findAnswerList  = "/findAnswerList";
        public static final String getSurveyList  = "/getSurveyList";
        public static final String setUsed  = "/setUsed";






    }

    /**
     * 线上就诊消息
     */
    public static class SystemMessage extends Basic {
        public static final String PREFIX  = "/message";
        public static final String addMessage  = "/addMessage";
        public static final String updateMessage  = "/updateMessage";
        public static final String searchMessagePageList  = "/searchMessagePageList";
        public static final String queryById  = "/queryById";
        public static final String commenSystemMessage  = "/commenSystemMessage";

    }

    public static class HcyyPrescription extends Basic {
        public static final String PREFIX  = "/hcyyPrescription";
        public static final String addMessage  = "/addMessage";
        public static final String updateMessage  = "/updateMessage";
        public static final String searchMessagePageList  = "/searchMessagePageList";
        public static final String queryById  = "/queryById";
        public static final String commenSystemMessage  = "/commenSystemMessage";

    }
    /**
     * 医生锦旗管理
     */
    public static class BaseBannerssage extends Basic{
        public static final String baseBanner  = "/baseBanner";
        public static final String queryByAndStatud = "/getByNameAndStatus";
        public static final String createBanner = "/creaetBanner";
        public static final String updateBanner = "/updateBanner";
        public static final String deleteBanner = "/deleteBanner";
        public static final String upBanner = "/upBanner";
        public static final String downBanner = "/downBanner";
        public static final String onOff = "/onOff";
    }
    /**
     * 隐私策略管理
     */
    public static class PrivateDictManager extends Basic{
        public static final String privateDictManager = "/privateDictManager";
        public static final String findPrivateDict  = "/findPrivateDict";
        public static final String savePrivateDict = "/savePrivateDict";
        public static final String delPrivateDict = "/delPrivateDict";
    }
    /**
     * 患者家人关系管理
     */
    public static class WlyyFamilyMember extends Basic{
        public static final String wlyyFamilyMember  = "/wlyyFamilyMember";
        public static final String sendZSFamily = "/sendZSFamily";
        public static final String sendFamily = "/sendFamily";
        public static final String findRelationDict = "/findRelationDict";
        public static final String findFamilyMumber = "/findFamilyMumber";
        public static final String findNatFamilyMumber = "/findNatFamilyMumber";
        public static final String findNatFamilyMumberById = "/findNatFamilyMumberById";
        public static final String delFamilyMumber = "/delFamilyMumber";
        public static final String delNatFamilyMumber = "/delNatFamilyMumber";
        public static final String updateFamilyMumber = "/updateFamilyMumber";
        public static final String saveFamilyRelation = "/saveFamilyRelation";
        public static final String saveNatFamilyRelation = "/saveNatFamilyRelation";
        public static final String saveFamilyRelationAppoint="/saveFamilyRelationAppoint";
        public static final String findSingleMember = "/findSingleMember";

    }
    /**
     * 医生锦旗展示
     */
    public static class DoctorBanner extends Basic{
        public static final String doctorBanner  = "/doctorBanner";
        public static final String giveBanner  = "/giveBanner";
        public static final String getBanner  = "/getBanner";
        public static final String getMessageNotRead  = "/getMessageNotRead";
        public static final String changeIsRead = "/changeIsRead";

    }
    /**
     * 医生反馈建议
     */
    public static class DoctorSuggest extends Basic{
        public static final String saveSuggest  = "/saveSuggest";
        public static final String findSuggestList  = "/findSuggestList";
        public static final String findOne  = "/findOne";
        public static final String baseDoctorSuggest  = "/baseDoctorSuggest";
    }
    /**
     * 背景展示
     */
    public static class BaseBackground extends Basic{
        public static final String backgroundManage  = "/backgroundManage";
        public static final String getAllBackground  = "/getAllBackground";
        public static final String saveDoctorBG  = "/saveDoctorBG";;
        public static final String createDoctorBG  = "/createDoctorBG";
        public static final String removeDoctorBG  = "/removeDoctorBG";
        public static final String updateDoctorBG  = "/updateDoctorBG";
        public static final String selectDoctorMessage  = "/selectDoctorMessage";
        public static final String saveDoctorMessage  = "/saveDoctorMessage";
        public static final String setMessageHead="/setMessageHead";
        public static final String delDoctorMessage = "/delDoctorMessage";
        public static final String selectMessageById = "/selectMessageById";

    }
    /**
     * 反馈建议
     */
    public static class suggestion extends Basic{
        public static final String suggestionManage  = "/suggestionManage";
        public static final String findSuggestionByType  = "/findSuggestionByType";
        public static final String delSuggestion  = "/delSuggestion";;
        public static final String saveSuggestion  = "/saveSuggestion";
        public static final String responseSuggestion  = "/responseSuggestion";
        public static final String findSuggestionById  = "/findSuggestionById";

    }
    /**
     * 反馈建议类型
     */
    public static class suggestionDict extends Basic{
        public static final String suggestionDictManage  = "/suggestionDictManage";
        public static final String findSuggestionType  = "/findSuggestionType";
        public static final String delSuggestionType = "/delSuggestionType";;
        public static final String saveSuggestionType  = "/saveSuggestionType";
        public static final String updateSuggestionType  = "/updateSuggestionType";
        public static final String upSuggestionType  = "/upSuggestionType";
        public static final String downSuggestionType  = "/downSuggestionType";
    }


    /**
     * 留言展示
     */
    public static class UserMessage extends Basic{
        public static final String userMessage  = "/userMessage";
        public static final String leaveMessage  = "/leaveMessage";
        public static final String responseMessage  = "/responseMessage";
        public static final String showMessage  = "/showMessage";
        public static final String getSingleMessage  = "/getSingleMessage";
        public static final String expertMessage  = "/expertMessage";
        public static final String onlineVisitMessage  = "/onlineVisitMessage";
        public static final String getMessage  = "/getMessage";
        public static final String getPoint  = "/getPoint";
        public static final String showDoctorMessage  = "/showDoctorMessage";
        public static final String updateIsShow  = "/updateIsShow";

    }
    /**
     * 医生分析总览
     */
    public static class Analysis extends Basic {
        public static final String PREFIX  = "/analysis";
        public static final String queryAnalysis  = "/queryAnalysis";
    }


    /**
     * 统计分析
     */
    public static class Statistics extends BaseHospitalRequestMapping.Basic{
        public static final String PREFIX  = "/statistics";

        public static final String getTotal3Data = "/getTotal3Data";
        public static final String getKindsConsultCount = "/getKindsConsultCount";
        public static final String getConsultAndPrescriptionList = "/getConsultAndPrescriptionList";
        public static final String getDrugAndExaminationFeeList = "/getDrugAndExaminationFeeList";
        public static final String getDeptOrDoctorVolumeList = "/getDeptOrDoctorVolumeList";
        public static final String getAllHospitalDetails = "/getAllHospitalDetails";
        public static final String exportHospitalDetails = "/exportHospitalDetails";
        public static final String getDeptScheduling = "/getDeptScheduling";
        public static final String getAllFunctionSetting = "/getAllFunctionSetting";
        public static final String getDoctorSetting = "/getDoctorSetting";
        public static final String updateDoctorSetting = "/updateDoctorSetting";
        public static final String insertFunctionDic = "/insertFunctionDic";

        public static final String total = "/total";
        public static final String outPatientLine="/outPatientLine";
        public static final String prescriptionLine="/prescriptionLine";
        public static final String prescriptionTj="/prescriptionTj";
        public static final String prescriptionByKd="/prescriptionByKd";
        public static final String outPatientCircular="/outPatientCircular";
        public static final String outPatientGrade = "/outPatientGrade";
        public static final String outPatientTypeLine= "/outPatientTypeLine";
        public static final String doctorStatictis = "/doctorStatictis";
        public static final String doctorTotal = "/doctorTotal";
        public static final String doctorStatictisExcel = "/doctorStatictisExcel";
        public static final String specialConsultHead = "/specialConsultHead";
        public static final String specialConsultLine = "/specialConsultLine";
        public static final String specialConsultExcel= "/specialConsultExcel";
        public static final String scoreHead = "/scoreHead";
        public static final String scoreLine = "/scoreLine";
        public static final String scoreList = "/scoreList";
        public static final String scheduleHead = "/scheduleHead";
        public static final String scheduleLine = "/scheduleLine";
        public static final String scheduleList = "/scheduleList";
        public static final String consultHead = "/consultHead";
        public static final String consultLine = "/consultLine";
        public static final String consultList= "/consultList";
        public static final String consultTotalApp = "/consultTotalApp";
        public static final String consultCircularApp = "/consultCircularApp";
        public static final String consultLineApp = "/consultLineApp";
        public static final String consultListApp = "/consultListApp";
        public static final String consultLinePC = "/consultLinePC";
        public static final String consultListPC = "/consultListPC";
        public static final String indexTotalApp = "/indexTotalApp";
        public static final String appIndexHead = "/appIndexHead";
        public static final String appIndexCenter ="/appIndexCenter";
        public static final String appCenterCircular ="/appCenterCircular";
        public static final String appPriceHead ="/appPriceHead";
        public static final String appPrescriptionHead="/appPrescriptionHead";
        public static final String articleTotal = "/articleTotal";
        public static final String getArticlePublishList="/getArticlePublishList";
        public static final String getArticleOperateDateLine = "/getArticleOperateDateLine";
        public static final String getArticleExcel="/getArticleExcel";
        public static final String getArticleTypeCircle="/getArticleTypeCircle";
        public static final String pushArticleCountExcel="/pushArticleCountExcel";
        public static final String getArticleTotalList="/getArticleTotalList";
    }


    /**
     * 医生服务配置
     */
    public static class DoctorSetting extends Basic {
        public static final String PREFIX  = "/doctor/setting";
        public static final String queryList  = "/queryList";
        public static final String queryById  = "/queryById";
        public static final String update  = "/update";
        public static final String updateList  = "/updateList";
        public static final String updateStatus  = "/updateStatus";
        public static final String updateSort  = "/updateSort";
        public static final String updateDoctorPw  = "/updateDoctorPw";
    }

    /**
     * 患者不用登陆访问居民PC端
     */
    public static class PatientNoLogin extends Basic {
        public static final String PREFIX  = "/open/noLogin";
        public static final String findDoctorByHospitalAndDiseaseAndDept = "/findDoctorByHospitalAndDiseaseAndDept";
        public static final String findHotDeptAndDiseaseDict = "/findHotDeptAndDiseaseDict";
        public static final String getTodayOutpatinetList ="/getTodayOutpatinetList";
        public static final String findByDeptTypeCode="/findByDeptTypeCode";
        public static final String findByHosAndDict="/findByHosAndDict";
        public static final String findDoctorInfo="/findDoctorInfo";
        public static final String isExistsUnfinishedConsult ="/isExistsUnfinishedConsult";
        public static final String getJobBySaasId ="/getJobBySaasId";
        public static final String findWorkTimeInfo="/findWorkTimeInfo";
        public static final String findLevelOneDoctorUpcoming="/findLevelOneDoctorUpcoming";
        public static final String getUpcomingByDoctor="/getUpcomingByDoctor";
        public static final String checkOperateTime="/checkOperateTime";
        public static final String querySettledRecord="/querySettledRecord";
        public static final String paySuccessNotice="/paySuccessNotice";
        public static final String findHisPatientInfo="/findHisPatientInfo";
        public static final String privateDictManager = "/privateDictManager";
        public static final String findPrivateDict  = "/findPrivateDict";
        public static final String savePrivateDict = "/savePrivateDict";
        public static final String delPrivateDict = "/delPrivateDict";
        public static final String findHospitalInfo = "/findHospitalInfo";
        public static final String synYktZxPrice = "/synYktZxPrice";
        public static final String findHospitalConsultInfo = "/findHospitalConsultInfo";
        public static final String findDictLists = "/findDictLists";
        public static final String findWorkDoctorCount = "/findWorkDoctorCount";
        public static final String findAllDict = "/findAllDict";
        public static final String findDictById = "/findDictById";
        public static final String updateDictById = "/updateDictById";
        public static final String findDictByCode = "/findDictByCode";
        public static final String findDict = "/findDict";
        public static final String delDict = "/delDict";
        public static final String createOrUpdateDict = "/createOrUpdateDict";
        public static final String findOneDict = "/findOneDict";
        public static final String findModelDict = "/findModelDict";
        public static final String updateDictGroup = "/updateDictGroup";
        public static final String delDictGroup = "/delDictGroup";
        public static final String upDoctorDict = "/upDoctorDict";
        public static final String downDoctorDict = "/downDoctorDict";
        public static final String insertSortDoctorDict = "/insertSortDoctorDict";
        public static final String saveSortDoctorDict = "/saveSortDoctorDict";
        public static final String findSortDoctorDict = "/findSortDoctorDict";

        //疾病首页标签配置
        public static final String findDiseaseHomepageBanner = "/findDiseaseHomepageBanner";
        public static final String updateDiseaseHomepageBanner = "/updateDiseaseHomepageBanner";
        public static final String delDiseaseHomepageBanner = "/delDiseaseHomepageBanner";
        //科室首页标签配置
        public static final String findDeptHomepageBanner = "/findDeptHomepageBanner";
        public static final String updateDeptHomepageBanner = "/updateDeptHomepageBanner";
        public static final String delDeptHomepageBanner = "/delDeptHomepageBanner";


        //疫情防控
        public static final String confirmedList = "/confirmedList";//确诊列表
        public static final String yqfkStatisticsHead = "/yqfkStatisticsHead";//头部确诊数量
        public static final String yqfkStatisticsTail = "/yqfkStatisticsTail";//密接数量统计
    }

    /**
     * app升级
     */
    public static class Version extends Basic{
        public static final String PREFIX  = "/open/version";
        public static final String app="/app";

    }


    public static class HealthCare extends Basic{
        public static final String PREFIX  = "/healthCare";


    }


    public static class WxPay extends Basic{
        public static final String wechatPay =  "/wechatPay";
        public static final String Notify =  "/notify";
        //发送微信模版消息
        public static final String sendWxTemple = "/sendWxTemple";
    }

    public static class UpWebTherapySupserviceInfo extends Basic {
        public static final String PREFIX = "/open/gc";
    }


    /**
     * 知识库-问题
     */
    public static class BaseKnowledgeQuestion extends Basic{
        public static final String PREFIX  = "/baseKnowledgeQuestion";
        //==============问题=================
        public static final String insertAndUpdateQuestion = "/insertAndUpdateQuestion";
        public static final String deleteQuestion = "/deleteQuestion";
        public static final String selectQuestionList = "/selectQuestionList";
        public static final String selectById = "/selectById";
        public static final String setQuestionSortById = "/setQuestionSortById";
        //===========问题集合=================
        public static final String insertAndUpdateQuestions = "/insertAndUpdateQuestions";
        public static final String deleteQuestions = "/deleteQuestions";
        public static final String selectQuestionsList = "/selectQuestionsList";
        public static final String selectQuestionsById = "/selectQuestionsById";
        public static final String setQuestionsSortById = "/setQuestionsSortById";

        public static final String setQuestionConfigurationRelation = "/setQuestionConfigurationRelation";

        public static final String selectFlowConfigurationRelations = "/selectFlowConfigurationRelations";

    }

    public static class BaseDiseaseHospital extends  Basic{
        public static final String PREFIX="/baseDiseaseHospital";
        public static final String insertAndUpdate = "/insertAndUpdate";
        public static final String findById="/findById";
        public static final String selectByCondition="/selectByCondition";
        public static final String deleteById = "/deleteById";
        public static final String updateStatusOrSort="/updateStatusOrSort";
        public static final String getSpecialList="/getSpecialList";
        public static final String getICD10="/getICD10";

        public static final String ascRevertData="ascRevertData";
    }

    /**
     * 知识库-字典
     */
    public static class BaseKnowledgeDict extends Basic{
        public static final String PREFIX  = "/baseKnowledgeDict";
        public static final String insertAndUpdateDict = "/insertAndUpdateDict";
        public static final String deleteDict = "/deleteDict";
        public static final String selectDictList = "/selectDictList";
        public static final String selectById = "/selectById";
        public static final String setDictSortById = "/setDictSortById";

        public static final String setDictRelation= "/setDictRelation";
    }

    /**
     * 系统会话设置
     */
    public static class BaseSystemDialogSetting extends Basic{
        public static final String PREFIX  = "/baseSystemDialogSetting";
        public static final String insterAndUpdateSystemDialogSetting = "/insterAndUpdateSystemDialogSetting";
        public static final String selectBySystemType = "/selectBySystemType";
    }


    /**
     * 活动配置
     */
    public static class BaseHospitalActivity extends Basic{
        public static final String PREFIX  = "/baseHospitalActivity";
        public static final String insertAndUpdate = "/insertAndUpdate";
        public static final String deleteById = "/deleteById";
        public static final String findById = "/findById";

        public static final String selectInfoByUserAndActivityId="/selectInfoByUserAndActivityId";
        public static final String selectByCondition = "/selectByCondition";
        public static final String updateFlagOrSort = "/updateFlagOrSort";

        public static final String updateStatusById="/updateStatusById";
    }

    /**
     * 用户参与活动情况
     */
    public static class BaseHospitalUserActivity extends Basic{
        public static final String PREFIX  = "/baseHospitalUserActivity";
        public static final String selectUserActivityByCondition = "/selectUserActivityByCondition";
        public static final String findUserActivityById="/findUserActivityById";
        public static final String selectUserIntegrateByCondition = "/selectUserIntegrateByCondition";
        public static final String receiveIntegrate = "/receiveIntegrate";
        public static final String selectUserActivityByUser = "/selectUserActivityByUser";
        public static final String takeActivity = "/takeActivity";
        public static final String selectUserIntegrateListByCondition="/selectUserIntegrateListByCondition";

        public static final String selectDeptRomByCondition= "/selectDeptRomByCondition";
        public static final String selectIntegrateInfoByUser="/selectIntegrateInfoByUser";
    }

    /**
     * 积分配置
     */
    public static class BaseHospitalMedal extends Basic{
        public static final String PREFIX  = "/baseHospitalMedal";
        public static final String insertAndUpdate = "/insertAndUpdate";
        public static final String deleteById = "/deleteById";
        public static final String findById = "/findById";
        public static final String selectByCondition = "/selectByCondition";
        public static final String selectMedalByUserId="/selectMedalByUserId";
    }


    /**
     * 兑换商品配置
     */
    public static class BaseHospitalGoods extends Basic{
        public static final String PREFIX  = "/baseHospitalGoods";
        public static final String insertAndUpdate = "/insertAndUpdate";
        public static final String updateGoodsStatus="/updateGoodsStatus";
        public static final String deleteById = "/deleteById";
        public static final String findById = "/findById";
        public static final String selectByCondition = "/selectByCondition";
        public static final String exchageGoods="/exchageGoods";

        public static final String selectGoodsExchageByCondition="/selectGoodsExchageByCondition";

        public static final String findGoodsExchageById="/findGoodsExchageById";
    }
}
