package com.yihu.jw.rm.iot;

/**
 * @author yeshijie on 2017/12/5.
 */
public class IotRequestMapping {

    public static final String api_iot_common = "svr-iot";
    public static final Integer api_iot_fail = -1;

    /**
     * 公共模块
     */
    public static class Common{
        public static final String company = api_iot_common + "/company";
        public static final String message = api_iot_common + "/message";
        public static final String system_dict = api_iot_common + "/systemDict";
        public static final String file_upload = api_iot_common + "/fileUpload";
        public static final String product = api_iot_common + "/product";
        public static final String order = api_iot_common + "/order";
        public static final String device = api_iot_common + "/device";
        public static final String quality = api_iot_common + "/quality";
        public static final String patientDevice = api_iot_common + "/patientDevice";
        public static final String wlyy = api_iot_common + "/wlyy";
        public static final String figereLabel = api_iot_common + "/figereLabel";
        public static final String platform = api_iot_common + "/platform";
        public static final String workType = api_iot_common + "/workType";
        public static final String hospital = api_iot_common + "/hospital";
        public static final String interfaceAudit = api_iot_common + "/interfaceAudit";
        public static final String monitorPlatform = api_iot_common + "/open/monitorPlatform";//免登录加上open
        public static final String sim = api_iot_common + "/sim";
        public static final String openThird = api_iot_common + "/open/gc"; //第三方调用 需要accesstoken
        public static final String getHospital = "/getHospital";
        public static final String getNameAndCode = "/open/getNameAndCode";
        public static final String getEquipmentAndCount = "getEquipmentAndCount";


        public static final String message_success_update = "update success";
        public static final String message_success_delete = "delete success";
        public static final String message_success_find = "find success";
        public static final String message_success_create = "create success";
        public static final String message_success_find_functions = "find success";
        public static final String message_success_import = "import success";

        public static final String message_fail_name_is_null = "name is null";
        public static final String message_fail_is_no_exist = "is no exist";
        public static final String message_fail_id_no_exist = "id no exist";
        public static final String message_fail_status_is_null = "status is null";
        public static final String message_fail_id_is_null = "id is null";
        public static final String message_fail_id_exist = "id exist";
        public static final String message_fail_saasId_is_null = "saasId is null";

    }

    public static class System{
        public static final String findDictByCode = "findDictByCode";
        public static final String createDict = "createDict";
        public static final String getListByParentCode = "getListByParentCode";
        public static final String findByDictName = "findByDictName";
    }

    /**
     * 第三方调用物联网接口 需要accesstoken
     */
    public static class ThirdOpen{
        public static final String registedevice = "registedevice";
        public static final String inputWeRunData = "inputWeRunData";
        public static final String uploadData = "uploadData";
        public static final String updateData = "updateData";
        public static final String iHealthDataSearch = "iHealthDataSearch";
        public static final String deleteData = "deleteData";
        public static final String searchList = "searchList";
    }

    /**
     * 文件上传模块常量
     */
    public static class FileUpload{
        public static final String api_upload_stream = "uploadStream";//文件流上传
        public static final String api_upload_stream_img = "uploadImg";//文件流上传图片
        public static final String api_upload_stream_attachment = "uploadattAchment";//文件流上传附件
        public static final String api_upload_string = "uploadString";//base64字符串上传

        public static final String message_success_upload = "上传成功";
        public static final String message_fail_upload = "上传失败";
        public static final String message_fail_upload_format = "不支持该文件格式上传";
        public static final String message_fail_jsonData_is_null = "jsonData is null";
        public static final String message_success_download= "下载成功";
    }

    /**
     * 企业模块
     */
    public static class Company{
        public static final String findCompanyPage = "findCompanyPage";
        public static final String addCompany = "addCompany";
        public static final String rootAddCompany = "rootAddCompany";
        public static final String findCompanyById = "findCompanyById";
        public static final String findByBusinessLicense = "findByBusinessLicense";
        public static final String updCompany = "updCompany";
        public static final String delCompany = "delCompany";
        public static final String auditCompanyPass = "auditCompanyPass";
        public static final String auditCompanyNoPass = "auditCompanyNoPass";
        public static final String findAll = "findAll";
        public static final String enterType = "enterType";
        public static final String conditionQueryPage = "conditionQueryPage";
        public static final String findUserCompanyStatus = "findUserCompanyStatus";
        public static final String findCompanyByAccount = "findCompanyByAccount";
        public static final String findCompanyApp ="findCompanyApp";

        public static final String findCompanyCertPage = "findCompanyCertPage";
        public static final String findCompanyCertById = "findCompanyCertById";
        public static final String findCompanyCertByCompanyId = "findCompanyCertByCompanyId";
        public static final String addCompanyCert = "addCompanyCert";
        public static final String delCompanyCert = "delCompanyCert";
        public static final String changePassWord = "changePassWord";

        public static final String api_create = "company";
        public static final String api_delete = "company";
        public static final String api_getById = "getById";
        public static final String api_update = "company";
        public static final String api_queryPage = "queryPage";
        public static final String api_getList = "getList";

        public static final String message_success_update = "update success";
        public static final String message_success_delete = "delete success";
        public static final String message_success_find = "find success";
        public static final String message_success_create = "create success";
        public static final String message_success_find_functions = "find success";
        public static final String message_success_audit = "audit success";
        public static final String message_success_enterType = "enter success";

    }

    /**
     * 消息模块
     */

    public static class Message {

        public static final String findAll = "findAll";
        public static final String markRead = "markRead";

        public static final String message_success_find = "message find success";
        public static final String message_success_update = "message mark success";

    }


    public static class MonitorPlatform{

    }

    /**
     * 产品模块常量
     */
    public static class Product {
        public static final String findProductPage = "findProductPage";
        public static final String data_sets = "data_sets";
        public static final String metadata = "metadata";
        public static final String findProductPageByCompanyId = "findProductPageByCompanyId";
        public static final String addProduct = "addProduct";
        public static final String findProductById = "findProductById";
        public static final String updProduct = "updProduct";
        public static final String delProduct = "delProduct";
        public static final String maintenanceUnitById = "maintenanceUnitById";
        public static final String setInventoryById = "setInventoryById";
        public static final String findAll = "findAll";
        public static final String findListByCategoryCode = "findListByCategoryCode";

    }

    /**
     * 居民设备模块常量
     */
    public static class PatientDevice {
        public static final String findByPage = "findByPage";
        public static final String addPatientDevice = "addPatientDevice";
        public static final String findById = "findById";
        public static final String updPatientDevice= "updPatientDevice";
        public static final String delPatientDevice= "delPatientDevice";
        public static final String findByDeviceSnAndUserType= "findByDeviceSnAndUserType";
        public static final String findByPatient= "findByPatient";
        public static final String findByPatientAndDeviceSn= "findByPatientAndDeviceSn";
        public static final String findByDeviceSnAndCategoryCode= "findByDeviceSnAndCategoryCode";
        public static final String findByDeviceSnAndCategoryCodeAndUserType= "findByDeviceSnAndCategoryCodeAndUserType";
        public static final String updatePatientDevice= "updatePatientDevice";
        public static final String findListByPatient= "findListByPatient";

        public static final String findAllLocations= "findAllLocations";
        public static final String findLocationByIdCard= "findLocationByIdCard";
        public static final String findLocationBySn= "findLocationBySn";
        public static final String deleteLocation= "deteleLocation";
        public static final String updateLocation= "updateLocation";

        public static final String createPatientDevice = "createPatientDevice";
        public static final String changePatientDevice = "changePatientDevice";
        public static final String getPatientDeviceList = "getPatientDeviceList";
        public static final String deleteDelPatientDevice = "deleteDelPatientDevice";

        //设备维修
        public static final String createRepairDevice = "createRepairDevice";
        public static final String getRepairDeviceList = "getRepairDeviceList";
        public static final String getDeviceInfoByDeviceSn = "getDeviceInfoByDeviceSn";
        public static final String deleteRepairDevice = "deleteRepairDevice";

        //设备检修
        public static final String getOverhaulDeviceList = "getOverhaulDeviceList";
        public static final String getOverhaulListByPatientDeviceId = "getOverhaulListByPatientDeviceId";
        public static final String delOverhaulByPatientDeviceId = "delOverhaulByPatientDeviceId";
        public static final String updateOverhaulStatusById = "updateOverhaulStatusById";
    }


    /**
     * 设备字典模块常量
     */
    public static class DeviceDict{
        public static final String api_create = "createDeviceDict";
        public static final String api_delete = "deleteDeviceDict";
        public static final String api_getById = "getDeviceDictById";
        public static final String api_update = "updateDeviceDict";
        public static final String api_queryPage = "queryDeviceDictPage";
        public static final String api_getList = "getDeviceDictList";
        public static final String api_findByDictName = "api_findByDictName";

        public static final String message_success_update = "deviceDict update success";
        public static final String message_success_delete = "deviceDict delete success";
        public static final String message_success_find = "deviceDict find success";
        public static final String message_success_create = "deviceDict create success";
        public static final String message_success_find_functions = "deviceDict find success";

    }

    /**
     * 设备模块常量
     */
    public static class Device{
        public static final String api_create = "createDevice";
        public static final String api_delete = "delDevice";
        public static final String api_getById = "getDeviceById";
        public static final String api_update = "updDevice";
        public static final String api_queryPage = "queryDevicePage";
        public static final String api_getList = "getDeviceList";
        public static final String api_findByDeviceSn = "findByDeviceSn";

        //设备库存
        public static final String getDeviceInventoryList = "getDeviceInventoryList";
        public static final String updateInventory = "updateInventory";
        public static final String getDeviceInventoryLog = "getDeviceInventoryLog";
        public static final String getDeviceInventoryLogDetail = "getDeviceInventoryLogDetail";
        public static final String deviceInventoryImport = "open/deviceInventoryImport";

        //预警
        public static final String getInventoryWarningHospital = "getInventoryWarningHospital";
        public static final String getInventoryWarningName = "getInventoryWarningName";


        //设备调拨
        public static final String getDeviceTransfersList = "getDeviceTransfersList";
        public static final String createDeviceTransfers = "createDeviceTransfers";
        public static final String deleteDeviceTransfers = "deleteDeviceTransfers";
        public static final String updateTransfersStatusById = "updateTransfersStatusById";

        public static final String isSnExist = "isSnExist";
        public static final String isSimExist = "isSimExist";
        public static final String updSim = "updSim";
        public static final String importDevice = "importDevice";
        public static final String isImportDevice = "isImportDevice";
        public static final String uploadDeviceInfo = "uploadDeviceInfo";
        public static final String downloadTemplate = "downloadTemplate";

        public static final String queryImportRecordPage = "queryImportRecordPage";

        public static final String message_success_update = "device update success";
        public static final String message_success_delete = "device delete success";
        public static final String message_success_find = "device find success";
        public static final String del_message_fail = "该设备已绑定居民，不允许删除";
        public static final String message_success_create = "device create success";
        public static final String message_success_find_functions = "device find success";
        public static final String message_success_updateInventory = "device inventory update success";
    }

    /**
     * SIM卡模块常量
     */
    public static class DeviceSim{
        public static final String addSIM = "addSIM";
        public static final String editSIM = "editSIM";
        public static final String conditionQueryPage = "conditionQueryPage";
        public static final String findAllSim = "findAllSim";
        public static final String remind = "remind";
        public static final String findRemind = "findRemind";

        public static final String message_success_add = "sim add success";
        public static final String message_success_edit = "sim edit success";
        public static final String message_success_remind = "sim remind success";
        public static final String message_success_find= " sim find success";
    }
    /**
     * 设备订单模块常量
     */
    public static class DeviceOrder{
        public static final String findPage = "findPage";
        public static final String findById = "findById";
        public static final String delOrder = "delOrder";
        public static final String delPurchase = "delPurchase";
        public static final String updOrder = "updOrder";
        public static final String createOrder = "createOrder";
        public static final String findAllOrderNo = "findAllOrderNo";
        public static final String findAllOrderBySupplierName = "findAllOrderBySupplierName";

        public static final String findPurcharsePage = "findPurcharsePage";
        public static final String findPurcharseById = "findPurcharseById";
        public static final String findQualityPage = "findQualityPage";

        public static final String api_create = "deviceOrder";
        public static final String api_delete = "deviceOrder";
        public static final String api_getById = "getDeviceOrderById";
        public static final String api_update = "deviceOrder";
        public static final String api_queryPage = "queryDeviceOrderPage";
        public static final String api_getList = "getDeviceOrderList";

        public static final String message_success_update = "deviceOrder update success";
        public static final String message_success_delete = "deviceOrder delete success";
        public static final String message_success_find = "deviceOrder find success";
        public static final String message_success_create = "deviceOrder create success";
        public static final String message_success_find_functions = "deviceOrder find success";
        public static final String delete_order_fail_message_device = "该订单有关联设备，不允许删除";
        public static final String delete_purchase_fail_message_device = "该采购清单有关联设备，不允许删除";

    }


    /**
     * 设备质检模块常量
     */
    public static class DeviceQuality{
        public static final String addQualityPlan = "addQualityPlan";
        public static final String delQualityPlan = "delQualityPlan";
        public static final String updQualityPlan = "updQualityPlan";
        public static final String completeQualityPlan = "completeQualityPlan";
        public static final String completePlanByPurchaseId = "completePlanByPurchaseId";
        public static final String queryQualityPlanPage = "queryQualityPlanPage";
        public static final String findById = "findById";
        public static final String findPlanTimeByOrderNo = "findPlanTimeByOrderNo";
        public static final String remindTimePlan = "remindTimePlan";
        public static final String findAll = "findAll";

    }

    /**
     * 设备标签模块常量
     */
    public static class DeviceLabel{
        public static final String api_create = "deviceLabel";
        public static final String api_delete = "deviceLabel";
        public static final String api_getById = "getDeviceLabelById";
        public static final String api_update = "deviceLabel";
        public static final String api_queryPage = "queryDeviceLabelPage";
        public static final String api_getList = "getDeviceLabelList";

        public static final String message_success_update = "deviceLabel update success";
        public static final String message_success_delete = "deviceLabel delete success";
        public static final String message_success_find = "deviceLabel find success";
        public static final String message_success_create = "deviceLabel create success";
        public static final String message_success_find_functions = "deviceLabel find success";

    }

    /**
     * 设备标签信息模块常量
     */
    public static class DeviceLabelInfo{
        public static final String api_create = "deviceLabelInfo";
        public static final String api_delete = "deviceLabelInfo";
        public static final String api_getById = "getDeviceLabelInfoById";
        public static final String api_update = "deviceLabelInfo";
        public static final String api_queryPage = "queryDeviceLabelInfoPage";
        public static final String api_getList = "getDeviceLabelInfoList";

        public static final String message_success_update = "deviceLabelInfo update success";
        public static final String message_success_delete = "deviceLabelInfo delete success";
        public static final String message_success_find = "deviceLabelInfo find success";
        public static final String message_success_create = "deviceLabelInfo create success";
        public static final String message_success_find_functions = "deviceLabelInfo find success";

    }

    /**
     * 居民标签信息模块常量
     */
    public static class FigureLabelInfo{
        public static final String api_getByIdcard = "getLabelByIdcard";
        public static final String api_getByTypeAndCode = "getLabelByTypeAndCode";

        public static final String message_success_find = "FigureLabelInfo find success";

    }

    /**
     * 平台接口信息模块常量
     */
    public static class  Platform{
        public static final String addInterface ="addInterface";
        public static final String editInterface ="editInterface";
        public static final String findInterfaceById ="findInterfaceById";
        public static final String parameterDescription = "parameterDescription";
        public static final String findAll ="findAll";
        public static final String findAllApp ="findAllApp";
        public static final String findAllLog ="findAllLog";
        public static final String findInterfaceLog ="findInterfaceLog";
        public static final String conditionQueryPage ="conditionQueryPage";
        public static final String delete ="delete";
        public static final String dataConsumption ="dataConsumption";
        public static final String findCompanyById ="findCompanyById";
        public static final String editCompanyById ="editCompanyById";
        public static final String delCompanyById ="delCompanyById";
        public static final String allotInterface ="allotInterface";
        public static final String findAppInterface ="findAppInterface";
        public static final String delAppInterface ="delAppInterface";
        public static final String interfaceDoc ="interfaceDoc";
        public static final String addApp ="addApp";
        public static final String findCompanyShareInterface ="findCompanyShareInterface";

        public static final String message_success_add = "add success";
        public static final String message_success_edit = "edit success";
        public static final String message_success_find = "find success";
        public static final String message_success_delete = "delete success";



    }

    /**
     * 接口申请与审核信息模块
     */
    public static class  InterfaceAudit{
        public static final String addInterfaceApplyFor ="addInterfaceApplyFor";
        public static final String findInterfaceApplyFor ="findInterfaceApplyFor";
        public static final String findAllApplyFor ="findAllApplyFor";

        public static final String auditPass ="auditPass";
        public static final String auditNoPass ="auditNoPass";
        public static final String conditionQueryPage ="conditionQueryPage";
        public static final String queryCompanyAppPage ="queryCompanyAppPage";

        public static final String message_success_apply_for = "apply for success";
        public static final String message_success_find = "find  success";
        public static final String message_success_audit = "audit  success";
    }


    /**
     * 业务类型信息模块常量
     */
    public static class WorkType{
        public static final  String addType="addType";
        public static final  String editType="editType";
        public static final  String deleteType="deleteType";
        public static final  String findType="findType";
        public static final  String findAll="findAll";

        public static final String message_success_add = "workType add success";
        public static final String message_success_edit = "workType edit success";
        public static final String message_success_delete = "workType delete success";
        public static final String message_success_find = "workType find success";
    }

    /**
     * 单位模块常量
     */
    public static class Hospital{
        public static final String getListByName = "getListByName";
        public static final String create = "createHospital";
        public static final String delete = "deleteHospital";

        public static final String message_success_find = "hospital find success";
        public static final String message_success_create = "hospital create success";
        public static final String message_success_delete = "hospital delete success";
    }



}
