package iot.device;


import com.fasterxml.jackson.annotation.JsonInclude;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.util.List;

/**
 * 体征数据实体类，新的标准的数据格式
 * @author ysj on 2020/06/24.
 */
@JsonInclude(JsonInclude.Include.NON_NULL)
@ApiModel
public class DataBodySignsVO {

    @ApiModelProperty(value = "数据来源",example = "iHealth",hidden = true)
    private String data_source; //数据来源
    @ApiModelProperty(value = "设备序列码",example = "65746176875",hidden = true)
    private String sn;          //设备序列码
    @ApiModelProperty(value = "设备数据识别代码",example = "1/0",hidden = true)
    private String ext_code;    //设备A，B键，取值为0,1，代表绑定不同的用户，
    @ApiModelProperty(value = "设备名称",example = "血压计",hidden = true)
    private String device_name; //设备名称
    @ApiModelProperty(value = "设备型号",example = "",hidden = true)
    private String device_model;//设备型号
    private List<MeasureDataVO> measure_data;    //设备所测量的数据内容
    private List<PositionDataVO> position_data;    //设备所测量的数据内容
    @ApiModelProperty(value = "身份证号",example = "350122198601145513",hidden = true)
    private String idcard;      //设备绑定的用户身份证号
    @ApiModelProperty(value = "身份证类型",example = "1",hidden = true)
    private String idcard_type;      //设备绑定的用户身份证号
    @ApiModelProperty(value = "用户名",example = "谢挺盛",hidden = true)
    private String username;    //用户名
    @ApiModelProperty(value = "用户code",example = "443a196ef8744536a531260eb26c05d7",hidden = true)
    private String usercode;    //用户在系统中的code，唯一识别


    public String getData_source() {
        return data_source;
    }

    public void setData_source(String data_source) {
        this.data_source = data_source;
    }

    public String getSn() {
        return sn;
    }

    public void setSn(String sn) {
        this.sn = sn;
    }

    public String getExt_code() {
        return ext_code;
    }

    public void setExt_code(String ext_code) {
        this.ext_code = ext_code;
    }

    public String getDevice_name() {
        return device_name;
    }

    public void setDevice_name(String device_name) {
        this.device_name = device_name;
    }

    public String getDevice_model() {
        return device_model;
    }

    public void setDevice_model(String device_model) {
        this.device_model = device_model;
    }

    public List<MeasureDataVO> getMeasure_data() {
        return measure_data;
    }

    public void setMeasure_data(List<MeasureDataVO> measure_data) {
        this.measure_data = measure_data;
    }

    public List<PositionDataVO> getPosition_data() {
        return position_data;
    }

    public void setPosition_data(List<PositionDataVO> position_data) {
        this.position_data = position_data;
    }

    public String getIdcard() {
        return idcard;
    }

    public void setIdcard(String idcard) {
        this.idcard = idcard;
    }

    public String getIdcard_type() {
        return idcard_type;
    }

    public void setIdcard_type(String idcard_type) {
        this.idcard_type = idcard_type;
    }

    public String getUsername() {
        return username;
    }

    public void setUsername(String username) {
        this.username = username;
    }

    public String getUsercode() {
        return usercode;
    }

    public void setUsercode(String usercode) {
        this.usercode = usercode;
    }
}
