package com.yihu.jw.restmodel.hospital.prescription;

import com.fasterxml.jackson.annotation.JsonFormat;
import com.yihu.jw.entity.hospital.prescription.WlyyPrescriptionEmrDO;
import com.yihu.jw.restmodel.UuidIdentityVOWithOperator;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;

import java.util.Date;
import java.util.List;


/**
 * 
 * 在线结算确认实体VO
 *
 *
 *
 */
@ApiModel(value = "WlyyHisSettleVO", description = "在线结算确认")
public class WlyyHisSettleVO extends UuidIdentityVOWithOperator {

    /**
     * 患者卡号
     */
    @ApiModelProperty(value = "患者卡号", example = "患者卡号")
    private String cardNo;

    /**
     * HIS 系统跟踪号
     */
    @ApiModelProperty(value = "HIS 系统跟踪号",example = "HIS 系统跟踪号")
    private String xtgzh0;

    /**
     * 机构编号(医院编号)
     */
    @ApiModelProperty(value = "机构编号(医院编号)",example = "机构编号(医院编号)")
    private String orgCode;

    /**
     * 充值方式(自费金额支付方式)
     */
    @ApiModelProperty(value = "充值方式(自费金额支付方式)",example = "充值方式(自费金额支付方式)")
    private String depositType;


    /**
     * 充值金额
     */
    @ApiModelProperty(value = "充值金额",example = "充值金额")
    private String depositAmount;

    /**
     * 信用支付 0-否 1-是
     */
    @ApiModelProperty(value = "信用支付 0-否 1-是",example = "信用支付 0-否 1-是")
    private String xyzf00;

    /**
     * 渠道类型
     */
    @ApiModelProperty(value = "渠道类型",example = "渠道类型")
    private String channelType;

    /**
     * 平台结算流水号
     */
    @ApiModelProperty(value = "平台结算流水号",example = "平台结算流水号")
    private String outChargeNo;

    /**
     * 单据流水号(医保收费流水号)
     */
    @ApiModelProperty(value = "单据流水号(医保收费流水号)",example = "单据流水号(医保收费流水号)")
    private String djlsh0;

    /**
     * 门诊流水号(医保挂号流水号)
     */
    @ApiModelProperty(value = "门诊流水号(医保挂号流水号)",example = "门诊流水号(医保挂号流水号)")
    private String mzlsh0;

    /**
     * 帐户支付额
     */
    @ApiModelProperty(value = "帐户支付额",example = "帐户支付额")
    private String zhzfe0;

    /**
     * 个人支付额
     */
    @ApiModelProperty(value = "个人支付额",example = "个人支付额")
    private String grzfe0;

    /**
     * 基金支付额
     */
    @ApiModelProperty(value = "基金支付额",example = "基金支付额")
    private String jjzfe0;

    /**
     * 公务员补助
     */
    @ApiModelProperty(value = "公务员补助",example = "公务员补助")
    private String gwybz0;

    /**
     * 非医保费用
     */
    @ApiModelProperty(value = "非医保费用",example = "非医保费用")
    private String fybfy0;

    /**
     * 超封顶线金额
     */
    @ApiModelProperty(value = "超封顶线金额",example = "超封顶线金额")
    private String cfdxje;

    /**
     * 保健基金支付
     */
    @ApiModelProperty(value = "保健基金支付",example = "保健基金支付")
    private String bjjjzf;


    /**
     * 本次报销总额
     */
    @ApiModelProperty(value = "本次报销总额",example = "本次报销总额")
    private String bcbxf0;

    /**
     * 收费日期
     */
    @ApiModelProperty(value = "收费日期",example = "收费日期")
    private String sfrq00;

    /**
     * 收费时间
     */
    @ApiModelProperty(value = "收费时间",example = "收费时间")
    private String sfsj00;

    /**
     * 收费人姓名
     */
    @ApiModelProperty(value = "收费人姓名",example = "收费人姓名")
    private String sfrxm0;

    /**
     * 医保帐户余额
     */
    @ApiModelProperty(value = "医保帐户余额",example = "医保帐户余额")
    private String grzhye;

    /**
     * 乙类支付额
     */
    @ApiModelProperty(value = "乙类支付额",example = "乙类支付额")
    private String ylzfje;

    /**
     * 健康账户支付
     */
    @ApiModelProperty(value = "健康账户支付",example = "健康账户支付")
    private String jkzhzf;

    /**
     * 健康账户余额
     */
    @ApiModelProperty(value = "健康账户余额",example = "健康账户余额")
    private String jkzhye;

    /**
     * 医保明细上传流水号
     */
    @ApiModelProperty(value = "医保明细上传流水号",example = "医保明细上传流水号")
    private String ybmxls;

    /**
     * 对账数据分类
     */
    @ApiModelProperty(value = "对账数据分类",example = "对账数据分类")
    private String dzsjfl;

    /**
     * 商业保险支付
     */
    @ApiModelProperty(value = "商业保险支付",example = "商业保险支付")
    private String sybxzf;

    /**
     * 本地共计账户支付
     */
    @ApiModelProperty(value = "本地共计账户支付",example = "本地共计账户支付")
    private String bdgjzf;

    /**
     * 异地共计账户支付
     */
    @ApiModelProperty(value = "异地共计账户支付",example = "异地共计账户支付")
    private String ydgjzf;

    /**
     * 本次看病次数
     */
    @ApiModelProperty(value = "本次看病次数",example = "本次看病次数")
    private String bckbcs;

    /**
     * 补助基金支付
     */
    @ApiModelProperty(value = "补助基金支付",example = "补助基金支付")
    private String bzjjzf;

    /**
     * 人员编号
     */
    @ApiModelProperty(value = "人员编号",example = "人员编号")
    private String psnNo;

    /**
     * 参保地行政区号
     */
    @ApiModelProperty(value = "参保地行政区号",example = "参保地行政区号")
    private String aab301;

    /**
     * 险种
     */
    @ApiModelProperty(value = "险种",example = "险种")
    private String insutype;

    /**
     * 医保结算时间
     */
    @ApiModelProperty(value = "医保结算时间",example = "医保结算时间")
    private String setlTime;

    public String getSetlTime() {
        return setlTime;
    }

    public void setSetlTime(String setlTime) {
        this.setlTime = setlTime;
    }

    public String getPsnNo() {
        return psnNo;
    }

    public void setPsnNo(String psnNo) {
        this.psnNo = psnNo;
    }

    public String getAab301() {
        return aab301;
    }

    public void setAab301(String aab301) {
        this.aab301 = aab301;
    }

    public String getInsutype() {
        return insutype;
    }

    public void setInsutype(String insutype) {
        this.insutype = insutype;
    }

    public String getBzjjzf() {
        return bzjjzf;
    }

    public void setBzjjzf(String bzjjzf) {
        this.bzjjzf = bzjjzf;
    }

    public String getCardNo() {
        return cardNo;
    }

    public void setCardNo(String cardNo) {
        this.cardNo = cardNo;
    }

    public String getXtgzh0() {
        return xtgzh0;
    }

    public void setXtgzh0(String xtgzh0) {
        this.xtgzh0 = xtgzh0;
    }

    public String getOrgCode() {
        return orgCode;
    }

    public void setOrgCode(String orgCode) {
        this.orgCode = orgCode;
    }

    public String getDepositType() {
        return depositType;
    }

    public void setDepositType(String depositType) {
        this.depositType = depositType;
    }

    public String getDepositAmount() {
        return depositAmount;
    }

    public void setDepositAmount(String depositAmount) {
        this.depositAmount = depositAmount;
    }

    public String getXyzf00() {
        return xyzf00;
    }

    public void setXyzf00(String xyzf00) {
        this.xyzf00 = xyzf00;
    }

    public String getChannelType() {
        return channelType;
    }

    public void setChannelType(String channelType) {
        this.channelType = channelType;
    }

    public String getOutChargeNo() {
        return outChargeNo;
    }

    public void setOutChargeNo(String outChargeNo) {
        this.outChargeNo = outChargeNo;
    }

    public String getDjlsh0() {
        return djlsh0;
    }

    public void setDjlsh0(String djlsh0) {
        this.djlsh0 = djlsh0;
    }

    public String getMzlsh0() {
        return mzlsh0;
    }

    public void setMzlsh0(String mzlsh0) {
        this.mzlsh0 = mzlsh0;
    }

    public String getZhzfe0() {
        return zhzfe0;
    }

    public void setZhzfe0(String zhzfe0) {
        this.zhzfe0 = zhzfe0;
    }

    public String getGrzfe0() {
        return grzfe0;
    }

    public void setGrzfe0(String grzfe0) {
        this.grzfe0 = grzfe0;
    }

    public String getJjzfe0() {
        return jjzfe0;
    }

    public void setJjzfe0(String jjzfe0) {
        this.jjzfe0 = jjzfe0;
    }

    public String getGwybz0() {
        return gwybz0;
    }

    public void setGwybz0(String gwybz0) {
        this.gwybz0 = gwybz0;
    }

    public String getFybfy0() {
        return fybfy0;
    }

    public void setFybfy0(String fybfy0) {
        this.fybfy0 = fybfy0;
    }

    public String getCfdxje() {
        return cfdxje;
    }

    public void setCfdxje(String cfdxje) {
        this.cfdxje = cfdxje;
    }

    public String getBjjjzf() {
        return bjjjzf;
    }

    public void setBjjjzf(String bjjjzf) {
        this.bjjjzf = bjjjzf;
    }

    public String getSybxzf() {
        return sybxzf;
    }

    public void setSybxzf(String sybxzf) {
        this.sybxzf = sybxzf;
    }

    public String getBdgjzf() {
        return bdgjzf;
    }

    public void setBdgjzf(String bdgjzf) {
        this.bdgjzf = bdgjzf;
    }

    public String getYdgjzf() {
        return ydgjzf;
    }

    public void setYdgjzf(String ydgjzf) {
        this.ydgjzf = ydgjzf;
    }

    public String getBckbcs() {
        return bckbcs;
    }

    public void setBckbcs(String bckbcs) {
        this.bckbcs = bckbcs;
    }

    public String getBcbxf0() {
        return bcbxf0;
    }

    public void setBcbxf0(String bcbxf0) {
        this.bcbxf0 = bcbxf0;
    }

    public String getSfrq00() {
        return sfrq00;
    }

    public void setSfrq00(String sfrq00) {
        this.sfrq00 = sfrq00;
    }

    public String getSfsj00() {
        return sfsj00;
    }

    public void setSfsj00(String sfsj00) {
        this.sfsj00 = sfsj00;
    }

    public String getSfrxm0() {
        return sfrxm0;
    }

    public void setSfrxm0(String sfrxm0) {
        this.sfrxm0 = sfrxm0;
    }

    public String getGrzhye() {
        return grzhye;
    }

    public void setGrzhye(String grzhye) {
        this.grzhye = grzhye;
    }

    public String getYlzfje() {
        return ylzfje;
    }

    public void setYlzfje(String ylzfje) {
        this.ylzfje = ylzfje;
    }

    public String getJkzhzf() {
        return jkzhzf;
    }

    public void setJkzhzf(String jkzhzf) {
        this.jkzhzf = jkzhzf;
    }

    public String getJkzhye() {
        return jkzhye;
    }

    public void setJkzhye(String jkzhye) {
        this.jkzhye = jkzhye;
    }

    public String getYbmxls() {
        return ybmxls;
    }

    public void setYbmxls(String ybmxls) {
        this.ybmxls = ybmxls;
    }

    public String getDzsjfl() {
        return dzsjfl;
    }

    public void setDzsjfl(String dzsjfl) {
        this.dzsjfl = dzsjfl;
    }
}