package com.yihu.jw.gateway.filter;

import com.alibaba.fastjson.JSONObject;
import com.netflix.zuul.ZuulFilter;
import com.netflix.zuul.context.RequestContext;
import com.yihu.jw.gateway.AesEncryptUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Component;
import org.springframework.util.StreamUtils;

import javax.servlet.http.HttpServletRequest;
import java.io.InputStream;
import java.util.zip.GZIPInputStream;



@Component
public class PostFilter extends ZuulFilter {
 
    private static Logger logger = LoggerFactory.getLogger(PostFilter.class);
 
    @Override
    public String filterType() {
        //后置过滤器
        return "post";
    }
 
    @Override
    public int filterOrder() {
        //优先级，数字越大，优先级越低
        return 0;
    }
 
    @Override
    public boolean shouldFilter() {
        //是否执行该过滤器，true代表需要过滤
        return true;
    }
    @Override
    public Object run() {
        RequestContext ctx = RequestContext.getCurrentContext();
       /* BaseExceptionServerDictDao baseExceptionServiceDictDao = BeanUtil.getBean(BaseExceptionServerDictDao.class);
        BaseExceptionLogDao baseExceptionLogDao = BeanUtil.getBean(BaseExceptionLogDao.class);
        BaseExceptionService baseExceptionService = BeanUtil.getBean(BaseExceptionService.class);
       */ logger.info("进入post过滤器");
        HttpServletRequest request = ctx.getRequest();
        String url = request.getRequestURI();
        if (url.contains("/excelControl")||url.contains("/prescription/pushListWrite")||
                url.contains("/prescription/pushListDrug")||
                url.contains("/open/noLogin/pushYkCardCharge")||
                url.contains("/open/noLogin/pushListWriteHealthInfo")||
                url.contains("/open/noLogin/pushArticleCountExcel")||
                url.contains("/prescription/searchRecordWrite")||
                url.contains("/Funds/reconciliationExcel")||
                url.contains("/exportExcel/")||
                url.contains("/servicePackageSubItem/exportSubItemExcel")|| //导出
                url.contains("/Funds/deviceInfoExcel")){
            return true;
        }
        InputStream stream = RequestContext.getCurrentContext().getResponseDataStream();
        try {
        byte[] bytes;
        if(RequestContext.getCurrentContext().getResponseGZipped()){
            GZIPInputStream gzipInputStream = null;
            gzipInputStream = new GZIPInputStream(stream);
            bytes = StreamUtils.copyToByteArray(gzipInputStream);
        }else {
            bytes = StreamUtils.copyToByteArray(stream);
        }
        String body = new String(bytes,"UTF8");

        /*String serviceId="";
        String responseCode="";
        String exceptionType="";
        List<BaseExceptionServerDictDO> baseExceptionServerDictDOS =baseExceptionServiceDictDao.findServiceAll();
        for (BaseExceptionServerDictDO baseExceptionServerDictDO:baseExceptionServerDictDOS){
            if (url.contains(baseExceptionServerDictDO.getPath())){
                serviceId=baseExceptionServerDictDO.getId();
                break;
            }
        }
        try {
            net.sf.json.JSONObject jsonObject = net.sf.json.JSONObject.fromObject(body);
            String status =jsonObject.getString("status");
            if (!"200".equalsIgnoreCase(status)){
                jsonObject.put("status",serviceId+status);
                BaseExceptionLogDO baseExceptionLogDO = new BaseExceptionLogDO();
                baseExceptionLogDO.setCreateTime(new Date());
                List<Map<String,Object>> list = baseExceptionService.findExceptionDict("",status,"","1");
                if (list!=null&&list.size()>0){
                    responseCode=serviceId+list.get(0).get("code").toString();
                    exceptionType = list.get(0).get("exceptionType").toString();
                    baseExceptionLogDO.setExceptionType(exceptionType);
                    baseExceptionLogDO.setServiceCode(serviceId);
                    baseExceptionLogDO.setExceptionCode(responseCode);
                    try {
                        String  in = ctx.getRequest().getParameter("object");
                        String jsonobject = AesEncryptUtils.decrypt(in);
                        baseExceptionLogDO.setRequest(jsonobject);
                        baseExceptionLogDO.setResponse(jsonObject.toString());
                        baseExceptionLogDao.save(baseExceptionLogDO);
                    }catch (Exception s){
                        s.printStackTrace();
                    }
                }else {
                    String  in = ctx.getRequest().getParameter("object");
                    String requestParam = AesEncryptUtils.decrypt(in);
                    baseExceptionLogDO.setRequest(requestParam);
                    baseExceptionLogDO.setExceptionType("其他异常");
                    baseExceptionLogDO.setServiceCode(serviceId);
                    baseExceptionLogDO.setExceptionCode(status);
                    baseExceptionLogDO.setResponse(jsonObject.toString());
                    baseExceptionLogDao.save(baseExceptionLogDO);
                }
            }
        }catch (Exception e){
            e.printStackTrace();
        }*/
        logger.info("body",body+"=====status====="+ctx.getResponseStatusCode());
        JSONObject object = new JSONObject();
        object.put("status","200");
        object.put("data", AesEncryptUtils.encrypt(body));
        if (!(url.contains("/open/noLogin/notify")||
            url.contains("/open/noLogin/ylzReceiveNotify")||
            url.contains("/open/noLogin/receiveNotify")||
            url.contains("/open/noLogin/getSFExpressInfoNew")||
            url.contains("/open/noLogin/sfroutepushservice")||
            url.contains("/open/noLogin/ylzSettleRecord")||
                url.contains("/weixin")||url.contains("/oauth/getSsoPublicKey")||
                url.contains("/open/gc")||
                url.contains("/prescription/pushListWrite")||
                url.contains("/prescription/pushListDrug")||
                url.contains("/open/noLogin/pushYkCardCharge")||
                url.contains("/open/noLogin/pushListWriteHealthInfo")||
                url.contains("/open/noLogin/pushArticleCountExcel")||
                url.contains("/excelControl")||
                url.contains("/prescription/searchRecordWrite")||
                url.contains("/Funds/reconciliationExcel")||

                url.contains("/servicePackageSubItem/exportSubItemExcel")|| //导出

                url.contains("/Funds/deviceInfoExcel"))){
            RequestContext.getCurrentContext().setResponseBody(object.toJSONString());
        }else {
            RequestContext.getCurrentContext().setResponseBody(body);
        }

        logger.info("请求返回参数："+ctx.getResponseBody()+"");
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
 
    }

 
}