package com.yihu.jw.gateway.methlog;

import com.yihu.jw.entity.base.login.BaseLoginLogDO;
import com.yihu.jw.entity.hospital.consult.WlyyHospitalSysDictDO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.CollectionUtils;
import java.util.Date;
import java.util.List;

@Service
@Transactional
public class BaseLoginLogService {

    @Autowired
    private BaseLoginLogDao baseLoginLogDao;
    @Autowired
    private WlyyHospitalSysDictDao wlyyHospitalSysDictDao;
    /**
     * 根据openid 获取最新的一条数据
     * @param openid
     * @return
     */
    public BaseLoginLogDO findByOpenId(String openid) {
        List<BaseLoginLogDO> loginLogs = baseLoginLogDao.findByOpenId(openid);
        if(!CollectionUtils.isEmpty(loginLogs)){
            return loginLogs.get(0);
        }
        return null;
    }
    /*
     *根据userid获取数据
     *
     */
    public Boolean checkTime(String userId){
        List<BaseLoginLogDO> list = baseLoginLogDao.findByUserId(userId);
        long between = 0l;
        long timeOut = 1000*60*5;
        String idOperate = "OPERATE_TIME";
        WlyyHospitalSysDictDO wlyyHospitalSysDictDO = wlyyHospitalSysDictDao.findById(idOperate).orElse(null);
        if (null!=wlyyHospitalSysDictDO){
            String dictValue =wlyyHospitalSysDictDO.getDictValue()==null?"5":wlyyHospitalSysDictDO.getDictValue();
            timeOut = 1000*60*Integer.valueOf(dictValue);
        }
        if (list.size()>0){
            BaseLoginLogDO baseLoginLogDO = list.get(0);
            Date optiondate = baseLoginLogDO.getOperateTime();
            //如果操作时间为空则拿创建时间比较
            if (null==optiondate){
                optiondate = baseLoginLogDO.getCreateTime();
                Date nowTime = new Date(System.currentTimeMillis());
                between = nowTime.getTime() - optiondate.getTime();
                if (between>timeOut){
                    baseLoginLogDO.setOperateTime(new Date());
                    baseLoginLogDao.save(baseLoginLogDO);
                    return false;
                }else {
                    baseLoginLogDO.setOperateTime(new Date());
                    baseLoginLogDao.save(baseLoginLogDO);
                    return true;
                }

            }else {
                Date nowTime = new Date(System.currentTimeMillis());
                between = nowTime.getTime() - optiondate.getTime();
                if (between>timeOut){
                    baseLoginLogDO.setOperateTime(new Date());
                    baseLoginLogDao.save(baseLoginLogDO);
                    return false;
                }else {
                    baseLoginLogDO.setOperateTime(new Date());
                    baseLoginLogDao.save(baseLoginLogDO);
                    return true;
                }
            }
        }else {
            return false;
        }
    }



}
