package com.yihu.jw.security.dao.doctor;

import com.yihu.jw.entity.base.doctor.BaseDoctorDO;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;

import java.util.List;

/**
 *
 * 医生基础信息 数据库访问层
 *
 * @version
 * <pre>
 * Author	Version		Date		Changes
 * litaohong 	1.0  		2018年08月31日 	Created
 *
 * </pre>
 * @since 1.
 */

public interface BaseDoctorDao extends JpaRepository<BaseDoctorDO, String>, JpaSpecificationExecutor<BaseDoctorDO>  {

    @Modifying
    @Query("UPDATE BaseDoctorDO SET idcard = CONCAT(idcard,'-'),password = CONCAT(password,'-'), mobile = CONCAT(mobile,'-'),id = concat(id,'-')   WHERE id = ?1")
    void logOff(String id);

    @Query("from BaseDoctorDO d where d.idcard=?1 and d.del ='1'")
    BaseDoctorDO findByIdcard(String idcard);

    List<BaseDoctorDO> findByMobile(String mobile);

    @Query("from BaseDoctorDO d where  d.del ='1'")
    List<BaseDoctorDO> findByDel();

}
