package com.yihu.jw.security.login.service;

import com.yihu.jw.entity.base.login.BaseLoginLogDO;
import com.yihu.jw.security.login.dao.BaseLoginLogDao;
import com.yihu.jw.mysql.query.BaseJpaService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.repository.CrudRepository;
import org.springframework.stereotype.Service;
import org.springframework.util.CollectionUtils;

import java.util.List;
import java.util.Date;
@Service
public class BaseLoginLogService<T, R extends CrudRepository> extends BaseJpaService<BaseLoginLogDO, BaseLoginLogDao> {

    @Autowired
    private BaseLoginLogDao baseLoginLogDao;

    public BaseLoginLogDO findByToken(String token){
        return baseLoginLogDao.findByToken(token);
    }

    /**
     * 根据openid 获取最新的一条数据
     * @param openid
     * @return
     */
    public BaseLoginLogDO findByOpenId(String openid) {
        List<BaseLoginLogDO> loginLogs = baseLoginLogDao.findByOpenId(openid);
        if(!CollectionUtils.isEmpty(loginLogs)){
            return loginLogs.get(0);
        }
        return null;
    }
    /*
     *根据userid获取数据
     *
     */
    public Boolean checkTime(String userId){
        List<BaseLoginLogDO> list = baseLoginLogDao.findByUserId(userId);
        long between = 0l;
        long timeOut = 1000*60*5;
        if (list.size()>0){
            BaseLoginLogDO baseLoginLogDO = list.get(0);
            Date optiondate = baseLoginLogDO.getOperateTime();
            //如果操作时间为空则拿创建时间比较
            if (null==optiondate){
                optiondate = baseLoginLogDO.getCreateTime();
                Date nowTime = new Date(System.currentTimeMillis());
                between = nowTime.getTime() - optiondate.getTime();
                if (between>timeOut){
                    return false;
                }else {
                    baseLoginLogDO.setOperateTime(new Date());
                    baseLoginLogDao.save(baseLoginLogDO);
                    return true;
                }

            }else {
                Date nowTime = new Date(System.currentTimeMillis());
                between = nowTime.getTime() - optiondate.getTime();
                if (between>timeOut){
                    return false;
                }else {
                    baseLoginLogDO.setOperateTime(new Date());
                    baseLoginLogDao.save(baseLoginLogDO);
                    return true;
                }
            }
        }else {
            return false;
        }
    }



}
