package com.yihu.jw.security.service;

import com.alibaba.fastjson.JSONObject;
import com.yihu.jw.entity.base.ca.OauthCaConfigDO;
import com.yihu.jw.security.dao.OauthCaConfigDao;
import com.yihu.jw.security.utils.qrcode.QRCodeService;
import com.yihu.jw.security.utils.qrcode.QRCodeServiceImplServiceLocator;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.net.URL;

/**
 * Created by Trick on 2019/12/25.
 */
@Service
@Transactional
public class OauthCaConfigSerivce {

    private Logger logger = LoggerFactory.getLogger(OauthCaConfigSerivce.class);

    @Autowired
    private OauthCaConfigDao oauthCaConfigDao;

    /**
     *
     * 中山生成二维码
     * @param sys
     * @return
     */
    public String getQRCode(String sys) {
        try {
            logger.info("生成二维码 getQRCode :"+sys);
            OauthCaConfigDO oauthCaConfigDO = oauthCaConfigDao.getOne("oauth_ca_config");
            QRCodeServiceImplServiceLocator locator = new QRCodeServiceImplServiceLocator();
            URL portAddress = new URL(oauthCaConfigDO.getUrl());
            QRCodeService service = locator.getQRCodeServiceImplPort(portAddress);
            return service.SOF_GetQRCodeBySys(sys);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }


    /**
     * 查询二维码授权结果
     * @param qrcode
     * @return
     */
    public JSONObject getQueryQRCode(String qrcode){
        try {
            OauthCaConfigDO oauthCaConfigDO = oauthCaConfigDao.getOne("oauth_ca_config");
            QRCodeServiceImplServiceLocator locator = new QRCodeServiceImplServiceLocator();
            URL portAddress = new URL(oauthCaConfigDO.getUrl());
            QRCodeService service = locator.getQRCodeServiceImplPort(portAddress);

            String rs = service.SOF_QueryQRCode(qrcode);
            logger.info("验证二维码 getQueryQRCode :"+rs);

            return JSONObject.parseObject(rs);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return null;
    }

    public static void main(String[] args) {
        try {
            QRCodeServiceImplServiceLocator locator = new QRCodeServiceImplServiceLocator();
            URL portAddress = new URL("http://47.100.121.92:8088/PKIQRCode/services/v1?wsdl");
            QRCodeService service = locator.getQRCodeServiceImplPort(portAddress);
            // 旧获取二维码接口
//            System.out.println(service.SOF_GetQRCode());
            // 新获取二维码接口
            System.out.println(service.SOF_GetQRCodeBySys("EMR"));
            // 获取二维码状态接口
            System.out.println(service.SOF_QueryQRCode("oFgFqfz7IDKfBGh93aU507Tj9UoOzJiCJ7pVAqDC8CwkFZmxo8uq3IcvgtY48y5vqRdc7vvVkUuMNH0hN-h3yQ"));
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
