package com.yihu.jw.security.service;

import com.alibaba.fastjson.JSONObject;
import com.yihu.jw.entity.base.doctor.BaseDoctorDO;
import com.yihu.jw.entity.base.doctor.BaseDoctorHospitalDO;
import com.yihu.jw.entity.base.doctor.BaseDoctorRoleDO;
import com.yihu.jw.entity.base.role.RoleDO;
import com.yihu.jw.entity.base.user.UserDO;
import com.yihu.jw.entity.equipment.WlyyUserAreaDO;
import com.yihu.jw.entity.equipment.WlyyUserEquipmentDO;
import com.yihu.jw.entity.hospital.mapping.DoctorMappingDO;
import com.yihu.jw.entity.third.wlyyinfo.OauthWlyyConfigDO;
import com.yihu.jw.security.dao.OauthWlyyConfigDao;
import com.yihu.jw.security.dao.doctor.BaseDoctorDao;
import com.yihu.jw.security.dao.doctor.BaseDoctorHospitalDao;
import com.yihu.jw.security.dao.doctor.BaseDoctorRoleDao;
import com.yihu.jw.security.dao.doctor.DoctorMappingDao;
import com.yihu.jw.security.dao.iot.UserDao;
import com.yihu.jw.security.dao.user.RoleDao;
import com.yihu.jw.security.dao.user.WlyyUserAreaDao;
import com.yihu.jw.security.dao.user.WlyyUserEquipmentDao;
import com.yihu.jw.util.http.HttpClientUtil;
import com.yihu.jw.util.encrypt.MD5;
import org.apache.commons.collections.map.HashedMap;
import org.apache.commons.lang3.StringUtils;
import org.apache.http.NameValuePair;
import org.apache.http.message.BasicNameValuePair;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;

/**
 * Created by Trick on 2019/8/6
 */
@Service
@Transactional
public class OauthWlyyConfigService {

    private static final Logger logger = LoggerFactory.getLogger(OauthWlyyConfigService.class);

    @Autowired
    private HttpClientUtil httpClientUtil;
    @Autowired
    private OauthWlyyConfigDao oauthWlyyConfigDao;
    @Autowired
    private BaseDoctorDao baseDoctorDao;
    @Autowired
    private BaseDoctorHospitalDao baseDoctorHospitalDao;
    @Autowired
    private BaseDoctorRoleDao baseDoctorRoleDao;
    @Autowired
    private JdbcTemplate jdbcTemplate;
    @Autowired
    private DoctorMappingDao doctorMappingDao;
    @Autowired
    private UserDao userDao;
    @Autowired
    private WlyyUserAreaDao userAreaDao;
    @Autowired
    private WlyyUserEquipmentDao userEquipmentDao;
    @Autowired
    private RoleDao roleDao;

    public JSONObject checkWlyyDoctor(String code)throws Exception{

        OauthWlyyConfigDO oauthWlyyConfigDO = oauthWlyyConfigDao.getOne("wlyyConfig");
        //token获取accesstoken
        List<NameValuePair> params = new ArrayList<>();
        params.add(new BasicNameValuePair("appid", oauthWlyyConfigDO.getAppId()));
        params.add(new BasicNameValuePair("appSecret",oauthWlyyConfigDO.getAppSecret()));
        String res = httpClientUtil.post(oauthWlyyConfigDO.getTokenUrl(),params,"UTF-8");
        String token = null;
        JSONObject rsjson = JSONObject.parseObject(res);

        logger.info("checkWlyyDoctor token ："+rsjson.toString());

        Integer status = rsjson.getInteger("status");
        if(status==10000){

            //设置入参
            List<NameValuePair> p = new ArrayList<>();
            p.add(new BasicNameValuePair("doctor", code));

            //设置头部
            token = rsjson.getJSONObject("result").getString("accesstoken");
            Map<String,Object> headerMap = new HashedMap();
            headerMap.put("accesstoken",token);

            String rs = httpClientUtil.headerPost(oauthWlyyConfigDO.getUrl(),p,"UTF-8",headerMap);
            logger.info("checkWlyyDoctor doctorInfo ："+rs);

            JSONObject auth = JSONObject.parseObject(rs);
            Integer s = auth.getInteger("status");

            if(s == 200){
                JSONObject data = auth.getJSONObject("data");
                String authCode =  data.getString("authCode");
                if("1".equals(authCode)){
                    JSONObject doctorJson = data.getJSONObject("doctor");
                    String idcard = doctorJson.getString("idcard");

                    if(StringUtils.isBlank(idcard)){
                        data.put("authCode","-3");
                        data.put("mes","I健康账户信息不完整,授权失败");
                        return data;
                    }
                    List<Map<String,Object>> dutys = findDutys();

                    BaseDoctorDO doctorDO = baseDoctorDao.findByIdcard(idcard);
                    if(doctorDO!=null){
                        Integer level =  doctorJson.getInteger("level");
                        if(level==null||level!=1){
                            //判断区信息 补充数据
                            if(StringUtils.isBlank(doctorDO.getTownCode())){
                                doctorDO.setTownCode(doctorJson.getString("town"));
                                doctorDO.setTownName(doctorJson.getString("townName"));
                                baseDoctorDao.save(doctorDO);
                            }

                            //判断不充机构信息
                            List<BaseDoctorHospitalDO> hospitalDOs = baseDoctorHospitalDao.findByDoctorCode(doctorDO.getId());
                            if(hospitalDOs!=null&&hospitalDOs.size()>0){
                                //不新增
                            }else{
                                //补充机构信息
                                BaseDoctorHospitalDO hospitalDO = new BaseDoctorHospitalDO();
                                hospitalDO.setDoctorCode(doctorDO.getId());
                                hospitalDO.setOrgCode(doctorJson.getString("hospital"));
                                hospitalDO.setOrgName(doctorJson.getString("hospitalName"));
                                hospitalDO.setDel("1");
                                baseDoctorHospitalDao.save(hospitalDO);
                            }

                            List<BaseDoctorRoleDO> roleDOs = baseDoctorRoleDao.findByDoctorCode(doctorDO.getId());

                            //判断不充角色信息
                            if(roleDOs!=null&&roleDOs.size()>0){
                                //不新增
                            }else{

                                BaseDoctorRoleDO role = new BaseDoctorRoleDO();
                                role.setDoctorCode(doctorDO.getId());
                                if(level!=null&&level==1){
                                    role.setRoleCode("specialist");
                                }else {
                                    role.setRoleCode("generalDoctor");
                                }


                                baseDoctorRoleDao.save(role);
                            }
                        }
                        return data;
                    }else{
                        //存储医生全科医生信息
                        BaseDoctorDO doctor = new BaseDoctorDO();
                        doctor.setName(doctorJson.getString("name"));
                        doctor.setIdcard(doctorJson.getString("idcard"));
                        doctor.setMobile(doctorJson.getString("mobile"));
                        doctor.setSex(doctorJson.getInteger("sex"));
                        doctor.setBirthday(doctorJson.getDate("birthday"));
                        doctor.setProvinceCode(doctorJson.getString("province"));
                        doctor.setProvinceName(doctorJson.getString("provinceName"));
                        doctor.setTownCode(doctorJson.getString("town"));
                        doctor.setTownName(doctorJson.getString("townName"));
                        doctor.setCityCode(doctorJson.getString("city"));
                        doctor.setCityName(doctorJson.getString("cityName"));

                        //认证信息设置
                        String salt = randomString(5);
                        String pw = idcard.substring(idcard.length()-6);
                        doctor.setPassword(MD5.md5Hex(pw + "{" + salt + "}"));
                        doctor.setDel("1");
                        doctor.setEnabled(1);
                        doctor.setLocked(0);
                        doctor.setCreateTime(new Date());

                        String jobName = doctorJson.getString("jobName");
                        doctor.setJobTitleCode(getDutysCode(dutys,jobName));
                        doctor.setJobTitleName(jobName);

                        BaseDoctorDO temp = baseDoctorDao.save(doctor);

                        //机构信息
                        BaseDoctorHospitalDO hospitalDO = new BaseDoctorHospitalDO();
                        hospitalDO.setDoctorCode(temp.getId());
                        hospitalDO.setOrgCode(doctorJson.getString("hospital"));
                        hospitalDO.setOrgName(doctorJson.getString("hospitalName"));
                        hospitalDO.setDeptCode(doctorJson.getString("dept"));
                        hospitalDO.setDeptName(doctorJson.getString("deptName"));
                        hospitalDO.setDel("1");
                        baseDoctorHospitalDao.save(hospitalDO);

                        Integer level =  doctorJson.getInteger("level");
                        BaseDoctorRoleDO role = new BaseDoctorRoleDO();
                        if(level!=null&&level==1){
                            role.setRoleCode("specialist");
                        }else {
                            role.setRoleCode("generalDoctor");
                        }
                        role.setDoctorCode(temp.getId());
                        baseDoctorRoleDao.save(role);

                        //保存
                        DoctorMappingDO mappingDO = new DoctorMappingDO();
                        mappingDO.setIdcard(idcard);
                        mappingDO.setDoctor(temp.getId());
                        mappingDO.setOrgCode(doctorJson.getString("hospital"));
                        mappingDO.setOrgName(doctorJson.getString("hospitalName"));
                        mappingDO.setMappingCode(temp.getId());
                        mappingDO.setDoctorName(temp.getName());
                        mappingDO.setMappingDeptName(temp.getName());
                        mappingDO.setCreateTime(new Date());
                        doctorMappingDao.save(mappingDO);
                        return data;
                    }
                }else{
                    return data;
                }
            }else{
                //请求异常
                JSONObject data = new JSONObject();
                data.put("authCode","-2");
                return data;
            }
        }else {
            //请求异常
            JSONObject data = new JSONObject();
            data.put("authCode","-2");
            return data;
        }

    }


    public JSONObject checkWlyyUserDoctor(String doctor)throws Exception{

        OauthWlyyConfigDO oauthWlyyConfigDO = oauthWlyyConfigDao.getOne("wlyyConfig");
        //token获取accesstoken
        List<NameValuePair> params = new ArrayList<>();
        params.add(new BasicNameValuePair("appid", oauthWlyyConfigDO.getAppId()));
        params.add(new BasicNameValuePair("appSecret",oauthWlyyConfigDO.getAppSecret()));
        String res = httpClientUtil.post(oauthWlyyConfigDO.getTokenUrl(),params,"UTF-8");
        String token = null;
        JSONObject rsjson = JSONObject.parseObject(res);

        logger.info("checkWlyyDoctor token ："+rsjson.toString());

        Integer status = rsjson.getInteger("status");
        if(status==10000){

            //设置入参
            List<NameValuePair> p = new ArrayList<>();
            p.add(new BasicNameValuePair("doctor", doctor));

            //设置头部
            token = rsjson.getJSONObject("result").getString("accesstoken");
            Map<String,Object> headerMap = new HashedMap();
            headerMap.put("accesstoken",token);

            String rs = httpClientUtil.headerPost(oauthWlyyConfigDO.getUrl(),p,"UTF-8",headerMap);
            logger.info("checkWlyyDoctor doctorInfo ："+rs);

            JSONObject auth = JSONObject.parseObject(rs);
            Integer s = auth.getInteger("status");

            if(s == 200){
                JSONObject data = auth.getJSONObject("data");
                String authCode =  data.getString("authCode");
                if("1".equals(authCode)){
                    JSONObject doctorJson = data.getJSONObject("doctor");
                    String idcard = doctorJson.getString("idcard");
                    String mobile = doctorJson.getString("mobile");

                    if(StringUtils.isBlank(idcard)){
                        data.put("authCode","-3");
                        data.put("mes","I健康账户信息不完整,授权失败");
                        return data;
                    }

                    UserDO userDO = userDao.findByMobile(mobile);
                    if(userDO!=null){
                        return data;
                    }else{
                        //存储医生全科医生信息
                        userDO = new UserDO();
                        userDO.setSaasId("808080eb7bc87123017bf16ba0ad0046");
                        userDO.setName(doctorJson.getString("name"));
                        userDO.setIdcard(doctorJson.getString("idcard"));
                        userDO.setUsername(doctorJson.getString("mobile"));
                        userDO.setMobile(doctorJson.getString("mobile"));
                        if (doctorJson.getInteger("sex")==1){
                            userDO.setGender(UserDO.Gender.male);
                        }else if (doctorJson.getInteger("sex")==2){
                            userDO.setGender(UserDO.Gender.female);
                        }
                        //认证信息设置
                        String salt = randomString(5);
                        String pw = idcard.substring(idcard.length()-6);
                        userDO.setPassword(MD5.md5Hex(pw + "{" + salt + "}"));
                        userDO.setSalt(salt);
                        userDO.setEnabled(true);
                        userDO.setLocked(false);
                        userDO.setCreateTime(new Date());
                        userDO.setUpdateTime(new Date());
                        userDO = userDao.save(userDO);
                        //18补货员19社区药柜管理员20药柜区域管理员21药柜超级管理员
                        String expandLevel = doctorJson.getString("expandLevel");
                        RoleDO roleDO = roleDao.getOne(expandLevel);
                        userDO.setRoleId(roleDO.getId());
                        userDO = userDao.save(userDO);
                        List<WlyyUserAreaDO> userAreaDOList = userAreaDao.findAllByUserId(userDO.getId());
                        if (userAreaDOList==null||userAreaDOList.size()==0){
                            WlyyUserAreaDO userAreaDO = new  WlyyUserAreaDO();
                            userAreaDO.setUserId(userDO.getId());
                            userAreaDO.setCity(doctorJson.getString("city"));
                            userAreaDO.setCityName(doctorJson.getString("cityName"));
                            userAreaDO.setTown(doctorJson.getString("town"));
                            userAreaDO.setTownName(doctorJson.getString("townName"));
                            userAreaDO.setHospital(doctorJson.getString("hospital"));
                            userAreaDO.setHospitalName(doctorJson.getString("hospitalName"));
                            userAreaDO.setUpdateTime(new Date());
                            userAreaDO.setCreateTime(new Date());
                            userAreaDO.setDel(1);
                            userAreaDao.save(userAreaDO);
                        }
                        if (roleDO.getCode().equalsIgnoreCase("replenisher")){
                            String sql = "select d.id as id,d.equ_name as name from t_mediicine_device d where d.belong_community ='"+doctorJson.getString("hospital")+"' ";
                            List<Map<String,Object>> mapList = jdbcTemplate.queryForList(sql);
                            for (Map<String,Object> map:mapList){
                                WlyyUserEquipmentDO equipmentDO = new WlyyUserEquipmentDO();
                                String id = map.get("id").toString();
                                String name = map.get("name")==null?"":map.get("name").toString();
                                equipmentDO.setEquipmentId(id);
                                equipmentDO.setEquipmentName(name);
                                equipmentDO.setUserId(userDO.getId());
                                equipmentDO.setDel(1);
                                equipmentDO.setCityName(doctorJson.getString("cityName"));
                                equipmentDO.setCity(doctorJson.getString("city"));
                                equipmentDO.setTown(doctorJson.getString("town"));
                                equipmentDO.setTownName(doctorJson.getString("townName"));
                                equipmentDO.setHospital(doctorJson.getString("hospital"));
                                equipmentDO.setHospitalName(doctorJson.getString("hospitalName"));
                                equipmentDO.setCreateTime(new Date());
                                equipmentDO.setUpdateTime(new Date());
                                userEquipmentDao.save(equipmentDO);
                            }

                        }
                        return data;
                    }
                }else{
                    return data;
                }
            }else{
                //请求异常
                JSONObject data = new JSONObject();
                data.put("authCode","-2");
                return data;
            }
        }else {
            //请求异常
            JSONObject data = new JSONObject();
            data.put("authCode","-2");
            return data;
        }

    }


    /**
     * 获取全部职称
     * @return
     */
    public List<Map<String,Object>> findDutys(){
        String sql = "select code,name from dict_doctor_duty";
        return jdbcTemplate.queryForList(sql);
    }

    public String getDutysCode(List<Map<String,Object>> dutys,String name){
        if(StringUtils.isNotBlank(name)){
            for(Map<String,Object> d:dutys){
                String duty = (String)d.get("name");
                if(name.equals(duty)){
                    return (String)d.get("code");
                }
            }
        }
        return "";
    }

    public String randomString(int length) {
        String str = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789";
        StringBuffer buffer = new StringBuffer();
        Random random = new Random();

        for(int i = 0; i < length; ++i) {
            int pos = random.nextInt(str.length());
            buffer.append(str.charAt(pos));
        }

        return buffer.toString();
    }
}
