package com.yihu.jw.security.service;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.yihu.jw.entity.base.patient.BasePatientDO;
import com.yihu.jw.entity.hospital.family.WlyyPatientFamilyMemberDO;
import com.yihu.jw.entity.third.ylzinfo.OauthYlzConfigDO;
import com.yihu.jw.security.dao.OauthYlzConfigDao;
import com.yihu.jw.security.dao.patient.BasePatientDao;
import com.yihu.jw.security.dao.patient.WlyyPatientFamilyMemberDao;
import com.yihu.jw.security.utils.ByteToInputStream;
import com.yihu.jw.security.utils.DateUtil;
import com.yihu.jw.security.utils.QrcodeUtil;
import com.yihu.jw.util.idcard.IdCardUtil;
import com.yihu.jw.util.encrypt.MD5;
import com.ylzinfo.ehc.EhcHandler;
import com.ylzinfo.ehc.common.utils.DateUtils;
import com.ylzinfo.ehc.trans.TransRequest;
import com.ylzinfo.ehc.trans.TransResponse;
import org.apache.commons.collections.map.HashedMap;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.io.InputStream;
import java.util.Date;
import java.util.Map;
import java.util.UUID;

/**
 * Created by Trick on 2019/7/26.
 */
@Service
public class OauthYlzConfigService {

    private static final Logger logger = LoggerFactory.getLogger(OauthYlzConfigService.class);

    @Autowired
    private OauthYlzConfigDao oauthYlzConfigDao;
    @Autowired
    private BasePatientDao basePatientDao;
    @Autowired
    private WlyyPatientFamilyMemberDao familyMemberDao;

//    @Value("${fastDFS.fastdfs_file_url}")
//    private String fastdfs_file_url;
//
//    @Value("${testPattern.sign}")
//    private String isClose;

//    @Value("${testPattern.remote_inner_url}")
//    private String remote_inner_url;

    @Autowired
    private ObjectMapper objectMapper;

//    public Map<String,Object> getOauthQRCode(){
//        try {
//            OauthYlzConfigDO oauthYlzConfigDO = oauthYlzConfigDao.findOne("ylz_config");
//            TransRequest e = new TransRequest();
//            e.setMethod("ehc.ehealthcard.authurl");
//            e.setApp_id(oauthYlzConfigDO.getAppId());
//            e.setTerm_id(oauthYlzConfigDO.getTermId());
//            e.setVersion(oauthYlzConfigDO.getVersion());
//            e.setTimestamp(DateUtil.dateToStr(new Date(),"yyyyMMddHHmmss"));
//            e.setSign_type(oauthYlzConfigDO.getSignType());
//            e.setEnc_type(oauthYlzConfigDO.getEncType());
//            com.alibaba.fastjson.JSONObject bizContent = new com.alibaba.fastjson.JSONObject();
//            String no = UUID.randomUUID().toString().substring(0,30);
//            bizContent.put("out_authorize_no", no);
//            bizContent.put("out_authorize_time", DateUtils.getOutTradeTime());
//            e.setBiz_content(JSON.toJSONString(bizContent));
//
//            String param = com.alibaba.fastjson.JSONObject.toJSONString(e);
//            logger.info("TransRequest :"+param);
//
//            EhcHandler ehcHandler = new EhcHandler(oauthYlzConfigDO.getUrl(), oauthYlzConfigDO.getAppId(), oauthYlzConfigDO.getTermId(), oauthYlzConfigDO.getAppKey());
//            TransResponse re = ehcHandler.execute(e);
//
//            String rs = com.alibaba.fastjson.JSONObject.toJSONString(re);
//            logger.info("TransResponse :"+rs);
//
//            com.alibaba.fastjson.JSONObject json = (com.alibaba.fastjson.JSONObject) com.alibaba.fastjson.JSONObject.parse(rs);
//            com.alibaba.fastjson.JSONObject biz = json.getJSONObject("biz_content");
//            InputStream qrcode = QrcodeUtil.createQrcode(biz.getString("ehealth_authurl"),300,"jpg");
//
//            Map<String,Object> map = new HashedMap();
//
//            if(isClose.equals("2")){
//                //内网上传
//                MultipartFile file = new MockMultipartFile("qrcode.jpg","qrcode.jpg","qrcode.jpg",qrcode);
//                String rsJson = fileUploadService.request(remote_inner_url,file,null);
//
//                logger.info("内网上传"+rsJson);
//                JSONObject uploadJson = JSON.parseObject(rsJson);
//
//                UploadVO uploadVO = objectMapper.readValue(uploadJson.getJSONObject("obj").toJSONString(),UploadVO.class);
//                map.put("fileName",uploadVO.getFileName());
//                map.put("fileType",uploadVO.getFileType());
//                map.put("fullUrl",uploadVO.getFullUrl());
//                map.put("fullUri",uploadVO.getFullUri());
//                map.put("out_authorize_no",no);
//
//                logger.info("fileUploadService:"+map.toString());
//            }else {
//                // 得到文件的完整名称  xxx.txt
//                logger.info("fastdfs_file_url:"+fastdfs_file_url);
//                UploadVO uploadVO = fileUploadService.uploadStream(qrcode,"qrcode.jpg",fastdfs_file_url);
//                map = new HashedMap();
//                map.put("fileName",uploadVO.getFileName());
//                map.put("fileType",uploadVO.getFileType());
//                map.put("fullUrl",uploadVO.getFullUrl());
//                map.put("fullUri",uploadVO.getFullUri());
//                map.put("out_authorize_no",no);
//                logger.info("fileUploadService:"+map.toString());
//            }
//
//            return map;
//        } catch (Exception var5) {
//            logger.info("获取电子健康卡图片异常");
//            var5.printStackTrace();
//        }
//
//        return null;
//    }

    public Map<String,Object> getOauthQRCodeImg(){
        try {
            logger.info("getOauthQRCodeImg dao1:"+DateUtil.dateToStr(new Date(),"yyyy-MM-dd HH:mm:ss:SSS"));
            OauthYlzConfigDO oauthYlzConfigDO = oauthYlzConfigDao.getOne("ylz_config");
            logger.info("getOauthQRCodeImg dao2:"+DateUtil.dateToStr(new Date(),"yyyy-MM-dd HH:mm:ss:SSS"));
            TransRequest e = new TransRequest();
            e.setMethod("ehc.ehealthcard.authurl");
            e.setApp_id(oauthYlzConfigDO.getAppId());
            e.setTerm_id(oauthYlzConfigDO.getTermId());
            e.setVersion(oauthYlzConfigDO.getVersion());
            e.setTimestamp(DateUtil.dateToStr(new Date(),"yyyyMMddHHmmss"));
            e.setSign_type(oauthYlzConfigDO.getSignType());
            e.setEnc_type(oauthYlzConfigDO.getEncType());
            com.alibaba.fastjson.JSONObject bizContent = new com.alibaba.fastjson.JSONObject();
            String no = UUID.randomUUID().toString().substring(0,30);
            bizContent.put("out_authorize_no", no);
            bizContent.put("out_authorize_time", DateUtils.getOutTradeTime());
            e.setBiz_content(JSON.toJSONString(bizContent));

            String param = com.alibaba.fastjson.JSONObject.toJSONString(e);
            logger.info("TransRequest :"+param);

            EhcHandler ehcHandler = new EhcHandler(oauthYlzConfigDO.getUrl(), oauthYlzConfigDO.getAppId(), oauthYlzConfigDO.getTermId(), oauthYlzConfigDO.getAppKey());
            TransResponse re = ehcHandler.execute(e);

            String rs = com.alibaba.fastjson.JSONObject.toJSONString(re);

            logger.info("TransResponse:"+DateUtil.dateToStr(new Date(),"yyyy-MM-dd HH:mm:ss:SSS")+" "+rs);
            JSONObject json =JSONObject.parseObject(rs);
            JSONObject biz = json.getJSONObject("biz_content");
            InputStream qrcode = QrcodeUtil.createQrcode(biz.getString("ehealth_authurl"),300,"jpg");

            ByteToInputStream byteToInputStream = new ByteToInputStream();
            String QRCodeImg = byteToInputStream.getBase64FromInputStream(qrcode);

            Map<String,Object> map = new HashedMap();
            map.put("QRCodeImg","data:image/png;base64,"+ QRCodeImg);
            map.put("out_authorize_no",no);

            return map;
        } catch (Exception e) {
            logger.error(e.toString());
        }

        return null;
    }

    /**
     * 验证电子健康卡授权
     * @param authorizeNo
     * @return
     */
    @Transactional
    public Map<String,Object> checkOauthQRCode(String authorizeNo){

        Map<String,Object> rsMap = new HashedMap();
        OauthYlzConfigDO oauthYlzConfigDO = oauthYlzConfigDao.getOne("ylz_config");
        try {
            TransRequest e = new TransRequest();
            e.setMethod("ehc.ehealthcard.auth.query");
            e.setApp_id(oauthYlzConfigDO.getAppId());
            e.setTerm_id(oauthYlzConfigDO.getTermId());
            e.setVersion(oauthYlzConfigDO.getVersion());
            e.setTimestamp(DateUtil.dateToStr(new Date(),"yyyyMMddHHmmss"));
            e.setSign_type(oauthYlzConfigDO.getSignType());
            e.setEnc_type(oauthYlzConfigDO.getEncType());
            com.alibaba.fastjson.JSONObject bizContent = new com.alibaba.fastjson.JSONObject();
            bizContent.put("out_authorize_no", authorizeNo);
            e.setBiz_content(JSON.toJSONString(bizContent));

            EhcHandler ehcHandler = new EhcHandler(oauthYlzConfigDO.getUrl(), oauthYlzConfigDO.getAppId(), oauthYlzConfigDO.getTermId(), oauthYlzConfigDO.getAppKey());
            TransResponse re = ehcHandler.execute(e);
            String rs = com.alibaba.fastjson.JSONObject.toJSONString(re);
            logger.info("checkOauthQRCode TransResponse :"+DateUtil.dateToStr(new Date(),"yyyy-MM-dd HH:mm:ss:SSS")+" "+rs);

            com.alibaba.fastjson.JSONObject json = (com.alibaba.fastjson.JSONObject) com.alibaba.fastjson.JSONObject.parse(rs);

            String ret_code = json.getString("ret_code");
            if("0000".equals(ret_code)){
                com.alibaba.fastjson.JSONObject biz = json.getJSONObject("biz_content");
                String  auth_status = biz.getString("auth_status");
                if("succ".equals(auth_status)){
                    String idcard = biz.getString("id_no");
                    String cardType = biz.getString("id_type");
                    BasePatientDO patientDO =  basePatientDao.findByIdcardAndDel(idcard,"1");
                    if(StringUtils.isNotBlank(idcard)&&patientDO == null){
                        BasePatientDO patient = new BasePatientDO();

                        String salt = UUID.randomUUID().toString().substring(0,5);
                        String mobile = biz.getString("mobile_phone");
                        String pw = null;

                        if(StringUtils.isNotBlank(mobile)){
                            pw = mobile.substring(mobile.length()-6);
                        }else{
                            pw = idcard.substring(idcard.length()-6);
                        }

                        patient.setIdcard(idcard);
                        patient.setName(biz.getString("user_name"));
                        patient.setPassword(MD5.md5Hex(pw + "{" + salt + "}"));
                        patient.setSalt(salt);
                        patient.setMobile(mobile);
                        patient.setDel("1");
                        patient.setEnabled(1);
                        patient.setLocked(0);
                        patient.setSex(Integer.parseInt(IdCardUtil.getSexForIdcard_new(idcard)));
                        patient.setCreateTime(new Date());
                        patient.setUpdateTime(new Date());
                        patient.setCardType(cardType);
                        patient.setBirthday(DateUtil.strToDate(biz.getString("birthday"),"yyyyMMdd"));
                        patientDO = basePatientDao.save(patient);
                        WlyyPatientFamilyMemberDO basePatientFamilyMemberDO = familyMemberDao.findFamilyMemberByPatientAndRelationCode(patientDO.getId(),"7");
                        if (basePatientFamilyMemberDO==null){
                            basePatientFamilyMemberDO = new WlyyPatientFamilyMemberDO();
                            basePatientFamilyMemberDO.setPatient(patientDO.getId());
                            basePatientFamilyMemberDO.setFamilyRelation("7");
                            basePatientFamilyMemberDO.setFamilyRelationName("自己");
                            basePatientFamilyMemberDO.setCardType("身份证");
                            basePatientFamilyMemberDO.setCardNo(patientDO.getIdcard());
                            basePatientFamilyMemberDO.setCreateTime(new Date());
                            basePatientFamilyMemberDO.setUpdateTime(new Date());
                            basePatientFamilyMemberDO.setIsAuthorize(1);
                            basePatientFamilyMemberDO.setIsDel(1);
                            basePatientFamilyMemberDO.setFamilyMember(patientDO.getId());
                            familyMemberDao.save(basePatientFamilyMemberDO);
                        }
                        rsMap.put("sCode",auth_status);
                        rsMap.put("sMes","success");
                        rsMap.put("patient",patient);
                        return rsMap;
                    }else{
                        patientDO.setCardType(cardType);
                        basePatientDao.save(patientDO);
                        WlyyPatientFamilyMemberDO basePatientFamilyMemberDO = familyMemberDao.findFamilyMemberByPatientAndRelationCode(patientDO.getId(),"7");
                        if (basePatientFamilyMemberDO==null){
                            basePatientFamilyMemberDO = new WlyyPatientFamilyMemberDO();
                            basePatientFamilyMemberDO.setPatient(patientDO.getId());
                            basePatientFamilyMemberDO.setFamilyRelation("7");
                            basePatientFamilyMemberDO.setFamilyRelationName("自己");
                            basePatientFamilyMemberDO.setCardType("身份证");
                            basePatientFamilyMemberDO.setCardNo(patientDO.getIdcard());
                            basePatientFamilyMemberDO.setCreateTime(new Date());
                            basePatientFamilyMemberDO.setUpdateTime(new Date());
                            basePatientFamilyMemberDO.setIsAuthorize(1);
                            basePatientFamilyMemberDO.setIsDel(1);
                            basePatientFamilyMemberDO.setFamilyMember(patientDO.getId());
                            familyMemberDao.save(basePatientFamilyMemberDO);
                        }
                        rsMap.put("sCode",auth_status);
                        rsMap.put("sMes","success");
                        rsMap.put("patient",patientDO);
                        return rsMap;
                    }
                }else if("ing".equals(auth_status)){
                    rsMap.put("sCode",auth_status);
                    rsMap.put("sMes","正在授权");
                    return rsMap;
                }else if("fail".equals(auth_status)){
                    rsMap.put("sCode",auth_status);
                    rsMap.put("sMes","授权失败");
                    return rsMap;
                }else if("cancel".equals(auth_status)){
                    rsMap.put("sCode",auth_status);
                    rsMap.put("sMes","取消授权");
                    return rsMap;
                }
            }
            rsMap.put("sCode","err");
            rsMap.put("sMes","请求失败");
            return rsMap;

        }catch (Exception e){
            e.printStackTrace();
        }
        rsMap.put("sCode","err");
        rsMap.put("sMes","请求失败");
        return rsMap;
    }
}
