//package com.xmca.demo.util;
package com.yihu.jw.security.utils;

//import lombok.extern.slf4j.Slf4j;
//import sun.misc.BASE64Decoder;
import javax.crypto.Cipher;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;

import com.yihu.jw.util.encrypt.MD5;
import org.apache.commons.codec.binary.Base64;


/**
 * AES算法工具类
 *
 * @author by YeMingXiang
 * @date   2019/07/02
 */
//@Slf4j
public class AesUtilsByDigitalCloudSign
{
	//测试用例
	public  static  void  main( String[]  args ) 
	{
		String  strOriginData = "zL9+oTclzZhf3NkHqD4NO95mXwkcuVW+6y27kb+5fCo="; //原文，带中文
		// strOriginData = "123test";
		
		System.out.println( "原文为：" +   strOriginData ); 
		String  secretKey = MD5.md5Hex(DateUtil.getStringDateShort()+"XMCASZYQ").substring(5,21).toUpperCase(); //AES对称密钥, 长度为16位
		System.out.println(secretKey);
		/* 对应VC++ aes的配置参数
		 const char g_key[17] = "Ij0bbMLZIy93cK8o"; //末尾以 \0结束
		 const char g_iv[17] = "abcd56789AEDd12f"; //末尾以 \0结束
		*/
/*
		String  strEncryptedData = AesUtilsByDigitalCloudSign.encrypt(strOriginData, secretKey) ;
		System.out.println( "aes加密后的密文(base64编码)为：" +   strEncryptedData ); 
		System.out.println(); */


		String  strOriginData1 = AesUtilsByDigitalCloudSign.decrypt(strOriginData, secretKey) ;
		System.out.println( "aes解密后的明文为：" +   strOriginData1 ); 

	}
	
	
	

	//==============================================================================================

	/**
	 * 加解密算法/模式/填充方式
	 *
	 * ECB模式只用密钥即可对数据进行加密解密，CBC模式需要添加一个iv
	 */
	private static final String CIPHER_ALGORITHM_AES_CBC_NOPADDING = "AES/CBC/NOPadding";

	/**
	 * 算法名
	 */
	private static final String KEY_NAME = "AES";
	private static String DEFAULT_IV = "abcd56789AEDd12f"; //缺省偏移矢量，16位

	
	
	/**AES加密
	 * 
	 * @param originalData       原文
	 * @param secretKey  对称密钥
	 * 
	 * @return            密文（base64编码）
	 */
	public static String encrypt(String originalData, String secretKey) 
	{

		/*
    	 if (StringUtils.isEmpty(data)) 
         {
            return "";
         }
		 */
//zgpn6em9J8GJJMhQLd9Kilr6w3CMR32vrH3NScvSWsQ
		try
		{
			// 参数分别代表 算法名称/加密模式/数据填充方式
			Cipher cipher = Cipher.getInstance(CIPHER_ALGORITHM_AES_CBC_NOPADDING);
			int blockSize = cipher.getBlockSize();

			byte[] dataBytes = originalData.getBytes(); //建议指定为 utf-8编码
			int plaintextLength = dataBytes.length;
			if (plaintextLength % blockSize != 0)
			{
				plaintextLength = plaintextLength + (blockSize - (plaintextLength % blockSize));
			}

			byte[] plaintext = new byte[plaintextLength];
			System.arraycopy(dataBytes, 0, plaintext, 0, dataBytes.length);

			SecretKeySpec keyspec = new SecretKeySpec(secretKey.getBytes(), KEY_NAME);
			IvParameterSpec ivspec = new IvParameterSpec(DEFAULT_IV.getBytes());
			cipher.init(Cipher.ENCRYPT_MODE, keyspec, ivspec);
			byte[] encrypted = cipher.doFinal(plaintext);
			
			System.out.println("encrypted length=" + encrypted.length); 

			return Base64.encodeBase64String(encrypted).trim().replaceAll("\r\n", "") ;  
			//return new sun.misc.BASE64Encoder().encode(encrypted).trim().replaceAll("\r\n", "");


		} 
		catch (Exception e)
		{
			e.printStackTrace();
			//log.error("AES加密失败_" + e.getMessage(), e);
			return "";
		}
	}


	/**AES解密
	 * 
	 * @param encryptedData        密文（base64编码）
	 * @param secretKey    密钥
	 * 
	 * @return     原文
	 */
	public static String decrypt(String encryptedData, String secretKey) 
	{
		return decrypt(encryptedData, secretKey, DEFAULT_IV);
	}



	/**解密
	 * 
	 * @param encryptedData       密文（base64编码）
	 * @param secretKey  对称密钥
	 * @param iv         矢量
	 * 
	 * @return     原文
	 */
	private static String decrypt(String encryptedData, String secretKey, String iv) 
	{
		/*
		if (StringUtils.isEmpty(data) || StringUtils.isUndefined(data)) 
		{
			return "";
		}
		 */

		try 
		{
			Cipher cipher = Cipher.getInstance(CIPHER_ALGORITHM_AES_CBC_NOPADDING);
			SecretKeySpec secretKeySpec     = new SecretKeySpec(secretKey.getBytes(), KEY_NAME);
			IvParameterSpec ivParameterSpec = new IvParameterSpec(iv.getBytes());
			cipher.init(Cipher.DECRYPT_MODE, secretKeySpec, ivParameterSpec);

			//byte[] encryptedData = new BASE64Decoder().decodeBuffer(data);
			byte[] bEncryptedData = Base64.decodeBase64(encryptedData); 
			System.out.println("bEncryptedData len=" + bEncryptedData.length); 
			
			byte[] original      = cipher.doFinal(bEncryptedData);
			System.out.println("aes decrypted original length=" + original.length); 

			return new String(original,"utf8").trim(); //byte[] 转为 string类型
		}
		catch (Exception e) 
		{
			//log.error("AES解密失败_" + e.getMessage(), e);
			e.printStackTrace();
			return "";
		}
	}
}
