package com.yihu.jw.security.utils.qrcode;

public class QRCodeServiceProxy implements QRCodeService {
  private String _endpoint = null;
  private QRCodeService qRCodeService = null;
  
  public QRCodeServiceProxy() {
    _initQRCodeServiceProxy();
  }
  
  public QRCodeServiceProxy(String endpoint) {
    _endpoint = endpoint;
    _initQRCodeServiceProxy();
  }
  
  private void _initQRCodeServiceProxy() {
    try {
      qRCodeService = (new QRCodeServiceImplServiceLocator()).getQRCodeServiceImplPort();
      if (qRCodeService != null) {
        if (_endpoint != null)
          ((javax.xml.rpc.Stub)qRCodeService)._setProperty("javax.xml.rpc.service.endpoint.address", _endpoint);
        else
          _endpoint = (String)((javax.xml.rpc.Stub)qRCodeService)._getProperty("javax.xml.rpc.service.endpoint.address");
      }
      
    }
    catch (javax.xml.rpc.ServiceException serviceException) {}
  }
  
  public String getEndpoint() {
    return _endpoint;
  }
  
  public void setEndpoint(String endpoint) {
    _endpoint = endpoint;
    if (qRCodeService != null)
      ((javax.xml.rpc.Stub)qRCodeService)._setProperty("javax.xml.rpc.service.endpoint.address", _endpoint);
    
  }
  
  public QRCodeService getQRCodeService() {
    if (qRCodeService == null)
      _initQRCodeServiceProxy();
    return qRCodeService;
  }
  
  public String SOF_QueryQRCode(String qrCode) throws java.rmi.RemoteException{
    if (qRCodeService == null)
      _initQRCodeServiceProxy();
    return qRCodeService.SOF_QueryQRCode(qrCode);
  }

  public String SOF_GetQRCode() throws java.rmi.RemoteException{
    if (qRCodeService == null)
      _initQRCodeServiceProxy();
    return qRCodeService.SOF_GetQRCode();
  }

  public String SOF_GetQRCodeBySys(String sys) throws java.rmi.RemoteException{
    if (qRCodeService == null)
      _initQRCodeServiceProxy();
    return qRCodeService.SOF_GetQRCodeBySys(sys);
  }
  
  
}