package com.yihu.jw.elasticsearch;

import com.alibaba.fastjson.JSONArray;
import org.springframework.stereotype.Component;

import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.SQLException;
import java.util.*;

/**
 * Created by Bing on 2022/8/10.
 */
@Component
public class ResultSetUtil {

   public List<Map<String,Object>> resultToMapList(ResultSet resultSet) throws SQLException {
       List<Map<String,Object>> result = new ArrayList<>();
       ResultSetMetaData md = resultSet.getMetaData();
       int columnCount = md.getColumnCount();
       while (resultSet.next()){
           Map<String,Object> tmp = new HashMap<>();
           for (int i = 1; i <= columnCount; i++) {
               tmp.put(md.getColumnName(i), resultSet.getObject(i));
           }
           result.add(tmp);
       }
       return  result;
   }

    public JSONArray resultToJSONArray(ResultSet resultSet) throws SQLException {
        JSONArray result = new JSONArray();
        ResultSetMetaData md = resultSet.getMetaData();
        int columnCount = md.getColumnCount();
        while (resultSet.next()){
            Map<String,Object> tmp = new HashMap<>();
            for (int i = 1; i <= columnCount; i++) {
                tmp.put(md.getColumnName(i), resultSet.getObject(i));
            }
            result.add(tmp);
        }
        return  result;
    }

    public <T> List<T> resultToEntity(ResultSet resultSet, Class<T> target) throws SQLException {
        List<T> result = new ArrayList<>();
        JSONArray list = resultToJSONArray(resultSet);
        if (list.size()>0){
            result = JSONArray.parseArray(list.toJSONString(),target);
        }
        return result;
    }

}
