package com.yihu.jw.afterDiagnosis.dao.device;

import com.yihu.jw.entity.patient.PatientDevice;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;

import java.util.List;

public interface PatientDeviceDao extends PagingAndSortingRepository<PatientDevice, Long>, JpaSpecificationExecutor<PatientDevice> {

    @Query("select a from PatientDevice a where a.user = ?1 ")
    Iterable<PatientDevice> findByUser(String user);

    @Query("select a from PatientDevice a where a.user = ?1 ")
    List<PatientDevice> findByPatient(String user);

    @Query("select a from PatientDevice a where a.user = ?1 and a.del=0 and a.deviceName like '%药盒%'")
    List<PatientDevice> findByPatientAndDel(String user);

    @Query("select a from PatientDevice a where a.user = ?1 and a.deviceSn=?2 ")
    List<PatientDevice> findByPatientAndDeviceSn(String user, String deviceSn);

    List<PatientDevice> findByUser(String user, Pageable pageRequest);

    List<PatientDevice> findByUserAndDoctor(String user, String doctor, Pageable pageRequest);

    List<PatientDevice> findByDeviceSnAndCategoryCode(String deviceSn, String categoryCode);

    PatientDevice findByDeviceSnAndCategoryCodeAndUserType(String deviceSn, String categoryCode, String userType);

    PatientDevice findByDeviceIdAndDeviceSnAndUserType(Long deviceId, String deviceSn, String userType);

    PatientDevice findByDeviceSnAndUserType(String deviceSn, String userType);

    @Query("select pd from PatientDevice pd where pd.deviceSn = ?1 and pd.del=0")
    List<PatientDevice> findByDeviceSn(String deviceSn);

    @Query("select pd from PatientDevice pd where pd.deviceSn = ?1 ")
    List<PatientDevice> findByDeviceSn2(String deviceSn);

    //更换患者绑定的血糖仪
    @Modifying
    @Query("update PatientDevice t set t.deviceSn = ?3 , t.userType = ?4,t.sim=?5,t.hospital=?6,t.hospitalName=?7,t.checkDoctorName=?8 where t.user = ?1 and t.deviceSn = ?2 ")
    int updatePatientDevice(String user, String deviceSN, String newDeviceSN, String userType, String sim,String hospital,String hospitalName,String checkDoctorName);

    @Query("select a " +
            "from PatientDevice a,BasePatientDO p where a.userIdcard=p.idcard")
    List<PatientDevice> findWithArrdess();

    @Query("select a from PatientDevice a")
    List<PatientDevice> findAll();


}
