package com.yihu.jw.afterDiagnosis.dao.device;

import com.yihu.jw.entity.patient.PatientDeviceLog;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;

import java.util.List;

public interface PatientDeviceLogDao extends PagingAndSortingRepository<PatientDeviceLog, Long>, JpaSpecificationExecutor<PatientDeviceLog> {

    @Query("select pdl from PatientDeviceLog pdl where pdl.patient=?1 and pdl.categoryCode=?2")
    List<PatientDeviceLog> findByPatientAndCategoryCode(String patient,String categoryCode);
    
    @Query("select pdl from PatientDeviceLog pdl where pdl.patient=?1 group by pdl.deviceSn ")
    List<PatientDeviceLog> findByPatientGroupByDeviceSn(String patient);

    @Query("select a from PatientDeviceLog a")
    List<PatientDeviceLog> findAllList();
}
