package com.yihu.jw.afterDiagnosis.dao.prescription;

import com.yihu.jw.entity.hospital.prescription.PrescriptionDispensaryCode;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;

import java.util.List;

/**
 * Created by Administrator on 2017/7/21.
 * 处方取码
 */
public interface PrescriptionDispensaryCodeDao extends PagingAndSortingRepository<PrescriptionDispensaryCode, Long>, JpaSpecificationExecutor<PrescriptionDispensaryCode> {
    @Query(nativeQuery = true, value = "select * from wlyy_prescription_dispensary_code  where code=?1 order by create_time desc limit 0,1 ")
    PrescriptionDispensaryCode finByCode(String code);

    List<PrescriptionDispensaryCode> findByPrescriptionCode(String prescriptionCode);

    @Query("select count(1) from PrescriptionDispensaryCode a where a.code= ?1 and a.isUse =0")
    Integer getResidentQRCodeCount(String code);

    @Query("select a.code from PrescriptionDispensaryCode a where a.prescriptionCode= ?1 and a.type =?2 ")
    String getCodeByPrescriptionCodeAndType(String prescriptionCode, Integer type);


    /**
     * 更新处方某一类型的编码为使用
     *
     * @param prescriptionCode
     * @param type
     */
    @Modifying
    @Query("update PrescriptionDispensaryCode a set a.isUse=1 where a.prescriptionCode= ?1 and a.type = ?2 and a.isUse=0 ")
    void updateToUse(String prescriptionCode, Integer type);

    PrescriptionDispensaryCode findByCodeAndIsUse(String code, Integer isUse);

    PrescriptionDispensaryCode findByPrescriptionCodeAndIsUseAndType(String prescriptionCode, Integer isUse,Integer type);
}
