package com.yihu.jw.afterDiagnosis.dao.prescription;

import com.yihu.jw.entity.hospital.prescription.PrescriptionFollowupContent;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;

import java.util.List;

/**
 * 续方咨询问卷相关方法
 * @author huangwenjie
 * @date 2017/11/2 09:07
 */
public interface PrescriptionFollowupContentDao extends
		PagingAndSortingRepository<PrescriptionFollowupContent, Long>,
		JpaSpecificationExecutor<PrescriptionFollowupContent> {
	
	@Query("from PrescriptionFollowupContent p where p.prescriptionCode=?1 and p.followupProject=?2")
	List<PrescriptionFollowupContent> findByPrescriptionCodeAndFollowupProject(String prescriptionCode, String followupProject);
	
	@Modifying
	@Query("delete PrescriptionFollowupContent p where p.prescriptionCode=?1 and p.followupProject=?2")
	void deleteByPrescriptioncodeAndFollowupProject(String prescriptioncode, String followupProject);
	
	@Query("from PrescriptionFollowupContent p where p.prescriptionCode=?1")
	List<PrescriptionFollowupContent> findByPrescriptionCode(String prescriptioncode);
}
