package com.yihu.jw.afterDiagnosis.dao.rehabilitation;

import com.yihu.jw.entity.specialist.rehabilitation.PatientDiagnosisInformationDO;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;

public interface PatientDiagnosisInformationDao extends PagingAndSortingRepository<PatientDiagnosisInformationDO, Long>,
        JpaSpecificationExecutor<PatientDiagnosisInformationDO> {

    PatientDiagnosisInformationDO findByPlanId(String planId);

    @Query("select d from PatientDiagnosisInformationDO d where d.patient = ?1 order by d.dischargeTime,d.createTime desc")
    Page<PatientDiagnosisInformationDO> findByPatient(String patient, Pageable pageRequest);
}
