package com.yihu.jw.afterDiagnosis.dao.rehabilitation;

import com.yihu.jw.entity.specialist.rehabilitation.SpecialDiseaseMessages;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;

/***
 * @ClassName: SpecialDiseaseMessagesDao
 * @Description:
 * @Auther: shi kejing
 * @Date: 2021/4/20 9:44
 */
public interface SpecialDiseaseMessagesDao extends PagingAndSortingRepository<SpecialDiseaseMessages,Long>, JpaSpecificationExecutor<SpecialDiseaseMessages> {

    @Query("select m from SpecialDiseaseMessages m where m.createTime>?1 and m.createTime<?2 order by m.createTime desc")
    Page<SpecialDiseaseMessages> findByTime(String createTime, String endTime, Pageable pageRequest);

    @Query("select count(1) from SpecialDiseaseMessages m where m.createTime>?1 and m.createTime<?2")
    Integer findCountsByTime(String createTime,String endTime);

}
