package com.yihu.jw.afterDiagnosis.endpoint.rehabilitation;

/**
 * Created by 刘文彬 on 2018/8/31.
 */


import com.yihu.jw.afterDiagnosis.endpoint.BaseController;
import com.yihu.jw.afterDiagnosis.service.rehabilitation.RehabilitationGuidanceService;
import com.yihu.jw.afterDiagnosis.service.rehabilitation.RehabilitationManageService;
import com.yihu.jw.afterDiagnosis.service.rehabilitation.RehabilitationPlanService;
import com.yihu.jw.afterDiagnosis.service.rehabilitation.WlyyRehabilitationManageService;
import com.yihu.jw.entity.specialist.rehabilitation.PatientMedicalRecordsDO;
import com.yihu.jw.entity.specialist.rehabilitation.RehabilitationOperateRecordsDO;
import com.yihu.jw.im.util.ImUtil;
import com.yihu.jw.restmodel.web.ObjEnvelop;
import com.yihu.jw.util.entity.ServiceException;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;
import java.util.Map;

/**
 * Created by 刘文彬 on 2018/8/30.
 */
@RestController
@RequestMapping(value = "/patient/specialist/rehabilitation")
@Api(description = "居民端-康复管理")
public class PatientRehabilitationManageController extends BaseController {

    @Autowired
    private RehabilitationManageService rehabilitationManageService;
    @Autowired
    private ImUtil imUtill;
    @Autowired
    private RehabilitationPlanService rehabilitationPlanService;
    @Autowired
    private RehabilitationGuidanceService rehabilitationGuidanceService;
    @Autowired
    private JdbcTemplate jdbcTemplate;
    @Autowired
    private WlyyRehabilitationManageService wlyyRehabilitationManageService;


    @RequestMapping(value = "patientRehabilitationDetail", method = RequestMethod.GET)
    @ApiOperation("康复管理-微信端-居民详情页")
    public ObjEnvelop patientRehabilitationDetail(){

        try {
            String patient = null;
            if (StringUtils.isNoneBlank(getRepresentedUID())){
                patient = getRepresentedUID();
            }else {
                patient = getUID();
            }
            return rehabilitationManageService.patientRehabilitationDetail(patient);
        } catch (ServiceException se) {
            return ObjEnvelop.getError(se.getMessage(),-1);
        } catch (Exception e) {
            return ObjEnvelop.getError("获取失败",-1);
        }
    }

    @RequestMapping(value = "getPatientInfo", method = RequestMethod.GET)
    @ApiOperation("康复管理-获取居民信息")
    public String getPatientInfo(@ApiParam(name = "patient", value = "居民信息", required = true)
                                     @RequestParam(value = "patient", required = true)String patient,
                                     @ApiParam(name = "planId", value = "计划id", required = true)
                                     @RequestParam(value = "planId", required = true)String planId){
        try {
            return write(200, "获取成功", "data", wlyyRehabilitationManageService.getPatientInfo(planId,patient));
        } catch (Exception e) {
            error(e);
            return error(-1, "请求失败");
        }
    }

    @RequestMapping(value = "selectByMedicalCode", method = RequestMethod.GET)
    @ApiOperation("获取医院病历")
    public String selectByMedicalCode(@ApiParam(name = "medical", value = "住院code", required = true)
                                      @RequestParam(value = "medical", required = true)String medical){

        try {
            List<PatientMedicalRecordsDO> result = wlyyRehabilitationManageService.selectByMedicalCode(medical);
            try{
                String sql = "UPDATE wlyy_patient_medical_records_rehabilitation` SET `patient_read_status`='1' WHERE (`code`='"+medical+"') ";
                jdbcTemplate.update(sql);
            }catch (Exception e){
                e.printStackTrace();
            }
            return write(200, "获取成功！", "data", result);
        } catch (Exception e) {
            error(e);
            return error(-1, "请求失败");
        }
    }
    
    @RequestMapping(value = "selectByPatient", method = RequestMethod.GET)
    @ApiOperation("获取居民医院病历列表")
    public String selectByPatient(@ApiParam(name = "patient", value = "居民code", required = true)
                                      @RequestParam(value = "patient", required = true)String patient){
        
        try {
            List<PatientMedicalRecordsDO> result = wlyyRehabilitationManageService.findByPatient(patient);
            return write(200, "获取成功！", "data", result);
        } catch (Exception e) {
            error(e);
            return error(-1, "请求失败");
        }
    }
    
    @RequestMapping(value = "getPlantCodeByMedicalRecordsCode", method = RequestMethod.GET)
    @ApiOperation("根据住院病历获取计划CODE")
    public String getPlantCodeByMedicalRecordsCode(@ApiParam(name = "code", value = "住院病历CODE", required = true)
                                                   @RequestParam(value = "code", required = true)String code){
        try {
            return write(200, "获取成功！", "data",wlyyRehabilitationManageService.getPlantCodeByMedicalRecordsCode(code));
        } catch (Exception e) {
            error(e);
            return error(-1, "请求失败");
        }
    }


    @RequestMapping(value = "calendarPlanDetail", method = RequestMethod.GET)
    @ApiOperation("康复管理-康复计划按日历展示")
    public ObjEnvelop calendarPlanDetail(@ApiParam(name = "executeStartTime", value = "日历开始时间（格式：yyyy-MM-dd HH:mm:ss）", required = true)
                                     @RequestParam(value = "executeStartTime", required = true)String executeStartTime,
                                     @ApiParam(name = "executeEndTime", value = "日历结束时间（格式：yyyy-MM-dd HH:mm:ss）", required = true)
                                     @RequestParam(value = "executeEndTime", required = true)String executeEndTime,
                                     @ApiParam(name = "planId", value = "计划id", required = true)
                                     @RequestParam(value = "planId", required = true)String planId,
                                     @ApiParam(name = "searchTask", value = "快速查找任务：（1、我的任务，2、健康教育，3、复诊，4、随访）", required = false)
                                     @RequestParam(value = "searchTask", required = false)Integer searchTask,
                                     @ApiParam(name = "status", value = "任务状态（0未完成，1已完成，2已预约）", required = false)
                                     @RequestParam(value = "status", required = false)Integer status){
        try {
            return rehabilitationManageService.calendarPlanDetail(executeStartTime,executeEndTime,planId,searchTask,status,null,null);
        } catch (ServiceException se) {
            return ObjEnvelop.getError(se.getMessage(),-1);
        } catch (Exception e) {
            return ObjEnvelop.getError("获取失败",-1);
        }
    }

    @RequestMapping(value = "serviceDoctorList", method = RequestMethod.GET)
    @ApiOperation("康复管理-微信端居民服务医生列表")
    public ObjEnvelop serviceDoctorList(){

        try {
            return rehabilitationManageService.serviceDoctorList(getUID());
        } catch (ServiceException se) {
            return ObjEnvelop.getError(se.getMessage(),-1);
        } catch (Exception e) {
            return ObjEnvelop.getError("获取失败",-1);
        }
    }

    @RequestMapping(value = "calendarPlanDetailList", method = RequestMethod.GET)
    @ApiOperation("康复管理-康复计划按列表展示")
    public ObjEnvelop calendarPlanDetailList(@ApiParam(name = "executeStartTime", value = "日历开始时间（格式：yyyy-MM-dd HH:mm:ss）", required = true)
                                         @RequestParam(value = "executeStartTime", required = true)String executeStartTime,
                                         @ApiParam(name = "executeEndTime", value = "日历结束时间（格式：yyyy-MM-dd HH:mm:ss）", required = true)
                                         @RequestParam(value = "executeEndTime", required = true)String executeEndTime,
                                         @ApiParam(name = "planId", value = "计划id", required = true)
                                         @RequestParam(value = "planId", required = true)String planId,
                                         @ApiParam(name = "searchTask", value = "快速查找任务：（1、我的任务，2、健康教育，3、复诊，4、随访）", required = false)
                                         @RequestParam(value = "searchTask", required = false)Integer searchTask,
                                         @ApiParam(name = "status", value = "任务状态（0未完成，1已完成，2已预约）", required = false)
                                         @RequestParam(value = "status", required = false)Integer status){
        try {
            return rehabilitationManageService.calendarPlanDetailList(planId,searchTask,status,null,executeStartTime,executeEndTime,null);
        } catch (ServiceException se) {
            return ObjEnvelop.getError(se.getMessage(),-1);
        } catch (Exception e) {
            return ObjEnvelop.getError("获取失败",-1);
        }
    }

    @RequestMapping(value = "calendarPlanDetailItems", method = RequestMethod.GET)
    @ApiOperation("康复管理-康复计划服务项目按列表展示")
    public String calendarPlanDetailItems(@ApiParam(name = "executeStartTime", value = "日历开始时间（格式：yyyy-MM-dd HH:mm:ss）", required = false)
                                          @RequestParam(value = "executeStartTime", required = true)String executeStartTime,
                                          @ApiParam(name = "executeEndTime", value = "日历结束时间（格式：yyyy-MM-dd HH:mm:ss）", required = false)
                                          @RequestParam(value = "executeEndTime", required = true)String executeEndTime,
                                          @ApiParam(name = "planId", value = "计划id", required = true)
                                          @RequestParam(value = "planId", required = true)String planId,
                                          @ApiParam(name = "searchTask", value = "快速查找任务：（1、我的任务，2、健康教育，3、健康指导，4、随访，5、复诊）", required = false)
                                          @RequestParam(value = "searchTask", required = false)Integer searchTask,
                                          @ApiParam(name = "status", value = "任务状态（0未完成，1已完成，2已预约）", required = false)
                                          @RequestParam(value = "status", required = false)Integer status){
        try {
            List<Map<String,Object>> result = wlyyRehabilitationManageService.calendarPlanDetailItems(executeStartTime,executeEndTime,planId,searchTask,status,null);
            return write(200, "获取成功", "data", result);
        } catch (Exception e) {
            error(e);
            return error(-1, "请求失败");
        }
    }

    @RequestMapping(value = "selectByGuidance", method = RequestMethod.GET)
    @ApiOperation("康复管理-根据计划查询指导留言")
    public String selectByGuidance(@ApiParam(name = "planId", value = "计划id", required = false)
                                   @RequestParam(value = "planId", required = true)String planId,
                                   @ApiParam(name = "itemCode", value = "服务项目code", required = true)
                                   @RequestParam(value = "itemCode", required = true)String itemCode){

        try {
            List<Map<String,Object>> mapList = wlyyRehabilitationManageService.selectByGuidance(planId,itemCode);
            return write(200, "获取成功", "data", mapList);
        } catch (Exception e) {
            error(e);
            return error(-1, "请求失败");
        }
    }

    @RequestMapping(value = "selectByPlanDetaiId", method = RequestMethod.GET)
    @ApiOperation("康复管理-获取操作记录")
    public String selectByPlanDetaiId(
                                      @ApiParam(name = "planId", value = "计划id", required = true)
                                      @RequestParam(value = "planId", required = true)String planId,
                                      @ApiParam(name = "code", value = "服务项目code", required = true)
                                      @RequestParam(value = "code", required = true)String code,
                                      @ApiParam(name = "page", value = "", required = false)
                                      @RequestParam(value = "page", required = false)Integer page,
                                      @ApiParam(name = "pagesize", value = "", required = false)
                                      @RequestParam(value = "pagesize", required = false)Integer pagesize){
        try {
            return write(200, "获取成功", "data", wlyyRehabilitationManageService.selectByPlanDetaiId(null,planId,code,page,pagesize));//patient,
        } catch (Exception e) {
            error(e);
            return error(-1, "请求失败");
        }
    }

    @RequestMapping(value = "selectPlanByPatient", method = RequestMethod.GET)
    @ApiOperation("康复管理-根据居民code查找康复计划")
    public String calendarPlanDetailItems(@ApiParam(name = "patient", value = "居民code", required = false)
                                          @RequestParam(value = "patient", required = false)String patient,
                                          @ApiParam(name = "status", value = "任务状态（0未完成，1已完成，2已预约）", required = false)
                                          @RequestParam(value = "status", required = false)Integer status){
        try {
            List<Map<String,Object>> result = wlyyRehabilitationManageService.selectPlanByPatient(patient,status,null,null);
            return write(200, "获取成功", "data", result);
        } catch (Exception e) {
            error(e);
            return error(-1, "请求失败");
        }
    }

    @RequestMapping(value = "sendMessageIm", method = RequestMethod.POST)
    @ApiOperation("康复管理-扫描二维码发送消息")
    public String sendMessageIm(@ApiParam(name = "sendId", value = "发送者id")@RequestParam(value = "sendId", required = true)String sendId,
                                @ApiParam(name = "receiverId", value = "接受者id", required = true)@RequestParam(value = "receiverId", required = true)String receiverId,
                                @ApiParam(name = "content", value = "内容", required = true)@RequestParam(value = "content", required = true)String content){

        try {
            imUtill.sendMessage(sendId,receiverId,"1",content);
            wlyyRehabilitationManageService.sendMessage(sendId, receiverId, content);//发送康复下转邀请
            return write(200,"发送成功！");
        } catch (Exception e) {
            error(e);
            return error(-1, "发送失败！");
        }
    }

    @RequestMapping(value = "checkAfterQrCode", method = RequestMethod.POST)
    @ApiOperation("康复管理-居民扫码后验证是否是关联的居民扫码")
    public String checkAfterQrCode(@ApiParam(name = "planDetailId", value = "康复计划项目明细ID")@RequestParam(value = "planDetailId", required = true)String planDetailId,
                                   @ApiParam(name = "patientCode", value = "居民端登录的居民code")@RequestParam(value = "patientCode", required = true)String patientCode){

        try {
            String message="";
            Boolean flag = true;
            Map<String,Object> map = rehabilitationPlanService.checkAfterQrCode(planDetailId,patientCode);
            int result = Integer.valueOf(String.valueOf(map.get("code")));
            if (result==200){
                message = "验证成功！";
            }
            if (result==-1){
                message = "请相关居民扫描二维码";
                flag=false;
            }
            if (result==-10000){
                message = "相关康复管理数据错误,请联系工作人员！";
                flag=false;
            }
            map.put("flag",flag);
            map.remove("code");
            return write(200, message, "data", map);
        } catch (Exception e) {
            error(e);
            return error(-1, "验证失败");
        }
    }

    @RequestMapping(value = "saveRehabilitationOperateRecord", method = RequestMethod.POST)
    @ApiOperation("康复管理-新增operateRecord")
    public String saveRehabilitationOperateRecord(@ApiParam(name = "dataJson", value = "实体json",defaultValue = "{\"rehabilitationDetailId\":\"402803f6657f195301657f4fbd3c0001\",\"patientCode\":\"00\",\"patientName\":\"11\",\"doctorCode\":\"22\",\"doctorName\":\"33\",\"node\":\"jjjjjj\",\"relationRecordType\":\"4\",\"relation_record_code\":\"55\",\"relationRecordImg\":\"666666\",\"status\":\"0\"}")@RequestParam(value = "dataJson", required = true)String dataJson){

        try {
            RehabilitationOperateRecordsDO result = rehabilitationPlanService.saveRehabilitationOperateRecord(dataJson);
            return write(200, "新增康复计划日志成功！", "data", result);
        } catch (Exception e) {
            error(e);
            return error(-1, "新增康复计划日志失败！");
        }
    }

    @RequestMapping(value = "recentPlanDetailRecord", method = RequestMethod.GET)
    @ApiOperation("康复管理-近期康复相关记录")
    public ObjEnvelop recentPlanDetailRecord(@ApiParam(name = "patientCode", value = "居民code", required = false)
                                         @RequestParam(value = "patientCode", required = false)String patientCode,
                                         @ApiParam(name = "startTime", value = "开始时间（格式：yyyy-MM-dd HH:mm:ss）", required = false)
                                         @RequestParam(value = "startTime", required = false)String startTime,
                                         @ApiParam(name = "endTime", value = "结束时间（格式：yyyy-MM-dd HH:mm:ss）", required = false)
                                         @RequestParam(value = "endTime", required = false)String endTime,
                                         @ApiParam(name = "page", value = "第几页，从1开始", required = true)
                                         @RequestParam(value = "page", required = false,defaultValue = "1")Integer page,
                                         @ApiParam(name = "pageSize", value = "每页分页大小", required = true)
                                         @RequestParam(value = "pageSize", required = false,defaultValue = "10")Integer pageSize){
        try {
            if(!StringUtils.isNotEmpty(patientCode)){
                patientCode = getUID();
            }
            return rehabilitationManageService.recentPlanDetailRecord(patientCode,startTime,endTime,page,pageSize);
        } catch (ServiceException se) {
            return ObjEnvelop.getError(se.getMessage(),-1);
        } catch (Exception e) {
            return ObjEnvelop.getError("获取失败",-1);
        }
    }

    @RequestMapping(value = "serviceItemList", method = RequestMethod.GET)
    @ApiOperation("康复管理-多个康复计划服务项目内容列表")
    public ObjEnvelop serviceItemList(@ApiParam(name = "planDetailIds", value = "康复计划多个服务项目id（多个‘，’分隔）", required = true)
                                  @RequestParam(value = "planDetailIds", required = true)String planDetailIds){
        try {
            return rehabilitationManageService.serviceItemList(planDetailIds,null);
        } catch (ServiceException se) {
            return ObjEnvelop.getError(se.getMessage(),-1);
        } catch (Exception e) {
            return ObjEnvelop.getError("获取失败",-1);
        }
    }

    @RequestMapping(value = "serviceItem", method = RequestMethod.GET)
    @ApiOperation("康复管理-康复计划服务项目确认详情页")
    public ObjEnvelop serviceItem(@ApiParam(name = "planDetailId", value = "康复计划服务项目id", required = true)
                              @RequestParam(value = "planDetailId", required = true)String planDetailId,
                              @ApiParam(name = "recordId", value = "记录id", required = false)
                              @RequestParam(value = "recordId", required = false)String recordId){
        try {
            return rehabilitationManageService.serviceItem(planDetailId,null,recordId);
        } catch (ServiceException se) {
            return ObjEnvelop.getError(se.getMessage(),-1);
        } catch (Exception e) {
            return ObjEnvelop.getError("获取失败",-1);
        }
    }

    @RequestMapping(value = "planSchedule", method = RequestMethod.GET)
    @ApiOperation("康复管理-计划总进度")
    public ObjEnvelop planSchedule(@ApiParam(name = "planId", value = "计划id", required = true)
                               @RequestParam(value = "planId", required = true)String planId,
                                   @ApiParam(name = "patientCode", value = "居民code", required = false)
                               @RequestParam(value = "patientCode", required = false)String patientCode){

        try {
            if(!StringUtils.isNotEmpty(patientCode)){
                patientCode = getRepUID();
            }
            return rehabilitationManageService.planSchedule(planId,patientCode,2);
        } catch (ServiceException se) {
            return ObjEnvelop.getError(se.getMessage(),-1);
        } catch (Exception e) {
            return ObjEnvelop.getError("获取失败",-1);
        }
    }

    @RequestMapping(value = "updatePatientImgById", method = RequestMethod.POST)
    @ApiOperation("更新康复计划居民签名照/证件照")
    public String updatePatientImgById(@ApiParam(name = "planId", value = "康复计划id", required = true)
                                       @RequestParam(value = "planId")String planId,
                                       @ApiParam(name = "patientImg", value = "居民签名/证件照地址")
                                       @RequestParam(value = "patientImg")String patientImg){

        try {
            rehabilitationPlanService.updatePatientImgById(planId, patientImg);
            return write(200, "更新成功！");
        } catch (ServiceException se) {
            return write(-1,se.getMessage());
        } catch (Exception e) {
            error(e);
            return error(-1, "更新失败");
        }
    }

    @RequestMapping(value = "getServiceItemsAfterStop", method = RequestMethod.GET)
    @ApiOperation("康复管理-已执行项目清单")
    public ObjEnvelop getServiceItemsAfterStop(@ApiParam(name = "planId", value = "康复计划id", required = true)
                                           @RequestParam(value = "planId", required = true)String planId){

        try {
            return rehabilitationManageService.getServiceItemsAfterStop(planId);
        } catch (ServiceException se) {
            return ObjEnvelop.getError(se.getMessage(),-1);
        } catch (Exception e) {
            return ObjEnvelop.getError("获取失败",-1);
        }
    }

    @RequestMapping(value = "selectByRelationCodeAndGuidance", method = RequestMethod.GET)
    @ApiOperation("康复管理-根据业务code查找康复指导")
    public String selectByRelationCodeAndGuidance(@ApiParam(name = "relationCode", value = "业务关联code", required = false)
                                       @RequestParam(value = "relationCode", required = false) String relationCode,
                                       @ApiParam(name = "patient", value = "居民code", required = false)
                                       @RequestParam(value = "patient", required = false) String patient,
                                       @ApiParam(name = "doctor", value = "医生code", required = false)
                                       @RequestParam(value = "doctor", required = false) String doctor) {

        try {
            return write(200, "请求成功！", "data", rehabilitationGuidanceService.selectByRelationCode(patient,doctor,relationCode));
        } catch (Exception e) {
            error(e);
            return error(-1, "请求失败");
        }
    }

    @RequestMapping(value = "selectGuidances", method = RequestMethod.GET)
    @ApiOperation("康复管理-查看指导列表")
    public String selectType(@ApiParam(name = "type", value = "康复指导类型", required = false)
                             @RequestParam(value = "type", required = false) Integer type,
                             @ApiParam(name = "id", value = "康复指导模板id", required = false)
                             @RequestParam(value = "id", required = false) String id,
                             @ApiParam(name = "title", value = "康复指导名称", required = false)
                             @RequestParam(value = "title", required = false) String title,
                             @ApiParam(name = "planId", value = "计划id", required = false)
                             @RequestParam(value = "planId", required = false) String planId,
                             @ApiParam(name = "page", value = "页码", required = false)
                             @RequestParam(value = "page", required = false) Integer page,
                             @ApiParam(name = "pagesize", value = "每页大小", required = false)
                             @RequestParam(value = "pagesize", required = false) Integer pagesize) {

        try {
            return write(200, "请求成功！", "data", rehabilitationGuidanceService.select(title,type,id,planId,page,pagesize));
        } catch (Exception e) {
            error(e);
            return error(-1, "请求失败");
        }
    }

    @RequestMapping(value = "selectPlanDetailByPlanId", method = RequestMethod.GET)
    @ApiOperation("康复管理-查看其它服务计划")
    public String selectPlanDetailByPlanId(@ApiParam(name = "planId", value = "计划id", required = true)
                                           @RequestParam(value = "planId", required = true) String planId,
                                           @ApiParam(name = "planDetailId", value = "计划详情id", required = true)
                                           @RequestParam(value = "planDetailId", required = true) String planDetailId,
                                           @ApiParam(name = "itemId", value = "服务项目code", required = true)
                                           @RequestParam(value = "itemId", required = true) String itemId) {

        try {
            return write(200, "请求成功！","data",wlyyRehabilitationManageService.selectPlanDetailByPlan(planId,planDetailId,itemId));
        } catch (Exception e) {
            error(e);
            return error(-1, "请求失败");
        }
    }

    @RequestMapping(value = "selectByRelationCode", method = RequestMethod.GET)
    @ApiOperation("康复管理-根据业务code查找康复指导")
    public String selectByRelationCode(@ApiParam(name = "relationCode", value = "业务关联code", required = false)
                                       @RequestParam(value = "relationCode", required = false) String relationCode,
                                       @ApiParam(name = "patient", value = "居民code", required = false)
                                       @RequestParam(value = "patient", required = false) String patient,
                                       @ApiParam(name = "doctor", value = "医生code", required = false)
                                       @RequestParam(value = "doctor", required = false) String doctor) {

        try {
            return write(200, "请求成功！", "data", rehabilitationGuidanceService.selectByRelationCode(patient,doctor,relationCode));
        } catch (Exception e) {
            error(e);
            return error(-1, "请求失败");
        }
    }
    
    @RequestMapping(value = "getDiseaseTopicInfo", method = RequestMethod.GET)
    @ApiOperation("获取居民疾病专题首页相关数据")
    public String getDiseaseTopicInfo(@ApiParam(name = "patientCode", value = "住院病历CODE", required = true)
                                                   @RequestParam(value = "patientCode", required = true)String patientCode,
                                                   @ApiParam(name = "diseaseType", value = "疾病类型", required = true)
                                                   @RequestParam(value = "diseaseType", required = true)String diseaseType){
        try {
            com.alibaba.fastjson.JSONObject object = new com.alibaba.fastjson.JSONObject();
            object.put("patientId",getUID());
            return write(200, "获取成功！", "data",wlyyRehabilitationManageService.getDiseaseTopicInfo(object,patientCode,diseaseType));
        } catch (Exception e) {
            error(e);
            return error(-1, "请求失败");
        }
    }

    @RequestMapping(value = "getDiseaseHospital", method = RequestMethod.GET)
    @ApiOperation("获取入住疾病的医院列表")
    public String getDiseaseHospital(@ApiParam(name = "diseaseType", value = "疾病类型", required = true)
                                     @RequestParam(value = "diseaseType", required = true)String diseaseType,
                                     @ApiParam(name = "name", value = "医院名称", required = false)
                                     @RequestParam(value = "name", required = false)String name,
                                     @ApiParam(name = "page", value = "页码", required = false)
                                         @RequestParam(value = "page", required = false) Integer page,
                                     @ApiParam(name = "pagesize", value = "每页大小", required = false)
                                         @RequestParam(value = "pagesize", required = false) Integer pagesize){
        try {
            if(page==null){
                page = 1;
            }
            if(pagesize==null){
                pagesize = 15;
            }

            return write(200, "获取成功！", "data",wlyyRehabilitationManageService.getDiseaseHospital(diseaseType,name,page,pagesize));
        } catch (Exception e) {
            error(e);
            return error(-1, "请求失败");
        }
    }

}
