package com.yihu.jw.afterDiagnosis.service.prescription;

import com.alibaba.fastjson.JSONObject;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.yihu.jw.afterDiagnosis.dao.prescription.PrescriptionPayDao;
import com.yihu.jw.doctor.dao.BaseDoctorDao;
import com.yihu.jw.entity.base.org.BaseOrgDO;
import com.yihu.jw.entity.base.patient.BasePatientDO;
import com.yihu.jw.entity.order.PayLog;
import com.yihu.jw.hospital.prescription.dao.PrescriptionDao;
import com.yihu.jw.hospital.prescription.dao.PrescriptionDiagnosisDao;
import com.yihu.jw.hospital.prescription.dao.PrescriptionExpressageDao;
import com.yihu.jw.hospital.prescription.dao.PrescriptionInfoDao;
import com.yihu.jw.order.dao.PayLogDao;
import com.yihu.jw.order.pay.utils.PayLogService;
import com.yihu.jw.org.dao.BaseOrgDao;
import com.yihu.jw.patient.dao.BasePatientDao;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.transaction.Transactional;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by Reece on 2017/7/28/028.
 * 患者支付
 */
@Service
public class PatientPrescriptionPayService {

    private Logger logger = LoggerFactory.getLogger(PatientPrescriptionPayService.class);


    @Autowired
    private BaseDoctorDao doctorDao;
    @Autowired
    private ObjectMapper objectMapper;
    @Autowired
    private PayLogService logService;
    @Autowired
    private BasePatientDao patientDao;
    @Autowired
    private PrescriptionPayDao payDao;
    @Autowired
    private WlyyPrescriptionService prescriptionService;
    @Autowired
    private PrescriptionInfoDao infoDao;
    @Autowired
    private JdbcTemplate jdbcTemplate;
    @Autowired
    private PrescriptionDao prescriptionDao;
    @Autowired
    private PrescriptionExpressageDao expressageDao;
    @Autowired
    private PrescriptionInfoService infoService;
    @Autowired
    private PayLogDao payLogDao;
    @Autowired
    private PrescriptionDiagnosisDao prescriptionDiagnosisDao;
    @Autowired
    private BaseOrgDao hospitalDao;


    /**
     * 长处方配送信息查询接口
     *
     * @param
     * @return
     */
    public JSONObject dispatch(String prescriptionCode, String orgCode) throws Exception {
        JSONObject result = new JSONObject();
        List manage = new ArrayList();
        List types = new ArrayList();
        BaseOrgDO hospital = hospitalDao.findByCode(orgCode);

        String hostpitalName = hospital.getName();
        String address = hospital.getAddress();
        String streeCode = hospital.getStreetCode();
        String townCode = hospital.getTownCode();
        String townName = hospital.getTownName();
        String cityCode = hospital.getCityCode();
        String cityName = hospital.getCityName();
        String provinceCode = hospital.getProvinceCode();
        String provinceName = hospital.getProvinceName();

        String h = orgCode.substring(0, 8);
        String sql = "SELECT h.`code`,h.`name`,h.`province` provinceCode,h.`province_name` provinceName,h.`city` cityCode ,h.`city_name` cityName," +
                " h.`town` townCode,h.`town_name` townName,h.`road_code` streeCode,h.`address` " +
                " FROM dm_hospital h  " +
                " WHERE h.`code` LIKE '%" + h + "%' AND RIGHT(h.code,2)<>'00' ";
        List<Map<String, Object>> hs = jdbcTemplate.queryForList(sql);
        for (Map<String, Object> hspital : hs) {
            Map temp = new HashMap();
            String code = (String) hspital.get("code");
            String name = (String) hspital.get("name");
            String manageProvinceCode = (String) hspital.get("provinceCode");
            String manageProvinceName = (String) hspital.get("provinceName");
            String manageCityCode = (String) hspital.get("cityCode");
            String manageCityName = (String) hspital.get("cityName");
            String manageTownCode = (String) hspital.get("townCode");
            String manageTownName = (String) hspital.get("townName");
            String manageStreeCode = (String) hspital.get("streeCode");
            String manageAddress = (String) hspital.get("address");
            temp.put("code", code);
            temp.put("name", name);
            temp.put("provinceCode", manageProvinceCode);
            temp.put("provinceName", manageProvinceName);
            temp.put("cityCode", manageCityCode);
            temp.put("cityName", manageCityName);
            temp.put("townCode", manageTownCode);
            temp.put("townName", manageTownName);
            temp.put("streeCode", manageStreeCode);
            temp.put("address", manageAddress);
            manage.add(temp);
        }
        //                社区下没有服务站只能自取或快递
        if (hs == null) {
            Map self = new HashMap();
            self.put("code", orgCode);
            self.put("name", hostpitalName);
            self.put("provinceCode", provinceCode);
            self.put("provinceName", provinceName);
            self.put("cityCode", cityCode);
            self.put("cityName", cityName);
            self.put("townCode", townCode);
            self.put("townName", townName);
            self.put("streeCode", streeCode);
            self.put("address", address);
            types.add(1);
            Map express = new HashMap();
            types.add(2);

            result.put("self", self);
            result.put("express", express);
            result.put("types", types);
            return result;
        }
        Map self = new HashMap();
        self.put("code", orgCode);
        self.put("name", hostpitalName);
        self.put("provinceCode", provinceCode);
        self.put("provinceName", provinceName);
        self.put("cityCode", cityCode);
        self.put("cityName", cityName);
        self.put("townCode", townCode);
        self.put("townName", townName);
        self.put("streeCode", streeCode);
        self.put("address", address);
        types.add(1);
        Map express = new HashMap();
        types.add(2);
        Map manager = new HashMap();
        manager.put("codes", manage);

        result.put("self", self);
        result.put("express", express);
        result.put("manager", manager);
        result.put("types", types);
        return result;
    }


    /**
     * 长处方支付成功前端页面回调接口
     *
     * @param
     * @return
     */
    public Map recipeReturnUrl(HttpServletRequest request, HttpServletResponse response, String accessToken) throws Exception {

        return new HashMap();
    }

    /**
     * 长处方对接方异步回调接口 市医保
     *
     * @return
     */
    public String receiveRecipeNotify(HttpServletRequest request, HttpServletResponse response) throws Exception {

        return null;
    }

    /**
     * 长处方对接方异步回调接口 自费
     *
     * @return
     */
    public String receiveRecipeNotify2(HttpServletRequest request, HttpServletResponse response) throws Exception {

        return null;
    }


    /**
     * 长处方支付，成功则返回支付路径
     */
    @Transactional
    public Map charge(int type, String addressJson, String orgCode, String prescriptionCode, int totalAmount, String people, String repUid, String accessToken, String returnUrl, String deliveryTime) throws Exception {
        Map resultMap = new HashMap();

        return resultMap;
    }


//******************************************  支付查询基本工具方法  *******************************************************************************

    /**
     * 家庭医生签约支付查询
     */
    public String chargeQuery(String code, String accessToken) throws Exception {

        return null;
    }

    public String getSignFamilyPayResult(String outChargeNo, String accessToken, String appId, String appSecret) throws Exception {

        return null;
    }


    /**
     * 查询缴费居民手机绑定情况
     *
     * @param user 需要缴费的患者code（共济支付为被代理人）
     * @return
     * @throws Exception
     */
    public String getPatientMobile(String user) throws Exception {
        String mobile = null;
        try {
            BasePatientDO patient = patientDao.findById(user).orElse(null);
            if (patient != null) {
                mobile = patient.getMobile();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return mobile;
    }
    
    /**
     * 根据长处方代码查询支付日志
     * @param prescriptionCode
     * @return
     * @throws Exception
     */
    public List<PayLog> getPayLogsByPrescriptionCode(String prescriptionCode)throws Exception{
        List<PayLog> result = payLogDao.getPayLogsByPrescriptionCode(prescriptionCode);
    
        for (int i = 0; i < result.size(); i++) {
            result.get(i).setResponse("");
            result.get(i).setParams("");
        }
        
        return result;
    }

    /**
     * 家庭医生签约支付查询
     */
    public String getChargeQuery(String code, String accessToken) throws Exception {

        return null;
    }

}

