package com.yihu.jw.afterDiagnosis.service.prescription;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.yihu.jw.afterDiagnosis.dao.prescription.PrescriptionReviewedDao;
import com.yihu.jw.entity.hospital.prescription.WlyyPrescriptionDO;
import com.yihu.jw.entity.hospital.prescription.WlyyPrescriptionLogDO;
import com.yihu.jw.entity.hospital.prescription.WlyyPrescriptionReviewedDO;
import com.yihu.jw.hospital.message.dao.SystemMessageDao;
import com.yihu.jw.hospital.prescription.dao.PrescriptionDao;
import com.yihu.jw.hospital.prescription.service.PrescriptionLogService;
import com.yihu.jw.im.util.ImUtil;
import com.yihu.jw.util.date.DateUtil;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import java.util.Date;

/**
 * 线下调整处方
 * Created by yeshijie on 2017/8/17.
 */
@Service
public class PrescriptionAdjustService {

    @Autowired
    private PrescriptionDao prescriptionDao;
    @Autowired
    private PrescriptionLogService prescriptionLogService;
    @Autowired
    private WlyyPrescriptionService prescriptionService;
    @Autowired
    private SystemMessageDao messageDao;
    @Autowired
    private PrescriptionReviewedDao prescriptionReviewedDao;
    @Autowired
    private PrescriptionInfoService prescriptionInfoService;
    @Autowired
    private ImUtil imUtill;
//    @Autowired
//    private OrgAddressDao orgAddressDao;

    /**
     * 保存续方科室和挂号类型
     * @param code 续方code
     * @param jwGisterTypeCode 基卫-挂号类型编码
     * @param jwDeptCode 基卫-挂号科室
     * @param jwRegisterFee 基卫-诊金
     */
    @Transactional(propagation= Propagation.NOT_SUPPORTED)
    public void saveDept(String code,String jwDeptCode,String jwGisterTypeCode,String jwRegisterFee,String deptCode){
        WlyyPrescriptionDO prescription = prescriptionDao.findById(code).orElse(null);
//        prescription.setJwGisterTypeCode(jwGisterTypeCode);
//        prescription.setJwDeptCode(jwDeptCode);
//        prescription.setJwRegisterFee(jwRegisterFee);
//        prescription.setDeptCode(deptCode);
        prescriptionDao.save(prescription);
    }

    /**
     * 线下调整处方
     * @param code
     */
    @Transactional
    public JSONObject adjustPrescription(String code,String deptCode,String orgAddress){
        JSONObject re = new JSONObject();
        WlyyPrescriptionDO prescription= prescriptionDao.findById(code).orElse(null);
        if (StringUtils.isNotEmpty(deptCode)){
//            prescription.setDeptCode(deptCode);
//            OrgAddress address = orgAddressDao.findByDeptCode(deptCode);
//            prescription.setDeptCodeName(address.getDeptName());
        }
        if (StringUtils.isNotEmpty(orgAddress)){
//            prescription.setOrgAddress(orgAddress);
        }
        if(prescription.getStatus()== WlyyPrescriptionLogDO.PrescriptionLogStatus.revieweding.getValue()||
                prescription.getStatus()== WlyyPrescriptionLogDO.PrescriptionLogStatus.change_error.getValue()){
            //待审核状态才可以线下调整处方
            prescriptionDao.save(prescription);
//            String response = jwPrescriptionService.saveRecipe(code,prescription.getJwGisterTypeCode(),prescription.getJwDeptCode(), deptCode);
            String response = "";
            JSONObject json = JSONObject.parseObject(response);
            if(json.getInteger("status")==200){
                JSONObject data = json.getJSONObject("data");
                String zyCode = data.getString("CODE");
                if("1".equals(zyCode)){
                    JSONArray returnData = data.getJSONArray("returnData");
                    if(returnData.size()>0){
                        JSONObject pre = returnData.getJSONArray(0).getJSONObject(0);
                        String visitNo = pre.getString("VISIT_NO");
                        String recipeNo = pre.getString("RECIPE_NO");
                        prescription.setStatus(WlyyPrescriptionLogDO.PrescriptionLogStatus.changeing.getValue());
                        prescription.setSerialNo(visitNo);
                        prescription.setRealOrder(recipeNo);
                        prescriptionDao.save(prescription);

                        //添加日志
                        prescriptionLogService.addLog(prescription,WlyyPrescriptionLogDO.PrescriptionLogType.zy.getValue(),1,2);

                        re.put("status",200);
                    }else {
                        //请求失败
                        prescriptionLogService.addLog(prescription,WlyyPrescriptionLogDO.PrescriptionLogType.zy.getValue(),0,2);
                        JSONArray byRefParaData = data.getJSONArray("byRefParaData");
                        re.put("status",-1);
                        re.put("msg",byRefParaData.getJSONObject(0).getString("errorMsg"));
                    }
                }else {
                    //调整请求失败
                    prescriptionLogService.addLog(prescription,WlyyPrescriptionLogDO.PrescriptionLogType.zy.getValue(),0,2);
                    re.put("status",-1);
                    re.put("msg",data.getString("MESSAGE"));
                }
            }else{
                //请求报错
                prescriptionLogService.addLog(prescription,WlyyPrescriptionLogDO.PrescriptionLogType.zy.getValue(),0,2);
                re.put("status",-1);
                re.put("msg","请求调整失败");
            }
        }else {
            re.put("status",-1);
            re.put("msg","只有待审核和调整失败的续方可以转线下调整");
        }
        return  re;
    }

    /**
     * 上传ca认证信息
     * @param code
     */
    @Transactional
    public JSONObject uploadCaDigital(String code){
        JSONObject re = new JSONObject();
        WlyyPrescriptionDO prescription= prescriptionDao.findById(code).orElse(null);
        if(prescription.getStatus()==WlyyPrescriptionLogDO.PrescriptionLogStatus.change_success.getValue()){
//            String response = jwPrescriptionService.affirmCARecipe(code);
            String response = "";
            JSONObject json = JSONObject.parseObject(response);
            if(json.getInteger("status")==200){
                JSONObject data = json.getJSONObject("data");
                String zyCode = data.getString("CODE");
                if("1".equals(zyCode)){
                    JSONArray returnData = data.getJSONArray("returnData");
                    if(returnData.size()>0){
                        //{"status":200,"msg":"CA认证通过接口！","data":"{\"CODE\":\"1\",\"returnData\":[{\"result\":\"True\"}],\"byRefParaData\":[{ \"errorMsg\": \"\" }]}"}
                        JSONObject pre = returnData.getJSONObject(0);
                        if("True".equals(pre.getString("result"))){
                            //认证成功-审核完成
                            prescription.setStatus(WlyyPrescriptionLogDO.PrescriptionLogStatus.wait_pay.getValue());
                            //设置审核通过
                            WlyyPrescriptionReviewedDO reviewed = prescriptionReviewedDao.findByPrescriptionCode(code);
                            reviewed.setStatus(1);
                            reviewed.setReviewedTime(new Date());
                            prescriptionDao.save(prescription);

                            //审核通过模板消息
                            prescriptionInfoService.sendRMess(prescription.getId(), 1);

                            //修改系统的续方消息的审核状态
                            messageDao.updatePreScriptionMessage(prescription.getConsult(), "1", 6);

                            //修改系统的消息的待ca认证
//                            messageDao.updatePreScriptionMessage(prescription.getCode(), 9);

                            //获取智业待结算接口，更新药品金额
                            prescriptionService.getPerscriptionInfoCostFromPayInfo(prescription.getId());

                            //添加日志
                            prescriptionLogService.addLog(prescription,WlyyPrescriptionLogDO.PrescriptionLogType.zy.getValue(),1,2);

                            //发送Im消息
                            JSONObject content = new JSONObject();
                            content.put("title", "我已经审核您" + DateUtil.dateToStr(prescription.getCreateTime(), "yyyy-MM-dd") + "发起的续方申请");
                            content.put("result", "审核通过");
                            content.put("reason", "");
                            content.put("url", "");
                            imUtill.sendTopicIM(prescription.getDoctor(), prescription.getDoctorName(), prescription.getConsult(), "15", content.toString(), null);

                            re.put("status",200);
                        }else {
                            //请求失败
                            prescriptionLogService.addLog(prescription,WlyyPrescriptionLogDO.PrescriptionLogType.zy.getValue(),0,2);
                            JSONArray byRefParaData = data.getJSONArray("byRefParaData");
                            re.put("status",-1);
                            re.put("msg",byRefParaData.getJSONObject(0).getString("errorMsg"));
                        }
                    }else {
                        //请求失败
                        prescriptionLogService.addLog(prescription,WlyyPrescriptionLogDO.PrescriptionLogType.zy.getValue(),0,2);
                        JSONArray byRefParaData = data.getJSONArray("byRefParaData");
                        re.put("status",-1);
                        re.put("msg",byRefParaData.getJSONObject(0).getString("errorMsg"));
                    }
                }else {
                    //调整请求失败
                    prescriptionLogService.addLog(prescription,WlyyPrescriptionLogDO.PrescriptionLogType.zy.getValue(),0,2);
                    re.put("status",-1);
                    re.put("msg",data.getString("MESSAGE"));
                }
            }else{
                //请求报错
                prescriptionLogService.addLog(prescription,WlyyPrescriptionLogDO.PrescriptionLogType.zy.getValue(),0,2);
                re.put("status",-1);
                re.put("msg","请求调整失败");
            }

        }else {
            re.put("status",-1);
            re.put("msg","只有调整成功的续方才可上传ca认证信息");
        }
        return  re;
    }

}
