package com.yihu.jw.afterDiagnosis.service.prescription;


import com.yihu.jw.entity.hospital.prescription.WlyyPatientExpressageAddrDO;
import com.yihu.jw.hospital.prescription.dao.WlyyPatientExpressageAddrDao;
import net.sf.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;

import javax.transaction.Transactional;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * Created by Trick on 2017/10/20.
 */
@Service
@Transactional(rollbackOn = Exception.class)
public class PrescriptionAdressService {
    @Autowired
    private JdbcTemplate jdbcTemplate;
    @Autowired
    private WlyyPatientExpressageAddrDao prescriptionAdressDao;

    //获取列表
    public List<Map<String,Object>> getAdressList(String patient){
        String sql = "SELECT ad.* FROM wlyy_patient_expressage_addr ad WHERE ad.patient ='"+patient+"' ORDER BY ad.default_flag DESC";
        List<Map<String,Object>> rs = jdbcTemplate.queryForList(sql);
        return rs;
    }

    public Map<String,Object> getDefAdress(String patient){
        String sql = "SELECT ad.* FROM wlyy_patient_expressage_addr ad WHERE ad.patient ='"+patient+"' AND ad.default_flag = 1";
        List<Map<String,Object>> rs = jdbcTemplate.queryForList(sql);
        if(rs!=null&&rs.size()>0){
            return rs.get(0);
        }else{
            return null;
        }
    }

    //保存
    public String saveAdress(String adressJosn){
        JSONObject jsonObject = JSONObject.fromObject(adressJosn);
        WlyyPatientExpressageAddrDO p = (WlyyPatientExpressageAddrDO) JSONObject.toBean(jsonObject,WlyyPatientExpressageAddrDO.class);
        p.setCreateTime(new Date());
        if(p.getIsDefault()==1){
            List<WlyyPatientExpressageAddrDO> list =  prescriptionAdressDao.queryByPatient(p.getPatient());
            if(list!=null&&list.size()>0){
                String sql ="UPDATE wlyy_prescription_adress set default_flag = 0 WHERE patient ='"+p.getPatient()+"' ";
                jdbcTemplate.execute(sql);
            }
        }
        prescriptionAdressDao.save(p);
        return "1";
    }
    //更新
    public String updateAdress(String adressJson){
        JSONObject jsonObject = JSONObject.fromObject(adressJson);
        WlyyPatientExpressageAddrDO p = (WlyyPatientExpressageAddrDO) JSONObject.toBean(jsonObject,WlyyPatientExpressageAddrDO.class);
        p.setCreateTime(new Date());
        if(p.getIsDefault()==1){
            String sql ="UPDATE wlyy_patient_expressage_addr set defaultFlag = 0 WHERE patient ='"+p.getPatient()+"' ";
            jdbcTemplate.execute(sql);
        }
        prescriptionAdressDao.save(p);
        return "1";
    }

    //删除
    public String delAdress(String id){
        prescriptionAdressDao.deleteById(id);
        return "1";
    }

    public List<Map<String,Object>> getProvince(){
        String sql = "SELECT " +
                " p.`code`, " +
                " p.`name` " +
                " FROM " +
                " base_province p";
        List<Map<String,Object>> rs = jdbcTemplate.queryForList(sql);
        return rs;
    }

    public List<Map<String,Object>> getCityByProvince(String province){
        String sql = "SELECT " +
                " p.`code`, " +
                " p.`name` " +
                " FROM " +
                " base_city p " +
                " WHERE p.province = '"+province+"'";
        List<Map<String,Object>> rs = jdbcTemplate.queryForList(sql);
        return rs;
    }

    public List<Map<String,Object>> getTowmByCity(String city){
        String sql = "SELECT " +
                " p.`code`, " +
                " p.`name` " +
                " FROM " +
                " base_town p " +
                " WHERE p.city = '"+city+"'";
        List<Map<String,Object>> rs = jdbcTemplate.queryForList(sql);
        return rs;
    }

}
