package com.yihu.jw.afterDiagnosis.service.prescription;

import com.alibaba.fastjson.JSONObject;
import com.yihu.jw.afterDiagnosis.dao.prescription.PrescriptionPayDao;
import com.yihu.jw.entity.hospital.prescription.PrescriptionPay;
import com.ylzinfo.onepay.sdk.utils.DateUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * Created by chenweida on 2017/7/27.
 * 处方支付相关
 */
@Service
public class PrescriptionPayService {
    @Autowired
    private PrescriptionPayDao prescriptionPayDao;

    /**
     *  获取处方支付信息
     * @param prescriptionCode 处方code
     * @return
     */
    public PrescriptionPay findByPrescriptionCode(String prescriptionCode) {
        return prescriptionPayDao.findByPrescriptionPay(prescriptionCode);
    }

    /**
     * 5.5.1.2.1.	自费患者身份主索引获取
     */
    /**
     * 获取线下接口
     */
    public void offlineApi(String appid,String transType){
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("version","1.0");
        jsonObject.put("appId",appid);
        jsonObject.put("transType",transType);
        jsonObject.put("timestamp", DateUtil.getCurrentDateTime());



//        1		version	接口版本	varchar2	N	1.0
//        2		appId	应用编号	varchar2	N
//        3		transType	交易类型	varchar2	N	见接口定义
//        4		timestamp	请求时间戳	varchar2	N	yyyy-MM-dd HH:mm:ss
//        5		sign	签名	Varchar2	n
//        6		signType	签名类型	Varchar2	n	MD5/SM3/SM4
//        7		encType	加密类型	Varchar2	n	SM4
//        8		param	业务入参	varchar2	n	详见具体接口定义

    }

    public static void main(String[] args) {
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("transType","ehc.ehealthcode.verify");

        JSONObject param = new JSONObject();
        param.put("user_name","叶仕杰");
        param.put("id_type","01");
        param.put("id_no","350124199002282150");
        param.put("card_no","D57142880");
        param.put("card_type","01");
        param.put("user_sex","0");
        param.put("phone","13559485270");
        jsonObject.put("param",param);

        System.out.println(jsonObject.toJSONString());
    }
}
