package com.yihu.jw.base.dao.menu;

import com.yihu.jw.entity.base.menu.BaseAppMenu;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

import java.util.List;

/**
 * Created by yeshijie on 2022/9/27.
 */
public interface BaseAppMenuDao extends JpaRepository<BaseAppMenu, String>, JpaSpecificationExecutor<BaseAppMenu> {

    @Query(" FROM BaseAppMenu rc WHERE rc.pid =?1 and rc.type=?2")
    List<BaseAppMenu> getChildrenByPid(String pid,Integer type);

    @Query(" FROM BaseAppMenu rc WHERE rc.pid = '0' and rc.type=?1")
    List<BaseAppMenu> getTopParents(Integer type);

    List<BaseAppMenu> findAllByType(Integer type);

    @Query(" FROM BaseAppMenu rc WHERE rc.id <> :id AND rc.code = :code ")
    BaseAppMenu isUniqueCode(@Param("id") String id, @Param("code") String code);

}
