package com.yihu.jw.base.endpoint.childManage;

import com.yihu.jw.base.service.child.ChildManageService;
import com.yihu.jw.contant.CommonContant;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.ListEnvelop;
import com.yihu.jw.restmodel.web.ObjEnvelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * Created by wsl on 2022/7/20
 */


@RestController
@RequestMapping("/childManage")
@Api(tags = "幼儿管理", description = "幼儿管理相关操作")
public class ChildManageController extends EnvelopRestEndpoint {

    @Autowired
    private ChildManageService childManageService;



    @ApiOperation(value = "获取列表")
    @GetMapping("/getChildManageList")
    public ObjEnvelop getChildManageList(@ApiParam(name = "type" ,value = "类型 1图文辅导，2视频辅导，3喜讯详细",required = true)
                                         @RequestParam(value = "type",required = true)Integer type,
                                         @ApiParam(name = "title" ,value = "标题",required = false)
                                         @RequestParam(value = "title",required = false)String title,
                                         @ApiParam(name = "orgCode" ,value = "机构code",required = false)
                                         @RequestParam(value = "orgCode",required = false)String orgCode,
                                         @ApiParam(name = "id" ,value = "id",required = false)
                                         @RequestParam(value = "id",required = false)String id,
                                         @RequestParam(value = "page",required = false)Integer page,
                                         @RequestParam(value = "pageSize",required = false)Integer pageSize){


        try {
            return success(childManageService.getChildManageList(type,page,pageSize,title,orgCode,id));
        } catch (Exception e) {
            e.printStackTrace();
            return ObjEnvelop.getError(CommonContant.Message.GET_ERROR);
        }
    }



    @ApiOperation(value = "保存修改")
    @PostMapping("/saveOrUpdate")
    public Envelop saveOrUpdate(@ApiParam(name = "jsonData",value = "实体转JSON",required = true)
                                @RequestParam(value = "jsonData",required = false)String jsonData){
        try {
            childManageService.saveOrUpdate(jsonData);
            return success(CommonContant.Message.SAVE_SUCCESS,200);
        } catch (Exception e) {
            e.printStackTrace();
            return Envelop.getError(CommonContant.Message.SAVE_ERROR);
        }
    }


    @ApiOperation(value = "删除")
    @PostMapping("/deletInfo")
    public Envelop deletinfo(@ApiParam(name = "id",value = "id",required = true)
                             @RequestParam(value = "id",required = true)String id){

        try {
            childManageService.deletinfo(id);
            return success("删除成功!",200);
        } catch (Exception e) {
            e.printStackTrace();
            return Envelop.getError("删除失败!");
        }
    }


    @ApiOperation(value = "获取机构")
    @GetMapping("/childOrgList")
    public ListEnvelop childOrgList(){
        try {
            return success(childManageService.childOrgList());
        } catch (Exception e) {
            e.printStackTrace();
            return ListEnvelop.getError("获取失败!");
        }

    }



}
