package com.yihu.jw.base.endpoint.dict;

import com.yihu.jw.base.service.dict.BaseTableDictService;
import com.yihu.jw.entity.dict.BaseTableDict;
import com.yihu.jw.restmodel.qvo.ParamQvo;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Map;

@RestController
@RequestMapping(value = "/tableDict")
@Api(value = "表单字典", description = "表单字典", tags = {"表单字典"})
public class BaseTableDictEndpoint extends EnvelopRestEndpoint {
    @Autowired
    private BaseTableDictService tableDictService;

    @PostMapping("/saveTableDict")
    @ApiOperation(value = "保存字典")
    public Envelop saveTableDict(
            @ApiParam(name = "jsonStr", value = "json")
            @RequestParam(name = "jsonStr", required = true) String jsonStr) throws Exception {

        try {
            BaseTableDict entity = objectMapper.readValue(jsonStr, BaseTableDict.class);
            tableDictService.saveTableDict(entity);
            return success("操作成功");
        } catch (Exception e) {
            return failedObjEnvelopException(e);
        }
    }


    @GetMapping("/findDictByName")
    @ApiOperation(value = "查找字典")
    public Envelop findDictByName(
            @ApiParam(name = "jsonStr", value = "json")
            @RequestParam(name = "jsonStr", required = false) String jsonStr) throws Exception {

        try {
            ParamQvo qvo = objectMapper.readValue(jsonStr, ParamQvo.class);
            List<Map<String, Object>> list = tableDictService.findDictByName(qvo);
            return success("查询成功", list);
        } catch (Exception e) {
            return failedObjEnvelopException(e);
        }
    }


}
