package com.yihu.jw.base.endpoint.dict;

import com.yihu.jw.base.service.dict.DictMedicineDosageFormService;
import com.yihu.jw.entity.base.dict.DictMedicineDosageFormDO;
import com.yihu.jw.restmodel.base.dict.DictMedicineDosageFormVO;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.ListEnvelop;
import com.yihu.jw.restmodel.web.ObjEnvelop;
import com.yihu.jw.restmodel.web.PageEnvelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import com.yihu.jw.rm.base.BaseRequestMapping;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.*;
import java.util.List;


/**
*
* 药品剂型字典控制器
*
* @version
* <pre>
 * Author	Version		Date		Changes
 * litaohong 	1.0  		2018年09月11日 	Created
 *
 * </pre>
* @since 1.
*/
@RestController
@RequestMapping(value = BaseRequestMapping.DictMedicineDosageForm.PREFIX)
@Api(value = "药品剂型字典管理", description = "药品剂型字典管理服务接口", tags = {"wlyy基础服务 - 药品剂型字典管理服务接口"})
public class DictMedicineDosageFormEndpoint extends EnvelopRestEndpoint {

@Autowired
private DictMedicineDosageFormService dictMedicineDosageFormService;

@PostMapping(value = BaseRequestMapping.DictMedicineDosageForm.CREATE)
@ApiOperation(value = "创建")
public ObjEnvelop<DictMedicineDosageFormVO> create (
    @ApiParam(name = "json_data", value = "Json数据", required = true)
    @RequestBody String jsonData) throws Exception {
    DictMedicineDosageFormDO dictMedicineDosageForm = toEntity(jsonData, DictMedicineDosageFormDO.class);
    dictMedicineDosageForm = dictMedicineDosageFormService.save(dictMedicineDosageForm);
    return success(dictMedicineDosageForm, DictMedicineDosageFormVO.class);
    }

    @PostMapping(value = BaseRequestMapping.DictMedicineDosageForm.DELETE)
    @ApiOperation(value = "删除")
    public Envelop delete(
    @ApiParam(name = "ids", value = "id串，中间用,分隔", required = true)
    @RequestParam(value = "ids") String ids) {
    dictMedicineDosageFormService.delete(ids.split(","));
    return success("删除成功");
    }

    @PostMapping(value = BaseRequestMapping.DictMedicineDosageForm.UPDATE)
    @ApiOperation(value = "更新")
    public ObjEnvelop<DictMedicineDosageFormVO> update (
        @ApiParam(name = "json_data", value = "Json数据", required = true)
        @RequestBody String jsonData) throws Exception {
        DictMedicineDosageFormDO dictMedicineDosageForm = toEntity(jsonData, DictMedicineDosageFormDO.class);
        if (null == dictMedicineDosageForm.getId()) {
        return failed("ID不能为空", ObjEnvelop.class);
        }
        dictMedicineDosageForm = dictMedicineDosageFormService.save(dictMedicineDosageForm);
        return success(dictMedicineDosageForm, DictMedicineDosageFormVO.class);
        }

        @GetMapping(value = BaseRequestMapping.DictMedicineDosageForm.PAGE)
        @ApiOperation(value = "获取分页")
        public PageEnvelop<DictMedicineDosageFormVO> page (
            @ApiParam(name = "fields", value = "返回的字段，为空返回全部字段")
            @RequestParam(value = "fields", required = false) String fields,
            @ApiParam(name = "filters", value = "过滤器，为空检索所有条件")
            @RequestParam(value = "filters", required = false) String filters,
            @ApiParam(name = "sorts", value = "排序，规则参见说明文档")
            @RequestParam(value = "sorts", required = false) String sorts,
            @ApiParam(name = "page", value = "分页大小", required = true, defaultValue = "1")
            @RequestParam(value = "page") int page,
            @ApiParam(name = "size", value = "页码", required = true, defaultValue = "15")
            @RequestParam(value = "size") int size) throws Exception {
            List<DictMedicineDosageFormDO> dictMedicineDosageForms = dictMedicineDosageFormService.search(fields, filters, sorts, page, size);
                int count = (int)dictMedicineDosageFormService.getCount(filters);
                return success(dictMedicineDosageForms, count, page, size, DictMedicineDosageFormVO.class);
         }

         @GetMapping(value = BaseRequestMapping.DictMedicineDosageForm.LIST)
         @ApiOperation(value = "获取列表")
         public ListEnvelop<DictMedicineDosageFormVO> list (
             @ApiParam(name = "fields", value = "返回的字段，为空返回全部字段")
             @RequestParam(value = "fields", required = false) String fields,
             @ApiParam(name = "filters", value = "过滤器，为空检索所有条件")
             @RequestParam(value = "filters", required = false) String filters,
             @ApiParam(name = "sorts", value = "排序，规则参见说明文档")
             @RequestParam(value = "sorts", required = false) String sorts) throws Exception {
             List<DictMedicineDosageFormDO> dictMedicineDosageForms = dictMedicineDosageFormService.search(fields, filters, sorts);
                  return success(dictMedicineDosageForms, DictMedicineDosageFormVO.class);
         }

 }
