package com.yihu.jw.base.endpoint.lifeCare;

import com.yihu.jw.base.service.lifeCare.LifeCareService;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.ObjEnvelop;
import com.yihu.jw.restmodel.web.PageEnvelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import com.yihu.jw.rm.base.BaseRequestMapping;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Map;

/**
 * Created by Bing on 2022/3/9.
 */
@RestController
@RequestMapping(value = BaseRequestMapping.LifeCare.PREFIX, produces = MediaType.APPLICATION_JSON_UTF8_VALUE)
@Api(value = "生活照料管理", description = "生活照料管理接口", tags = {"wlyy基础服务 - 生活照料管理接口"})
public class LifeCareEndpoint extends EnvelopRestEndpoint {

    @Autowired
    private LifeCareService lifeCareService;






    //----------------------------------------------------------------------------


    @ApiOperation("获取生活照料服务项目列表")
    @RequestMapping(value = "/getServeDictList",method = RequestMethod.GET)
    public PageEnvelop<List<Map<String,Object>>> getServeDictList(@ApiParam(name = "orgName",value = "机构名称",required = false)
                                        @RequestParam(value = "orgName",required = false)String orgName,
                                        @ApiParam(name = "itemName",value = "服务项目名称",required = false)
                                        @RequestParam(value = "itemName",required = false)String itemName,
                                        @ApiParam(name = "page", value = "分页大小", required = true, defaultValue = "1")
                                        @RequestParam(value = "page") Integer page,
                                        @ApiParam(name = "size", value = "页码", required = true, defaultValue = "15")
                                        @RequestParam(value = "size") Integer size){
        try {
            return lifeCareService.getServeDictList(orgName,itemName,page,size);
        }catch (Exception e){
            return failedPageEnvelopException2(e);
        }
    }

    @ApiOperation("编辑新增生活照料服务型")
    @RequestMapping(value = "/saveLifeItem",method = RequestMethod.POST)
    public Envelop saveLifeItem(@ApiParam(name = "json",value = "json数据",required = true)
                                @RequestParam(value = "json",required = false)String json){
        try {
            return success(lifeCareService.saveLifeItem(json));
        }catch (Exception e){
            return failedException2(e);
        }
    }

    @ApiOperation("修改生活照料服务项目状态")
    @RequestMapping(value = "/updDelLifeItem",method = RequestMethod.POST)
    public Envelop saveLifeItem(@ApiParam(name = "code",value = "服务项code",required = true)
                                @RequestParam(value = "code",required = false)String code,
                                @ApiParam(name = "status",value = "1有效 0无效",required = true)
                                @RequestParam(value = "status",required = false)Integer status,
                                @ApiParam(name = "orgCode",value = "机构code",required = true)
                                @RequestParam(value = "orgCode",required = false)String orgCode){
        try {
            return success(lifeCareService.updDelLifeItem(code,status,orgCode));
        }catch (Exception e){
            return failedException2(e);
        }
    }

    @ApiOperation("获取服务详情")
    @RequestMapping(value = "/getLifeItemDetail",method = RequestMethod.GET)
    public ObjEnvelop getLifeItemDetail(@ApiParam(name = "code",value = "服务项code",required = true)
                                    @RequestParam(value = "code",required = true)String id){
        try {
            return success(lifeCareService.getLifeItemDetail(id));
        }catch (Exception e){
            return failedObjEnvelopException2(e);
        }
    }

    @ApiOperation("删除服务项/机构服务项")
    @PostMapping(value = "/delLifeItem")
    public Envelop delLifeItem(@ApiParam(name = "code", value = "服务项code", required = true)
                               @RequestParam(value = "code", required = true) String code,
                               @ApiParam(name = "orgCode", value = "机构code", required = false)
                               @RequestParam(value = "orgCode", required = false) String orgCode) {


        try {
            return success(lifeCareService.delLifeItem(code, orgCode));
        } catch (Exception e) {
            return failedException2(e);
        }

    }

}
