package com.yihu.jw.base.endpoint.processGuidance;


import com.yihu.jw.contant.CommonContant;
import com.yihu.jw.entity.base.processGuidance.*;
import com.yihu.jw.processGuidance.dao.*;
import com.yihu.jw.processGuidance.service.BaseProcessGuidanceNodeService;
import com.yihu.jw.processGuidance.service.BaseProcessGuidanceNodeWxService;
import com.yihu.jw.processGuidance.service.BaseProcessGuidancePushLogService;
import com.yihu.jw.processGuidance.service.BaseProcessGuidanceService;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.ListEnvelop;
import com.yihu.jw.restmodel.web.ObjEnvelop;
import com.yihu.jw.restmodel.web.PageEnvelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.BeanPropertyRowMapper;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.List;

/**
 * Created by yeshijie on 2022/10/8.
 */
@RestController
@RequestMapping(value = "processGuidance")
@Api(value = "全流程指引", tags = {"全流程指引"})
public class BaseProcessGuidanceEndpoint extends EnvelopRestEndpoint {

    @Autowired
    private BaseProcessGuidanceService processGuidanceService;
    @Resource
    private BaseProcessGuidanceDao processGuidanceDao;
    @Resource
    private BaseProcessGuidanceNodeService processGuidanceNodeService;
    @Resource
    private BaseProcessGuidanceDeptDao processGuidanceDeptDao;
    @Resource
    private BaseProcessGuidanceNodeDao processGuidanceNodeDao;
    @Resource
    private BaseProcessGuidanceNodeAppDao processGuidanceNodeAppDao;
    @Resource
    private BaseProcessGuidanceNodeWxDao processGuidanceNodeWxDao;
    @Resource
    private BaseProcessGuidanceNodeWxService processGuidanceNodeWxService;
    @Resource
    private BaseProcessGuidanceNodeSmsDao processGuidanceNodeSmsDao;
    @Resource
    private BaseProcessGuidancePushLogService processGuidancePushLogService;
    @Resource
    private BaseProcessGuidancePresetDao processGuidancePresetDao;
    @Resource
    private JdbcTemplate jdbcTemplate;

    @PostMapping(value = "saveProcessGuidance")
    @ApiOperation(value = "保存或更新流程")
    public ObjEnvelop saveProcessGuidance(@ApiParam(name = "jsonData", value = "Json数据", required = true)
                                              @RequestParam(value = "jsonData") String jsonData) {
        try {
            BaseProcessGuidanceDO guidanceDO = toEntity(jsonData, BaseProcessGuidanceDO.class);
            return processGuidanceService.saveProcessGuidance(guidanceDO);
        }catch (Exception e){
            e.printStackTrace();
        }
        return ObjEnvelop.getError(CommonContant.Message.SAVE_ERROR);
    }

    @GetMapping(value = "processGuidancePushLogPage")
    @ApiOperation(value = "获取消息推送日志分页")
    public PageEnvelop processGuidancePushLogPage(
            @ApiParam(name = "fields", value = "返回的字段，为空返回全部字段")
            @RequestParam(value = "fields", required = false) String fields,
            @ApiParam(name = "filters", value = "过滤器，为空检索所有条件")
            @RequestParam(value = "filters", required = false) String filters,
            @ApiParam(name = "sorts", value = "排序，规则参见说明文档")
            @RequestParam(value = "sorts", required = false) String sorts,
            @ApiParam(name = "page", value = "分页大小", required = true, defaultValue = "1")
            @RequestParam(value = "page") int page,
            @ApiParam(name = "size", value = "页码", required = true, defaultValue = "15")
            @RequestParam(value = "size") int size){
        try {
            List<BaseProcessGuidancePushLogDO> processGuidancePushLogDOS = processGuidancePushLogService.search(fields, filters, sorts, page, size);
            processGuidancePushLogDOS.forEach(one->{
                if(one.getSendType()==1){
                    one.setSendTypeName("wx模板");
                }else {
                    one.setSendTypeName("短信");
                }
                if(one.getUserType()==1){
                    one.setUserTypeName("居民");
                }else {
                    one.setUserTypeName("医生");
                }
                if(one.getStatus()==1){
                    one.setStatusName("成功");
                }else {
                    one.setStatusName("失败");
                }
            });
            int count = (int) processGuidancePushLogService.getCount(filters);
            return success(processGuidancePushLogDOS, count, page, size, BaseProcessGuidancePushLogDO.class);
        }catch (Exception e){
            e.printStackTrace();
        }
        return PageEnvelop.getError("查询失败");
    }

    @PostMapping(value = "saveProcessGuidanceNodeSms")
    @ApiOperation(value = "保存或更新节点段信")
    public ObjEnvelop saveProcessGuidanceNodeSms(@ApiParam(name = "jsonData", value = "Json数据", required = true)
                                                @RequestParam(value = "jsonData") String jsonData) {
        try {
            BaseProcessGuidanceNodeSmsDO nodeSmsDO = toEntity(jsonData, BaseProcessGuidanceNodeSmsDO.class);
            return processGuidanceService.saveProcessGuidanceNodeSms(nodeSmsDO);
        }catch (Exception e){
            e.printStackTrace();
        }
        return ObjEnvelop.getError(CommonContant.Message.SAVE_ERROR);
    }

    @PostMapping(value = "saveProcessGuidanceNodeWx")
    @ApiOperation(value = "保存或更新节点微信模板")
    public ObjEnvelop saveProcessGuidanceNodeWx(@ApiParam(name = "jsonData", value = "Json数据", required = true)
                             @RequestParam(value = "jsonData") String jsonData) {
        try {
            BaseProcessGuidanceNodeWxDO nodeWxDO = toEntity(jsonData, BaseProcessGuidanceNodeWxDO.class);
            if(StringUtils.isBlank(nodeWxDO.getNodeId())){
                return ObjEnvelop.getError("参数错误，节点id不能为空");
            }
            return processGuidanceService.saveProcessGuidanceNodeWx(nodeWxDO);
        }catch (Exception e){
            e.printStackTrace();
        }
        return ObjEnvelop.getError(CommonContant.Message.SAVE_ERROR);
    }

    @GetMapping(value = "nodeWxTemplateList")
    @ApiOperation(value = "获取列表")
    public ListEnvelop<BaseProcessGuidanceNodeWxDO> list() throws Exception {
        try {
            List<BaseProcessGuidanceNodeWxDO> nodeWxDOList = processGuidanceNodeWxService.search(null, "nodeId=system", null);
            return ListEnvelop.getSuccess("查询成功",nodeWxDOList);
        }catch (Exception e){
            e.printStackTrace();
        }
        return ListEnvelop.getError(CommonContant.Message.GET_ERROR);
    }

    @PostMapping(value = "saveProcessGuidanceNode")
    @ApiOperation(value = "保存或更新节点")
    public ObjEnvelop saveProcessGuidanceNode(@ApiParam(name = "jsonData", value = "Json数据", required = true)
                              @RequestParam(value = "jsonData") String jsonData) {
        try {
            BaseProcessGuidanceNodeDO nodeDO = toEntity(jsonData, BaseProcessGuidanceNodeDO.class);
            return processGuidanceService.saveProcessGuidanceNode(nodeDO);
        }catch (Exception e){
            e.printStackTrace();
        }
        return ObjEnvelop.getError(CommonContant.Message.SAVE_ERROR);
    }

    @GetMapping(value = "getWxTemplateByNodeId")
    @ApiOperation(value = "按节点id查找微信模板")
    public Envelop getWxTemplateByNodeId(
            @ApiParam(name = "nodeId", value = "节点id", required = true)
            @RequestParam(value = "nodeId") String nodeId) {
        try {
            List<BaseProcessGuidanceNodeWxDO> list =  processGuidanceNodeWxDao.findByNodeId(nodeId);
            if(list.size()>0){
                return ObjEnvelop.getSuccess("查询成功",list.get(0));
            }
            return ObjEnvelop.getSuccess("查询成功");
        }catch (Exception e){
            e.printStackTrace();
        }
        return Envelop.getError("查询失败");
    }

    @GetMapping(value = "getSmsByNodeId")
    @ApiOperation(value = "按节点id查找短信模板")
    public Envelop getSmsByNodeId(
            @ApiParam(name = "nodeId", value = "节点id", required = true)
            @RequestParam(value = "nodeId") String nodeId) {
        try {
            List<BaseProcessGuidanceNodeSmsDO> list =  processGuidanceNodeSmsDao.findByNodeId(nodeId);
            if(list.size()>0){
                return ObjEnvelop.getSuccess("查询成功",list.get(0));
            }
            return ObjEnvelop.getSuccess("查询成功");
        }catch (Exception e){
            e.printStackTrace();
        }
        return Envelop.getError("查询失败");
    }

    @GetMapping(value = "getProcessGuidanceNodeById")
    @ApiOperation(value = "按id查找节点模板")
    public Envelop getProcessGuidanceNodeById(
            @ApiParam(name = "id", value = "id", required = true)
            @RequestParam(value = "id") String id) {
        try {
            BaseProcessGuidanceNodeDO processGuidanceDO = processGuidanceNodeDao.findById(id).orElse(null);
            if(processGuidanceDO==null){
                return Envelop.getError("id不存在");
            }
            if(processGuidanceDO.getStatus()==1){
                processGuidanceDO.setStatusName("生效");
            }else {
                processGuidanceDO.setStatusName("失效");
            }
            List<BaseProcessGuidanceNodeAppDO> nodeAppDOList = processGuidanceNodeAppDao.findByNodeId(id);
            processGuidanceDO.setNodeAppDOList(nodeAppDOList);
            return ObjEnvelop.getSuccess("查询成功",processGuidanceDO);
        }catch (Exception e){
            e.printStackTrace();
        }
        return Envelop.getError("查询失败");
    }

    @GetMapping(value = "processGuidanceNodePage")
    @ApiOperation(value = "获取节点分页")
    public PageEnvelop processGuidanceNodePage(
            @ApiParam(name = "fields", value = "返回的字段，为空返回全部字段")
            @RequestParam(value = "fields", required = false) String fields,
            @ApiParam(name = "filters", value = "过滤器，为空检索所有条件")
            @RequestParam(value = "filters", required = false) String filters,
            @ApiParam(name = "sorts", value = "排序，规则参见说明文档")
            @RequestParam(value = "sorts", required = false) String sorts,
            @ApiParam(name = "page", value = "分页大小", required = true, defaultValue = "1")
            @RequestParam(value = "page") int page,
            @ApiParam(name = "size", value = "页码", required = true, defaultValue = "15")
            @RequestParam(value = "size") int size) {
        try {
            List<BaseProcessGuidanceNodeDO> processGuidanceDOList = processGuidanceNodeService.search(fields, filters, sorts, page, size);
            processGuidanceDOList.forEach(one->{
                if(one.getStatus()==1){
                    one.setStatusName("生效");
                }else {
                    one.setStatusName("失效");
                }
                List<BaseProcessGuidanceNodeAppDO> nodeAppDOList = processGuidanceNodeAppDao.findByNodeId(one.getId());
                one.setNodeAppDOList(nodeAppDOList);
            });
            int count = (int) processGuidanceNodeService.getCount(filters);
            return success(processGuidanceDOList, count, page, size, BaseProcessGuidanceNodeDO.class);
        }catch (Exception e){
            e.printStackTrace();
        }
        return PageEnvelop.getError("查询失败");
    }

    @GetMapping(value = "processGuidancePage")
    @ApiOperation(value = "获取就诊流程分页")
    public PageEnvelop processGuidancePage(
            @ApiParam(name = "fields", value = "返回的字段，为空返回全部字段")
            @RequestParam(value = "fields", required = false) String fields,
            @ApiParam(name = "filters", value = "过滤器，为空检索所有条件")
            @RequestParam(value = "filters", required = false) String filters,
            @ApiParam(name = "deptName", value = "部门名称")
            @RequestParam(value = "deptName", required = false) String deptName,
            @ApiParam(name = "sorts", value = "排序，规则参见说明文档")
            @RequestParam(value = "sorts", required = false) String sorts,
            @ApiParam(name = "page", value = "分页大小", required = true, defaultValue = "1")
            @RequestParam(value = "page") int page,
            @ApiParam(name = "size", value = "页码", required = true, defaultValue = "15")
            @RequestParam(value = "size") int size){
        try {
            if(StringUtils.isBlank(deptName)){
                List<BaseProcessGuidanceDO> processGuidanceDOList = processGuidanceService.search(fields, filters, sorts, page, size);
                processGuidanceDOList.forEach(one->{
                    if(one.getStatus()==1){
                        one.setStatusName("生效");
                    }else {
                        one.setStatusName("失效");
                    }
                    List<BaseProcessGuidanceDeptDO> deptDOList = processGuidanceDeptDao.findByProcessGuidanceId(one.getId());
                    one.setDeptDOList(deptDOList);
                });
                int count = (int) processGuidanceService.getCount(filters);
                return success(processGuidanceDOList, count, page, size, BaseProcessGuidanceDO.class);
            }
            String sql = "SELECT DISTINCT g.* ";
            String sqlCount = "SELECT count(DISTINCT g.id) ";
            String filter = " FROM base_process_guidance g " +
                    "LEFT JOIN base_process_guidance_dept d on g.id = d.process_guidance_id " +
                    "WHERE (g.is_all_dept = 1 or d.dept_name like '%"+deptName+"%') ";
            if(StringUtils.isNotBlank(filters)){
                filter += " and g.name like '%"+filters.split("\\?")[1]+"%'";
            }
            String limit = " limit "+(page-1)*size+","+size;
            Integer count = jdbcTemplate.queryForObject(sqlCount + filter,Integer.class);
            List<BaseProcessGuidanceDO> processGuidanceDOList = new ArrayList<>();
            if(count>0){
                processGuidanceDOList = jdbcTemplate.query(sql+filter+limit,new BeanPropertyRowMapper<>(BaseProcessGuidanceDO.class));
                processGuidanceDOList.forEach(one->{
                    if(one.getStatus()==1){
                        one.setStatusName("生效");
                    }else {
                        one.setStatusName("失效");
                    }
                    List<BaseProcessGuidanceDeptDO> deptDOList = processGuidanceDeptDao.findByProcessGuidanceId(one.getId());
                    one.setDeptDOList(deptDOList);
                });
            }
            return success(processGuidanceDOList, count, page, size, BaseProcessGuidanceDO.class);
        }catch (Exception e){
            e.printStackTrace();
        }
        return PageEnvelop.getError("查询失败");
    }

    @GetMapping(value = "getProcessGuidanceById")
    @ApiOperation(value = "按id查找流程")
    public Envelop getProcessGuidanceById(
            @ApiParam(name = "id", value = "id", required = true)
            @RequestParam(value = "id") String id) {
        try {
            BaseProcessGuidanceDO processGuidanceDO = processGuidanceDao.findById(id).orElse(null);
            if(processGuidanceDO==null){
                return Envelop.getError("id不存在");
            }
            if(processGuidanceDO.getStatus()==1){
                processGuidanceDO.setStatusName("生效");
            }else {
                processGuidanceDO.setStatusName("失效");
            }
            List<BaseProcessGuidanceDeptDO> deptDOList = processGuidanceDeptDao.findByProcessGuidanceId(id);
            processGuidanceDO.setDeptDOList(deptDOList);

            List<BaseProcessGuidancePresetDO> presetDOList = processGuidancePresetDao.findByProcessGuidanceId(id);
            processGuidanceDO.setPresetDOList(presetDOList);

            return ObjEnvelop.getSuccess("查询成功",processGuidanceDO);
        }catch (Exception e){
            e.printStackTrace();
        }
        return Envelop.getError("查询失败");
    }

    @PostMapping(value = "delProcessGuidance")
    @ApiOperation(value = "删除就诊流程")
    public Envelop delProcessGuidance(
            @ApiParam(name = "id", value = "id", required = true)
            @RequestParam(value = "id") String id) {
        try {
            return processGuidanceService.delProcessGuidance(id);
        }catch (Exception e){
            e.printStackTrace();
        }
        return Envelop.getError("删除失败");
    }

    @PostMapping(value = "delProcessGuidanceNode")
    @ApiOperation(value = "删除节点模板")
    public Envelop delProcessGuidanceNode(
            @ApiParam(name = "id", value = "id", required = true)
            @RequestParam(value = "id") String id) {
        try {
            return processGuidanceService.delProcessGuidanceNode(id);
        }catch (Exception e){
            e.printStackTrace();
        }
        return Envelop.getError("删除失败");
    }

}
