package com.yihu.jw.base.service.ManageMessagePush;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.serializer.SerializerFeature;
import com.yihu.jw.base.dao.log.BasePatientPadPushOnOffDao;
import com.yihu.jw.base.dao.log.BasePushRecordLogDao;
import com.yihu.jw.base.dao.log.BasePushrecordLogInfoDao;
import com.yihu.jw.entity.base.patient.BasePatientDO;
import com.yihu.jw.entity.hospital.message.SystemMessageDO;
import com.yihu.jw.entity.log.BasePatientPadPushOnOffEntity;
import com.yihu.jw.entity.log.BasePushRecordLogEntity;
import com.yihu.jw.entity.log.BasePushrecordLogInfoEntity;
import com.yihu.jw.hospital.dict.WlyyHospitalSysDictDao;
import com.yihu.jw.hospital.message.dao.SystemMessageDao;
import com.yihu.jw.im.util.ImUtil;
import com.yihu.jw.util.date.DateUtil;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.ResponseEntity;
import org.springframework.jdbc.core.BeanPropertyRowMapper;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.client.RestTemplate;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.UUID;


/**
 * Created by wsl on 2022/7/4
 */
@Service
public class ManageSystemPushMessageService {


    @Autowired
    private JdbcTemplate jdbcTemplate;
    @Autowired
    private SystemMessageDao systemMessageDao;
    @Autowired
    private BasePushRecordLogDao basePushRecordLogDao;
    @Autowired
    private BasePushrecordLogInfoDao basePushrecordLogInfoDao;
    @Autowired
    private BasePatientPadPushOnOffDao basePatientPadPushOnOffDao;
    @Autowired
    private WlyyHospitalSysDictDao dictDao;
    @Autowired
    private RestTemplate restTemplate;
    @Autowired
    private ImUtil imUtil;

    /*   SELECT p.id,p.name  FROM base_patient p INNER JOIN wlyy_patient_device d ON p.id = d.`user`
    WHERE p.sign_status = 0 AND p.del = 1 AND d.del = 0 AND p.id NOT IN ( SELECT dict_code FROM `base`.`wlyy_hospital_sys_dict` WHERE `dict_name` = 'jkzl_older' OR dict_name = 'jkzl_child' )*/



    /**
     * 获取签约老人
     * @param name
     */
    public List<BasePatientDO> signOlds(String name) {


        String sql = "SELECT p.id,p.`name`,p.sex FROM  base_patient p " +
                " WHERE  p.sign_status = 1 AND p.del = 1  ";

        if (StringUtils.isNotBlank(name)) {
            sql += "and p.name like '%" + name + "%'";
        }
        sql += " AND p.id NOT IN ( SELECT dict_code FROM `base`.`wlyy_hospital_sys_dict` WHERE `dict_name` = 'jkzl_older' OR dict_name = 'jkzl_child' )";
        List<BasePatientDO> basePatientDOS = jdbcTemplate.query(sql, BeanPropertyRowMapper.newInstance(BasePatientDO.class));
        return basePatientDOS;
    }

    /**
     * 新增消息推送
     *
     * @param content  自定义内容
     * @param pushObjectType  推送对象类型 1签约老人 2部分签约老人
     * @param pushObjectJson 推送对象
     * @param pushDateType  推送时间 1立即推送 2定时推送
     * @param pushDate
     */
    @Transactional(rollbackFor = Exception.class)
    public void addPushMessage(String content, Integer pushObjectType, String pushObjectJson, Integer pushDateType, String pushDate,Integer addType,String pushId) {
        BasePushRecordLogEntity basePushRecordLogEntity = new BasePushRecordLogEntity();
        List<BasePatientDO> basePatientDOS = null;
        List<BasePushrecordLogInfoEntity> basePushrecordLogInfoEntityList = new ArrayList<>();

        Date date =DateUtil.strToDate(pushDate);
        if (null!=addType&&addType==2) {
            BasePushRecordLogEntity one = basePushRecordLogDao.findById(pushId).orElse(null);;
            if (one.getStatus()!=1) {
                basePushRecordLogDao.deleteById(pushId);
                basePushrecordLogInfoDao.deleteByPushId(pushId);
            }
        }

        //判断发送对象类型  1签约老人  2 部分签约老人
        if (1 == pushObjectType) {
            basePatientDOS = signOlds("");
            basePushRecordLogEntity.setSendObjectType(1);
            basePushRecordLogEntity.setSendObject("签约老人");
        }else {
            basePatientDOS = JSONObject.parseArray(pushObjectJson, BasePatientDO.class);
            basePushRecordLogEntity.setSendObjectType(2);
            String s = nameStringHandle(basePatientDOS);
            basePushRecordLogEntity.setSendObject(s);
        }

        Integer status ;
        //判断 1立即发送   2定时发送
        if (1==pushDateType) {
            SystemMessageDOListSave(basePatientDOS,content);
            basePushRecordLogEntity.setStatus(1);
            basePushRecordLogEntity.setSendTime(new Date());
            basePushRecordLogEntity.setPushType("1");
            status = 1;
        }else{
            basePushRecordLogEntity.setSendTime(date);
            basePushRecordLogEntity.setStatus(0);
            basePushRecordLogEntity.setPushType("2");
            status = 0;
        }


        //创建定时任务记录
        for (BasePatientDO logInfoDO : basePatientDOS) {
            String data = content;
            if (StringUtils.containsIgnoreCase(content,"【姓名】"))data = data.replace("【姓名】",logInfoDO.getName());
            if (StringUtils.containsIgnoreCase(content,"【称谓】"))data = data.replace("【称谓】",logInfoDO.getSex()==1?"大爷":"大妈");
            BasePushrecordLogInfoEntity basePushrecordLogInfoEntity = new BasePushrecordLogInfoEntity();
            basePushrecordLogInfoEntity.setPatient(logInfoDO.getId());
            basePushrecordLogInfoEntity.setPatientName(logInfoDO.getName());
            basePushrecordLogInfoEntity.setContent(data);
            basePushrecordLogInfoEntity.setStatus(status);
            basePushrecordLogInfoEntity.setSendTime(date);
            basePushrecordLogInfoEntityList.add(basePushrecordLogInfoEntity);
        }

        //日志保存
        //basePushRecordLogEntity.setId(UUID.randomUUID().toString().replace("-", ""));
        basePushRecordLogEntity.setContent(content);
        basePushRecordLogEntity.setNum(basePatientDOS.size());
        basePushRecordLogEntity.setMessageType(1);
        basePushRecordLogDao.save(basePushRecordLogEntity);


        if (null!=basePushrecordLogInfoEntityList&&basePushrecordLogInfoEntityList.size()>0) {
            basePushrecordLogInfoEntityList.forEach(basePushLogInfoEntity -> basePushLogInfoEntity.setPushId(basePushRecordLogEntity.getId()));
            basePushrecordLogInfoDao.saveAll(basePushrecordLogInfoEntityList);
        }

    }


    //获取列表
    public JSONObject pushMessageList(Integer messageType,Integer status,String name,Integer page,Integer pageSize){

        JSONObject result = new JSONObject();

        if(page==null){
            page = 1;
        }
        if(pageSize==null){
            pageSize = 10;
        }

        String sql = "SELECT * FROM base_pushrecord_log where 1=1 ";
        String countSql = "Select  count(id) from base_pushrecord_log where 1=1 ";
        String filiteSql = " ";
        String orderSql = " ";

        if(null!=messageType){
            filiteSql +=" and message_type ='"+messageType+"' ";
        }

        if (null!=status) {
            filiteSql +=" and status = '"+status+"'";
        }

        if (StringUtils.isNotBlank(name)){
            filiteSql +=" and  send_object like '%"+name+"%'";
        }

        orderSql = " ORDER BY send_time DESC LIMIT  " + (page - 1) * pageSize + "," + pageSize + "";

        List<BasePushRecordLogEntity> entityList = jdbcTemplate.query(sql + filiteSql + orderSql, new BeanPropertyRowMapper<>(BasePushRecordLogEntity.class));
        result.put("obj",entityList);
        Integer count = jdbcTemplate.queryForObject(countSql + filiteSql, Integer.class);
        result.put("count",count);


        if (entityList.size()>0) {
            for (BasePushRecordLogEntity logEntity : entityList) {
                String patientListSql = "select patient from base_pushrecord_log_info where push_id = '"+logEntity.getId()+"'";
                List<String> list = jdbcTemplate.queryForList(patientListSql, String.class);
                logEntity.setPatientList(list);
            }
        }
        return result;
    }


    //删除
    @Transactional(rollbackFor = Exception.class)
    public void delPushMessageLog(String id){
        basePushRecordLogDao.deleteById(id);
    }


    //初始化居民推送开关
    @Transactional(rollbackFor = Exception.class)
    public String patientPushOnOff(){

        JSONObject jsonObject = new JSONObject();
        JSONArray jsonArray = new JSONArray();

        jsonObject.put("1","时间整点报时");
        jsonArray.add(jsonObject);
        jsonObject.put("2","智能安居设备状态播报(必选)");
        jsonArray.add(jsonObject);
        jsonObject.put("3","体征测量消息");
        jsonArray.add(jsonObject);
        jsonObject.put("4","用药提醒");
        jsonArray.add(jsonObject);
        jsonObject.put("5","天气预报");
        jsonArray.add(jsonObject);
        jsonObject.put("6","服务预约提醒");
        jsonArray.add(jsonObject);
        jsonObject.put("7","生日祝福提醒");
        jsonArray.add(jsonObject);
        jsonObject.put("8","热点新闻播报");
        jsonArray.add(jsonObject);

        String sql = "SELECT p.id FROM  base_patient p WHERE  p.sign_status = 1 AND p.del = 1  ";

        List<String> patientList = jdbcTemplate.queryForList(sql, String.class);

        List<BasePatientPadPushOnOffEntity> onOffEntityList = new ArrayList<>();

        patientList.forEach(patientId -> {
            for (int i = 1; i <= jsonArray.size(); i++) {
                BasePatientPadPushOnOffEntity onOffEntity = new BasePatientPadPushOnOffEntity();
                onOffEntity.setPatient(patientId);
                onOffEntity.setType(i);
                onOffEntity.setTypeName(jsonArray.getJSONObject(0).getString(i+""));
                if (jsonArray.getJSONObject(0).getString(i+"").equals("智能安居设备状态播报(必选)")){
                    onOffEntity.setOnOff(1);
                }else {
                    onOffEntity.setOnOff(0);
                }
                onOffEntity.setCreateTime(new Date());
                onOffEntityList.add(onOffEntity);
            }
        });
        
        basePatientPadPushOnOffDao.saveAll(onOffEntityList);

        return null;

    }





    //推送开关修改
    public void pushOnOff(String id,String dictName,String pyCode) {
        dictDao.updatePyCode(pyCode,id,dictName);
    }



    private void SystemMessageDOListSave(List<BasePatientDO> basePatientDOS,String content){
        List<SystemMessageDO> messageDOS = new ArrayList<>();
        for (BasePatientDO basePatientDO : basePatientDOS) {
            String data = content;
            if (StringUtils.containsIgnoreCase(content,"【姓名】"))data = data.replace("【姓名】",basePatientDO.getName());
            if (StringUtils.containsIgnoreCase(content,"【称谓】"))data = data.replace("【称谓】",basePatientDO.getSex()==1?"大爷":"大妈");

            SystemMessageDO systemMessageDO = new SystemMessageDO();
            systemMessageDO.setId(UUID.randomUUID().toString().replace("-", ""));
            systemMessageDO.setTitle("系统消息推送");
            systemMessageDO.setType("999");
            systemMessageDO.setIsRead("0");
            systemMessageDO.setSender("system");
            systemMessageDO.setSenderName("系统推送助手");
            systemMessageDO.setReceiver(basePatientDO.getId());
            systemMessageDO.setReceiverName(basePatientDO.getName());
            systemMessageDO.setContent(data);
            systemMessageDO.setOver("1");
            systemMessageDO.setDel("1");
            systemMessageDO.setCreateTime(new Date());
            systemMessageDO.setAudioUrl(audioUrl(data));
            messageDOS.add(systemMessageDO);

            patientMessageSocket(systemMessageDO);
        }
        systemMessageDao.saveAll(messageDOS);
    }



    //处理名字
    private String  nameStringHandle(List<BasePatientDO> basePatientDOS){
        String names = "";
        for (int i = 0; i < basePatientDOS.size(); i++) {
            BasePatientDO basePatientDO = basePatientDOS.get(i);
            String s = i == basePatientDOS.size()-1 ? "" : ",";
            names += basePatientDO.getName()+ s;
        }
        return names;
    }


    //腾讯语音
    private String audioUrl(String content){
        ResponseEntity<String> forEntity = restTemplate.getForEntity("http://svr-cloud-care/common/open/wordToVoice?text={1}", String.class, content);
        JSONObject jsonObject = JSONObject.parseObject(forEntity.getBody());
        if (jsonObject.getInteger("status") == 200){
            return jsonObject.getString("message");
        }else {
            return null;
        }
    }


    //SOCKET
    private void patientMessageSocket(SystemMessageDO messageDOWatch){
        JSONObject message = new JSONObject();
        message.put("title",messageDOWatch.getTitle());
        message.put("type",messageDOWatch.getType());
        message.put("content",messageDOWatch.getContent());
        message.put("audioUrl",messageDOWatch.getAudioUrl());
        message.put("content_type",999);
        imUtil.sendPatientSystemMessage(messageDOWatch.getReceiver(), JSON.toJSONString(message, SerializerFeature.WriteMapNullValue));
    }





}
