package com.yihu.jw.base.service.child;

import com.alibaba.fastjson.JSONObject;
import com.yihu.jw.base.dao.childManage.BaseChildManageDao;
import com.yihu.jw.entity.care.child.BaseChildManage;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.BeanPropertyRowMapper;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * Created by wsl on 2022/7/20
 */

@Service
public class ChildManageService {


    @Autowired
    private JdbcTemplate jdbcTemplate;
    @Autowired
    private BaseChildManageDao baseChildManageDao;

    //获取
    public JSONObject getChildManageList(Integer type,Integer page,Integer pageSize,String title,String orgCode,String id){

        JSONObject jsonObject = new JSONObject();

        String sql = "select * from base_child_manage where  1=1 and type = "+type+" ";
        String totalSql = "select count(id) total from base_child_manage where 1=1 and type = "+type+" ";
        String commonSql = "";

        if(page==null){
            page = 1;
        }
        if(pageSize==null){
            pageSize = 10;
        }

        if (StringUtils.isNotBlank(id)) {
            commonSql += "and id = '"+id+"' ";
        }

        if (StringUtils.isNotBlank(title)){
            commonSql += " and title like '%"+title+"%' ";
        }

        if (StringUtils.isNotBlank(orgCode)){
            commonSql +=  " and org = '"+orgCode+"' ";
        }
        commonSql +=  "ORDER BY create_time DESC LIMIT  " + (page - 1) * pageSize + "," + pageSize + "";
        List<BaseChildManage> baseChildManage = jdbcTemplate.query(sql+commonSql, new BeanPropertyRowMapper<>(BaseChildManage.class));
        Integer total = jdbcTemplate.queryForObject(totalSql + commonSql, Integer.class);
        jsonObject.put("obj",baseChildManage);
        jsonObject.put("total",total);
        return jsonObject;
    }


    //新增修改
    @Transactional(rollbackFor = Exception.class)
    public void saveOrUpdate(String jsonData){
        BaseChildManage baseChildManage = JSONObject.parseObject(jsonData, BaseChildManage.class);
        if (baseChildManage.getCreateTime()==null) {
            baseChildManage.setCreateTime(new Date());
        }

        if (baseChildManage.getType()==2&&baseChildManage.getClick()==null) {
            baseChildManage.setClick(0);
        }
        baseChildManageDao.save(baseChildManage);
    }

    //删除信息
    @Transactional(rollbackFor = Exception.class)
    public void deletinfo(String id){
        baseChildManageDao.deleteById(id);
    }


    public List<Map<String, Object>> childOrgList(){
        String sql = "SELECT code,name  FROM base_org WHERE type = '4' AND del = 1";
        List<Map<String, Object>> list = jdbcTemplate.queryForList(sql);
        return list;
    }


}
