package com.yihu.jw.base.service.followup;

import com.yihu.jw.base.dao.followup.FollowupTemplateDao;
import com.yihu.jw.entity.followup.FollowupTemplate;
import com.yihu.jw.mysql.query.BaseJpaService;
import com.yihu.jw.restmodel.qvo.ParamQvo;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;


@Service
public class FollowupTemplateService extends BaseJpaService<FollowupTemplate, FollowupTemplateDao> {

    @Autowired
    private FollowupTemplateDao followupTemplateDao;
    @Autowired
    JdbcTemplate jdbcTemplate;


    public HashMap<String, Object> findList(ParamQvo qvo) {
        String detailSql = "SELECT * ";
        String countSql = "SELECT COUNT(1) ";
        String conditionSql = " FROM base_followup_template WHERE 1=1 ";
        String pageSql = "";

        if (StringUtils.isNotBlank(qvo.getId())) {
            conditionSql += " AND `id`='" + qvo.getId() + "'";
        }
        if (StringUtils.isNotBlank(qvo.getSearchKey())) {
            conditionSql += " AND `template_name`='" + qvo.getSearchKey() + "'";
        }
        if (StringUtils.isNotBlank(qvo.getStatus())) {
            conditionSql += " AND `status`='" + qvo.getStatus() + "'";
        }
        if (StringUtils.isNotBlank(qvo.getLeasedCode())) {
            conditionSql += " AND `leased_code`='" + qvo.getLeasedCode() + "'";
        }
        if (StringUtils.isNotBlank(qvo.getOrgCode())) {
            conditionSql += " AND `org_code`='" + qvo.getOrgCode() + "'";
        }

        if (StringUtils.isNotBlank(qvo.getPageIf())) {
            pageSql = "limit " + (qvo.getPage() - 1) * qvo.getPageSize() + "," + qvo.getPageSize();
        }
        //查询
        detailSql += conditionSql + pageSql;
        countSql += conditionSql;
        List<Map<String, Object>> list = jdbcTemplate.queryForList(detailSql);
        Integer count = jdbcTemplate.queryForObject(countSql, Integer.class);
        HashMap<String, Object> map = new HashMap<>();
        map.put("list", list);
        map.put("count", count);
        return map;
    }

    /**
     * 创建模板
     */
    public FollowupTemplate createTemplate(FollowupTemplate vo) {
        FollowupTemplate entity = followupTemplateDao.save(vo);
        return entity;
    }

    /**
     * 改变模板状态
     */
    public FollowupTemplate changeTemplateStatus(ParamQvo qvo) throws Exception {
        FollowupTemplate entity = followupTemplateDao.findById(qvo.getId()).orElse(null);
        if (entity != null) {
            entity.setStatus(qvo.getStatus());
            FollowupTemplate save = followupTemplateDao.save(entity);
            return save;
        } else {
            throw new Exception("没找到模板信息");
        }
    }

    /**
     * 删除模板
     */
    public void deleteTemplate(ParamQvo qvo) {
        String sql = "DELETE FROM base_followup_template WHERE 1=1 AND id='" + qvo.getId() + "'";
        jdbcTemplate.execute(sql);
    }
}
