package com.yihu.jw.base.service.radio;

import com.yihu.jw.base.dao.radio.WlyyRadioDao;
import com.yihu.jw.contant.CommonContant;
import com.yihu.jw.entity.care.radio.WlyyRadioDO;
import com.yihu.jw.mysql.query.BaseJpaService;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.PageEnvelop;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * @author xyq
 * @create 2022-07-04 13:43
 * @slogan 他化自在，我自逍遥
 */
@Service
public class WlyyRadioService extends BaseJpaService<WlyyRadioDO, WlyyRadioDao> {

    @Autowired
    private WlyyRadioDao radioDao;
    @Autowired
    private JdbcTemplate jdbcTemplate;

    /**
     * 分页条件查询收音机列表
     * @param name
     * @param frequency
     * @param page
     * @param pageSize
     * @return
     */
    public PageEnvelop getRadioPage(String name,String frequency,Integer page,Integer pageSize){
        page = page>0?page-1:0;
        String colSql = "SELECT id,name,frequency,introduction,url,sort_num sortNum, " +
                " CAST(DATE_FORMAT(create_time,'%Y-%m-%d %H:%i:%S') as char) createTime,CAST(status as UNSIGNED) status ";
        String sql = " from wlyy_radio " +
                " where 1 = 1 ";
        if(StringUtils.isNotBlank(name)){
            sql += " and name like '%"+name+"%' ";
        }
        if(StringUtils.isNotBlank(frequency)){
            sql += " and frequency like '%"+frequency+"%' ";
        }
        String orderSql = " order by sort_num desc limit "+page*pageSize+","+pageSize;
        List<Map<String, Object>> list = jdbcTemplate.queryForList(colSql+sql+orderSql);
        String countSql = "SELECT count(*) ";
        Long count = jdbcTemplate.queryForObject(countSql+sql, Long.class);
        return PageEnvelop.getSuccessListWithPage("查询成功",list,page,pageSize,count);
    }


    /**
     * 修改收音机
     * @param name
     * @param frequency
     * @param introduction
     * @param url
     * @param sortNum
     * @param status
     * @return
     */
    public Envelop updateRadio(Long id,String name,String frequency,String introduction,String url,Integer sortNum,Integer status){
        if(StringUtils.isBlank(name) || StringUtils.isBlank(frequency) || StringUtils.isBlank(url)){
            return Envelop.getError("必填字段不能为空");
        }
        WlyyRadioDO radio = new WlyyRadioDO();
        if(id != null){
            radio.setId(id);
        }
        radio.setName(name);
        radio.setFrequency(frequency);
        radio.setIntroduction(introduction);
        radio.setUrl(url);
        radio.setSortNum(sortNum);
        radio.setCreateTime(new Date());
        radio.setStatus(status);
        radioDao.save(radio);
        return Envelop.getSuccess(CommonContant.Message.SAVE_SUCCESS);
    }

    /**
     * 删除收音机
     * @param id
     * @return
     */
    public Envelop deleteRadio(Long id){
        WlyyRadioDO byId = radioDao.findById(id);
        if(byId != null){
            radioDao.delete(byId);
        }
        return Envelop.getSuccess("删除成功");
    }
}
