package com.yihu.jw.base.service.role;

import com.alibaba.fastjson.JSON;
import com.yihu.jw.base.dao.role.WlyyRoleDao;
import com.yihu.jw.base.dao.role.WlyyUserRoleDao;
import com.yihu.jw.entity.care.role.DoctorRole;
import com.yihu.jw.entity.care.role.WlyyUserRole;
import com.yihu.jw.restmodel.web.PageEnvelop;
import com.yihu.jw.mysql.query.BaseJpaService;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * Created by Bing on 2022/4/12.
 */
@Service
public class WlyyUserRoleService extends BaseJpaService<WlyyUserRole, WlyyUserRoleDao> {

    @Autowired
    private WlyyRoleDao wlyyRoleDao;
    @Autowired
    private WlyyUserRoleDao wlyyUserRoleDao;

    /**
     * 获取管理员列表
     * @return
     */
    public PageEnvelop<List<Map<String,Object>>> getAdminList(String name,String idcard,String mobile,Integer page,Integer size){
        page = page>0?page-1:0;
        String sql = " select ur.id,doc.name,doc.idcard,doc.id doctorCode,doc.mobile,ur.role,wr.code,wr.name roleName,wr.level from base_doctor doc " +
                " INNER JOIN wlyy_user_role ur on doc.id = ur.`user` INNER JOIN wlyy_role wr on ur.role = wr.`code` where 1=1 " ;
        String sqlCount = " select count(ur.id) from base_doctor doc " +
                " INNER JOIN wlyy_user_role ur on doc.id = ur.`user` INNER JOIN wlyy_role wr on ur.role = wr.`code` where 1=1 ";
        String filter  = " ";
        if (StringUtils.isNotBlank(name)){
            filter += " and doc.`name`like '%"+name+"%' ";
        }
        if (StringUtils.isNotBlank(idcard)){
            filter += " and doc.idcard like '%"+idcard+"%' ";
        }
        if (StringUtils.isNotBlank(mobile)){
            filter += " and doc.mobile like '%"+mobile+"%' ";
        }
        Long count = jdbcTemplate.queryForObject(sqlCount+filter,Long.class);
        filter += " order by doc.id asc limit "+page*size+","+size;
        List<Map<String,Object>> list = jdbcTemplate.queryForList(sql+filter);
        return PageEnvelop.getSuccessListWithPage("success",list,page,size,count);
    }

    /**
     *修改管理员权限
     */
    @Transactional
    public Integer modifyUserRole(String id,String role){
        DoctorRole doctorRole = wlyyRoleDao.findByCode(role);
        if (null==doctorRole){
            return -1;
        }
        WlyyUserRole wlyyUserRole = wlyyUserRoleDao.findById(Long.valueOf(id)).orElse(null);;
        if (null==wlyyUserRole){
            return -2;
        }
        wlyyUserRoleDao.modifyRoleById(role,Long.valueOf(id));
        return 1;
    }

    /**
     * 保存新增权限
     */
    public Integer saveUserRole(String json){
        List<WlyyUserRole> userRoles = JSON.parseArray(json,WlyyUserRole.class);
        List<WlyyUserRole> saveRoles = new ArrayList<>();
        if (userRoles.size()>0){
            for (WlyyUserRole tmp:userRoles){
                if (null!= wlyyRoleDao.findByCode(tmp.getRole())){
                    if (null == wlyyUserRoleDao.findByUserAndRole(tmp.getUser(),tmp.getRole())){
                        saveRoles.add(tmp);
                    }
                }
            }
        }
        if (saveRoles.size()>0){
            wlyyUserRoleDao.saveAll(saveRoles);
        }
        return 1;
    }

    /**
     * 获取权限列表
     * @param level 管理权限等级 1省2市(街道) 3区县4机构5团队（社区）6医生
     * @return
     */
    public  List<Map<String,Object>> getRoleList(String level){
        String sql = " select * from wlyy_role where 1=1 ";
        if (StringUtils.isNotBlank(level)){
            sql += " and level='"+level+"' ";
        }
        return jdbcTemplate.queryForList(sql);
    }

    /**
     *根据id获取权限详情
     */
    public Map<String,Object> getUserRoleById(String id){
        String sql = " select ur.id,doc.name,doc.idcard,doc.id doctorCode,doc.mobile,ur.role,wr.code,wr.name roleName,wr.level from base_doctor doc " +
                " INNER JOIN wlyy_user_role ur on doc.id = ur.`user` INNER JOIN wlyy_role wr on ur.role = wr.`code` where ur.id='"+id+"' " ;
        List<Map<String,Object>> list = jdbcTemplate.queryForList(sql);
        if (list.size()>0){
            return list.get(0);
        }
        return null;
    }
}
