package com.yihu.jw.base.service.servicePackage;

import com.alibaba.fastjson.JSONObject;
import com.yihu.jw.base.dao.servicePackage.ServicePackageItemDao;
import com.yihu.jw.base.dao.servicePackage.ServicePackageItemRelationalDao;
import com.yihu.jw.base.util.ConstantUtils;
import com.yihu.jw.entity.base.servicePackage.ServicePackageItemDO;
import com.yihu.jw.entity.base.servicePackage.ServicePackageItemRelationalDO;
import com.yihu.jw.mysql.query.BaseJpaService;
import com.yihu.jw.restmodel.qvo.ParamQvo;
import com.yihu.jw.util.date.DateUtil;
import com.yihu.jw.utils.StringUtil;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * Created by yeshijie on 2021/2/23.
 */
@Service
public class ServicePackageItemService extends BaseJpaService<ServicePackageItemDO, ServicePackageItemDao> {

    @Autowired
    private ServicePackageItemDao servicePackageItemDao;
    @Autowired
    ServicePackageItemRelationalDao relationalDao;

    public JSONObject create(ServicePackageItemDO itemDO) {
        JSONObject result = new JSONObject();

        if (StringUtil.isEmpty(itemDO.getId())) {
            //新增
            itemDO.setServicePackageId("system");
            itemDO.setCreateTime(DateUtil.getStringDate());
            itemDO.setDel("1");
            servicePackageItemDao.save(itemDO);
            //保存子项目
            String subItemIdList = itemDO.getSubItemId();
            for (String subItemId : subItemIdList.split(",")) {
                ServicePackageItemRelationalDO entity = new ServicePackageItemRelationalDO();
                entity.setItemId(itemDO.getId());
                entity.setSubItemId(subItemId);
                relationalDao.save(entity);
            }
        } else {
            //修改
            servicePackageItemDao.save(itemDO);
            //删除关联表重新添加
            String delSql = " DELETE FROM base_service_package_item_relational WHERE item_id='" + itemDO.getId() + "'";
            jdbcTemplate.execute(delSql);
            //加入关联表
            String subItemIdList = itemDO.getSubItemId();
            for (String subItemId : subItemIdList.split(",")) {
                ServicePackageItemRelationalDO entity = new ServicePackageItemRelationalDO();
                entity.setItemId(itemDO.getId());
                entity.setSubItemId(subItemId);
                relationalDao.save(entity);
            }
        }

        result.put("response", ConstantUtils.SUCCESS);
        result.put("msg", "操作成功");
        return result;
    }

    public HashMap<String, Object> getItemList(ParamQvo qvo) {
        String detailSql = "SELECT a.*, " +
                " (SELECT GROUP_CONCAT(q.sub_item_id) FROM base_service_package_item_relational q WHERE q.item_id=a.id) 'subItemId' ";
        String countSql = "SELECT count(1) ";
        String pageSql = "";
        String sql = " FROM base_service_package_item a WHERE 1=1 \n";
        if (StringUtils.isNotBlank(qvo.getConfigureIf())) {
            //添加的项
            sql += " AND a.service_package_id ='system'  ";
        }
        if (StringUtils.isNotBlank(qvo.getId())) {
            sql += " AND a.id ='" + qvo.getId() + "'";
        }
        if (StringUtils.isNotBlank(qvo.getParentId())) {
            sql += " AND a.service_package_id ='" + qvo.getParentId() + "'";
        }
        if (StringUtils.isNotBlank(qvo.getLeasedCode())) {
            sql += " AND a.leased_code ='" + qvo.getLeasedCode() + "'";
        }
        if (StringUtils.isNotBlank(qvo.getOrgCode())) {
            sql += " AND a.org_code ='" + qvo.getOrgCode() + "'";
        }
        if (StringUtils.isNotBlank(qvo.getStatus())) {
            sql += " AND a.del ='" + qvo.getStatus() + "'";
        }
        if (StringUtils.isNotBlank(qvo.getItemName())) {
            sql += " AND a.`name` LIKE '%" + qvo.getItemName() + "%'";
        }
        if (StringUtils.isNotBlank(qvo.getPageIf())) {
            //需要分页
            pageSql = " limit " + (qvo.getPage() - 1) * qvo.getPageSize() + "," + qvo.getPageSize();
        }
        countSql += sql;
        detailSql += sql + pageSql;
        Integer count = jdbcTemplate.queryForObject(countSql, Integer.class);
        List<Map<String, Object>> list = jdbcTemplate.queryForList(detailSql);
        HashMap<String, Object> map = new HashMap<>();
        map.put("count", count);
        map.put("list", list);
        return map;
    }

    public ServicePackageItemDO changeState(ParamQvo qvo) {
        ServicePackageItemDO entity = servicePackageItemDao.findById(qvo.getId()).orElse(null);
        if (entity != null) {
            entity.setDel(qvo.getStatus());
            ServicePackageItemDO newEntity = servicePackageItemDao.save(entity);
            return newEntity;
        }
        return null;
    }

    public void deleteById(String ids) {
        String collect = Arrays.stream(ids.split(",")).map(s -> "'" + s + "'").collect(Collectors.joining(",", "(", ")"));
        String delSql = "DELETE FROM base_service_package_item WHERE id IN ";
        delSql += collect;
        jdbcTemplate.execute(delSql);
        //删除关联关系
        String delRelationalSql = "DELETE FROM base_service_package_item_relational WHERE item_id in " + collect;
        jdbcTemplate.execute(delRelationalSql);
    }


}
