package com.yihu.jw.base.service.servicePackage;

import com.alibaba.fastjson.JSONObject;
import com.yihu.jw.base.dao.servicePackage.ServicePackageDao;
import com.yihu.jw.base.dao.servicePackage.ServicePackageItemDao;
import com.yihu.jw.base.util.ConstantUtils;
import com.yihu.jw.entity.base.servicePackage.ServicePackageDO;
import com.yihu.jw.entity.base.servicePackage.ServicePackageItemDO;
import com.yihu.jw.mysql.query.BaseJpaService;
import com.yihu.jw.restmodel.qvo.ParamQvo;
import com.yihu.jw.utils.StringUtil;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.text.SimpleDateFormat;
import java.util.*;
import java.util.stream.Collectors;

/**
 * @author yeshijie on 2018/8/17.
 */
@Service
@Transactional(rollbackFor = Exception.class)
public class ServicePackageService extends BaseJpaService<ServicePackageDO, ServicePackageDao> {

    private Logger logger = LoggerFactory.getLogger(ServicePackageService.class);

    @Autowired
    private ServicePackageDao servicePackageDao;
    @Autowired
    private ServicePackageItemDao servicePackageItemDao;

    @Transactional(rollbackFor = Exception.class)
    public JSONObject create(ServicePackageDO packageVo) {
        SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        JSONObject result = new JSONObject();
        //获取服务项
        List<ServicePackageItemDO> itemList = packageVo.getPackageItemDOList();

        //服务项的个数
        if (itemList == null) {
            packageVo.setNum(0);
        } else {
            packageVo.setNum(itemList.size());
        }
        //数据逻辑
        if (StringUtil.isEmpty(packageVo.getId())) {
            //新增
            packageVo.setCreateTime(new Date());
            packageVo = servicePackageDao.save(packageVo);
        } else {
            //修改
//            ServicePackageDO oldDO = servicePackageDao.findById(packageVo.getId()).orElse(null);
//            oldDO.setName(packageVo.getName());
//            oldDO.setDel(packageVo.getDel());
//            oldDO.setType(packageVo.getType());
//            oldDO.setIntroduce(packageVo.getIntroduce());
//            oldDO.setOrgCode(packageVo.getOrgCode());
//            oldDO.setOrgName(packageVo.getOrgName());
//            oldDO.setLeasedCode(packageVo.getLeasedCode());
//            oldDO.setLeasedName(packageVo.getLeasedName());
            //更新服务包
            packageVo = servicePackageDao.save(packageVo);
            //删除服务项-根据server_page_id
            servicePackageItemDao.deleteByServicePackageId(packageVo.getId());
        }
        //保存服务项
        List<ServicePackageItemDO> saveItemList = new ArrayList<>();
        for (ServicePackageItemDO item : itemList) {
            item.setCreateTime(dateFormat.format(new Date()));
            item.setServicePackageId(packageVo.getId());
            saveItemList.add(item);
        }
        servicePackageItemDao.saveAll(saveItemList);
        result.put("response", ConstantUtils.SUCCESS);
        result.put("msg", "操作成功");
        return result;
    }


    public HashMap<String, Object> findList(String id, String leasedCode, String orgCode, String pageName, String status, int page, int size) {
        String detailSql = "SELECT\n" +
                "	(SELECT GROUP_CONCAT(b.`name`) FROM  base_service_package_item b WHERE b.service_package_id=a.id) 'pageItemName',\n" +
                "	a.* \n";
        String countSql = "SELECT count(1)  ";
        String sql = " FROM 	base_service_package a  WHERE 1 =1 ";

        if (StringUtils.isNotBlank(id)) {
            sql += " AND a.id='" + id + "'";
        }
        if (StringUtils.isNotBlank(status)) {
            sql += " AND a.del='" + status + "'";
        }
        if (StringUtils.isNotBlank(pageName)) {
            sql += " AND a.`name` like'%" + pageName + "%'";
        }
        if (StringUtils.isNotBlank(leasedCode)) {
            sql += " AND a.`leased_code`='" + leasedCode + "'";
        }
        if (StringUtils.isNotBlank(orgCode)) {
            sql += " AND a.`org_code`='" + orgCode + "'";
        }
        sql += " ORDER BY a.create_time DESC ";
        String pageSql = " limit " + (page - 1) * size + "," + size;
        detailSql += sql + pageSql;
        countSql += sql;
        List<Map<String, Object>> list = jdbcTemplate.queryForList(detailSql);
        Integer count = jdbcTemplate.queryForObject(countSql, Integer.class);
        HashMap<String, Object> map = new HashMap<>();
        map.put("list", list);
        map.put("count", count);
        return map;
    }

    public void deleteById(ParamQvo qvo) {
        //查出服务包的服务项
        String itemSql = "SELECT id 'itemId' FROM base_service_package_item WHERE service_package_id ='" + qvo.getId() + "'";
        List<Map<String, Object>> list = jdbcTemplate.queryForList(itemSql);
        String collect = list.stream().map(map -> String.valueOf("'" + map.get("itemId") + "'")).collect(Collectors.joining(",", "(", ") "));
        //删除服务部
        String sql01 = " DELETE FROM base_service_package WHERE id='" + qvo.getId() + "'";
        //删除关联的服务项
        String sql02 = " DELETE FROM base_service_package_item WHERE service_package_id='" + qvo.getId() + "'";
        //删除关联关系
        if (!list.isEmpty()) {
            String sql03 = " DELETE FROM base_service_package_item_relational WHERE item_id IN " + collect;
            jdbcTemplate.execute(sql03);
        }
        jdbcTemplate.execute(sql02);
        jdbcTemplate.execute(sql01);
    }

    public void changeState(ParamQvo qvo) {
        String sql = " UPDATE  base_service_package SET del='" + qvo.getStatus() + "' WHERE id='" + qvo.getId() + "'";
        jdbcTemplate.execute(sql);
    }
}
