package com.yihu.jw.basic.agadmin.controller.common;

import com.yihu.jw.basic.dict.service.SystemDictEntryService;
import com.yihu.jw.basic.dict.service.SystemDictService;
import com.yihu.jw.entity.ehr.dict.SystemDict;
import com.yihu.jw.entity.ehr.dict.SystemDictEntry;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.PageEnvelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import io.swagger.annotations.Api;
import org.springframework.data.domain.Page;
import org.springframework.util.StringUtils;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by Administrator on 2015/8/12.
 */
@RequestMapping("/dict")
@RestController
@Api( tags = {"网关-字典"})
public class SystemDictController extends EnvelopRestEndpoint {

    @Resource
    private SystemDictService dictService;
    @Resource
    private SystemDictEntryService systemDictEntryService;
//
//    @RequestMapping("/createDict")
//    public Envelop createDict(String name, String reference, String userId) {
//        Map<String, Object> params = new HashMap<>();
//        if (StringUtils.isEmpty(name)){
//            return failed("字典名称不能为空");
//        }
//        SystemDictModel systemDictModel = new SystemDictModel();
//        systemDictModel.setName(name.replace(" ", ""));
//        systemDictModel.setAuthorId("System");
//        params.put("dictionary", toJson(systemDictModel));
//        try {
//            String urlCheck = "/basic/api/v1.0/dictionaries/existence";
//            Map<String, Object> paramsCheck = new HashMap<>();
//            paramsCheck.put("dict_name",name);
//            String resultCheckStr = HttpClientUtil.doGet(adminInnerUrl + urlCheck, paramsCheck, username, password);
//            boolean exists = Boolean.valueOf(resultCheckStr);
//            if (exists) {
//                return failed("字典名字在系统中已存在");
//            }
//            String url = "/basic/api/v1.0/dictionaries";
//            HttpResponse resultStr = HttpUtils.doJsonPost(adminInnerUrl + url, toJson(systemDictModel), null, username, password);
//            if (resultStr.isSuccessFlg()) {
//                return toModel(resultStr.getContent(), Envelop.class);
//            } else {
//                return failed(resultStr.getContent());
//            }
//        } catch (Exception ex){
//            ex.printStackTrace();
//            return failed(ex.getMessage());
//        }
//    }
//
//    @RequestMapping("/deleteDict")
//    public Envelop deleteDict(long dictId) {
//        try {
//            Map<String, Object> params = new HashMap<>();
//            params.put("dictId", dictId);
//            String url ="/basic/api/v1.0/dictionaries/" + dictId;
//            String resultStr = HttpClientUtil.doDelete(adminInnerUrl + url, params, username, password);
//            boolean success = Boolean.valueOf(resultStr);
//            if (success) {
//                return success(true);
//            }
//            return failed("删除失败");
//        } catch (Exception ex){
//            ex.printStackTrace();
//            return failed(ex.getMessage());
//        }
//    }
//
//    @RequestMapping("/updateDict")
//    public Envelop updateDict(long dictId, String name) {
//        if (StringUtils.isEmpty(name)) {
//            return failed("字典名称不能为空");
//        }
//        try {
//            Map<String, Object> dictParams = new HashMap<>();
//            dictParams.put("id", dictId);
//            dictParams.put("name", name.replace(" ", ""));
//            String url = "/basic/api/v1.0/dictionaries";
//            HttpResponse httpResponse = HttpUtils.doJsonPut(adminInnerUrl + url, toJson(dictParams), null, username, password);
//            if (httpResponse.isSuccessFlg()) {
//                return toModel(httpResponse.getContent(), Envelop.class);
//            } else {
//                return failed(httpResponse.getContent());
//            }
//        } catch (Exception ex){
//            ex.printStackTrace();
//            return failed(ex.getMessage());
//        }
//    }

    @GetMapping("searchSysDicts")
    public Envelop searchSysDicts(String searchNm, Integer page, Integer rows) {
        Map<String, Object> params = new HashMap<>();

        StringBuffer stringBuffer = new StringBuffer();
        if (!StringUtils.isEmpty(searchNm)) {
            stringBuffer.append("name?" + searchNm + " g1;phoneticCode?" + searchNm + " g1");
        }
        String filters = stringBuffer.toString();
        params.put("filters", "");
        if (!StringUtils.isEmpty(filters)) {
            params.put("filters", filters);
        }
        params.put("page", page);
        params.put("size", rows);

        try {
            if (page != null || page > 0) {
                page = page - 1;
            }else {
                page = 1;
            }
            String url ="/dictionaries";
            page = reducePage(page);
            if (org.apache.commons.lang3.StringUtils.isEmpty(filters)) {
                Page<SystemDict> systemDictPage = dictService.getDictList(null, page, rows);
                return PageEnvelop.getSuccessListWithPage("",systemDictPage.toList(),page,rows,systemDictPage.getTotalElements());
            } else {
                List<SystemDict> systemDictList = dictService.search(null, filters, null, page, rows);
                return PageEnvelop.getSuccessListWithPage("",systemDictList,page,rows, dictService.getCount(filters));
            }
        } catch (Exception ex){
            ex.printStackTrace();
            return failed(ERR_SYSTEM_DES);
        }
    }

//    @RequestMapping("createDictEntry")
//    public Object createDictEntry(Long dictId, String code, String value, Integer sort, String catalog) {
//
//        Map<String, Object> params = new HashMap<>();
//        Envelop result = new Envelop();
//        String resultStr = "";
//
//        if(StringUtils.isEmpty(dictId)){
//            result.setSuccessFlg(false);
//            result.setErrorMsg("字典Id不能为空！");
//            return result;
//        }
//        if(StringUtils.isEmpty(code)){
//            result.setSuccessFlg(false);
//            result.setErrorMsg("字典项编码不能为空！");
//            return result;
//        }
//        if(StringUtils.isEmpty(value)){
//            result.setSuccessFlg(false);
//            result.setErrorMsg("字典项值不能为空！");
//            return result;
//        }
//
//        SystemDictEntryModel dictEntryModel = new SystemDictEntryModel();
//        dictEntryModel.setDictId(dictId);
//        dictEntryModel.setCode(code.replace(" ", ""));
//        dictEntryModel.setValue(value.replace(" ", ""));
//        dictEntryModel.setSort(sort);
//        dictEntryModel.setCatalog(catalog);
//        params.put("entry",toJson(dictEntryModel));
//
//        try {
//            String urlCheck = "/dictionaries/existence/" + dictId ;
//            Map<String, Object> paramsCheck = new HashMap<>();
//            paramsCheck.put("dict_id",dictId);
//            paramsCheck.put("code",code.replace(" ", ""));
//            String resultCheckStr = HttpClientUtil.doGet(comUrl + urlCheck, paramsCheck, username, password);
//
//            if(Boolean.parseBoolean(resultCheckStr)){
//                result.setSuccessFlg(false);
//                result.setErrorMsg("代码在该字典中已存在，请确认。");
//                return result;
//            }
//
//            String url = "/dictionaries/entries";
//            resultStr = HttpClientUtil.doPost(comUrl+url,params,username,password);
//            return resultStr;
//
//        } catch (Exception ex){
//            ex.printStackTrace();
//            return failed(ERR_SYSTEM_DES);
//        }
//    }
//
//    @RequestMapping("deleteDictEntry")
//    @ResponseBody
//    public Object deleteDictEntry(long dictId, String code) throws Exception{
//
//        Envelop result = new Envelop();
//        String resultStr = "";
//        Map<String, Object> params = new HashMap<>();
//        params.put("id",dictId);
//        params.put("code",code);
//
//        String url = "/dictionaries/"+ dictId + "/entries/"+ URLEncoder.encode(code, "UTF-8");
//
//        try {
//            resultStr = HttpClientUtil.doDelete(comUrl+url,params,username,password);
//            return resultStr;
//        } catch (Exception ex){
//            ex.printStackTrace();
//            return failed(ERR_SYSTEM_DES);
//        }
//    }
//
//    @RequestMapping("updateDictEntry")
//    @ResponseBody
//    public Object updateDictEntry(Long dictId, String code, String value, Integer sort, String catalog) {
//
//        Map<String, Object> params = new HashMap<>();
//        Envelop result = new Envelop();
//        String resultStr = "";
//
//        if(StringUtils.isEmpty(dictId)){
//            result.setSuccessFlg(false);
//            result.setErrorMsg("字典id不能为空！");
//            return result;
//        }
//        if(StringUtils.isEmpty(code)){
//            result.setSuccessFlg(false);
//            result.setErrorMsg("字典项编码code不能为空！");
//            return result;
//        }
//
//        SystemDictEntryModel dictEntryModel = new SystemDictEntryModel();
//        dictEntryModel.setDictId(dictId);
//        dictEntryModel.setCode(code.replace(" ", ""));
//        dictEntryModel.setValue(value.replace(" ", ""));
//        dictEntryModel.setSort(sort);
//        dictEntryModel.setCatalog(catalog);
//        params.put("dictionary",toJson(dictEntryModel));
//
//        try {
//            String dictEntryUrl = "/dictionaries/" + dictId + "/entries/" + URLEncoder.encode(code,"UTF-8");
//            Map<String, Object> dictEntryParams = new HashMap<>();
//            dictEntryParams.put("dict_id",dictId);
//            dictEntryParams.put("code",code);
//            String dictEntryResultStr = HttpClientUtil.doGet(comUrl + dictEntryUrl, dictEntryParams, username, password);
//            result = getEnvelop(dictEntryResultStr);
//
//            if(result.isSuccessFlg()){
//                SystemDictEntryModel systemDictEntryModel = getEnvelopModel(result.getObj(),SystemDictEntryModel.class);
//                systemDictEntryModel.setValue(value.replace(" ", ""));
//                systemDictEntryModel.setSort(sort);
//                systemDictEntryModel.setCatalog(catalog);
//                params.put("entry",toJson(systemDictEntryModel));
//
//                String urlCheckDict = "/dictionaries/entries";
//                resultStr = HttpClientUtil.doPut(comUrl + urlCheckDict, params, username, password);
//                return resultStr;
//            }
//        } catch (Exception ex){
//            ex.printStackTrace();
//            return failed(ERR_SYSTEM_DES);
//        }
//        return result;
//    }
//
//    @RequestMapping("searchDictEntryListForManage")
//    @ResponseBody
//    public Object searchDictEntryList(Long dictId, Integer page, Integer rows) {
//
//        String resultStr = "";
//        Envelop result = new Envelop();
//        Map<String, Object> params = new HashMap<>();
//
//        StringBuffer stringBuffer = new StringBuffer();
//        if (!StringUtils.isEmpty(dictId)) {
//            stringBuffer.append("dictId=" + dictId);
//        }
//        String filters = stringBuffer.toString();
//        params.put("filters", "");
//        if (!StringUtils.isEmpty(filters)) {
//            params.put("filters", filters);
//        }
//        params.put("page", page);
//        params.put("size", rows);
//
//        try {
//            String url ="/dictionaries/entries";
//            resultStr = HttpClientUtil.doGet(comUrl + url, params, username, password);
//            return resultStr;
//        } catch (Exception ex){
//            ex.printStackTrace();
//            return failed(ERR_SYSTEM_DES);
//        }
//    }
//
//    @RequestMapping("selecttags")
//    @ResponseBody
//    public Object selectTags() {
//
//        String resultStr = "";
//        Envelop result = new Envelop();
//        Map<String, Object> params = new HashMap<>();
//
//        try {
//            String url ="/dictionaries/tags";
//            resultStr = HttpClientUtil.doGet(comUrl + url, params, username, password);
//
//            ObjectMapper objectMapper = new ObjectMapper();
//            result = objectMapper.readValue(resultStr, Envelop.class);
//            result.setObj(result.getDetailModelList());
//
//            return result;
//        } catch (Exception ex){
//            ex.printStackTrace();
//            return failed(ERR_SYSTEM_DES);
//        }
//    }

    @GetMapping("searchDictEntryList")
    public Envelop searchDictEntryListForDDL(Long dictId, Integer page, Integer rows) {
        StringBuffer stringBuffer = new StringBuffer();
        if (!StringUtils.isEmpty(dictId)) {
            stringBuffer.append("dictId=" + dictId);
        }
        String filters = stringBuffer.toString();
        if(StringUtils.isEmpty(page) || page == 0){
            page = 1;
        }
        if(StringUtils.isEmpty(rows) || rows == 0){
            rows = 50;
        }
        try {
            String url ="/dictionaries/entries";
            List<SystemDictEntry> systemDictEntryList = systemDictEntryService.search(null,filters,null,page,rows);
            return PageEnvelop.getSuccessListWithPage("",systemDictEntryList,page,rows, systemDictEntryService.getCount(filters));
        }catch (Exception ex){
            ex.printStackTrace();
            return failed(ERR_SYSTEM_DES);
        }
    }


//    @RequestMapping("searchDictForSelect")
//    public Object searchDictForSelect(Long dictId, String searchParm, Integer page, Integer rows) {
//
//        String resultStr = "";
//        Envelop result = new Envelop();
//        Map<String, Object> params = new HashMap<>();
//
//        StringBuffer stringBuffer = new StringBuffer();
//        if (!StringUtils.isEmpty(dictId)) {
//            stringBuffer.append("dictId=" + dictId+";");
//        }
//        if (!StringUtils.isEmpty(searchParm)){
//            stringBuffer.append("code?"+searchParm+" g1;value?"+searchParm+" g1;");
//        }
//        String filters = stringBuffer.toString();
//        params.put("filters", "");
//        if (!StringUtils.isEmpty(filters)) {
//            params.put("filters", filters);
//        }
//        if(StringUtils.isEmpty(page) || page == 0){
//            page = 1;
//        }
//        if(StringUtils.isEmpty(rows) || rows == 0){
//            rows = 50;
//        }
//        params.put("page", page);
//        params.put("size", rows);
//        params.put("sorts", "+sort");
//
//        try {
//            String url ="/dictionaries/entries";
//            resultStr = HttpClientUtil.doGet(comUrl + url, params, username, password);
//            Envelop envelopGet = objectMapper.readValue(resultStr,Envelop.class);
//            List<SystemDictEntryModel> modelList = (List<SystemDictEntryModel>)getEnvelopList(envelopGet.getDetailModelList(),new ArrayList<SystemDictEntryModel>(),SystemDictEntryModel.class);
//            List<Map> list = new ArrayList<>();
//            for (SystemDictEntryModel m:modelList){
//                Map map = new HashMap<>();
//                map.put("id", m.getCode());
//                map.put("name",m.getValue());
//                list.add(map);
//            }
//            envelopGet.setDetailModelList(list);
//            return envelopGet;
//        }catch (Exception ex){
//            ex.printStackTrace();
//            return failed(ERR_SYSTEM_DES);
//        }
//    }
//
//    @RequestMapping("validator")
//    @ResponseBody
//    public Object validator(String systemName){
//        Envelop result = new Envelop();
//        String resultStr = "";
//
//        Map<String, Object> params = new HashMap<>();
//        params.put("dict_name",systemName);
//
//        try {
//            String url ="/dictionaries/existence";
//            resultStr = HttpClientUtil.doGet(comUrl + url, params, username, password);
//            if(Boolean.parseBoolean(resultStr)){
//                result.setSuccessFlg(false);
//                result.setErrorMsg("名称重复");
//            }else{
//                result.setSuccessFlg(true);
//            }
//        } catch (Exception ex){
//            ex.printStackTrace();
//            return failed(ERR_SYSTEM_DES);
//        }
//        return result;
//    }
//
//    @RequestMapping("autoSearchDictEntryList")
//    @ResponseBody
//    public Object autoSearchDictEntryList(Long dictId,String key){
//
//        return null  ;
//    }

}
