package com.yihu.jw.basic.agadmin.controller.quota;

import com.yihu.jw.basic.quota.service.TjDataSourceService;
import com.yihu.jw.entity.ehr.quota.TjDataSource;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.ObjEnvelop;
import com.yihu.jw.restmodel.web.PageEnvelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import io.swagger.annotations.Api;
import org.springframework.util.StringUtils;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.io.IOException;
import java.net.URLDecoder;
import java.util.Date;
import java.util.List;

/**
 * Created by llh on 2017/5/9.
 */
@RestController
@RequestMapping("/tjDataSource")
@Api( tags = {"网关-统计数据源"})
public class TjDataSourceController extends EnvelopRestEndpoint {

    @Resource
    TjDataSourceService tjDataSourceService;

    //查询
    @GetMapping("/getTjDataSource")
    public Envelop searchTjDataSource(String name,String searchParm, int page, int rows){
        String url = "/tj/getTjDataSourceList";
        StringBuffer stringBuffer = new StringBuffer();
        if (!StringUtils.isEmpty(name)) {
            stringBuffer.append("name?" + name );
        }
        if (!StringUtils.isEmpty(searchParm)) {
            stringBuffer.append("name?" + searchParm );
        }
        String filters = stringBuffer.toString();
        try {
            PageEnvelop PageEnvelop = new PageEnvelop();
            List<TjDataSource> tjDataSourceList = tjDataSourceService.search(null, filters, null, page, rows);
            if(tjDataSourceList != null){
                PageEnvelop.setDetailModelList(tjDataSourceList);
                PageEnvelop.setTotalCount((int)tjDataSourceService.getCount(filters));
                PageEnvelop.setStatus(200);
                PageEnvelop.setCurrPage(page);
                PageEnvelop.setPageSize(rows);
            }else{
                PageEnvelop.setStatus(200);
                PageEnvelop.setMessage("查询无数据");
                PageEnvelop.setTotalCount(0);
            }
            return PageEnvelop;
        } catch (Exception ex) {
            ex.printStackTrace();
            return failed(ERR_SYSTEM_DES);
        }
    }



    /**
     * 新增修改
     */
    @PostMapping(value = "updateTjDataSource")
    public Envelop updateTjDataSource(String tjDataSourceModelJsonData) throws IOException {
        String url = "/tj/addTjDataSource";
        String[] strings = URLDecoder.decode(tjDataSourceModelJsonData, "UTF-8").split(";");
        TjDataSource detailModel = objectMapper.readValue(strings[0],TjDataSource.class);
        try {
            if (!StringUtils.isEmpty(detailModel.getId())) {
                Long tjDataSourceId = detailModel.getId();
                TjDataSource updateTjDataSource = tjDataSourceService.getById(tjDataSourceId);
                if (updateTjDataSource!=null) {
                    updateTjDataSource.setCode(detailModel.getCode());
                    updateTjDataSource.setName(detailModel.getName());
                    updateTjDataSource.setType(detailModel.getType());
                    updateTjDataSource.setStatus(detailModel.getStatus());
                    updateTjDataSource.setRemark(detailModel.getRemark());
                    updateTjDataSource.setUpdateTime(new Date());
                    tjDataSourceService.save(updateTjDataSource);
                    return ObjEnvelop.getSuccess("操作成功",updateTjDataSource);
                } else {
                    return failed("参数错误");
                }
            } else {
                detailModel.setCreateTime(new Date());
                tjDataSourceService.save(detailModel);
                return ObjEnvelop.getSuccess("操作成功",detailModel);
            }
        } catch (Exception e) {
            e.printStackTrace();
            return failed(ERR_SYSTEM_DES);
        }
    }

    /**
     * 删除消息
     */
    @PostMapping("deleteTjDataSource")
    public Envelop deleteTjDataSource(Long tjDataSourceId) {
        String url = "/tj/deletetTjDataSource" ;
        try {
            TjDataSource tjDataSource = tjDataSourceService.getById(tjDataSourceId);
            tjDataSource.setStatus(-1);
            tjDataSourceService.save(tjDataSource);
            return success("删除成功");
        } catch (Exception e) {
            e.printStackTrace();
            return failed(ERR_SYSTEM_DES);
        }
    }

    /**
     * 根据id获取消息
     */
    @GetMapping("getTjDataSourceById")
    public Envelop getTjQuotaById(Long id ) {
        String url ="/tj/getTjDataSourceById/" +id;
        try {
            TjDataSource updateTjDataSource = tjDataSourceService.getById(id);
            return ObjEnvelop.getSuccess("获取成功",updateTjDataSource);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return failed("查询失败");
    }

    /**
     * 校验name是否唯一,true已存在
     */
    @GetMapping("hasExistsName")
    public Envelop hasExistsName(String name) {
        String url = "/tj/tjDataSourceExistsName/" + name ;
        try {
            String filter = "name=" + name;
            List<TjDataSource> list = tjDataSourceService.search(filter);
            return ObjEnvelop.getSuccess("查询成功",list.size() > 0);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return  failed("查询失败");
    }

    /**
     * 校验code是否唯一
     */
    @GetMapping("hasExistsCode")
    public Envelop hasExistsCode(String code) {
        String url = "/tj/tjDataSourceExistsCode/" + code ;
        try {
            String filter = "code=" + code;
            List<TjDataSource> list = tjDataSourceService.search(filter);
            return ObjEnvelop.getSuccess("查询成功",list.size() > 0);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return  failed("查询失败");
    }
}
