package com.yihu.jw.basic.agadmin.controller.quota;


import com.yihu.jw.basic.quota.service.TjDimensionMainService;
import com.yihu.jw.basic.quota.service.TjQuotaDimensionMainService;
import com.yihu.jw.entity.ehr.quota.TjDimensionMain;
import com.yihu.jw.entity.ehr.quota.TjQuotaDimensionMain;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.MixEnvelop;
import com.yihu.jw.restmodel.web.ObjEnvelop;
import com.yihu.jw.restmodel.web.PageEnvelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import io.swagger.annotations.Api;
import org.springframework.util.StringUtils;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.io.IOException;
import java.net.URLDecoder;
import java.util.*;

/**
 * Created by llh on 2017/5/9.
 */
@RestController
@RequestMapping("/tjDimensionMain")
@Api( tags = {"网关-统计主维度"})
public class TjDimensionMainController extends EnvelopRestEndpoint {

    @Resource
    TjDimensionMainService tjDimensionMainService;
    @Resource
    TjQuotaDimensionMainService tjQuotaDimensionMainService;

    //查询统计主维度
    @GetMapping("/getTjDimensionMain")
    public Object searchTjDimensionMain(String name, int page, int rows){
        String url = "/tj/getTjDimensionMainList";
        StringBuffer stringBuffer = new StringBuffer();
        if (!StringUtils.isEmpty(name)) {
            stringBuffer.append("name?" + name );
        }
        String filters = stringBuffer.toString();
        try {
            PageEnvelop PageEnvelop = new PageEnvelop();
            List<TjDimensionMain> qtjDimensionMainList = tjDimensionMainService.search(null, filters, null, page, rows);
            if(qtjDimensionMainList != null){
                PageEnvelop.setDetailModelList(qtjDimensionMainList);
                PageEnvelop.setTotalCount((int)tjDimensionMainService.getCount(filters));
                PageEnvelop.setStatus(200);
                PageEnvelop.setCurrPage(page);
                PageEnvelop.setPageSize(rows);
            }else{
                PageEnvelop.setStatus(200);
                PageEnvelop.setMessage("查询无数据");
                PageEnvelop.setTotalCount(0);
            }
            return PageEnvelop;
        } catch (Exception ex) {
            ex.printStackTrace();
            return failed(ERR_SYSTEM_DES);
        }
    }



    /**
     * 新增修改
     */
    @PostMapping(value = "updateTjDimensionMain")
    public Object updateTjDimensionMain(String tjDimensionMainModelJsonData) throws IOException {

        String url = "/tj/tjDimensionMain";
        System.out.println();
        String[] strings = URLDecoder.decode(tjDimensionMainModelJsonData, "UTF-8").split(";");
        TjDimensionMain detailModel = objectMapper.readValue(strings[0], TjDimensionMain.class);
        try {
            if (!StringUtils.isEmpty(detailModel.getId())) {
                Long id = detailModel.getId();
                TjDimensionMain updateTjDimensionMain = tjDimensionMainService.getTjDimensionMain(id);
                if (updateTjDimensionMain!=null) {
                    updateTjDimensionMain.setCode(detailModel.getCode());
                    updateTjDimensionMain.setName(detailModel.getName());
                    updateTjDimensionMain.setType(detailModel.getType());
                    updateTjDimensionMain.setStatus(detailModel.getStatus());
                    updateTjDimensionMain.setRemark(detailModel.getRemark());
                    updateTjDimensionMain.setUpdateTime(new Date());
                    tjDimensionMainService.save(updateTjDimensionMain);
                    return ObjEnvelop.getSuccess("保存成功",updateTjDimensionMain);
                } else {
                    return failed("参数错误");
                }
            } else {
                detailModel.setCreateTime(new Date());
                tjDimensionMainService.save(detailModel);
                return ObjEnvelop.getSuccess("保存成功",detailModel);
            }
        } catch (Exception e) {
            e.printStackTrace();
            return failed(ERR_SYSTEM_DES);
        }
    }

    /**
     * 删除消息
     */
    @PostMapping("deleteTjDimensionMain")
    public Object deleteTjDimensionMain(Long tjDimensionMainId) {
        String url = "/tj/tjDimensionMain";

        try {
            TjDimensionMain tjDimensionMain = tjDimensionMainService.getTjDimensionMain(tjDimensionMainId);
            tjDimensionMain.setStatus(-1);
            tjDimensionMainService.save(tjDimensionMain);
            return ObjEnvelop.getSuccess("主维度删除成功！");
        } catch (Exception e) {
            e.printStackTrace();
            return failed(ERR_SYSTEM_DES);
        }
    }


    /**
     * 根据id获取消息
     */
    @GetMapping("getTjDimensionMainByID")
    public Envelop getTjDimensionMainByID(Long id ) {
        String url ="/tj/tjDimensionMainId/" +id;
        try {
            TjDimensionMain updateTjDimensionMain = tjDimensionMainService.getTjDimensionMain(id);
            return ObjEnvelop.getSuccess("查询成功",updateTjDimensionMain);
        } catch (Exception e) {
            e.printStackTrace();
            return failed("查询失败");
        }
    }



    /**
     * 校验名称是否唯一
     */
    @GetMapping("isNameExists")
    public Envelop isNameExists(String name) {
        String url = "/tj/tjDimensionMainName" ;
        try {
            String filter = "name=" + name;
            List<TjDimensionMain> tjDimensionMains = tjDimensionMainService.search(filter);
            return ObjEnvelop.getSuccess("",tjDimensionMains.size() >0);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return  failed("查询失败");
    }

    /**
     * 校验code是否唯一
     */
    @GetMapping("isCodeExists")
    public Envelop isCodeExists(String code) {
        String url = "/tj/tjDimensionMainCode" ;
        try {
            String filter = "code=" + code;
            List<TjDimensionMain> tjDimensionMains = tjDimensionMainService.search(filter);
            return ObjEnvelop.getSuccess("",tjDimensionMains.size() >0);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return  failed("查询失败");
    }

    @GetMapping("/getTjDimensionMainInfo")
    public Envelop getTjDimensionMainInfo(String quotaCode, String name, int page, int rows){
        String url = "/tj/getTjDimensionMainInfoList";
        StringBuffer mainFilter = new StringBuffer("status=1");
        if (!StringUtils.isEmpty(name)) {
            mainFilter.append("name?" + name + " g1;code?" + name + " g1;");
        }
        String filters = mainFilter.toString();
        String filter = "quotaCode=" + quotaCode;
        try {
            List<TjDimensionMain> mainModelList = tjDimensionMainService.search(null, filters, null, page, rows);
            if(mainModelList.size()>0){
                List<TjQuotaDimensionMain> mainModelList2 = tjQuotaDimensionMainService.search(null, filter, null, page, rows);
                if(mainModelList2.size() > 0) {
                    for (TjQuotaDimensionMain tjQuotaDimensionMainModel : mainModelList2) {
                        List<TjDimensionMain> tjDimensionMains = tjDimensionMainService.search("code=" + tjQuotaDimensionMainModel.getMainCode());
                        if (tjDimensionMains.size()>0) {
                            tjQuotaDimensionMainModel.setName(tjDimensionMains.get(0).getName());
                        }
                    }
                }
                List<String> list = getTjQuotaDimensionMainOfMainCode(filter, null);
                for (TjDimensionMain tjDimensionMain : mainModelList) {
                    tjDimensionMain.setChecked(list.contains(tjDimensionMain.getCode()));
                }
                return MixEnvelop.getSuccess("查询成功",mainModelList2,mainModelList,page,rows,tjDimensionMainService.getCount(filters));
            }else{
                return success();
            }
        } catch (Exception ex) {
            ex.printStackTrace();
            return failed(ERR_SYSTEM_DES);
        }
    }

    public List<String> getTjQuotaDimensionMainOfMainCode(String filters, String sorts) throws Exception{
        List<TjQuotaDimensionMain> mainModelList = tjQuotaDimensionMainService.search(filters, sorts);
        List<String> list = new ArrayList<>();
        if(mainModelList.size() > 0){
            for (TjQuotaDimensionMain tjQuotaDimensionMain : mainModelList) {
                list.add(tjQuotaDimensionMain.getMainCode());
            }
        }
        return list;
    }
}
