package com.yihu.jw.basic.agadmin.controller.quota;

import com.yihu.jw.basic.quota.service.TjDimensionSlaveService;
import com.yihu.jw.basic.quota.service.TjQuotaDimensionSlaveService;
import com.yihu.jw.entity.ehr.quota.TjDimensionSlave;
import com.yihu.jw.entity.ehr.quota.TjQuotaDimensionSlave;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.MixEnvelop;
import com.yihu.jw.restmodel.web.ObjEnvelop;
import com.yihu.jw.restmodel.web.PageEnvelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import io.swagger.annotations.Api;
import org.springframework.util.StringUtils;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.io.IOException;
import java.net.URLDecoder;
import java.util.*;

/**
 * Created by llh on 2017/5/9.
 */
@RestController
@RequestMapping("/tjDimensionSlave")
@Api( tags = {"网关-统计从维度"})
public class TjDimensionSlaveController extends EnvelopRestEndpoint {

    @Resource
    TjDimensionSlaveService tjDimensionSlaveService;
    @Resource
    TjQuotaDimensionSlaveService tjQuotaDimensionSlaveService;

    //查询
    @GetMapping("/getTjDimensionSlave")
    public Envelop searchTjDimensionSlave(String name, int page, int rows){
        String url = "/tj/getTjDimensionSlaveList";
        StringBuffer stringBuffer = new StringBuffer();
        if (!StringUtils.isEmpty(name)) {
            stringBuffer.append("name?" + name );
        }
        String filters = stringBuffer.toString();
        try {
            PageEnvelop PageEnvelop = new PageEnvelop();
            List<TjDimensionSlave> qtjDimensionSlaveList = tjDimensionSlaveService.search(null, filters, null, page, rows);
            if(qtjDimensionSlaveList != null){
                PageEnvelop.setDetailModelList(qtjDimensionSlaveList);
                PageEnvelop.setTotalCount((int)tjDimensionSlaveService.getCount(filters));
                PageEnvelop.setStatus(200);
                PageEnvelop.setCurrPage(page);
                PageEnvelop.setPageSize(rows);
            }else{
                PageEnvelop.setStatus(200);
                PageEnvelop.setMessage("查询无数据");
                PageEnvelop.setTotalCount(0);
            }
            return PageEnvelop;
        } catch (Exception ex) {
            ex.printStackTrace();
            return failed(ERR_SYSTEM_DES);
        }
    }



    /**
     * 新增修改
     */
    @PostMapping(value = "updateTjDimensionSlave")
    public Envelop updateTjDimensionSlave(String tjDimensionSlaveModelJsonData) throws IOException {

        String url = "/tj/tjDimensionSlave";
        String[] strings = URLDecoder.decode(tjDimensionSlaveModelJsonData, "UTF-8").split(";");
        TjDimensionSlave detailModel = objectMapper.readValue(strings[0], TjDimensionSlave.class);
        try {
            if (!StringUtils.isEmpty(detailModel.getId())) {
                Long id = detailModel.getId();
                TjDimensionSlave updateTjDimensionSlave =  tjDimensionSlaveService.getTjDimensionSlave(id);
                if (updateTjDimensionSlave!=null) {
                    updateTjDimensionSlave.setCode(detailModel.getCode());
                    updateTjDimensionSlave.setName(detailModel.getName());
                    updateTjDimensionSlave.setType(detailModel.getType());
                    updateTjDimensionSlave.setStatus(detailModel.getStatus());
                    updateTjDimensionSlave.setRemark(detailModel.getRemark());
                    updateTjDimensionSlave.setUpdateTime(new Date());
                    tjDimensionSlaveService.save(updateTjDimensionSlave);
                    return ObjEnvelop.getSuccess("操作成功",updateTjDimensionSlave);
                } else {
                    return failed("参数错误");
                }
            } else {
                detailModel.setCreateTime(new Date());
                tjDimensionSlaveService.save(detailModel);
                return ObjEnvelop.getSuccess("操作成功",detailModel);
            }
        } catch (Exception e) {
            e.printStackTrace();
            return failed(ERR_SYSTEM_DES);
        }
    }

    /**
     * 删除消息
     */
    @PostMapping("deleteTjDimensionSlave")
    public Envelop deleteTjDimensionSlave(Long tjDimensionSlaveId) {
        String url = "/tj/tjDimensionSlave";
        try {
            TjDimensionSlave tjDimensionSlave = tjDimensionSlaveService.getTjDimensionSlave(tjDimensionSlaveId);
            tjDimensionSlave.setStatus(-1);
            tjDimensionSlaveService.save(tjDimensionSlave);
            return ObjEnvelop.getSuccess("从维度删除成功！");
        } catch (Exception e) {
            e.printStackTrace();
            return failed(ERR_SYSTEM_DES);
        }
    }


    /**
     * 根据id获取消息
     */
    @GetMapping("getTjDimensionSlaveById")
    public Envelop getTjDimensionSlaveById( Long id ) {
        String url ="/tj/tjDimensionSlaveId/" +id;
        try {
            TjDimensionSlave updateTjDimensionSlave =  tjDimensionSlaveService.getTjDimensionSlave(id);
            return ObjEnvelop.getSuccess("获取成功",updateTjDimensionSlave);
        } catch (Exception e) {
            e.printStackTrace();
            return failed("查询失败");
        }
    }

    /**
     * 校验名称是否唯一
     */
    @GetMapping("isNameExists")
    public Envelop isNameExists(String name) {
        String url = "/tj/tjDimensionSlaveName" ;
        try {
            String filter = "name=" + name;
            List<TjDimensionSlave> list = tjDimensionSlaveService.search(filter);
            return ObjEnvelop.getSuccess("查询成功",list.size() > 0);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return failed("查询失败");
    }

    /**
     * 校验code是否唯一
     */
    @GetMapping("isCodeExists")
    public Envelop isCodeExists(String code) {
        String url = "/tj/tjDimensionSlaveCode" ;
        try {
            String filter = "code=" + code;
            List<TjDimensionSlave> list = tjDimensionSlaveService.search(filter);
            return ObjEnvelop.getSuccess("查询成功",list.size() > 0);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return failed("查询失败");
    }

    @GetMapping("/getTjDimensionSlaveInfo")
    public Envelop getTjDimensionSlaveInfo(String quotaCode, String name, int page, int rows){
        String url = "/tj/getTjDimensionSlaveInfoList";
        StringBuffer slaveFilter = new StringBuffer("status=1");
        String filter = null;
        if (!StringUtils.isEmpty(quotaCode)) {
            filter = "quotaCode=" + quotaCode;
        }
        if (!StringUtils.isEmpty(name)) {
            slaveFilter.append("name?" + name + " g1;code?" + name + " g1;");
        }
        String filters = slaveFilter.toString();
        try {
            List<TjDimensionSlave> mainModelList = tjDimensionSlaveService.search(null, filters, null, page, rows);
            if (mainModelList.size()>0) {
                List<TjQuotaDimensionSlave> qtjQuotaDimensionSlaveList = tjQuotaDimensionSlaveService.search(null, filter, null, page, rows);
                if (qtjQuotaDimensionSlaveList.size()>0) {
                    for (TjQuotaDimensionSlave tjQuotaQuotaDimensionSlaveModel : qtjQuotaDimensionSlaveList) {
                        List<TjDimensionSlave> tjDimensionSlaves = tjDimensionSlaveService.search("code=" + tjQuotaQuotaDimensionSlaveModel.getSlaveCode());
                        if (tjDimensionSlaves.size()>0) {
                            tjQuotaQuotaDimensionSlaveModel.setName(tjDimensionSlaves.get(0).getName());
                        }
                    }
                }
                List<String> list = getTjQuotaDimensionMainOfSlaveCode(filter, null);
                for (TjDimensionSlave tjDimensionSlave : mainModelList) {
                    tjDimensionSlave.setChecked(list.contains(tjDimensionSlave.getCode()));
                }
                return MixEnvelop.getSuccess("",qtjQuotaDimensionSlaveList,mainModelList,page,rows,tjDimensionSlaveService.getCount(filters));
            } else {
                return success();
            }
        } catch (Exception ex) {
            ex.printStackTrace();
            return failed(ERR_SYSTEM_DES);
        }
    }

    public List<String> getTjQuotaDimensionMainOfSlaveCode(String filters, String sorts) throws Exception {
        List<String> list = new ArrayList<>();
        List<TjQuotaDimensionSlave> qtjQuotaDimensionSlaveList = tjQuotaDimensionSlaveService.search(filters, sorts);
        if (qtjQuotaDimensionSlaveList.size()>0) {
            for (TjQuotaDimensionSlave tjQuotaDimensionSlave : qtjQuotaDimensionSlaveList) {
                list.add(tjQuotaDimensionSlave.getSlaveCode());
            }
        }
        return list;
    }
}
