package com.yihu.jw.basic.agadmin.controller.quota;

import com.fasterxml.jackson.core.type.TypeReference;
import com.yihu.jw.basic.dict.service.SystemDictEntryService;
import com.yihu.jw.basic.quota.service.*;
import com.yihu.jw.basic.resource.service.RsResourceQuotaService;
import com.yihu.jw.basic.util.TemPath;
import com.yihu.jw.entity.ehr.dict.SystemDictEntry;
import com.yihu.jw.entity.ehr.quota.*;
import com.yihu.jw.entity.ehr.resource.RsResourceQuota;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.MixEnvelop;
import com.yihu.jw.restmodel.web.ObjEnvelop;
import com.yihu.jw.restmodel.web.PageEnvelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import com.yihu.jw.util.date.DateTimeUtil;
import com.yihu.jw.util.http.HttpClientUtil;
import io.swagger.annotations.Api;
import org.apache.commons.lang3.StringUtils;
import org.apache.http.NameValuePair;
import org.apache.http.message.BasicNameValuePair;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.client.RestClientException;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.*;
import java.net.URLDecoder;
import java.util.*;
import java.util.stream.Collectors;

/**
 * Created by Administrator on 2017/6/13.
 */
@RestController
@RequestMapping("/tjQuota")
@Api( tags = {"网关-统计"})
public class TjQuotaController extends EnvelopRestEndpoint {


    @Resource
    private SystemDictEntryService dictEntryService;
    @Resource
    TjQuotaService tjQuotaService;
    @Resource
    private RsResourceQuotaService resourceQuotaService;
    @Resource
    TjQuotaDataSaveService tjQuotaDataSaveService;
    @Resource
    TjQuotaDataSourceService tjQuotaDataSourceService;
    @Resource
    TjDataSaveService tjDataSaveService;
    @Resource
    TjDataSourceService tjDataSourceService;
    @Resource
    TjQuotaChartService tjQuotaChartService;
    @Resource
    TjDimensionMainService tjDimensionMainService;
    @Resource
    TjDimensionSlaveService tjDimensionSlaveService;
    @Resource
    private TjQuotaCategoryService quotaCategoryService;
    @Resource
    TjQuotaDimensionSlaveService tjQuotaDimensionSlaveService;
    @Resource
    TjQuotaDimensionMainService tjQuotaDimensionMainService;
    @Resource
    private QuotaService quotaService;
    @Resource
    TjQuotaLogService tjQuotaLogService;
    @Resource
    private HttpClientUtil httpClientUtil;
    @Value("${url.svr_quota}")
    private String quotaUrl;

    @GetMapping("/getTjQuota")
    public Envelop searchTjQuota(String name, Integer quotaType, int page, int rows) {
        String url = "/tj/getTjQuotaList";
        StringBuffer stringBuffer = new StringBuffer();
        stringBuffer.append("status=1;");
        if (!StringUtils.isEmpty(name)) {
            stringBuffer.append("name?" + name.trim() + " g1;code?" + name.trim() + " g1;");
        }
        if (quotaType!=null) {
            stringBuffer.append("quotaType=" + quotaType + ";");
        } /*else {
            stringBuffer.append("quotaType=-1");
        }*/
        String filters = stringBuffer.toString();

        try {
            PageEnvelop PageEnvelop = new PageEnvelop();
            List<TjQuota> tjQuota = tjQuotaService.search(null, filters, null, page, rows);
            if(tjQuota != null){
                PageEnvelop.setDetailModelList(tjQuota);
                PageEnvelop.setTotalCount((int)tjQuotaService.getCount(filters));
                PageEnvelop.setStatus(200);
                PageEnvelop.setCurrPage(page);
                PageEnvelop.setPageSize(rows);
            }else{
                PageEnvelop.setStatus(200);
                PageEnvelop.setMessage("查询无数据");
                PageEnvelop.setTotalCount(0);
            }
            return PageEnvelop;
        } catch (Exception ex) {
            ex.printStackTrace();
            return failed(ERR_SYSTEM_DES);
        }
    }

    /**
     * 新增修改
     */
    @PostMapping(value = "updateTjDataSource")
    public ObjEnvelop updateTjQuota(String tjQuotaModelJsonData) {
        String url = "/tj/addTjQuota/";
        try {
            String[] strings = URLDecoder.decode(tjQuotaModelJsonData, "UTF-8").split(";");
            TjQuota detailModel = objectMapper.readValue(strings[0], TjQuota.class);
            if (detailModel.getId()!=null) {
                Long tjQuotaId = detailModel.getId();
                TjQuota updateTjQuota = tjQuotaService.getById(tjQuotaId);
                if (updateTjQuota!=null) {
                    updateTjQuota.setResultGetType(detailModel.getResultGetType());
                    updateTjQuota.setCode(detailModel.getCode());
                    updateTjQuota.setName(detailModel.getName());
                    updateTjQuota.setCron(detailModel.getCron());
                    updateTjQuota.setJobStatus(detailModel.getJobStatus());
                    updateTjQuota.setExecType(detailModel.getExecType());
                    updateTjQuota.setExecTime(detailModel.getExecTime());
                    updateTjQuota.setJobClazz(detailModel.getJobClazz());
                    updateTjQuota.setQuotaType(detailModel.getQuotaType());
                    updateTjQuota.setDataLevel(detailModel.getDataLevel());
                    updateTjQuota.setRemark(detailModel.getRemark());
                    TjQuotaDataSource tjquotaDataSource = null;
                    TjQuotaDataSave tjQuotaDataSave = null;
                    if(detailModel.getTjQuotaDataSourceModel() != null){
                        tjquotaDataSource = detailModel.getTjQuotaDataSourceModel();
                        tjquotaDataSource.setQuotaCode(detailModel.getCode());
                    }
                    if(detailModel.getTjQuotaDataSaveModel() != null
                            && org.apache.commons.lang3.StringUtils.isNotEmpty(detailModel.getTjQuotaDataSaveModel().getSaveCode())){
                        tjQuotaDataSave = detailModel.getTjQuotaDataSaveModel();
                        tjQuotaDataSave.setQuotaCode(detailModel.getCode());
                    }
                    updateTjQuota.setUpdateTime(new Date());
                    tjQuotaService.saves(updateTjQuota, tjquotaDataSource, tjQuotaDataSave);
                    return ObjEnvelop.getSuccess("统计表更新成功！", updateTjQuota);
                } else {
                    return ObjEnvelop.getError("参数错误");
                }
            } else {
                TjQuotaDataSource tjquotaDataSource = null;
                TjQuotaDataSave tjQuotaDataSave = null;
                if(detailModel.getTjQuotaDataSourceModel() != null){
                    tjquotaDataSource = detailModel.getTjQuotaDataSourceModel();
                    tjquotaDataSource.setQuotaCode(detailModel.getCode());
                }
                if(detailModel.getTjQuotaDataSaveModel() != null
                        && org.apache.commons.lang3.StringUtils.isNotEmpty(detailModel.getTjQuotaDataSaveModel().getSaveCode())){
                    tjQuotaDataSave = detailModel.getTjQuotaDataSaveModel();
                    tjQuotaDataSave.setQuotaCode(detailModel.getCode());
                }
                detailModel.setIsInitExec("0");
                detailModel.setStatus(1);
                detailModel.setCreateTime(new Date());
                detailModel.setUpdateTime(new Date());
                tjQuotaService.saves(detailModel, tjquotaDataSource, tjQuotaDataSave);
                return ObjEnvelop.getSuccess("统计表更新成功！", detailModel);
            }
        } catch (Exception e) {
            e.printStackTrace();
            return ObjEnvelop.getError(ERR_SYSTEM_DES);
        }
    }

    /**
     * 删除
     */
    @PostMapping("deleteTjDataSave")
    public Envelop deleteTjQuota(Long tjQuotaId) {
        String url = "/tj/deleteTjQuota";
        //判断资源视图中有没有用到此视图，有用到 不允许删除
        String resQuotaUrl = "/resourceQuota/searchByQuotaId";
        try {
            List<RsResourceQuota> list = resourceQuotaService.search("quotaId=" + tjQuotaId);
            if (list.size()>0) {
                return failed("指标在视图中被使用暂时不能删除，若要删除先解除资源视图中指标关系");
            }
            TjQuota tjQuota = tjQuotaService.getById(tjQuotaId);
            tjQuota.setStatus(-1);
            tjQuotaService.save(tjQuota);
            return ObjEnvelop.getSuccess("统计指标表删除成功！");
        } catch (Exception e) {
            e.printStackTrace();
            return failed(ERR_SYSTEM_DES);
        }
    }

    /**
     * 根据id获取消息
     */
    @GetMapping("getTjQuotaById")
    public Envelop getTjQuotaById(Long id) {
        String url = "/tj/getTjQuotaById/" + id;
        try {
            TjQuota tjQuota = tjQuotaService.getById(id);
            if (null != tjQuota) {
                TjQuotaDataSave tjQuotaDataSave = tjQuotaDataSaveService.getByQuotaCode(tjQuota.getCode());
                TjQuotaDataSource tjQuotaDataSource = tjQuotaDataSourceService.getByQuotaCode(tjQuota.getCode());
                if (tjQuotaDataSave != null && tjQuotaDataSave.getSaveCode() != null) {
                    TjDataSave tjDataSave = tjDataSaveService.getByCode(tjQuotaDataSave.getSaveCode());
                    tjQuotaDataSave.setName(tjDataSave.getName());
                }
                if (tjQuotaDataSource != null && tjQuotaDataSource.getSourceCode() != null) {
                    TjDataSource tjDataSource = tjDataSourceService.getByCode(tjQuotaDataSource.getSourceCode());
                    tjQuotaDataSource.setName(tjDataSource.getName());
                }
                tjQuota.setTjQuotaDataSaveModel(tjQuotaDataSave);
                tjQuota.setTjQuotaDataSourceModel(tjQuotaDataSource);
            }
            return ObjEnvelop.getSuccess("统计指标表删除成功！",tjQuota);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return failed("查询失败");
    }

    /**
     * 校验name是否唯一,true已存在
     */
    @GetMapping("hasExistsName")
    public Envelop hasExistsName(String name) {
        String url = "/tj/tjQuotaExistsName/" + name;
        try {
            String filter = "name=" + name;
            List<TjQuota> list = tjQuotaService.search(filter);
            return ObjEnvelop.getSuccess("查询成功",list.size() >0);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return failed("查询失败");
    }

    /**
     * 校验code是否唯一
     */
    @GetMapping("hasExistsCode")
    public Envelop hasExistsCode(String code) {
        String url = "/tj/tjQuotaExistsCode/" + code;
        try {
            String filter = "code=" + code;
            List<TjQuota> list = tjQuotaService.search(filter);
            return ObjEnvelop.getSuccess("查询成功",list.size() >0);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return  failed("查询失败");
    }

    /**
     * 初始执行(全量统计)
     */
    @PostMapping("firstExecuteQuota")
    public Envelop firstExecuteQuota(Long tjQuotaId) {
        try {
            String url = quotaUrl + "/api/v1.0/job/firstExecuteQuota";
            List<NameValuePair> params = new ArrayList<>();
            params.add(new BasicNameValuePair("id", tjQuotaId+""));
            String infoResponse = httpClientUtil.post(url,params,"UTF-8");
//            return jobController.firstExecuteQuota(tjQuotaId);
            if("true".equals(infoResponse)){
                return success("执行成功");
            }
            return Envelop.getError("执行失败");
        } catch (Exception e) {
            e.printStackTrace();
            return failed(ERR_SYSTEM_DES);
        }
    }

    /**
     * 执行指标
     */
    @PostMapping("execuQuota")
    public Envelop execuQuota(Long tjQuotaId, String startDate, String endDate) {
        try {
            String url = quotaUrl + "/api/v1.0/job/execuJob";
            List<NameValuePair> params = new ArrayList<>();
            params.add(new BasicNameValuePair("id", tjQuotaId+""));
            params.add(new BasicNameValuePair("startDate", startDate));
            params.add(new BasicNameValuePair("endDate", endDate));
//            return jobController.executeQuota(tjQuotaId,startDate,endDate);
            String infoResponse = httpClientUtil.post(url,params,"UTF-8");
//            return jobController.firstExecuteQuota(tjQuotaId);
            if("true".equals(infoResponse)){
                return success("执行成功");
            }
            return Envelop.getError("执行失败");
        } catch (Exception e) {
            e.printStackTrace();
            return failed(ERR_SYSTEM_DES);
        }
    }

    /**
     * 指标结果页
     */
    @GetMapping("initialResult")
    public Envelop initialResult(long tjQuotaId, String quotaCode, String quotaType, String name) throws Exception {
        try {
            Map<String,String> map = new HashMap<>();
            List<TjQuotaDimensionSlave> slaveModelList = tjQuotaDimensionSlaveService.getTjQuotaDimensionSlaveByCode(quotaCode);
            if (slaveModelList.size() > 0) {
                int num = 1;
                for (TjQuotaDimensionSlave quotaDimensionSlaveModel : slaveModelList) {
                    TjDimensionSlave tjDimensionSlave = tjDimensionSlaveService.getTjDimensionSlaveByCode(quotaDimensionSlaveModel.getSlaveCode());
                    if (tjDimensionSlave!=null) {
                        map.put("slaveKey" + num + "Name", tjDimensionSlave.getName());
                        num++;
                    }
                }
            }
            return ObjEnvelop.getSuccess("查询成功",map);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return failed("查询失败");
    }


    /**
     * 指标执行结果
     */
    @GetMapping("selectQuotaResult")
    public Envelop selectQuotaResult(Long tjQuotaId, int page, int rows,
                                    String startTime, String endTime, String orgName,
                                    String province, String city, String district,String res) {
        try {
            Map<String, Object> filters = new HashMap<>();
            filters.put("startTime", startTime);
            filters.put("endTime", endTime);
            filters.put("org", orgName);
            filters.put("province", province);
            filters.put("town", city);
            filters.put("district", district);
            // 结果大于0
            filters.put("result", res);

            String url = quotaUrl + "/api/v1.0/tj/tjGetQuotaResult";
            List<NameValuePair> params = new ArrayList<>();
            params.add(new BasicNameValuePair("id", tjQuotaId+""));
            params.add(new BasicNameValuePair("pageNo", page+""));
            params.add(new BasicNameValuePair("pageSize", rows+""));
            params.add(new BasicNameValuePair("filters", objectMapper.writeValueAsString(filters)));

            String infoResponse = httpClientUtil.get(url,params,"UTF-8");
            return toModel(infoResponse,MixEnvelop.class);

//            Map<String, Object> filters = new HashMap<>();
//            if(StringUtils.isNotBlank(startTime)){
//                filters.put("startTime", startTime);
//            }
//            if(StringUtils.isNotBlank(endTime)){
//                filters.put("endTime", endTime);
//            }
//            if(StringUtils.isNotBlank(orgName)){
//                filters.put("orgName", orgName);
//            }
//            if(StringUtils.isNotBlank(province)){
//                filters.put("province", province);
//            }
//            if(StringUtils.isNotBlank(city)){
//                filters.put("city", city);
//            }
//            if(StringUtils.isNotBlank(district)){
//                filters.put("district", district);
//            }
//            if(StringUtils.isNotBlank(res)){
//                // 结果大于0
//                filters.put("result", res);
//            }
//            try {
//                List<SaveModel> saveModelList = new ArrayList<>();
//                List<Map<String, Object>> resultList = quotaService.queryResultPage(tjQuotaId, filters.toString(), page, rows);
//                if(resultList != null && resultList.size() > 0){
//                    for(Map<String, Object> map : resultList){
//                        SaveModel saveModel =  objectMapper.convertValue(map, SaveModel.class);
//                        if(saveModel != null){
//                            saveModelList.add(saveModel);
//                        }
//                    }
//                }
//                long totalCount = quotaService.getQuotaTotalCount(tjQuotaId,filters.toString());
//                return PageEnvelop.getSuccessListWithPage("查询成功",saveModelList,page,rows,totalCount);
//            } catch (Exception e) {
//                e.printStackTrace();
//            }
//            return failed("查询失败");
        } catch (Exception e) {
            e.printStackTrace();
            return failed(ERR_SYSTEM_DES);
        }
    }


    /**
     * 获取指标日志信息
     */
    @GetMapping("queryQuotaLog")
    public Envelop queryQuotaLog(String quotaCode, String startTime, String endTime, int page, int rows) throws Exception {
        String url = "/tj/getTjQuotaLogList";
        try {
            Map<String, Object> conditionMap = new HashMap<>();
            conditionMap.put("quotaCode", quotaCode);
            conditionMap.put("page", page);
            conditionMap.put("pageSize", rows);

            Date startDate = DateTimeUtil.simpleDateTimeParse(startTime);
            Date endDate = DateTimeUtil.simpleDateTimeParse(endTime);
            if(null!=endDate){
                Calendar calendar   =   new GregorianCalendar();
                calendar.setTime(endDate);
                calendar.add(calendar.DATE,1);//把日期往后增加一天.整数往后推,负数往前移动
                endDate=calendar.getTime();   //日期往后推一天
            }
            conditionMap.put("startDate", startDate);
            conditionMap.put("endDate", endDate);
            List<TjQuotaLog> tjQuotaLogs = tjQuotaLogService.searchQuotaLogByParams(conditionMap);
            if(tjQuotaLogs.size()>0){
                List<SystemDictEntry> dictEntries = dictEntryService.getDictEntries(82,null);
                Map<String, String> distMap = dictEntries.stream()
                        .collect(Collectors.toMap(SystemDictEntry::getCode, SystemDictEntry::getValue));
                for (TjQuotaLog log:tjQuotaLogs){
                    //获取类别字典
                    log.setStatusName(distMap.get(String.valueOf(log.getStatus())));
                }
            }

            Long totalCount =Long.parseLong(tjQuotaLogService.searchQuotaLogByParamsTotalCount(conditionMap).toString());
            return PageEnvelop.getSuccessListWithPage("",tjQuotaLogs,page,rows,totalCount);
        } catch (Exception ex) {
            ex.printStackTrace();
            return failed(ERR_SYSTEM_DES);
        }
    }

    /**
     * 获取quotaCode查询是否配置维度
     */
    @GetMapping("hasConfigDimension")
    public Envelop hasConfigDimension(String quotaCode) throws Exception {
        String url = "/tj/hasConfigDimension";
        try {
            String filters = "quotaCode=" + quotaCode;
            List<TjQuotaDimensionMain> list = tjQuotaDimensionMainService.search(filters);
            return ObjEnvelop.getSuccess("",list.size()>0);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return failed("查询失败");
    }


    //带检索分页的查找指标方法,用于下拉框
    @GetMapping("/rsQuota")
    public Envelop searchRsQuota(String searchParm, int page, int rows) {
        String url = "/tj/getTjQuotaList";
        StringBuffer stringBuffer = new StringBuffer();
        if (!StringUtils.isEmpty(searchParm)) {
            stringBuffer.append("name?" + searchParm + ";");
        }
        String filters = stringBuffer.toString();
        try {
            PageEnvelop PageEnvelop = new PageEnvelop();
            List<TjQuota> tjQuota = tjQuotaService.search(null, filters, null, page, rows);
            if(tjQuota != null){
                PageEnvelop.setDetailModelList(tjQuota);
                PageEnvelop.setTotalCount((int)tjQuotaService.getCount(filters));
                PageEnvelop.setStatus(200);
                PageEnvelop.setCurrPage(page);
                PageEnvelop.setPageSize(rows);
            }else{
                PageEnvelop.setStatus(200);
                PageEnvelop.setMessage("查询无数据");
                PageEnvelop.setTotalCount(0);
            }
            return PageEnvelop;
        } catch (Exception ex) {
            ex.printStackTrace();
            return failed(ERR_SYSTEM_DES);
        }
    }


    @GetMapping("/getTjQuotaChartList")
    public Envelop getQuotaChartList(String quotaCode, String name, Integer dictId, int page, int rows) {
        String url = "/tj/getTjQuotaChartList";
        StringBuffer stringBuffer = new StringBuffer();
        if (!StringUtils.isEmpty(quotaCode)) {
            stringBuffer.append("quotaCode=" + quotaCode);
        }
        if (!StringUtils.isEmpty(name)) {
            stringBuffer.append("value?" + name);
        }
        String filters = stringBuffer.toString();
        String filter = "";
        if (dictId != null) {
            filter = "dictId=" + dictId;
        }
//        params.put("dictfilter", filter);
        try {
            List<SystemDictEntry> conventionalDictList = dictEntryService.search(null, filter, null, page, rows);
            List<SystemDictEntry> mainModelList = new ArrayList<>();
            if (conventionalDictList.size() > 0) {
                mainModelList.addAll(conventionalDictList);
                Map<String,String> dictMap = new HashMap<>();
                for(SystemDictEntry dict:mainModelList){
                    dictMap.put(dict.getCode(),dict.getValue());
                }

                List<TjQuotaChart> tjQuotaChartList = tjQuotaChartService.search(null, filters, null, page, rows);
                List<SystemDictEntry> checkedConventionalDicts = new ArrayList<>();
                if (tjQuotaChartList.size() > 0) {
                    for (TjQuotaChart tjQuotaChartModel : tjQuotaChartList) {
                        SystemDictEntry mConventionalDict = new SystemDictEntry();
                        String key = tjQuotaChartModel.getChartId()+"";
                        if(dictMap.containsKey(key)){
                            mConventionalDict.setCode(key);
                            mConventionalDict.setValue(dictMap.get(key));
                            checkedConventionalDicts.add(mConventionalDict);
                        }
                    }
                }
                List<String> list = getAllCheckedTjQuotaChart(filters);
                for (SystemDictEntry systemDictEntry : mainModelList) {
                    systemDictEntry.setChecked(list.contains(systemDictEntry.getCode()));
                }
                return MixEnvelop.getSuccess("",checkedConventionalDicts,mainModelList,page,rows,dictEntryService.getCount(filter));
            } else {
                return success();
            }
        } catch (Exception ex) {
            ex.printStackTrace();
            return failed(ERR_SYSTEM_DES);
        }
    }

    public List<String> getAllCheckedTjQuotaChart(String filters) throws Exception{
        List<String> list = new ArrayList<>();
        List<TjQuotaChart> tjQuotaCharts = tjQuotaChartService.search(filters, null);
        List<TjQuotaChart>  tjQuotaChartModels = new ArrayList<>();
        if (tjQuotaCharts.size()> 0) {
            for (TjQuotaChart tjQuotaChartModel : tjQuotaCharts) {
                tjQuotaChartModels.add(tjQuotaChartModel);
                list.add(tjQuotaChartModel.getChartId()+"");
            }
        }
        return list;
    }

    /**
     * 添加主维度子表
     */
    @PostMapping(value = "addTjQuotaChart")
    public Envelop addTjQuotaChart(String quotaCode, String jsonModel, HttpServletRequest request) throws IOException {
        String url = "/tj/batchTjQuotaChart";
        try {
            List<TjQuotaChart> list = objectMapper.readValue(jsonModel, new TypeReference<List<TjQuotaChart>>(){});
            if (list != null && list.size() > 0) {
                tjQuotaChartService.deleteByQuotaCode(list.get(0).getQuotaCode());
            }
            for (TjQuotaChart tjQuotaChart : list) {
                tjQuotaChartService.save(tjQuotaChart);
            }
            return ObjEnvelop.getSuccess("指标图表信息更新成功！", list);
        } catch (RestClientException e) {
            e.printStackTrace();
            return failed(ERR_SYSTEM_DES);
        }
    }

    /**
     * 指标文件导入
     */
    private static final String parentFile = "tjQuotaDataSet";

//    @RequestMapping(value = "import")
//    public void importData(MultipartFile file, HttpServletRequest request, HttpServletResponse response) throws IOException {
//        try {
//            writerResponse(response, 1 + "", "l_upd_progress");
//            request.setCharacterEncoding("UTF-8");
//            TjQuotaMsgReader excelReader = new TjQuotaMsgReader();
//            excelReader.read(file.getInputStream());
//            //指标
//            List<TjQuotaMsg> errorLs = excelReader.getErrorLs();
//            List<TjQuotaMsg> correctLs = excelReader.getCorrectLs();
//            //主维度
//            List<TjQuotaDMainMsg> quotaMainErrorLs = excelReader.getQuotaMainErrorLs();
//            List<TjQuotaDMainMsg> quotaMainCorrectLs = excelReader.getQuotaMainCorrectLs();
//            //细维度
//            List<TjQuotaDSlaveMsg> quotaSlaveErrorLs = excelReader.getQuotaSlaveErrorLs();
//            List<TjQuotaDSlaveMsg> quotaSlaveCorrectLs = excelReader.getQuotaSlaveCorrectLs();
//            writerResponse(response, 35 + "", "l_upd_progress");
//
//            Map<String, Object> LsMap = validate(user, excelReader, errorLs, correctLs, quotaMainErrorLs, quotaMainCorrectLs, quotaSlaveErrorLs, quotaSlaveCorrectLs);
//            writerResponse(response, 55 + "", "l_upd_progress");
//
//            Map rs = new HashMap<>();
//            //输出错误信息
//            if (errorLs.size() > 0 || quotaMainErrorLs.size() > 0 || quotaSlaveErrorLs.size() > 0) {
//                String eFile = TemPath.createFileName(user.getLoginCode(), "e", parentFile, ".xls");
//                new TjQuotaMsgWriter().write(new File(TemPath.getFullPath(eFile, parentFile)), errorLs, quotaMainErrorLs, quotaSlaveErrorLs);
//                rs.put("eFile", new String[]{eFile.substring(0, 10), eFile.substring(11, eFile.length())});
//            }
//            writerResponse(response, 65 + "", "l_upd_progress");
//
//            if (LsMap.size() > 0) {
//                saveData(LsMap);
//            }
//            if (errorLs.size() == 0 && quotaMainErrorLs.size() == 0 && quotaSlaveErrorLs.size() == 0){
//                writerResponse(response, 100 + ",'suc'", "l_upd_progress");
//            } else {
//                writerResponse(response, 100 + ",'" + toJson(rs) + "'", "l_upd_progress");
//            }
//        } catch (Exception e) {
//            e.printStackTrace();
//            writerResponse(response, "-1", "l_upd_progress");
//        }
//    }

    protected void writerResponse(HttpServletResponse response, String body, String client_method) throws IOException {
        StringBuffer sb = new StringBuffer();
        sb.append("<script type=\"text/javascript\">//<![CDATA[\n");
        sb.append("     parent.").append(client_method).append("(").append(body).append(");\n");
        sb.append("//]]></script>");

        response.setContentType("text/html;charset=UTF-8");
        response.addHeader("Pragma", "no-cache");
        response.setHeader("Cache-Control", "no-cache,no-store,must-revalidate");
        response.setHeader("Cache-Control", "pre-check=0,post-check=0");
        response.setDateHeader("Expires", 0);
        response.getWriter().write(sb.toString());
        response.flushBuffer();
    }

    /**
     * 验证指标编码、名称、指标分类、主维度、细维度
     *
     * @param excelReader         待验证的数据
     * @param errorLs             指标错误数据
     * @param correctLs           指标正常数据
     * @param quotaMainErrorLs    主维度错误数据
     * @param quotaMainCorrectLs  主维度正常数据
     * @param quotaSlaveErrorLs   细维度错误数据
     * @param quotaSlaveCorrectLs 细维度正常数据
     * @return
     * @throws Exception
     */
//    private Map<String,Object> validate(UsersModel user,TjQuotaMsgReader excelReader,
//                          List<TjQuotaMsg> errorLs, List<TjQuotaMsg> correctLs ,
//                           List<TjQuotaDMainMsg>  quotaMainErrorLs ,List<TjQuotaDMainMsg>  quotaMainCorrectLs ,
//                           List<TjQuotaDSlaveMsg>  quotaSlaveErrorLs ,List<TjQuotaDSlaveMsg>  quotaSlaveCorrectLs) throws Exception {
//        List saveLs = new ArrayList<>();
//        List quotaMainLs = new ArrayList<>();
//        List quotaSlaveLs = new ArrayList<>();
//        //验证指标编码是否存在
//        Set<String> quotaCodes = findExistCodeOrName("code", excelReader.getRepeat().get("code"));
//        //验证指标名称是否存在
//        Set<String> quotaNames = findExistCodeOrName("name", excelReader.getRepeat().get("name"));
//        //根据指标类型名称获取指标类型id
//        Map<String, String> quotaTypes = findExistQuotaType(excelReader.getRepeat().get("quotaType"));
//        //判断主维度编码是否存在
//        Set<String> mainCodes = findExistCodeOrName("mainCode", excelReader.getQuotaMainRepeat().get("mainCode"));
//        //判断细维度编码是否存在
//        Set<String> slaveCodes = findExistCodeOrName("slaveCode", excelReader.getQuotaSlaveRepeat().get("slaveCode"));
//
//        TjQuotaMsg model;
//        TjQuotaDMainMsg TjQuotaDMainModel;
//        TjQuotaDSlaveMsg TjQuotaDSlaveModel;
//        boolean valid;
//        for (int i = 0; i < errorLs.size(); i++) {
//            model = errorLs.get(i);
//            TjQuotaDMainModel = quotaMainErrorLs.get(i);
//            TjQuotaDSlaveModel = quotaSlaveErrorLs.get(i);
//            //验证指标编码是否存在
//            if (quotaCodes.contains(model.getCode())) {
//                model.addErrorMsg("code", "该指标编码已存在！");
//            }
//
////            //验证指标名称是否存在
////            if(quotaNames.contains(model.getName())){
////                model.addErrorMsg("name", "该指标名称已存在！");
////            }
//
//            //根据指标类型名称获取指标类型id
//            if (null == quotaTypes.get(model.getQuotaType())) {
//                model.addErrorMsg("quotaType", "该指标类型不存在！");
//            }
//
//            //判断主维度编码是否存在
//            if (mainCodes.contains(TjQuotaDMainModel.getMainCode())) {
//                TjQuotaDMainModel.addErrorMsg("mainCode", "该主维度编码不存在！");
//            }
//
//            //判断细维度编码是否存在
//            if (slaveCodes.contains(TjQuotaDSlaveModel.getSlaveCode())) {
//                TjQuotaDSlaveModel.addErrorMsg("slaveCode", "该细维度编码不存在！");
//            }
//
//            //判断主维度指标编码是否存在（包括库里存在、现导入文件的指标编码）
//            if (!excelReader.getRepeat().get("code").contains(TjQuotaDMainModel.getMainCode())) {
//                TjQuotaDMainModel.addErrorMsg("quotaCode", "导入指标中找不到该主维度的指标编码！");
//            }
//            //判断细维度指标编码是否存在（包括库里存在、现导入文件的指标编码）
//            if (excelReader.getRepeat().get("code").contains(TjQuotaDSlaveModel.getSlaveCode())) {
//                TjQuotaDSlaveModel.addErrorMsg("quotaCode", "导入指标中找不到该细维度的指标编码！");
//            }
//        }
//
//        for (int i = 0; i < correctLs.size(); i++) {
//            valid = true;
//            model = correctLs.get(i);
//            //验证指标编码是否存在
//            if (quotaCodes.contains(model.getCode())) {
//                model.addErrorMsg("code", "该指标编码已存在！");
//                valid = false;
//            }
////            //验证指标名称是否存在
////            if(quotaNames.contains(model.getName())){
////                model.addErrorMsg("name", "该指标名称已存在！");
////                valid = false;
////            }
//
//            //根据指标类型名称获取指标类型id
//            if (null == quotaTypes.get(model.getQuotaType())) {
//                model.addErrorMsg("quotaType", "该指标类型不存在！");
//                valid = false;
//            }
//            //指标错误信息
//            if (!valid) {
//                errorLs.add(model);
//            } else {
//                model.setQuotaType(quotaTypes.get(model.getQuotaType()));
//                model.setCreateUser(user.getId());
//                model.setCreateUserName(user.getRealName());
//            }
//
//            if (valid) {
//                saveLs.add(correctLs.get(i));
//            }
//        }
//        //主维度
//        for (int i = 0; i < quotaMainCorrectLs.size(); i++) {
//            valid = true;
//            TjQuotaDMainModel = quotaMainCorrectLs.get(i);
//
//            //判断主维度编码是否存在
//            if (!(mainCodes.contains(TjQuotaDMainModel.getMainCode()))) {
//                TjQuotaDMainModel.addErrorMsg("mainCode", "该主维度编码不存在！");
//                valid = false;
//            }
//            //判断主维度指标编码是否存在（包括库里存在、现导入文件的指标编码）
//            if (!(quotaCodes.contains(TjQuotaDMainModel.getQuotaCode()) || excelReader.getRepeat().get("code").contains(TjQuotaDMainModel.getQuotaCode()))) {
//                TjQuotaDMainModel.addErrorMsg("quotaCode", "导入的指标中找不到该主维度的指标编码！");
//                valid = false;
//            }
//            //主维度错误信息
//            if (!valid) {
//                quotaMainErrorLs.add(TjQuotaDMainModel);
//            }
//
//            if (valid) {
//                quotaMainLs.add(quotaMainCorrectLs.get(i));
//            }
//        }
//        //细维度
//        for (int i = 0; i < quotaSlaveCorrectLs.size(); i++) {
//            valid = true;
//            TjQuotaDSlaveModel = quotaSlaveCorrectLs.get(i);
//            //判断细维度编码是否存在
//            if (!(slaveCodes.contains(TjQuotaDSlaveModel.getSlaveCode()))) {
//                TjQuotaDSlaveModel.addErrorMsg("slaveCode", "该细维度编码不存在！");
//                valid = false;
//            }
//            //判断细维度指标编码是否存在（包括库里存在、现导入文件的指标编码）
//            if (!(quotaCodes.contains(TjQuotaDSlaveModel.getQuotaCode()) || excelReader.getRepeat().get("code").contains(TjQuotaDSlaveModel.getQuotaCode()))) {
//                TjQuotaDSlaveModel.addErrorMsg("quotaCode", "导入的指标中找不到该细维度的指标编码！");
//                valid = false;
//            }
//            //细维度错误信息
//            if (!valid) {
//                quotaSlaveErrorLs.add(TjQuotaDSlaveModel);
//            }else{
//                quotaSlaveLs.add(quotaSlaveCorrectLs.get(i));
//            }
//        }
//        Map<String, Object> map = new HashMap<>();
//        if (null != saveLs && saveLs.size() > 0) {
//            map.put("saveLs", saveLs);
//            map.put("quotaMainLs", quotaMainLs);
//            map.put("quotaSlaveLs", quotaSlaveLs);
//        }
//        return map;
//    }

    /**
     * 获取已经存在的指标编码/指标名称
     *
     * @param name  检索字段名称
     * @param codes 检索列表
     */
    private List<String> findExistCodeOrName(String name, Set<String> codes) throws Exception {

        Map<String, Object> conditionMap = new HashMap<>();
        List values = new ArrayList();
        //获取存在的主维度
        if (!StringUtils.isEmpty(name) && name.equals("mainCode")) {
            if (null != codes && codes.size() > 0) {
                values = tjDimensionMainService.tjDimensionMainIsExist(toEntity(toJson(codes), String[].class));
            }
        } else if (!StringUtils.isEmpty(name) && name.equals("slaveCode")) {
            //获取存在的细维度
            if (null != codes && codes.size() > 0) {
                values = tjDimensionSlaveService.tjDimensionSlaveIsExist(toEntity(toJson(codes), String[].class));
            }
        } else {
            if (null != codes && codes.size() > 0) {
                values = tjQuotaService.tjQuotaTypeIsExist(name,toEntity(toJson(codes), String[].class));
            }
        }

        return values;
    }

    /**
     * 根据指标分类的名称获取指标id和name
     *
     */
    private Map<String, String> findExistQuotaType(Set<String> names) throws Exception {
        Map<String, String> map = new HashMap<>();
        List<Object> list = (List<Object>)quotaCategoryService.getQuotaCategoryByName(toEntity(toJson(names), String[].class));
        for (Object o : list) {
            Object[] objectList = (Object[]) o;
            if (null != objectList[0] && null != objectList[1]) {
                map.put(objectList[0].toString(), objectList[1].toString());
            }
        }
        return  map;
    }

    /**
     * 指标、数据源、数据存储、主维度、细维度整体入库
     *
     * @return
     */
//    private Envelop saveData(Map<String, Object> lsMap) {
//        Envelop ret = new Envelop();
//        Map map = new HashMap<>();
//        try {
//            map.put("lsMap", toJson(lsMap));
//            String envelopStrNew = HttpClientUtil.doPost(comUrl + "/tjQuota/batch", map, username, password);
//            ret = objectMapper.readValue(envelopStrNew,Envelop.class);
//            return ret;
//        } catch (Exception e) {
//            e.printStackTrace();
//            ret.setSuccessFlg(false);
//            ret.setErrorMsg(e.getMessage());
//            return ret;
//        }
//    }


    @GetMapping("/downLoadErrInfo")
    public void downLoadErrInfo(String f, String datePath, HttpServletResponse response) throws IOException {

        try {
            f = datePath + TemPath.separator + f;
            downLoadFile(TemPath.getFullPath(f, parentFile), response);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void downLoadFile(String filePath, HttpServletResponse response) throws IOException {

        InputStream fis = null;
        OutputStream toClient = null;
        try {
            File file = new File(filePath);
            fis = new BufferedInputStream(new FileInputStream(file));
            byte[] buffer = new byte[fis.available()];
            fis.read(buffer);
            fis.close();

            response.reset();
            response.setContentType("octets/stream");
            response.addHeader("Content-Length", "" + file.length());
            response.addHeader("Content-Disposition", "attachment; filename="
                    + new String(file.getName().getBytes("gb2312"), "ISO8859-1"));

            toClient = new BufferedOutputStream(response.getOutputStream());
            toClient.write(buffer);
            toClient.flush();
            toClient.close();
        } catch (Exception e) {
            e.printStackTrace();
            if (fis != null){
                fis.close();
            }
            if (toClient != null){
                toClient.close();
            }
        }
    }

    /**
     * 停止执行指标
     */
    @PostMapping("removeQuota")
    public Object removeQuota(Long tjQuotaId) {
        try {

            String url = quotaUrl + "/api/v1.0/job/removeQuota";
            List<NameValuePair> params = new ArrayList<>();
            params.add(new BasicNameValuePair("id", tjQuotaId+""));
            String infoResponse = httpClientUtil.post(url,params,"UTF-8");
            if("true".equals(infoResponse)){
                return success("执行成功");
            }
            return Envelop.getError("执行失败");
        } catch (Exception e) {
            e.printStackTrace();
            return failed(ERR_SYSTEM_DES);
        }
    }

}
