package com.yihu.jw.basic.agadmin.controller.quota;

import com.fasterxml.jackson.core.type.TypeReference;

import com.yihu.jw.basic.quota.service.TjQuotaDimensionMainService;
import com.yihu.jw.entity.ehr.quota.TjQuotaDimensionMain;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.ObjEnvelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import io.swagger.annotations.Api;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.io.IOException;
import java.util.List;
import java.util.Map;

/**
 * Created by Administrator on 2017/6/15.
 */
@RestController
@RequestMapping("/tjQuotaDimensionMain")
@Api( tags = {"网关-统计指标主维度"})
public class TjQuotaDimensionMainController extends EnvelopRestEndpoint {

    @Autowired
    TjQuotaDimensionMainService tjQuotaDimensionMainService;

    /**
     * 添加主维度子表
     * @param jsonModel 维度子表信息的json串
     * @param request
     * @return
     * @throws IOException
     */
    @PostMapping(value = "addTjQuotaDimensionMain")
    public Object addTjQuotaDimensionMain(String quotaCode, String jsonModel, HttpServletRequest request) throws IOException {
        String url = "/tj/addTjQuotaDimensionMain";
        String resultStr = "";
        Envelop result = new Envelop();
        if (!StringUtils.isBlank(quotaCode)) {
            url = "/tj/deleteMainByQuotaCode";
            tjQuotaDimensionMainService.deleteByQuotaCode(quotaCode);
            return success("删除成功");
        }
        List<TjQuotaDimensionMain> list = objectMapper.readValue(jsonModel, new TypeReference<List<TjQuotaDimensionMain>>(){});
        if (list != null && list.size() > 0) {
            tjQuotaDimensionMainService.deleteByQuotaCode(list.get(0).getQuotaCode());
        }
        for (int i=0; i<list.size(); i++) {
            tjQuotaDimensionMainService.save(list.get(i));
        }
        return ObjEnvelop.getSuccess("统计指标主维度关联信息更新成功！", list);
    }
}
