package com.yihu.jw.basic.agadmin.controller.quota;

import com.fasterxml.jackson.core.type.TypeReference;
import com.yihu.jw.basic.quota.service.TjQuotaDimensionSlaveService;
import com.yihu.jw.entity.ehr.quota.TjQuotaDimensionSlave;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.ObjEnvelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import io.swagger.annotations.Api;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.io.IOException;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by Administrator on 2017/6/15.
 */
@RestController
@RequestMapping("/tjQuotaDimensionMain")
@Api( tags = {"网关-统计指标从维度"})
public class TjQuotaDimensionSlaveController extends EnvelopRestEndpoint {

    @Autowired
    TjQuotaDimensionSlaveService tjQuotaDimensionSlaveService;
    /**
     * 添加主维度子表
     * @param jsonModel 维度子表信息的json串
     * @param request
     * @return
     * @throws IOException
     */
    @PostMapping(value = "addTjQuotaDimensionSlave")
    public Object addTjQuotaDimensionSlave(String quotaCode, String jsonModel, HttpServletRequest request) throws IOException {
        String url = "/tj/addTjQuotaDimensionSlave";
        String resultStr = "";
        Envelop result = new Envelop();
        if (!StringUtils.isBlank(quotaCode)) {
            url = "/tj/deleteSlaveByQuotaCode";
            tjQuotaDimensionSlaveService.deleteByQuotaCode(quotaCode);
            return success("删除成功");
        }
        List<TjQuotaDimensionSlave> list = objectMapper.readValue(jsonModel, new TypeReference<List<TjQuotaDimensionSlave>>(){});
        if (list != null && list.size() > 0) {
            tjQuotaDimensionSlaveService.deleteByQuotaCode(list.get(0).getQuotaCode());
        }
        for (int i=0; i<list.size(); i++) {
            TjQuotaDimensionSlave item = list.get(i);
            // 年龄段转换类
            if ("age".equals(item.getSlaveCode()) && "patient_age".equals(item.getKeyVal())) {
                item.setConverClass("com.yihu.quota.etl.conver.AgeConvert");
            }
            tjQuotaDimensionSlaveService.save(item);
        }
        return ObjEnvelop.getSuccess("统计指标从维度关联信息更新成功！", list);
    }
}
