package com.yihu.jw.basic.agadmin.controller.report;


import com.yihu.jw.basic.report.controller.CalculatePointUtil;
import com.yihu.jw.basic.report.service.QcQuotaResultService;
import com.yihu.jw.entity.ehr.report.QcQuotaResult;
import com.yihu.jw.restmodel.ehr.report.MQcDailyReportQuotaResult;
import com.yihu.jw.restmodel.ehr.report.MQcDailyReportResultDetail;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.PageEnvelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import com.yihu.jw.util.date.DateUtil;
import io.swagger.annotations.Api;
import jxl.Workbook;
import jxl.format.CellFormat;
import jxl.write.*;
import org.apache.commons.lang3.StringUtils;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletResponse;
import java.io.OutputStream;
import java.text.DecimalFormat;
import java.util.*;

/**
 * Created by llh on 2017/5/9.
 */
@RestController
@RequestMapping("/report")
@Api( tags = {"网关-报表"})
public class ReportController extends EnvelopRestEndpoint {

    @Resource
    QcQuotaResultService qcQuotaResultService;

    CalculatePointUtil calculatePointUtil=new CalculatePointUtil();

    //所有指标统计结果查询,初始化查询
    @GetMapping("/getQcOverAllIntegrity")
    public Envelop searchQcOverAllIntegrity(String location,String startTime,String endTime){
        PageEnvelop result = new PageEnvelop();
        List<Object> quotaList;
        List<QcQuotaResult> newQuotaList = new ArrayList<QcQuotaResult>();
        Date startDate = DateUtil.formatYMDToYMDHMS(startTime);
        Date endDate = DateUtil.formatYMDToYMDHMS(endTime);
        Calendar calendar = new GregorianCalendar();
        calendar.setTime(endDate);
        calendar.add(calendar.DATE, 1);//把日期往后增加一天.整数往后推,负数往前移动
        endDate = calendar.getTime();   //日期往后推一天
        QcQuotaResult qc;
        //按区域查询统计结果集
        quotaList = qcQuotaResultService.getQuotaListByLocation(location, startDate, endDate);
        if(null!=quotaList&&quotaList.size() > 0){
            for (Object o : quotaList) {
                Object[] obj = (Object[]) o;
                //json处理
                qc = new QcQuotaResult();
                //指标Id
                String quotaId = obj[0].toString();
                qc.setQuotaId(Long.parseLong(quotaId));
                //指标名称
                qc.setQuotaName(obj[1].toString());
                int realNum = 0;
                int totalNum = 0;
                int errorNum = 0;
                int timelyNum = 0;
                String value = "";
                if (obj[2] != null && obj[3] != null && obj[4] != null && obj[5] != null) {
                    //实收数 （数据元的实收为 应收 - 错误数（标识为空的错误code））
                    totalNum = Integer.valueOf(obj[2].toString());
                    qc.setTotalNum(totalNum);
                    //应收数
                    realNum = Integer.valueOf(obj[3].toString());
                    qc.setRealNum(realNum);
                    //错误数量（该字段只针对数据元的准确性统计）
                    errorNum = Integer.valueOf(obj[4].toString());
                    qc.setErrorNum(errorNum);
                    //及时采集的档案数量
                    timelyNum = Integer.valueOf(obj[5].toString());
                    qc.setTimelyNum(timelyNum);
                    value = calculatePointUtil.calculatePoint(quotaId, realNum, totalNum, errorNum, timelyNum);
                }
                qc.setValue(value + "%");
                newQuotaList.add(qc);
            }
        }
        if(newQuotaList.size() > 0){
            result.setDetailModelList(newQuotaList);
            result.setStatus(200);
        }else {
            result.setStatus(200);
            result.setMessage("查询无数据");
            result.setTotalCount(0);
        }
        return result;
    }

    //根据机构查询所有指标统计结果,初始化查询
    @GetMapping("/getQcOverAllOrgIntegrity")
    public Envelop searchQcOverAllOrgIntegrity(String location,String orgCode,String startTime,String endTime){
        PageEnvelop result = new PageEnvelop();
        List<Object> quotaList;
        List<QcQuotaResult> newQuotaList = new ArrayList<QcQuotaResult>();
        Date startDate = DateUtil.formatYMDToYMDHMS(startTime);
        Date endDate =DateUtil.formatYMDToYMDHMS(endTime);
        Calendar   calendar   =   new   GregorianCalendar();
        calendar.setTime(endDate);
        calendar.add(calendar.DATE,1);//把日期往后增加一天.整数往后推,负数往前移动
        endDate=calendar.getTime();   //日期往后推一天
        QcQuotaResult qc=null;
        //按区域查询统计结果集
        quotaList = qcQuotaResultService.getQuotaListByOrgCode(orgCode,startDate,endDate);
        if(null!=quotaList&&quotaList.size() > 0) {
            for (int i = 0; i < quotaList.size(); i++) {
                Object[] obj = (Object[]) quotaList.get(i);
                //json处理
                qc = new QcQuotaResult();
                //指标Id
                String quotaId = obj[2].toString();
                //指标名称
                qc.setQuotaName(obj[3].toString());
                qc.setOrgName(obj[1].toString());
                qc.setOrgCode(obj[0].toString());
                qc.setQuotaId(Long.parseLong(quotaId));
                int realNum = 0;
                int totalNum = 0;
                int errorNum = 0;
                int timelyNum = 0;
                String value = "";
                if (obj[4] != null && obj[5] != null && obj[6] != null && obj[7] != null) {
                    //实收数 （数据元的实收为 应收 - 错误数（标识为空的错误code））
                    totalNum = Integer.parseInt(obj[4].toString());
                    qc.setTotalNum(totalNum);
                    //应收数
                    realNum = Integer.parseInt(obj[5].toString());
                    qc.setRealNum(realNum);
                    //错误数量（该字段只针对数据元的准确性统计）
                    errorNum = Integer.parseInt(obj[6].toString());
                    qc.setErrorNum(errorNum);
                    //及时采集的档案数量
                    timelyNum = Integer.parseInt(obj[7].toString());
                    qc.setTimelyNum(timelyNum);
                    value = calculatePointUtil.calculatePoint(quotaId, realNum, totalNum, errorNum, timelyNum);
                }
                qc.setValue(value + "%");
                newQuotaList.add(qc);
            }
        }
        if(newQuotaList.size() > 0){
            result.setDetailModelList(newQuotaList);
            result.setStatus(200);
        }else {
            result.setStatus(200);
            result.setMessage("查询无数据");
            result.setTotalCount(0);
            result.setDetailModelList(newQuotaList);
        }
        return result;
    }

    //趋势分析 - 按区域列表查询,初始化查询
    @GetMapping("/getQcQuotaIntegrity")
    public Envelop searchQcQuotaIntegrity(String location,String quotaId,String startTime,String endTime){
        PageEnvelop result = new PageEnvelop();
        List<Object> quotaList;
        List<MQcDailyReportQuotaResult> newQuotaList = new ArrayList<MQcDailyReportQuotaResult>();
        Date startDate = DateUtil.formatYMDToYMDHMS(startTime);
        Date endDate =DateUtil.formatYMDToYMDHMS(endTime);
        Calendar   calendar   =   new   GregorianCalendar();
        calendar.setTime(endDate);
        calendar.add(calendar.DATE,1);//把日期往后增加一天.整数往后推,负数往前移动
        endDate=calendar.getTime();   //日期往后推一天
        MQcDailyReportQuotaResult qc=null;
        if(!StringUtils.isEmpty(quotaId)){
            //区域整体统计结果 - 按机构及指标划分
            quotaList = qcQuotaResultService.getQuotaListByLocation(location,Long.parseLong(quotaId),startDate, endDate);
            if(null!=quotaList&&quotaList.size() > 0){
                for(int i=0;i<quotaList.size();i++){
                    Object[] obj = (Object[])quotaList.get(i);
                    //json处理
                    qc=new MQcDailyReportQuotaResult();
                    String quotaIdstr = obj[0].toString();
                    //指标名称
                    qc.setQuotaName(obj[1].toString());
                    String eventTime=obj[2].toString();
                    if(null!=eventTime&&!"".equals(eventTime)){
                        //事件时间
                        qc.setEventTime(eventTime.substring(0,4)+"年"+eventTime.substring(5,7)+"月"+eventTime.substring(8,10)+"日");
                    }
                    int realNum = 0;
                    int totalNum = 0;
                    int errorNum = 0;
                    int timelyNum = 0;
                    String value="";
                    if(obj[3] != null && obj[4] != null && obj[5] != null && obj[6] != null){
                        //实收数 （数据元的实收为 应收 - 错误数（标识为空的错误code））
                        totalNum = Integer.valueOf(obj[3].toString());
                        qc.setTotalNum(totalNum);
                        //应收数
                        realNum = Integer.valueOf(obj[4].toString());
                        qc.setRealNum(realNum);
                        //错误数量（该字段只针对数据元的准确性统计）
                        errorNum = Integer.valueOf(obj[5].toString());
                        qc.setErrorNum(errorNum);
                        //及时采集的档案数量
                        timelyNum = Integer.valueOf(obj[6].toString());
                        qc.setTimelyNum(timelyNum);
                        value=calculatePointUtil.calculatePoint(quotaIdstr, realNum, totalNum , errorNum , timelyNum);
                    }
                    DecimalFormat df = new DecimalFormat("0.00");
                    if(obj[0] != null){
                        //指标ID
                        qc.setQuotaId( Long.valueOf(obj[0].toString()));
                    }
                    qc.setValue(value+"%");
                    String an=obj[7].toString();
                    if(null!=an&&an.length()>5){
                        qc.setAn(an.substring(0,6)+'%');
                    }else{
                        qc.setAn(an+'%');
                    }
                    String mom=obj[8].toString();
                    if(null!=mom&&mom.length()>5){
                        qc.setMom(mom.substring(0,6)+'%');
                    }else{
                        qc.setMom(mom+'%');
                    }
                    newQuotaList.add(qc);
                }
                result.setDetailModelList(newQuotaList);
                result.setStatus(200);
            }else {
                result.setStatus(200);
                result.setMessage("查询无数据");
                result.setTotalCount(0);
            }
        }
        return result;
    }
    //趋势分析 -按机构列表查询,初始化查询
    @GetMapping("/getQcQuotaOrgIntegrity")
    public Envelop searchQcQuotaOrgIntegrity(String orgCode,String quotaId,String startTime,String endTime){
        PageEnvelop result = new PageEnvelop();
        List<Object> quotaList = new ArrayList<Object>();
        List<MQcDailyReportQuotaResult> newQuotaList = new ArrayList<MQcDailyReportQuotaResult>();
        Date startDate = DateUtil.formatYMDToYMDHMS(startTime);
        Date endDate =DateUtil.formatYMDToYMDHMS(endTime);
        Calendar   calendar   =   new   GregorianCalendar();
        calendar.setTime(endDate);
        calendar.add(calendar.DATE,1);//把日期往后增加一天.整数往后推,负数往前移动
        endDate=calendar.getTime();   //日期往后推一天
        MQcDailyReportQuotaResult qc = null;
        if(!StringUtils.isEmpty(quotaId)){
            quotaList = qcQuotaResultService.getQuotaListByOrg(orgCode, Long.parseLong(quotaId), startDate, endDate);
            if (null!=quotaList&&quotaList.size() > 0) {
                for (int i = 0; i < quotaList.size(); i++) {
                    Object[] obj = (Object[]) quotaList.get(i);
                    //json处理
                    qc = new MQcDailyReportQuotaResult();
                    String quotaIdstr = obj[0].toString();
                    //指标名称
                    qc.setQuotaName(obj[1].toString());
                    String eventTime=obj[2].toString();
                    if(null!=eventTime&&!"".equals(eventTime)){
                        //事件时间
                        qc.setEventTime(eventTime.substring(0,4)+"年"+eventTime.substring(5,7)+"月"+eventTime.substring(8,10)+"日");
                    }
                    int realNum = 0;
                    int totalNum = 0;
                    int errorNum = 0;
                    int timelyNum = 0;
                    String value="";
                    if (obj[3] != null && obj[4] != null && obj[5] != null && obj[6] != null) {
                        //实收数 （数据元的实收为 应收 - 错误数（标识为空的错误code））
                        totalNum = Integer.valueOf(obj[3].toString());
                        qc.setTotalNum(totalNum);
                        //应收数
                        realNum = Integer.valueOf(obj[4].toString());
                        qc.setRealNum(realNum);
                        //错误数量（该字段只针对数据元的准确性统计）
                        errorNum = Integer.valueOf(obj[5].toString());
                        qc.setErrorNum(errorNum);
                        //及时采集的档案数量
                        timelyNum = Integer.valueOf(obj[6].toString());
                        qc.setTimelyNum(timelyNum);
                        value=calculatePointUtil.calculatePoint(quotaIdstr, realNum, totalNum , errorNum , timelyNum);
                    }
                    DecimalFormat df = new DecimalFormat("0.00");
                    if (obj[0] != null) {
                        //指标ID
                        qc.setQuotaId( Long.valueOf(obj[0].toString()));
                    }
                    qc.setValue(value+ "%");
                    String an=obj[7].toString();
                    if(null!=an&&an.length()>5){
                        qc.setAn(an.substring(0,6)+'%');
                    }else{
                        qc.setAn(an+'%');
                    }
                    String mom=obj[8].toString();
                    if(null!=mom&&mom.length()>5){
                        qc.setMom(mom.substring(0,6)+'%');
                    }else{
                        qc.setMom(mom+'%');
                    }
                    newQuotaList.add(qc);
                }
                result.setDetailModelList(newQuotaList);
                result.setStatus(200);
            } else {
                result.setStatus(200);
                result.setMessage("查询无数据");
                result.setTotalCount(0);
            }
        }
        return result;
    }

    //分析明细列表
    @GetMapping("/getQcQuotaDailyIntegrity")
    public Envelop searchQcQuotaDailyIntegrity(String location,String startTime,String endTime){
        PageEnvelop result = new PageEnvelop();
        List<Object> quotaList = new ArrayList<Object>();
        List<Object> detailQuotaList = new ArrayList<Object>();
//        int firstDate=(page-1)*size;

        Date startDate = DateUtil.formatYMDToYMDHMS(startTime);
        Date endDate = DateUtil.formatYMDToYMDHMS(endTime);
        Calendar calendar = new GregorianCalendar();
        calendar.setTime(endDate);
        calendar.add(calendar.DATE, 1);//把日期往后增加一天.整数往后推,负数往前移动
        endDate = calendar.getTime();   //日期往后推一天
        Map<String, String> QcQuotaResultAnalyseMap = new TreeMap();
        //获取区域名称和事件时间
        quotaList = qcQuotaResultService.getfindQcListByLocationAndTime(location, startDate, endDate);
        if (null!=quotaList&&quotaList.size() > 0) {
            for (int i = 0; i < quotaList.size(); i++) {
                Object[] obj = (Object[]) quotaList.get(i);
                String eventTime = obj[2].toString();
                String newEventTime = "";
                if (null != eventTime && !"".equals(eventTime)) {
                    //事件时间
                    newEventTime = eventTime.substring(0,4)+"年"+eventTime.substring(5,7)+"月"+eventTime.substring(8,10)+"日";
                }
                String qcKey = obj[2].toString().substring(0, 10) + obj[3].toString();
                QcQuotaResultAnalyseMap.put(qcKey, newEventTime);
            }
        }
        //区域整体统计结果
        detailQuotaList = qcQuotaResultService.getQuotaListByLocationAndTime(location, startDate, endDate);
        Map<String, MQcDailyReportResultDetail> detailMap = new TreeMap();
        Map<String, MQcDailyReportResultDetail> detailAnMap = new TreeMap();
        Map<String, MQcDailyReportResultDetail> detailMonMap = new TreeMap();
        if(null!=detailQuotaList&&detailQuotaList.size() > 0){
            for (int i = 0; i < detailQuotaList.size(); i++) {
                Object[] obj = (Object[]) detailQuotaList.get(i);
                String qcKey = obj[0].toString().substring(0, 10) + obj[2].toString();
                if (null != QcQuotaResultAnalyseMap.get(qcKey)) {
                    String resultQuotaId = obj[3].toString();
                    //总比
                    String detailMapKey = qcKey + "总比";
                    Map<String, String> map = calculatePointUtil.reportDetailData("1", obj);
                    //,map.get("1standard")
                    detailMap = calculatePointUtil.detailValueModel(resultQuotaId, i, detailMap, detailMapKey, QcQuotaResultAnalyseMap.get(qcKey), obj[2].toString(), obj[1].toString(), "总比", map.get("1"),map.get("1standard"));

                    //同比
                    String detailAnMapKey = qcKey + "同比";
                    map = calculatePointUtil.reportDetailData("2", obj);
                    detailAnMap = calculatePointUtil.detailValueModel(resultQuotaId, i, detailAnMap, detailAnMapKey, QcQuotaResultAnalyseMap.get(qcKey), obj[2].toString(), obj[1].toString(), "同比", map.get("2"),"");

                    //环比
                    String detailMonMapKey = qcKey + "环比";
                    map = calculatePointUtil.reportDetailData("3", obj);
                    detailMonMap = calculatePointUtil.detailValueModel(resultQuotaId, i, detailMonMap, detailMonMapKey, QcQuotaResultAnalyseMap.get(qcKey), obj[2].toString(), obj[1].toString(), "环比", map.get("3"),"");

                }
            }
        }
        List<MQcDailyReportResultDetail>  objectList=new ArrayList<MQcDailyReportResultDetail>();
        for (String key : detailMap.keySet()) {
            String mapKey=key.substring(0,key.length()-2);
            objectList.add(detailMap.get(key));
            objectList.add(detailAnMap.get(mapKey+"同比"));
            objectList.add(detailMonMap.get(mapKey+"环比"));
        }
        if(objectList.size() > 0){
            result.setDetailModelList(objectList);
            result.setStatus(200);
        }else {
            result.setStatus(200);
            result.setMessage("查询无数据");
            result.setTotalCount(0);
        }

        return result;
    }

    //根据地区、期间查询各机构某项指标的值
    @GetMapping("/getQcQuotaByLocation")
    public Envelop searchQcQuotaByLocation(String location,String quotaId,String startTime,String endTime){
        PageEnvelop result = new PageEnvelop();
        List<Object> quotaList = new ArrayList<Object>();
        List<QcQuotaResult> newQuotaList = new ArrayList<QcQuotaResult>();
        Date startDate = DateUtil.formatYMDToYMDHMS(startTime);
        Date endDate =DateUtil.formatYMDToYMDHMS(endTime);
        Calendar   calendar   =   new   GregorianCalendar();
        calendar.setTime(endDate);
        calendar.add(calendar.DATE,1);//把日期往后增加一天.整数往后推,负数往前移动
        endDate=calendar.getTime();   //日期往后推一天
        QcQuotaResult qc=null;
        if(!StringUtils.isEmpty(quotaId)){
            //区域整体统计结果 - 按机构及指标划分
            //@Query("select qc.orgCode,qc.orgName,qc.quotaId,qc.quotaName,sum(qc.totalNum) as totalNum,sum(qc.realNum) as realNum,sum(qc.errorNum) as errorNum,sum(qc.timelyNum) as timelyNum
            quotaList = qcQuotaResultService.getQuotaListByLocationGBOrg(location,Long.parseLong(quotaId),startDate, endDate);
            if(null!=quotaList&&quotaList.size() > 0){
                for(int i=0;i<quotaList.size();i++){
                    Object[] obj = (Object[])quotaList.get(i);
                    //json处理
                    qc=new QcQuotaResult();
                    qc.setOrgCode(obj[0].toString());
                    qc.setOrgName(obj[1].toString());
                    String quotaIdstr = obj[2].toString();
                    //指标名称
                    qc.setQuotaName(obj[3].toString());
                    int realNum = 0;
                    int totalNum = 0;
                    int errorNum = 0;
                    int timelyNum = 0;
                    String value="";
                    if(obj[4] != null && obj[5] != null && obj[6] != null && obj[7] != null){
                        //实收数 （数据元的实收为 应收 - 错误数（标识为空的错误code））
                        totalNum = Integer.parseInt(obj[4].toString());
                        qc.setTotalNum(totalNum);
                        //应收数
                        realNum = Integer.parseInt(obj[5].toString());
                        qc.setRealNum(realNum);
                        //错误数量（该字段只针对数据元的准确性统计）
                        errorNum = Integer.parseInt(obj[6].toString());
                        qc.setErrorNum(errorNum);
                        //及时采集的档案数量
                        timelyNum = Integer.parseInt(obj[7].toString());
                        qc.setTimelyNum(timelyNum);
                        value=calculatePointUtil.calculatePoint(quotaIdstr, realNum, totalNum , errorNum , timelyNum);
                    }
                    DecimalFormat df = new DecimalFormat("0.00");
                    if(obj[2] != null){
                        //指标ID
                        qc.setQuotaId( Long.valueOf(obj[2].toString()));
                    }
                    qc.setValue(value+"%");
                    newQuotaList.add(qc);
                }
                result.setDetailModelList(newQuotaList);
                result.setStatus(200);
            }else {
                result.setStatus(200);
                result.setMessage("查询无数据");
                result.setTotalCount(0);
            }
        }
        return result;
    }

    //根据地区、期间查询分析明细列表，并导出
    @GetMapping("/exportToExcel")
    public void exportToExcel(HttpServletResponse response,String location,String startTime,String endTime){
        try {
            String fileName = "分析列表明细";
            String url="";
            String envelopStr = "";
            //设置下载
            response.setContentType("octets/stream");
            response.setHeader("Content-Disposition", "attachment; filename="
                    + new String( fileName.getBytes("gb2312"), "ISO8859-1" )+".xls");
            OutputStream os = response.getOutputStream();
            //获取导出字典
            Map<String,Object> params = new HashMap<>();
            url = "/report/getQcQuotaDailyIntegrity";
            params.put("location",location);
            params.put("startTime",startTime);
            params.put("endTime",endTime);

            List<Object> quotaList;
            List<Object> detailQuotaList;
//        int firstDate=(page-1)*size;

            Date startDate = DateUtil.formatYMDToYMDHMS(startTime);
            Date endDate = DateUtil.formatYMDToYMDHMS(endTime);
            Calendar calendar = new GregorianCalendar();
            calendar.setTime(endDate);
            calendar.add(calendar.DATE, 1);//把日期往后增加一天.整数往后推,负数往前移动
            endDate = calendar.getTime();   //日期往后推一天
            Map<String, String> QcQuotaResultAnalyseMap = new TreeMap();
            //获取区域名称和事件时间
            quotaList = qcQuotaResultService.getfindQcListByLocationAndTime(location, startDate, endDate);
            if (null!=quotaList&&quotaList.size() > 0) {
                for (Object o : quotaList) {
                    Object[] obj = (Object[]) o;
                    String eventTime = obj[2].toString();
                    String newEventTime = "";
                    if (null != eventTime && !"".equals(eventTime)) {
                        //事件时间
                        newEventTime = eventTime.substring(0, 4) + "年" + eventTime.substring(5, 7) + "月" + eventTime.substring(8, 10) + "日";
                    }
                    String qcKey = obj[2].toString().substring(0, 10) + obj[3].toString();
                    QcQuotaResultAnalyseMap.put(qcKey, newEventTime);
                }
            }
            //区域整体统计结果
            detailQuotaList = qcQuotaResultService.getQuotaListByLocationAndTime(location, startDate, endDate);
            Map<String, MQcDailyReportResultDetail> detailMap = new TreeMap();
            Map<String, MQcDailyReportResultDetail> detailAnMap = new TreeMap();
            Map<String, MQcDailyReportResultDetail> detailMonMap = new TreeMap();
            MQcDailyReportResultDetail qrd = null;
            if(null!=detailQuotaList&&detailQuotaList.size() > 0){
                for (int i = 0; i < detailQuotaList.size(); i++) {
                    Object[] obj = (Object[]) detailQuotaList.get(i);
                    String qcKey = obj[0].toString().substring(0, 10) + obj[2].toString();
                    if (null != QcQuotaResultAnalyseMap.get(qcKey)) {
                        String resultQuotaId = obj[3].toString();
                        //总比
                        String detailMapKey = qcKey + "总比";
                        Map<String, String> map = calculatePointUtil.reportDetailData("1", obj);
                        //,map.get("1standard")
                        detailMap = calculatePointUtil.detailValueModel(resultQuotaId, i, detailMap, detailMapKey, QcQuotaResultAnalyseMap.get(qcKey), obj[2].toString(), obj[1].toString(), "总比", map.get("1"),map.get("1standard"));

                        //同比
                        String detailAnMapKey = qcKey + "同比";
                        map = calculatePointUtil.reportDetailData("2", obj);
                        detailAnMap = calculatePointUtil.detailValueModel(resultQuotaId, i, detailAnMap, detailAnMapKey, QcQuotaResultAnalyseMap.get(qcKey), obj[2].toString(), obj[1].toString(), "同比", map.get("2"),"");

                        //环比
                        String detailMonMapKey = qcKey + "环比";
                        map = calculatePointUtil.reportDetailData("3", obj);
                        detailMonMap = calculatePointUtil.detailValueModel(resultQuotaId, i, detailMonMap, detailMonMapKey, QcQuotaResultAnalyseMap.get(qcKey), obj[2].toString(), obj[1].toString(), "环比", map.get("3"),"");

                    }
                }
            }
            List<MQcDailyReportResultDetail>  qcModelList=new ArrayList<MQcDailyReportResultDetail>();
            for (String key : detailMap.keySet()) {
                String mapKey=key.substring(0,key.length()-2);
                qcModelList.add(detailMap.get(key));
                qcModelList.add(detailAnMap.get(mapKey+"同比"));
                qcModelList.add(detailMonMap.get(mapKey+"环比"));
            }

            //写excel
            WritableWorkbook wwb = Workbook.createWorkbook(os);
            //创建Excel工作表 指定名称和位置
            WritableSheet ws = wwb.createSheet("质控分析明细",0);
            addStaticCell(ws);//添加固定信息，题头等
            //添加字典项信息
            WritableCellFormat wc = new WritableCellFormat();
            wc.setBorder(jxl.format.Border.ALL, jxl.format.BorderLineStyle.THIN, Colour.SKY_BLUE);//边框
            MQcDailyReportResultDetail qc=null;
            for(int i=0;i<qcModelList.size();i++) {
                int j=i+1;
                qc = qcModelList.get(i);
                //添加列表明细
                addCell(ws,0,j,qc.getEventTime(),wc);//时间
                addCell(ws,1,j,qc.getOrgName(),wc);//机构名称
                addCell(ws,2,j,qc.getScaleType(),wc);//比例名称
                addCell(ws,3,j,qc.getArIntegrity(),wc);//整体数量完整性
                addCell(ws,4,j,qc.getDsIntegrity(),wc);//数据集完整性
                addCell(ws,5,j,qc.getMdIntegrity(),wc);//数据元完整性
                addCell(ws,6,j,qc.getMdAccuracy(),wc);//准确性
                addCell(ws,7,j,qc.getArTimely(),wc);//全部及时性
                addCell(ws,8,j,qc.getHpTimely(),wc);//住院病人及时性
                addCell(ws,9,j,qc.getOpTimely(),wc);//门诊病人及时性

            }
            //写入工作表
            wwb.write();
            wwb.close();
            os.flush();
            os.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    //excel中添加固定内容
    private void addStaticCell(WritableSheet ws){
        try {
            addCell(ws,0,0,"时间");
            addCell(ws,1,0,"对象");
            addCell(ws,2,0," ");
            addCell(ws,3,0,"整体数量完整性");
            addCell(ws,4,0,"数据集完整性");
            addCell(ws,5,0,"数据元完整性");
            addCell(ws,6,0,"准确性");
            addCell(ws,7,0,"全部及时性");
            addCell(ws,8,0,"住院病人及时性");
            addCell(ws,9,0,"门诊病人及时性");

        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    //添加单元格内容
    private void addCell(WritableSheet ws,int column,int row,String data){
        try {
            Label label = new Label(column,row,data);
            ws.addCell(label);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
    //添加单元格内容带样式
    private void addCell(WritableSheet ws,int column,int row,String data,CellFormat cellFormat){
        try {
            Label label = new Label(column,row,data,cellFormat);
            ws.addCell(label);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }



    /**
     * 档案入库状况数据
     * @param model
     * @return
     */
//    @RequestMapping("rukuData")
//    public Object rukuData(Model model,String orgCode,String startDate,String endDate) {
//        String url = "/report/qcDailyStatisticsStorageByDate";
//        String resultStr = "";
//        Map<String, Object> params = new HashMap<>();
//        Envelop result = new Envelop();
//        try {
//            params.put("orgCode",orgCode);
//            params.put("startDate",startDate);
//            params.put("endDate",endDate);
//            resultStr = HttpClientUtil.doGet(comUrl + url, params, username, password);
//            ObjectMapper mapper = new ObjectMapper();
//            Envelop envelop = mapper.readValue(resultStr, Envelop.class);
//            if (!envelop.isSuccessFlg()) {
//                result.setSuccessFlg(true);
//                result.setDetailModelList(envelop.getDetailModelList());
//                result.setObj(envelop.getObj());
//                return result;
//            } else {
//                result.setSuccessFlg(false);
//                return result;
//            }
//        } catch (Exception e) {
//            e.printStackTrace();
//            return failed(ERR_SYSTEM_DES);
//        }
//    }


}
