package com.yihu.jw.basic.agadmin.controller.resource;

import com.yihu.jw.basic.resource.service.RsDictionaryService;
import com.yihu.jw.entity.ehr.resource.RsDictionary;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.PageEnvelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.*;

/**
 * @author lincl
 * @version 1.0
 * @created 2016/5/20
 */
@RestController("resource-dict")
@RequestMapping("/resource/dict")
@Api( tags = {"网关-资源字典"})
public class DictController extends EnvelopRestEndpoint {

    @Autowired
    private RsDictionaryService dictionaryService;

    final String parentFile = "dict";
    Map<String, Integer> dictExcel;
    Map<String, Integer> dictEntryExcel;
    Map<Integer, String> headerMap ;

    public DictController() {
        dictExcel = new HashMap<>();
        dictExcel.put("code", 0);
        dictExcel.put("name", 1);
        dictExcel.put("description", 2);

        dictEntryExcel = new HashMap<>();
        dictEntryExcel.put("code", 3);
        dictEntryExcel.put("name", 4);
        dictEntryExcel.put("description", 5);

        headerMap = new HashMap<>();
        headerMap.put(0, "代码");
        headerMap.put(1, "名称");
        headerMap.put(2, "说明");
    }


    @RequestMapping("/searchCombo")
    public Envelop comboSearch(String searchParm, int page, int rows){
        try{
            String filters =  "code?"+searchParm+" g1;name?"+searchParm+";";
            List<RsDictionary> dictionaries = dictionaryService.search(null, filters, null, page, rows);
            return PageEnvelop.getSuccessListWithPage("查询成功",dictionaries,page,rows,dictionaryService.getCount(filters));
        } catch (Exception e) {
            e.printStackTrace();
            return failed("查询失败");
        }
    }

}
