package com.yihu.jw.basic.agadmin.controller.resource;

import com.yihu.jw.basic.resource.dao.RsResourceMetadataDao;
import com.yihu.jw.basic.resource.service.RsMetadataService;
import com.yihu.jw.basic.resource.service.RsResourceMetadataService;
import com.yihu.jw.entity.ehr.id.BizObject;
import com.yihu.jw.entity.ehr.resource.RsMetadata;
import com.yihu.jw.entity.ehr.resource.RsResourceMetadata;
import com.yihu.jw.restmodel.ehr.resource.MRsMetadata;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.ListEnvelop;
import com.yihu.jw.restmodel.web.PageEnvelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.util.StringUtils;
import org.springframework.web.bind.annotation.*;

import java.util.*;

/**
 * 资源配置服务控制器
 * Created by wq on 2016/5/23.
 */
@RestController
@RequestMapping("/resourceConfiguration")
@Api(tags = {"网关-资源配置服务控制器","网关-资源配置服务控制器"})
public class ResourceConfigurationController extends EnvelopRestEndpoint {

    @Autowired
    private RsResourceMetadataService rsMetadataService;
    @Autowired
    private RsResourceMetadataDao rsMetadataDao;
    @Autowired
    private RsMetadataService metadataService;

    @GetMapping("searchResourceConfiguration")
    public Object searchResourceConfiguration(String searchNm, int page, int rows) {
        Map<String, Object> params = new HashMap<>();
        String metaDataUrl = "/resources/metadata";
        params.put("filters", "");
        String filters ="valid=1";
        if (!StringUtils.isEmpty(searchNm)){
            filters += ";name?" + searchNm + " g1;ehrId?" + searchNm + " g1";
        }
        params.put("filters",filters);
        params.put("page", page);
        params.put("size", rows);
        params.put("fields", "");
        params.put("sorts", "");
        try {
            long total = 0;
            List<MRsMetadata> metaList;

            //过滤条件为空
            if(StringUtils.isEmpty(filters))
            {
                Page<RsMetadata> metadataPage = metadataService.getMetadata(null,reducePage(page),rows);
                total = metadataPage.getTotalElements();
                return PageEnvelop.getSuccessListWithPage("查询成功",metadataPage.toList(),page,rows,total);
            }
            else
            {
                List<RsMetadata> metadata = metadataService.search(null,filters,null,page,rows);
                total = metadataService.getCount(filters);
                return PageEnvelop.getSuccessListWithPage("查询成功",metadata,page,rows,total);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return failed("查询失败");

    }

    @GetMapping("searchSelResourceConfiguration")
    public Object searchSelResourceConfiguration(String searchNm, String resourcesId, int page, int rows) {
        Map<String, Object> params = new HashMap<>();
        String ResourceMetadataUrl = "/resources/rs_metadata";
        String selResourceMetadataListUrl = "/resources/" + resourcesId + "/metadata_list";
        String resultStr = "";
        try {
            if ("selAll".equals(searchNm)) {
                List<RsResourceMetadata> metadataList = rsMetadataService.getRsMetadataByResourcesId(resourcesId);
                return ListEnvelop.getSuccess("查询成功",metadataList);
            } else {
                String filters = "";
                if (!StringUtils.isEmpty(searchNm)) {
                    filters = "name?" + searchNm + " g1;id?" + searchNm + " g1";
                }
                if (!StringUtils.isEmpty(resourcesId)) {
                    params.put("resources_id", resourcesId);
                }
                params.put("page", page);
                params.put("size", rows);
                long total = 0;
                //过滤条件为空
                List<RsResourceMetadata> rsMetadatas;
                if (StringUtils.isEmpty(resourcesId)) {
                    Page<RsResourceMetadata> dimensions = rsMetadataService.getResourceMetadata(null, reducePage(page), rows);
                    total = dimensions.getTotalElements();
                    rsMetadatas = dimensions.toList();
                } else {
                    rsMetadatas = rsMetadataService.search(null, "resourcesId=" + resourcesId, null, page, rows);
                    total = rsMetadataService.getCount("resourcesId=" + resourcesId);
                }
                List<RsResourceMetadata> rsResourceMetadataModels = getRsMetadata(rsMetadatas,filters,page,rows);
                return PageEnvelop.getSuccessListWithPage("查询成功",rsResourceMetadataModels,page,rows,total);
            }
        } catch (Exception e) {
            e.printStackTrace();
            return failed("查询失败");
        }
    }

    public List<RsResourceMetadata> getRsMetadata(List<RsResourceMetadata> rsMetadatas,String filters,int page,int size) throws Exception{
        String fs = null;
        for (RsResourceMetadata rsMetadataModel : rsMetadatas){
            fs = "ehrId=" + rsMetadataModel.getMetadataId()+" g2;"+filters;
            List<RsMetadata> metadata = metadataService.search("",fs,"",page,size);
            if (metadata.size()>0) {
                rsMetadataModel.setName(metadata.get(0).getName());
                rsMetadataModel.setColumnType(metadata.get(0).getColumnType());
                rsMetadataModel.setStdCode(metadata.get(0).getEhrId());
            }
        }
        return rsMetadatas;
    }

    @PostMapping("/saveResourceConfiguration")
    public Envelop saveResourceConfiguration(String addRowDatas, String delRowDatas) {
        String resultStr = "";
        String metaDataUrl = "/resources/rs_metadata/batch";
        try {
            if (!StringUtils.isEmpty(delRowDatas)) {
                //执行删除操作
                String ids[] = delRowDatas.split(",");
                for (String id:ids){
                    rsMetadataDao.deleteById(id);
                }
            }
            if (!StringUtils.isEmpty(addRowDatas)) {
                //执行新增操作
                RsResourceMetadata[] rsMetadata = toEntity(addRowDatas, RsResourceMetadata[].class);
                for (RsResourceMetadata metadata : rsMetadata) {
                    metadata.setId(getObjectId(BizObject.ResourceMetadata));
                }
                List<RsResourceMetadata> metadataList = rsMetadataService.saveMetadataBatch(rsMetadata);
            }
            return success("超做成功");
        } catch (Exception e) {
            e.printStackTrace();
        }
        return failed("操作失败");
    }
}