package com.yihu.jw.basic.agadmin.controller.resource;

import com.yihu.jw.constants.ServiceApi;

import com.yihu.jw.basic.resource.dao.RsResourceDefaultParamDao;
import com.yihu.jw.basic.resource.service.RsResourceDefaultParamService;
import com.yihu.jw.entity.ehr.resource.RsResourceDefaultParam;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.ListEnvelop;
import com.yihu.jw.restmodel.web.ObjEnvelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import io.swagger.annotations.Api;
import org.apache.commons.lang.StringUtils;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by yww on 2016/7/20.
 */
@RestController
@RequestMapping("/resource/rsDefaultParam")
@Api(tags = {"网关-资源默认参数"})
public class ResourceDefaultParamController extends EnvelopRestEndpoint {

    @Resource
    private RsResourceDefaultParamService resourceDefaultParamService;
    @Resource
    private RsResourceDefaultParamDao resourceDefaultParamDao;

    @GetMapping("/infoInitial")
    public Envelop rsDefaultParamInfoInitial(String id,String resourcesId,String resourcesCode,String mode,String rowIndex){
        try {
            if(StringUtils.equals(mode,"new")){
                return success();
            }
            String url = "/resources/param/"+id;
            RsResourceDefaultParam resourceDefaultParam = resourceDefaultParamService.findById(id);
            return ObjEnvelop.getSuccess("",resourceDefaultParam);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return failed("查询失败");
    }

    //新增、修改
    @PostMapping("/update")
    public Envelop addOrUpdate(String dataJson,String mode){
        if(StringUtils.isEmpty(mode)){
            return failed("操作类别不能为空！");
        }
        if(StringUtils.isEmpty(dataJson)){
            return failed("空数据！");
        }
        try{
            RsResourceDefaultParam model = toEntity(dataJson, RsResourceDefaultParam.class);
            if(StringUtils.isEmpty(model.getResourcesId())){
                return failed("资源id不能为空！");
            }
            if(StringUtils.isEmpty(model.getResourcesCode())){
                return failed("资源编码不能为空！");
            }
            if(StringUtils.isEmpty(model.getParamKey())){
                return failed("默认参数名不能为空！");
            }
            if(StringUtils.isEmpty(model.getParamValue())){
                return failed("默认参数值不能为空！");
            }
            String url = ServiceApi.Resources.Param;
            Map<String,Object> params = new HashMap<>();
            params.put("json_data",dataJson);
            if(StringUtils.equalsIgnoreCase(mode,"new")){
                RsResourceDefaultParam resourceDefaultParamNew = resourceDefaultParamService.save(model);
                return ObjEnvelop.getSuccess("新增成功",resourceDefaultParamNew);
            }
            RsResourceDefaultParam resourceDefaultParamNew = resourceDefaultParamService.save(model);
            return ObjEnvelop.getSuccess("操作成功",resourceDefaultParamNew);
        }catch (Exception ex){
            ex.printStackTrace();
            return failed(ERR_SYSTEM_DES);
        }
    }
    //删除
    @PostMapping("/delete")
    public Envelop delete(String id){
        try{
            if(id == null){
                return failed("id不能为空！");
            }
            resourceDefaultParamDao.deleteById(id);
            return success();
        }catch (Exception ex){
            ex.printStackTrace();
            return failed(ERR_SYSTEM_DES);
        }
    }
    //查看不分页
    @GetMapping("/searchList")
    public Envelop searchList(String resourcesId){
        try{
            if(StringUtils.isEmpty(resourcesId)){
                return failed("资源id不能为空！");
            }
            String filters = "resourcesId="+resourcesId;
            String url = ServiceApi.Resources.ParamsNoPage;
            List<RsResourceDefaultParam> rsDefaultParams = resourceDefaultParamService.search(filters);
            return ListEnvelop.getSuccess("查询成功",rsDefaultParams);
        }catch (Exception ex){
            ex.printStackTrace();
            return failed(ERR_SYSTEM_DES);
        }
    }

    //参数值唯一性验证
    @GetMapping("/isKeyValueExistence")
    public Envelop isExistenceRsParamKeyValue(String resourcesId,String paramKey,String paramValue){
        try{
            String url = ServiceApi.Resources.ParamKeyValueExistence;
            Map<String,Object> params = new HashMap<>();
            params.put("resources_id",resourcesId);
            params.put("param_key",paramKey);
            params.put("param_value",paramValue);
            String[] fields = {"resourcesId","paramKey","paramValue"};
            String[] values = {resourcesId,paramKey,paramValue};
            List<RsResourceDefaultParam> list = resourceDefaultParamService.findByFields(fields, values);
            if(list != null && list.size()>0){
                return ObjEnvelop.getSuccess("查询成功",true);
            }
            return ObjEnvelop.getSuccess("查询成功",false);
        }catch (Exception ex){
            ex.printStackTrace();
            return failed(ERR_SYSTEM_DES);
        }
    }
}
