package com.yihu.jw.basic.agadmin.controller.resource;

import com.yihu.jw.basic.resource.dao.RsInterfaceDao;
import com.yihu.jw.basic.resource.service.RsInterfaceService;
import com.yihu.jw.entity.ehr.id.BizObject;
import com.yihu.jw.entity.ehr.resource.RsInterface;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.ObjEnvelop;
import com.yihu.jw.restmodel.web.PageEnvelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.StringUtils;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by yww on 2016/5/24.
 */
@RestController
@Api( tags = {"网关-资源接口"})
@RequestMapping("/resource/resourceInterface")
public class ResourceInterfaceController extends EnvelopRestEndpoint {

    @Autowired
    private RsInterfaceService interfaceService;
    @Autowired
    private RsInterfaceDao rsInterfaceDao;

    @GetMapping("/infoInitial")
    public Envelop resourceInterfaceInfoInitial(String id,String mode){
        Envelop envelop = new Envelop();
        String envelopStr = "";
        try{
            if (!StringUtils.isEmpty(id)) {
                RsInterface rsInterface = interfaceService.getOne(id);
                return ObjEnvelop.getSuccess("查询成功",rsInterface);
            }
            return success();
        }catch (Exception e){
            e.printStackTrace();
            return failed("失败");
        }
    }

    @GetMapping("/searchRsInterfaces")
    public Envelop searchRsInterfaces(String searchNm, int page, int rows) {
        Envelop envelop = new Envelop();
        String envelopStr = "";
        String filters = "";
        try{
            if(!StringUtils.isEmpty(searchNm)){
                filters += "name?"+searchNm+" g1;resourceInterface?"+searchNm+" g1;";
            }
            List<RsInterface> interfaces = interfaceService.search(null, filters, null, page, rows);
            return PageEnvelop.getSuccessListWithPage("查询成功",interfaces,page,rows,interfaceService.getCount(filters));
        } catch (Exception ex){
            ex.printStackTrace();
            return failed(ERR_SYSTEM_DES);
        }
    }

    @GetMapping("/getResourceInterface")
    public Envelop getResourceInterface(String id){
        Envelop envelop = new Envelop();
        try{
            RsInterface rsInterface = interfaceService.getOne(id);
            return ObjEnvelop.getSuccess("查询成功",rsInterface);
        } catch (Exception ex){
            ex.printStackTrace();
            return failed(ERR_SYSTEM_DES);
        }
    }

    @RequestMapping("/findByResourceInterface")
    public Envelop findByResourceInterface(String resourceInterface){
        Envelop envelop = new Envelop();
        try{
            String url = "/resources/interface";
            Map<String,Object> params = new HashMap<>();
            params.put("resource_interface",resourceInterface);
            RsInterface  rsInterface =  interfaceService.findByResourceInterface(resourceInterface);
            return ObjEnvelop.getSuccess("查询成功",rsInterface);
        } catch (Exception ex){
            ex.printStackTrace();
            return failed(ERR_SYSTEM_DES);
        }
    }
    //新增、修改
    @PostMapping("/update")
    public Envelop updateResourceInterface(String dataJson,String mode){
        Envelop envelop = new Envelop();
        String url = "/resources/interfaces";
        try{
            RsInterface rsInterface = toEntity(dataJson, RsInterface.class);
            if(StringUtils.isEmpty(rsInterface.getName())){
                return failed("资源接口名称不能为空");
            }
            if("new".equals(mode)){
                rsInterface.setId(getObjectId(BizObject.RsInterface));
                interfaceService.save(rsInterface);
                return ObjEnvelop.getSuccess("新增成功",rsInterface);
            } else if("modify".equals(mode)){
                RsInterface updateModel = interfaceService.getOne(rsInterface.getId());
                if (updateModel==null){
                    return failed("原资源接口信息获取失败");
                }
                updateModel.setName(rsInterface.getName());
                updateModel.setResourceInterface(rsInterface.getResourceInterface());
                updateModel.setParamDescription(rsInterface.getParamDescription());
                updateModel.setResultDescription(rsInterface.getResultDescription());
                updateModel.setDescription(rsInterface.getDescription());
                interfaceService.save(updateModel);
                return ObjEnvelop.getSuccess("新增成功",updateModel);
            }
        }catch(Exception ex){
            ex.printStackTrace();
            return failed(ERR_SYSTEM_DES);
        }
        return envelop;
    }

    //删除
    @PostMapping("/delete")
    public Envelop deleteRsInterface(String id){
        Envelop envelop = new Envelop();
        try{
            rsInterfaceDao.deleteById(id);
            return success();
        } catch(Exception ex){
            ex.printStackTrace();
            return failed(ERR_SYSTEM_DES);
        }
    }

    @GetMapping("/isNameExist")
    public Envelop isNameExist(String name){
        Envelop envelop = new Envelop();
        try{
            String url = "/resources/existence/name";
            return ObjEnvelop.getSuccess("查询成功",interfaceService.isNameExist(name));
        } catch (Exception ex){
            ex.printStackTrace();
            return failed(ERR_SYSTEM_DES);
        }
    }
}
