package com.yihu.jw.basic.agadmin.controller.resource;

import com.yihu.jw.basic.resource.service.RsReportService;
import com.yihu.jw.entity.ehr.resource.RsReport;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.PageEnvelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * Created by janseny on 2017/11/8.
 */

@RestController
@RequestMapping("/resource/monitorTypeReport")
@Api(tags = {"网关-监控报表"})
public class ResourceMonitorTypeReportController extends EnvelopRestEndpoint {

    @Autowired
    private RsReportService rsReportService;

    /**
     * 报表分页查询
     */
    @GetMapping("/search")
    public Envelop search(String searchNm, int page, int rows) {
        StringBuffer filters = new StringBuffer();

        if (!org.apache.commons.lang3.StringUtils.isEmpty(searchNm)) {
            filters.append("code?" + searchNm + " g1;name?" + searchNm + " g1;");
        }

        try {
            List<RsReport> rsReports = rsReportService.search(null, filters.toString(), null, page, rows);
            return PageEnvelop.getSuccessListWithPage("查询成功",rsReports,page,rows,rsReportService.getCount(filters.toString()));
        } catch (Exception e) {
            e.printStackTrace();
            return failed(ERR_SYSTEM_DES);
        }
    }

    //监测类型添加报表
//    @RequestMapping("/reportCreate")
//    public Envelop reportCreate(String reportId,String monitorTypeId) {
//        if(StringUtils.isEmpty(reportId)){
//            return failed("报表不能为空！");
//        }
//        if(StringUtils.isEmpty(monitorTypeId)){
//            return failed("监测类型id不能为空！");
//        }
//        RsMonitorTypeReportModel model = new RsMonitorTypeReportModel();
//        model.setReportId(Integer.valueOf(reportId));
//        model.setRsReoportMonitorTypeId(Integer.valueOf(monitorTypeId));
//        try{
//            String url = ServiceApi.Resources.RsMonitorTypeReport;
//            Map<String,Object> params = new HashMap<>();
//            params.put("data_json",objectMapper.writeValueAsString(model));
//            String envelopStr = HttpClientUtil.doPost(comUrl+url,params,username,password);
//            return envelopStr;
//        }catch (Exception ex){
//            ex.printStackTrace();
//            return failed(ERR_SYSTEM_DES);
//        }
//    }
//
//    //监测类型删除报表
//    @RequestMapping("/reportDelete")
//    public Envelop reportDelete(String reportId,String monitorTypeId) {
//        if(org.apache.commons.lang.StringUtils.isEmpty(reportId)){
//            return failed("报表不能为空！");
//        }
//        if(org.apache.commons.lang.StringUtils.isEmpty(monitorTypeId)){
//            return failed("监测类型id不能为空！");
//        }
//        try{
//            Map<String,Object> params = new HashMap<>();
//            params.put("reportId",reportId);
//            params.put("monitorTypeId",monitorTypeId);
//            String url = ServiceApi.Resources.RsMonitorTypeReport;
//            String envelopStr = HttpClientUtil.doDelete(comUrl+url,params,username,password);
//            return envelopStr;
//        }catch (Exception ex){
//            ex.printStackTrace();
//            return failed(ERR_SYSTEM_DES);
//        }
//    }

//    //监测类型配置报表列表查询
//    @GetMapping("/monitorTypeReportList")
//    public Envelop getMonitorTypeReportList(String searchNm,int page,int rows){
//        if(org.apache.commons.lang.StringUtils.isEmpty(searchNm)){
//            return failed("监测类型id不能为空！");
//        }
//        try{
//            String url = ServiceApi.Resources.RsMonitorTypeReports;
//            Map<String,Object> params = new HashMap<>();
//            params.put("fields","");
//            params.put("filters","rsReoportMonitorTypeId="+searchNm);
//            params.put("page",page);
//            params.put("size",rows);
//            String envelopStr = HttpClientUtil.doGet(comUrl+url,params,username,password);
//            return envelopStr;
//        }catch (Exception ex){
//            ex.printStackTrace();
//            return failed(ERR_SYSTEM_DES);
//        }
//    }
//
//    //获取监测类型配置的所有 报表
//    @GetMapping("/monitorTypeReportByMonitorTypeId")
//    public Envelop getMonitorTypeReportByMonitorTypeId(String monitorTypeId){
//        if(org.apache.commons.lang.StringUtils.isEmpty(monitorTypeId)){
//            return failed("监测类型id不能为空！");
//        }
//        try{
//            String url = ServiceApi.Resources.RsMonitorTypeReportsNoPage;
//            Map<String,Object> params = new HashMap<>();
//            params.put("filters","rsReoportMonitorTypeId="+monitorTypeId);
//            String envelopStr = HttpClientUtil.doGet(comUrl+url,params,username,password);
//            return envelopStr;
//        }catch (Exception ex){
//            ex.printStackTrace();
//            return failed(ERR_SYSTEM_DES);
//        }
//    }

}
