package com.yihu.jw.basic.agadmin.controller.resource;


import com.yihu.jw.basic.agadmin.service.ResourceBrowseControllerService;
import com.yihu.jw.basic.dict.service.SystemDictEntryService;
import com.yihu.jw.entity.ehr.dict.SystemDictEntry;
import com.yihu.jw.restmodel.ehr.resource.MRsColumnsModel;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.ListEnvelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import io.swagger.annotations.Api;
import jxl.Workbook;
import jxl.write.Label;
import jxl.write.WritableSheet;
import jxl.write.WritableWorkbook;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.util.StringUtils;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.io.File;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by wq on 2016/6/7.
 */

@RestController
@RequestMapping("/resourceView")
@Api(tags = {"网关-资源视图"})
public class ResourceViewController extends EnvelopRestEndpoint {

    @Autowired
    private ResourceBrowseControllerService resourceBrowseControllerService;
    @Autowired
    private SystemDictEntryService systemDictEntryService;

    @GetMapping("/searchResource")
    public Envelop searchResource(String ids) {
        return resourceBrowseControllerService.getCategories(ids);
    }


    /**
     * 动态获取GRID的列名
     *
     * @param dictId
     * @return
     */
    @GetMapping("/getGridCloumnNames")
    public Envelop getGridCloumnNames(String dictId) {
        Envelop envelop = new Envelop();
        Map<String, Object> params = new HashMap<>();
        String url = "/resources/ResourceBrowses/getResourceMetadata";
        String resultStr = "";
        params.put("resourcesCode", dictId);
        try {
            List<MRsColumnsModel> rsBrowseModelList = resourceBrowseControllerService.getResourceMetadata(dictId,"");
            return ListEnvelop.getSuccess("查询成功",rsBrowseModelList);
        } catch (Exception e) {
            e.printStackTrace();
            return failed("查询失败");
        }
    }

    @GetMapping("/searchDictEntryList")
    public Envelop getDictEntryList(String dictId) {
        List<MRsColumnsModel> rsBrowseModelList = new ArrayList<>();
        try {
            if (!StringUtils.isEmpty(dictId)) {
                if ("34".equals(dictId)) {
                    List<SystemDictEntry> systemDictEntryList = systemDictEntryService.search("","dictId=" + dictId,"",1,500);
                    return ListEnvelop.getSuccess("查询成功",systemDictEntryList);
                }else if("andOr".equals(dictId)){
                    rsBrowseModelList.add(new MRsColumnsModel("AND", "并且"));
                    rsBrowseModelList.add(new MRsColumnsModel("OR", "或者"));
                    return ListEnvelop.getSuccess("查询成功",rsBrowseModelList);
                }else {
//                    url = "/resources/ResourceBrowses";
//                    params.put("category_id", dictId);
//
//                    resultStr = HttpClientUtil.doGet(comUrl + url, params, username, password);
//                    envelop = toModel(resultStr, Envelop.class);
//                    break;
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return failed("查询失败");
    }

    //数据导出方法
//    @RequestMapping("outExcel")
//    public Envelop outExcel(String rowData, String resourceCategoryName) {
//
//        Envelop envelop = new Envelop();
//        resourceCategoryName = resourceCategoryName.replaceAll("/", "") + "_" + System.currentTimeMillis();
//        //标题行
//        List<Object> dataAllList = toModel(rowData, List.class);
//
//        List<String> titleList = new ArrayList<>();
//        List<List> dataList = new ArrayList<>();
//        List<String> rowContext = new ArrayList<>();
//
//        Map<String, String> map = new HashMap<>();
//
//        for (int i = 0; i < dataAllList.size(); i++) {
//            map = toModel(toJson(dataAllList.get(i)), Map.class);
//            for (String key : map.keySet()) {
//
//                if (!titleList.contains(key)) {
//                    titleList.add(key);
//                }
//                rowContext.add(String.valueOf(map.get(key)));
//            }
//            dataList.add(rowContext);
//            rowContext = new ArrayList<>();
//        }
//
//        try {
//            //resourceCategoryName.xls为要新建的文件名
//            WritableWorkbook book = Workbook.createWorkbook(new File("F:\\excel\\" + resourceCategoryName + ".xls"));
//            //生成名为“resourceCategoryName”的工作表，参数0表示这是第一页
//            WritableSheet sheet = book.createSheet(resourceCategoryName, 0);
//            //title
//            for (int i = 0; i < titleList.size(); i++) {
//                sheet.addCell(new Label(i, 0, titleList.get(i)));
//            }
//            //context
//            for (int i = 0; i < dataList.size(); i++) {
//                for (int j = 0; j < dataList.get(i).size(); j++) {
//                    sheet.addCell(new Label(j, i + 1, String.valueOf(dataList.get(i).get(j))));
//                }
//            }
//            book.write();
//            book.close();
//        } catch (Exception e) {
//            envelop.setSuccessFlg(false);
//            envelop.setErrorMsg("数据导出失败");
//        }
//        envelop.setSuccessFlg(true);
//        return envelop;
//    }
}
