package com.yihu.jw.basic.agadmin.controller.resource;

import com.yihu.jw.constants.ServiceApi;

import com.yihu.jw.basic.resource.service.RsAdapterSchemeService;
import com.yihu.jw.entity.ehr.id.BizObject;
import com.yihu.jw.entity.ehr.resource.RsAdapterScheme;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.ObjEnvelop;
import com.yihu.jw.restmodel.web.PageEnvelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import io.swagger.annotations.Api;
import org.apache.commons.lang3.StringUtils;
import org.springframework.data.domain.Page;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by linz on 2016/5/23.
 */

@RestController
@RequestMapping("/schemeAdapt")
@Api( tags = {"网关-资源适配管理"})
public class SchemeAdaptController extends EnvelopRestEndpoint {

    @Resource
    private RsAdapterSchemeService schemaService;

    public static final String SCHEME_PLATFORM="1";//平台类型
    public static final String SCHEME_TP="2";//第三方


    @GetMapping("/list")
    public Object searchAdaptSchemes(String searchNm, String type, int page, int rows){
        StringBuffer stringBuffer = new StringBuffer();
        if (!StringUtils.isEmpty(searchNm)) {
            stringBuffer.append("code?").append(searchNm).append(" g1;").append("name?").append(searchNm).append(" g1;");
        }
        if (!StringUtils.isEmpty(type)) {
            stringBuffer.append("type=").append(type).append(";");
        }
        String filters = stringBuffer.toString();
        if(filters.lastIndexOf(";")>0){
            filters = filters.substring(0,filters.lastIndexOf(";"));
        }
        String url = ServiceApi.Adaptions.Schemes;
        try {
            long total = 0;
            //过滤条件为空
            List<RsAdapterScheme> metaList;
            if (org.springframework.util.StringUtils.isEmpty(filters)) {
                Page<RsAdapterScheme> metadataPage = schemaService.getAdapterScheme(null, reducePage(page), rows);
                total = metadataPage.getTotalElements();
                metaList = metadataPage.toList();
            } else {
                metaList = schemaService.search(null, filters, null, page, rows);
                total = schemaService.getCount(filters);
            }
            return PageEnvelop.getSuccessListWithPage("查询成功",metaList,page,rows,total);
        } catch (Exception e){
            e.printStackTrace();
            return failed("内部服务请求失败");
        }
    }
    /**
     * 资源适配：新增、修改窗口
     */
    @GetMapping("gotoModify")
    public Object adapterSchemeTemplate(String id,String mode) {
        Map<String, Object> params = new HashMap<>();
        params.put("id",id);
        try {
            if(mode.equals("view") || mode.equals("modify")) {
                String url = "/adaptions/schemas/"+id;
                ObjEnvelop.getSuccess("",schemaService.getAdapterSchemeById(id));
            }
            return success();
        } catch (Exception e) {
            e.printStackTrace();
            return failed("内部服务请求失败");
        }
    }

    /**
     * 资源适配：新增、修改窗口
     */
    @PostMapping("save")
    public Envelop updateSchemeAdpat(String dataJson) {
        try{
            RsAdapterScheme mRsAdapterSchema = toEntity(dataJson, RsAdapterScheme.class);
            if (StringUtils.isEmpty(mRsAdapterSchema.getType())) {
                return failed("方案类别不能为空");
            }
            if (StringUtils.isEmpty(mRsAdapterSchema.getName())) {
                return failed("方案名称不能为空");
            }
            if (StringUtils.isEmpty(mRsAdapterSchema.getCode())) {
                return failed("方案编码不能为空");
            }
            if (StringUtils.isEmpty(mRsAdapterSchema.getAdapterVersion())&& SCHEME_PLATFORM.equals(mRsAdapterSchema.getType())) {
                return failed("版本号不能为空");
            }
            if(StringUtils.isEmpty(mRsAdapterSchema.getAdapterVersion())&& SCHEME_TP.equals(mRsAdapterSchema.getType())){
                return failed("标准名称不能为空！");
            }
            String url = ServiceApi.Adaptions.Schemes;
            if(StringUtils.isNotBlank(mRsAdapterSchema.getId())){
                schemaService.save(mRsAdapterSchema);
            }else{
                mRsAdapterSchema.setId(getObjectId(BizObject.RsAdapterSchema));
                schemaService.saveAdapterScheme(mRsAdapterSchema);
            }
            return ObjEnvelop.getSuccess("操作成功",mRsAdapterSchema);
        } catch(Exception ex){
            ex.printStackTrace();
            return failed("内部服务请求失败");
        }
    }

    @PostMapping("delete")
    public Envelop deleteScheme(String schemeId) {
        String url = "/adaptions/schemas/"+schemeId;
        try{
            schemaService.deleteById(schemeId);
            return success();
        } catch(Exception ex){
            ex.printStackTrace();
            return failed("内部服务请求失败");
        }
    }
}
