package com.yihu.jw.basic.agadmin.controller.resource;


import com.yihu.jw.constants.ServiceApi;

import com.yihu.jw.basic.resource.service.RsAdapterMetadataService;
import com.yihu.jw.basic.resource.service.RsAdapterSchemeService;
import com.yihu.jw.entity.ehr.resource.RsAdapterMetadata;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.ObjEnvelop;
import com.yihu.jw.restmodel.web.PageEnvelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import io.swagger.annotations.Api;
import org.apache.commons.lang3.StringUtils;
import org.springframework.data.domain.Page;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 资源适配管理方案适配管理
 * Created by linz on 2015/11/1.
 */

@RequestMapping("/schemeAdaptDataSet")
@RestController
@Api( tags = {"网关-资源适配管理方案适配管理"})
public class SchemeAdaptDataSetController extends EnvelopRestEndpoint {

    @Resource
    private RsAdapterSchemeService schemaService;
    @Resource
    private RsAdapterMetadataService metadataService;

    @GetMapping("/initial")
    public Envelop gotoList(String dataModel,String version){
        String url = "/adaptions/schemas/"+dataModel;
        try {
            return ObjEnvelop.getSuccess("查询成功",schemaService.getAdapterSchemeById(dataModel));
        }catch (Exception e){
            e.printStackTrace();
            return failed("查询失败");
        }
    }

    @GetMapping("/metaDataList")
    public Envelop searchmetaData(String adapterSchemeId, String code, int page, int rows) {
        StringBuffer stringBuffer = new StringBuffer();
        if(StringUtils.isNotBlank(adapterSchemeId)){
            stringBuffer.append("schemeId=").append(adapterSchemeId).append(";");
        }else{
            return failed("请选择资源适配方案");
        }
        if(StringUtils.isNotBlank(code)){
            stringBuffer.append("srcDatasetCode=").append(code).append(";");
        }
        String filters = stringBuffer.toString();
        if(filters.lastIndexOf(";")>0){
            filters = filters.substring(0,filters.lastIndexOf(";"));
        }

        try {
            long total;
            List<RsAdapterMetadata> metaList;
            //过滤条件为空
            if (StringUtils.isEmpty(filters)) {
                Page<RsAdapterMetadata> metadataPage = metadataService.getAdapterMetadata(null, reducePage(page), rows);
                total = metadataPage.getTotalElements();
                metaList = metadataPage.toList();
            } else {
                metaList = metadataService.search(null, filters, null, page, rows);
                total = metadataService.getCount(filters);
            }
            return PageEnvelop.getSuccessListWithPage("查询成功",metaList,page,rows,total);
        } catch (Exception e) {
            e.printStackTrace();
            return failed(ERR_SYSTEM_DES);
        }
    }


    /**
     * 资源适配：新增、修改窗口
     */
    @PostMapping("save")
    public Envelop updatesSchemeAdpatDataset(String dataJson) {
        try{
            String url = ServiceApi.Adaptions.SchemaMetadataList;
            RsAdapterMetadata metadata = toEntity(dataJson,RsAdapterMetadata.class);
            metadata = metadataService.saveAdapterMetadata(metadata);
            return ObjEnvelop.getSuccess("保存成功",metadata);
        }catch(Exception ex){
            ex.printStackTrace();
            return failed(ERR_SYSTEM_DES);
        }
      }
    }
