package com.yihu.jw.basic.agadmin.controller.resource;


import com.yihu.jw.basic.resource.service.RsAdapterDictionaryService;
import com.yihu.jw.entity.ehr.resource.RsAdapterDictionary;
import com.yihu.jw.restmodel.web.ObjEnvelop;
import com.yihu.jw.restmodel.web.PageEnvelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import io.swagger.annotations.Api;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 *
 * Created by linz on 2015/11/1.
 */

@RequestMapping("/schemeAdaptDict")
@RestController
@Api( tags = {"网关-资源适配管理方案适配管理"})
public class SchemeAdaptDictController extends EnvelopRestEndpoint {

    @Autowired
    private RsAdapterDictionaryService adapterDictionaryService;

    @GetMapping("/dictlist")
    public Object searchmetaData(String adapterSchemeId, String code, int page, int rows) {
        StringBuffer stringBuffer = new StringBuffer();
        if(StringUtils.isNotBlank(adapterSchemeId)){
            stringBuffer.append("schemeId=").append(adapterSchemeId).append(";");
        }else{
            return failed("请选择资源适配方案");
        }
        if(StringUtils.isNotBlank(code)){
            stringBuffer.append("srcDictCode=").append(code).append(" g1").append(";");
        }
        String filters = stringBuffer.toString();
        if(filters.lastIndexOf(";")>0){
            filters = filters.substring(0,filters.lastIndexOf(";"));
        }
        try {
            String url = "/adaptions/adapter/dictionaries";
            List<RsAdapterDictionary> adapterDictionaries = adapterDictionaryService.search(null, filters, null, page, rows);
            return PageEnvelop.getSuccessListWithPage("查询成功",adapterDictionaries,page,rows,adapterDictionaryService.getCount(filters));
        } catch (Exception e) {
            e.printStackTrace();
            return failed(ERR_SYSTEM_DES);
        }
    }

    /**
     * 资源适配：新增、修改窗口
     */
    @PostMapping("/save")
    public Object updatesSchemeAdpatDict(String dataJson) {
        try{
            String url = "/adaptions/adapter/dictionaries";
            RsAdapterDictionary adapterDictionary = toEntity(dataJson, RsAdapterDictionary.class);
            adapterDictionary = adapterDictionaryService.save(adapterDictionary);
            return ObjEnvelop.getSuccess("更新成功",adapterDictionary);
        } catch(Exception ex){
            ex.printStackTrace();
            return failed(ERR_SYSTEM_DES);
        }
    }
}
