package com.yihu.jw.basic.patient.dao;

import com.yihu.jw.entity.ehr.patient.DemographicInfo;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.repository.query.Param;

import java.util.List;

/**
 * @author Sand
 * @version 1.0
 * @created 2015.12.16 15:10
 */
public interface XDemographicInfoRepository extends JpaRepository<DemographicInfo, String> {

    @Query("select demographicInfo from DemographicInfo demographicInfo where 1=1")
    public List<DemographicInfo> getOrgByCode(@Param("orgCode") String orgCode);

    @Query("select demographicInfo from DemographicInfo demographicInfo where demographicInfo.telephoneNo=:telephoneNo")
    public List<DemographicInfo> getDemographicInfoByTelephoneNo(@Param("telephoneNo") String telephoneNo);

    @Query("select demographicInfo from DemographicInfo demographicInfo where demographicInfo.idCardNo = :idCardNo")
    List<DemographicInfo> getDemographicInfoByIdCardNo(@Param("idCardNo") String idCardNo);
}
