package com.yihu.jw.basic.portal.controller;

import com.yihu.jw.basic.portal.service.PortalMessageRemindService;
import com.yihu.jw.basic.portal.service.QuestionnaireService;
import com.yihu.jw.constants.ApiVersion;
import com.yihu.jw.constants.ServiceApi;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import com.yihu.jw.restmodel.web.Envelop;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Map;


/**
 * Created by zhangdan on 2018/4/17.
 */
@RestController
@RequestMapping(ApiVersion.Version1_0)
@Api(value = "questionnaire", description = "问卷/满意度调查", tags = {"云门户-问卷调查"})
public class PortalQuestionnaireController extends EnvelopRestEndpoint {

    @Autowired
    private QuestionnaireService questionnaireService;

    @Autowired
    private PortalMessageRemindService portalMessageRemindService;

    @PostMapping(value = ServiceApi.Questionnaire.GetAllQuestionsByTemplateCode)
    @ApiOperation(value = "根据模板id获取所有问题", notes = "根据模板id获取所有问题")
    public Envelop getAllQuestions(
            @ApiParam(name = "surveyTemplateCode",value = "问卷模板id")
            @RequestParam(value = "surveyTemplateCode",required = true)String surveyTemplateCode,
            @ApiParam(name = "messageId",value = "消息id")
            @RequestParam(value = "messageId",required = false)String messageId) throws Exception{
            Map<String, Object> map= questionnaireService.getAllQuestions(surveyTemplateCode);
            portalMessageRemindService.updateMessageRemind("readed","1",Long.valueOf(messageId));
            return success(map);
            //return Result.success("查询成功！",jsonObject);

    }

}
