package com.yihu.jw.basic.quota.controller;

import com.yihu.jw.basic.quota.dao.XTjQuotaDataSaveRepository;
import com.yihu.jw.basic.quota.service.TjQuotaDataSaveService;
import com.yihu.jw.entity.ehr.quota.TjQuotaDataSave;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.ObjEnvelop;
import com.yihu.jw.restmodel.web.PageEnvelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import com.yihu.jw.constants.ApiVersion;
import com.yihu.jw.constants.ServiceApi;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.List;

/**
 * Created by Administrator on 2017/6/9.
 */
@RestController
@RequestMapping(ApiVersion.Version1_0)
@Api(value = "TjQuotaDataSave", description = "统计数据存储", tags = {"统计指标管理-统计数据存储"})
public class TjQuotaDataSaveEndPoint extends EnvelopRestEndpoint {
    @Autowired
    TjQuotaDataSaveService tjQuotaDataSaveService;
    @Autowired
    XTjQuotaDataSaveRepository tjQuotaDataSaveRepository;

    @RequestMapping(value = ServiceApi.TJ.GetTjQuotaDataSaveList, method = RequestMethod.GET)
    @ApiOperation(value = "根据查询条件查询统计数据存储")
    public PageEnvelop getTjDataSaveList(
            @ApiParam(name = "fields", value = "返回的字段，为空返回全部字段", defaultValue = "")
            @RequestParam(value = "fields", required = false) String fields,
            @ApiParam(name = "filters", value = "过滤器，为空检索所有条件")
            @RequestParam(value = "filters", required = false) String filters,
            @ApiParam(name = "sorts", value = "排序，规则参见说明文档", defaultValue = "+name,+createTime")
            @RequestParam(value = "sorts", required = false) String sorts,
            @ApiParam(name = "size", value = "分页大小", defaultValue = "15")
            @RequestParam(value = "size", required = false) int size,
            @ApiParam(name = "page", value = "页码", defaultValue = "1")
            @RequestParam(value = "page", required = false) int page,
            HttpServletRequest request,
            HttpServletResponse response) throws Exception {

        PageEnvelop PageEnvelop = new PageEnvelop();
        List<TjQuotaDataSave> tjQuotaDataSave = tjQuotaDataSaveService.search(fields, filters, sorts, page, size);
        if(tjQuotaDataSave != null){
            PageEnvelop.setDetailModelList(tjQuotaDataSave);
            PageEnvelop.setTotalCount((int)tjQuotaDataSaveService.getCount(filters));
            PageEnvelop.setStatus(200);
            PageEnvelop.setCurrPage(page);
            PageEnvelop.setPageSize(size);
        }else{
            PageEnvelop.setStatus(200);
            PageEnvelop.setMessage("查询无数据");
            PageEnvelop.setTotalCount(0);
        }
        return PageEnvelop;
    }

    @RequestMapping(value = ServiceApi.TJ.AddTjQuotaDataSave, method = RequestMethod.POST, consumes = MediaType.APPLICATION_JSON_UTF8_VALUE)
    @ApiOperation(value = "新增&修改统计数据存储")
    public ObjEnvelop add(
            @ApiParam(name = "model", value = "json数据模型", defaultValue = "")
            @RequestBody String model) throws Exception{
        TjQuotaDataSave obj = objectMapper.readValue(model, TjQuotaDataSave.class);
        obj = tjQuotaDataSaveService.save(obj);
        return ObjEnvelop.getSuccess("统计数据存储更新成功！", obj);
    }


    @RequestMapping(value = ServiceApi.TJ.DeleteTjQuotaDataSave, method = RequestMethod.DELETE)
    @ApiOperation(value = "删除统计数据存储")
    public Envelop delete(
            @ApiParam(name = "id", value = "编号", defaultValue = "")
            @RequestParam(value = "id") Long id) throws Exception{
        tjQuotaDataSaveRepository.deleteById(id);
        return ObjEnvelop.getSuccess("统计数据存储删除成功！");
    }
}
