package com.yihu.jw.basic.quota.controller;

import com.fasterxml.jackson.core.type.TypeReference;
import com.yihu.jw.basic.quota.dao.XTjQuotaDimensionMainRepository;
import com.yihu.jw.basic.quota.service.TjQuotaDimensionMainService;
import com.yihu.jw.entity.ehr.quota.TjQuotaDimensionMain;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.ObjEnvelop;
import com.yihu.jw.restmodel.web.PageEnvelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import com.yihu.jw.constants.ApiVersion;
import com.yihu.jw.constants.ServiceApi;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.List;

/**
 * Created by janseny on 2017/5/8.
 */
@RestController
@RequestMapping(ApiVersion.Version1_0)
@Api(value = "TjQuotaDimensionMain", description = "统计指标主维度关联信息", tags = {"统计指标主维度关联信息"})
public class TjQuotaDimensionMainEndPoint extends EnvelopRestEndpoint {

    @Autowired
    TjQuotaDimensionMainService tjQuotaDimensionMainService;
    @Autowired
    XTjQuotaDimensionMainRepository tjQuotaDimensionMainRepository;

    @RequestMapping(value = ServiceApi.TJ.GetTjQuotaDimensionMainList, method = RequestMethod.GET)
    @ApiOperation(value = "根据查询条件查询统计指标主维度关联信息")
    public PageEnvelop getTjQuotaDimensionMainList(
            @ApiParam(name = "fields", value = "返回的字段，为空返回全部字段", defaultValue = "")
            @RequestParam(value = "fields", required = false) String fields,
            @ApiParam(name = "filters", value = "过滤器，为空检索所有条件")
            @RequestParam(value = "filters", required = false) String filters,
            @ApiParam(name = "sorts", value = "排序，规则参见说明文档", defaultValue = "+name,+createTime")
            @RequestParam(value = "sorts", required = false) String sorts,
            @ApiParam(name = "size", value = "分页大小", defaultValue = "15")
            @RequestParam(value = "size", required = false) int size,
            @ApiParam(name = "page", value = "页码", defaultValue = "1")
            @RequestParam(value = "page", required = false) int page,
            HttpServletRequest request,
            HttpServletResponse response) throws Exception {

        PageEnvelop PageEnvelop = new PageEnvelop();
        List<TjQuotaDimensionMain> qtjQuotaDimensionMainList = tjQuotaDimensionMainService.search(fields, filters, sorts, page, size);
        if(qtjQuotaDimensionMainList != null){
            PageEnvelop.setDetailModelList(qtjQuotaDimensionMainList);
            PageEnvelop.setTotalCount((int)tjQuotaDimensionMainService.getCount(filters));
            PageEnvelop.setStatus(200);
            PageEnvelop.setCurrPage(page);
            PageEnvelop.setPageSize(size);
        }else{
            PageEnvelop.setStatus(200);
            PageEnvelop.setMessage("查询无数据");
            PageEnvelop.setTotalCount(0);
        }
        return PageEnvelop;
    }

    @RequestMapping(value = ServiceApi.TJ.GetTjQuotaDimensionMainAll, method = RequestMethod.GET)
    @ApiOperation(value = "根据查询条件查询统计指标主维度关联信息")
    public PageEnvelop getTjQuotaDimensionMainAll(
            @ApiParam(name = "filters", value = "过滤器，为空检索所有条件")
            @RequestParam(value = "filters", required = false) String filters,
            @ApiParam(name = "sorts", value = "排序，规则参见说明文档", defaultValue = "+name,+createTime")
            @RequestParam(value = "sorts", required = false) String sorts,
            HttpServletRequest request,
            HttpServletResponse response) throws Exception {

        PageEnvelop PageEnvelop = new PageEnvelop();
        List<TjQuotaDimensionMain> tjQuotaDimensionMainList = tjQuotaDimensionMainService.search(filters, sorts);
        if(tjQuotaDimensionMainList != null){
            PageEnvelop.setDetailModelList(tjQuotaDimensionMainList);
            PageEnvelop.setTotalCount((int)tjQuotaDimensionMainService.getCount(filters));
            PageEnvelop.setStatus(200);
        }else{
            PageEnvelop.setStatus(200);
            PageEnvelop.setMessage("查询无数据");
            PageEnvelop.setTotalCount(0);
        }
        return PageEnvelop;
    }

    @RequestMapping(value = ServiceApi.TJ.TjQuotaDimensionMain, method = RequestMethod.POST, consumes = MediaType.APPLICATION_JSON_UTF8_VALUE)
    @ApiOperation(value = "新增&修改统计指标主维度关联信息")
    public ObjEnvelop add(
            @ApiParam(name = "model", value = "json数据模型", defaultValue = "")
            @RequestBody String model) throws Exception{
        TjQuotaDimensionMain obj = objectMapper.readValue(model, TjQuotaDimensionMain.class);
        obj = tjQuotaDimensionMainService.save(obj);
        return ObjEnvelop.getSuccess("统计指标主维度关联信息更新成功！", obj);
    }

    @RequestMapping(value = ServiceApi.TJ.AddTjQuotaDimensionMain, method = RequestMethod.POST, consumes = MediaType.APPLICATION_JSON_UTF8_VALUE)
    @ApiOperation(value = "新增&修改统计指标主维度关联信息")
    public ObjEnvelop addTjQuotaDimensionMain(
            @ApiParam(name = "model", value = "json数据模型", defaultValue = "")
            @RequestBody String model) throws Exception{
        List<TjQuotaDimensionMain> list = objectMapper.readValue(model, new TypeReference<List<TjQuotaDimensionMain>>(){});
        if (list != null && list.size() > 0) {
            tjQuotaDimensionMainService.deleteByQuotaCode(list.get(0).getQuotaCode());
        }
        for (int i=0; i<list.size(); i++) {
            tjQuotaDimensionMainService.save(list.get(i));
        }
        return ObjEnvelop.getSuccess("统计指标主维度关联信息更新成功！", list);
    }

    @RequestMapping(value = ServiceApi.TJ.TjQuotaDimensionMain, method = RequestMethod.DELETE)
    @ApiOperation(value = "删除统计指标主维度关联信息")
    public Envelop delete(
            @ApiParam(name = "id", value = "编号", defaultValue = "")
            @RequestParam(value = "id") Long id) throws Exception{
        tjQuotaDimensionMainRepository.deleteById(id);
        return ObjEnvelop.getSuccess("统计指标主维度关联信息删除成功！");
    }

    @RequestMapping(value = "tj/deleteMainByQuotaCode", method = RequestMethod.DELETE)
    @ApiOperation(value = "根据指标ID删除统计指标主维度关联信息")
    public Envelop deleteMainByQuotaCode(
            @ApiParam(name = "quotaCode", value = "指标Id")
            @RequestParam(value = "quotaCode") String quotaCode) throws Exception {
        tjQuotaDimensionMainService.deleteByQuotaCode(quotaCode);
        return ObjEnvelop.getSuccess("保存成功!");
    }
}
