package com.yihu.jw.basic.quota.service;

import com.yihu.jw.basic.es.EsResultExtract;
import com.yihu.jw.basic.quota.dao.XTjQuotaRepository;
import com.yihu.jw.basic.resource.service.RsResourceQuotaService;
import com.yihu.jw.basic.util.BasesicUtil;
import com.yihu.jw.entity.ehr.quota.TjQuota;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;

import java.util.*;

/**
 * @author janseny
 */
@Service
public class QuotaService {
    @Autowired
    private XTjQuotaRepository quotaDao;
    @Autowired
    private EsResultExtract esResultExtract;

    @Autowired
    private JdbcTemplate jdbcTemplate;
    @Autowired
    private RsResourceQuotaService resourceQuotaService;
    @Autowired
    private OrgHealthCategoryStatisticsService orgHealthCategoryStatisticsService;
    @Autowired
    private BaseStatistsService baseStatistsService;
    @Autowired
    private DeviceService deviceService;

    private BasesicUtil basesicUtil = new BasesicUtil();

    public static String orgHealthCategoryCode = "orgHealthCategoryCode";


    public List<Map<String, Object>> getQuotaReportTwoDimensionalTable(String quotaCodeStr, String filter,String dimension, String top
    ) {
        List<Map<String, Object>> dataList = new ArrayList<>();
        Map<String, List<Map<String, Object>>> quotaViewResult = new HashMap<>();
        List<String> quotaCodes = Arrays.asList(quotaCodeStr.split(","));
        String maxQuotaCode = "";
        int num = 0;
        try {
            for (String code : quotaCodes) {
                List<Map<String, Object>> quotaResult = baseStatistsService.getSimpleQuotaReport(code, filter, dimension,false, top);
                if (quotaResult.size() >= num) {
                    num = quotaResult.size();
                    maxQuotaCode = code;
                }
                quotaViewResult.put(code, quotaResult);
            }
            Map<String, List<Map<String, Object>>> otherQuotaViewResult = new HashMap<>();
            for (String key : quotaViewResult.keySet()) {
                if (key != maxQuotaCode) {
                    otherQuotaViewResult.put(key, quotaViewResult.get(key));
                }
            }
            //以查询结果数据最多的指标为主，其他指标对应维度没有数据的补充0
            for (Map<String, Object> vMap : quotaViewResult.get(maxQuotaCode)) {
                vMap.put(maxQuotaCode, vMap.get("result")==null ? 0 : ("--".equals(vMap.get("result")) ? vMap.get("result") : basesicUtil.decimalPointHandle(Double.valueOf(vMap.get("result").toString()))));
                for (String viewQuotaCode : otherQuotaViewResult.keySet()) {
                    if(otherQuotaViewResult != null && otherQuotaViewResult.get(viewQuotaCode) != null && otherQuotaViewResult.get(viewQuotaCode).size()>0 ){
                        for (Map<String, Object> quotaResultMap : otherQuotaViewResult.get(viewQuotaCode)) {
                            if (quotaResultMap.get(dimension) != null && vMap.get(dimension) != null ) {
                                if (vMap.get(dimension).toString().trim().equals(quotaResultMap.get(dimension).toString().trim())) {
                                    vMap.put(viewQuotaCode, quotaResultMap.get("result")==null ? 0 : ("--".equals(quotaResultMap.get("result")) ? quotaResultMap.get("result") : basesicUtil.decimalPointHandle(Double.valueOf(quotaResultMap.get("result").toString()))));
                                    break;
                                } else {
                                    if( !vMap.get(dimension).toString().equals("合计")){
                                        vMap.put(viewQuotaCode, 0);
                                    }
                                }
                            } else {
                                vMap.put(viewQuotaCode, 0);
                            }
                        }
                    }else {
                        vMap.put(viewQuotaCode, 0);
                    }
                }
            }
            List<Map<String, Object>> resultList = quotaViewResult.get(maxQuotaCode);

            if(dimension.equals(orgHealthCategoryCode)){//如果是特殊机构类型树状机构需要转成树状结构
                List<Map<String, Object>> orgHealthCategoryList = orgHealthCategoryStatisticsService.getOrgHealthCategoryTreeByPid(-1);
//                dataList = baseStatistsService.setResultAllDimenMap(maxQuotaCode, orgHealthCategoryList, resultList,null);
                //采用新的
                dataList = baseStatistsService.allCategoryResultMap(quotaCodes, orgHealthCategoryList, resultList);

            }else {
                dataList = resultList;
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        for(Map<String, Object> map : dataList){
            if(map.get("firstColumn") == null || map.get("firstColumn").toString().equals("null") || StringUtils.isEmpty(map.get("firstColumn").toString())){
                if(map.get("level")!= null && StringUtils.isNotEmpty(map.get("level").toString())){
                    String level = map.get("level").toString();
                    if (level.equals("1")){
                        level = "一级";
                    }else if (level.equals("2")){
                        level = "二级";
                    }else if (level.equals("3")){
                        level = "三级";
                    }else {
                        level = "未指定";
                    }
                    map.put("firstColumn",level);
                }
                if(map.get("economic")!= null && StringUtils.isNotEmpty(map.get("economic").toString())){
                    String economic = map.get("economic").toString();
                    if (economic.equals("1021")){
                        economic = "公立";
                    }else if (economic.equals("1022")){
                        economic = "非公立";
                    }else {
                        economic = "其他";
                    }
                    map.put("firstColumn",economic);
                }
            }
        }
        //计算合计
        if(dataList != null && dataList.size() > 0){
            Map<String, Object> sumMap = new HashMap<>();
            sumMap.put("firstColumn","合计");
            for (String code : quotaCodes) {
                String total =  existsTotal(code,dataList);
                if( total.equals("false") || total.equals("--")){
                    double sum = 0;
                    sum = calculateSum(sum,code,dataList);
                    sumMap.put(code, basesicUtil.decimalPointHandle(sum));
                }else {
                    sumMap.put(code, basesicUtil.decimalPointHandle(Double.valueOf(total)));
                }
            }
            dataList.add(0,sumMap);
            if(dataList.get(dataList.size()-1).get("firstColumn") != null){
                if(dataList.get(dataList.size()-1).get("firstColumn").equals("合计")){
                    dataList.remove(dataList.size()-1);
                }
            }
        }
        int size = dataList.size();
        if (size > 0 && dataList.get(size - 1).containsValue("合计")) {
            dataList = dataList.subList(0, size - 1);
        }

        return dataList;
    }

    /**
     * 判断指标统计中 总计 是否已经计算过
     * @param code
     * @param dataList
     * @return
     */
    private String existsTotal(String code,List<Map<String, Object>> dataList){
        for(Map<String, Object> map : dataList){
            if(map.get("firstColumn") != null && map.get("firstColumn").toString().equals("合计") && map.get(code) != null){
                if(map.get(code).toString().equals("--")){
                    return "false";
                }else {
                    return map.get(code).toString();
                }
            }
        }
        return "false";
    }

    /**
     * 统计每列合计
     * @param sum
     * @param code
     * @param dataList
     * @return
     */
    private double calculateSum( double sum,String code,List<Map<String, Object>> dataList){
        for(Map<String, Object> map : dataList){
            if(map.get(code) != null){
                sum += Double.valueOf("--".equals(map.get(code)) ? "0" : map.get(code).toString());
            }
        }
        return sum;
    }













    public TjQuota findOne(Long id){
        return quotaDao.getOne(id);
    }

    public TjQuota findByCode(String code){
        return quotaDao.findByCode(code);
    }

    public List<Map<String, Object>> queryResultPage(Long id,String filters ,int pageNo,int pageSize) throws Exception {
        TjQuota tjQuota= quotaDao.getOne(id);
        return  esResultExtract.queryResultPage(tjQuota, filters, pageNo, pageSize);
    }

    public List<Map<String, Object>> queryResultPageByCode(String code,String filters ,int pageNo,int pageSize) throws Exception {
        TjQuota tjQuota= quotaDao.findByCode(code);
        return  esResultExtract.queryResultPage(tjQuota, filters, pageNo, pageSize);
    }

    public long getQuotaTotalCount(Long id,String filters) throws Exception {
        TjQuota tjQuota= quotaDao.getOne(id);
        long count = esResultExtract.getQuotaTotalCount(tjQuota,filters);
        return count;
    }

    //指标分组统计数量 - 只支持一个字段
    public List<Map<String, Object>> searcherByGroup(TjQuota tjQuota,String filters,String aggsField ) throws Exception {
        return  esResultExtract.searcherByGroup(tjQuota, filters,aggsField );
    }

    //根据mysql 指标分组求和 支持一个和多个字段
    public Map<String, Integer> searcherSumByGroupBySql(TjQuota tjQuota,String aggsField ,String filters,String sumField ,String orderFild,String order) throws Exception {
        return  esResultExtract.searcherSumByGroupBySql(tjQuota, aggsField, filters,sumField,orderFild,order);
    }

    //多维度数据的总和 返回数据结果集
    //返回结果 ：key为共同维度的组合值，value为数据结果集
    public Map<String,Map<String, Object>> getQuotaResult(Long id, String filters,String dimension) throws Exception {

        String[] dimensions = null;
        if(StringUtils.isNotEmpty(dimension)){
            dimensions = dimension.split(";");
        }else{
            dimensions = new String[]{"quotaDate"};
        }
        TjQuota tjQuota= quotaDao.getOne(id);
        List<Map<String, Object>> resultListMap = esResultExtract.getQuotaReport(tjQuota, filters,10000);

        Map<String,Map<String, Object>> cloumnMap = new HashMap<>();

        for(int i=0 ; i < resultListMap.size() ;i++){
            Map<String, Object> resultMap = resultListMap.get(i);
            Object resultVal = resultMap.get("result");

            String cloumnStr = "";//多个列 值 拼接串
            for(int k=0 ; k < dimensions.length ; k++){
                String nameVal = resultMap.get(dimensions[k]).toString();
                cloumnStr = cloumnStr + nameVal + "-";
            }
            boolean repeat = false;
            Object oldResultVal = null;
            if( cloumnMap.size() == 0 ){//第一个
                cloumnMap.put(cloumnStr,resultMap);
            }else {
                for(String key:cloumnMap.keySet()){
                    if(cloumnStr.equals(key)){
                        repeat = true;
                        Map<String, Object> oldMap = cloumnMap.get(key);
                        oldResultVal = oldMap.get("result");
                    }
                }
            }
            if( !repeat){
                cloumnMap.put(cloumnStr,resultMap);
            }else {
                //如果有重复 先计删除listl里面的数据，再添加新数据
                cloumnMap.remove(cloumnStr);
                resultMap.remove("result");
                Object newResultVal = ( Integer.valueOf(resultVal.toString()) + Integer.valueOf(oldResultVal.toString()) );
                resultMap.put("result",newResultVal);
                cloumnMap.put(cloumnStr, resultMap);
            }


        }
        return cloumnMap;
    }

}
