package com.yihu.jw.basic.quota.service;

import com.yihu.jw.basic.quota.dao.XTjDataSaveRepository;
import com.yihu.jw.entity.ehr.quota.TjDataSave;
import com.yihu.jw.entity.ehr.quota.TjQuotaDataSave;
import com.yihu.jw.mysql.query.BaseJpaService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.BeanPropertyRowMapper;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * Created by Administrator on 2017/6/9.
 */
@Service
@Transactional
public class TjDataSaveService extends BaseJpaService<TjDataSave, XTjDataSaveRepository> {
    @Autowired
    XTjDataSaveRepository tjDataSaveRepository;

    public TjDataSave getById(Long id) {
        TjDataSave tjDataSave = tjDataSaveRepository.findById(id).orElse(null);
        return tjDataSave;
    }

    public TjDataSave getByCode(String code) {
        return tjDataSaveRepository.findByCode(code);
    }

    public TjQuotaDataSave findByQuota(String code) {
        String sql = "select   qds.*, ds.type from tj_data_save ds, tj_quota_data_save qds where ds.`code` = qds.save_code and qds.quota_code = ?";
        List<TjQuotaDataSave> quotaDataSources = jdbcTemplate.query(sql, new BeanPropertyRowMapper(TjQuotaDataSave.class), code);
        if (quotaDataSources.size() > 0) {
            return quotaDataSources.get(0);
        }
        return null;
    }
}
