package com.yihu.jw.basic.quota.service;

import com.yihu.jw.basic.quota.dao.XTjDataSourceRepository;

import com.yihu.jw.entity.ehr.quota.TjDataSource;
import com.yihu.jw.entity.ehr.quota.TjQuotaDataSource;
import com.yihu.jw.mysql.query.BaseJpaService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.BeanPropertyRowMapper;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * Created by Administrator on 2017/6/9.
 */
@Service
@Transactional
public class TjDataSourceService extends BaseJpaService<TjDataSource, XTjDataSourceRepository> {
    @Autowired
    XTjDataSourceRepository tjDataSourceRepository;

    public TjDataSource getById(Long id) {
        TjDataSource tjDataSource = tjDataSourceRepository.findById(id).orElse(null);
        return tjDataSource;
    }

    public TjDataSource getByCode(String code) {
        return tjDataSourceRepository.findByCode(code);
    }

    public TjQuotaDataSource findSourceByQuotaCode(String code) {
        String sql = " SELECT " +
                "  qds.*, ds.code " +
                "FROM " +
                "  tj_quota_data_source qds, " +
                "  tj_data_source ds " +
                "WHERE " +
                "  qds.source_code = ds.`code` " +
                "  and " +
                "  qds.quota_code = ?";
        List<TjQuotaDataSource> quotaDataSources = jdbcTemplate.query(sql, new BeanPropertyRowMapper(TjQuotaDataSource.class), code);
        if (quotaDataSources.size() > 0) {
            return quotaDataSources.get(0);
        }
        return null;
    }
}
