package com.yihu.jw.basic.quota.service;

import com.fasterxml.jackson.databind.ObjectMapper;
import com.yihu.jw.basic.quota.dao.XTjDimensionMainRepository;
import com.yihu.jw.entity.ehr.quota.TjDimensionMain;
import com.yihu.jw.entity.ehr.quota.TjQuotaDimensionMain;
import com.yihu.jw.mysql.query.BaseJpaService;
import org.hibernate.query.NativeQuery;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.BeanPropertyRowMapper;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * @author janseny
 * @version 1.0
 * @created 2017/5/08
 */
@Service
@Transactional
public class TjDimensionMainService extends BaseJpaService<TjDimensionMain, XTjDimensionMainRepository> {


    @Autowired
    XTjDimensionMainRepository tjDimensionMainRepository;

    @Autowired
    ObjectMapper objectMapper;

    /**
     * 根据ID获取.
     * @param
     */
    public TjDimensionMain getTjDimensionMain(Long id) {
        TjDimensionMain tjDimensionMain = tjDimensionMainRepository.findById(id).orElse(null);
        return tjDimensionMain;
    }

    public TjDimensionMain getTjDimensionMainByCode(String quotaCode) {
        List<TjDimensionMain>  dimensionMains = tjDimensionMainRepository.findByCode(quotaCode);
        if(dimensionMains!=null && dimensionMains.size()>0){
            return dimensionMains.get(0);
        }else {
            return null;
        }
    }

    /**
     * 查询主维度编码是否已存在， 返回已存在数据
     */
    public List tjDimensionMainIsExist(String[] values)
    {
        String sql =  "SELECT code FROM tj_dimension_main WHERE code in(:values)";
        NativeQuery sqlQuery = currentSession().createSQLQuery(sql);
        sqlQuery.setParameterList("values", values);
        return sqlQuery.list();
    }

    public List<TjQuotaDimensionMain> findTjQuotaDimensionMainByQuotaCode(String code) {
        String sql = "SELECT  qdm.*, dm.type FROM   tj_dimension_main dm, tj_quota_dimension_main qdm " +
                "WHERE   dm.`code` = qdm.main_code AND qdm.quota_code = ? order by qdm.id asc";
        List<TjQuotaDimensionMain> quotaDataSources = jdbcTemplate.query(sql, new BeanPropertyRowMapper(TjQuotaDimensionMain.class), code);
        return quotaDataSources;
    }
}
