package com.yihu.jw.basic.quota.service;

import com.yihu.jw.basic.quota.dao.XTjDimensionSlaveRepository;
import com.yihu.jw.entity.ehr.quota.TjDimensionSlave;
import com.yihu.jw.entity.ehr.quota.TjQuotaDimensionSlave;
import com.yihu.jw.mysql.query.BaseJpaService;
import org.hibernate.query.NativeQuery;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.BeanPropertyRowMapper;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * @author janseny
 * @version 1.0
 * @created 2017/5/08
 */
@Service
@Transactional
public class TjDimensionSlaveService extends BaseJpaService<TjDimensionSlave, XTjDimensionSlaveRepository> {


    @Autowired
    private XTjDimensionSlaveRepository tjDimensionSlaveRepository;

    /**
     * 根据ID获取.
     * @param
     */
    public TjDimensionSlave getTjDimensionSlave(Long id) {
        TjDimensionSlave tjDimensionSlave = tjDimensionSlaveRepository.findById(id).orElse(null);
        return tjDimensionSlave;
    }

    public TjDimensionSlave getTjDimensionSlaveByCode(String quotaCode) {
        List<TjDimensionSlave>  dimensionSlaves = tjDimensionSlaveRepository.findByCode(quotaCode);
        if(dimensionSlaves!=null && dimensionSlaves.size()>0){
            return dimensionSlaves.get(0);
        }else {
            return null;
        }
    }

    /**
     * 查询细维度编码是否已存在， 返回已存在数据
     */
    public List tjDimensionSlaveIsExist(String[] values) {
        String sql = "SELECT code FROM tj_dimension_slave WHERE code in(:values)";
        NativeQuery sqlQuery = currentSession().createSQLQuery(sql);
        sqlQuery.setParameterList("values", values);
        return sqlQuery.list();
    }

    public List<TjQuotaDimensionSlave> findTjQuotaDimensionSlaveByQuotaCode(String code) {
        String sql = "SELECT " +
                "  qdm.*,dm.type " +
                " FROM " +
                "  tj_dimension_slave dm, " +
                "  tj_quota_dimension_slave qdm " +
                " WHERE " +
                "  dm.`code` = qdm.slave_code " +
                " AND qdm.quota_code = ? order BY" +
                " qdm.id asc ";
        List<TjQuotaDimensionSlave> quotaDataSources = jdbcTemplate.query(sql, new BeanPropertyRowMapper(TjQuotaDimensionSlave.class), code);
        return quotaDataSources;
    }
}
