package com.yihu.jw.basic.redis.dao;

import com.yihu.jw.entity.ehr.redis.RedisMqMessageLog;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.Param;

import java.util.List;

/**
 * redis消息记录 DAO
 *
 * @author 张进军
 * @date 2017/11/10 11:45
 */
public interface RedisMqMessageLogDao extends JpaRepository<RedisMqMessageLog, String> {

    List<RedisMqMessageLog> findByChannel(@Param("channel") String channel);

    @Modifying
    @Query("update RedisMqMessageLog set status=:status where id=:id")
    void updateStatus(@Param("id") String id, @Param("status") Integer status);

}
