package com.yihu.jw.basic.redis.service;

import com.yihu.jw.basic.redis.dao.RedisMqMessageLogDao;
import com.yihu.jw.entity.ehr.redis.RedisMqMessageLog;
import com.yihu.jw.mysql.query.BaseJpaService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * redis消息记录 Service
 *
 * @author 张进军
 * @date 2017/11/10 11:45
 */
@Service
@Transactional
public class RedisMqMessageLogService extends BaseJpaService<RedisMqMessageLog, RedisMqMessageLogDao> {

    @Autowired
    RedisMqMessageLogDao redisMqMessageLogDao;

    public RedisMqMessageLog getById(String id) {
        return redisMqMessageLogDao.getOne(id);
    }

    public List<RedisMqMessageLog> findByChannel(String channel) {
        return redisMqMessageLogDao.findByChannel(channel);
    }

    @Transactional(readOnly = false)
    public RedisMqMessageLog save(RedisMqMessageLog redisMqMessageLog) {
        return redisMqMessageLogDao.save(redisMqMessageLog);
    }

    @Transactional(readOnly = false)
    public void updateStatus(String id, Integer status) {
        redisMqMessageLogDao.updateStatus(id, status);
    }

}