package com.yihu.jw.basic.resource.dao;

import com.yihu.jw.entity.ehr.resource.RsResourceDefaultParam;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.repository.query.Param;

import java.util.List;

/**
 * @author linaz
 * @created 2016.05.17 16:33
 */
public interface RsResourceDefaultParamDao extends JpaRepository<RsResourceDefaultParam, String> {

    List<RsResourceDefaultParam> findByResourcesCode(String resourcesCode);

    void deleteByResourcesId(String resourcesId);

    void deleteByResourcesIdAndParamKey(String resourcesId, String paramKey);

    @Query("from RsResourceDefaultParam where resourcesId = ?1 or resourcesCode = ?2 ")
    List<RsResourceDefaultParam> findByResourcesIdOrResourcesCode(String resourcesId, String resourceCode);

    @Query("from RsResourceDefaultParam where ( resourcesId = ?1 or resourcesCode = ?2 ) and paramKey = ?3 ")
    List<RsResourceDefaultParam> findByResourcesIdOrResourcesCodeWithParamKey(String resourceId, String resourceCode , String ParamKey);
}