package com.yihu.jw.basic.resource.dao;

import com.yihu.jw.entity.ehr.resource.RsResourceQuota;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.repository.query.Param;

import java.util.List;

/**
 * Created by Administrator on 2017/8/10.
 */
public interface RsResourceQuotaDao extends JpaRepository<RsResourceQuota,Integer> {

    @Query("delete from RsResourceQuota rq where rq.resourceId = :resourceId")
    @Modifying
    int deleteByResourceId(@Param("resourceId") String resourceId);

    @Query("select count(rq.quotaId) from RsResourceQuota rq where rq.resourceId = :resourceId")
    Integer fingQuotaCount(@Param("resourceId") String resourceId);

    @Query("select rq.quotaChart from RsResourceQuota rq where rq.quotaId = :quotaId and rq.resourceId = :resourceId")
    List<Integer> findQuotaChartByQuotaId(@Param("quotaId")Integer quotaId, @Param("resourceId") String resourceId);

    @Query("select rq.quotaId from RsResourceQuota rq where rq.resourceId = :resourceId")
    List<Integer> findQuotaIdByResourceId(@Param("resourceId") String resourceId);

    @Query("select rq from RsResourceQuota rq where rq.resourceId = :resourceId and rq.pid = :pid")
    List<RsResourceQuota> findChildByPidAndResourceId(@Param("resourceId") String resourceId, @Param("pid") Integer pid);

    @Query(" FROM RsResourceQuota rq WHERE rq.resourceId = :resourceId and rq.pid = null ")
    List<RsResourceQuota> getTopParents(@Param("resourceId") String resourceId);

    @Query("select  rq FROM RsResourceQuota rq WHERE rq.resourceId = :resourceId and rq.quotaId = :quotaId")
    RsResourceQuota findByResourceIdAndQuotaId(@Param("resourceId")String resourceId, @Param("quotaId")Integer quotaId);

    @Query("select rq from RsResourceQuota rq where rq.resourceId = :resourceId and rq.pid in (:pid)")
    List<RsResourceQuota> findChildByPidAndResourceIds(@Param("resourceId") String resourceId, @Param("pid") List<Integer> pid);


    List<RsResourceQuota> findByResourceId(String resourceId);
}
