package com.yihu.jw.basic.resource.service;

import com.yihu.jw.entity.ehr.portal.PortalMessageTemplate;
import com.yihu.jw.mysql.query.BaseJpaService;
import com.yihu.jw.basic.resource.dao.PortalMessageTemplateDao;
import org.hibernate.FlushMode;
import org.hibernate.query.Query;
import org.hibernate.Session;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.cloud.openfeign.EnableFeignClients;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;

/**
 * @author zdm
 * @since 2018.04.21
 */
@Service
@Transactional
@EnableFeignClients
public class PortalMessageTemplateService extends BaseJpaService<PortalMessageTemplate, PortalMessageTemplateDao> {

    @Autowired
    private PortalMessageTemplateDao portalMessageTemplateRepository;


    public List<PortalMessageTemplate> getMessageTemplate(String classification,String type,String state) {
        return portalMessageTemplateRepository.searchPortalMessageTemplate(classification,type,state);
    }

    /**
     * 根据身份证号码获取用户的id
     * @param id_card_no
     * @return
     */
    public String getUserIdByIdCardNo(String id_card_no) {
           Session session = currentSession();
        String sql = "SELECT id FROM users WHERE id_card_no = :id_card_no";
        Query query = session.createSQLQuery(sql);
        query.setFlushMode(FlushMode.COMMIT);
        query.setString("id_card_no", id_card_no);
        return (String)query.uniqueResult();

    }

}
