package com.yihu.jw.basic.resource.service;

import com.yihu.jw.mysql.query.BaseJpaService;
import com.yihu.jw.basic.resource.dao.RsAdapterMetadataDao;
import com.yihu.jw.entity.ehr.resource.RsAdapterMetadata;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import org.springframework.stereotype.Service;

import javax.transaction.Transactional;

/**
 * 适配数据元服务
 *
 * Created by lyr on 2016/5/17.
 */
@Service
@Transactional
public class RsAdapterMetadataService extends BaseJpaService<RsAdapterMetadata, RsAdapterMetadataDao> {
    @Autowired
    private RsAdapterMetadataDao adMetadataDao;

//    @Autowired
//    private AdapterMetadataQueryDao adapterMetadataQueryDao;


    /**
     * 保存适配数据元
     *
     * @param adapterMetadata RsAdapterMetadata 适配数据元
     * @return RsAdapterSchema 适配数据元
     */
    public RsAdapterMetadata saveAdapterMetadata(RsAdapterMetadata adapterMetadata)
    {

        return adMetadataDao.save(adapterMetadata);
    }

    /**
     * 删除适配数据元
     *
     * @param ids String 适配方案ID
     */
    public void deleteAdapterMetadata(String ids)
    {
        String[] idsArray = ids.split(",");

        for(String id_ : idsArray)
        {
            adMetadataDao.deleteById(id_);
        }
    }

    /**
     * 获取适配数据元
     *
     * @param sorts String 排序
     * @param page int 分页
     * @param size int 分页大小
     * @return Page<RsAdapterSchema>
     */
    public Page<RsAdapterMetadata> getAdapterMetadata(String sorts, int page, int size)
    {
        Pageable pageable =  PageRequest.of(page,size,parseSorts(sorts));

        return adMetadataDao.findAll(pageable);
    }


    /**
     * 获取适配数据元
     *
     * @param id String Id
     * @return RsAdapterMetadata
     */
    public RsAdapterMetadata getAdapterMetadataById(String id)
    {
        return adMetadataDao.getOne(id);
    }

    public void deleteBySchemaId(String id) {

    }
}
