package com.yihu.jw.basic.resource.service;

import com.yihu.jw.mysql.query.BaseJpaService;
import com.yihu.jw.basic.resource.dao.RsDimensionDao;
import com.yihu.jw.entity.ehr.resource.RsDimension;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 * Created by lyr on 2016/4/25.
 */
@Service
@Transactional
public class RsDimensionService extends BaseJpaService<RsDimension, RsDimensionDao> {
    @Autowired
    private RsDimensionDao dimensionDao;

    /**
     * 资源创建
     *
     * @param dimension RsDimension 资源实体
     * @return RsResources 资源实体
     */
    public RsDimension saveDimension(RsDimension dimension)
    {
        dimensionDao.save(dimension);
        return dimension;
    }

    /**
     * 资源删除
     *
     * @param id 资源ID
     */
    public void deleteDimension(String id)
    {
        dimensionDao.deleteById(id);
    }

    /**
     * 资源获取
     *
     * @param sorts 排序
     * @param page 页码
     * @param size 分页大小
     * @return Page<RsResources> 资源
     */
    public Page<RsDimension> getDimensions(String sorts, int page, int size)
    {
        Pageable pageable =  PageRequest.of(page,size,parseSorts(sorts));

        return dimensionDao.findAll(pageable);
    }
}
