package com.yihu.jw.basic.standard.controller;

import com.yihu.jw.basic.standard.service.standard.StdPublisherService;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;

/**
 * Created by LLH on 2016/1/6.
 */
@RestController("PublisherController")
@RequestMapping("/standardCenter")
@Api(protocols = "https", value = "PublisherController", tags = {"发布者管理"})
public class PublisherController extends EnvelopRestEndpoint {

    @Resource(name = StdPublisherService.BEAN_ID)
    private StdPublisherService stdPublisherService;

    @GetMapping(value = "/getForPublisherId")
    @ApiOperation(value = "根据标准ID获取发布机构",  produces = "application/json", notes = "获取发布机构")
    public Envelop get(
            @ApiParam(name = "publisherId", value = "机构ID")
            @RequestParam(value = "publisherId") String publisherId) {
        return stdPublisherService.get(publisherId);
    }

    @GetMapping(value = "/getStandardPublisher")
    @ApiOperation(value = "获取发布机构",  produces = "application/json", notes = "获取发布机构")
    public Envelop getStandardPublisher(){
        return stdPublisherService.getStandardPublisher();
    }


    @GetMapping(value = "/getPublishers")
    @ApiOperation(value = "获取发布机构列表",  produces = "application/json", notes = "获取发布机构列表")
    public Envelop getPublishers(
            @ApiParam(name = "condition", value = "Must be Json")
            @RequestParam(value = "condition", required = false) String condition,
            @ApiParam(name = "order", value = "Must be Json")
            @RequestParam(value = "order", required = false) String order,
            @ApiParam(name = "rows", value = "Limit the size of result set. Must be an integer")
            @RequestParam(value = "rows", required = false) Integer rows,
            @ApiParam(name = "page", value = "Start position of result set. Must be an integer")
            @RequestParam(value = "page", required = false) Integer page) {
        return stdPublisherService.getDictionaryResult(condition, order, rows, page);
    }
}
