package com.yihu.jw.basic.standard.controller;



import com.yihu.jw.constants.ServiceApi;
import com.yihu.jw.basic.standard.model.standard.StdDatasetRelation;
import com.yihu.jw.basic.standard.model.standard.StdIndex;
import com.yihu.jw.basic.standard.service.bo.StandardVersion;
import com.yihu.jw.basic.standard.service.standard.StdRelationService;
import com.yihu.jw.restmodel.ehr.standard.MStdDatasetRelation;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.ListEnvelop;
import com.yihu.jw.restmodel.web.PageEnvelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

@Api(value = "stdRelation", tags = "标准关联关系相关")
@RestController("StdRelationController")
public class StdRelationController extends EnvelopRestEndpoint {

    @Autowired
    private StdRelationService stdRelationService;

    @ApiOperation("获取列表数据(分页)")
    @RequestMapping(value = ServiceApi.StdRelation.List, method = RequestMethod.GET)
    public Envelop getList(
            @ApiParam(name = "fields", value = "返回的字段，为空返回全部字段")
            @RequestParam(value = "fields", required = false) String fields,
            @ApiParam(name = "filters", value = "过滤器，为空检索所有条件")
            @RequestParam(value = "filters", required = false) String filters,
            @ApiParam(name = "sorts", value = "排序，规则参见说明文档")
            @RequestParam(value = "sorts", required = false) String sorts,
            @ApiParam(name = "rows", value = "分页大小", defaultValue = "15")
            @RequestParam(value = "rows", required = false) int rows,
            @ApiParam(name = "page", value = "页码", defaultValue = "1")
            @RequestParam(value = "page", required = false) int page,
            @ApiParam(name = "version", value = "版本")
            @RequestParam(value = "version") String version) throws IOException {
        List<StdDatasetRelation> responseEntity = stdRelationService.searchPage(StdIndex.class, StandardVersion.StdIndexTable,version, filters, sorts, page, rows,true);
        List<StdDatasetRelation> all = stdRelationService.searchPage(StdIndex.class, StandardVersion.StdIndexTable,version, filters, sorts, null, null,true);
        Long count = (long) all.size();
        List<MStdDatasetRelation> list = (List<MStdDatasetRelation>) convertToModels(responseEntity, new ArrayList<MStdDatasetRelation>(responseEntity.size()), MStdDatasetRelation.class, null);

        return PageEnvelop.getSuccessListWithPage("查询成功",list,page,rows,count);
    }

    @ApiOperation("获取列表数据(不分页)")
    @RequestMapping(value = ServiceApi.StdRelation.ListNoPage, method = RequestMethod.GET)
    public Envelop getListNoPage(
            @ApiParam(name = "fields", value = "返回的字段，为空返回全部字段")
            @RequestParam(value = "fields", required = false) String fields,
            @ApiParam(name = "filters", value = "过滤器，为空检索所有条件")
            @RequestParam(value = "filters", required = false) String filters,
            @ApiParam(name = "sorts", value = "排序，规则参见说明文档")
            @RequestParam(value = "sorts", required = false) String sorts,
            @ApiParam(name = "version", value = "版本")
            @RequestParam(value = "version") String version) throws IOException {
        List<StdDatasetRelation> responseEntity = stdRelationService.searchPage(StdDatasetRelation.class, StandardVersion.StdRelationTable,version, filters, sorts, null, null,true);
        List<MStdDatasetRelation> list = (List<MStdDatasetRelation>) convertToModels(responseEntity, new ArrayList<MStdDatasetRelation>(responseEntity.size()), MStdDatasetRelation.class, null);
        return ListEnvelop.getSuccess("查询成功",list);
    }

    @ApiOperation("保存/修改标准关联关系")
    @RequestMapping(value = ServiceApi.StdRelation.Modify, method = RequestMethod.POST)
    public Envelop modify(@ApiParam(name = "list", value = "json字符串")
                          @RequestParam(value = "list") String list,
                          @ApiParam(name = "version", value = "版本号")
                          @RequestParam(value = "version") String version){
        Envelop envelop = new Envelop();
        try {
            List<StdDatasetRelation> stdDatasetRelations = Arrays.asList(objectMapper.readValue(list, StdDatasetRelation[].class));
            stdRelationService.modifyRelation(version,stdDatasetRelations);
            envelop.setStatus(200);
            envelop.setMessage("操作成功");
        } catch (Exception e) {
            e.printStackTrace();
            envelop.setStatus(-1);
            envelop.setMessage("操作失败");
        }
        return envelop;
    }

}
