package com.yihu.jw.basic.standard.model.standard;


import javax.persistence.*;
import java.io.Serializable;
import java.util.Objects;

/**
 * Created by wq on 2015/9/16.
 */

@MappedSuperclass
public class StdDataSetModel implements Serializable {
    @Id
    @GeneratedValue(strategy = GenerationType.IDENTITY)
    @Column(name = "id")
    private Long id;

    @Column(name="document_id")
    private Long documentId;

    @Column(name = "code")
    private String code;

    @Column(name = "name")
    private String name;

    @Column(name = "language")
    private String language;

    @Column(name = "catalog")
    private Integer catalog;

    @Column(name = "summary")
    private String summary;

    @Column(name = "class_model")
    private String classModel;

    @Column(name="ref_standard")
    private String reference;

    @Column(name = "lang", unique = false, nullable = true)
    private Integer lang;

    @Column(name = "publisher", unique = false, nullable = false)
    private Integer publisher;

    @Column(name = "multi_record", nullable = false)
    private boolean multiRecord;

    @Column(name = "std_version", unique = false, nullable = true)
    private String stdVersion;

    @Column(name = "hash", unique = false, nullable = true)
    private Integer hashCode;

    @Column(name="std_id")
    private Long standardId;

    @Transient
    private String innerVersionId;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }


    public String getLanguage() {
        return language;
    }

    public void setLanguage(String language) {
        this.language = language;
    }

    public Integer getCatalog() {
        return catalog;
    }

    public void setCatalog(Integer catalog) {
        this.catalog = catalog;
    }

    public String getSummary() {
        return summary;
    }

    public void setSummary(String summary) {
        this.summary = summary;
    }


    public String getClassModel() {
        return classModel;
    }

    public void setClassModel(String classModel) {
        this.classModel = classModel;
    }

    public Integer getHashCode() {
        hashCode = Objects.hash( catalog, lang, standardId,
                publisher, stdVersion, code, name, summary);

        return hashCode;
    }

    public void setHashCode(Integer hashCode) {
        this.hashCode = hashCode;
    }

    public Integer getLang() {
        return lang;
    }

    public void setLang(Integer lang) {
        this.lang = lang;
    }

    public boolean isMultiRecord() {
        return multiRecord;
    }

    public void setMultiRecord(boolean multiRecord) {
        this.multiRecord = multiRecord;
    }

    public Integer getPublisher() {
        return publisher;
    }

    public void setPublisher(Integer publisher) {
        this.publisher = publisher;
    }

    public String getStdVersion() {
        return stdVersion;
    }

    public void setStdVersion(String stdVersion) {
        this.stdVersion = stdVersion;
    }

    public Long getDocumentId() {
        return documentId;
    }

    public void setDocumentId(Long documentId) {
        this.documentId = documentId;
    }

    public String getReference() {
        return reference;
    }

    public void setReference(String reference) {
        this.reference = reference;
    }

    public String getInnerVersionId() {
        return innerVersionId;
    }

    public void setInnerVersionId(String innerVersionId) {
        this.innerVersionId = innerVersionId;
    }

    public Long getStandardId() {
        return standardId;
    }

    public void setStandardId(Long standardId) {
        this.standardId = standardId;
    }
}
