package com.yihu.jw.basic.standard.service.standard;

import com.fasterxml.jackson.databind.JsonNode;

import com.yihu.jw.basic.standard.dao.SQLGeneralDAO;
import com.yihu.jw.basic.standard.model.standard.StdDataSetModel;
import com.yihu.jw.basic.standard.model.standard.StdIndex;
import com.yihu.jw.basic.standard.model.standard.resultModel.MStdIndex;
import com.yihu.jw.basic.standard.service.bo.StandardVersion;
import com.yihu.jw.util.sql.SqlCreator;
import org.hibernate.query.NativeQuery;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.CollectionUtils;

import javax.annotation.Resource;
import java.io.IOException;
import java.util.List;


@Transactional
@Service
public class StdIndexService extends SQLGeneralDAO {
    @Resource
    private StdDatasetService stdDatasetService;

    public void save(String indexJson) throws Exception {
        MStdIndex mStdIndex = objectMapper.readValue(indexJson, MStdIndex.class);
        String version = mStdIndex.getVersion();
        Long stdDatasetId = mStdIndex.getStdDatasetId();
        //通过id查找stdDatasetCode
        StdDataSetModel stdDataSetModel = stdDatasetService.get(new StandardVersion(version), stdDatasetId);
        if(stdDataSetModel!=null){
            mStdIndex.setStdDatasetCode(stdDataSetModel.getCode());
        }else{
            throw new Exception("未找到数据集");
        }
        JsonNode jsonNode = objectMapper.readTree(objectMapper.writeValueAsString(mStdIndex));
        SqlCreator sqlCreator = new SqlCreator(StdIndex.class);
        String sql = sqlCreator.insertData("std_index_"+version, jsonNode);
        NativeQuery query = getExeuteQuery(sqlCreator, sql);
        query.executeUpdate();
    }

    public void update(String indexJson) throws IOException {
        MStdIndex mStdIndex = objectMapper.readValue(indexJson, MStdIndex.class);
        String version = mStdIndex.getVersion();
        JsonNode jsonNode = objectMapper.readTree(indexJson);
        SqlCreator sqlCreator = new SqlCreator(StdIndex.class);
        String sql = sqlCreator.updateDataByTableKey("std_index_"+version, jsonNode);
        NativeQuery query = getExeuteQuery(sqlCreator, sql);
        query.executeUpdate();
    }


    public boolean isUnique(String filters, String version) throws IOException {
        List<StdIndex> list = searchPage(StdIndex.class, StandardVersion.StdIndexTable,version, filters, null, null, null,true);
        return !CollectionUtils.isEmpty(list);
    }
}

