package com.yihu.jw.basic.system.controller;


import com.yihu.jw.basic.system.model.SystemDict;
import com.yihu.jw.basic.system.model.SystemDictList;
import com.yihu.jw.basic.system.service.BaseDictManager;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import io.swagger.annotations.Api;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;


/**
 * Created by hzp on 2016/01/11.
 */
@RequestMapping("/basedict")
@RestController
@Api(value = "basedict", tags = "基础字典相关")
public class BaseDictController extends EnvelopRestEndpoint {

    @Autowired
    private BaseDictManager dictManager;



    /****************** 字典目录 *****************************/
    /**
     * 获取字典目录
     */
    @GetMapping("getDictList")
    public Envelop getDictList(String condition, int page, int rows) {
        try {
            return dictManager.getSystemDictList(condition, page, rows);
        }
        catch (Exception e){
            e.printStackTrace();
            return failed("查询失败");
        }
    }

    /**
     * 新增字典
     */
    @PostMapping("addDict")
    public Envelop addDict() {
        try {
            SystemDictList dict = new SystemDictList();
            return dictManager.addDict(dict);
        }
        catch (Exception e){
            e.printStackTrace();
            return failed("新增失败");
        }
    }

    /**
     * 修改字典
     */
    @PostMapping("updateDict")
    public Envelop updateDict() {
        try {
            SystemDictList dict = new SystemDictList();
            return dictManager.updateDict(dict);
        }
        catch (Exception e){
            e.printStackTrace();
            return failed("修改失败");
        }
    }

    /**
     * 删除字典
     */
    @PostMapping("deleteDict")
    public Envelop deleteDict() {
        try {
            SystemDictList dict = new SystemDictList();
            return dictManager.deleteDict(dict);
        }
        catch (Exception e){
            e.printStackTrace();
            return failed("删除失败");
        }
    }

    /****************** 字典维护 *****************************/

    /**
     * 根据字典名称获取字典项(常用)
     */
    @GetMapping(value = "getDict",produces = "application/json")
    public Envelop getDict(String name,String where,String type) {
        try {
            return dictManager.getDict(name, where, type);
        }
        catch (Exception e){
            e.printStackTrace();
            return failed("查询失败");
        }
    }


    /**
     * 新增字典项
     */
    @PostMapping("addDictItem")
    public Envelop addDictItem() {
        try {
            SystemDict dict = new SystemDict();
            return dictManager.addDictItem(dict);
        }
        catch (Exception e){
            e.printStackTrace();
            return failed("新增失败");
        }
    }

    /**
     * 新增字典项
     */
    @PostMapping("updateDictItem")
    public Envelop updateDictItem() {
        try {
            SystemDict dict = new SystemDict();
            return dictManager.updateDictItem(dict);
        }
        catch (Exception e){
            e.printStackTrace();
            return failed("修改失败");
        }
    }

    /**
     * 删除字典项
     */
    @PostMapping("deleteDictItem")
    public Envelop deleteDictItem() {
        try {
            SystemDict dict = new SystemDict();
            return dictManager.deleteDictItem(dict);
        }
        catch (Exception e){
            e.printStackTrace();
            return failed("删除失败");
        }
    }
}
