package com.yihu.jw.basic.system.controller;


import com.yihu.jw.basic.system.model.SystemDict;
import com.yihu.jw.basic.system.model.SystemDictList;
import com.yihu.jw.basic.system.service.DictManager;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.ObjEnvelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import io.swagger.annotations.Api;
import org.apache.commons.beanutils.BeanUtils;
import org.springframework.stereotype.Controller;
import org.springframework.util.StringUtils;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import java.util.HashMap;
import java.util.Map;

/**
 * Created by chenweida on 2016/1/20.
 */
@RestController
@RequestMapping("/dict")
@Api(value = "DictController", tags = "esb字典相关")
public class DictController extends EnvelopRestEndpoint {
    @Resource(name = DictManager.BEAN_ID)
    private DictManager dictManager;


    @GetMapping("/dictDialog")
    public Envelop resourceRestDialog(String id, String mode) {
        SystemDictList sdl;
        try {
            if ("view".equals(mode)) {
                sdl = dictManager.getSystemDictListById(id);
            } else if ("modify".equals(mode)) {
                sdl = dictManager.getSystemDictListById(id);
            } else {
                sdl = new SystemDictList();
            }
            return ObjEnvelop.getSuccess("查询成功",sdl);
        } catch (Exception e) {
            e.printStackTrace();
            return failed("查询失败");
        }
    }

    @GetMapping("/dictItemDialog")
    public Envelop resourceRestDetailDialog(String id, String mode, String dictName) {
        SystemDict sd = null;
        try {
            if ("view".equals(mode)) {
                sd = dictManager.getSystemDictById(id);
            } else if ("modify".equals(mode)) {
                sd = dictManager.getSystemDictById(id);
            } else {
                sd = new SystemDict();
                // sd.setInnerCode(chineseName);
                sd.setDictName(dictName);

            }
            return ObjEnvelop.getSuccess("查询成功",sd);
        } catch (Exception e) {
            e.printStackTrace();
            return failed("查询失败");
        }
    }

    /**
     * 获取字典列表
     */
    @GetMapping("/getDictList")
    public Envelop getDictList(HttpServletRequest request) {
        try {
            Map<String, Object> params = new HashMap<>();
            String name = request.getParameter("name");
            params.put("name", name);
            String page = StringUtils.isEmpty(request.getParameter("page")) ? "1" : request.getParameter("page");
            String rows = StringUtils.isEmpty(request.getParameter("rows")) ? "10" : request.getParameter("rows");

            params.put("page", page);
            params.put("rows", rows);

            return dictManager.getDictList(params);
        } catch (Exception ex) {
            ex.printStackTrace();
            return failed("查询失败");
        }
    }


    @PostMapping("/deleteDict")
    public Envelop deleteDict(HttpServletRequest request) {
        try {
            String id = request.getParameter("id");
            return dictManager.deleteDict(id);
        } catch (Exception e) {
            e.printStackTrace();
            return Envelop.getError("删除失败");
        }

    }

    @PostMapping("/addDict")
    public Envelop addDict(HttpServletRequest request) {
        try {
            SystemDictList rr = new SystemDictList();
            BeanUtils.populate(rr, request.getParameterMap());
            return dictManager.addDict(rr);
        } catch (Exception e) {
            e.printStackTrace();
            return Envelop.getError("新增失败");
        }

    }

    @PostMapping("/updateDict")
    public Envelop updateDict(HttpServletRequest request) {
        try {
            SystemDictList rr = new SystemDictList();
            BeanUtils.populate(rr, request.getParameterMap());
            return dictManager.updateDict(rr);
        } catch (Exception e) {
            e.printStackTrace();
            return Envelop.getError("更新失败");
        }

    }


    //-------------------------字典项----------------------------

    /**
     * 获取字典列表
     */
    @GetMapping("/getDictItemList")
    public Envelop getDictItemList(HttpServletRequest request) {
        try {
            Map<String, Object> params = new HashMap<>();
            String name = request.getParameter("name");
            String dictId = request.getParameter("dictId");
            params.put("name", name);
            String page = StringUtils.isEmpty(request.getParameter("page")) ? "1" : request.getParameter("page");
            String rows = StringUtils.isEmpty(request.getParameter("rows")) ? "10" : request.getParameter("rows");

            params.put("dictId", dictId);
            params.put("page", page);
            params.put("rows", rows);

            return dictManager.getDictItemList(params);
        } catch (Exception ex) {
            ex.printStackTrace();
            return Envelop.getError(ex.getMessage());
        }
    }


    @PostMapping("/deleteDictItem")
    public Envelop deleteDictItem(HttpServletRequest request) {
        try {
            String id = request.getParameter("id");
            return dictManager.deleteDictItem(id);
        } catch (Exception e) {
            e.printStackTrace();
            return Envelop.getError("删除失败");
        }

    }

    @PostMapping("/addDictItem")
    public Envelop addDictItem(HttpServletRequest request) {
        try {
            SystemDict rr = new SystemDict();
            BeanUtils.populate(rr, request.getParameterMap());
            return dictManager.addDictItem(rr);
        } catch (Exception e) {
            e.printStackTrace();
            return Envelop.getError("新增失败");
        }

    }

    @PostMapping("/updateDictItem")
    public Envelop updateDictItem(HttpServletRequest request) {
        try {
            SystemDict rr = new SystemDict();
            BeanUtils.populate(rr, request.getParameterMap());
            return dictManager.updateDictItem(rr);
        } catch (Exception e) {
            e.printStackTrace();
            return Envelop.getError("更新失败");
        }
    }

}
