package com.yihu.jw.basic.user.dao;

import com.yihu.jw.entity.ehr.user.UserTypeRoles;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.repository.query.Param;

import java.util.List;

public interface XUserTypeRolesRepository extends JpaRepository<UserTypeRoles, String> {

    UserTypeRoles findById(int id);

    List<UserTypeRoles> findByTypeId(int typeId);

    @Modifying
    @Query("delete from UserTypeRoles r where r.typeId = :typeId")
    void deleteUserTypeRolesByTypeId(@Param("typeId") Long typeId);

    @Query("select r from UserTypeRoles r where r.typeId = :typeId and r.clientId=:clientId")
    List<UserTypeRoles> ListUserTypeRolesByTypeIdAndClientId(@Param("typeId") int typeId,@Param("clientId")String clientId);

}
