package com.yihu.jw.door.controller.doctor;


import com.yihu.jw.door.controller.BaseController;
import com.yihu.jw.door.service.statics.DoorStatisticAnalyzeService;
import com.yihu.jw.es.util.ElasticsearchUtil;
import com.yihu.jw.util.date.DateUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.apache.commons.lang.StringUtils;
import org.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletResponse;
import java.util.List;
import java.util.Map;

/**
 * @author liuwenbin on 2019/3/21.
 */
@Controller
@RequestMapping(value = "/doctor/statisticAnalyze", produces = MediaType.APPLICATION_JSON_UTF8_VALUE)
@Api(description = "医生端-上门服务-统计分析")
public class DoorStatisticAnalyzeController extends BaseController {
    @Autowired
    private DoorStatisticAnalyzeService doorStatisticAnalyzeService;
    @Autowired
    ElasticsearchUtil elasticsearchUtil;

    /*********************************************app端 start*******************************************************************/
    @GetMapping("/doorQualificationAnalyzeHead")
    @ResponseBody
    @ApiOperation(value = "资质分析-app-头部")
    public String doorQualificationAnalyzeHead(
            @ApiParam(name = "area", value = "区域code：如思明区350203",required = true)
            @RequestParam(value = "area", required = true) String area,
            @ApiParam(name = "startDate", value = "搜索，开始时间",required = false)
            @RequestParam(value = "startDate", required = false) String startDate,
            @ApiParam(name = "endDate", value = "搜索，结束时间",required = false)
            @RequestParam(value = "endDate", required = false) String endDate,
            @ApiParam(name="level",value="1 省 2 市 3 区县 4 机构 5团队",defaultValue = "")@RequestParam(required = true) Integer level
    ){

        try{
            if(StringUtils.isEmpty(endDate)){
                endDate = DateUtil.getStringDate();
            }
            Map<String,Object> result = doorStatisticAnalyzeService.doorQualificationAnalyzeHead(area,startDate,endDate,level);
            return write(200,"获取成功！","data",result);
        }catch (Exception e){
            e.printStackTrace();
            return error(-1,"当前时间段还未统计");
        }
    }

    @GetMapping("/doorQualificationAnalyzeList")
    @ResponseBody
    @ApiOperation(value = "资质分析-app-列表")
    public String doorQualificationAnalyzeList(
            @ApiParam(name = "area", value = "区域code：如思明区350203",required = true)
            @RequestParam(value = "area", required = true) String area,
            @ApiParam(name = "startDate", value = "搜索，开始时间",required = false)
            @RequestParam(value = "startDate", required = false) String startDate,
            @ApiParam(name = "endDate", value = "搜索，结束时间",required = false)
            @RequestParam(value = "endDate", required = false) String endDate,
            @RequestParam(required = false) String lowLevel,
            @ApiParam(name="level",value="1 省 2 市 3 区县 4 机构 5科室 6医生",defaultValue = "")@RequestParam(required = true) Integer level
    ){

        try{

            if(StringUtils.isEmpty(endDate)){
                endDate = DateUtil.getStringDate();
            }
            List<Map<String,Object>> result = doorStatisticAnalyzeService.doorQualificationAnalyzeList(area,startDate,endDate,level,lowLevel);
            return write(200,"获取成功！","data",result);
        }catch (Exception e){
            e.printStackTrace();
            return error(-1,"当前时间段还未统计");
        }
    }

    @GetMapping("/subsidyExpenseList")
    @ResponseBody
    @ApiOperation(value = "补助费用-app-列表")
    public String subsidyExpenseList(
            @ApiParam(name = "area", value = "区域code：如思明区350203",required = true)
            @RequestParam(value = "area", required = true) String area,
            @ApiParam(name = "startDate", value = "搜索，开始时间",required = false)
            @RequestParam(value = "startDate", required = false) String startDate,
            @ApiParam(name = "endDate", value = "搜索，结束时间",required = false)
            @RequestParam(value = "endDate", required = false) String endDate,
            @RequestParam(required = false) String lowLevel,
            @ApiParam(name="level",value="1 省 2 市 3 区县 4 机构 5科室 6医生",defaultValue = "")@RequestParam(required = true) Integer level
    ){
        try{

            if(StringUtils.isEmpty(endDate)){
                endDate = DateUtil.getStringDate();
            }
            List<Map<String,Object>> result = doorStatisticAnalyzeService.subsidyExpenseList(area,startDate,endDate,level,lowLevel);
            return write(200,"获取成功！","data",result);
        }catch (Exception e){
            e.printStackTrace();
            return error(-1,"当前时间段还未统计");
        }
    }

    @GetMapping("/subsidyExpenseHead")
    @ResponseBody
    @ApiOperation(value = "补助费用-app-头部")
    public String subsidyExpenseHead(
            @ApiParam(name = "area", value = "区域code：如思明区350203",required = true)
            @RequestParam(value = "area", required = true) String area,
            @ApiParam(name = "startDate", value = "搜索，开始时间",required = false)
            @RequestParam(value = "startDate", required = false) String startDate,
            @ApiParam(name = "endDate", value = "搜索，结束时间",required = false)
            @RequestParam(value = "endDate", required = false) String endDate,
            @ApiParam(name="level",value="1 省 2 市 3 区县 4 机构 5科室 6医生",defaultValue = "")@RequestParam(required = true) Integer level
    ){
        try{

            if(StringUtils.isEmpty(endDate)){
                endDate = DateUtil.getStringDate();
            }
            Map<String,Object> result = doorStatisticAnalyzeService.subsidyExpenseHead(area,startDate,endDate,level);
            return write(200,"获取成功！","data",result);
        }catch (Exception e){
            e.printStackTrace();
            return error(-1,"当前时间段还未统计");
        }
    }

    @GetMapping("/doorServiceOrderAnalyzeHead")
    @ResponseBody
    @ApiOperation(value = "服务工单分析-app-头部")
    public String doorServiceOrderAnalyzeHead(
            @ApiParam(name = "area", value = "区域code：如思明区350203",required = true)
            @RequestParam(value = "area", required = true) String area,
            @ApiParam(name = "startDate", value = "搜索，开始时间",required = false)
            @RequestParam(value = "startDate", required = false) String startDate,
            @ApiParam(name = "endDate", value = "搜索，结束时间",required = false)
            @RequestParam(value = "endDate", required = false) String endDate,
            @ApiParam(name = "type", value = "发起类型（1本人发起 2家人待预约 3医生代预约）",required = false)
            @RequestParam(value = "type", required = false) Integer type,
            @ApiParam(name="level",value="1 省 2 市 3 区县 4 机构 5科室 6医生",defaultValue = "")@RequestParam(required = true) Integer level
    ){
        try{

            if(StringUtils.isEmpty(endDate)){
                endDate = DateUtil.getStringDate();
            }
            Map<String,Object> result = doorStatisticAnalyzeService.doorServiceOrderAnalyzeHead(area,startDate,endDate, type,level);
            return write(200,"获取成功！","data",result);
        }catch (Exception e){
            e.printStackTrace();
            return error(-1,"当前时间段还未统计");
        }
    }

    @GetMapping("/doorServiceOrderAnalyzeList")
    @ResponseBody
    @ApiOperation(value = "服务工单分析-app-列表")
    public String doorServiceOrderAnalyzeList(
            @ApiParam(name = "area", value = "区域code：如思明区350203",required = true)
            @RequestParam(value = "area", required = true) String area,
            @ApiParam(name = "startDate", value = "搜索，开始时间",required = false)
            @RequestParam(value = "startDate", required = false) String startDate,
            @ApiParam(name = "endDate", value = "搜索，结束时间",required = false)
            @RequestParam(value = "endDate", required = false) String endDate,
            @RequestParam(required = false) String lowLevel,
            @ApiParam(name = "type", value = "发起类型（1本人发起 2家人待预约 3医生代预约）",required = false)
            @RequestParam(value = "type", required = false) Integer type,
            @ApiParam(name="level",value="1 省 2 市 3 区县 4 机构 5科室 6医生",defaultValue = "")@RequestParam(required = true) Integer level
    ){
        try{

            if(StringUtils.isEmpty(endDate)){
                endDate = DateUtil.getStringDate();
            }
            List<Map<String,Object>> result = doorStatisticAnalyzeService.doorServiceOrderAnalyzeList(area,startDate,endDate, type,level,lowLevel);
            return write(200,"获取成功！","data",result);
        }catch (Exception e){
            e.printStackTrace();
            return error(-1,"当前时间段还未统计");
        }
    }

    @GetMapping("/doorResponseAnalyzeHead")
    @ResponseBody
    @ApiOperation(value = "响应速度分析-app-头部")
    public String doorResponseAnalyzeHead(
            @ApiParam(name = "area", value = "区域code：如思明区350203",required = true)
            @RequestParam(value = "area", required = true) String area,
            @ApiParam(name = "startDate", value = "搜索，开始时间",required = false)
            @RequestParam(value = "startDate", required = false) String startDate,
            @ApiParam(name = "endDate", value = "搜索，结束时间",required = false)
            @RequestParam(value = "endDate", required = false) String endDate,
            @ApiParam(name = "roleType", value = "1、调度员，2、服务医生",required = true)
            @RequestParam(value = "roleType", required = true) Integer roleType,
            @ApiParam(name="level",value="1 省 2 市 3 区县 4 机构 5科室 6医生",defaultValue = "")@RequestParam(required = true) Integer level
    ){

        try{

            if(StringUtils.isEmpty(endDate)){
                endDate = DateUtil.getStringDate();
            }
            Map<String,Object> result = doorStatisticAnalyzeService.doorResponseAnalyzeHead(area,startDate,endDate,roleType, level);
            return write(200,"获取成功！","data",result);
        }catch (Exception e){
            e.printStackTrace();
            return error(-1,"当前时间段还未统计");
        }
    }

    @GetMapping("/doorResponseAnalyzeList")
    @ResponseBody
    @ApiOperation(value = "响应速度分析-app-列表")
    public String doorResponseAnalyzeList(
            @ApiParam(name = "area", value = "区域code：如思明区350203",required = true)
            @RequestParam(value = "area", required = true) String area,
            @ApiParam(name = "startDate", value = "搜索，开始时间",required = false)
            @RequestParam(value = "startDate", required = false) String startDate,
            @ApiParam(name = "endDate", value = "搜索，结束时间",required = false)
            @RequestParam(value = "endDate", required = false) String endDate,
            @RequestParam(required = false) String lowLevel,
            @ApiParam(name = "roleType", value = "1、调度员，2、服务医生",required = true)
            @RequestParam(value = "roleType", required = true) Integer roleType,
            @ApiParam(name="level",value="1 省 2 市 3 区县 4 机构 5科室 6医生",defaultValue = "")@RequestParam(required = true) Integer level
    ){
        try{

            if(StringUtils.isEmpty(endDate)){
                endDate = DateUtil.getStringDate();
            }
            List<Map<String,Object>> result = doorStatisticAnalyzeService.doorResponseAnalyzeList(area,startDate,endDate,roleType, level,lowLevel);
            return write(200,"获取成功！","data",result);
        }catch (Exception e){
            e.printStackTrace();
            return error(-1,"当前时间段还未统计");
        }
    }


    /*********************************************app端 end *******************************************************************/

    @GetMapping("/doorQualificationAnalyze")
    @ResponseBody
    @ApiOperation(value = "资质分析")
    public String doorQualificationAnalyze(
            @ApiParam(name = "area", value = "区域code：如思明区350203",required = false)
            @RequestParam(value = "area", required = false) String area,
            @ApiParam(name = "startDate", value = "搜索，开始时间",required = false)
            @RequestParam(value = "startDate", required = false) String startDate,
            @ApiParam(name = "endDate", value = "搜索，结束时间",required = false)
            @RequestParam(value = "endDate", required = false) String endDate
    ){

        try{
            if(StringUtils.isEmpty(endDate)){
                endDate = DateUtil.getStringDate();
            }
            List<Map<String,Object>> result = doorStatisticAnalyzeService.doorQualificationAnalyze(area,startDate,endDate);
            return write(200,"获取成功！","data",result);
        }catch (Exception e){
            e.printStackTrace();
            return error(-1,"当前时间段还未统计");
        }
    }

    @GetMapping("/doorResponseAnalyze")
    @ResponseBody
    @ApiOperation(value = "响应速度分析")
    public String doorResponseAnalyze(
            @ApiParam(name = "area", value = "区域code：如思明区350203",required = false)
            @RequestParam(value = "area", required = false) String area,
            @ApiParam(name = "startDate", value = "搜索，开始时间",required = false)
            @RequestParam(value = "startDate", required = false) String startDate,
            @ApiParam(name = "endDate", value = "搜索，结束时间",required = false)
            @RequestParam(value = "endDate", required = false) String endDate,
            @ApiParam(name = "roleType", value = "1、调度员，2、服务医生",required = true)
            @RequestParam(value = "roleType", required = true) Integer roleType,
            @ApiParam(name = "type", value = "发起类型（1本人发起 2家人待预约 3医生代预约）",required = false)
            @RequestParam(value = "type", required = false) Integer type
    ){
        try{
            if(StringUtils.isEmpty(endDate)){
                endDate = DateUtil.getStringDate();
            }
            List<Map<String,Object>> result = doorStatisticAnalyzeService.doorResponseAnalyze(area,startDate,endDate,roleType, type);
            return write(200,"获取成功！","data",result);
        }catch (Exception e){
            e.printStackTrace();
            return error(-1,"当前时间段还未统计");
        }
    }

    @GetMapping("/doorServiceOrderAnalyze")
    @ResponseBody
    @ApiOperation(value = "服务工单分析")
    public String doorServiceOrderAnalyze(
            @ApiParam(name = "area", value = "区域code：如思明区350203",required = false)
            @RequestParam(value = "area", required = false) String area,
            @ApiParam(name = "startDate", value = "搜索，开始时间",required = false)
            @RequestParam(value = "startDate", required = false) String startDate,
            @ApiParam(name = "endDate", value = "搜索，结束时间",required = false)
            @RequestParam(value = "endDate", required = false) String endDate,
            @ApiParam(name = "type", value = "发起类型（1本人发起 2家人待预约 3医生代预约）",required = false)
            @RequestParam(value = "type", required = false) Integer type
    ){
        try{
            if(StringUtils.isEmpty(endDate)){
                endDate = DateUtil.getStringDate();
            }
            List<Map<String,Object>> result = doorStatisticAnalyzeService.doorServiceOrderAnalyze(area,startDate,endDate, type);
            return write(200,"获取成功！","data",result);
        }catch (Exception e){
            e.printStackTrace();
            return error(-1,"当前时间段还未统计");
        }
    }

    @GetMapping("/subsidyExpense")
    @ResponseBody
    @ApiOperation(value = "补助费用")
    public String subsidyExpense(
            @ApiParam(name = "area", value = "区域code：如思明区350203",required = false)
            @RequestParam(value = "area", required = false) String area,
            @ApiParam(name = "startDate", value = "搜索，开始时间",required = false)
            @RequestParam(value = "startDate", required = false) String startDate,
            @ApiParam(name = "endDate", value = "搜索，结束时间",required = false)
            @RequestParam(value = "endDate", required = false) String endDate
    ){
        try{
            if(StringUtils.isEmpty(endDate)){
                endDate = DateUtil.getStringDate();
            }
            List<Map<String,Object>> result = doorStatisticAnalyzeService.subsidyExpense(area,startDate,endDate);
            return write(200,"获取成功！","data",result);
        }catch (Exception e){
            e.printStackTrace();
            return error(-1,"当前时间段还未统计");
        }
    }

    /*********************************************导出excel*******************************************************************/

    @ApiOperation(value = "资质分析导出excel")
    @GetMapping(value = "/doorQualificationAnalyzeExport")
    public void doorQualificationAnalyzeExport(
            @ApiParam(name = "area", value = "区域code：如思明区350203",required = false)
            @RequestParam(value = "area", required = false) String area,
            @ApiParam(name = "startDate", value = "搜索，开始时间",required = false)
            @RequestParam(value = "startDate", required = false) String startDate,
            @ApiParam(name = "endDate", value = "搜索，结束时间",required = false)
            @RequestParam(value = "endDate", required = false) String endDate,
            HttpServletResponse response
    ){
        try{
            if(StringUtils.isEmpty(endDate)){
                endDate = DateUtil.getStringDate();
            }
            doorStatisticAnalyzeService.doorQualificationAnalyzeExport(area,startDate,endDate,response);
        }catch (Exception e){
            e.printStackTrace();
        }
    }

    @ApiOperation(value = "响应速度分析导出excel")
    @GetMapping(value = "/doorResponseAnalyzeExport")
    public void doorResponseAnalyzeExport(
            @ApiParam(name = "area", value = "区域code：如思明区350203",required = false)
            @RequestParam(value = "area", required = false) String area,
            @ApiParam(name = "startDate", value = "搜索，开始时间",required = false)
            @RequestParam(value = "startDate", required = false) String startDate,
            @ApiParam(name = "endDate", value = "搜索，结束时间",required = false)
            @RequestParam(value = "endDate", required = false) String endDate,
            @ApiParam(name = "roleType", value = "1、调度员，2、服务医生",required = true)
            @RequestParam(value = "roleType", required = true) Integer roleType,
            @ApiParam(name = "type", value = "发起类型（1本人发起 2家人待预约 3医生代预约）",required = false)
            @RequestParam(value = "type", required = false) Integer type,
            HttpServletResponse response
    ){
        try{
            if(StringUtils.isEmpty(endDate)){
                endDate = DateUtil.getStringDate();
            }
            doorStatisticAnalyzeService.doorResponseAnalyzeExport(area,startDate,endDate,roleType,response, type);
        }catch (Exception e){
            e.printStackTrace();
        }
    }

    @ApiOperation(value = "补助费用导出excel")
    @GetMapping(value = "/subsidyExpenseExport")
    public void subsidyExpenseExport(
            @ApiParam(name = "area", value = "区域code：如思明区350203",required = false)
            @RequestParam(value = "area", required = false) String area,
            @ApiParam(name = "startDate", value = "搜索，开始时间",required = false)
            @RequestParam(value = "startDate", required = false) String startDate,
            @ApiParam(name = "endDate", value = "搜索，结束时间",required = false)
            @RequestParam(value = "endDate", required = false) String endDate,
            HttpServletResponse response
    ){
        try{
            if(StringUtils.isEmpty(endDate)){
                endDate = DateUtil.getStringDate();
            }
            doorStatisticAnalyzeService.subsidyExpenseExport(area,startDate,endDate,response);
        }catch (Exception e){
            e.printStackTrace();
        }
    }

    @ApiOperation(value = "服务工单分析导出excel")
    @GetMapping(value = "/doorServiceOrderAnalyzeExport")
    public void doorServiceOrderAnalyzeExport(
            @ApiParam(name = "area", value = "区域code：如思明区350203",required = false)
            @RequestParam(value = "area", required = false) String area,
            @ApiParam(name = "startDate", value = "搜索，开始时间",required = false)
            @RequestParam(value = "startDate", required = false) String startDate,
            @ApiParam(name = "endDate", value = "搜索，结束时间",required = false)
            @RequestParam(value = "endDate", required = false) String endDate,
            @ApiParam(name = "type", value = "发起类型（1本人发起 2家人待预约 3医生代预约）",required = false)
            @RequestParam(value = "type", required = false) Integer type,
            HttpServletResponse response
    ){
        try{
            if(StringUtils.isEmpty(endDate)){
                endDate = DateUtil.getStringDate();
            }
            doorStatisticAnalyzeService.doorServiceOrderAnalyzeExport(area,startDate,endDate,response, type);
        }catch (Exception e){
            e.printStackTrace();
        }
    }

    @ApiOperation(value = "上门服务工单总体分析")
    @GetMapping(value = "/doorAggregateAnalysis")
    @ResponseBody
    public String doorAggregateAnalysis(
            @ApiParam(name = "area", value = "区域code：如思明区350203，团队641",required = false)
            @RequestParam(value = "area", required = false) String area,
            @ApiParam(name = "level", value = "等级，2市  3区  4社区 5科室 6 医生",required = false)
            @RequestParam(required = true) int level,
            @ApiParam(name = "startDate", value = "搜索，开始时间",required = false)
            @RequestParam(value = "startDate", required = false) String startDate,
            @ApiParam(name = "endDate", value = "搜索，结束时间",required = false)
            @RequestParam(value = "endDate", required = false) String endDate){

        try{
            //默认显示本月
            if(StringUtils.isEmpty(startDate)){
                startDate = DateUtil.getCurMonthFirstDayShort();
            }
            if(StringUtils.isEmpty(endDate)){
                endDate = DateUtil.getStringDate();
            }
            Map<String,Object> map = doorStatisticAnalyzeService.doorAggregateAnalysis(area,level, startDate,endDate);
            return write(200, "查询成功", "data", map);
        }catch (Exception e){
            e.printStackTrace();
            return error(-1, "查询失败");
        }
    }

    @ApiOperation(value = "获取上门服务疾病分析")
    @GetMapping(value = "/getDoorDiagnosisAnalysis")
    @ResponseBody
    public String getDoorDiagnosisAnalysis(
            @ApiParam(name = "area", value = "区域code：如思明区350203，团队641",required = false)
            @RequestParam(value = "area", required = false) String area,
            @ApiParam(name = "level", value = "等级，2市  3区  4社区 5科室 6医生",required = false)
            @RequestParam(required = true) int level,
            @ApiParam(name = "startDate", value = "搜索，开始时间",required = false)
            @RequestParam(value = "startDate", required = false) String startDate,
            @ApiParam(name = "endDate", value = "搜索，结束时间",required = false)
            @RequestParam(value = "endDate", required = false) String endDate,
            @ApiParam(name = "page", value = "第几页",required = true)
            @RequestParam(value = "page", required = true) Integer page,
            @ApiParam(name = "pageSize", value = "页面大小",required = true)
            @RequestParam(value = "pageSize", required = true) Integer pageSize){

        try{
            //默认显示本月
            if(StringUtils.isEmpty(startDate)){
                startDate = DateUtil.getCurMonthFirstDayShort();
            }
            if(StringUtils.isEmpty(endDate)){
                endDate = DateUtil.getStringDate();
            }
            return write(200, "查询成功", "data", doorStatisticAnalyzeService.getOrderByDiagnosis(area, level, startDate, endDate, page, pageSize));
        }catch (Exception e){
            e.printStackTrace();
            return error(-1, "查询失败");
        }
    }

    @ApiOperation(value = "获取上门服务服务项目分析")
    @GetMapping(value = "/getDoorDrugCodeAnalysis")
    @ResponseBody
    public String getDoorDrugCodeAnalysis(
            @ApiParam(name = "area", value = "区域code：如思明区350203，团队641",required = false)
            @RequestParam(value = "area", required = false) String area,
            @ApiParam(name = "level", value = "等级，2市  3区  4社区 5科室 6医生",required = false)
            @RequestParam(required = true) int level,
            @ApiParam(name = "subjectClass", value = "科目类别，010开头为药品，020为服务项目",required = false)
            @RequestParam(value = "subjectClass", required = false) String subjectClass,
            @ApiParam(name = "page", value = "第几页",required = true)
            @RequestParam(value = "page", required = true) Integer page,
            @ApiParam(name = "pageSize", value = "页面大小",required = true)
            @RequestParam(value = "pageSize", required = true) Integer pageSize,
            @ApiParam(name = "startDate", value = "搜索，开始时间",required = false)
            @RequestParam(value = "startDate", required = false) String startDate,
            @ApiParam(name = "endDate", value = "搜索，结束时间",required = false)
            @RequestParam(value = "endDate", required = false) String endDate){

        try{
            //默认显示本月
            if(StringUtils.isEmpty(startDate)){
                startDate = DateUtil.getCurMonthFirstDayShort();
            }
            if(StringUtils.isEmpty(endDate)){
                endDate = DateUtil.getStringDate();
            }
            return write(200, "查询成功", "data", doorStatisticAnalyzeService.getGroupbyDrugCodeList(area, level, subjectClass, page, pageSize, startDate, endDate));
        }catch (Exception e){
            e.printStackTrace();
            return error(-1, "查询失败");
        }
    }

    /**
     * 服务工单排行
     * @param endDate     结束时间
     * @param area        父code
     * @param level       等级   4 市  3区  2社区 1团队
     * @param sort        排序 1倒叙 2是 正序
     * @param lowLevel   等级 1:团队 2社区机构 3区级 4市级
     * @return
     */
    @ApiOperation(value = "获取上门服务工单排行列表")
    @GetMapping("/order_lowlevel_all")
    @ResponseBody
    public String getOrderLowlevelAll(@ApiParam(name = "startDate", value = "搜索，开始时间",required = true)
                                          @RequestParam(value = "startDate") String startDate,
                                      @RequestParam(required = true) String endDate,
                                           @RequestParam(required = true) String area,
                                           @RequestParam(required = true) int level,
                                           @RequestParam(required = true) int sort,
                                           @RequestParam(required = false) String lowLevel,
                                           @RequestParam(required = false) String year) {

        try{
            lowLevel = String.valueOf(org.apache.commons.lang3.StringUtils.isEmpty(lowLevel) ? (level - 1) : lowLevel);
            //新版与旧版统计适配
            level = elasticsearchUtil.changeLevel(level);
            if (org.apache.commons.lang3.StringUtils.isNotEmpty(lowLevel)) {
                lowLevel = elasticsearchUtil.changeLevel(Integer.parseInt(lowLevel)) + "";
            }
            JSONObject result = new JSONObject();
            result.put("index_121",doorStatisticAnalyzeService.getOrderLowlevelAll(startDate, endDate, area, level, sort, lowLevel, year));
            return write(200, "查询成功", "data", result);
        } catch (Exception e) {
            e.printStackTrace();
            return error(-1, "查询失败");
        }
    }

    /*******************************上门服务统计 1.6.8.3 版本 start **************************************************************/
    @ApiOperation(value = "上门服务分析-v1.6.8.3")
    @GetMapping(value = "/doorServiceAnalysis")
    @ResponseBody
    public String doorServiceAnalysis(
            @ApiParam(name = "area", value = "区域code：如思明区350203，团队641",required = false)
            @RequestParam(value = "area", required = false) String area,
            @ApiParam(name = "level", value = "等级，2市  3区  4社区 5团队",required = false)
            @RequestParam(required = true) int level,
            @ApiParam(name = "startDate", value = "搜索，开始时间",required = false)
            @RequestParam(value = "startDate", required = false) String startDate,
            @ApiParam(name = "endDate", value = "搜索，结束时间",required = false)
            @RequestParam(value = "endDate", required = false) String endDate){

        try{
            Map<String,Object> map = doorStatisticAnalyzeService.doorServiceAnalysis(area,level, startDate,endDate);
            return write(200, "查询成功", "data", map);
        }catch (Exception e){
            e.printStackTrace();
            return error(-1, "查询失败");
        }
    }

    @ApiOperation(value = "新增服务工单趋势-v1.6.8.3")
    @GetMapping(value = "/serviceOrderTrend")
    @ResponseBody
    public String serviceOrderTrend(
            @ApiParam(name = "area", value = "区域code：如思明区350203，团队641",required = false)
            @RequestParam(value = "area", required = false) String area,
            @ApiParam(name = "level", value = "等级，2市  3区  4社区 5科室 6医生",required = false)
            @RequestParam(required = true) int level,
            @ApiParam(name="interval",value="统计类型：1按天，2按周，3按月",defaultValue = "")
            @RequestParam(required = true) String interval,
            @ApiParam(name = "startDate", value = "搜索，开始时间",required = true)
            @RequestParam(value = "startDate", required = false) String startDate,
            @ApiParam(name = "endDate", value = "搜索，结束时间",required = true)
            @RequestParam(value = "endDate", required = false) String endDate){

        try{
            List<Map<String,Object>> list = doorStatisticAnalyzeService.serviceOrderTrend(area,level, startDate,endDate,interval);
            return write(200, "查询成功", "data", list);
        }catch (Exception e){
            e.printStackTrace();
            return error(-1, "查询失败");
        }
    }

    /**
     * 服务工单排行
     * @param endDate     结束时间
     * @param area        父code
     * @param level       等级   4 市  3区  2社区 1团队
     * @param lowLevel   等级 1:团队 2社区机构 3区级 4市级
     * @return
     */
    @ApiOperation(value = "获取上门服务工单排行列表-v1.6.8.3")
    @GetMapping("doorServiceOrderLowlevelAll")
    @ResponseBody
    public String doorServiceOrderLowlevelAll(@ApiParam(name = "startDate", value = "搜索，开始时间",required = true)
                                      @RequestParam(value = "startDate") String startDate,
                                      @RequestParam(required = true) String endDate,
                                      @RequestParam(required = true) String area,
                                      @RequestParam(required = false) String slaveKey1,
                                      @RequestParam(required = true) int level,
                                      @RequestParam(required = true) String lowLevel) {

        try{
            lowLevel = String.valueOf(org.apache.commons.lang3.StringUtils.isEmpty(lowLevel) ? (level - 1) : lowLevel);

            JSONObject result = new JSONObject();
            result.put("index_177",doorStatisticAnalyzeService.doorServiceOrderLowlevelAll(startDate, endDate, area, level,slaveKey1, lowLevel));
            return write(200, "查询成功", "data", result);
        } catch (Exception e) {
            e.printStackTrace();
            return error(-1, "查询失败");
        }
    }

    @ApiOperation(value = "获取上门服务服务项目分析-v1.6.8.3")
    @GetMapping(value = "doorServiceItemAnalysis")
    @ResponseBody
    public String doorServiceItemAnalysis(
            @ApiParam(name = "area", value = "区域code：如思明区350203，团队641",required = false)
            @RequestParam(value = "area", required = false) String area,
            @ApiParam(name = "level", value = "等级，2市  3区  4社区 5科室 6团队",required = false)
            @RequestParam(required = true) int level,
            @ApiParam(name = "pageSize", value = "页面大小，默认6 返回全部传999",required = true)
            @RequestParam(value = "pageSize", required = true) Integer pageSize,
            @ApiParam(name = "startDate", value = "搜索，开始时间",required = false)
            @RequestParam(value = "startDate", required = false) String startDate,
            @ApiParam(name = "endDate", value = "搜索，结束时间",required = false)
            @RequestParam(value = "endDate", required = false) String endDate){

        try{
            //默认显示本月
            if(StringUtils.isEmpty(startDate)){
                startDate = DateUtil.getCurMonthFirstDayShort();
            }
            if(StringUtils.isEmpty(endDate)){
                endDate = DateUtil.getStringDate();
            }
            return write(200, "查询成功", "data", doorStatisticAnalyzeService.doorServiceItemAnalysis(area, level, pageSize, startDate, endDate));
        }catch (Exception e){
            e.printStackTrace();
            return error(-1, "查询失败");
        }
    }

    /*******************************上门服务统计 1.6.8.3 版本 end **************************************************************/

    /*******************************入户访视统计 1.6.8.3 版本 start **************************************************************/
    @ApiOperation("入户访视统计-获取总量头部-v1.6.8.3")
    @GetMapping("getHomeVisitTotalHead")
    @ResponseBody
    public String getHomeVisitTotalHead(@ApiParam(name="startDate",value="开始时间",defaultValue = "")@RequestParam(required = true) String startDate,
                                        @ApiParam(name="endDate",value="结束时间",defaultValue = "")@RequestParam(required = true) String endDate,
                                        @ApiParam(name="slaveKey1",value="类型 5 产后,6 新生儿,7 严重精神疾病,8 80岁以上老人,9 肺结核",defaultValue = "")
                                            @RequestParam(required = false) String slaveKey1,
                                        @ApiParam(name="area",value="区域code",defaultValue = "")@RequestParam(required = true) String area,
                                        @ApiParam(name="level",value="1 省 2 市 3 区县 4 机构 5科室 6医生",defaultValue = "")@RequestParam(required = true) Integer level) {
        try {
            JSONObject jsonObject = doorStatisticAnalyzeService.getHomeVisitTotalHead(startDate,endDate,area,level,slaveKey1);
            return write(200, "查询成功", "data", jsonObject);
        } catch (Exception e) {
            e.printStackTrace();
            return error(-1, "查询失败");
        }
    }

    @ApiOperation(value = "通用单条折线图趋势-v1.6.8.3")
    @GetMapping(value = "generalSingleLineChartTrend")
    @ResponseBody
    public String generalSingleLineChartTrend(
            @ApiParam(name = "area", value = "区域code：如思明区350203，团队641",required = false)
            @RequestParam(value = "area", required = false) String area,
            @ApiParam(name = "level", value = "等级，2市  3区  4社区 5团队",required = false)
            @RequestParam(required = true) int level,
            @ApiParam(name="index",value="指标",defaultValue = "")@RequestParam(required = true) String index,
            @ApiParam(name="interval",value="统计类型：1按天，2按周，3按月",defaultValue = "")
            @RequestParam(required = true) String interval,
            @ApiParam(name="slaveKey1",value="index=150 类型 5 产后,6 新生儿,7 严重精神疾病,8 80岁以上老人,9 肺结核",defaultValue = "")
            @RequestParam(required = false) String slaveKey1,
            @ApiParam(name = "startDate", value = "搜索，开始时间",required = true)
            @RequestParam(value = "startDate", required = false) String startDate,
            @ApiParam(name = "endDate", value = "搜索，结束时间",required = true)
            @RequestParam(value = "endDate", required = false) String endDate){

        try{
            List<Map<String,Object>> list = doorStatisticAnalyzeService.generalSingleLineChartTrend(area,level,index,startDate,endDate,interval,slaveKey1);
            return write(200, "查询成功", "data", list);
        }catch (Exception e){
            e.printStackTrace();
            return error(-1, "查询失败");
        }
    }


    @ApiOperation(value = "通用饼图-v1.6.8.3")
    @GetMapping(value = "generalPieChartTrend")
    @ResponseBody
    public String generalPieChartTrend(
            @ApiParam(name = "area", value = "区域code：如思明区350203，团队641",required = false)
            @RequestParam(value = "area", required = false) String area,
            @ApiParam(name = "level", value = "等级，2市  3区  4社区 5团队",required = false)
            @RequestParam(required = true) int level,
            @ApiParam(name="index",value="指标",defaultValue = "")@RequestParam(required = true) String index,
            @ApiParam(name="slaveKey1",value="index=150 类型 5 产后,6 新生儿,7 严重精神疾病,8 80岁以上老人,9 肺结核",defaultValue = "")
            @RequestParam(required = false) String slaveKey1,
            @ApiParam(name = "startDate", value = "搜索，开始时间",required = true)
            @RequestParam(value = "startDate", required = false) String startDate,
            @ApiParam(name = "endDate", value = "搜索，结束时间",required = true)
            @RequestParam(value = "endDate", required = false) String endDate){

        try{
            List<Map<String,Object>> list = doorStatisticAnalyzeService.generalPieChartTrend(area,level,index,startDate,endDate,slaveKey1);
            return write(200, "查询成功", "data", list);
        }catch (Exception e){
            e.printStackTrace();
            return error(-1, "查询失败");
        }
    }

    @ApiOperation(value = "通用下砖接口 区-社区-团队-v1.6.8.3")
    @GetMapping("generalLowlevelAll")
    @ResponseBody
    public String generalLowlevelAll(@ApiParam(name = "startDate", value = "搜索，开始时间",required = true)
                                     @RequestParam(value = "startDate") String startDate,
                                     @RequestParam(required = true) String endDate,
                                     @RequestParam(required = true) String area,
                                     @ApiParam(name="index",value="指标",defaultValue = "")@RequestParam(required = true) String index,
                                     @ApiParam(name="slaveKey1",value="index=150 类型 5 产后,6 新生儿,7 严重精神疾病,8 80岁以上老人,9 肺结核",defaultValue = "")
                                     @RequestParam(required = false) String slaveKey1,
                                     @RequestParam(required = true) int level,
                                     @RequestParam(required = true) String lowLevel) {

        try{
            List<Map<String, Object>> resultList = doorStatisticAnalyzeService.generalLowlevelAll(startDate, endDate, area, level,index,slaveKey1, lowLevel);
            return write(200, "查询成功", "data", resultList);
        } catch (Exception e) {
            e.printStackTrace();
            return error(-1, "查询失败");
        }
    }

    /*******************************入户访视统计 1.6.8.3 版本 end **************************************************************/
}
