package com.yihu.jw.door.controller.patient;

import com.alibaba.fastjson.JSONObject;
import com.yihu.jw.door.service.WlyyDoorCommentDoctorService;
import com.yihu.jw.restmodel.ResponseContant;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.ListEnvelop;
import com.yihu.jw.restmodel.web.PageEnvelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
*
* 服务工单中的医生评价控制器
*
* @version
*
<pre>
 * Author	Version		Date		Changes
 * Administrator 	1.0        2019年03月20日 	Created
 *
 * </pre>
* @since 1.
*/
@RestController
@RequestMapping(value = "/wlyyDoorCommentDoctor")
@Api(value = "服务工单中的医生评价管理", description = "服务工单中的医生评价管理服务接口")
public class WlyyDoorCommentDoctorController extends EnvelopRestEndpoint {

    @Autowired
    private WlyyDoorCommentDoctorService wlyyDoorCommentDoctorService;

    @PostMapping(value = "create")
    @ApiOperation(value = "创建")
    public Envelop create(@ApiParam(name = "jsonData", value = "Json数据", required = true) @RequestParam String jsonData) throws Exception {
        JSONObject result = wlyyDoorCommentDoctorService.create(jsonData);
        if (result.getIntValue(ResponseContant.resultFlag) == ResponseContant.fail) {
            return failed(result.getString(ResponseContant.resultMsg));
        }
        return success(result.get(ResponseContant.resultMsg));
    }

    @PostMapping(value = "delete")
    @ApiOperation(value = "删除")
    public Envelop delete(
    @ApiParam(name = "ids", value = "id串，中间用,分隔", required = true) @RequestParam(value = "ids") String ids) {
            wlyyDoorCommentDoctorService.delete(ids.split(","));
            return success("删除成功");
    }

    @PostMapping(value = "update")
    @ApiOperation(value = "更新")
    public Envelop update (@ApiParam(name = "jsonData", value = "Json数据", required = true) @RequestParam String jsonData) throws Exception {
        JSONObject result = wlyyDoorCommentDoctorService.update(jsonData);
        if (result.getIntValue(ResponseContant.resultFlag) == ResponseContant.fail) {
        return failed(result.getString(ResponseContant.resultMsg));
        }
        return success(result.get(ResponseContant.resultMsg));
    }


    @GetMapping(value = "infoList")
    @ApiOperation(value = "获取列表分页")
    public PageEnvelop page(
                @ApiParam(name = "fields", value = "返回的字段，为空返回全部字段") @RequestParam(value = "fields", required = false) String fields,
                @ApiParam(name = "filters", value = "过滤器，为空检索所有条件") @RequestParam(value = "filters", required = false) String filters,
                @ApiParam(name = "sorts", value = "排序，规则参见说明文档") @RequestParam(value = "sorts", required = false) String sorts,
                @ApiParam(name = "page", value = "分页大小", required = true, defaultValue = "1") @RequestParam(value = "page") int page,
                @ApiParam(name = "size", value = "页码", required = true, defaultValue = "15") @RequestParam(value = "size") int size) throws Exception {
            JSONObject result = wlyyDoorCommentDoctorService.queryInfoList(fields,filters,sorts,page,size);
            if (result.getIntValue(ResponseContant.resultFlag) == ResponseContant.fail) {
            return PageEnvelop.getError(result.getString(ResponseContant.resultMsg), -1);
            }
            int count = result.getIntValue(ResponseContant.count);
            return success((List) result.get(ResponseContant.resultMsg), count, page, size);
    }

    @GetMapping(value = "list")
    @ApiOperation(value = "获取列表")
    public ListEnvelop list (
                @ApiParam(name = "fields", value = "返回的字段，为空返回全部字段") @RequestParam(value = "fields", required = false) String fields,
                @ApiParam(name = "filters", value = "过滤器，为空检索所有条件") @RequestParam(value = "filters", required = false) String filters,
                @ApiParam(name = "sorts", value = "排序，规则参见说明文档") @RequestParam(value = "sorts", required = false) String sorts) throws Exception {
         return success(wlyyDoorCommentDoctorService.search(fields, filters, sorts));
     }
}