package com.yihu.jw.door.service;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.yihu.jw.doctor.dao.BaseDoctorDao;
import com.yihu.jw.door.dao.DoorServiceOrderDao;
import com.yihu.jw.door.dao.WlyyDoorPrescriptionDao;
import com.yihu.jw.door.dao.WlyyDoorPrescriptionDetailDao;
import com.yihu.jw.door.dao.WlyyDoorPrescriptionDrugDao;
import com.yihu.jw.door.service.prescription.JwDoorPrescriptionService;
import com.yihu.jw.door.service.prescription.PresModeAdapter;
import com.yihu.jw.door.util.MessageUtil;
import com.yihu.jw.entity.base.doctor.BaseDoctorDO;
import com.yihu.jw.entity.base.im.ConsultDo;
import com.yihu.jw.entity.base.patient.BasePatientDO;
import com.yihu.jw.entity.base.wx.BasePatientWechatDo;
import com.yihu.jw.entity.door.WlyyDoorPrescriptionDO;
import com.yihu.jw.entity.door.WlyyDoorPrescriptionDrugDO;
import com.yihu.jw.entity.door.WlyyDoorServiceOrderDO;
import com.yihu.jw.hospital.mapping.dao.DoctorMappingDao;
import com.yihu.jw.im.dao.ConsultDao;
import com.yihu.jw.im.util.ImUtil;
import com.yihu.jw.patient.dao.BasePatientDao;
import com.yihu.jw.util.common.IdCardUtil;
import com.yihu.jw.util.date.DateUtil;
import com.yihu.jw.util.entity.EntityUtils;
import com.yihu.jw.wechat.dao.BasePatientWechatDao;
import com.yihu.mysql.query.BaseJpaService;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.io.IOException;
import java.util.*;

/**
 * 上门服务开方相关业务
 * create by hmf on 2019/7/25
 */
@Service
public class WlyyDoorPrescriptionService  extends BaseJpaService<WlyyDoorPrescriptionDO, WlyyDoorPrescriptionDao> {

    private Logger logger = LoggerFactory.getLogger(WlyyDoorPrescriptionService.class);

    @Autowired
    private WlyyDoorPrescriptionDao doorPrescriptionDao;
    @Autowired
    private WlyyDoorPrescriptionDetailDao doorPrescriptionDetailDao;
    @Autowired
    private DoorServiceOrderDao doorServiceOrderDao;
    @Autowired
    private BasePatientDao patientDao;
    @Autowired
    private ConsultDao consultDao;
    @Autowired
    private ImUtil imUtill;
    @Autowired
    ObjectMapper objectMapper;
/*    @Autowired
    private WechatTemplateConfigDao templateConfigDao;
    @Autowired
    private PushMsgTask pushMsgTask;
        @Autowired
    private SignFamilyDao signFamilyDao;
    @Autowired
    WeiXinAccessTokenUtils tokenUtils;*/
    @Autowired
    private BaseDoctorDao doctorDao;
    @Autowired
    private DoctorMappingDao doctorMappingDao;
    @Autowired
    private WlyyDoorPrescriptionDrugDao doorPrescriptionDrugDao;
    @Autowired
    private JwDoorPrescriptionService jwDoorPrescriptionService;

    @Autowired
    private PresModeAdapter presModeAdapter;
/*    @Autowired
    private ZyDictService zyDictService;
    @Autowired
    private ZyIvDeptDictDao zyIvDeptDictDao;*/
    @Autowired
    private JdbcTemplate jdbcTemplate;
    @Autowired
    private MessageUtil messageUtil;
    @Autowired
    private BasePatientWechatDao basePatientWechatDao;

    @Value("${server.server_url}")
    private String server_url;
    @Value("${wechat.id}")
    private String wxId;

    /**
     * 造长处方开方数据
     *
     * @param doctor
     * @param patient
     * @param visitDept
     * @param visitTimeFrom
     * @param visitTimeEnd
     * @return
     */
    public JSONArray getPrescription(String doctor, String patient, String visitDept, String visitTimeFrom, String visitTimeEnd) throws Exception {
        JSONArray array = new JSONArray();
/*        if (StringUtils.isEmpty(visitTimeFrom)) {
            visitTimeEnd = DateUtil.getStringDateShort();
            Calendar c = Calendar.getInstance();
            c.setTime(new Date());
            c.add(Calendar.MONTH, -2);
            c.add(Calendar.DATE, 1);
            visitTimeFrom = DateUtil.dateToStrShort(c.getTime());
        }

        String re = jwDoorPrescriptionService.getVisitRecordListUnion(doctor, patient, visitDept, visitTimeFrom, visitTimeEnd);
        array = JSONObject.parseObject(re).getJSONArray("returnData");
        if(array.size() > 0) {
            array.getJSONArray(0).sort(Comparator.comparing(obj -> ((JSONObject) obj).getInteger("VISIT_NO")).reversed());
        }*/
//        String jsonString = "[]";
        /*String jsonString = "[{\"RECIPE_NO\": \"123456\",\"DIAGNOSE_NAME\": \"高血压\",\"DIAGNOSE_CODE\":\"1\",\"TOTAL_FEE\":\"125\",\"APPLY_TIME\": \"2019-04-24 09:15:00\", \"RECIPE_DETAIL\":[{\"ITEM_CODE\": \"12\",\"ITEM_NAME\": \"尿液分析\",\"ITEM_PRICE\": \"25.00\",\"ITEM_QUANTITY\": \"1\",\"COST\": \"25\"}," +
                "{\"ITEM_CODE\": \"13\",\"ITEM_NAME\": \"出诊费\",\"ITEM_PRICE\": \"50\",\"ITEM_QUANTITY\": \"2\",\"COST\": \"100\"}]},{\"RECIPE_NO\": \"23333\",\"DIAGNOSE_NAME\": \"高血压,糖尿病\",\"DIAGNOSE_CODE\":\"2\",\"TOTAL_FEE\":\"125\",\"APPLY_TIME\": \"2019-04-23 09:15:00\", " +
                "\"RECIPE_DETAIL\":[{\"ITEM_CODE\": \"21\",\"ITEM_NAME\": \"饮血试验\",\"ITEM_PRICE\": \"25.00\",\"ITEM_QUANTITY\": \"1\",\"COST\": \"25.00\"}," +
                "{\"ITEM_CODE\": \"22\",\"ITEM_NAME\": \"出诊费\",\"ITEM_PRICE\": \"50.00\",\"ITEM_QUANTITY\": \"2\",\"COST\": \"100.00\"}]}]";*/
//        JSONArray array = JSONArray.parseArray(jsonString);
        return array;
    }

    /**
     * 保存上门服务开方记录
     *
     * @param orderId
     * @param jsonData
     * @param doctor
     */
    public JSONObject createDoorPrescription(String orderId, String jsonData, String doctor) throws Exception {
        JSONObject re = new JSONObject();
        List<WlyyDoorPrescriptionDO> prescriptionDOList = new ArrayList<>();
        WlyyDoorPrescriptionDO prescriptionDO = new WlyyDoorPrescriptionDO();
        WlyyDoorServiceOrderDO orderDO = doorServiceOrderDao.findOne(orderId);
        BaseDoctorDO d = doctorDao.findById(doctor);
        //判断是上门前开方，或者是上门后开方
        if(orderDO.getStatus() < WlyyDoorServiceOrderDO.Status.waitForServe.getType()){
            JSONObject jsonObject = saveDoorPrescriptionBefore(jsonData, d, orderDO.getPatient(), orderId);
            if(jsonObject.getInteger("status") == 200) {
                prescriptionDOList = (List<WlyyDoorPrescriptionDO>) jsonObject.get("data");
                orderDO.setPrescriptionStatus(1);
                //更新工单信息
                orderDO.setPrescriptionTime(new Date());
                orderDO.setStatus(4);
                doorServiceOrderDao.save(orderDO);
                //发送 预约卡片信息(2101类型)
                JSONObject orderInfoContent = this.queryOrderCardInfo(orderDO);
                orderInfoContent.put("re_msg_type", 2);//开方完成消息
                this.qucikSendIM(orderDO.getId(), orderDO.getDispatcher(), "智能助手", "2101", orderInfoContent.toJSONString());
            }else {
                re.put("status", -1);
                re.put("msg", jsonObject.getString("msg"));
                return re;
            }
        }else {
            JSONObject object = saveDoorPrescriptionAfter(jsonData, d, orderDO.getPatient(), orderId);
            if(object.getInteger("status") == 200){
                prescriptionDO = (WlyyDoorPrescriptionDO) object.get("data");
                prescriptionDOList.add(prescriptionDO);
            }else {
                re.put("status", -1);
                re.put("msg", object.getString("msg"));
                return re;
            }
        }
        re.put("status", 200);
        re.put("data", prescriptionDOList);
        return re;
    }

    private String getRandomIntStr() {
        Random rand = new Random();
        int i = rand.nextInt(); //int范围类的随机数
        i = rand.nextInt(100); //生成0-100以内的随机数
        i = (int) (Math.random() * 100000000); //0-100以内的随机数，用Matn.random()方式
        return String.valueOf(i);
    }

    /**
     * 查询预约简要卡片信息
     * <p>
     * 服务时间：2019-01-01   12:30
     * 服务对象：张三
     * 联系电话：13125256565（儿子）
     * 上门地址：福建省厦门市思明区望海路55号
     *
     * @param orderDO
     * @return
     */
    public JSONObject queryOrderCardInfo(WlyyDoorServiceOrderDO orderDO) {
        JSONObject result = new JSONObject();
        BasePatientDO patientDO = patientDao.findById(orderDO.getPatient());
        result.put("title", "预约服务信息如下:");
        result.put("orderId", orderDO.getId());
        result.put("status", orderDO.getStatus());
        result.put("number", orderDO.getNumber());
        result.put("serveDesc", orderDO.getServeDesc());
        result.put("expectedDoctor", orderDO.getExpectedDoctorName());
        if (StringUtils.isNotBlank(orderDO.getDoctorArrivingTime())) {
            result.put("time", orderDO.getDoctorArrivingTime());
        } else {
            result.put("time", "工作时间");
        }
        result.put("patientName", patientDO.getName());
        result.put("patientSex", IdCardUtil.getSexNameForIdcard_new(patientDO.getIdcard()));
        result.put("patientAge", IdCardUtil.getAgeForIdcard(patientDO.getIdcard()));
        result.put("phone", orderDO.getPatientPhone());
        if (StringUtils.equalsIgnoreCase(orderDO.getPatient(), orderDO.getProxyPatient())) {
            result.put("relation", "");
        } else {
            result.put("relation", orderDO.getPatientRelation());
        }
        result.put("serveTown", orderDO.getServeTown());
        result.put("serveAddress", orderDO.getServeAddress());
        result.put("type", 11);
        return result;
    }

    /**
     * 【调度员，医生】快速发送IM消息
     *
     * @param orderId
     * @param sendId
     * @param sendName
     * @param content
     * @return
     */
    public int qucikSendIM(String orderId, String sendId, String sendName, String contentType, String content) {
        int result = -1;
        ConsultDo consult = consultDao.queryByRelationCode(orderId);
        if (null == consult) {
            logger.error("当前工单未关联咨询，工单id：" + orderId);
            return result;
        }
        String response = imUtill.sendTopicIM(sendId, sendName, consult.getId(), contentType, content, null);
        JSONObject resObj = JSONObject.parseObject(response);
        if (resObj.getIntValue("status") == -1) {
            logger.error("上门服务工单消息发送失败：" + resObj.getString("message"));
            return result;
        }
        result = 1;
        return result;
    }

    /**
     * 保存授权图片并发送模板消息
     *
     * @param orderId
     * @param authorizeImage
     */
    public void saveAuthorizeImage(String orderId, String authorizeImage) {
        WlyyDoorServiceOrderDO orderDO = doorServiceOrderDao.findOne(orderId);
//        orderDO.setAuthorizeImage(authorizeImage);
        orderDO.setAuthorizeImage(server_url+"/images/healthCardQRcode.png");
        doorServiceOrderDao.save(orderDO);
        BasePatientDO patient = patientDao.findById(orderDO.getPatient());
        String first = "key1，您好！请授权电子健康卡";//·
        first = first.replace("key1", orderDO.getPatientName());
        JSONObject json = new JSONObject();
        json.put("orderId", orderDO.getId());
        json.put("openId", patient.getOpenid());
        json.put("authorizeImage", orderDO.getAuthorizeImage());
        List<BasePatientWechatDo> basePatientWechatDos = basePatientWechatDao.findByWechatIdAndPatientId(wxId,patient.getId());
        String openId = basePatientWechatDos.get(0).getOpenid();
        messageUtil.putTemplateWxMessage(wxId,"template_process_feedback","authorize",openId,first,null,null,34,json,DateUtil.dateToChineseDate(new Date()));

/*        Patient patient = patientDao.findByCode(orderDO.getPatient());//·
        //发送微信模板消息
        WechatTemplateConfig templateConfig = templateConfigDao.findByScene("template_process_feedback", "authorize");
        String first = templateConfig.getFirst();
        first = first.replace("key1", orderDO.getPatientName());
        String keyword2 = templateConfig.getKeyword2();
        org.json.JSONObject json = new org.json.JSONObject();
        json.put("first", first);
        json.put("keyword1", DateUtil.dateToStrShort(new Date()));
        json.put("keyword2", keyword2);
        json.put("url", templateConfig.getUrl());
        json.put("remark", templateConfig.getRemark());
        json.put("orderId", orderDO.getId());
        json.put("authorizeImage", orderDO.getAuthorizeImage());
        pushMsgTask.putWxMsg(tokenUtils.getAccessToken(), 34, patient.getOpenid(), orderDO.getPatientName(), json);*/
    }

    /**
     * 根据处方表code查处方信息
     *
     * @param recipeNo
     * @return
     * @throws Exception
     */
    public JSONObject getPrescriptionByCode(String recipeNo, String patientCode) throws Exception {
        JSONObject json = new JSONObject();
        //获取智业处方详细
        String response = "";
                //获取居民签约信息
//        SignFamily signFamily = signFamilyDao.findSignFamilyByPatient(patientCode);
        WlyyDoorPrescriptionDO prescriptionDO = doorPrescriptionDao.findByRecipeNo(recipeNo);
        //说明是非手动开方，手动开方库里只有处方号
        if (prescriptionDO != null) {
            json.put("prescription", prescriptionDO);
//            response = jwDoorPrescriptionService.getVisitRecipeDetailUnion(prescriptionDO.getVisitNo(), recipeNo, signFamily.getHospital());
//            throw new Exception("该处方不存在！");
        }else {
//            response = jwDoorPrescriptionService.getVisitRecipeDetailUnion(null, recipeNo, signFamily.getHospital());
        }
        JSONObject jsonObject = presModeAdapter.modelToSinglePrescription(response);
        json.put("prescriptionDrugList", jsonObject);

        BasePatientDO patient = patientDao.findById(patientCode);
        if (patient != null) {
            //居民基本信息
            JSONObject patientInfo = new JSONObject();
            String sex = IdCardUtil.getSexForIdcard_new(patient.getIdcard());
            String birthday = IdCardUtil.getBirthdayForIdcardStr(patient.getIdcard());
            patientInfo.put("sex", sex);
            patientInfo.put("name", patient.getName());
            patientInfo.put("birthday", birthday);

            json.put("patientInfo", patientInfo);
        }

        return json;
    }

    /**
     * 取消处方
     *
     * @param prescriptionCode
     * @param reason
     */
    public void cancelPrescriptionByCode(String prescriptionCode, String reason) {
        WlyyDoorPrescriptionDO prescriptionDO = doorPrescriptionDao.findByCode(prescriptionCode);
        prescriptionDO.setStatus(-1);
        prescriptionDO.setReason(reason);
        prescriptionDO.setUpdateTime(new Date());
        doorPrescriptionDao.save(prescriptionDO);
        doorPrescriptionDetailDao.updateStatusByPrescriptionCode(prescriptionDO.getCode());
        doorPrescriptionDrugDao.updateDelByPrescriptionCode(prescriptionDO.getCode());
    }

    /**
     * 跳过开处方更新工单状态跟处方状态
     *
     * @param orderId
     */
    @Transactional
    public void skipPrescriptionByOrderId(String orderId) {
        doorServiceOrderDao.updatePrescriptionStatusAndStatusById(orderId);
    }

    /**
     * 上门前关联处方开方
     *
     * @param jsonData
     * @param doctor
     * @param patientCode
     * @param orderId
     * @return
     */
    public JSONObject saveDoorPrescriptionBefore(String jsonData, BaseDoctorDO doctor, String patientCode, String orderId) throws Exception {
        JSONObject res = new JSONObject();
        List<WlyyDoorPrescriptionDO> doorPrescriptionDOList = new ArrayList<>();
        JSONObject json = JSONObject.parseObject(jsonData);
        JSONArray jsonArray = json.getJSONArray("prescription");
        for(Object o : jsonArray) {
            JSONObject prescriptionJson = (JSONObject)o;
            String visitNo = prescriptionJson.getString("visitNo");
            List<WlyyDoorPrescriptionDO> lastPrescription = doorPrescriptionDao.findByVisitNoAndOrderIdNot(visitNo);
            if(lastPrescription.size() > 0 ){
                res.put("status", -1);
                res.put("msg", "该就诊记录已被关联");
                return res;
            }
            WlyyDoorPrescriptionDO prescription = new WlyyDoorPrescriptionDO();
            prescription = objectMapper.readValue(prescriptionJson.toString(), WlyyDoorPrescriptionDO.class);
            //获取居民签约信息
//            SignFamily signFamily = signFamilyDao.findSignFamilyByPatient(patientCode);
            //获取智业处方详细
            String response = jwDoorPrescriptionService.getVisitRecipeDetailUnion(visitNo, null, "");
//            String response = jwDoorPrescriptionService.getVisitRecipeDetailUnion(visitNo, null, signFamily.getHospital());
            JSONObject oldJson = JSONObject.parseObject(response);
            JSONObject data = JSONObject.parseObject(oldJson.getString("data"));
            String code = data.getString("CODE");
            if(oldJson.getInteger("status")!=200 || StringUtils.isBlank(code) || !code.equals("1")){
                res.put("status", -1);
                res.put("msg", "智业接口失败："+oldJson.getString("msg"));
                return res;
            }
            JSONArray array = presModeAdapter.modelToDoorPrescription(response);
            for(Object object : array) {
                JSONObject jsonObject = (JSONObject) object;
                //保存处方信息
                prescription.setCode(getCode());
                prescription.setOrderId(orderId);
                prescription.setRecipeNo(jsonObject.getString("code"));
                prescription.setIsAfterDoor(1);//上门前开方
/*                prescription.setHospitalName(doctor.getHospitalName());
                prescription.setHospital(doctor.getHospital());
                prescription.setAdminTeamId(signFamily.getAdminTeamId());
                prescription.setVisitDept(doctor.getDept());
                //获取基卫科室明称
                if(StringUtils.isNotBlank(prescription.getJwDeptCode())) {
                    ZyIvDeptDict deptDict = zyIvDeptDictDao.findByDeptCode(prescription.getJwDeptCode());
                    if(deptDict != null) {
                        prescription.setVisitDeptName(deptDict.getDeptName());
                    }
                }
//                prescription.setVisitDeptName(doctor.getDeptName());
                prescription.setDoctorCode(doctor.getCode());
                prescription.setDoctorName(doctor.getName());

                prescription.setPatient(signFamily.getPatient());
                prescription.setPatientName(signFamily.getName());
                prescription.setSsc(signFamily.getSsc());*/
                prescription.setStatus(50);
                prescription.setJwHospital(jsonObject.getString("jwHospital"));
                prescription.setVisitTime(DateUtil.strToDate(jsonObject.getString("createTime")));

                //保存续方药品（处方）信息
                JSONArray infos = jsonObject.getJSONArray("prescriptionInfo");
                int day = 0;
                if (infos != null && infos.size() > 0 && infos.getJSONObject(0).get("dayCount") != null) {
                    day = infos.getJSONObject(0).getInteger("dayCount");
                }
                for (int i = 0; i < infos.size(); i++) {
                    JSONObject info = infos.getJSONObject(i);
                    WlyyDoorPrescriptionDrugDO prescriptionInfo = new WlyyDoorPrescriptionDrugDO();
                    prescriptionInfo.setPrescriptionCode(prescription.getCode());
                    prescriptionInfo.setCode(getCode());
                    prescriptionInfo.setDel(1);
                    prescriptionInfo.setDirection(info.getString("USAGE_NAME"));//药品用法
                    prescriptionInfo.setDrugCode(info.getString("drugCode"));//药品code
                    prescriptionInfo.setDrugName(info.getString("drugName"));//药品名称
                    prescriptionInfo.setDrugRate(info.getString("drugRate"));//吃药频率
                    prescriptionInfo.setDrugRateName(getZyCommonDictName(info.getString("drugRate")));
                    prescriptionInfo.setDrugFormat(info.getString("drugFormat"));//药品规格
                    prescriptionInfo.setNum(info.getInteger("num"));//药品数目
                    prescriptionInfo.setPrice(info.getBigDecimal("price"));//药品单价
//            prescriptionInfo.setIsRefrigerate(0);//是否冷藏 1是 0否
                    prescriptionInfo.setJwSubCode(info.getString("jwSubCode"));//智业子处方号

                    prescriptionInfo.setDrugNumUnit(info.getString("drugNumUnit"));//数量单位编码
                    prescriptionInfo.setDrugNumUnitName(info.getString("drugNumUnitName"));//数量单位名称
                    prescriptionInfo.setCost(info.getBigDecimal("cost"));//金额
                    prescriptionInfo.setCharge(info.getBigDecimal("charge"));//自付
                    prescriptionInfo.setBindFlag(info.getString("bindFlag"));//成组标志, 0.非成组,1.成组
                    prescriptionInfo.setDayCount(info.getInteger("dayCount"));//用药天数
                    //设置最小用药天数
                    if (day != 0 && prescriptionInfo.getDayCount() < day) {
                        day = prescriptionInfo.getDayCount();
                    }
                    prescriptionInfo.setDrugUsage(info.getString("drugUsage"));//用药方法编码
                    prescriptionInfo.setUsageName(info.getString("usageName"));//用药方法名称
                    prescriptionInfo.setPhysicDose(info.getString("physicDose"));//用药剂量
                    prescriptionInfo.setPhysicDoseUnit(info.getString("physicDoseUnit"));//剂量单位编码
                    prescriptionInfo.setPhysicDoseUnitName(info.getString("physicDoseUnitName"));//剂量单位名称
                    prescriptionInfo.setPhysicInjectPlace(info.getString("physicInjectPlace"));//注射地点编码
                    prescriptionInfo.setPhysicInjectPlaceName(info.getString("physicInjectPlaceName"));//注射地点名称
                    prescriptionInfo.setPhysicSkinTest(info.getString("physicSkinTest"));//注射地点名称
                    prescriptionInfo.setPhysicSkinTestName(info.getString("physicSkinTestName"));//皮试类型名称
                    prescriptionInfo.setRemark(info.getString("Remark"));//备注
                    //需要特殊处理的字段
/*                    ZyIvPhysicDict physicDict = zyDictService.findByPhysicCode(prescriptionInfo.getDrugCode());
                    String subjectClass = info.getString("subjectClass");//科目类型
                    String physicAmount = info.getString("physicAmount");//用药总量
                    String physicAmountUnit = info.getString("physicAmountUnit");//总量单位编码
                    String physicAmountUnitName = info.getString("physicAmountUnitName");//总量单位名称
                    Integer isRefrigerate = 0;
                    if (physicDict != null) {
                        subjectClass = physicDict.getSubjectClass();
                        isRefrigerate = "2".equals(physicDict.getStorageConditions()) ? 1 : isRefrigerate;
                        physicAmount = null;
                        physicAmountUnit = physicDict.getPackUnit();
                        physicAmountUnitName = zyDictService.findByDictNameAndCode("IV_MEASURE_UNIT_DICT", physicAmountUnit);
                    }
                    prescriptionInfo.setPhysicAmount(physicAmount);
                    prescriptionInfo.setPhysicAmountUnit(physicAmountUnit);
                    prescriptionInfo.setPhysicAmountUnitName(physicAmountUnitName);
                    prescriptionInfo.setIsRefrigerate(isRefrigerate);
                    prescriptionInfo.setSubjectClass(subjectClass);//科目编码*/
                    prescriptionInfo.setCreateTime(new Date());
                    doorPrescriptionDrugDao.save(prescriptionInfo);
                }
                prescription.setCreateTime(new Date());
                prescription.setUpdateTime(new Date());
                //保存续方记录
                doorPrescriptionDao.save(prescription);
                doorPrescriptionDOList.add(prescription);
            }
        }
        res.put("status", 200);
        res.put("data", doorPrescriptionDOList);
        //添加保存日志
//        prescriptionLogService.addLog(prescription, PrescriptionLog.PrescriptionLogType.create.getValue(), 1, 1);
        return res;
    }

    public JSONObject saveDoorPrescriptionAfter(String jsonData, BaseDoctorDO doctor, String patientCode, String orderId) {
        JSONObject jsonObject = JSONObject.parseObject(jsonData);
        JSONObject re = new JSONObject();
        WlyyDoorPrescriptionDO prescription = EntityUtils.jsonToEntity(jsonObject.getString("prescription"), WlyyDoorPrescriptionDO.class);
        //获取居民签约信息
//        SignFamily signFamily = signFamilyDao.findSignFamilyByPatient(patientCode);
        //医生映射信息
//        DoctorMapping doctorMapping = doctorMappingDao.findListByDoctorCode(doctor.getCode()).get(0);
        //判断这个工单上门后是否开过方，如果开过方且该就诊号没有作废过，就用同一个就诊号
        List<WlyyDoorPrescriptionDO> lastPrescriptionList = doorPrescriptionDao.findByOrderIdAndIsAfterDoor(orderId, 2);
        if(lastPrescriptionList.size() > 0){
            for(WlyyDoorPrescriptionDO prescriptionDO : lastPrescriptionList) {
                //判断该就诊号是否作废过
                List<WlyyDoorPrescriptionDO> fadePrescriptionList = doorPrescriptionDao.findByVisitNoAndStatus(prescriptionDO.getVisitNo(), -1);
                if (fadePrescriptionList.size() == 0) {
                    prescription.setVisitNo(prescriptionDO.getVisitNo());
                    break;
                }
            }
        }
        //保存开方字段
        String code = getCode();
        prescription.setCode(code);
        prescription.setOrderId(orderId);
        prescription.setIsAfterDoor(2);//上门后开方
/*        prescription.setHospitalName(doctor.getHospitalName());
        prescription.setHospital(doctor.getHospital());
        prescription.setAdminTeamId(signFamily.getAdminTeamId());
        prescription.setDoctorCode(doctor.getCode());
        prescription.setDoctorName(doctor.getName());
        prescription.setVisitDept(doctor.getDept());
//        prescription.setVisitDeptName(doctor.getDeptName());
        //获取基卫科室明称
        if(StringUtils.isNotBlank(prescription.getJwDeptCode())) {
            ZyIvDeptDict deptDict = zyIvDeptDictDao.findByDeptCode(prescription.getJwDeptCode());
            if(deptDict != null) {
                prescription.setVisitDeptName(deptDict.getDeptName());
            }
        }
        prescription.setJwDoctorCode(doctorMapping.getJwDoctor());
        //设置费别类型
        prescription.setRateType(zyDictService.getRateType());
        prescription.setRateTypeName("市医保");
        prescription.setPatient(signFamily.getPatient());
        prescription.setPatientName(signFamily.getName());
        prescription.setSsc(signFamily.getSsc());*/
        prescription.setVisitTime(new Date());
        prescription.setCreateTime(new Date());
        prescription.setUpdateTime(new Date());
        prescription.setStatus(30);
        doorPrescriptionDao.save(prescription);

        //保存开单记录
        List<WlyyDoorPrescriptionDrugDO> prescriptionDrugDOList = new ArrayList<>();
        List<WlyyDoorPrescriptionDrugDO> prescriptionDrugDOS = new ArrayList<>();
        try {
            if(jsonObject.containsKey("prescriptionDetailList")) {
                prescriptionDrugDOS = objectMapper.readValue(jsonObject.getString("prescriptionDetailList"), new TypeReference<List<WlyyDoorPrescriptionDrugDO>>() {
                });
            }
            if(jsonObject.containsKey("prescriptionDrugList")) {
                prescriptionDrugDOS.addAll(objectMapper.readValue(jsonObject.getString("prescriptionDrugList"), new TypeReference<List<WlyyDoorPrescriptionDrugDO>>() {
                }));
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
        //保存上门服务开药记录
        for (WlyyDoorPrescriptionDrugDO prescriptionDrugDO : prescriptionDrugDOS) {
            prescriptionDrugDO.setCode(getCode());
            prescriptionDrugDO.setPrescriptionCode(code);
            prescriptionDrugDO.setCreateTime(new Date());
            prescriptionDrugDO.setDel(1);
            prescriptionDrugDOList.add(prescriptionDrugDO);
        }
        doorPrescriptionDrugDao.save(prescriptionDrugDOList);
        prescription.setRecipeDetailList(prescriptionDrugDOList);

        //保存上门后开方
        String response = jwDoorPrescriptionService.saveRecipeUnion(code, "", prescription.getJwDeptCode());
//        String response = jwDoorPrescriptionService.saveRecipeUnion(code, doctorMapping.getJwDoctor(), prescription.getJwDeptCode());
        JSONObject json = JSONObject.parseObject(response);
        if (json.getInteger("status") == 200) {
            JSONObject data = JSONObject.parseObject(json.getString("data"));
            String zyCode = data.getString("CODE");
            if ("1".equals(zyCode)) {
                JSONArray returnData = data.getJSONArray("returnData");
                if (returnData.size() > 0) {
                    JSONObject pre = returnData.getJSONArray(0).getJSONObject(0);
                    String visitNo = pre.getString("VISIT_NO");
                    String recipeNo = pre.getString("RECIPE_NO");
                    prescription.setVisitNo(visitNo);
                    prescription.setRecipeNo(recipeNo);
                    doorPrescriptionDao.save(prescription);
                    re.put("status", 200);
                    re.put("data", prescription);
                } else {
                    //请求失败
                    doorPrescriptionDao.delete(prescription.getId());
                    doorPrescriptionDrugDao.updateDelByPrescriptionCode(prescription.getCode());
                    JSONArray byRefParaData = data.getJSONArray("byRefParaData");
                    re.put("status", -1);
                    re.put("msg", byRefParaData.getJSONObject(0).getString("errorMsg"));
                }
            } else {
                //调整请求失败
                doorPrescriptionDao.delete(prescription.getId());
                doorPrescriptionDrugDao.updateDelByPrescriptionCode(prescription.getCode());
                re.put("status", -1);
                re.put("msg", data.getString("MESSAGE"));
            }
        } else {
            //请求报错
            doorPrescriptionDao.delete(prescription.getId());
            doorPrescriptionDrugDao.updateDelByPrescriptionCode(prescription.getCode());
            re.put("status", -1);
            re.put("msg", json.getString("msg"));
        }
        return re;
    }


    public String getZyCommonDictName(String code) {
        try {
            String sql = "SELECT t.name FROM zy_common_dict t WHERE t.code=? AND t.dict_name='IV_RECIPE_FREQUENCY_DICT'";
            List<Map<String, Object>> list = jdbcTemplate.queryForList(sql, new Object[]{code});
            if (list != null && list.size() > 0) {
                return (String) (list.get(0).get("name"));
            }
            return "";
        } catch (Exception e) {
            return "";
        }
    }

    public org.json.JSONArray getIcd10Info(String nameKey, Integer page, Integer pageSize) {
        StringBuffer stringBuffer = new StringBuffer(" SELECT t.code,t.name FROM icd10_dict t WHERE t.name LIKE ?  limit " + (page-1)*pageSize + "," + pageSize);
        List<Map<String, Object>> rs = jdbcTemplate.queryForList(stringBuffer.toString(), new Object[]{"%" + nameKey + "%"});
        return new org.json.JSONArray(rs);
    }
}
