package com.yihu.jw.door.service.common;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import org.apache.commons.collections.map.HashedMap;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * Created by wzn54 on 2019/3/19.
 */
@Service
@Transactional
public class ServerPackageService  {

    @Autowired
    private JdbcTemplate jdbcTemplate;
    @Value("${wechat.id}")
    private String wxId;


    /**
     * 根据机构code获取服务项目
     *
     * @param hospital
     * @return
     */
    public List<Map<String,Object>> selectByHospital(String hospital){
        String sql = "SELECT  *  FROM  wlyy.wlyy_server_item si  " +
                "WHERE  si.CODE IN (SELECT service_item_code FROM wlyy.wlyy_hospital_service_item hsi " +
                "WHERE (hsi.hospital IN ( SELECT hp.hospital_partner FROM wlyy.wlyy_hospital_partner hp " +
                "WHERE  hp.hospital ='"+hospital+"' AND hp.del = 1 ) OR hsi.hospital = '"+hospital+"') " +
                "AND hsi.del = 1 )";
        List<Map<String,Object>> mapList = jdbcTemplate.queryForList(sql);
        return mapList;
    }


    /**
     *
     * 根据机构code获取本机构服务项目
     *
     * @param hospital
     * @return
     */
    public JSONArray selectByHospital1(String hospital){
        String sql = "select * from wlyy.wlyy_server_item si JOIN wlyy.wlyy_hospital_service_item hsi ON hsi.service_item_code = si.`code` AND hsi.del=1\n" +
                "and hsi.hospital = '"+hospital+"'";
        List<Map<String,Object>> mapList = jdbcTemplate.queryForList(sql);
        JSONArray  array= new JSONArray();
        JSONObject object = new JSONObject();
        object.put("type","1");
        List<Map<String,Object>> maps = new ArrayList<>();
        JSONObject object1 = new JSONObject();
        object1.put("type","2");
        List<Map<String,Object>> maps1 = new ArrayList<>();
        for (Map<String,Object> map:mapList){
            if (map.get("item_type").toString().equalsIgnoreCase("1")){
                maps.add(map);
            }else if (map.get("item_type").toString().equalsIgnoreCase("2")){
                maps1.add(map);
            }
        }
        object.put("items",maps);
        object1.put("items",maps1);
        array.add(object);
        array.add(object1);
        return array;
    }


    public List<Map<String,Object>> selectServiceByHospital(String hospital,String serverItemName,String type,String patient,String doctor){
        StringBuffer buffer = new StringBuffer();

        if(StringUtils.isNoneBlank(hospital)){
//            HospitalMapping hospitalMapping = hospitalMappingDao.findByCode(hospital);
//            buffer.append(" and ziocad.org_code = '"+hospitalMapping.getMappingCode()+"'");
        }
        String sql = "";

        if("sd_tnzyy_wx".equals(wxId)){
            if("door".equals(type)){
                //上门护理
                sql = "SELECT code,value title,'' unit,0 expense   from base_system_dict_entry WHERE dict_code = 'door_service_door_dict' ORDER BY sort";
            }else{
                sql = "SELECT DISTINCT a.FYXH code,a.FYMC title,a.FYDW unit,a.FYDJ expense from gy_ylsf a ";
                if("used".equals(type)){
                    sql += " JOIN wlyy_door_order_item i on i.code = a.FYXH and (i.patient = '"+patient+"' or i.doctor='"+doctor+"') ";
                }else if("other".equals(type)){
                    sql += " where a.FYGB not in (SELECT code from base_system_dict_entry WHERE dict_code = 'door_service_subject_class_dict')";
                }else{
                    sql += " WHERE a.FYGB ="+type;
                }
            }

        }else {
            sql ="SELECT " +
                    "ziocad.org_code AS hospital," +
                    "zicd.clinic_code AS diagnosis_code," +
                    "zicd.clinic_code AS code," +
                    "zicd.clinic_name AS title," +
                    "zicd.clinic_spec AS spec," +
                    "zicd.clinic_unit AS unit," +
                    "ziccad.allot_quantity AS quantity," +
                    "zicd.subject_class AS subjectClass," +
                    "ziccad.item_code AS itemCode," +
                    " SUBSTR(zicd.subject_class, 1, 4) AS subjectCatagory," +
                    " (CASE WHEN ISNULL(ziocd.price) THEN 0 ELSE ziocd.price END) as expense " +
                    " FROM zy_iv_org_clinic_allot_dict ziocad " +
                    " LEFT JOIN zy_iv_clinic_charge_allot_dict ziccad ON ziccad.clinic_code = ziocad.clinic_code AND ziccad.org_code = ziocad.org_code" +
                    " LEFT JOIN zy_iv_clinic_dict zicd ON zicd.clinic_code = ziocad.clinic_code" +
                    " LEFT JOIN zy_iv_org_charge_allot_dict ziocd ON ziocd.charge_code = ziccad.item_code and ziocd.org_code = ziccad.org_code  " ;

            if("used".equals(type)){
                sql += " LEFT JOIN wlyy_door_order_item i on i.code = zicd.clinic_code and (i.patient = '"+patient+"' or i.doctor='"+doctor+"') ";
                sql += " WHERE SUBSTR(zicd.subject_class, 1, 4) = '"+type+"' ";
            }else{
                sql += " WHERE SUBSTR(zicd.subject_class, 1, 4) = '"+type+"' ";
            }
            sql += buffer;
        }


        List<Map<String,Object>> mapList = jdbcTemplate.queryForList(sql);

        return mapList;
    }

    /**
     * 居民端服务项类型
     * @return
     */
    public List<Map<String,Object>> selectPatientTypes(){
        String sql = "SELECT code,value type from base_system_dict_entry WHERE dict_code = 'door_service_subject_class_dict' and code = 'door'";
        List<Map<String,Object>> mapList = jdbcTemplate.queryForList(sql);
        return mapList;
    }

    /**
     * 医生端服务项类型
     * @return
     */
    public List<Map<String,Object>> selectTypes(){
        String sql = "SELECT code,value type from base_system_dict_entry WHERE dict_code = 'door_service_subject_class_dict' ORDER BY sort";
        List<Map<String,Object>> mapList1 = jdbcTemplate.queryForList(sql);
        Map<String,Object> map1 = new HashedMap();
        map1.put("code","used");
        map1.put("type","常用");
        mapList1.add(map1);
        Map<String,Object> map2 = new HashedMap();
        map2.put("code","other");
        map2.put("type","其他");
        mapList1.add(map2);
        return mapList1;
    }

}
