package com.yihu.jw.door.service.prescription;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.stereotype.Component;

import java.util.Iterator;

/**
 * Created by Trick on 2017/8/10.
 */
@Component
public class PresModeAdapter {

    private static Logger logger = LoggerFactory.getLogger(PresModeAdapter.class);
/*    @Autowired
    private ZyDictService zyDictService;
    @Autowired
    private DictIcd10Se icd10DictServcie;*/


    /**
     * 处方详情转换
     * @param json
     * @return
     */
    public JSONObject modelToSinglePrescription(String json){
        try{
            JSONObject oldJson = JSONObject.parseObject(json);
            if(oldJson.getInteger("status")!=200){
                throw new RuntimeException("智业接口失败："+oldJson.getString("msg"));
            }
            JSONObject data = JSONObject.parseObject(oldJson.getString("data"));
            JSONArray returnData = data.getJSONArray("returnData");
            String code = data.getString("CODE");
            if(StringUtils.isNotBlank(code)&&"1".equals(code)&&returnData.size()>0){
                JSONArray modeArray = returnData.getJSONArray(0);
                JSONObject mode = (JSONObject) modeArray.get(0);
                JSONObject p  = new JSONObject();
                p.put("code",mode.getInteger("RECIPE_NO")+"");
                p.put("createTime",mode.getString("APPLY_TIME"));

/*                Doctor doctor =  zyDictService.getDoctByJw(mode.getString("APPLY_OPERATOR"),mode.getString("HEALTH_ORG_CODE"));
                // "APPLY_OPERATOR_NAME": 开单医生姓名","HEALTH_ORG_CODE": "开单机构编码",
                if(doctor!=null){
                    p.put("doctor",doctor.getCode());
                    p.put("doctorName",doctor.getName());
                    p.put("hospitalName",doctor.getHospitalName());
                    p.put("hospital",doctor.getHospital());
                    p.put("jwHospital",mode.getString("HEALTH_ORG_CODE"));
                }else{
                    p.put("doctor",mode.getString("APPLY_OPERATOR"));
                    p.put("doctorName",mode.getString("APPLY_OPERATOR_NAME"));
                    p.put("hospitalName",mode.getString("HEALTH_ORG_CODE"));
                    p.put("jwHospital",mode.getString("HEALTH_ORG_CODE"));
                }*/
                JSONObject diagnosis = new JSONObject();
                String diagnoseCode = mode.getString("DIAGNOSE_CODE");
                String diagnoseName = mode.getString("DIAGNOSE_NAME");
//                String diagnoseCode = "E10.100";
//                String diagnoseName = "1型糖尿病性酮症";
                diagnosis.put("code",diagnoseCode);//诊断代码
                diagnosis.put("name",diagnoseName);//诊断名称
/*                String icd10 = icd10DictServcie.getHealthProblemsByIcd10Code(diagnoseCode);
                if(!StringUtils.isEmpty(icd10)){
                    JSONObject icd = JSONObject.parseObject(icd10);
                    diagnosis.put("healthProblemName",icd.getString("value"));//诊断名称
                    diagnosis.put("healthProblem",icd.getString("key"));//诊断代码
                }else{
                    diagnosis.put("healthProblemName",diagnoseName);//诊断名称
                    diagnosis.put("healthProblem",diagnoseCode);//诊断代码
                }*/
                JSONArray jsonArrayDt = new JSONArray();
                jsonArrayDt.add(diagnosis);
    
                if(mode.getString("DIAGNOSE_SUB_CODE")!=null){
                    JSONObject diagnosisSub = new JSONObject();
                    String diagnoseCodeSub = mode.getString("DIAGNOSE_SUB_CODE");
                    String diagnoseNameSub = mode.getString("DIAGNOSE_SUB_NAME");
                    diagnosisSub.put("code",diagnoseCodeSub);//诊断代码
                    diagnosisSub.put("name",diagnoseNameSub);//诊断名称
/*                    String icd10Sub = icd10DictServcie.getHealthProblemsByIcd10Code(diagnoseCodeSub);
                    if(!StringUtils.isEmpty(icd10Sub)){
                        JSONObject icdSub = JSONObject.parseObject(icd10Sub);
                        diagnosisSub.put("healthProblemName",icdSub.getString("value"));//诊断名称
                        diagnosisSub.put("healthProblem",icdSub.getString("key"));//诊断代码
                    }else{
                        diagnosisSub.put("healthProblemName",diagnoseNameSub);//诊断名称
                        diagnosisSub.put("healthProblem",diagnoseCodeSub);//诊断代码
                    }*/
                    jsonArrayDt.add(diagnosisSub);
                }
                
                p.put("prescriptionDt",jsonArrayDt);

                JSONArray infos = mode.getJSONArray("RECIPE_DETAIL");
                Iterator infoIt = infos.iterator();
                JSONArray prescriptionInfos = new JSONArray();
                while (infoIt.hasNext()){
                    JSONObject info = (JSONObject) infoIt.next();
                    JSONObject prescriptionInfo = new JSONObject();
                    prescriptionInfo.put("Remark",info.getString("REMARK"));
                    prescriptionInfo.put("BindFlag",info.getString("BIND_FLAG"));
                    prescriptionInfo.put("direction",info.getString("USAGE_NAME"));//药品用法
                    prescriptionInfo.put("drugCode",info.getString("ITEM_CODE"));//药品code
                    prescriptionInfo.put("drugName",info.getString("ITEM_NAME"));//药品名称
                    prescriptionInfo.put("drugRate",info.getString("FREQUENCY"));//吃药频率 FREQUENCY
                    prescriptionInfo.put("drugRateName",info.getString("FREQUENCY_NAME"));
                    prescriptionInfo.put("drugFormat",info.getString("ITEM_SPEC"));//药品规格
                    prescriptionInfo.put("price",info.getDouble("ITEM_PRICE"));//药品单价
                    prescriptionInfo.put("num",info.getInteger("ITEM_QUANTITY"));//药品数目
                    prescriptionInfo.put("jwSubCode",info.getString("RECIPE_SUB_NO"));//智业子处方号
                    prescriptionInfo.put("drugNumUnit",info.getString("ITEM_UNIT"));//数量单位编码
                    prescriptionInfo.put("drugNumUnitName",info.getString("ITEM_UNIT_NAME"));//数量单位名称
                    prescriptionInfo.put("cost",info.getDouble("COST"));//金额
                    prescriptionInfo.put("charge",info.getDouble("CHARGE"));//自付
                    prescriptionInfo.put("bindFlag",info.getString("BIND_FLAG"));//成组标志, 0.非成组,1.成组
                    prescriptionInfo.put("dayCount",info.getInteger("DAY_COUNT"));//用药天数
                    prescriptionInfo.put("drugUsage",info.getString("USAGE"));//用药方法编码
                    prescriptionInfo.put("usageName",info.getString("USAGE_NAME"));//用药方法名称
                    prescriptionInfo.put("physicDose",info.getString("PHYSIC_DOSE"));//用药剂量
                    prescriptionInfo.put("physicDoseUnit",info.getString("PHYSIC_DOSE_UNIT"));//剂量单位编码
                    prescriptionInfo.put("physicDoseUnitName",info.getString("PHYSIC_DOSE_UNIT_NAME"));//剂量单位名称
                    prescriptionInfo.put("physicAmount",info.getString("PHYSIC_AMOUNT"));//用药总量
                    prescriptionInfo.put("physicAmountUnit",info.getString("PHYSIC_AMOUNT_UNIT"));//总量单位编码
                    prescriptionInfo.put("physicAmountUnitName",info.getString("PHYSIC_AMOUNT_UNIT_NAME"));//总量单位名称
                    prescriptionInfo.put("physicInjectPlace",info.getString("PHYSIC_INJECT_PLACE"));//注射地点编码
                    prescriptionInfo.put("physicInjectPlaceName",info.getString("PHYSIC_INJECT_PLACE_NAME"));//注射地点名称
                    prescriptionInfo.put("physicSkinTest",info.getString("PHYSIC_SKIN_TEST"));//皮试类型名称
                    prescriptionInfo.put("physicSkinTestName",info.getString("PHYSIC_SKIN_TEST_NAME"));//皮试类型名称
                    prescriptionInfo.put("subjectClass",info.getString("SUBJECT_CLASS"));//科目类型
                    prescriptionInfos.add(prescriptionInfo);
                }
                p.put("prescriptionInfo",prescriptionInfos);
                return p;
            }
        }catch (Exception e){
            logger.info("PresModeAdapter:modelToSinglePrescription:Json:"+json);
            throw e;
        }
        return new JSONObject();
    }

    /**
     * 思明上门处方详情转换
     * @param json
     * @return
     */
    public JSONArray modelToDoorPrescription(String json){
        try{
            JSONArray res = new JSONArray();
            JSONObject oldJson = JSONObject.parseObject(json);
            if(oldJson.getInteger("status")!=200){
                throw new RuntimeException("智业接口失败："+oldJson.getString("msg"));
            }
            JSONObject data = JSONObject.parseObject(oldJson.getString("data"));
            JSONArray returnData = data.getJSONArray("returnData").getJSONArray(0);
            String code = data.getString("CODE");
            if(StringUtils.isNotBlank(code)&&"1".equals(code)&&returnData.size()>0){
                for(Object o : returnData) {
//                    JSONArray modeArray = returnData.getJSONArray(0);
                    JSONObject mode = (JSONObject) o;
                    JSONObject p = new JSONObject();
                    p.put("code", mode.getInteger("RECIPE_NO") + "");
                    p.put("createTime", mode.getString("APPLY_TIME"));

/*                    Doctor doctor = zyDictService.getDoctByJw(mode.getString("APPLY_OPERATOR"), mode.getString("HEALTH_ORG_CODE"));
                    // "APPLY_OPERATOR_NAME": 开单医生姓名","HEALTH_ORG_CODE": "开单机构编码",
                    if (doctor != null) {
                        p.put("doctor", doctor.getCode());
                        p.put("doctorName", doctor.getName());
                        p.put("hospitalName", doctor.getHospitalName());
                        p.put("hospital", doctor.getHospital());
                        p.put("jwHospital", mode.getString("HEALTH_ORG_CODE"));
                    } else {
                        p.put("doctor", mode.getString("APPLY_OPERATOR"));
                        p.put("doctorName", mode.getString("APPLY_OPERATOR_NAME"));
                        p.put("hospitalName", mode.getString("HEALTH_ORG_CODE"));
                        p.put("jwHospital", mode.getString("HEALTH_ORG_CODE"));
                    }*/
                    JSONObject diagnosis = new JSONObject();
                    String diagnoseCode = mode.getString("DIAGNOSE_CODE");
                    String diagnoseName = mode.getString("DIAGNOSE_NAME");
//                String diagnoseCode = "E10.100";
//                String diagnoseName = "1型糖尿病性酮症";
                    diagnosis.put("code", diagnoseCode);//诊断代码
                    diagnosis.put("name", diagnoseName);//诊断名称
/*                    String icd10 = icd10DictServcie.getHealthProblemsByIcd10Code(diagnoseCode);
                    if (!StringUtils.isEmpty(icd10)) {
                        JSONObject icd = JSONObject.parseObject(icd10);
                        diagnosis.put("healthProblemName", icd.getString("value"));//诊断名称
                        diagnosis.put("healthProblem", icd.getString("key"));//诊断代码
                    } else {
                        diagnosis.put("healthProblemName", diagnoseName);//诊断名称
                        diagnosis.put("healthProblem", diagnoseCode);//诊断代码
                    }*/
                    JSONArray jsonArrayDt = new JSONArray();
                    jsonArrayDt.add(diagnosis);

                    if (mode.getString("DIAGNOSE_SUB_CODE") != null) {
                        JSONObject diagnosisSub = new JSONObject();
                        String diagnoseCodeSub = mode.getString("DIAGNOSE_SUB_CODE");
                        String diagnoseNameSub = mode.getString("DIAGNOSE_SUB_NAME");
                        diagnosisSub.put("code", diagnoseCodeSub);//诊断代码
                        diagnosisSub.put("name", diagnoseNameSub);//诊断名称
/*                        String icd10Sub = icd10DictServcie.getHealthProblemsByIcd10Code(diagnoseCodeSub);
                        if (!StringUtils.isEmpty(icd10Sub)) {
                            JSONObject icdSub = JSONObject.parseObject(icd10Sub);
                            diagnosisSub.put("healthProblemName", icdSub.getString("value"));//诊断名称
                            diagnosisSub.put("healthProblem", icdSub.getString("key"));//诊断代码
                        } else {
                            diagnosisSub.put("healthProblemName", diagnoseNameSub);//诊断名称
                            diagnosisSub.put("healthProblem", diagnoseCodeSub);//诊断代码
                        }*/
                        jsonArrayDt.add(diagnosisSub);
                    }

//                    p.put("prescriptionDt", jsonArrayDt);

                    JSONArray infos = mode.getJSONArray("RECIPE_DETAIL");
                    Iterator infoIt = infos.iterator();
                    JSONArray prescriptionInfos = new JSONArray();
                    while (infoIt.hasNext()) {
                        JSONObject info = (JSONObject) infoIt.next();
                        JSONObject prescriptionInfo = new JSONObject();
                        prescriptionInfo.put("Remark", info.getString("REMARK"));
                        prescriptionInfo.put("BindFlag", info.getString("BIND_FLAG"));
                        prescriptionInfo.put("direction", info.getString("USAGE_NAME"));//药品用法
                        prescriptionInfo.put("drugCode", info.getString("ITEM_CODE"));//药品code
                        prescriptionInfo.put("drugName", info.getString("ITEM_NAME"));//药品名称
                        prescriptionInfo.put("drugRate", info.getString("FREQUENCY"));//吃药频率 FREQUENCY
                        prescriptionInfo.put("drugRateName", info.getString("FREQUENCY_NAME"));
                        prescriptionInfo.put("drugFormat", info.getString("ITEM_SPEC"));//药品规格
                        prescriptionInfo.put("price", info.getDouble("ITEM_PRICE"));//药品单价
                        prescriptionInfo.put("num", info.getInteger("ITEM_QUANTITY"));//药品数目
                        prescriptionInfo.put("jwSubCode", info.getString("RECIPE_SUB_NO"));//智业子处方号
                        prescriptionInfo.put("drugNumUnit", info.getString("ITEM_UNIT"));//数量单位编码
                        prescriptionInfo.put("drugNumUnitName", info.getString("ITEM_UNIT_NAME"));//数量单位名称
                        prescriptionInfo.put("cost", info.getDouble("COST"));//金额
                        prescriptionInfo.put("charge", info.getDouble("CHARGE"));//自付
                        prescriptionInfo.put("bindFlag", info.getString("BIND_FLAG"));//成组标志, 0.非成组,1.成组
                        prescriptionInfo.put("dayCount", info.getInteger("DAY_COUNT"));//用药天数
                        prescriptionInfo.put("drugUsage", info.getString("USAGE"));//用药方法编码
                        prescriptionInfo.put("usageName", info.getString("USAGE_NAME"));//用药方法名称
                        prescriptionInfo.put("physicDose", info.getString("PHYSIC_DOSE"));//用药剂量
                        prescriptionInfo.put("physicDoseUnit", info.getString("PHYSIC_DOSE_UNIT"));//剂量单位编码
                        prescriptionInfo.put("physicDoseUnitName", info.getString("PHYSIC_DOSE_UNIT_NAME"));//剂量单位名称
                        prescriptionInfo.put("physicAmount", info.getString("PHYSIC_AMOUNT"));//用药总量
                        prescriptionInfo.put("physicAmountUnit", info.getString("PHYSIC_AMOUNT_UNIT"));//总量单位编码
                        prescriptionInfo.put("physicAmountUnitName", info.getString("PHYSIC_AMOUNT_UNIT_NAME"));//总量单位名称
                        prescriptionInfo.put("physicInjectPlace", info.getString("PHYSIC_INJECT_PLACE"));//注射地点编码
                        prescriptionInfo.put("physicInjectPlaceName", info.getString("PHYSIC_INJECT_PLACE_NAME"));//注射地点名称
                        prescriptionInfo.put("physicSkinTest", info.getString("PHYSIC_SKIN_TEST"));//皮试类型名称
                        prescriptionInfo.put("physicSkinTestName", info.getString("PHYSIC_SKIN_TEST_NAME"));//皮试类型名称
                        prescriptionInfo.put("subjectClass", info.getString("SUBJECT_CLASS"));//科目类型
                        prescriptionInfos.add(prescriptionInfo);
                    }
                    p.put("prescriptionInfo", prescriptionInfos);
                    res.add(p);
                }
                return res;
            }
        }catch (Exception e){
            logger.info("PresModeAdapter:modelToSinglePrescription:Json:"+json);
            throw e;
        }
        return new JSONArray();
    }
}
