package com.yihu.jw.entrance.controller;

import com.yihu.jw.hospital.caauth.CaService;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 * Created by Trick on 2019/12/24.
 */
@RestController
@RequestMapping(value ="/ca")
@Api(value = "ca测试", description = "ca测试", tags = {"ca测试"})
public class CaController extends EnvelopRestEndpoint {

    @Autowired
    private CaService caService;

    @GetMapping(value = "/getQRCodeBySys")
    @ApiOperation(value = "测试二维码")
    public Envelop getQRCodeBySys(@ApiParam(name = "url", value = "url", required = true)
                                  @RequestParam(value = "url") String url,
                                  @ApiParam(name = "name", value = "namespace", required = true)
                                  @RequestParam(value = "name")String name,
                                  @ApiParam(name = "api", value = "api", required = true)
                                  @RequestParam(value = "api")String api,
                                  @ApiParam(name = "sys", value = "系统名", required = true)
                                  @RequestParam(value = "sys")String sys) throws Exception{
        return success(caService.getQRCodeBySys(url,name,api,sys));
    }

    @GetMapping(value = "/queryQRCode")
    @ApiOperation(value = "查询二维码")
    public Envelop queryQRCode(@ApiParam(name = "url", value = "url", required = true)
                                  @RequestParam(value = "url") String url,
                                  @ApiParam(name = "name", value = "namespace", required = true)
                                  @RequestParam(value = "name")String name,
                                  @ApiParam(name = "api", value = "api", required = true)
                                  @RequestParam(value = "api")String api,
                                  @ApiParam(name = "qrCode", value = "二维码验证码", required = true)
                                  @RequestParam(value = "qrCode")String qrCode) throws Exception{
        return success(caService.queryQRCode(url,name,api,qrCode));
    }
}
