package com.yihu.jw.entrance.controller;

import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.ObjEnvelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import com.yihu.jw.wechat.enterprise.EnterpriseService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import net.sf.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * Created by Trick on 2020/2/9.
 */
@RestController
@RequestMapping(value ="/enterprise")
@Api(value = "企业号相关", description = "企业号相关", tags = {"企业号相关"})
public class EnterpriseController extends EnvelopRestEndpoint {

    @Autowired
    private EnterpriseService enterpriseService;

    @PostMapping(value = "/sendTWMes")
    @ApiOperation(value = "发送图文消息")
    public Envelop sendTWMes(
            @ApiParam(name = "enterpriseId", value = "企业id", required = true)
            @RequestParam(value = "enterpriseId") String enterpriseId,
            @ApiParam(name = "mobile", value = "手机号", required = true)
            @RequestParam(value = "mobile")String mobile,
            @ApiParam(name = "title", value = "标题", required = true)
            @RequestParam(value = "title")String title,
            @ApiParam(name = "description", value = "描述", required = true)
            @RequestParam(value = "description")String description,
            @ApiParam(name = "url", value = "跳转链接", required = true)
            @RequestParam(value = "url")String url) throws Exception{
        return success(enterpriseService.sendTWMesBymobile( enterpriseId, mobile, title, description, url));
    }

    @PostMapping(value = "/sendTWMesByDoctor")
    @ApiOperation(value = "发送图文消息")
    public Envelop sendTWMesByDoctor(
            @ApiParam(name = "enterpriseId", value = "企业id", required = true)
            @RequestParam(value = "enterpriseId") String enterpriseId,
            @ApiParam(name = "doctor", value = "医生code", required = true)
            @RequestParam(value = "doctor")String doctor,
            @ApiParam(name = "title", value = "标题", required = true)
            @RequestParam(value = "title")String title,
            @ApiParam(name = "description", value = "描述", required = true)
            @RequestParam(value = "description")String description,
            @ApiParam(name = "url", value = "跳转链接", required = true)
            @RequestParam(value = "url")String url) throws Exception{
        return success(enterpriseService.sendTWMesByDoctor( enterpriseId, doctor, title, description, url));
    }

    @PostMapping(value = "/sendMKMesByDoctor")
    @ApiOperation(value = "发送MK消息")
    public Envelop sendMKMesByDoctor(
            @ApiParam(name = "enterpriseId", value = "企业id", required = true)
            @RequestParam(value = "enterpriseId") String enterpriseId,
            @ApiParam(name = "doctor", value = "医生code", required = true)
            @RequestParam(value = "doctor")String doctor,
            @ApiParam(name = "content", value = "描述", required = true)
            @RequestParam(value = "content")String content) throws Exception{
        return success(enterpriseService.sendMKMesByDoctor(enterpriseId,doctor,content));
    }

    @PostMapping(value = "/sendMKMesByMobile")
    @ApiOperation(value = "发送MK消息")
    public Envelop sendMKMesByMobile(
            @ApiParam(name = "enterpriseId", value = "企业id", required = true)
            @RequestParam(value = "enterpriseId") String enterpriseId,
            @ApiParam(name = "mobile", value = "手机号", required = true)
            @RequestParam(value = "mobile")String mobile,
            @ApiParam(name = "content", value = "描述", required = true)
            @RequestParam(value = "content")String content) throws Exception{
        return success(enterpriseService.sendMKMesByMobile(enterpriseId,mobile,content));
    }

    @PostMapping(value = "/sendXCXMesByDoctor")
    @ApiOperation(value = "发送小程序消息")
    public Envelop sendXCXMesByDoctor(@ApiParam(name = "enterpriseId", value = "企业id", required = true)
                                          @RequestParam(value = "enterpriseId")String enterpriseId,
                                      @ApiParam(name = "doctor", value = "医生手机号", required = true)
                                          @RequestParam(value = "doctor")String doctor,
                                      @ApiParam(name = "appid", value = "appid", required = true)
                                          @RequestParam(value = "appid")String appid,
                                      @ApiParam(name = "page", value = "跳转地址", required = true)
                                          @RequestParam(value = "page")String page,
                                      @ApiParam(name = "title", value = "标题", required = true)
                                          @RequestParam(value = "title")String title,
                                      @ApiParam(name = "description", value = "描述", required = true)
                                          @RequestParam(value = "description")String description,
                                      @ApiParam(name = "emphasis_first_item", value = "是否首行放大", required = true)
                                          @RequestParam(value = "emphasis_first_item")Boolean emphasis_first_item,
                                      @ApiParam(name = "content_item", value = "内容JSON数组字符串", required = true)
                                          @RequestParam(value = "content_item")String content_item) throws Exception{
        return success(enterpriseService.sendXCXMesByDoctor(enterpriseId,doctor,appid,page,title,description,emphasis_first_item,content_item));
    }

    @PostMapping(value = "/sendXCXMesByMobile")
    @ApiOperation(value = "发送小程序消息")
    public Envelop sendXCXMesByMobile(@ApiParam(name = "enterpriseId", value = "企业id", required = true)
                                          @RequestParam(value = "enterpriseId")String enterpriseId,
                                      @ApiParam(name = "mobile", value = "手机号", required = true)
                                      @RequestParam(value = "mobile")String mobile,
                                      @ApiParam(name = "appid", value = "appid", required = true)
                                          @RequestParam(value = "appid")String appid,
                                      @ApiParam(name = "page", value = "跳转地址", required = true)
                                          @RequestParam(value = "page")String page,
                                      @ApiParam(name = "title", value = "标题", required = true)
                                          @RequestParam(value = "title")String title,
                                      @ApiParam(name = "description", value = "描述", required = true)
                                          @RequestParam(value = "description")String description,
                                      @ApiParam(name = "emphasis_first_item", value = "是否首行放大", required = true)
                                          @RequestParam(value = "emphasis_first_item")Boolean emphasis_first_item,
                                      @ApiParam(name = "content_item", value = "内容JSON数组字符串", required = true)
                                          @RequestParam(value = "content_item")String content_item) throws Exception{
        return success(enterpriseService.sendXCXMesByMobile(enterpriseId,mobile,appid,page,title,description,emphasis_first_item,content_item));
    }

    @PostMapping(value = "/saveAllUser")
    @ApiOperation(value = "拉取用户信息")
    public Envelop saveAllUser(
            @ApiParam(name = "enterpriseId", value = "企业id", required = true)
            @RequestParam(value = "enterpriseId") String enterpriseId) throws Exception{
        return success(enterpriseService.saveAllUser(enterpriseId));
    }
}
