package com.yihu.jw.entrance.controller;


import com.fasterxml.jackson.databind.ObjectMapper;
import com.yihu.jw.entity.base.dict.DictHospitalDeptDO;
import com.yihu.jw.entity.hospital.dict.WlyyChargeDictDO;
import com.yihu.jw.hospital.prescription.service.entrance.EntranceService;
import com.yihu.jw.hospital.prescription.service.entrance.RegisterService;
import com.yihu.jw.order.pay.ylz.YlzPayService;
import com.yihu.jw.restmodel.hospital.prescription.WlyyOutpatientVO;
import com.yihu.jw.restmodel.hospital.prescription.WlyyPrescriptionVO;
import com.yihu.jw.restmodel.hospital.register.RegisterAmVO;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.ListEnvelop;
import com.yihu.jw.restmodel.web.ObjEnvelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import net.sf.json.JSON;
import net.sf.json.JSONArray;
import net.sf.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.*;

import java.util.List;


/**
 * Created by zdm on 2019/5/16
 */
@RestController
@RequestMapping(value ="/mqsdk")
@Api(value = "his信息获取解析", description = "his信息获取解析", tags = {"hospital-entrance基础服务"})
public class MqSdkController extends EnvelopRestEndpoint {
    private boolean testProfiles=false;
    @Autowired
    private EntranceService entranceService;
    @Autowired
    private RegisterService registerService;
    @Value("${demo.flag}")
    private boolean demoFlag;

    @Autowired
    private ObjectMapper objectMapper;
    @Autowired
    private YlzPayService ylzPayService;

    @GetMapping(value = "/BS15017")
    @ApiOperation(value = "固定入参：门诊余额查询")
    public ObjEnvelop BS15017(
            @ApiParam(name = "cardNo", value = "卡号", required = true)
            @RequestParam(value = "cardNo") String cardNo) {
        try {
           JSONObject obj= entranceService.qutpatientBalance(cardNo,demoFlag);
          return ObjEnvelop.getSuccess("获取成功",obj);
        } catch (Exception e) {
            e.printStackTrace();
            return ObjEnvelop.getError("获取失败"+e.getMessage());
        }
    }

    @GetMapping(value = "/BS15018")
    @ApiOperation(value = "固定入参：门诊就诊卡列表")
    public ListEnvelop BS15018(
            @ApiParam(name = "socialNo", value = "身份证号", required = false)
            @RequestParam(value = "socialNo",required = false) String socialNo,
            @ApiParam(name = "cardNo", value = "就诊卡号", required = false)
            @RequestParam(value = "cardNo",required = false) String cardNo) throws Exception {
        JSONArray obj = entranceService.BS15018(socialNo, cardNo, demoFlag);
        return success(obj);
    }

    @GetMapping(value = "/BS16017")
    @ApiOperation(value = "根据流水号或者居民id查找门诊处方信息（所有处方）")
    public ListEnvelop BS16017(
            @ApiParam(name = "registerSn", value = "流水号", required = false)
            @RequestParam(value = "registerSn",required = false) String registerSn,
            @ApiParam(name = "patNo", value = "病人id", required = false)
            @RequestParam(value = "patNo",required = false) String patNo,
            @ApiParam(name = "admNo", value = "住院唯一号", required = false)
            @RequestParam(value = "admNo",required = false) String admNo,
            @ApiParam(name = "realOrder", value = "处方号", required = false)
            @RequestParam(value = "realOrder",required = false) String realOrder) throws Exception {
        List<WlyyPrescriptionVO> obj = entranceService.BS16017(registerSn,realOrder, patNo, admNo, demoFlag);
        return success(obj);
    }

    @GetMapping(value = "/BS30025")
    @ApiOperation(value = " 查询某个时间段的患者门诊就诊记录 V1.00")
    public ListEnvelop BS30025(@ApiParam(name = "patNo", value = "居民id")
                               @RequestParam(value = "patNo", required = false) String patNo,
                               @ApiParam(name = "conNo", value = "就诊次数")
                               @RequestParam(value = "conNo", required = false) String conNo,
                               @ApiParam(name = "startTime", value = "开始时间")
                               @RequestParam(value = "startTime", required = false) String startTime,
                               @ApiParam(name = "endTime", value = "结束时间")
                               @RequestParam(value = "endTime", required = false) String endTime) throws Exception {
        List<WlyyOutpatientVO> obj = entranceService.BS30025(patNo,conNo, startTime, endTime, demoFlag,null);
        return success(obj);
    }

    @GetMapping(value = "/MS30001")
    @ApiOperation(value = "医院药品字典 V1.00--弃用")
    public ListEnvelop MS30001(@ApiParam(name = "DRUG_CODE", value = "字典编码")
                          @RequestParam(value = "DRUG_CODE", required = false) String DRUG_CODE,
                          @ApiParam(name = "startTime", value = "就诊开始时间")
                          @RequestParam(value = "startTime", required = false) String startTime) throws Exception{
            String obj=  entranceService.MS30001();
           return convertListEnvelopInBody(obj);
    }


    @GetMapping(value = "/MS53001")
    @ApiOperation(value = " 医院药品字典")
    public ListEnvelop MS53001(@ApiParam(name = "chargeCode", value = "收费码")
                          @RequestParam(value = "chargeCode", required = false) String chargeCode,
                          @ApiParam(name = "pyCode", value = "拼音码")
                          @RequestParam(value = "pyCode", required = false) String pyCode,
                          @ApiParam(name = "stockAmount", value = "库存")
                          @RequestParam(value = "stockAmount", required = false) String stockAmount,
                          @ApiParam(name = "winNo", value = "分部：6总部7金榜8夏禾")
                          @RequestParam(value = "winNo", required = false) String winNo,
                          @ApiParam(name = "visibleFlag", value = "可用标志(0可用1不可用)")
                          @RequestParam(value = "visibleFlag", required = false) String visibleFlag,
                          @ApiParam(name = "groupNo", value = "药房编码")
                          @RequestParam(value = "groupNo", required = false) String groupNo)throws Exception{
        JSONArray obj=  entranceService.MS53001(chargeCode,pyCode,stockAmount, winNo,visibleFlag,groupNo,demoFlag);
           return success(obj);
    }

    @GetMapping(value = "/BS10110")
    @ApiOperation(value = "门诊给药方式")
    public ListEnvelop BS10110(
            @ApiParam(name = "supplyCode", value = "编码")
            @RequestParam(value = "supplyCode", required = false) String supplyCode,
            @ApiParam(name = "py_code", value = "编码")
            @RequestParam(value = "py_code", required = false) String py_code) throws Exception{
        JSONArray obj=  entranceService.BS10110(supplyCode,py_code,demoFlag);
            return success(obj);
    }

    @PostMapping(value = "/BS10111")
    @ApiOperation(value = "  线上挂号接口")
    public ObjEnvelop BS10111(
            @ApiParam(name = "cardNo", value = "卡号")
            @RequestParam(value = "cardNo", required = false) String cardNo,
            @ApiParam(name = "doctor", value = "医生工号")
            @RequestParam(value = "doctor", required = false) String doctor,
            @ApiParam(name = "dept", value = "科室编码")
            @RequestParam(value = "dept", required = false) String dept,
            @ApiParam(name = "chargeType", value = "号别")
            @RequestParam(value = "chargeType", required = false) String chargeType,
            @ApiParam(name = "winNo", value = "分部号")
            @RequestParam(value = "winNo", required = false) String winNo) throws Exception {
        JSONObject obj = entranceService.BS10111(cardNo, doctor, dept, chargeType, winNo,demoFlag);
        return ObjEnvelop.getSuccess("获取成功",obj);
    }

    @PostMapping(value = "/BS10138")
    @ApiOperation(value = "  线上挂号接口")
    public ObjEnvelop BS10138(
            @ApiParam(name = "cardNo", value = "卡号")
            @RequestParam(value = "cardNo", required = false) String cardNo,
            @ApiParam(name = "doctor", value = "医生工号")
            @RequestParam(value = "doctor", required = false) String doctor,
            @ApiParam(name = "dept", value = "科室编码")
            @RequestParam(value = "dept", required = false) String dept,
            @ApiParam(name = "serial_no", value = "挂号号")
            @RequestParam(value = "serial_no", required = false) String serial_no,
            @ApiParam(name = "winNo", value = "分部号")
            @RequestParam(value = "winNo", required = false) String winNo) throws Exception {
        JSONObject obj = entranceService.BS10138(cardNo, doctor, dept, serial_no, winNo,demoFlag);
        return ObjEnvelop.getSuccess("获取成功",obj);
    }

    //多个前端使用json传参
    @PostMapping(value = "/BS10112")
    @ApiOperation(value = "线上处方接口")
    public ObjEnvelop BS10112(
            @ApiParam(name = "jsonData", value = "处方开方json数组对象")
            @RequestBody String jsonData) throws Exception {
        JSONObject obj = entranceService.BS10112(jsonData,demoFlag);
        return  success(obj);
    }


    @GetMapping(value = "/BS10114")
    @ApiOperation(value = "医生挂号权限查询接口 ")
    public ListEnvelop BS10114(
            @ApiParam(name = "doctorCode", value = "医生工号")
            @RequestParam(value = "doctorCode", required = false) String doctorCode,
            @ApiParam(name = "dept", value = "科室编码")
            @RequestParam(value = "dept", required = false) String dept,
            @ApiParam(name = "chargeType", value = "号别编码")
            @RequestParam(value = "chargeType", required = false) String chargeType,
            @ApiParam(name = "winNo", value = "分部号")
            @RequestParam(value = "winNo", required = false) String winNo) throws Exception {
        JSONArray obj = entranceService.BS10114(doctorCode, dept, chargeType, winNo,demoFlag);
        return success(obj);
    }

    @GetMapping(value = "/MS02001")
    @ApiOperation(value = "科室字典  ")
    public ListEnvelop MS02001() throws Exception {
        List<DictHospitalDeptDO> obj = entranceService.MS02001(demoFlag);
        return success(obj);
    }

    @GetMapping(value = "/updateMS02001")
    @ApiOperation(value = "科室字典  ")
    public Envelop updateMS02001() throws Exception {
        return success(entranceService.updateMS02001(demoFlag));
    }

    @GetMapping(value = "/MS02013")
    @ApiOperation(value = "号别字典接口   ")
    public ListEnvelop MS02013(
            @ApiParam(name = "code", value = "号别字典")
            @RequestParam(value = "code", required = false) String code
    ) throws Exception {
        JSONArray obj = entranceService.MS02013(code);
        return success(obj);
    }

    @GetMapping(value = "/MS30012")
    @ApiOperation(value = "医院频次")
    public ListEnvelop MS30012() throws Exception {
        JSONArray obj = entranceService.MS30012(demoFlag);
        return success(obj);
    }


    @GetMapping(value = "/MS25001")
    @ApiOperation(value = "Icd10诊断编码")
    public ListEnvelop MS25001( @ApiParam(name = "pyCode", value = "拼音码")
                                @RequestParam(value = "pyCode", required = false) String pyCode,
                                @ApiParam(name = "flag", value = "1为旧的ICD10 3为ICD9 4为2012-8月份ICD10")
                                @RequestParam(value = "flag", required = false) String flag)throws Exception {
        JSONArray obj = entranceService.MS25001(pyCode,demoFlag);
        return success(obj);
    }


    /**
     * 返回对象数组数据解析
     * @param obj
     * @return
     * @throws Exception
     */
    public ListEnvelop convertListEnvelopInBody(String obj)throws Exception{
        JSONObject jsonObject=JSONObject.fromObject(obj);
        JSONArray jsonArray=new JSONArray();
        if(null!=jsonObject&&"1".equals(jsonObject.get("code").toString())){
            JSONArray jsonObjectMgsInfo=(JSONArray)jsonObject.get("MsgInfo");
            if(null!=jsonObjectMgsInfo){
                for (Object object : jsonObjectMgsInfo) {
                    JSONObject jsonObjectBody=(JSONObject)object;
                    Object objectBody=jsonObjectBody.get("body");
                    if(objectBody instanceof JSONArray){
                        net.sf.json.JSONArray jsonArrayBody = (net.sf.json.JSONArray) jsonObjectBody.get("body");
                        for (Object objectBodySub : jsonArrayBody) {
                            jsonArray.add(objectBodySub);
                        }
                    }else {
                        jsonArray.add(jsonObjectBody) ;

                    }
                }
                return success(jsonArray);
            }else {
                return null;
            }
        }else {
            return  null;
        }
    }


    @GetMapping(value = "/yytDown")
    @ApiOperation(value = " 银医通下载 ")
    public ObjEnvelop yytDown(
            @ApiParam(name = "cardNo", value = "卡号", required = true)
            @RequestParam(value = "cardNo") String cardNo) {
        try {
            JSONObject  obj= entranceService.callYYTServerService(cardNo);
            return success(obj);
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }

    @GetMapping(value = "/guahao")
    @ApiOperation(value = " 查询挂号是否失效")
    public ObjEnvelop guahao(@ApiParam(name = "patNo", value = "居民id")
                         @RequestParam(value = "patNo",required = false) String patNo,
                         @ApiParam(name = "dept", value = "挂号科室")
                         @RequestParam(value = "dept",required = false) String dept,
                         @ApiParam(name = "doctor", value = "就诊医生")
                         @RequestParam(value = "doctor",required = false) String doctor) {
        try {
            boolean  obj = entranceService.guahao(patNo,dept,doctor,demoFlag);
            return success(obj);
        } catch (Exception e) {
            e.printStackTrace();
            return ObjEnvelop.getError("获取失败："+e.getMessage());
        }
    }

    @GetMapping(value = "/MS25002")
    @ApiOperation(value = " 检查检验字典接口 ")
    public ListEnvelop MS25002( @ApiParam(name = "pyCode", value = "拼音码")
                           @RequestParam(value = "pyCode", required = false) String pyCode,
                           @ApiParam(name = "winNo", value = "库存")
                           @RequestParam(value = "winNo", required = false) String winNo,
                           @ApiParam(name = "codes", value = "检查检验收费码codes，逗号分割")
                           @RequestParam(value = "codes", required = false) String codes) throws Exception {
        JSONArray obj = entranceService.MS25002(pyCode,codes,winNo,demoFlag);
        return success(obj);
    }

    @GetMapping(value = "/BS25017")
    @ApiOperation(value = "影像信息表")
    public ListEnvelop BS25017(@ApiParam(name = "patNo", value = "居民id")
                             @RequestParam(value = "patNo",required = false) String patNo,
                             @ApiParam(name = "conNo", value = "就诊次数")
                             @RequestParam(value = "conNo",required = false) String conNo) throws Exception{
            JSONArray  obj = entranceService.BS25017(patNo,conNo,demoFlag);
            return success(obj);
    }

    //检验的是通过BS20010先查出applyno 这个，然后去查BS20019
    @GetMapping(value = "/BS20019")
    @ApiOperation(value = "检验")
    public ListEnvelop BS20019(@ApiParam(name = "patNo", value = "居民id")
                               @RequestParam(value = "patNo",required = false) String patNo,
                               @ApiParam(name = "conNo", value = "就诊次数")
                               @RequestParam(value = "conNo",required = false) String conNo) throws Exception{
        JSONArray  obj = entranceService.BS20019(patNo,conNo,demoFlag);
        return success(obj);
    }

    //微生物的是先查BS20018，也是查出applyno 再去查BS20011
    @GetMapping(value = "/BS20011")
    @ApiOperation(value = "微生物")
    public ListEnvelop BS20011(@ApiParam(name = "patNo", value = "居民id")
                               @RequestParam(value = "patNo",required = false) String patNo,
                               @ApiParam(name = "conNo", value = "就诊次数")
                               @RequestParam(value = "conNo",required = false) String conNo) throws Exception{
        JSONArray  obj = entranceService.BS20011(patNo,conNo,demoFlag);
        return success(obj);
    }


    @GetMapping(value = "/BS55010")
    @ApiOperation(value = "医生号别及诊查费")
    public ListEnvelop BS55010(@ApiParam(name = "windowsNo", value = "分部号")
                               @RequestParam(value = "windowsNo", required = false) String windowsNo,
                               @ApiParam(name = "chargeType", value = "号别")
                               @RequestParam(value = "chargeType", required = false) String chargeType,
                               @ApiParam(name = "code", value = "医生编码")
                               @RequestParam(value = "code", required = false) String code) throws Exception {
        List<WlyyChargeDictDO> obj = entranceService.chargeDict(windowsNo, code,chargeType, demoFlag);
        return success(obj);
    }

    @GetMapping(value = "/MS02003")
    @ApiOperation(value = "医生信息同步")
    public ObjEnvelop MS02003() throws Exception {
       int obj = entranceService.MS02003(demoFlag);
       System.out.println("共同步"+obj+"位医生！");
        return success(obj);
    }

    @GetMapping(value = "/MS02014")
    @ApiOperation(value = "医生详细信息同步")
    public ObjEnvelop MS02014() throws Exception {
        return success(entranceService.MS02014(demoFlag));
    }


    @GetMapping(value = "/MS02019")
    @ApiOperation(value = "五级地址字典")
    public ListEnvelop MS02019() throws Exception{
        JSONArray  obj = entranceService.MS02019(demoFlag);
        return success(obj);
    }

    @GetMapping(value = "/BS10142")
    @ApiOperation(value = "核酸预约列表接口")
    public ListEnvelop BS10142(@ApiParam(name = "deptCode", value = "科室code")
                                   @RequestParam(value = "deptCode", required = true) String deptCode,
                               @ApiParam(name = "docCode", value = "医生code")
                               @RequestParam(value = "docCode", required = true) String docCode,
                               @ApiParam(name = "chargeType", value = "号别类型")
                                   @RequestParam(value = "chargeType", required = true) String chargeType) throws Exception{
        JSONArray  obj = entranceService.BS10142(deptCode,docCode,chargeType,demoFlag);
        return success(obj);
    }

    @GetMapping(value = "/BS10143")
    @ApiOperation(value = "核酸号源查询")
    public ListEnvelop BS10143(@ApiParam(name = "day", value = "时间")
                               @RequestParam(value = "day", required = true) String day,
                               @ApiParam(name = "pm", value = "pm")
                                   @RequestParam(value = "pm",required = false)String pm) throws Exception{
        JSONArray  obj = entranceService.BS10143(day,pm,demoFlag);
        return success(obj);
    }

    @GetMapping(value = "/BS10144")
    @ApiOperation(value = "核酸预约")
    public Envelop BS10144(@ApiParam(name = "deptCode", value = "科室code")
                               @RequestParam(value = "deptCode", required = true) String deptCode,
                               @ApiParam(name = "docCode", value = "医生code")
                               @RequestParam(value = "docCode", required = true) String docCode,
                               @ApiParam(name = "startTime", value = "预约时间")
                               @RequestParam(value = "startTime", required = true) String startTime,
                               @ApiParam(name = "sSID", value = "社保卡")
                                   @RequestParam(value = "sSID", required = true) String sSID,
                               @ApiParam(name = "patientName", value = "患者姓名")
                                   @RequestParam(value = "patientName", required = true) String patientName,
                               @ApiParam(name = "patientID", value = "患者身份证")
                                   @RequestParam(value = "patientID", required = true) String patientID,
                               @ApiParam(name = "patientPhone", value = "患者手机号")
                                   @RequestParam(value = "patientPhone", required = true) String patientPhone,
                           @ApiParam(name = "pm", value = "pm")
                               @RequestParam(value = "pm", required = true) String pm) throws Exception{
        //String deptCode,String docCode,String startTime,String sSID,String patientName,String patientID,String patientPhone
        String   obj = entranceService.BS10144(deptCode,docCode,startTime,sSID,patientName,patientID,patientPhone,pm,demoFlag);
        return success(obj);
    }

    @GetMapping(value = "/BS10145")
    @ApiOperation(value = "核酸预约")
    public Envelop BS10145(@ApiParam(name = "deptCode", value = "科室code")
                               @RequestParam(value = "deptCode", required = true) String deptCode,
                               @ApiParam(name = "docCode", value = "医生code")
                               @RequestParam(value = "docCode", required = true) String docCode,
                               @ApiParam(name = "startTime", value = "预约时间")
                               @RequestParam(value = "startTime", required = true) String startTime,
                               @ApiParam(name = "sSID", value = "社保卡")
                               @RequestParam(value = "sSID", required = true) String sSID,
                               @ApiParam(name = "patientName", value = "患者姓名")
                               @RequestParam(value = "patientName", required = true) String patientName,
                               @ApiParam(name = "patientID", value = "患者身份证")
                               @RequestParam(value = "patientID", required = true) String patientID,
                               @ApiParam(name = "patientPhone", value = "患者手机号")
                               @RequestParam(value = "patientPhone", required = true) String patientPhone,
                           @ApiParam(name = "pm", value = "pm")
                               @RequestParam(value = "pm", required = true) String pm) throws Exception{
        //String deptCode,String docCode,String startTime,String sSID,String patientName,String patientID,String patientPhone
        String  obj = entranceService.BS10145(deptCode,docCode,startTime,sSID,patientName,patientID,patientPhone,pm,demoFlag);
        return success(obj);
    }


    @PostMapping(value = "/ehospitalNotice")
    @ApiOperation(value = "互联网医院通知")
    public ObjEnvelop ehospitalNotice(
            @ApiParam(name = "userName", value = "推送人姓名")
            @RequestParam(value = "userName", required = true) String userName,
            @ApiParam(name = "idCard", value = "推送人身份证")
            @RequestParam(value = "idCard", required = false) String idCard,
            @ApiParam(name = "phone", value = "推送人手机号")
            @RequestParam(value = "phone", required = true) String phone,
            @ApiParam(name = "title", value = "推送标题")
            @RequestParam(value = "title", required = true) String title,
            @ApiParam(name = "url", value = "跳转链接")
            @RequestParam(value = "url", required = false) String url,
            @ApiParam(name = "content", value = "内容简介")
            @RequestParam(value = "content", required = true) String content,
            @ApiParam(name = "contentString", value = "内容明细串")
            @RequestParam(value = "contentString", required = false) String contentString) throws Exception {
        String responseMsg = entranceService.ehospitalNotice(userName, idCard, phone, title, url, content, contentString);
        org.json.JSONObject object1 = new org.json.JSONObject(responseMsg);
        if (null != object1 && "00".equals(object1.get("respCode"))) {
            return ObjEnvelop.getSuccess(object1.get("respMsg").toString(), null);
        } else {
            return ObjEnvelop.getError(object1.get("respMsg").toString());
        }
    }

    @GetMapping(value = "/ylzPushMessage")
    @ApiOperation(value = "易慧")
    public Envelop ylzPushMessage(@ApiParam(name = "cardType", value = "卡类型")
                           @RequestParam(value = "cardType", required = false) String cardType,
                           @ApiParam(name = "cardNo", value = "社保卡")
                           @RequestParam(value = "cardNo", required = false) String cardNo,
                           @ApiParam(name = "accountType", value = "预约时间")
                           @RequestParam(value = "accountType", required = false) String accountType,
                           @ApiParam(name = "contactNumber", value = "社保卡")
                           @RequestParam(value = "contactNumber", required = false) String contactNumber,
                           @ApiParam(name = "patientName", value = "患者姓名")
                           @RequestParam(value = "patientName", required = false) String patientName,
                           @ApiParam(name = "feeType", value = "患者身份证")
                           @RequestParam(value = "feeType", required = false) String feeType,
                           @ApiParam(name = "userNo", value = "患者手机号")
                           @RequestParam(value = "userNo", required = false) String userNo,
                           @ApiParam(name = "userName", value = "userName")
                           @RequestParam(value = "userName", required = false) String userName,
                            @ApiParam(name = "idNo", value = "idNo")
                            @RequestParam(value = "idNo", required = false) String idNo,
                            @ApiParam(name = "voucherNo", value = "voucherNo")
                            @RequestParam(value = "voucherNo", required = false) String voucherNo,
                            @ApiParam(name = "applyDepaName", value = "applyDepaName")
                            @RequestParam(value = "applyDepaName", required = false) String applyDepaName,
                            @ApiParam(name = "applyDoctorName", value = "applyDoctorName")
                            @RequestParam(value = "applyDoctorName", required = false) String applyDoctorName,
                            @ApiParam(name = "recipeTime", value = "recipeTime")
                            @RequestParam(value = "recipeTime", required = false) String recipeTime,
                              @ApiParam(name = "fee", value = "fee")
                                  @RequestParam(value = "fee", required = false) String fee,
                              @ApiParam(name = "recipeNum", value = "recipeNum")
                                  @RequestParam(value = "recipeNum", required = false) String recipeNum,
                                  @ApiParam(name = "pushChannel", value = "pushChannel")
                                      @RequestParam(value = "pushChannel", required = false) String pushChannel) throws Exception{
        //String deptCode,String docCode,String startTime,String sSID,String patientName,String patientID,String patientPhone
        String   obj = ylzPayService.msgPush(cardType,cardNo,accountType,contactNumber,feeType,userNo,userName,idNo,voucherNo,
                applyDepaName,applyDoctorName,recipeTime,fee,recipeNum,pushChannel);
        return success(obj);
    }


    @GetMapping(value = "/getUserInfoByOpenid")
    @ApiOperation(value = "获取用户信息")
    public ObjEnvelop getUserInfoByOpenid(
            @ApiParam(name = "openId", value = "用户openId")
            @RequestParam(value = "openId", required = true) String openId) throws Exception {
        String responseMsg = entranceService.getUserInfoByOpenid(openId);
        JSONObject object1 = JSONObject.fromObject(responseMsg);
        if (null != object1&&null!=object1.get("status") && "200".equals(object1.get("status").toString())) {
            return success(object1.get("userinfo"));
        } else {
            return ObjEnvelop.getError(null!=object1.get("message")?object1.get("message").toString():"无效openId");
        }
    }

    @GetMapping(value = "/getAccessToken")
    @ApiOperation(value = "获取accessToken")
    public ObjEnvelop getAccessToken(
            @ApiParam(name = "interfaceid", value = "校验码,默认:100033")
            @RequestParam(value = "interfaceid", required = true,defaultValue = "100033") String interfaceid) throws Exception {
        String responseMsg = entranceService.getAccessToken(interfaceid);
        JSONObject object1 = JSONObject.fromObject(responseMsg);
        if (null != object1&&null!=object1.get("respCode") && "00".equals(object1.get("respCode"))) {
            return success(object1.get("respEntity"));
        } else {
            return ObjEnvelop.getError(object1.get("respMsg").toString());
        }
    }

    @GetMapping(value = "/BS16010")
    @ApiOperation(value = "医生简介同步")
    public ObjEnvelop BS16010(
            @ApiParam(name = "doctorCode", value = "医生编码")
            @RequestParam(value = "doctorCode",defaultValue = "") String doctor) throws Exception {
        JSON obj = entranceService.BS16010(doctor,demoFlag);
        System.out.println("共同步"+obj+"位医生简介！");
        return success(obj);
    }
    @GetMapping(value = "/BS16011")
    @ApiOperation(value = "科室简介同步")
    public ObjEnvelop BS16011(
            @ApiParam(name = "depNumber", value = "科室编码")
            @RequestParam(value = "depNumber",defaultValue = "") String depNumber
    ) throws Exception {
        JSON obj = entranceService.BS16011(depNumber,demoFlag);
        System.out.println("共同步"+obj+"个科室简介！");
        return success(obj);
    }

    @GetMapping(value = "/BS20030")
    @ApiOperation(value = "检验模板接口")
    public ObjEnvelop BS20030(@ApiParam(name = "bz_code", value = "入参条件为第一节点代码")
                              @RequestParam(value = "bz_code",defaultValue = "") String bz_code,
                              @ApiParam(name = "tc_no", value = "二级节点代码")
                              @RequestParam(value = "tc_no",defaultValue = "") String tc_no,
                              @ApiParam(name = "flag", value = "1一级，2二级，3三级")
                              @RequestParam(value = "flag",defaultValue = "1") String flag) throws Exception {
        JSON obj = entranceService.BS20030(bz_code,tc_no,flag,demoFlag);
        return success(obj);
    }

    @GetMapping(value = "/BS25033")
    @ApiOperation(value = "BS25033检查模板接口")
    public ObjEnvelop BS25033(
            @ApiParam(name = "bz_code", value = "入参条件为第一节点代码")
            @RequestParam(value = "bz_code",defaultValue = "") String bz_code,
            @ApiParam(name = "tc_no", value = "二级节点代码")
            @RequestParam(value = "tc_no",defaultValue = "") String tc_no,
            @ApiParam(name = "flag", value = "1一级，2二级，3三级")
            @RequestParam(value = "flag",defaultValue = "1") String flag) throws Exception {
        JSON obj = entranceService.BS25033(bz_code,tc_no,flag,demoFlag);
        return success(obj);
    }

    @GetMapping(value = "/MS02015")
    @ApiOperation(value = "MS02015套餐子项目字典接口")
    public ObjEnvelop MS02015(
            @ApiParam(name = "parent_code", value = "入参条件为子项目编码")
            @RequestParam(value = "parent_code",defaultValue = "") String parent_code) throws Exception {
        JSON obj = entranceService.MS02015(parent_code,demoFlag);
        return success(obj);
    }

    @GetMapping(value = "/MS02016")
    @ApiOperation(value = "MS02016主项目绑定子项目字典接口")
    public ObjEnvelop MS02016(
            @ApiParam(name = "zd_charge_code", value = "入参条件为项目代码")
            @RequestParam(value = "zd_charge_code",defaultValue = "") String zd_charge_code) throws Exception {
        JSON obj = entranceService.MS02016(zd_charge_code,demoFlag);
        return success(obj);
    }

    @GetMapping(value = "/MS02017")
    @ApiOperation(value = "MS02017套餐选择接口")
    public ObjEnvelop MS02017(
            @ApiParam(name = "bz_code", value = "一级节点代码")
            @RequestParam(value = "bz_code",defaultValue = "") String charge_code,
            @ApiParam(name = "tc_no", value = "二级节点代码")
            @RequestParam(value = "tc_no",defaultValue = "") String tc_no,
            @ApiParam(name = "flag", value = "1一级，2二级，3三级")
            @RequestParam(value = "flag",defaultValue = "1") String flag) throws Exception {
        JSON obj = entranceService.MS02017(charge_code,tc_no,flag,demoFlag);
        return success(obj);
    }

    //==================预约挂号================


    @GetMapping(value = "/BS10045")
    @ApiOperation(value = "预约排班号源")
    public ObjEnvelop BS10045(String dept,
                              String doctor_code,
                              String doctor_name,
                              String special_code,
                              String charge_type,
                              String startDate,
                              String endDate) throws Exception {
        JSON obj = registerService.BS10045( dept, doctor_code, doctor_name, special_code, charge_type, startDate, endDate,demoFlag);
        return success(obj);
    }
    @GetMapping(value = "/BS10046")
    @ApiOperation(value = "预约时间号源表")
    public ObjEnvelop BS10046(
            @ApiParam(name = "dept", value = "部门")
            @RequestParam(value = "dept",defaultValue = "") String dept,
            @ApiParam(name = "doctor_code", value = "医生")
            @RequestParam(value = "doctor_code",defaultValue = "") String doctor_code,
            @ApiParam(name = "date", value = "日期")
            @RequestParam(value = "date",defaultValue = "") String date,
            @ApiParam(name = "ampm", value = "上午下午")
            @RequestParam(value = "ampm",defaultValue = "")String ampm) throws Exception {
        JSON obj = registerService.BS10046(dept,doctor_code,date,ampm,demoFlag);
        return success(obj);
    }
    @GetMapping(value = "/BS10047")
    @ApiOperation(value = "预约时间号源表")
    public ObjEnvelop BS10047(String req_id,
                              String doctor_code,
                              String doctor_name,
                              String op_id,
                              String startDate,
                              String endDate,
                              String reg_type) throws Exception {
        JSON obj = registerService.BS10047( req_id, doctor_code, doctor_name, op_id, startDate, endDate, reg_type,demoFlag);
        return success(obj);
    }
    @GetMapping(value = "/BS10048")
    @ApiOperation(value = "居民预约")
    public ObjEnvelop BS10048(
            @ApiParam(name = "json", value = "入参实体")
            @RequestParam(value = "json",defaultValue = "") String json) throws Exception {
        RegisterAmVO registerAmVO = objectMapper.readValue(json,RegisterAmVO.class);
        JSON obj = registerService.BS10048(registerAmVO,demoFlag);
        return success(obj);
    }
    @GetMapping(value = "/BS10049")
    @ApiOperation(value = "居民取消预约")
    public ObjEnvelop BS10049(
            @ApiParam(name = "json", value = "入参实体")
            @RequestParam(value = "json",defaultValue = "") String json) throws Exception {
        RegisterAmVO registerAmVO = objectMapper.readValue(json,RegisterAmVO.class);
        JSON obj = registerService.BS10049(registerAmVO,demoFlag);
        return success(obj);
    }

    @GetMapping(value = "/sysDoctorInfo")
    @ApiOperation(value = "单个同步医生")
    public ObjEnvelop sysDoctorInfo(
            @ApiParam(name = "idcard", value = "医生同步")
            @RequestParam(value = "idcard",defaultValue = "") String idcard) throws Exception {
        return success(entranceService.sysDoctorInfo(idcard,demoFlag));
    }
    //==================预约挂号end================


    @GetMapping(value = "/zsMsgFlow")
    @ApiOperation(value = "消息平台发送消息")
    public Envelop zsMsgFlow(@ApiParam(name = "jsonString", value = "入参")
                               @RequestParam(value = "jsonString", required = false) String jsonString,
                                 @ApiParam(name = "msgUrl", value = "消息接口地址")
                                 @RequestParam(value = "msgUrl", required = false) String msgUrl) throws Exception {
        return success(entranceService.zsMsgFlowEntrance(jsonString,msgUrl));
    }
}
