package com.yihu.jw.entrance.controller;


import com.alibaba.fastjson.JSONObject;
import com.yihu.jw.entity.hospital.prescription.*;
import com.yihu.jw.hospital.prescription.service.entrance.TnyyEntranceService;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.ListEnvelop;
import com.yihu.jw.restmodel.web.ObjEnvelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import com.yihu.jw.utils.hibernate.HibenateUtils;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;
import java.util.Map;

/**
 * Created by Trick on 2020/1/19.
 */
@RestController
@RequestMapping(value ="/tnyy")
@Api(value = "泰安中医院视图解析", description = "泰安中医院视图解析", tags = {"泰安中医院视图解析"})
public class TnyyController extends EnvelopRestEndpoint {

    @Autowired
    private TnyyEntranceService tnyyEntranceService;
    @Autowired
    private HibenateUtils hibenateUtils;

    @GetMapping(value = "/queryBySql")
    @ApiOperation(value = "视图统一查询")
    public ListEnvelop queryBySql(@ApiParam(name = "sql", value = "sql语句", required = true)
                                      @RequestParam(value = "sql",required = true)String sql){
        return success(tnyyEntranceService.queryBySql(sql));
    }

    @GetMapping(value = "/update")
    @ApiOperation(value = "更新实体类")
    public ObjEnvelop udapte(@ApiParam(name = "json", value = "json", required = true)
                             @RequestParam(value = "json",required = true)String json,
                             @ApiParam(name = "table", value = "table", required = true)
                             @RequestParam(value = "table",required = true)String table){
        ObjEnvelop envelop = new ObjEnvelop();
        JSONObject object = JSONObject.parseObject(json);
        if (table.equalsIgnoreCase("HLW_CF01")){
            HlwTnCf01DO hlwCf01VO =  JSONObject.toJavaObject(object,HlwTnCf01DO.class);
            tnyyEntranceService.update(hlwCf01VO);
            envelop.setObj(hlwCf01VO);
        } else if (table.equalsIgnoreCase("HLW_CF02")) {
            HlwTnCf02DO hlwCf02VO =  JSONObject.toJavaObject(object,HlwTnCf02DO.class);
            tnyyEntranceService.update(hlwCf02VO);
            envelop.setObj(hlwCf02VO);
        }
        return success(envelop);
    }

    @GetMapping(value = "/updateBySql")
    @ApiOperation(value = "更新支付")
    public ObjEnvelop updateBySql(@ApiParam(name = "sql", value = "sql语句", required = true)
                                  @RequestParam(value = "sql",required = true)String sql){
        ObjEnvelop envelop = new ObjEnvelop();
        tnyyEntranceService.updateBySql(sql);
        return success(envelop);
    }

    @GetMapping(value = "/save")
    @ApiOperation(value = "保存01表")
    public Envelop save(@ApiParam(name = "json", value = "json", required = true)
                                 @RequestParam(value = "json",required = true)String json,
                             @ApiParam(name = "table", value = "table", required = true)
                                 @RequestParam(value = "table",required = true)String table){

        ObjEnvelop envelop = new ObjEnvelop();
        JSONObject object = JSONObject.parseObject(json);
        if (table.equalsIgnoreCase("HLW_CF01")){
            HlwTnCf01DO hlwTnCf01DO =  JSONObject.toJavaObject(object,HlwTnCf01DO.class);
            String cfsbSql =" select DQZ + 1 as \"total\"  from GY_IDENTITY_MS where BMC = 'MS_CF01_YD'";
            String cfhmSql="select DQZ + 1 as \"total\"  from GY_IDENTITY_MS where BMC = 'MS_CF01_YD_CFHM'";
            List<Map<String,Object>> cfsbList = hibenateUtils.createSQLQuery(cfsbSql);
            List<Map<String,Object>> cfhmList = hibenateUtils.createSQLQuery(cfhmSql);
            Long cfsb = 0L;
            Long cfhm = 0L;
            if (cfsbList!=null&&cfsbList.size()!=0){
                cfsb = Long.parseLong(cfsbList.get(0).get("total").toString());
                System.out.println("cfsb:"+cfsb);
                String updateCfsb = "update GY_IDENTITY_MS set DQZ=DQZ+1 where BMC = 'MS_CF01_YD'";
                hibenateUtils.updateBySql(updateCfsb);

            }
            if (cfhmList!=null&&cfhmList.size()!=0){
                cfhm = Long.parseLong(cfhmList.get(0).get("total").toString());
                System.out.println("cfhm:"+cfhm);
                String updateCfhm = "update GY_IDENTITY_MS set DQZ=DQZ+1 where BMC = 'MS_CF01_YD_CFHM'";
                hibenateUtils.updateBySql(updateCfhm);
            }
            hlwTnCf01DO.setCFSB(cfsb.intValue());
            hlwTnCf01DO.setCFHM(cfhm+"");
            JSONObject object1 = new JSONObject();
            object1.put("cfsb",cfsb);
            object1.put("cfhm",cfhm);
            tnyyEntranceService.save(hlwTnCf01DO);
            envelop.setObj(object1);
        }else if (table.equalsIgnoreCase("HLW_CF02")){
            HlwTnCf02DO hlwCf02DO =  JSONObject.toJavaObject(object,HlwTnCf02DO.class);
            String sbxhSql =" select DQZ + 1 as \"total\"  from GY_IDENTITY_MS where BMC = 'MS_CF02_YD'";
            List<Map<String,Object>> sbxhList = hibenateUtils.createSQLQuery(sbxhSql);
            Long sbxh = 0L;
            if (sbxhList!=null&&sbxhList.size()!=0){
                sbxh = Long.parseLong(sbxhList.get(0).get("total").toString());
                String updateSbxh = "update GY_IDENTITY_MS set DQZ=DQZ+1 where BMC = 'MS_CF02_YD'";
                hibenateUtils.updateBySql(updateSbxh);
            }
            JSONObject object1 = new JSONObject();
            object1.put("sbxh",sbxh);
            envelop.setObj(object1);
            hlwCf02DO.setSBXH(sbxh.intValue());
            tnyyEntranceService.save(hlwCf02DO);

        }
        return envelop;
    }


    
}
