package com.yihu.jw.entrance.controller;

import com.alibaba.fastjson.JSONObject;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.yihu.jw.doctor.dao.BaseDoctorDao;
import com.yihu.jw.entity.base.doctor.BaseDoctorDO;
import com.yihu.jw.entity.hospital.prescription.*;
import com.yihu.jw.hospital.prescription.service.PrescriptionService;
import com.yihu.jw.hospital.prescription.service.entrance.YkyyEntranceService;
import com.yihu.jw.im.service.ImService;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.ListEnvelop;
import com.yihu.jw.restmodel.web.ObjEnvelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import com.yihu.jw.utils.EntityUtils;
import com.yihu.jw.utils.StringUtil;
import com.yihu.jw.utils.hibernate.HibenateUtils;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.io.IOException;
import java.math.BigDecimal;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * Created by Trick on 2020/1/19.
 */
@RestController
@RequestMapping(value ="/ykyy")
@Api(value = "眼科医院视图解析", description = "眼科医院视图解析", tags = {"眼科医院视图解析"})
public class YkyyController extends EnvelopRestEndpoint {

    @Autowired
    private YkyyEntranceService ykyyEntranceService;
    @Autowired
    private ObjectMapper objectMapper;
    
    @Autowired
    private PrescriptionService prescriptionService;
    @Autowired
    private ImService imService;
    
    @Autowired
    private BaseDoctorDao baseDoctorDao;
    @Autowired
    private HibenateUtils hibenateUtils;
    @Value("${wechat.id}")
    private String wxId;

    @GetMapping(value = "/createSQLQuery")
    @ApiOperation(value = "视图统一查询")
    public ListEnvelop createSQLQuery(@ApiParam(name = "sql", value = "sql语句", required = true)
                                      @RequestParam(value = "sql",required = true)String sql,
                                      @ApiParam(name = "params", value = "入参", required = false)
                                      @RequestParam(value = "params",required = false)Map<String, Object> params,
                                      @ApiParam(name = "page", value = "第几页", required = false)
                                      @RequestParam(value = "page",required = false)Integer page,
                                      @ApiParam(name = "size", value = "分页大小", required = false)
                                      @RequestParam(value = "size",required = false)Integer size){
        return success(ykyyEntranceService.createSQLQuery(sql,params,page,size));
    }

    @GetMapping(value = "/jdbcSQLQuery")
    @ApiOperation(value = "视图统一查询")
    public ListEnvelop jdbcSQLQuery(@ApiParam(name = "sql", value = "sql语句", required = true)
                                      @RequestParam(value = "sql",required = true)String sql){
        return success(ykyyEntranceService.jdbcSQLQuery(sql));
    }


    @GetMapping(value = "/update")
    @ApiOperation(value = "更新支付")
    public ObjEnvelop udapte(@ApiParam(name = "json", value = "json", required = true)
                                 @RequestParam(value = "json",required = true)String json,
                             @ApiParam(name = "table", value = "table", required = true)
                                 @RequestParam(value = "table",required = true)String table){
        ObjEnvelop envelop = new ObjEnvelop();
        JSONObject object = JSONObject.parseObject(json);
        if (table.equalsIgnoreCase("HLW_CF01")){
            HlwCf01DO hlwCf01VO =  JSONObject.toJavaObject(object,HlwCf01DO.class);
            ykyyEntranceService.update(hlwCf01VO);
            envelop.setObj(hlwCf01VO);
        } else if (table.equalsIgnoreCase("HLW_CF02")) {
            HlwCf02DO hlwCf02VO =  JSONObject.toJavaObject(object,HlwCf02DO.class);
            ykyyEntranceService.update(hlwCf02VO);
            envelop.setObj(hlwCf02VO);
        }else if(table.equalsIgnoreCase("HlwGhmxDO")){
            HlwGhmxDO hlwGhmxDO =  JSONObject.toJavaObject(object,HlwGhmxDO.class);
            ykyyEntranceService.update(hlwGhmxDO);
            envelop.setObj(hlwGhmxDO);
        }
        return success(envelop);
    }



    @GetMapping(value = "/updateBySql")
    @ApiOperation(value = "更新支付")
    public ObjEnvelop updateBySql(@ApiParam(name = "sql", value = "sql语句", required = true)
                              @RequestParam(value = "sql",required = true)String sql){
        ObjEnvelop envelop = new ObjEnvelop();
        ykyyEntranceService.updateBySql(sql);
        return success(envelop);
    }





    @GetMapping(value = "/save")
    @ApiOperation(value = "保存01和02表")
    public ObjEnvelop save(@ApiParam(name = "json", value = "json", required = true)
                                      @RequestParam(value = "json",required = true)String json,
                           @ApiParam(name = "table", value = "table", required = true)
                        @RequestParam(value = "table",required = true)String table) throws IOException {
        ObjEnvelop envelop = new ObjEnvelop();
        JSONObject object = JSONObject.parseObject(json);
        if (table.equalsIgnoreCase("HLW_CF01")){
            HlwCf01DO hlwCf01VO =  JSONObject.toJavaObject(object,HlwCf01DO.class);
            String cfsbSql =" select dqz + 1 as \"total\"  from portal_his.gy_identity_ms@xec_link where bmc = 'MS_CF01'";
            String cfhmSql="select dqz + 1 as \"total\"  from portal_his.gy_identity_ms@xec_link where bmc = 'MS_CF01_CFHM'";
            List<Map<String,Object>> cfsbList = hibenateUtils.createSQLQuery(cfsbSql);
            List<Map<String,Object>> cfhmList = hibenateUtils.createSQLQuery(cfhmSql);
            Long cfsb = 0L;
            Long cfhm = 0L;
            if (cfsbList!=null&&cfsbList.size()!=0){
                cfsb = Long.parseLong(cfsbList.get(0).get("total").toString());
                System.out.println("cfsb:"+cfsb);
                String updateCfsb = "update portal_his.gy_identity_ms@xec_link set dqz=dqz+1 where bmc = 'MS_CF01'";
                hibenateUtils.updateBySql(updateCfsb);

            }
            if (cfhmList!=null&&cfhmList.size()!=0){
                cfhm = Long.parseLong(cfhmList.get(0).get("total").toString());
                System.out.println("cfhm:"+cfhm);
                String updateCfhm = "update portal_his.gy_identity_ms@xec_link set dqz=dqz+1 where bmc = 'MS_CF01_CFHM'";
                hibenateUtils.updateBySql(updateCfhm);
            }
            hlwCf01VO.setCFSB(cfsb.intValue());
            hlwCf01VO.setCFHM(cfhm+"");
            JSONObject object1 = new JSONObject();
            object1.put("cfsb",cfsb);
            object1.put("cfhm",cfhm);
            ykyyEntranceService.save(hlwCf01VO);

            envelop.setObj(object1);
        }else if (table.equalsIgnoreCase("HLW_CF02")){
            HlwCf02DO hlwCf02VO =  JSONObject.toJavaObject(object,HlwCf02DO.class);
            String sbxhSql =" select dqz + 1 as \"total\"  from portal_his.gy_identity_ms@xec_link where bmc = 'MS_CF02'";
            List<Map<String,Object>> sbxhList = hibenateUtils.createSQLQuery(sbxhSql);
            Long sbxh = 0L;
            if (sbxhList!=null&&sbxhList.size()!=0){
                sbxh = Long.parseLong(sbxhList.get(0).get("total").toString());
                String updateSbxh = "update portal_his.gy_identity_ms@xec_link set dqz=dqz+1 where bmc = 'MS_CF02'";
                hibenateUtils.updateBySql(updateSbxh);
            }
            JSONObject object1 = new JSONObject();
            object1.put("sbxh",sbxh);
            envelop.setObj(object1);
            hlwCf02VO.setSBXH(sbxh.intValue());
            ykyyEntranceService.save(hlwCf02VO);

        }else if(table.equalsIgnoreCase("HlwYsMzJbzdDO")){
            // portal_his.gy_identity_ms@xec_link
            HlwYsMzJbzdDO hlwYsMzJbzdDO =  JSONObject.toJavaObject(object,HlwYsMzJbzdDO.class);
            String sbxhSql =" select dqz + 1 as \"total\"  from portal_his.gy_identity_ys@xec_link where bmc = 'YS_MZ_JBZD'";
            List<Map<String,Object>> sbxhList = hibenateUtils.createSQLQuery(sbxhSql);
            Long jlbh = 0L;
            if (sbxhList!=null&&sbxhList.size()!=0){
                jlbh = Long.parseLong(sbxhList.get(0).get("total").toString());
                String updateJlbh = "update portal_his.gy_identity_ms@xec_link set dqz=dqz+1 where bmc = 'YS_MZ_JBZD'";
                hibenateUtils.updateBySql(updateJlbh);
            }
            JSONObject object1 = new JSONObject();
            object1.put("jlbh",jlbh);
            envelop.setObj(object1);
            hlwYsMzJbzdDO.setJLBH(jlbh.intValue());
            ykyyEntranceService.save(hlwYsMzJbzdDO);
        }else if(table.equalsIgnoreCase("HlwGhmxDO")){
            // portal_his.gy_identity_ms@xec_link
            HlwGhmxDO hlwGhmxDO =  JSONObject.toJavaObject(object,HlwGhmxDO.class);
            String sbxhSql =" select dqz + 1 as \"total\"  from portal_his.gy_identity_ms@xec_link where bmc = 'MS_GHMX'";
            List<Map<String,Object>> sbxhList = hibenateUtils.createSQLQuery(sbxhSql);
            Long sbxh = 0L;
            if (sbxhList!=null&&sbxhList.size()!=0){
                sbxh = Long.parseLong(sbxhList.get(0).get("total").toString());
                String updateSbxh = "update portal_his.gy_identity_ms@xec_link set dqz=dqz+1 where bmc = 'MS_GHMX'";
                hibenateUtils.updateBySql(updateSbxh);
            }
            JSONObject object1 = new JSONObject();
            object1.put("sbxh",sbxh);
            envelop.setObj(object1);
            hlwGhmxDO.setSBXH(sbxh.intValue());
            ykyyEntranceService.save(hlwGhmxDO);

        }else if(table.equalsIgnoreCase("HlwYsMzJzLsDO")){
            // portal_his.gy_identity_ms@xec_link
            HlwYsMzJzLsDO hlwYsMzJzLsDO =  JSONObject.toJavaObject(object,HlwYsMzJzLsDO.class);
            String sbxhSql =" select dqz + 1 as \"total\"  from portal_his.gy_identity_ys@xec_link where bmc = 'YS_MZ_JZLS'";
            List<Map<String,Object>> sbxhList = hibenateUtils.createSQLQuery(sbxhSql);
            Long jzxh = 0L;
            if (sbxhList!=null&&sbxhList.size()!=0){
                jzxh = Long.parseLong(sbxhList.get(0).get("total").toString());
                String updateJzxh = "update portal_his.gy_identity_ms@xec_link set dqz=dqz+1 where bmc = 'YS_MZ_JZLS'";
                hibenateUtils.updateBySql(updateJzxh);
            }
            JSONObject object1 = new JSONObject();
            object1.put("jzxh",jzxh);
            envelop.setObj(object1);
            hlwYsMzJzLsDO.setJZXH(jzxh.intValue());
            ykyyEntranceService.save(hlwYsMzJzLsDO);
        }

        return envelop;
    }
    
    @GetMapping(value = "/getUpcomingByDoctor")
    @ApiOperation(value = "获取医生待办详情")
    public Envelop getUpcomingByDoctor(@ApiParam(name = "doctorIdcard", value = "doctorIdcard", required = true)
                                           @RequestParam(value = "doctorIdcard",required = true)String doctorIdcard){
        JSONObject result = new JSONObject();
        List<BaseDoctorDO> doctors = baseDoctorDao.findByIdcard(doctorIdcard);
        BaseDoctorDO doctor = new BaseDoctorDO();
        if(!doctors.isEmpty()){
            doctor = doctors.get(0);
        }else{
            return success("该身份证无法找到医生",-1);
        }
        //专家咨询
        result.put("zxCount",imService.sessionCountByType(doctor.getId(),1,0));
        result.put("fzCount",prescriptionService.getWaitVideoCount(doctor.getId(),"1","1",wxId));//图文复诊数量
        return success("请求成功",result);
    }
    @GetMapping(value = "/outPatientOrder")
    @ApiOperation(value = "医生开单")
    public ListEnvelop outPatientOrder(@ApiParam(name = "json", value = "json", required = true)
                                       @RequestParam(value = "json",required = true)String json,
                                              @ApiParam(name = "table", value = "table", required = true)
                                           @RequestParam(value = "table",required = true)String table) throws  Exception{
        List<YkEmrJcsqDO> surveys = EntityUtils.jsonToList(json, YkEmrJcsqDO.class);
        System.out.println(surveys);
        BigDecimal totalprice=new BigDecimal(0);
        ListEnvelop mixEnvelop = new ListEnvelop();
        if (surveys!=null){
            for (YkEmrJcsqDO ykEmrJcsqDO:surveys){
                String sqdhSql =" select dqz + 1 as \"total\"  from portal_his.gy_identity_emr@xec_link where bmc = 'EMR_JCSQ'";
                List<Map<String,Object>> sqdhList = hibenateUtils.createSQLQuery(sqdhSql);
                Long sqdh = 0L;
                if (sqdhList!=null&&sqdhList.size()!=0){
                    sqdh = Long.parseLong(sqdhList.get(0).get("total").toString());
                    System.out.println("sqdh:"+sqdh);
                    String updatesqdh = "update portal_his.gy_identity_emr@xec_link set dqz=dqz+1 where bmc = 'EMR_JCSQ'";
                    hibenateUtils.updateBySql(updatesqdh);
                }
                ykEmrJcsqDO.setSqdh(sqdh.intValue());
                ykEmrJcsqDO.setJjbz(0);
                ykEmrJcsqDO.setJzlx(1);
                ykEmrJcsqDO.setJczt(1);
                ykEmrJcsqDO.setZfbz(0);
                ykEmrJcsqDO.setQxbz(0);
                ykEmrJcsqDO.setKdsj(new Date());
                ykEmrJcsqDO.setJsbz(0);
                totalprice =ykEmrJcsqDO.getXmdj().multiply(new BigDecimal(ykEmrJcsqDO.getSqsl()));
                System.out.println("totalprice"+totalprice);
                String yjxhSql =" select dqz + 1 as \"total\"  from portal_his.gy_identity_ms@xec_link where bmc = 'MS_YJ01'";
                List<Map<String,Object>> yjxhList = hibenateUtils.createSQLQuery(yjxhSql);
                Long yjxh = 0L;
                if (yjxhList!=null&&yjxhList.size()!=0){
                    yjxh = Long.parseLong(yjxhList.get(0).get("total").toString());
                    System.out.println("yjxh:"+yjxh);
                    String updateyjxh = "update portal_his.gy_identity_ms@xec_link set dqz=dqz+1 where bmc = 'MS_YJ01'";
                    hibenateUtils.updateBySql(updateyjxh);
                    ykEmrJcsqDO.setYjxh(yjxh.intValue());
                }
                ykyyEntranceService.save(ykEmrJcsqDO);
                //检查主表
                YkMsYj01DO ykMsYj01DO = new YkMsYj01DO();
                ykMsYj01DO.setYjxh(yjxh.intValue());
                ykMsYj01DO.setMZXH(0);
                ykMsYj01DO.setFphm("");
                ykMsYj01DO.setBrid(ykEmrJcsqDO.getBrid());
                ykMsYj01DO.setBrxm(ykEmrJcsqDO.getBrxm());
                ykMsYj01DO.setKdrq(ykEmrJcsqDO.getKdsj());
                ykMsYj01DO.setKsdm(ykEmrJcsqDO.getBrks());
                ykMsYj01DO.setYsdm(ykEmrJcsqDO.getKdys());
                ykMsYj01DO.setZxks(ykEmrJcsqDO.getZxks());
                ykMsYj01DO.setZxpb(0);
                ykMsYj01DO.setZfpb(0);
                ykMsYj01DO.setCfbz(0);
                ykMsYj01DO.setJzxh(ykEmrJcsqDO.getJzxh());
                ykMsYj01DO.setDjzt(0);
                ykMsYj01DO.setSqid(sqdh.intValue());
                ykMsYj01DO.setQxbz(0);
                ykMsYj01DO.setXmmc(ykEmrJcsqDO.getJcxm());
                ykMsYj01DO.setZtbh(ykEmrJcsqDO.getXmid());
                ykMsYj01DO.setYgsf(0);
                ykMsYj01DO.setJcbw(0);
                ykMsYj01DO.setZjflag(1);
                ykMsYj01DO.setLjlx(0);
                ykMsYj01DO.setHlwjf(0);
                ykMsYj01DO.setSjly(1);
                System.out.println(ykMsYj01DO);
                ykyyEntranceService.save(ykMsYj01DO);
                String sqlCxzt = "Select t.zlxmid as \"zlxmid\",t.fyxh as \"fyxh\",t.fysl as \"fysl\" from VEMR_ORDER_ITEM_MX t where t.zlxmid ='"+ykEmrJcsqDO.getXmid()+"'";
                List<Map<String,Object>> sbxlMap = hibenateUtils.createSQLQuery(sqlCxzt);
                if (sbxlMap.size()>0){
                    int i = 0;
                    //明细可能会有多条
                    for (Map<String,Object> map:sbxlMap){
                        String sbxhSql =" select dqz + 1 as \"total\"  from portal_his.gy_identity_ms@xec_link where bmc = 'MS_YJ02'";
                        List<Map<String,Object>> sbxhList = hibenateUtils.createSQLQuery(sbxhSql);
                        Long sbxh = 0L;
                        if (sbxhList!=null&&sbxhList.size()!=0){
                            sbxh = Long.parseLong(sbxhList.get(0).get("total").toString());
                            System.out.println("sbxh:"+sbxh);
                            String updateyjxh = "update portal_his.gy_identity_ms@xec_link set dqz=dqz+1 where bmc = 'MS_YJ02'";
                            hibenateUtils.updateBySql(updateyjxh);
                        }
                        YkMsYj02DO ykMsYj02DO = new YkMsYj02DO();
                        ykMsYj02DO.setSbxh(sbxh.intValue());
                        ykMsYj02DO.setYjxh(ykMsYj01DO.getYjxh());
                        /*ykMsYj02DO.setYlxh(ykEmrJcsqDO.getXmid());*/
                        ykMsYj02DO.setYlxh(map.get("fyxh")!=null?Integer.parseInt(map.get("fyxh").toString()):0);
                        Integer sqsl = ykEmrJcsqDO.getSqsl();
                        ykMsYj02DO.setYlsl(Integer.valueOf(map.get("fysl").toString())*sqsl);
                        ykMsYj02DO.setYjzx(i==0?1:0);
                        i++;
                        String fyxhSql ="select t.xmlx as \"xmlx\",t.fydj as \"fydj\",t.fygb as \"fygb\"" +
                                " from portal_his.GY_YLSF@xec_link t " +
                                " where t.fyxh = '"+map.get("fyxh").toString()+"'";
                        List<Map<String,Object>> fyxhList = hibenateUtils.createSQLQuery(fyxhSql);

                        if (fyxhList.size()>0){
                            Integer xmlx = 0;
                            if (fyxhList.get(0).get("xmlx")!=null){
                                xmlx = Integer.valueOf(fyxhList.get(0).get("xmlx").toString());
                            }
                            ykMsYj02DO.setXmlx(xmlx);
                            ykMsYj02DO.setFygb(Integer.valueOf(fyxhList.get(0).get("fygb").toString()));
                            ykMsYj02DO.setYldj(new BigDecimal(fyxhList.get(0).get("fydj").toString()));
                            ykMsYj02DO.setHjje(totalprice);
                        }
                        ykMsYj02DO.setZfbl(1);
                        ykMsYj02DO.setZxpb(0);
                        ykMsYj02DO.setZjflag(0);
                        ykMsYj02DO.setHjje(totalprice);
                        System.out.println(ykMsYj02DO);
                        ykyyEntranceService.save(ykMsYj02DO);
                    }
                }

            }
            mixEnvelop.setDetailModelList(surveys);
        }
        return mixEnvelop;
    }



    @GetMapping(value = "/saveJdxx")
    @ApiOperation(value = "患者建档")
    public Envelop saveJdxx(@ApiParam(name = "brxm", value = "病人姓名", required = true)
                                      @RequestParam(value = "brxm",required = true)String brxm,
                                      @ApiParam(name = "csny", value = "出生日期", required = false)
                                      @RequestParam(value = "csny",required = false)String csny,
                                      @ApiParam(name = "brxb", value = "病人性别", required = false)
                                      @RequestParam(value = "brxb",required = false)Float brxb,
                                      @ApiParam(name = "czgh", value = "操作工号", required = false)
                                      @RequestParam(value = "czgh",required = false)String czgh,
                                @ApiParam(name = "sfzh", value = "身份证号", required = false)
                                    @RequestParam(value = "sfzh",required = false)String sfzh,
                                @ApiParam(name = "sjhm", value = "手机号码", required = false)
                                    @RequestParam(value = "sjhm",required = false)String sjhm,
                                @ApiParam(name = "ybkh", value = "医保卡号", required = false)
                                    @RequestParam(value = "ybkh",required = false)String ybkh,
                                @ApiParam(name = "lxdz", value = "联系地址", required = false)
                                    @RequestParam(value = "lxdz",required = false)String lxdz,
                                @ApiParam(name = "zy", value = "职业", required = false)
                                    @RequestParam(value = "zy",required = false)Float zy){
        return success(ykyyEntranceService.saveJdxx(brxm,csny,brxb, czgh,sfzh,sjhm,ybkh,lxdz,zy));
    }


    @GetMapping(value = "/updateJdxx")
    @ApiOperation(value = "更新患者档案")
    public Envelop updateJdxx(@ApiParam(name = "brid", value = "病人id", required = true)
                            @RequestParam(value = "brid",required = true)Float brid,
                            @ApiParam(name = "sfzh", value = "身份证号", required = false)
                            @RequestParam(value = "sfzh",required = false)String sfzh,
                            @ApiParam(name = "lxdh", value = "联系电话", required = false)
                            @RequestParam(value = "lxdh",required = false)String lxdh,
                            @ApiParam(name = "lxdz", value = "联系地址", required = false)
                            @RequestParam(value = "lxdz",required = false)String lxdz,
                            @ApiParam(name = "zy", value = "职业", required = false)
                            @RequestParam(value = "zy",required = false)Float zy){
        return success(ykyyEntranceService.updateJdxx(brid,sfzh,lxdz,zy,lxdh));
    }


    @GetMapping(value = "/updateJzkh")
    @ApiOperation(value = "更新患者就诊卡号")
    public Envelop updateJzkh(@ApiParam(name = "brid", value = "病人id", required = true)
                              @RequestParam(value = "brid",required = true)Float brid,
                              @ApiParam(name = "jzkh", value = "就诊卡号", required = false)
                              @RequestParam(value = "jzkh",required = false)String jzkh){
        return success(ykyyEntranceService.updateJzkh(brid,jzkh));
    }
    @GetMapping(value = "/updateSfzh")
    @ApiOperation(value = "更新患者身份证号")
    public Envelop updateSfzh(@ApiParam(name = "brid", value = "病人id", required = true)
                              @RequestParam(value = "brid",required = true)Float brid,
                              @ApiParam(name = "sfzh", value = "身份证号", required = false)
                              @RequestParam(value = "sfzh",required = false)String sfzh){
        return success(ykyyEntranceService.updateSfzh(brid,sfzh));
    }
}
