package com.yihu.jw.entrance.service;

import com.alibaba.fastjson.JSONObject;
import com.yihu.jw.entity.hospital.message.SystemMessageDO;
import com.yihu.jw.hospital.message.service.SystemMessageService;
import com.yihu.jw.im.service.ImService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;


/**
 * 互联网医院系统消息业务层
 * @author huangwenjie
 * @date 2019/11/22 13:53
 */
@Service
public class HospitalSystemMessageService  {

    private static Logger logger = LoggerFactory.getLogger(HospitalSystemMessageService.class);


    @Autowired
    private SystemMessageService systemMessageService;

    @Autowired
    private ImService imService;

    /**
     * 保存系统消息
     * @param systemMessageDO
     * @throws Exception
     */
    public void saveMessage(SystemMessageDO systemMessageDO) throws Exception{
        //发送系统消息
        systemMessageService.saveMessage(systemMessageDO);
        //发型IM外层消息

        JSONObject object = new JSONObject();
        object.put("socket_sms_type",11);//系统消息刷新事件
        object.put("relation_code",systemMessageDO.getType());
        imService.sendWaiSocketMessage(systemMessageDO.getSender(),systemMessageDO.getReceiver(),object.toString(),"1");
    }

    /**
     * 发送IM消息推送
     * @param systemMessageDO
     * @throws Exception
     */
    public void sendImMessage(SystemMessageDO systemMessageDO) throws Exception{
        try{
            //发型IM外层消息
            JSONObject object = new JSONObject();
            object.put("socket_sms_type",11);//系统消息刷新事件
            object.put("relation_code",systemMessageDO.getType());
            imService.sendWaiSocketMessage(systemMessageDO.getSender(),systemMessageDO.getReceiver(),object.toString(),"1");
        }catch (Exception e){
            logger.error(e.toString());
        }

    }

}
