package com.yihu.jw.job;

import com.yihu.jw.service.channel.PrescriptionDeleteService;
import org.quartz.Job;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.quartz.Trigger;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;

public class PrescriptionAutoDeleteJob implements Job {
    private static final Logger logger = LoggerFactory.getLogger(PrescriptionAutoDeleteJob.class);
    @Autowired
    private PrescriptionDeleteService prescriptionDeleteService;
    @Override
    public void execute(JobExecutionContext jobExecutionContext) throws JobExecutionException {
        logger.info("START========PrescriptionAutoDeleteJob========");
        try {
            Trigger trigger =jobExecutionContext.getTrigger();
            System.out.println("执行时间为"+trigger.getNextFireTime());
            prescriptionDeleteService.deletePrescription();
            logger.info("END========PrescriptionAutoDeleteJob========");
        } catch (Exception e) {
            e.printStackTrace();
            logger.error("END===ERROE===PrescriptionAutoDeleteJob,message:"+e.getMessage());
        }

    }
}
