package com.yihu.jw.job.im;

import com.yihu.jw.service.im.ImJobService;
import org.quartz.DisallowConcurrentExecution;
import org.quartz.Job;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;

/**
 * im在线导诊定时任务
 * Created by yeshijie on 2023/4/28.
 */
@DisallowConcurrentExecution
public class ImOnlineGuidanceJob implements Job {

    private static final Logger logger = LoggerFactory.getLogger(ImOnlineGuidanceJob.class);
    @Autowired
    private ImJobService imJobService;

    @Override
    public void execute(JobExecutionContext context) throws JobExecutionException {
        try {
            logger.info("onlineGuidance job start...");
            imJobService.onlineGuidance("18");
            imJobService.onlineGuidance("26");
            logger.info("onlineGuidance job end.");
        }catch (Exception e){
            e.printStackTrace();
        }

    }
}
