package com.yihu.jw.job.yk;

import com.yihu.jw.internet.service.YkyyCommonService;
import com.yihu.jw.job.DataUploadJob;
import com.yihu.jw.util.date.DateUtil;
import org.quartz.Job;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;

/**
 * Created by wsy on 2021/9/13.
 */
public class YKYYDataUploadJob implements Job {

    private static final Logger logger = LoggerFactory.getLogger(DataUploadJob.class);
    @Autowired
    private YkyyCommonService ykykcommonService;
    @Override
    public void execute(JobExecutionContext jobExecutionContext) throws JobExecutionException {
        logger.info("START========DataUploadJob========");
        try {
            //1、获取 JOB 执行区间  执行时间点的前一天  时间点定在每天的 02：00：00 执行,同步前一天的数据
            /*String endDate = DateUtil.dateToStr(DateUtil.getNow(),"yyyy-MM-dd")+" 00:00:00";
            String startDate = DateUtil.dateToStr(DateUtil.getPreDays(DateUtil.getNow(),-1),"yyyy-MM-dd")+" 00:00:00";*/
            String endDate = DateUtil.dateToStr(DateUtil.getNow(),"yyyy-MM-dd");
            String startDate = DateUtil.dateToStr(DateUtil.getPreDays(DateUtil.getNow(),-1),"yyyy-MM-dd");

            String res = "";

            //2、分步执行需要JOB执行的服务
            logger.info("START========2.5 网上预约挂号上传开始========");
            try {
                res = ykykcommonService.upAppointmentOnline(startDate,endDate,null);
            }catch (Exception e){
                e.printStackTrace();
                logger.error(e.toString());
            }
            logger.info("END==========2.5 网上预约挂号上传结束========" + res);



           logger.info("START========2.6 网上医技预约上传开始========");
           try {
               res = ykykcommonService.upMedicalOnline(startDate,endDate,null);
           }catch (Exception e){
               e.printStackTrace();
               logger.error(e.toString());
           }
           logger.info("END==========2.6 网上医技预约上传结束========" + res);



            logger.info("START========2.7 医生评价信息开始========");
            try {
                res = ykykcommonService.upNsDoctorScore(startDate,endDate,null);
            }catch (Exception e){
                e.printStackTrace();
                logger.error(e.toString());
            }
            logger.info("END==========2.7 医生评价信息结束========" + res);



            logger.info("START========2.8 网络咨询服务信息开始========");
            try {
                res = ykykcommonService.upNsOnlineAsk(startDate,endDate,null);
            }catch (Exception e){
                e.printStackTrace();
                logger.error(e.toString());
            }
            logger.info("END==========2.8 网络咨询服务信息结束========" + res);



            logger.info("START========2.9 网络诊疗服务信息========");
            try {
                res = ykykcommonService.upNsOnlineMed(startDate,endDate,null);
            }catch (Exception e){
                e.printStackTrace();
                logger.error(e.toString());
            }
            logger.info("END==========2.9 网络诊疗服务信息========" + res);



            logger.info("START========2.10 电子处方表开始========");
            try {
                res = ykykcommonService.upPrescription(startDate,endDate,null);
            }catch (Exception e){
                e.printStackTrace();
                logger.error(e.toString());
            }
            logger.info("END==========2.10 电子处方表结束========" + res);



            logger.info("START========2.11 电子处方_药品明细表开始 ========");
            try {
                res = ykykcommonService.upPrescriptionDrug(startDate,endDate,null);
            }catch (Exception e){
                e.printStackTrace();
                logger.error(e.toString());
            }
            logger.info("END==========2.11 电子处方_药品明细表结束 ========" + res);




            logger.info("END========DataUploadJob 执行结束========");

        } catch (Exception e) {
            e.printStackTrace();
            logger.error("END===ERROE===DataUploadJob,message:"+e.getMessage());
        }
    }

}
