package com.yihu.jw.job.ykyy;


import com.yihu.jw.service.channel.UnSettledHISPrescriptionService;
import org.quartz.DisallowConcurrentExecution;
import org.quartz.Job;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;

/**
 * 定时查询HIS的01表中的审方状态，如果已审方，且未结算，则推送一条模板消息给居民，让居民进行支付结算。
 * Created by yeshijie on 2020/4/26.
 *
 * @author yeshijie.
 */
@DisallowConcurrentExecution
public class UnSettledHISPrescriptionJob implements Job{

    private static final Logger logger = LoggerFactory.getLogger(UnSettledHISPrescriptionJob.class);

    @Autowired
    private UnSettledHISPrescriptionService unSettledHISPrescription;

    @Override
    public void execute(JobExecutionContext jobExecutionContext) throws JobExecutionException {
        logger.info("START========UnSettledHISPrescriptionJob========");
        try {
            unSettledHISPrescription.unSettledHISPrescription();

            logger.info("END========UnSettledHISPrescriptionJob 执行结束========");
        }catch (Exception e){
            e.printStackTrace();
            logger.error("END===ERROE===UnSettledHISPrescriptionJob,message:"+e.getMessage());
        }
    }
}
