package com.yihu.jw.job.ykyy;

import com.yihu.jw.service.channel.UnSettledHISPrescriptionService;
import org.quartz.DisallowConcurrentExecution;
import org.quartz.Job;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;

/**
 * 1、发起咨询、复诊时需增加支付时限，时限需支持按分钟设置，目前设置为15分钟。

 2、如果长时间未支付，需要提醒患者。需要支持配置提前n分钟进行提醒推送。
 * Created by yeshijie on 2020/4/26.
 *
 * @author wangzhinan.
 */
@DisallowConcurrentExecution
public class UpdateStatusByPayTimeJob implements Job{

    private static final Logger logger = LoggerFactory.getLogger(UpdateStatusByPayTimeJob.class);

    @Autowired
    private UnSettledHISPrescriptionService unSettledHISPrescriptionService;

    @Override
    public void execute(JobExecutionContext jobExecutionContext) throws JobExecutionException {
        logger.info("START========UpdateStatusByPayTimeJob========");
        try {
            unSettledHISPrescriptionService.updateStatusByPayTime();

            logger.info("END========UpdateStatusByPayTimeJob 执行结束========");
        }catch (Exception e){
            e.printStackTrace();
            logger.error("END===ERROE===UpdateStatusByPayTimeJob,message:"+e.getMessage());
        }
    }
}
