package com.yihu.jw.service.channel;

import com.yihu.jw.entity.base.patient.BasePatientDO;
import com.yihu.jw.entity.hospital.consult.WlyyHospitalSysDictDO;
import com.yihu.jw.entity.hospital.consult.WlyyHospitalWaitingRoomDO;
import com.yihu.jw.entity.hospital.doctor.WlyyPatientRegisterTimeDO;
import com.yihu.jw.entity.hospital.mapping.PatientMappingDO;
import com.yihu.jw.entity.hospital.message.SystemMessageDO;
import com.yihu.jw.entity.hospital.prescription.BaseNatAppointmentDO;
import com.yihu.jw.entity.hospital.prescription.WlyyOutpatientDO;
import com.yihu.jw.entity.order.BusinessOrderDO;
import com.yihu.jw.hospital.consult.dao.HospitalWaitingRoomDao;
import com.yihu.jw.hospital.dict.WlyyHospitalSysDictDao;
import com.yihu.jw.hospital.doctor.dao.PatientRegisterTimeDao;
import com.yihu.jw.hospital.mapping.dao.PatientMappingDao;
import com.yihu.jw.hospital.message.service.SystemMessageService;
import com.yihu.jw.hospital.prescription.dao.*;
import com.yihu.jw.hospital.prescription.service.PrescriptionLogService;
import com.yihu.jw.hospital.prescription.service.PrescriptionService;
import com.yihu.jw.hospital.prescription.service.entrance.EntranceService;
import com.yihu.jw.hospital.prescription.service.entrance.YkyyEntranceService;
import com.yihu.jw.hospital.ykyy.service.YkyyService;
import com.yihu.jw.im.dao.ConsultDao;
import com.yihu.jw.im.dao.ConsultTeamDao;
import com.yihu.jw.im.service.ImService;
import com.yihu.jw.order.BusinessOrderService;
import com.yihu.jw.order.dao.BusinessOrderDao;
import com.yihu.jw.patient.dao.BasePatientDao;
import com.yihu.jw.util.common.IdCardUtil;
import com.yihu.jw.util.date.DateUtil;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import java.util.Date;
import java.util.List;

@Component
@Transactional
public class TimeoutOverDueService {
    private static Logger logger = LoggerFactory.getLogger(TimeoutOverDueService.class);
    @Autowired
    private JdbcTemplate jdbcTemplate;
    @Value("${wechat.ids}")
    private String wechatId;
    @Value("${hlwyyEntrance.url}")
    private String hlwyyEntranceUrl;
    @Autowired
    private PrescriptionDao prescriptionDao;
    @Autowired
    private PrescriptionDiagnosisDao prescriptionDiagnosisDao;
    @Autowired
    private PrescriptionInfoDao prescriptionInfoDao;
    @Autowired
    private OutpatientDao outpatientDao;
    @Autowired
    private ImService imService;
    @Autowired
    private BusinessOrderDao businessOrderDao;
    @Autowired
    private BusinessOrderService businessOrderService;
    @Autowired
    private PrescriptionLogService prescriptionLogService;
    @Autowired
    private HospitalWaitingRoomDao hospitalWaitingRoomDao;
    @Autowired
    private PatientRegisterTimeDao patientRegisterTimeDao;
    @Autowired
    private YkyyService ykyyService;
    @Autowired
    private BasePatientDao basePatientDao;
    @Autowired
    private PrescriptionService prescriptionService;
    @Autowired
    private SystemMessageService systemMessageService;
    @Autowired
    private ConsultTeamDao consultTeamDao;
    @Autowired
    private ConsultDao consultDao;
    @Autowired
    private BaseNatAppointmentDao baseNatAppointmentDao;
    @Autowired
    private WlyyHospitalSysDictDao wlyyHospitalSysDictDao;
    @Autowired
    private EntranceService entranceService;
    @Autowired
    private PatientMappingDao patientMappingDao;
    @Autowired
    private YkyyEntranceService ykyyEntranceService;
    @Autowired
    private WlyyHospitalSysDictDao hospitalSysDictDao;
    /**
     *  取消未结束门诊
     */
    public void cancelOutPatientOver(){
            logger.info("进入结束超时未接诊的门诊");
            List<WlyyOutpatientDO> timeout = outpatientDao.findAllWaitingOutpatient();
            if (null!=timeout&&timeout.size()>0){
                logger.info("开始结束超时未接诊的门诊");
                String cancelValue = "超时订单系统自动取消";
                String cancelRemark = "当天未接诊的门诊订单自动取消";
                for(WlyyOutpatientDO wlyyOutpatientDO:timeout){
                    try {
                        long currentTime = new Date().getTime();
                        long outpatientTime = wlyyOutpatientDO.getRegisterDate().getTime();
                        if (currentTime-outpatientTime>24*60*60*1000){
                            logger.info("时间满足条件");
                            String outPatientId = wlyyOutpatientDO.getId();
                            String consultCode ="";
                            try {
                                    /*//医生未回复可以退费
                                    businessOrderService.consultRefund(consultCode,wechatId);
                                    wlyyOutpatientDO.setDoctorCancelRemark(cancelRemark);
                                    wlyyOutpatientDO.setDoctorCancelType("6");
                                    wlyyOutpatientDO.setDoctorCancelValue(cancelValue);
                                    wlyyOutpatientDO.setEndTime(new Date());
                                    wlyyOutpatientDO.setOperator("system");
                                    outpatientDao.save(wlyyOutpatientDO);
                                    logger.info(wlyyOutpatientDO.getId()+"的门诊记录设置为取消");*/
                                //判断医生是否接诊
                                List<WlyyHospitalWaitingRoomDO> roomDOs = hospitalWaitingRoomDao.findByOutpatientId(outPatientId);
                                if (roomDOs != null && roomDOs.size() > 0) {
                                    for (WlyyHospitalWaitingRoomDO roomDO : roomDOs) {
                                        if (roomDO.getVisitStatus() == 2) {
                                            logger.info("id为："+outPatientId+"的门诊已被医生接诊");
                                        } else {
                                            roomDO.setVisitStatus(-1);
                                            logger.info("修改候诊室状态，将候诊病人移除候诊室");
                                            hospitalWaitingRoomDao.save(roomDO);
                                        }
                                    }
                                }
                                //更改门诊状态
                                wlyyOutpatientDO.setStatus("-1");
                                String description = null;
                                wlyyOutpatientDO.setDoctorCancelRemark(cancelRemark);
                                wlyyOutpatientDO.setDoctorCancelType("6");
                                wlyyOutpatientDO.setDoctorCancelValue(cancelValue);
                                wlyyOutpatientDO.setEndTime(new Date());
                                wlyyOutpatientDO.setOperator("system");
                                description = cancelValue;
                                //系统消息
                                SystemMessageDO messageDO = new SystemMessageDO();
                                messageDO.setTitle("超时订单系统自动取消");
                                messageDO.setType("13");
                                messageDO.setSender(wlyyOutpatientDO.getDoctor());
                                messageDO.setSenderName(wlyyOutpatientDO.getDoctorName());
                                messageDO.setRelationCode(wlyyOutpatientDO.getId());
                                messageDO.setReceiver(wlyyOutpatientDO.getPatient());
                                messageDO.setReceiverName(wlyyOutpatientDO.getPatientName());
                                net.sf.json.JSONObject data = new net.sf.json.JSONObject();
                                data.put("name", wlyyOutpatientDO.getPatientName());
                                data.put("consumerName",wlyyOutpatientDO.getConsumerName());
                                data.put("age", IdCardUtil.getAgeForIdcard(wlyyOutpatientDO.getIdcard()));
                                data.put("gender", IdCardUtil.getSexForIdcard(wlyyOutpatientDO.getIdcard()));
                                data.put("question", wlyyOutpatientDO.getIcd10Name());
                                String msg = "";
                                if ("1".equalsIgnoreCase(wlyyOutpatientDO.getType())) {
                                    data.put("type", "9");
                                    msg += wlyyOutpatientDO.getPatientName() + ",您好！ 您有一个图文复诊已被系统取消，取消原因：" + cancelValue + "。取消说明：" + cancelRemark + "。";
                                    prescriptionService.sendWxTemplateMsg(wechatId, wlyyOutpatientDO.getId(),null, "9", "systemCancelRemind", cancelRemark);
                                }
                                if ("2".equalsIgnoreCase(wlyyOutpatientDO.getType())) {
                                    data.put("type", "16");
                                    msg += wlyyOutpatientDO.getPatientName() + ",您好！ 您有一个视频复诊已被系统取消，取消原因：" + cancelValue + "。取消说明：" + cancelRemark + "。";
                                    prescriptionService.sendWxTemplateMsg(wechatId, wlyyOutpatientDO.getId(),null, "16", "systemCancelRemind", cancelRemark);
                                }
                                data.put("msg", msg);
                                messageDO.setData(data.toString());
                                systemMessageService.saveMessage(messageDO);
                                //推送消息到眼科通
                                BasePatientDO patient = basePatientDao.findById(wlyyOutpatientDO.getPatient()).orElse(null);;
                                if ("xm_ykyy_wx".equalsIgnoreCase(wechatId)) {
                                    logger.info("推送消息到眼科通");
                                    ykyyService.pushNotificationToYktPatient(patient.getYktId(), messageDO.getTitle(), data.get("msg").toString());
                                }
                                //删除门诊号源
                                List<WlyyPatientRegisterTimeDO> list = patientRegisterTimeDao.findByOutpatientId(wlyyOutpatientDO.getId());
                                if (list != null && list.size() > 0) {
                                    patientRegisterTimeDao.deleteAll(list);
                                }
                                BusinessOrderDO businessOrderDO = businessOrderDao.selectByRelationCode(outPatientId);
                                if (wechatId.equalsIgnoreCase("xm_ykyy_wx")) {
                                    if (businessOrderDO.getStatus()==1){
                                        businessOrderService.orderRefund(wechatId, wlyyOutpatientDO.getConsumer(), businessOrderDO.getOrderNo(), businessOrderDO.getPayPrice(), description);
                                        //眼科接诊时更新眼科通状态
                                        if (businessOrderDO!=null){
                                            ykyyService.updateYktOrderStatus(businessOrderDO.getOrderNo(),"2");
                                        }
                                    }
                                } else if (wechatId.equalsIgnoreCase("xm_zsyy_wx")) {
                                    WlyyHospitalSysDictDO hospitalSysDictDO =  hospitalSysDictDao.findById("isCloseRefund").orElse(null);;
                                    if (hospitalSysDictDO!=null&&hospitalSysDictDO.getDictValue().equalsIgnoreCase("1")){
                                        try {
                                            if (businessOrderDO.getStatus()==1){
                                                entranceService.hisRefund(outPatientId);
                                            }
                                        }catch (Exception e){
                                            e.printStackTrace();
                                        }

                                    }
    /*
                        businessOrderService.ylzOrderRefund(wechatId, wlyyOutpatientDO.getPatient(), businessOrderDO.getOrderNo(), businessOrderDO.getPayPrice(), description);
    */
                                }
                                outpatientDao.save(wlyyOutpatientDO);
                                logger.info(wlyyOutpatientDO.getId()+"的门诊记录设置为取消");
                                consultCode = imService.getConsultCodeByOutpatientId(outPatientId);
                                logger.info("consultCode"+consultCode);
                                if(StringUtils.isNoneBlank(consultCode)) {
                                    imService.cancelRevisit(consultCode, "admin", 2);
                                }
                                if ("xm_zsyy_wx".equalsIgnoreCase(wechatId)){
                                    String msgUrl="https://hlwyy.xmzsh.com/ims-wx/index.html#/returnVisit/record?outpatientId="+wlyyOutpatientDO.getId();
                                    prescriptionService.sendZsMsgFlow("OL_WZCS_CANCEL",wlyyOutpatientDO.getId(),"",msgUrl,"24 时未接诊,问诊超时取消");
                                }
                                }catch(Exception e)  {
                                    e.printStackTrace();
                                    logger.info("自动结束咨询报错 consultCode： "+consultCode);
                                }

                            }
                    } catch (Exception e) {
                        e.printStackTrace();
                        logger.info(wlyyOutpatientDO.getId()+"的门诊记录取消失败");
                    }
                }
            }
        }
    public void CancelNotPay(){
        List<BaseNatAppointmentDO> list =  baseNatAppointmentDao.findByPayStatus();
        long defaultTime=30;//分钟
        WlyyHospitalSysDictDO wlyyHospitalSysDictDO = wlyyHospitalSysDictDao.findById("CancelNotPayTime").orElse(null);;
        if (wlyyHospitalSysDictDO!=null&&StringUtils.isNoneBlank(wlyyHospitalSysDictDO.getDictValue())){
            defaultTime= Long.parseLong(wlyyHospitalSysDictDO.getDictValue());
        }
        if (list!=null&&list.size()>0){
            for (BaseNatAppointmentDO baseNatAppointmentDO:list){
                long currentTime = new Date().getTime();
                long outpatientTime = baseNatAppointmentDO.getCreateTime().getTime();
                if (currentTime-outpatientTime>defaultTime*60*1000){
                    baseNatAppointmentDO.setCancelBy("system");
                    baseNatAppointmentDO.setCancelReson("超时系统取消");
                    baseNatAppointmentDO.setCancelTime(new Date());
                    baseNatAppointmentDO.setIsSuccess("-1");
                    baseNatAppointmentDao.save(baseNatAppointmentDO);
                }
                //取消预约
                try {
                    PatientMappingDO patientMappingDO = patientMappingDao.findByPatient(baseNatAppointmentDO.getPatientId());
                    String userNo = null;
                    if (patientMappingDO != null) {
                        userNo = patientMappingDO.getMappingCode();
                    }
                    if ("xm_zsyy_wx".equalsIgnoreCase(wechatId)){
                        entranceService.BS10145("3150000","0001", DateUtil.dateToStrLong(baseNatAppointmentDO.getAppointmentTime()),baseNatAppointmentDO.getMedicare(),baseNatAppointmentDO.getName(),baseNatAppointmentDO.getCardNo(),baseNatAppointmentDO.getMobile(),baseNatAppointmentDO.getAmpm(),false);
                    }
                    if ("xm_ykyy_wx".equalsIgnoreCase(wechatId)){
                        baseNatAppointmentDO.setIsSuccess("-1");
                        baseNatAppointmentDO.setCancelReson("系统超时取消");
                        baseNatAppointmentDO.setCancelTime(new Date());
                        baseNatAppointmentDO.setCancelBy("system");
                        baseNatAppointmentDao.save(baseNatAppointmentDO);
                        if (StringUtils.isNoneBlank(baseNatAppointmentDO.getRealOrder())){
                            String updateJcsq = "update V_EMR_JCSQ set ZFBZ = 1 where yjxh = "+baseNatAppointmentDO.getRealOrder();
                            ykyyEntranceService.updateHisStatus(updateJcsq);
                            String update01sq = "update V_MS_YJ01 set ZFPB = 1 where yjxh = "+baseNatAppointmentDO.getRealOrder();
                            ykyyEntranceService.updateHisStatus(update01sq);
                        }
                    }
                    //取消挂号
                } catch (Exception e) {
                    e.printStackTrace();
                }
            }
        }

    }
    }

