package com.yihu.jw.service.im;

import com.yihu.jw.entity.hospital.consult.WlyyHospitalSysDictDO;
import com.yihu.jw.entity.knowledge.BaseSystemDialogSetting;
import com.yihu.jw.im.service.RobotService;
import com.yihu.jw.im.util.ImUtil;
import com.yihu.jw.knowledge.dao.BaseSystemDialogSettingDao;
import com.yihu.jw.util.date.DateUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;

import java.time.LocalDateTime;
import java.util.List;
import java.util.Map;

/**
 * Created by yeshijie on 2023/4/26.
 */
@Service
public class ImJobService {

    @Autowired
    private BaseSystemDialogSettingDao dialogSettingDao;
    @Autowired
    private JdbcTemplate jdbcTemplate;
    @Autowired
    private ImUtil imUtil;
    @Value("${im.data_base_name}")
    private String imDbName;
    @Autowired
    private RobotService robotService;


    /**
     *
     * @param type 18在线导诊 26专属服务导诊
     */
    public void onlineGuidance(String type){
        //查找配置
        WlyyHospitalSysDictDO dictDO = robotService.getSender();
        BaseSystemDialogSetting customerSetting =  dialogSettingDao.findBySystemTypeAndFunctionType("1","3",1);
        if(customerSetting!=null){
            String content = customerSetting.getContent();
            String time = timeTransfor(customerSetting.getTime(),customerSetting.getTimeUnit());
            //查找未结束的在线导诊
            String sql = "SELECT s.id from "+imDbName+".sessions s,"+imDbName+".patients p  WHERE " +
                    "s.type='"+type+"' and s.`status`='0' and s.last_message_time<='"+time+"' and s.last_sender_id=p.id ";
            List<Map<String,Object>> sessionList = jdbcTemplate.queryForList(sql);
            for (Map<String,Object> map:sessionList){
                String sessionId = map.get("id")+"";
                try {
                    imUtil.sendImMsg(dictDO.getDictCode(), dictDO.getDictValue(), sessionId, "1", content, "1", null);
                }catch (Exception e){
                    e.printStackTrace();
                }
            }
        }
        BaseSystemDialogSetting userSetting =  dialogSettingDao.findBySystemTypeAndFunctionType("1","4",1);
        if(userSetting!=null){
            String content = userSetting.getContent();
            String time = timeTransfor(customerSetting.getTime(),customerSetting.getTimeUnit());
            //查找未结束的在线导诊
            String sql = "SELECT s.id from "+imDbName+".sessions s,"+imDbName+".doctors d  WHERE  " +
                    "s.type='"+type+"' and s.`status`='0' and s.last_message_time<='"+time+"' and s.last_sender_id=d.id ";
            List<Map<String,Object>> sessionList = jdbcTemplate.queryForList(sql);
            for (Map<String,Object> map:sessionList){
                String sessionId = map.get("id")+"";
                try {
                    imUtil.sendImMsg(dictDO.getDictCode(), dictDO.getDictValue(), sessionId, "1", content, "1", null);
                }catch (Exception e){
                    e.printStackTrace();
                }
            }
        }

        BaseSystemDialogSetting endSetting =  dialogSettingDao.findBySystemTypeAndFunctionType("1","6",1);
        if(endSetting!=null){
            String content = endSetting.getContent();
            String time = timeTransfor(customerSetting.getTime(),customerSetting.getTimeUnit());
            //查找未结束的在线导诊
            String sql = "SELECT s.id from im.sessions s  WHERE  " +
                    "s.type='"+type+"' and s.`status`='0' and s.last_message_time<='"+time+"'  ";
            List<Map<String,Object>> sessionList = jdbcTemplate.queryForList(sql);
            for (Map<String,Object> map:sessionList){
                String sessionId = map.get("id")+"";
                try {
                    imUtil.sendImMsg(dictDO.getDictCode(), dictDO.getDictValue(), sessionId, "1", content, "1", null);
                    imUtil.updateSessionStatus(sessionId,"1");
                }catch (Exception e){
                    e.printStackTrace();
                }
            }
        }
    }


    /**
     * 时间处理
     * @param time
     * @param timeUnit {"1":"秒","2":"分钟","3":"小时"}
     * @return
     */
    public String timeTransfor(String time,String timeUnit){
        Long timgLong = Long.parseLong(time);
        if("1".equals(timeUnit)){
            return DateUtil.localTimeToLong(LocalDateTime.now().minusSeconds(timgLong));
        }
        if("2".equals(timeUnit)){
            return DateUtil.localTimeToLong(LocalDateTime.now().minusMinutes(timgLong));
        }
        if("3".equals(timeUnit)){
            return DateUtil.localTimeToLong(LocalDateTime.now().minusHours(timgLong));
        }
        return null;
    }

}
