package com.yihu.jw.util;

import com.yihu.jw.entity.hospital.consult.WlyyHospitalSysDictDO;
import com.yihu.jw.hospital.dict.WlyyHospitalSysDictDao;
import com.yihu.jw.service.channel.PrescriptionStatusUpdateService;
import com.yihu.jw.service.channel.RemindDoctorService;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.scheduling.Trigger;
import org.springframework.scheduling.TriggerContext;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.SchedulingConfigurer;
import org.springframework.scheduling.config.ScheduledTaskRegistrar;
import org.springframework.scheduling.support.CronTrigger;
import org.springframework.stereotype.Component;

import java.util.Date;
import java.util.List;

@Lazy(false)
@Component
@EnableScheduling
public class RemindDoctorJob implements SchedulingConfigurer {
    private static final Logger logger = LoggerFactory.getLogger(RemindDoctorJob.class);
    private static String cron = "0 */1 * * * ?";//"0 0 0 * * ?";0 */5 * * * ?
    public RemindDoctorJob(){
        cron="0 */1 * * * ?";
        System.out.println("初始化时的corn"+cron);
    }
    @Autowired
    private RemindDoctorService remindDoctorService;
    @Autowired
    private WlyyHospitalSysDictDao wlyyHospitalSysDictDao;
    public String change(String corIn) {
        if (StringUtils.isNotBlank(corIn)) {
            cron = corIn;
        }
        return cron;
    }
    @Override
    public void configureTasks(ScheduledTaskRegistrar taskRegistrar) {
        taskRegistrar.addTriggerTask(new Runnable() {
            @Override
            public void run() {
                try {
                    List<WlyyHospitalSysDictDO> dictDOS =wlyyHospitalSysDictDao.findByDictNameAndDictCode("RECEPTION_REMINDER","OPEN");
                    if (dictDOS!=null&&dictDOS.size()>0){
                        if ("1".equalsIgnoreCase(dictDOS.get(0).getDictValue())){//配置中的value值如果为1则表示开启发送提醒功能
                            logger.info("配置开始发送提醒========remindDoctor========");
                            remindDoctorService.sendSystemMessage();
                        }else {
                            logger.info("配置发送提醒关闭");
                        }
                    }else {
                        logger.info("若无配置则发送提醒关闭");
                    }

                } catch (Exception e) {
                    e.printStackTrace();
                    logger.error("END===ERROE===remindDoctor,message:"+e.getMessage());
                }
            }
        }, new Trigger() {
            @Override
            public Date nextExecutionTime(TriggerContext triggerContext) {
                // 任务触发，可修改任务的执行周期
                CronTrigger trigger = new CronTrigger(cron);
                System.out.println("remindDoctor，可修改任务的执行周期"+cron);
                Date nextExec = trigger.nextExecutionTime(triggerContext);
                return nextExec;
            }
        });
    }
}
