package com.yihu.jw.util;


import com.yihu.jw.entity.hospital.consult.WlyyHospitalSysDictDO;
import com.yihu.jw.hospital.dict.WlyyHospitalSysDictDao;
import com.yihu.jw.service.channel.SyncWlyyHospitalService;
import org.apache.commons.lang.time.DateFormatUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.scheduling.Trigger;
import org.springframework.scheduling.TriggerContext;
import org.springframework.scheduling.annotation.EnableScheduling;
import org.springframework.scheduling.annotation.SchedulingConfigurer;
import org.springframework.scheduling.config.ScheduledTaskRegistrar;
import org.springframework.scheduling.support.CronTrigger;
import org.springframework.stereotype.Component;

import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;

@Lazy(false)
@Component
@EnableScheduling
public class SyncWlyyHosptialJob implements SchedulingConfigurer {
    private static final Logger logger = LoggerFactory.getLogger(SyncWlyyHosptialJob.class);
    private static String cron = "0 0 2 * * ?";//"0 0 0 * * ?";0 */5 * * * ?
    public SyncWlyyHosptialJob(){
        cron="0 0 2 * * ?";
        System.out.println("初始化时的corn"+cron);
    }
    @Autowired
    private SyncWlyyHospitalService wlyyHospitalService;
    @Autowired
    private WlyyHospitalSysDictDao wlyyHospitalSysDictDao;
    @Override
    public void configureTasks(ScheduledTaskRegistrar taskRegistrar) {
        taskRegistrar.addTriggerTask(new Runnable() {
            @Override
            public void run() {
                try {
                    WlyyHospitalSysDictDO wlyyHospitalSysDictDO=wlyyHospitalSysDictDao.findById("openSyncWlyy").orElse(null);;
                    String openSyncWlyy="0";
                    if (wlyyHospitalSysDictDO!=null){
                        openSyncWlyy=wlyyHospitalSysDictDO.getDictCode();
                    }
                    if ("1".equalsIgnoreCase(openSyncWlyy)){
                        logger.info("START========syncHospital========");
                        wlyyHospitalService.syncHospital("");
                        logger.info("END========syncHospital========");
                        logger.info("START========syncTeam========");
                        wlyyHospitalService.syncTeam("");
                        logger.info("END========syncTeam========");
                        logger.info("START========syncTeamMember========");
                        Calendar calendar = new GregorianCalendar();
                        calendar.setTime(new Date());
                        calendar.add(calendar.DATE,-1);
                        String nowTime= DateFormatUtils.format(calendar,"yyyy-MM-dd");
                        wlyyHospitalService.syncTeamMemberByTime(nowTime);
                        logger.info("END========syncTeamMember========");
                    }
                } catch (Exception e) {
                    e.printStackTrace();
                    logger.error("END===ERROE===syncHospital,message:"+e.getMessage());
                }
            }
        }, new Trigger() {
            @Override
            public Date nextExecutionTime(TriggerContext triggerContext) {
                // 任务触发，可修改任务的执行周期
                CronTrigger trigger = new CronTrigger(cron);
                System.out.println("syncHospital，可修改任务的执行周期"+cron);
                Date nextExec = trigger.nextExecutionTime(triggerContext);
                return nextExec;
            }
        });

    }
}
