package com.yihu.jw.hospital.endpoint.MultipleCode;

import com.alibaba.fastjson.JSONObject;
import com.yihu.jw.entity.base.patient.BasePatientDO;
import com.yihu.jw.entity.base.wx.BasePatientWechatDo;
import com.yihu.jw.entity.hospital.httplog.WlyyHttpLogDO;
import com.yihu.jw.hospital.httplog.dao.WlyyHttpLogDao;
import com.yihu.jw.hospital.service.MultipleCode.MultipleCodeService;
import com.yihu.jw.patient.dao.BasePatientDao;
import com.yihu.jw.restmodel.web.MixEnvelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import com.yihu.jw.rm.base.BaseRequestMapping;
import com.yihu.jw.util.date.DateUtil;
import com.yihu.jw.wechat.dao.BasePatientWechatDao;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 * @author HZY
 * @vsrsion 1.0
 * Created at 2020/4/9
 */
@RestController
@RequestMapping("mcf" )
@Api(tags ="多码融合", description = "互联网医院")
public class MultipleCoderController extends EnvelopRestEndpoint {


    @Autowired
    private MultipleCodeService multipleCodeService;


    @Autowired
    private BasePatientDao basePatientDao;

    @Autowired
    private WlyyHttpLogDao wlyyHttpLogDao;

    @Autowired
    private BasePatientWechatDao basePatientWechatDao;

    @Value("${wechat.id}")
    private String wechatId;


    /**
     *  多码融合-获取健康卡
     * @param patientId 居民id
     * @return
     */
    @GetMapping(value = BaseRequestMapping.ThirdInterface.selectHealthIdCard)
    @ApiOperation(value = "多码融合-获取健康卡")
    public MixEnvelop getE_healthCard(@ApiParam(name = "patientId", value = "居民id")
                               @RequestParam(value = "patientId",required = true) String patientId){


        try {
            WlyyHttpLogDO logDO = new WlyyHttpLogDO();
            MixEnvelop envelop = new MixEnvelop();
            BasePatientDO patientDO = basePatientDao.findById(patientId).orElse(null);

            logDO.setCode("ehc.ehealthcard.queryInfo");
            logDO.setName("查询多码融合信息");
            logDO.setPatient(patientId);
            String patient = JSONObject.toJSONString(patientDO);
            logDO.setRequest("patientDO="+patient);
            wlyyHttpLogDao.save(logDO);
            String result = multipleCodeService.mcfQueryInfo(patientDO);
            logDO.setResponse(result);
            logDO.setStatus("0");
            logDO.setCreateTime(DateUtil.getNowDate());
            wlyyHttpLogDao.save(logDO);

            if (patientDO!=null&&patientDO.getRegister().equalsIgnoreCase("0")&&result==null){
                //用户表没查询到注册信息
                    BasePatientWechatDo basePatientWechatDo = basePatientWechatDao.findByWechatIdAndPatientId(wechatId, patientId).get(0);
                    if (basePatientWechatDo.getOpenid()!=null){
//                    有openid 去注册
                        logDO.setCode("ehc.ehealthcard.register");
                        logDO.setName("注册多码融合信息");
                        logDO.setPatient(patientId);
                        logDO.setRequest("patientId="+patientId+"&wechatId="+wechatId);
                        wlyyHttpLogDao.save(logDO);
                        envelop = multipleCodeService.mcfRegister(patientDO,wechatId);
                        Object obj = envelop.getObj();
                        String response = JSONObject.toJSONString(obj);
                        logDO.setResponse(response);
                        logDO.setStatus("0");
                        logDO.setCreateTime(DateUtil.getNowDate());
                        wlyyHttpLogDao.save(logDO);
                        return MixEnvelop.getSuccess("获取注册链接成功",response);
                    } else {
//                    无openID
                        return  MixEnvelop.getError("获取注册链接失败",-1);
                    }
            } else {

//                注册成功 返回空
                return MixEnvelop.getSuccess("注册成功",null);
            }
        } catch (Exception e){
            e.printStackTrace();
            return MixEnvelop.getError(e.getMessage());
        }
    }
}

