package com.yihu.jw.hospital.endpoint.account;

import com.yihu.jw.contant.CommonContant;
import com.yihu.jw.doctor.dao.BaseDoctorDao;
import com.yihu.jw.doctor.service.BaseDoctorInfoService;
import com.yihu.jw.doctor.service.BaseDoctorRoleService;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.ObjEnvelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 * Created by yeshijie on 2022/12/7.
 */
@RestController
@RequestMapping("doctor/info" )
@Api(tags = "医生基础信息", value = "医生基础信息")
public class DoctorEndpoint extends EnvelopRestEndpoint {

    @Autowired
    private BaseDoctorDao doctorDao;
    @Autowired
    private BaseDoctorInfoService doctorInfoService;
    @Autowired
    private BaseDoctorRoleService doctorRoleService;

    @GetMapping(value= "findTipNum")
    @ApiOperation("获取医生模块消息数角标")
    public Envelop findTipNum(
            @ApiParam(name = "doctor", value = "doctor", required = true)
            @RequestParam(value = "doctor", required = true)String doctor){
        try {
            return ObjEnvelop.getSuccess(CommonContant.Message.GET_SUCCESS,doctorInfoService.findTipNum(doctor));
        }catch (Exception e){
            return failedException2(e);
        }
    }

    @GetMapping(value= "getDoctorRole")
    @ApiOperation("获取医生角色")
    public Envelop getDoctorRole(
            @ApiParam(name = "doctor", value = "doctor", required = true)
            @RequestParam(value = "doctor", required = true)String doctor){
        try {
            return ObjEnvelop.getSuccess(CommonContant.Message.GET_SUCCESS,doctorRoleService.getDoctorRole(doctor, CommonContant.DR_INPATIENTAREA));
        }catch (Exception e){
            return failedException2(e);
        }
    }

}
