package com.yihu.jw.hospital.endpoint.analysis;

import com.yihu.jw.hospital.service.analysis.AnalysisService;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import com.yihu.jw.rm.hospital.BaseHospitalRequestMapping;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;



/**
 * @author zmk
 * @vsrsion 1.0
 * Created at 2019/11/21
 */
@RestController
@RequestMapping(value = BaseHospitalRequestMapping.Analysis.PREFIX)
@Api(value = "分析总览", description = "分析总览", tags = {"互联网医院 - 医生分析总览接口"})
public class AnalysisEndPoint extends EnvelopRestEndpoint {

    private static Logger logger = LoggerFactory.getLogger(AnalysisEndPoint.class);

    @Autowired
    private AnalysisService analysisService;


    @GetMapping(value= BaseHospitalRequestMapping.Analysis.queryAnalysis)
    @ApiOperation("查询分析数据")
    public Envelop queryAnalysis(
            @ApiParam(name = "doctor", value = "doctor", required = true)
            @RequestParam(value = "doctor", required = true)String doctor,
            @ApiParam(name = "startTime", value = "startTime", required = true)
            @RequestParam(value = "startTime", required = true)String startTime,
            @ApiParam(name = "endTime", value = "endTime", required = true)
            @RequestParam(value = "endTime", required = false)String endTime)throws Exception{


        try {
            Object num = analysisService.queryAnalysis(doctor,startTime,endTime);
            return success(num);
        }catch (Exception e){
            return failedException(e);
        }
    }



}
