package com.yihu.jw.hospital.endpoint.dict;

import com.yihu.jw.dict.service.DeptHomepageBannerService;
import com.yihu.jw.entity.hospital.manage.BaseDeptHomepageBannerDO;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import com.yihu.jw.rm.hospital.BaseHospitalRequestMapping;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping(value = BaseHospitalRequestMapping.PatientNoLogin.PREFIX)
@Api(value = "科室首页图标管理",tags = "科室首页图标")
public class DeptHomepageBannerEndpoint extends EnvelopRestEndpoint {

    @Autowired
    private DeptHomepageBannerService deptHomepageBannerService;

    @ApiOperation("删除疾病首页图标")
    @PostMapping(value = BaseHospitalRequestMapping.PatientNoLogin.delDeptHomepageBanner)
    public Envelop delDeptHomepageBanner(@ApiParam(name = "id", value = "id", required = true)
                                            @RequestParam(value = "id", required = true) Integer id) {
        deptHomepageBannerService.delDeptHomepageBanner(id);
        return success();
    }

    @ApiOperation("新增/修改疾病首页图标")
    @PostMapping(value = BaseHospitalRequestMapping.PatientNoLogin.updateDeptHomepageBanner)
    public Envelop updateDeptHomepageBanner(@ApiParam(name = "json", value = "json", required = true)
                                               @RequestParam(value = "json", required = true) String json) throws Exception {
        BaseDeptHomepageBannerDO deptHomepageBannerDO = objectMapper.readValue(json, BaseDeptHomepageBannerDO.class);
        return success(deptHomepageBannerService.updateDeptHomepageBanner(deptHomepageBannerDO));
    }
}
