package com.yihu.jw.hospital.endpoint.expressage;

import com.yihu.jw.contant.CommonContant;
import com.yihu.jw.hospital.prescription.service.PrescriptionService;
import com.yihu.jw.restmodel.hospital.prescription.WlyyPrescriptionVO;
import com.yihu.jw.restmodel.web.ObjEnvelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 * Created by yeshijie on 2020/4/26.
 *
 * @author yeshijie.
 */
@RestController
@RequestMapping(value = "doctorExpressage")
@Api(value = "眼科医院物流管理器", description = "眼科医院物流管理器", tags = {"眼科医院物流管理器"})
public class DoctorExpressageEndpoint extends EnvelopRestEndpoint {

    private static Logger logger = LoggerFactory.getLogger(DoctorExpressageEndpoint.class);

    @Autowired
    private PrescriptionService prescriptionService;

    @RequestMapping(value = "/findUndeliveredList", method = RequestMethod.GET)
    @ApiOperation("查询所有待派送的订单")
    public ObjEnvelop<WlyyPrescriptionVO> findUndeliveredList(){
        try{
//            String tmp = "{\"id\":\"2ae192b848504c6591fe7328c795a181\",\"createTime\":\"2020-03-0316:28:06\",\"createUser\":null,\"createUserName\":null,\"updateTime\":null,\"updateUser\":null,\"updateUserName\":null,\"outpatientId\":null,\"realOrder\":\"1159744\",\"originRealOrder\":null,\"admNo\":null,\"originAdmNo\":null,\"serialNo\":\"03031021\",\"originSerialNo\":null,\"type\":1,\"patientCode\":\"9f9c89db892b4d5cbef9a2c788702bc3\",\"patientName\":\"吴菜花\",\"idcard\":null,\"cardNo\":null,\"ssc\":\"D40136795\",\"doctor\":\"4028a14770a41b240170a4bbb6e600f4\",\"doctorName\":\"陈亮\",\"status\":60,\"mkFailReason\":null,\"mkTime\":null,\"prescribeTime\":null,\"prescribeReason\":null,\"payTime\":null,\"dosageTime\":null,\"finishTime\":null,\"dept\":\"4\",\"deptName\":\"视光部\",\"hospital\":\"350211A5004\",\"hospitalName\":\"厦门大学附属厦门眼科医院\",\"consult\":null,\"dispensaryType\":null,\"reason\":null,\"diseaseImg\":null,\"remark\":null,\"cancelReason\":null,\"caCertData\":null,\"caMessage\":null,\"digitalSignNo\":null,\"originalDataAbstract\":null,\"strOriginalData\":null,\"hisDeptCode\":null,\"hisDoctorCode\":null,\"hisGisterTypeCode\":null,\"hisRateTypeCode\":null,\"hisHospital\":null,\"hisRegisterFee\":0,\"payStatus\":null,\"diagnosisVOs\":null,\"infoVOs\":null,\"expressage\":null,\"dispUser\":null,\"dispUserName\":null,\"dispDate\":null,\"inspectionVOs\":null}";
//            JSONObject json = JSONObject.parseObject(tmp);
//            JSONArray array = new JSONArray();
//            array.add(json);
//            return ObjEnvelop.getSuccess(CommonContant.Message.GET_SUCCESS, array);
            return ObjEnvelop.getSuccess(CommonContant.Message.GET_SUCCESS, prescriptionService.findUndeliveredList());
        }catch (Exception e){
            logger.error(e.getMessage());
            return ObjEnvelop.getError(CommonContant.Message.GET_ERROR);
        }
    }

    @RequestMapping(value = "/findUndeliveredDetail", method = RequestMethod.GET)
    @ApiOperation("查询待派送订单的订单详情")
    public ObjEnvelop findUndeliveredDetail(
            @ApiParam(name = "id", value = "处方id", required = true)
            @RequestParam(value = "id",required = true) String id){
        try{
//            //续方信息
//            Map<String,Object> rs = new HashedMap();
//            String tmp = "{\"id\":\"2ae192b848504c6591fe7328c795a181\",\"createTime\":\"2020-03-0316:28:06\",\"createUser\":null,\"createUserName\":null,\"updateTime\":null,\"updateUser\":null,\"updateUserName\":null,\"outpatientId\":null,\"realOrder\":\"1159744\",\"originRealOrder\":null,\"admNo\":null,\"originAdmNo\":null,\"serialNo\":\"03031021\",\"originSerialNo\":null,\"type\":1,\"patientCode\":\"9f9c89db892b4d5cbef9a2c788702bc3\",\"patientName\":\"吴菜花\",\"idcard\":null,\"cardNo\":null,\"ssc\":\"D40136795\",\"doctor\":\"4028a14770a41b240170a4bbb6e600f4\",\"doctorName\":\"陈亮\",\"status\":60,\"mkFailReason\":null,\"mkTime\":null,\"prescribeTime\":null,\"prescribeReason\":null,\"payTime\":null,\"dosageTime\":null,\"finishTime\":null,\"dept\":\"4\",\"deptName\":\"视光部\",\"hospital\":\"350211A5004\",\"hospitalName\":\"厦门大学附属厦门眼科医院\",\"consult\":null,\"dispensaryType\":null,\"reason\":null,\"diseaseImg\":null,\"remark\":null,\"cancelReason\":null,\"caCertData\":null,\"caMessage\":null,\"digitalSignNo\":null,\"originalDataAbstract\":null,\"strOriginalData\":null,\"hisDeptCode\":null,\"hisDoctorCode\":null,\"hisGisterTypeCode\":null,\"hisRateTypeCode\":null,\"hisHospital\":null,\"hisRegisterFee\":0,\"payStatus\":null,\"diagnosisVOs\":null,\"infoVOs\":null,\"expressage\":null,\"dispUser\":null,\"dispUserName\":null,\"dispDate\":null,\"inspectionVOs\":null}";
//            JSONObject json = JSONObject.parseObject(tmp);
//            rs.put("prescription",json);
//
//            //居民详情
//            rs.put("patientName","吴菜花");
//            rs.put("patientId","9f9c89db892b4d5cbef9a2c788702bc3");
//            rs.put("idCard","352122296708091145");
//            rs.put("sex", null);
//            rs.put("ssc", null);
//            rs.put("age", 52);
//
//            //诊断信息
//            rs.put("diagnosis",new JSONArray());
//
//            //药品信息
//            String tmp2 = "{\"id\":\"2ae192b848504c6591fe7328c795a181\",\"prescriptionId\":\"2ae192b848504c6591fe7328c795a181\",\"drugNo\":\"0116\",\"drugName\":\"七叶洋地黄双苷滴眼液（施图伦）\",\"dispDeposite\":null,\"dosage\":\"0.400\",\"quantity\":\"1\",\"unit\":null,\"unitName\":\"ml\",\"packUnit\":null,\"packUnitName\":\"盒\",\"supplyCode\":\"78\",\"supplyName\":\"滴双眼\",\"days\":null,\"frequency\":null,\"serial\":null,\"groupNo\":null,\"specification\":\"0.4ml：10支\",\"del\":1,\"usageCode\":\"qd\",\"usageName\":\"1次/d\",\"packRetprice\":32.29,\"herbalCount\":null,\"postCount\":null,\"comm\":null}";
//            JSONObject json2 = JSONObject.parseObject(tmp2);
//            JSONArray array2 = new JSONArray();
//            array2.add(json2);
//            rs.put("infos",array2);
//            return ObjEnvelop.getSuccess(CommonContant.Message.GET_SUCCESS, rs);
            return ObjEnvelop.getSuccess(CommonContant.Message.GET_SUCCESS, prescriptionService.findPrescriptionInfo(id));
        }catch (Exception e){
            logger.error(e.getMessage());
            return ObjEnvelop.getError(CommonContant.Message.GET_ERROR);
        }
    }


}
