package com.yihu.jw.hospital.endpoint.healthUpload;

import com.yihu.jw.entity.healthUpload.BasePatientHealthUploadDO;
import com.yihu.jw.healthUpload.service.BasePatientHealthUploadService;
import com.yihu.jw.restmodel.web.MixEnvelop;
import com.yihu.jw.restmodel.web.ObjEnvelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * Created by yeshijie on 2022/12/6.
 */
@RestController
@RequestMapping(value = "healthUpload/patient")
@Api(value = "居民端-马銮湾医院健康上报功能", tags = "居民端-马銮湾医院健康上报功能")
public class PatientHealthUploadPoint extends EnvelopRestEndpoint {

    @Autowired
    private BasePatientHealthUploadService patientHealthUploadService;

    @PostMapping(value = "createHealthUploadInfo")
    @ApiOperation(value = "提交健康信息")
    public ObjEnvelop createHealthUploadInfo(@ApiParam(name = "jsonData", value = "健康信息实体")
                                             @RequestParam(value = "jsonData", required = true) String jsonData) {
        try {
            BasePatientHealthUploadDO healthUploadDO = objectMapper.readValue(jsonData, BasePatientHealthUploadDO.class);
            healthUploadDO = patientHealthUploadService.createHealthUploadInfo(healthUploadDO);
            return success(healthUploadDO);
        } catch (Exception e) {
            return failedObjEnvelopException2(e);
        }
    }

    @GetMapping(value = "selectHealthUploadInfoByPatientId")
    @ApiOperation(value = "查询成员的健康上报记录")
    public MixEnvelop selectHealthUploadInfoByPatientId(@ApiParam(name = "patientId", value = "医生id")
                                                       @RequestParam(value = "patientId", required = true) String patientId,
                                                       @ApiParam(name = "startDate", value = "开始时间")
                                                       @RequestParam(value = "startDate", required = false) String startDate,
                                                       @ApiParam(name = "endDate", value = "结束时间")
                                                       @RequestParam(value = "endDate", required = false) String endDate,
                                                       @ApiParam(name = "page", value = "页码")
                                                       @RequestParam(value = "page", required = false) Integer page,
                                                       @ApiParam(name = "pageSize", value = "大小")
                                                       @RequestParam(value = "pageSize", required = false) Integer pageSize) {
        try {
            MixEnvelop mixEnvelop = patientHealthUploadService.selectHealthUploadInfoByPatientId(patientId,startDate,endDate,page,pageSize);
            return mixEnvelop;
        } catch (Exception e) {
            return failedMixEnvelopException(e);
        }
    }
    @GetMapping(value = "selectHealthInfoById")
    @ApiOperation(value = "根据id查询健康上报情况")
    public ObjEnvelop selectHealthInfoById(@ApiParam(name = "id", value = "医生id")
                                                       @RequestParam(value = "id", required = true) String id) {
        try {
            BasePatientHealthUploadDO healthUploadDO = patientHealthUploadService.selectHealthInfoById(id);
            return success(healthUploadDO);
        } catch (Exception e) {
            return failedObjEnvelopException(e);
        }
    }
}
