package com.yihu.jw.hospital.endpoint.hospital;

import com.yihu.jw.doctor.service.BaseDoctorSuggestService;
import com.yihu.jw.entity.hospital.suggest.BaseSuggestionDO;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import com.yihu.jw.rm.hospital.BaseHospitalRequestMapping;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Map;


@RestController
@RequestMapping(value = BaseHospitalRequestMapping.DoctorSuggest.baseDoctorSuggest)
@Api(value = "医生反馈建议管理", description = "医生反馈建议管理", tags = {"互联网医院 - 医生反馈建议管理"})
public class BaseDoctorSuggestController extends EnvelopRestEndpoint {
    @Autowired
    private BaseDoctorSuggestService baseDoctorSuggestService;
    @ApiOperation("查询反馈建议列表")
    @GetMapping(value= BaseHospitalRequestMapping.DoctorSuggest.findSuggestList)
    public Envelop findSuggestList(@ApiParam(name = "doctor", value = "doctor", required = false)
                                       @RequestParam(value = "doctor", required = false)String doctor,
                                       @ApiParam(name = "patient", value = "patient", required = false)
                                       @RequestParam(value = "patient", required = false)String patient,
                                       @ApiParam(name = "doctorName", value = "doctorName", required = false)
                                           @RequestParam(value = "doctorName", required = false)String doctorName,
                                       @ApiParam(name = "patientName", value = "patientName", required = false)
                                           @RequestParam(value = "patientName", required = false)String patientName,
                                       @ApiParam(name = "startTime", value = "startTime", required = false)
                                           @RequestParam(value = "startTime", required = false)String startTime,
                                       @ApiParam(name = "endTime", value = "endTime", required = false)
                                           @RequestParam(value = "endTime", required = false)String endTime,
                                       @ApiParam(name = "suggestType", value = "suggestType", required = false)
                                           @RequestParam(value = "suggestType", required = false)String suggestType,
                                       @ApiParam(name = "relationType", value = "relationType", required = false)
                                           @RequestParam(value = "relationType", required = false)String relationType,
                                       @ApiParam(name = "keyWord", value = "keyWord", required = false)
                                           @RequestParam(value = "keyWord", required = false)String keyWord,
                                       @ApiParam(name = "page", value = "page", required = false)
                                       @RequestParam(value = "page", required = false)Integer page,
                                       @ApiParam(name = "size", value = "size", required = false)
                                       @RequestParam(value = "size", required = false)Integer size){

        try {

            return success( baseDoctorSuggestService.findDoctorSuggest(doctor,patient,doctorName,patientName,startTime,endTime,suggestType,relationType,keyWord,page,size));
        }catch (Exception e){
            System.out.println(e.getClass());
            return failedException(e);
        }
    }
    @PostMapping(value= BaseHospitalRequestMapping.DoctorSuggest.saveSuggest)
    @ApiOperation("新增医生反馈建议")
    public Envelop saveSuggest(
            @ApiParam(name = "suggestType", value = "", required = false)
            @RequestParam(value = "suggestType", required = false)String suggestType,
            @ApiParam(name = "suggestContent", value = "", required = false)
            @RequestParam(value = "suggestContent", required = false)String suggestContent,
            @ApiParam(name = "imgUrl", value = "", required = false)
            @RequestParam(value = "imgUrl", required = false)String imgUrl,
            @ApiParam(name = "doctor", value = "", required = false)
            @RequestParam(value = "doctor", required = false)String doctor,
            @ApiParam(name = "createUser", value = "", required = false)
            @RequestParam(value = "createUser", required = false)String createUser,
            @ApiParam(name = "relationCode", value = "", required = false)
            @RequestParam(value = "relationCode", required = false)String relationCode,
            @ApiParam(name = "relationType", value = "", required = false)
            @RequestParam(value = "relationType", required = false)String relationType)throws Exception{

        try {
           baseDoctorSuggestService.saveDoctorSuggest(suggestType,suggestContent,imgUrl,doctor,createUser,relationCode,relationType);
            return success("新增成功");
        }catch (Exception e){
            return failedException(e);
        }
    }
    @GetMapping(value= BaseHospitalRequestMapping.DoctorSuggest.findOne)
    @ApiOperation("查询单条")
    public Envelop findOne(
            @ApiParam(name = "id", value = "id", required = true)
            @RequestParam(value = "id", required = false)String id)throws Exception{

        try {

            return success(baseDoctorSuggestService.findById(id));
        }catch (Exception e){
            return failedException(e);
        }
    }
}
