package com.yihu.jw.hospital.endpoint.hospital;

import com.yihu.jw.hospital.team.service.WlyyAdminTeamService;
import com.yihu.jw.restmodel.web.MixEnvelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import com.yihu.jw.rm.hospital.BaseHospitalRequestMapping;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.imageio.ImageIO;
import javax.swing.*;
import java.awt.image.BufferedImage;
import java.io.File;
import java.net.URL;
import java.util.UUID;

@RestController
@RequestMapping("/wlyyAdminManage")
@Api(value = "社区管理", description = "社区管理", tags = {"互联网医院 - 社区管理"})
public class WlyyAdminTeamController extends EnvelopRestEndpoint {
    @Autowired
    private WlyyAdminTeamService wlyyAdminTeamService;
    @ApiOperation("查询社区")
    @GetMapping("/findOrgList")
    public MixEnvelop findOrgList(@ApiParam(name = "code", value = "code", required = false)
                                           @RequestParam(value = "code", required = false)String code,
                                  @ApiParam(name = "name", value = "name", required = false)
                                        @RequestParam(value = "name", required = false)String name,
                                           @ApiParam(name = "page", value = "第几页，从1开始", required = true, defaultValue = "1")
                                           @RequestParam(value = "page", required = true,defaultValue = "1")Integer page,
                                           @ApiParam(name = "pageSize", value = "每页分页大小", required = true, defaultValue = "10")
                                           @RequestParam(value = "pageSize", required = true,defaultValue = "10")Integer pageSize){


        try {
            return wlyyAdminTeamService.findHospitalByTown(code,name,page,pageSize);
        }catch (Exception e){
            System.out.println(e.getClass());
            return failedMixEnvelopException(e);
        }
    }
    @ApiOperation("查询团队")
    @GetMapping("/findTeamList")
    public MixEnvelop findTeamList(@ApiParam(name = "city", value = "city", required = false)
                                  @RequestParam(value = "city", required = false)String city,
                                   @ApiParam(name = "town", value = "town", required = false)
                                   @RequestParam(value = "town", required = false)String town,
                                   @ApiParam(name = "orgCode", value = "orgCode", required = false)
                                       @RequestParam(value = "orgCode", required = false)String orgCode,
                                  @ApiParam(name = "page", value = "第几页，从1开始", required = true, defaultValue = "1")
                                  @RequestParam(value = "page", required = true,defaultValue = "1")Integer page,
                                  @ApiParam(name = "pageSize", value = "每页分页大小", required = true, defaultValue = "10")
                                  @RequestParam(value = "pageSize", required = true,defaultValue = "10")Integer pageSize){


        try {
            return wlyyAdminTeamService.findTeamByOrg(city,town,orgCode,page,pageSize);
        }catch (Exception e){
            System.out.println(e.getClass());
            return failedMixEnvelopException(e);
        }
    }
    @ApiOperation("查询医生")
    @GetMapping("/findMemberList")
    public MixEnvelop findMemberList(@ApiParam(name = "code", value = "code", required = false)
                                  @RequestParam(value = "code", required = false)String code,
                                  @ApiParam(name = "page", value = "第几页，从1开始", required = true, defaultValue = "1")
                                  @RequestParam(value = "page", required = true,defaultValue = "1")Integer page,
                                  @ApiParam(name = "pageSize", value = "每页分页大小", required = true, defaultValue = "10")
                                  @RequestParam(value = "pageSize", required = true,defaultValue = "10")Integer pageSize){


        try {
            return wlyyAdminTeamService.findDoctorByTeam(code,page,pageSize);
        }catch (Exception e){
            System.out.println(e.getClass());
            return failedMixEnvelopException(e);
        }
    }

    @ApiOperation("查询区")
    @GetMapping("/findTown")
    public MixEnvelop findTown(@ApiParam(name = "code", value = "code", required = false)
                                     @RequestParam(value = "code", required = false)String code){


        try {
            return MixEnvelop.getSuccess("操作成功",wlyyAdminTeamService.findTownByCity(code));
        }catch (Exception e){
            System.out.println(e.getClass());
            return failedMixEnvelopException(e);
        }
    }
    @ApiOperation("查询团队医生单条")
    @GetMapping("/findOneTeamMember")
    public MixEnvelop findOneTeamMember(@ApiParam(name = "id", value = "id", required = false)
                               @RequestParam(value = "id", required = false)Integer id){


        try {
            return MixEnvelop.getSuccess("操作成功",wlyyAdminTeamService.findOneTeamMemberById(id));
        }catch (Exception e){
            System.out.println(e.getClass());
            return failedMixEnvelopException(e);
        }
    }

}
