package com.yihu.jw.hospital.endpoint.hospital;

import com.alibaba.fastjson.JSONObject;
import com.yihu.jw.entity.base.patient.BaseNatPatientFamilyMemberDO;
import com.yihu.jw.entity.hospital.consult.WlyyHospitalSysDictDO;
import com.yihu.jw.entity.hospital.family.WlyyPatientFamilyMemberDO;
import com.yihu.jw.hospital.dict.WlyyHospitalSysDictDao;
import com.yihu.jw.hospital.family.dao.WlyyNatPatientFamilyMemberDao;
import com.yihu.jw.hospital.family.dao.WlyyPatientFamilyMemberDao;
import com.yihu.jw.hospital.family.service.PatientMemberDictService;
import com.yihu.jw.hospital.family.service.WlyyFamilyMemberService;
import com.yihu.jw.hospital.prescription.service.entrance.EntranceService;
import com.yihu.jw.hospital.prescription.service.entrance.TnyyEntranceService;
import com.yihu.jw.hospital.prescription.service.entrance.XzzxEntranceService;
import com.yihu.jw.hospital.prescription.service.entrance.YkyyEntranceService;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.MixEnvelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import com.yihu.jw.rm.hospital.BaseHospitalRequestMapping;
import com.yihu.jw.sms.service.YkyyINSMSService;
import com.yihu.jw.sms.service.ZBSmsService;
import com.yihu.jw.sms.service.ZhongShanSMSService;
import com.yihu.jw.sms.util.ykyy.vo.ResultMsg;
import com.yihu.jw.util.date.DateUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import net.sf.json.JSONArray;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.data.redis.core.RedisTemplate;
import org.springframework.util.StringUtils;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.text.ParseException;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.concurrent.TimeUnit;

@RestController
@RequestMapping(value = BaseHospitalRequestMapping.WlyyFamilyMember.wlyyFamilyMember)
@Api(value = "互联网医院家人关联管理", description = "互联网医院家人关联管理", tags = {"互联网医院 - 互联网医院家人关联管理"})
public class WlyyFamilyMemberController extends EnvelopRestEndpoint {
    @Autowired
    private WlyyFamilyMemberService wlyyFamilyMemberService;
    @Autowired
    private WlyyPatientFamilyMemberDao wlyyPatientFamilyMemberDao;
    @Autowired
    private PatientMemberDictService patientMemberDictService;
    @Autowired
    private EntranceService entranceService;
    @Autowired
    private RedisTemplate redisTemplate;
    @Autowired
    private YkyyINSMSService ykyyINSMSService;
    private final String KEY_SUFFIX = ":code";
    @Autowired
    private ZhongShanSMSService zhongShanSMSService;
    @Autowired
    private YkyyEntranceService ykyyEntranceService;
    @Autowired
    private XzzxEntranceService xzzxEntranceService;
    @Autowired
    private TnyyEntranceService tnyyEntranceService;
    @Autowired
    private ZBSmsService zbSmsService;
    @Autowired
    private WlyyHospitalSysDictDao wlyyHospitalSysDictDao;
    @Autowired
    private WlyyNatPatientFamilyMemberDao natPatientFamilyMemberDao;
    @Value("${wechat.id}")
    private String wxId;

    @ApiOperation("获取家人关系")
    @PostMapping(value = BaseHospitalRequestMapping.WlyyFamilyMember.findRelationDict)
    public Envelop findRelationDict() {
        return success(patientMemberDictService.findAllMemberDict());
    }

    @ApiOperation("发送验证码")
    @PostMapping(value = BaseHospitalRequestMapping.WlyyFamilyMember.sendZSFamily)
    public MixEnvelop sendZSCaptcha(@ApiParam(name = "jsonData", value = "jsonData", required = false)
                                    @RequestParam(value = "jsonData", required = false) String jsonData) throws Exception {
        MixEnvelop mixEnvelop = new MixEnvelop();
        JSONObject obj = JSONObject.parseObject(jsonData);
        String client_id = obj.getString("client_id");
        String phoneNum = obj.getString("phoneNum");
        String idCard = obj.getString("idCard");
        String familyName = obj.getString("familyName");
        String medicareType = obj.getString("medicareType");
        String medicare = obj.getString("medicare");
        String clinicId = obj.getString("clinicId");
        /*String key = obj.getString("key");
        String text = obj.getString("text");
        if(org.apache.commons.lang3.StringUtils.isNotBlank(key)&& org.apache.commons.lang3.StringUtils.isNotBlank(text)){
            if(!verifyCaptcha(key,text)){
                mixEnvelop.setStatus(408);
                mixEnvelop.setMessage("图形验证码输入错误");
                return mixEnvelop;
            }
        }*/
        net.sf.json.JSONArray jsonArray = new JSONArray();
        if("xm_ykyy_wx".equalsIgnoreCase(wxId)){
            /*jsonArray = ykyyEntranceService.findHisPatientBymMedicare(medicare,clinicId,false);
            if(jsonArray!=null&&jsonArray.size()>0){
                net.sf.json.JSONObject jsonObject= net.sf.json.JSONObject.fromObject(jsonArray.get(0).toString());
                if (null!=jsonObject.get("brid")){
                    String Pat_name = jsonObject.getString("brxm");
                    if(!Pat_name.equalsIgnoreCase(familyName)){
                        mixEnvelop.setStatus(408);
                        mixEnvelop.setMessage("您所添加的家属的名称有误，无法发送验证码");
                        return mixEnvelop;
                    }
                }else {
                    mixEnvelop.setStatus(408);
                    mixEnvelop.setMessage("您所添加的家属无就诊记录无法添加");
                    return mixEnvelop;
                }

            }else {
                mixEnvelop.setStatus(408);
                mixEnvelop.setMessage("您所添加的家属无就诊记录无法添加");
                return mixEnvelop;
            }*/
        }else if ("xm_zsyy_wx".equalsIgnoreCase(wxId)){
            jsonArray = entranceService.BS10008(idCard, "", "", "", "", "", false);
            if(jsonArray!=null&&jsonArray.size()>0){
                net.sf.json.JSONObject jsonObject= net.sf.json.JSONObject.fromObject(jsonArray.get(0).toString());
                if (null!=jsonObject.get("Patient_Id")){
                    String Pat_name = jsonObject.getString("Pat_Name");
                    if (null!=jsonObject.get("Phone_Number_Business")){
                        String Next_Of_Kin_Phone = jsonObject.get("Phone_Number_Business").toString();
                        if(!Next_Of_Kin_Phone.equalsIgnoreCase(phoneNum)){
                            mixEnvelop.setStatus(408);
                            mixEnvelop.setMessage("您所添加的家属的电话有误，无法发送验证码");
                            return mixEnvelop;
                        }
                    }
                    if(!Pat_name.equalsIgnoreCase(familyName)){
                        mixEnvelop.setStatus(408);
                        mixEnvelop.setMessage("您所添加的家属的名称有误，无法发送验证码");
                        return mixEnvelop;
                    }
                }

            }
        }else if("xm_xzzx_wx".equalsIgnoreCase(wxId)){
            com.alibaba.fastjson.JSONArray jsonArray1 = xzzxEntranceService.selectPateintCardByIdCard(idCard);
            if (null!=jsonArray1&&jsonArray1.size()>0){

            }else {
                mixEnvelop.setStatus(408);
                mixEnvelop.setMessage("您所添加的家属无就诊记录，无法添加");
                return  mixEnvelop;
            }
        }else if ("sd_tnzyy_wx".equalsIgnoreCase(wxId)){
            com.alibaba.fastjson.JSONArray jsonArray1 = tnyyEntranceService.selectPatientMappingCode(idCard);
            if (jsonArray1!=null&&jsonArray1.size()>0){

            }else {
                mixEnvelop.setStatus(408);
                mixEnvelop.setMessage("您所添加的家属无就诊记录，无法添加");
                return  mixEnvelop;
            }
        }
        if (StringUtils.isEmpty(client_id)) {
            mixEnvelop.setStatus(468);
            mixEnvelop.setMessage("client_id不能为空");
            return mixEnvelop;
        }
        if (StringUtils.isEmpty(phoneNum)) {
            mixEnvelop.setStatus(468);
            mixEnvelop.setMessage("电话号不能为空");
            return mixEnvelop;
        }
        if (phoneNum.length() > 12) {
            mixEnvelop.setStatus(468);
            mixEnvelop.setMessage("请输入正确的手机号");
            return mixEnvelop;
        }
        //验证请求间隔超时，防止频繁获取验证码
        if (!this.isIntervalTimeout(client_id, phoneNum)) {
            throw new IllegalAccessException("SMS request frequency is too fast");
            //发送短信获取验证码
        }
        WlyyHospitalSysDictDO wlyyHospitalSysDictDO = wlyyHospitalSysDictDao.findById("isNeedSMS").orElse(null);
        if (wlyyHospitalSysDictDO!=null&&!StringUtils.isEmpty(wlyyHospitalSysDictDO.getDictValue())){
            String captcha = wlyyHospitalSysDictDO.getDictValue();
            this.store(client_id, phoneNum, captcha, 120);
            mixEnvelop.setMessage("验证码发送成功");
        }else {
            String captcha = this.getCodeNumber();
            System.out.println("=====================当前短信验证码============="+captcha+"=====================");
            if("xm_ykyy_wx".equalsIgnoreCase(wxId)){
                System.out.println("发送眼科验证码开始");
                ResultMsg result= null;
                result = ykyyINSMSService.ykyySendSMS(phoneNum, "您好，您的此次操作的验证码是：" + captcha + "，2分钟内有效。如非本人操作，请忽略");
                if (result.isSuccess()){
                    this.store(client_id, phoneNum, captcha, 120);
                    mixEnvelop.setMessage("验证码发送成功");
                } else {
                    mixEnvelop.setMessage("验证码发送失败");
                    mixEnvelop.setStatus(500);
                }
            }else if("xm_zsyy_wx".equalsIgnoreCase(wxId)){
                System.out.println("发送中山验证码开始");
                int result = 1;
                if (null!=jsonArray&&jsonArray.size() > 0) {
                    result = zhongShanSMSService.ZhongShangSendSMS(phoneNum, "您好，您当前操作的验证码是：" + captcha + "，2分钟内有效。如非本人操作，请忽略");
                } else {
                    result = 2;
                }
                if (0 == result) {
                    this.store(client_id, phoneNum, captcha, 120);
                    mixEnvelop.setMessage("验证码发送成功");
                } else if (2 == result) {
                    mixEnvelop.setStatus(408);
                    mixEnvelop.setMessage("您所添加的家属无就诊记录，无法发送验证码");
                } else {
                    mixEnvelop.setMessage("验证码发送失败");
                    mixEnvelop.setStatus(500);
                }
            }else if("xm_xzzx_wx".equalsIgnoreCase(wxId)){
                //发送短信获取验证码
                JSONObject object = new JSONObject();
                object.put("operatetel","18788888888");
                object.put("interfaceid","jcpt");
                object.put("interfacepwd","jcpt");
                object.put("operator","xxgwxgzh");
                object.put("operateid","xxgwxgzh");
                com.alibaba.fastjson.JSONArray array = new com.alibaba.fastjson.JSONArray();
                JSONObject jsonObject = new JSONObject();
                jsonObject.put("content","您好，你的手机登录短信验证码是："+captcha+"，5分钟内有效。");
                jsonObject.put("sendtel",phoneNum);
                jsonObject.put("sendtime", DateUtil.dateToStrLong(new Date()));
                array.add(jsonObject);
                object.put("messageinfo",array);
                int result =  xzzxEntranceService.SendSmsToEntrance(object.toJSONString());
                if (0 == result) {
                    this.store(client_id, phoneNum, captcha, 120);
                    mixEnvelop.setMessage("验证码发送成功");
                } else {
                    mixEnvelop.setMessage("验证码发送失败");
                    mixEnvelop.setStatus(500);
                }
            }else if("sd_tnzyy_wx".equalsIgnoreCase(wxId)){
                //发送短信获取验证码
                String content = captcha;
                int result =  zbSmsService.sendMessage(phoneNum,content);
                if (0 == result) {
                    this.store(client_id, phoneNum, captcha, 120);
                    mixEnvelop.setMessage("验证码发送成功");
                } else {
                    mixEnvelop.setMessage("验证码发送失败");
                    mixEnvelop.setStatus(500);
                }
            }
        }


        return mixEnvelop;
    }

    @ApiOperation("核酸代预约发送验证码")
    @PostMapping(value = BaseHospitalRequestMapping.WlyyFamilyMember.sendFamily)
    public MixEnvelop sendCaptcha(@ApiParam(name = "jsonData", value = "jsonData", required = false)
                                    @RequestParam(value = "jsonData", required = false) String jsonData) throws Exception {
        MixEnvelop mixEnvelop = new MixEnvelop();
        JSONObject obj = JSONObject.parseObject(jsonData);
        String client_id = obj.getString("client_id");
        String phoneNum = obj.getString("phoneNum");

        if (StringUtils.isEmpty(client_id)) {
            mixEnvelop.setStatus(468);
            mixEnvelop.setMessage("client_id不能为空");
            return mixEnvelop;
        }
        if (StringUtils.isEmpty(phoneNum)) {
            mixEnvelop.setStatus(468);
            mixEnvelop.setMessage("电话号不能为空");
            return mixEnvelop;
        }
        if (phoneNum.length() > 12) {
            mixEnvelop.setStatus(468);
            mixEnvelop.setMessage("请输入正确的手机号");
            return mixEnvelop;
        }
        //验证请求间隔超时，防止频繁获取验证码
        if (!this.isIntervalTimeout(client_id, phoneNum)) {
            throw new IllegalAccessException("SMS request frequency is too fast");
            //发送短信获取验证码
        }
        WlyyHospitalSysDictDO wlyyHospitalSysDictDO = wlyyHospitalSysDictDao.findById("isNeedSMS").orElse(null);
        if (wlyyHospitalSysDictDO!=null&&!StringUtils.isEmpty(wlyyHospitalSysDictDO.getDictValue())){
            String captcha = wlyyHospitalSysDictDO.getDictValue();
            this.store(client_id, phoneNum, captcha, 120);
            mixEnvelop.setMessage("验证码发送成功");
        }else {
            String captcha = this.getCodeNumber();
            System.out.println("=====================当前短信验证码============="+captcha+"=====================");
            System.out.println("发送中山验证码开始");
            int result = 1;
            result = zhongShanSMSService.ZhongShangSendSMS(phoneNum, "您好，您当前操作的验证码是：" + captcha + "，2分钟内有效。如非本人操作，请忽略");
            if (0 == result) {
                this.store(client_id, phoneNum, captcha, 120);
                mixEnvelop.setMessage("验证码发送成功");
            } else {
                mixEnvelop.setMessage("验证码发送失败");
                mixEnvelop.setStatus(500);
            }
        }
        return mixEnvelop;
    }

    public void store(String client_id, String username, String code, int expire) {
        String key = client_id + ":" + username + KEY_SUFFIX;
        redisTemplate.opsForValue().set(key, code);
        redisTemplate.expire(key, expire, TimeUnit.SECONDS);
        String intervalKey = key + ":" + code + "_interval";
        redisTemplate.opsForValue().set(intervalKey, 60);
        redisTemplate.expire(intervalKey, 60, TimeUnit.SECONDS);
    }

    public boolean isIntervalTimeout(String client_id, String username) {
        String key = client_id + ":" + username + KEY_SUFFIX;
        String code = (String) redisTemplate.opsForValue().get(key);
        if (null == code) {
            return true;
        }
        String intervalKey = key + ":" + code + "_interval";
        if (redisTemplate.opsForValue().get(intervalKey) != null) {
            return false;
        }
        return true;
    }

    //生成6位随机数
    public String getCodeNumber() {
        return (int) ((Math.random() * 9 + 1) * 100000) + "";
    }

    //验证验证码
    public boolean verification(String client_id, String username, String code) {
        WlyyHospitalSysDictDO wlyyHospitalSysDictDO = wlyyHospitalSysDictDao.findById("isNeedSMS").orElse(null);
        if (wlyyHospitalSysDictDO!=null&&!StringUtils.isEmpty(wlyyHospitalSysDictDO.getDictValue())){
            if (code.equalsIgnoreCase(wlyyHospitalSysDictDO.getDictValue())){
                return true;
            }else {
                return false;
            }
        }
        if (StringUtils.isEmpty(code)) {
            return false;
        }
        String key = client_id + ":" + username + KEY_SUFFIX;
        String _code = (String) redisTemplate.opsForValue().get(key);
        if (null == _code) {
            return false;
        }
        if (code.equalsIgnoreCase(_code)) {
            return true;
        }
        return false;
    }

    @ApiOperation("保存家人关系")
    @PostMapping(value = BaseHospitalRequestMapping.WlyyFamilyMember.saveFamilyRelation)
    public MixEnvelop saveFamilyRelation(@ApiParam(name = "jsonData", value = "jsonData", required = false)
                                         @RequestParam(value = "jsonData", required = false) String jsonData) {
        MixEnvelop mixEnvelop = new MixEnvelop();
        try {
            JSONObject jsonObject = JSONObject.parseObject(jsonData);
            String client_id = jsonObject.getString("client_id");
            String username = jsonObject.getString("phoneNum");
            String code = jsonObject.getString("code");
            String medicareType = jsonObject.getString("medicareType");
            String medicare = jsonObject.getString("medicare");
            String clinicId = jsonObject.getString("clinicId");
            boolean checkCode =false;
            if(!StringUtils.isEmpty(code)){
                checkCode = this.verification(client_id, username, code);
            }else if(StringUtils.isEmpty(code)&&StringUtils.isEmpty(client_id)) {
                checkCode = true;
            }
            if (checkCode) {
                String patientId = jsonObject.getString("patientId");
                String familyName = jsonObject.getString("familyName");
                String dictId = jsonObject.getString("dictId");
                String cardType = jsonObject.getString("cardType");
                String idCard = jsonObject.getString("idCard");
                //家人关系只允许添加一次自己
                if (null == jsonObject.get("id")&&!StringUtils.isEmpty(dictId)&&"7".equalsIgnoreCase(dictId)){
                    List<WlyyPatientFamilyMemberDO> list = wlyyPatientFamilyMemberDao.findByPatientAndFamilyRelation(patientId,dictId);
                    if (null!=list&&list.size()>0){
                        mixEnvelop.setStatus(408);
                        mixEnvelop.setMessage("您已经添加自己的信息请勿重复添加");
                        return mixEnvelop;
                    }
                }
                String id = "";
                if (null != jsonObject.get("id")) {
                    id = jsonObject.get("id").toString();
                }
                //获取建档信息
                if ("xm_ykyy_wx".equalsIgnoreCase(wxId)){

                    mixEnvelop = wlyyFamilyMemberService.addFamily(id, patientId, familyName, dictId, cardType, idCard, username, false, medicareType, medicare, clinicId);
                    if (mixEnvelop!=null){
                        if(mixEnvelop.getStatus() == 200) {
                            JSONObject jdObject = ykyyEntranceService.patientJDKH(idCard,familyName,username,medicare,clinicId);
                            if (jdObject.getInteger("status")!=200){
                                mixEnvelop.setStatus(410);
                                mixEnvelop.setMessage(jdObject.getString("message"));
                                return mixEnvelop;
                            }
                        }else {
                            if (mixEnvelop.getStatus()==409){
                                if (medicare==null||medicare==""){
                                    mixEnvelop.setStatus(408);
                                    mixEnvelop.setMessage("社保卡号为空无法建档！请核对社保卡号！");
                                    return mixEnvelop;
                                }
                                JSONObject jdObject = ykyyEntranceService.patientJDKH(idCard,familyName,username,medicare,clinicId);
                                if (jdObject.getInteger("status")!=200){
                                    mixEnvelop.setStatus(410);
                                    mixEnvelop.setMessage(jdObject.getString("message"));
                                    return mixEnvelop;
                                }else {
                                    mixEnvelop = wlyyFamilyMemberService.addFamily(id, patientId, familyName, dictId, cardType, idCard, username, false, medicareType, medicare, clinicId);
                                }
                            }
                            return mixEnvelop;
                        }
                    }
                }else {
                    mixEnvelop = wlyyFamilyMemberService.addFamily(id, patientId, familyName, dictId, cardType, idCard, username, false, medicareType, medicare, clinicId);
                }

            } else {
                mixEnvelop.setStatus(408);
                mixEnvelop.setMessage("验证码不正确");
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return mixEnvelop;
    }

    @ApiOperation("核酸待预约保存家人关系")
    @PostMapping(value = BaseHospitalRequestMapping.WlyyFamilyMember.saveNatFamilyRelation)
    public MixEnvelop saveNatFamilyRelation(@ApiParam(name = "jsonData", value = "jsonData", required = false)
                                         @RequestParam(value = "jsonData", required = false) String jsonData) {
        MixEnvelop mixEnvelop = new MixEnvelop();
        try {
            JSONObject jsonObject = JSONObject.parseObject(jsonData);
            String client_id = jsonObject.getString("client_id");
            String username = jsonObject.getString("phoneNum");
            String code = jsonObject.getString("code");
            String medicareType = jsonObject.getString("medicareType");
            String medicare = jsonObject.getString("medicare");
            String clinicId = jsonObject.getString("clinicId");
            String idtype = jsonObject.getString("idtype");
            String idtypeName = jsonObject.getString("idtypeName");
            String sex = jsonObject.getString("sex");
            String age = jsonObject.getString("age");
            String birth = jsonObject.getString("birth");
            boolean checkCode =false;
            if(!StringUtils.isEmpty(code)){
                checkCode = this.verification(client_id, username, code);
            }else if(StringUtils.isEmpty(code)&&StringUtils.isEmpty(client_id)) {
                checkCode = true;
            }
            if (checkCode) {
                String patientId = jsonObject.getString("patientId");
                String familyName = jsonObject.getString("familyName");
                String dictId = jsonObject.getString("dictId");
                String cardType = jsonObject.getString("cardType");
                String idCard = jsonObject.getString("idCard");
                //家人关系只允许添加一次自己
                if (null == jsonObject.get("id")&&!StringUtils.isEmpty(dictId)&&"7".equalsIgnoreCase(dictId)){
                    List<BaseNatPatientFamilyMemberDO> list = natPatientFamilyMemberDao.findbyPatientAndFamilyRelation(patientId,dictId);
                    if (null!=list&&list.size()>0){
                        mixEnvelop.setStatus(408);
                        mixEnvelop.setMessage("您已经添加自己的信息请勿重复添加");
                        return mixEnvelop;
                    }
                }

                mixEnvelop = wlyyFamilyMemberService.addNatFamily(patientId, familyName, dictId, cardType, idCard, username, false, medicareType, medicare, clinicId,idtype,idtypeName,sex,age,birth);

            } else {
                mixEnvelop.setStatus(408);
                mixEnvelop.setMessage("验证码不正确");
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return mixEnvelop;
    }

    @ApiOperation("核酸查询就诊人")
    @PostMapping(value = BaseHospitalRequestMapping.WlyyFamilyMember.findNatFamilyMumber)
    public Envelop findNatFamilyMumber(@ApiParam(name = "patientId", value = "patientId", required = false)
                                               @RequestParam(value = "patientId", required = false) String patientId) {

        try {
            List<BaseNatPatientFamilyMemberDO> list = new ArrayList<>();
            try {
                list = wlyyFamilyMemberService.selectByPatientId(patientId);
            } catch (Exception e) {
                e.printStackTrace();
            }
            return success(list);
        }catch (Exception e){
            return failedException(e);
        }
    }

    @ApiOperation("核酸查询单个就诊人")
    @PostMapping(value = BaseHospitalRequestMapping.WlyyFamilyMember.findNatFamilyMumberById)
    public Envelop findNatFamilyMumberById(@ApiParam(name = "id", value = "id", required = false)
                                       @RequestParam(value = "id", required = false) String id) {

        try {
            return success(wlyyFamilyMemberService.selectByFamilyId(id));
        }catch (Exception e){
            return failedException(e);
        }
    }

    @ApiOperation("删除家庭关系")
    @PostMapping(value = BaseHospitalRequestMapping.WlyyFamilyMember.delNatFamilyMumber)
    public Envelop delNatFamilyMumber(@ApiParam(name = "id", value = "家庭关系id", required = false)
                                       @RequestParam(value = "id", required = false) String id) {
        try {
            return success(wlyyFamilyMemberService.deleteMember(id));
        }catch (Exception e){
            return failedException(e);
        }
    }


    @ApiOperation("预约挂号时保存家人关系")
    @PostMapping(value = BaseHospitalRequestMapping.WlyyFamilyMember.saveFamilyRelationAppoint)
    public MixEnvelop saveFamilyRelationAppoint(@ApiParam(name = "jsonData", value = "jsonData", required = false)
                                         @RequestParam(value = "jsonData", required = false) String jsonData) {
        MixEnvelop mixEnvelop = new MixEnvelop();
        try {
            JSONObject jsonObject = JSONObject.parseObject(jsonData);
            String client_id = jsonObject.getString("client_id");
            String username = jsonObject.getString("phoneNum");
            String code = jsonObject.getString("code");
            String medicareType = jsonObject.getString("medicareType");
            String medicare = jsonObject.getString("medicare");
            String clinicId = jsonObject.getString("clinicId");
            boolean checkCode =false;
            if(!StringUtils.isEmpty(code)){
                checkCode = this.verification(client_id, username, code);
            }else if(StringUtils.isEmpty(code)&&StringUtils.isEmpty(client_id)) {
                checkCode = true;
            }
            if (checkCode) {
                String patientId = jsonObject.getString("patientId");
                String familyName = jsonObject.getString("familyName");
                String dictId = jsonObject.getString("dictId");
                String cardType = jsonObject.getString("cardType");
                String idCard = jsonObject.getString("idCard");
                //家人关系只允许添加一次自己
                if (null == jsonObject.get("id")&&!StringUtils.isEmpty(dictId)&&"7".equalsIgnoreCase(dictId)){
                    List<WlyyPatientFamilyMemberDO> list = wlyyPatientFamilyMemberDao.findByPatientAndFamilyRelation(patientId,dictId);
                    if (null!=list&&list.size()>0){
                        mixEnvelop.setStatus(408);
                        mixEnvelop.setMessage("您已经添加自己的信息请勿重复添加");
                        return mixEnvelop;
                    }
                }
                String id = "";
                if (null != jsonObject.get("id")) {
                    id = jsonObject.get("id").toString();
                }
                //获取建档信息
                if ("xm_ykyy_wx".equalsIgnoreCase(wxId)) {

                    mixEnvelop = wlyyFamilyMemberService.addFamilyAppoint(id, patientId, familyName, dictId, cardType, idCard, username, false, medicareType, medicare, clinicId);
                }

            } else {
                mixEnvelop.setStatus(408);
                mixEnvelop.setMessage("验证码不正确");
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return mixEnvelop;
    }

    @ApiOperation("查询就诊人")
    @PostMapping(value = BaseHospitalRequestMapping.WlyyFamilyMember.findFamilyMumber)
    public Envelop findFamilyMumberByPatientId(@ApiParam(name = "patientId", value = "patientId", required = false)
                                               @RequestParam(value = "patientId", required = false) String patientId) {

        try {
            List<Map<String, Object>> list = new ArrayList<>();
            try {
                list = wlyyFamilyMemberService.findFamilyByPatientId(patientId);
            } catch (ParseException e) {
                e.printStackTrace();
            }
            return success(list);
        }catch (Exception e){
            return failedException(e);
        }
    }

    @ApiOperation("删除就诊人")
    @PostMapping(value = BaseHospitalRequestMapping.WlyyFamilyMember.delFamilyMumber)
    public Envelop delFamilyMumber(@ApiParam(name = "id", value = "id", required = false)
                                   @RequestParam(value = "id", required = false) String id) {

        try {
            return wlyyFamilyMemberService.delMember(id);
        }catch (Exception e){
            return failedException(e);
        }
    }

    @ApiOperation("获取单个亲属信息")
    @PostMapping(value = BaseHospitalRequestMapping.WlyyFamilyMember.findSingleMember)
    public Envelop findSingleMember(@ApiParam(name = "id", value = "id", required = false)
                                    @RequestParam(value = "id", required = false) String id) throws Exception {

        try {
            return success(wlyyFamilyMemberService.findMemberById(id));
        }catch (Exception e){
            return failedException(e);
        }
    }
    public boolean verifyCaptcha(String key,String text){
        boolean pass = false;
        String captcha = redisTemplate.opsForValue().get(key).toString();
        if (org.apache.commons.lang3.StringUtils.isNotBlank(captcha)&& captcha.equals(text.toLowerCase())){
            pass = true;
            redisTemplate.delete(key);
        }
        return pass;
    }
}