package com.yihu.jw.hospital.endpoint.inpatient;

import com.yihu.jw.inpatient.service.BaseInpatientRegistrationService;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.ObjEnvelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * Created by yeshijie on 2022/12/5.
 */
@RestController
@RequestMapping(value ="/doctor/inpatientRegistration")
@Api(value = "医生端-住院登记",  tags = {"医生端-住院登记"})
public class DoctorInpatientRegistrationEndpoint extends EnvelopRestEndpoint {

    @Autowired
    private BaseInpatientRegistrationService inpatientRegistrationService;

    @GetMapping(value= "page")
    @ApiOperation("历史住院登记记录")
    public Envelop page(@ApiParam(name = "name", value = "姓名或者身份证", required = false)
                        @RequestParam(value = "name", required = false)String name,
                        @ApiParam(name = "page", value = "第几页，从1开始", required = true, defaultValue = "1")
                        @RequestParam(value = "page", required = true,defaultValue = "1")Integer page,
                        @ApiParam(name = "size", value = "每页分页大小", required = true, defaultValue = "10")
                        @RequestParam(value = "size", required = true,defaultValue = "10")Integer size){

        try {
            return inpatientRegistrationService.page(null,name,null,null,page,size);
        }catch (Exception e){
            return failedException2(e);
        }
    }

    @PostMapping(value= "registration")
    @ApiOperation("入院登记")
    public Envelop registration(@ApiParam(name = "id", value = "id", required = true)
                                @RequestParam(value = "id", required = true)String id,
                                @ApiParam(name = "inpatientTime", value = "入院时间", required = true)
                                @RequestParam(value = "inpatientTime", required = true) String inpatientTime,
                                @ApiParam(name = "bedNo", value = "床位号", required = true)
                                @RequestParam(value = "bedNo", required = true)String bedNo,
                                @ApiParam(name = "attendingDoctor", value = "主治医师id", required = true)
                                @RequestParam(value = "attendingDoctor", required = true)String attendingDoctor,
                                @ApiParam(name = "attendingDoctorName", value = "主治医师", required = true)
                                @RequestParam(value = "attendingDoctorName", required = true)String attendingDoctorName,
                                @ApiParam(name = "inpatientAreaId", value = "病区id", required = true)
                                @RequestParam(value = "inpatientAreaId", required = true)String inpatientAreaId,
                                @ApiParam(name = "inpatientAreaName", value = "病区名称", required = true)
                                @RequestParam(value = "inpatientAreaName", required = true)String inpatientAreaName){

        try {
            return ObjEnvelop.getSuccess("提交成功",inpatientRegistrationService.registration(id,inpatientTime,bedNo
                    ,attendingDoctor,attendingDoctorName,inpatientAreaId,inpatientAreaName));
        }catch (Exception e){
            return failedException2(e);
        }
    }

    @PostMapping(value= "confirmAdmission")
    @ApiOperation("确认入院")
    public Envelop confirmAdmission(@ApiParam(name = "id", value = "id", required = true)
                                @RequestParam(value = "id", required = true)String id){

        try {
            return ObjEnvelop.getSuccess("提交成功",inpatientRegistrationService.confirmAdmission(id));
        }catch (Exception e){
            return failedException2(e);
        }
    }

}
