package com.yihu.jw.hospital.endpoint.inpatient;

import com.yihu.jw.contant.CommonContant;
import com.yihu.jw.inpatient.service.BaseInpatientRegistrationService;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.ListEnvelop;
import com.yihu.jw.restmodel.web.ObjEnvelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * Created by yeshijie on 2022/12/5.
 */
@RestController
@RequestMapping(value ="/patient/inpatientRegistration")
@Api(value = "居民端-住院登记", tags = {"居民端-住院登记"})
public class PatientInpatientRegistrationEndpoint extends EnvelopRestEndpoint {

    @Autowired
    private BaseInpatientRegistrationService inpatientRegistrationService;

    @GetMapping(value= "list")
    @ApiOperation("住院登记记录-未提交记录")
    public Envelop list(@ApiParam(name = "patient", value = "patient", required = true)
                        @RequestParam(value = "patient", required = true)String patient){

        try {
            return ListEnvelop.getSuccess(CommonContant.Message.GET_SUCCESS,inpatientRegistrationService.list(patient));
        }catch (Exception e){
            return failedException2(e);
        }
    }

    @GetMapping(value= "findDetail")
    @ApiOperation("住院登记记录")
    public Envelop findDetail(@ApiParam(name = "id", value = "id", required = true)
                        @RequestParam(value = "id", required = true)String id){

        try {
            return ObjEnvelop.getSuccess(CommonContant.Message.GET_SUCCESS,inpatientRegistrationService.findDetail(id));
        }catch (Exception e){
            return failedException2(e);
        }
    }

    @GetMapping(value= "page")
    @ApiOperation("历史住院登记记录")
    public Envelop page(@ApiParam(name = "patient", value = "patient", required = true)
                        @RequestParam(value = "patient", required = true)String patient,
                        @ApiParam(name = "page", value = "第几页，从1开始", required = true, defaultValue = "1")
                        @RequestParam(value = "page", required = true,defaultValue = "1")Integer page,
                        @ApiParam(name = "size", value = "每页分页大小", required = true, defaultValue = "10")
                        @RequestParam(value = "size", required = true,defaultValue = "10")Integer size){

        try {
            return inpatientRegistrationService.page(patient,null,null,null,page,size);
        }catch (Exception e){
            return failedException2(e);
        }
    }

    @PostMapping(value= "submitRegist")
    @ApiOperation("提交住院登记")
    public Envelop submitRegist(@ApiParam(name = "id", value = "id", required = true)
                        @RequestParam(value = "id", required = true)String id,
                        @ApiParam(name = "mobile", value = "患者手机", required = true)
                        @RequestParam(value = "mobile", required = true) String mobile,
                        @ApiParam(name = "address", value = "住院地址", required = true)
                        @RequestParam(value = "address", required = true)String address,
                        @ApiParam(name = "contacts", value = "联系人", required = true)
                        @RequestParam(value = "contacts", required = true)String contacts,
                        @ApiParam(name = "contactsMobile", value = "联系人手机", required = true)
                        @RequestParam(value = "contactsMobile", required = true)String contactsMobile){

        try {
            return ObjEnvelop.getSuccess("提交成功",inpatientRegistrationService.submitRegist(id,mobile,address,contacts,contactsMobile));
        }catch (Exception e){
            return failedException2(e);
        }
    }
}
