package com.yihu.jw.hospital.endpoint.knowledge;


import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.yihu.jw.entity.knowledge.BaseSystemDialogSetting;
import com.yihu.jw.knowledge.service.BaseSystemDialogSettingService;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import com.yihu.jw.rm.hospital.BaseHospitalRequestMapping;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;
import java.util.List;


@RestController
@RequestMapping(value = BaseHospitalRequestMapping.BaseSystemDialogSetting.PREFIX)
@Api(value = "系统会话配置", description = "系统会话配置", tags = {"系统会话配置"})
public class BaseSystemDialogSettingController extends EnvelopRestEndpoint {

    @Autowired
    private BaseSystemDialogSettingService dialogSettingService;

    @ApiOperation("新增/更新系统会话设置")
    @PostMapping(value= BaseHospitalRequestMapping.BaseSystemDialogSetting.insterAndUpdateSystemDialogSetting)
    public Envelop insertAndUpdateDict(@ApiParam(name = "json", value = "系统会话设置实体json", required = true)
                                   @RequestParam(value = "json", required = true)String json){

        try {
            JSONArray array = JSONArray.parseArray(json);
            List<BaseSystemDialogSetting> dialogSettings = new ArrayList<>();
            for (int i=0;i<array.size();i++){
                JSONObject object = array.getJSONObject(i);
                BaseSystemDialogSetting dialogSetting = toEntity(object.toJSONString(), BaseSystemDialogSetting.class);
                dialogSettings.add(dialogSetting);
            }

            return success(dialogSettingService.insterAndUpdateSystemDialogSetting(dialogSettings));
        }catch (Exception e){
            return failedException(e);
        }
    }


    @ApiOperation("根据不同业务code查询相关的系统会话设置配置信息")
    @GetMapping(value= BaseHospitalRequestMapping.BaseKnowledgeDict.selectById)
    public Envelop selectById(@ApiParam(name = "systemType", value = "系统业务编码", required = true)
                              @RequestParam(value = "systemType", required = true)String systemType){

        try {
            return success(dialogSettingService.selectBySystemType(systemType));
        }catch (Exception e){
            return failedException(e);
        }
    }

}