package com.yihu.jw.hospital.endpoint.message;

import com.alibaba.fastjson.JSONObject;
import com.yihu.jw.hospital.message.service.BaseUserMsgService;
import com.yihu.jw.hospital.message.service.UserMsgContentService;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.ObjEnvelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import com.yihu.jw.rm.hospital.BaseHospitalRequestMapping;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.print.Doc;
import java.io.IOException;
import java.text.ParseException;
import java.util.List;
import java.util.Map;

@RestController
@RequestMapping(value = BaseHospitalRequestMapping.UserMessage.userMessage)
@Api(value = "评论管理接口", description = "评论管理接口", tags = {"互联网医院 - 评论管理接口"})
public class BaseUserMsgController extends EnvelopRestEndpoint {
    @Autowired
    private BaseUserMsgService baseUserMsgService;
    @Autowired
    private UserMsgContentService userMsgContentService;
    @ApiOperation("回复留言")
    @PostMapping(value= BaseHospitalRequestMapping.UserMessage.responseMessage)
    public Envelop responseMessage(@ApiParam(name = "reciverId", value = "reciverId", required = false)
                                       @RequestParam(value = "reciverId", required = false)String reciverId,
                                   @ApiParam(name = "content", value = "content", required = false)
                                       @RequestParam(value = "content", required = false)String content,
                                   @ApiParam(name = "contentId", value = "contentId", required = false)
                                       @RequestParam(value = "contentId", required = false)String  contentId,
                                   @ApiParam(name = "isDoctor", value = "isDoctor", required = false)
                                       @RequestParam(value = "isDoctor", required = false)Integer  isDoctor){

        try {
            String patient = getUID();
            System.out.println("patient"+patient);
            baseUserMsgService.responseMessage(contentId,content,reciverId,patient,isDoctor);
            return success("回复成功" );
        }catch (Exception e){
            return failedException(e);
        }
    }
    @ApiOperation("自身评论")
    @PostMapping(value= BaseHospitalRequestMapping.UserMessage.leaveMessage)
    public ObjEnvelop leaveMessage(@ApiParam(name = "reciverId", value = "reciverId", required = false)
                              @RequestParam(value = "reciverId", required = false)String reciverId,
                                   @ApiParam(name = "reciverName", value = "reciverName", required = false)
                              @RequestParam(value = "reciverName", required = false)String reciverName,
                                   @ApiParam(name = "content", value = "content", required = false)
                              @RequestParam(value = "content", required = false)String content,
                                   @ApiParam(name = "type", value = "type", required = false)
                                    @RequestParam(value = "type", required = false)Integer type,
                                   @ApiParam(name = "key", value = "key", required = false)
                                    @RequestParam(value = "key", required = false)String key,
                                   @ApiParam(name = "value", value = "value", required = false)
                                    @RequestParam(value = "value", required = false)String value
                              ) throws IOException {

        try {
            String senderId = getUID();
            System.out.println("senderId"+senderId);
            //String senderName = getUNAME();
            ObjEnvelop objEnvelop = new ObjEnvelop();
            objEnvelop= baseUserMsgService.leaveMessage(content,reciverId,reciverName,senderId,type,key,value);
            return objEnvelop;
        }catch (Exception e){
            return failedObjEnvelopException(e);
        }
}
    @ApiOperation("医生评论展示")
    @PostMapping(value= BaseHospitalRequestMapping.UserMessage.showMessage)
    public Envelop showMessage(@ApiParam(name = "doctor", value = "doctor", required = false)
                                   @RequestParam(value = "doctor", required = false)String doctor,
                               @ApiParam(name = "showAll", value = "showAll", required = false)
                               @RequestParam(value = "showAll", required = false)String showAll,
                               @ApiParam(name = "showAllType", value = "showAllType", required = false)
                                   @RequestParam(value = "showAllType", required = false)String showAllType,
                               @ApiParam(name = "beginTime", value = "beginTime", required = false)
                                   @RequestParam(value = "beginTime", required = false)String beginTime,
                               @ApiParam(name = "endTime", value = "endTime", required = false)
                                   @RequestParam(value = "endTime", required = false)String endTime,
                               @ApiParam(name = "patient", value = "patient", required = false)
                                   @RequestParam(value = "patient", required = false)String patient,
                                           @ApiParam(name = "page", value = "第几页，从1开始", required = true, defaultValue = "1")
                                           @RequestParam(value = "page", required = true,defaultValue = "1")Integer page,
                               @ApiParam(name = "pageSize", value = "每页分页大小", required = true, defaultValue = "10")
                                   @RequestParam(value = "pageSize", required = true,defaultValue = "10")Integer pageSize,
                               @ApiParam(name = "isShow", value = "是否显示（1显示0不显示）", required = false)
                                   @RequestParam(value = "isShow", required = false)Integer isShow){
        try {
            return baseUserMsgService.getMessage(doctor,showAll,showAllType,beginTime,endTime,patient,page,pageSize,isShow);
        }catch (Exception e){
            return failedException(e);
        }
    }


    @ApiOperation("修改留言是否展示")
    @PostMapping(value= BaseHospitalRequestMapping.UserMessage.updateIsShow)
    public Envelop updateIsShow(@ApiParam(name = "id", value = "id", required = false)
                               @RequestParam(value = "id", required = false)String id,
                               @ApiParam(name = "isShow", value = "isShow", required = false)
                               @RequestParam(value = "isShow", required = false)Integer isShow){
        try {
            return success(baseUserMsgService.updateIsShow(id,isShow));
        }catch (Exception e){
            return failedException(e);
        }
    }

    @ApiOperation("医生评论展示")
    @PostMapping(value= BaseHospitalRequestMapping.UserMessage.getSingleMessage)
    public Envelop getSingleMessage(@ApiParam(name = "id", value = "id", required = false)
                               @RequestParam(value = "id", required = false)String id){

        try {
            List<Map<String,Object>> list = baseUserMsgService.getSingle(id);
            if (list.size()>=0){
                return success(list);
            }else {
                return failed("查询失败");
            }
        }catch (Exception e){
            return failedException(e);
        }
    }
    @ApiOperation("在线复诊")
    @PostMapping(value= BaseHospitalRequestMapping.UserMessage.onlineVisitMessage)
    public Envelop onlineVisitMessage(@ApiParam(name = "reciverId", value = "reciverId", required = false)
                                   @RequestParam(value = "reciverId", required = false)String reciverId,
                                   @ApiParam(name = "reciverName", value = "reciverName", required = false)
                                   @RequestParam(value = "reciverName", required = false)String reciverName,
                                   @ApiParam(name = "content", value = "content", required = false)
                                   @RequestParam(value = "content", required = false)String content,
                                   @ApiParam(name = "relationCode", value = "relationCode", required = false)
                                   @RequestParam(value = "relationCode", required = false)String relationCode){

        try {
            String senderId = getUID();
            String senderName = getUNAME();
            baseUserMsgService.onlineVisitMessage(content,reciverId,reciverName,senderId,senderName,relationCode);
            return success("留言成功" );
        }catch (Exception e){
            return failedException(e);
        }
    }
    @ApiOperation("专家咨询")
    @PostMapping(value= BaseHospitalRequestMapping.UserMessage.expertMessage)
    public Envelop expertMessage(@ApiParam(name = "reciverId", value = "reciverId", required = false)
                                   @RequestParam(value = "reciverId", required = false)String reciverId,
                                   @ApiParam(name = "reciverName", value = "reciverName", required = false)
                                   @RequestParam(value = "reciverName", required = false)String reciverName,
                                   @ApiParam(name = "content", value = "content", required = false)
                                   @RequestParam(value = "content", required = false)String content,
                                   @ApiParam(name = "relationCode", value = "relationCode", required = false)
                                   @RequestParam(value = "relationCode", required = false)String relationCode){

        try {
            String senderId = getUID();
            String senderName = getUNAME();
            baseUserMsgService.expertMessage(content,reciverId,reciverName,senderId,senderName,relationCode);
            return success("留言成功" );
        }catch (Exception e){
            return failedException(e);
        }
    }
    @ApiOperation("获取评论")
    @PostMapping(value= BaseHospitalRequestMapping.UserMessage.getMessage)
    public Envelop getMessage(
                                 @ApiParam(name = "relationCode", value = "relationCode", required = false)
                                 @RequestParam(value = "relationCode", required = false)String relationCode){


        try {
            return success(userMsgContentService.getAllMessage(relationCode));
        }catch (Exception e){
            return failedException(e);
        }
    }
    @ApiOperation("获取评分")
    @PostMapping(value= BaseHospitalRequestMapping.UserMessage.getPoint)
    public Envelop getPoint(
            @ApiParam(name = "doctor", value = "doctor", required = false)
            @RequestParam(value = "doctor", required = false)String doctor){


        try {
            return success(userMsgContentService.countPoint(doctor));
        }catch (Exception e){
            return failedException(e);
        }
    }



    @ApiOperation("医生评论展示")
    @PostMapping(value= BaseHospitalRequestMapping.UserMessage.showDoctorMessage)
    public Envelop showDoctorMessage(@ApiParam(name = "doctor", value = "doctor", required = false)
                               @RequestParam(value = "doctor", required = false)String doctor,
                               @ApiParam(name = "page", value = "第几页，从1开始", required = true, defaultValue = "1")
                               @RequestParam(value = "page", required = true,defaultValue = "1")Integer page,
                               @ApiParam(name = "pageSize", value = "每页分页大小", required = true, defaultValue = "10")
                               @RequestParam(value = "pageSize", required = true,defaultValue = "10")Integer pageSize) throws ParseException {

        try {
            JSONObject jsonObject=userMsgContentService.showContentByDoctor(doctor,page,pageSize);
            return success(jsonObject);
        }catch (Exception e){
            return failedException(e);
        }
    }

    @ApiOperation("医生评论删除")
    @GetMapping("/deleteMessage")
    public Envelop deleteMessage(@ApiParam(name = "msgId", value = "msgId", required = false)
                                     @RequestParam(value = "msgId", required = false)String msgId,
                                     @ApiParam(name = "isDelParent", value = "isDelParent", required = false)
                                     @RequestParam(value = "isDelParent", required = false)String isDelParent) throws ParseException {

        try {
            baseUserMsgService.deleteMessageOrMessageContent(msgId,isDelParent);
            return success("操作成功");
        }catch (Exception e){
            return failedException(e);
        }
    }
}
