package com.yihu.jw.hospital.endpoint.patient;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.yihu.jw.article.dao.KnowledgeArticleUserDao;
import com.yihu.jw.contant.CommonContant;
import com.yihu.jw.dict.service.BaseDictJobTitleService;
import com.yihu.jw.dict.service.HospitalDeptService;
import com.yihu.jw.doctor.dao.BaseDoctorDao;
import com.yihu.jw.doctor.dao.BaseDoctorHospitalDao;
import com.yihu.jw.doctor.service.BaseDoctorInfoService;
import com.yihu.jw.entity.base.dict.DictHospitalDeptDO;
import com.yihu.jw.entity.base.dict.DictJobTitleDO;
import com.yihu.jw.entity.base.doctor.BaseDoctorDO;
import com.yihu.jw.entity.base.doctor.BaseDoctorHospitalDO;
import com.yihu.jw.entity.base.im.ConsultDo;
import com.yihu.jw.entity.base.im.ConsultTeamDo;
import com.yihu.jw.entity.base.patient.BasePatientDO;
import com.yihu.jw.entity.base.wx.BasePatientWechatDo;
import com.yihu.jw.entity.base.wx.WxWechatDO;
import com.yihu.jw.entity.hospital.article.KnowledgeArticleDO;
import com.yihu.jw.entity.hospital.article.KnowledgeArticleUserDO;
import com.yihu.jw.entity.hospital.consult.WlyyHospitalSysDictDO;
import com.yihu.jw.entity.hospital.enterprise.WxEnterpriseDO;
import com.yihu.jw.entity.hospital.healthCare.YlzMedicalRelationDO;
import com.yihu.jw.entity.hospital.httplog.WlyyHttpLogDO;
import com.yihu.jw.entity.hospital.message.SystemMessageDO;
import com.yihu.jw.entity.hospital.prescription.*;
import com.yihu.jw.entity.order.BusinessOrderDO;
import com.yihu.jw.entity.third.ylzinfo.OauthYlzConfigDO;
import com.yihu.jw.es.service.StatisticsEsService;
import com.yihu.jw.es.service.yqfk.YqfkService;
import com.yihu.jw.file_upload.FileUploadService;
import com.yihu.jw.healthUpload.service.BaseDoctorHealthUploadService;
import com.yihu.jw.hospital.dao.consult.KnowledgeArticleDao;
import com.yihu.jw.hospital.dict.WlyyHospitalSysDictDao;
import com.yihu.jw.hospital.healthCare.YlzMedicailRelationDao;
import com.yihu.jw.hospital.httplog.dao.WlyyHttpLogDao;
import com.yihu.jw.hospital.httplog.service.WlyyHttpLogService;
import com.yihu.jw.hospital.message.service.BaseBannerDoctorService;
import com.yihu.jw.hospital.message.service.BaseUserMsgService;
import com.yihu.jw.hospital.message.service.SystemMessageService;
import com.yihu.jw.hospital.prescription.dao.*;
import com.yihu.jw.hospital.prescription.service.*;
import com.yihu.jw.hospital.prescription.service.entrance.EntranceService;
import com.yihu.jw.hospital.prescription.service.entrance.HcyyEntranceService;
import com.yihu.jw.hospital.prescription.service.entrance.YkyyEntranceService;
import com.yihu.jw.hospital.service.SystemMessage.HospitalSystemMessageService;
import com.yihu.jw.hospital.service.consult.KnowledgeArticleService;
import com.yihu.jw.hospital.service.consult.KnowledgeCategoryService;
import com.yihu.jw.hospital.service.consult.QrcodeService;
import com.yihu.jw.hospital.service.consult.SysDictService;
import com.yihu.jw.im.dao.ConsultDao;
import com.yihu.jw.im.dao.ConsultTeamDao;
import com.yihu.jw.im.service.ImService;
import com.yihu.jw.order.BusinessOrderService;
import com.yihu.jw.order.dao.BusinessOrderDao;
import com.yihu.jw.order.pay.utils.PayLogService;
import com.yihu.jw.order.pay.ylz.YlzPayService;
import com.yihu.jw.patient.dao.BasePatientDao;
import com.yihu.jw.restmodel.hospital.prescription.WlyyPrescriptionInfoVO;
import com.yihu.jw.restmodel.hospital.prescription.WlyyPrescriptionVO;
import com.yihu.jw.restmodel.iot.common.UploadVO;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.ListEnvelop;
import com.yihu.jw.restmodel.web.MixEnvelop;
import com.yihu.jw.restmodel.web.ObjEnvelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import com.yihu.jw.rm.hospital.BaseHospitalRequestMapping;
import com.yihu.jw.rm.patient.PatientRequestMapping;
import com.yihu.jw.sms.service.YkyyINSMSService;
import com.yihu.jw.util.common.FileUtil;
import com.yihu.jw.util.common.XMLUtil;
import com.yihu.jw.util.date.DateUtil;
import com.yihu.jw.wechat.dao.BasePatientWechatDao;
import com.yihu.jw.wechat.dao.WechatDao;
import com.yihu.jw.wechat.enterprise.EnterpriseService;
import com.yihu.jw.wechat.enterprise.dao.WxEnterpriseDao;
import com.yihu.jw.wechat.service.WechatInfoService;
import com.yihu.jw.wlyy.wlyyhttp.WlyyHttpService;
import com.ylzinfo.onepay.sdk.OnepayClient;
import com.ylzinfo.onepay.sdk.OnepayDefaultClient;
import com.ylzinfo.onepay.sdk.domain.ResponseParams;
import com.ylzinfo.onepay.sdk.domain.WebHook;
import com.ylzinfo.onepay.sdk.domain.ext.WaitPayDetailVO;
import com.ylzinfo.onepay.sdk.exception.PayException;
import com.ylzinfo.onepay.sdk.utils.SecurityUtil;
import com.ylzinfo.onepay.sdk.utils.StringUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import net.sf.json.JSONArray;
import net.sf.json.xml.XMLSerializer;
import org.apache.axis.utils.StringUtils;
import org.apache.commons.collections.map.HashedMap;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.util.StreamUtils;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.URLEncoder;
import java.nio.charset.Charset;
import java.util.*;
import java.util.concurrent.TimeUnit;

import static com.yihu.jw.utils.sfutils.SHAUtils.SHA1;

/**
 * @author zmk
 * 患者不用登陆访问居民PC端控制类
 * Created at 2019/12/25。
 */
@RestController
@RequestMapping(value = BaseHospitalRequestMapping.PatientNoLogin.PREFIX)
@Api(value = "患者不用登陆访问居民PC端控制类", description = "患者不用登陆访问居民PC端控制类")
public class PatientNoLoginEndPoint extends EnvelopRestEndpoint {

    private static final Logger logger = LoggerFactory.getLogger(PatientNoLoginEndPoint.class);
    @Autowired
    private BusinessOrderService businessOrderService;
    @Autowired
    private PrescriptionExpressageService sfexpressService;
    @Autowired
    private QrcodeService qrcodeService;
    @Autowired
    private BaseUserMsgService baseUserMsgService;
    @Autowired
    private PrescriptionService prescriptionService;
    @Autowired
    private SysDictService sysDictService;
    @Autowired
    private ImService imService;
    @Autowired
    private BaseDictJobTitleService baseDictJobTitleService;
    @Autowired
    private BaseDoctorInfoService baseDoctorService;
    @Autowired
    private WlyyHospitalSysDictDao wlyyHospitalSysDictDao;
    @Autowired
    private JdbcTemplate jdbcTemplate;

    @Value("${wechat.id}")
    private String wxId;
    @Value("${pay.flag}")
    private boolean payFlag;
    @Autowired
    private StringRedisTemplate redisTemplate;
    @Autowired
    private OauthYlzConfigDao oauthYlzConfigDao;
    @Autowired
    private HospitalDeptService hospitalDeptService;
    @Autowired
    private BusinessOrderDao businessOrderDao;
    @Autowired
    private PrescriptionDao prescriptionDao;
    @Autowired
    private PrescriptionInfoDao prescriptionInfoDao;
    @Autowired
    private PayLogService logService;
    @Autowired
    private WorkTimeService workTimeService;
    @Autowired
    private WlyyHttpLogDao wlyyHttpLogDao;

    @Autowired
    private BaseDoctorHospitalDao doctorHospitalDao;
    @Autowired
    private KnowledgeArticleUserDao knowledgeArticleUserDao;
    @Autowired
    private KnowledgeArticleService knowledgeArticleService;
    @Resource
    private KnowledgeArticleDao knowledgeArticleDao;
    @Autowired
    private WechatDao wechatDao;
    @Autowired
    private YlzPayService ylzPayService;
    @Autowired
    private EntranceService entranceService;
    @Autowired
    private PayInfoNoticeService payInfoNoticeService;
    @Autowired
    private OutpatientDao outpatientDao;
    @Autowired
    private PrescriptionLogDao prescriptionLogDao;
    @Autowired
    private PrescriptionExpressageDao prescriptionExpressageDao;
    @Autowired
    private YkyyEntranceService ykyyEntranceService;
    @Autowired
    private WlyyHttpLogService wlyyHttpLogService;
    @Autowired
    private HospitalSystemMessageService hospitalSystemMessageService;
    @Autowired
    private StatisticsEsService statisticsEsService;
    @Autowired
    private BasePatientDao patientDao;

    @Autowired
    private YkyyPrescriptionService ykyyPrescriptionService;
    @Autowired
    private KnowledgeCategoryService knowledgeCategoryService;

    @Autowired
    private BaseBannerDoctorService baseBannerDoctorService;
    @Autowired
    private BaseNatAppointmentDao baseNatAppointmentDao;
    @Autowired
    private YkyyINSMSService ykyyINSMSService;
    @Autowired
    private BasePatientWechatDao basePatientWechatDao;
    @Autowired
    private SystemMessageService systemMessageService;
    @Autowired
    private ConsultDao consultDao;
    @Autowired
    FileUploadService fileUploadService;
    @Autowired
    private WlyyHttpService wlyyHttpService;
    @Autowired
    private FileUtil fileUtil;
    @Value("${fastDFS.fastdfs_file_url}")
    private String fastdfs_file_url;
    @Value("${FileTempPath.upload_temp_path}")
    private String upload_temp_path;
    @Autowired
    private ConsultTeamDao consultTeamDao;
    @Autowired
    private BaseDoctorDao baseDoctorDao;
    @Autowired
    private TasyNatService tasyNatService;
    @Autowired
    private YqfkService yqfkService;

    @Value("${testPattern.sign}")
    private String isClose;
    @Value("${testPattern.remote_inner_url}")
    private String remote_inner_url;
    @Autowired
    private WechatInfoService wechatInfoService;
    @Autowired
    private YlzMedicailRelationDao ylzMedicailRelationDao;
    @Autowired
    private BaseDoctorHealthUploadService baseDoctorHealthUploadService;
    @Autowired
    private EnterpriseService enterpriseService;
    @Autowired
    private WxEnterpriseDao wxEnterpriseDao;



    @GetMapping(value = BaseHospitalRequestMapping.PatientNoLogin.findDoctorByHospitalAndDiseaseAndDept)
    @ApiOperation(value = "根据疾病名称，热门部门查询医生", notes = "根据疾病名称，热门部门查询医生")
    public MixEnvelop findDoctorByHospitalAndDiseaseAndDept(@ApiParam(name = "iswork", value = "是否过滤排班,1是")
                                                             @RequestParam(value = "iswork", required = false)String iswork,
                                                            @ApiParam(name = "orgCode", value = "机构code")
                                                             @RequestParam(value = "orgCode", required = true,defaultValue = "350211A1002")String orgCode,
                                                            @ApiParam(name = "patientid", value = "patientid")
                                                                @RequestParam(value = "patientid", required = false)String patientid,
                                                            @ApiParam(name = "dept", value = "部门code")
                                                             @RequestParam(value = "dept", required = false)String dept,
                                                            @ApiParam(name = "diseaseKey", value = "疾病名称关键字")
                                                             @RequestParam(value = "diseaseKey", required = false)String diseaseKey,
                                                            @ApiParam(name = "doctorNameKey", value = "医生名称关键字")
                                                             @RequestParam(value = "doctorNameKey", required = false)String doctorNameKey,
                                                            @ApiParam(name = "jobTitleNameKey", value = "医生职称关键字")
                                                             @RequestParam(value = "jobTitleNameKey", required = false)String jobTitleNameKey,
                                                            @ApiParam(name = "outpatientType", value = "咨询类型1图文，2视频")
                                                             @RequestParam(value = "outpatientType", required = false)String outpatientType,
                                                            @ApiParam(name = "keyName", value = "姓名/科室/疾病模糊搜索关键字")
                                                             @RequestParam(value = "keyName", required = false)String keyName,
                                                            @ApiParam(name = "workingTime", value = "排班时间YYYY-MM-DD")
                                                             @RequestParam(value = "workingTime", required = false)String workingTime,
                                                            @ApiParam(name = "consultStatus", value = "在线状态")
                                                             @RequestParam(value = "consultStatus", required = false,defaultValue = "")String consultStatus,
                                                            @ApiParam(name = "chargType", value = "医生号别")
                                                             @RequestParam(value = "chargType", required = false,defaultValue = "")String chargType,
                                                            @ApiParam(name = "consutlSort", value = "咨询量排序")
                                                             @RequestParam(value = "consutlSort", required = true,defaultValue = "DESC")String consutlSort,
                                                            @ApiParam(name = "isAttention", value = "是否关注 1:关注 0:不关注 不传:查所有")
                                                                 @RequestParam(value = "isAttention", required = false)String isAttention,
                                                            @ApiParam(name = "page", value = "第几页")
                                                             @RequestParam(value = "page",required = false) Integer page,
                                                            @ApiParam(name = "pagesize", value = "分页大小")
                                                             @RequestParam(value = "pagesize",required = false) Integer pagesize
    ) {
        try {
            logger.info("findDoctorByHospitalAndDiseaseAndDept start:"+ DateUtil.dateToStr(new Date(),"yyyy-MM-dd HH:mm:ss:SSS"));
            return prescriptionService.findDoctorByHospitalAndDiseaseAndDept2(iswork,patientid,
                    orgCode,dept,
                    diseaseKey,doctorNameKey,
                    jobTitleNameKey,outpatientType,
                    keyName,workingTime,consultStatus,chargType,consutlSort,isAttention,page,pagesize);
        } catch (Exception e){
            return  failedMixEnvelopException2(e);
        }
    }
    @GetMapping("/testFrontQuery")
    @ApiOperation(value = "根据疾病名称，热门部门查询医生", notes = "根据疾病名称，热门部门查询医生")
    public MixEnvelop findDoctorByHospitalAndDiseaseAndDept2(@ApiParam(name = "iswork", value = "是否过滤排班,1是")
                                                            @RequestParam(value = "iswork", required = true)String iswork,
                                                            @ApiParam(name = "orgCode", value = "机构code")
                                                            @RequestParam(value = "orgCode", required = true,defaultValue = "350211A1002")String orgCode,
                                                            @ApiParam(name = "patientid", value = "patientid")
                                                            @RequestParam(value = "patientid", required = false)String patientid,
                                                            @ApiParam(name = "dept", value = "部门code")
                                                            @RequestParam(value = "dept", required = false)String dept,
                                                            @ApiParam(name = "diseaseKey", value = "疾病名称关键字")
                                                            @RequestParam(value = "diseaseKey", required = false)String diseaseKey,
                                                            @ApiParam(name = "doctorNameKey", value = "医生名称关键字")
                                                            @RequestParam(value = "doctorNameKey", required = false)String doctorNameKey,
                                                            @ApiParam(name = "jobTitleNameKey", value = "医生职称关键字")
                                                            @RequestParam(value = "jobTitleNameKey", required = false)String jobTitleNameKey,
                                                            @ApiParam(name = "outpatientType", value = "咨询类型1图文，2视频")
                                                            @RequestParam(value = "outpatientType", required = false)String outpatientType,
                                                            @ApiParam(name = "keyName", value = "姓名/科室/疾病模糊搜索关键字")
                                                            @RequestParam(value = "keyName", required = false)String keyName,
                                                            @ApiParam(name = "workingTime", value = "排班时间YYYY-MM-DD")
                                                            @RequestParam(value = "workingTime", required = false)String workingTime,
                                                            @ApiParam(name = "consultStatus", value = "在线状态")
                                                            @RequestParam(value = "consultStatus", required = false,defaultValue = "")String consultStatus,
                                                            @ApiParam(name = "chargType", value = "医生号别")
                                                            @RequestParam(value = "chargType", required = false,defaultValue = "")String chargType,
                                                            @ApiParam(name = "consutlSort", value = "咨询量排序")
                                                            @RequestParam(value = "consutlSort", required = true,defaultValue = "DESC")String consutlSort,
                                                            @ApiParam(name = "isAttention", value = "是否关注 1:关注 0:不关注 不传:查所有")
                                                            @RequestParam(value = "isAttention", required = false)String isAttention,
                                                            @ApiParam(name = "page", value = "第几页")
                                                            @RequestParam(value = "page",required = false) Integer page,
                                                            @ApiParam(name = "pagesize", value = "分页大小")
                                                            @RequestParam(value = "pagesize",required = false) Integer pagesize
    ) throws Exception{
        try {
            logger.info("findDoctorByHospitalAndDiseaseAndDept start:"+ DateUtil.dateToStr(new Date(),"yyyy-MM-dd HH:mm:ss:SSS"));
            return prescriptionService.findDoctorByHospitalAndDiseaseAndDept2(iswork,patientid,
                    orgCode,dept,
                    diseaseKey,doctorNameKey,
                    jobTitleNameKey,outpatientType,
                    keyName,workingTime,consultStatus,chargType,consutlSort,isAttention,page,pagesize);
        } catch (Exception e){
            return  failedMixEnvelopException2(e);
        }
    }


    @GetMapping(value = BaseHospitalRequestMapping.PatientNoLogin.findHotDeptAndDiseaseDict)
    @ApiOperation(value = "获取常见疾病、热门部门、医生拒绝接诊原因 字典", notes = "获取常见疾病、热门部门、医生拒绝接诊原因 字典")
    public ListEnvelop findHotDeptAndDiseaseDict(@ApiParam(name = "dictName", value = "dictName")
                                                 @RequestParam(value = "dictName", required = true,defaultValue = "ONLINE_HOSPITAL_DEPT_350211A1002")String dictName)throws Exception{

        try {
            return success(prescriptionService.findHotDeptAndDiseaseDict(dictName));
        } catch (Exception e){
            return  failedListEnvelopException2(e);
        }
    }


    @GetMapping(value = BaseHospitalRequestMapping.PatientNoLogin.getTodayOutpatinetList)
    @ApiOperation(value = "居民获取当日就诊列表", notes = "居民获取当日就诊列表")
    public ListEnvelop getTodayOutpatinetList(@ApiParam(name = "patient", value = "居民ID")
                                              @RequestParam(value = "patient", required = true) String patient){

        try {
            return success(prescriptionService.getTodayOutpatinetList(patient,wxId));
        } catch (Exception e){
            return  failedListEnvelopException2(e);
        }
    }


    @GetMapping(value = BaseHospitalRequestMapping.PatientNoLogin.findByDeptTypeCode)
    @ApiOperation(value = "就诊费用查询", notes = "就诊费用查询")
    public ListEnvelop findByDeptTypeCode(@ApiParam(name = "deptTypeCode", value = "6总部7金榜8夏禾")
                                          @RequestParam(value = "deptTypeCode", required = false)String deptTypeCode) throws Exception{
        try {
            return success(prescriptionService.findByDeptTypeCode(deptTypeCode));
        } catch (Exception e){
            return  failedListEnvelopException2(e);
        }
    }


    @GetMapping(value = BaseHospitalRequestMapping.PatientNoLogin.findByHosAndDict)
    @ApiOperation(value = "根据医院和字典名查询")
    public Envelop findByHosAndDict(
            @ApiParam(name = "hospital", value = "医院编码", required = true)
            @RequestParam(value = "hospital", required = true) String hospital,
            @ApiParam(name = "dictName", value = "字典名称", required = true)
            @RequestParam(value = "dictName", required = true) String dictName ) throws Exception {


        try {
            List<Map<String, Object>> list = sysDictService.findByHosAndDict(hospital, dictName);
            return success("查询成功",list);
        } catch (Exception e){
            return  failedException2(e);
        }
    }


    @GetMapping(value = BaseHospitalRequestMapping.PatientNoLogin.findDoctorInfo)
    @ApiOperation(value = "获取医生信息", notes = "获取医生信息")
    public Envelop findDoctorInfo(@ApiParam(name = "doctor", value = "医生code")
                                     @RequestParam(value = "doctor", required = false)String doctor,
                                  @ApiParam(name = "idcard", value = "医生身份证")
                                  @RequestParam(value = "idcard", required = false)String idcard,
                                     @ApiParam(name = "withWork", value = "传1带排班，其他不带")
                                     @RequestParam(value = "withWork", required = false)String withWork,
                                     @ApiParam(name = "patient", value = "患者code")
                                         @RequestParam(value = "patient", required = false)String patient)throws Exception{
        try {
            return success(prescriptionService.findDoctorInfo(doctor,idcard,withWork,patient));
        }catch (Exception e){
            return  failedException2(e);
        }

    }


    @GetMapping(value = BaseHospitalRequestMapping.PatientNoLogin.isExistsUnfinishedConsult)
    @ApiOperation(value = "查询居民与某个医生是否存在未结束的专家咨询")
    public Envelop isExistsUnfinishedConsult(
            @ApiParam(name = "doctor", value = "医生CODE")
            @RequestParam(value = "doctor",required = true) String doctor,
            @ApiParam(name = "patient", value = "居民CODE")
            @RequestParam(value = "patient",required = true) String patient)throws Exception {
        try {
            if(StringUtils.isEmpty(patient)){
                patient= getUID();
            }
            String consultCode = imService.getUnfinishedConsult(patient, doctor);
            return success("请求成功",consultCode);
        }catch (Exception e){
            return  failedException2(e);
        }
    }

    /**
     * 根据机构编码获取部门列表信息
     * @param orgCode
     * @return
     */
    @GetMapping(value = "/getDeptByOrgCode")
    @ApiOperation(value = "根据机构编码获取部门列表信息", notes = "基础数据获取")
    public Envelop getDeptByOrgCode(
            @ApiParam(name = "orgCode", value = "机构编码")
            @RequestParam(value = "orgCode", required = false) String orgCode,
            @ApiParam(name = "name", value = "科室名称")
            @RequestParam(value = "name", required = false) String name,
            @ApiParam(name = "consultDeptFlag", value = "是否是就诊科室,1为查询门诊，不传为全部")
            @RequestParam(value = "consultDeptFlag", required = false) String consultDeptFlag)  {
        try {
            List<DictHospitalDeptDO> res =  hospitalDeptService.getHosDeptByCode(orgCode,consultDeptFlag,name);
            if(res != null && res.size() > 0 ){
                return  success(res);
            }else{
                return success("无法获取该机构的部门列表信息！");
            }
        }catch (Exception e){
            return  failedException2(e);
        }
    }

    /**
     * 获取机构职称信息
     * @return
     */
    @GetMapping(value = BaseHospitalRequestMapping.PatientNoLogin.getJobBySaasId)
    @ApiOperation(value = "获取机构职称信息", notes = "基础数据获取")
    public Envelop getJobBySaasId(
            @ApiParam(name = "saasId", value = "租户ID，当为空的情况下查询所有")
            @RequestParam(value = "saasId", required = false) String saasId)  {
        try {
            List<DictJobTitleDO> res= baseDictJobTitleService.getBySaasId(saasId);
            if(res != null && res.size() > 0 ){
                return  success(res);
            }else{
                return success("无法获取该机构的职称信息！");
            }
        }catch (Exception e){
            return  failedException2(e);
        }
    }


    @GetMapping(value = BaseHospitalRequestMapping.PatientNoLogin.findWorkTimeInfo)
    @ApiOperation(value = "获取具体号源", notes = "获取具体号源")
    public ListEnvelop findWorkTimeInfo(@ApiParam(name = "id", value = "排班id")
                                        @RequestParam(value = "id", required = false)String id) {

        try {
            return success(prescriptionService.findWorkTimeInfo(id));
        }catch (Exception e){
            return  failedListEnvelopException2(e);
        }
    }


    @GetMapping(value = BaseHospitalRequestMapping.PatientNoLogin.findLevelOneDoctorUpcoming)
    @ApiOperation(value = "根据医生身份证查找互联网医院待办数量", notes = "根据医生身份证查找互联网医院待办数量")
    public ObjEnvelop findLevelOneDoctorUpcoming(@ApiParam(name = "doctor_idcard", value = "医生身份证")
                                                 @RequestParam(value = "doctor_idcard", required = true)String doctor_idcard){

        try {
            List<BaseDoctorDO> doctors = baseDoctorService.findByField("idcard",doctor_idcard);
            BaseDoctorDO doctor = null;
            JSONObject result = new JSONObject();
            if(!doctors.isEmpty()){
                doctor = doctors.get(0);
                //专家咨询
                Integer zjCount = imService.sessionCountByType(doctor.getId(),1,0);
                //全科医生求助专科
                Integer zjqzCount = imService.sessionCountByType(doctor.getId(),15,0);

                //专家咨询
                Integer unreadMessageCount = imService.SessionsUnreadMessageCount(doctor.getId(),"1");
                result.put("zjCount",zjCount+zjqzCount);//专家咨询数量
                result.put("zjUnreadMessageCount",unreadMessageCount);//专家咨询未读数
            }else{
                result.put("zjCount",0);//专家咨询数量
                result.put("zjUnreadMessageCount",0);//专家咨询未读数
            }
            return success("请求成功",result);
        }catch (Exception e){
            return  failedObjEnvelopException2(e);
        }
    }

    @GetMapping(value = BaseHospitalRequestMapping.PatientNoLogin.getUpcomingByDoctor)
    @ApiOperation(value = "获取医生待办详情", notes = "获取医生待办详情")
    public Envelop getUpcomingByDoctor(@ApiParam(name = "doctorIdcard", value = "doctorIdcard", required = true)
                                       @RequestParam(value = "doctorIdcard",required = true)String doctorIdcard){

        try {
            JSONObject result = new JSONObject();
            List<BaseDoctorDO> doctors = baseDoctorService.findDoctorsByIdcard(doctorIdcard);
            BaseDoctorDO doctor = new BaseDoctorDO();
            if(!doctors.isEmpty()){
                doctor = doctors.get(0);
            }else{
                return success("该身份证无法找到医生",-1);
            }

            //医生咨询
            Integer zxCount = imService.SessionsUnreadMessageCount(doctor.getId(), "1");
            Integer fzCount = imService.SessionsUnreadMessageCount(doctor.getId(), "9");
            Integer spCount = imService.SessionsUnreadMessageCount(doctor.getId(), "16");
            result.put("zxCount",zxCount);//专家咨询咨询数量
            result.put("fzCount",fzCount);//图文复诊数量
            result.put("spCount",spCount);//图文复诊数量
            result.put("totalCount",zxCount+fzCount+spCount);

            return success("请求成功",result);
        } catch (Exception e){
            return  failedException2(e);
        }
    }



    /**
     * 获取微信openid
     *
     * @param code
     * @return
     */
    @RequestMapping(value = "/getOpenidByCode", method = {RequestMethod.POST, RequestMethod.GET})
    @ResponseBody
    public Envelop getOpenidByCode(String code,@RequestParam(value = "patientId", required = false)String patientId) throws Exception {

        try {
            //通过redis获取openid, 获取不到,则调用微信接口去取
            String key = wxId+":code";
            String openid = redisTemplate.opsForValue().get(key);
            if(!StringUtils.isEmpty(openid)){
                return success(PatientRequestMapping.Wechat.api_success,openid);
            }
            openid = wechatInfoService.getOpenidByCode(code, wxId);
            if (!StringUtils.isEmpty(patientId)){
                List<BasePatientWechatDo> list = basePatientWechatDao.findByWechatIdAndPatientId(wxId,patientId);
                if (list!=null&&list.size()>0){
                    for (BasePatientWechatDo basePatientWechatDo:list){
                        basePatientWechatDo.setOpenid(openid);
                        basePatientWechatDao.save(basePatientWechatDo);
                    }
                }else {
                    BasePatientWechatDo basePatientWechatDo = new BasePatientWechatDo();
                    basePatientWechatDo.setPatientId(patientId);
                    basePatientWechatDo.setWechatId(wxId);
                    basePatientWechatDo.setCreateTime(new Date());
                    basePatientWechatDo.setOpenid(openid);
                    basePatientWechatDao.save(basePatientWechatDo);
                }

            }
            redisTemplate.opsForValue().set(key,openid);
            redisTemplate.expire(key,10, TimeUnit.SECONDS);
            return success(PatientRequestMapping.Wechat.api_success,openid);
        } catch (Exception e){
            return  failedException2(e);
        }
    }


    /**
     * 微信支付异步回调
     * @param request
     * @param response
     * @return
     * @throws IOException
     */
    @ResponseBody
    @ApiOperation("微信支付结果通知")
    @RequestMapping(value = "/notify", method = {RequestMethod.GET, RequestMethod.POST})
    public String wxPayNotify(HttpServletRequest request, HttpServletResponse response) throws Exception {
        String result = "";
        String inputLine;
        while ((inputLine = request.getReader().readLine()) != null) {
            result += inputLine;
        }
        request.getReader().close();
        //im处方发消息
        Map<String,Object> wxrs =  XMLUtil.xmltoMap(result);
        Map<String, String> map = new HashedMap();
        if("SUCCESS".equals(wxrs.get("return_code").toString())){
            // 我方 订单号+时间差
            String seqNo = wxrs.get("out_trade_no")+"";
            BusinessOrderDO businessOrderDO = businessOrderDao.selectByOrderNo(seqNo);
            if (businessOrderDO.getStatus()!=1&&businessOrderDO.getStatus()!=9){
                if (businessOrderDO!=null&&businessOrderDO.getOrderCategory().equalsIgnoreCase("4")){
                    WlyyPrescriptionDO wlyyPrescriptionDO = prescriptionDao.findById(businessOrderDO.getRelationCode()).orElse(null);
                    JSONObject object = (JSONObject) JSONObject.toJSON(wlyyPrescriptionDO);
                    logger.info("wlyyPrescriptionDO参数入参"+object.toJSONString());
                    WlyyPrescriptionVO prescriptionVO = JSONObject.toJavaObject(object,WlyyPrescriptionVO.class);
                    List<WlyyPrescriptionInfoDO> wlyyPrescriptionInfoDOS = prescriptionInfoDao.findByPrescriptionId(wlyyPrescriptionDO.getId(),1);
                    List<WlyyPrescriptionInfoVO> wlyyPrescriptionInfoVOS = new ArrayList<>();
                    for (WlyyPrescriptionInfoDO wlyyPrescriptionInfoDO:wlyyPrescriptionInfoDOS){
                        JSONObject jsonObject1 = (JSONObject) JSONObject.toJSON(wlyyPrescriptionInfoDO);
                        logger.info("wlyyPrescriptionInfoDO参数入参"+jsonObject1.toJSONString());
                        WlyyPrescriptionInfoVO prescriptionInfoVO = JSONObject.toJavaObject(jsonObject1,WlyyPrescriptionInfoVO.class);
                        wlyyPrescriptionInfoVOS.add(prescriptionInfoVO);
                    }
                    prescriptionVO.setInfoVOs(wlyyPrescriptionInfoVOS);
                    prescriptionVO.setPayStatus(1);
                    imService.pushPrescriptionImMessage(prescriptionVO);
                }
                map= businessOrderService.getWxPayResultNotify(result);
            }
        }


        return XMLUtil.map2xml(map);

    }


    /**
     * 商户回调通知
     * @param request
     * @param response
     * @throws IOException
     * @throws PayException
     */
    @RequestMapping(value = "/ylzReceiveNotify")
    public String mmpReceiveNotify(HttpServletRequest request, HttpServletResponse response) throws IOException, PayException {
        response.setContentType("text/html;charset=utf-8");
        OauthYlzConfigDO oauthYlzConfigDO = oauthYlzConfigDao.findById("ylz_pay_config").orElse(null);
        if(oauthYlzConfigDO==null){
            return "未找到支付配置文件";
        }
        String appId = oauthYlzConfigDO.getAppId();
        String appSecret = oauthYlzConfigDO.getAppKey();
        InputStream inputStream = request.getInputStream();
        String params = StreamUtils.copyToString(inputStream, Charset.forName("UTF-8"));
        logger.info("回调参数：{}", params);
        if (StringUtil.isEmpty(params)) {
            response.getWriter().write("empty");
            return appId;
        }
        // 参数转换
        ResponseParams<?> encryptRes = JSON.parseObject(params, ResponseParams.class);
        OnepayDefaultClient client = new OnepayDefaultClient("", appId, appSecret, encryptRes.getSignType(), encryptRes.getEncryptType());
        try {
            logger.info("解密前：{}", JSON.toJSONString(encryptRes));
            ResponseParams<?> decryptRes = client.decryptNotifyResponse(encryptRes);
            logger.info("解密后：{}",JSON.toJSONString(decryptRes) );
            boolean isDecrypt = ("-1".equals(decryptRes.getRespCode()) ? false : true); // 是否解密失败
            if (!isDecrypt) {
                response.getWriter().write("DECRYPT FAILURE");
            } else {
                boolean isVerify = client.verifyResponseSign(decryptRes);
                logger.info("验签结果：{}", isVerify);
                if (!isVerify) {
                    response.getWriter().write("FAILURE");
                } else {
                    JSONObject jsonObject = JSONObject.parseObject(JSON.toJSONString(decryptRes));
                    JSONObject param = jsonObject.getJSONObject("param");
                    logger.info("param"+params);
                    String traceNo = param.getString("outChargeNo");
                    //im处方发消息
                    BusinessOrderDO businessOrderDO = businessOrderDao.selectByOrderNo(traceNo);
                    if (businessOrderDO.getStatus()!=1){
                        if (businessOrderDO!=null&&businessOrderDO.getOrderCategory().equalsIgnoreCase("4")){
                            WlyyPrescriptionDO wlyyPrescriptionDO = prescriptionDao.findById(businessOrderDO.getRelationCode()).orElse(null);
                            JSONObject object = (JSONObject) JSONObject.toJSON(wlyyPrescriptionDO);
                            logger.info("wlyyPrescriptionDO参数入参"+object.toJSONString());
                            WlyyPrescriptionVO prescriptionVO = JSONObject.toJavaObject(object,WlyyPrescriptionVO.class);
                            List<WlyyPrescriptionInfoDO> wlyyPrescriptionInfoDOS = prescriptionInfoDao.findByPrescriptionId(wlyyPrescriptionDO.getId(),1);
                            List<WlyyPrescriptionInfoVO> wlyyPrescriptionInfoVOS = new ArrayList<>();
                            for (WlyyPrescriptionInfoDO wlyyPrescriptionInfoDO:wlyyPrescriptionInfoDOS){
                                JSONObject jsonObject1 = (JSONObject) JSONObject.toJSON(wlyyPrescriptionInfoDO);
                                logger.info("wlyyPrescriptionInfoDO参数入参"+jsonObject1.toJSONString());
                                WlyyPrescriptionInfoVO prescriptionInfoVO = JSONObject.toJavaObject(jsonObject1,WlyyPrescriptionInfoVO.class);
                                wlyyPrescriptionInfoVOS.add(prescriptionInfoVO);
                            }
                            prescriptionVO.setInfoVOs(wlyyPrescriptionInfoVOS);
                            prescriptionVO.setPayStatus(1);
                            imService.pushPrescriptionImMessage(prescriptionVO);
                        }else if (businessOrderDO!=null&&businessOrderDO.getOrderCategory().equalsIgnoreCase("2")){
                            SystemMessageDO systemMessageDO = new SystemMessageDO();
                            systemMessageDO.setType("1");
                            systemMessageDO.setReceiver(businessOrderDO.getDoctor());
                            systemMessageDO.setSender(businessOrderDO.getPatient());
                            //发送IM消息
                            hospitalSystemMessageService.sendImMessage(systemMessageDO);
                        }else if (businessOrderDO!=null&&businessOrderDO.getOrderCategory().equalsIgnoreCase("3")){
                            SystemMessageDO systemMessageDO = new SystemMessageDO();
                            systemMessageDO.setType("2");
                            systemMessageDO.setReceiver(businessOrderDO.getDoctor());
                            systemMessageDO.setSender(businessOrderDO.getPatient());
                            //发送IM消息
                            hospitalSystemMessageService.sendImMessage(systemMessageDO);
                        }else if (businessOrderDO!=null&&businessOrderDO.getOrderCategory().equalsIgnoreCase("6")){
                            YlzMedicalRelationDO ylzMedicalRelationDO = ylzMedicailRelationDao.findById(businessOrderDO.getRelationCode()).orElse(null);
                            prescriptionService.confirmSettlementService(ylzMedicalRelationDO.getRelationCode());
                        }
                    }
                    businessOrderService.updatePayStatus(traceNo);
                    return "SUCCESS";
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }

        return appId;
    }


    @RequestMapping(value = "/receiveNotify")
    @ApiOperation("支付回调")
    public String receiveNotify(HttpServletRequest request, HttpServletResponse response) throws IOException, IOException {
        response.setContentType("text/html;charset=utf-8");
        OauthYlzConfigDO oauthYlzConfigDO = oauthYlzConfigDao.findById("ylz_pay_config").orElse(null);
        if(oauthYlzConfigDO==null){
            return "未找到支付配置文件";
        }
        String appId = oauthYlzConfigDO.getAppId();
        String appSecret = oauthYlzConfigDO.getAppKey();
        InputStream inputStream = request.getInputStream();
        logger.info("转换前的回调参数："+inputStream);
        String params = StreamUtils.copyToString(inputStream, Charset.forName("UTF-8"));
        // 回调参数：{"appId":"1A3VL0KVK0000B020A0A0000CC3F48AD","encryptData":"qPebDp0xBA/0qdr2lDvY2zBp2kB5em5GOr29y7o2WnHvm0tswnbyxDjCIUGI74yNGWFyCeJfeU5A\nK+Zr/yPs6nnsyzIFTSSljrKZCkzgbj3mjMax/3NzByfvE7R2MO+fljJUYqE93AvuRDc1wcdSUuKK\nmcryOvaU","encryptType":"DES","sign":"24635D0085CC72447657BD0713F0FB7C","signType":"MD5","timestamp":"20161018171127869","transType":"charge.success"}
        logger.info("回调参数：{}", params);
        if (StringUtil.isEmpty(params)) {
            response.getWriter().write("empty");
            return null;
        }
        // 参数转换
        ResponseParams<?> res = JSON.parseObject(params, ResponseParams.class);

        // 解密报文
        System.out.println("解密前报文：" + JSONObject.toJSONString(res.getEncryptData()));
        String decryptData;
        ResponseParams<WebHook> responseParams = new ResponseParams<WebHook>();
        WebHook webhook = new WebHook();
        try {
            decryptData = SecurityUtil.decrypt(res.getEncryptData(), res.getEncryptType(), appSecret, appId);
            System.out.println("解密后报文：" + decryptData);
            webhook = JSON.parseObject(decryptData, WebHook.class);

            // 参数转换
            responseParams.setAppId(appId);
            responseParams.setSign(res.getSign());
            responseParams.setSignType(res.getSignType());
            responseParams.setEncryptType(res.getEncryptType());
            responseParams.setTimestamp(res.getTimestamp());
            responseParams.setRespCode(res.getRespCode());
            responseParams.setRespMsg(res.getRespMsg());
            responseParams.setPageParams(res.getPageParams());
            responseParams.setTransType(res.getTransType());
            // 解密后设置param
            responseParams.setParam(webhook);

        } catch (Exception e1) {
            logger.error("解密回调报文错误");
            return e1.getMessage();
        }

        OnepayClient payService = new OnepayClient("", appId, appSecret, res.getSignType(), res.getEncryptType());
        boolean isSuccess = false;
        String jsonObject = null;
        String error = null;
        try {
            // boolean isVerify = payService.verifyResponseSign(responseParams);
            boolean isVerify = payService.verifyResponseSign(responseParams);
            //boolean isVerify = true;
            isSuccess = true;
            jsonObject = isVerify+"";
            logger.info("验签结果：{}", isVerify);
            if (isVerify) {
                if (responseParams.getTransType().equalsIgnoreCase("charge.success")){
                    if (webhook!=null){
                        String outChargeNo = webhook.getOutChargeNo();
                        //im处方发消息
                        BusinessOrderDO businessOrderDO = businessOrderDao.selectByOrderNo(outChargeNo);
                        if (businessOrderDO.getStatus()!=1){
                            if (businessOrderDO!=null&&businessOrderDO.getOrderCategory().equalsIgnoreCase("4")){
                                WlyyPrescriptionDO wlyyPrescriptionDO = prescriptionDao.findById(businessOrderDO.getRelationCode()).orElse(null);
                                JSONObject object = (JSONObject) JSONObject.toJSON(wlyyPrescriptionDO);
                                logger.info("wlyyPrescriptionDO参数入参"+object.toJSONString());
                                WlyyPrescriptionVO prescriptionVO = JSONObject.toJavaObject(object,WlyyPrescriptionVO.class);
                                List<WlyyPrescriptionInfoDO> wlyyPrescriptionInfoDOS = prescriptionInfoDao.findByPrescriptionId(wlyyPrescriptionDO.getId(),1);
                                List<WlyyPrescriptionInfoVO> wlyyPrescriptionInfoVOS = new ArrayList<>();
                                for (WlyyPrescriptionInfoDO wlyyPrescriptionInfoDO:wlyyPrescriptionInfoDOS){
                                    JSONObject jsonObject1 = (JSONObject) JSONObject.toJSON(wlyyPrescriptionInfoDO);
                                    logger.info("wlyyPrescriptionInfoDO参数入参"+jsonObject1.toJSONString());
                                    WlyyPrescriptionInfoVO prescriptionInfoVO = JSONObject.toJavaObject(jsonObject1,WlyyPrescriptionInfoVO.class);
                                    wlyyPrescriptionInfoVOS.add(prescriptionInfoVO);
                                }
                                prescriptionVO.setInfoVOs(wlyyPrescriptionInfoVOS);
                                prescriptionVO.setPayStatus(1);
                                imService.pushPrescriptionImMessage(prescriptionVO);
                            }
                        }
                        businessOrderService.updatePayStatus(outChargeNo);
                    }
                }
                return "SUCCESS";
            } else {
                return "FAIL";
            }

        } catch (Exception e) {
            e.printStackTrace();
        }
        logService.saveHttpLog(isSuccess, "hop.trade.verifyResponseSign", "支付回调", "POST", null,JSON.toJSONString(responseParams), jsonObject, error,logService.shoppatType);
        return appId;
    }


    @PostMapping(value= BaseHospitalRequestMapping.Prescription.findWorkTimeRule)
    @ApiOperation(value = "查询排班规则")
    public ObjEnvelop findWorkTimeRule(@ApiParam(name = "hospital", value = "医院code")
                                       @RequestParam(value = "hospital",required = true)String hospital) {

        try {
            return success(workTimeService.findWorkTimeRule(hospital));
        } catch (Exception e){
            return  failedObjEnvelopException2(e);
        }
    }

    @PostMapping(value= BaseHospitalRequestMapping.Prescription.checkDoctorWork)
    @ApiOperation(value = "判断医生是否在班")
    public ObjEnvelop checkDoctorWork(@ApiParam(name = "doctor", value = "判断医生是否在班")
                                      @RequestParam(value = "doctor",required = true)String doctor,
                                      @ApiParam(name = "ywCode", value = "业务code")
                                      @RequestParam(value = "ywCode",required = false)String ywCode) throws Exception{

        try {
            return success(workTimeService.checkDoctorWork(doctor,ywCode));
        } catch (Exception e){
            return  failedObjEnvelopException2(e);
        }
    }


    @PostMapping(value = "/getSFExpressInfoNew")
    @ApiOperation(value = "获取顺丰物流面单信息")
    public ObjEnvelop getSFExpressInfoNew(
            @ApiParam(name = "admNo", value = "门诊就诊唯一号", required = true)
            @RequestParam(value = "admNo") String admNo,
            @ApiParam(name = "realOrder", value = "处方号", required = false)
            @RequestParam(value = "realOrder") String realOrder) {
        try {
            WlyyHttpLogDO log = new WlyyHttpLogDO();
            log.setCode("getSFExpressInfo");
            log.setName("获取顺丰物流面单信息");
            log.setRequest("admNo="+admNo+"&realOrder="+realOrder);
            log.setCreateTime(new Date());
            wlyyHttpLogDao.save(log);
            System.out.println("获取顺丰物流面单信息:admNo="+admNo+"&realOrder="+realOrder);
            //String result = "{\"mailno\":\"444844980525\",\"mailtype\":\"标准快递\",\"destcode\":\"592\",\"j_name\":\"厦门大学附属中山医院\",\"j_provinceName\":\"福建省\",\"j_cityName\":\"厦门市\",\"j_townName\":\"思明区\",\"j_address\":\"湖滨南路201-209号\",\"j_phone\":\"4003008888\",\"d_name\":\"陈筑城\",\"d_provinceName\":\"福建省\",\"d_cityName\":\"厦门市\",\"d_townName\":\"思明区\",\"d_address\":\"软件园二期望海路55号\",\"d_phone\":\"18205968888\",\"express_type\":11,\"pay_method\":2,\"receive_time\":\"\",\"dispensaryType\":\"1\"}";
            Object result = prescriptionService.getSFExpressInfoNew(admNo, realOrder,wxId);
            if ("".equals(result)){
                return ObjEnvelop.getError("获取面单信息失败");
            }else {
                return ObjEnvelop.getSuccess("获取面单信息成功",result);
            }
        } catch (Exception e) {
            return failedObjEnvelopException2(e);
        }
    }


    @RequestMapping(value="/sfroutepushservice",method = RequestMethod.POST)
    @ApiOperation("顺丰路由信息推送")
    public String SFRoutePushServiceNew(@RequestBody String param){
        try {
            logger.info("顺丰路由信息推送，WaybillRoute="+param);
            sfexpressService.SFRoutePushServiceNew(param);
            return "SUCCESS";
        }catch (Exception e){
            logger.error("接收顺丰路由信息推送失败，入参WaybillRoute:"+param);
            //日志文件中记录异常信息
            //返回接口异常信息处理结果
            return "FALSE";
        }
    }

   /* @GetMapping(value = BaseHospitalRequestMapping.KnowledgeArticle.queryById)
    @ApiOperation(value = "根据id查询文章")
    public Envelop queryByCode(
            @ApiParam(name = "id", value = "id", required = true)
            @RequestParam(value = "id", required = true)String id) throws Exception{

        try {
            KnowledgeArticleDO articleDO = knowledgeArticleDao.findById(id).orElse(null);
            KnowledgeArticleUserDO knowledgeArticleUserDO = knowledgeArticleUserDao.findByrelationCodeAndUserAndDel(articleDO.getId(),getUID());
            if (knowledgeArticleUserDO!=null){
                articleDO.setIsUsed(knowledgeArticleUserDO.getUsed());
                articleDO.setKnowledgeArticleUserDO(knowledgeArticleUserDO);
            }
            List<BaseDoctorHospitalDO> doctorHospitalDOS = doctorHospitalDao.findByDoctorCode(articleDO.getCreateUser());
            if (doctorHospitalDOS!=null&&doctorHospitalDOS.size()!=0){
                articleDO.setHospitalName(doctorHospitalDOS.get(0).getOrgName());
                articleDO.setDeptName(doctorHospitalDOS.get(0).getDeptName());
            }

            return success(articleDO);
        }catch (Exception e) {
            return failedException2(e);
        }
    }*/


    @PostMapping(value = BaseHospitalRequestMapping.PatientIM.getSign)
    @ApiOperation(value = "获取微信签名", notes = "获取微信签名")
    public Envelop getSign(@ApiParam(name = "pageUrl", value = "授权页面")
                           @RequestParam(value = "pageUrl", required = true)String pageUrl,
                           @ApiParam(name = "wxId", value = "微信id")
                           @RequestParam(value = "wxId", required = true)String wxId) throws Exception {
        logger.info("pageUrl="+pageUrl);
        logger.info("wxId="+wxId);
        String ticket = wechatInfoService.getJsapi_ticketByToken(wxId);
        WxWechatDO wxWechatDO = wechatDao.findByIdAndStatus(wxId);
        Map<Object, Object> map = new HashMap<Object, Object>();
        if (ticket != null) {
            String noncestr = UUID.randomUUID().toString();
            long timestamp = System.currentTimeMillis() / 1000;
            String url = pageUrl;
            logger.info("getSign.url="+url);
            String str = "jsapi_ticket=" + ticket + "&noncestr=" + noncestr + "&timestamp=" + timestamp + "&url=" + url;
            logger.info("getSign.str="+str);
            // sha1加密
            String signature = SHA1(str);
            map.put("noncestr", noncestr);
            map.put("timestamp", timestamp);
            map.put("signature", signature);
            map.put("appid", wxWechatDO.getAppId());
            return success(PatientRequestMapping.Wechat.api_success,map);
        }
        return failed(PatientRequestMapping.Wechat.api_error);
    }

    @PostMapping(value = BaseHospitalRequestMapping.PatientIM.getEnterpriseSign)
    @ApiOperation(value = "获取企业微信签名", notes = "获取企业微信签名")
    public Envelop getEnterpriseSign(@ApiParam(name = "pageUrl", value = "授权页面")
                           @RequestParam(value = "pageUrl", required = true)String pageUrl,
                           @ApiParam(name = "wxId", value = "微信id")
                           @RequestParam(value = "wxId", required = true)String wxId) throws Exception {
        logger.info("pageUrl="+pageUrl);
        logger.info("wxId="+wxId);
        String ticket = enterpriseService.getEnterpriseJsapi_ticketByToken(wxId);
        String id = "";
        if (wxId.equalsIgnoreCase("xm_zsyy_wx")){
            id = "zsyy";
        }
        WxEnterpriseDO wxEnterpriseDO = wxEnterpriseDao.findById(id).orElse(null);
        Map<Object, Object> map = new HashMap<Object, Object>();
        if (ticket != null) {
            String noncestr = UUID.randomUUID().toString();
            long timestamp = System.currentTimeMillis() / 1000;
            String url = pageUrl;
            logger.info("getSign.url="+url);
            String str = "jsapi_ticket=" + ticket + "&noncestr=" + noncestr + "&timestamp=" + timestamp + "&url=" + url;
            logger.info("getSign.str="+str);
            // sha1加密
            String signature = SHA1(str);
            map.put("noncestr", noncestr);
            map.put("timestamp", timestamp);
            map.put("signature", signature);
            map.put("appid", wxEnterpriseDO.getCorpid());
            return success(PatientRequestMapping.Wechat.api_success,map);
        }
        return failed(PatientRequestMapping.Wechat.api_error);
    }

    @GetMapping(value = BaseHospitalRequestMapping.KnowledgeArticle.setAllCode)
    @ApiOperation(value = "生成所有医生二维码")
    public Envelop setAllCode() throws Exception{
       try {
           qrcodeService.makeAllSpecialistQrcode();
           return success("操作成功");
       }catch (Exception e) {
           return failedException2(e);
       }
    }

    @GetMapping(value = BaseHospitalRequestMapping.KnowledgeArticle.setQrCode)
    @ApiOperation(value = "生成医生二维码")
    public Envelop setQrCode(@ApiParam(name = "doctor", value = "doctor", required = true)
                                 @RequestParam(value = "doctor", required = true)String doctor) throws Exception{

        try {
            String uri = qrcodeService.makeSpecialistQrcode(doctor);
            return success("操作成功",uri);
        } catch (Exception e) {
            return failedException2(e);
        }
    }

    @GetMapping(value = "setXcxQrCode")
    @ApiOperation(value = "生成医生小程序二维码")
    public Envelop setXcxQrCode(@ApiParam(name = "doctor", value = "doctor", required = false)
                             @RequestParam(value = "doctor", required = true)String doctor) throws Exception{

        try {
            String uri = qrcodeService.makeSpecialistXcxQrcode(doctor);
            return success("操作成功",uri);
        } catch (Exception e) {
            return failedException2(e);
        }
    }

    @GetMapping(value = "getUserPhoneApplets")
    @ApiOperation(value = "根据小程序获取用户手机号")
    public Envelop getUserPhoneApplets(@ApiParam(name = "code", value = "code", required = true)
                                @RequestParam(value = "code", required = true)String code) throws Exception{

        try {
            String uri = wechatInfoService.getUserPhoneByApplets(code);
            return success("操作成功",uri);
        } catch (Exception e) {
            return failedException2(e);
        }
    }

    @GetMapping(value = BaseHospitalRequestMapping.KnowledgeArticle.setUrlCode)
    @ApiOperation(value = "生成链接推送")
    public Envelop setUrlCode(@ApiParam(name = "flag", value = "flag", required = true)
                             @RequestParam(value = "flag", required = true)String flag) throws Exception{

        try {
            String uri = qrcodeService.makeUrlQrcode(flag);
            return success("操作成功",uri);
        } catch (Exception e) {
            return failedException2(e);
        }
    }

    @GetMapping(value = BaseHospitalRequestMapping.PatientNoLogin.querySettledRecord)
    @ApiOperation(value = "易联众_查询结算状态")
    public Envelop querySettledRecord(@ApiParam(name = "cardNo", value = "cardNo", required = true)
                             @RequestParam(value = "cardNo", required = true)String cardNo,
                                      @ApiParam(name = "beginDate", value = "beginDate", required = false)
                                      @RequestParam(value = "beginDate", required = false)String beginDate,
                                      @ApiParam(name = "endDate", value = "endDate", required = false)
                                          @RequestParam(value = "endDate", required = false)String endDate,
                                      @ApiParam(name = "queryType", value = "queryType", required = false)
                                          @RequestParam(value = "queryType", required = false)String queryType,
                                      @ApiParam(name = "billSn", value = "billSn", required = false)
                                          @RequestParam(value = "billSn", required = false)String billSn,
                                      @ApiParam(name = "traceNo", value = "traceNo", required = false)
                                          @RequestParam(value = "traceNo", required = false)String traceNo,
                                      @ApiParam(name = "pageNo", value = "页码", required = false)
                                          @RequestParam(value = "pageNo", required = false)String pageNo,
                                      @ApiParam(name = "pageSize", value = "分页大小", required = false)
                                          @RequestParam(value = "pageSize", required = false)String pageSize) throws Exception{

       try {
           String result = ylzPayService.querySettledRecord(cardNo,beginDate,endDate,queryType,billSn,traceNo,pageNo,pageSize);
           logger.info(result);
           return success("操作成功",result);
       }catch (Exception e) {
           return failedException2(e);
       }
    }


    @GetMapping(value = BaseHospitalRequestMapping.PatientNoLogin.paySuccessNotice)
    @ApiOperation(value = "微信支付状态查询")
    public Envelop paySuccessNotice(@ApiParam(name = "userName", value = "userName", required = true)
                                      @RequestParam(value = "userName", required = true)String userName,
                                      @ApiParam(name = "idCard", value = "idCard", required = false)
                                      @RequestParam(value = "idCard", required = false)String idCard,
                                      @ApiParam(name = "phone", value = "phone", required = false)
                                      @RequestParam(value = "phone", required = false)String phone,
                                      @ApiParam(name = "title", value = "title", required = false)
                                      @RequestParam(value = "title", required = false)String title,
                                      @ApiParam(name = "url", value = "url", required = false)
                                      @RequestParam(value = "url", required = false)String url,
                                      @ApiParam(name = "doctorName", value = "doctorName", required = false)
                                      @RequestParam(value = "doctorName", required = false)String doctorName,
                                      @ApiParam(name = "total", value = "总费用", required = false)
                                      @RequestParam(value = "total", required = false)String total,
                                      @ApiParam(name = "miPay", value = "医保支付", required = false)
                                      @RequestParam(value = "miPay", required = false)String miPay,
                                    @ApiParam(name = "selfPay", value = "个人支付", required = false)
                                        @RequestParam(value = "selfPay", required = false)String selfPay,
                                    @ApiParam(name = "orderNo", value = "单据号", required = false)
                                        @RequestParam(value = "orderNo", required = false)String orderNo,
                                    @ApiParam(name = "remark", value = "备注", required = false)
                                        @RequestParam(value = "remark", required = false)String remark) throws Exception{

        try {
            String result = payInfoNoticeService.paySuccessNotice(userName,idCard,phone,title,url,doctorName,total,miPay,selfPay,orderNo,remark);
            logger.info(result);
            return success("操作成功",result);
        } catch (Exception e) {
            return failedException2(e);
        }
    }
    /**
     * 商户回调通知
     * @param request
     * @param response
     * @throws IOException
     * @throws PayException
     */
    @RequestMapping(value = "/ylzSettleRecord")
    public String ylzSettleRecord(HttpServletRequest request, HttpServletResponse response) throws Exception{
        response.setContentType("text/html;charset=utf-8");
        OauthYlzConfigDO oauthYlzConfigDO = oauthYlzConfigDao.findById("ylz_balance_config").orElse(null);
        if(oauthYlzConfigDO==null){
            return "未找到支付配置文件";
        }
        String appId = oauthYlzConfigDO.getAppId();
        String appSecret = oauthYlzConfigDO.getAppKey();
        InputStream inputStream = request.getInputStream();
        String params = StreamUtils.copyToString(inputStream, Charset.forName("UTF-8"));
        logger.info("回调参数：{}", params);
        if (StringUtil.isEmpty(params)) {
            return appId;
        }
        // 参数转换
        ResponseParams<?> encryptRes = JSON.parseObject(params, ResponseParams.class);
        OnepayDefaultClient client = new OnepayDefaultClient("", appId, appSecret, encryptRes.getSignType(), encryptRes.getEncryptType());
        try {
            logger.info("解密前：{}", JSON.toJSONString(encryptRes));
            ResponseParams<?> decryptRes = client.decryptNotifyResponse(encryptRes);
            logger.info("解密后：{}",JSON.toJSONString(decryptRes) );
            JSONObject jsonObject = JSONObject.parseObject(JSON.toJSONString(decryptRes));
            String hsName="核酸";
            WlyyHospitalSysDictDO wlyyHospitalSysDictDO = wlyyHospitalSysDictDao.findById("natItemName").orElse(null);
            if (wlyyHospitalSysDictDO!=null){
                hsName=wlyyHospitalSysDictDO.getDictValue();
            }
            boolean isDecrypt = ("-1".equals(decryptRes.getRespCode()) ? false : true); // 是否解密失败
            if (!isDecrypt) {
                response.getWriter().write("DECRYPT FAILURE");
            } else {
                boolean isVerify = true;
                logger.info("验签结果：{}", isVerify);
                if (!isVerify) {
                    response.getWriter().write("FAILURE");
                } else {
                    JSONObject param = jsonObject.getJSONObject("param");
                    logger.info("param"+params);
                    if (param!=null){
                        JSONObject object = param.getJSONObject("externalMap");
                        String cardNo = object.getString("cardNo");
                        String traceNo = object.getString("traceNo");
                        String channelId = object.getString("channelId");
                        String result = ylzPayService.querySettledRecord(cardNo,null,null,"onlineRecordDetail",null,traceNo,"1","10000");
                        JSONObject jsonObjectTotal = JSONObject.parseObject(result);
                        logger.info("查询在线结算处方信息"+jsonObjectTotal);
                        if (jsonObjectTotal.getString("respCode").equalsIgnoreCase("000000")){
                            JSONObject listParam =  JSONObject.parseObject(jsonObjectTotal.getString("param"));
                            List<WaitPayDetailVO> listWPD = JSONObject.parseArray(listParam.getString("waitPayDetailVOs"),  WaitPayDetailVO.class);
                            if (listWPD!=null&&listWPD.size()!=0){
                                WaitPayDetailVO waitPayDetailVO = listWPD.get(0);
                                String voucherNo = waitPayDetailVO.getVoucherNo();
                                //判断处方
                                List<WlyyPrescriptionDO> prescriptionDOList = prescriptionDao.findByRealOrderList(waitPayDetailVO.getRecipeNo());
                                for (WlyyPrescriptionDO prescriptionDO:prescriptionDOList){
                                    if (prescriptionDO.getStatus()!=30&&prescriptionDO.getStatus()>=20){
                                        String fee=null;
                                        String title = null;
                                        WlyyOutpatientDO wlyyOutpatientDO = outpatientDao.findById(prescriptionDO.getOutpatientId()).orElse(null);
                                        if (wlyyOutpatientDO.getHisStatus()==null){
                                            fee=(prescriptionDO.getDrugFee()+wlyyOutpatientDO.getFee())+"";
                                            if (wxId.equalsIgnoreCase("xm_zsyy_wx")){
                                                title="您在厦门大学附属中山医院有一笔诊察/处方费用已支付完成！结算费用包含本次在线问诊的复诊诊查费："+wlyyOutpatientDO.getFee()+"元。";
                                            }else if (wxId.equalsIgnoreCase("xm_zsyy_wx")){
                                                title="您在厦门大学附属中山医院有一笔诊察/处方费用已支付完成！结算费用包含本次在线问诊的复诊诊查费："+wlyyOutpatientDO.getFee()+"元。";
                                            }

                                        }else {
                                            fee=prescriptionDO.getDrugFee()+"";
                                            if (wxId.equalsIgnoreCase("xm_zsyy_wx")){
                                                title="您在厦门大学附属中山医院有一笔诊察/处方费用已支付完成！";
                                            }
                                        }
                                        String pushPayLog = null;
                                        if (wxId.equalsIgnoreCase("xm_zsyy_wx")){
                                            pushPayLog = payInfoNoticeService.pushPrescriptionPay(wlyyOutpatientDO.getConsumer(),prescriptionDO.getDoctorName(),voucherNo,prescriptionDO.getOutpatientId(),prescriptionDO.getId(),fee,title,null);
                                        }
                                        WlyyPrescriptionLogDO prescriptionLogDO = new WlyyPrescriptionLogDO();
                                        prescriptionLogDO.setCreateTime(new Date());
                                        prescriptionLogDO.setStatus(30);
                                        prescriptionLogDO.setOutpatientId(prescriptionDO.getOutpatientId());
                                        prescriptionLogDO.setPrescriptionCode(prescriptionDO.getId());
                                        prescriptionLogDO.setUserCode(prescriptionDO.getPatientCode());
                                        prescriptionLogDO.setUserName(prescriptionDO.getPatientName());
                                        prescriptionLogDO.setUserType(1);
                                        prescriptionLogDO.setDatajson("处方结算");
                                        prescriptionLogDao.save(prescriptionLogDO);
                                        /*prescriptionService.electronicPrescriptionReceiving(wlyyOutpatientDO.getId());*/
                                        BusinessOrderDO orderDO = businessOrderDao.selectByRelationCode(prescriptionDO.getId());
                                        orderDO.setStatus(1);
                                        businessOrderDao.save(orderDO);
                                        for (WaitPayDetailVO waitPayDetailVO1:listWPD){
                                            if (waitPayDetailVO1.getItemName().equalsIgnoreCase("互联网医院复诊诊查费")){
                                                WlyyOutpatientDO wlyyOutpatientDO1 = outpatientDao.findByRealOrder(waitPayDetailVO1.getRecipeNo());
                                                if (wlyyOutpatientDO1!=null){
                                                    wlyyOutpatientDO1.setHisStatus(1);
                                                    outpatientDao.save(wlyyOutpatientDO1);
                                                }
                                            }
                                        }
                                        logger.info("处方结算成功"+pushPayLog+"====="+waitPayDetailVO.getRecipeNo());
                                    }
                                }
                            }
                            for (WaitPayDetailVO waitPayDetailVO:listWPD){
                                if (waitPayDetailVO.getItemName().contains(hsName)){
                                    System.out.println("hsName:"+hsName);
                                    //判断检查订单
                                    List<BaseNatAppointmentDO> baseNatAppointmentDOS = baseNatAppointmentDao.findByRealOrderList(waitPayDetailVO.getRecipeNo());
                                    for (BaseNatAppointmentDO natAppointmentDO:baseNatAppointmentDOS){

                                        if (channelId.contains("WX")&&natAppointmentDO.getPayStatus().equalsIgnoreCase("0")){
                                            //发送支付成功通知
                                            String pushPayLog = null;
                                            logger.info("支付完成开始推送模板消息==="+natAppointmentDO.getName());
                                            String fee = waitPayDetailVO.getFee();
                                            if (wxId.equalsIgnoreCase("xm_zsyy_wx")){
                                                String title="您在厦门大学附属中山医院有一笔交易已支付完成！";
                                                pushPayLog = payInfoNoticeService.pushPrescriptionPayAndHsjc(natAppointmentDO.getPatientId(),natAppointmentDO.getDoctorName(),waitPayDetailVO.getVoucherNo(),natAppointmentDO.getId()+"",fee,title,null,waitPayDetailVO.getRecipeNo());
                                            }
                                            BasePatientDO patientDO = patientDao.findById(natAppointmentDO.getPatientId()).orElse(null);
                                            //发送预约成功通知
                                            String name= patientDO.getName();
                                            String idcard = patientDO.getIdcard();
                                            String mobile = patientDO.getMobile();
                                            String url = "https://hlwyy.xmzsh.com/hlwyy/ims-wx/#/nucleicTest/detail?id="+natAppointmentDO.getId();
                                            String date = DateUtil.dateToStrLong(natAppointmentDO.getAppointmentTime());
                                            WlyyHospitalSysDictDO hospitalSysDictDO = wlyyHospitalSysDictDao.findById("natConfigTestNew").orElse(null);
                                            String addres = "我院五号楼北侧（急诊部后侧）";
                                            String timeDes = "6-8小时";
                                            if (hospitalSysDictDO!=null){
                                                com.alibaba.fastjson.JSONArray array = com.alibaba.fastjson.JSONArray.parseArray(hospitalSysDictDO.getDictValue());
                                                for (int i=0;i<array.size();i++){
                                                    JSONObject object1 = array.getJSONObject(i);
                                                    String chargeCode = object1.getString("chargeCode");
                                                    if (natAppointmentDO.getChargeCode().equalsIgnoreCase(chargeCode)){
                                                        addres = "我院发热门诊";
                                                        timeDes = "2小时";
                                                    }
                                                }
                                            }
                                            String first = "尊敬的用户"+natAppointmentDO.getName()+"，您已完成线上自助核酸检测预约申请";
                                            String contentMsg = "申请人："+natAppointmentDO.getName()+"\r\n 预约时间："+date+" \r\n发票流水号："+waitPayDetailVO.getRecipeNo();
                                            String remark="1、请您持核酸预约申请信息和发票流水号、医保卡/就诊卡/电子健康卡，准时至"+addres+"核酸检测点领取标本试管窗口绑定检测。\r\n" +
                                                    "2、核酸检测标本采集"+timeDes+"后出具报告。请关注厦门大学附属中山医院微信公众号查询；如需打印，请至厦门大学附属中山医院核酸检测点自助机打印。";
                                            String responseMsg="";
                                            if ("xm_zsyy_wx".equalsIgnoreCase(wxId)) {

                                                responseMsg = entranceService.ehospitalNotice(
                                                        name,
                                                        idcard,
                                                        mobile,
                                                        first,
                                                        url,
                                                        contentMsg,
                                                        remark);
                                                logger.info("中山发送模板消息返回结果="+responseMsg);
                                                System.out.println("结束发送模板消息");
                                                WlyyHttpLogDO wlyyHttpLogDO = new WlyyHttpLogDO();
                                                wlyyHttpLogDO.setRequest(url);
                                                wlyyHttpLogDO.setName("核酸检测模板消息推送");
                                                wlyyHttpLogDO.setCode(natAppointmentDO.getId().toString());
                                                wlyyHttpLogDO.setCreateTime(new Date());
                                                wlyyHttpLogDO.setRequest(url);
                                                wlyyHttpLogDO.setResponse(responseMsg);
                                                wlyyHttpLogDao.save(wlyyHttpLogDO);
                                            }
                                        }else if (channelId.contains("ALI")){
                                            if (natAppointmentDO.getPayStatus().equalsIgnoreCase("0")){
                                                logger.info("支付宝发送模板消息开始111");
                                                String url = "https://hlwyy.xmzsh.com/hlwyy/ims-wx/#/nucleicTest/detail?id="+natAppointmentDO.getId();
                                                String date = DateUtil.dateToStrLong(natAppointmentDO.getAppointmentTime());
                                                prescriptionService.sendAlipayMessage(natAppointmentDO.getPatientId(),"3",waitPayDetailVO.getFee(),url,date,waitPayDetailVO.getRecipeNo(),natAppointmentDO.getId());
                                                logger.info("支付宝发送模板消息结束1111");
                                                logger.info("支付宝发送模板消息结束22222");
                                                prescriptionService.sendAlipayMessage(natAppointmentDO.getPatientId(),"13",waitPayDetailVO.getFee(),url,date,waitPayDetailVO.getRecipeNo(),natAppointmentDO.getId());
                                                logger.info("支付宝发送模板消息结束2222222");
                                            }
                                        }
                                        natAppointmentDO.setPayStatus("1");
                                        baseNatAppointmentDao.save(natAppointmentDO);

                                    }
                                }
                                if (waitPayDetailVO.getItemName().equalsIgnoreCase("互联网医院复诊诊查费")){
                                    logger.info(waitPayDetailVO.getRecipeNo());
                                    List<WlyyPrescriptionDO> prescriptionDOList = prescriptionDao.findByRealOrderList(waitPayDetailVO.getRecipeNo());
                                    if (prescriptionDOList==null||prescriptionDOList.size()==0){
                                        WlyyOutpatientDO wlyyOutpatientDO = outpatientDao.findByRealOrder(waitPayDetailVO.getRecipeNo());
                                        if (wlyyOutpatientDO!=null){
                                            if (wlyyOutpatientDO.getHisStatus()==null){
                                                String fee=wlyyOutpatientDO.getFee()+"";
                                                if (wxId.equalsIgnoreCase("xm_zsyy_wx")){
                                                    String title="您在厦门大学附属中山医院有一笔诊察/处方费用已支付完成！";
                                                    String url = "https://hlwyy.xmzsh.com/ims-wx/index.html#/returnVisit/record?outpatientId="+wlyyOutpatientDO.getId()+"";
                                                    payInfoNoticeService.pushPrescriptionPay(wlyyOutpatientDO.getConsumer(),wlyyOutpatientDO.getDoctorName(),waitPayDetailVO.getVoucherNo(),null,null,fee,title,url);
                                                }
                                                outpatientDao.updateHisStatusById(wlyyOutpatientDO.getId(),1);
                                                logger.info("更新门诊结算状态");
                                            }
                                        }
                                        /*prescriptionService.electronicPrescriptionReceiving(wlyyOutpatientDO.getId());*/
                                    }else {
                                        WlyyOutpatientDO wlyyOutpatientDO1 = outpatientDao.findByRealOrder(waitPayDetailVO.getRecipeNo());
                                        if (wlyyOutpatientDO1!=null){
                                            wlyyOutpatientDO1.setHisStatus(1);
                                            outpatientDao.save(wlyyOutpatientDO1);
                                            logger.info("更新门诊结算状态");
                                        }
                                    }
                                }
                                prescriptionDao.updateStatusByRealOrder(waitPayDetailVO.getRecipeNo(),30,new Date());

                            }
                            logger.info("更新系统处方支付状态");
                        }
                    }
                    return "SUCCESS";
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return appId;
    }
    @GetMapping(value = BaseHospitalRequestMapping.PatientNoLogin.findHisPatientInfo)
    @ApiOperation(value = "查询his门诊病人基本信息")
    public Envelop findHisPatientInfo(@ApiParam(name = "idcard", value = "idcard", required = false)
                                      @RequestParam(value = "idcard", required = false)String idcard,
                                      @ApiParam(name = "patientName", value = "patientName", required = false)
                                      @RequestParam(value = "patientName", required = false)String patientName,
                                      @ApiParam(name = "phoneNum", value = "phoneNum", required = false)
                                      @RequestParam(value = "phoneNum", required = false)String phoneNum,
                                      @ApiParam(name = "patientId", value = "patientId", required = false)
                                      @RequestParam(value = "patientId", required = false)String patientId,
                                      @ApiParam(name = "admitNum", value = "admitNum", required = false)
                                      @RequestParam(value = "admitNum", required = false)String admitNum,
                                      @ApiParam(name = "ybcard", value = "ybcard", required = false)
                                      @RequestParam(value = "ybcard", required = false)String ybcard,
                                      @ApiParam(name = "demoFlag", value = "是否demo", required = false)
                                      @RequestParam(value = "demoFlag", required = false)boolean demoFlag) throws Exception{
        JSONArray result = entranceService.BS10008(idcard,patientName,phoneNum,patientId,admitNum,ybcard,false);
        return success("操作成功",result.toString());
    }


    @PostMapping(value = "/BS15054")
    @ApiOperation(value = "  查询待结算金额")
    public ObjEnvelop BS10138(
            @ApiParam(name = "pid", value = "病人id")
            @RequestParam(value = "pid", required = false) String pid,
            @ApiParam(name = "realorder", value = "处方号")
            @RequestParam(value = "realorder", required = false) String realorder) throws Exception {
        net.sf.json.JSONObject obj = entranceService.BS15054(pid, realorder,false);
        return ObjEnvelop.getSuccess(CommonContant.Message.GET_SUCCESS,obj);
    }
    @PostMapping(value = "/testSFHis")
    @ApiOperation(value = "测试快递下单并更新his")
    public void testSFHis(@ApiParam(name = "prescriptionId", value = "处方id")
                              @RequestParam(value = "prescriptionId", required = false) String prescriptionId,
                          @ApiParam(name = "demoflag", value = "是否测试")
                          @RequestParam(value = "demoflag", required = false) boolean demoflag) throws Exception{

        WlyyPrescriptionDO wlyyPrescriptionDO = prescriptionDao.findById(prescriptionId).orElse(null);
        //判断是否是快递如果是则下物流单
        List<WlyyPrescriptionExpressageDO> expressList=prescriptionExpressageDao.findByOutpatientId(wlyyPrescriptionDO.getOutpatientId());
        if (null!=expressList&&expressList.size()>0){
            WlyyPrescriptionExpressageDO wlyyPrescriptionExpressageDO = expressList.get(0);
            if (null!=wlyyPrescriptionExpressageDO&&wlyyPrescriptionExpressageDO.getOneselfPickupFlg()==1){
                String condition ="";
                if (org.apache.commons.lang3.StringUtils.isNoneBlank(wlyyPrescriptionDO.getAdmNo())){
                    condition = " t.JZXH = '"+wlyyPrescriptionDO.getAdmNo()+"' and ";
                }
                //同步his写入自取信息
                String updatesql = "update v_ms_dd01 t set t.PSFS = 0 ,t.FKZT=1 ," +
                        " t.YFSB = '"+wlyyPrescriptionExpressageDO.getHospitalCode()+"'"+
                        "where "+condition+" t.CFSB ='"+wlyyPrescriptionDO.getRealOrder()+"'";
                ykyyEntranceService.updateHisStatus(updatesql);
                logger.info("自取写入更新his");
            }else {
                //向顺丰下单
                logger.info("向顺丰快递下单");
                String admNo = wlyyPrescriptionDO.getAdmNo();
                String realOrder = wlyyPrescriptionDO.getRealOrder();
                logger.info("admNo:"+admNo+"-----realorder:"+realOrder);
                Object sfResult = new Object();
                if(demoflag){
                    sfResult = "{\"mailNo\":\"SF1041297002449\",\"mailtype\":\"标准快递\",\"destcode\":\"592\",\"j_name\":\"厦门大学附属中山医院\",\"j_provinceName\":\"福建省\",\"j_cityName\":\"厦门市\",\"j_townName\":\"思明区\",\"j_address\":\"湖滨南路201-209号\",\"j_phone\":\"4003008888\",\"d_name\":\"陈筑城\",\"d_provinceName\":\"福建省\",\"d_cityName\":\"厦门市\",\"d_townName\":\"思明区\",\"d_address\":\"软件园二期望海路55号\",\"d_phone\":\"18205968888\",\"express_type\":11,\"pay_method\":2,\"receive_time\":\"\",\"dispensaryType\":\"1\"}";
                }else {
                    if (org.apache.commons.lang3.StringUtils.isNotBlank(realOrder)){
                        sfResult = prescriptionService.getSFExpressInfoNew(admNo,realOrder,"");
                    }
                }

                if (!"".equals(sfResult)) {
                    JSONObject json = JSONObject.parseObject(sfResult.toString());
                    String sfOrder =  json.getString("mailNo");
                    logger.info("---获取订单号为："+sfOrder);
                    String condition ="";
                    if (org.apache.commons.lang3.StringUtils.isNoneBlank(wlyyPrescriptionDO.getAdmNo())){
                        condition = " t.JZXH = '"+wlyyPrescriptionDO.getAdmNo()+"' and ";
                    }
                    String updatesql = "update v_ms_dd01 t set t.PSFS = 1 ,t.FKZT=1 ,t.KDDH ='"+sfOrder+"',t.SJR = '"+wlyyPrescriptionExpressageDO.getName()+"' ," +
                            " t.SJRDH = '"+wlyyPrescriptionExpressageDO.getMobile()+"' ,"+
                            " t.SJRDZ = '"+wlyyPrescriptionExpressageDO.getAddress()+"' ,"+
                            " t.YFSB = 6"+
                            " where "+condition+"  t.CFSB ='"+realOrder+"'";
                    ykyyEntranceService.updateHisStatus(updatesql);
                    logger.info("更新his成功");
                }
            }
        }
    }
    @PostMapping(value = "/getWXUserInfo")
    @ApiOperation(value = "获取微信用户信息")
    public ObjEnvelop getWXUserInfo(
            @ApiParam(name = "patient", value = "病人id")
            @RequestParam(value = "patient", required = false) String patient) throws Exception {

        return qrcodeService.getWXUserInfo(patient);
    }
    @PostMapping(value = "/getWXGZHQrcode")
    @ApiOperation(value = "生成微信公众号二维码")
    public ObjEnvelop createWXGZHQrcode(@ApiParam(name = "fileName", value = "文件名称")
                                         @RequestParam(value = "fileName", required = false) String fileName) throws Exception {
        ObjEnvelop objEnvelop= new ObjEnvelop();
        objEnvelop.setObj(qrcodeService.createPublicQrcode(fileName));
        return objEnvelop;
    }
    @PostMapping(value = "/findWXGZHQrcode")
    @ApiOperation(value = "查询微信公众号二维码")
    public MixEnvelop findWXGZHQrcode(@ApiParam(name = "orgCode", value = "医院code")
                                     @RequestParam(value = "orgCode", required = false) String orgCode) throws Exception {
        return qrcodeService.getWXGZHQrcode(orgCode);
    }
    @PostMapping(value = "/saveCheckHttpLog")
    @ApiOperation(value = "添加操作日志")
    public Envelop saveCheckHttpLog(@ApiParam(name = "code", value = "code")
                                      @RequestParam(value = "code", required = false) String code,
                                       @ApiParam(name = "name", value = "name")
                                       @RequestParam(value = "name", required = false) String name,
                                       @ApiParam(name = "patient", value = "patient")
                                           @RequestParam(value = "patient", required = false) String patient,
                                       @ApiParam(name = "doctor", value = "doctor")
                                           @RequestParam(value = "doctor", required = false) String doctor,
                                       @ApiParam(name = "request", value = "request")
                                           @RequestParam(value = "request", required = false) String request,
                                       @ApiParam(name = "response", value = "response")
                                           @RequestParam(value = "response", required = false) String response,
                                       @ApiParam(name = "status", value = "status")
                                           @RequestParam(value = "status", required = false) String status
                                       ) throws Exception {
        wlyyHttpLogService.saveHttpLog(code,name,patient,doctor,request,response,status);
        return success("添加成功");
    }
    @PostMapping(value = "/findHttpLog")
    @ApiOperation(value = "查询接口操作日志")
    public MixEnvelop findHttpLog(@ApiParam(name = "startTime", value = "startTime")
                                    @RequestParam(value = "startTime", required = false) String startTime,
                                    @ApiParam(name = "endTime", value = "endTime")
                                    @RequestParam(value = "endTime", required = false) String endTime,
                               @ApiParam(name = "interfaceName", value = "interfaceName")
                                   @RequestParam(value = "interfaceName", required = false) String interfaceName,
                                    @ApiParam(name = "patient", value = "patient")
                                    @RequestParam(value = "patient", required = false) String patient,
                                    @ApiParam(name = "doctor", value = "doctor")
                                    @RequestParam(value = "doctor", required = false) String doctor,
                               @ApiParam(name = "page", value = "page")
                                   @RequestParam(value = "page", required = false) Integer page,
                               @ApiParam(name = "pageSize", value = "pageSize")
                                   @RequestParam(value = "pageSize", required = false) Integer pageSize
    ) {

        try {
            return wlyyHttpLogService.findLog(startTime,endTime,interfaceName,patient,doctor,page,pageSize);
        } catch (Exception e) {
            return failedMixEnvelopException2(e);
        }
    }


    @PostMapping(value = BaseHospitalRequestMapping.PatientNoLogin.findHospitalInfo)
    @ApiOperation(value = "查询医院统计信息", notes = "查询医院统计信息")
    public ObjEnvelop selectHospitalInfo(@ApiParam(name = "doctorId", value = "医生id")
                                          @RequestParam(value = "doctorId", required = true)String doctorId,
                                         @ApiParam(name = "orgCode", value = "医院code")
                                         @RequestParam(value = "orgCode", required = true)String orgCode) throws Exception{


        try {
            JSONObject object = prescriptionService.selectHospitalInfo(doctorId,orgCode);
            String date = DateUtil.getStringDateShort();
            //服务评分
            JSONObject jsonObject = statisticsEsService.getScoreList(null,date,2,"350200","4");
            if (jsonObject!=null){
                com.alibaba.fastjson.JSONArray array  = jsonObject.getJSONArray("resultList");
                if (array!=null&&array.size()!=0){
                    JSONObject object1 = array.getJSONObject(0);
                    object.put("scoreRate",object1.getString("scoreRate"));
                }else {
                    object.put("scoreRate",null);
                }
            }else {
                object.put("scoreRate",null);
            }
            return success(object);
        } catch (Exception e) {
            return failedObjEnvelopException2(e);
        }
    }


    @PostMapping(value = BaseHospitalRequestMapping.PatientNoLogin.synYktZxPrice)
    @ApiOperation(value = "同步眼科通医生价格", notes = "同步眼科通医生价格")
    public Envelop synYktZxPrice(@ApiParam(name = "idcard", value = "医生身份证")
                                         @RequestParam(value = "idcard", required = false)String idcard,
                                         @ApiParam(name = "price", value = "价格")
                                         @RequestParam(value = "price", required = false)Integer price,
                                    @ApiParam(name = "type", value = "类型")
                                        @RequestParam(value = "type", required = false)Integer type,
                                    @ApiParam(name = "flag", value = "同步所有医生价格")
                                        @RequestParam(value = "flag", required = false)String flag) throws Exception{
        String object = prescriptionService.synYktZxPrice(idcard,price,type,flag);
        return success(object);
    }
    @GetMapping(value = BaseHospitalRequestMapping.PatientNoLogin.findHospitalConsultInfo)
    @ApiOperation(value = "根据疾病查询咨询数量", notes = "根据疾病查询咨询数量")
    public ListEnvelop findHospitalConsultInfo(
                                                  @ApiParam(name = "startTime", value = "开始时间 yyyy-MM-dd hh:mm:ss")
                                                  @RequestParam(value = "startTime", required = false)String startTime,
                                              @ApiParam(name = "endTime", value = "结束时间 yyyy-MM-dd hh:mm:ss")
                                                  @RequestParam(value = "endTime", required = false)String endTime) throws Exception{


        try {
            return success(prescriptionService.findOutpatientAndPatient(startTime,endTime));
        } catch (Exception e) {
            return failedListEnvelopException2(e);
        }
    }

    /**
     * 获取微信支付参数
     *
     * @param relationCode 关联code
     * @return
     * @throws Exception
     */
    @RequestMapping(value = "selectOrderByRelationCode", method = RequestMethod.POST)
    @ApiOperation("获取微信支付参数")
    public ObjEnvelop selectOrderByRelationCode(
            @ApiParam(name = "relationCode", value = "relationCode", required = true)
            @RequestParam(required = true)String relationCode,
            @ApiParam(name = "tradeType", value = "tradeType", required = false)
            @RequestParam(required = false)String tradeType,
            @ApiParam(name = "appletCode", value = "appletCode", required = false)
            @RequestParam(value = "appletCode",required = false)String appletCode) throws Exception {
        try {
            if ("xm_tasy_wx".equalsIgnoreCase(wxId)){
               return ObjEnvelop.getSuccess("操作成功",tasyNatService.selectByRelationCode(relationCode));
            }
            return ObjEnvelop.getSuccess("ok",businessOrderService.selectOrderByRelationCode(relationCode,tradeType,wxId,payFlag,appletCode));
        } catch (Exception e) {
            return ObjEnvelop.getError(e.getMessage());
        }
    }

    @GetMapping(value = BaseHospitalRequestMapping.Prescription.prescriptionPay)
    @ApiOperation(value = "处方支付", notes = "处方支付")
    public ObjEnvelop findPatientCard(@ApiParam(name = "code", value = "处方code")
                                      @RequestParam(value = "code", required = true)String code,
                                      @ApiParam(name = "price", value = "支付费用")
                                      @RequestParam(value = "price", required = false)Double price,
                                      @ApiParam(name = "tradeType", value = "支付方式")
                                      @RequestParam(value = "tradeType", required = false)String tradeType,
                                      @ApiParam(name = "appletCode", value = "appletCode", required = false)
                                          @RequestParam(value = "appletCode",required = false)String appletCode)throws Exception {
        try {
            return success("ok",ykyyPrescriptionService.savePrescriptionOrder(code,price,tradeType,wxId,appletCode));
        } catch (Exception e) {
            return ObjEnvelop.getError(e.getMessage());
        }
    }

    @GetMapping(value = BaseHospitalRequestMapping.PatientNoLogin.findDictLists)
    @ApiOperation(value = "查询基础号别字典", notes = "查询基础号别字典")
    public ListEnvelop findDictLists() throws Exception{


        try {
            return success(baseDoctorService.findChargeDicts());
        } catch (Exception e) {
            return failedListEnvelopException2(e);
        }
    }
    @GetMapping("/deleteChargeDict")
    @ApiOperation(value = "删除基础号别字典", notes = "删除基础号别字典")
    public Envelop deleteChargeDict(@ApiParam(name = "id", value = "id")
                                            @RequestParam(value = "id", required = true)String id,
                                        @ApiParam(name = "del", value = "1正常0删除")
                                            @RequestParam(value = "del", required = false)String del) throws Exception{


        try {
            baseDoctorService.deleteChargeDict(id,del);
            return success("操作成功");
        } catch (Exception e) {
            return failedException2(e);
        }
    }
    @GetMapping(value = BaseHospitalRequestMapping.PatientNoLogin.findWorkDoctorCount)
    @ApiOperation(value = "查询医生排版数量", notes = "查询医生排版数量")
    public ObjEnvelop<JSONObject> findWorkDoctorCount(
            @ApiParam(name = "nowTime", value = "当前时间 yyyy-MM-dd hh:mm:ss")
            @RequestParam(value = "nowTime", required = false)String nowTime,
            @ApiParam(name = "orgCode", value = "医院code")
            @RequestParam(value = "orgCode", required = false)String orgCode) throws Exception{

        try {
            return success(prescriptionService.getWorkDoctorCount(nowTime,orgCode));
        }catch (Exception e) {
            return failedObjEnvelopException2(e);
        }
    }
    @GetMapping(value = BaseHospitalRequestMapping.PatientNoLogin.findAllDict)
    @ApiOperation(value = "查询配置字典所有项", notes = "查询配置字典所有项")
    public ListEnvelop<WlyyHospitalSysDictDO> findAllDict() throws Exception{


        try {
            return success(prescriptionService.findAllDict());
        } catch (Exception e) {
            return failedListEnvelopException2(e);
        }
    }
    @GetMapping(value = BaseHospitalRequestMapping.PatientNoLogin.findDictById)
    @ApiOperation(value = "根据id查询配置字典", notes = "根据id查询配置字典")
        public Envelop findDictById(@ApiParam(name = "dictId", value = "dictId")
                                                                      @RequestParam(value = "dictId", required = true)String dictId) throws Exception{


        try {
            return success(prescriptionService.findDictById(dictId));
        } catch (Exception e) {
            return failedException2(e);
        }
    }
    @GetMapping(value = BaseHospitalRequestMapping.PatientNoLogin.updateDictById)
    @ApiOperation(value = "根据id修改配置字典", notes = "根据id修改配置字典")
    public Envelop updateDictById(@ApiParam(name = "dictId", value = "dictId")
                                @RequestParam(value = "dictId", required = true)String dictId,
                                  @ApiParam(name = "dictValue", value = "dictId")
                                  @RequestParam(value = "dictValue", required = true)String dictValue) throws Exception{


        try {
            return success(prescriptionService.updateDictById(dictId,dictValue));
        }catch (Exception e) {
            return failedException2(e);
        }
    }
    @GetMapping(value = BaseHospitalRequestMapping.PatientNoLogin.findDictByCode)
    @ApiOperation(value = "根据id修改配置字典", notes = "根据id修改配置字典")
    public ListEnvelop findDictByCode(@ApiParam(name = "dictCode", value = "dictCode")
                                  @RequestParam(value = "dictCode", required = true, defaultValue = "isDoctorWork")String dictCode) throws Exception{


        try {
            return success(prescriptionService.findSysByDictCode(dictCode));
        }catch (Exception e) {
            return failedListEnvelopException2(e);
        }
    }
    @GetMapping(value = BaseHospitalRequestMapping.PatientIM.getDoctorConsultCount)
    @ApiOperation(value = "医生端：查询会话视频邀请状态", notes = "医生端：查询会话视频邀请状态")
    public Envelop getDoctorConsultCount(@ApiParam(name = "doctorids", value = "会话ID")
                                         @RequestParam(value = "doctorids",required = true) String doctorids)throws Exception  {
        return success("查询成功",imService.getDoctorConsultCount(doctorids));

    }
    @ApiOperation("医生评论展示")
    @PostMapping(value= BaseHospitalRequestMapping.UserMessage.showMessage)
    public Envelop showMessage(@ApiParam(name = "doctor", value = "doctor", required = false)
                               @RequestParam(value = "doctor", required = false)String doctor,
                               @ApiParam(name = "showAll", value = "showAll", required = false)
                               @RequestParam(value = "showAll", required = false)String showAll,
                               @ApiParam(name = "showAllType", value = "showAllType", required = false)
                               @RequestParam(value = "showAllType", required = false)String showAllType,
                               @ApiParam(name = "beginTime", value = "beginTime", required = false)
                               @RequestParam(value = "beginTime", required = false)String beginTime,
                               @ApiParam(name = "endTime", value = "endTime", required = false)
                               @RequestParam(value = "endTime", required = false)String endTime,
                               @ApiParam(name = "patient", value = "patient", required = false)
                                   @RequestParam(value = "patient", required = false)String patient,
                               @ApiParam(name = "page", value = "第几页，从1开始", required = true, defaultValue = "1")
                               @RequestParam(value = "page", required = true,defaultValue = "1")Integer page,
                               @ApiParam(name = "pageSize", value = "每页分页大小", required = true, defaultValue = "10")
                               @RequestParam(value = "pageSize", required = true,defaultValue = "10")Integer pageSize,
                               @ApiParam(name = "isShow", value = "是否显示（1显示0不显示）", required = false)
                                   @RequestParam(value = "isShow", required = false)Integer isShow){

        try {
            return baseUserMsgService.getMessage(doctor,showAll,showAllType,beginTime,endTime,patient,page,pageSize,isShow);
        } catch (Exception e) {
            return failedException2(e);
        }
    }
    @GetMapping(value = BaseHospitalRequestMapping.KnowledgeArticle.searchKnowledgePageList)
    @ApiOperation(value = "获取文章列表")
    public Envelop searchKnowledgePageList(
            @ApiParam(name = "fields", value = "返回的字段，为空返回全部字段")
            @RequestParam(value = "fields", required = false) String fields,
            @ApiParam(name = "filters", value = "过滤器，为空检索所有条件")
            @RequestParam(value = "filters", required = false) String filters,
            @ApiParam(name = "sorts", value = "排序，规则参见说明文档")
            @RequestParam(value = "sorts", required = false) String sorts,
            @ApiParam(name = "page", value = "第几页，从1开始", required = true, defaultValue = "1")
            @RequestParam(value = "page", required = true,defaultValue = "1")Integer page,
            @ApiParam(name = "pageSize", value = "每页分页大小", required = true, defaultValue = "10")
            @RequestParam(value = "pageSize", required = true,defaultValue = "10")Integer pageSize)throws Exception{

        try {
            if(org.apache.commons.lang.StringUtils.isBlank(filters)){
                filters=filters+"del=1";
            }else{
                filters=filters+";del=1";
            }

            List<KnowledgeArticleDO> list  = knowledgeArticleService.search(fields,filters,sorts,page,pageSize);
            for (KnowledgeArticleDO knowledgeArticleDO:list){
                List<BaseDoctorHospitalDO> doctorHospitalDOS = doctorHospitalDao.findByDoctorCode(knowledgeArticleDO.getCreateUser());
                if (doctorHospitalDOS!=null&&doctorHospitalDOS.size()!=0){
                    BaseDoctorHospitalDO doctorHospitalDO = doctorHospitalDOS.get(0);
                    knowledgeArticleDO.setDeptName(doctorHospitalDO.getDeptName());
                    knowledgeArticleDO.setHospitalName(doctorHospitalDO.getOrgName());
                }
                KnowledgeArticleUserDO knowledgeArticleUserDO = knowledgeArticleUserDao.findByrelationCodeAndUserAndDel(knowledgeArticleDO.getId(),getUID());
                if (knowledgeArticleUserDO!=null){
                    if (knowledgeArticleUserDO.getUsed()!=null&&knowledgeArticleUserDO.getUsed()==1){
                        knowledgeArticleDO.setIsUsed(1);
                    }
                }
            }
            List<KnowledgeArticleDO> totals  = knowledgeArticleService.search(fields,filters,sorts);

            JSONObject result = new JSONObject();
            result.put("total",totals.size());
            result.put("detailModelList",list);

            return success(result);
        }catch (Exception e) {
            return failedException2(e);
        }
    }
    @GetMapping(value = BaseHospitalRequestMapping.Prescription.popularityIncrease)
    @ApiOperation(value = "医生人气值增长")
    public Envelop popularityIncrease (
            @ApiParam(name = "doctor", value = "医生id")
            @RequestParam(value = "doctor", required = false) String doctor) throws Exception {

        try {
            BaseDoctorDO baseDoctorDO=baseDoctorService.popularityIncrease(doctor);
            return  success("操作成功",baseDoctorDO);
        } catch (Exception e) {
            return failedException2(e);
        }
    }
    @ApiOperation("查询赠送锦旗")
    @PostMapping(value= BaseHospitalRequestMapping.DoctorBanner.getBanner)
    public Envelop getBanners(@ApiParam(name = "doctor", value = "doctor", required = false)
                              @RequestParam(value = "doctor", required = false)String doctor){

        try {
            JSONObject jsonObject = baseBannerDoctorService.getDoctorBanners(doctor);
            return success(jsonObject);
        }catch (Exception e) {
            return failedException2(e);
        }
    }
    @GetMapping(value = BaseHospitalRequestMapping.Prescription.findDeptByHospital)
    @ApiOperation(value = "查询机构底下部门", notes = "查询机构底下部门")
    public ListEnvelop findDeptByHospital(@ApiParam(name = "orgCode", value = "机构code")
                                          @RequestParam(value = "orgCode", required = true)String orgCode,
                                          @ApiParam(name = "dept", value = "需要置顶部门")
                                          @RequestParam(value = "dept", required = false)String dept,
                                          @ApiParam(name = "consultDeptFlag", value = "1为查询开通服务部门")
                                          @RequestParam(value = "consultDeptFlag", required = false)String consultDeptFlag) {

        try {
            return success(prescriptionService.findDeptByHospital(orgCode,dept,consultDeptFlag));
        }catch (Exception e) {
            return failedListEnvelopException2(e);
        }
    }
    @GetMapping(value = BaseHospitalRequestMapping.KnowledgeArticle.getArticleGroup)
    @ApiOperation(value = "查询分类")
    public MixEnvelop getGroup(){

        try {
            MixEnvelop envelop = knowledgeCategoryService.findAllGroup();
            return envelop;
        }catch (Exception e) {
            return failedMixEnvelopException2(e);
        }

    }
    @PostMapping(value = BaseHospitalRequestMapping.KnowledgeArticle.findArticleByCategoryAndName)
    @ApiOperation(value = "查询文章")
    public MixEnvelop findArticleByCategoryAndName(@ApiParam(name = "categoryFirst", value = "一级分类code")
                                                   @RequestParam(value = "categoryFirst",required = false)String categoryFirst,
                                                   @ApiParam(name = "categorySecond", value = "二级分类code")
                                                   @RequestParam(value = "categorySecond",required = false)String categorySecond,
                                                   @ApiParam(name = "keyWords", value = "关键词")
                                                   @RequestParam(value = "keyWords",required = false)String keyWords,
                                                   @ApiParam(name = "page", value = "当前页")
                                                   @RequestParam(value = "page",required = false)Integer page,
                                                   @ApiParam(name = "pageSize", value = "分页大小）")
                                                   @RequestParam(value = "pageSize",required = false)Integer pageSize)throws Exception {


        try {
            MixEnvelop mixEnvelop=knowledgeArticleService.findArticleByCategoryAndName(categoryFirst,categorySecond,keyWords,page,pageSize);
            return mixEnvelop;
        }catch (Exception e) {
            return failedMixEnvelopException2(e);
        }
    }
    @GetMapping(value = BaseHospitalRequestMapping.Prescription.findAllHospital)
    @ApiOperation(value = "查询所有机构", notes = "查询所有机构")
    public ListEnvelop findAllHospital(@ApiParam(name = "level", value = "医院等级")
                                       @RequestParam(value = "level", required = false)Integer level,
                                       @ApiParam(name = "keyWord", value = "名字关键字")
                                       @RequestParam(value = "keyWord", required = false)String keyWord) {

        try {
            return success(prescriptionService.findAllHospital(level,keyWord));
        }catch (Exception e) {
            return failedListEnvelopException2(e);
        }
    }
    @PostMapping(value = BaseHospitalRequestMapping.Prescription.appointmentRevisitOnDoor)
    @ApiOperation(value = "上门复诊", notes = "上门复诊")
    public ObjEnvelop appointmentRevisitOnDoor(@ApiParam(name = "outpatientJson", value = "居民门诊json")
                                               @RequestParam(value = "outpatientJson", required = false)String outpatientJson,
                                               @ApiParam(name = "expressageJson", value = "居民物流json")
                                               @RequestParam(value = "expressageJson", required = false)String expressageJson,
                                               @ApiParam(name = "registerJson", value = "预约时间")
                                               @RequestParam(value = "registerJson", required = false)String registerJson,
                                               @ApiParam(name = "chargeType", value = "预约实体json")
                                               @RequestParam(value = "chargeType", required = false)String chargeType)throws Exception {


        try {
            WlyyOutpatientDO wlyyOutpatientDO = prescriptionService.appointmentRevisitOnDoor(outpatientJson,expressageJson,registerJson,chargeType);
            return success(BaseHospitalRequestMapping.Prescription.api_success,wlyyOutpatientDO);
        }catch (Exception e) {
            return failedObjEnvelopException2(e);
        }



    }
    @GetMapping(value = BaseHospitalRequestMapping.Prescription.findJobCategory)
    @ApiOperation(value = "查询所有业务分类", notes = "查询所有业务分类")
    public MixEnvelop findJobCategory() {

        try {
            return prescriptionService.findJobCategory();
        }catch (Exception e) {
            return failedMixEnvelopException2(e);
        }
    }


    @GetMapping(value = BaseHospitalRequestMapping.Prescription.getNatRecords)
    @ApiOperation(value = "查询预约记录", notes = "查询预约记录")
    public MixEnvelop getNatRecords(@ApiParam(name = "patientId", value = "居民id")
                                        @RequestParam(value = "patientId", required = false)String patientId,
                                    @ApiParam(name = "id", value = "预约id")
                                    @RequestParam(value = "id", required = false)String id,
                                    @ApiParam(name = "payStatus", value = "支付状态1支付0未支付")
                                        @RequestParam(value = "payStatus", required = false)String payStatus,
                                    @ApiParam(name = "isSuccess", value = "预约成功状态1成功0失败")
                                        @RequestParam(value = "isSuccess", required = false)String isSuccess,
                                    @ApiParam(name = "appointmentTime", value = "appointmentTime")
                                        @RequestParam(value = "appointmentTime", required = false)String appointmentTime,
                                    @ApiParam(name = "idcard", value = "身份证")
                                        @RequestParam(value = "idcard", required = false)String idcard,
                                    @ApiParam(name = "page", value = "页数")
                                    @RequestParam(value = "page", required = false)Integer page,
                                    @ApiParam(name = "pageSize", value = "每页大小")
                                        @RequestParam(value = "pageSize", required = false)Integer pageSize) throws Exception {

        try {
            if (wxId.equalsIgnoreCase("xm_zsyy_wx")){
                prescriptionService.savePayStatusByHis(patientId);
            }else if (wxId.equalsIgnoreCase("xm_tasy_wx")){
                tasyNatService.savePayStatusByHis(patientId);
            }
            logger.info("同步数据成功");
            return  prescriptionService.getNatRecords(patientId,id,payStatus,appointmentTime,isSuccess,idcard,page,pageSize);
        } catch (Exception e) {
            return failedMixEnvelopException2(e);
        }
    }
    @GetMapping(value = BaseHospitalRequestMapping.Prescription.findBaseAddress)
    @ApiOperation(value = "查询地址", notes = "查询地址")
    public ListEnvelop findBaseAddress(@ApiParam(name = "addressFlag", value = "addressFlag")
                                    @RequestParam(value = "addressFlag", required = false)String addressFlag,
                                    @ApiParam(name = "parentName", value = "parentName")
                                    @RequestParam(value = "parentName", required = false)String parentName ){



        try {
            return  success(prescriptionService.findBaseAddress(addressFlag,parentName));
        } catch (Exception e) {
            return failedListEnvelopException2(e);
        }
    }
    @GetMapping("/testsms")
    public void testsms(String mobile ,String contet){
        ykyyINSMSService.ykyySendSMS(mobile,contet);
    }
    @GetMapping("/smsToDoctor")
    public Envelop sentMessageRemindSms(@RequestParam(value = "consult", required = true)String consult){
        try {
            ConsultDo consultDo = consultDao.findById(consult).orElse(null);
            return  success(systemMessageService.sendDoctorRemindSms(consultDo));
        } catch (Exception e) {
            return failedException2(e);
        }
    }
    /**
     * 充值卡一支付
     * @param mzhm
     * @param jkje
     * @param type
     * @param paymentType
     * @param patientId
     * @return
     * @throws Exception
     */
    @PostMapping(value= BaseHospitalRequestMapping.Prescription.yktMedicalCardTopUp)
    @ApiOperation("眼科--充值卡支付")
    public ObjEnvelop yktMedicalCardTopUp(
            @ApiParam(name = "mzhm", value = "卡号", required = true)
            @RequestParam(required = true)String mzhm,
            @ApiParam(name = "jkje", value = "充值金额", required = true)
            @RequestParam(required = true)Double jkje,
            @ApiParam(name = "type", value = "类型0 就诊卡号 1 门诊卡号", required = true)
            @RequestParam(required = true)Integer type,
            @ApiParam(name = "paymentType", value = "1支付宝 2微信", required = true)
            @RequestParam(required = true)Integer paymentType,
            @ApiParam(name = "patientId", value = "居民code", required = true)
            @RequestParam(required = true)String patientId,
            @ApiParam(name = "hospitalId", value = "医院Ccode", required = true)
            @RequestParam(required = true)String hospitalId,
            @ApiParam(name = "wxPayType", value = "微信交易类型 公众号支付:JSAPI  原生扫码支付:NATIVE", required = true)
            @RequestParam(required = true)String wxPayType,
            @ApiParam(name = "geetestChallenge", value = "geetestChallenge")
            @RequestParam(value = "geetestChallenge", required = false)String geetestChallenge,
            @ApiParam(name = "geetestValidate", value = "geetestValidate")
            @RequestParam(value = "geetestValidate", required = false)String geetestValidate,
            @ApiParam(name = "geetestSeccode", value = "geetestSeccode")
            @RequestParam(value = "geetestSeccode", required = false)String geetestSeccode,
            @ApiParam(name = "appletCode", value = "appletCode", required = false)
            @RequestParam(required = false)String appletCode) throws Exception {
        try {
            return ObjEnvelop.getSuccess("ok",businessOrderService.yktMedicalCardTopUp(mzhm,jkje,type,paymentType,patientId,wxId,hospitalId,wxPayType,appletCode,geetestChallenge,geetestValidate,geetestSeccode));
        } catch (Exception e) {
            return ObjEnvelop.getError(e.getMessage());
        }
    }
    @GetMapping(value = BaseHospitalRequestMapping.Prescription.findDoctorByIdCard)
    @ApiOperation(value = "根据身份证号查询医生", notes = "根据身份证号查询医生")
    public Envelop findDoctorByIdCard(@ApiParam(name = "idCard", value = "身份证号")
                                      @RequestParam(value = "idCard", required = false)String idCard) {

        try {
            return success(prescriptionService.findByIdCard(idCard));
        }catch (Exception e) {
            return failedException2(e);
        }
    }


    @PostMapping(value = "updateChannelId")
    @ApiOperation(value = "保存云信channelId", notes = "保存云信channelId")
    public Envelop updateChannelId(@ApiParam(name = "id", value = "outpatientId")
                                      @RequestParam(value = "id", required = false)String id,
                                      @ApiParam(name = "channelId", value = "渠道id")
                                      @RequestParam(value = "channelId", required = false)String channelId) {

        try {
            prescriptionService.updateChannelId(id,channelId);
            return success(CommonContant.Message.SAVE_ERROR);
        }catch (Exception e) {
            return failedException2(e);
        }
    }


    @PostMapping(value = "uploadFileToWx")
    @ApiOperation(value = "上传语音文件或者视频")
    public Envelop append(
            @ApiParam(name = "type", value = "追问内容类型：1文字，2图片，3语音  ... (im消息类型)")
            @RequestParam(value = "type",required = true) Integer type,
            @ApiParam(name = "times", value = "")
            @RequestParam(value = "times",required = false) Integer times) throws Exception {
        JSONObject object = new JSONObject();
        UploadVO uploadVO = new UploadVO();

        //处理语音文件
        if(!org.springframework.util.StringUtils.isEmpty(wxId)){
//			imService.getInputStream("1",wechat_appid);

            if(3 == type){//语音文件
                String voicepath = imService.fetchWxVoices(wxId);
                logger.info("voice_path:"+voicepath);
                JSONObject obj = new JSONObject();
                String voiceurl = "";
                // 将临时语音拷贝到正式存储路径下
                if (org.apache.commons.lang3.StringUtils.isNotEmpty(voicepath)) {
                    if("xm_ihealth_wx".equals(wxId)){
                        logger.info("voice_wx_type:"+wxId);
                        voiceurl = fileUploadService.uploadWxVoice(voicepath);
//					uploadVO.setFullUri(map.get("accessory").toString());
                    }else {
                        if(isClose.equals("2")){
                            voiceurl = fileUploadService.uploadInLocalWxVoice(voicepath,remote_inner_url);
                        }else {
                            voiceurl = fileUtil.copyTempVoice(voicepath,fastdfs_file_url);
                        }

                    }
                    obj.put("path", voiceurl);
                    obj.put("times", times);
                }
                object.put("path",voiceurl);
            }else if(2 == type){//图片文件
                String imagepath = imService.fetchWxImages(wxId);
                logger.info("image_path:"+imagepath);
                JSONObject obj = new JSONObject();
                String imgeUrl = "";
                // 将临时语音拷贝到正式存储路径下
                if (org.apache.commons.lang3.StringUtils.isNotEmpty(imagepath)) {
                    if("xm_ihealth_wx".equals(wxId)){
                        logger.info("imge_wx_type:"+wxId);
                        imgeUrl = fileUploadService.uploadWxImage(imagepath);
//					uploadVO.setFullUri(map.get("accessory").toString());
                    }else{
                        if(isClose.equals("2")){
                            imgeUrl = fileUploadService.uploadInLocalWxImage(imagepath,upload_temp_path,remote_inner_url);
                        }else {
                            imgeUrl = fileUtil.copyTempImage(imagepath,upload_temp_path);
                        }

                    }
                    logger.info("imgeUrl"+imgeUrl);
                    object.put("path",imgeUrl);
                }
            }else{}
        }
        logger.info("object"+object.toString());
        return success(object);
    }

    @PostMapping(value = "uploadFileToEnterprise")
    @ApiOperation(value = "上传企业微信语音文件或者视频")
    public Envelop appendEnterprise(
            @ApiParam(name = "type", value = "追问内容类型：1文字，2图片，3语音  ... (im消息类型)")
            @RequestParam(value = "type",required = true) Integer type,
            @ApiParam(name = "times", value = "")
            @RequestParam(value = "times",required = false) Integer times,HttpServletRequest request) throws Exception {
        JSONObject object = new JSONObject();
        UploadVO uploadVO = new UploadVO();

        //处理语音文件
        if(!org.springframework.util.StringUtils.isEmpty(wxId)){
            if(3 == type){//语音文件
                String voicepath = enterpriseService.fetchWxVoices(wxId,request);
                logger.info("voice_path:"+voicepath);
                JSONObject obj = new JSONObject();
                String voiceurl = "";
                // 将临时语音拷贝到正式存储路径下
                if (org.apache.commons.lang3.StringUtils.isNotEmpty(voicepath)) {
                    if("xm_ihealth_wx".equals(wxId)){
                        logger.info("voice_wx_type:"+wxId);
                        voiceurl = fileUploadService.uploadWxVoice(voicepath);
//					uploadVO.setFullUri(map.get("accessory").toString());
                    }else {
                        if(isClose.equals("2")){
                            voiceurl = fileUploadService.uploadInLocalWxVoice(voicepath,remote_inner_url);
                        }else {
                            voiceurl = fileUtil.copyTempVoice(voicepath,fastdfs_file_url);
                        }

                    }
                    obj.put("path", voiceurl);
                    obj.put("times", times);
                }
                object.put("path",voiceurl);
            }
        }
        logger.info("object"+object.toString());
        return success(object);
    }
    @GetMapping(value = BaseHospitalRequestMapping.Prescription.testJpush)
    @ApiOperation(value = "根据身份证号查询医生", notes = "")
    public Envelop testJPush(@ApiParam(name = "outpatientId", value = "")
                                      @RequestParam(value = "outpatientId", required = false)String outpatientId,
                             @ApiParam(name = "templateCode", value = "")
                             @RequestParam(value = "templateCode", required = false)String templateCode,
                             @ApiParam(name = "drugName", value = "")
                                 @RequestParam(value = "drugName", required = false)String drugName,
                             @ApiParam(name = "mailNo", value = "")
                                 @RequestParam(value = "mailNo", required = false)String mailNo,
                             @ApiParam(name = "mailStatus", value = "")
                                 @RequestParam(value = "mailStatus", required = false)String mailStatus,
                             @ApiParam(name = "prescriptionId", value = "")
                                 @RequestParam(value = "prescriptionId", required = false)String prescriptionId) {
       WlyyOutpatientDO wlyyOutpatientDO =  outpatientDao.findById(outpatientId).orElse(null);
        ConsultTeamDo consultTeamDo = consultTeamDao.queryByRelationCode(outpatientId);

        return success(prescriptionService.wxTempalteJPush(templateCode,wlyyOutpatientDO,consultTeamDo,drugName,mailNo,mailStatus,prescriptionId));
    }



    @GetMapping(value = BaseHospitalRequestMapping.Prescription.findYkCardCharge)
    @ApiOperation(value = "查询眼科通充值记录", notes = "")
    public MixEnvelop findYkCardCharge(@ApiParam(name = "startTime", value = "开始时间")
                             @RequestParam(value = "startTime", required = false)String startTime,
                             @ApiParam(name = "endTime", value = "结束时间")
                             @RequestParam(value = "endTime", required = false)String endTime,
                             @ApiParam(name = "orderNo", value = "订单号")
                             @RequestParam(value = "orderNo", required = false)String orderNo,
                             @ApiParam(name = "yktOrderNo", value = "眼科订单号")
                             @RequestParam(value = "yktOrderNo", required = false)String yktOrderNo,
                             @ApiParam(name = "patientName", value = "患者姓名")
                             @RequestParam(value = "patientName", required = false)String patientName,
                             @ApiParam(name = "idCard", value = "身份证")
                             @RequestParam(value = "idCard", required = false)String idCard,
                             @ApiParam(name = "medicard", value = "就诊卡")
                             @RequestParam(value = "medicard", required = false)String medicard,
                             @ApiParam(name = "status", value = "状态（0:未支付|1：已支付| 9退款完成）")
                             @RequestParam(value = "status", required = false)Integer status,
                             @ApiParam(name = "page", value = "页数")
                             @RequestParam(value = "page", required = false)Integer page,
                             @ApiParam(name = "pageSize", value = "页吗")
                             @RequestParam(value = "pageSize", required = false)Integer pageSize,
                             @ApiParam(name = "orderType", value = "咨询方式(1、图文、3、视频)")
                             @RequestParam(value = "orderType", required = false)String orderType,
                             @ApiParam(name = "orderCategory", value = "业务列表(1，专家咨询，2、复诊，4处方、5、就诊卡充值)")
                             @RequestParam(value = "orderCategory", required = false)String orderCategory) {

        try {
            return businessOrderService.findYktCardCharge(startTime,endTime,orderNo,yktOrderNo,patientName,idCard,medicard,status,page,pageSize, orderType, orderCategory);
        }catch (Exception e) {
            return failedMixEnvelopException2(e);
        }
    }

    @GetMapping(value = BaseHospitalRequestMapping.Prescription.pushYkCardCharge)
    @ApiOperation(value = "导出眼科通充值记录", notes = "")
    public Envelop pushYkCardCharge(@ApiParam(name = "startTime", value = "开始时间")
                                       @RequestParam(value = "startTime", required = false)String startTime,
                                       @ApiParam(name = "endTime", value = "结束时间")
                                       @RequestParam(value = "endTime", required = false)String endTime,
                                       @ApiParam(name = "orderNo", value = "订单号")
                                       @RequestParam(value = "orderNo", required = false)String orderNo,
                                       @ApiParam(name = "yktOrderNo", value = "眼科订单号")
                                       @RequestParam(value = "yktOrderNo", required = false)String yktOrderNo,
                                       @ApiParam(name = "patientName", value = "患者姓名")
                                       @RequestParam(value = "patientName", required = false)String patientName,
                                       @ApiParam(name = "idCard", value = "身份证")
                                       @RequestParam(value = "idCard", required = false)String idCard,
                                       @ApiParam(name = "medicard", value = "就诊卡")
                                       @RequestParam(value = "medicard", required = false)String medicard,
                                       @ApiParam(name = "status", value = "状态（0:未支付|1：已支付| 9退款完成||退款失败）")
                                       @RequestParam(value = "status", required = false)Integer status,
                                       @ApiParam(name = "page", value = "页数")
                                       @RequestParam(value = "page", required = false)Integer page,
                                       @ApiParam(name = "pageSize", value = "页吗")
                                       @RequestParam(value = "pageSize", required = false)Integer pageSize,
                                       @ApiParam(name = "orderType", value = "咨询方式(1、图文、3、视频)")
                                       @RequestParam(value = "orderType", required = false)String orderType,
                                       @ApiParam(name = "orderCategory", value = "业务列表(1，专家咨询，2、复诊，4处方、5、就诊卡充值)")
                                       @RequestParam(value = "orderCategory", required = false)String orderCategory,
                                       HttpServletResponse response) {

        try {
            MixEnvelop expressages = businessOrderService.pushYktCardCharge(startTime,endTime,orderNo,yktOrderNo,patientName,idCard,medicard,status,page,pageSize, orderType, orderCategory);
            List<Map<String, Object>> list = expressages.getDetailModelList();
            response.setContentType("octets/stream");
            response.setHeader("Content-Disposition", "attachment; filename=" + new String("pushYktCardCharge.xls"));
            OutputStream os = response.getOutputStream();
            prescriptionService.pushYktCardChargeWrite(os, list);

            return success(expressages);
        }catch (Exception e) {
            return failedMixEnvelopException(e);
        }
    }

    @GetMapping(value = "pushListWriteHealthInfo")
    @ApiOperation(value = "健康上报数据导出", notes = "健康上报数据导出")
    public Envelop pushListWrite(@ApiParam(name = "startDate", value = "开始时间")
                                 @RequestParam(value = "startDate", required = false) String startDate,
                                 @ApiParam(name = "endDate", value = "结束时间")
                                 @RequestParam(value = "endDate", required = false) String endDate,
                                 @ApiParam(name = "dept", value = "科室id")
                                     @RequestParam(value = "dept", required = false) String dept,
                                 HttpServletResponse response) throws Exception {
        try{
            response.setContentType("octets/stream");
            response.setHeader("Content-Disposition", "attachment; filename=" + new String(URLEncoder.encode("健康上报报表")+".xls"));
            OutputStream os = response.getOutputStream();
            return success(baseDoctorHealthUploadService.selectListInfoExcelByTotal(os, startDate,endDate,dept));
        }catch (Exception e) {
            return failedMixEnvelopException(e);
        }
    }


    /**
     * 导出文章全院明细
     *
     * @param startDate
     * @param endDate
     * @param area
     * @param level
     * @param flag
     * @param lowLevel
     * @param lowCode
     * @param response
     * @return
     */
    @GetMapping(value = BaseHospitalRequestMapping.Statistics.pushArticleCountExcel)
    @ApiOperation(value = " 导出文章全院明细")
    public ListEnvelop pushArticleCountExcel(
            @ApiParam(name = "startDate", value = "开始时间", required = false)
            @RequestParam(value = "startDate", required = false) String startDate,
            @ApiParam(name = "endDate", value = "结束时间", required = false)
            @RequestParam(value = "endDate", required = false) String endDate,
            @ApiParam(name = "area", value = "区域编码 如 level2 area传市编码", required = true)
            @RequestParam(value = "area", required = true) String area,
            @ApiParam(name = "level", value = "2 市  3区  4医院 5、科室 6医生", required = true)
            @RequestParam(value = "level", required = true) int level,
            @ApiParam(name = "flag", value = "0自定义 1本月2近半年3本年", required = true)
            @RequestParam(value = "flag", required = true) Integer flag,
            @ApiParam(name = "lowLevel", value = "下一级区域等级   2 市  3区  4医院 5、科室 6医生", required = false)
            @RequestParam(value = "lowLevel", required = false) String lowLevel,
            @ApiParam(name = "lowCode", value = "", required = false)
            @RequestParam(value = "lowCode", required = false) String lowCode,
            HttpServletResponse response) {

        try {
            List<Map<String, Object>> list = statisticsEsService.selectArticleCountExcel(flag,startDate,endDate,level,area,lowLevel,lowCode);
            response.setContentType("octets/stream");
            response.setHeader("Content-Disposition", "attachment; filename=" + new String("pushArticleTotalExcel.xls"));
            OutputStream os = response.getOutputStream();
            statisticsEsService.pushArticleTotalExcel(os, list);
            return success(list);
        } catch (Exception e) {
            e.printStackTrace();
            return failedListEnvelopException(e);
        }
    }

    /**
     * 咨询列表
     * @param startDate
     * @param endDate
     * @param area
     * @param level 2 市  3区  4医院 5、科室 6医生
     * @return
     */
    @GetMapping(value = BaseHospitalRequestMapping.Statistics.consultHead)
    @ApiOperation(value = " 咨询分析-头部")
    public ObjEnvelop getConsultHead(
            @RequestParam(required = true) String startDate,
            @RequestParam(required = true) String endDate,
            @RequestParam(required = true) String area,
            @RequestParam(required = true) int level,
            @RequestParam(required = true) String index,
            @RequestParam(required = false) String lowCode) {

        try {
            //新版与旧版统计适配
            JSONObject result = new JSONObject();
            try {
                result = statisticsEsService.getConsultHead(startDate, endDate, area, level, index,lowCode);

            } catch (Exception e) {
                e.printStackTrace();
            }
            return success(result);
        } catch (Exception e) {
            return failedObjEnvelopException2(e);
        }
    }

    @GetMapping(value = BaseHospitalRequestMapping.Statistics.scheduleHead)
    @ApiOperation(value = "排班头部")
    public ObjEnvelop getScheduleTotal(
            @RequestParam(required = true) String startDate,
            @RequestParam(required = true) String endDate,
            @RequestParam(required = true) String area,
            @RequestParam(required = true) int level,
            @RequestParam(required = true) String index) {


        try {
            JSONObject result = new JSONObject();
            try {
                result= statisticsEsService.getScheduleTotal(startDate, endDate,index,level,area);
            } catch (Exception e) {
                e.printStackTrace();
            }

            return success(result);
        }catch (Exception e) {
            return failedObjEnvelopException2(e);
        }
    }


    @GetMapping(value = BaseHospitalRequestMapping.Prescription.zsMsgFlowTest)
    @ApiOperation(value = "消息中心发送消息测试接口", notes = "")
    public Envelop zsMsgFlowTest(@ApiParam(name = "visitId", value = "")
                                       @RequestParam(value = "visitId", required = false)String visitId,
                                       @ApiParam(name = "msgId", value = "")
                                       @RequestParam(value = "msgId", required = false)String msgId,
                                       @ApiParam(name = "idType", value = "")
                                       @RequestParam(value = "idType", required = false)String idType,
                                       @ApiParam(name = "idNo", value = "")
                                       @RequestParam(value = "idNo", required = false)String idNo,
                                       @ApiParam(name = "patientName", value = "")
                                       @RequestParam(value = "patientName", required = false)String patientName,
                                       @ApiParam(name = "msgTime", value = "")
                                       @RequestParam(value = "msgTime", required = false)String msgTime,
                                       @ApiParam(name = "msgType", value = "")
                                       @RequestParam(value = "msgType", required = false)String msgType,
                                       @ApiParam(name = "msgContent", value = "")
                                       @RequestParam(value = "msgContent", required = false)String msgContent,
                                       @ApiParam(name = "jumpType", value = "")
                                       @RequestParam(value = "jumpType", required = false)String jumpType,
                                       @ApiParam(name = "jumpUrl", value = "")
                                       @RequestParam(value = "jumpUrl", required = false)String jumpUrl,
                                    @ApiParam(name = "miniAppId", value = "")
                                        @RequestParam(value = "miniAppId", required = false)String miniAppId,
                                    @ApiParam(name = "miniAppUrl", value = "")
                                        @RequestParam(value = "miniAppUrl", required = false)String miniAppUrl,
                                    @ApiParam(name = "remark", value = "")
                                        @RequestParam(value = "remark", required = false)String remark,
                                    @ApiParam(name = "sender", value = "")
                                        @RequestParam(value = "sender", required = false)String sender)  throws Exception{
        return success(entranceService.zsMsgFlow(visitId,msgId,idType,idNo,patientName,msgTime,msgType,msgContent,jumpType,jumpUrl,miniAppId,miniAppUrl,remark,sender));


    }
    @GetMapping("/doctorReviewConsultCount")
    @ApiOperation(value = "提供给i健康：图文复诊、视频复诊咨询数量、协同门诊候诊数量", notes = "提供给i健康：图文复诊、视频复诊咨询数量、协同门诊候诊数量")
    public Envelop doctorReviewConsultCount(@ApiParam(name = "doctorIdcard", value = "医生CODE")
                                            @RequestParam(value = "doctorIdcard",required = true) String doctorIdcard){
        JSONObject result = new JSONObject();
        String doctor ="";
        BaseDoctorDO baseDoctorDO = baseDoctorDao.findByIdcardAndDel(doctorIdcard);
        if (baseDoctorDO!=null){
            doctor = baseDoctorDO.getId();
        }
        logger.info("action:doctorReviewConsultCount--start:doctor"+doctor);
        result.put("imgCount",prescriptionService.getWaitVideoCount(doctor,"1","1",wxId));//图文复诊数量
        result.put("imgTotal",prescriptionService.getVideoCount(doctor,"1","1",wxId));//图文复诊总数量
        result.put("videoCount",prescriptionService.getWaitVideoCount(doctor,"2","1",wxId));//视频复诊数量
        result.put("videoTotal",prescriptionService.getVideoCount(doctor,"2","1",wxId));//视频复诊总数量
        result.put("xtCount",prescriptionService.getWaitVideoCount(doctor,"","2",wxId));//协同门诊候诊数量
        result.put("xtTotal",prescriptionService.getVideoCount(doctor,"","2",wxId));//协同门诊候诊总数量
        result.put("imgConsultCount",prescriptionService.getWaitVideoCount(doctor,"1","3",wxId));//图文咨询数量
        result.put("imgConsultTotal",prescriptionService.getVideoCount(doctor,"1","3",wxId));//图文咨询总数量
        result.put("videoConsultCount",prescriptionService.getWaitVideoCount(doctor,"2","3",wxId));//视频咨询数量
        result.put("videoConsultTotal",prescriptionService.getVideoCount(doctor,"2","3",wxId));//视频咨询总数量
        result.put("homeConsultCount",prescriptionService.getWaitVideoCount(doctor,"3","3",wxId));//家医咨询数量
        result.put("homeConsultTotal",prescriptionService.getVideoCount(doctor,"3","3",wxId));//家医咨询总数量
        Integer unreadMessageCount = imService.SessionsUnreadMessageCount(doctor,"1");
        result.put("zjUnreadMessageCount",unreadMessageCount);//专家咨询未读数
        if ("sd_tnzyy_wx".equalsIgnoreCase(wxId)){
            result.put("doorServiceCount",prescriptionService.waitUpdoorCount(doctor));//上门服务数量
        }
        logger.info("action:doctorReviewConsultCount--end:"+DateUtil.dateToStrLong(new Date()));
        return success("请求成功",result);
    }
    @GetMapping("/getGeetConfig")
    @ApiOperation(value = "getGeetConfig", notes = "getGeetConfig")
    public Envelop testgeet(
            @ApiParam(name = "gt", value = "gt")
            @RequestParam(value = "gt", required = false)String gt)throws Exception {
        try {

            return success("操作成功", wlyyHttpService.testgeet(gt));
        }catch (Exception e){
            return Envelop.getError(e.getMessage());
        }
    }
    @GetMapping("/findDoctorWorkTime")
    @ApiOperation(value = "findDoctorWorkTime", notes = "findDoctorWorkTime")
    public Envelop findDoctorWorkTime(
            @ApiParam(name = "doctor", value = "doctor")
            @RequestParam(value = "doctor", required = false)String doctor,
            @ApiParam(name = "hospital", value = "hospital")
            @RequestParam(value = "hospital", required = false)String hospital,
            @ApiParam(name = "ywCode", value = "ywCode")
            @RequestParam(value = "ywCode", required = false)String ywCode)throws Exception {
        try {

            return success("操作成功", prescriptionService.findDoctorWorkTime(doctor,hospital,ywCode));
        }catch (Exception e){
            return Envelop.getError(e.getMessage());
        }
    }
    @GetMapping("/findDoctorChargeType")
    @ApiOperation(value = "findDoctorChargeType", notes = "findDoctorChargeType")
    public Envelop findDoctorChargeType(
            @ApiParam(name = "doctor", value = "doctor")
            @RequestParam(value = "doctor", required = false)String doctor,
            @ApiParam(name = "chargeType", value = "chargeType")
            @RequestParam(value = "chargeType", required = false)String chargeType)throws Exception {
        try {
            return success("操作成功", workTimeService.findChargeTypeByDoctor(doctor,chargeType));
        }catch (Exception e){
            return Envelop.getError(e.getMessage());
        }
    }

    @GetMapping(value = BaseHospitalRequestMapping.Prescription.findDeptByOrgCode)
    @ApiOperation(value = "查询机构下所有科室", notes = "查询机构下所有科室")
    public MixEnvelop findDeptByOrgCode(@ApiParam(name = "orgCode", value = "机构code")
                                        @RequestParam(value = "orgCode", required = true)String orgCode,
                                        @ApiParam(name = "keyName", value = "关键字")
                                        @RequestParam(value = "keyName", required = false)String keyName) {

        try {
            return prescriptionService.findDeptByOrgCode(orgCode,keyName);
        }catch (Exception e) {
            return failedMixEnvelopException(e);
        }
    }

    @GetMapping(value = BaseHospitalRequestMapping.Prescription.findDeptDescByDeptCodeAndOrgCode)
    @ApiOperation(value = "查询科室介绍", notes = "查询科室介绍")
    public MixEnvelop findDeptDesc(@ApiParam(name = "orgCode", value = "机构code")
                                   @RequestParam(value = "orgCode", required = true)String orgCode,
                                   @ApiParam(name = "deptCode", value = "部门code")
                                   @RequestParam(value = "deptCode", required = true)String deptCode) {

        try {
            return prescriptionService.findDeptDesc(orgCode,deptCode);
        }catch (Exception e) {
            return failedMixEnvelopException(e);
        }
    }


    @GetMapping("/testTasyInterface")
    @ApiOperation(value = "testTasyInterface")
    public Envelop testTasyInterface(
            @ApiParam(name = "api", value = "api", required = true)
            @RequestParam(value = "api", required = true) String api,
            @ApiParam(name = "json", value = "json", required = true)
            @RequestParam(value = "json", required = true) String json ) throws Exception {


        try {
            JSONObject jsonObject = JSON.parseObject(json);
            if ("SickNocardRegister".equalsIgnoreCase(api)){
                return success("操作成功",tasyNatService.registerPatient(jsonObject));
            }
            if ("insertNucleicBill".equalsIgnoreCase(api)){
                return success("操作成功",tasyNatService.insertNucleicBill(jsonObject));
            }
            if ("cancelNucleicBill".equalsIgnoreCase(api)){
                return success("操作成功",tasyNatService.cancelNucleicBill(jsonObject));
            }
            if ("ChargenucleicBill".equalsIgnoreCase(api)){
                return success("操作成功",tasyNatService.ChargenucleicBill(jsonObject));
            }
            if ("QueryApplyInfo".equalsIgnoreCase(api)){
                return success("操作成功",tasyNatService.QueryApplyInfo(jsonObject.getString("realOrder")));
            }
            return success("");
        } catch (Exception e){
            return  failedException(e);
        }
    }


    @GetMapping("/testTasyPay")
    @ApiOperation(value = "testTasyPay")
    public Envelop testTasyPay(
            @ApiParam(name = "api", value = "api", required = true)
            @RequestParam(value = "api", required = true) String api,
            @ApiParam(name = "json", value = "json", required = true)
            @RequestParam(value = "json", required = true) String json ) throws Exception {


        try {
            JSONObject jsonObject = JSON.parseObject(json);
            if ("placeOrder".equalsIgnoreCase(api)){
                return success("操作成功",tasyNatService.placeOrder(jsonObject));
            }
            if ("orderStatus".equalsIgnoreCase(api)){
                return success("操作成功",tasyNatService.orderStatus(jsonObject));
            }
            if ("tmpPush".equalsIgnoreCase(api)){
                return success("操作成功",tasyNatService.tmpPush(jsonObject));
            }
            if ("CancleOrder".equalsIgnoreCase(api)){
                return success("操作成功",tasyNatService.cancleOrder(jsonObject.getString("HisID"),jsonObject.getString("no"),jsonObject.getString("OrderNumber")));
            }
            if ("GetOrderInfo".equalsIgnoreCase(api)){
                return success("操作成功",tasyNatService.GetOrderInfo(jsonObject.getString("HisID"),jsonObject.getString("ApplyType")));
            }
            if ("hdrQueryDataWS".equalsIgnoreCase(api)){
                System.out.println("111");
                return success("操作成功",tasyNatService.hdrQueryDataWS(jsonObject.getString("idcard"),jsonObject.getString("wsCode"),jsonObject.getString("oid"),jsonObject.getString("time")));
            }
            if ("GetDoctorWorkDate".equalsIgnoreCase(api)){
                System.out.println("111");
                return success("操作成功",tasyNatService.GetDoctorWorkDate("3",jsonObject.getString("dept")));
            }

            return success("");
        } catch (Exception e){
            return  failedException2(e);
        }
    }


    /**
     * 亿同支付回调接口
     * @return
     * @throws IOException
     */
    @ResponseBody
    @ApiOperation("亿同支付回调接口")
    @RequestMapping(value = "/ytzfNotify", method = {RequestMethod.GET, RequestMethod.POST})
    public String ytzfNotify(@ApiParam(name = "code", value = "code", required = true)
                                 @RequestParam(value = "code", required = true) String code,
                             @ApiParam(name = "orderNo", value = "支付系统订单号(亿同系统订单号，用于查询订单号状态)", required = true)
                             @RequestParam(value = "orderNo", required = false) String orderNo,
                             @ApiParam(name = "traceNo", value = "互联网医院系统订单号", required = false)
                                 @RequestParam(value = "traceNo", required = false) String traceNo,
                             @ApiParam(name = "msg", value = "msg", required = false)
                                 @RequestParam(value = "msg", required = false) String msg) throws Exception {
        System.out.println(" "+code);
        System.out.println("进入回调orderNo="+orderNo);
        System.out.println("进入回调traceNo="+traceNo);
        System.out.println("进入回调msg="+msg);
        if ("0".equalsIgnoreCase(code)){
            BusinessOrderDO businessOrderDO = businessOrderDao.selectByTraceNoAndorderNo(orderNo,traceNo);
            if (businessOrderDO!=null){
                JSONObject requestObj=new JSONObject();
                requestObj.put("orderNo",orderNo);
                String res = tasyNatService.orderStatus(requestObj);
                JSONObject orderStatus=JSONObject.parseObject(res);
                if ("0".equalsIgnoreCase(orderStatus.getString("code"))){
                    System.out.println("开始同步状态");
                        BaseNatAppointmentDO baseNatAppointmentDO = baseNatAppointmentDao.findById(Integer.valueOf(businessOrderDO.getRelationCode())).orElse(null);
                        if (baseNatAppointmentDO!=null){
                            if (baseNatAppointmentDO.getPayStatus().equalsIgnoreCase("0")){
                                JSONObject chargeObj=new JSONObject();
                                chargeObj.put("hisTradeNo",baseNatAppointmentDO.getRealOrder());
                                chargeObj.put("icCardNo",baseNatAppointmentDO.getMedicare().trim());
                                chargeObj.put("patientName",baseNatAppointmentDO.getName());
                                //调用扣费接口
                                String feeRes=tasyNatService.ChargenucleicBill(chargeObj);
                                JSONObject feeObj = JSONObject.parseObject(feeRes);
                                if (feeObj!=null){
                                    if ("1".equalsIgnoreCase(feeObj.getString("ReturnCode"))){
                                        JSONObject ApplyInfoObj = JSON.parseObject(feeObj.getString("ApplyInfo"));
                                        if (ApplyInfoObj!=null){
                                            String voucherNo = ApplyInfoObj.getString("ApplyNo");
                                            if(org.apache.commons.lang3.StringUtils.isNoneBlank(voucherNo)){
                                                System.out.println("ApplyNo:"+voucherNo);
                                                baseNatAppointmentDO.setVoucherNo(voucherNo);
                                            }
                                        }
                                    }else{
                                        return feeObj.getString("ReturnMsg");
                                    }
                                }else{
                                    return  "FAILED";
                                }
                                baseNatAppointmentDO.setPayStatus("1");
                                baseNatAppointmentDao.save(baseNatAppointmentDO);
                                businessOrderDO.setStatus(1);
                                businessOrderDao.save(businessOrderDO);
                                tasyNatService.sendWxtemplateMessaeg(baseNatAppointmentDO.getConsumer(),baseNatAppointmentDO.getName(),"hszfcgtx",baseNatAppointmentDO.getId().toString());
                            }
                            return "SUCCESS";
                    }
                }

            }
        }
        return  "FAILED";
    }

    @GetMapping("/saveNatAppointment")
    @ApiOperation(value = "核酸检测预约接口")
    public Envelop saveNatAppointment(@ApiParam(name = "chargeAmount", value = "chargeAmount")
                                      @RequestParam(value = "chargeAmount",required = false)String chargeAmount,
                                      @ApiParam(name = "inspectionName", value = "inspectionName")
                                      @RequestParam(value = "inspectionName",required = false)String inspectionName,
                                      @ApiParam(name = "mediaCard", value = "mediaCard")
                                      @RequestParam(value = "mediaCard",required = false)String mediaCard,
                                      @ApiParam(name = "patientId", value = "patientId")
                                      @RequestParam(value = "patientId",required = false)String patientId,
                                      @ApiParam(name = "name", value = "name")
                                      @RequestParam(value = "name",required = false)String name,
                                      @ApiParam(name = "cardNo", value = "cardNo")
                                      @RequestParam(value = "cardNo",required = false)String cardNo,
                                      @ApiParam(name = "cardType", value = "cardType")
                                      @RequestParam(value = "cardType",required = false)String cardType,
                                      @ApiParam(name = "mobile", value = "mobile")
                                      @RequestParam(value = "mobile",required = false)String mobile,
                                      @ApiParam(name = "firstJobCode", value = "firstJobCode")
                                      @RequestParam(value = "firstJobCode",required = false)String firstJobCode,
                                      @ApiParam(name = "firstJobName", value = "firstJobName")
                                      @RequestParam(value = "firstJobName",required = false)String firstJobName,
                                      @ApiParam(name = "secondJobCode", value = "secondJobCode")
                                      @RequestParam(value = "secondJobCode",required = false)String secondJobCode,
                                      @ApiParam(name = "secondJobName", value = "secondJobName")
                                      @RequestParam(value = "secondJobName",required = false)String secondJobName,
                                      @ApiParam(name = "natTime", value = "natTime")
                                      @RequestParam(value = "natTime",required = false)String natTime,
                                      @ApiParam(name = "address", value = "address")
                                      @RequestParam(value = "address",required = false)String address,
                                      @ApiParam(name = "provinceName", value = "provinceName")
                                      @RequestParam(value = "provinceName",required = false)String provinceName,
                                      @ApiParam(name = "cityName", value = "cityName")
                                      @RequestParam(value = "cityName",required = false)String cityName,
                                      @ApiParam(name = "townName", value = "townName")
                                      @RequestParam(value = "townName",required = false)String townName,
                                      @ApiParam(name = "streetName", value = "streetName")
                                      @RequestParam(value = "streetName",required = false)String streetName,
                                      @ApiParam(name = "pm", value = "pm")
                                      @RequestParam(value = "pm",required = false)String pm,
                                      @ApiParam(name = "checkPart", value = "checkPart")
                                      @RequestParam(value = "checkPart",required = false)String checkPart,
                                      @ApiParam(name = "pushFlag", value = "pushFlag")
                                      @RequestParam(value = "pushFlag",required = false)String pushFlag,
                                      @ApiParam(name = "cardNoType", value = "cardNoType")
                                      @RequestParam(value = "cardNoType",required = false)String cardNoType,
                                      @ApiParam(name = "chargeFlag", value = "chargeFlag")
                                      @RequestParam(value = "chargeFlag",required = false)String chargeFlag,
                                      @ApiParam(name = "chargeCode", value = "chargeCode")
                                          @RequestParam(value = "chargeCode",required = false)String chargeCode,
                                      @ApiParam(name = "icdCode", value = "icdCode")
                                          @RequestParam(value = "icdCode",required = false)String icdCode,
                                      @ApiParam(name = "preNo", value = "preNo")
                                          @RequestParam(value = "preNo",required = false)String preNo,
                                      @ApiParam(name = "idnoType", value = "idnoType")
                                          @RequestParam(value = "idnoType",required = false)String idnoType,
                                      @ApiParam(name = "source", value = "source")
                                          @RequestParam(value = "source", required = false) Integer source,
                                      @ApiParam(name = "patientHisId", value = "patientHisId")
                                          @RequestParam(value = "patientHisId", required = false) String patientHisId){
        try {

            return success(prescriptionService.saveNatAppointment(chargeAmount,inspectionName,mediaCard,patientId,name,cardNo,cardType,mobile,firstJobCode,firstJobName,secondJobCode,secondJobName,natTime,address,provinceName,
                    cityName,townName,streetName,pm,pushFlag,cardNoType,getUID(),checkPart,chargeFlag,chargeCode,icdCode,preNo,idnoType,source,patientHisId));
        } catch (Exception e) {
            return Envelop.getError(e.getMessage());
        }

    }

    @GetMapping("/testYt")
    public Envelop testYt() throws Exception {
        try {
            return success(prescriptionService.testYt());
        } catch (Exception e) {
            return Envelop.getError(e.getMessage());
        }
    }


    @GetMapping("/BS10145")
    public Envelop BS10145(@ApiParam(name = "id", value = "id")
                           @RequestParam(value = "id",required = false)Integer id,
                           @ApiParam(name = "patientId", value = "patientId")
                           @RequestParam(value = "patientId",required = false)String patientId) throws Exception {
        try {
            return success(prescriptionService.cancelNatAppointment(id,patientId));
        } catch (Exception e) {
            return Envelop.getError(e.getMessage());
        }
    }
    @GetMapping("/BS10142")
    public ListEnvelop BS10142(
            @ApiParam(name = "deptCode", value = "deptCode")
            @RequestParam(value = "deptCode",required = false)String deptCode,
            @ApiParam(name = "docCode", value = "docCode")
            @RequestParam(value = "docCode",required = false)String docCode,
            @ApiParam(name = "chargeType", value = "chargeType")
            @RequestParam(value = "chargeType",required = false)String chargeType) throws Exception {
        if("xm_zsyy_wx".equalsIgnoreCase(wxId)){
            return success(entranceService.BS10142(deptCode,docCode,chargeType,false));
        }else if ("xm_tasy_wx".equalsIgnoreCase(wxId)){
            String res=tasyNatService.departMent(deptCode);
            String dept="";
            JSONObject deptres = JSON.parseObject(res);
            if (deptres!=null){
                if (deptres.getString("success").equalsIgnoreCase("true")){
                    JSONObject data = JSON.parseObject(deptres.getString("data"));
                    dept=data.getString("Dept");
                    com.alibaba.fastjson.JSONArray jsonArray1 = JSON.parseArray(dept);
                    if (jsonArray1!=null&&jsonArray1.size()>0){
                        JSONObject jsonObject = jsonArray1.getJSONObject(0);
                        dept=jsonObject.getString("Id");
                        System.out.println(dept);
                    }
                    String json=tasyNatService.GetDoctorWorkDate("3",dept);
                    JSONObject jsonObject = JSON.parseObject(json);
                    jsonObject.put("dept",dept);
                    com.alibaba.fastjson.JSONArray jsonArray = new com.alibaba.fastjson.JSONArray();
                    jsonArray.add(jsonObject);
                    return success(jsonArray);
                }else {
                    return ListEnvelop.getError("获取部门编码失败");
                }
            }else {
                return ListEnvelop.getError("无效部门");
            }
        }else {
            return ListEnvelop.getError("未开放");
        }

    }

    @GetMapping("/BS10143")
    public ListEnvelop BS10143(@ApiParam(name = "day", value = "day")
                               @RequestParam(value = "day",required = false)String day,
                               @ApiParam(name = "dept", value = "dept")
                               @RequestParam(value = "dept",required = false)String dept,
                               @ApiParam(name = "doctor", value = "doctor")
                               @RequestParam(value = "doctor",required = false)String doctor,
                               @ApiParam(name = "IsAll", value = "IsAll")
                               @RequestParam(value = "IsAll",required = false)String IsAll,
                               @ApiParam(name = "pm", value = "pm")
                               @RequestParam(value = "pm",required = false)String pm) throws Exception {
        if("xm_zsyy_wx".equalsIgnoreCase(wxId)){
            return success(entranceService.BS10143(day,pm,false));
        }else if ("xm_tasy_wx".equalsIgnoreCase(wxId)){
            String res=tasyNatService.GetOrderSource(dept,doctor,day,"3",IsAll,pm);
            String xml="";
            if (!StringUtils.isEmpty(res)){
                JSONObject jsonObject = JSON.parseObject(res);
                System.out.println("====="+jsonObject.getString("success"));
                if (jsonObject!=null&&jsonObject.getString("success").equalsIgnoreCase("true")){
                    xml=jsonObject.getString("data");
                    XMLSerializer xmlSerializer = new XMLSerializer();
                    String json = xmlSerializer.read(xml).toString();
                    JSONObject jsonObjectRes = JSON.parseObject(json);
                    com.alibaba.fastjson.JSONArray jsonArray = new com.alibaba.fastjson.JSONArray();
                    jsonArray.add(jsonObjectRes);
                    return success(jsonArray);
                }
            }
            return ListEnvelop.getError("查询失败");
        }else {
            return ListEnvelop.getError("未开放");
        }

    }
    @GetMapping("/DepartMent")
    public Envelop DepartMent(
            @ApiParam(name = "DepartMent", value = "DepartMent")
            @RequestParam(value = "DepartMent",required = false)String DepartMent) throws Exception {
        return success("查询成功",tasyNatService.departMent(DepartMent));

    }

    @GetMapping("/hdrQueryData")
    public MixEnvelop hdrQueryData(
            @ApiParam(name = "patient", value = "patient")
            @RequestParam(value = "patient",required = false)String patient) throws Exception {
        try {
            return MixEnvelop.getSuccess("查询成功",tasyNatService.getNatResult(patient));
        }catch (Exception e){
            return failedMixEnvelopException(e);
        }
    }


    @GetMapping("/checkBalance")
    public Envelop checkBalance(
            @ApiParam(name = "relationCode", value = "relationCode")
            @RequestParam(value = "relationCode",required = false)String relationCode) throws Exception {
        try {
            return success(tasyNatService.checkBalance(relationCode));
        }catch (Exception e){
            return failedMixEnvelopException(e);
        }
    }

    /*  =================================疫情防控代码开始========================================================    */
    @GetMapping(value = BaseHospitalRequestMapping.PatientNoLogin.confirmedList)
    @ApiOperation(value = "确诊列表", notes = "确诊列表")
    public ListEnvelop confirmedList(@ApiParam(name = "name", value = "姓名")
                                         @RequestParam(value = "name",required = false)String name,
                                     @ApiParam(name = "localCaseFlag", value = "本地或者外地")
                                         @RequestParam(value = "localCaseFlag",required = false)String localCaseFlag){

        try {
            return success(yqfkService.confirmedList(name,localCaseFlag));
        } catch (Exception e){
            return  failedListEnvelopException(e);
        }
    }
    @GetMapping(value = BaseHospitalRequestMapping.PatientNoLogin.yqfkStatisticsHead)
    @ApiOperation(value = "头部确诊数量", notes = "头部确诊数量")
    public ObjEnvelop yqfkStatisticsHead(@ApiParam(name = "startTime", value = "开始时间")
                                              @RequestParam(value = "startTime",required = false)String startTime,
                                          @ApiParam(name = "endTime", value = "结束时间")
                                          @RequestParam(value = "endTime",required = false)String endTime){

        try {
            return success(yqfkService.yqfkStatisticsHead(startTime,endTime));
        } catch (Exception e){
            return  failedObjEnvelopException(e);
        }
    }

    @GetMapping(value = BaseHospitalRequestMapping.PatientNoLogin.yqfkStatisticsTail)
    @ApiOperation(value = "密接数量统计", notes = "密接数量统计")
    public ObjEnvelop yqfkStatisticsTail(@ApiParam(name = "patientId", value = "患者id")
                                         @RequestParam(value = "patientId",required = false)String patientId,
                                         @ApiParam(name = "endTime", value = "结束时间")
                                         @RequestParam(value = "endTime",required = false)String endTime){

        try {
            return success(yqfkService.yqfkStatisticsTail(patientId,endTime));
        } catch (Exception e){
            return  failedObjEnvelopException(e);
        }
    }

    /*  =================================疫情防控代码结束========================================================    */

    @Autowired
    private HcyyEntranceService hcyyEntranceService;

    @GetMapping(value = "/getDeptInfo")
    @ApiOperation(value = "获取部门信息", notes = "获取部门信息")
    public ObjEnvelop getDeptInfo(@ApiParam(name = "code", value = "code", required = false)
                                  @RequestParam(value = "code",required = false)String code)throws Exception{
        return ObjEnvelop.getSuccess("ok",hcyyEntranceService.getDeptInfo(code));
    }

    @GetMapping(value = "/selectDoctorInfo")
    @ApiOperation(value = "获取医生信息", notes = "获取医生信息")
    public ObjEnvelop selectDoctorInfo(@ApiParam(name = "idCard", value = "身份证号", required = false)
                                       @RequestParam(value = "idCard",required = false)String idcard)throws Exception{
        return ObjEnvelop.getSuccess("ok",hcyyEntranceService.selectDoctorInfo(idcard));
    }

    @GetMapping(value = "/getDoctorInfo")
    @ApiOperation(value = "同步医生信息", notes = "同步医生信息")
    public ObjEnvelop getDoctorInfo(@ApiParam(name = "idCard", value = "身份证号", required = false)
                                    @RequestParam(value = "idCard",required = false)String idcard)throws Exception{
        return ObjEnvelop.getSuccess("ok",hcyyEntranceService.getDoctorInfo(idcard));
    }

    @GetMapping(value = "/getJobTitle")
    @ApiOperation(value = "同步职称", notes = "同步职称")
    public ObjEnvelop getJobTitle()throws Exception{
        return ObjEnvelop.getSuccess("ok",hcyyEntranceService.getJobTitle());
    }

    @GetMapping(value = "/getChargeDict")
    @ApiOperation(value = "同步号别", notes = "同步号别")
    public ObjEnvelop getChargeDict()throws Exception{
        return ObjEnvelop.getSuccess("ok",hcyyEntranceService.getChargeDict());
    }

    @GetMapping(value = "/initiateDataSign")
    @ApiOperation(value = "数据签名", notes = "数据签名")
    public ObjEnvelop initiateDataSign(@ApiParam(name = "prescriptionId", value = "处方id", required = false)
                                           @RequestParam(value = "prescriptionId",required = false)String prescriptionId,
                                       @ApiParam(name = "flag", value = "1处方签名、2病例签名", required = false)
                                       @RequestParam(value = "flag",required = false)Integer flag,HttpServletRequest request)throws Exception{
        return ObjEnvelop.getSuccess("ok",hcyyEntranceService.initiateDataSign(prescriptionId, flag,getIpAddress(request)));
    }
}
