package com.yihu.jw.hospital.endpoint.processGuidance;

import com.yihu.jw.contant.CommonContant;
import com.yihu.jw.processGuidance.service.ProcessGuidanceService;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.ListEnvelop;
import com.yihu.jw.restmodel.web.ObjEnvelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;

/**
 * Created by yeshijie on 2022/11/18.
 */
@RestController
@RequestMapping(value = "processGuidance")
@Api(value = "全流程指引-居民端", tags = {"全流程指引-居民端"})
public class ProcessGuidanceEndpoint extends EnvelopRestEndpoint {

    @Resource
    private ProcessGuidanceService processGuidanceService;

    @GetMapping(value = "nextStep")
    @ApiOperation(value = "获取居民进行中的流程")
    public Envelop nextStep(@ApiParam(name = "patient", value = "居民id", required = true)
                                           @RequestParam(value = "patient") String patient,
                                           @ApiParam(name = "setp", value = "当前步骤", required = true)
                                           @RequestParam(value = "setp") Integer setp) {
        try {
            return ObjEnvelop.getSuccess("查询成功",processGuidanceService.nextStep(patient,setp));
        }catch (Exception e){
            e.printStackTrace();
        }
        return Envelop.getError("查询失败");
    }

    @GetMapping(value = "findStep")
    @ApiOperation(value = "获取居民进行中的流程步骤")
    public Envelop findStep(@ApiParam(name = "patient", value = "居民id", required = true)
                                           @RequestParam(value = "patient") String patient) {
        try {
            return ObjEnvelop.getSuccess("查询成功",processGuidanceService.findStep(patient));
        }catch (Exception e){
            e.printStackTrace();
        }
        return Envelop.getError("查询失败");
    }

    @GetMapping(value = "findProcessGuidanceList")
    @ApiOperation(value = "获取居民进行中的流程")
    public Envelop findProcessGuidanceList(@ApiParam(name = "patient", value = "居民id", required = true)
                                @RequestParam(value = "patient") String patient,
                                @ApiParam(name = "isApp", value = "是否需要app，1是0否", required = true)
                                @RequestParam(value = "isApp") Integer isApp) {
        try {

            return ListEnvelop.getSuccess("查询成功",processGuidanceService.findProcessGuidanceList(patient,isApp));
        }catch (Exception e){
            e.printStackTrace();
        }
        return Envelop.getError("查询失败");
    }

    @PostMapping(value = "sendGuidance")
    @ApiOperation(value = "推送全流程指引")
    public Envelop sendGuidance(@ApiParam(name = "patient", value = "居民id", required = true)
                                @RequestParam(value = "patient") String patient,
                                @ApiParam(name = "type", value = "类型", required = true)
                                @RequestParam(value = "type") String type,
                                @ApiParam(name = "orderId", value = "工单id", required = true)
                                @RequestParam(value = "orderId") String orderId) {
        try {
            processGuidanceService.sendGuidance(patient, type, orderId);
            return success("操作成功");
        }catch (Exception e){
            e.printStackTrace();
        }
        return Envelop.getError(CommonContant.Message.SAVE_ERROR);
    }

}
