package com.yihu.jw.hospital.endpoint.processGuidance;

import com.yihu.jw.contant.CommonContant;
import com.yihu.jw.entity.base.processGuidance.BaseProcessGuidanceBookingDO;
import com.yihu.jw.entity.base.processGuidance.BaseProcessGuidanceThirdPushLogDO;
import com.yihu.jw.processGuidance.dao.BaseProcessGuidanceBookingDao;
import com.yihu.jw.processGuidance.dao.BaseProcessGuidanceThirdPushLogDao;
import com.yihu.jw.processGuidance.service.ProcessGuidanceService;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.ObjEnvelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

/**
 * Created by yeshijie on 2022/11/23.
 */
@RestController
@RequestMapping(value = "open/gc/processGuidance")
@Api(value = "全流程指引-第三方推送通知", tags = {"全流程指引-第三方推送通知"})
public class ThirdProcessGuidanceEndpoint extends EnvelopRestEndpoint {

    @Autowired
    private ProcessGuidanceService processGuidanceService;
    @Autowired
    private BaseProcessGuidanceBookingDao processGuidanceBookingDao;
    @Autowired
    private BaseProcessGuidanceThirdPushLogDao thirdPushLogDao;

    @PostMapping(value = "sendGuidanceInfo")
    @ApiOperation(value = "推送全流程指引")
    public Envelop sendGuidanceInfo(@ApiParam(name = "jsonData", value = "jsonData", required = true)
                                @RequestParam(value = "jsonData") String jsonData) {
        try {
            processGuidanceService.sendGuidanceInfo(jsonData);
            return success("操作成功");
        }catch (Exception e){
            e.printStackTrace();
        }
        return Envelop.getError(CommonContant.Message.SAVE_ERROR);
    }

    @GetMapping(value = "getInfo")
    @ApiOperation(value = "获取测试数据")
    public Envelop getInfo(@ApiParam(name = "id", value = "id", required = true)
                           @RequestParam(value = "id") String id,
                           @ApiParam(name = "type", value = "type", required = true)
                           @RequestParam(value = "type") String type){
        try {
            if("thirdLog".equals(type)){
                BaseProcessGuidanceThirdPushLogDO logDO = thirdPushLogDao.findById(id).orElse(null);
                return ObjEnvelop.getSuccess("",logDO);
            }
            if("booking".equals(type)){
                BaseProcessGuidanceBookingDO logDO = processGuidanceBookingDao.findById(id).orElse(null);
                return ObjEnvelop.getSuccess("",logDO);
            }

        }catch (Exception e){
            e.printStackTrace();
        }
        return Envelop.getError(CommonContant.Message.GET_ERROR);
    }

}
