package com.yihu.jw.hospital.endpoint.thirdUpload;


import com.alibaba.fastjson.JSONObject;
import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.yihu.jw.entity.base.dict.BaseFrequencyDictDO;
import com.yihu.jw.entity.hospital.article.KnowledgeCategoryDO;
import com.yihu.jw.entity.thirdUpload.*;
import com.yihu.jw.restmodel.iot.device.IotDeviceImportVO;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.ListEnvelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import com.yihu.jw.rm.hospital.BaseHospitalRequestMapping;
import com.yihu.jw.thirdUpload.UpnsOrganBaseDao;
import com.yihu.jw.thirdUpload.service.*;
import com.yihu.jw.util.date.DateUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import com.yihu.jw.rm.regulatory.BaseRegulatoryRequestMapping;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

@RestController
@RequestMapping(value = BaseHospitalRequestMapping.UpWebTherapySupserviceInfo.PREFIX)     //请求地址前缀
@Api(value = "监管平台数据增删改查", description = "监管平台数据增删改查", tags = {"监管平台数据增删改查"})
public class ThirdUploadEndpoint extends EnvelopRestEndpoint {
    @Autowired
    private ObjectMapper objectMapper;
    @Autowired
    private AchnsDoctorRecordService achnsDoctorRecordService;
    @Autowired
    private UpAppointmentOnlineService upAppointmentOnlineService;
    @Autowired
    private UpMedicalOnlineService upMedicalOnlineService;
    @Autowired
    private UpnsDoctorRecordService upnsDoctorRecordService;
    @Autowired
    private UpnsDoctorScoreService upnsDoctorScoreService;
    @Autowired
    private UpnsOrganBaseService upnsOrganBaseService;
    @Autowired
    private BaseNsOnlineAskService baseNsOnlineAskService;
    @Autowired
    private BaseNsOlineMedService baseNsOlineMedService;
    @Autowired
    private BaseNsPrescriptionAService baseNsPrescriptionAService;
    @Autowired
    private BaseNsPrescriptionDrugService baseNsPrescriptionDrugService;

    @PostMapping(value = BaseRegulatoryRequestMapping.UpWebTherapySupserviceInfo.SAVEACHNS)     //请求地址  /saveAchns
    @ApiOperation(value = "保存医师唯一标识")
    public Envelop saveAchns(@ApiParam(name = "jsonData", value = "")
                             @RequestParam(name = "jsonData", required = true) String jsonData) throws Exception {

        try {
            List<AchnsDoctorRecordDO> dealList = objectMapper.readValue(jsonData, new TypeReference<List<AchnsDoctorRecordDO>>() {
            });
            achnsDoctorRecordService.saveAchns(dealList);
            return success("操作成功");
        }catch (Exception e) {
            return failedObjEnvelopException(e);
        }
    }
    @GetMapping(value = BaseRegulatoryRequestMapping.UpWebTherapySupserviceInfo.DELETEACHNS)    //请求地址  /deleteAchns
    @ApiOperation(value = "删除医师唯一标识")
    public Envelop deleteAchns(@ApiParam(name = "id", value = "")
                               @RequestParam(name = "id", required = true) String id) throws Exception {

        try {
            achnsDoctorRecordService.deleteById(id);
            return success("操作成功");
        }catch (Exception e) {
            return failedObjEnvelopException(e);
        }
    }

    @GetMapping(value = BaseRegulatoryRequestMapping.UpWebTherapySupserviceInfo.FINDACHNSBYCREATETIME)
    @ApiOperation(value = "查询医师唯一标识")
    public Envelop findAchnsByCreateTime(@ApiParam(name = "date", value = "yyyy-mm-dd")
                                         @RequestParam(name = "date", required = true) String date) throws Exception {

        try {

            return success(achnsDoctorRecordService.findByCreateTime(date));
        }catch (Exception e) {
            return failedObjEnvelopException(e);
        }
    }

    @GetMapping("/findAchnsList")
    @ApiOperation(value = "获取医师唯一标识分类列表")
    public ListEnvelop findAchnsList(
            @ApiParam(name = "fields", value = "返回的字段，为空返回全部字段")
            @RequestParam(value = "fields", required = false) String fields,
            @ApiParam(name = "filters", value = "过滤器，为空检索所有条件")
            @RequestParam(value = "filters", required = false) String filters,
            @ApiParam(name = "sorts", value = "排序，规则参见说明文档")
            @RequestParam(value = "sorts", required = false) String sorts,
            @ApiParam(name = "page", value = "第几页，从1开始", required = true, defaultValue = "1")
            @RequestParam(value = "page", required = true,defaultValue = "1")Integer page,
            @ApiParam(name = "pageSize", value = "每页分页大小", required = true, defaultValue = "10")
            @RequestParam(value = "pageSize", required = true,defaultValue = "10")Integer pageSize)throws Exception{

        try {
            List<AchnsDoctorRecordDO> list  = achnsDoctorRecordService.search(fields,filters,sorts,page,pageSize);
            return success(list);
        }catch (Exception e){
            return failedListEnvelopException(e);
        }
    }

    @PostMapping("/saveUpApp")
    @ApiOperation(value = "保存网上预约挂号")
    public Envelop saveUpAppointmentOnline(@ApiParam(name = "jsonData", value = "")
                                           @RequestParam(name = "jsonData", required = true) String jsonData) throws Exception {

        try {
            List<UpAppointmentOnlineDO> dealList = objectMapper.readValue(jsonData, new TypeReference<List<UpAppointmentOnlineDO>>() {
            });
            upAppointmentOnlineService.saveUpAppointment(dealList);
            return success("操作成功");
        }catch (Exception e) {
            return failedObjEnvelopException(e);
        }
    }
    @GetMapping("/deleteUpApp")
    @ApiOperation(value = "删除网上预约挂号")
    public Envelop deleteUpAppointmentOnline(@ApiParam(name = "id", value = "")
                                             @RequestParam(name = "id", required = true) String id) throws Exception {

        try {
            upAppointmentOnlineService.deleteById(id);
            return success("操作成功");
        }catch (Exception e) {
            return failedObjEnvelopException(e);
        }
    }

    @GetMapping("/findUpAppByCreateTime")
    @ApiOperation(value = "查询网上预约挂号")
    public Envelop findUpAppByCreateTime(@ApiParam(name = "date", value = "yyyy-mm-dd")
                                         @RequestParam(name = "date", required = true) String date) throws Exception {

        try {

            return success(upAppointmentOnlineService.findByCreateTime(date));
        }catch (Exception e) {
            return failedObjEnvelopException(e);
        }
    }

    @GetMapping("/findUpAppList")
    @ApiOperation(value = "获取网上预约挂号分类列表")
    public ListEnvelop findUpAppList(
            @ApiParam(name = "fields", value = "返回的字段，为空返回全部字段")
            @RequestParam(value = "fields", required = false) String fields,
            @ApiParam(name = "filters", value = "过滤器，为空检索所有条件")
            @RequestParam(value = "filters", required = false) String filters,
            @ApiParam(name = "sorts", value = "排序，规则参见说明文档")
            @RequestParam(value = "sorts", required = false) String sorts,
            @ApiParam(name = "page", value = "第几页，从1开始", required = true, defaultValue = "1")
            @RequestParam(value = "page", required = true,defaultValue = "1")Integer page,
            @ApiParam(name = "pageSize", value = "每页分页大小", required = true, defaultValue = "10")
            @RequestParam(value = "pageSize", required = true,defaultValue = "10")Integer pageSize)throws Exception{

        try {
            List<UpAppointmentOnlineDO> list  = upAppointmentOnlineService.search(fields,filters,sorts,page,pageSize);
            return success(list);
        }catch (Exception e){
            return failedListEnvelopException(e);
        }
    }
    @PostMapping("/saveUpMedical")
    @ApiOperation(value = "保存在线医技预约")
    public Envelop saveUpMedical(@ApiParam(name = "jsonData", value = "")
                                 @RequestParam(name = "jsonData", required = true) String jsonData) throws Exception {

        try {
            List<UpMedicalOnlineDO> dealList = objectMapper.readValue(jsonData, new TypeReference<List<UpMedicalOnlineDO>>() {
            });
            upMedicalOnlineService.saveUpMedicalOnline(dealList);
            return success("操作成功");
        }catch (Exception e) {
            return failedObjEnvelopException(e);
        }
    }
    @GetMapping("/deleteUpMedical")
    @ApiOperation(value = "删除在线医技预约")
    public Envelop deleteUpMedical(@ApiParam(name = "id", value = "")
                                   @RequestParam(name = "id", required = true) String id) throws Exception {

        try {
            upMedicalOnlineService.deleteById(id);
            return success("操作成功");
        }catch (Exception e) {
            return failedObjEnvelopException(e);
        }
    }

    @GetMapping("/findUpMedicalByCreateTime")
    @ApiOperation(value = "查询在线医技预约")
    public Envelop findUpMedicalByCreateTime(@ApiParam(name = "date", value = "yyyy-mm-dd")
                                             @RequestParam(name = "date", required = true) String date) throws Exception {

        try {

            return success(upMedicalOnlineService.findByCreateTime(date));
        }catch (Exception e) {
            return failedObjEnvelopException(e);
        }
    }

    @GetMapping("/findUpMedicalList")
    @ApiOperation(value = "获取在线医技预约分类列表")
    public ListEnvelop findUpMedicalList(
            @ApiParam(name = "fields", value = "返回的字段，为空返回全部字段")
            @RequestParam(value = "fields", required = false) String fields,
            @ApiParam(name = "filters", value = "过滤器，为空检索所有条件")
            @RequestParam(value = "filters", required = false) String filters,
            @ApiParam(name = "sorts", value = "排序，规则参见说明文档")
            @RequestParam(value = "sorts", required = false) String sorts,
            @ApiParam(name = "page", value = "第几页，从1开始", required = true, defaultValue = "1")
            @RequestParam(value = "page", required = true,defaultValue = "1")Integer page,
            @ApiParam(name = "pageSize", value = "每页分页大小", required = true, defaultValue = "10")
            @RequestParam(value = "pageSize", required = true,defaultValue = "10")Integer pageSize)throws Exception{

        try {
            List<UpMedicalOnlineDO> list  = upMedicalOnlineService.search(fields,filters,sorts,page,pageSize);
            return success(list);
        }catch (Exception e){
            return failedListEnvelopException(e);
        }
    }
    @PostMapping("/saveUpnsDr")
    @ApiOperation(value = "保存医师基本信息")
    public Envelop saveUpnsDr(@ApiParam(name = "jsonData", value = "")
                              @RequestParam(name = "jsonData", required = true) String jsonData) throws Exception {

        try {
            List<UpnsDoctorRecordDO> dealList = objectMapper.readValue(jsonData, new TypeReference<List<UpnsDoctorRecordDO>>() {
            });
            upnsDoctorRecordService.saveUpnsDoctorRecord(dealList);
            return success("操作成功");
        }catch (Exception e) {
            return failedObjEnvelopException(e);
        }
    }
    @GetMapping("/deleteUpnsDr")
    @ApiOperation(value = "删除医师基本信息")
    public Envelop deleteUpnsDr(@ApiParam(name = "id", value = "")
                                @RequestParam(name = "id", required = true) String id) throws Exception {

        try {
            upnsDoctorRecordService.deleteById(id);
            return success("操作成功");
        }catch (Exception e) {
            return failedObjEnvelopException(e);
        }
    }

    @GetMapping("/findUpnsDrByCreateTime")
    @ApiOperation(value = "查询医师基本信息")
    public Envelop findUpnsDrByCreateTime(@ApiParam(name = "date", value = "yyyy-mm-dd")
                                          @RequestParam(name = "date", required = true) String date) throws Exception {

        try {

            return success(upnsDoctorRecordService.findByCreateTime(date));
        }catch (Exception e) {
            return failedObjEnvelopException(e);
        }
    }

    @GetMapping("/findUpnsDrList")
    @ApiOperation(value = "获取医师基本信息分类列表")
    public ListEnvelop findUpnsDrList(
            @ApiParam(name = "fields", value = "返回的字段，为空返回全部字段")
            @RequestParam(value = "fields", required = false) String fields,
            @ApiParam(name = "filters", value = "过滤器，为空检索所有条件")
            @RequestParam(value = "filters", required = false) String filters,
            @ApiParam(name = "sorts", value = "排序，规则参见说明文档")
            @RequestParam(value = "sorts", required = false) String sorts,
            @ApiParam(name = "page", value = "第几页，从1开始", required = true, defaultValue = "1")
            @RequestParam(value = "page", required = true,defaultValue = "1")Integer page,
            @ApiParam(name = "pageSize", value = "每页分页大小", required = true, defaultValue = "10")
            @RequestParam(value = "pageSize", required = true,defaultValue = "10")Integer pageSize)throws Exception{

        try {
            List<UpnsDoctorRecordDO> list  = upnsDoctorRecordService.search(fields,filters,sorts,page,pageSize);
            return success(list);
        }catch (Exception e){
            return failedListEnvelopException(e);
        }
    }
    @PostMapping("/saveUpnsDs")
    @ApiOperation(value = "保存医生评价信息")
    public Envelop saveUpnsDs(@ApiParam(name = "jsonData", value = "")
                              @RequestParam(name = "jsonData", required = true) String jsonData) throws Exception {

        try {
            List<UpnsDoctorScoreDO> dealList = objectMapper.readValue(jsonData, new TypeReference<List<UpnsDoctorScoreDO>>() {
            });
            upnsDoctorScoreService.saveUpnsDoctorScore(dealList);
            return success("操作成功");
        }catch (Exception e) {
            return failedObjEnvelopException(e);
        }
    }
    @GetMapping("/deleteUpnsDs")
    @ApiOperation(value = "删除医生评价信息")
    public Envelop deleteUpnsDs(@ApiParam(name = "id", value = "")
                                @RequestParam(name = "id", required = true) String id) throws Exception {

        try {
            upnsDoctorScoreService.deleteById(id);
            return success("操作成功");
        }catch (Exception e) {
            return failedObjEnvelopException(e);
        }
    }

    @GetMapping("/findUpnsDsByCreateTime")
    @ApiOperation(value = "查询医生评价信息")
    public Envelop findUpnsDsByCreateTime(@ApiParam(name = "date", value = "yyyy-mm-dd")
                                          @RequestParam(name = "date", required = true) String date) throws Exception {

        try {

            return success(upnsDoctorScoreService.findByCreateTime(date));
        }catch (Exception e) {
            return failedObjEnvelopException(e);
        }
    }

    @GetMapping("/findUpnsDsList")
    @ApiOperation(value = "获取医生评价信息分类列表")
    public ListEnvelop findUpnsDsList(
            @ApiParam(name = "fields", value = "返回的字段，为空返回全部字段")
            @RequestParam(value = "fields", required = false) String fields,
            @ApiParam(name = "filters", value = "过滤器，为空检索所有条件")
            @RequestParam(value = "filters", required = false) String filters,
            @ApiParam(name = "sorts", value = "排序，规则参见说明文档")
            @RequestParam(value = "sorts", required = false) String sorts,
            @ApiParam(name = "page", value = "第几页，从1开始", required = true, defaultValue = "1")
            @RequestParam(value = "page", required = true,defaultValue = "1")Integer page,
            @ApiParam(name = "pageSize", value = "每页分页大小", required = true, defaultValue = "10")
            @RequestParam(value = "pageSize", required = true,defaultValue = "10")Integer pageSize)throws Exception{

        try {
            List<UpnsDoctorScoreDO> list  = upnsDoctorScoreService.search(fields,filters,sorts,page,pageSize);
            return success(list);
        }catch (Exception e){
            return failedListEnvelopException(e);
        }
    }
    @PostMapping("/saveUpnsOrg")
    @ApiOperation(value = "保存医院基本信息")
    public Envelop saveUpnsOrg(@ApiParam(name = "jsonData", value = "")
                               @RequestParam(name = "jsonData", required = true) String jsonData) throws Exception {

        try {
            List<UpNsOrganBaseDO> dealList = objectMapper.readValue(jsonData, new TypeReference<List<UpNsOrganBaseDO>>() {
            });
            upnsOrganBaseService.saveUpnsOrganBase(dealList);
            return success("操作成功");
        }catch (Exception e) {
            return failedObjEnvelopException(e);
        }
    }
    @GetMapping("/deleteUpnsOrg")
    @ApiOperation(value = "删除医院基本信息")
    public Envelop deleteUpnsOrg(@ApiParam(name = "id", value = "")
                                 @RequestParam(name = "id", required = true) String id) throws Exception {

        try {
            upnsOrganBaseService.deleteById(id);
            return success("操作成功");
        }catch (Exception e) {
            return failedObjEnvelopException(e);
        }
    }

    @GetMapping("/findUpnsOrgByCreateTime")
    @ApiOperation(value = "查询医院基本信息")
    public Envelop findUpnsOrgByCreateTime(@ApiParam(name = "date", value = "yyyy-mm-dd")
                                           @RequestParam(name = "date", required = true) String date) throws Exception {

        try {

            return success(upnsOrganBaseService.findByCreateTime(date));
        }catch (Exception e) {
            return failedObjEnvelopException(e);
        }
    }

    @GetMapping("/findUpnsOrgList")
    @ApiOperation(value = "获取医院基本信息分类列表")
    public ListEnvelop findUpnsOrgList(
            @ApiParam(name = "fields", value = "返回的字段，为空返回全部字段")
            @RequestParam(value = "fields", required = false) String fields,
            @ApiParam(name = "filters", value = "过滤器，为空检索所有条件")
            @RequestParam(value = "filters", required = false) String filters,
            @ApiParam(name = "sorts", value = "排序，规则参见说明文档")
            @RequestParam(value = "sorts", required = false) String sorts,
            @ApiParam(name = "page", value = "第几页，从1开始", required = true, defaultValue = "1")
            @RequestParam(value = "page", required = true,defaultValue = "1")Integer page,
            @ApiParam(name = "pageSize", value = "每页分页大小", required = true, defaultValue = "10")
            @RequestParam(value = "pageSize", required = true,defaultValue = "10")Integer pageSize)throws Exception{

        try {
            List<UpNsOrganBaseDO> list  = upnsOrganBaseService.search(fields,filters,sorts,page,pageSize);
            return success(list);
        }catch (Exception e){
            return failedListEnvelopException(e);
        }
    }

    @PostMapping(value = BaseRegulatoryRequestMapping.UpWebTherapySupserviceInfo.SAVENSOLINEASK)
    @ApiOperation(value = "保存网络咨询服务信息")
    public Envelop saveNsOlineAsk(@ApiParam(name = "jsonData", value = "")
                                  @RequestParam(name = "jsonData",required = true) String jsonData) throws Exception{
        try{
            List<BaseNsOnlineAskDO> dealList = objectMapper.readValue(jsonData, new TypeReference<List<BaseNsOnlineAskDO>>(){});
            baseNsOnlineAskService.saveNsOlineAsk(dealList);
            return success("success");
        }catch (Exception e){
            return failedObjEnvelopException(e);
        }

    }

    @GetMapping(value = BaseRegulatoryRequestMapping.UpWebTherapySupserviceInfo.DELETESOLINEASK)
    @ApiOperation(value = "删除网络咨询信息")
    public Envelop deleteNsOlineAsk(@ApiParam(name = "id", value = "")
                                    @RequestParam(name = "id", required = true) String id) throws Exception{
        try{
            baseNsOnlineAskService.deleteById(id);
            return success("success");
        }catch (Exception e){
            return failedObjEnvelopException(e);
        }
    }

    @PostMapping(value = BaseRegulatoryRequestMapping.UpWebTherapySupserviceInfo.SAVENSONLINEMED)
    @ApiOperation(value = "保存网络诊疗信息")
    public Envelop saveNsOnlinemed(@ApiParam(name = "jsonData", value = "")
                                   @RequestParam(name = "jsonData",required = true) String jsonData) throws Exception{
        try{
            List<BaseNsOnlineMedDO> dealList = objectMapper.readValue(jsonData, new TypeReference<List<BaseNsOnlineMedDO>>(){});
            baseNsOlineMedService.saveNsOnlinemed(dealList);
            return success("success");
        }catch (Exception e){
            return failedObjEnvelopException(e);
        }
    }

    @GetMapping(value = BaseRegulatoryRequestMapping.UpWebTherapySupserviceInfo.DELETENSONLINEMED)
    @ApiOperation(value = "删除网络咨询信息")
    public Envelop deleteNsonlinemed(@ApiParam(name = "id", value = "")
                                    @RequestParam(name = "id", required = true) String id) throws Exception{
        try{
            baseNsOlineMedService.deleteById(id);
            return success("success");
        }catch (Exception e){
            return failedObjEnvelopException(e);
        }
    }

    @PostMapping(value = BaseRegulatoryRequestMapping.UpWebTherapySupserviceInfo.SAVEPRESCRIPTION)
    @ApiOperation(value = "保存电子处方")
    public Envelop savePrescription(@ApiParam(name = "jsonData", value = "")
                                    @RequestParam(name = "jsonData",required = true) String jsonData)throws Exception{
        try{
            List<BaseNsPrescriptionDO> dealList = objectMapper.readValue(jsonData, new TypeReference<List<BaseNsPrescriptionDO>>(){});
            baseNsPrescriptionAService.savePrescription(dealList);
            return success("success");
        }catch (Exception e){
            return failedObjEnvelopException(e);
        }
    }

    @GetMapping(value = BaseRegulatoryRequestMapping.UpWebTherapySupserviceInfo.DELETEPRESCRIPTION)
    @ApiOperation(value = "删除电子处方")
    public Envelop deletePrescription(@ApiParam(name = "id", value = "")
                                     @RequestParam(name = "id", required = true) String id) throws Exception{
        try{
            baseNsPrescriptionAService.deleteById(id);
            return success("success");
        }catch (Exception e){
            return failedObjEnvelopException(e);
        }
    }

    @PostMapping(value = BaseRegulatoryRequestMapping.UpWebTherapySupserviceInfo.SAVEPRESCRIPTIONDRUG)
    @ApiOperation(value = "保存电子处方药品明细")
    public Envelop savePrescriptionDrug(@ApiParam(name = "jsonData", value = "")
                                        @RequestParam(name = "jsonData",required = true) String jsonData) throws Exception{
        try{
            List<BaseNsPrescriptionDrugDO> dealList = objectMapper.readValue(jsonData, new TypeReference<List<BaseNsPrescriptionDrugDO>>(){});
            baseNsPrescriptionDrugService.savePrescriptionDrug(dealList);
            return success("success");
        }catch (Exception e){
            return failedObjEnvelopException(e);
        }
    }

    @GetMapping(value = BaseRegulatoryRequestMapping.UpWebTherapySupserviceInfo.DELETEPRESCRIPTIONDRUG)
    @ApiOperation(value = "删除电子处方")
    public Envelop deletePrescriptionDrug(@ApiParam(name = "id", value = "")
                                      @RequestParam(name = "id", required = true) String id) throws Exception{
        try{
            baseNsPrescriptionDrugService.deleteById(id);
            return success("success");
        }catch (Exception e){
            return failedObjEnvelopException(e);
        }
    }
}
