package com.yihu.jw.hospital.endpoint.tnyy;

import com.yihu.jw.hospital.prescription.service.TnPrescriptionService;
import com.yihu.jw.hospital.prescription.service.entrance.TnyyEntranceService;
import com.yihu.jw.restmodel.web.ObjEnvelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 * Created by Trick on 2020/1/19.
 */
@RestController
@RequestMapping(value ="/tnyy")
@Api(value = "泰安中医院", description = "泰安中医院", tags = {"泰安中医院"})
public class TnyyController extends EnvelopRestEndpoint {

    @Autowired
    private TnyyEntranceService tnyyEntranceService;
    @Autowired
    private TnPrescriptionService prescriptionService;


    @GetMapping(value = "/getDeptInfo")
    @ApiOperation(value = "获取部门信息", notes = "获取部门信息")
    public ObjEnvelop getDeptInfo(@ApiParam(name = "code", value = "code", required = false)
                                  @RequestParam(value = "code",required = false)String code)throws Exception{

        try {
            return ObjEnvelop.getSuccess("ok",tnyyEntranceService.updateTnyyDept());
        }catch (Exception e) {
            return failedObjEnvelopException(e);
        }
    }


    @GetMapping(value = "/updateTnyyDoctor")
    @ApiOperation(value = "获取医生信息", notes = "获取医生信息")
    public ObjEnvelop updateTnyyDoctor(@ApiParam(name = "idcard", value = "idcard", required = false)
                                  @RequestParam(value = "idcard",required = false)String idcard)throws Exception{
        try {
            return ObjEnvelop.getSuccess("ok",tnyyEntranceService.updateTnyyDoctor(idcard));
        }catch (Exception e) {
            return failedObjEnvelopException(e);
        }
    }


    @GetMapping(value = "/synYkICD10")
    @ApiOperation(value = "获取icd10信息", notes = "获取icd10信息")
    public ObjEnvelop synYkICD10()throws Exception{

        try {
            return ObjEnvelop.getSuccess("ok",prescriptionService.synYkICD10());
        }catch (Exception e) {
            return failedObjEnvelopException(e);
        }
    }

}
