package com.yihu.jw.hospital.service.MultipleCode;

import com.alibaba.fastjson.JSONObject;
import com.yihu.jw.entity.base.patient.BasePatientDO;
import com.yihu.jw.entity.base.wx.BasePatientWechatDo;
import com.yihu.jw.entity.base.wx.WxWechatDO;
import com.yihu.jw.entity.hospital.httplog.WlyyHttpLogDO;
import com.yihu.jw.entity.third.ylzinfo.OauthYlzConfigDO;
import com.yihu.jw.hospital.httplog.dao.WlyyHttpLogDao;
import com.yihu.jw.hospital.prescription.dao.OauthYlzConfigDao;
import com.yihu.jw.hospital.ykyy.service.YkyyService;
import com.yihu.jw.patient.dao.BasePatientDao;
import com.yihu.jw.restmodel.web.MixEnvelop;
import com.yihu.jw.util.date.DateUtil;
import com.yihu.jw.wechat.dao.BasePatientWechatDao;
import com.yihu.jw.wechat.dao.WechatDao;
import com.ylzinfo.ehc.EhcHandler;
import com.ylzinfo.ehc.common.utils.DateUtils;
import com.ylzinfo.ehc.trans.TransRequest;
import com.ylzinfo.ehc.trans.TransResponse;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.UUID;

/**
 * @author HZY
 * @vsrsion 1.0
 * Created at 2020/4/17
 */
@Service
public class MultipleCodeService {

    @Autowired
    private  OauthYlzConfigDao oauthYlzConfigDao;

    @Autowired
    private BasePatientDao basePatientDao;

    @Autowired
    private BasePatientWechatDao basePatientWechatDao;

    @Autowired
    private WechatDao wechatDao;

    @Autowired
    private WlyyHttpLogDao wlyyHttpLogDao;

    @Autowired
    private YkyyService ykyyService;

    public MixEnvelop mcfRegister(BasePatientDO patientDO, String wechatId) throws Exception {
        BasePatientWechatDo patientWechatDo = basePatientWechatDao.findByWechatIdAndPatientId(wechatId, patientDO.getId()).get(0);
        WxWechatDO wechatDO = wechatDao.findByIdAndStatus(wechatId);
        OauthYlzConfigDO oauthYlzConfigDO = oauthYlzConfigDao.findById("mcf_config").orElse(null);
        TransResponse re= new TransResponse();
        try {
            TransRequest request = new TransRequest();
            request.setMethod("ehc.ehealthcard.register");
            request.setApp_id(oauthYlzConfigDO.getAppId());
            request.setTerm_id(oauthYlzConfigDO.getTermId());
            request.setVersion("X.M.0.1");
            request.setTimestamp(DateUtils.getOutTradeTime());
            request.setSign_type("RSA");
            request.setEnc_type("Plain");
            JSONObject bizContent = new JSONObject();
            bizContent.put("out_register_time", DateUtils.getOutTradeTime());
            bizContent.put("out_register_no", DateUtils.getOutTradeTime());
            bizContent.put("open_id", patientWechatDo.getOpenid());
            bizContent.put("account_id", wechatDO.getAppOriginId());
            bizContent.put("certificate_mode", "01");
            bizContent.put("id_type", "01");
            bizContent.put("id_no", patientDO.getIdcard());
            bizContent.put("user_name", patientDO.getName());
            bizContent.put("birthday", patientDO.getBirthday());
            bizContent.put("address", patientDO.getAddress());
            bizContent.put("mobile_phone", patientDO.getMobile());
            bizContent.put("apply_method", "1");
            bizContent.put("user_sex",patientDO.getSex());
            bizContent.put("nation", "01");
            request.setBiz_content(JSONObject.toJSONString(bizContent));
            EhcHandler ehcHandler = new EhcHandler(oauthYlzConfigDO.getUrl()+"ehcweb/gateway.do", oauthYlzConfigDO.getAppId(), oauthYlzConfigDO.getTermId(), oauthYlzConfigDO.getPrivateKey(), oauthYlzConfigDO.getEhcPublicKey());
            re = ehcHandler.execute(request);
            JSONObject jsonObject = new JSONObject();
            jsonObject.put("code_url",JSONObject.parseObject(re.getBiz_content()).getString("code_url"));
            String result = jsonObject.toJSONString().replaceAll("\\|888", "");
            if(result!=null){
                return MixEnvelop.getSuccess("注册URL获取成功",result);
            }
            return MixEnvelop.getError(JSONObject.parseObject(re.getRet_msg()).toString());
        } catch (Exception e) {
            e.printStackTrace();
            return MixEnvelop.getError(JSONObject.parseObject(re.getRet_msg()).toString());
        }
    }
//     根据openId、 accountId查询三码融合码信息
    public MixEnvelop mcfOpenquery(String patientId,String wechatId) throws Exception {
        WxWechatDO wechatDO = wechatDao.findByAppId(wechatId);
        BasePatientDO patientDO = basePatientDao.findById(patientId).orElse(null);
        if (patientDO!=null){
            BasePatientWechatDo patientWechatDo = basePatientWechatDao.findByWechatIdAndPatientId(wechatId, patientDO.getId()).get(0);
            if (patientWechatDo!=null){
                OauthYlzConfigDO oauthYlzConfigDO = oauthYlzConfigDao.findById("mcf_config").orElse(null);
                TransRequest request = new TransRequest();
                request.setMethod("ehc.ehealthcard.openquery");
                request.setApp_id(oauthYlzConfigDO.getAppId());
                request.setTerm_id(oauthYlzConfigDO.getTermId());
                request.setVersion("X.M.0.1");
                request.setTimestamp(DateUtils.getOutTradeTime());
                request.setSign_type("MD5");
                request.setEnc_type("Plain");
                JSONObject bizContent = new JSONObject();
                bizContent.put("open_id", patientWechatDo.getOpenid());
                bizContent.put("account_id",wechatDO.getAppOriginId());
                request.setBiz_content(JSONObject.toJSONString(bizContent));
                EhcHandler ehcHandler = new EhcHandler(oauthYlzConfigDO.getUrl()+"ehcService/gateway.do", oauthYlzConfigDO.getAppId(), oauthYlzConfigDO.getTermId(), oauthYlzConfigDO.getAppKey());
                TransResponse re = ehcHandler.execute(request);
                JSONObject jsonObject = new JSONObject();
                if (re.getRet_code().equalsIgnoreCase("0000")){
                    patientDO.setRegister("1");
                    String idCard = JSONObject.parseObject(re.getBiz_content()).getString("id_no");
                    if (idCard!=null)
                    {
                        patientDO.setIdcard(idCard);
                    }
                    String userName = JSONObject.parseObject(re.getBiz_content()).getString("user_name");
                    if (userName!=null)
                    {
                        patientDO.setName(userName);
                    }
                    String userSex = JSONObject.parseObject(re.getBiz_content()).getString("user_sex");
                    if (userSex!=null){
                        patientDO.setSex(Integer.valueOf(userName));
                    }
                    String mobilePhone = JSONObject.parseObject(re.getBiz_content()).getString("mobile_phone");
                    if (mobilePhone!=null){
                        patientDO.setMobile(mobilePhone);
                    }
                    String birthday = JSONObject.parseObject(re.getBiz_content()).getString("birthday");
                    if (birthday!=null){
                        patientDO.setBirthday(DateUtil.strToDate(birthday));
                    }
                    String telephone = JSONObject.parseObject(re.getBiz_content()).getString("telephone");
                    if (telephone!=null){
                        patientDO.setPhone(telephone);
                    }
                    String address = JSONObject.parseObject(re.getBiz_content()).getString("address");
                    if (address!=null){
                        patientDO.setAddress(address);
                    }
                    basePatientDao.save(patientDO);
                   jsonObject.put("register","1");
                    String ehealthCardId = JSONObject.parseObject(re.getBiz_content()).getString("ehealth_card_id");
                    WlyyHttpLogDO logDO = new WlyyHttpLogDO();
                    logDO.setCode("ehc.ehealthcard.register");
                    logDO.setName("获取多码融合展示码");
                    logDO.setPatient(patientId);
                    logDO.setRequest("ehealthCardId="+ehealthCardId);
                    String codeUrl = mcfGetCodeUrl(ehealthCardId);
                    if (codeUrl!=null){
                        logDO.setResponse(codeUrl);
                        logDO.setStatus("0");
                        logDO.setCreateTime(DateUtil.getNowDate());
                        wlyyHttpLogDao.save(logDO);
                        jsonObject.put("codeUrl",codeUrl);
                        return MixEnvelop.getSuccess("注册成功",jsonObject);
                    }

                }
            }
        }
        return null;
    }
//     获取展码地址
    public  String mcfGetCodeUrl(String ehealth_card_id) throws Exception {
        OauthYlzConfigDO oauthYlzConfigDO = oauthYlzConfigDao.findById("mcf_config").orElse(null);
        TransRequest request = new TransRequest();
        request.setMethod("ehc.ehealthcard.getCodeUrl");
        request.setApp_id(oauthYlzConfigDO.getAppId());
        request.setTerm_id(oauthYlzConfigDO.getTermId());
        request.setVersion("X.M.0.1");
        request.setTimestamp(DateUtils.getOutTradeTime());
        request.setSign_type("RSA");
        request.setEnc_type("Plain");
        JSONObject bizContent = new JSONObject();
        String no = UUID.randomUUID().toString();
        bizContent.put("ehealth_card_id",ehealth_card_id);
        bizContent.put("out_trade_no",no);
        bizContent.put("out_trade_time",DateUtils.getOutTradeTime());
        request.setBiz_content(JSONObject.toJSONString(bizContent));

        EhcHandler ehcHandler = new EhcHandler(oauthYlzConfigDO.getUrl()+"ehcweb/gateway.do", oauthYlzConfigDO.getAppId(), oauthYlzConfigDO.getTermId(), oauthYlzConfigDO.getPrivateKey(), oauthYlzConfigDO.getEhcPublicKey());
        TransResponse re = ehcHandler.execute(request);
        if ("0000".equalsIgnoreCase(re.getRet_code())){
            JSONObject jsonObject = new JSONObject();
            jsonObject.put("code_url",JSONObject.parseObject(re.getBiz_content()).getString("code_url"));
            String code_url = jsonObject.toJSONString().replaceAll("\\|888", "");
            if (code_url!=null){
                return code_url;
            }
        }
        return null;
    }
    //通过身边证查询用户信息
    public  String  mcfQueryInfo(BasePatientDO patientDO) throws Exception {
        OauthYlzConfigDO oauthYlzConfigDO = oauthYlzConfigDao.findById("mcf_config").orElse(null);
        TransRequest request = new TransRequest();
        request.setMethod("ehc.ehealthcard.queryInfo");
        request.setApp_id(oauthYlzConfigDO.getAppId());
        request.setTerm_id(oauthYlzConfigDO.getTermId());
        request.setVersion("X.M.0.1");
        request.setTimestamp(DateUtils.getOutTradeTime());
        request.setSign_type("MD5");
        request.setEnc_type("Plain");
        JSONObject bizContent = new JSONObject();
        String no = UUID.randomUUID().toString();
        bizContent.put("id_type", "01");
        bizContent.put("id_no", patientDO.getIdcard());
        request.setBiz_content(JSONObject.toJSONString(bizContent));
        EhcHandler ehcHandler = new EhcHandler(oauthYlzConfigDO.getUrl()+"ehcService/gateway.do", oauthYlzConfigDO.getAppId(), oauthYlzConfigDO.getTermId(), oauthYlzConfigDO.getAppKey());
        TransResponse re = ehcHandler.execute(request);
        JSONObject jsonObject = new JSONObject();
        if (re.getRet_code().equalsIgnoreCase("0000")){
            JSONObject object = JSONObject.parseObject(re.getBiz_content());
            patientDO.setRegister("1");
            String idCard =object.getString("id_no");
            if (idCard!=null)
            {
                patientDO.setIdcard(idCard);
            }
            String userName = object.getString("user_name");
            if (userName!=null)
            {
                patientDO.setName(userName);
            }
            String userSex = object.getString("user_sex");
            if (userSex!=null){
                patientDO.setSex(Integer.valueOf(userSex));
            }
            String mobilePhone = object.getString("mobile_phone");
            if (mobilePhone!=null){
                patientDO.setMobile(mobilePhone);
            }
            String birthday = object.getString("birthday");
            if (birthday!=null){
                patientDO.setBirthday(DateUtil.strToDate(birthday));
            }
            String telephone = object.getString("telephone");
            if (telephone!=null){
                patientDO.setPhone(telephone);
            }
            String address = object.getString("address");
            if (address!=null){
                patientDO.setAddress(address);
            }
            basePatientDao.save(patientDO);
            jsonObject.put("register",patientDO.getRegister());
            String cardType = object.getString("card_type");
            String cardNo =object.getString("card_no");
            String ehealthCardId = JSONObject.parseObject(re.getBiz_content()).getString("ehealth_card_id");
            WlyyHttpLogDO logDO = new WlyyHttpLogDO();
            logDO.setCode("ehc.ehealthcard.getCodeUr");
            logDO.setName("获取多码融合展示码");
            logDO.setPatient(patientDO.getId());
            logDO.setRequest("ehealthCardId="+ehealthCardId);
            String codeUrl = mcfGetCodeUrl(ehealthCardId);
            if (codeUrl!=null){
                logDO.setResponse(codeUrl);
                logDO.setStatus("0");
                logDO.setCreateTime(DateUtil.getNowDate());
                wlyyHttpLogDao.save(logDO);
                jsonObject.put("codeUrl",codeUrl);
                return codeUrl;
            }
            if (cardType.equalsIgnoreCase("01")){
                if (StringUtils.isNoneBlank(patientDO.getUserId())){
                    String patientId = patientDO.getId();
                    String userId = patientDO.getUserId();
                    ykyyService.addYkCard(patientId,cardNo,userId,"0");
                }else {
                    String mobile = patientDO.getMobile();
                    String response = ykyyService.getUserId(mobile);
                    JSONObject jsonObject1 = JSONObject.parseObject(response);
                    String userId = "";
                    String patientId = patientDO.getId();
                    if (jsonObject1.getString("code").equalsIgnoreCase("200")){
                        JSONObject data = jsonObject1.getJSONObject("data");
                        userId = data.getString("USER_ID");
                    }
                    ykyyService.addYkCard(patientId,cardNo,userId,"0");
                }
            }

        }

        return null;
    }

    public MixEnvelop mcfQueryInfo(String ehealth_card_id ) throws Exception {
        OauthYlzConfigDO oauthYlzConfigDO = oauthYlzConfigDao.findById("mcf_config").orElse(null);
        TransRequest request = new TransRequest();
        request.setMethod("ehc.ehealthcard.queryInfo");
        request.setApp_id(oauthYlzConfigDO.getAppId());
        request.setTerm_id(oauthYlzConfigDO.getTermId());
        request.setVersion("X.M.0.1");
        request.setTimestamp(DateUtils.getOutTradeTime());
        request.setSign_type("MD5");
        request.setEnc_type("Plain");
        JSONObject bizContent = new JSONObject();
        String no = UUID.randomUUID().toString();
        bizContent.put("ehealth_card_id",ehealth_card_id);
        request.setBiz_content(JSONObject.toJSONString(bizContent));
        EhcHandler ehcHandler = new EhcHandler(oauthYlzConfigDO.getUrl()+"ehcService/gateway.do", oauthYlzConfigDO.getAppId(), oauthYlzConfigDO.getTermId(), oauthYlzConfigDO.getAppKey());
        TransResponse re = ehcHandler.execute(request);
        if ("0000".equalsIgnoreCase(re.getRet_code())){
            return MixEnvelop.getSuccess("获取用户信息成功",re);
        }
        return MixEnvelop.getError("获取用户信息失败");

    }
}
