package com.yihu.jw.hospital.service.analysis;

import com.yihu.jw.hospital.prescription.dao.OutpatientDao;
import com.yihu.jw.im.dao.ConsultTeamDao;
import com.yihu.jw.util.date.DateUtil;
import com.yihu.jw.utils.hibernate.HibenateUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import java.text.DecimalFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @author zmk.
 * @vsrsion 1.0
 * Created at 2019/11/21
 */
@Service
public class AnalysisService {

    @Autowired
    private OutpatientDao outpatientDao;
    @Autowired
    private ConsultTeamDao consultTeamDao;
    @Autowired
    private HibenateUtils hibenateUtils;
    @Value("${wechat.id}")
    private String wxId;


    @Value("${wechat.flag}")
    private boolean flag;

    /**
     * 分析总览数据查询
     * @param doctor
     * @param startTime
     * @param endTime
     * @return
     * @throws Exception
     */
    public Object queryAnalysis(String doctor,String startTime,String endTime)throws Exception{
        Map<String, Object> map = new HashMap<>();
        Date start = DateUtil.strToDate(startTime, "yyyy-MM-dd HH:mm:ss");
        Date end = DateUtil.strToDate(endTime, "yyyy-MM-dd HH:mm:ss");
        //在线复诊
        Integer fzNum = outpatientDao.countByTime("1",doctor,start,end);
        //专科协同
        Integer xtNum = outpatientDao.countByTime("2",doctor,start,end);
        //专家咨询
        Integer imNum = consultTeamDao.countByTime(1,doctor,start,end);
        String sqlCountFee = "select t.drug_fee as \"drugFee\"," +
                " t.inspect_fee as \"inspectFee\" , " +
                " t.reg_fee as \"regFee\"  from wlyy_outpatient o " +
                " left join wlyy_prescription t on o.id = t.outpatient_id where o.status != -1" +
                " and t.status in (30,31,32,100,101) ";
        sqlCountFee+= " and o.doctor = '"+doctor+"'";
        if("xm_ykyy_wx".equals(wxId)){
            if (flag){
                sqlCountFee+=" and t.create_time > '" + startTime + " ' and t.create_time<'" + endTime + " '";
            }else {
                sqlCountFee+=" and t.create_time > to_date('" + startTime + " ', 'yyyy-mm-dd hh24:mi:ss') and t.create_time< to_date('" + endTime + " ','yyyy-mm-dd hh24:mi:ss')";
            }
        }else{
            sqlCountFee+=" and t.create_time > '" + startTime + " ' and t.create_time<'" + endTime + " '";
        }
        double totalFee =0.00;
        List<Map<String,Object>> mapList = hibenateUtils.createSQLQuery(sqlCountFee);
        if (null!=mapList&&mapList.size()>0){
            for (Map<String,Object> feemap:mapList){
                String regFee = null==feemap.get("regFee")?"0":feemap.get("regFee").toString();
                String inspectFee =  null==feemap.get("inspectFee")?"0":feemap.get("inspectFee").toString();
                String drugFee =  null==feemap.get("drugFee")?"0":feemap.get("drugFee").toString();
                double singleTotal = Double.parseDouble(regFee)+Double.parseDouble(inspectFee)+Double.parseDouble(drugFee);
                totalFee=totalFee+singleTotal;
            }
        }
        map.put("fzNum",fzNum);
        map.put("xtNum",xtNum);
        map.put("imNum",imNum);
        map.put("srNum",totalFee);

        return map;
    }

}
