package com.yihu.jw.hospital.service.consult;

import com.yihu.jw.article.dao.KnowledgeArticleUserDao;
import com.yihu.jw.doctor.dao.BaseDoctorDao;
import com.yihu.jw.entity.base.doctor.BaseDoctorDO;
import com.yihu.jw.entity.base.patient.BasePatientBusinessDO;
import com.yihu.jw.entity.base.patient.BasePatientDO;
import com.yihu.jw.entity.hospital.article.KnowledgeArticleDO;
import com.yihu.jw.entity.hospital.article.KnowledgeArticleUserDO;
import com.yihu.jw.entity.hospital.survey.WlyySurveyTemplateDO;
import com.yihu.jw.hospital.dao.consult.KnowledgeArticleDao;
import com.yihu.jw.hospital.survey.dao.SurveyTemplateDao;
import com.yihu.jw.hospital.survey.service.SurveyService;
import com.yihu.jw.mysql.query.BaseJpaService;
import com.yihu.jw.patient.dao.BasePatientBusinessDao;
import com.yihu.jw.patient.dao.BasePatientDao;
import com.yihu.jw.restmodel.hospital.survey.WlyySurveyLabelInfoVO;
import com.yihu.jw.restmodel.web.MixEnvelop;
import com.yihu.jw.util.date.DateUtil;
import com.yihu.jw.utils.hibernate.HibenateUtils;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * 患者文章业务层代码
 */
@Service
public class BasePatientBusinessService extends BaseJpaService<BasePatientBusinessDO, BasePatientBusinessDao> {

	@Autowired
	private BasePatientBusinessDao patientBusinessDao;
	@Autowired
	private KnowledgeArticleDao knowledgeArticleDao;
	@Autowired
	private KnowledgeArticleUserDao knowledgeArticleUserDao;
	@Autowired
	private BasePatientDao patientDao;
	@Autowired
	private BaseDoctorDao doctorDao;
	@Autowired
	private SurveyTemplateDao surveyTemplateDao;
	@Autowired
	private HibenateUtils hibenateUtils;
	@Autowired
	private SurveyService surveyService;
	/**
	 *
	 * @param id
	 * @param flag 1收藏2阅读3点赞4分享
	 * @param status
	 * @return
	 */
	public KnowledgeArticleDO setCollectionById(String id,Integer flag,Integer status,String user,String userType){
		KnowledgeArticleDO knowledgeArticleDO = knowledgeArticleDao.findByIdAndDel(id);
		KnowledgeArticleUserDO knowledgeArticleUserDO =knowledgeArticleUserDao.findByrelationCodeAndUserAndDel(id,user);
		if (knowledgeArticleUserDO==null){
			knowledgeArticleUserDO = new KnowledgeArticleUserDO();
			knowledgeArticleUserDO.setRelationCode(id);
			knowledgeArticleUserDO.setRelationName(knowledgeArticleDO.getTitle());
			knowledgeArticleUserDO.setRelationType(1);
			knowledgeArticleUserDO.setDel(1);
			knowledgeArticleUserDO.setUser(user);
			if (StringUtils.isNoneBlank(userType)&&userType.equalsIgnoreCase("1")){
				BasePatientDO patientDO = patientDao.findById(user).orElse(null);
				if (patientDO!=null){
					knowledgeArticleUserDO.setUserName(patientDO.getName());
					knowledgeArticleUserDO.setCreateUserName(patientDO.getName());
				}
			}else if (StringUtils.isNoneBlank(userType)&&userType.equalsIgnoreCase("2")){
				BaseDoctorDO doctorDO = doctorDao.findById(user).orElse(null);
				if (doctorDO!=null){
					knowledgeArticleUserDO.setUserName(doctorDO.getName());
					knowledgeArticleUserDO.setCreateUserName(doctorDO.getName());
				}
			}

			knowledgeArticleUserDO.setCreateTime(new Date());
			knowledgeArticleUserDO.setUpdateTime(new Date());
			knowledgeArticleUserDO.setCreateUser(user);
			knowledgeArticleUserDO.setUpdateUser(user);
			knowledgeArticleUserDO = knowledgeArticleUserDao.save(knowledgeArticleUserDO);
		}
		if (knowledgeArticleDO!=null){
			if (flag!=null&&flag==1){
				knowledgeArticleUserDO.setCollection(status);
				knowledgeArticleUserDO.setRelationName(knowledgeArticleDO.getTitle());
				knowledgeArticleUserDao.save(knowledgeArticleUserDO);
				if (knowledgeArticleDO!=null){
					if (knowledgeArticleDO.getCollection()!=null){
						if (status==1){
							knowledgeArticleDO.setCollection(knowledgeArticleDO.getCollection()+1);
							knowledgeArticleDO = knowledgeArticleDao.save(knowledgeArticleDO);
						}else {
							knowledgeArticleDO.setCollection(knowledgeArticleDO.getCollection()-1);
							knowledgeArticleDO =knowledgeArticleDao.save(knowledgeArticleDO);
						}
					}else {
						if (status==1){
							knowledgeArticleDO.setCollection(1);
							knowledgeArticleDO=	knowledgeArticleDao.save(knowledgeArticleDO);
						}
					}
				}
			}else if (flag!=null&&flag==2){
				knowledgeArticleUserDO.setIsRead(status);
				knowledgeArticleUserDao.save(knowledgeArticleUserDO);
				if (knowledgeArticleDO!=null){
					if (knowledgeArticleDO.getReadCount()!=null){
						if (status==1){
							knowledgeArticleDO.setReadCount(knowledgeArticleDO.getReadCount()+1);
							knowledgeArticleDO = knowledgeArticleDao.save(knowledgeArticleDO);
						}else {
							knowledgeArticleDO.setReadCount(knowledgeArticleDO.getReadCount()-1);
							knowledgeArticleDO = knowledgeArticleDao.save(knowledgeArticleDO);
						}
					}else {
						if (status==1){
							knowledgeArticleDO.setReadCount(1);
							knowledgeArticleDO = knowledgeArticleDao.save(knowledgeArticleDO);
						}
					}
				}
			}else if (flag!=null&&flag==3){
				knowledgeArticleUserDO.setFabulous(status);
				knowledgeArticleUserDao.save(knowledgeArticleUserDO);
				if (knowledgeArticleDO!=null){
					if (knowledgeArticleDO.getFabulous()!=null){
						if (status==1){
							knowledgeArticleDO.setFabulous(knowledgeArticleDO.getFabulous()+1);
							knowledgeArticleDO=knowledgeArticleDao.save(knowledgeArticleDO);
						}else {
							knowledgeArticleDO.setFabulous(knowledgeArticleDO.getFabulous()-1);
							knowledgeArticleDO = knowledgeArticleDao.save(knowledgeArticleDO);
						}
					}else {
						if (status==1){
							knowledgeArticleDO.setFabulous(1);
							knowledgeArticleDO= knowledgeArticleDao.save(knowledgeArticleDO);
						}
					}
				}
			}else if (flag!=null&&flag==4){
				knowledgeArticleUserDO.setShare(status);
				knowledgeArticleUserDao.save(knowledgeArticleUserDO);
				if (knowledgeArticleDO!=null){
					if (knowledgeArticleDO.getShare()!=null){
						if (status==1){
							knowledgeArticleDO.setShare(knowledgeArticleDO.getShare()+1);
							knowledgeArticleDO = knowledgeArticleDao.save(knowledgeArticleDO);
						}else {
							knowledgeArticleDO.setShare(knowledgeArticleDO.getShare()-1);
							knowledgeArticleDO = knowledgeArticleDao.save(knowledgeArticleDO);
						}
					}else {
						if (status==1){
							knowledgeArticleDO.setShare(1);
							knowledgeArticleDO = knowledgeArticleDao.save(knowledgeArticleDO);
						}
					}
				}
			}
		}
		return knowledgeArticleDO;
	}
	public void setUsed(String id,Integer used,String doctor){
		WlyySurveyTemplateDO wlyySurveyTemplateDO = surveyTemplateDao.findById(id).orElse(null);
		BaseDoctorDO doctorDO = doctorDao.findById(doctor).orElse(null);
		KnowledgeArticleUserDO knowledgeArticleUserDO =knowledgeArticleUserDao.findByrelationCodeAndUserAndDel(id,doctor);
		if (null==knowledgeArticleUserDO){
			knowledgeArticleUserDO = new KnowledgeArticleUserDO();
			knowledgeArticleUserDO.setUsed(used);
			knowledgeArticleUserDO.setRelationCode(id);
			knowledgeArticleUserDO.setRelationName(wlyySurveyTemplateDO.getTitle());
			knowledgeArticleUserDO.setRelationType(2);
			knowledgeArticleUserDO.setDel(1);
			knowledgeArticleUserDO.setUser(doctor);
			if (doctorDO!=null){
				knowledgeArticleUserDO.setUserName(doctorDO.getName());
				knowledgeArticleUserDO.setCreateUserName(doctorDO.getName());
			}
			knowledgeArticleUserDO.setCreateTime(new Date());
			knowledgeArticleUserDO.setUpdateTime(new Date());
			knowledgeArticleUserDO.setCreateUser(doctor);
			knowledgeArticleUserDO.setUpdateUser(doctor);
			knowledgeArticleUserDO = knowledgeArticleUserDao.save(knowledgeArticleUserDO);
		}
		if (wlyySurveyTemplateDO!=null){
			if (wlyySurveyTemplateDO.getUsed()!=null){
				if (used==1){
					knowledgeArticleUserDO.setUsed(1);
					wlyySurveyTemplateDO.setUsed(wlyySurveyTemplateDO.getUsed()+1);
				}else if (used==0){
					knowledgeArticleUserDO.setUsed(0);
					wlyySurveyTemplateDO.setUsed(wlyySurveyTemplateDO.getUsed()==0?0:wlyySurveyTemplateDO.getUsed()-1);
				}
			}else {
				if (used==1){
					wlyySurveyTemplateDO.setUsed(1);
				}else if (used==0){
					wlyySurveyTemplateDO.setUsed(0);
				}
			}
		}
		knowledgeArticleUserDao.save(knowledgeArticleUserDO);
		surveyTemplateDao.save(wlyySurveyTemplateDO);
	}
	public MixEnvelop getUsedList(String title, String doctor,String labelCode,  Integer used, Integer page, Integer pageSize) {
		StringBuffer sql = new StringBuffer();
		MixEnvelop mixEnvelop = new MixEnvelop();

		sql.append("SELECT " +
				" t.id as \"id\", " +
				" b.used as \"used\","+
				" t.title as \"title\", " +
				" t.template_comment AS \"templateComment\", " +
				" t.organization as \"organization\", " +
				" t.creater as \"creater\", " +
				" t.creater_code as \"creater_code\", " +
				" t.create_time AS \"createTime\", " +
				" t.del as \"del\", " +
				" t.update_time AS \"updateTime\"" +
				" FROM " +
				" wlyy_survey_template t ");
		//1为查询常用
		if (null != used) {
			if (1 == used) {
				if (StringUtils.isNotEmpty(labelCode)){
					sql.append(" JOIN wlyy_survey_label_info i on t.id = i.survey_temp_code ");
				}
				sql.append(" JOIN wlyy_knowledge_article_user b on t.id = b.relation_code where 1=1 ");
				sql.append(" and b.used = 1");
				if (StringUtils.isNotEmpty(title)) {
					sql.append(" and t.title like '%" + title + "%'");

				}
				if (StringUtils.isNotEmpty(doctor)) {
					sql.append(" and b.user_code ='"+doctor+"'");

				}
				if (StringUtils.isNotEmpty(labelCode)){
					sql.append(" and i.label_code = '"+labelCode+"'");
				}
				System.out.println(sql);
				String sqlCount = "select Count(1) as \"total\" from ("+sql+") l";
				List<Map<String, Object>> list = hibenateUtils.createSQLQuery(sql.toString(), page, pageSize);
				List<Map<String, Object>> listCount = hibenateUtils.createSQLQuery(sqlCount);
				Long count = 0L;
				if (listCount.size()>0){
					count = hibenateUtils.objTransformLong(listCount.get(0).get("total"));
				}
				if (list.size() > 0) {
					for (Map<String, Object> map : list) {
						List<WlyySurveyLabelInfoVO>  wlyySurveyLabelInfoVOS= surveyService.findSurveyTemplateLabel(null==map.get("id")?"":map.get("id").toString());
						String createTime = null == map.get("createTime") ? "" : map.get("createTime").toString();
                        String updateTime = null == map.get("updateTime") ? "" : map.get("updateTime").toString();
						map.put("createTime", DateUtil.dateToStrLong(DateUtil.strToDateLong(createTime)));
                        map.put("updateTime", DateUtil.dateToStrLong(DateUtil.strToDateLong(updateTime)));
						map.put("labels",wlyySurveyLabelInfoVOS);
					}
				}
				mixEnvelop.setPageSize(pageSize);
				mixEnvelop.setCurrPage(page);
				mixEnvelop.setTotalCount(count.intValue());
				mixEnvelop.setDetailModelList(list);
				return mixEnvelop;
				//0为查询模板
			} else {
				sql.append("JOIN wlyy_survey_label_info i ON t.id = i.survey_temp_code where 1=1");
				sql.append(" and t.del = 1");
				if (StringUtils.isNotEmpty(doctor)) {
					sql.append(" and t.title like '%" + title + "%'");
				}
				String sqlCount = "select Count(1) as \"total\" from ("+sql+") l";
				List<Map<String, Object>> list = hibenateUtils.createSQLQuery(sql.toString(), page, pageSize);
				List<Map<String, Object>> listCount = hibenateUtils.createSQLQuery(sqlCount);
				Long count = 0L;
				if (listCount.size()>0){
					count = hibenateUtils.objTransformLong(listCount.get(0).get("total"));
				}
				if (list.size() > 0) {
					for (Map<String, Object> map : list) {
						List<WlyySurveyLabelInfoVO>  wlyySurveyLabelInfoVOS= surveyService.findSurveyTemplateLabel(null==map.get("id")?"":map.get("id").toString());
						map.put("labels",wlyySurveyLabelInfoVOS);
                        String createTime = null == map.get("createTime") ? "" : map.get("createTime").toString();
                        String updateTime = null == map.get("updateTime") ? "" : map.get("updateTime").toString();
                        map.put("createTime", DateUtil.dateToStrLong(DateUtil.strToDateLong(createTime)));
                        map.put("updateTime", DateUtil.dateToStrLong(DateUtil.strToDateLong(updateTime)));
					}
				}
				mixEnvelop.setPageSize(pageSize);
				mixEnvelop.setCurrPage(page);
				mixEnvelop.setTotalCount(count.intValue());
				mixEnvelop.setDetailModelList(list);
				return mixEnvelop;
			}
			//空位查我的问卷
		} else {
			sql.append("JOIN wlyy_survey_label_info i ON t.id = i.survey_temp_code where 1=1");
			sql.append(" and t.del = 1");
			if (StringUtils.isNotEmpty(doctor)) {
				sql.append(" and t.creater = '" + doctor + "'");
			}
			if (StringUtils.isNotEmpty(doctor)) {
				sql.append(" and t.title like '%" + title + "%'");
			}
			String sqlCount = "select Count(1) as \"total\" from ("+sql+") l";
			List<Map<String, Object>> list = hibenateUtils.createSQLQuery(sql.toString(), page, pageSize);
			List<Map<String, Object>> listCount = hibenateUtils.createSQLQuery(sqlCount);
			Long count = 0L;
			if (listCount.size()>0){
				count = hibenateUtils.objTransformLong(listCount.get(0).get("total"));
			}
			if (list.size() > 0) {
				for (Map<String, Object> map : list) {
					List<WlyySurveyLabelInfoVO>  wlyySurveyLabelInfoVOS= surveyService.findSurveyTemplateLabel(null==map.get("id")?"":map.get("id").toString());
					map.put("labels",wlyySurveyLabelInfoVOS);
                    String createTime = null == map.get("createTime") ? "" : map.get("createTime").toString();
                    String updateTime = null == map.get("updateTime") ? "" : map.get("updateTime").toString();
                    map.put("createTime", DateUtil.dateToStrLong(DateUtil.strToDateLong(createTime)));
                    map.put("updateTime", DateUtil.dateToStrLong(DateUtil.strToDateLong(updateTime)));

				}
			}
			mixEnvelop.setPageSize(pageSize);
			mixEnvelop.setCurrPage(page);
			mixEnvelop.setTotalCount(count.intValue());
			mixEnvelop.setDetailModelList(list);
			return mixEnvelop;
		}
	}
}
