package com.yihu.jw.hospital.service.consult;

import com.yihu.jw.entity.hospital.consult.WlyyHospitalConsultPriceDO;
import com.yihu.jw.hospital.dao.consult.ConsultPriceDao;
import com.yihu.jw.mysql.query.BaseJpaService;
import net.sf.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Map;

@Service
public class ConsultPriceService extends BaseJpaService<WlyyHospitalConsultPriceDO, ConsultPriceDao> {
    @Autowired
    private ConsultPriceDao consultPriceDao;

    /**
     * // 根据机构编码查询所有计费列表
     * @param jsonObject
     * @param hospital
     * @return
     *
     */
    public WlyyHospitalConsultPriceDO saveConsultPrice(JSONObject jsonObject, String hospital){
        /*CREATE TABLE `wlyy_hospital_consult_price` (
             `id` varchar(50) NOT NULL,
             `saas_id` varchar(50) DEFAULT NULL,
             `type` int(1) DEFAULT '1' COMMENT '0图文 1视频',
             `pay_type` int(1) DEFAULT '0' COMMENT '0按次收费 1计时收费 3固定时长收费 4',
             `dept` varchar(500) DEFAULT NULL COMMENT '服务科室',
             `doctor_job` varchar(50) DEFAULT NULL COMMENT '0专家 1主任 2医师',
             `service_range` varchar(50) DEFAULT NULL COMMENT '0帮扶医院、社区  1普通患者',
             `price` int(11) DEFAULT NULL COMMENT '价格',
             `hospital` varchar(50) DEFAULT NULL,
                   PRIMARY KEY (`id`)
           ) ENGINE=InnoDB DEFAULT CHARSET=utf8 COMMENT='医院咨询计费价目表';*/

        int flag = -1;
        WlyyHospitalConsultPriceDO wlyyHospitalConsultPriceDO = new WlyyHospitalConsultPriceDO();
        Map dataDetail  = JSONObject.fromObject(jsonObject);
        String id = dataDetail.get("id") == "" ? "":dataDetail.get("id").toString();
        // 若id为空，则为新增，否则走更新操作。
        if ("".equals(id)) {
            wlyyHospitalConsultPriceDO.setSaasId("");
            wlyyHospitalConsultPriceDO.setType(dataDetail.get("type") == "" ? 0 : Integer.parseInt(dataDetail.get("type").toString()));
            wlyyHospitalConsultPriceDO.setPayType(dataDetail.get("payType") == "" ? 0 : Integer.parseInt(dataDetail.get("payType").toString()));
            wlyyHospitalConsultPriceDO.setDept(dataDetail.get("dept") == "" ? "" : dataDetail.get("dept").toString());
            wlyyHospitalConsultPriceDO.setDoctorJob(dataDetail.get("doctorJob") == "" ? "" : dataDetail.get("doctorJob").toString());
            wlyyHospitalConsultPriceDO.setServiceRange(dataDetail.get("serviceRange") == "" ? "" : dataDetail.get("serviceRange").toString());
            wlyyHospitalConsultPriceDO.setPrice(dataDetail.get("price") == "" ? 0 : Integer.parseInt(dataDetail.get("price").toString()));
            wlyyHospitalConsultPriceDO.setHospital(hospital);
            wlyyHospitalConsultPriceDO = consultPriceDao.save(wlyyHospitalConsultPriceDO);
        }else{
            WlyyHospitalConsultPriceDO wlyyHospitalConsultPriceDOL = consultPriceDao.findById(id).orElse(null);
            wlyyHospitalConsultPriceDOL.setType(dataDetail.get("type") == "" ? 0 : Integer.parseInt(dataDetail.get("type").toString()));
            wlyyHospitalConsultPriceDOL.setPayType(dataDetail.get("payType") == "" ? 0 : Integer.parseInt(dataDetail.get("payType").toString()));
            wlyyHospitalConsultPriceDOL.setDept(dataDetail.get("dept") == "" ? "" : dataDetail.get("dept").toString());
            wlyyHospitalConsultPriceDOL.setDoctorJob(dataDetail.get("doctorJob") == "" ? "" : dataDetail.get("doctorJob").toString());
            wlyyHospitalConsultPriceDOL.setServiceRange(dataDetail.get("serviceRange") == "" ? "" : dataDetail.get("serviceRange").toString());
            wlyyHospitalConsultPriceDOL.setPrice(dataDetail.get("price") == "" ? 0 : Integer.parseInt(dataDetail.get("price").toString()));
            wlyyHospitalConsultPriceDO.setHospital(hospital);
            wlyyHospitalConsultPriceDO = consultPriceDao.save(wlyyHospitalConsultPriceDOL);
        }
        return wlyyHospitalConsultPriceDO;
    }



    public void deleteConsultPrice(String id){
        consultPriceDao.deleteById(id);
    }

}
