package com.yihu.jw.hospital.service.consult;

import com.yihu.jw.entity.hospital.consult.WlyyHospitalReservationSettingDO;
import com.yihu.jw.hospital.dao.consult.ReservationSettingDao;
import com.yihu.jw.mysql.query.BaseJpaService;
import net.sf.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Map;

@Service
public class ReservationSettingService extends BaseJpaService<WlyyHospitalReservationSettingDO, ReservationSettingDao> {
    @Autowired
    private ReservationSettingDao reservationSettingDao;

    public WlyyHospitalReservationSettingDO saveReverationSetting(JSONObject jsonObject, Map baseInfo){
        int flag = -1;
        WlyyHospitalReservationSettingDO wlyyHospitalReservationSettingDO = new WlyyHospitalReservationSettingDO();
        Map dataDetail  = JSONObject.fromObject(jsonObject);
        String id = dataDetail.get("id") == "" ? "":dataDetail.get("id").toString();

        // 若id为空，则为新增，否则走更新操作。
        if ("".equals(id)) {
            wlyyHospitalReservationSettingDO.setSaasId("");
            wlyyHospitalReservationSettingDO.setCity(baseInfo.get("city").toString());
            wlyyHospitalReservationSettingDO.setCityName(baseInfo.get("cityName").toString());
            wlyyHospitalReservationSettingDO.setTown(baseInfo.get("town").toString());
            wlyyHospitalReservationSettingDO.setTownName(baseInfo.get("townName").toString());
            wlyyHospitalReservationSettingDO.setHospital(baseInfo.get("hospital").toString());
            wlyyHospitalReservationSettingDO.setHospitalName(baseInfo.get("hospitalName").toString());
            wlyyHospitalReservationSettingDO.setDept(dataDetail.get("dept").toString());
            wlyyHospitalReservationSettingDO.setDeptName(dataDetail.get("deptName").toString());
            wlyyHospitalReservationSettingDO.setDoctor(dataDetail.get("doctor").toString());
            wlyyHospitalReservationSettingDO.setDoctorName(dataDetail.get("doctorName").toString());
            wlyyHospitalReservationSettingDO.setJob(dataDetail.get("job").toString());
            wlyyHospitalReservationSettingDO.setJobName(dataDetail.get("jobName").toString());
            wlyyHospitalReservationSettingDO.setDiseaseRange(dataDetail.get("diseaseRange").toString());
            wlyyHospitalReservationSettingDO.setConsultType(Integer.parseInt(dataDetail.get("consultType").toString()));
            wlyyHospitalReservationSettingDO.setReservationStatus(Integer.parseInt(dataDetail.get("reservationStatus").toString()));
            wlyyHospitalReservationSettingDO = reservationSettingDao.save(wlyyHospitalReservationSettingDO);
        }else{
            WlyyHospitalReservationSettingDO wlyyHospitalReservationSettingDOL = reservationSettingDao.findById(id).orElse(null);
            wlyyHospitalReservationSettingDOL.setDept(dataDetail.get("dept").toString());
            wlyyHospitalReservationSettingDOL.setDeptName(dataDetail.get("deptName").toString());
            wlyyHospitalReservationSettingDOL.setDoctor(dataDetail.get("doctor").toString());
            wlyyHospitalReservationSettingDOL.setDoctorName(dataDetail.get("doctorName").toString());
            wlyyHospitalReservationSettingDOL.setJob(dataDetail.get("job").toString());
            wlyyHospitalReservationSettingDOL.setJobName(dataDetail.get("jobName").toString());
            wlyyHospitalReservationSettingDOL.setDiseaseRange(dataDetail.get("diseaseRange").toString());
            wlyyHospitalReservationSettingDOL.setConsultType(Integer.parseInt(dataDetail.get("consultType").toString()));
            wlyyHospitalReservationSettingDOL.setReservationStatus(Integer.parseInt(dataDetail.get("reservationStatus").toString()));
            wlyyHospitalReservationSettingDO = reservationSettingDao.save(wlyyHospitalReservationSettingDOL);
        }

        return  wlyyHospitalReservationSettingDO;
    }


    public void deleteReservationSetting(String id){
        reservationSettingDao.deleteById(id);
    }

}
