package  com.yihu.customer.controller.export.excel;

import  com.yihu.customer.controller.BaseController;
import com.yihu.customer.service.doctor.DoctorService;
import jxl.Workbook;
import jxl.write.Label;
import jxl.write.WritableSheet;
import jxl.write.WritableWorkbook;
import jxl.write.WriteException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.OutputStream;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * Created by wxw on 2018/11/6.
 *
 * @author wxw.
 */
@Controller
@RequestMapping("/doctor")
public class DoctorController extends BaseController {
    @Autowired
    private DoctorService doctorService;

    @RequestMapping(value = "/outExcel", produces = "application/json;charset=UTF-8")
    @ResponseBody
    public void outExcel(String hospital, HttpServletResponse response) {

        try {
            List<Map<String, Object>> list = doctorService.findConsultAndConcernByHospitalDept(hospital);
            List<Map<String, Object>> list2 = doctorService.findConsultAndConcernByHospitalDoctor(hospital);

            //基本设置
            response.setContentType("application/vnd.ms-excel");
            String fileName = "医院关注咨询统计";
            SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMdd");
            Date date = new Date();
            response.setHeader("Content-Disposition", "attachment; filename="
                    + new String(fileName.getBytes("UTF-8"), "ISO8859-1") + "_" + sdf.format(date) + ".xls");
            OutputStream os = response.getOutputStream();
            //处理Excel
            WritableWorkbook book = Workbook.createWorkbook(os);
            WritableSheet sheet = book.createSheet("按科室", 0);
            sheet.addCell(new Label(0, 0, "编号"));
            sheet.addCell(new Label(1, 0, "医院名称"));
            sheet.addCell(new Label(2, 0, "科室名称"));
            sheet.addCell(new Label(3, 0, "关注人数"));
            sheet.addCell(new Label(4, 0, "咨询数"));
            List<Map<String, Object>> objList = list;
            if (null != objList && objList.size() > 0 && objList.get(0).size() > 0) {
                for(int i = 0; i< objList.size(); i ++) {
                    Map<String, Object> objMap = objList.get(i);
                    sheet.addCell(new Label(0, i + 1, String.valueOf(i + 1)));
                    sheet.addCell(new Label(1, i + 1, String.valueOf(objMap.get("hospital"))));
                    sheet.addCell(new Label(2, i + 1, String.valueOf(objMap.get("dept"))));
                    sheet.addCell(new Label(3, i + 1, String.valueOf(objMap.get("concern"))));
                    sheet.addCell(new Label(4, i + 1, String.valueOf(objMap.get("consult"))));
                }
            }

            WritableSheet sheet2 = book.createSheet("按医生", 1);
            sheet2.addCell(new Label(0, 0, "编号"));
            sheet2.addCell(new Label(1, 0, "医院名称"));
            sheet2.addCell(new Label(2, 0, "科室名称"));
            sheet2.addCell(new Label(3, 0, "医生"));
            sheet2.addCell(new Label(4, 0, "关注人数"));
            sheet2.addCell(new Label(5, 0, "咨询数"));
            List<Map<String, Object>> listMap = list2;
            if (null != listMap && listMap.size() > 0 && listMap.get(0).size() > 0) {
                for(int i = 0; i< listMap.size(); i ++) {
                    Map<String, Object> objMap = listMap.get(i);
                    sheet2.addCell(new Label(0, i + 1, String.valueOf(i + 1)));
                    sheet2.addCell(new Label(1, i + 1, String.valueOf(objMap.get("hospital"))));
                    sheet2.addCell(new Label(2, i + 1, String.valueOf(objMap.get("dept"))));
                    sheet2.addCell(new Label(3, i + 1, String.valueOf(objMap.get("name"))));
                    sheet2.addCell(new Label(4, i + 1, String.valueOf(objMap.get("concern"))));
                    sheet2.addCell(new Label(5, i + 1, String.valueOf(objMap.get("consult"))));
                }
            }

            book.write();
            book.close();
            os.flush();
            os.close();
        } catch (IOException e) {
            e.printStackTrace();
        } catch (WriteException e) {
            e.printStackTrace();
        }

    }

}
