package  com.yihu.customer.controller.manager;

import org.apache.shiro.web.filter.authc.FormAuthenticationFilter;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;

import javax.servlet.http.HttpServletRequest;

/**
 * LoginController负责打开登录页面(GET请求)和登录出错页面(POST请求)，
 * 
 * 真正登录的POST请求由Filter完成,
 * 
 * @author calvin
 */
@Controller
@RequestMapping(value = "/login")
public class AdminController {

	@RequestMapping(method = RequestMethod.GET)
	public String login(HttpServletRequest req) {
		try {
			if(req.getSession().getAttribute("errorTipNum")!=null){
				Integer errorTipNum = (Integer) req.getSession().getAttribute("errorTipNum");
				if(errorTipNum==1){
					req.getSession().setAttribute("errorTipNum",2);
				}else {
					req.getSession().setAttribute(FormAuthenticationFilter.DEFAULT_ERROR_KEY_ATTRIBUTE_NAME, "");
					req.getSession().removeAttribute("errorTipNum");
				}
			}
		}catch (Exception e){
			e.printStackTrace();
		}
		return "login";
	}

	@RequestMapping(method = RequestMethod.POST)
	public String fail(@RequestParam(FormAuthenticationFilter.DEFAULT_USERNAME_PARAM) String userName,  Model model) {
		model.addAttribute(FormAuthenticationFilter.DEFAULT_USERNAME_PARAM, userName);
		return "login";
	}

}
