package  com.yihu.customer.controller.manager.consult;

import  com.yihu.customer.controller.BaseController;
import  com.yihu.customer.entity.consult.WlyyConsultRemindLog;
import com.yihu.customer.service.manager.consult.WlyyConsultRemindLogService;
import com.yihu.customer.util.DateUtil;
import io.swagger.annotations.Api;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.PageImpl;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import java.util.Date;

/**
 * Created by linz on 2017/5/15.
 */
@Controller
@RequestMapping(value = "admin/consult/remind")
@Api(description = "咨询提醒")
public class ConsultRemindController extends BaseController {

    //    咨询列表
    @RequestMapping(value = "initial", method = RequestMethod.GET)
    public String listInit () {
        return "consult/consult_list";
    }

    //    医生信息
    @RequestMapping(value = "docInfo/{code}/{remind}/{reply}/{isclick}", method = RequestMethod.GET)
    public  String DocInfo (@PathVariable("code") String code, @PathVariable("remind") String remind, @PathVariable("reply") String reply, @PathVariable("isclick") String isclick) throws  Exception {
        request.setAttribute("code",code);
        request.setAttribute("remind",remind);
        request.setAttribute("reply",reply);
        request.setAttribute("isclick",isclick);
        return "consult/consult_doctor_info";
    }

    //    咨询提醒
    @RequestMapping(value = "remind/{code}",method = RequestMethod.GET)
    public String Remind (@PathVariable("code") String code) {
        request.setAttribute( "code", code);
        return "consult/consult_remind_content";
    }

    //提醒记录
    @RequestMapping(value = "relyHis",method = RequestMethod.GET)
    public String ReplyHis () {
        return "consult/consult_remind_reply_list";
    }

    @Autowired
    private WlyyConsultRemindLogService wlyyConsultRemindLogService;

    //获取咨询列表
    @RequestMapping(value = "list")
    @ResponseBody
    public String searchList(
            @RequestParam(value = "city",required = false) String city,
            @RequestParam(value = "town",required = false) String town,
            @RequestParam(value = "hospital",required = false) String hospital,
            @RequestParam(value = "teamCode",required = false) String teamCode,
            @RequestParam(value = "doctorName",required = false) String doctorName,
            @RequestParam(value = "doctor",required = false) String doctor,
            @RequestParam(value = "beginDate",required = false) String beginDateString,
            @RequestParam(value = "endDate",required = false) String endDateString,
            @RequestParam(value = "remindType",required = false) String remindType,
            @RequestParam(value = "page",required = true) int page,
            @RequestParam(value = "rows",required = true) int rows){
        try {
            Date beginDate = null;
            Date endDate = null;
            if(StringUtils.isNotBlank(beginDateString)){
                beginDate = DateUtil.strToDate(beginDateString,DateUtil.YYYY_MM_DD_HH_MM_SS);
            }
            if(StringUtils.isNotBlank(endDateString)){
                endDate = DateUtil.strToDate(endDateString,DateUtil.YYYY_MM_DD_HH_MM_SS);
            }
            PageImpl<WlyyConsultRemindLog> consults = wlyyConsultRemindLogService.list(city,town,hospital,teamCode,doctorName,doctor,beginDate,endDate,remindType,page,rows);
            return write(200,"查询成功",page,rows,consults);
        }catch (Exception ex){
            error(ex);
            return error(-1, "查询失败！");
        }
    }

    //提醒医生
    @RequestMapping(value = "doctor")
    @ResponseBody
    public String remind(
            @RequestParam(value = "doctor",required = false) String doctor,
            @RequestParam(value = "remindType",required = false) Integer remindType,
            @RequestParam(value = "content",required = false) String content){
        try {
            wlyyConsultRemindLogService.remind(doctor,remindType,content);
            return write(200,"提醒成功！");
        }catch (Exception ex){
            error(ex);
            return error(-1, "提醒失败！");
        }
    }



}
