package  com.yihu.customer.controller.manager.consult;

import  com.yihu.customer.controller.BaseController;
import  com.yihu.customer.entity.consult.WlyyReplyConsult;
import com.yihu.customer.service.manager.consult.WlyyReplyConsultService;
import com.yihu.customer.util.DateUtil;
import io.swagger.annotations.Api;
import org.apache.commons.lang3.StringUtils;
import org.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.PageImpl;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import java.text.DecimalFormat;
import java.util.Date;

/**
 * Created by linz on 2017/5/15.
 */
@Controller
@RequestMapping(value = "admin/consult/reply")
@Api(description = "咨询回复统计相关")
public class ConsultReplyController extends BaseController {
    @Autowired
    private WlyyReplyConsultService wlyyReplyConsultService;

    //获取咨询列表
    @RequestMapping(value = "list")
    @ResponseBody
    public String searchList(
            @RequestParam(value = "city",required = false) String city,
            @RequestParam(value = "town",required = false) String town,
            @RequestParam(value = "hospital",required = false) String hospital,
            @RequestParam(value = "teamCode",required = false) String teamCode,
            @RequestParam(value = "doctorName",required = false) String doctorName,
            @RequestParam(value = "doctor",required = false) String doctor,
            @RequestParam(value = "reply",required = false) Integer reply,
            @RequestParam(value = "status",required = false) Integer status,
            @RequestParam(value = "beginDate",required = false) String beginDateString,
            @RequestParam(value = "endDate",required = false) String endDateString,
            @RequestParam(value = "page",required = true) int page,
            @RequestParam(value = "rows",required = true) int rows){
        try {
            Date beginDate = null;
            Date endDate = null;
            if(StringUtils.isNotBlank(beginDateString)){
                beginDate = DateUtil.strToDate(beginDateString,DateUtil.YYYY_MM_DD_HH_MM_SS);
            }
            if(StringUtils.isNotBlank(endDateString)){
                endDate = DateUtil.strToDate(endDateString,DateUtil.YYYY_MM_DD_HH_MM_SS);
            }
            PageImpl<WlyyReplyConsult> consults = wlyyReplyConsultService.list(city,town,hospital,teamCode,doctorName,doctor,reply,status,beginDate,endDate,page,rows);
            return write(200,"操作成功",page,rows,consults);
        }catch (Exception ex){
            error(ex);
            return error(-1, "操作失败！");
        }
    }


    //获取咨询总数及回复率
    @RequestMapping(value = "rate")
    @ResponseBody
    public String getHandData(
            @RequestParam(value = "city",required = false) String city,
            @RequestParam(value = "town",required = false) String town,
            @RequestParam(value = "hospital",required = false) String hospital,
            @RequestParam(value = "teamCode",required = false) String teamCode,
            @RequestParam(value = "doctorName",required = false) String doctorName,
            @RequestParam(value = "beginDate",required = false) String beginDateString,
            @RequestParam(value = "endDate",required = false) String endDateString){
        try {
            Date beginDate = null;
            Date endDate = null;
            if(StringUtils.isNotBlank(beginDateString)){
                beginDate = DateUtil.strToDate(beginDateString,DateUtil.YYYY_MM_DD_HH_MM_SS);
            }
            if(StringUtils.isNotBlank(endDateString)){
                endDate = DateUtil.strToDate(endDateString,DateUtil.YYYY_MM_DD_HH_MM_SS);
            }
            JSONObject result = new JSONObject();
            //未回复数量
            int countNoReply = wlyyReplyConsultService.getCountByFilter(city,town,hospital,teamCode,doctorName,null,0,0,beginDate,endDate);
            //总数
            int count = wlyyReplyConsultService.getCountByFilter(city,town,hospital,teamCode,doctorName,null,null,null,beginDate,endDate);
            result.put("count",count);
            result.put("noReply",countNoReply);
            DecimalFormat df = new DecimalFormat("0.00");//格式化小数，不足的补0
            Double rate;
            if(count!=0){
                rate = (countNoReply*100.00)/count;
                String  num = df.format(rate);//返回的是String类型的
                result.put("rate",num+"%");
            }else{
                result.put("rate","0.00%");
            }


            return write(200,"获取成功！","data",result);
        }catch (Exception ex){
            error(ex);
            return error(-1, "操作失败！");
        }
    }

    //获取咨询未回复总数
    @RequestMapping(value = "noReply")
    @ResponseBody
    public String getHandData(
            @RequestParam(value = "doctor",required = false) String doctor){
        try {
            //未回复数量
            int countNoReply = wlyyReplyConsultService.getCountByFilter(null,null,null,null,null,doctor,0,0,null,null);
            return write(200,"获取成功！","data",countNoReply);
        }catch (Exception ex){
            error(ex);
            return error(-1, "操作失败！");
        }
    }


}
