package  com.yihu.customer.controller.manager.datastatic;

import  com.yihu.customer.controller.BaseController;
import  com.yihu.customer.entity.PayLog;
import com.yihu.customer.service.httplog.ManagePayLogService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

/**
 * Created by humingfen on 2018/7/16.
 * 支付日志管理
 */
@Controller
@RequestMapping("admin/paylog")
public class PayLogController extends BaseController {
    @Autowired
    private ManagePayLogService managePayLogService;

    @RequestMapping(value = "initial", method = RequestMethod.GET)
    public String initListPage(){
        return "static/pay_log_list";
    }

    @RequestMapping(value = "infoInit", method = RequestMethod.GET)
    public String initInfoPage(@RequestParam(value = "id") Integer id){
        request.setAttribute("id",id);
        return "static/pay_log_modify";
    }

    @RequestMapping(value ="list",method = RequestMethod.POST)
    @ResponseBody
    public String searchList(
            @RequestParam(value = "params",required = false) String params,
            @RequestParam(value = "startDate",required = false) String startDate,
            @RequestParam(value = "endDate",required = false) String endDate,
            @RequestParam(value = "status",required = false) String status,
            @RequestParam(value = "page",required = false) Integer page,
            @RequestParam(value = "rows",required = false) Integer pageSize){
        try{
            Page<PayLog> payLogs = managePayLogService.searchList(params,startDate, endDate, status, page, pageSize);
            return write(200,"操作成功",page,pageSize,payLogs);
        }catch (Exception ex){
            error(ex);
            return error(-1,"操作失败！");
        }
    }

    //根据id获取
    @RequestMapping(value = "findById")
    @ResponseBody
    public String findById(@RequestParam(value = "id") Long id) {
        try {
            PayLog payLog = managePayLogService.findById(id);
            return write(200, "操作成功！", "data", payLog);
        } catch (Exception e) {
            error(e);
            return error(-1, "操作失败！");
        }
    }
}
