package  com.yihu.customer.controller.manager.device;

import com.fasterxml.jackson.databind.ObjectMapper;
import  com.yihu.customer.controller.BaseController;
import  com.yihu.customer.device.entity.DeviceManufacturer;
import com.yihu.customer.service.manager.device.DeviceManufacturerService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import java.util.List;

/**
 * Created by humingfen on 2018/6/6.
 * 设备管理
 */
@Controller
@RequestMapping("admin/manufacturer")
public class DeviceManufacturerController extends BaseController {

    @Autowired
    private DeviceManufacturerService deviceManufacturerService;
    @Autowired
    private ObjectMapper objectMapper;

    @RequestMapping(value = "initial", method = RequestMethod.GET)
    public String initListPage(){
        return "device/deviceManufacturer_list";
    }

    @RequestMapping(value = "infoInit")
    public String initInfoPage(@RequestParam(value = "id") Integer id,String type){
        request.setAttribute("id",id);
        request.setAttribute("type",type);
        return "device/deviceManufacturer_modify";
    }

    @RequestMapping(value ="list",method = RequestMethod.POST)
    @ResponseBody
    public String searchList(
            @RequestParam(value = "manufacturerName",required = false) String manufacturerName,
            @RequestParam(value = "manufacturerCode",required = false) String manufacturerCode,
            @RequestParam(value = "address",required = false) String address,
            @RequestParam(value = "page",required = false) Integer page,
            @RequestParam(value = "rows",required = false) Integer pageSize){
        try{
            Page<DeviceManufacturer> deviceManufacturer = deviceManufacturerService.searchList(manufacturerName,manufacturerCode, address, page, pageSize);
            return write(200,"操作成功",page,pageSize,deviceManufacturer);
        }catch (Exception ex){
            error(ex);
            return error(-1,"操作失败！");
        }
    }

    @RequestMapping(value = "findById", method = RequestMethod.POST)
    @ResponseBody
    public String getManufacturer(@RequestParam(value = "id") Long id){
        try {
            DeviceManufacturer manufacturer = deviceManufacturerService.findById(id);
            return  write(200,"操作成功","data",manufacturer);
        }catch (Exception ex){
            error(ex);
            return error(-1,"操作失败！");
        }
    }

    @RequestMapping(value = "create")
    @ResponseBody
    public String createManufacturer(String jsonData, String code){
        try{
            DeviceManufacturer manufacturer = objectMapper.readValue(jsonData, DeviceManufacturer.class);
            // 判断是否存在code，存在直接
            Boolean b = deviceManufacturerService.existCode(code);
            if(b){
                return error(-1,"厂商标识已存在");
            }
            deviceManufacturerService.createManufacturer(manufacturer);
            return write(200,"操作成功");
        }catch (Exception ex){
            error(ex);
            return error(-1,"操作失败");
        }
    }

    @RequestMapping(value = "update")
    @ResponseBody
    public String updateManufacturer(String jsonData){
        try{
            DeviceManufacturer manufacturer = objectMapper.readValue(jsonData, DeviceManufacturer.class);
            deviceManufacturerService.updateManufacturer(manufacturer);
            return write(200,"操作成功");
        }catch (Exception ex){
            error(ex);
            return error(-1,"操作失败");
        }
    }

    @RequestMapping(value = "delete")
    @ResponseBody
    public String deleteDevice(Long id){
        try{
            deviceManufacturerService.deleteManufacturer(id);
            return write(200,"操作成功");
        }catch (Exception ex){
            error(ex);
            return error(-1,"操作失败");

        }
    }

    @RequestMapping(value = "findAll")
    @ResponseBody
    public String findAll(){
        try{
            List<DeviceManufacturer> manufacturer = deviceManufacturerService.findAll();
            return write(200,"操作成功","data",manufacturer);
        }catch (Exception ex){
            error(ex);
            return error(-1,"操作失败");

        }
    }
}
