package  com.yihu.customer.controller.manager.device;

import com.fasterxml.jackson.databind.ObjectMapper;
import  com.yihu.customer.controller.BaseController;
import  com.yihu.customer.device.entity.WlyyDevice;
import  com.yihu.customer.entity.DmDevice;
import com.yihu.customer.service.manager.device.DmDeviceService;
import com.yihu.customer.service.manager.device.PatientDeviceService;
import com.yihu.customer.service.manager.device.WlyyDeviceService;
import jxl.Workbook;
import jxl.read.biff.BiffException;
import jxl.write.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.List;

/**
 * Created by yww on 2016/12/2.
 * 设备管理
 */
@Controller
@RequestMapping("admin/device")
public class WlyyDeviceController extends BaseController {

    @Autowired
    private WlyyDeviceService deviceService;
    @Autowired
    private DmDeviceService dmDeviceService;
    @Autowired
    private ObjectMapper objectMapper;
    @Autowired
    private PatientDeviceService patientDeviceService;

    @RequestMapping(value = "initial", method = RequestMethod.GET)
    public String initListPage(){
        return "device/device_list";
    }

    @RequestMapping(value = "infoInit")
    public String initInfoPage(@RequestParam(value = "id") Integer id,String type){
        request.setAttribute("id",id);
        request.setAttribute("type",type);
        return "device/device_modify";
    }

    @RequestMapping(value = "createInit")
    public String initCreatePage(){
//        request.setAttribute("id",id);
        return  "device/device_create";
    }

    //列表查询
    @RequestMapping(value="deviceList",method = RequestMethod.POST)
    @ResponseBody
    public String searchList(
            @RequestParam(value = "deviceName",required = false)String deviceName,
            @RequestParam(value = "deviceCode",required = false) String deviceCode,
            @RequestParam(value = "orgName",required = false)String orgName,
            @RequestParam(value = "linkman",required = false) String linkman,
            @RequestParam(value = "page",required = false)Integer page,
            @RequestParam(value = "rows",required = false)Integer pageSize){
        try {
            Page<WlyyDevice> wlyyDevices = deviceService.searchDeviceList(deviceName,deviceCode,orgName,linkman, page, pageSize);
            return write(200,"操作成功",page,pageSize,wlyyDevices);
        }catch (Exception ex){
            error(ex);
            return error(-1, "操作失败！");
        }
    }

    //设备型号列表
    @RequestMapping(value = "modelList",method = RequestMethod.POST)
    @ResponseBody
    public String findAll(){
        try{
            List<DmDevice> list = dmDeviceService.findAll();
            return  write(200,"操作成功","data",list);
        }catch (Exception ex){
            error(ex);
            return error(-1, "操作失败！");
        }
    }


    @RequestMapping(value = "device")
    @ResponseBody
    public String getDevice(@RequestParam(value = "id") Long id){
        try {
            WlyyDevice device = deviceService.findById(id);
            return  write(200,"操作成功","data",device);
        }catch (Exception ex){
            error(ex);
            return error(-1,"操作失败！");
        }
    }

    @RequestMapping(value = "create")
    @ResponseBody
    public String createDevice(String jsonData){
        try{
            WlyyDevice device = objectMapper.readValue(jsonData, WlyyDevice.class);
            WlyyDevice deviceNew = deviceService.createDevice(device);
            return write(200,"操作成功","data",deviceNew);
        }catch (Exception ex){
            error(ex);
            return error(-1,"操作失败");
        }
    }

    @RequestMapping(value = "update")
    @ResponseBody
    public String updateDevice(String jsonData){
        try{
            WlyyDevice device = objectMapper.readValue(jsonData, WlyyDevice.class);
            WlyyDevice deviceNew = deviceService.updateDevice(device);
            return write(200,"操作成功","data",deviceNew);
        }catch (Exception ex){
            error(ex);
            return error(-1,"操作失败");
        }
    }

    @RequestMapping(value = "updateStatus")
    @ResponseBody
    public String updateStatus(String jsonData){
        try{
            WlyyDevice device = objectMapper.readValue(jsonData, WlyyDevice.class);
            WlyyDevice deviceNew = deviceService.updateDevice(device);
            return write(200,"操作成功","data",deviceNew);
        }catch (Exception ex){
            error(ex);
            return error(-1,"操作失败");
        }
    }

    @RequestMapping(value = "delete")
    @ResponseBody
    public String deleteDevice(Long id){
        try{
            deviceService.deleteDevice(id);
            return write(200,"操作成功");
        }catch (Exception ex){
            error(ex);
            return error(-1,"操作失败");

        }
    }

    @RequestMapping(value = "isCodeExist")
    @ResponseBody
    public String isCodeExist(String deviceCode) {
        return deviceService.existDeviceCode(deviceCode);
    }
    
    //导出设备报表
    @RequestMapping(value="toExcel",method = RequestMethod.POST,produces = "application/json;charset=UTF-8" )
    public void exportList(
            @RequestParam(value = "deviceName",required = false)String deviceName,
            @RequestParam(value = "deviceCode",required = false) String deviceCode,
            @RequestParam(value = "orgName",required = false)String orgName,
            @RequestParam(value = "linkman",required = false) String linkman,
            HttpServletResponse response){
        try {
            List<WlyyDevice> wlyyDevices = deviceService.exporthDeviceList(deviceName,deviceCode,orgName,linkman);
            response.setContentType("octets/stream");
            response.setHeader("Content-Disposition", "attachment; filename="+ new String( "deviceDataList.xls"));
            OutputStream os = response.getOutputStream();
            this.write(os,wlyyDevices);
        }catch (Exception ex){
            error(ex);
        }
    }

    //导入设备报表
    @RequestMapping(value = "importData", produces = "application/json;charset=UTF-8")
    @ResponseBody
    public String importData(HttpServletRequest request) {
        try {
            request.setCharacterEncoding("UTF-8");
            InputStream inputStream = request.getInputStream();
            Workbook workbook = Workbook.getWorkbook(inputStream);

            deviceService.importData(workbook);

            return write(200, "操作成功");
        } catch (IOException | BiffException e) {
            e.printStackTrace();
            error(e);
            return error(-1, "操作失败！");
        }
    }

    public void addHeader(WritableSheet ws) throws WriteException {
        
        String[] header = {"ID","设备名称","型号","SN码", "SIM卡号","机构名称", "联系人", "联系电话", "厂家名称"};
        int i = 0;
        for (String h : header) {
            addCell(ws, 0, i, h);//表名，行，列，header
            i++;
        }
    }
    
    public void write(WritableWorkbook wwb, List ls) throws Exception {
        try {
            WritableSheet ws;
            ws = wwb.createSheet("sheet",1);
            addHeader(ws);
            int i = 1;
            for (WlyyDevice m : (List<WlyyDevice>) ls) {
                addCell(ws, i, 0, m.getId()+"","");
                addCell(ws, i, 1, m.getDeviceName(),"");
                addCell(ws, i, 2, m.getDeviceModel(),"");
                addCell(ws, i, 3, m.getDeviceCode(),"");
                addCell(ws, i, 4, m.getSim()+"","");
                addCell(ws, i, 5, m.getOrgName(),"");
                addCell(ws, i, 6, m.getLinkman(),"");
                addCell(ws, i, 7, m.getTel(),"");
                addCell(ws, i, 8, m.getManufacturer(),"");
                i++;
            }
            wwb.write();
            wwb.close();
        } catch (IOException e) {
            e.printStackTrace();
            if (wwb != null) wwb.close();
            throw e;
        }
    }
    public void write(OutputStream os, List ls) throws Exception{
        write(Workbook.createWorkbook(os), ls);
    }
    //添加单元格内容
    public void addCell(WritableSheet ws, int row, int column,  String data) throws WriteException {
        Label label = new Label(column ,row, data);
        ws.addCell(label);
    }
    //添加单元格内容
    public void addCell(WritableSheet ws, int row, int column, String data, String memo) throws WriteException {
        Label label = new Label(column ,row, data);
        if(!org.springframework.util.StringUtils.isEmpty(memo)){
            WritableCellFeatures cellFeatures = new WritableCellFeatures();
            cellFeatures.setComment(memo);
            label.setCellFeatures(cellFeatures);
        }
        ws.addCell(label);
    }


    @RequestMapping(value = "register")
    @ResponseBody
    public String register(@RequestParam(value = "deviceSn") String deviceSn){
        try {
            patientDeviceService.checkDeviceSn(deviceSn);
            return  write(200,"操作成功！");
        }catch (Exception ex){
            error(ex);
            return error(-1,"操作失败！");
        }
    }
}
