package  com.yihu.customer.controller.manager.device;

import  com.yihu.customer.controller.BaseController;
import  com.yihu.customer.device.entity.PatientDeviceExportVO;
import  com.yihu.customer.device.entity.WlyyPatientDeviceVO;
import  com.yihu.customer.entity.Doctor;
import  com.yihu.customer.entity.WlyyPatientDevice;
import com.yihu.customer.service.doctor.DoctorService;
import com.yihu.customer.service.manager.device.WlyyDeviceService;
import com.yihu.customer.service.manager.device.WlyyPatientDeviceLogService;
import com.yihu.customer.service.manager.device.WlyyPatientDeviceService;
import  com.yihu.customer.repository.WlyyPatientDeviceDao;
import jxl.Workbook;
import jxl.write.*;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.OutputStream;
import java.util.List;

/**
 * Created by yww on 2016/12/7.
 */
@Controller
@RequestMapping("admin/patientDevice")
public class WlyyPatientDeviceController extends BaseController {
    @Autowired
    private WlyyPatientDeviceService patientDeviceService;
    @Autowired
    private DoctorService doctorService;
    @Autowired
    private WlyyDeviceService wlyyDeviceService;
    @Autowired
    private JdbcTemplate jdbcTemplate;
    @Autowired
    private WlyyPatientDeviceLogService wlyyPatientDeviceLogService;
    @Autowired
    private WlyyPatientDeviceDao wlyyPatientDeviceDao;

    @RequestMapping(value = "initial", method = RequestMethod.GET)
    public String listPageInit(){
        
        return "device/patientDevice_list";
    }

    @RequestMapping(value = "list",method = RequestMethod.POST)
    @ResponseBody
    public String searchList(
            @RequestParam(value = "deviceName",required = false) String deviceName,
            @RequestParam(value = "categoryCode",required = false) String categoryCode,
            @RequestParam(value = "deviceSn",required = false) String deviceSn,
            @RequestParam(value = "userName",required = false) String userName,
            @RequestParam(value = "doctorName",required = false) String doctorName,
            @RequestParam(value = "hospitalName",required = false) String hospitalName,
            @RequestParam(value = "page") Integer page,
            @RequestParam(value = "rows") Integer pageSize,
            HttpServletRequest req, HttpServletResponse resp){
        try {
    
            String currentid = req.getSession().getAttribute("code").toString();
    
            System.out.println("doctorid:"+currentid);
            
            Doctor doctor = doctorService.findDoctorByCode(currentid);
    
            String hospitalCode = "";
    
            if(doctor != null){
                System.out.println("doctor-hospitalCode:"+doctor.getHospital());
                hospitalCode = doctor.getHospital();
            }
            
            List<WlyyPatientDeviceVO> patientDevices = patientDeviceService.searchListNew(deviceName,categoryCode, deviceSn, userName, doctorName,hospitalName,hospitalCode,page, pageSize);
            Long totalcount = patientDeviceService.getCountSearchListNew(deviceName,categoryCode, deviceSn, userName, doctorName,hospitalName,hospitalCode);
            return write(200,"操作成功",page,pageSize,totalcount,patientDevices);
        }catch (Exception ex){
            error(ex);
            return error(-1,"操作失败！");
        }

    }
    
    @RequestMapping(value = "listbak",method = RequestMethod.POST)
    @ResponseBody
    public String searchListbak(
            @RequestParam(value = "deviceName",required = false) String deviceName,
            @RequestParam(value = "categoryCode",required = false) String categoryCode,
            @RequestParam(value = "deviceSn",required = false) String deviceSn,
            @RequestParam(value = "userName",required = false) String userName,
            @RequestParam(value = "doctorName",required = false) String doctorName,
            @RequestParam(value = "hospital",required = false) String hospital,
            @RequestParam(value = "page") Integer page,
            @RequestParam(value = "rows") Integer pageSize){
        try {
            Page<WlyyPatientDevice> patientDevices = patientDeviceService.searchList(deviceName,categoryCode, deviceSn, userName, page, pageSize);
            return write(200,"操作成功",page,pageSize,patientDevices);
        }catch (Exception ex){
            error(ex);
            return error(-1,"操作失败！");
        }
        
    }

    //设备解绑（记录删除）
    @RequestMapping(value = "delete")
    @ResponseBody
    public String deletePatientDevice(@RequestParam(value = "id") Integer id){
        try {
            if(id == null){
                return write(-1,"id不能为空！");
            }
            WlyyPatientDevice wlyyPatientDevice = wlyyPatientDeviceDao.findById(id).get();
            patientDeviceService.delete(id);
            String deviceSn = "";
            if (wlyyPatientDevice!=null){
                deviceSn = wlyyPatientDevice.getDeviceSn();
            }
            //全部解绑后去判断就更新设备表中是否绑定字段.
            wlyyDeviceService.unBindUpdateIsBinding(deviceSn);
            wlyyPatientDeviceLogService.savePatientDeviceLog(wlyyPatientDevice,deviceSn,3,2);
            return write(200,"操作成功");
        }catch (Exception ex){
            error(ex);
            return error(-1,"操作失败！");
        }

    }
    
    //导出报表
    @RequestMapping(value="toExcel",method = RequestMethod.POST,produces = "application/json;charset=UTF-8" )
    public void exportList(
            @RequestParam(value = "town",required = false)String town,
            @RequestParam(value = "hospital",required = false)String hospital,
            HttpServletResponse response){
        try {
            List<PatientDeviceExportVO> wlyyDevices = patientDeviceService.exportPatientDeviceList(town,hospital);
            response.setContentType("octets/stream");
            response.setHeader("Content-Disposition", "attachment; filename="+ new String( "patientDeviceDataList.xls"));
            OutputStream os = response.getOutputStream();
            this.write(os,wlyyDevices);
        }catch (Exception ex){
            error(ex);
        }
    }
    
    
    public void addHeader(WritableSheet ws) throws WriteException {
        
        String[] header = {"居民姓名","手机号","身份证","设备码", "设备类型","签约医生", "居民住址", "openid", "是否绑定微信号"};
        int i = 0;
        for (String h : header) {
            addCell(ws, 0, i, h);//表名，行，列，header
            i++;
        }
    }
    
    public void write(WritableWorkbook wwb, List ls) throws Exception {
        try {
            WritableSheet ws;
            ws = wwb.createSheet("sheet",1);
            addHeader(ws);
            int i = 1;
            for (PatientDeviceExportVO m : (List<PatientDeviceExportVO>) ls) {
                addCell(ws, i, 0, m.getName(),"");
                addCell(ws, i, 1, m.getMobile(),"");
                addCell(ws, i, 2, m.getIdcard(),"");
                addCell(ws, i, 3, m.getDevice_sn(),"");
                addCell(ws, i, 4, m.getDevice_name(),"");
                addCell(ws, i, 5, m.getDoctor_name(),"");
                addCell(ws, i, 6, m.getAddress(),"");
                addCell(ws, i, 7, m.getOpenid(),"");
                addCell(ws, i, 8, m.getIsopenid(),"");
                i++;
            }
            wwb.write();
            wwb.close();
        } catch (IOException e) {
            e.printStackTrace();
            if (wwb != null) wwb.close();
            throw e;
        }
    }
    public void write(OutputStream os, List ls) throws Exception{
        write(Workbook.createWorkbook(os), ls);
    }
    //添加单元格内容
    public void addCell(WritableSheet ws, int row, int column,  String data) throws WriteException {
        Label label = new Label(column ,row, data);
        ws.addCell(label);
    }
    //添加单元格内容
    public void addCell(WritableSheet ws, int row, int column, String data, String memo) throws WriteException {
        Label label = new Label(column ,row, data);
        if(!org.springframework.util.StringUtils.isEmpty(memo)){
            WritableCellFeatures cellFeatures = new WritableCellFeatures();
            cellFeatures.setComment(memo);
            label.setCellFeatures(cellFeatures);
        }
        ws.addCell(label);
    }
}
