package  com.yihu.customer.controller.manager.dict;

import  com.yihu.customer.controller.BaseController;
import  com.yihu.customer.entity.SpecialDisease;
import  com.yihu.customer.entity.SystemDict;
import com.yihu.customer.service.manager.dict.SystemDictService;
import  com.yihu.customer.repository.SpecialDiseaseDao;
import io.swagger.annotations.ApiOperation;
import org.apache.commons.lang3.StringUtils;
import org.json.JSONArray;
import org.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.multipart.MultipartFile;

import java.io.File;
import java.io.IOException;
import java.util.List;

/**
 * Created by Administrator on 2016/8/13.
 */

@Controller
@RequestMapping(value = "/common")
public class SystemDictController extends BaseController {
	@Autowired
	private SystemDictService systemDictService;
	@Autowired
	private JdbcTemplate jdbcTemplate;
	@Autowired
	private SpecialDiseaseDao specialDiseaseDao;

	@ResponseBody
	@RequestMapping(value = "/getDictByDictName")
	public String getDictByDictName(String name){
		try {
			JSONArray ja=new JSONArray();
			if("ZB_TYPE".equals(name)){
				//十大专病
				List<SpecialDisease> list = specialDiseaseDao.findDisByDel("1");
				for (SpecialDisease specialDisease:list){
					JSONObject jo=new JSONObject();
					jo.put("value",specialDisease.getCode());
					jo.put("text",specialDisease.getName());
					ja.put(jo);
				}
			}else {
				List<SystemDict> list=systemDictService.getByDictName(name);
				for (SystemDict systemDict:list){
					JSONObject jo=new JSONObject();
					jo.put("value",systemDict.getCode());
					jo.put("text",systemDict.getValue());
					ja.put(jo);
				}
			}
			return write(200,"获取成功","list",ja);
		} catch (Exception e) {
			error(e);
			return error(-1, "获取失败");
		}
	}

	@RequestMapping("/fileUpload")
	@ApiOperation("文件上传")
	public String handleFileUpload(@RequestParam("file") MultipartFile file
			,@RequestParam("token") String token) {
		if (file.isEmpty()) {
			return "文件为空";
		}
		if(StringUtils.isBlank(token)){
			return error(-1,"非法请求");
		}
		String sql = " select code from system_dict where dict_name ='fileUpload_token'  ";
		List<String> urls = jdbcTemplate.queryForList(sql,String.class);
		if(urls.size()==0){
			return error(-1,"非法请求");
		}

		if(!token.equals(urls.get(0))){
			return error(-1,"非法请求");
		}

		// 获取文件名
		String fileName = file.getOriginalFilename();
		System.out.println("上传的文件名为：" + fileName);
		// 获取文件的后缀名
		String suffixName = fileName.substring(fileName.lastIndexOf("."));
		System.out.println("上传的后缀名为：" + suffixName);
		// 文件上传后的路径
		String filePath = "/data/";
		File dest = new File(filePath + fileName);
		// 检测是否存在目录
		if (!dest.getParentFile().exists()) {
			dest.getParentFile().mkdirs();
		}
		try {
			file.transferTo(dest);
			return "上传成功";
		} catch (IllegalStateException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return "上传失败";
	}
}
