package  com.yihu.customer.controller.manager.healthbank;

import com.alibaba.fastjson.JSONObject;
import  com.yihu.customer.controller.BaseController;
import  com.yihu.customer.entity.healthbank.TaskDO;
import com.yihu.customer.service.manager.healthbank.TaskService;
import net.sf.json.JSONArray;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import java.util.List;

/**
 * Created by humingfen on 2018/6/21.
 * 健康任务管理
 */
@Controller
@RequestMapping("admin/task")
public class TaskController extends BaseController {
    @Autowired
    private TaskService taskService;

    @RequestMapping(value = "initial", method = RequestMethod.GET)
    public String initListPage(){
        return "healthbank/task_list";
    }

    @RequestMapping(value = "infoInit")
    public String initInfoPage(@RequestParam(value = "id") String id, String type){
        request.setAttribute("id",id);
        request.setAttribute("type",type);
        return "healthbank/task_modify";
    }

    @RequestMapping(value = "init")
    public String init(String type){
        request.setAttribute("type",type);
        return "healthbank/task_modify";
    }

    @RequestMapping(value ="list",method = RequestMethod.POST)
    @ResponseBody
    public String searchList(
            @RequestParam(name = "task") String task,
            @RequestParam(value = "page",required = false) Integer page,
            @RequestParam(value = "rows",required = false) Integer pageSize){
        try{
            JSONObject jsonObject = taskService.searchList(task, page, pageSize);
            String totalCount = String.valueOf(jsonObject.get("totalCount"));
            Long total = Long.parseLong(totalCount);
            return write(200,"操作成功",page,pageSize,total,(List<TaskDO>)jsonObject.get("detailModelList"));
        }catch (Exception ex){
            error(ex);
            return error(-1,"操作失败！");
        }
    }

    @RequestMapping(value = "findById")
    @ResponseBody
    public String findById(@RequestParam(value = "id") String id){
        try {
            String task = "{\"id\":\""+ id + "\"}";
            return  write(200,"操作成功","data",taskService.searchList(task, 1, 1));
        }catch (Exception ex){
            error(ex);
            return error(-1,"操作失败！");
        }
    }

    @RequestMapping(value = "update")
    @ResponseBody
    public String update(String jsonData) {
        try {
            taskService.update(jsonData);
            return write(200, "操作成功" );
        }catch (Exception ex){
            error(ex);
            return error(-1,"操作失败！");
        }
    }

    @RequestMapping(value = "create")
    @ResponseBody
    public String create(String jsonData) {
        try {
            taskService.create(jsonData);
            return write(200, "操作成功" );
        }catch (Exception ex){
            error(ex);
            return error(-1,"操作失败！");
        }
    }

    @RequestMapping(value = "delete")
    @ResponseBody
    public String delete(@RequestParam(value = "id") String id) {
        try {
            String[] ids = {id};
            String s = JSONArray.fromObject(ids).toString();
            taskService.delete(s);
            return write(200, "操作成功" );
        }catch (Exception ex){
            error(ex);
            return error(-1,"操作失败！");
        }
    }
}
