package  com.yihu.customer.controller.manager.healthbank;

import com.alibaba.fastjson.JSONObject;
import  com.yihu.customer.controller.BaseController;
import  com.yihu.customer.entity.healthbank.TaskRuleDO;
import com.yihu.customer.service.manager.healthbank.TaskRuleService;
import net.sf.json.JSONArray;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import java.util.List;

/**
 * Created by humingfen on 2018/6/22.
 * 健康任务规则管理
 */
@Controller
@RequestMapping("admin/taskRule")
public class TaskRuleController extends BaseController {
    @Autowired
    private TaskRuleService taskRuleService;

    @RequestMapping(value = "initial", method = RequestMethod.GET)
    public String initListPage(){
        return "healthbank/taskRule_list";
    }

    @RequestMapping(value = "infoInit")
    public String initInfoPage(@RequestParam(value = "id") String id, String type){
        request.setAttribute("id",id);
        request.setAttribute("type",type);
        return "healthbank/taskRule_modify";
    }

    @RequestMapping(value = "init")
    public String init(String type){
        request.setAttribute("type",type);
        return "healthbank/taskRule_modify";
    }

    @RequestMapping(value ="list",method = RequestMethod.POST)
    @ResponseBody
    public String searchList(
            @RequestParam(value = "q", required = false) String name,
            @RequestParam(name = "taskRule") String taskRule,
            @RequestParam(value = "page",required = false) Integer page,
            @RequestParam(value = "rows",required = false) Integer pageSize){
        try{
            if(StringUtils.isNotBlank(name)){
                taskRule = taskRule.replace("}",",\"name\":"+name+"}");
            }
            JSONObject jsonObject = taskRuleService.searchList(taskRule, page, pageSize);
            String totalCount = String.valueOf(jsonObject.get("totalCount"));
            Long total = Long.parseLong(totalCount);
            return write(200,"操作成功",page,pageSize,total,(List<TaskRuleDO>)jsonObject.get("detailModelList"));
        }catch (Exception ex){
            error(ex);
            return error(-1,"操作失败！");
        }
    }

    @RequestMapping(value ="list",method = RequestMethod.GET)
    @ResponseBody
    public String list(
            @RequestParam(value = "q", required = false) String name,
            @RequestParam(name = "taskRule") String taskRule,
            @RequestParam(value = "page",required = false) Integer page,
            @RequestParam(value = "rows",required = false) Integer pageSize){
        try{
            taskRule = "{" + taskRule + "}";
            if(StringUtils.isNotBlank(name)){
                taskRule = taskRule.replace("}",",\"name\":"+name+"}");
            }
            JSONObject jsonObject = taskRuleService.searchList(taskRule, page, pageSize);
            return write(200,"操作成功","detailModelList",jsonObject.get("detailModelList"));
        }catch (Exception ex){
            error(ex);
            return error(-1,"操作失败！");
        }
    }

    @RequestMapping(value = "findById")
    @ResponseBody
    public String findById(@RequestParam(value = "id") String id){
        try {
            String taskRule = "{\"id\":\""+ id + "\"}";
            return  write(200,"操作成功","data",taskRuleService.searchList(taskRule, 1, 1));
        }catch (Exception ex){
            error(ex);
            return error(-1,"操作失败！");
        }
    }

    @RequestMapping(value = "update")
    @ResponseBody
    public String update(String jsonData) {
        try {
            taskRuleService.update(jsonData);
            return write(200, "操作成功" );
        }catch (Exception ex){
            error(ex);
            return error(-1,"操作失败！");
        }
    }

    @RequestMapping(value = "create")
    @ResponseBody
    public String create(String jsonData) {
        try {
            taskRuleService.create(jsonData);
            return write(200, "操作成功" );
        }catch (Exception ex){
            error(ex);
            return error(-1,"操作失败！");
        }
    }

    @RequestMapping(value = "delete")
    @ResponseBody
    public String delete(@RequestParam(value = "id") String id) {
        try {
            String[] ids = {id};
            String s = JSONArray.fromObject(ids).toString();
            taskRuleService.delete(s);
            return write(200, "操作成功" );
        }catch (Exception ex){
            error(ex);
            return error(-1,"操作失败！");
        }
    }
}
