/*
package com.yihu.jw.controller.manager.healthchannel;

import com.yihu.jw.controller.BaseController;
import com.yihu.jw.entity.Doctor;
import com.yihu.jw.entity.healthchannel.HealthChannelRecommendArticleDo;
import com.yihu.jw.service.doctor.DoctorService;
import com.yihu.jw.service.manager.healthchannel.ChannelRecommendArticleService;
import com.yihu.jw.service.manager.healthcolumn.PeriodicalService;
import com.yihu.jw.service.manager.platformInformation.PlatformInformationService;
import com.yihu.jw.service.refinement.RefinementService;
import com.yihu.jw.util.Constant;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.http.MediaType;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

*/
/**
 * Created by zdm on 2019/2/15.
 *//*

@Controller
@RequestMapping(value = "/admin/channel/channelRecommendArticle",produces = MediaType.APPLICATION_JSON_UTF8_VALUE)
@Api(description = "健康频道-文章推荐/置顶")
public class ChannelRecommendArticleController extends BaseController {
    private static Logger logger = LoggerFactory.getLogger(ChannelRecommendArticleController.class);
    @Autowired
    private ChannelRecommendArticleService channelRecommendArticleService;
    @Autowired
    private PlatformInformationService platformInformationService;
    @Autowired
    private PeriodicalService periodicalService;
    @Autowired
    private RefinementService refinementService;
    @Autowired
    private DoctorService doctorService;


    @RequestMapping(value = "recommend/list", method = RequestMethod.GET)
    @ApiOperation(value = "获取健康频道-推荐文章列表")
    @ResponseBody
    public String list(
            @ApiParam(name = "channelId", value = "频道id", required = true)
            @RequestParam(value = "channelId", required = false) Integer channelId) {
        try {
            String filters="type=1;delFlag=1;channelId="+channelId;
            List<HealthChannelRecommendArticleDo> healthChannelRecommendArticleDos = channelRecommendArticleService.search(null,filters,"+articleType,+sort",1,20);
            Map<String,List<HealthChannelRecommendArticleDo>> map = healthChannelRecommendArticleDos.stream().collect(Collectors.groupingBy(HealthChannelRecommendArticleDo::getArticleType));
            return write(200, "获取成功", "data",map);
        } catch (Exception ex) {
            logger.error(getClass().getName() + ":"+ex.getMessage(), ex.getMessage());
            return error(-1, "获取失败！"+ex.getMessage());
        }
    }

    @RequestMapping(value = "stick/list", method = RequestMethod.GET)
    @ApiOperation(value = "获取健康频道-置顶文章列表")
    @ResponseBody
    public String list(
            @ApiParam(name = "channelId", value = "频道id", required = true)
            @RequestParam(value = "channelId", required = true) Integer channelId,
            @ApiParam(name = "title", value = "标题", required = false)
            @RequestParam(value = "title", required = false) String title,
            @ApiParam(name = "articleAuthor", value = "作者", required = false)
            @RequestParam(value = "articleAuthor", required = false) String articleAuthor,
            @ApiParam(name = "categoryId", value = "内容类型", required = false)
            @RequestParam(value = "categoryId", required = false) String categoryId,
            @ApiParam(name = "classification", value = "分类", required = false)
            @RequestParam(value = "classification", required = false) String classification,
            @ApiParam(name = "startTime", value = "置顶开始时间", required = false)
            @RequestParam(value = "startTime", required = false) String startTime,
            @ApiParam(name = "endTime", value = "置顶结束时间", required = false)
            @RequestParam(value = "endTime", required = false) String endTime,
            @ApiParam(name = "delFlag", value = "状态", required = false)
            @RequestParam(value = "delFlag", required = false) String delFlag,
            @RequestParam(value = "page", required = false, defaultValue = "1") Integer page,
            @RequestParam(value = "pageSize", required = false, defaultValue = "15") Integer pageSize) {
        try {
            Page<HealthChannelRecommendArticleDo> healthChannelDos = channelRecommendArticleService.searchStickList(channelId,title,articleAuthor,categoryId,classification,startTime,endTime,delFlag,page,pageSize);
            return write(200, "获取成功", "data",healthChannelDos);
        } catch (Exception ex) {
            logger.error(getClass().getName() + ":"+ex.getMessage(), ex.getMessage());
            return error(-1, "获取失败！"+ex.getMessage());
        }
    }

    @RequestMapping(value = "recommend/platformInformation/list", method = RequestMethod.GET)
    @ApiOperation(value = "查询-平台资讯")
    @ResponseBody
    public String platformInformationList(
            @ApiParam(name = "title", value = "文章标题", required = false)
            @RequestParam(value = "title", required = false) String title,
            @ApiParam(name = "type", value = "资讯分类", required = false)
            @RequestParam(value = "type", required = false) Integer type,
            @ApiParam(name = "classify", value = "分类", required = false)
            @RequestParam(value = "classify", required = false) String classify,
            @ApiParam(name = "town", value = "行政规划(厦门市+**区)", required = false)
            @RequestParam(value = "town", required = false) String town,
            @ApiParam(name = "hospital", value = "机构编码", required = false)
            @RequestParam(value = "hospital", required = false) String hospital,
            @RequestParam(value = "page", required = false, defaultValue = "1") Integer page,
            @RequestParam(value = "pageSize", required = false, defaultValue = "15") Integer pageSize) {
        try {
            Page<List<Map<String, Object>>>platformInformationDOS= platformInformationService.channelSearchList(title,type,classify,town,hospital,page,pageSize);
            return write(200, "获取成功", "data",platformInformationDOS);
        } catch (Exception ex) {
            logger.error(getClass().getName() + ":"+ex.getMessage(), ex.getMessage());
            return error(-1, "获取失败！"+ex.getMessage());
        }
    }

    @RequestMapping(value = "recommend/healthColumn/list", method = RequestMethod.GET)
    @ApiOperation(value = "查询-健康专栏")
    @ResponseBody
    public String healthColumnList(
            @ApiParam(name = "title", value = "专栏名称", required = false)
            @RequestParam(value = "title", required = false) String title,
            @ApiParam(name = "author", value = "作者", required = false)
            @RequestParam(value = "author", required = false) String author,
            @ApiParam(name = "classify", value = "分类", required = false)
            @RequestParam(value = "classify", required = false) String classify,
            @RequestParam(value = "page", required = false, defaultValue = "1") Integer page,
            @RequestParam(value = "pageSize", required = false, defaultValue = "15") Integer pageSize) {
        try {
            Page<List<Map<String, Object>>> mapPage=  periodicalService.searchList(title,author,classify,page,pageSize);
            return write(200, "获取成功", "data",mapPage);
        } catch (Exception ex) {
            logger.error(getClass().getName() + ":"+ex.getMessage(), ex.getMessage());
            return error(-1, "获取失败！"+ex.getMessage());
        }
    }

    @RequestMapping(value = "recommend/healthArticle/list", method = RequestMethod.GET)
    @ApiOperation(value = "查询-精选问答/健康文章")
    @ResponseBody
    public String healthArticleList(
            @ApiParam(name = "type", value = "内容分类：selected_questions_and_answers精选问答/health_article健康文章", required = true)
            @RequestParam(value = "type", required = true) String type,
            @ApiParam(name = "title", value = "标题", required = false)
            @RequestParam(value = "title", required = false) String title,
            @ApiParam(name = "author", value = "作者", required = false)
            @RequestParam(value = "author", required = false) String author,
            @ApiParam(name = "firstLevelCategoryId", value = "一级分类")
            @RequestParam(value = "firstLevelCategoryId", required = false) String firstLevelCategoryId,
            @ApiParam(name = "secondLevelCategoryId", value = "二级分类")
            @RequestParam(value = "secondLevelCategoryId", required = false) String secondLevelCategoryId,
            @ApiParam(name = "scopeOfApplication", value = "健康文章适用范围（1、全市使用，2、全区使用，3、全社区使用）")
            @RequestParam(value = "scopeOfApplication", required = false) Integer scopeOfApplication,
            @RequestParam(value = "page", required = false, defaultValue = "1") Integer page,
            @RequestParam(value = "pageSize", required = false, defaultValue = "15") Integer pageSize) {
        try {
            JSONObject jsonObject = null;
            if(page == null){
                page = 1;
            }
            if(pageSize == null){
                pageSize = 15;
            }
            //健康文章查询
            if (Constant.health_article.equals(type)) {
                jsonObject = channelRecommendArticleService.queryArticleList(title, author, firstLevelCategoryId, secondLevelCategoryId, scopeOfApplication, page, pageSize);
            } else if (Constant.selected_questions_and_answers.equals(type)) {
                //精选问答
                jsonObject = refinementService.getRefinnementList(title,author,firstLevelCategoryId,secondLevelCategoryId,scopeOfApplication,page,pageSize);
            }
            return write(200, "获取成功", "data", jsonObject);
        } catch (Exception ex) {
            logger.error(getClass().getName() + ":"+ex.getMessage(), ex.getMessage());
            return error(-1, "获取失败！"+ex.getMessage());
        }
    }

    @RequestMapping(value = "create", method = RequestMethod.POST)
    @ApiOperation(value = "创建推荐/置顶文章")
    @ResponseBody
    public String create(
            @ApiParam(name = "operationType", value = "操作类型:1推荐、2置顶", required = true)
            @RequestParam(value = "operationType", required = true) Integer operationType,
            @ApiParam(name = "jsonData", value = "推荐/置顶文章Json", required = true)
            @RequestParam(value = "jsonData", required = true) String jsonData, HttpServletRequest req) {
        try {
            System.out.println("code---"+String.valueOf(req.getSession().getAttribute("code")));
            System.out.println("getUid----"+getUID());
            Doctor d= doctorService.findDoctorByCode(String.valueOf(req.getSession().getAttribute("code")));
            List<HealthChannelRecommendArticleDo> healthChannelRecommendArticleDos=channelRecommendArticleService.create(operationType,jsonData,d);
            return write(200, "创建成功","data",healthChannelRecommendArticleDos);
        } catch (Exception ex) {
            logger.error(getClass().getName() + ":"+ex.getMessage(), ex.getMessage());
            return error(-1, "创建失败!"+ex.getMessage());
        }
    }

    @RequestMapping(value = "update", method = RequestMethod.POST)
    @ApiOperation(value = "编辑推荐/置顶文章")
    @ResponseBody
    public String update(
            @ApiParam(name = "operationType", value = "操作类型:1推荐、2置顶", required = true)
            @RequestParam(value = "operationType", required = true) Integer operationType,
            @ApiParam(name = "healthChannelRecommendArticleId", value = "推荐/置顶记录id", required = true)
            @RequestParam(value = "healthChannelRecommendArticleId", required = true) Long healthChannelRecommendArticleId,
            @ApiParam(name = "startTime", value = "置顶开始时间", required = false)
            @RequestParam(value = "startTime", required = false) String startTime,
            @ApiParam(name = "endTime", value = "置顶结束时间", required = false)
            @RequestParam(value = "endTime", required = false) String endTime,
            @ApiParam(name = "sort", value = "推荐排序位置", required = false)
            @RequestParam(value = "sort", required = false) Integer sort,HttpServletRequest req) {
        try {
            HealthChannelRecommendArticleDo healthChannelRecommendArticleDo=channelRecommendArticleService.update( operationType, healthChannelRecommendArticleId, startTime, endTime, sort);
            return write(200, "编辑成功!","data",healthChannelRecommendArticleDo);
        } catch (Exception ex) {
            logger.error(getClass().getName() + ":"+ex.getMessage(), ex.getMessage());
            return error(-1, "编辑失败!"+ex.getMessage());
        }
    }

    @RequestMapping(value = "delete", method = RequestMethod.POST)
    @ApiOperation(value = "删除推荐/置顶文章")
    @ResponseBody
    public String delete(
            @ApiParam(name = "healthChannelRecommendArticleId", value = "推荐/置顶记录id,多个适用逗号隔开", required = true)
            @RequestParam(value = "healthChannelRecommendArticleId", required = true) String healthChannelRecommendArticleId) {
        try {
            channelRecommendArticleService.deleteById(healthChannelRecommendArticleId);
            return write(200, "删除成功!");
        } catch (Exception ex) {
            logger.error(getClass().getName() + ":"+ex.getMessage(), ex.getMessage());
            return error(-1, "删除失败!"+ex.getMessage());
        }
    }

    @RequestMapping(value = "getCategoryList",method = RequestMethod.GET)
    @ApiOperation("获取健康文章分类")
    @ResponseBody
    public String getCategoryList(@ApiParam(name = "categoryLevel", value = "获取类别：1、一级类别 2、二级类别")
                                      @RequestParam(value = "categoryLevel") Integer categoryLevel,
                                  @ApiParam(name = "firstlevelId", value = "一级类别Id")
                                  @RequestParam(value = "firstlevelId", required = false) String firstlevelId,
                                  @ApiParam(name = "secondLevelId", value = "二级类别Id")
                                  @RequestParam(value = "secondLevelId", required = false) String secondLevelId){
        try {
            com.alibaba.fastjson.JSONArray response = channelRecommendArticleService.getCategoryList(categoryLevel, firstlevelId, secondLevelId);
            return write(200,"查询成功！","data",response);
        }catch (Exception e){
            e.printStackTrace();
            return error(-1,"查询失败！");
        }
    }

    @RequestMapping(value = "getJkeduCategoryList",method = RequestMethod.GET)
    @ApiOperation("获取健康文章全部分类")
    @ResponseBody
    public String getCategoryList(){
        try {
            com.alibaba.fastjson.JSONArray response = channelRecommendArticleService.getJkeduCategoryList();
            return write(200,"查询成功！","data",response);
        }catch (Exception e){
            e.printStackTrace();
            return error(-1,"查询失败！");
        }
    }

}
*/
