/*
package com.yihu.jw.controller.manager.integratedquery;

import com.yihu.jw.controller.BaseController;
import com.yihu.jw.service.integratedquery.IntegratedqueryService;
import com.yihu.jw.service.manager.special.SpecialDiseaseService;
import com.yihu.jw.util.ElasticsearchUtil;
import com.yihu.jw.util.WorkbookUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import jxl.Workbook;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.http.MediaType;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletResponse;
import java.io.OutputStream;
import java.net.URLEncoder;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

*/
/**
 * Created by janseny on 2019/2/15.
 *
 * 综合查询
 *
 *//*

@Controller
@RequestMapping(value="admin/integratedQuery/",produces = MediaType.APPLICATION_JSON_UTF8_VALUE)
@Api(value = "integratedQuery", description = "指标综合查询", tags = {"指标综合查询"})
public class IntegratedQueryController extends BaseController {
    @Autowired
    SpecialDiseaseService specialDiseaseService;
    @Value("${es.index.HealthEduArticlePatient}")
    private String esIndex_HealthEduArticlePatient;
    @Value("${es.type.HealthEduArticlePatient}")
    private String esType_HealthEduArticlePatient;
    @Value("${es.index.Statistics}")
    private String esIndex;
    @Value("${es.type.Statistics}")
    private String esType;
    @Autowired
    private ElasticsearchUtil elasticsearchUtil;
    @Autowired
    private JdbcTemplate jdbcTemplate;
    @Autowired
    private IntegratedqueryService integratedqueryService;

    @RequestMapping(value = "treeList", method = RequestMethod.GET)
    @ResponseBody
    public String treeList(){
        try {
            Map<String,Map<String,String>> treeMap = new HashMap<>();
            Map<String,String> map = new HashMap<>();
            map.put("1","签约全人群");
            map.put("2","签约高血压");
            map.put("3","签约糖尿病");
            map.put("4","签约孕产妇");
            map.put("5","签约0-6岁儿童");
            map.put("6","签约65岁以上老人");
            treeMap.put("签约人数",map);

            Map<String,String> map1 = new HashMap<>();
            map1.put("7","续约全人群");
            map1.put("8","续约高血压");
            map1.put("9","续约糖尿病");
            map1.put("10","续约65岁以上老人");
            treeMap.put("续签",map1);

            Map<String,String> map2 = new HashMap<>();
            map2.put("11","推送数量");
            map2.put("12","生日居民未推送数");
            treeMap.put("家签居民生日祝福推送统计",map2);

            Map<String,String> map3 = new HashMap<>();
            map3.put("13","厦门I健康公众号绑定人数");
            map3.put("14","咨询量");
            map3.put("15","及时回复");
            map3.put("16","未回复");
            map3.put("17","线上长处方（完成数）");
            map3.put("28","计免绑定量");
            treeMap.put("厦门I健康",map3);

            Map<String,String> map4 = new HashMap<>();
            map4.put("18","发放新设备");
            map4.put("19","使用设备");
            map4.put("20","设备绑定数");
            map4.put("21","24小时干预（人数）");
            map4.put("22","24小时异常总数");
            treeMap.put("可穿戴设备",map4);

            Map<String,String> map5 = new HashMap<>();
            map5.put("24","健康文章推送人数");
            map5.put("25","健康文章触达人数");
            map5.put("26","阅读量");
            treeMap.put("健康教育",map5);

            Map<String,String> map6 = new HashMap<>();
            map6.put("27","健康指导次数");
            treeMap.put("健康管理",map6);
            return write(200, "操作成功", "data",treeMap);
        } catch (Exception ex) {
            error(ex);
            return error(-1, "操作失败");
        }
    }

    public Map<String,String> getTitleMap(){
        Map<String, String> map = new HashMap<>();
        map.put("1","quotaCode=36&签约全人群");
        map.put("2","quotaCode=36-slaveKey1=4&签约高血压");
        map.put("3","quotaCode=36-slaveKey1=5&签约糖尿病");
        map.put("4","quotaCode=36-slaveKey1=6&签约孕产妇");
        map.put("5","quotaCode=36-slaveKey1=7&签约0-6岁儿童");
        map.put("6","quotaCode=36-slaveKey1=3&签约65岁以上老人");
        map.put("7","quotaCode=51&续约全人群");
        map.put("8","quotaCode=51-slaveKey1=1&续约高血压");
        map.put("9","quotaCode=51-slaveKey1=2&续约糖尿病");
        map.put("10","quotaCode=51-slaveKey1=3&续约65岁以上老人");
        map.put("11","quotaCode=98&推送数量");
        map.put("12","quotaCode=99&生日居民未推送数");
//        map.put("12","mysql=patientBirthday&生日居民数");
        map.put("13","quotaCode=21&厦门I健康公众号绑定人数");
        map.put("14","quotaCode=25&咨询量");
        map.put("15","quotaCode=23&及时回复");
        map.put("16","quotaCode=22&未回复");
        map.put("17","mysql=xiamenIjiankang2&线上长处方（完成数）");

        map.put("18","quotaCode=85&发放新设备");
        map.put("19","quotaCode=87&使用设备");
        map.put("20","quotaCode=86&设备绑定数");
        map.put("21","quotaCode=88&24小时干预（人数）");
        map.put("22","quotaCode=97&24小时异常总数");

        map.put("24","quotaCode=103&健康文章推送人数");
        map.put("25","quotaCode=83&健康文章触达人数");
        map.put("26","elasticSearch=health_edu_article_patient-isRead=1&阅读量");

        map.put("27","quotaCode=5&健康指导次数");
        map.put("28","mysql=childFamilyImmune&计免绑定量");
        return map;
    }

    @RequestMapping(value = "teamList", method = RequestMethod.GET)
    @ResponseBody
    public String teamList(){
        try {
            String teamSql = "SELECT id ,name from wlyy_admin_team ";
            List<Map<String, Object>>  teamList = jdbcTemplate.queryForList(teamSql);
            return write(200, "操作成功", "data",teamList);
        } catch (Exception ex) {
            error(ex);
            return error(-1, "操作失败");
        }
    }

    @RequestMapping(value = "teamListByArea", method = RequestMethod.GET)
    @ResponseBody
    public String teamListByArea(
            @ApiParam(name = "area", value = "地区")
            @RequestParam(required = false) String area) {
        try {
            String teamSql = "SELECT t.id ,t.name from wlyy_admin_team t,dm_hospital h where t.org_code=h.`code` and t.available=1 ";
            if (StringUtils.isNotBlank(area)) {
                teamSql = teamSql + " and h.town='" + area + "'";
            }
            List<Map<String, Object>> teamList = jdbcTemplate.queryForList(teamSql);
            return write(200, "操作成功", "data", teamList);
        } catch (Exception ex) {
            error(ex);
            return error(-1, "操作失败");
        }
    }

    @ApiOperation(value = "获取综合统计数据")
    @ResponseBody
    @RequestMapping(value = "getStatisticDataList", method = RequestMethod.GET)
    public String getStatisticDataList(
            @ApiParam(name = "startDate", value = "开始时间", required = true)
            @RequestParam(value = "startDate",required = true)String startDate,
            @ApiParam(name = "endDate", value = "结束时间", required = true)
            @RequestParam(value = "endDate",required = true)String endDate,
            @ApiParam(name = "team", value = "团队", required = false)
            @RequestParam(required = false) String team,
            @ApiParam(name = "area", value = "地区", required = false)
            @RequestParam(required = false) String area,
            @ApiParam(name = "quotaStr", value = "指标字符串，多个用逗号隔开", required = true)
            @RequestParam(required = true) String quotaStr,
            @ApiParam(name="page",value="第几页，从1开始", defaultValue = "1")
            @RequestParam(required = false, defaultValue = "1")Integer page,
            @ApiParam(name="size",value="页码大小", defaultValue = "5")
            @RequestParam(required = false, defaultValue = "5")Integer size
    ){
        try {
            Map<String, Object> resultMap = new HashMap<>();
            List<Map<String, Object>>  teamList = new ArrayList<>();
            teamList = statisticDataList(startDate,  endDate, team,area, quotaStr);
            int count = size;//相当于pageSize
            int total = teamList.size();
            int pageCount=total/size;
            int fromIndex = count * (page - 1);
            int toIndex = fromIndex + count;
            if (toIndex >= total) {
                toIndex = total;
            }
            if(page>pageCount+1){
                fromIndex=0;
                toIndex=0;
            }
            teamList =teamList.subList(fromIndex, toIndex);
            for(Map<String, Object> teamMap : teamList){
                teamMap.remove("id");
            }
            resultMap.put("data",teamList);
            resultMap.put("total",total);
            return write(200, "操作成功", "data",resultMap);
        } catch (Exception ex) {
            error(ex);
            return error(-1, "操作失败");
        }
    }

    public List<Map<String, Object>> statisticDataList(String startDate, String endDate,String team,String area,String quotaStr){
        Map<String,String> titleMap = getTitleMap();
        String teamSql = "SELECT t.id ,t.name ,h.town,h.town_name from wlyy_admin_team t,dm_hospital h where t.org_code=h.`code` and t.available=1 ";
        if(StringUtils.isNotEmpty(team)){
            teamSql += " and t.id = " + team;
        }
        if(StringUtils.isNotEmpty(area)){
            teamSql += " and (h.city='"+area+"' or h.town='" + area+"')";
        }
        //1.5.7追加所有团队的指标统计
        Map<String, Object> totalMap=new HashMap<>();
        totalMap.put("name","所有团队");
        totalMap.put("town_name","合计");
        totalMap.put("town","");
        totalMap.put("id","totalTeam");

        List<Map<String, Object>>  teamList = jdbcTemplate.queryForList(teamSql);
        teamList.add(0,totalMap);
        String [] quotas = quotaStr.split(",");
        if(quotas.length > 0){
            for(int i=0 ;i < quotas.length; i++ ){
                String quotaId = quotas[i];
                String quota = titleMap.get(quotaId).split("&")[0];
                String quotaName = titleMap.get(quotaId).split("&")[1];
                if(quota.contains("quotaCode")){
                    String initalStr = "";
                    if(StringUtils.isNotEmpty(startDate) && StringUtils.isNotEmpty(endDate)){
                        initalStr += " where quotaDate >= '" + startDate + "T00:00:00+0800'" + " and quotaDate <= '" + endDate + "T23:59:59+0800'";
                    }
                    if(StringUtils.isNotEmpty(team)){
                        initalStr += " and team = '" + team + "'";
                    }
                    if(StringUtils.isNotEmpty(area)){
                        initalStr += " and town = '" + area + "'";
                    }
                    String quotaCodeAndWhere = quota.substring(quota.indexOf("quotaCode="));
                    String filter = "";
                    String quotaCode = "";
                    if(quotaCodeAndWhere.contains("-")){
                        quotaCode = quotaCodeAndWhere.split("-")[0];
                        filter = " and " + quotaCodeAndWhere.split("-")[1];
                    }else {
                        quotaCode = quotaCodeAndWhere;
                    }
                    filter += " and " + quotaCode;
                    String sql = "select sum(result1) result from  " + esIndex + initalStr + filter + " and timeLevel = '1'  and areaLevel='5'  group by team,teamName";
                    List<Map<String, Object>> dataList = elasticsearchUtil.excuteDataModel(sql);
                    teamList = dataListIntegration(totalMap,teamList,dataList,quotaName,"team");
                }else  if(quota.contains("elasticSearch")){
                    String initalStr = "";
                    if(StringUtils.isNotEmpty(startDate) && StringUtils.isNotEmpty(endDate)){
                        initalStr += " where userType =1 and createTime >= '" + startDate + "T00:00:00+0800'" + " and createTime <= '" + endDate + "T23:59:59+0800'";
                    }
                    if(StringUtils.isNotEmpty(team)){
                        initalStr += " and adminTeamCode = '" + team + "'";
                    }
                    if(StringUtils.isNotEmpty(area)){
                        initalStr += " and town = '" + area + "'";
                    }
                    String esIndexAndWhere = quota.substring(quota.indexOf("elasticSearch="));
                    String filter = "";
                    String indexStr = "";
                    if(esIndexAndWhere.contains("-")){
                        indexStr = esIndexAndWhere.split("-")[0];
                        String index =indexStr.split("=")[1].trim();
                        List<Map<String, Object>> esDataList = new ArrayList<>();
                        if(esIndexAndWhere.split("-")[1].contains("=")){
                            filter = esIndexAndWhere.split("-")[1];
                            String sql = "select count(*) result from  " + index + initalStr + " and " + filter + " group by adminTeamCode,adminTeamName";
                            esDataList = elasticsearchUtil.excuteDataModel(sql);

                        }else if(esIndexAndWhere.split("-")[1].contains("count")){
                            String sql = "select count(*) result from  " + index + initalStr + " and " + " group by adminTeamCode,adminTeamName";
                            esDataList = elasticsearchUtil.excuteDataModel(sql);

                        }else if(esIndexAndWhere.split("-")[1].contains("personCount")){
                            // 团队循环

                        }
                        teamList = dataListIntegration(totalMap,teamList,esDataList,quotaName,"adminTeamCode");
                    }
                }else  if(quota.contains("mysql")){
                    String mysqlAndWhere = quota.substring(quota.indexOf("mysql="));
                    String code = mysqlAndWhere.split("=")[1];
                    if(code.equals("xiamenIjiankang2")){
                        //线上长处方（完成数）
                        List<Map<String, Object>> prescriptionList = integratedqueryService.getTeamPrescriptionCount(startDate, endDate,team,area);
                        teamList = dataListIntegration(totalMap,teamList,prescriptionList,quotaName,"team");
                    }else if(code.equals("24Exception")){
                        //24 小时设备异常数
                        List<Map<String, Object>> exceptionList = integratedqueryService.getDevice24ExceptionCount(startDate, endDate, team,area);
                        teamList = dataListIntegration(totalMap,teamList,exceptionList,quotaName,"team");
                    }else if(code.equals("patientBirthday")) {
                        //生日人数
                        List<Map<String, Object>> birthdayList = integratedqueryService.getPatientBirthdayCount(startDate, endDate, team,area);
                        teamList = dataListIntegration(totalMap,teamList,birthdayList,quotaName,"team");
                    }else if(code.equals("childFamilyImmune")) {
                        //计免绑定量
                        List<Map<String, Object>> childFamilyImmuneList = integratedqueryService.getChildFamilyImmuneCount(startDate, endDate, team,area);
                        teamList = dataListIntegration(totalMap,teamList,childFamilyImmuneList,quotaName,"team");
                    }
                }
            }
        }
        return teamList;
    }

    public  List<Map<String, Object>> dataListIntegration( Map<String, Object> totalMap,List<Map<String, Object>>  teamList,List<Map<String, Object>>  dataList,String quotaName,String teamCloumn){
        DecimalFormat df = new DecimalFormat("###");
        Double total=0.00;
        List<Map<String, Object>>  resultList=new ArrayList<>();
        for(Map<String, Object> teamMap : teamList){
            String teamId = teamMap.get("id").toString();
            boolean exit = false;
            if(dataList != null && dataList.size() > 0){
                for(Map<String, Object> dataMap : dataList){
                    if(dataMap.get(teamCloumn)!= null && dataMap.get(teamCloumn).toString().equals(teamId)){
                        if(dataMap.get("result") != null){
                            String result = df.format(Double.valueOf(dataMap.get("result").toString()));
                            total=total+Double.valueOf(dataMap.get("result").toString());
                            teamMap.put(quotaName,result);
                            exit = true;
                            break;
                        }else if(dataMap.get("count") != null){
                            String result = df.format(Double.valueOf(dataMap.get("count").toString()));
                            total=total+Double.valueOf(dataMap.get("count").toString());
                            teamMap.put(quotaName,result);
                            exit = true;
                            break;
                        }
                    }
                }
            }
            if( !exit){
                teamMap.put(quotaName,0);
            }
            resultList.add(teamMap);
        }
        //1.5.7追加合计
        totalMap.put(quotaName,df.format(total));
        return resultList;
    }


    //报表导出
    @ApiOperation("数据文件导出")
    @RequestMapping(value="export",method = RequestMethod.GET,produces = "application/json;charset=UTF-8" )
    public void export(
            @ApiParam(name = "startDate", value = "开始时间", required = false)
            @RequestParam(value = "startDate",required = false)String startDate,
            @ApiParam(name = "endDate", value = "结束时间", required = false)
            @RequestParam(value = "endDate",required = false)String endDate,
            @ApiParam(name = "team", value = "团队", required = false)
            @RequestParam(required = false) String team,
            @ApiParam(name = "area", value = "地区", required = false)
            @RequestParam(required = false) String area,
            @ApiParam(name = "quotaStr", value = "指标字符串，多个用逗号隔开", required = true)
            @RequestParam(required = true) String quotaStr,
            HttpServletResponse response){
        try {
            String fileName = "综合指标查询";
            response.setContentType("octets/stream");
            response.setCharacterEncoding("utf-8");
            fileName = URLEncoder.encode(fileName, "utf-8");
            response.setHeader("Content-Disposition", "attachment; filename="+ fileName + new String(".xls"));
            OutputStream os = response.getOutputStream();
            Map<Integer,String> columnMap = new HashMap<>();
            WorkbookUtil workbookUtil = new WorkbookUtil();
            List<Map<String,Object>> listMap = new ArrayList<>();
            listMap = statisticDataList(startDate,  endDate, team,area, quotaStr);

            Map<String,String> titleMap = getTitleMap();
            String [] quotas = quotaStr.split(",");
            String[] header = new  String[quotas.length+1];
            header[0] = "团队";
            columnMap.put(0,"name");
            if(quotas.length > 0) {
                for (int i = 0; i < quotas.length; i++) {
                    String quotaId = quotas[i];
//                    String quota = titleMap.get(quotaId).split("&")[0];
                    String quotaName = titleMap.get(quotaId).split("&")[1];;
                    header[i+1] = quotaName;
                    columnMap.put(i+1,quotaName);
                }
            }
            workbookUtil.write(Workbook.createWorkbook(os), listMap, columnMap, header);
        }catch (Exception ex){
            error(ex);
        }
    }



}
*/
