package  com.yihu.customer.controller.manager.messager;


import  com.yihu.customer.controller.BaseController;
import  com.yihu.customer.entity.consult.WlyyConsultTeamExportVO;
import com.yihu.customer.service.messager.MessagerServer;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

@RestController
@RequestMapping(value = "/message/doctor", produces = MediaType.APPLICATION_JSON_UTF8_VALUE)
@Api(description = "消息回复")
public class MessagerController extends BaseController {

    @Autowired
    MessagerServer messagerServer;


    @RequestMapping(value = "getMessageNoReply", method = RequestMethod.GET)
    @ApiOperation("咨询未及时回复  明细列表")
    public String getMessageNoReply(
            @ApiParam(name = "startDate", value = "开始时间", required = true)
            @RequestParam(value = "startDate", required = true) String startDate,
            @ApiParam(name = "endDate", value = "结束时间", required = true)
            @RequestParam(value = "endDate", required = true) String endDate,
            @ApiParam(name = "team", value = "团队", required = false)
            @RequestParam(required = false) String team,
            @ApiParam(name = "area", value = "地区", required = false)
            @RequestParam(required = false) String area,
            @ApiParam(name = "hospital", value = "医院", required = false)
            @RequestParam(required = false) String hospital,
            @ApiParam(name = "page", value = "第几页，从1开始", defaultValue = "1")
            @RequestParam(required = false, defaultValue = "1") Integer page,
            @ApiParam(name = "size", value = "页码大小", defaultValue = "10")
            @RequestParam(required = false, defaultValue = "10") Integer size,
            @ApiParam(name = "range", value = "数据范围(town区,hospital医院,team团队)", required = true)
            @RequestParam(required = true) String range) {
        try {
            List<WlyyConsultTeamExportVO> consultTeams = messagerServer.exportReplyDelayList(startDate, endDate, team, area, hospital, range, page, size);
            List<WlyyConsultTeamExportVO> consultTeamsSize = messagerServer.exportReplyDelayList(startDate, endDate, team, area, hospital, range, page, 0);
            JSONObject object = new JSONObject();
            object.put("consultTeams", consultTeams);
            object.put("consultTeamsSize", consultTeamsSize.size());
            return write(200, "查询成功", "data", object);
        } catch (Exception ex) {
            error(ex);
            return write(-1, "查询失败");
        }
    }
}
