/*
package com.yihu.jw.controller.manager.notification;

import com.fasterxml.jackson.databind.ObjectMapper;
import com.yihu.jw.controller.WeixinBaseController;
import com.yihu.jw.entity.platformInformation.PlatformInformationDO;
import com.yihu.jw.service.manager.platformInformation.PlatformInformationService;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.data.domain.Page;
import org.springframework.http.MediaType;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.util.Map;

@Controller
@RequestMapping(value = "/admin/platformInfomation", produces = MediaType.APPLICATION_JSON_UTF8_VALUE)
public class PlatformInformationController extends WeixinBaseController {

    @Autowired
    private PlatformInformationService platformInformationService;
    @Autowired
    private ObjectMapper objectMapper;
    //图片服务地址
    @Value("${fastDFS.fastdfs_file_url}")
    private String imgUrlDomain;

    */
/**
     * 列表页面初始化数据
     *//*

    @RequestMapping(value = "initial", method = RequestMethod.GET)
    public String listInitial() {
        return "platformInformation/platform_information_list";
    }

    @RequestMapping(value = "initial/{id}", method = RequestMethod.GET)
    public String listInitial2(@PathVariable(value = "id") String id) {
        return "platformInformation/platform_information_list";
    }

    @RequestMapping(value = "denizenArticle", method = RequestMethod.GET)
    public String denizenArticle() {
        request.setAttribute("imgUrlDomain", imgUrlDomain);
        return "platformInformation/denizenArticle";
    }

    @RequestMapping(value = "doctorArticle", method = RequestMethod.GET)
    public String doctorArticle() {
        request.setAttribute("imgUrlDomain", imgUrlDomain);
        return "platformInformation/doctorArticle";
    }

    @RequestMapping(value = "denizenArticle/{id}", method = RequestMethod.GET)
    public String denizenArticle2(@PathVariable(value = "id") String id) {
        request.setAttribute("imgUrlDomain", imgUrlDomain);
        return "platformInformation/denizenArticle";
    }

    @RequestMapping(value = "doctorArticle/{id}", method = RequestMethod.GET)
    public String doctorArticle2(@PathVariable(value = "id") String id) {
        request.setAttribute("imgUrlDomain", imgUrlDomain);
        return "platformInformation/doctorArticle";
    }

    @RequestMapping(value = "list", method = RequestMethod.POST)
    @ApiOperation(value = "获取平台咨讯列表")
    @ResponseBody
    public String list(
            @RequestParam(value = "sendingObjects", required = false) Integer sendingObjects,
            @RequestParam(value = "title", required = false) String title,
            @RequestParam(value = "type", required = false) Integer type,
            @RequestParam(value = "isNotice", required = false) Integer isNotice,
            @RequestParam(value = "sendType", required = false) Integer sendType,
            @RequestParam(value = "startDate", required = false) String startDate,
            @RequestParam(value = "endDate", required = false) String endDate,
            @RequestParam(value = "page") Integer page,
            @RequestParam(value = "pagesize") Integer pageSize) {
        try {
            Page<PlatformInformationDO> platformInformationDOS = platformInformationService.searchList(sendingObjects, title, type, isNotice, sendType, startDate, endDate, page, pageSize);
            return write(200, "获取成功", page, pageSize, platformInformationDOS);
        } catch (Exception ex) {
            error(ex);
            return error(-1, "获取失败！");
        }
    }

    @RequestMapping(value = "uploadImg", method = RequestMethod.POST)
    @ApiOperation(value = "上传图片")
    @ResponseBody
    public String uploadImg(HttpServletRequest request) {
        try {
            Map<String, Object> map = platformInformationService.uploadImg(request);
            return write(200, "上传成功！", "data", map);
        } catch (Exception e) {
            e.printStackTrace();
            return write(-1, "上传失败！");
        }
    }

    @RequestMapping(value = "create",method = RequestMethod.POST)
    @ApiOperation(value = "创建平台咨讯")
    @ResponseBody
    public String create(String jsonData, HttpServletRequest req) {
        try {
            String token = getAccessToken();
            System.out.println("token : " + token);
            platformInformationService.create(jsonData, token, String.valueOf(req.getSession().getAttribute("code")));
            return write(200, "创建成功");
        } catch (Exception ex) {
            error(ex);
            return error(-1, "创建失败");
        }
    }

    @RequestMapping(value = "update",method = RequestMethod.POST)
    @ApiOperation("更新平台咨讯")
    @ResponseBody
    public String update(String jsonData, HttpServletRequest req) {
        try {
            platformInformationService.update(jsonData, String.valueOf(req.getSession().getAttribute("code")));
            return write(200, "更新成功");
        } catch (Exception ex) {
            error(ex);
            return error(-1, "更新失败");
        }
    }

    @RequestMapping(value = "preview",method = RequestMethod.GET)
    @ApiOperation("预览详情")
    @ResponseBody
    public String preview(Long id) {
        try {
            Map<String, Object> map = platformInformationService.preview(id);
            return write(200, "获取成功", "data", map);
        } catch (Exception ex) {
            error(ex);
            return error(-1, "获取失败");
        }
    }

    @RequestMapping(value = "send",method = RequestMethod.POST)
    @ApiOperation("更新平台咨讯")
    @ResponseBody
    public String send(Long id,Integer sendStatus, HttpServletRequest req) {
        try {
            platformInformationService.send(id,sendStatus, String.valueOf(req.getSession().getAttribute("code")));
            return write(200, "发送成功");
        } catch (Exception ex) {
            error(ex);
            return error(-1, "发送失败");
        }
    }

    @RequestMapping(value = "findPatientLabel",method = RequestMethod.GET)
    @ApiOperation("查找居民标签")
    @ResponseBody
    public String findPatientLabel() {
        try {
            return write(200, "查找成功", "data", platformInformationService.findPatientLabel());
        } catch (Exception ex) {
            error(ex);
            return error(-1, "查找失败");
        }
    }

    @RequestMapping(value = "findInformationLabel",method = RequestMethod.GET)
    @ApiOperation("查找咨讯标签")
    @ResponseBody
    public String findInformationLabel() {
        try {
            return write(200, "查找成功", "data", platformInformationService.findInformationLabel());
        } catch (Exception ex) {
            error(ex);
            return error(-1, "查找失败");
        }
    }

    @RequestMapping(value = "findById",method = RequestMethod.GET)
    @ApiOperation("查看详情")
    @ResponseBody
    public String findById(Long id) {
        try {
            return write(200, "获取成功", "data", platformInformationService.findById(id));
        } catch (Exception ex) {
            error(ex);
            return error(-1, "获取失败");
        }
    }

    @RequestMapping(value = "findInformationVideoClassify",method = RequestMethod.GET)
    @ApiOperation("查找咨讯视频标签")
    @ResponseBody
    public String findInformationVideoClassify(Integer type) {
        try {
            return write(200, "查找成功", "data", platformInformationService.findInformationVideoClassify(type));
        } catch (Exception ex) {
            error(ex);
            return error(-1, "查找失败");
        }
    }


    @RequestMapping(value = "/undoArticle",method = RequestMethod.GET, produces = "application/json;charset=UTF-8")
    @ApiOperation("平台咨讯--撤销")
    @ResponseBody
    public String undoArticle(Long id, String reason, HttpServletRequest req) {
        try {
            PlatformInformationDO platformInformationDO = platformInformationService.undoOperation(id, String.valueOf(req.getSession().getAttribute("code")), reason);
            return write(200, "撤回成功", "data", platformInformationDO);
        } catch (Exception ex) {
            error(ex);
            return error(-1, "撤回失败");
        }
    }

    @RequestMapping(value = "findPlatformInformationClassify",method = RequestMethod.GET)
    @ApiOperation("查找平台咨讯树状全部分类")
    @ResponseBody
    public String findPlatformInformationClassify() {
        try {
            return write(200, "查找成功", "data", platformInformationService.findPlatformInformationClassify());
        } catch (Exception ex) {
            error(ex);
            return error(-1, "查找失败");
        }
    }

}
*/
