package  com.yihu.customer.controller.manager.refinement;

import  com.yihu.customer.controller.BaseController;
import com.yihu.customer.service.refinement.RefinementService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;


/**
 * 精选问答
 * @author zhangdan
 *
 */
@Controller
@RequestMapping(value = "/admin/refinement", produces = MediaType.APPLICATION_JSON_UTF8_VALUE)
@Api(value = "精选问答--医生端", description = "精选问答--医生端")
public class RefinementController extends BaseController {
	private static Logger logger = LoggerFactory.getLogger(RefinementController.class);

	@Autowired
	private RefinementService refinementService;


	@RequestMapping(value = "/findCategory",method = RequestMethod.GET)
	@ResponseBody
	@ApiOperation(value = "获取类别")
	public String findCategory(@ApiParam(value = "类型code") @RequestParam(value = "code") String code,
							   	@ApiParam(value = "是否取下级类别 1是 2不是") @RequestParam(value = "isChild") Integer isChild){
		try {
			return write(200,"获取成功！","data",refinementService.findCategory(code,isChild));
		}catch (Exception e){
			e.printStackTrace();
			logger.info("获取类型列表失败！----"+e.getMessage());
			return write(-1,"获取失败！");
		}
	}
}
