package  com.yihu.customer.controller.manager.sign;

import com.alibaba.fastjson.JSONObject;
import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.JavaType;
import com.fasterxml.jackson.databind.ObjectMapper;
import  com.yihu.customer.controller.BaseController;
import  com.yihu.customer.entity.PatientReservation;
import  com.yihu.customer.entity.SignFamily;
import  com.yihu.customer.entity.WlyyAdminTeamMember;
import com.yihu.customer.service.manager.sign.SignFamilyService;
import com.yihu.customer.service.manager.team.ManageWlyyAdminTeamMemberService;
import com.yihu.customer.util.HttpManageClientUtil;
import io.swagger.annotations.ApiParam;
import jxl.Workbook;
import jxl.write.*;
import org.apache.commons.lang3.StringUtils;
import org.apache.http.NameValuePair;
import org.apache.http.message.BasicNameValuePair;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.data.domain.Page;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.OutputStream;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

/**
 * Created by Administrator on 2016/10/26.
 */
@Controller
@RequestMapping(value="admin/sign")
public class SignFamilyController extends BaseController {

    private static Logger logger = LoggerFactory.getLogger(SignFamilyController.class);

    @Value("${reservation.zyurl}")
    private String baseUrl;
    @Autowired
    private SignFamilyService signFamilyService;
    @Autowired
    private ManageWlyyAdminTeamMemberService teamMemberService;
    @Autowired
    private HttpManageClientUtil httpManageClientUtil;

    //签约居民管理*******************************
    @RequestMapping(value = "initial", method = RequestMethod.GET)
    public String listInit(){
        return "sign/sign_family_list";
    }

    @RequestMapping(value = "signList")
    @ResponseBody
    public String searchPatientList(
            @RequestParam(value = "name",required = false)String name,
            @RequestParam(value = "idcard",required = false)String idcard,
            @RequestParam(value = "address",required = false)String address,
            @RequestParam(value = "hospitalName",required = false)String hospitalName,
            @RequestParam(value = "signDoctorName",required = false)String signDoctorName,
            @RequestParam(value = "page",required = false)Integer page,
            @RequestParam(value = "rows",required = false)Integer pageSize
    ){
        try {
            Page<SignFamily> signFamilies = signFamilyService.searchList(name, idcard,address,hospitalName,signDoctorName, page, pageSize);
            return write(200,"操作成功",page,pageSize,signFamilies);
        }catch (Exception ex){
            error(ex);
            return error(-1, "操作失败！");
        }
    }

    @RequestMapping(value = "infoInit/{id}",method = RequestMethod.GET)
    public String infoInit(@PathVariable(value = "id") Long id){
        return "sign/sign_family_modify";
    }

    @RequestMapping(value = "signInfo/{id}")
    @ResponseBody
    public String findById(@PathVariable(value = "id")Long id){
        try {
            SignFamily signFamily = signFamilyService.findById(id);
            return write(200,"success","data",signFamily);
        }catch (Exception e){
            error(e);
            return error(-1,"操作失败！");
        }

    }


    @RequestMapping(value = "memberList", method = RequestMethod.POST)
    @ResponseBody
    public String memberList(
            @ApiParam(name = "teamId", value = "团队Id")
            @RequestParam(value = "teamId") Long teamId,
            @ApiParam(name = "doctorCode", value = "医生编码")
            @RequestParam(value = "doctorCode", required = false) String doctorCode) {
        try {
            List<WlyyAdminTeamMember> members = teamMemberService.searchTeamMembers(teamId, doctorCode);
            return write(200, "操作成功", "detailModelList", members);
        } catch (Exception ex) {
            error(ex);
            return error(200, "操作失败");
        }
    }
    //签约居民管理******************************

    //签约居民分配******************************
    //用于签约居民分配的签约居民显示
    @RequestMapping(value = "allocate/initial", method = RequestMethod.GET)
    public String initAllocateListPage(){
        return "team/patient/sign_family_allocate_list";
    }

    @RequestMapping(value = "allocate/list",method = RequestMethod.POST)
    @ResponseBody
    public String searchListForAllocate(
            @RequestParam(value = "name",required = false)String name,
            @RequestParam(value = "idcard",required = false)String idcard,
            @RequestParam(value = "address",required = false)String address,
            @RequestParam(value = "hospitalName",required = false)String hospitalName,
            @RequestParam(value = "signDoctorName",required = false)String signDoctorName,
            @RequestParam(value = "adminTeamId",required = false)Integer adminTeamId,
            @RequestParam(value = "adminTeamName",required = false)String adminTeamName,
            @RequestParam(value = "leaderName",required = false)String leaderName,
            @RequestParam(value = "doctorHealthName",required = false)String doctorHealthName,
            @RequestParam(value = "page",required = false)Integer page,
            @RequestParam(value = "rows",required = false)Integer pageSize){
        try {
            Page<SignFamily> signFamilies = signFamilyService.searchListForAllocate(name, idcard,address, hospitalName, signDoctorName, adminTeamId,adminTeamName,leaderName,doctorHealthName, page, pageSize);
            return write(200,"操作成功",page,pageSize,signFamilies);
        }catch (Exception ex){
            error(ex);
            return error(-1, "操作失败！");
        }
    }

    @RequestMapping(value = "allocate",method = RequestMethod.GET)
    public String initAllocatePage(){
        return "team/patient/sign_family_allocate";
    }

    @RequestMapping(value = "allocate",method = RequestMethod.POST)
    @ResponseBody
    public String allocate(
            @RequestParam(value = "ids",required = true)Long[] ids,
            @RequestParam(value = "doctor",required = false)String doctor,
            @RequestParam(value = "doctorHealth",required = false)String doctorHealth){
        try {
            if(ids.length <=0){
                return error(-1,"批量分配签约ids不能为空！");
            }
            //全科和健管师都为空，全科和健管有一个为空，全科和健管都不为空。
            if(StringUtils.isEmpty(doctor) && StringUtils.isEmpty(doctorHealth)){
                return error(-1,"分配的全科医生，健康管理师不能同时为空！");
            }
//            if(StringUtils.equals(doctor,doctorHealth)){
//                return error(-1,"分配的全科医生，健康管理师不能为同一个人！");
//            }
            Map<String,Object> res = signFamilyService.batchAllocate(ids, doctor, doctorHealth);
            if(res.get("errorMsg") != null){
                return write(-1,res.get("errorMsg").toString());
            }
            return write(200,"操作成功","data",res);
        }catch (Exception e){
            error(e);
            return error(-1,"操作失败！");
        }
    }



    //签约居民批量分配失败记录导出Excel
    //导入失败数据生成Excel表
    @RequestMapping(value = "toExcel",method = RequestMethod.POST,produces = "application/json;charset=UTF-8" )
    public void errorDataToExcel(@RequestParam(value = "errorData")String errorData,HttpServletResponse response){
        try {
            ObjectMapper objectMapper = new ObjectMapper();
            JavaType javaType = objectMapper.getTypeFactory().constructParametricType(ArrayList.class, SignFamily.class);
            List<SignFamily> lst =  (List<SignFamily>)objectMapper.readValue(errorData, javaType);
            response.setContentType("octets/stream");
            response.setHeader("Content-Disposition", "attachment; filename="+ new String( "errorAllocateTable.xls"));
            OutputStream os = response.getOutputStream();
            this.write(os,lst);
        }catch (Exception ex){
            error(ex);
        }
    }
    public void addHeader(WritableSheet ws) throws WriteException {
        String[] header = {"签约id","患者编码","患者姓名", "身份证号", "团队id", "签约人","全科医生", "健康管理师", "分配失败原因"};
        int i = 0;
        for (String h : header) {
            addCell(ws, 0, i, h);//表名，行，列，header
            i++;
        }
    }

    public void write(WritableWorkbook wwb, List ls) throws Exception {
        try {
            WritableSheet ws;
            ws = wwb.createSheet("sheet",1);
            addHeader(ws);
            int i = 1;
            for (SignFamily m : (List<SignFamily>) ls) {
                addCell(ws, i, 0, m.getId()+"","");
                addCell(ws, i, 1, m.getPatient(),"");
                addCell(ws, i, 2, m.getName(),"");
                addCell(ws, i, 3, m.getIdcard(),"");
                addCell(ws, i, 4, m.getAdminTeamId()+"","");
                addCell(ws, i, 5, m.getSignDoctorName(),"");
                addCell(ws, i, 6, m.getDoctorName(),"");
                addCell(ws, i, 7, m.getDoctorHealthName(),"");
                addCell(ws, i, 8, m.getMsg());
                i++;
            }
            wwb.write();
            wwb.close();
        } catch (IOException e) {
            e.printStackTrace();
            if (wwb != null) wwb.close();
            throw e;
        }
    }
    public void write(OutputStream os, List ls) throws Exception{
        write(Workbook.createWorkbook(os), ls);
    };
    //添加单元格内容
    public void addCell(WritableSheet ws, int row, int column,  String data) throws WriteException {
        Label label = new Label(column ,row, data);
        ws.addCell(label);
    }
    //添加单元格内容
    public void addCell(WritableSheet ws, int row, int column, String data, String memo) throws WriteException {
        Label label = new Label(column ,row, data);
        if(!org.springframework.util.StringUtils.isEmpty(memo)){
            WritableCellFeatures cellFeatures = new WritableCellFeatures();
            cellFeatures.setComment(memo);
            label.setCellFeatures(cellFeatures);
        }
        ws.addCell(label);
    }

    @RequestMapping(value = "reservation/{patient}",method = RequestMethod.GET)
    public String infoReservation(@PathVariable(value = "patient") String patient){
        return "sign/patient_reservation_list";
    }

    @RequestMapping(value = "reservationInfo")
    @ResponseBody
    public String getReservation(
            @ApiParam(name = "patient", value = "居民标识")
            @RequestParam(value = "patient") String patient){
        try {
            String url = baseUrl + "/third/guahao/GetRegList";
            List<NameValuePair> params = new ArrayList<>();
            params.add(new BasicNameValuePair("patient", patient));
            String response = httpManageClientUtil.post(url, params, "UTF-8");
//            String response = "{\"status\": 200,\"msg\": \"根据患者医保卡获取近三个月的预约记录成功！\",\"data\": [{\"id\": null,\"code\": \"709d4565-b2bd-4b38-8d90-6b6e953d47e4\",\"doctor\": null,\"dname\": null,\"patient\": \"275f6e8c54874595bd92d8ac255535c4\"," +
//                    "\"idcard\": \"412724198310182529\",\"name\": \"魏立苹\",\"phone\": \"13799282718\",\"ssc\": \"DB9954948\",\"sectionType\": \"a\",\"startTime\": \"2018-06-08 09:30:00\",\"endTime\": \"2018-06-08 09:37:00\",\"orgCode\": \"350211A1001\",\"orgName\": \"厦门大学附属第一医院\",\"deptCode\": \"1050100\",\"deptName\": \"中医科门诊\",\"doctorCode\": \"50104\",\"doctorName\": \"黄献钟\",\"doctorPhoto\": \"\",\"doctorJob\": \"副主任医师\",\"status\": 2,\"canceler\": null,\"cancelerName\": null,\"cancelerType\": null,\"cancelerTime\": null,\"czrq\": \"2018-05-29 09:17:56\",\"type\": \"1\",\"signType\": null,\"adminTeamCode\": null}]}";
            JSONObject res = JSONObject.parseObject(response);
            //从JSONObject对象里取出key是data的对象
            String data = res.getString("data");
            List<PatientReservation> patientReservations = null;
            if(data != null) {
                //json字符串转成List<T>
                ObjectMapper objectMapper = new ObjectMapper();
                JavaType javaType = objectMapper.getTypeFactory().constructParametricType(ArrayList.class, PatientReservation.class);
                patientReservations = (List<PatientReservation>) objectMapper.readValue(data, javaType);
            }
            return write(200,"success","data",patientReservations);
        }catch (Exception e){
            error(e);
            return error(-1,"操作失败！");
        }

    }

    @RequestMapping(value = "moreInfoInit/{idCard}/{hospital}",method = RequestMethod.GET)
    public String moreInfoInit(@PathVariable(value = "idCard")String idCard, @PathVariable(value = "hospital")String hospital){
        return "sign/sign_family_more";
    }

    /**
     * 获取居民家庭成员关系信息列表
     * @param idCard
     * @return
     */
    @RequestMapping(value = "/getSickFamilyMemberLis")
    @ResponseBody
    public String getSickFamilyMemberLis(
            @ApiParam(name = "idCard", value = "居民身份证号码")
            @RequestParam(value = "idCard") String idCard){
        try {
            String url = baseUrl + "/third/archives/getSickFamilyMemberList";
            List<NameValuePair> params = new ArrayList<>();
            params.add(new BasicNameValuePair("idCard", idCard));
            String response = httpManageClientUtil.post(url, params, "UTF-8");
            logger.info("获取居民家庭成员关系信息列表getSickFamilyMemberList:{}", response);
            List<Map<String,Object>> listMap = new ArrayList<>();
            listMap = parsingResponse(response, listMap);
            return write(200,"success","detailModelList", listMap);
        }catch (Exception e){
            error(e);
            return error(-1,"操作失败！");
        }

    }

    /**
     * 获取高危产妇信息
     * @param idCard
     * @param hospital
     * @return
     */
    @RequestMapping(value = "/getEhrMaternalPregnancyHighRecord")
    @ResponseBody
    public String getEhrMaternalPregnancyHighRecord(
            @ApiParam(name = "idCard", value = "居民身份证号码")
            @RequestParam(value = "idCard") String idCard,
            @ApiParam(name = "hospital", value = "医院code")
            @RequestParam(value = "hospital") String hospital){
        try {
            String url = baseUrl + "/third/prenatalInspector/getEhrMaternalPregnancyHighRecord";
            List<NameValuePair> params = new ArrayList<>();
            params.add(new BasicNameValuePair("idcard", idCard));
            params.add(new BasicNameValuePair("hospital", hospital));
            String response = httpManageClientUtil.post(url, params, "UTF-8");
            logger.info("获取高危产妇信息getEhrMaternalPregnancyHighRecord:{}", response);
            List<Map<String,Object>> listMap = new ArrayList<>();
            listMap = parsingResponse(response, listMap);
            return write(200,"success","detailModelList", listMap);
        }catch (Exception e){
            error(e);
            return error(-1,"操作失败！");
        }

    }

    /**
     * 获取孕妇分娩信息
     * @param idCard
     * @param hospital
     * @return
     */
    @RequestMapping(value = "/getEhrMaternalDeliveryRecord")
    @ResponseBody
    public String getEhrMaternalDeliveryRecord(
            @ApiParam(name = "idCard", value = "居民身份证号码")
            @RequestParam(value = "idCard") String idCard,
            @ApiParam(name = "hospital", value = "医院code")
            @RequestParam(value = "hospital") String hospital){
        try {
            String url = baseUrl + "/third/prenatalInspector/getEhrMaternalDeliveryRecord";
            List<NameValuePair> params = new ArrayList<>();
            params.add(new BasicNameValuePair("idcard", idCard));
            params.add(new BasicNameValuePair("hospital", hospital));
            String response = httpManageClientUtil.post(url, params, "UTF-8");
            logger.info("获取孕妇分娩信息getEhrMaternalDeliveryRecord:{}", response);
            List<Map<String,Object>> listMap = new ArrayList<>();
            listMap = parsingResponse(response, listMap);
            return write(200,"success","detailModelList", listMap);
        }catch (Exception e){
            error(e);
            return error(-1,"操作失败！");
        }

    }

    /**
     * 获取儿童健康体检0-6岁记录
     * @param idCard
     * @param hospital
     * @return
     */
    @RequestMapping(value = "/getEhrMaternalChildMedicalRecord")
    @ResponseBody
    public String getEhrMaternalChildMedicalRecord(
            @ApiParam(name = "idCard", value = "居民身份证号码")
            @RequestParam(value = "idCard") String idCard,
            @ApiParam(name = "hospital", value = "医院code")
            @RequestParam(value = "hospital") String hospital){
        try {
            String url = baseUrl + "/third/prenatalInspector/getEhrMaternalChildMedicalRecord";
            List<NameValuePair> params = new ArrayList<>();
            params.add(new BasicNameValuePair("idcard", idCard));
            params.add(new BasicNameValuePair("hospital", hospital));
            String response = httpManageClientUtil.post(url, params, "UTF-8");
            logger.info("获取儿童健康体检0-6岁记录getEhrMaternalChildMedicalRecord:{}", response);
            List<Map<String,Object>> listMap = new ArrayList<>();
            listMap = parsingResponse(response, listMap);
            return write(200,"success","detailModelList", listMap);
        }catch (Exception e){
            error(e);
            return error(-1,"操作失败！");
        }

    }

    /**
     * 获取新生儿访视信息
     * @param idCard
     * @param hospital
     * @return
     */
    @RequestMapping(value = "/getEhrMaternalHomeVisitRecord")
    @ResponseBody
    public String getEhrMaternalHomeVisitRecord(
            @ApiParam(name = "idCard", value = "居民身份证号码")
            @RequestParam(value = "idCard") String idCard,
            @ApiParam(name = "hospital", value = "医院code")
            @RequestParam(value = "hospital") String hospital){
        try {
            String url = baseUrl + "/third/prenatalInspector/getEhrMaternalHomeVisitRecord";
            List<NameValuePair> params = new ArrayList<>();
            params.add(new BasicNameValuePair("idcard", idCard));
            params.add(new BasicNameValuePair("hospital", hospital));
            String response = httpManageClientUtil.post(url, params, "UTF-8");
            logger.info("获取新生儿访视信息getEhrMaternalHomeVisitRecord:{}", response);
            List<Map<String,Object>> listMap = new ArrayList<>();
            listMap = parsingResponse(response, listMap);
            return write(200,"success","detailModelList", listMap);
        }catch (Exception e){
            error(e);
            return error(-1,"操作失败！");
        }

    }

    private List<Map<String, Object>> parsingResponse(String response, List<Map<String,Object>> listMap) throws IOException {
        if (StringUtils.isNotEmpty(response)) {
            JSONObject res = JSONObject.parseObject(response);
            //从JSONObject对象里取出key是data的对象
            String status = res.getString("status");
            String data = res.getString("data");
            if("200".equals(status) && data != null) {
                JSONObject nestedRes = JSONObject.parseObject(data);
                String nestedData = nestedRes.getString("DATA");
                //json字符串转成List<T>
                ObjectMapper objectMapper = new ObjectMapper();
                listMap = objectMapper.readValue(nestedData, new TypeReference<List>() {});
            }
        }
        return listMap;
    }
}
