package  com.yihu.customer.controller.manager.specialist;/**
 * Created by nature of king on 2018/8/29.
 */

import  com.yihu.customer.controller.BaseController;
import com.yihu.customer.service.manager.specialist.SpecialistHospitalItemService;
import jxl.Workbook;
import jxl.read.biff.BiffException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.io.InputStream;

/**
 * @author wangzhinan
 * @create 2018-08-29 1:48
 * @desc 机构服务项目
 **/
@Controller
@RequestMapping(value="/admin/specialist/hospitalServiceItem")
public class HopsitalServiceItemController extends BaseController {

    @Autowired
    private SpecialistHospitalItemService specialistHospitalItemService;


    @RequestMapping(value = "initial")
    public String listInit() {
        return "desizenMan/service_project_management";
    }


    @RequestMapping(value = "initial1")
    public String listInit1() {
        return "desizenMan/new-institutional-projects";
    }

    /**
     * 添加机构服务项目
     *
     * @param hospitalServiceItem
     * @return
     */
    @RequestMapping(value = "createHospitalServiceItem", method = RequestMethod.POST)
    @ResponseBody
    public String insert(@RequestParam(name = "hospitalServiceItem") String hospitalServiceItem){
        try {
            return write(200, "操作成功", "data",specialistHospitalItemService.insert(hospitalServiceItem));
        } catch (Exception ex) {
            error(ex);
            return error(-1, "操作失败");
        }
    }

    /**
     * 获取机构
     * @return
     */
    @RequestMapping(value = "selectHospital", method = RequestMethod.POST)
    @ResponseBody
    public String selectHospitals(@RequestParam(name = "hospitalName",required = false) String hospitalName,
                                  @RequestParam(name = "grade",required = false) Integer grade){
        try {
            return write(200, "查询成功", "data",specialistHospitalItemService.selectHospital(hospitalName,grade));
        } catch (Exception ex) {
            error(ex);
            return error(-1, "查询失败");
        }
    }


    /**
     *
     * @param hospital
     * @return
     */
    @RequestMapping(value = "selectByHospital", method = RequestMethod.POST)
    @ResponseBody
    public String selectByHospital(@RequestParam(name = "hospital") String hospital){
        try {
            return write(200, "查询成功", "data",specialistHospitalItemService.selectItemByHospital(hospital));
        } catch (Exception ex) {
            error(ex);
            return error(-1, "查询失败");
        }
    }


    /**
     * 获取机构服务项目
     *
     * @param serviceItemName
     * @param hospital
     * @return
     */
    @RequestMapping(value = "selectByCondition", method = RequestMethod.POST)
    @ResponseBody
    public String selectByCondition(@RequestParam(name = "serviceItemName",required = false) String serviceItemName,
                                    @RequestParam(name = "hospital",required = false) String hospital){
        try {
            return write(200, "查询成功", "data",specialistHospitalItemService.selectCondition(serviceItemName,hospital));
        } catch (Exception ex) {
            error(ex);
            return error(-1, "查询失败");
        }
    }


    /**
     *  删除机构服务项目
     *
     * @param serviceItem 服务项目id
     * @param hospital 医院code
     * @return
     */
    @RequestMapping(value = "deleteHospitalItem", method = RequestMethod.POST)
    @ResponseBody
    public String delete(@RequestParam(name = "serviceItem",required = false) String serviceItem,
                                    @RequestParam(name = "hospital",required = false) String hospital,
                         @RequestParam(name = "id",required = false) String id){
        try {
            return write(200, "删除成功", "data",specialistHospitalItemService.delete(serviceItem,hospital,id));
        } catch (Exception ex) {
            error(ex);
            return error(-1, "删除失败");
        }
    }


    /**
     * 机构服务项目导数据
     * @param file
     * @return
     */
    @RequestMapping(value = "importData", produces = "application/json;charset=UTF-8")
    @ResponseBody
    public String importData(@RequestParam(name = "file") MultipartFile file) {
        try {
            request.setCharacterEncoding("UTF-8");
            InputStream inputStream = file.getInputStream();
            Workbook workbook = Workbook.getWorkbook(inputStream);

            specialistHospitalItemService.importData(workbook);

            return write(200, "操作成功");
        } catch (IOException | BiffException e) {
            e.printStackTrace();
            error(e);
            return error(-1, "操作失败！");
        }
    }
}
