package  com.yihu.customer.controller.manager.specialist;/**
 * Created by nature of king on 2018/8/17.
 */

import com.alibaba.fastjson.JSONObject;
import  com.yihu.customer.controller.BaseController;
import  com.yihu.customer.entity.specialist.SpecialistServiceItemDO;
import com.yihu.customer.service.manager.specialist.ServiceItemService;
import jxl.Workbook;
import jxl.read.biff.BiffException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.multipart.MultipartFile;

import java.io.IOException;
import java.io.InputStream;
import java.util.List;

/**
 * @author wangzhinan
 * @create 2018-08-17 16:51
 * @desc 服务项目
 **/
@Controller
@RequestMapping(value="/admin/specialist/serviceItem")
public class ServiceItemController  extends BaseController {
    @Autowired
    private ServiceItemService serviceItemService;


    @RequestMapping(value = "initial")
    public String listInit() {
        return "specialty/index";
    }

    /**
     * 创建服务项目
     * @param serviceItem
     * @return
     */
    @RequestMapping(value = "createServiceItem", method = RequestMethod.POST)
    @ResponseBody
    public String createServiceItem(@RequestParam(name = "serviceItem") String serviceItem){
        try {

            return write(200, "操作成功", "data",serviceItemService.createServiceItem(serviceItem));
        } catch (Exception ex) {
            error(ex);
            return error(-1, "操作失败");
        }
    }

    /**
     * 更新服务项目
     *
     * @param serviceItem
     * @return
     */
    @RequestMapping(value = "updateServiceItem", method = RequestMethod.POST)
    @ResponseBody
    public String updateServiceItem(@RequestParam(name = "serviceItem") String serviceItem){
        try {

            return write(200, "操作成功", "data",serviceItemService.updateServiceItem(serviceItem));
        } catch (Exception ex) {
            error(ex);
            return error(-1, "操作失败");
        }
    }


    /**
     * 获取服务项目
     *
     * @param serviceItem
     * @param page
     * @param pagesize
     * @return
     */
    @RequestMapping(value = "selectServiceItem", method = RequestMethod.GET)
    @ResponseBody
    public String selectServiceItem(@RequestParam(name = "serviceItem") String serviceItem,
                                    @RequestParam(name = "page",defaultValue = "1")Integer page,
                                    @RequestParam(name = "pagesize",defaultValue = "10")Integer pagesize){
        try {
            JSONObject jsonObject = serviceItemService.selectServiceItem(serviceItem,page,pagesize);
            String totalCount = String.valueOf(jsonObject.get("totalCount"));
            Long total = Long.parseLong(totalCount);
            return write(200, "操作成功", page,pagesize,total,(List< SpecialistServiceItemDO>)jsonObject.get("detailModelList"));
        } catch (Exception ex) {
            error(ex);
            return error(-1, "操作失败");
        }
    }


    /**
     * 删除服务项目
     *
     * @param ids
     * @return
     */
    @RequestMapping(value = "delete", method = RequestMethod.POST)
    @ResponseBody
    public String deleteServiceItem(@RequestParam(name = "ids") String ids){
        try {

            return write(200, "操作成功", "data",serviceItemService.delete(ids));
        } catch (Exception ex) {
            error(ex);
            return error(-1, "操作失败");
        }
    }


    /**
     * 查询历史记录
     *
     * @param serviceItem
     * @param page
     * @param size
     * @return
     */
    @RequestMapping(value = "selectOperate", method = RequestMethod.POST)
    @ResponseBody
    public String selectOperate(@RequestParam(name = "serviceItem") String serviceItem,
                                    @RequestParam(name = "page",defaultValue = "1")Integer page,
                                    @RequestParam(name = "size",defaultValue = "10")Integer size){
        try {

            return write(200, "操作成功", "data",serviceItemService.selectOperate(serviceItem,page,size));
        } catch (Exception ex) {
            error(ex);
            return error(-1, "操作失败");
        }
    }

    /**
     * 服务项目导数据
     *
     * @param file
     * @return
     */
    @RequestMapping(value = "importData", produces = "application/json;charset=UTF-8")
    @ResponseBody
    public String importData(@RequestParam(name = "file") MultipartFile file) {
        try {
            request.setCharacterEncoding("UTF-8");
            InputStream inputStream = file.getInputStream();
            Workbook workbook = Workbook.getWorkbook(inputStream);
            serviceItemService.importData(workbook);

            return write(200, "操作成功");
        } catch (IOException | BiffException e) {
            e.printStackTrace();
            error(e);
            return error(-1, "操作失败！");
        }
    }
}
