package  com.yihu.customer.controller.manager.survey;

import  com.yihu.customer.controller.BaseController;
import  com.yihu.customer.entity.survey.QuestionnaireWinning;
import com.yihu.customer.service.manager.survey.QuestionnaireService;
import io.swagger.annotations.Api;
import jxl.Workbook;
import jxl.read.biff.BiffException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import java.io.IOException;
import java.io.InputStream;
import java.text.ParseException;
import java.util.List;

/**
 * Created by yww on 2016/12/13.
 */
@Controller
@RequestMapping("admin/questionnaire")
@Api(description = "管理端问卷奖励管理")
public class QuestionnaireController extends BaseController {
    @Autowired
    private QuestionnaireService questionnaireService;

    @RequestMapping(value = "initial", method = RequestMethod.GET)
    public String initList(){
        return "questionnaire/prize/prize_list";
    }

    @RequestMapping(value = "list")
    @ResponseBody
    public String searchList(
            @RequestParam(value = "type",defaultValue = "1")Integer type,
            @RequestParam(value = "name",required = false)String name,
            @RequestParam(value = "idcard",required = false)String idcard,
            @RequestParam(value = "page",required = false)Integer page,
            @RequestParam(value = "rows",required = false)Integer pageSize){
        try{
            List<QuestionnaireWinning> userprizes = questionnaireService.searchList(type ,name,idcard,page, pageSize);
            List<QuestionnaireWinning> total = questionnaireService.searchListCount(type,name,idcard);
            return write(200,"操作成功",page,pageSize,total.size(),userprizes);
        }catch (Exception ex){
            error(ex);
            return error(-1,"操作失败！");
        }
    }

    /*
     * 导入奖品信息Excel表格数据
     * @param request
     * @return
    
     */
    @RequestMapping(value = "/importData", produces = "application/json;charset=UTF-8")
    @ResponseBody
    public String importData(HttpServletRequest request) {
        try {
            request.setCharacterEncoding("UTF-8");
            InputStream inputStream = request.getInputStream();
            Workbook workbook = Workbook.getWorkbook(inputStream);
            questionnaireService.importData(workbook);
            return write(200, "操作成功");

        } catch (IOException | BiffException | ParseException e) {
            e.printStackTrace();
            error(e);
            return error(-1, "操作失败！");
        }
    }
}
