package  com.yihu.customer.controller.manager.survey;

import  com.yihu.customer.controller.BaseController;
import  com.yihu.customer.entity.survey.SurveyAdvice;
import com.yihu.customer.service.manager.survey.SurveyAdviceService;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import java.util.List;

/**
 * Created by humingfen on 2018/7/5.
 */
@Controller
@RequestMapping(value="admin/surveyAdvice/")
public class SurveyAdviceController extends BaseController {
    @Autowired
    private SurveyAdviceService surveyAdviceService;

    @RequestMapping(value = "findByDiseaseType", method = RequestMethod.POST)
    @ResponseBody
    public String findById(
            @ApiParam(name = "diseaseType",value = "疾病类型")
            @RequestParam(value = "diseaseType",required = true) Integer diseaseType,
            @ApiParam(name = "templateCode",value = "模板id")
            @RequestParam(value = "templateCode",required = true) String templateCode){
        try {
            List<SurveyAdvice> results = surveyAdviceService.findAdvice(diseaseType, templateCode);
            return write(200, "操作成功","data",results);
        } catch (Exception ex) {
            error(ex);
            return error(-1, "操作失败");
        }
    }

    @RequestMapping(value = "saveOrUpdate", method = RequestMethod.POST)
    @ResponseBody
    public String saveResult(@ApiParam(name = "jsonData", value = "新增json",defaultValue = "")
                                 @RequestParam(value = "jsonData", required = true) String jsonData){
        try {
            SurveyAdvice advice = surveyAdviceService.saveOrUpdate(jsonData);
            return write(200,"保存成功","data",advice);
        }catch (Exception e){
            e.printStackTrace();
            return write(-1,"保存失败");
        }
    }
}
