package  com.yihu.customer.controller.manager.survey;

import  com.yihu.customer.controller.BaseController;
import  com.yihu.customer.entity.survey.SurveyAdvice;
import com.yihu.customer.service.manager.survey.SurveyAdviceService;
import com.yihu.customer.service.manager.survey.SurveyTemplateAdviceService;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import java.util.List;

/**
 * Created by humingfen on 2018/7/5.
 */
@Controller
@RequestMapping(value="admin/surveyTemplateAdvice/")
public class SurveyTemplateAdviceController extends BaseController {
    @Autowired
    private SurveyTemplateAdviceService templateAdviceService;
    @Autowired
    private SurveyAdviceService surveyAdviceService;

    @RequestMapping(value = "initial", method = RequestMethod.GET)
    public String initAdvice(Integer diseaseType, String templateCode,String mode){
        request.setAttribute("templateCode",templateCode);
        request.setAttribute("diseaseType",diseaseType);
        request.setAttribute("mode",mode);
        return "questionnaire/template/template_advice";
    }

    @RequestMapping(value = "saveOrUpdate", method = RequestMethod.POST)
    @ResponseBody
    public String saveResult(@ApiParam(name = "jsonData", value = "新增json",defaultValue = "")
                             @RequestParam(value = "jsonData", required = true) String jsonData,
                             @ApiParam(name = "templateCode", value = "新增json",defaultValue = "")
                             @RequestParam(value = "templateCode", required = true) String templateCode){
        try {
            templateAdviceService.saveOrUpdate(jsonData, templateCode);
            return write(200,"保存成功");
        }catch (Exception e){
            e.printStackTrace();
            return write(-1,"保存失败");
        }
    }

    @RequestMapping(value = "adviceList", method = RequestMethod.POST)
    @ResponseBody
    public String adviceList(@ApiParam(name = "templateCode", value = "新增json",defaultValue = "")
                             @RequestParam(value = "templateCode", required = true) String templateCode){
        try {
            List<SurveyAdvice> surveyAdviceList = surveyAdviceService.findAdviceByTemplateCode(templateCode);
            return write(200,"保存成功","data",surveyAdviceList);
        }catch (Exception e){
            e.printStackTrace();
            return write(-1,"保存失败");
        }
    }

}
