package  com.yihu.customer.controller.manager.survey;

import  com.yihu.customer.controller.BaseController;
import  com.yihu.customer.entity.User;
import  com.yihu.customer.entity.survey.SurveyTemplateResult;
import com.yihu.customer.service.manager.survey.SurveyTemplateResultService;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

/**
 * Created by humingfen on 2018/7/5.
 */
@Controller
@RequestMapping(value="admin/surveyTemplateResult/")
public class SurveyTemplateResultController extends BaseController {
    @Autowired
    private SurveyTemplateResultService resultService;

    @RequestMapping(value = "findByTemplateCode", method = RequestMethod.POST)
    @ResponseBody
    public String findById(
            @ApiParam(name = "templateCode",value = "模板id")
            @RequestParam(value = "templateCode",required = true) String templateCode){
        try {
            List<SurveyTemplateResult> results = resultService.findByTemplateCode(templateCode);
            return write(200, "操作成功","data",results);
        } catch (Exception ex) {
            error(ex);
            return error(-1, "操作失败");
        }
    }

    @RequestMapping(value = "save", method = RequestMethod.POST)
    @ResponseBody
    public String saveResult(@ApiParam(name = "jsonData", value = "新增json",defaultValue = "")
                               @RequestParam(value = "jsonData", required = true) String jsonData,
                             @ApiParam(name = "templateCode",value = "模板id")
                             @RequestParam(value = "templateCode",required = true) String templateCode,
                               HttpServletRequest request){
        User loginUser = (User) request.getSession().getAttribute("userInfo");
        try {
            resultService.saveOrUpdate(jsonData,templateCode,loginUser.getCode());
            return write(200,"保存成功");
        }catch (Exception e){
            e.printStackTrace();
            return write(-1,"保存失败");
        }
    }

}
