package  com.yihu.customer.controller.manager.team;

import com.fasterxml.jackson.databind.ObjectMapper;
import  com.yihu.customer.controller.BaseController;
import  com.yihu.customer.entity.Doctor;
import  com.yihu.customer.entity.WlyyAdminTeam;
import  com.yihu.customer.entity.WlyyAdminTeamMember;
import com.yihu.customer.service.manager.hos.HosDoctorService;
import com.yihu.customer.service.manager.team.ManageWlyyAdminTeamMemberService;
import com.yihu.customer.service.manager.team.ManageWlyyAdminTeamService;
import com.yihu.customer.util.HttpUtil;
import io.swagger.annotations.ApiParam;
import jxl.Workbook;
import jxl.read.biff.BiffException;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.data.domain.Page;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletRequest;
import java.io.IOException;
import java.io.InputStream;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by yww on 2016/11/15.
 */
@Controller
@RequestMapping("admin/team")
public class WlyyAdminTeamController extends BaseController {
    @Autowired
    private ManageWlyyAdminTeamService teamService;
    @Value("${service-gateway.update-team-url}")
    private String loadTeamInfoUrl;
    //----------------------------------------团队成员列表--------------------------------
    @Autowired
    private ManageWlyyAdminTeamMemberService teamMemberService;
    @Autowired
    private HosDoctorService doctorService;

    //---医生团队查询 开始---
    @RequestMapping(value = "initial", method = RequestMethod.GET)
    public String initTeamList() {
        return "team/doctor/team_list";
    }

    //---专科医生团队查询 开始---
    @RequestMapping(value = "zk/initial", method = RequestMethod.GET)
    public String initZkTeamList() {
        return "team/doctor/zk_team_list";
    }

    //分页查询团队列表
    @RequestMapping(value = "teamList", method = RequestMethod.POST)
    @ResponseBody
    public String searchTeams(
            @ApiParam(name = "orgName", value = "机构名称")
            @RequestParam(value = "orgName", required = false) String orgName,
            @ApiParam(name = "teamName", value = "团队名称")
            @RequestParam(value = "teamName", required = false) String teamName,
            @ApiParam(name = "leaderName", value = "团队长")
            @RequestParam(value = "leaderName", required = false) String leaderName,
            @ApiParam(name = "memberName", value = "团队成员名")
            @RequestParam(value = "memberName", required = false) String memberName,
            @ApiParam(name = "memberMobile", value = "团队成员名电话")
            @RequestParam(value = "memberMobile", required = false) String memberMobile,
            @ApiParam(name = "page")
            @RequestParam(value = "page") int page,
            @ApiParam(name = "rows")
            @RequestParam(value = "rows") int rows) {
        try {
            //按医生code信息外查询,
            Page<WlyyAdminTeam> wlyyTeams = teamService.searchTeams(orgName, teamName, leaderName, memberName, memberMobile, 0,page, rows);
            return writeToJson(200, "操作成功", page, rows, wlyyTeams);
        } catch (Exception ex) {
            error(ex);
            return error(-1, "操作失败");
        }
    }

    //分页查询团队列表
    @RequestMapping(value = "specialTeamList", method = RequestMethod.POST)
    @ResponseBody
    public String specialTeamList(
            @ApiParam(name = "orgName", value = "机构名称")
            @RequestParam(value = "orgName", required = false) String orgName,
            @ApiParam(name = "teamName", value = "团队名称")
            @RequestParam(value = "teamName", required = false) String teamName,
            @ApiParam(name = "leaderName", value = "团队长")
            @RequestParam(value = "leaderName", required = false) String leaderName,
            @ApiParam(name = "memberName", value = "团队成员名")
            @RequestParam(value = "memberName", required = false) String memberName,
            @ApiParam(name = "memberMobile", value = "团队成员名电话")
            @RequestParam(value = "memberMobile", required = false) String memberMobile,
            @ApiParam(name = "page")
            @RequestParam(value = "page") int page,
            @ApiParam(name = "rows")
            @RequestParam(value = "rows") int rows) {
        try {
            //按医生code信息外查询,
            Page<WlyyAdminTeam> wlyyTeams = teamService.searchTeams(orgName, teamName, leaderName, memberName, memberMobile,1,page, rows);
            return writeToJson(200, "操作成功", page, rows, wlyyTeams);
        } catch (Exception ex) {
            error(ex);
            return error(-1, "操作失败");
        }
    }


    //获取某个机构下的所有团队
    @RequestMapping(value = "list", method = RequestMethod.POST)
    @ResponseBody
    public String searchTeams(
            @ApiParam(name = "orgCode", value = "机构编码")
            @RequestParam(value = "orgCode", required = false) String orgCode) {
        try {
            //按医生code信息外查询,
            List<WlyyAdminTeam> wlyyTeams = teamService.getByOrgCode(orgCode);
            return write(200, "操作成功", "list",wlyyTeams);
        } catch (Exception ex) {
            error(ex);
            return error(-1, "操作失败");
        }
    }

    //-----居民签约团队信息查询开始(团队信息、团队成员列表）-----
    @RequestMapping(value = "signTeamInfo/{adminTeamId}", method = RequestMethod.GET)
    public String initTeamPatientList(
            @ApiParam(name = "adminTeamId", value = "居民签约行政团队id")
            @PathVariable Long adminTeamId) throws Exception {
        ObjectMapper objectMapper = new ObjectMapper();
        WlyyAdminTeam team = teamService.findById(adminTeamId);
        team = teamService.searchOrgName(team);
        request.setAttribute("teamInfo", objectMapper.writeValueAsString(team));
        request.setAttribute("adminTeamId", adminTeamId);
        return "sign/sign_team_info";
    }

    @RequestMapping(value = "signTeamInfo", method = RequestMethod.POST)
    @ResponseBody
    public String signTeamInfo(
            @ApiParam(name = "teamId", value = "居民签约行政团队id")
            @RequestParam(value = "teamId", required = true) Long teamId) {
        try {
            WlyyAdminTeam signTeamInfo = teamService.getSignTeamInfo(teamId);
            return write(200, "操作成功", "data", signTeamInfo);
        } catch (Exception ex) {
            error(ex);
            return error(-1, "操作失败");
        }
    }



    //修改团队状态
    @RequestMapping(value = "updateStatus", method = RequestMethod.POST)
    @ResponseBody
    public String updateTeamStatus(
            @ApiParam(name = "id", value = "团队id")
            @RequestParam(value = "id", required = true) Long id,
            @ApiParam(name = "available", value = "修改状态值 1,0")
            @RequestParam(value = "available") String available) {
        try {
            boolean res = teamService.updateStatus(available, id);
            if (!res) {
                return error(-1, "操作失败！");
            }
            return write(200, "操作成功");
        } catch (Exception ex) {
            error(ex);
            return error(-1, "操作失败！");
        }
    }

    //查看团队信息
    @RequestMapping(value = "teamInfo/{id}", method = RequestMethod.GET)
    public String teamInfoPage(
            @ApiParam(name = "id", value = "团队id")
            @PathVariable(value = "id") Long id) {
        request.setAttribute("id", id);
        return "team/doctor/team_info";
    }

    //查看专科团队信息
    @RequestMapping(value = "teamInfo/zk/{id}", method = RequestMethod.GET)
    public String zkTeamInfoPage(
            @ApiParam(name = "id", value = "团队id")
            @PathVariable(value = "id") Long id) {
        request.setAttribute("id", id);
        return "team/doctor/zk_team_info";
    }

    @RequestMapping(value = "teamInfo", method = RequestMethod.POST)
    @ResponseBody
    public String teamInfo(
            @ApiParam(name = "id", value = "团队id")
            @RequestParam(value = "id") Long id) {
        try {
            WlyyAdminTeam team = teamService.findById(id);
            return write(200, "操作成功", "data", team);
        } catch (Exception ex) {
            error(ex);
            return error(-1, "操作失败");
        }
    }



    //同步团队
    @RequestMapping(value = "loadTeamInfo", method = RequestMethod.POST)
    @ResponseBody
    public String loadTeamInfo() {
        try {
            String res = HttpUtil.sendPost(loadTeamInfoUrl, "");
            if (!StringUtils.isEmpty(res)) {
                return write(200, "操作成功");
            }
            return write(-1, "操作失败");
        } catch (Exception ex) {
            error(ex);
            return error(-1, "系统异常");
        }
    }

    //团队成员列表页（不分页查询）
    @RequestMapping(value = "memberList/{teamId}", method = RequestMethod.GET)
    public String memberListPage(
            @ApiParam(name = "teamId", value = "团队Id")
            @PathVariable Long teamId) {
        request.setAttribute("teamId", teamId);
        return "team/doctor/team_member_list";

    }

    @RequestMapping(value = "memberList", method = RequestMethod.POST)
    @ResponseBody
    public String memberList(
            @ApiParam(name = "teamId", value = "团队Id")
            @RequestParam(value = "teamId") Long teamId,
            @ApiParam(name = "doctorCode", value = "医生编码")
            @RequestParam(value = "doctorCode", required = false) String doctorCode) {
        try {
            List<WlyyAdminTeamMember> members = teamMemberService.searchTeamMembers(teamId, doctorCode);
            return write(200, "操作成功", "detailModelList", members);
        } catch (Exception ex) {
            error(ex);
            return error(200, "操作失败");
        }
    }

    //团队成员信息
    @RequestMapping(value = "memberInfo/{doctorCode}", method = RequestMethod.GET)
    public String memberInfoPage(
            @ApiParam(name = "doctorCode", value = "团队医生编码")
            @PathVariable String doctorCode) {
        request.setAttribute("doctorCode", doctorCode);
        return "team/doctor/member_info";
    }

    @RequestMapping(value = "memberInfo", method = RequestMethod.POST)
    @ResponseBody
    public String memberInfo(
            @ApiParam(name = "doctorCode", value = "团队医生编码")
            @RequestParam(value = "doctorCode") String doctorCode) {
        try {
            Doctor doctor = doctorService.getDoctorByCode(doctorCode);
            return write(200, "操作成功", "data", doctor);
        } catch (Exception ex) {
            error(ex);
            return error(-1, "操作失败！");

        }
    }

    public String writeToJson(int code, String errorMsg, int page, int rows, Page<WlyyAdminTeam> list) {
        try {
            Map<Object, Object> map = new HashMap<Object, Object>();
            ObjectMapper mapper = new ObjectMapper();
            map.put("successFlg", code == 0);
            map.put("errorMsg", errorMsg);
            // 是否为第一页
            map.put("errorCode", code);
            // 是否为最后一页
            map.put("currPage", page);
            // 分页大小
            map.put("pageSize", rows);
            // 总条数
            map.put("totalCount", list.getTotalElements());
            // 总页数
            map.put("totalPage", list.getTotalPages());
            List<WlyyAdminTeam> teamList = list.getContent();
            if (teamList != null && teamList.size() > 0) {
                for (WlyyAdminTeam team : teamList) {
                    team = teamService.searchOrgName(team);

                }
            }
            // 结果集
            map.put("detailModelList", teamList);
            return mapper.writeValueAsString(map);
        } catch (Exception e) {
            error(e);
            return error(-1, "服务器异常，请稍候再试！");
        }
    }


    //获取团队成员下拉列表框（类型：专科1，全科2，健管师3
    @RequestMapping(value = "memberCodes", method = RequestMethod.POST)
    @ResponseBody
    public String searchMemberCodes(
            @RequestParam(value = "teamId", required = true) Long teamId,
            @RequestParam(value = "doctorLevel", required = true) Integer[] doctorLevel) {//逗号隔开：如 1,2,3
        try {
            if (doctorLevel.length < 0) {
                return error(-1, "医生角色类型不能为空");
            }
//            String[] level = doctorLevel.split(",");
            List<Doctor> members = teamMemberService.searchTeamMemberCodes(teamId, doctorLevel);
            return write(200, "操作成功", "detailModelList", members);
        } catch (Exception ex) {
            error(ex);
            return error(-1, "操作失败");
        }
    }

    @RequestMapping(value = "importData", method = RequestMethod.POST, produces = "application/json;charset=UTF-8")
    @ResponseBody
    public String importData(HttpServletRequest request) {
        try {
            request.setCharacterEncoding("UTF-8");
            InputStream inputStream = request.getInputStream();
            Workbook workbook = Workbook.getWorkbook(inputStream);

            teamService.importData(workbook);

            return write(200, "操作成功");
        } catch (IOException | BiffException e) {
            e.printStackTrace();
            error(e);
            return error(-1, "操作失败！");
        }
    }

    //修改团队下转信息
    @RequestMapping(value = "updateTeamAcceptInfor", method = RequestMethod.POST)
    @ResponseBody
    public String updateTeamAcceptInfor(
            @ApiParam(name = "teamId", value = "团队id")
            @RequestParam(value = "teamId") Long teamId,
            @ApiParam(name = "leaderCode", value = "团队长code")
            @RequestParam(value = "leaderCode") String leaderCode,
            @ApiParam(name = "specialCode", value = "专病code")
            @RequestParam(value = "specialCode") String specialCode,
            @ApiParam(name = "specialName", value = "专病名称")
            @RequestParam(value = "specialName") String specialName,
            @ApiParam(name = "acceptType", value = "是否下转 1接收 0拒绝 ")
            @RequestParam(value = "acceptType") Integer acceptType
    ) {
        try {
            Boolean stateType = teamService.updateTeamAcceptInfor(teamId, leaderCode, specialCode, specialName, acceptType);
            if(stateType){
                return write(200, "操作成功");
            }
            else{
                return write(-1, "该病种已有团队接受,无法重复接受");
            }
        } catch (Exception ex) {
            error(ex);
            return error(-1, "操作失败");
        }
    }

}
