package  com.yihu.customer.controller.manager.vaccin;

import  com.yihu.customer.controller.BaseController;
import com.yihu.customer.vaccin.VaccinService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.http.MediaType;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

/**
 * Created by wxw on 2019/1/14.
 *
 * @author wxw.
 */
@Controller
@RequestMapping(value = "/admin/vaccin", produces = MediaType.APPLICATION_JSON_UTF8_VALUE)
@Api(description = "国家疫苗信息")
public class VaccinController extends BaseController {
    @Autowired
    private VaccinService vaccinService;

    @RequestMapping(value = "/initial",method = RequestMethod.GET)
    public String ReplyHis () {
        return "vaccin/vaccin_list";
    }

    @RequestMapping(value = "/searchPageList", method = {RequestMethod.GET, RequestMethod.POST})
    @ApiOperation(value = "获取文章列表")
    @ResponseBody
    public String searchPageList(
            @ApiParam(name = "discriminateCode", value = "识别码")
            @RequestParam(value = "discriminateCode", required = false) String discriminateCode,
            @ApiParam(name = "name", value = "疫苗名称")
            @RequestParam(value = "name", required = false) String name,
            @ApiParam(name = "subtitle", value = "副标题")
            @RequestParam(value = "subtitle", required = false) String subtitle,
            @ApiParam(name = "type", value = "1一类 2二类")
            @RequestParam(value = "type", required = false) String type,
            @ApiParam(name = "page", value = "第几页，从1开始", required = true, defaultValue = "1")
            @RequestParam(value = "page", required = true,defaultValue = "1")Integer page,
            @ApiParam(name = "rows", value = "每页分页大小", required = true, defaultValue = "10")
            @RequestParam(value = "rows", required = true,defaultValue = "10")Integer rows) {
        try {
            Page result = vaccinService.searchPageList(discriminateCode, name, subtitle, type, page, rows);
            return write(200,"获取成功", page, rows, result.getTotalElements(), result.getContent());
        } catch (Exception e) {
            e.printStackTrace();
            return write(-1, "获取失败！");
        }
    }
}
