package  com.yihu.customer.controller.manager.yueren;

import  com.yihu.customer.controller.BaseController;
import com.yihu.customer.service.manager.medicine.WlyyMedicineKeyService;
import com.yihu.customer.util.HttpManageClientUtil;
import io.swagger.annotations.Api;
import org.json.JSONException;
import org.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.core.io.FileSystemResource;
import org.springframework.stereotype.Controller;
import org.springframework.util.LinkedMultiValueMap;
import org.springframework.util.MultiValueMap;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.client.RestTemplate;
import org.springframework.web.multipart.MultipartFile;

import java.io.File;
import java.io.IOException;


/**
 * Created by Administrator on 2017/8/14.
 */
@Controller
@RequestMapping("/yueren")
@Api(description = "调用越人接口")
public class YueRenController extends BaseController {

    @Value("${yueren.api}")
    private String api;

    @Autowired
    private WlyyMedicineKeyService wlyyMedicineKeyService;
    //--预约模块 begin
    /**
     * 获取每个接口需要传递的key值
     * @return
     */
    @RequestMapping(value = "/phonekey", method = RequestMethod.POST, produces = "application/json;charset=UTF-8")
    @ResponseBody
    public String getPhoneKey() throws JSONException {
        String key =wlyyMedicineKeyService.getKey();
        return  write(200,"查询成功","key",key);
    }

    /**
     * 新增客户咨询预约单，如果是新客人，同时新增客户信息
     * @param jsonString
     * @return
     */
    @RequestMapping(value = "insertslip", method = RequestMethod.POST, produces = "application/json;charset=UTF-8")
    @ResponseBody
    public String insertSlip(@RequestBody String jsonString) throws JSONException {
        JSONObject params = new JSONObject(jsonString);
        params.put("key",wlyyMedicineKeyService.getKey());
        String postStr = remoteCall("/yueren/insertslip", params);
        return postStr;
    }
    //--预约模块 end

    //--四诊模块 begin

    /**
     * 上传图片音频等附件
     * @param file
     * @return
     */
    @RequestMapping(value = "/uploadattachment", method = RequestMethod.POST, produces = "application/json;charset=UTF-8")
    @ResponseBody
    public String uploadAttachment(@RequestParam MultipartFile file) {
        MultiValueMap<String, Object> param = new LinkedMultiValueMap<>();
        String fileName = file.getOriginalFilename();
        String filePath =this.getClass().getResource("/").getPath() + "temp/" + System.currentTimeMillis() + fileName;
        File dest = new File(filePath);
        if (!dest.getParentFile().exists()) {
            dest.getParentFile().mkdirs();
        }
        try {
            file.transferTo(dest);
            RestTemplate rest = new RestTemplate();
            FileSystemResource resource = new FileSystemResource(filePath);
            param.add("file", resource);
            String postStr = rest.postForObject(api + "/yueren/uploadattachment", param, String.class);
            if (dest.exists() && dest.isFile()) {
                dest.delete();
            }
            return postStr;
        } catch (IOException e) {
            e.printStackTrace();
        }
        return "{\"status\":500,\"exception\":\"上传文件出错\"}";
    }

    /**
     * 处理头像舌苔声音
     * @param jsonString
     * @return
     */
    @RequestMapping(value = "dillphoneimgdata", method = RequestMethod.POST, produces = "application/json;charset=UTF-8")
    @ResponseBody
    public String inserTemp(@RequestBody String jsonString) throws JSONException {
        String key = wlyyMedicineKeyService.getKey();
        JSONObject params = new JSONObject(jsonString);
        params.put("key",key);
        String answer = params.get("answer").toString();
        params.put("answer","/attach/{{key}}/"+answer);
        String postStr = remoteCall("/yueren/dillphoneimgdata", params);
        return postStr;
    }
    //--四诊模块 end

    //--答题模块 begin
    /**
     * 查找试卷
     * @param jsonString
     * @return
     */
    @RequestMapping(value = "findtest", method = RequestMethod.POST, produces = "application/json;charset=UTF-8")
    @ResponseBody
    public String findTest(@RequestBody String jsonString) throws JSONException {
        JSONObject params = new JSONObject(jsonString);
        params.put("key",wlyyMedicineKeyService.getKey());
        String postStr = remoteCall("/yueren/findtest", params);
        return postStr;
    }

    /**
     * 查找试卷题目
     * @param jsonString
     * @return
     */
    @RequestMapping(value = "giveproblem", method = RequestMethod.POST, produces = "application/json;charset=UTF-8")
    @ResponseBody
    public String giveproblem(@RequestBody String jsonString) throws JSONException {
        JSONObject params = new JSONObject(jsonString);
        params.put("key",wlyyMedicineKeyService.getKey());
        String postStr = remoteCall("/yueren/giveproblem", params);
        return postStr;
    }

    /**
     * 将用户提交的试卷题目的答案进行保存
     * @param jsonString
     * @return 将用户提交的试卷题目的答案进行保存
     */
    @RequestMapping(value = "handleproblem", method = RequestMethod.POST, produces = "application/json;charset=UTF-8")
    @ResponseBody
    public String handleproblem(@RequestBody String jsonString) throws JSONException {
        JSONObject params = new JSONObject(jsonString);
        params.put("key",wlyyMedicineKeyService.getKey());
        String postStr = remoteCall("/yueren/handleproblem", params);
        return postStr;
    }

    /**
     * 将用户提交的试卷题目的答案进行处理
     * @param jsonString
     * @return
     */
    @RequestMapping(value = "centralizedproblem", method = RequestMethod.POST, produces = "application/json;charset=UTF-8")
    @ResponseBody
    public String centralizedproblem(@RequestBody String jsonString) throws JSONException {
        JSONObject params = new JSONObject(jsonString);
        params.put("key",wlyyMedicineKeyService.getKey());
        String postStr = remoteCall("/yueren/centralizedproblem", params);
        return postStr;
    }

    /**
     * 在生成报告单之前，必须调用这个接口，将风险预警中的因素中的所有病处理到影响中
     * @param jsonString
     * @return
     */
    @RequestMapping(value = "conclusionfactor", method = RequestMethod.POST, produces = "application/json;charset=UTF-8")
    @ResponseBody
    public String conclusionFactor(@RequestBody String jsonString) throws JSONException {
        JSONObject params = new JSONObject(jsonString);
        params.put("key",wlyyMedicineKeyService.getKey());
        String postStr = remoteCall("/yueren/conclusionfactor", params);
        return postStr;
    }
    //--答题模块 end

    //--报告单模块 begin
    /**
     * 生成报告单
     * @param jsonString
     * @return
     */
    @RequestMapping(value = "insertconconhealth", method = RequestMethod.POST, produces = "application/json;charset=UTF-8")
    @ResponseBody
    public String insertConsultConclusionHealth(@RequestBody String jsonString) throws JSONException {
        JSONObject params = new JSONObject(jsonString);
        params.put("key",wlyyMedicineKeyService.getKey());
        String postStr = remoteCall("/yueren/insertconconhealth", params);
        return postStr;
    }

    /**
     * 查找报告单结论
     * @param jsonString
     * @return
     */
    @RequestMapping(value = "findconconhealth", method = RequestMethod.POST, produces = "application/json;charset=UTF-8")
    @ResponseBody
    public String insertConsultConclusion(@RequestBody String jsonString) throws JSONException {
        JSONObject params = new JSONObject(jsonString);
        params.put("key",wlyyMedicineKeyService.getKey());
        String postStr = remoteCall("/yueren/findconconhealth", params);
        return postStr;
    }

    /**
     * 查找状态要素结论积分图及个人信息
     * @param jsonString
     * @return
     */
    @RequestMapping(value = "findintegral", method = RequestMethod.POST, produces = "application/json;charset=UTF-8")
    @ResponseBody
    public String findIntegral(@RequestBody String jsonString) throws JSONException {
        JSONObject params = new JSONObject(jsonString);
        params.put("key",wlyyMedicineKeyService.getKey());
        String postStr = remoteCall("/yueren/findintegral", params);
        return postStr;
    }

    private String remoteCall(String url, JSONObject jsonDate) {
        try {
            String result = HttpManageClientUtil.postBody(api + url, jsonDate);
            return result;
        } catch (Exception e) {
            e.printStackTrace();
            return "{\"status\":500,\"exception\":\"连接出错\"}";
        }
    }

    public void saveKey(String key) {
        wlyyMedicineKeyService.saveKey(key);
    }
}