package  com.yihu.customer.controller.synergy.customer;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import  com.yihu.customer.controller.BaseController;
import com.yihu.customer.service.synergy.QuestionnaireManageService;
import com.yihu.customer.service.synergy.SynergyManageService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import jxl.Workbook;
import jxl.write.Label;
import jxl.write.WritableSheet;
import jxl.write.WritableWorkbook;
import jxl.write.WriteException;
import org.apache.commons.collections.map.HashedMap;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.OutputStream;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * 客服端问卷调查
 * Created by Humingfen on 2018/9/29.
 */
@RestController
@RequestMapping(value = "/customer/question", produces = MediaType.APPLICATION_JSON_UTF8_VALUE)
@Api(description = "客服端-调查问卷协同服务")
public class CustomerQuestionnaireController extends BaseController {

    @Autowired
    private QuestionnaireManageService questionnaireService;
    @Autowired
    private SynergyManageService synergyManageService;

    @RequestMapping(value = "saveAnswer", method = RequestMethod.POST)
    @ApiOperation(value = "保存用户答案")
    public String saveAnswer( @ApiParam(value = "问卷题目及选项")@RequestParam String jsonData,
                              @ApiParam(value = "客服code")@RequestParam(value = "customerCode", required = true)String customerCode,
                              @ApiParam(value = "居民code")@RequestParam(value = "patientCode", required = true)String patientCode,
                              @ApiParam(value = "问卷标签（疾病筛查问卷要传5，调查问卷传4）")@RequestParam(value = "labelType", required = false)Integer labelType,
                              @ApiParam(value = "来源（1医生发放 2居民自我评估）")@RequestParam(value = "source", required = false, defaultValue = "1")Integer source,
                              @ApiParam(value = "协同工单服务对象表code", required = true)@RequestParam(value = "serviceCode", required = true)String serviceCode) {
        try {
            return  write(200, "保存成功！", "data", questionnaireService.saveResultAndAnswer(patientCode, labelType, customerCode, source,jsonData, serviceCode));
        } catch (Exception e) {
            e.printStackTrace();
            return write(-1, "保存失败！");
        }
    }

    @RequestMapping(value = "getAnswers", method = RequestMethod.GET)
    @ApiOperation(value = "查看调查统计结果")
    public String getAnswers(@ApiParam(value = "问卷code", required = true) @RequestParam String surveyCode) {
        try {
            return write(200, "查询成功!", "data", questionnaireService.getAnswers(surveyCode));
        } catch (Exception e) {
            e.printStackTrace();
            return write(-1, "查询失败!");
        }
    }

    @RequestMapping(value = "getResult", method = RequestMethod.GET)
    @ApiOperation(value = "查看客服对居民调查问卷结果")
    public String getResult(@ApiParam(value = "调查结果code") @RequestParam String questionResultCode) {
        try {
            return write(200, "查询成功!", "data", questionnaireService.getReuslt(questionResultCode));
        } catch (Exception e) {
            e.printStackTrace();
            return write(-1, "查询失败!");
        }
    }

    @RequestMapping(value = "getQuestionnaireDetail", method = RequestMethod.GET)
    @ApiOperation(value = "查看调查问卷内容")
    public String getQuestionnaireDetail(@ApiParam(value = "调查问卷code") @RequestParam String surveyCode) {
        try {
            com.alibaba.fastjson.JSONObject jsonObject = questionnaireService.getQuestionnaireDetail(surveyCode);
            return write(200, "查询成功!", "data", jsonObject);
        } catch (Exception e) {
            e.printStackTrace();
            return write(-1, "查询失败!");
        }
    }

    @RequestMapping(value = "getOptionsComment", method = RequestMethod.GET)
    @ApiOperation(value = "获取调查结果")
    public String getOptionsComment(@RequestParam int pageNo,
                                    @RequestParam int pageSize,
                                    @ApiParam(value = "问卷code")
                                        @RequestParam String surveyCode,
                                    @ApiParam(value = "题目code")
                                        @RequestParam String questionCode,
                                    @ApiParam(value = "选项code")
                                        @RequestParam(required = false) String optionCode) {
        try {
            return write(200, "查询成功!", "data", questionnaireService.getOptionsComment(surveyCode, questionCode, optionCode, pageNo, pageSize));
        } catch (Exception e) {
            e.printStackTrace();
            return write(-1, "查询失败!");
        }
    }

    @RequestMapping(value = "isNotException", method = RequestMethod.POST)
    @ApiOperation(value = "判断是否异常通话")
    public String isNotException(@ApiParam(value = "协同服务工单code") @RequestParam String workorderCode,
                                 @ApiParam(value = "客服code") @RequestParam String customerCode) {
        try {
            return write(200, "查询成功!", "data", synergyManageService.isNotException(workorderCode, customerCode));
        } catch (Exception e) {
            e.printStackTrace();
            return write(-1, "查询失败!");
        }
    }

    @RequestMapping(value = "loadingInfo", method = RequestMethod.GET)
    @ApiOperation(value = "载入异常通话居民信息")
    public String loadingInfo(@ApiParam(value = "协同服务对象code") @RequestParam String workorderServiceCode) {
        try {
            return write(200, "查询成功!", "data", synergyManageService.loadingInfo(workorderServiceCode));
        } catch (Exception e) {
            e.printStackTrace();
            return write(-1, "查询失败!");
        }
    }

    @RequestMapping(value = "statics", method = RequestMethod.GET)
    @ApiOperation(value = "问卷")
    public String statics(@ApiParam(value = "问卷code") @RequestParam String code) {
        try {
            return write(200, "查询成功!", "data", questionnaireService.getQuestionOption(code));
        } catch (Exception e) {
            e.printStackTrace();
            return write(-1, "查询失败!");
        }
    }


    @RequestMapping(value = "/surveyOutExcel", produces = "application/json;charset=UTF-8")
    @ResponseBody
    public void outExcel(HttpServletResponse response,
                         @RequestParam(required = true) String code) {
        try {
            Map<String,Object> map = questionnaireService.getQuestionOption(code);
            JSONArray array = new JSONArray();
            JSONArray jsonArray = new JSONArray();
            if (map!=null&&map.size()!=0){
                array = JSONArray.parseArray(map.get("title").toString());
                jsonArray = JSONArray.parseArray(map.get("jsonArray").toString());
            }
            //基本设置
            response.setContentType("application/vnd.ms-excel");
            String fileName = "问卷调查明细表导出";
            SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMdd");
            Date date = new Date();
            response.setHeader("Content-Disposition", "attachment; filename="
                    + new String(fileName.getBytes("UTF-8"), "ISO8859-1") + "_" + sdf.format(date) + ".xls");
            OutputStream os = response.getOutputStream();
            //处理Excel
            WritableWorkbook book = Workbook.createWorkbook(os);
            WritableSheet sheet = book.createSheet("问卷调查明细表", 0);
            sheet.addCell(new Label(0, 0, "居民姓名"));
            sheet.addCell(new Label(1, 0, "性别"));
            sheet.addCell(new Label(2, 0, "电话"));
            sheet.addCell(new Label(3, 0, "签约机构"));
            sheet.addCell(new Label(4, 0, "签约医生"));
            sheet.addCell(new Label(5, 0, "服务类型"));
            List<Map<String,Object>> maps = new ArrayList<>();
            for (int i=0;i<array.size();i++){
                JSONObject object = array.getJSONObject(i);
                sheet.addCell(new Label(6+i, 0, object.getString("title")));
                Map<String,Object> map1 = new HashedMap();
                map1.put("sort",6+i);
                map1.put("code",object.getString("code"));
                maps.add(map1);
            }
            if (null != jsonArray && jsonArray.size() > 0) {
                for(int i = 0; i< jsonArray.size(); i ++) {
                    JSONObject object = jsonArray.getJSONObject(i);
                    sheet.addCell(new Label(0, i+1, object.getString("name")));
                    sheet.addCell(new Label(1, i+1, object.getString("sex")));
                    sheet.addCell(new Label(2, i+1, object.getString("mobile")));
                    sheet.addCell(new Label(3, i+1, object.getString("hospitalName")));
                    sheet.addCell(new Label(4, i+1, object.getString("doctorName")));
                    sheet.addCell(new Label(5, i+1, object.getString("serverType")));
                    JSONArray array1 = object.getJSONArray("questions");
                    for (int j=0;j<array1.size();j++){
                        JSONObject object1 = array1.getJSONObject(j);
                        for (Map<String,Object> map1:maps){
                            if (object1.getString("questionCode").equals(map1.get("code").toString())){
                                sheet.addCell(new Label(Integer.parseInt(map1.get("sort").toString()), i+1, object1.getString("sort")));
                            }
                        }
                    }

                }
            }
            maps.clear();
            book.write();
            book.close();
            os.flush();
            os.close();
        } catch (IOException e) {
            e.printStackTrace();
        } catch (WriteException e) {
            e.printStackTrace();
        } catch (Exception e) {
            e.printStackTrace();
        }

    }
}
