package  com.yihu.customer.controller.synergy.customer;

import  com.yihu.customer.controller.BaseController;
import com.yihu.customer.service.synergy.ScreenResultManageService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

/**
 * 客服端疾病筛查
 * Created by Humingfen on 2018/9/29.
 */
@RestController
@RequestMapping(value = "/customer/screen", produces = MediaType.APPLICATION_JSON_UTF8_VALUE)
@Api(description = "客服端-疾病筛查协同服务")
public class CustomerScreenResultController extends BaseController {

    @Autowired
    private ScreenResultManageService screenResultService;

    @RequestMapping(value = "getScreenResultDetail", method = RequestMethod.GET)
    @ApiOperation(value = "获取筛查结果记录详情")
    public String getScreenResultDetail(@ApiParam(value = "筛查结果唯一code")@RequestParam(value = "code") String code) {
        try {
            return write(200, "获取成功!", "data", screenResultService.getScreenResultDetail(code));
        } catch (Exception e) {
            e.printStackTrace();
            return write(-1, "获取失败!");
        }
    }

    @RequestMapping(value = "getQuestions", method = RequestMethod.GET)
    @ApiOperation(value = "获取筛查问卷详情")
    public String getScreenDetail(@ApiParam(value = "筛查问卷code")@RequestParam(value = "code") String templateCode) {
        try {
            return write(200, "获取成功!", "data", screenResultService.getScreenDetail(templateCode));
        } catch (Exception e) {
            e.printStackTrace();
            return write(-1, "获取失败!");
        }
    }
}
