package  com.yihu.customer.controller.synergy.customer;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import  com.yihu.customer.controller.BaseController;
import  com.yihu.customer.entity.Hospital;
import  com.yihu.customer.entity.User;
import  com.yihu.customer.entity.synergy.KnowledgeArticleDO;
import  com.yihu.customer.entity.synergy.KnowledgeCategoryDO;
import com.yihu.customer.service.common.district.DistrictService;
import com.yihu.customer.service.manager.hos.HosService;
import com.yihu.customer.service.synergy.KnowledgeArticleService;
import com.yihu.customer.service.synergy.KnowledgeCategoryService;
import  com.yihu.customer.repository.UserDao;
import com.yihu.customer.util.DateTimeUtil;
import com.yihu.customer.util.DateUtil;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.PageRequest;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.*;

import java.util.*;
import java.util.stream.Collectors;

/**
 * Created by wxw on 2018/12/26.
 *
 * @author wxw.
 */
@RestController
@RequestMapping(value = "/customer/article", produces = MediaType.APPLICATION_JSON_UTF8_VALUE)
@Api(description = "知识库-文章管理")
public class KnowledgeArticleController extends BaseController {
    @Autowired
    private KnowledgeArticleService articleService;
    @Autowired
    private DistrictService districtService;
    @Autowired
    private HosService hosService;
    @Autowired
    private KnowledgeCategoryService categoryService;
    @Autowired
    private UserDao userDao;

    @RequestMapping(value = "/searchPageList", method = RequestMethod.GET)
    @ApiOperation(value = "获取文章列表")
    public String searchPageList(
            @ApiParam(name = "category", value = "分类编码")
            @RequestParam(value = "category", required = false) String category,
            @ApiParam(name = "keyword", value = "分类编码")
            @RequestParam(value = "keyword", required = false) String keyword,
            @ApiParam(name = "start", value = "开始时间")
            @RequestParam(value = "start", required = false) String start,
            @ApiParam(name = "end", value = "结束时间")
            @RequestParam(value = "end", required = false) String end,
            @ApiParam(name = "page", value = "第几页，从1开始", required = true, defaultValue = "1")
            @RequestParam(value = "page", required = true,defaultValue = "1")Integer page,
            @ApiParam(name = "pageSize", value = "每页分页大小", required = true, defaultValue = "10")
            @RequestParam(value = "pageSize", required = true,defaultValue = "10")Integer pageSize) {
        try {
            StringBuffer sb = new StringBuffer();
            sb.append("del=1;");
            if (StringUtils.isNotEmpty(category)) {
                sb.append("category=").append(category).append(";");
            }
            if (StringUtils.isNotEmpty(keyword)) {
                sb.append("title?").append(keyword).append(" g1;").append("content?").append(keyword).append(" g1;");
            }
            if (StringUtils.isNotEmpty(start)) {
                Date startDate = DateUtil.strToDate(start, DateUtil.YYYY_MM_DD);
                sb.append("czrq>=").append(DateTimeUtil.utcDateTimeFormat(startDate)).append(";");
            }
            if (StringUtils.isNotEmpty(end)) {
                Date endDate = DateUtil.strToDate(end, DateUtil.YYYY_MM_DD);
                Calendar calendar = Calendar.getInstance();
                calendar.setTime(endDate);
                calendar.add(Calendar.DATE, 1);
                endDate = calendar.getTime();
                sb.append("czrq<").append(DateTimeUtil.utcDateTimeFormat(endDate)).append(";");
            }
            PageRequest pageRequest = PageRequest.of(page - 1, pageSize);
            List search = articleService.search("", sb.toString(), "-czrq", page, pageSize);
            List search1 = new ArrayList();
            for (int i=0;i<search.size();i++){
                Object object = search.get(i);
                JSONObject jsonObject = (JSONObject) JSON.toJSON(object);
                User user = userDao.findByCode(jsonObject.getString("patient"));
                jsonObject.put("name",user.getName());
                search1.add(jsonObject);
            }
            List searchCount = articleService.search(sb.toString());
            Page result = new PageImpl(search1, pageRequest, null != searchCount && searchCount.size() > 0 ? searchCount.size() : 0);
            return  write(200, "获取成功！", "data", result);
        } catch (Exception e) {
            e.printStackTrace();
            return write(-1, "获取失败！");
        }
    }

    @RequestMapping(value = "/searchKnowledgePageList", method = RequestMethod.GET)
    @ApiOperation(value = "获取文章列表")
    public String searchKnowledgePageList(
            @ApiParam(name = "keyword", value = "分类编码")
            @RequestParam(value = "keyword", required = false) String keyword,
            @ApiParam(name = "applyOrg", value = "适用社区")
            @RequestParam(value = "applyOrg", required = false) String applyOrg,
            @ApiParam(name = "patient", value = "用户code", required = true)
            @RequestParam(value = "patient", required = true, defaultValue = "xx") String patient,
            @ApiParam(name = "page", value = "第几页，从1开始", required = true, defaultValue = "1")
            @RequestParam(value = "page", required = true,defaultValue = "1")Integer page,
            @ApiParam(name = "pageSize", value = "每页分页大小", required = true, defaultValue = "10")
            @RequestParam(value = "pageSize", required = true,defaultValue = "10")Integer pageSize) {
        try {
            StringBuffer sb = new StringBuffer();
            StringBuffer category = new StringBuffer();
            sb.append("del=1;");
            category.append("del=1;");
            if (StringUtils.isNotEmpty(keyword)) {
                List<String> list = Arrays.asList(keyword.split(","));
                for (String key : list) {
                    sb.append("title?").append(key).append(" g1;").append("content?").append(key).append(" g1;");
                    category.append("name?").append(key).append(" g1;");
                }
                List<KnowledgeCategoryDO> categoryList = categoryService.search(category.toString());
                Set<String> codes = categoryList.stream().map(KnowledgeCategoryDO::getCode).collect(Collectors.toSet());
                if (null != codes && codes.size() > 0) {
                    String join = StringUtils.join(codes, ",");
                    sb.append("category=").append(join).append(" g1;");
                }
            }
            if (StringUtils.isNotEmpty(applyOrg)) {
                sb.append("applyOrg?").append(applyOrg).append(";");
            }
            PageRequest pageRequest = PageRequest.of(page - 1, pageSize);
            List search = articleService.search("", sb.toString(), "-czrq", page, pageSize);
            List search1 = new ArrayList();
            for (int i=0;i<search.size();i++){
                Object object = search.get(i);
                JSONObject jsonObject = (JSONObject) JSON.toJSON(object);
                User user = userDao.findByCode(jsonObject.getString("patient"));
                jsonObject.put("name",user.getName());
                search1.add(jsonObject);
            }
            List searchCount = articleService.search(sb.toString());
            Page result = new PageImpl(search1, pageRequest, null != searchCount && searchCount.size() > 0 ? searchCount.size() : 0);
            return  write(200, "获取成功！", "data", result);
        } catch (Exception e) {
            e.printStackTrace();
            return write(-1, "获取失败！");
        }
    }

    @RequestMapping(value = "/searchMyPageList", method = RequestMethod.GET)
    @ApiOperation(value = "获取我的文章列表")
    public String searchMyPageList(
            @ApiParam(name = "category", value = "分类编码")
            @RequestParam(value = "category") String category,
            @ApiParam(name = "keyword", value = "分类编码")
            @RequestParam(value = "keyword") String keyword,
            @ApiParam(name = "start", value = "开始时间")
            @RequestParam(value = "start") String start,
            @ApiParam(name = "end", value = "结束时间")
            @RequestParam(value = "end") String end,
            @ApiParam(name = "applyOrg", value = "适用社区")
            @RequestParam(value = "applyOrg", required = false) String applyOrg,
            @ApiParam(name = "patient", value = "用户code", required = true)
            @RequestParam(value = "patient", required = true, defaultValue = "xx") String patient,
            @ApiParam(name = "page", value = "第几页，从1开始", required = true, defaultValue = "1")
            @RequestParam(value = "page", required = true,defaultValue = "1")Integer page,
            @ApiParam(name = "pageSize", value = "每页分页大小", required = true, defaultValue = "10")
            @RequestParam(value = "pageSize", required = true,defaultValue = "10")Integer pageSize) {
        try {
            StringBuffer sb = new StringBuffer();
            sb.append("del=1;");
            if (StringUtils.isNotEmpty(category)) {
                sb.append("category=").append(category).append(";");
            }
            if (StringUtils.isNotEmpty(keyword)) {
                sb.append("title?").append(keyword).append(" g1;").append("content?").append(keyword).append(" g1;");
            }
            if (StringUtils.isNotEmpty(start)) {
                Date startDate = DateUtil.strToDate(start, DateUtil.YYYY_MM_DD);
                sb.append("czrq>=").append(DateTimeUtil.utcDateTimeFormat(startDate)).append(";");
            }
            if (StringUtils.isNotEmpty(end)) {
                Date endDate = DateUtil.strToDate(end, DateUtil.YYYY_MM_DD);
                Calendar calendar = Calendar.getInstance();
                calendar.setTime(endDate);
                calendar.add(Calendar.DATE, 1);
                endDate = calendar.getTime();
                sb.append("czrq<").append(DateTimeUtil.utcDateTimeFormat(endDate)).append(";");
            }
            if (StringUtils.isNotEmpty(applyOrg)) {
                sb.append("applyOrg?").append(applyOrg).append(";");
            }
            if (StringUtils.isEmpty(patient)) {
                sb.append("patient=-1;");
            } else {
                sb.append("patient=").append(patient).append(";");
            }
            PageRequest pageRequest = PageRequest.of(page - 1, pageSize);
            List search = articleService.search("", sb.toString(), "-czrq", page, pageSize);
            List searchCount = articleService.search(sb.toString());
            Page result = new PageImpl(search, pageRequest, null != searchCount && searchCount.size() > 0 ? searchCount.size() : 0);
            return  write(200, "获取成功！", "data", result);
        } catch (Exception e) {
            e.printStackTrace();
            return write(-1, "获取失败！");
        }
    }

    @RequestMapping(value = "/queryById", method = RequestMethod.GET)
    @ApiOperation(value = "根据id查询文章")
    public String queryByCode(
            @ApiParam(name = "id", value = "id", required = true)
            @RequestParam(value = "id", required = true)Long id) {
        try {
            KnowledgeArticleDO articleDO = articleService.findById(id);
            return  write(200, "获取成功！", "data", articleDO);
        } catch (Exception e) {
            e.printStackTrace();
            return write(-1, "获取失败！");
        }
    }

    @RequestMapping(value = "/queryOneById", method = RequestMethod.GET)
    @ApiOperation(value = "根据id查询文章详情")
    public String queryOneById(
            @ApiParam(name = "id", value = "id", required = true)
            @RequestParam(value = "id", required = true)Long id) {
        try {
            KnowledgeArticleDO articleDO = articleService.queryOneById(id);
            return  write(200, "获取成功！", "data", articleDO);
        } catch (Exception e) {
            e.printStackTrace();
            return write(-1, "获取失败！");
        }
    }

    @RequestMapping(value = "/deleteById", method = RequestMethod.GET)
    @ApiOperation(value = "根据id删除文章")
    public String DeleteById(
            @ApiParam(name = "id", value = "id，多个使用英文逗号分隔", required = true)
            @RequestParam(value = "id", required = true)String id) {
        try {
            articleService.delArticle(id);
            return  write(200, "删除成功！");
        } catch (Exception e) {
            e.printStackTrace();
            return write(-1, "删除失败！");
        }
    }

    @RequestMapping(value = "/updateArticle",method = RequestMethod.POST)
    @ApiOperation("更新客服文章")
    public String updateArticle(String json) {
        try {
            articleService.updateArticle(json);
            return write(200, "更新成功");
        } catch (Exception ex) {
            error(ex);
            return error(-1, "更新失败");
        }
    }

    @RequestMapping(value = "/hospitalsTree", method = RequestMethod.GET)
    @ApiOperation("查询机构树接口")
    public String hospitalsTree() {
        try {
            List<Map<String, Object>> list = articleService.hospitalsTree("");
            return write(200, "获取成功","data", list);
        } catch (Exception ex) {
            error(ex);
            return error(-1, "获取失败");
        }
    }

    @RequestMapping(value = "/hospitalsByCity", method = RequestMethod.GET)
    @ApiOperation("根据区域查询机构")
    public String hospitalsByCity(@RequestParam(value = "code", required = true) String code) {
        try {
            List<Hospital> hospitalList = hosService.getHospitalByType(1, code);
            return write(200, "获取成功","data", hospitalList);
        } catch (Exception ex) {
            error(ex);
            return error(-1, "获取失败");
        }
    }

    @RequestMapping(value = "/getHospitalList", method = RequestMethod.GET)
    @ApiOperation("模糊查询机构")
    public String getHospitalList(@RequestParam(value = "name", required = false) String name) {
        try {
            List<Hospital> hospitals = hosService.searchHospitalNoPage(name,null);
            return write(200, "获取成功","data", hospitals);
        } catch (Exception ex) {
            error(ex);
            return error(-1, "获取失败");
        }
    }
}
