package  com.yihu.customer.controller.synergy.customer;

import  com.yihu.customer.controller.BaseController;
import  com.yihu.customer.entity.synergy.KnowledgeCategoryDO;
import com.yihu.customer.service.synergy.KnowledgeCategoryService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.PageRequest;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.*;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by wxw on 2018/12/26.
 *
 * @author wxw.
 */
@RestController
@RequestMapping(value = "/customer/category", produces = MediaType.APPLICATION_JSON_UTF8_VALUE)
@Api(description = "知识库-分类管理")
public class KnowledgeCategoryController extends BaseController {
    @Autowired
    private KnowledgeCategoryService service;

    @RequestMapping(value = "/saveCategory", method = RequestMethod.POST)
    @ApiOperation(value = "新增、修改分类")
    public String saveCategory(String json) {
        try {
            KnowledgeCategoryDO knowledgeCategoryDO = service.saveCategory(json);
            return  write(200, "保存成功！", "data", knowledgeCategoryDO);
        } catch (Exception e) {
            e.printStackTrace();
            return write(-1, "保存失败！");
        }
    }

    @RequestMapping(value = "/searchCategoryPageList", method = RequestMethod.GET)
    @ApiOperation(value = "获取分类列表")
    public String searchCategoryPageList(
            @ApiParam(name = "page", value = "第几页，从1开始", required = true, defaultValue = "1")
            @RequestParam(value = "page", required = true,defaultValue = "1")Integer page,
            @ApiParam(name = "pageSize", value = "每页分页大小", required = true, defaultValue = "10")
            @RequestParam(value = "pageSize", required = true,defaultValue = "10")Integer pageSize) {
        try {
            Map<String, Object> map = new HashMap<>();
            String filters = "del=1";
            PageRequest pageRequest = PageRequest.of(page - 1, pageSize);
            List search = service.search("", filters, "", page, pageSize);
            List searchCount = service.search(filters);
            Page result = new PageImpl(search, pageRequest, null != searchCount && searchCount.size() > 0 ? searchCount.size() : 0);
            return  write(200, "获取成功！", "data", result);
        } catch (Exception e) {
            e.printStackTrace();
            return write(-1, "获取失败！");
        }
    }

    @RequestMapping(value = "/hasExistCode", method = RequestMethod.GET)
    @ApiOperation(value = "是否存在分类code")
    public String hasExistCode(
            @ApiParam(name = "code", value = "code", required = true)
            @RequestParam(value = "code", required = true)String code) {
        try {
            Boolean flag = service.hasExistCode(code);
            return  write(200, "获取成功！", "data", flag);
        } catch (Exception e) {
            e.printStackTrace();
            return write(-1, "获取失败！");
        }
    }

    @RequestMapping(value = "/updateDel", method = RequestMethod.GET)
    @ApiOperation(value = "根据分类code删除分类")
    public String updateDel(
            @ApiParam(name = "code", value = "code", required = true)
            @RequestParam(value = "code", required = true)String code) {
        try {
            Boolean flag = service.updateDel(code);
            if (!flag) {
                return write(205, "该分类下有文章，请先删除文章！");
            }
            return write(200, "删除成功！");
        } catch (Exception e) {
            e.printStackTrace();
            return write(-1, "删除失败！");
        }
    }

    @RequestMapping(value = "/queryByCode", method = RequestMethod.GET)
    @ApiOperation(value = "根据code查询分类")
    public String queryByCode(
            @ApiParam(name = "code", value = "code", required = true)
            @RequestParam(value = "code", required = true)String code) {
        try {
            KnowledgeCategoryDO knowledgeCategoryDO = service.queryByCode(code);
            return  write(200, "获取成功！", "data", knowledgeCategoryDO);
        } catch (Exception e) {
            e.printStackTrace();
            return write(-1, "获取失败！");
        }
    }

    @RequestMapping(value = "/searchCategoryList", method = RequestMethod.GET)
    @ApiOperation(value = "获取分类列表")
    public String searchCategoryList() {
        try {
            List search = service.search("del=1;pid=0;");
            return  write(200, "获取成功！", "data", search);
        } catch (Exception e) {
            e.printStackTrace();
            return write(-1, "获取失败！");
        }
    }
}
