package  com.yihu.customer.device.repository;

import  com.yihu.customer.device.entity.DeviceManufacturer;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * Created by humingfen on 2018/6/6.
 */
public interface DeviceManufacturerDao extends PagingAndSortingRepository<DeviceManufacturer, Long>, JpaSpecificationExecutor<DeviceManufacturer> {

    @Transactional
    @Modifying
    @Query("update DeviceManufacturer dm set dm.manufacturerName = ?1, dm.manufacturerCode = ?2, dm.address = ?3, dm.representative = ?4, dm.del = ?5 where dm.id = ?6")
    void updateManufacturer(String manufacturerName, String manufacturerCode, String address, String representative, Integer del, Long id);

    DeviceManufacturer findByCode(String code);

    @Query("select dm.manufacturerCode from DeviceManufacturer dm where dm.code = ?1")
    String getManufacturerCodeByCode(String code);

    @Query("select dm from DeviceManufacturer dm where dm.del = 0")
    List<DeviceManufacturer> getAll();
}
