package  com.yihu.customer.entity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.util.List;

/**
 * 城市信息對象
 * @author George
 *
 */

@Entity
@Table(name = "dm_hospital")
public class Hospital extends IdEntity {
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 8039389705624435301L;
	
	// 医院編碼
	private String code;
	// 医院名稱
	private String name;
	//支持专病
	private List<Wlyyhospitalspecia> specialist;
	// 作废标志
	private String del;
	//省份标志
	private String province;
	//省份名称
	private String provinceName;
	//城市标志
	private String city;
	//城市名称
	private String cityName;
	//区县标志
	private String town;
	//区县名称
	private String townName;
	//级别，1医院，2社区医院
	private int level;
	//医院等级
	private int grade;
	//医院详细地址
	private String address;
	//医院简介
	private String intro;
	
	//医院图片
	private String photo;
	
	//add by cws 20160830
	private String roadCode;
	private String centerSite;

	//add by hmf
	private String orgPhone;
	private String startWorkingTimeAm;//早上开始工作时间
	private String stopWorkingTimeAm;//早上下班时间
	private String startWorkingTimePm;//下午开始工作时间
	private String stopWorkingTimePm;//下午下班时间
	private String description; //家签提示语
    @Transient
    public List<Wlyyhospitalspecia> getSpecialist() {
        return specialist;
    }

    public void setSpecialist(List<Wlyyhospitalspecia> specialist) {
        this.specialist = specialist;
    }

    public String getRoadCode() {
		return roadCode;
	}

	public void setRoadCode(String roadCode) {
		this.roadCode = roadCode;
	}

	public String getCenterSite() {
		return centerSite;
	}

	public void setCenterSite(String centerSite) {
		this.centerSite = centerSite;
	}

	public String getDel() {
		return del;
	}

	public void setDel(String del) {
		this.del = del;
	}

	public String getCode() {
		return code;
	}

	public void setCode(String code) {
		this.code = code;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getProvince() {
		return province;
	}

	public void setProvince(String province) {
		this.province = province;
	}

	public String getProvinceName() {
		return provinceName;
	}

	public void setProvinceName(String provinceName) {
		this.provinceName = provinceName;
	}

	public String getCity() {
		return city;
	}

	public void setCity(String city) {
		this.city = city;
	}

	public String getCityName() {
		return cityName;
	}

	public void setCityName(String cityName) {
		this.cityName = cityName;
	}

	public String getTown() {
		return town;
	}

	public void setTown(String town) {
		this.town = town;
	}

	public String getTownName() {
		return townName;
	}

	public void setTownName(String townName) {
		this.townName = townName;
	}

	public int getLevel() {
		return level;
	}

	public void setLevel(int level) {
		this.level = level;
	}

	public String getAddress() {
		return address;
	}

	public void setAddress(String address) {
		this.address = address;
	}

	public String getIntro() {
		return intro;
	}

	public void setIntro(String intro) {
		this.intro = intro;
	}

	public String getPhoto() {
		return photo;
	}

	public void setPhoto(String photo) {
		this.photo = photo;
	}


	public int getGrade() {
		return grade;
	}

	public void setGrade(int grade) {
		this.grade = grade;
	}

	@Column(name = "phone")
	public String getOrgPhone() {
		return orgPhone;
	}

	public void setOrgPhone(String orgPhone) {
		this.orgPhone = orgPhone;
	}

	public String getStartWorkingTimeAm() {
		return startWorkingTimeAm;
	}

	public void setStartWorkingTimeAm(String startWorkingTimeAm) {
		this.startWorkingTimeAm = startWorkingTimeAm;
	}

	public String getStopWorkingTimeAm() {
		return stopWorkingTimeAm;
	}

	public void setStopWorkingTimeAm(String stopWorkingTimeAm) {
		this.stopWorkingTimeAm = stopWorkingTimeAm;
	}

	public String getStartWorkingTimePm() {
		return startWorkingTimePm;
	}

	public void setStartWorkingTimePm(String startWorkingTimePm) {
		this.startWorkingTimePm = startWorkingTimePm;
	}

	public String getStopWorkingTimePm() {
		return stopWorkingTimePm;
	}

	public void setStopWorkingTimePm(String stopWorkingTimePm) {
		this.stopWorkingTimePm = stopWorkingTimePm;
	}

	public String getDescription() {
		return description;
	}

	public void setDescription(String description) {
		this.description = description;
	}
}
