package  com.yihu.customer.entity;

import com.fasterxml.jackson.annotation.JsonFormat;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.util.Date;

/**
 * 消息提醒设置
 * @author yeshijie on 2017/11/27.
 *
 */
@Entity
@Table(name = "wlyy_message_notice_setting")
public class MessageNoticeSetting extends IdEntity {

    private String user;//'用户code'
    private String type;// '类型（1医生，2居民）'
    private Integer masterSwitch;// '总开关' (1开，0关)
    private Integer imSwitch;//'im消息开关'(1开，0关)
    private Integer familyTopicSwitch;// '健管师邀请后推送开关'(1开，0关)
    private Integer signSwitch;// '签约消息开关'(1开，0关)
    private Integer healthSignSwitch;// '体征消息开关'(1开，0关)
    private Integer systemSwitch;// '系统消息开关'(1开，0关)
    private Integer prescriptionSwitch;// '续方消息开关'(1开，0关)
    private Integer soundSwitch;// '铃声提醒开关'(1开，0关)
    private Integer vibrationSwitch;// '振动提醒开关'(1开，0关)
    private Integer coordinationSwitch;// '协同消息开关'(1开，0关)
    private Date createTime;// '创建时间'

    //状态枚举
    public enum MessageTypeEnum {

        masterSwitch("总开关","masterSwitch"),
        imSwitch("im消息开关","imSwitch"),
        familyTopicSwitch("健管师邀请后推送开关","familyTopicSwitch"),
        signSwitch("签约消息开关","signSwitch"),
        healthSignSwitch("体征消息开关","healthSignSwitch"),
        systemSwitch("系统消息开关","systemSwitch"),
        prescriptionSwitch("续方消息开关","prescriptionSwitch"),
        soundSwitch("铃声提醒开关","soundSwitch"),
        vibrationSwitch("振动提醒开关","vibrationSwitch"),
        coordinationSwitch("协同消息开关","coordinationSwitch");

        private String name;
        private String value;

        MessageTypeEnum(String name, String value) {
            this.name = name;
            this.value = value;
        }

        public String getName() {
            return name;
        }

        public void setName(String name) {
            this.name = name;
        }

        public String getValue() {
            return value;
        }

        public void setValue(String value) {
            this.value = value;
        }
    }

    public String getUser() {
        return user;
    }

    public void setUser(String user) {
        this.user = user;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public Integer getMasterSwitch() {
        return masterSwitch;
    }

    public void setMasterSwitch(Integer masterSwitch) {
        this.masterSwitch = masterSwitch;
    }

    public Integer getImSwitch() {
        return imSwitch;
    }

    public void setImSwitch(Integer imSwitch) {
        this.imSwitch = imSwitch;
    }

    public Integer getFamilyTopicSwitch() {
        return familyTopicSwitch;
    }

    public void setFamilyTopicSwitch(Integer familyTopicSwitch) {
        this.familyTopicSwitch = familyTopicSwitch;
    }

    public Integer getSignSwitch() {
        return signSwitch;
    }

    public void setSignSwitch(Integer signSwitch) {
        this.signSwitch = signSwitch;
    }

    public Integer getHealthSignSwitch() {
        return healthSignSwitch;
    }

    public void setHealthSignSwitch(Integer healthSignSwitch) {
        this.healthSignSwitch = healthSignSwitch;
    }

    public Integer getSystemSwitch() {
        return systemSwitch;
    }

    public void setSystemSwitch(Integer systemSwitch) {
        this.systemSwitch = systemSwitch;
    }

    public Integer getPrescriptionSwitch() {
        return prescriptionSwitch;
    }

    public void setPrescriptionSwitch(Integer prescriptionSwitch) {
        this.prescriptionSwitch = prescriptionSwitch;
    }

    public Integer getSoundSwitch() {
        return soundSwitch;
    }

    public void setSoundSwitch(Integer soundSwitch) {
        this.soundSwitch = soundSwitch;
    }

    public Integer getVibrationSwitch() {
        return vibrationSwitch;
    }

    public void setVibrationSwitch(Integer vibrationSwitch) {
        this.vibrationSwitch = vibrationSwitch;
    }

    public Integer getCoordinationSwitch() {
        return coordinationSwitch;
    }

    public void setCoordinationSwitch(Integer coordinationSwitch) {
        this.coordinationSwitch = coordinationSwitch;
    }

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
    @Column(name="create_time")
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }
}
