package  com.yihu.customer.entity.copd;

import com.fasterxml.jackson.annotation.JsonFormat;
import  com.yihu.customer.entity.IdEntity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.util.Date;

/**
 * 慢阻肺居民记录表
 * Created by yeshijie on 2021/3/19.
 */
@Entity
@Table(name = "wlyy_copd_patient")
public class CopdPatient extends IdEntity {

    private String name;
    private String patient;
    private String status;//状态（1已管理，0未管理 4不纳入管理 2失访 8死亡）
    private String hospital;
    private String hospitalName;
    private String doctor;
    private String doctorName;
    private Integer sort;//'排序字段'
    private Date createTime;
    private Date updateTime;
    private String latestDischargeTime;//'最近出院时间'
    private String dischargeDiagnosis;//'出院诊断
    private String latestOutpatientTime;//'最近门诊时间'
    private String outpatientDiagnosis;//'门诊诊断'
    private String latestEmergencyTime;//'最近急诊时间'
    private String emergencyDiagnosis;//'急诊诊断'
    private String inclusionConditions;//纳入条件
    private String exclusionConditions;//排除条件
    private String secondInclusionConditions;//纳入条件
    private String secondExclusionConditions;//排除条件
    private String followupTwoStatus; //二次随访状态(0不通过，1通过)
    private Integer del;//删除标志 1正常 0删除
    private String phone;//导入数据-电话
    private String psn;//导入数据-psn
    private String pid;//导入数据-pid
    private String sexName;//导入数据-性别
    private String birthday;//导入数据-出生日期
    private String liveAddress;//导入数据-现住址
    private String address;//导入数据-户口地址
    private String jwOrgCode;//导入数据-基卫医院code
    private String jwOrgName;//导入数据-基卫医院名称
    private String jwDoctorName;//导入数据-基卫医生名称
    private String jwDoctorCode;//导入数据-基卫医生code
    private String groupScreeningStatus;//慢阻肺分组 0 未分组 1 随访观察组(旧) 2 肺康复锻炼组(旧)  3 肺康复锻炼组 4 常规治疗组 5待分配
    private String groupScreeningStatusName;//慢阻肺分组 0 未分组 1 随访观察组(旧) 2 肺康复锻炼组(旧)  3 肺康复锻炼组 4 常规治疗组 5待分配
    private String groupScreeningCode;// GCZ+六位数字  DLZ+六位数字 ab组新的规则 1-01-00001
    private String groupHospital;// 生成编码的医院code 生成编码和入组分开
    private String groupWatch;// 智能手表亚组 1是0否
    private String watchSn;//智能手表sn码
    private String sex;
    private String photo;
    private String idcard;
    private String age;
    private String mobile;

    private String ssc;
    private String statusName;//状态（1已管理，0未管理 4不纳入管理 2失访 8死亡）

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getPatient() {
        return patient;
    }

    public void setPatient(String patient) {
        this.patient = patient;
    }

    public String getStatus() {
        return status;
    }

    public void setStatus(String status) {
        this.status = status;
    }

    public String getHospital() {
        return hospital;
    }

    public void setHospital(String hospital) {
        this.hospital = hospital;
    }

    @Column(name = "hospital_name")
    public String getHospitalName() {
        return hospitalName;
    }

    public void setHospitalName(String hospitalName) {
        this.hospitalName = hospitalName;
    }

    public String getDoctor() {
        return doctor;
    }

    public void setDoctor(String doctor) {
        this.doctor = doctor;
    }

    @Column(name = "doctor_name")
    public String getDoctorName() {
        return doctorName;
    }

    public void setDoctorName(String doctorName) {
        this.doctorName = doctorName;
    }

    public Integer getSort() {
        return sort;
    }

    public void setSort(Integer sort) {
        this.sort = sort;
    }

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    public String getLatestDischargeTime() {
        return latestDischargeTime;
    }

    public void setLatestDischargeTime(String latestDischargeTime) {
        this.latestDischargeTime = latestDischargeTime;
    }

    public String getDischargeDiagnosis() {
        return dischargeDiagnosis;
    }

    public void setDischargeDiagnosis(String dischargeDiagnosis) {
        this.dischargeDiagnosis = dischargeDiagnosis;
    }

    public String getLatestOutpatientTime() {
        return latestOutpatientTime;
    }

    public void setLatestOutpatientTime(String latestOutpatientTime) {
        this.latestOutpatientTime = latestOutpatientTime;
    }

    public String getOutpatientDiagnosis() {
        return outpatientDiagnosis;
    }

    public void setOutpatientDiagnosis(String outpatientDiagnosis) {
        this.outpatientDiagnosis = outpatientDiagnosis;
    }

    public String getLatestEmergencyTime() {
        return latestEmergencyTime;
    }

    public void setLatestEmergencyTime(String latestEmergencyTime) {
        this.latestEmergencyTime = latestEmergencyTime;
    }

    public String getEmergencyDiagnosis() {
        return emergencyDiagnosis;
    }

    public void setEmergencyDiagnosis(String emergencyDiagnosis) {
        this.emergencyDiagnosis = emergencyDiagnosis;
    }

    public String getInclusionConditions() {
        return inclusionConditions;
    }

    public void setInclusionConditions(String inclusionConditions) {
        this.inclusionConditions = inclusionConditions;
    }

    public String getExclusionConditions() {
        return exclusionConditions;
    }

    public void setExclusionConditions(String exclusionConditions) {
        this.exclusionConditions = exclusionConditions;
    }

    @Transient
    public String getSex() {
        return sex;
    }

    public void setSex(String sex) {
        this.sex = sex;
    }

    @Transient
    public String getPhoto() {
        return photo;
    }

    public void setPhoto(String photo) {
        this.photo = photo;
    }

    public String getIdcard() {
        return idcard;
    }

    public void setIdcard(String idcard) {
        this.idcard = idcard;
    }

    @Transient
    public String getAge() {
        return age;
    }

    public void setAge(String age) {
        this.age = age;
    }

    @Transient
    public String getMobile() {
        return mobile;
    }

    public void setMobile(String mobile) {
        this.mobile = mobile;
    }

    public Integer getDel() {
        return del;
    }

    public void setDel(Integer del) {
        this.del = del;
    }

    public String getPhone() {
        return phone;
    }

    public void setPhone(String phone) {
        this.phone = phone;
    }

    public String getPsn() {
        return psn;
    }

    public void setPsn(String psn) {
        this.psn = psn;
    }

    public String getPid() {
        return pid;
    }

    public void setPid(String pid) {
        this.pid = pid;
    }

    public String getSexName() {
        return sexName;
    }

    public void setSexName(String sexName) {
        this.sexName = sexName;
    }

    public String getBirthday() {
        return birthday;
    }

    public void setBirthday(String birthday) {
        this.birthday = birthday;
    }

    public String getLiveAddress() {
        return liveAddress;
    }

    public void setLiveAddress(String liveAddress) {
        this.liveAddress = liveAddress;
    }

    public String getAddress() {
        return address;
    }

    public void setAddress(String address) {
        this.address = address;
    }

    public String getJwOrgCode() {
        return jwOrgCode;
    }

    public void setJwOrgCode(String jwOrgCode) {
        this.jwOrgCode = jwOrgCode;
    }

    public String getJwOrgName() {
        return jwOrgName;
    }

    public void setJwOrgName(String jwOrgName) {
        this.jwOrgName = jwOrgName;
    }

    public String getJwDoctorName() {
        return jwDoctorName;
    }

    public void setJwDoctorName(String jwDoctorName) {
        this.jwDoctorName = jwDoctorName;
    }

    public String getJwDoctorCode() {
        return jwDoctorCode;
    }

    public void setJwDoctorCode(String jwDoctorCode) {
        this.jwDoctorCode = jwDoctorCode;
    }

    public String getGroupScreeningStatus() {
        return groupScreeningStatus;
    }

    public void setGroupScreeningStatus(String groupScreeningStatus) {
        this.groupScreeningStatus = groupScreeningStatus;
    }

    public String getGroupScreeningCode() {
        return groupScreeningCode;
    }

    public void setGroupScreeningCode(String groupScreeningCode) {
        this.groupScreeningCode = groupScreeningCode;
    }

    public String getSecondInclusionConditions() {
        return secondInclusionConditions;
    }

    public void setSecondInclusionConditions(String secondInclusionConditions) {
        this.secondInclusionConditions = secondInclusionConditions;
    }

    public String getSecondExclusionConditions() {
        return secondExclusionConditions;
    }

    public void setSecondExclusionConditions(String secondExclusionConditions) {
        this.secondExclusionConditions = secondExclusionConditions;
    }

    public String getFollowupTwoStatus() {
        return followupTwoStatus;
    }

    public void setFollowupTwoStatus(String followupTwoStatus) {
        this.followupTwoStatus = followupTwoStatus;
    }

    @Transient
    public String getSsc() {
        return ssc;
    }

    public void setSsc(String ssc) {
        this.ssc = ssc;
    }

    @Transient
    public String getStatusName() {
        return statusName;
    }

    public void setStatusName(String statusName) {
        this.statusName = statusName;
    }

    @Transient
    public String getGroupScreeningStatusName() {
        return groupScreeningStatusName;
    }

    public void setGroupScreeningStatusName(String groupScreeningStatusName) {
        this.groupScreeningStatusName = groupScreeningStatusName;
    }

    public String getGroupHospital() {
        return groupHospital;
    }

    public void setGroupHospital(String groupHospital) {
        this.groupHospital = groupHospital;
    }

    public String getGroupWatch() {
        return groupWatch;
    }

    public void setGroupWatch(String groupWatch) {
        this.groupWatch = groupWatch;
    }

    public String getWatchSn() {
        return watchSn;
    }

    public void setWatchSn(String watchSn) {
        this.watchSn = watchSn;
    }
}
