package  com.yihu.customer.entity.es;

import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.searchbox.annotations.JestId;
import org.springframework.data.annotation.Transient;

import java.util.Date;
import java.util.List;

/**
 * 推送记录表
 * Created by chenweida on 2017/9/7.
 */
public class HealthEduArticleES {
    @JestId
    private String id;
    //说明：如医生推送文章给5个居民，则保存5条userType=1的记录和1条userType=2的记录（共6条）batchNo批次号一样。
    private String batchNo;//批次号记录发送所属批次（ES：必填）
    private String patientCode; // 患者标识（ES）（根据userType的值，userType=1，必填；userType=2，为空）
    private String patientName; // 患者名称（ES）（根据userType的值，userType=1，必填；userType=2，为空）
    private String doctorCode;  //发送人code(doctor表中的code)（ES：必填）
    private String doctorName;  //发送人名称(doctor表中的name)（ES：必填）
    private String sendName;   // 推送人的名称（包括医生本人、卫计委）（ES:必填）（如医生本人推送则记录医生名称，如管理员推送则记录管理员的角色名称）

    //备注：从发送人的信息中获取（doctor表获取）
    private String sendPic;   // 发送人头像（ES）
    private String sendSex;   // 发送人性别（ES）
    private Long adminTeamCode;// 行政团队（ES）
    private String adminTeamName;// 行政团队（ES）
    private String hospital; // 所属机构（ES）
    private String hospitalName; // 所属机构（ES）
    private String town; // 所属区划（ES）
    private String townName; // 所属区划（ES）

    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd'T'HH:mm:ssXX")
    @JSONField(format = "yyyy-MM-dd'T'HH:mm:ssXX")
    private Date createTime;  // 创建时间（ES:必填）
    private Integer sendType;//发送类型 1医生发送 2（管理员）卫纪委发送（ES:必填）
    private String sendLevel;   // 发送人级别  1专科医生，2全科医生，3健康管理师 4 管理员（ES）

    private String articleId;  //文章id（ES:必填）
    private String articleTitle;  //文章标题（ES:必填）
    private String articleCover;//文章封面（ES:必填）
    private String articleContent; //文章内容（ES:必填）
    private String articleCategoryId;//文章类别（ES:必填）
    private String firstLevelCategoryId;//文章一级类别id（ES:必填）
    private String firstLevelCategoryName;//文章一级类别Name（ES:必填）
    private String secondLevelCategoryId;//文章二级类别id（ES:必填）
    private String secondLevelCategoryName;//文章二级类别Name（ES:必填）
    private String operatorId;//文章作者Id（ES:必填）
    private Integer isRead=0;//文章是否已读 0未读，1已读（ES:必填）
    private String articleSource;//文章来源（ES:必填）（备注：医生所属机构名称）

    private List<RoleVo> roleList;//发送者角色List（ES:非必填）（备注：管理员有值，普通医生为空）
    private String leaveWords;//医生留言（ES:非必填）

    //说明：如普通医生推送则保存doctor表中的hospital字段，如管理员推送则保存当前角色的code（取wlyy_user_role表中的role字段）
    private String currentUserRoleCode;//发送者当前登录的角色code（ES:必填）
    private String currentUserRoleLevel;//发送者当前登录的角色级别，1、省，2、市，3、区，4、机构（ES:必填）
    private Integer sendSource; //1或者为空 i健康后台推送  2PC端推送（默认旧数据为1）（为后续平台推送统计做备用字段）
    private Integer allCount;//所有的推送数目（ES:必填）
    private Long readNumber;//阅读数（备注：和浏览数不一样）（不保存ES）

    @Transient
    private Boolean newArricleFlag;//新版文章推送标志（不保存ES）

    //说明：如医生推送文章给5个居民，则保存5条userType=1的记录和1条userType=2的记录（共6条）
    //业务需求：userType=1为居民被推送文章列表；userType=2医生推送的文章列表；
    private Integer userType; // 1、患者，2医生（ES：必填）
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd'T'HH:mm:ssXX")
    @JSONField(format = "yyyy-MM-dd'T'HH:mm:ssXX")
    private Date czrq;//阅读时间（默认为空，isRead=0；如isRead=1已读，则该字段有值）（ES:非必填）

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getBatchNo() {
        return batchNo;
    }

    public void setBatchNo(String batchNo) {
        this.batchNo = batchNo;
    }

    public String getPatientCode() {
        return patientCode;
    }

    public void setPatientCode(String patientCode) {
        this.patientCode = patientCode;
    }

    public String getPatientName() {
        return patientName;
    }

    public void setPatientName(String patientName) {
        this.patientName = patientName;
    }

    public String getDoctorCode() {
        return doctorCode;
    }

    public void setDoctorCode(String doctorCode) {
        this.doctorCode = doctorCode;
    }

    public String getDoctorName() {
        return doctorName;
    }

    public void setDoctorName(String doctorName) {
        this.doctorName = doctorName;
    }

    public String getSendName() {
        return sendName;
    }

    public void setSendName(String sendName) {
        this.sendName = sendName;
    }

    public String getSendPic() {
        return sendPic;
    }

    public void setSendPic(String sendPic) {
        this.sendPic = sendPic;
    }

    public String getSendSex() {
        return sendSex;
    }

    public void setSendSex(String sendSex) {
        this.sendSex = sendSex;
    }

    public Long getAdminTeamCode() {
        return adminTeamCode;
    }

    public void setAdminTeamCode(Long adminTeamCode) {
        this.adminTeamCode = adminTeamCode;
    }

    public String getAdminTeamName() {
        return adminTeamName;
    }

    public void setAdminTeamName(String adminTeamName) {
        this.adminTeamName = adminTeamName;
    }

    public String getHospital() {
        return hospital;
    }

    public void setHospital(String hospital) {
        this.hospital = hospital;
    }

    public String getHospitalName() {
        return hospitalName;
    }

    public void setHospitalName(String hospitalName) {
        this.hospitalName = hospitalName;
    }

    public String getTown() {
        return town;
    }

    public void setTown(String town) {
        this.town = town;
    }

    public String getTownName() {
        return townName;
    }

    public void setTownName(String townName) {
        this.townName = townName;
    }

    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    public Integer getSendType() {
        return sendType;
    }

    public void setSendType(Integer sendType) {
        this.sendType = sendType;
    }

    public String getSendLevel() {
        return sendLevel;
    }

    public void setSendLevel(String sendLevel) {
        this.sendLevel = sendLevel;
    }

    public String getArticleId() {
        return articleId;
    }

    public void setArticleId(String articleId) {
        this.articleId = articleId;
    }

    public String getArticleTitle() {
        return articleTitle;
    }

    public void setArticleTitle(String articleTitle) {
        this.articleTitle = articleTitle;
    }

    public String getArticleCover() {
        return articleCover;
    }

    public void setArticleCover(String articleCover) {
        this.articleCover = articleCover;
    }

    public String getArticleContent() {
        return articleContent;
    }

    public void setArticleContent(String articleContent) {
        this.articleContent = articleContent;
    }

    public String getArticleCategoryId() {
        return articleCategoryId;
    }

    public void setArticleCategoryId(String articleCategoryId) {
        this.articleCategoryId = articleCategoryId;
    }

    public String getFirstLevelCategoryId() {
        return firstLevelCategoryId;
    }

    public void setFirstLevelCategoryId(String firstLevelCategoryId) {
        this.firstLevelCategoryId = firstLevelCategoryId;
    }

    public String getFirstLevelCategoryName() {
        return firstLevelCategoryName;
    }

    public void setFirstLevelCategoryName(String firstLevelCategoryName) {
        this.firstLevelCategoryName = firstLevelCategoryName;
    }

    public String getSecondLevelCategoryId() {
        return secondLevelCategoryId;
    }

    public void setSecondLevelCategoryId(String secondLevelCategoryId) {
        this.secondLevelCategoryId = secondLevelCategoryId;
    }

    public String getSecondLevelCategoryName() {
        return secondLevelCategoryName;
    }

    public void setSecondLevelCategoryName(String secondLevelCategoryName) {
        this.secondLevelCategoryName = secondLevelCategoryName;
    }

    public String getOperatorId() {
        return operatorId;
    }

    public void setOperatorId(String operatorId) {
        this.operatorId = operatorId;
    }

    public Integer getIsRead() {
        return isRead;
    }

    public void setIsRead(Integer isRead) {
        this.isRead = isRead;
    }

    public String getArticleSource() {
        return articleSource;
    }

    public void setArticleSource(String articleSource) {
        this.articleSource = articleSource;
    }

    public List<RoleVo> getRoleList() {
        return roleList;
    }

    public void setRoleList(List<RoleVo> roleList) {
        this.roleList = roleList;
    }

    public String getLeaveWords() {
        return leaveWords;
    }

    public void setLeaveWords(String leaveWords) {
        this.leaveWords = leaveWords;
    }

    public String getCurrentUserRoleCode() {
        return currentUserRoleCode;
    }

    public void setCurrentUserRoleCode(String currentUserRoleCode) {
        this.currentUserRoleCode = currentUserRoleCode;
    }

    public String getCurrentUserRoleLevel() {
        return currentUserRoleLevel;
    }

    public void setCurrentUserRoleLevel(String currentUserRoleLevel) {
        this.currentUserRoleLevel = currentUserRoleLevel;
    }

    public Integer getSendSource() {
        return sendSource;
    }

    public void setSendSource(Integer sendSource) {
        this.sendSource = sendSource;
    }

    public Integer getAllCount() {
        return allCount;
    }

    public void setAllCount(Integer allCount) {
        this.allCount = allCount;
    }

    public Boolean getNewArricleFlag() {
        return newArricleFlag;
    }

    public void setNewArricleFlag(Boolean newArricleFlag) {
        this.newArricleFlag = newArricleFlag;
    }

    public Integer getUserType() {
        return userType;
    }

    public void setUserType(Integer userType) {
        this.userType = userType;
    }

    public Long getReadNumber() {
        return readNumber;
    }

    public void setReadNumber(Long readNumber) {
        this.readNumber = readNumber;
    }

    public Date getCzrq() {
        return czrq;
    }

    public void setCzrq(Date czrq) {
        this.czrq = czrq;
    }

    public HealthEduArticleES() {
    }
}
