package  com.yihu.customer.entity.gdp;

import com.fasterxml.jackson.annotation.JsonFormat;
import  com.yihu.customer.entity.IdEntity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.util.Date;

/**
 * gdp法人单位核查表
 * Created by yeshijie on 2021/11/8.
 */
@Entity
@Table(name = "gdp_survey_check")
public class GdpSurveyCheck extends IdEntity {

    private String unifiedSocialCreditCode;//统一社会信用代码
    private String companyName;//单位名称
    private String address;//单位地址
    private String businessActivity1;//单位主要业务活动1
    private String businessActivity2;//单位主要业务活动2
    private String businessActivity3;//单位主要业务活动3
    private String healthRelated;//是否生产或提供健康产业类产品或服务 1是 0否
    private String serviceType;//服务类别逗号间隔 按序号1开始
    private String serviceTypeOther;//服务类型其他
    private String annualIncome;//全年收入
    private String healthIncome;//健康相关收入
    private String healthRate;//健康占比
    private String lastYearIncome;//去年收入
    private String lastYearHealthIncome;//去年健康相关收入
    private String lastYearHealthRate;//去年健康占比
    private String companyLeader;//单位负责人
    private String preparer;//填表人
    private String preparerPhone;//填表人联系方式
    private Date reportDate;//报出日期
    private Date createTime;

    @Column(name = "unified_social_credit_code")
    public String getUnifiedSocialCreditCode() {
        return unifiedSocialCreditCode;
    }

    public void setUnifiedSocialCreditCode(String unifiedSocialCreditCode) {
        this.unifiedSocialCreditCode = unifiedSocialCreditCode;
    }
    @Column(name = "company_name")
    public String getCompanyName() {
        return companyName;
    }

    public void setCompanyName(String companyName) {
        this.companyName = companyName;
    }
    @Column(name = "address")
    public String getAddress() {
        return address;
    }

    public void setAddress(String address) {
        this.address = address;
    }
    @Column(name = "business_activity1")
    public String getBusinessActivity1() {
        return businessActivity1;
    }

    public void setBusinessActivity1(String businessActivity1) {
        this.businessActivity1 = businessActivity1;
    }
    @Column(name = "business_activity2")
    public String getBusinessActivity2() {
        return businessActivity2;
    }

    public void setBusinessActivity2(String businessActivity2) {
        this.businessActivity2 = businessActivity2;
    }
    @Column(name = "business_activity3")
    public String getBusinessActivity3() {
        return businessActivity3;
    }

    public void setBusinessActivity3(String businessActivity3) {
        this.businessActivity3 = businessActivity3;
    }
    @Column(name = "health_related")
    public String getHealthRelated() {
        return healthRelated;
    }

    public void setHealthRelated(String healthRelated) {
        this.healthRelated = healthRelated;
    }
    @Column(name = "service_type")
    public String getServiceType() {
        return serviceType;
    }

    public void setServiceType(String serviceType) {
        this.serviceType = serviceType;
    }
    @Column(name = "service_type_other")
    public String getServiceTypeOther() {
        return serviceTypeOther;
    }

    public void setServiceTypeOther(String serviceTypeOther) {
        this.serviceTypeOther = serviceTypeOther;
    }
    @Column(name = "annual_income")
    public String getAnnualIncome() {
        return annualIncome;
    }

    public void setAnnualIncome(String annualIncome) {
        this.annualIncome = annualIncome;
    }
    @Column(name = "health_income")
    public String getHealthIncome() {
        return healthIncome;
    }

    public void setHealthIncome(String healthIncome) {
        this.healthIncome = healthIncome;
    }
    @Column(name = "health_rate")
    public String getHealthRate() {
        return healthRate;
    }

    public void setHealthRate(String healthRate) {
        this.healthRate = healthRate;
    }
    @Column(name = "last_year_income")
    public String getLastYearIncome() {
        return lastYearIncome;
    }

    public void setLastYearIncome(String lastYearIncome) {
        this.lastYearIncome = lastYearIncome;
    }
    @Column(name = "last_year_health_income")
    public String getLastYearHealthIncome() {
        return lastYearHealthIncome;
    }

    public void setLastYearHealthIncome(String lastYearHealthIncome) {
        this.lastYearHealthIncome = lastYearHealthIncome;
    }
    @Column(name = "last_year_health_rate")
    public String getLastYearHealthRate() {
        return lastYearHealthRate;
    }

    public void setLastYearHealthRate(String lastYearHealthRate) {
        this.lastYearHealthRate = lastYearHealthRate;
    }
    @Column(name = "company_leader")
    public String getCompanyLeader() {
        return companyLeader;
    }

    public void setCompanyLeader(String companyLeader) {
        this.companyLeader = companyLeader;
    }
    @Column(name = "preparer")
    public String getPreparer() {
        return preparer;
    }

    public void setPreparer(String preparer) {
        this.preparer = preparer;
    }
    @Column(name = "preparer_phone")
    public String getPreparerPhone() {
        return preparerPhone;
    }

    public void setPreparerPhone(String preparerPhone) {
        this.preparerPhone = preparerPhone;
    }

    @Column(name = "report_date")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+08:00")
    public Date getReportDate() {
        return reportDate;
    }

    public void setReportDate(Date reportDate) {
        this.reportDate = reportDate;
    }

    @Column(name = "create_time")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }
}
