package  com.yihu.customer.entity.gdp;

import com.fasterxml.jackson.annotation.JsonFormat;
import  com.yihu.customer.entity.IdEntity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.util.Date;

/**
 * gdp调查记录表
 * Created by yeshijie on 2021/11/8.
 */
@Entity
@Table(name = "gdp_survey_record")
public class GdpSurveyRecord extends IdEntity {

    private String companyType;//单位类型 1企业法人单位 2行政事业单位 3社会团体单位
    private String industryType;//行业类型 1农、林、牧、渔业法人单位 2工业法人单位 3建筑业法人单位 4服务业法人单位
    private String unifiedSocialCreditCode;//统一社会信用代码
    private String companyName;//单位名称
    private String address;//单位地址
    private String detailed;//详情json格式 不同的单位 行业格式不同
    private String companyLeader;//单位负责人
    private String statisticalLeader;//统计负责人
    private String preparer;//填表人
    private String preparerPhone;//填表人联系方式
    private Date reportDate;//报出日期
    private Date createTime;

    @Column(name = "company_type")
    public String getCompanyType() {
        return companyType;
    }

    public void setCompanyType(String companyType) {
        this.companyType = companyType;
    }
    @Column(name = "industry_type")
    public String getIndustryType() {
        return industryType;
    }

    public void setIndustryType(String industryType) {
        this.industryType = industryType;
    }
    @Column(name = "unified_social_credit_code")
    public String getUnifiedSocialCreditCode() {
        return unifiedSocialCreditCode;
    }

    public void setUnifiedSocialCreditCode(String unifiedSocialCreditCode) {
        this.unifiedSocialCreditCode = unifiedSocialCreditCode;
    }
    @Column(name = "company_name")
    public String getCompanyName() {
        return companyName;
    }

    public void setCompanyName(String companyName) {
        this.companyName = companyName;
    }
    @Column(name = "address")
    public String getAddress() {
        return address;
    }

    public void setAddress(String address) {
        this.address = address;
    }
    @Column(name = "detailed")
    public String getDetailed() {
        return detailed;
    }

    public void setDetailed(String detailed) {
        this.detailed = detailed;
    }
    @Column(name = "company_leader")
    public String getCompanyLeader() {
        return companyLeader;
    }

    public void setCompanyLeader(String companyLeader) {
        this.companyLeader = companyLeader;
    }
    @Column(name = "statistical_leader")
    public String getStatisticalLeader() {
        return statisticalLeader;
    }

    public void setStatisticalLeader(String statisticalLeader) {
        this.statisticalLeader = statisticalLeader;
    }
    @Column(name = "preparer")
    public String getPreparer() {
        return preparer;
    }

    public void setPreparer(String preparer) {
        this.preparer = preparer;
    }
    @Column(name = "preparer_phone")
    public String getPreparerPhone() {
        return preparerPhone;
    }

    public void setPreparerPhone(String preparerPhone) {
        this.preparerPhone = preparerPhone;
    }
    @Column(name = "report_date")
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+08:00")
    public Date getReportDate() {
        return reportDate;
    }

    public void setReportDate(Date reportDate) {
        this.reportDate = reportDate;
    }
    @Column(name = "create_time")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }
}
