package  com.yihu.customer.entity.healthchannel;

import com.fasterxml.jackson.annotation.JsonFormat;
import  com.yihu.customer.entity.BaseIdentityEntity;

import javax.persistence.Entity;
import javax.persistence.Table;
import java.util.Date;

/**
 * 健康频道-置顶/推荐文章关联表
 * Created by zdm on 2019/2/15.
 */
@Entity
@Table(name = "wlyy_channel_recommend_article")
public class HealthChannelRecommendArticleDo extends BaseIdentityEntity {
    /**
     * 频道id
     */
    private Integer channelId;
    /**
     * 频道名称
     */
    private String channelName;
    /**
     * 文章类型:health_article健康文章，platform_information平台资讯，selected_questions_and_answers精选问答，health_column健康专栏
     */
     private String articleType;
    /**
     * 文章id
     */
     private String articleId;
    /**
     * 最新发布的刊物
     */
    private String publicationId;
    /**
     * 最新发布的刊物名称
     */
    private String publicationName;
    /**
     * 文章创建时间，刊物发布时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
    private Date articleCreateTime;
    /**
     * 文章标题
     */
    private String articleTitle;
    /**
     * 文章作者
     */
    private String articleAuthor;
    /**
     * 机构
     */
    private String organization;
    /**
     * 内容类型id
     */
    private String categoryId;
    /**
     * 内容类型名称
     */
    private String categoryName;
    /**
     * 分类ID
     */
    private String classification;
    /**
     * 分类名称
     */
    private String classificationName;
    /**
     * 置顶起始时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
    private Date startTime;
    /**
     * 置顶结束时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
    private Date endTime;
    /**
     * 创建者
     */
    private String author;
    /**
     * 创建者姓名
     */
    private String authorName;
    /**
     * 操作类型：1推荐、2置顶
     */
    private String type;
    /**
     * 排序
     */
    private Integer sort;
    /**
     * 是否有效：-1删除，0失效，1生效，2未生效
     */
    private Integer delFlag;

    public Integer getChannelId() {
        return channelId;
    }

    public void setChannelId(Integer channelId) {
        this.channelId = channelId;
    }

    public String getChannelName() {
        return channelName;
    }

    public void setChannelName(String channelName) {
        this.channelName = channelName;
    }

    public String getArticleTitle() {
        return articleTitle;
    }

    public void setArticleTitle(String articleTitle) {
        this.articleTitle = articleTitle;
    }

    public String getArticleAuthor() {
        return articleAuthor;
    }

    public void setArticleAuthor(String articleAuthor) {
        this.articleAuthor = articleAuthor;
    }

    public String getOrganization() {
        return organization;
    }

    public void setOrganization(String organization) {
        this.organization = organization;
    }

    public String getCategoryId() {
        return categoryId;
    }

    public void setCategoryId(String categoryId) {
        this.categoryId = categoryId;
    }

    public String getCategoryName() {
        return categoryName;
    }

    public void setCategoryName(String categoryName) {
        this.categoryName = categoryName;
    }

    public String getClassification() {
        return classification;
    }

    public void setClassification(String classification) {
        this.classification = classification;
    }

    public String getClassificationName() {
        return classificationName;
    }

    public void setClassificationName(String classificationName) {
        this.classificationName = classificationName;
    }

    public Date getStartTime() {
        return startTime;
    }

    public void setStartTime(Date startTime) {
        this.startTime = startTime;
    }

    public Date getEndTime() {
        return endTime;
    }

    public void setEndTime(Date endTime) {
        this.endTime = endTime;
    }

    public String getAuthor() {
        return author;
    }

    public void setAuthor(String author) {
        this.author = author;
    }

    public String getAuthorName() {
        return authorName;
    }

    public void setAuthorName(String authorName) {
        this.authorName = authorName;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public Integer getSort() {
        return sort;
    }

    public void setSort(Integer sort) {
        this.sort = sort;
    }

    public Integer getDelFlag() {
        return delFlag;
    }

    public void setDelFlag(Integer delFlag) {
        this.delFlag = delFlag;
    }

    public String getArticleType() {
        return articleType;
    }

    public void setArticleType(String articleType) {
        this.articleType = articleType;
    }

    public String getArticleId() {
        return articleId;
    }

    public void setArticleId(String articleId) {
        this.articleId = articleId;
    }

    public String getPublicationId() {
        return publicationId;
    }

    public void setPublicationId(String publicationId) {
        this.publicationId = publicationId;
    }

    public String getPublicationName() {
        return publicationName;
    }

    public void setPublicationName(String publicationName) {
        this.publicationName = publicationName;
    }

    public Date getArticleCreateTime() {
        return articleCreateTime;
    }

    public void setArticleCreateTime(Date articleCreateTime) {
        this.articleCreateTime = articleCreateTime;
    }
}
