package  com.yihu.customer.entity.healthcolumn;

import com.fasterxml.jackson.annotation.JsonFormat;
import  com.yihu.customer.entity.BaseIdentityEntity;

import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.util.Date;

/**
 * 集美宣教-健康专栏：期刊表
 * Created by zdm on 2018/12/25.
 */
@Entity
@Table(name = "wlyy_periodical")
public class PeriodicalDo extends BaseIdentityEntity {
    /** 期刊号 */
    private String  code;
    /** 期刊名称*/
    private String  name;
    /** 简介*/
    private String  introduction;
    /** 作者*/
    private String  author;
    /** 作者姓名*/
    private String authorName;
    /** 专栏排序*/
    private Integer  sort;
    /**
     * 已发布刊物数量
     */
    private Integer releseCount;
    /**
     * 下一次发布刊物时间
     */
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
    private Date nextReleseDate;
    /**
     * 专栏是否有效:0删除，1正常2下线
     */
    private Integer delFlag;
    /**
     * 专栏是否有效:0删除，1正常2下线
     */
    private String delFlagVal;
    /**
     * 最新发布的期刊
     */
    private String publicationCode;
    /**
     * 是否已读：0未读，1已读
     */
    private String readFlag="0";

    /**
     * 期刊分类
     */
    private String classification;
    /**
     * 期刊分类名称
     */
    private String classificationName;
    /**
     * 操作人所属机构编码
     */
    private String authorOrg;
    /**
     * 操作人所属机构名称
     */
    private String authorOrgName;

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getIntroduction() {
        return introduction;
    }

    public void setIntroduction(String introduction) {
        this.introduction = introduction;
    }

    public String getAuthor() {
        return author;
    }

    public void setAuthor(String author) {
        this.author = author;
    }

    public Integer getSort() {
        return sort;
    }

    public void setSort(Integer sort) {
        this.sort = sort;
    }

    @Transient
    public Integer getReleseCount() {
        return releseCount;
    }

    public void setReleseCount(Integer releseCount) {
        this.releseCount = releseCount;
    }
    @Transient
    public Date getNextReleseDate() {
        return nextReleseDate;
    }

    public void setNextReleseDate(Date nextReleseDate) {
        this.nextReleseDate = nextReleseDate;
    }

    public Integer getDelFlag() {
        return delFlag;
    }

    public void setDelFlag(Integer delFlag) {
        this.delFlag = delFlag;
    }

    @Transient
    public String getPublicationCode() {
        return publicationCode;
    }

    public void setPublicationCode(String publicationCode) {
        this.publicationCode = publicationCode;
    }
    @Transient
    public String getDelFlagVal() {
        return delFlagVal;
    }

    public void setDelFlagVal(String delFlagVal) {
        this.delFlagVal = delFlagVal;
    }

    public String getAuthorName() {
        return authorName;
    }

    public void setAuthorName(String authorName) {
        this.authorName = authorName;
    }

    @Transient
    public String getReadFlag() {
        return readFlag;
    }

    public void setReadFlag(String readFlag) {
        this.readFlag = readFlag;
    }

    public String getClassification() {
        return classification;
    }

    public void setClassification(String classification) {
        this.classification = classification;
    }

    public String getClassificationName() {
        return classificationName;
    }

    public void setClassificationName(String classificationName) {
        this.classificationName = classificationName;
    }

    public String getAuthorOrg() {
        return authorOrg;
    }

    public void setAuthorOrg(String authorOrg) {
        this.authorOrg = authorOrg;
    }

    public String getAuthorOrgName() {
        return authorOrgName;
    }

    public void setAuthorOrgName(String authorOrgName) {
        this.authorOrgName = authorOrgName;
    }
}
