package  com.yihu.customer.entity.healthcolumn;

import com.fasterxml.jackson.annotation.JsonFormat;
import  com.yihu.customer.entity.BaseIdentityEntity;

import javax.persistence.Entity;
import javax.persistence.Table;
import java.util.Date;

/**
 * 集美宣教-健康专栏：刊物表
 * Created by zdm on 2018/12/25.
 */
@Entity
@Table(name = "wlyy_publication")
public class PublicationDo extends BaseIdentityEntity {
    /**刊物编号*/
    private String code;
    /**刊物名称*/
    private String name;
    /** 简介*/
    private String  introduction;
    /**专栏id*/
    private Long periodicalCode;
    /**期刊名称*/
    private String periodicalName;
    /**作者*/
    private String author ;
    /** 作者姓名*/
    private String authorName;

    /**刊物状态（1未发布、2已发布、3已下线、0已删除）*/
    private String status;
    /**发布时间*/
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
    private Date releaseTime;
    /**
     * 发布类型：0手动发布，1自动发布
     */
    private  Integer releaseType;
    /**二维码*/
    private String qrCode;
    /**是否显示往期回顾（0是，1否）*/
    private String showPastReviews;
    /**刊物排序*/
    private Integer sort;
    /**
     * 期刊图片地址
     */
    private String image;
    /**
     * 是否置顶专栏：0否1是
     */
    private Integer stickFlag;
    /**
     * 刊物内容
     */
    private String content;

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public Long getPeriodicalCode() {
        return periodicalCode;
    }

    public void setPeriodicalCode(Long periodicalCode) {
        this.periodicalCode = periodicalCode;
    }

    public String getPeriodicalName() {
        return periodicalName;
    }

    public void setPeriodicalName(String periodicalName) {
        this.periodicalName = periodicalName;
    }

    public String getAuthor() {
        return author;
    }

    public void setAuthor(String author) {
        this.author = author;
    }

    public String getStatus() {
        return status;
    }

    public void setStatus(String status) {
        this.status = status;
    }

    public Date getReleaseTime() {
        return releaseTime;
    }

    public void setReleaseTime(Date releaseTime) {
        this.releaseTime = releaseTime;
    }

    public String getQrCode() {
        return qrCode;
    }

    public void setQrCode(String qrCode) {
        this.qrCode = qrCode;
    }

    public String getShowPastReviews() {
        return showPastReviews;
    }

    public void setShowPastReviews(String showPastReviews) {
        this.showPastReviews = showPastReviews;
    }

    public Integer getSort() {
        return sort;
    }

    public void setSort(Integer sort) {
        this.sort = sort;
    }

    public Integer getReleaseType() {
        return releaseType;
    }

    public void setReleaseType(Integer releaseType) {
        this.releaseType = releaseType;
    }

    public String getAuthorName() {
        return authorName;
    }

    public void setAuthorName(String authorName) {
        this.authorName = authorName;
    }

    public String getImage() {
        return image;
    }

    public void setImage(String image) {
        this.image = image;
    }

    public String getIntroduction() {
        return introduction;
    }

    public void setIntroduction(String introduction) {
        this.introduction = introduction;
    }

    public Integer getStickFlag() {
        return stickFlag;
    }

    public void setStickFlag(Integer stickFlag) {
        this.stickFlag = stickFlag;
    }

    public String getContent() {
        return content;
    }

    public void setContent(String content) {
        this.content = content;
    }
}
