package  com.yihu.customer.entity.platformInformation;

import  com.yihu.customer.entity.IdEntity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.util.Date;

/**
 * Created by humingfen on 2018/11/21.
 * 平台咨讯表
 */
@Entity
@Table(name = "wlyy_platform_information")
public class PlatformInformationDO extends IdEntity {

    private String code;//平台咨讯唯一标识
    private String title;//咨讯标题
    private String subTitle;//咨讯副标题
    private String content;//咨讯内容
    private Integer type;//咨讯分类（1健康知识、2活动通知、3功能介绍、4平台宣传、5健康视频,6家庭医生）
    private String organizer;//主办方（发送对象为居民时才有）
    private String image;//封面图片
    private String province;//省份标识
    private String provinceName;//省份名称
    private String city;//城市标识
    private String cityName;//城市名称
    private String town;//区县标识
    private String townName;//区县名称
    private String hospital;//机构标识
    private String hospitalName;//机构名称
    private Integer sendingObjects;//发送对象（1居民、2家医、3专科医生）
    private Integer isNotice;//是否通知居民（1是、0否）
    private Integer sendType;//发送类型（1自动、2手动）
    private Integer sendStatus;//发送状态（0待发送、1已发送,2下架, 3撤回）
    private Date sendTime;//发送时间
    private String qrCode;//二维码
    private Integer del;//是否有效（1是0否）
    private Date createTime;//创建时间
    private Date updateTime;//更新时间
    /**
     * 视频二级分类
     */
    private String videoTypeClassify;

    private String undoReason;  // 撤回原因

    private String classifyName;//二级分类名称
    /**
     * 作者
     */
    private String author;
    /**
     * 作者所属机构
     */
    private String authorOrgName;

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public String getContent() {
        return content;
    }

    public void setContent(String content) {
        this.content = content;
    }

    public Integer getType() {
        return type;
    }

    public void setType(Integer type) {
        this.type = type;
    }

    public String getOrganizer() {
        return organizer;
    }

    public void setOrganizer(String organizer) {
        this.organizer = organizer;
    }

    public String getImage() {
        return image;
    }

    public void setImage(String image) {
        this.image = image;
    }

    public String getProvince() {
        return province;
    }

    public void setProvince(String province) {
        this.province = province;
    }

    @Column(name = "province_name")
    public String getProvinceName() {
        return provinceName;
    }

    public void setProvinceName(String provinceName) {
        this.provinceName = provinceName;
    }

    public String getCity() {
        return city;
    }

    public void setCity(String city) {
        this.city = city;
    }

    @Column(name = "city_name")
    public String getCityName() {
        return cityName;
    }

    public void setCityName(String cityName) {
        this.cityName = cityName;
    }

    public String getTown() {
        return town;
    }

    public void setTown(String town) {
        this.town = town;
    }

    @Column(name = "town_name")
    public String getTownName() {
        return townName;
    }

    public void setTownName(String townName) {
        this.townName = townName;
    }

    public String getHospital() {
        return hospital;
    }

    public void setHospital(String hospital) {
        this.hospital = hospital;
    }

    @Column(name = "hospital_name")
    public String getHospitalName() {
        return hospitalName;
    }

    public void setHospitalName(String hospitalName) {
        this.hospitalName = hospitalName;
    }

    @Column(name = "sending_objects")
    public Integer getSendingObjects() {
        return sendingObjects;
    }

    public void setSendingObjects(Integer sendingObjects) {
        this.sendingObjects = sendingObjects;
    }

    @Column(name = "is_notice")
    public Integer getIsNotice() {
        return isNotice;
    }

    public void setIsNotice(Integer isNotice) {
        this.isNotice = isNotice;
    }

    @Column(name = "send_type")
    public Integer getSendType() {
        return sendType;
    }

    public void setSendType(Integer sendType) {
        this.sendType = sendType;
    }

    @Column(name = "send_status")
    public Integer getSendStatus() {
        return sendStatus;
    }

    public void setSendStatus(Integer sendStatus) {
        this.sendStatus = sendStatus;
    }

    @Column(name = "send_time")
    public Date getSendTime() {
        return sendTime;
    }

    public void setSendTime(Date sendTime) {
        this.sendTime = sendTime;
    }

    public Integer getDel() {
        return del;
    }

    public void setDel(Integer del) {
        this.del = del;
    }

    @Column(name = "create_time")
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Column(name = "update_time")
    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    public String getQrCode() {
        return qrCode;
    }

    public void setQrCode(String qrCode) {
        this.qrCode = qrCode;
    }

    @Column(name = "sub_title")
    public String getSubTitle() {
        return subTitle;
    }

    public void setSubTitle(String subTitle) {
        this.subTitle = subTitle;
    }

    public String getVideoTypeClassify() {
        return videoTypeClassify;
    }

    public void setVideoTypeClassify(String videoTypeClassify) {
        this.videoTypeClassify = videoTypeClassify;
    }

    @Column(name = "undo_reason")
    public String getUndoReason() {
        return undoReason;
    }

    public void setUndoReason(String undoReason) {
        this.undoReason = undoReason;
    }

    @Column(name = "classify_name")
    public String getClassifyName() {
        return classifyName;
    }

    public void setClassifyName(String classifyName) {
        this.classifyName = classifyName;
    }

    public String getAuthor() {
        return author;
    }

    public void setAuthor(String author) {
        this.author = author;
    }

    public String getAuthorOrgName() {
        return authorOrgName;
    }

    public void setAuthorOrgName(String authorOrgName) {
        this.authorOrgName = authorOrgName;
    }
}
