package  com.yihu.customer.entity.prescription;

import com.fasterxml.jackson.annotation.JsonFormat;
import  com.yihu.customer.entity.IdEntity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.util.Date;

/**
 * @author huangwenjie
 * @date 2017/12/20 20:29
 */
@Entity
@Table(name = "wlyy_prescription_expressage")
public class PrescriptionExpressage extends IdEntity {
	
	private String code;                    //业务code
	private String prescriptionCode;      //处方code  关联表wlyy_prescription code
	private String mailno;                  //快递单号
	private String name;                    //收货人名称
	private String mobile;                  //收货人手机号码
	private String phone;                   //收货人座机号
	private String address;                 //收货人详细地址
	private String provinceCode;           //收货人省代码
	private String provinceName;           //收货人省名称
	private String cityCode;                //收货人市代码
	private String cityName;                //收货人市名称
	private String townCode;                //收货人区代码
	private String townName;                //收货人区名称
	private String streetCode;              //收货人街道代码
	private String streetName;              //收货人街道名称
	private Integer price;                    //快递的配送费用 单位是分
	private Integer weight;                  //快递重量  单位是g
	
	//患者填写的需要送达的机构信息
	private String  patientHospitalAddress;         // 患者填写的需要送达的机构地址
	private String  patientHospitalName;            // 患者填写的需要送达的机构名称
	private String  patientHospitalCode;            // 患者填写的需要送达的机构code
	
	
	//配药机构信息
	private String hospitalAddress;         // 配药机构地址
	private String hospitalName;            // 配药机构名称
	private String hospitalCode;            // 配药机构code
	private String hospitalDoctor;          // 配药机构出药人（健管师或者称工作人员）
	private String hospitalDoctorCode;     // 配药机构出药人code
	private Date fetchingMedicineTime;    //配药机构出药时间
	
	//配送人信息
	private String expressageHospitalName;            // 如果配送方式是健管师那么这个字段存服务站名称，如果是快递配送那么是快递公司名称
	private String expressageHospitalAddress;         // 配送机构地址
	private String expressageHospitalCode;            //配送机构code
	private String expressageName;          //配送人名称
	private String expressageCode;          //配送人code
	private String expressageMobile;        //配送人电话
	private Date expressageTime;                //开始配送的时间
	
	//医院接收快递信息
	private String acceptMobile;        //医院药品接收人电话
	private String acceptCode;        //医院药品接收人Code
	private String acceptName;        //医院药品接收人名称
	private String acceptHospital;        //医院药品接收人名称
	private String acceptHospitalName;        //医院药品接收人名称
	private String acceptHospitalAddress;        //医院药品接收人名称
	private Date acceptTime;                //接收的时间
	
	
	private Integer oneselfPickupFlg;//是否自取 1是 0否
	private Date createTime;                //创建的时间
	private Integer del;    //1可用 0删除
	
	private Date deliveryTime; //送达时间
	
	public String getHospitalCode() {
		return hospitalCode;
	}
	
	public void setHospitalCode(String hospitalCode) {
		this.hospitalCode = hospitalCode;
	}
	
	@Column(name = "code", unique = true , nullable=false)
	public String getCode() {
		return code;
	}
	
	public void setCode(String code) {
		this.code = code;
	}
	
	public String getPrescriptionCode() {
		return prescriptionCode;
	}
	
	public void setPrescriptionCode(String prescriptionCode) {
		this.prescriptionCode = prescriptionCode;
	}
	
	public String getName() {
		return name;
	}
	
	public void setName(String name) {
		this.name = name;
	}
	
	public String getMobile() {
		return mobile;
	}
	
	public void setMobile(String mobile) {
		this.mobile = mobile;
	}
	
	public String getPhone() {
		return phone;
	}
	
	public void setPhone(String phone) {
		this.phone = phone;
	}
	
	public String getAddress() {
		return address;
	}
	
	public void setAddress(String address) {
		this.address = address;
	}
	
	public String getProvinceCode() {
		return provinceCode;
	}
	
	public void setProvinceCode(String provinceCode) {
		this.provinceCode = provinceCode;
	}
	
	public String getProvinceName() {
		return provinceName;
	}
	
	public void setProvinceName(String provinceName) {
		this.provinceName = provinceName;
	}
	
	public String getCityCode() {
		return cityCode;
	}
	
	public void setCityCode(String cityCode) {
		this.cityCode = cityCode;
	}
	
	public String getCityName() {
		return cityName;
	}
	
	public void setCityName(String cityName) {
		this.cityName = cityName;
	}
	
	public String getTownCode() {
		return townCode;
	}
	
	public void setTownCode(String townCode) {
		this.townCode = townCode;
	}
	
	public String getTownName() {
		return townName;
	}
	
	public void setTownName(String townName) {
		this.townName = townName;
	}
	
	public String getStreetCode() {
		return streetCode;
	}
	
	public void setStreetCode(String streetCode) {
		this.streetCode = streetCode;
	}
	
	public String getStreetName() {
		return streetName;
	}
	
	public void setStreetName(String streetName) {
		this.streetName = streetName;
	}
	
	public String getHospitalName() {
		return hospitalName;
	}
	
	public void setHospitalName(String hospitalName) {
		this.hospitalName = hospitalName;
	}
	
	public Integer getPrice() {
		return price;
	}
	
	public void setPrice(Integer price) {
		this.price = price;
	}
	
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
	public Date getCreateTime() {
		return createTime;
	}
	
	public void setCreateTime(Date createTime) {
		this.createTime = createTime;
	}
	
	public Integer getOneselfPickupFlg() {
		return oneselfPickupFlg;
	}
	
	public void setOneselfPickupFlg(Integer oneselfPickupFlg) {
		this.oneselfPickupFlg = oneselfPickupFlg;
	}
	
	public String getMailno() { return mailno; }
	
	public void setMailno(String mailno) { this.mailno = mailno; }
	
	public String getExpressageName() {
		return expressageName;
	}
	
	public void setExpressageName(String expressageName) {
		this.expressageName = expressageName;
	}
	
	public String getExpressageCode() {
		return expressageCode;
	}
	
	public void setExpressageCode(String expressageCode) {
		this.expressageCode = expressageCode;
	}
	
	public String getExpressageMobile() {
		return expressageMobile;
	}
	
	public void setExpressageMobile(String expressageMobile) {
		this.expressageMobile = expressageMobile;
	}
	
	public Integer getWeight() {
		return weight;
	}
	
	public void setWeight(Integer weight) {
		this.weight = weight;
	}
	
	public Integer getDel() {
		return del;
	}
	
	public void setDel(Integer del) {
		this.del = del;
	}
	
	public String getHospitalAddress() {
		return hospitalAddress;
	}
	
	public void setHospitalAddress(String hospitalAddress) {
		this.hospitalAddress = hospitalAddress;
	}
	
	public String getAcceptMobile() {
		return acceptMobile;
	}
	
	public void setAcceptMobile(String acceptMobile) {
		this.acceptMobile = acceptMobile;
	}
	
	public String getAcceptCode() {
		return acceptCode;
	}
	
	public void setAcceptCode(String acceptCode) {
		this.acceptCode = acceptCode;
	}
	
	public String getAcceptName() {
		return acceptName;
	}
	
	public void setAcceptName(String acceptName) {
		this.acceptName = acceptName;
	}
	
	public String getAcceptHospital() {
		return acceptHospital;
	}
	
	public void setAcceptHospital(String acceptHospital) {
		this.acceptHospital = acceptHospital;
	}
	
	public String getAcceptHospitalName() {
		return acceptHospitalName;
	}
	
	public void setAcceptHospitalName(String acceptHospitalName) {
		this.acceptHospitalName = acceptHospitalName;
	}
	
	public Date getExpressageTime() {
		return expressageTime;
	}
	
	public void setExpressageTime(Date expressageTime) {
		this.expressageTime = expressageTime;
	}
	
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
	public Date getAcceptTime() {
		return acceptTime;
	}
	
	public void setAcceptTime(Date acceptTime) {
		this.acceptTime = acceptTime;
	}
	
	public String getExpressageHospitalName() {
		return expressageHospitalName;
	}
	
	public void setExpressageHospitalName(String expressageHospitalName) {
		this.expressageHospitalName = expressageHospitalName;
	}
	
	public String getExpressageHospitalAddress() {
		return expressageHospitalAddress;
	}
	
	public void setExpressageHospitalAddress(String expressageHospitalAddress) {
		this.expressageHospitalAddress = expressageHospitalAddress;
	}
	
	public String getExpressageHospitalCode() {
		return expressageHospitalCode;
	}
	
	public void setExpressageHospitalCode(String expressageHospitalCode) {
		this.expressageHospitalCode = expressageHospitalCode;
	}
	
	public String getPatientHospitalAddress() {
		return patientHospitalAddress;
	}
	
	public void setPatientHospitalAddress(String patientHospitalAddress) {
		this.patientHospitalAddress = patientHospitalAddress;
	}
	
	public String getPatientHospitalName() {
		return patientHospitalName;
	}
	
	public void setPatientHospitalName(String patientHospitalName) {
		this.patientHospitalName = patientHospitalName;
	}
	
	public String getPatientHospitalCode() {
		return patientHospitalCode;
	}
	
	public void setPatientHospitalCode(String patientHospitalCode) {
		this.patientHospitalCode = patientHospitalCode;
	}
	
	public String getAcceptHospitalAddress() {
		return acceptHospitalAddress;
	}
	
	public void setAcceptHospitalAddress(String acceptHospitalAddress) {
		this.acceptHospitalAddress = acceptHospitalAddress;
	}
	
	public String getHospitalDoctor() {
		return hospitalDoctor;
	}
	
	public void setHospitalDoctor(String hospitalDoctor) {
		this.hospitalDoctor = hospitalDoctor;
	}
	
	public String getHospitalDoctorCode() {
		return hospitalDoctorCode;
	}
	
	public void setHospitalDoctorCode(String hospitalDoctorCode) {
		this.hospitalDoctorCode = hospitalDoctorCode;
	}
	
	public Date getFetchingMedicineTime() {
		return fetchingMedicineTime;
	}
	
	public void setFetchingMedicineTime(Date fetchingMedicineTime) {
		this.fetchingMedicineTime = fetchingMedicineTime;
	}
	
	@JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+08:00")
	public Date getDeliveryTime() {
		return deliveryTime;
	}
	
	public void setDeliveryTime(Date deliveryTime) {
		this.deliveryTime = deliveryTime;
	}
}