package  com.yihu.customer.entity.prescription;

import com.fasterxml.jackson.annotation.JsonFormat;
import  com.yihu.customer.entity.IdEntity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.util.Date;

/**
 * Created by Administrator on 2017/7/21.
 * 处方配送流程表
 */
@Entity
@Table(name = "wlyy_prescription_expressage_log")
public class PrescriptionExpressageLog extends IdEntity {
	
	private String code;                    //业务code
	private String prescriptionCode;      //处方code  关联表wlyy_prescription code
	private String expressageCode; //配送code 关联wlyy_prescription_expressage code
	private Date createTime;                //创建的时间
	private String remark;//备注
	
	//健管师配送时候填写字段
	//配送人
	private String expressageHospitalName;            // 如果配送方式是健管师那么这个字段存服务站名称，如果是快递配送那么是快递公司名称
	private String expressageHospitalAddress;         // 配送机构地址
	private String expressageHospitalCode;            //配送机构code
	private String expressageUserName;          //配送人名称
	private String expressageUserCode;          //配送人code
	private String expressageUserMobile;        //配送人电话
	private Date   expressageTime;                //开始配送的时间
	//接收人
	private String acceptHospital;// /健管师配送 接收机构
	private String acceptHospitalName;///健管师配送 接收机构名称
	private String acceptUser;///健管师配送 接收人
	private String acceptUserName;///健管师配送 接收名称
	private String acceptUserMobile;///健管师配送 接收人电话
	
	//快递配送填写字段
	private String acceptAddress;//快递配 路由节点发生的城市    健管师配送机构地址
	private Date acceptTime;// 路由节点产生的时间，格式：YYYY-MM-DD HH24:MM:SS，示例：2012-7-30 09:30:00。
	private String opCode;//路由节点操作码
	private String acceptRemark;//路由节点具体描述
	
	@Column(name = "code", unique = true , nullable=false)
	public String getCode() {
		return code;
	}
	
	public void setCode(String code) {
		this.code = code;
	}
	
	public String getPrescriptionCode() {
		return prescriptionCode;
	}
	
	public void setPrescriptionCode(String prescriptionCode) {
		this.prescriptionCode = prescriptionCode;
	}
	
	
	
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
	public Date getCreateTime() {
		return createTime;
	}
	
	public void setCreateTime(Date createTime) {
		this.createTime = createTime;
	}
	
	public String getExpressageCode() {
		return expressageCode;
	}
	
	public void setExpressageCode(String expressageCode) {
		this.expressageCode = expressageCode;
	}
	
	public String getRemark() {
		return remark;
	}
	
	public void setRemark(String remark) {
		this.remark = remark;
	}
	
	public String getAcceptAddress() {
		return acceptAddress;
	}
	
	public void setAcceptAddress(String acceptAddress) {
		this.acceptAddress = acceptAddress;
	}
	
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
	public Date getAcceptTime() {
		return acceptTime;
	}
	
	public void setAcceptTime(Date acceptTime) {
		this.acceptTime = acceptTime;
	}
	
	public String getOpCode() {
		return opCode;
	}
	
	public void setOpCode(String opCode) {
		this.opCode = opCode;
	}
	
	public String getAcceptRemark() {
		return acceptRemark;
	}
	
	public void setAcceptRemark(String acceptRemark) {
		this.acceptRemark = acceptRemark;
	}
	
	public String getAcceptHospital() {
		return acceptHospital;
	}
	
	public void setAcceptHospital(String acceptHospital) {
		this.acceptHospital = acceptHospital;
	}
	
	public String getAcceptHospitalName() {
		return acceptHospitalName;
	}
	
	public void setAcceptHospitalName(String acceptHospitalName) {
		this.acceptHospitalName = acceptHospitalName;
	}
	
	public String getAcceptUser() {
		return acceptUser;
	}
	
	public void setAcceptUser(String acceptUser) {
		this.acceptUser = acceptUser;
	}
	
	public String getAcceptUserName() {
		return acceptUserName;
	}
	
	public void setAcceptUserName(String acceptUserName) {
		this.acceptUserName = acceptUserName;
	}
	
	public String getAcceptUserMobile() {
		return acceptUserMobile;
	}
	
	public void setAcceptUserMobile(String acceptUserMobile) {
		this.acceptUserMobile = acceptUserMobile;
	}
	
	public String getExpressageHospitalName() {
		return expressageHospitalName;
	}
	
	public void setExpressageHospitalName(String expressageHospitalName) {
		this.expressageHospitalName = expressageHospitalName;
	}
	
	public String getExpressageHospitalAddress() {
		return expressageHospitalAddress;
	}
	
	public void setExpressageHospitalAddress(String expressageHospitalAddress) {
		this.expressageHospitalAddress = expressageHospitalAddress;
	}
	
	public String getExpressageHospitalCode() {
		return expressageHospitalCode;
	}
	
	public void setExpressageHospitalCode(String expressageHospitalCode) {
		this.expressageHospitalCode = expressageHospitalCode;
	}
	
	public String getExpressageUserName() {
		return expressageUserName;
	}
	
	public void setExpressageUserName(String expressageUserName) {
		this.expressageUserName = expressageUserName;
	}
	
	public String getExpressageUserCode() {
		return expressageUserCode;
	}
	
	public void setExpressageUserCode(String expressageUserCode) {
		this.expressageUserCode = expressageUserCode;
	}
	
	public String getExpressageUserMobile() {
		return expressageUserMobile;
	}
	
	public void setExpressageUserMobile(String expressageUserMobile) {
		this.expressageUserMobile = expressageUserMobile;
	}
	
	public Date getExpressageTime() {
		return expressageTime;
	}
	
	public void setExpressageTime(Date expressageTime) {
		this.expressageTime = expressageTime;
	}
}
