package  com.yihu.customer.entity.prescription;


import com.fasterxml.jackson.annotation.JsonFormat;
import  com.yihu.customer.entity.IdEntity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.util.Date;
/**
 * Created by Administrator on 2017/7/21.
 * 处方日志
 */
@Entity
@Table(name = "wlyy_prescription_log")
public class PrescriptionLog extends IdEntity {
	
	
	public enum PrescriptionLogType {
		zy("智业对接", 1),
		ylz("易联众对接", 2),
		create("创建处方", 3),
		reviewed("审核", 4),
		pay("支付", 5),
		expressage("配送", 6),
		finish("已完成", 7),
		sf("顺丰对接", 8);
		private String name;
		private int value;
		
		PrescriptionLogType(String name, int value) {
			this.name = name;
			this.value = value;
		}
		
		public String getName() {
			return name;
		}
		
		public void setName(String name) {
			this.name = name;
		}
		
		public int getValue() {
			return value;
		}
		
		public void setValue(int value) {
			this.value = value;
		}
	}
	
	//状态枚举
	public enum PrescriptionLogStatus {
		
		pay_cancle("线下取消", -5),
		
		pay_refund("线下退费", -4),
		//续方取消
		pay_outtime("支付超时", -3),
		patient_canel("患者自己取消", -2),
		
		// 审核不通过
		no_reviewed("审核不通过", -1),
		
		//审核中
		revieweding("待审核", 0),
		changeing("调整中", 2),
		change_success("调整成功", 3),
		change_error("调整失败", 4),
		reviewed_success(" 医生审核(CA)通过", 10),
		
		//药师审核中
		Pharmacist_examination("药师审核中", 20),
		Pharmacist_examination_error("药师审核失败", 21),
		
		//开方中/药师审核成功
		adding("开方中/药师审核成功", 30),
		add_error("开方失败", 31),
		
		//待支付
		wait_pay("开方完成/待支付", 40),
		pay_error("支付失败", 41),
		
		//配药中
		pay_success("支付成功/待配药", 50),
		
		//等待领药
		wait_expressage("配药成功/待配送", 60),
		
		//配送中
		expressageing_error("配送失败", 61),
		expressageJGS("分配健管师", 62),
		expressageing("配送中", 65),
		expressage2hospital("配送到服务站", 69),
		
		//已完成
		finish("配送到患者手中/已完成", 100);
		
		private String name;
		private int value;
		
		PrescriptionLogStatus(String name, int value) {
			this.name = name;
			this.value = value;
		}
		
		public String getName() {
			return name;
		}
		
		public void setName(String name) {
			this.name = name;
		}
		
		public int getValue() {
			return value;
		}
		
		public void setValue(int value) {
			this.value = value;
		}
	}
	
	private String code;                    //业务流程
	private String prescriptionCode;      //处方code 关联表wlyy_prescription code
	private Date createTime;               //处方创建时间
	private Integer status;                 //状态 （-4线下退费 -3 支付过期 -2 患者自己取消 ）续方取消，-1 审核不通过 ,
	// （0 待审核, 2调整中，3调整成功, 4调整失败 ,10 医生审核(CA)通过）审核中，
	// 20药师审核中,21.药师审核失败,30 开方中/药师审核成功,31.开方失败/预结算失败,
	// （40开方完成/待支付 ，41 支付失败 ）待支付，  50 支付成功/待配药，（60配药成功/待配送）等待领药，
	// （61配送失败62分配健管师 65配送中，69配送到服务站）配送中，（100配送到患者手中/已完成）已完成',
	
	private Integer type;                   //类型: 1智业对接 2易联众对接  3创建处方 4 审核  5付款 6 配送 7完成
	private String userCode;                  //医生或者患者code
	private String userName;                  //医生或者患者name
	private Integer userType;                 //1 患者 2医生
	private Integer flag;                      //操作是否成功 1成功 0失败
	private String remark;                     //备注信息
	private String hospital;                //医院code
	private String hospitalName;            //医院名称
	
	private String statusName;  //状态名称
	
	@Column(name = "code")
	public String getCode() {
		return code;
	}
	
	public void setCode(String code) {
		this.code = code;
	}
	
	@Column(name = "prescription_code")
	public String getPrescriptionCode() {
		return prescriptionCode;
	}
	
	public void setPrescriptionCode(String prescriptionCode) {
		this.prescriptionCode = prescriptionCode;
	}
	
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
	@Column(name = "create_time")
	public Date getCreateTime() {
		return createTime;
	}
	
	public void setCreateTime(Date createTime) {
		this.createTime = createTime;
	}
	
	@Column(name = "type")
	public Integer getType() {
		return type;
	}
	
	public void setType(Integer type) {
		this.type = type;
	}
	
	@Column(name = "user_code")
	public String getUserCode() {
		return userCode;
	}
	
	public void setUserCode(String userCode) {
		this.userCode = userCode;
	}
	
	@Column(name = "user_name")
	public String getUserName() {
		return userName;
	}
	
	public void setUserName(String userName) {
		this.userName = userName;
	}
	
	@Column(name = "user_type")
	public Integer getUserType() {
		return userType;
	}
	
	public void setUserType(Integer userType) {
		this.userType = userType;
	}
	
	@Column(name = "flag")
	public Integer getFlag() {
		return flag;
	}
	
	public void setFlag(Integer flag) {
		this.flag = flag;
	}
	
	@Column(name = "remark")
	public String getRemark() {
		return remark;
	}
	
	public void setRemark(String remark) {
		this.remark = remark;
	}
	
	public Integer getStatus() {
		return status;
	}
	
	public void setStatus(Integer status) {
		this.status = status;
	}
	
	public String getHospital() {
		return hospital;
	}
	
	public void setHospital(String hospital) {
		this.hospital = hospital;
	}
	
	public String getHospitalName() {
		return hospitalName;
	}
	
	public void setHospitalName(String hospitalName) {
		this.hospitalName = hospitalName;
	}
	
	
	@Transient
	public String getStatusName() {
		return Prescription.getStatusName(this.status, hospitalName, userName);
	}
}
