package  com.yihu.customer.entity.prescription;

import com.fasterxml.jackson.annotation.JsonFormat;
import  com.yihu.customer.entity.IdEntity;

import javax.persistence.Entity;
import javax.persistence.Table;
import java.util.Date;

/**
 * Created by chenweida on 2017/7/26.
 * 处方支付实体
 */
@Entity
@Table(name = "wlyy_prescription_pay")
public class PrescriptionPay extends IdEntity {
	
	private String code;//接入应用业务流水号outChargeNo
	private String prescriptionCode;//开处方的医生code 关联 wlyy_prescription
	private Integer type;//1 医保支付 2基卫线下支付
	private Date outChargeTime;//接入应用时间
	private String channel;//支付方式
	private String chargeNo;//支付平台流水号
	private Date chargeTime;//支付平台交易成功时间
	private String billNo;//待结算费用单据号
	private String cardNo;//医保卡号
	private Integer totalAmount;//交易总金额
	private Integer insuranceAmount;//医保支付金额
	private Integer selfPayAmount;//自付金额
	private String openid;//用户openID
	private String userName;//用户名字
	private String idType;//证件类型
	private String idNo;//证件号码
	private String tradeStatus;//交易状态
	private String miSettleNo;//医保收费单据号
	private String miRegisterNo;//医保挂号
	private Date miCollectDate;//收费日期
	private Date miCollectTime;//收费时间
	private String miCollectorName;//收费人姓名
	private Integer miTotalFee;//本次报销总额
	private Integer selfPay;//个人现金支付
	private Integer accountPay;//个人账户支付
	private Integer heathPay;//健康账户支付
	private Integer cadresPay;//公务员补助
	private Integer fundPay;//基金支付
	private Integer healthCarePay;//保健基金支付
	private Integer commercePay;//商业保险支付
	private Integer familyPay;//共济账户支付
	private Integer civilPay;//民政补助金额
	private String civilZone;//民政行政区号
	private Integer bdrugPay;//乙类支付金额
	private Integer unlessAmount;//非医保费用
	private Integer exceedAmount;//超封顶线金额
	private Integer accountBalance;//个人账户余额
	private Integer healthBalance;//健康账户余额
	private String recipeContent;//处方主信息
	private String zdlist;//诊断明细
	private String mxlist;//处方明细
	private Date createTime;//续方确认支付时间
	private Date czrq;//续方记录最后操作时间
	//    易联众新增查询返回字段v1.3.7
	private String medOrgNo;//医疗机构编号
	private String medOrgName;//医疗机构名称
	private Date traceTime;//交易成功时间
	private String traceNo;//支付平台跟踪号
	
	private String principalCardNo;//实际签约卡号
	
	public String getPrincipalCardNo() {
		return principalCardNo;
	}
	
	public void setPrincipalCardNo(String principalCardNo) {
		this.principalCardNo = principalCardNo;
	}
	
	public Date getTraceTime() {
		return traceTime;
	}
	
	public void setTraceTime(Date traceTime) {
		this.traceTime = traceTime;
	}
	
	public String getTraceNo() {
		return traceNo;
	}
	
	public void setTraceNo(String traceNo) {
		this.traceNo = traceNo;
	}
	
	public String getMedOrgNo() {
		return medOrgNo;
	}
	
	public void setMedOrgNo(String medOrgNo) {
		this.medOrgNo = medOrgNo;
	}
	
	public String getMedOrgName() {
		return medOrgName;
	}
	
	public void setMedOrgName(String medOrgName) {
		this.medOrgName = medOrgName;
	}
	
	public Integer getAccountBalance() {
		return accountBalance;
	}
	
	public void setAccountBalance(Integer accountBalance) {
		this.accountBalance = accountBalance;
	}
	
	public Integer getHealthBalance() {
		return healthBalance;
	}
	
	public void setHealthBalance(Integer healthBalance) {
		this.healthBalance = healthBalance;
	}
	
	public String getRecipeContent() {
		return recipeContent;
	}
	
	public void setRecipeContent(String recipeContent) {
		this.recipeContent = recipeContent;
	}
	
	public String getZdlist() {
		return zdlist;
	}
	
	public void setZdlist(String zdlist) {
		this.zdlist = zdlist;
	}
	
	public String getMxlist() {
		return mxlist;
	}
	
	public void setMxlist(String mxlist) {
		this.mxlist = mxlist;
	}
	
	public String getCode() {
		return code;
	}
	
	public void setCode(String code) {
		this.code = code;
	}
	
	public String getPrescriptionCode() {
		return prescriptionCode;
	}
	
	public void setPrescriptionCode(String prescriptionCode) {
		this.prescriptionCode = prescriptionCode;
	}
	
	public Integer getType() {
		return type;
	}
	
	public void setType(Integer type) {
		this.type = type;
	}
	
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
	public Date getOutChargeTime() {
		return outChargeTime;
	}
	
	public void setOutChargeTime(Date outChargeTime) {
		this.outChargeTime = outChargeTime;
	}
	
	public String getChannel() {
		return channel;
	}
	
	public void setChannel(String channel) {
		this.channel = channel;
	}
	
	public String getChargeNo() {
		return chargeNo;
	}
	
	public void setChargeNo(String chargeNo) {
		this.chargeNo = chargeNo;
	}
	
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
	public Date getChargeTime() {
		return chargeTime;
	}
	
	public void setChargeTime(Date chargeTime) {
		this.chargeTime = chargeTime;
	}
	
	public String getBillNo() {
		return billNo;
	}
	
	public void setBillNo(String billNo) {
		this.billNo = billNo;
	}
	
	public String getCardNo() {
		return cardNo;
	}
	
	public void setCardNo(String cardNo) {
		this.cardNo = cardNo;
	}
	
	public Integer getTotalAmount() {
		return totalAmount;
	}
	
	public void setTotalAmount(Integer totalAmount) {
		this.totalAmount = totalAmount;
	}
	
	public Integer getInsuranceAmount() {
		return insuranceAmount;
	}
	
	public void setInsuranceAmount(Integer insuranceAmount) {
		this.insuranceAmount = insuranceAmount;
	}
	
	public Integer getSelfPayAmount() {
		return selfPayAmount;
	}
	
	public void setSelfPayAmount(Integer selfPayAmount) {
		this.selfPayAmount = selfPayAmount;
	}
	
	public String getOpenid() {
		return openid;
	}
	
	public void setOpenid(String openid) {
		this.openid = openid;
	}
	
	public String getUserName() {
		return userName;
	}
	
	public void setUserName(String userName) {
		this.userName = userName;
	}
	
	public String getIdType() {
		return idType;
	}
	
	public void setIdType(String idType) {
		this.idType = idType;
	}
	
	public String getIdNo() {
		return idNo;
	}
	
	public void setIdNo(String idNo) {
		this.idNo = idNo;
	}
	
	public String getTradeStatus() {
		return tradeStatus;
	}
	
	public void setTradeStatus(String tradeStatus) {
		this.tradeStatus = tradeStatus;
	}
	
	public String getMiSettleNo() {
		return miSettleNo;
	}
	
	public void setMiSettleNo(String miSettleNo) {
		this.miSettleNo = miSettleNo;
	}
	
	public String getMiRegisterNo() {
		return miRegisterNo;
	}
	
	public void setMiRegisterNo(String miRegisterNo) {
		this.miRegisterNo = miRegisterNo;
	}
	
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
	public Date getMiCollectDate() {
		return miCollectDate;
	}
	
	public void setMiCollectDate(Date miCollectDate) {
		this.miCollectDate = miCollectDate;
	}
	
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
	public Date getMiCollectTime() {
		return miCollectTime;
	}
	
	public void setMiCollectTime(Date miCollectTime) {
		this.miCollectTime = miCollectTime;
	}
	
	public String getMiCollectorName() {
		return miCollectorName;
	}
	
	public void setMiCollectorName(String miCollectorName) {
		this.miCollectorName = miCollectorName;
	}
	
	public Integer getMiTotalFee() {
		return miTotalFee;
	}
	
	public void setMiTotalFee(Integer miTotalFee) {
		this.miTotalFee = miTotalFee;
	}
	
	public Integer getSelfPay() {
		return selfPay;
	}
	
	public void setSelfPay(Integer selfPay) {
		this.selfPay = selfPay;
	}
	
	public Integer getAccountPay() {
		return accountPay;
	}
	
	public void setAccountPay(Integer accountPay) {
		this.accountPay = accountPay;
	}
	
	public Integer getHeathPay() {
		return heathPay;
	}
	
	public void setHeathPay(Integer heathPay) {
		this.heathPay = heathPay;
	}
	
	public Integer getCadresPay() {
		return cadresPay;
	}
	
	public void setCadresPay(Integer cadresPay) {
		this.cadresPay = cadresPay;
	}
	
	public Integer getFundPay() {
		return fundPay;
	}
	
	public void setFundPay(Integer fundPay) {
		this.fundPay = fundPay;
	}
	
	public Integer getHealthCarePay() {
		return healthCarePay;
	}
	
	public void setHealthCarePay(Integer healthCarePay) {
		this.healthCarePay = healthCarePay;
	}
	
	public Integer getCommercePay() {
		return commercePay;
	}
	
	public void setCommercePay(Integer commercePay) {
		this.commercePay = commercePay;
	}
	
	public Integer getFamilyPay() {
		return familyPay;
	}
	
	public void setFamilyPay(Integer familyPay) {
		this.familyPay = familyPay;
	}
	
	public Integer getCivilPay() {
		return civilPay;
	}
	
	public void setCivilPay(Integer civilPay) {
		this.civilPay = civilPay;
	}
	
	public String getCivilZone() {
		return civilZone;
	}
	
	public void setCivilZone(String civilZone) {
		this.civilZone = civilZone;
	}
	
	public Integer getBdrugPay() {
		return bdrugPay;
	}
	
	public void setBdrugPay(Integer bdrugPay) {
		this.bdrugPay = bdrugPay;
	}
	
	public Integer getUnlessAmount() {
		return unlessAmount;
	}
	
	public void setUnlessAmount(Integer unlessAmount) {
		this.unlessAmount = unlessAmount;
	}
	
	public Integer getExceedAmount() {
		return exceedAmount;
	}
	
	public void setExceedAmount(Integer exceedAmount) {
		this.exceedAmount = exceedAmount;
	}
	
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
	public Date getCreateTime() {
		return createTime;
	}
	
	public void setCreateTime(Date createTime) {
		this.createTime = createTime;
	}
	
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
	public Date getCzrq() {
		return czrq;
	}
	
	public void setCzrq(Date czrq) {
		this.czrq = czrq;
	}
}
