package  com.yihu.customer.entity.satisfaction;

import com.fasterxml.jackson.annotation.JsonFormat;
import  com.yihu.customer.entity.IdEntity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.util.Date;

/**
 * 满意度调查计划
 * @author xyq
 * @create 2022-07-18 9:55
 * @slogan 他化自在，我自逍遥
 */
@Entity
@Table(name = "wlyy_satisfaction_survey_plan")
public class SatisfactionSurveyPlan extends IdEntity {

    //调查计划名字
    private String name;
    //调查范围，0集美区，1社区
    private Integer rangType;
    //调查社区code，逗号拼接
    private String rangCode;
    //调查社区name,逗号拼接
    private String rangName;
    //筛选方式，0随机筛选，1按社区平均筛选，2按团队平均筛选
    private Integer filterType;
    //筛选数量
    private Integer filterNumber;
    //调查客服
    private String userCode;
    //客服名字
    private String userName;
    //调查开始时间
    private Date beginTime;
    //调查结束时间
    private Date endTime;
    //备注
    private String remark;
    //创建时间
    private Date createTime;

    @Column(name = "name")
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    @Column(name = "rang_type")
    public Integer getRangType() {
        return rangType;
    }

    public void setRangType(Integer rangType) {
        this.rangType = rangType;
    }

    @Column(name = "rang_code")
    public String getRangCode() {
        return rangCode;
    }

    public void setRangCode(String rangCode) {
        this.rangCode = rangCode;
    }

    @Column(name = "rang_name")
    public String getRangName() {
        return rangName;
    }

    public void setRangName(String rangName) {
        this.rangName = rangName;
    }

    @Column(name = "filter_type")
    public Integer getFilterType() {
        return filterType;
    }

    public void setFilterType(Integer filterType) {
        this.filterType = filterType;
    }

    @Column(name = "filter_number")
    public Integer getFilterNumber() {
        return filterNumber;
    }

    public void setFilterNumber(Integer filterNumber) {
        this.filterNumber = filterNumber;
    }

    @Column(name = "user_code")
    public String getUserCode() {
        return userCode;
    }

    public void setUserCode(String userCode) {
        this.userCode = userCode;
    }

    @Column(name = "user_name")
    public String getUserName() {
        return userName;
    }

    public void setUserName(String userName) {
        this.userName = userName;
    }

    @Column(name = "begin_time")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
    public Date getBeginTime() {
        return beginTime;
    }

    public void setBeginTime(Date beginTime) {
        this.beginTime = beginTime;
    }

    @Column(name = "end_time")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
    public Date getEndTime() {
        return endTime;
    }

    public void setEndTime(Date endTime) {
        this.endTime = endTime;
    }

    @Column(name = "remark")
    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }

    @Column(name = "create_time")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }
}
