package  com.yihu.customer.entity.synergy;

import com.fasterxml.jackson.annotation.JsonFormat;
import  com.yihu.customer.entity.IdEntity;
import org.hibernate.annotations.Formula;

import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * Created by wxw on 2018/12/26.
 * 知识库文章表
 * @author wxw.
 */
@Entity
@Table(name = "wlyy_knowledge_article")
public class KnowledgeArticleDO extends IdEntity {

    private String code;    // 文章标识
    private String patient; // 用户code
    private String title;   // 文章标题
    private String category;    // 分类标识
    private String categoryName;    // 分类名称
    private String content; // 文章内容
    private String source;  // 文章来源--客服
    private String image;   // 封面图片
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
    private Date czrq;  // 添加时间
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+08:00")
    private Date updateTime;  // 编辑时间
    private Integer del; // 是否删除，1正常，0删除
    private String applyOrg;    // 适用机构编码，多个使用逗号分隔
    private String applyOrgName;    // 适用机构名称，多个使用逗号分隔
    private String name;//发布人

    private List<Map<String, Object>> orgTree;  // 机构列表树
    private List<Map<String, Object>> selected; // 已选中的机构（包含code和name）

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getPatient() {
        return patient;
    }

    public void setPatient(String patient) {
        this.patient = patient;
    }

    public String getTitle() {
        return title;
    }

    public void setTitle(String title) {
        this.title = title;
    }

    public String getCategory() {
        return category;
    }

    public void setCategory(String category) {
        this.category = category;
    }

    @Formula("(select c.name from wlyy_knowledge_category c where c.code=category)")
    public String getCategoryName() {
        return categoryName;
    }

    public void setCategoryName(String categoryName) {
        this.categoryName = categoryName;
    }

    public String getContent() {
        return content;
    }

    public void setContent(String content) {
        this.content = content;
    }

    public String getSource() {
        return source;
    }

    public void setSource(String source) {
        this.source = source;
    }

    public String getImage() {
        return image;
    }

    public void setImage(String image) {
        this.image = image;
    }

    public Date getCzrq() {
        return czrq;
    }

    public void setCzrq(Date czrq) {
        this.czrq = czrq;
    }

    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    public Integer getDel() {
        return del;
    }

    public void setDel(Integer del) {
        this.del = del;
    }

    public String getApplyOrg() {
        return applyOrg;
    }

    public void setApplyOrg(String applyOrg) {
        this.applyOrg = applyOrg;
    }

    public String getApplyOrgName() {
        return applyOrgName;
    }

    public void setApplyOrgName(String applyOrgName) {
        this.applyOrgName = applyOrgName;
    }

    @Transient
    public List<Map<String, Object>> getOrgTree() {
        return orgTree;
    }

    public void setOrgTree(List<Map<String, Object>> orgTree) {
        this.orgTree = orgTree;
    }

    @Transient
    public List<Map<String, Object>> getSelected() {
        return selected;
    }

    public void setSelected(List<Map<String, Object>> selected) {
        this.selected = selected;
    }

    @Transient
    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }
}
