package  com.yihu.customer.entity.synergy;

import com.fasterxml.jackson.annotation.JsonFormat;
import  com.yihu.customer.entity.IdEntity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import javax.persistence.Transient;
import java.util.Date;

/**
 * Created by 刘文彬 on 2018/9/27.
 * 协同服务工单表
 */
@Entity
@Table(name = "manage_synergy_workorder")
public class ManageSynergyWorkorderDO extends IdEntity {
    private String code;//服务编号
    /**
     * 服务类型（0、咨询，1、健康教育，2、预约，3、随访，4、问卷调查，5、疾病筛查）
     *  v1.5.7变更：去掉原来的疾病筛查、随访；优化健康教育流程、新增体征测量提醒、新增体检提醒。所以追加类型：6、健康教育-v1.5.7 ，7、体检提醒， 8、体征测量
     */
    private Integer type;
    private Date serviceTime;//服务时间
    private Integer status;//工单状态（0、草稿，1、未接受，2、处理中，3、处理完成，4、退回，5、关闭）
    private Integer priority;//工单优先级（0、普通，1、加急）
    private Date createTime;//创建时间
    private String createUser;//创建人code
    private String createUserName;//创建人名称
    private String remark;//备注
    private Integer createUserType;//创建人类型（1、医生，2、客服）
    private Integer createUserRole;//创建人角色（1、普通，2、管理员）
    private Integer del;//逻辑删除（1、有效，0、删除）
    private String content;//服务内容
    private String relationCode;//根据type关联业务code
    private String relationCodeName;//关联业务名称
    private String returnedRemark;//退回操作备注说明
    private String dealResultRemark;//处理结果
    private String dealResultAccessory;//处理结果附件
    private Integer servicerCount;//服务对象人数
    private String servicerKey;//服务对象其中五个人
    private String receiverCode;//接收人code
    private String receiverName;//接收人名称
    private Integer receiverType;//接收人类型（1、医生，2、客服）
    private String hospital;//创建人所属机构code；
    private String hospitalName;//创建人所属机构名称
    private Date receiverTime;//工单（客服管理员）接收时间
    private Date completeTime;//工单完成时间
    private int read;//工单状态（0已读，1未读）
    /**
     * v1.5.7追加 体征测量提醒类型：1体征异常、2体征未测量
     */
    private Integer reminderType;

    /**
     *
     * v1.5.9追加关闭说明、关闭人员code、关闭人员名称、关闭时间
     */
    private String reason;
    private String closeUser;
    private String closeUserName;
    private Date closeTime;
    private String articleContent;

    @Column(name = "code")
    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    @Column(name = "type")
    public Integer getType() {
        return type;
    }

    public void setType(Integer type) {
        this.type = type;
    }

    @Column(name = "service_time")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+08:00")
    public Date getServiceTime() {
        return serviceTime;
    }

    public void setServiceTime(Date serviceTime) {
        this.serviceTime = serviceTime;
    }

    @Column(name = "status")
    public Integer getStatus() {
        return status;
    }

    public void setStatus(Integer status) {
        this.status = status;
    }

    @Column(name = "priority")
    public Integer getPriority() {
        return priority;
    }

    public void setPriority(Integer priority) {
        this.priority = priority;
    }

    @Column(name = "create_time")
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Column(name = "create_user")
    public String getCreateUser() {
        return createUser;
    }

    public void setCreateUser(String createUser) {
        this.createUser = createUser;
    }

    @Column(name = "create_user_name")
    public String getCreateUserName() {
        return createUserName;
    }

    public void setCreateUserName(String createUserName) {
        this.createUserName = createUserName;
    }

    @Column(name = "remark")
    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }

    @Column(name = "create_user_type")
    public Integer getCreateUserType() {
        return createUserType;
    }

    public void setCreateUserType(Integer createUserType) {
        this.createUserType = createUserType;
    }

    @Column(name = "del")
    public Integer getDel() {
        return del;
    }

    public void setDel(Integer del) {
        this.del = del;
    }

    @Column(name = "content")
    public String getContent() {
        return content;
    }

    public void setContent(String content) {
        this.content = content;
    }

    @Column(name = "relation_code")
    public String getRelationCode() {
        return relationCode;
    }

    public void setRelationCode(String relationCode) {
        this.relationCode = relationCode;
    }

    @Column(name = "relation_code_name")
    public String getRelationCodeName() {
        return relationCodeName;
    }

    public void setRelationCodeName(String relationCodeName) {
        this.relationCodeName = relationCodeName;
    }

    @Column(name = "returned_remark")
    public String getReturnedRemark() {
        return returnedRemark;
    }

    public void setReturnedRemark(String returnedRemark) {
        this.returnedRemark = returnedRemark;
    }

    @Column(name = "deal_result_remark")
    public String getDealResultRemark() {
        return dealResultRemark;
    }

    public void setDealResultRemark(String dealResultRemark) {
        this.dealResultRemark = dealResultRemark;
    }

    @Column(name = "deal_result_accessory")
    public String getDealResultAccessory() {
        return dealResultAccessory;
    }

    public void setDealResultAccessory(String dealResultAccessory) {
        this.dealResultAccessory = dealResultAccessory;
    }

    @Column(name = "servicer_count")
    public Integer getServicerCount() {
        return servicerCount;
    }

    public void setServicerCount(Integer servicerCount) {
        this.servicerCount = servicerCount;
    }

    @Column(name = "servicer_key")
    public String getServicerKey() {
        return servicerKey;
    }

    public void setServicerKey(String servicerKey) {
        this.servicerKey = servicerKey;
    }

    @Column(name = "receiver_code")
    public String getReceiverCode() {
        return receiverCode;
    }

    public void setReceiverCode(String receiverCode) {
        this.receiverCode = receiverCode;
    }

    @Column(name = "receiver_type")
    public Integer getReceiverType() {
        return receiverType;
    }

    public void setReceiverType(Integer receiverType) {
        this.receiverType = receiverType;
    }

    @Column(name = "receiver_name")
    public String getReceiverName() {
        return receiverName;
    }

    public void setReceiverName(String receiverName) {
        this.receiverName = receiverName;
    }

    @Column(name = "hospital")
    public String getHospital() {
        return hospital;
    }

    public void setHospital(String hospital) {
        this.hospital = hospital;
    }

    @Column(name = "hospital_name")
    public String getHospitalName() {
        return hospitalName;
    }

    public void setHospitalName(String hospitalName) {
        this.hospitalName = hospitalName;
    }

    @Column(name = "receiver_time")
    public Date getReceiverTime() {
        return receiverTime;
    }

    public void setReceiverTime(Date receiverTime) {
        this.receiverTime = receiverTime;
    }

    @Column(name = "create_user_role")
    public Integer getCreateUserRole() {
        return createUserRole;
    }

    public void setCreateUserRole(Integer createUserRole) {
        this.createUserRole = createUserRole;
    }

    @Column(name = "complete_time")
    public Date getCompleteTime() {
        return completeTime;
    }

    public void setCompleteTime(Date completeTime) {
        this.completeTime = completeTime;
    }

    @Column(name = "is_read")
    public int  getRead() {
        return read;
    }

    public void setRead(int read) {
        this.read = read;
    }

    public Integer getReminderType() {
        return reminderType;
    }

    public void setReminderType(Integer reminderType) {
        this.reminderType = reminderType;
    }

    @Column(name = "reason")
    public String getReason() {
        return reason;
    }

    public void setReason(String reason) {
        this.reason = reason;
    }

    @Column(name = "close_user")
    public String getCloseUser() {
        return closeUser;
    }

    public void setCloseUser(String closeUser) {
        this.closeUser = closeUser;
    }

    @Column(name = "close_user_name")
    public String getCloseUserName() {
        return closeUserName;
    }

    public void setCloseUserName(String closeUserName) {
        this.closeUserName = closeUserName;
    }

    @Column(name = "close_time")
    @JsonFormat(pattern = "yyyy-MM-dd HH:mm", timezone = "GMT+08:00")
    public Date getCloseTime() {
        return closeTime;
    }

    public void setCloseTime(Date closeTime) {
        this.closeTime = closeTime;
    }

    @Transient
    public String getArticleContent() {
        return articleContent;
    }

    public void setArticleContent(String articleContent) {
        this.articleContent = articleContent;
    }
}
