package  com.yihu.customer.entity.synergy;

import  com.yihu.customer.entity.IdEntity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.util.Date;

/**
 * Created by 刘文彬 on 2018/9/27.
 * 协同服务工单的服务对象表
 */
@Entity
@Table(name = "manage_synergy_workorder_servicer")
public class ManageSynergyWorkorderServicerDO extends IdEntity {
    private String code;
    /**
     * 服务类型（0、咨询，1、健康教育，2、预约，3、随访，4、问卷调查，5、疾病筛查）
     *  v1.5.7变更：去掉原来的疾病筛查、随访；优化健康教育流程、新增体征测量提醒、新增体检提醒。所以追加类型：6、健康教育-v1.5.7 ，7、体检提醒， 8、体征测量
     */
    private Integer workorderType;
    private String workorderCode;//协同服务工单code
    private Integer status;//服务状态（1、待处理，2、处理中，3、处理完成）
    private Date completeTime;//完成时间
    private Date createTime;//创建时间
    private String servicePatientCode;//服务对象（居民）code
    private String servicePatientName;//服务对象（居民）名称
    private String executorCode;//服务执行完成人的code
    private String executorName;//服务执行完成人的名称
    private Integer executorType;//服务完成人类型（1、医生，2、客服）
    private String ssc;//服务对象（居民）社保卡号
    private String idcard;//服务对象（居民）身份证
    private String mobile;//服务对象（居民）联系号码
    private String hospital;//医院机构编码
    private String hospitalName;//机构名称
    private String town;//区县编码
    private String townName;//区县名称
    private String relationCode;//工单类型所关联的业务code
    private String relationCodeName;//关联业务名称

    @Column(name = "code")
    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    @Column(name = "workorder_code")
    public String getWorkorderCode() {
        return workorderCode;
    }

    public void setWorkorderCode(String workorderCode) {
        this.workorderCode = workorderCode;
    }

    @Column(name = "status")
    public Integer getStatus() {
        return status;
    }

    public void setStatus(Integer status) {
        this.status = status;
    }

    @Column(name = "complete_time")
    public Date getCompleteTime() {
        return completeTime;
    }

    public void setCompleteTime(Date completeTime) {
        this.completeTime = completeTime;
    }

    @Column(name = "create_time")
    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    @Column(name = "service_patient_code")
    public String getServicePatientCode() {
        return servicePatientCode;
    }

    public void setServicePatientCode(String servicePatientCode) {
        this.servicePatientCode = servicePatientCode;
    }

    @Column(name = "service_patient_name")
    public String getServicePatientName() {
        return servicePatientName;
    }

    public void setServicePatientName(String servicePatientName) {
        this.servicePatientName = servicePatientName;
    }

    @Column(name = "executor_code")
    public String getExecutorCode() {
        return executorCode;
    }

    public void setExecutorCode(String executorCode) {
        this.executorCode = executorCode;
    }

    @Column(name = "executor_name")
    public String getExecutorName() {
        return executorName;
    }

    public void setExecutorName(String executorName) {
        this.executorName = executorName;
    }

    @Column(name = "executor_type")
    public Integer getExecutorType() {
        return executorType;
    }

    public void setExecutorType(Integer executorType) {
        this.executorType = executorType;
    }

    @Column(name = "ssc")
    public String getSsc() {
        return ssc;
    }

    public void setSsc(String ssc) {
        this.ssc = ssc;
    }

    @Column(name = "idcard")
    public String getIdcard() {
        return idcard;
    }

    public void setIdcard(String idcard) {
        this.idcard = idcard;
    }

    @Column(name = "mobile")
    public String getMobile() {
        return mobile;
    }

    public void setMobile(String mobile) {
        this.mobile = mobile;
    }

    @Column(name = "hospital")
    public String getHospital() {
        return hospital;
    }

    public void setHospital(String hospital) {
        this.hospital = hospital;
    }

    @Column(name = "hospital_name")
    public String getHospitalName() {
        return hospitalName;
    }

    public void setHospitalName(String hospitalName) {
        this.hospitalName = hospitalName;
    }

    @Column(name = "town")
    public String getTown() {
        return town;
    }

    public void setTown(String town) {
        this.town = town;
    }

    @Column(name = "town_name")
    public String getTownName() {
        return townName;
    }

    public void setTownName(String townName) {
        this.townName = townName;
    }

    @Column(name = "relation_code")
    public String getRelationCode() {
        return relationCode;
    }

    public void setRelationCode(String relationCode) {
        this.relationCode = relationCode;
    }

    @Column(name = "workorder_type")
    public Integer getWorkorderType() {
        return workorderType;
    }

    public void setWorkorderType(Integer workorderType) {
        this.workorderType = workorderType;
    }

    @Column(name = "relation_code_name")
    public String getRelationCodeName() {
        return relationCodeName;
    }

    public void setRelationCodeName(String relationCodeName) {
        this.relationCodeName = relationCodeName;
    }
}
