package  com.yihu.customer.entity.vaccin;

import  com.yihu.customer.entity.IdEntity;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.Table;
import java.io.Serializable;

/**
 * Created by wxw on 2019/1/14.
 * 国家疫苗计划表
 * @author wxw.
 */
@Entity
@Table(name = "wlyy_vaccin_plan")
public class VaccinPlan extends IdEntity implements Serializable {
	
	private static final long serialVersionUID = 8358924836164389434L;
	
	// 业务主键
	private String code;
	//识别码
	private String vaccinCode;
	//接种年纪
	// (0:0月龄、1:1月龄、2:2月龄、3 4 5 6 7 8 18(同理以上等于相同的月龄)
	// 24:18~24月龄、25:2岁、26:3岁、27:4岁、28:6岁、29:6~12岁)
	private String inoculationAge;
	//是否间隔打疫苗 0否1是
	private Integer isInterval;
	//间隔时间（月份）
	private Integer intervalTime;
	//是否特定人群 0否 1是
	private Integer specificPopulation;
	//特定人群年纪
	private String specificAge;
	//备注
	private String remark;


	public String getCode() {
		return code;
	}

	public void setCode(String code) {
		this.code = code;
	}

	@Column(name = "vaccin_code")
	public String getVaccinCode() {
		return vaccinCode;
	}

	public void setVaccinCode(String vaccinCode) {
		this.vaccinCode = vaccinCode;
	}

	@Column(name = "inoculation_age")
	public String getInoculationAge() {
		return inoculationAge;
	}

	public void setInoculationAge(String inoculationAge) {
		this.inoculationAge = inoculationAge;
	}

	@Column(name = "is_interval")
	public Integer getIsInterval() {
		return isInterval;
	}

	public void setIsInterval(Integer isInterval) {
		this.isInterval = isInterval;
	}

	@Column(name = "interval_time")
	public Integer getIntervalTime() {
		return intervalTime;
	}

	public void setIntervalTime(Integer intervalTime) {
		this.intervalTime = intervalTime;
	}

	@Column(name = "specific_population")
	public Integer getSpecificPopulation() {
		return specificPopulation;
	}

	public void setSpecificPopulation(Integer specificPopulation) {
		this.specificPopulation = specificPopulation;
	}

	@Column(name = "specific_age")
	public String getSpecificAge() {
		return specificAge;
	}

	public void setSpecificAge(String specificAge) {
		this.specificAge = specificAge;
	}

	public String getRemark() {
		return remark;
	}

	public void setRemark(String remark) {
		this.remark = remark;
	}
}
