/*
package com.yihu.jw.listener;

import com.yihu.jw.entity.ManageFeature;
import com.yihu.jw.filter.RoleCache;
import com.yihu.jw.repository.ManageFeatureDao;
import org.apache.commons.lang3.StringUtils;
import org.springframework.context.ApplicationListener;
import org.springframework.context.event.ContextRefreshedEvent;
import org.springframework.stereotype.Component;


@Component
public class ApplicationStart implements ApplicationListener<ContextRefreshedEvent> {
    @Override
    public void onApplicationEvent(ContextRefreshedEvent contextRefreshedEvent) {
        if (contextRefreshedEvent.getApplicationContext().getParent() == null) {
            RoleCache roleCache = (RoleCache) contextRefreshedEvent.getApplicationContext().getBean("roleCache");
            ManageFeatureDao manageFeatureDao = (ManageFeatureDao) contextRefreshedEvent.getApplicationContext().getBean("manageFeatureDao");
            Iterable<ManageFeature> features = manageFeatureDao.findAll();
            for (ManageFeature feature : features) {
                String url = feature.getUrl();
                if (url != null && !StringUtils.isEmpty(feature.getUrl().trim()))
                    roleCache.addRes(feature.getUrl());
            }
        }

    }
}
*/
