/*******************************************************************************
 * Copyright (c) 2005, 2014 springside.github.io
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 *******************************************************************************/
package  com.yihu.customer.repository;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;

import  com.yihu.customer.entity.Hospital;

import java.util.List;

public interface HospitalDao extends PagingAndSortingRepository<Hospital, Long>,JpaSpecificationExecutor<Hospital>  {
	// 根據CODE查詢医院名称
	@Query("select p from Hospital p where p.code = ?1")
	Hospital findByCode(String code);

    @Query("select p from Hospital p where p.name = ?1")
    Hospital findByName(String name);
	
	@Query("select a from Hospital a where a.name like ?1 and a.id<?2")
	Page<Hospital> getHospitalList(String query, long id, Pageable pageRequest);

    @Modifying
    @Query(value = "update Hospital p set p.del=?1 where p.id=?2 ")
    int updateDel(String del, Long id);

    @Query("select p from Hospital p where p.town = ?1 and p.del='1' and p.level =2 and p.centerSite='00'")
    List<Hospital> findByTownCode(String town);

    @Query("select p from Hospital p where p.city = ?1 and p.del='1' and p.level =2 and p.centerSite='00'")
    List<Hospital> findByCity(String city);

    @Query("select p.code from Hospital p where p.town=?1")
    List<String> findByOrgCodesTown(String town);

    @Query("select DISTINCT p.code from Hospital p where p.city=?1")
    List<String> findAllOrgCodesByCity(String city);

    @Query("select p from Hospital p where p.code like ?1 order by p.code desc ")
    List<Hospital> findByCodePrefix(String codePrefix);

    @Query("select p from Hospital p where p.del = 1 and p.level in (1,2) ")
    List<Hospital> findAllHospital();

}
