/*******************************************************************************
 * Copyright (c) 2005, 2014 springside.github.io
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 *******************************************************************************/
package  com.yihu.customer.repository;

import java.util.List;

import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;

import  com.yihu.customer.entity.HospitalDept;

public interface HospitalDeptDao extends PagingAndSortingRepository<HospitalDept, Long> , JpaSpecificationExecutor<HospitalDept>{

	
// 数据库表字段变更，原接口注释	
//	// 根據CODE查詢科室名称
	@Query("select p from HospitalDept p where p.code = ?1")
	HospitalDept findByCode(String code);
//
//	@Query("from HospitalDept p where p.parent = ?1 and p.del='1' ")
//	List<HospitalDept> findByParent(String parent);
//
//	@Query("from HospitalDept p where (p.parent is not null) and p.del='1' ")
//	List<HospitalDept> findByNoParent();
//
//	@Query("from HospitalDept p where p.parent = ?1 and p.id != ?2 and p.del='1' ")
//	List<HospitalDept> findByParentWithOutId(String parent, Long id);
//
//	@Query("from HospitalDept p where (p.parent is not null) and p.id != ?1 and p.del='1' ")
//	List<HospitalDept> findByNoParentWithOutId(Long id);
//
//	@Query("from HospitalDept p where p.parent = ?1 and p.name=?2 and p.del='1' ")
//	List<HospitalDept> findByParent(String parent, String name);
//
//	@Query("from HospitalDept p where  p.name=?1 and (p.parent is not null) and p.del='1' ")
//	List<HospitalDept> findByNoParent(String name);
//
//	@Query("from HospitalDept p where p.parent = ?1 and p.id != ?3  and p.name=?2 and p.del='1' ")
//	List<HospitalDept> findByParentWithOutId(String parent, String name, Long id);
//
//	@Query("from HospitalDept p where (p.parent is not null) and p.id != ?1  and p.name=?2 and p.del='1' ")
//	List<HospitalDept> findByNoParentWithOutId(Long id, String name);
//
	@Query("from HospitalDept p where  p.hospital=?1 and p.del='1' ")
	List<HospitalDept> getDeptByOrgCode(String orgCode);
//
//	@Query("from HospitalDept p where p.hospital=?1 and p.id!=?2 and p.del='1' ")
//	List<HospitalDept> getDeptByOrgCodeWithOutThis(String orgCode, Long valueOf);

	//根据医院code以及科室名获取数据
	@Query("select p from HospitalDept p where p.del = '1' and p.hospital = ?1 and p.name = ?2")
	HospitalDept findByHospitalCodeAndDeptName(String hospital, String name);
}
