package  com.yihu.customer.repository;

import  com.yihu.customer.entity.DictEntryKey;
import  com.yihu.customer.entity.ManageDictEntry;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;
import org.springframework.data.repository.query.Param;

import java.util.List;

/**
 * Created by Administrator on 2017/1/24.
 */
public interface ManageDictEntryDao extends PagingAndSortingRepository<ManageDictEntry, DictEntryKey> {
    List<ManageDictEntry> findByDictId(long dictId);

    Page<ManageDictEntry> findByDictId(long dictId, Pageable pageable);

    Page<ManageDictEntry> findByDictIdAndValueLike(long dictId, String value, Pageable pageable);

    @Modifying
    void deleteByDictId(long dictId);

    /**
     * 获取字典项下一排序号.
     *
     * @param dictId
     * @return
     */
    @Query("select max(entry.sort) from ManageDictEntry entry where entry.dictId = :dictId")
    Integer getNextEntrySN(@Param("dictId") long dictId);

    /**
     * 批量获取字典项列表.
     *
     * @param dictId
     * @param codes
     * @return
     */
    @Query("select entry from ManageDictEntry entry where entry.dictId = :dictId and entry.code in (:codes) order by entry.sort asc")
    List<ManageDictEntry> findByDictIdAndCodes(@Param("dictId") long dictId, @Param("codes") String[] codes);
}
