package  com.yihu.customer.repository;

import  com.yihu.customer.entity.ManageFeature;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;

import java.util.List;

/**
 * Created by yww on 2016/12/28.
 */
public interface ManageFeatureDao extends PagingAndSortingRepository<ManageFeature, Long> {
    @Query(value = "select count(1) from ManageFeature r where r.code = ?1")
    int isCodeExist(String code);

    @Query(value = "select count(1) from ManageFeature r where  r.name = ?1 and r.parentId = ?2")
    int isNameExist(String name, long parentId);

    @Query(value = "select count(1) from ManageFeature r where  r.url = ?1")
    int isUrlExist(String url);

    //根据角色ids联表查询
    @Query(value = "select distinct f from ManageFeature f,ManageRoleFeature r where f.id = r.featureId and r.roleId in ?1")
    List<ManageFeature> findByRoleIds(long[] roleIds);

    //根据角色id联表查询
    @Query(value = "select f from ManageFeature f where f.id in (select r.featureId from ManageRoleFeature r where r.roleId = ?1)")
    List<ManageFeature> findByRoleId(long roleId);
}
