package  com.yihu.customer.repository;

import  com.yihu.customer.entity.ManageRoleFeature;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;
import org.springframework.data.repository.query.Param;

import java.util.List;

/**
 * Created by yww on 2016/12/28.
 */
public interface ManageRoleFeatureDao extends PagingAndSortingRepository<ManageRoleFeature, Long> {
    @Query("select r from ManageRoleFeature r where r.featureId = :featureId and r.roleId = :roleId")
    ManageRoleFeature findRelation(@Param("featureId") long featureId, @Param("roleId") long roleId);

    @Query(value = "select r  from ManageRoleFeature r  where r.roleId = ?1")
    List<ManageRoleFeature> findByRoleId(long roleId);

    @Modifying
    @Query(value = "delete ManageRoleFeature r where r.roleId = ?1")
    int deleteByRoleId(long roleId);


    @Modifying
    @Query(value = "delete ManageRoleFeature r where r.featureId = ?1")
    int deleteByFeatureId(long featureId);

    @Query(value = "select distinct r.id from ManageRoleFeature r where  r.featureId = ?1")
    List<Long> findByFeatureId(long featureId);

}