package  com.yihu.customer.repository;

import  com.yihu.customer.entity.ManageRoleUser;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;
import org.springframework.data.repository.query.Param;

/**
 * Created by yww on 2016/12/28.
 */
public interface ManageRoleUserDao extends PagingAndSortingRepository<ManageRoleUser, Long> {
    @Query("select r from ManageRoleUser r where r.userCode = :userCode and r.roleId = :roleId")
    ManageRoleUser findRelation(@Param("userCode") String userCode, @Param("roleId") long roleId);

    @Query("select distinct(r.roleId) from ManageRoleUser r where r.userCode = :userCode")
    long[] findByUserCode(@Param("userCode") String userCode);

    @Query("delete ManageRoleUser r where r.userCode = ?1 and r.roleId = ?2")
    int deleteByUserCodeAndRoleId(String userCode, long roleId);

    @Modifying
    @Query(value = "delete ManageRoleUser r where r.userCode =?1")
    int deleteByUserCode(String userCode);

    @Query(value = "select count(1) from ManageRoleUser r where r.roleId =?1 ")
    int isRoleExistUser(long roleId);

}
