package  com.yihu.customer.repository;

import  com.yihu.customer.entity.PatientFamilyMember;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;

import java.util.List;

/**
 * 家庭成员
 * Created by hzp on 2017/02/23.
 */
public interface PatientFamilyMemberDao extends PagingAndSortingRepository<PatientFamilyMember, Long>,
        JpaSpecificationExecutor<PatientFamilyMember> {

    /**
     * 查找某个居民的家庭成员
     *
     * @param patient 居民
     * @return
     */
    @Query(value = "select pfm from PatientFamilyMember pfm where pfm.patient = ?1")
    List<PatientFamilyMember> findByPatient(String patient);
}
