/*******************************************************************************
 * Copyright (c) 2005, 2014 springside.github.io
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 *******************************************************************************/
package  com.yihu.customer.repository;

import  com.yihu.customer.entity.Town;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;

public interface TownDao extends PagingAndSortingRepository<Town, Long> {
	// 根據CODE查詢區縣名稱
	@Query("select p from Town p where p.code = ?1")
	Town findByCode(String code);

	@Query("select a from Town a where a.city = ?1 order by id")
	Iterable<Town> findByCity(String province);

	@Query("select p from Town p where p.name = ?1")
	Town findByName(String name);

	@Query("select p from Town p where p.name = ?1 and p.city = ?2")
	Town findByNameAndCity(String name, String city);
}
