/*******************************************************************************
 * Copyright (c) 2005, 2014 springside.github.io
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 *******************************************************************************/
package  com.yihu.customer.repository;

import java.util.List;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;

import  com.yihu.customer.entity.User;

public interface UserDao extends PagingAndSortingRepository<User, Long>, JpaSpecificationExecutor<User> {


	User findByMobile(String mobile);
	
	User findByCode(String code);
	
	@Query("select a from User a where a.organizationId = ?1")
	List<User> findByOrgid(long orgId);

	@Query("from User a where a.mobile = ?1")
	List<User> findByPhone(String mobile);

	@Query("from User a where a.mobile = ?1 and a.id!=?2")
	List<User> findByPhoneWithOutId(String mobile, Long id);

    @Query("from User a where a.name like ?1 order by code")
    Page<User> searchUsersByName(String name, Pageable pageRequest);

	List<User> findBySeat(String seat);

	User findByJobNo(String jobNo);

	List<User> findByType(int type);

	@Query("from User a where a.type = ?1 and a.online=?2")
	List<User> findByOnline(int type, String online);

	@Query("from User u where u.type IN(3,4)")
    List<User> findAllCustomer();

	List<User> findBySeatAndType(String seat, int type);

	// 查询用户姓名
	@Query("select p.name from User p where p.code=?1")
	String findNameByCode(String code);
}
