/*******************************************************************************
 * Copyright (c) 2005, 2014 springside.github.io
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 *******************************************************************************/
package  com.yihu.customer.repository;

import  com.yihu.customer.entity.UserRole;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;

import java.util.List;

public interface UserRoleDao extends PagingAndSortingRepository<UserRole, Long>, JpaSpecificationExecutor<UserRole> {

	List<UserRole> findByUser(String user);

	@Query("select count(1) from UserRole where role = ?1")
	int countByRole(String role);

	@Modifying
	@Query("delete UserRole where user = ?1 and role = ?2")
	int deleteByUserRole(String user, String role);

	@Modifying
	@Query("delete UserRole where user = ?1 ")
	int deleteByUserRole(String user);

}
