package  com.yihu.customer.repository;

import  com.yihu.customer.entity.WlyyAdminTeam;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;

import java.util.List;

/**
 * Created by yww on 2016/11/15.
 */
public interface WlyyAdminTeamDao extends PagingAndSortingRepository<WlyyAdminTeam,Long>,JpaSpecificationExecutor<WlyyAdminTeam> {
    @Modifying
    @Query(value = "update WlyyAdminTeam t set t.available = ?1 where t.id=?2")
    int updateAvailable(String available, Long id);

    @Query(value = "select distinct(t.id) from WlyyAdminTeam t,Doctor d where t.leaderCode = d.code and t.name like ?1 and d.name like ?2")
    Long[] findByNameAndLeaderNameLike(String name, String leaderName);

    @Query("select t from WlyyAdminTeam t where t.name = ?1 and t.orgCode = ?2")
    WlyyAdminTeam findByNameAndOrgCode(String name, String orgCode);

    @Query("select t from WlyyAdminTeam t where  t.orgCode = ?1")
    List<WlyyAdminTeam> findByOrgCode(String orgCode);

    @Query("select t from WlyyAdminTeam t where t.specialCode=?1 and t.acceptType = ?2 and t.orgCode = ?3 and t.id <>?4 and t.available=1 ")
    WlyyAdminTeam findByDisAndAcceptTypeAndOrgCode(String specialCode, Integer acceptType, String orgCode, Long teamId);

    @Modifying
    @Query(value = "update WlyyAdminTeam t set t.leaderCode =?1,t.specialCode=?2,t.specialName=?3,t.acceptType=?4 where t.id=?5")
    int updateTeamAcceptInfor(String leaderCode, String specialCode, String specialName, Integer acceptType, Long teamId);

}
