package  com.yihu.customer.repository;

import  com.yihu.customer.entity.WlyyDoctorTeamMember;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;

import java.util.List;

/**
 * Created by Administrator on 2016/12/19.
 */
public interface WlyyDoctorTeamMemberDao extends PagingAndSortingRepository<WlyyDoctorTeamMember,Integer> {
    //原成员失效操作
    @Modifying
    @Query(value = "update WlyyDoctorTeamMember m set m.del=0 where m.team=?1")
    int updateDel(String team);

    @Modifying
    @Query(value = "update WlyyDoctorTeamMember m set m.del=0 where m.team=?1 and m.type = ?2")
    int updateDelByTeamAndType(String team, Integer type);

    //批量原成员失效操作(根据team type为2或3）
    @Modifying
    @Query(value = "update WlyyDoctorTeamMember m set m.del=0 where m.type <> 5 and m.type in (2,3) and m.team in ?1")
    int updateDelsByTeamsAndTypes(String[] team);

    @Modifying
    @Query(value = "update WlyyDoctorTeamMember m set m.del=0 where m.type <> 5 and m.type = ?2 and m.team in ?1")
    int updateDelsByTeamsAndType(String[] team, Integer type);


    @Query(value = "select count(1) from WlyyDoctorTeamMember m where m.team = ?1 and m.memberCode = ?2 and m.type = ?3 and m.del = ?4")
    int isMemberExist(String team, String memberCode, Integer type, String del);

    @Query(value = "select m from WlyyDoctorTeamMember m where m.team = ?1 and m.memberCode = ?2 and m.type = ?3 and m.del = ?4")
    List<WlyyDoctorTeamMember> findByTeamAndMemberCodeAndTypeAndDel(String team, String memberCode, Integer type, String del);

}
