package  com.yihu.customer.repository.copd;

import  com.yihu.customer.entity.copd.CopdPatient;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;

import java.util.List;

/**
 * Created by yeshijie on 2021/3/19.
 */
public interface CopdPatientDao extends PagingAndSortingRepository<CopdPatient, Long>, JpaSpecificationExecutor<CopdPatient> {

    @Query("select a from CopdPatient a where a.patient = ?1")
    CopdPatient findByPatient(String patient);

    @Query("select a from CopdPatient a where a.patient is null")
    List<CopdPatient> findListNoPatient();

    @Query("select a from CopdPatient a where a.status=1 and a.del=1")
    List<CopdPatient> findListPatient();

    @Modifying
    @Query("delete from CopdPatient a where a.patient=?1")
    void deleteCopdPatient(String patient);

}
