package  com.yihu.customer.repository.feedback;

import  com.yihu.customer.entity.feedback.Appeal;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;

import java.util.List;

/**
 * Created by Reece on 2017/5/6.
 */
public interface AppealDao extends PagingAndSortingRepository<Appeal, Long>, JpaSpecificationExecutor<Appeal> {
    //根据类型、身份、状态查询申诉列表
    @Query("select  t from  Appeal t where t.type = ?1 and t.identity = ?2 and t.status = ?3 and  t.del = 1 ")
    List<Appeal> findAppealList(int type, int identity, int status, Pageable pageable);

    //    根据申诉ID查询申诉详情
    @Query("select  t from  Appeal t where t.id = ?1 and t.del = 1 ")
    Appeal findFeedbackById(long id);

    //    根据申诉ID更改申诉状态
    @Modifying
    @Query("update Appeal t set t.status = ?2 where t.id = ?1 ")
    void modifyAppealStatus(long id, int status);

    //    根据申诉ID保存处理结果
    @Modifying
    @Query("update Appeal t set t.result = ?2 where t.id = ?1 ")
    void modifyAppealResult(long id, String result);

    @Modifying
    @Query("update Appeal t set t.del = 0 where t.id = ?1 ")
    void delAppeal(Long id);

}
