package  com.yihu.customer.repository.feedback;

import  com.yihu.customer.entity.feedback.Feedback;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;

import java.util.List;

/**
 * Created by Reece on 2017/5/6.
 */
public interface FeedbackDao extends PagingAndSortingRepository<Feedback, Long>, JpaSpecificationExecutor<Feedback> {

    //    根据类型、身份、状态查询列表
    @Query("select  t from Feedback t where t.type = ?1 and t.identity = ?2 and t.status = ?3 and t.del = 1 ")
    List<Feedback> findFeedbackList(int type, int identity, int status, Pageable pageable);

    //    根据反馈ID查询反馈详情
    @Query("select  t from Feedback t where t.id = ?1 and t.del = 1 ")
    Feedback findFeedbackById(long id);

    //    根据反馈ID更改反馈状态
    @Modifying
    @Query("update Feedback t set t.status = ?2 where t.id = ?1 ")
    void modifyFeedbackStatus(long id, int type);

    @Modifying
    @Query("update Feedback t set t.del = 0 where t.id = ?1 ")
    void delFeedback(long id);
}
