package  com.yihu.customer.repository.health;

import  com.yihu.customer.entity.health.HealthPlanTask;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;

import java.util.List;

/**
 * Created by wzn54 on 2018/12/29.
 */
public interface HealthPlanTaskDao extends PagingAndSortingRepository<HealthPlanTask, Long> {
    @Modifying
    @Query("update HealthPlanTask t set t.del=0 where t.healthPlanCode=?1")
    int deleteByHealthPlanCode(String healthPlanCode);


    @Query("select t from HealthPlanTask t where t.healthPlanCode=?1 and t.del=1")
    List<HealthPlanTask> selectByHealthPlanCode(String healthPlanCode);

    @Modifying
    @Query("delete from HealthPlanTask t  where t.healthPlanCode=?1 and t.healthTaskCode=?2")
    int delete(String healthPlanCode, String healthTaskCode);


    @Modifying
    @Query("delete from HealthPlanTask t  where t.healthPlanCode=?1")
    int delete(String healthPlanCode);


    @Query("select t from HealthPlanTask t where t.healthPlanCode=?1 and t.healthTaskCode=?2 and t.del=1")
    HealthPlanTask selectOne(String healthPlanCode, String healthTaskCode);
}
