package  com.yihu.customer.repository.healthchannel;

import  com.yihu.customer.entity.healthchannel.HealthChannelDo;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;

import java.util.List;

/**
 * Created by zdm on 2019/2/15.
 */
public interface ChannelDao  extends PagingAndSortingRepository<HealthChannelDo,Long> {

    @Modifying
    @Query("delete HealthChannelDo c where c.classification = ?1")
    void deleteByClassification(String classification);

    @Modifying
    @Query("UPDATE HealthChannelDo c set c.delFlag = ?2 WHERE c.id= ?1 ")
    void updateDelFlagById(Long channelId, int delFlag);

    @Query("select c from HealthChannelDo c where c.classification = ?1 and c.level = ?2 and c.delFlag = 1 GROUP BY c.code")
    List<HealthChannelDo> getRecommendCategoryByChannelId(String classification, String level);

    @Query("select c.categoryId,c.categoryName from HealthChannelDo c where c.classification = ?1  and c.level = ?2 and c.code = ?3 and c.delFlag = 1")
    List<HealthChannelDo> getCategoryByCode(String classification, String level, String code);
    @Query("select c from HealthChannelDo c where c.classification = ?1  and c.level = ?2 and c.code = ?3 and c.delFlag = 1 group by c.firstLevelCategoryId")
    List<HealthChannelDo> findFirstLevelCategoryIdByLevelAndCode(String classification, String level, String code);

    @Query("select c from HealthChannelDo c where c.classification = ?1  and c.level = ?2 and c.code = ?3 and c.delFlag = 1 and c.firstLevelCategoryId = ?4")
    List<HealthChannelDo> getSecondLevelCategoryId(String classification, String level, String code, String firstLevelCategoryId);

    @Query("SELECT c from HealthChannelDo c where c.level = ?1  order by c.lastUpdateTime desc")
    List<HealthChannelDo> findByLevel(String level, Pageable pageRequest);

    @Query("SELECT count(c.id) from HealthChannelDo c where c.level = ?1  and c.delFlag = 1 ")
    Integer findByLevel(String level);

    @Query("select c from HealthChannelDo c where c.classification = ?1 and c.level = ?2 and c.delFlag = 1 group by c.firstLevelCategoryId")
    List<HealthChannelDo> findByLevelAndClassification(String classification, String level);
}
