/*******************************************************************************
 * Copyright (c) 2005, 2014 springside.github.io
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 *******************************************************************************/
package  com.yihu.customer.repository.pneumonia;

import  com.yihu.customer.entity.pneumonia.PneumoniaAttackAddress;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;

import java.util.List;

public interface PneumoniaAttackAddressDao extends PagingAndSortingRepository<PneumoniaAttackAddress, Long>, JpaSpecificationExecutor<PneumoniaAttackAddress> {

    @Query("SELECT a FROM PneumoniaAttackAddress a  WHERE a.del = '1' ORDER BY a.publishTime DESC")
    Page<PneumoniaAttackAddress> find(Pageable pageRequest);

    @Modifying
    @Query("update PneumoniaAttackAddress a set a.del = 0 where a.code = ?1")
    int updateDel(String code);

    @Query("SELECT a FROM PneumoniaAttackAddress a  WHERE a.del = '1' and a.area=?1 ORDER BY a.publishTime DESC")
    List<PneumoniaAttackAddress> selectByArea(String area);

    @Query("SELECT a FROM PneumoniaAttackAddress a  WHERE a.del=?1 order by a.createTime desc ")
    List<PneumoniaAttackAddress> findByDel(Integer del, Pageable pageRequest);

    @Query("SELECT count(1) FROM PneumoniaAttackAddress a  WHERE a.del=?1")
    Integer findCountByDel(Integer del);

    @Modifying
    @Query("update PneumoniaAttackAddress a set a.del = ?2 where a.id = ?1")
    int updateDelById(Long id, Integer del);
}
