package  com.yihu.customer.repository.pneumonia;

import  com.yihu.customer.entity.pneumonia.PneumoniaAttackArea;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;

import java.util.List;

/**
 * Created by Bing on 2021/9/22.
 */
public interface PneumoniaAttackAreaDao extends PagingAndSortingRepository<PneumoniaAttackArea, Long>,
        JpaSpecificationExecutor<PneumoniaAttackArea> {
    @Query("select a from PneumoniaAttackArea a where a.del=?1")
    List<PneumoniaAttackArea> findByDel(Integer del, Pageable pageRequest);

    @Query("SELECT count(1) FROM PneumoniaAttackArea a  WHERE a.del=?1")
    Integer findCountByDel(Integer del);

    @Modifying
    @Query("update PneumoniaAttackArea a set a.del = ?2 where a.id = ?1")
    int updateDelById(Long id, Integer del);
}
