package  com.yihu.customer.repository.survey;

import  com.yihu.customer.entity.survey.SurveyAdvice;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;

import java.util.List;

/**
 * Created by humingfen on 2018/7/5.
 */
public interface SurveyAdviceDao extends PagingAndSortingRepository<SurveyAdvice,Long>,JpaSpecificationExecutor<SurveyAdvice> {

    @Query(value = "SELECT a.* from wlyy_survey_advice a LEFT JOIN (SELECT * from wlyy_survey_template_advice where template_code=?2) ta on a.code = ta.advice_code where a.disease_type=?1 and ta.advice_code is null",nativeQuery = true)
    List<SurveyAdvice> findAdvice(Integer diseaseType, String templateCode);

    @Query("select s from SurveyAdvice s where s.code = ?1")
    SurveyAdvice findByCode(String adviceCode);

    @Query(value = "SELECT a.* from wlyy_survey_template_advice ta LEFT JOIN wlyy_survey_advice a on ta.advice_code = a.code where ta.template_code = ?1",nativeQuery = true)
    List<SurveyAdvice> findAdviceByTemplateCode(String templateCode);
}
