package  com.yihu.customer.repository.survey;

import  com.yihu.customer.entity.survey.SurveyLabelInfo;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.repository.PagingAndSortingRepository;

import java.util.List;

/**
 * Created by ysj on 2017/3/3.
 */
public interface SurveyLabelInfoDao extends PagingAndSortingRepository<SurveyLabelInfo,Long>,JpaSpecificationExecutor<SurveyLabelInfo> {
    /**
     * 根据类型查找标签列表
     * @param useType 0模板 1问卷
     * @return
     */
    List<SurveyLabelInfo> findByUseType(Integer useType);

    /**
     *
     * @param useType 0模板 1问卷
     * @param relationCode 关联编码
     * @return
     */
    List<SurveyLabelInfo> findByUseTypeAndRelationCode(Integer useType, String relationCode);

    /**
     *
     * @param useType 0模板 1问卷
     * @param relationCode 关联编码
     * @return
     */
    void deleteByUseTypeAndRelationCode(Integer useType, String relationCode);
}
