package  com.yihu.customer.repository.survey;

import  com.yihu.customer.entity.survey.SurveyAdvice;
import  com.yihu.customer.entity.survey.SurveyTemplateAdvice;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;

import javax.transaction.Transactional;
import java.util.List;

public interface SurveyTemplateAdviceDao extends PagingAndSortingRepository<SurveyTemplateAdvice,Long>,JpaSpecificationExecutor<SurveyTemplateAdvice> {

    List<SurveyTemplateAdvice> findByTemplateCode(String templateCode);

    @Query(value = "SELECT a.* from wlyy_survey_template_advice ta LEFT JOIN wlyy_survey_advice a on ta.advice_code = a.code where ta.template_code = ?1",nativeQuery = true)
    List<SurveyAdvice> findAdviceByTemplateCode(String templateCode);

    @Query("delete from SurveyTemplateAdvice s where s.templateCode=?1")
    @Modifying
    @Transactional
    void deleteByTemplateCode(String templateCode);
}
