package  com.yihu.customer.repository.survey;

import  com.yihu.customer.entity.survey.SurveyTemplate;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;

/**
 * Created by yeshijie on 2017/3/7.
 */
public interface SurveyTemplateDao extends PagingAndSortingRepository<SurveyTemplate,Long>,JpaSpecificationExecutor<SurveyTemplate> {
    @Query("from SurveyTemplate where title=?1 and del = 1")
    SurveyTemplate findByTitle(String title);

    @Query("update SurveyTemplate set del = 0 where id=?1 and del = 1")
    @Modifying
    void deleteById(Long id);
    
    @Query("update SurveyTemplate set del = 1 where id=?1 and del = 0")
    @Modifying
    void onlineById(Long id);

    @Query("select t.diseaseType from SurveyTemplate t where t.code = ?1")
    String findByCode(String code);
}
