package  com.yihu.customer.repository.survey;

import  com.yihu.customer.entity.survey.SurveyTemplateOption;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;

import java.util.List;

/**
 * Created by yeshijie on 2017/3/7.
 */
public interface SurveyTemplateOptionDao extends PagingAndSortingRepository<SurveyTemplateOption,Long>,JpaSpecificationExecutor<SurveyTemplateOption> {

    @Query("update SurveyTemplateOption set del = 0 where templateCode=?1 and del = 1")
    @Modifying
    void updateDelByTemplateCode(String templateCode);

    void deleteByTemplateCode(String templateCode);

    @Query("select s from SurveyTemplateOption s where s.templateCode=?1 and s.del=?2 and s.questionCode=?3")
    List<SurveyTemplateOption>  findByTemplateCodeAndDelAndQuestionCode(String templateCode, String del, String questionCode);

}
