package  com.yihu.customer.repository.survey;

import  com.yihu.customer.entity.survey.SurveyTemplateResult;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;

import javax.transaction.Transactional;
import java.util.List;

/**
 * Created by humingfen on 2018/7/5.
 */
public interface  SurveyTemplateResultDao extends PagingAndSortingRepository<SurveyTemplateResult,Long>,JpaSpecificationExecutor<SurveyTemplateResult> {
    @Query("select s from SurveyTemplateResult s where s.templateCode = ?1 and s.del = 1")
    List<SurveyTemplateResult> findByTemplateCode(String templateCode);

    @Query("update SurveyTemplateResult s set s.del = 0 where s.templateCode=?1 and s.del = 1")
    @Modifying
    @Transactional
    void deleteByTemplateCode(String templateCode);

    @Query("update SurveyTemplateResult s set s.del = 1 where s.id = ?1 and s.del = 0")
    @Modifying
    @Transactional
    void updateDel(long id);
}
