package  com.yihu.customer.repository.synergy;

import  com.yihu.customer.entity.synergy.KnowledgeCategoryDO;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;
import org.springframework.data.repository.query.Param;

import java.util.List;

/**
 * Created by wxw on 2018/12/26.
 *
 * @author wxw.
 */
public interface KnowledgeCategoryDao extends PagingAndSortingRepository<KnowledgeCategoryDO, Long> {

    @Query("select c from KnowledgeCategoryDO c where c.del = 1")
    List<KnowledgeCategoryDO> findList();

    @Query(value = "select c.* from wlyy_knowledge_category c where c.code = :code limit 1", nativeQuery = true)
    KnowledgeCategoryDO findByCode(@Param("code") String code);

    @Query("update KnowledgeCategoryDO c set c.del = 0 where c.code = :code")
    @Modifying
    void updateDel(@Param("code") String code);
}
