package  com.yihu.customer.repository.synergy;

import  com.yihu.customer.entity.synergy.ManageSynergyWorkorderServicerDO;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;

import java.util.List;

public interface ManageSynergyWorkorderServicerDao extends PagingAndSortingRepository<ManageSynergyWorkorderServicerDO, Long> {

    @Query(" select count(1) from ManageSynergyWorkorderServicerDO s where s.workorderCode=?1 and s.status=?2 ")
    Integer findByWorkorderCodeCount(String workorderCode, Integer status);

    @Modifying
    @Query("update ManageSynergyWorkorderServicerDO s set s.relationCode = ?2 where s.code = ?1")
    void updateRelationCodeByCode(String serviceCode, String questionResultCode);

    //根据工单code和居民code获取处理完成的服务对象信息
    @Query("select s from ManageSynergyWorkorderServicerDO s where s.workorderCode = ?1 and s.servicePatientCode = ?2 and s.status = 3")
    ManageSynergyWorkorderServicerDO findByWorkOrderCodeAndPatientCode(String workorderCode, String patient);

    //根据工单code和居民code获取未完成的服务对象信息
    @Query("select s from ManageSynergyWorkorderServicerDO s where s.workorderCode = ?1 and s.servicePatientCode = ?2")
    ManageSynergyWorkorderServicerDO findByWorkOrderCodeAndPatientCode1(String workorderCode, String patient);

    @Query("select count(1) from ManageSynergyWorkorderServicerDO s where s.workorderCode=?1 and s.executorCode=?2 and s.status=?3")
    Integer countByWorkorderCodeAndExecutorCodeAndStatus(String workorderCode, String executorCode, Integer status);

    ManageSynergyWorkorderServicerDO findByCode(String code);

    List<ManageSynergyWorkorderServicerDO> findByWorkorderCode(String workorderCode);

    @Modifying
    @Query("update ManageSynergyWorkorderServicerDO s set s.executorCode = ?2,s.executorName=?3,s.executorType=?4 where s.workorderCode = ?1 and s.executorCode is not null")
    Integer updateWorkorderServicer(String workorderCode, String userCode, String userName, Integer userType);
}
