
package com.yihu.customer.service.common;

import com.yihu.customer.service.BaseService;
import  com.yihu.customer.entity.Doctor;
import  com.yihu.customer.entity.SignFamily;
import  com.yihu.customer.repository.DoctorDao;
import  com.yihu.customer.repository.PatientDao;
import  com.yihu.customer.repository.SignFamilyDao;
import com.yihu.customer.util.SendPatientUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

@Component
@Transactional
public class ConsultService extends BaseService {

	@Autowired
	public PatientDao patientDao;
	@Autowired
	public DoctorDao doctorDao;
	@Autowired
	private SignFamilyDao signFamilyDao;
	@Autowired
	private PatientService patientService;

	public void sendMucMessageBySingnType(String doctor,String doctorName,String patient,String  content,String contentType,String title){
		Doctor d = doctorDao.findByCode(doctor);
		SignFamily signFamily = signFamilyDao.findByPatient(patient);//当前签约团队
		if(signFamily==null){
			List<SignFamily> signFamilys = signFamilyDao.findLastJySignByPatient(patient,2);//获取旧的家庭签约关系
			if(signFamilys!=null&&signFamilys.size()>0){
				signFamily = signFamilys.get(0);
			}
		}
		if(signFamily!=null){
			new SendPatientUtil(doctor,doctorName,patient, contentType, content,title,signFamily.getType()+"",signFamily.getTeamCode()).start();
		}else {
			throw new RuntimeException("无法找到签约关系！");
		}
	}
}
