package com.yihu.customer.service.doctor;

import  com.yihu.customer.entity.Doctor;
import  com.yihu.customer.repository.DoctorDao;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

/**
 * @author huangwenjie
 * @date 2018/1/24 16:20
 */
@Service
public class DoctorService {
	
	@Autowired
	private DoctorDao doctorDao;
	@Autowired
	private JdbcTemplate jdbcTemplate;
	
	public Doctor findDoctorByCode(String code) {
		return doctorDao.findByCode(code);
	}

	public List<Map<String, Object>> findConsultAndConcernByHospitalDept(String hostipal) {
		String sql = "select hospital_name hospital,dept_name dept,sum(concern_num) concern,sum(consult_num) consult " +
				"from wlyy_doctor where hospital_name = ? group by hospital_name,dept_name order by dept_name";
		List<Map<String, Object>> list = jdbcTemplate.queryForList(sql, hostipal);
		return list;
	}

	public List<Map<String, Object>> findConsultAndConcernByHospitalDoctor(String hostipal) {
		String sql = "select hospital_name hospital,dept_name dept,`name`,sum(concern_num) concern,sum(consult_num) " +
				"consult from wlyy_doctor where hospital_name = ? group by hospital_name,dept_name,`name` order by dept_name";
		List<Map<String, Object>> list = jdbcTemplate.queryForList(sql, hostipal);
		return list;
	}
}
