/*
package com.yihu.jw.service.export;

import com.yihu.jw.entity.Hospital;
import com.yihu.jw.repository.HospitalDao;
import com.yihu.jw.service.elasticsearch.EsService;
import com.yihu.jw.util.DateUtil;
import jxl.Workbook;
import jxl.write.Label;
import jxl.write.WritableSheet;
import jxl.write.WritableWorkbook;
import jxl.write.WriteException;
import org.apache.commons.lang.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.OutputStream;
import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.*;

*/
/**
 * Created by wxw on 2018/11/7.
 *
 * @author wxw.
 *//*

@Service
public class ExportService {
    private static Logger logger = LoggerFactory.getLogger(ExportService.class);

    @Autowired
    private EsService esService;
    
    private DecimalFormat df = new DecimalFormat("#");

    @Autowired
    private JdbcTemplate jdbcTemplate;
    @Autowired
    private HospitalDao hospitalDao;

    */
/**
     *  Excel基本信息设置
     * @return
     *//*

    public OutputStream setExcelBasicInfo(HttpServletResponse response, String name) throws IOException {
        response.setContentType("application/vnd.ms-excel");
        String fileName = name;
        SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMdd");
        Date date = new Date();
        response.setHeader("Content-Disposition", "attachment; filename="
                + new String(fileName.getBytes("UTF-8"), "ISO8859-1") + "_" + sdf.format(date) + ".xls");
        OutputStream os = response.getOutputStream();
        return os;
    }

    public void healthPush(String start, String end, String city, HttpServletResponse response) {
        try {
            int row = 1;
            // 获取数据 待预约
            List<Map<String, Object>> reserved = esService.getReservedByTime(start, end, city, false);
            // 咨询量
            List<Map<String, Object>> consult = esService.getConsultByTime(start, end, city, false);
            // 未回复
            List<Map<String, Object>> unanswered = esService.getUnansweredByTime(start, end, city, false);
            // 回复及时
            List<Map<String, Object>> reply = esService.getReplyByTime(start, end, city, false);
            // 绑定量
            List<Map<String, Object>> bindingAmount = esService.getBindingAmountByTime(start, end, city, false);
            // 签约已扣费数
            List<Map<String, Object>> contractDeductions = esService.getContractDeductionsByTime(start, end, city, false);
            // 总推送量
            List<Map<String, Object>> totalPushVolume = esService.getTotalPushVolumeByTime(start, end, city, false);
            // 阅读量
            List<Map<String, Object>> readingVolume = esService.getReadingVolumeByTime(start, end, city, false);

            // Excel基本设置
            OutputStream os = this.setExcelBasicInfo(response, "签约状况");

            //处理Excel
            WritableWorkbook book = Workbook.createWorkbook(os);
            WritableSheet sheet = book.createSheet("按区域", 0);
            sheet.addCell(new Label(0, 0, "类型"));
            sheet.addCell(new Label(1, 0, "区域"));
            sheet.addCell(new Label(2, 0, "值"));

            int reservedSize = reserved.size();
            sheet = setSheetInfo(sheet, reserved, reservedSize, row, "townName");
            sheet.mergeCells(0, row, 0, sheet.getRows() - 1);
            sheet.addCell(new Label(0, row, "待预约"));

            row += reservedSize;
            int consultSize = consult.size();
            sheet = setSheetInfo(sheet, consult, consultSize, row, "townName");
            sheet.mergeCells(0, row, 0, sheet.getRows() - 1);
            sheet.addCell(new Label(0, row, "咨询量"));

            row += consultSize;
            int unansweredSize = unanswered.size();
            sheet = setSheetInfo(sheet, unanswered, unansweredSize, row, "townName");
            sheet.mergeCells(0, row, 0, sheet.getRows() - 1);
            sheet.addCell(new Label(0, row, "未回复"));

            row += unansweredSize;
            int replySize = reply.size();
            sheet = setSheetInfo(sheet, reply, replySize, row, "townName");
            sheet.mergeCells(0, row, 0, sheet.getRows() - 1);
            sheet.addCell(new Label(0, row, "回复及时"));

            row += replySize;
            int bindingAmountSize = bindingAmount.size();
            sheet = setSheetInfo(sheet, bindingAmount, bindingAmountSize, row, "townName");
            sheet.mergeCells(0, row, 0, sheet.getRows() - 1);
            sheet.addCell(new Label(0, row, "绑定数"));

            row += bindingAmountSize;
            int contractDeductionsSize = contractDeductions.size();
            sheet = setSheetInfo(sheet, contractDeductions, contractDeductionsSize, row, "townName");
            sheet.mergeCells(0, row, 0, sheet.getRows() - 1);
            sheet.addCell(new Label(0, row, "签约已扣费数"));

            row += contractDeductionsSize;
            int totalPushVolumeSize = totalPushVolume.size();
            sheet = setSheetInfo(sheet, totalPushVolume, totalPushVolumeSize, row, "townName");
            sheet.mergeCells(0, row, 0, sheet.getRows() - 1);
            sheet.addCell(new Label(0, row, "总推送量"));

            row += totalPushVolumeSize;
            int readingVolumeSize = readingVolume.size();
            sheet = setSheetInfo(sheet, readingVolume, readingVolumeSize, row, "townName");
            sheet.mergeCells(0, row, 0, sheet.getRows() - 1);
            sheet.addCell(new Label(0, row, "阅读量"));

            WritableSheet sheet2 = book.createSheet("按机构", 1);
            sheet2 = healthPushHospitalInfo(sheet2,start, end, city);

            book.write();
            book.close();
            os.flush();
            os.close();
        } catch (IOException e) {
            e.printStackTrace();
        } catch (WriteException e) {
            e.printStackTrace();
        }

    }

    public WritableSheet healthPushHospitalInfo(WritableSheet sheet, String start, String end, String city) {
        try {
            int row = 1;
            // 获取数据 待预约
            List<Map<String, Object>> reserved = esService.getReservedByTime(start, end, city, true);
            // 咨询量
            List<Map<String, Object>> consult = esService.getConsultByTime(start, end, city, true);
            // 未回复
            List<Map<String, Object>> unanswered = esService.getUnansweredByTime(start, end, city, true);
            // 回复及时
            List<Map<String, Object>> reply = esService.getReplyByTime(start, end, city, true);
            // 绑定量
            List<Map<String, Object>> bindingAmount = esService.getBindingAmountByTime(start, end, city, true);
            // 签约已扣费数
            List<Map<String, Object>> contractDeductions = esService.getContractDeductionsByTime(start, end, city, true);
            // 总推送量
            List<Map<String, Object>> totalPushVolume = esService.getTotalPushVolumeByTime(start, end, city, true);
            // 阅读量
            List<Map<String, Object>> readingVolume = esService.getReadingVolumeByTime(start, end, city, true);

            sheet.addCell(new Label(0, 0, "类型"));
            sheet.addCell(new Label(1, 0, "区域"));
            sheet.addCell(new Label(2, 0, "社区名称"));
            sheet.addCell(new Label(3, 0, "值"));

            int reservedSize = reserved.size();
            sheet = setSheetInfo(sheet, reserved, reservedSize, row, new String[]{"townName", "hospitalName"});
            sheet.mergeCells(0, row, 0, sheet.getRows() - 1);
            sheet.addCell(new Label(0, row, "待预约"));

            row += reservedSize;
            int consultSize = consult.size();
            sheet = setSheetInfo(sheet, consult, consultSize, row, new String[]{"townName", "hospitalName"});
            sheet.mergeCells(0, row, 0, sheet.getRows() - 1);
            sheet.addCell(new Label(0, row, "咨询量"));

            row += consultSize;
            int unansweredSize = unanswered.size();
            sheet = setSheetInfo(sheet, unanswered, unansweredSize, row, new String[]{"townName", "hospitalName"});
            sheet.mergeCells(0, row, 0, sheet.getRows() - 1);
            sheet.addCell(new Label(0, row, "未回复"));

            row += unansweredSize;
            int replySize = reply.size();
            sheet = setSheetInfo(sheet, reply, replySize, row, new String[]{"townName", "hospitalName"});
            sheet.mergeCells(0, row, 0, sheet.getRows() - 1);
            sheet.addCell(new Label(0, row, "回复及时"));

            row += replySize;
            int bindingAmountSize = bindingAmount.size();
            sheet = setSheetInfo(sheet, bindingAmount, bindingAmountSize, row, new String[]{"townName", "hospitalName"});
            sheet.mergeCells(0, row, 0, sheet.getRows() - 1);
            sheet.addCell(new Label(0, row, "绑定数"));

            row += bindingAmountSize;
            int contractDeductionsSize = contractDeductions.size();
            sheet = setSheetInfo(sheet, contractDeductions, contractDeductionsSize, row, new String[]{"townName", "hospitalName"});
            sheet.mergeCells(0, row, 0, sheet.getRows() - 1);
            sheet.addCell(new Label(0, row, "签约已扣费数"));

            row += contractDeductionsSize;
            int totalPushVolumeSize = totalPushVolume.size();
            sheet = setSheetInfo(sheet, totalPushVolume, totalPushVolumeSize, row, new String[]{"townName", "hospitalName"});
            sheet.mergeCells(0, row, 0, sheet.getRows() - 1);
            sheet.addCell(new Label(0, row, "总推送量"));

            row += totalPushVolumeSize;
            int readingVolumeSize = readingVolume.size();
            sheet = setSheetInfo(sheet, readingVolume, readingVolumeSize, row, new String[]{"townName", "hospitalName"});
            sheet.mergeCells(0, row, 0, sheet.getRows() - 1);
            sheet.addCell(new Label(0, row, "阅读量"));

        } catch (WriteException e) {
            e.printStackTrace();
        }
        return sheet;
    }
    
    private WritableSheet setSheetInfo(WritableSheet sheet, List<Map<String, Object>> list, int size, int row, String... name) throws WriteException {
        if (null != list && list.size() > 0 && list.get(0).size() > 0) {
            for(int i = 0; i < size; i++) {
                Map<String, Object> objMap = list.get(i);
                int length = name.length;
                switch (length) {
                    case 1 :
                        sheet.addCell(new Label(1, row + i, String.valueOf(objMap.get(name[0]))));
                        sheet.addCell(new Label(2, row + i, df.format(objMap.get("result1"))));
                        break;
                    case 2 :
                        sheet.addCell(new Label(1, row + i, String.valueOf(objMap.get(name[0]))));
                        sheet.addCell(new Label(2, row + i, String.valueOf(objMap.get(name[1]))));
                        sheet.addCell(new Label(3, row + i, df.format(objMap.get("result1"))));
                        break;
                    default:
                        break;
                }
            }
        }
        return sheet;
    }

    */
/**
     * 家庭医生签约信息
     * @param start
     * @param end
     * @param response
     * @throws WriteException
     * @throws IOException
     *//*

    public void signService(String start, String end, String city, HttpServletResponse response) throws WriteException, IOException {

        Calendar calendar = Calendar.getInstance();
        Date date = DateUtil.strToDate(start, DateUtil.YYYY_MM_DD);
        calendar.setTime(date);
        // 获取start的上一年签约年份
        Calendar calendar1 = Calendar.getInstance();
        calendar1.setTime(DateUtil.strToDate(start,DateUtil.YYYY_MM_DD));
        String year = DateUtil.getSignYear(calendar1)-1+"";

        List<Map<String, Object>> singOrRenewAmount = esService.getLastYearSingAmount("1", year, city);
        List<Map<String, Object>> hypertensionAmount = esService.getAmount("17", year, city, "1");
        List<Map<String, Object>> diabetesAmount = esService.getAmount("17", year, city, "2");
        List<Map<String, Object>> elderlyAmount = esService.getAmount("17", year, city, "3");

        // Excel基本设置
        OutputStream os = this.setExcelBasicInfo(response, "续签率统计");

        //处理Excel
        WritableWorkbook book = Workbook.createWorkbook(os);
        WritableSheet sheet = book.createSheet("去年签约量", 0);
        sheet = familyDoctorSheet(sheet, singOrRenewAmount, elderlyAmount, hypertensionAmount, diabetesAmount);

        WritableSheet sheet2 = book.createSheet("续签数", 1);
        List<Map<String, Object>> singOrRenewAmount44 = esService.getSingOrRenewAmount("43", start, end, city);
        List<Map<String, Object>> hypertensionAmount54 = esService.getHypertensionAmount("53", start, end, city);
        List<Map<String, Object>> diabetesAmount54 = esService.getDiabetesAmount("53", start, end, city);
        List<Map<String, Object>> elderlyAmount54 = esService.getElderlyAmount("53", start, end, city);
        sheet2 = familyDoctorSheet(sheet2, singOrRenewAmount44, elderlyAmount54, hypertensionAmount54, diabetesAmount54);

        book.write();
        book.close();
        os.flush();
        os.close();
    }

    private WritableSheet familyDoctorSheet(WritableSheet sheet, List<Map<String, Object>> singOrRenewAmount,
                List<Map<String, Object>> elderlyAmount, List<Map<String, Object>> hypertensionAmount,
                List<Map<String, Object>> diabetesAmount) throws WriteException {
        int row = 1;
        sheet.addCell(new Label(0, 0, "类型"));
        sheet.addCell(new Label(1, 0, "区域"));
        sheet.addCell(new Label(2, 0, "单位"));
        sheet.addCell(new Label(3, 0, "值"));

        int singOrRenewAmountSize = singOrRenewAmount.size();
        sheet = setSheetInfo(sheet, singOrRenewAmount, singOrRenewAmountSize, row, new String[]{"townName", "hospitalName"});
        sheet.mergeCells(0, row, 0, sheet.getRows() - 1);
        sheet.addCell(new Label(0, row, "签约总数"));

        row += singOrRenewAmountSize;
        int elderlyAmountSize = elderlyAmount.size();
        sheet = setSheetInfo(sheet, elderlyAmount, elderlyAmountSize, row, new String[]{"townName", "hospitalName"});
        sheet.mergeCells(0, row, 0, sheet.getRows() - 1);
        sheet.addCell(new Label(0, row, "65岁以上老年人"));

        row += elderlyAmountSize;
        int hypertensionAmountSize = hypertensionAmount.size();
        sheet = setSheetInfo(sheet, hypertensionAmount, hypertensionAmountSize, row, new String[]{"townName", "hospitalName"});
        sheet.mergeCells(0, row, 0, sheet.getRows() - 1);
        sheet.addCell(new Label(0, row, "高血压"));

        row += hypertensionAmountSize;
        int diabetesAmountSize = diabetesAmount.size();
        sheet = setSheetInfo(sheet, diabetesAmount, diabetesAmountSize, row, new String[]{"townName", "hospitalName"});
        sheet.mergeCells(0, row, 0, sheet.getRows() - 1);
        sheet.addCell(new Label(0, row, "糖尿病"));

        return sheet;
    }

    */
/**
     * XX医院各团队数据
     * @param start
     * @param end
     * @param response
     * @throws WriteException
     * @throws IOException
     *//*

    public void teamInfo(String start, String end, String hospital, HttpServletResponse response) throws WriteException, IOException {
        // 21微信绑定数
        List<Map<String, Object>> wxBinding = esService.getTeamInfo("21", hospital, start, end);
        // 1签约已扣费
        List<Map<String, Object>> contractDeductions = esService.getTeamInfo("1", hospital, start, end);
        // 3咨询量
        List<Map<String, Object>> consult = esService.getTeamInfo("3", hospital, start, end);
        // 23及时回复
        List<Map<String, Object>> reply = esService.getTeamInfo("23", hospital, start, end);
        // 83健康教育
        List<Map<String, Object>> healthEdu = esService.getTeamInfo("83", hospital, start, end);
        // 5健康指导
        List<Map<String, Object>> healthGuide = esService.getTeamInfo("5", hospital, start, end);

        // Excel基本设置
        OutputStream os = this.setExcelBasicInfo(response, "运营数据");

        //处理Excel
        WritableWorkbook book = Workbook.createWorkbook(os);
        WritableSheet sheet = book.createSheet("按机构", 0);
        sheet = teamInfoSheet(sheet, wxBinding, contractDeductions, consult, reply, healthEdu, healthGuide);

        book.write();
        book.close();
        os.flush();
        os.close();
    }

    private WritableSheet teamInfoSheet(WritableSheet sheet, List<Map<String, Object>> wxBinding, List<Map<String, Object>> contractDeductions,
                List<Map<String, Object>> consult, List<Map<String, Object>> reply, List<Map<String, Object>> healthEdu,
                List<Map<String, Object>> healthGuide) throws WriteException {
        int row = 1;
        sheet.addCell(new Label(0, 0, "类型"));
        sheet.addCell(new Label(1, 0, "团队"));
        sheet.addCell(new Label(2, 0, "值"));

        int wxBindingSize = wxBinding.size();
        sheet = setSheetInfo(sheet, wxBinding, wxBindingSize, row, "teamName");
        sheet.mergeCells(0, row, 0, sheet.getRows() - 1);
        sheet.addCell(new Label(0, row, "i健康微信绑定数"));

        row += wxBindingSize;
        int contractDeductionsSize = contractDeductions.size();
        sheet = setSheetInfo(sheet, contractDeductions, contractDeductionsSize, row, "teamName");
        sheet.mergeCells(0, row, 0, sheet.getRows() - 1);
        sheet.addCell(new Label(0, row, "签约已扣费"));

        row += contractDeductionsSize;
        int consultSize = consult.size();
        sheet = setSheetInfo(sheet, consult, consultSize, row, "teamName");
        sheet.mergeCells(0, row, 0, sheet.getRows() - 1);
        sheet.addCell(new Label(0, row, "咨询量"));

        row += consultSize;
        int replySize = reply.size();
        sheet = setSheetInfo(sheet, reply, replySize, row, "teamName");
        sheet.mergeCells(0, row, 0, sheet.getRows() - 1);
        sheet.addCell(new Label(0, row, "24小时回复量"));

        row += replySize;
        int healthEduSize = healthEdu.size();
        sheet = setSheetInfo(sheet, healthEdu, healthEduSize, row, "teamName");
        sheet.mergeCells(0, row, 0, sheet.getRows() - 1);
        sheet.addCell(new Label(0, row, "健康教育"));

        row += healthEduSize;
        int healthGuideSize = healthGuide.size();
        sheet = setSheetInfo(sheet, healthGuide, healthGuideSize, row, "teamName");
        sheet.mergeCells(0, row, 0, sheet.getRows() - 1);
        sheet.addCell(new Label(0, row, "健康指导"));

        return sheet;
    }

    */
/**
     * 长处方
     * @param start
     * @param end
     * @param city
     * @param response
     * @throws WriteException
     * @throws IOException
     *//*

    public void prescriptionService(String start, String end, String city, HttpServletResponse response) throws WriteException, IOException {
        List<Map<String, Object>> total = esService.getPrescriptionInfo("64", null, start, end, city, false);
        List<Map<String, Object>> ongoing = esService.getPrescriptionInfo("64", "1", start, end, city, false);
        List<Map<String, Object>> finished = esService.getPrescriptionInfo("64", "2", start, end, city, false);
        List<Map<String, Object>> cancel = esService.getPrescriptionInfo("64", "3", start, end, city, false);
        List<Map<String, Object>> auditFail = esService.getPrescriptionInfo("64", "4", start, end, city, false);
        List<Map<String, Object>> other = esService.getPrescriptionInfo("64", "5", start, end, city, false);


        // Excel基本设置
        OutputStream os = this.setExcelBasicInfo(response, "长处方统计");

        //处理Excel
        WritableWorkbook book = Workbook.createWorkbook(os);
        WritableSheet sheet = book.createSheet("按区县", 0);
        sheet = prescriptionSheet(sheet, total, ongoing, finished, cancel, auditFail, other);

        WritableSheet sheet2 = book.createSheet("按机构", 1);
        List<Map<String, Object>> totalLow = esService.getPrescriptionInfo("64", null, start, end, city, true);
        List<Map<String, Object>> ongoingLow = esService.getPrescriptionInfo("64", "1", start, end, city, true);
        List<Map<String, Object>> finishedLow = esService.getPrescriptionInfo("64", "2", start, end, city, true);
        List<Map<String, Object>> cancelLow = esService.getPrescriptionInfo("64", "3", start, end, city, true);
        List<Map<String, Object>> auditFailLow = esService.getPrescriptionInfo("64", "4", start, end, city, true);
        List<Map<String, Object>> otherLow = esService.getPrescriptionInfo("64", "5", start, end, city, true);
        sheet2 = prescriptionLowSheet(sheet2, totalLow, ongoingLow, finishedLow, cancelLow, auditFailLow, otherLow);

        book.write();
        book.close();
        os.flush();
        os.close();
    }

    private WritableSheet prescriptionSheet(WritableSheet sheet, List<Map<String, Object>> total,
                                            List<Map<String, Object>> ongoing, List<Map<String, Object>> finished,
                                            List<Map<String, Object>> cancel, List<Map<String, Object>> auditFail,
                                            List<Map<String, Object>> other) throws WriteException {
        int row = 1;
        sheet.addCell(new Label(0, 0, "类型"));
        sheet.addCell(new Label(1, 0, "区域"));
        sheet.addCell(new Label(2, 0, "值"));

        int totalSize = total.size();
        sheet = setSheetInfo(sheet, total, totalSize, row, new String[]{"townName"});
        sheet.mergeCells(0, row, 0, sheet.getRows() - 1);
        sheet.addCell(new Label(0, row, "续方总量"));

        row += totalSize;
        int ongoingSize = ongoing.size();
        sheet = setSheetInfo(sheet, ongoing, ongoingSize, row, new String[]{"townName"});
        sheet.mergeCells(0, row, 0, sheet.getRows() - 1);
        sheet.addCell(new Label(0, row, "进行中"));

        row += ongoingSize;
        int finishedSize = finished.size();
        sheet = setSheetInfo(sheet, finished, finishedSize, row, new String[]{"townName"});
        sheet.mergeCells(0, row, 0, sheet.getRows() - 1);
        sheet.addCell(new Label(0, row, "已完成"));

        row += finishedSize;
        int cancelSize = cancel.size();
        sheet = setSheetInfo(sheet, cancel, cancelSize, row, new String[]{"townName"});
        sheet.mergeCells(0, row, 0, sheet.getRows() - 1);
        sheet.addCell(new Label(0, row, "已取消"));

        row += finishedSize;
        int auditFailSize = auditFail.size();
        sheet = setSheetInfo(sheet, auditFail, auditFailSize, row, new String[]{"townName"});
        sheet.mergeCells(0, row, 0, sheet.getRows() - 1);
        sheet.addCell(new Label(0, row, "审核不通过"));

        row += auditFailSize;
        int otherSize = other.size();
        sheet = setSheetInfo(sheet, other, otherSize, row, new String[]{"townName"});
        sheet.mergeCells(0, row, 0, sheet.getRows() - 1);
        sheet.addCell(new Label(0, row, "其他原因取消"));

        return sheet;
    }

    private WritableSheet prescriptionLowSheet(WritableSheet sheet, List<Map<String, Object>> total,
                                            List<Map<String, Object>> ongoing, List<Map<String, Object>> finished,
                                            List<Map<String, Object>> cancel, List<Map<String, Object>> auditFail,
                                            List<Map<String, Object>> other) throws WriteException {
        int row = 1;
        sheet.addCell(new Label(0, 0, "类型"));
        sheet.addCell(new Label(1, 0, "区域"));
        sheet.addCell(new Label(2, 0, "社区名称"));
        sheet.addCell(new Label(3, 0, "值"));

        int totalSize = total.size();
        sheet = setSheetInfo(sheet, total, totalSize, row, new String[]{"townName", "hospitalName"});
        sheet.mergeCells(0, row, 0, sheet.getRows() - 1);
        sheet.addCell(new Label(0, row, "续方总量"));

        row += totalSize;
        int ongoingSize = ongoing.size();
        sheet = setSheetInfo(sheet, ongoing, ongoingSize, row, new String[]{"townName", "hospitalName"});
        sheet.mergeCells(0, row, 0, sheet.getRows() - 1);
        sheet.addCell(new Label(0, row, "进行中"));

        row += ongoingSize;
        int finishedSize = finished.size();
        sheet = setSheetInfo(sheet, finished, finishedSize, row, new String[]{"townName", "hospitalName"});
        sheet.mergeCells(0, row, 0, sheet.getRows() - 1);
        sheet.addCell(new Label(0, row, "已完成"));

        row += finishedSize;
        int cancelSize = cancel.size();
        sheet = setSheetInfo(sheet, cancel, cancelSize, row, new String[]{"townName", "hospitalName"});
        sheet.mergeCells(0, row, 0, sheet.getRows() - 1);
        sheet.addCell(new Label(0, row, "已取消"));

        row += finishedSize;
        int auditFailSize = auditFail.size();
        sheet = setSheetInfo(sheet, auditFail, auditFailSize, row, new String[]{"townName", "hospitalName"});
        sheet.mergeCells(0, row, 0, sheet.getRows() - 1);
        sheet.addCell(new Label(0, row, "审核不通过"));

        row += auditFailSize;
        int otherSize = other.size();
        sheet = setSheetInfo(sheet, other, otherSize, row, new String[]{"townName", "hospitalName"});
        sheet.mergeCells(0, row, 0, sheet.getRows() - 1);
        sheet.addCell(new Label(0, row, "其他原因取消"));

        return sheet;
    }

    */
/**
     * 咨询
     * @param start
     * @param end
     * @param city
     * @param town
     * @param hospital
     * @param response
     * @throws Exception
     *//*

    public void consultService(String start, String end, String city,String town, String hospital, HttpServletResponse response) throws Exception {
        Integer flag = 0; // 标识今年或往年 1：今年    0：往年
        String search = "city";
        String code = city;
        int nowYear = DateUtil.getSignYear(); // 获取现在所属的签约年份
        Date date = DateUtil.strToDate(start, DateUtil.YYYY_MM_DD);
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(date);
        int signYear = DateUtil.getSignYear(calendar);   // 获取签约年份
        if (nowYear == signYear) {
            flag = 1;
        }

        if (StringUtils.isNotEmpty(hospital)) {
            search = "hospital";
            code = hospital;
        } else if (StringUtils.isNotEmpty(town)) {
            search = "town";
            code = town;
        }

        // Excel基本设置
        OutputStream os = this.setExcelBasicInfo(response, "居民咨询分析");
        //处理Excel
        WritableWorkbook book = Workbook.createWorkbook(os);
        WritableSheet sheet = book.createSheet("居民咨询分析", 0);
        if ("city".equals(search)) {
            sheet = citySheet(sheet, flag, signYear, "town", start, end, code);
        } else if ("town".equals(search)) {
            sheet = townSheet(sheet, flag, signYear, search, start, end, code);
        } else if ("hospital".equals(search)) {
            sheet = townSheet(sheet, flag, signYear, "hospital", start, end, code);
        }

        book.write();
        book.close();
        os.flush();
        os.close();
    }

    public WritableSheet citySheet(WritableSheet sheet,Integer flag, Integer signYear, String search, String start, String end, String code) throws Exception {
        List<Map<String, Object>> listAll = this.consultCityList(flag, signYear, start, end);
        List<Map<String, Object>> distinctListAll = this.consultCityDistinctList(flag, signYear, start, end);

        List<Map<String, Object>> list = this.handleList(listAll, "350203");
        List<Map<String, Object>> distinctList = this.handleList(distinctListAll, "350203");
        List<Map<String, Object>> result1 = fillList(list, distinctList);

        List<Map<String, Object>> list2 = this.handleList(listAll, "350206");
        List<Map<String, Object>> distinctList2 = this.handleList(distinctListAll, "350206");
        List<Map<String, Object>> result2 = fillList(list2, distinctList2);

        List<Map<String, Object>> list3 = this.handleList(listAll, "350205");
        List<Map<String, Object>> distinctList3 = this.handleList(distinctListAll, "350205");
        List<Map<String, Object>> result3 = fillList(list3, distinctList3);

        List<Map<String, Object>> list4 = this.handleList(listAll, "350211");
        List<Map<String, Object>> distinctList4 = this.handleList(distinctListAll, "350211");
        List<Map<String, Object>> result4 = fillList(list4, distinctList4);

        List<Map<String, Object>> list5 = this.handleList(listAll, "350212");
        List<Map<String, Object>> distinctList5 = this.handleList(distinctListAll, "350212");
        List<Map<String, Object>> result5 = fillList(list5, distinctList5);

        List<Map<String, Object>> list6 = this.handleList(listAll, "350213");
        List<Map<String, Object>> distinctList6 = this.handleList(distinctListAll, "350213");
        List<Map<String, Object>> result6 = fillList(list6, distinctList6);

        List<Map<String, Object>> list7 = this.consultList(flag, signYear, "city", start, end, "350200");
        List<Map<String, Object>> distinctList7 = this.consultDistinctList(flag, signYear, "city", start, end, "350200");
        List<Map<String, Object>> result7 = fillList(list7, distinctList7);

        sheet = setSheetInfo(sheet, result1, result2, result3, result4, result5, result6, result7, "咨询");
        return sheet;
    }

    public WritableSheet townSheet(WritableSheet sheet,Integer flag, Integer signYear, String search, String start, String end, String code) throws Exception {
        List<Map<String, Object>> list = this.consultList(flag, signYear, search, start, end, code);
        List<Map<String, Object>> distinctList = this.consultDistinctList(flag, signYear, search, start, end, code);
        List<Map<String, Object>> result = fillList(list, distinctList);
        sheet.addCell(new Label(0, 0, "地区"));
        sheet.addCell(new Label(1, 0, "人群"));
        sheet.addCell(new Label(2, 0, "咨询人次"));
        sheet.addCell(new Label(3, 0, "咨询人数"));

        int row = 1;
        List<Map<String, Object>> objList = result;
        if (null != objList && objList.size() > 0 && objList.get(0).size() > 0) {
            for(int i = 0; i< objList.size(); i ++) {
                Map<String, Object> objMap = objList.get(i);
                sheet.addCell(new Label(1, i + 1, String.valueOf(objMap.get("server_type"))));
                sheet.addCell(new Label(2, i + 1, String.valueOf(objMap.get("result1"))));
                sheet.addCell(new Label(3, i + 1, String.valueOf(objMap.get("result2"))));
            }
            sheet.mergeCells(0, row, 0, sheet.getRows() - 1);
            sheet.addCell(new Label(0, row, codeExchange(code)));
        }
        return sheet;
    }

    */
/**
     * 预约
     * @param start
     * @param end
     * @param city
     * @param town
     * @param hospital
     * @param response
     * @throws Exception
     *//*

    public void appointmentService(String start, String end, String city,String town, String hospital, HttpServletResponse response) throws Exception {
        Integer flag = 0; // 标识今年或往年 1：今年    0：往年
        String search = "city";
        String code = city;
        int nowYear = DateUtil.getSignYear(); // 获取现在所属的签约年份
        Date date = DateUtil.strToDate(start, DateUtil.YYYY_MM_DD);
        Calendar calendar = Calendar.getInstance();
        calendar.setTime(date);
        int signYear =DateUtil.getSignYear(calendar);   // 获取签约年份
        if (nowYear == signYear) {
            flag = 1;
        }

        if (StringUtils.isNotEmpty(hospital)) {
            search = "hospital";
            code = hospital;
        } else if (StringUtils.isNotEmpty(town)) {
            search = "town";
            code = town;
        }

        // Excel基本设置
        OutputStream os = this.setExcelBasicInfo(response, "居民预约分析");
        //处理Excel
        WritableWorkbook book = Workbook.createWorkbook(os);
        WritableSheet sheet = book.createSheet("居民预约分析", 0);
        if ("city".equals(search)) {
            sheet = appointmentCitySheet(sheet, flag, signYear, "town", start, end, code);
        } else if ("town".equals(search)) {
            sheet = appointmentTownSheet(sheet, flag, signYear, search, start, end, code);
        } else if ("hospital".equals(search)) {
            sheet = appointmentTownSheet(sheet, flag, signYear, "hospital", start, end, code);
        }

        book.write();
        book.close();
        os.flush();
        os.close();
    }

    public WritableSheet appointmentCitySheet(WritableSheet sheet,Integer flag, Integer signYear, String search, String start, String end, String code) throws Exception {
        List<Map<String, Object>> listAll = this.appointmentCityList(flag, signYear, start, end);
        List<Map<String, Object>> distinctListAll = this.appointmentCityDistinctList(flag, signYear, start, end);

        List<Map<String, Object>> list = this.handleList(listAll, "350203");
        List<Map<String, Object>> distinctList = this.handleList(distinctListAll, "350203");;
        List<Map<String, Object>> result1 = fillList(list, distinctList);

        List<Map<String, Object>> list2 = this.handleList(listAll, "350206");
        List<Map<String, Object>> distinctList2 = this.handleList(distinctListAll, "350206");
        List<Map<String, Object>> result2 = fillList(list2, distinctList2);

        List<Map<String, Object>> list3 = this.handleList(listAll, "350205");
        List<Map<String, Object>> distinctList3 = this.handleList(distinctListAll, "350205");
        List<Map<String, Object>> result3 = fillList(list3, distinctList3);

        List<Map<String, Object>> list4 = this.handleList(listAll, "350211");
        List<Map<String, Object>> distinctList4 = this.handleList(distinctListAll, "350211");
        List<Map<String, Object>> result4 = fillList(list4, distinctList4);

        List<Map<String, Object>> list5 = this.handleList(listAll, "350212");
        List<Map<String, Object>> distinctList5 = this.handleList(distinctListAll, "350212");
        List<Map<String, Object>> result5 = fillList(list5, distinctList5);

        List<Map<String, Object>> list6 = this.handleList(listAll, "350213");
        List<Map<String, Object>> distinctList6 = this.handleList(distinctListAll, "350213");
        List<Map<String, Object>> result6 = fillList(list6, distinctList6);

        List<Map<String, Object>> list7 = this.appointmentList(flag, signYear, "city", start, end, "350200");
        List<Map<String, Object>> distinctList7 = this.appointmentDistinctList(flag, signYear, "city", start, end, "350200");
        List<Map<String, Object>> result7 = fillList(list7, distinctList7);

        sheet = setSheetInfo(sheet, result1, result2, result3, result4, result5, result6, result7, "预约");
        return sheet;
    }

    public WritableSheet appointmentTownSheet(WritableSheet sheet,Integer flag, Integer signYear, String search, String start, String end, String code) throws Exception {
        List<Map<String, Object>> list = this.appointmentList(flag, signYear, search, start, end, code);
        List<Map<String, Object>> distinctList = this.appointmentDistinctList(flag, signYear, search, start, end, code);
        List<Map<String, Object>> result = fillList(list, distinctList);
        sheet.addCell(new Label(0, 0, "地区"));
        sheet.addCell(new Label(1, 0, "人群"));
        sheet.addCell(new Label(2, 0, "预约人次"));
        sheet.addCell(new Label(3, 0, "预约人数"));

        int row = 1;
        List<Map<String, Object>> objList = result;
        if (null != objList && objList.size() > 0 && objList.get(0).size() > 0) {
            for(int i = 0; i< objList.size(); i ++) {
                Map<String, Object> objMap = objList.get(i);
                sheet.addCell(new Label(1, i + 1, String.valueOf(objMap.get("server_type"))));
                sheet.addCell(new Label(2, i + 1, String.valueOf(objMap.get("result1"))));
                sheet.addCell(new Label(3, i + 1, String.valueOf(objMap.get("result2"))));
            }
            sheet.mergeCells(0, row, 0, sheet.getRows() - 1);
            sheet.addCell(new Label(0, row, codeExchange(code)));
        }
        return sheet;
    }

    public WritableSheet setSheetInfo(WritableSheet sheet, List<Map<String, Object>> result, List<Map<String, Object>> result2,
                                      List<Map<String, Object>> result3, List<Map<String, Object>> result4, List<Map<String, Object>> result5,
                                      List<Map<String, Object>> result6, List<Map<String, Object>> result7, String name) throws Exception {
        int row = 1;
        sheet.addCell(new Label(0, 0, "地区"));
        sheet.addCell(new Label(1, 0, "人群"));
        sheet.addCell(new Label(2, 0, name + "人次"));
        sheet.addCell(new Label(3, 0, name + "人数"));

        int resultSize = result.size();
        sheet = setSheetInfo(sheet, result, resultSize, row);
        sheet.mergeCells(0, row, 0, sheet.getRows() - 1);
        sheet.addCell(new Label(0, row, "思明区"));

        row += resultSize;
        int result2Size = result2.size();
        sheet = setSheetInfo(sheet, result2, result2Size, row);
        sheet.mergeCells(0, row, 0, sheet.getRows() - 1);
        sheet.addCell(new Label(0, row, "湖里区"));

        row += result2Size;
        int result3Size = result3.size();
        sheet = setSheetInfo(sheet, result3, result3Size, row);
        sheet.mergeCells(0, row, 0, sheet.getRows() - 1);
        sheet.addCell(new Label(0, row, "海沧区"));

        row += result3Size;
        int result4Size = result4.size();
        sheet = setSheetInfo(sheet, result4, result4Size, row);
        sheet.mergeCells(0, row, 0, sheet.getRows() - 1);
        sheet.addCell(new Label(0, row, "集美区"));

        row += result4Size;
        int result5Size = result5.size();
        sheet = setSheetInfo(sheet, result5, result5Size, row);
        sheet.mergeCells(0, row, 0, sheet.getRows() - 1);
        sheet.addCell(new Label(0, row, "同安区"));

        row += result5Size;
        int result6Size = result6.size();
        sheet = setSheetInfo(sheet, result6, result6Size, row);
        sheet.mergeCells(0, row, 0, sheet.getRows() - 1);
        sheet.addCell(new Label(0, row, "翔安区"));

        row += result6Size;
        int result7Size = result7.size();
        sheet = setSheetInfo(sheet, result7, result7Size, row);
        sheet.mergeCells(0, row, 0, sheet.getRows() - 1);
        sheet.addCell(new Label(0, row, "全市"));

        return sheet;
    }

    private WritableSheet setSheetInfo(WritableSheet sheet, List<Map<String, Object>> list, int size, int row) throws WriteException {
        if (null != list && list.size() > 0 && list.get(0).size() > 0) {
            for(int i = 0; i < size; i++) {
                Map<String, Object> objMap = list.get(i);
                sheet.addCell(new Label(1, i + row, String.valueOf(objMap.get("server_type"))));
                sheet.addCell(new Label(2, i + row, String.valueOf(objMap.get("result1"))));
                sheet.addCell(new Label(3, i + row, String.valueOf(objMap.get("result2"))));
            }
        }
        return sheet;
    }

    */
/**
     * 将两个List<Map<String, Object>>合并，id一样的放在一起
     * @param list
     * @param distinctList
     * @return
     *//*

    public List<Map<String, Object>> fillList(List<Map<String, Object>> list, List<Map<String, Object>> distinctList) {
        List<Map<String, Object>> result = new ArrayList<>();
        for (int i = 0; i < list.size(); i++) {
            Map<String, Object> map = new HashMap<>();
            map.put("id", list.get(i).get("id"));
            map.put("server_type", list.get(i).get("server_type"));
            map.put("result1", list.get(i).get("result"));
            map.put("result2", distinctList.get(i).get("result"));
            result.add(map);
        }
        return result;
    }

    private String codeExchange(String code) {
        String name = code;
        if (code.length() > 6) {
            Hospital byCode = hospitalDao.findByCode(code);
            if (null != byCode) {
                return byCode.getName();
            } else {
                return name;
            }
        }
        code = code.substring(0,6);
        switch (code) {
            case "350203" :
                name = "思明区";
                break;
            case "350205" :
                name = "海沧区";
                break;
            case "350206" :
                name = "湖里区";
                break;
            case "350211" :
                name = "集美区";
                break;
            case "350212" :
                name = "同安区";
                break;
            case "350213" :
                name = "翔安区";
                break;
            default:
                name = "厦门市";
                break;
        }
        return name;
    }

    */
/**
     * 拼接咨询量SQL，返回查询结果
     * @param flag
     * @param year
     * @param search
     * @param start
     * @param end
     * @param code
     * @return
     *//*

    public List<Map<String, Object>> consultList(Integer flag, Integer year, String search, String start, String end, String code) {
        StringBuffer sb = new StringBuffer();
        sb.append("SELECT b.server_type, COUNT(*) FROM wlyy_consult_team a JOIN (SELECT f.`code`,f.patient,f.hospital,")
                .append("s.server_type,s.server_type_name FROM wlyy_sign_family f LEFT JOIN wlyy_sign_family_server s ON f.`code` = s.sign_code ");
        if (flag == 1 ) {
            sb.append("WHERE f.`status`>0 AND f.type = 2 AND s.server_type in(1,2,3,4,5,6,7) AND f.sign_year = '").append(year).append("' AND ");
        } else {
            sb.append("WHERE f.`status`=-4 AND f.type = 2 AND s.server_type in(1,2,3,4,5,6,7) AND f.sign_year = '").append(year).append("' AND ");
        }
        if ("city".equals(search)) {
            sb.append("LEFT (f.hospital, 4) = '").append(code.substring(0,4));
        } else if ("town".equals(search)) {
            sb.append("LEFT (f.hospital, 6) = '").append(code.substring(0,6));
        } else {
            sb.append("f.hospital='").append(code);
        }

        sb.append("') b ON a.patient = b.patient WHERE a.type = 2 AND a.czrq >= '").append(start).append("' AND a.czrq <= '").append(end)
                .append("' GROUP BY b.server_type UNION ");

        sb.append("SELECT '8' as server_type, COUNT(*) FROM wlyy_consult_team a JOIN (SELECT f.`code`,f.patient,f.hospital,")
                .append("s.server_type,s.server_type_name FROM wlyy_sign_family f LEFT JOIN wlyy_sign_family_server s ON f.`code` = s.sign_code ");
        if (flag == 1 ) {
            sb.append("WHERE f.`status`>0 AND f.type = 2 AND s.server_type not in(1,2,3,4,5,6,7) AND f.sign_year = '").append(year).append("' AND ");
        } else {
            sb.append("WHERE f.`status`=-4 AND f.type = 2 AND s.server_type not in(1,2,3,4,5,6,7) AND f.sign_year = '").append(year).append("' AND ");
        }
        if ("city".equals(search)) {
            sb.append("LEFT (f.hospital, 4) = '").append(code.substring(0,4));
        } else if ("town".equals(search)) {
            sb.append("LEFT (f.hospital, 6) = '").append(code.substring(0,6));
        } else {
            sb.append("f.hospital='").append(code);
        }

        sb.append("') b ON a.patient = b.patient WHERE a.type = 2 AND a.czrq >= '").append(start).append("' AND a.czrq <= '").append(end)
                .append("' UNION ");

        sb.append("SELECT '9' as server_type, COUNT(*) FROM wlyy_consult_team a JOIN (SELECT f.`code`,f.patient,f.hospital,")
                .append("s.server_type,s.server_type_name FROM wlyy_sign_family f LEFT JOIN wlyy_sign_family_server s ON f.`code` = s.sign_code ");
        if (flag == 1 ) {
            sb.append("WHERE f.`status`>0 AND f.type = 2 AND f.sign_year = '").append(year).append("' AND ");
        } else {
            sb.append("WHERE f.`status`=-4 AND f.type = 2 AND f.sign_year = '").append(year).append("' AND ");
        }
        if ("city".equals(search)) {
            sb.append("LEFT (f.hospital, 4) = '").append(code.substring(0,4));
        } else if ("town".equals(search)) {
            sb.append("LEFT (f.hospital, 6) = '").append(code.substring(0,6));
        } else {
            sb.append("f.hospital='").append(code);
        }

        sb.append("') b ON a.patient = b.patient WHERE a.type = 2 AND a.czrq >= '").append(start).append("' AND a.czrq <= '").append(end).append("'");

        List<Map<String, Object>> list = jdbcTemplate.queryForList(sb.toString());
        List<Map<String, Object>> mapList = handleList(list, null);
        return mapList;
    }

    */
/**
     * 拼接咨询人数SQL，返回查询结果
     * @param flag
     * @param year
     * @param search
     * @param start
     * @param end
     * @param code
     * @return
     *//*

    public List<Map<String, Object>> consultDistinctList(Integer flag, Integer year, String search, String start, String end, String code) {
        StringBuffer sb = new StringBuffer();
        sb.append("SELECT b.server_type, COUNT(*) FROM (SELECT * FROM wlyy_consult_team WHERE type = 2 AND czrq >= '").append(start)
                .append("' AND czrq <= '").append(end).append("' GROUP BY patient ) a JOIN (SELECT f.`code`, f.patient, s.server_type,")
                .append(" s.server_type_name FROM wlyy_sign_family f LEFT JOIN wlyy_sign_family_server s ON f.`code` = s.sign_code ");
        if (flag == 1 ) {
            sb.append("WHERE f.`status` > 0 AND f.type = 2 AND s.server_type in(1,2,3,4,5,6,7) AND f.sign_year = '").append(year).append("' AND ");
        } else {
            sb.append("WHERE f.`status`=-4 AND f.type = 2 AND s.server_type in(1,2,3,4,5,6,7) AND f.sign_year = '").append(year).append("' AND ");
        }
        if ("city".equals(search)) {
            sb.append("LEFT (f.hospital, 4) = '").append(code.substring(0,4));
        } else if ("town".equals(search)) {
            sb.append("LEFT (f.hospital, 6) = '").append(code.substring(0,6));
        } else {
            sb.append("f.hospital='").append(code);
        }

        sb.append("' ) b ON a.patient = b.patient GROUP BY b.server_type UNION ");

        sb.append("SELECT '8' as server_type, COUNT(*) FROM (SELECT * FROM wlyy_consult_team WHERE type = 2 AND czrq >= '").append(start)
                .append("' AND czrq <= '").append(end).append("' GROUP BY patient ) a JOIN (SELECT f.`code`, f.patient, s.server_type,")
                .append(" s.server_type_name FROM wlyy_sign_family f LEFT JOIN wlyy_sign_family_server s ON f.`code` = s.sign_code ");
        if (flag == 1 ) {
            sb.append("WHERE f.`status` > 0 AND f.type = 2 AND s.server_type not in(1,2,3,4,5,6,7) AND f.sign_year = '").append(year).append("' AND ");
        } else {
            sb.append("WHERE f.`status`=-4 AND f.type = 2 AND s.server_type not in(1,2,3,4,5,6,7) AND f.sign_year = '").append(year).append("' AND ");
        }
        if ("city".equals(search)) {
            sb.append("LEFT (f.hospital, 4) = '").append(code.substring(0,4));
        } else if ("town".equals(search)) {
            sb.append("LEFT (f.hospital, 6) = '").append(code.substring(0,6));
        } else {
            sb.append("f.hospital='").append(code);
        }

        sb.append("' ) b ON a.patient = b.patient UNION ");

        sb.append("SELECT '9' as server_type, COUNT(*) FROM (SELECT * FROM wlyy_consult_team WHERE type = 2 AND czrq >= '").append(start)
                .append("' AND czrq <= '").append(end).append("' GROUP BY patient ) a JOIN (SELECT f.`code`, f.patient, s.server_type,")
                .append(" s.server_type_name FROM wlyy_sign_family f LEFT JOIN wlyy_sign_family_server s ON f.`code` = s.sign_code ");
        if (flag == 1 ) {
            sb.append("WHERE f.`status` > 0 AND f.type = 2 AND f.sign_year = '").append(year).append("' AND ");
        } else {
            sb.append("WHERE f.`status`=-4 AND f.type = 2 AND f.sign_year = '").append(year).append("' AND ");
        }
        if ("city".equals(search)) {
            sb.append("LEFT (f.hospital, 4) = '").append(code.substring(0,4));
        } else if ("town".equals(search)) {
            sb.append("LEFT (f.hospital, 6) = '").append(code.substring(0,6));
        } else {
            sb.append("f.hospital='").append(code);
        }

        sb.append("' ) b ON a.patient = b.patient ");

        List<Map<String, Object>> list = jdbcTemplate.queryForList(sb.toString());
        List<Map<String, Object>> mapList = handleList(list, null);
        return mapList;
    }

    */
/**
     * 拼接预约量SQL，返回查询结果
     * @param flag
     * @param year
     * @param search
     * @param start
     * @param end
     * @param code
     * @return
     *//*

    public List<Map<String, Object>> appointmentList(Integer flag, Integer year, String search, String start, String end, String code) {
        StringBuffer sb = new StringBuffer();
        sb.append("SELECT b.server_type, COUNT(*) FROM wlyy_patient_reservation a JOIN (SELECT f.`code`, f.patient, s.server_type, ")
                .append("s.server_type_name FROM wlyy_sign_family f LEFT JOIN wlyy_sign_family_server s ON f.`code` = s.sign_code WHERE ");
        if (flag == 1 ) {
            sb.append("f.`status` > 0 AND f.type = 2 AND s.server_type in(1,2,3,4,5,6,7) AND f.sign_year = '").append(year).append("' AND ");
        } else {
            sb.append("f.`status`=-4 AND f.type = 2 AND s.server_type in(1,2,3,4,5,6,7) AND f.sign_year = '").append(year).append("' AND ");
        }
        if ("city".equals(search)) {
            sb.append("LEFT (f.hospital, 4) = '").append(code.substring(0,4));
        } else if ("town".equals(search)) {
            sb.append("LEFT (f.hospital, 6) = '").append(code.substring(0,6));
        } else {
            sb.append("f.hospital='").append(code);
        }

        sb.append("') b ON a.patient = b.patient WHERE a.doctor is NULL AND a.czrq >= '").append(start).append("' AND a.czrq <= '").append(end)
                .append("' GROUP BY b.server_type union ");

        sb.append("SELECT '8' as server_type, COUNT(*) FROM wlyy_patient_reservation a JOIN (SELECT f.`code`, f.patient, s.server_type, ")
                .append("s.server_type_name FROM wlyy_sign_family f LEFT JOIN wlyy_sign_family_server s ON f.`code` = s.sign_code WHERE ");
        if (flag == 1 ) {
            sb.append("f.`status` > 0 AND f.type = 2 AND s.server_type not in(1,2,3,4,5,6,7) AND f.sign_year = '").append(year).append("' AND ");
        } else {
            sb.append("f.`status`=-4 AND f.type = 2 AND s.server_type not in(1,2,3,4,5,6,7) AND f.sign_year = '").append(year).append("' AND ");
        }
        if ("city".equals(search)) {
            sb.append("LEFT (f.hospital, 4) = '").append(code.substring(0,4));
        } else if ("town".equals(search)) {
            sb.append("LEFT (f.hospital, 6) = '").append(code.substring(0,6));
        } else {
            sb.append("f.hospital='").append(code);
        }
        sb.append("') b ON a.patient = b.patient WHERE a.doctor is NULL AND a.czrq >= '").append(start).append("' AND a.czrq <= '").append(end)
                .append("' union ");

        sb.append("SELECT '9' as server_type, COUNT(*) FROM wlyy_patient_reservation a JOIN (SELECT f.`code`, f.patient, s.server_type, ")
                .append("s.server_type_name FROM wlyy_sign_family f LEFT JOIN wlyy_sign_family_server s ON f.`code` = s.sign_code WHERE ");
        if (flag == 1 ) {
            sb.append("f.`status` > 0 AND f.type = 2 AND s.server_type between 1 and 12 AND f.sign_year = '").append(year).append("' AND ");
        } else {
            sb.append("f.`status`=-4 AND f.type = 2 AND s.server_type between 1 and 12 AND f.sign_year = '").append(year).append("' AND ");
        }
        if ("city".equals(search)) {
            sb.append("LEFT (f.hospital, 4) = '").append(code.substring(0,4));
        } else if ("town".equals(search)) {
            sb.append("LEFT (f.hospital, 6) = '").append(code.substring(0,6));
        } else {
            sb.append("f.hospital='").append(code);
        }

        sb.append("') b ON a.patient = b.patient WHERE a.doctor is NULL AND a.czrq >= '").append(start).append("' AND a.czrq <= '").append(end)
                .append("'");

        List<Map<String, Object>> list = jdbcTemplate.queryForList(sb.toString());
        List<Map<String, Object>> mapList = handleList(list, null);
        return mapList;
    }

    */
/**
     * 拼接预约人数SQL，返回查询结果
     * @param flag
     * @param year
     * @param search
     * @param start
     * @param end
     * @param code
     * @return
     *//*

    public List<Map<String, Object>> appointmentDistinctList(Integer flag, Integer year, String search, String start, String end, String code) {
        StringBuffer sb = new StringBuffer();
        sb.append("SELECT b.server_type, COUNT(*) FROM (SELECT * FROM wlyy_patient_reservation WHERE doctor is null AND czrq >= '").append(start)
                .append("' AND czrq <= '").append(end).append("' GROUP BY patient) a JOIN (SELECT f.`code`, f.patient, s.server_type, s.server_type_name ")
                .append(" FROM wlyy_sign_family f LEFT JOIN wlyy_sign_family_server s ON f.`code` = s.sign_code ");
        if (flag == 1 ) {
            sb.append("WHERE f.`status` > 0 AND f.type = 2 AND s.server_type in(1,2,3,4,5,6,7) AND f.sign_year = '").append(year).append("' AND ");
        } else {
            sb.append("WHERE f.`status`=-4 AND f.type = 2 AND s.server_type in(1,2,3,4,5,6,7) AND f.sign_year = '").append(year).append("' AND ");
        }
        if ("city".equals(search)) {
            sb.append("LEFT (f.hospital, 4) = '").append(code.substring(0,4));
        } else if ("town".equals(search)) {
            sb.append("LEFT (f.hospital, 6) = '").append(code.substring(0,6));
        } else {
            sb.append("f.hospital='").append(code);
        }
        sb.append("' ) b ON a.patient = b.patient GROUP BY b.server_type UNION ");

        sb.append("SELECT '8' as server_type, COUNT(*) FROM (SELECT * FROM wlyy_patient_reservation WHERE doctor is null AND czrq >= '").append(start)
                .append("' AND czrq <= '").append(end).append("' GROUP BY patient) a JOIN (SELECT f.`code`, f.patient, s.server_type, s.server_type_name ")
                .append(" FROM wlyy_sign_family f LEFT JOIN wlyy_sign_family_server s ON f.`code` = s.sign_code ");
        if (flag == 1 ) {
            sb.append("WHERE f.`status` > 0 AND f.type = 2 AND s.server_type not in(1,2,3,4,5,6,7) AND f.sign_year = '").append(year).append("' AND ");
        } else {
            sb.append("WHERE f.`status`=-4 AND f.type = 2 AND s.server_type not in(1,2,3,4,5,6,7) AND f.sign_year = '").append(year).append("' AND ");
        }
        if ("city".equals(search)) {
            sb.append("LEFT (f.hospital, 4) = '").append(code.substring(0,4));
        } else if ("town".equals(search)) {
            sb.append("LEFT (f.hospital, 6) = '").append(code.substring(0,6));
        } else {
            sb.append("f.hospital='").append(code);
        }
        sb.append("' ) b ON a.patient = b.patient UNION ");

        sb.append("SELECT '9' as server_type, COUNT(*) FROM (SELECT * FROM wlyy_patient_reservation WHERE doctor is null AND czrq >= '").append(start)
                .append("' AND czrq <= '").append(end).append("' GROUP BY patient) a JOIN (SELECT f.`code`, f.patient, s.server_type, s.server_type_name ")
                .append(" FROM wlyy_sign_family f LEFT JOIN wlyy_sign_family_server s ON f.`code` = s.sign_code ");
        if (flag == 1 ) {
            sb.append("WHERE f.`status` > 0 AND f.type = 2 AND s.server_type between 1 and 12 AND f.sign_year = '").append(year).append("' AND ");
        } else {
            sb.append("WHERE f.`status`=-4 AND f.type = 2 AND s.server_type between 1 and 12 AND f.sign_year = '").append(year).append("' AND ");
        }
        if ("city".equals(search)) {
            sb.append("LEFT (f.hospital, 4) = '").append(code.substring(0,4));
        } else if ("town".equals(search)) {
            sb.append("LEFT (f.hospital, 6) = '").append(code.substring(0,6));
        } else {
            sb.append("f.hospital='").append(code);
        }
        sb.append("' ) b ON a.patient = b.patient");

        List<Map<String, Object>> list = jdbcTemplate.queryForList(sb.toString());
        List<Map<String, Object>> mapList = handleList(list, null);
        return mapList;
    }

    */
/**
     * 对查询出来的结果进行加工 补0
     * @param list
     * @return
     *//*

    public List<Map<String, Object>> handleList(List<Map<String, Object>> list, String town) {
        List<Map<String, Object>> listMap = new ArrayList<>();
        Map<String, Integer> statistic = new LinkedHashMap<>();
        List<String> flagList = new ArrayList<>();
        list.stream().forEach(item -> {
            if (StringUtils.isNotEmpty(town)) {
                if (item.containsKey("hos") && town.equals(String.valueOf(item.get("hos")))) {
                    statistic.put(String.valueOf(item.get("server_type")), Integer.parseInt(String.valueOf(item.get("COUNT(*)"))));
                }
            } else {
                statistic.put(String.valueOf(item.get("server_type")), Integer.parseInt(String.valueOf(item.get("COUNT(*)"))));
            }
        });
        // 补0操作
        if (!statistic.containsKey("1")) {
            statistic.put("1", 0);
        }
        if (!statistic.containsKey("2")) {
            statistic.put("2", 0);
        }
        if (!statistic.containsKey("4")) {
            statistic.put("4", 0);
        }
        if (!statistic.containsKey("5")) {
            statistic.put("5", 0);
        }
        if (!statistic.containsKey("6")) {
            statistic.put("6", 0);
        }
        if (!statistic.containsKey("7")) {
            statistic.put("7", 0);
        }
        if (!statistic.containsKey("8")) {
            statistic.put("8", 0);
        }
        if (!statistic.containsKey("9")) {
            statistic.put("9", 0);
        }

        Map<String, Integer> myMap = new TreeMap<>(statistic);
        myMap.forEach((k,v) -> {
            Map<String, Object> nestMap = new HashMap<>();
            if ("1".equals(k)) {
                nestMap.put("server_type", "普通人群");
                nestMap.put("id", "1");
                nestMap.put("result", v);
            } else if ("2".equals(k) || "3".equals(k)) {
                if (flagList.size() == 0) {
                    int first = null != statistic.get("2") ? Integer.parseInt(String.valueOf(statistic.get("2"))) : 0;
                    int second = null != statistic.get("3") ? Integer.parseInt(String.valueOf(statistic.get("3"))) : 0;
                    int i = first + second;
                    nestMap.put("server_type", "老年人");
                    nestMap.put("id", "2");
                    nestMap.put("result", i);
                    flagList.add(k);
                }
            } else if ("4".equals(k)) {
                nestMap.put("server_type", "高血压");
                nestMap.put("id", "4");
                nestMap.put("result", v);
            } else if ("5".equals(k)) {
                nestMap.put("server_type", "糖尿病");
                nestMap.put("id", "5");
                nestMap.put("result", v);
            } else if ("6".equals(k)) {
                nestMap.put("server_type", "孕产妇");
                nestMap.put("id", "6");
                nestMap.put("result", v);
            } else if ("7".equals(k)) {
                nestMap.put("server_type", "0-6岁儿童");
                nestMap.put("id", "7");
                nestMap.put("result", v);
            } else if ("8".equals(k)) {
                nestMap.put("server_type", "其他");
                nestMap.put("id", "8");
                nestMap.put("result", v);
            } else if ("9".equals(k)) {
                nestMap.put("server_type", "合计");
                nestMap.put("id", "9");
                nestMap.put("result", v);
            }
            if (nestMap.size() > 0) {
                if (StringUtils.isNotEmpty(town)) {
                    nestMap.put("town", town);
                }
                listMap.add(nestMap);
            }
        });
        return listMap;
    }

    public List<Map<String, Object>> appointmentCityList(Integer flag, Integer year, String start, String end) {
        StringBuffer sb = new StringBuffer();
        sb.append("SELECT LEFT(b.hospital,6) as hos, b.server_type, COUNT(*) FROM wlyy_patient_reservation a JOIN (SELECT f.`code`,")
                .append("f.patient,f.hospital, s.server_type, s.server_type_name FROM wlyy_sign_family f LEFT JOIN ")
                .append("wlyy_sign_family_server s ON f.`code`= s.sign_code WHERE ");
        if (flag == 1 ) {
            sb.append("f.`status` > 0 AND f.type = 2 AND s.server_type in(1,2,3,4,5,6,7) AND f.sign_year = '").append(year).append("'");
        } else {
            sb.append("f.`status`=-4 AND f.type = 2 AND s.server_type in(1,2,3,4,5,6,7) AND f.sign_year = '").append(year).append("'");
        }
        sb.append(") b ON a.patient = b.patient WHERE a.doctor IS NULL AND a.czrq >= '").append(start).append("' AND a.czrq <= '").append(end)
                .append("' and LEFT(b.hospital,4) = '3502' GROUP BY LEFT(b.hospital,6), b.server_type UNION ");

        sb.append("SELECT LEFT(b.hospital,6) as hos, '8' AS server_type, COUNT(*) FROM wlyy_patient_reservation a JOIN (SELECT f.`code`,")
                .append("f.patient,f.hospital, s.server_type, s.server_type_name FROM wlyy_sign_family f LEFT JOIN ")
                .append("wlyy_sign_family_server s ON f.`code`= s.sign_code WHERE ");
        if (flag == 1 ) {
            sb.append("f.`status` > 0 AND f.type = 2 AND s.server_type NOT in(1,2,3,4,5,6,7) AND f.sign_year = '").append(year).append("'");
        } else {
            sb.append("f.`status`=-4 AND f.type = 2 AND s.server_type NOT in(1,2,3,4,5,6,7) AND f.sign_year = '").append(year).append("'");
        }
        sb.append(") b ON a.patient = b.patient WHERE a.doctor IS NULL AND a.czrq >= '").append(start).append("' AND a.czrq <= '").append(end)
                .append("' and LEFT(b.hospital,4) = '3502' GROUP BY LEFT(b.hospital,6), b.server_type UNION ");

        sb.append("SELECT LEFT(b.hospital,6) as hos, '9' AS server_type, COUNT(*) FROM wlyy_patient_reservation a JOIN (SELECT f.`code`,")
                .append("f.patient,f.hospital, s.server_type, s.server_type_name FROM wlyy_sign_family f LEFT JOIN ")
                .append("wlyy_sign_family_server s ON f.`code`= s.sign_code WHERE ");
        if (flag == 1 ) {
            sb.append("f.`status` > 0 AND f.type = 2 AND s.server_type BETWEEN 1 AND 12 AND f.sign_year = '").append(year).append("'");
        } else {
            sb.append("f.`status`=-4 AND f.type = 2 AND s.server_type BETWEEN 1 AND 12 AND f.sign_year = '").append(year).append("'");
        }
        sb.append(") b ON a.patient = b.patient WHERE a.doctor IS NULL AND a.czrq >= '").append(start).append("' AND a.czrq <= '").append(end)
                .append("' and LEFT(b.hospital,4) = '3502' GROUP BY LEFT(b.hospital,6), b.server_type ORDER BY hos,server_type");

        logger.info("appointmentCityList={}", sb.toString());
        List<Map<String, Object>> list = jdbcTemplate.queryForList(sb.toString());
        return list;
    }

    public List<Map<String, Object>> appointmentCityDistinctList(Integer flag, Integer year, String start, String end) {
        StringBuffer sb = new StringBuffer();
        sb.append("SELECT LEFT (b.hospital, 6) AS hos,b.server_type, COUNT(*) FROM (SELECT * FROM wlyy_patient_reservation")
                .append(" WHERE doctor IS NULL AND czrq >= '").append(start).append("' AND czrq <= '").append(end).append("' GROUP BY patient ) a")
                .append(" JOIN (SELECT f.`code`, f.patient,f.hospital, s.server_type, s.server_type_name FROM wlyy_sign_family f")
                .append(" LEFT JOIN wlyy_sign_family_server s ON f.`code` = s.sign_code WHERE ");
        if (flag == 1 ) {
            sb.append("f.`status` > 0 AND f.type = 2 AND s.server_type IN (1, 2, 3, 4, 5, 6, 7) AND f.sign_year = '").append(year).append("'");
        } else {
            sb.append("f.`status`=-4 AND f.type = 2 AND s.server_type IN (1, 2, 3, 4, 5, 6, 7) AND f.sign_year = '").append(year).append("'");
        }
        sb.append(" AND LEFT (f.hospital, 4) = '3502') b ON a.patient = b.patient GROUP BY LEFT (b.hospital, 6), b.server_type")
                .append(" UNION ");

        sb.append("SELECT LEFT (b.hospital, 6) AS hos,'8' AS server_type, COUNT(*) FROM (SELECT * FROM wlyy_patient_reservation")
                .append(" WHERE doctor IS NULL AND czrq >= '").append(start).append("' AND czrq <= '").append(end).append("' GROUP BY patient ) a")
                .append(" JOIN (SELECT f.`code`, f.patient,f.hospital, s.server_type, s.server_type_name FROM wlyy_sign_family f")
                .append(" LEFT JOIN wlyy_sign_family_server s ON f.`code` = s.sign_code WHERE ");
        if (flag == 1 ) {
            sb.append("f.`status` > 0 AND f.type = 2 AND s.server_type not IN (1, 2, 3, 4, 5, 6, 7) AND f.sign_year = '").append(year).append("'");
        } else {
            sb.append("f.`status`=-4 AND f.type = 2 AND s.server_type not IN (1, 2, 3, 4, 5, 6, 7) AND f.sign_year = '").append(year).append("'");
        }
        sb.append(" AND LEFT (f.hospital, 4) = '3502') b ON a.patient = b.patient GROUP BY LEFT (b.hospital, 6), b.server_type")
                .append(" UNION ");

        sb.append("SELECT LEFT (b.hospital, 6) AS hos,'9' AS server_type, COUNT(*) FROM (SELECT * FROM wlyy_patient_reservation")
                .append(" WHERE doctor IS NULL AND czrq >= '").append(start).append("' AND czrq <= '").append(end).append("' GROUP BY patient ) a")
                .append(" JOIN (SELECT f.`code`, f.patient,f.hospital, s.server_type, s.server_type_name FROM wlyy_sign_family f")
                .append(" LEFT JOIN wlyy_sign_family_server s ON f.`code` = s.sign_code WHERE ");
        if (flag == 1 ) {
            sb.append("f.`status` > 0 AND f.type = 2 AND s.server_type BETWEEN 1 AND 12 AND f.sign_year = '").append(year).append("'");
        } else {
            sb.append("f.`status`=-4 AND f.type = 2 AND s.server_type BETWEEN 1 AND 12 AND f.sign_year = '").append(year).append("'");
        }
        sb.append(" AND LEFT (f.hospital, 4) = '3502') b ON a.patient = b.patient GROUP BY LEFT (b.hospital, 6), b.server_type")
        .append(" ORDER BY hos,server_type");

        logger.info("appointmentCityDistinctList={}", sb.toString());
        List<Map<String, Object>> list = jdbcTemplate.queryForList(sb.toString());
        return list;
    }

    public List<Map<String, Object>> consultCityList(Integer flag, Integer year, String start, String end) {
        StringBuffer sb = new StringBuffer();
        sb.append("SELECT LEFT(b.hospital,6) as hos, b.server_type, COUNT(*) FROM wlyy_consult_team a JOIN (SELECT ")
                .append("f.`code`,f.patient,f.hospital,s.server_type,s.server_type_name FROM wlyy_sign_family f ")
                .append("LEFT JOIN wlyy_sign_family_server s ON f.`code` = s.sign_code WHERE ");
        if (flag == 1 ) {
            sb.append("f.`status`>0 AND f.type = 2 AND s.server_type in(1,2,3,4,5,6,7) AND f.sign_year = '").append(year).append("'");
        } else {
            sb.append("f.`status`=-4 AND f.type = 2 AND s.server_type in(1,2,3,4,5,6,7) AND f.sign_year = '").append(year).append("'");
        }
        sb.append(" AND LEFT (f.hospital, 4) = '3502') b ON a.patient = b.patient WHERE a.type = 2 AND a.czrq >= '").append(start)
                .append("' AND a.czrq <= '").append(end).append("' GROUP BY LEFT(b.hospital,6),b.server_type UNION ");

        sb.append("SELECT LEFT(b.hospital,6) as hos, '8' as server_type, COUNT(*) FROM wlyy_consult_team a JOIN (SELECT ")
                .append("f.`code`,f.patient,f.hospital,s.server_type,s.server_type_name FROM wlyy_sign_family f ")
                .append("LEFT JOIN wlyy_sign_family_server s ON f.`code` = s.sign_code WHERE ");
        if (flag == 1 ) {
            sb.append("f.`status`>0 AND f.type = 2 AND s.server_type not in(1,2,3,4,5,6,7) AND f.sign_year = '").append(year).append("'");
        } else {
            sb.append("f.`status`=-4 AND f.type = 2 AND s.server_type not in(1,2,3,4,5,6,7) AND f.sign_year = '").append(year).append("'");
        }
        sb.append(" AND LEFT (f.hospital, 4) = '3502') b ON a.patient = b.patient WHERE a.type = 2 AND a.czrq >= '").append(start)
                .append("' AND a.czrq <= '").append(end).append("' GROUP BY LEFT(b.hospital,6) UNION ");

        sb.append("SELECT LEFT(b.hospital,6) as hos, '9' as server_type, COUNT(*) FROM wlyy_consult_team a JOIN (SELECT ")
                .append("f.`code`,f.patient,f.hospital,s.server_type,s.server_type_name FROM wlyy_sign_family f ")
                .append("LEFT JOIN wlyy_sign_family_server s ON f.`code` = s.sign_code WHERE ");
        if (flag == 1 ) {
            sb.append("f.`status`>0 AND f.type = 2 AND f.sign_year = '").append(year).append("'");
        } else {
            sb.append("f.`status`=-4 AND f.type = 2 AND f.sign_year = '").append(year).append("'");
        }
        sb.append(" AND LEFT (f.hospital, 4) = '3502') b ON a.patient = b.patient WHERE a.type = 2 AND a.czrq >= '").append(start)
                .append("' AND a.czrq <= '").append(end).append("' GROUP BY LEFT(b.hospital,6) ORDER BY hos,server_type");

        logger.info("consultCityList={}", sb.toString());
        List<Map<String, Object>> list = jdbcTemplate.queryForList(sb.toString());
        return list;
    }

    public List<Map<String, Object>> consultCityDistinctList(Integer flag, Integer year, String start, String end) {
        StringBuffer sb = new StringBuffer();
        sb.append("SELECT LEFT(b.hospital,6) as hos,b.server_type, COUNT(*) FROM (SELECT * FROM wlyy_consult_team WHERE type = 2 AND czrq >= '")
                .append(start).append("' AND czrq <= '").append(end).append("' GROUP BY patient ) a JOIN (SELECT f.`code`,")
                .append("f.hospital,f.patient, s.server_type, s.server_type_name FROM wlyy_sign_family f LEFT JOIN ")
                .append("wlyy_sign_family_server s ON f.`code` = s.sign_code WHERE ");
        if (flag == 1 ) {
            sb.append("f.`status` > 0 AND f.type = 2 AND s.server_type in(1,2,3,4,5,6,7) AND f.sign_year = '").append(year).append("'");
        } else {
            sb.append("f.`status`=-4 AND f.type = 2 AND s.server_type in(1,2,3,4,5,6,7) AND f.sign_year = '").append(year).append("'");
        }
        sb.append(" AND LEFT (f.hospital, 4) = '3502') b ON a.patient = b.patient GROUP BY LEFT(b.hospital,6),b.server_type")
                .append(" UNION ");

        sb.append("SELECT LEFT(b.hospital,6) as hos,'8' as server_type, COUNT(*) FROM (SELECT * FROM wlyy_consult_team WHERE type = 2 AND czrq >= '")
                .append(start).append("' AND czrq <= '").append(end).append("' GROUP BY patient ) a JOIN (SELECT f.`code`,")
                .append("f.hospital,f.patient, s.server_type, s.server_type_name FROM wlyy_sign_family f LEFT JOIN ")
                .append("wlyy_sign_family_server s ON f.`code` = s.sign_code WHERE ");
        if (flag == 1 ) {
            sb.append("f.`status` > 0 AND f.type = 2 AND s.server_type not in(1,2,3,4,5,6,7) AND f.sign_year = '").append(year).append("'");
        } else {
            sb.append("f.`status`=-4 AND f.type = 2 AND s.server_type not in(1,2,3,4,5,6,7) AND f.sign_year = '").append(year).append("'");
        }
        sb.append(" AND LEFT (f.hospital, 4) = '3502') b ON a.patient = b.patient GROUP BY LEFT(b.hospital,6) UNION ");

        sb.append("SELECT LEFT(b.hospital,6) as hos,'9' as server_type, COUNT(*) FROM (SELECT * FROM wlyy_consult_team WHERE type = 2 AND czrq >= '")
                .append(start).append("' AND czrq <= '").append(end).append("' GROUP BY patient ) a JOIN (SELECT f.`code`,")
                .append("f.hospital,f.patient, s.server_type, s.server_type_name FROM wlyy_sign_family f LEFT JOIN ")
                .append("wlyy_sign_family_server s ON f.`code` = s.sign_code WHERE ");
        if (flag == 1 ) {
            sb.append("f.`status` > 0 AND f.type = 2 AND f.sign_year = '").append(year).append("'");
        } else {
            sb.append("f.`status`=-4 AND f.type = 2 AND f.sign_year = '").append(year).append("'");
        }
        sb.append(" AND LEFT (f.hospital, 4) = '3502') b ON a.patient = b.patient GROUP BY LEFT(b.hospital,6)")
        .append(" ORDER BY hos,server_type");

        logger.info("consultCityDistinctList={}", sb.toString());
        List<Map<String, Object>> list = jdbcTemplate.queryForList(sb.toString());
        return list;
    }
}
*/
