package com.yihu.customer.service.gdp;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.parser.Feature;
import com.alibaba.fastjson.serializer.SerializerFeature;
import com.fasterxml.jackson.databind.ObjectMapper;
import  com.yihu.customer.entity.gdp.GdpSurveyCheck;
import  com.yihu.customer.entity.gdp.GdpSurveyRecord;
import  com.yihu.customer.repository.gdp.GdpSurveyCheckDao;
import  com.yihu.customer.repository.gdp.GdpSurveyRecordDao;
import com.yihu.customer.util.DateUtil;
import jxl.Workbook;
import jxl.write.*;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Sort;
import org.springframework.data.jpa.domain.Specification;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;
import org.apache.commons.lang3.StringUtils;
import org.springside.modules.persistence.DynamicSpecifications;
import org.springside.modules.persistence.SearchFilter;

import javax.servlet.http.HttpServletResponse;
import java.io.*;
import java.text.SimpleDateFormat;
import java.util.*;
import java.util.zip.ZipEntry;
import java.util.zip.ZipOutputStream;

/**
 * Created by yeshijie on 2021/11/8.
 */
@Service
public class HealthGdpService {
    private Logger logger = LoggerFactory.getLogger(HealthGdpService.class);
    @Autowired
    private GdpSurveyCheckDao gdpSurveyCheckDao;
    @Autowired
    private GdpSurveyRecordDao gdpSurveyRecordDao;
    @Autowired
    protected ObjectMapper objectMapper;
    @Autowired
    private JdbcTemplate jdbcTemplate;

    /**
     * 导出文件夹
     * @param ids
     * @param type 1record 2check
     * @param response
     * @return
     * @throws Exception
     */
    public File writeWordFile(String ids,int type, HttpServletResponse response) throws Exception {
        String zipFileName = "服务小结";
        long time = System.currentTimeMillis();
        String exportConclusionList = time+"exportList";
        String path = this.getClass().getResource("/").getPath() + exportConclusionList;
//        String path = "D:\\GitWorkspace\\patient-co-management\\patient-co\\patient-co-wlyy\\target\\classes\\exportConclusionList";
        File file = new File(path);
        // 删除文件夹、文件
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss:SSS");
        System.out.println("创建文件夹时间："+sdf.format(new Date()));
        if (file.exists()) {
            if (file != null){
                deleteFolder(file);
                file.mkdir();
            }else {
                file.delete();
                file.mkdir();
            }
        }else {
            file.mkdir();
        }
        int j =1;
        String orderId[] = ids.split(",");
        logger.info("开始生成Word："+sdf.format(new Date()));
        Map<String,Integer> fileNum = new HashMap<>();
        for (int i = 0; i < orderId.length; i++) {
            Long id = Long.parseLong(orderId[i]);
            GdpSurveyRecord record = null;
            GdpSurveyCheck check = null;
            String mhtName = "";
            if(type==1){
                record = gdpSurveyRecordDao.findById(id).get();
                if("1".equals(record.getCompanyType())){
                    mhtName = record.getIndustryType()+".mht";
                }else if("2".equals(record.getCompanyType())){
                    mhtName = "5.mht";
                }else if("3".equals(record.getCompanyType())){
                    mhtName = "6.mht";
                }
            }else{
                check = gdpSurveyCheckDao.findById(id).get();
                if("1".equals(check.getHealthRelated())){
                    mhtName = "7_1.mht";
                }else{
                    mhtName = "7_2.mht";
                }
            }
            if(StringUtils.isBlank(mhtName)){
                continue;
            }

            String fileName =  j + "文档.doc";
            if (type==1){
                fileName = record.getCompanyName();
            }else {
                fileName = check.getCompanyName();
            }
            if (fileNum.containsKey(fileName)){
                Integer fileNameNum =Integer.parseInt(fileNum.get(fileName).toString());
                fileNum.put(fileName,fileNameNum+1);
                fileName = fileName+"("+fileNameNum+").doc";
            }else {
                fileNum.put(fileName,1);
                fileName = fileName+".doc";
            }

            j = j + 1;
//            fileName = URLEncoder.encode(fileName, "utf-8");
            fileName = java.net.URLEncoder.encode(fileName,"UTF-8");
            fileName = java.net.URLDecoder.decode(fileName,"UTF-8");
//            response.setHeader("Content-Disposition", "attachment;filename=" + new String( fileName.getBytes(), "iso-8859-1"));
            response.setHeader("Content-Disposition", "attachment; filename=" + fileName);
//            String pathName = this.getClass().getResource("/").getPath() + "conclusion.mht";
            String pathName = this.getClass().getResource("/").getPath() + mhtName;
            Document doc = Jsoup.parse(new File(pathName), "UTF-8");
            String html;
            if(type==1){
                html = this.handleDataRecord(doc, record);
            }else{
                html = this.handleDataCheck(doc, check);
            }
            BufferedWriter bw = new BufferedWriter(new FileWriter(path+"/"+fileName));//创建的文件
            bw.write(html);
            bw.close();
            File zipFile = new File(path.replace(exportConclusionList, "") + zipFileName + ".zip");
            if (zipFile.exists()) {
                zipFile.delete();
            }
        }
        logger.info("Word生成结束："+sdf.format(new Date()));
        // 打包文件夹
        if (fileToZip(path, path.replace(exportConclusionList, ""), zipFileName)) {
            return new File(path.replace(exportConclusionList, "") + zipFileName + ".zip");
        } else {
            return null;
        }
    }

    /**
     * 导出文件夹
     * @param ids
     * @param type 1record 2check
     * @param response
     * @return
     * @throws Exception
     */
    public File writeExcelFile(String ids,int type, HttpServletResponse response) throws Exception {
        String zipFileName = "服务小结";
        long time = System.currentTimeMillis();
        String exportConclusionList = time+"exportList";
        String path = this.getClass().getResource("/").getPath() + exportConclusionList;
//        String path = "D:\\GitWorkspace\\patient-co-management\\patient-co\\patient-co-wlyy\\target\\classes\\exportConclusionList";
        File file = new File(path);
        // 删除文件夹、文件
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss:SSS");
        System.out.println("创建文件夹时间："+sdf.format(new Date()));
        if (file.exists()) {
            if (file != null){
                deleteFolder(file);
                file.mkdir();
            }else {
                file.delete();
                file.mkdir();
            }
        }else {
            file.mkdir();
        }
        int j =1;
        String orderId[] = ids.split(",");
        logger.info("开始生成Excel："+sdf.format(new Date()));
        Map<String,Integer> fileNum = new HashMap<>();
        for (int i = 0; i < orderId.length; i++) {
            Long id = Long.parseLong(orderId[i]);
            GdpSurveyRecord record = null;
            GdpSurveyCheck check = null;
            String mhtName = "";
            if(type==1){
                record = gdpSurveyRecordDao.findById(id).get();
                if("1".equals(record.getCompanyType())){
                    mhtName = record.getIndustryType()+".mht";
                }else if("2".equals(record.getCompanyType())){
                    mhtName = "5.mht";
                }else if("3".equals(record.getCompanyType())){
                    mhtName = "6.mht";
                }
            }else{
                check = gdpSurveyCheckDao.findById(id).get();
                if("1".equals(check.getHealthRelated())){
                    mhtName = "7_1.mht";
                }else{
                    mhtName = "7_2.mht";
                }
            }
            if(StringUtils.isBlank(mhtName)){
                continue;
            }

            String fileName =  j + "文档.doc";
            if (type==1){
                fileName = record.getCompanyName();
            }else {
                fileName = check.getCompanyName();
            }

            if (fileNum.containsKey(fileName)){
                Integer fileNameNum =Integer.parseInt(fileNum.get(fileName).toString());
                fileNum.put(fileName,fileNameNum+1);
                fileName = fileName+"("+fileNameNum+").xls";
            }else {
                fileNum.put(fileName,1);
                fileName = fileName+".xls";
            }

            j = j + 1;
//            fileName = URLEncoder.encode(fileName, "utf-8");
            fileName = java.net.URLEncoder.encode(fileName,"UTF-8");
            fileName = java.net.URLDecoder.decode(fileName,"UTF-8");
            response.setHeader("Content-Disposition", "attachment; filename=" + fileName);
            String pathName = this.getClass().getResource("/").getPath() + mhtName;
            OutputStream os = response.getOutputStream();

            Document doc = Jsoup.parse(new File(pathName), "UTF-8");
            String html;
            if(type==1){
                this.handleDataRecordExcel(path, fileName,record,mhtName);
            }else{
               this.handleDataCheckExcel(path,fileName, check,mhtName);
            }
//            BufferedWriter bw = new BufferedWriter(new FileWriter(path+"/"+fileName));//创建的文件
//            bw.write(html);
//            bw.close();
            File zipFile = new File(path.replace(exportConclusionList, "") + zipFileName + ".zip");
            if (zipFile.exists()) {
                zipFile.delete();
            }
        }
        logger.info("Excel生成结束："+sdf.format(new Date()));
        // 打包文件夹
        if (fileToZip(path, path.replace(exportConclusionList, ""), zipFileName)) {
            return new File(path.replace(exportConclusionList, "") + zipFileName + ".zip");
        } else {
            return null;
        }
    }

    public String handleDataRecord(Document doc, GdpSurveyRecord record){
        String html = doc.toString();
        String jsonStr = record.getDetailed();
        JSONObject jsonObject = JSONObject.parseObject(jsonStr);
        Iterator iter = jsonObject.entrySet().iterator();
        while (iter.hasNext()) {
            Map.Entry entry = (Map.Entry) iter.next();
            html = html.replace("${"+entry.getKey().toString()+"}", null==entry.getValue()?"":entry.getValue().toString());
        }

        html = html.replace("${unifiedSocialCreditCode}", record.getUnifiedSocialCreditCode());
        html = html.replace("${companyName}",record.getCompanyName());
        html = html.replace("${address}",record.getAddress());

        html = html.replace("${companyLeader}",record.getCompanyLeader());
        html = html.replace("${statisticalLeader}",record.getStatisticalLeader());
        html = html.replace("${preparer}",record.getPreparer());
        html = html.replace("${preparerPhone}",record.getPreparerPhone());
        html = html.replace("${reportDate}",DateUtil.dateToStrShort(record.getReportDate()));
        return html;
    }

    public void handleDataRecordExcel(String path,String name, GdpSurveyRecord record,String mhtName){
        try {
            write(Workbook.createWorkbook(new File(path+"/" + name)),JSON.toJSONString(record, SerializerFeature.WriteMapNullValue),GdpSurveyRecord.class,mhtName);
        }catch (Exception e){
            e.printStackTrace();
        }
    }

    /**
     * 对mht模板文件的变量赋值
     * @param doc
     * @return
     */
    public String handleDataCheck(Document doc, GdpSurveyCheck check) {
        String html = doc.toString();
        //对各个字段赋值
        html = html.replace("${companyName}", check.getCompanyName());
        html = html.replace("${unifiedSocialCreditCode}",check.getUnifiedSocialCreditCode());
        html = html.replace("${address}",check.getAddress());
        html = html.replace("${businessActivity1}",check.getBusinessActivity1() == null ? "" : check.getBusinessActivity1());
        html = html.replace("${businessActivity2}",check.getBusinessActivity2() == null ? "" : check.getBusinessActivity2());
        html = html.replace("${businessActivity3}",check.getBusinessActivity3() == null ? "" : check.getBusinessActivity3());
        if("1".equals(check.getHealthRelated())){
            html = html.replace("${serviceType}",getServiceTypeName(check.getServiceType(),check.getServiceTypeOther()));
            html = html.replace("${annualIncome}", check.getAnnualIncome() == null ? "" : check.getAnnualIncome());
            html = html.replace("${healthIncome}", check.getHealthIncome() == null ? "" : check.getHealthIncome());
            html = html.replace("${healthRate}", check.getHealthRate() == null ? "" : check.getHealthRate());
            html = html.replace("${lastYearIncome}", check.getLastYearIncome() == null ? "" : check.getLastYearIncome());
            html = html.replace("${lastYearHealthIncome}", check.getLastYearHealthIncome() == null ? "" : check.getLastYearHealthIncome());
            html = html.replace("${lastYearHealthRate}", check.getLastYearHealthRate() == null ? "" : check.getLastYearHealthRate());
        }
        html = html.replace("${companyLeader}", check.getCompanyLeader() == null ? "" : check.getCompanyLeader());
        html = html.replace("${preparer}", check.getPreparer() == null ? "" : check.getPreparer());
        html = html.replace("${preparerPhone}",check.getPreparerPhone() == null ? "" : check.getPreparerPhone());
        html = html.replace("${reportDate}",DateUtil.dateToStr(check.getReportDate(), "yyyy-MM-dd"));
        return html;
    }

    public void handleDataCheckExcel(String path, String name,GdpSurveyCheck check,String mhtName){
        try {
            write(Workbook.createWorkbook(new File(path+"/" + name)),JSON.toJSONString(check, SerializerFeature.WriteMapNullValue),GdpSurveyCheck.class,mhtName);
        }catch (Exception e){
            e.printStackTrace();
        }
    }

    private String getServiceTypeName(String serviceType,String other){
        if(StringUtils.isBlank(serviceType)){
            return "";
        }
        String result = "";
        Map<String,String> map = new HashMap<>();
        map.put("1","医疗卫生服务业");
        map.put("2","健康事务、健康环境管理与科研技术服务");
        map.put("3","健康人才教育与健康知识普及");
        map.put("4","健康促进服务");
        map.put("5","健康保障与金融服务");
        map.put("6","智慧健康技术服务");
        map.put("7","药品及其他健康产品流通服务");
        map.put("8","其他与健康相关服务");
        map.put("9","医药制造");
        map.put("10","医疗仪器设备及器械制造");
        map.put("11","健康用品、器材与智能设备制造");
        map.put("12","医疗卫生机构设施建设");
        map.put("13","中药材种植、养殖和采集");
//        map.put("","其他");
        String type[] = serviceType.split(",");
        for (int i=0;i<type.length;i++){
            String tmp = type[i];
            if("14".equals(tmp)){
                result += other+";";
            }else {
                result += map.get(tmp) + ";";
            }
        }
        return result;
    }

    /**
     * 获取单位经营情况列表
     * @return
     * @throws Exception
     */
    public Page<GdpSurveyRecord> searchGdpSurveyRecords(String companyType, String industryType, String companyName, Integer page, Integer pageSize) {
        if (page==null||page <= 0) {
            page = 1;
        }
        if (pageSize==null||pageSize <= 0) {
            pageSize = 15;
        }
        // 分页信息
        // 排序
        Sort sort = Sort.by(Sort.Direction.DESC, "id");
        PageRequest pageRequest = PageRequest.of(page - 1, pageSize,sort);
        Map<String, SearchFilter> filters = new HashMap<String, SearchFilter>();
        if (!StringUtils.isEmpty(companyName)) {
            filters.put("companyName", new SearchFilter("companyName", SearchFilter.Operator.LIKE, companyName));
        }
        if (!StringUtils.isEmpty(companyType)) {
            filters.put("companyType", new SearchFilter("companyType", SearchFilter.Operator.EQ, companyType));
        }
        if (!StringUtils.isEmpty(industryType)) {
            filters.put("industryType", new SearchFilter("industryType", SearchFilter.Operator.EQ, industryType));
        }
        Specification<GdpSurveyRecord> spec = DynamicSpecifications.bySearchFilter(filters.values(), GdpSurveyRecord.class);
        return gdpSurveyRecordDao.findAll(spec, pageRequest);
    }

    /**
     * 获取法人单位核查表列表
     * @return
     * @throws Exception
     */
    public Page<GdpSurveyCheck> searchGdpSurveyChecks(String companyName, Integer page, Integer pageSize){
        if (page==null||page <= 0) {
            page = 1;
        }
        if (pageSize==null||pageSize <= 0) {
            pageSize = 15;
        }
        // 分页信息
        // 排序
        Sort sort = Sort.by(Sort.Direction.DESC, "id");
        PageRequest pageRequest = PageRequest.of(page - 1, pageSize,sort);
        Map<String, SearchFilter> filters = new HashMap<String, SearchFilter>();
        if (!StringUtils.isEmpty(companyName)) {
            filters.put("companyName", new SearchFilter("companyName", SearchFilter.Operator.LIKE, companyName));
        }
        Specification<GdpSurveyCheck> spec = DynamicSpecifications.bySearchFilter(filters.values(), GdpSurveyCheck.class);
        return gdpSurveyCheckDao.findAll(spec, pageRequest);
    }

    public GdpSurveyCheck findCheckById(Long id){
        return gdpSurveyCheckDao.findById(id).get();
    }

    public GdpSurveyRecord findRecordById(Long id){
        return gdpSurveyRecordDao.findById(id).get();
    }

    public void delRecordById(Long id){
        gdpSurveyRecordDao.deleteById(id);
    }

    public void delCheckById(Long id){
        gdpSurveyCheckDao.deleteById(id);
    }

    /**
     * 打包文件夹
     *
     * @param sourcePath
     * @param zipPath
     * @param zipName
     * @return
     * @throws Exception
     */
    public boolean fileToZip(String sourcePath, String zipPath, String zipName) throws Exception {
        File sourceFile = new File(sourcePath);
        File zipFile = new File(zipPath + File.separator + zipName + ".zip");
        File[] files = sourceFile.listFiles();
        FileOutputStream fos = new FileOutputStream(zipFile);
        ZipOutputStream zos = new ZipOutputStream(new BufferedOutputStream(fos));

        if (files != null) {
            byte[] bufs = new byte[1024 * 10];
            for (int i = 0; i < files.length; i++) {
                // 创建ZIP实体,并添加进压缩包
                ZipEntry zipEntry = new ZipEntry(files[i].getName());
                zos.putNextEntry(zipEntry);
                // 读取待压缩的文件并写进压缩包里
                FileInputStream fis = new FileInputStream(files[i]);
                BufferedInputStream bis = new BufferedInputStream(fis, 1024 * 10);
                int read = 0;
                while ((read = bis.read(bufs, 0, 1024 * 10)) != -1) {
                    zos.write(bufs, 0, read);
                }
                bis.close();
                fis.close();
            }
            deleteFolder(sourceFile);
        }

        zos.close();
        fos.close();

        return true;
    }

    public static void deleteFolder(File folder){
        File[] files  = folder.listFiles();
        if (files != null){
            for(File f: files){
                if (f.isDirectory()){
                    deleteFolder(f);
                }else {
                    f.delete();
                }
            }
        }
        folder.delete();
    }


    public <T> T write(WritableWorkbook wwb,String objJsonStr, Class<T> target,String mhtName) throws Exception {
        try {
            WritableSheet ws;
            ws = wwb.createSheet("sheet", 1);
            addHeader(ws,objJsonStr,target,mhtName);
            wwb.write();
            wwb.close();
            return null;
        } catch (IOException e) {
            e.printStackTrace();
            if (wwb != null) wwb.close();
            throw e;
        }
    }

    public <T> T addHeader(WritableSheet ws,String objJsonStr ,Class<T> target,String mhtName) throws WriteException {
        if (target == GdpSurveyCheck.class){
            String sql = " select json_str from gdp_survey_dict where file ='"+mhtName+"'";
            List<String> jsonStrs = jdbcTemplate.queryForList(sql,String.class);
            if (jsonStrs.size()>0){
                LinkedHashMap jsonObject = JSON.parseObject(jsonStrs.get(0),LinkedHashMap.class, Feature.SortFeidFastMatch);;
                Iterator iter = jsonObject.entrySet().iterator();
                int i=0;
                List<String> header = new ArrayList<>();
                JSONObject objEntity = JSONObject.parseObject(objJsonStr);
                List<String> content = new ArrayList<>();
                while (iter.hasNext()) {
                Map.Entry entry = (Map.Entry) iter.next();
                header.add(entry.getValue().toString());
                String key = entry.getKey().toString();
                String value = "";
                if ("serviceType".equals(key)){
                    value = getServiceTypeName(objEntity.getString("serviceType"),objEntity.getString("serviceTypeOther"));
                }else if ("reportDate".equals(key)){
                   value = DateUtil.dateToStr(objEntity.getDate("reportDate"), "yyyy-MM-dd");
                }else if ("healthRelated".equals(key)){
                    value = objEntity.getString("healthRelated").equals("1")?"是":"否";
                }else{
                    value = objEntity.containsKey(key)?objEntity.getString(entry.getKey().toString()):"";
                }
                content.add(value);
                }
                i = 0;
                for (String h : header) {
                    addCell(ws, 0, i, h);//表名，行，列，header
                    i++;
                }
                i = 0;
                for (String h : content) {
                    addCell(ws, 1, i, h);//表名，行，列，header
                    i++;
                }

            }
        }
        else if(target == GdpSurveyRecord.class){
            String sql = " select json_str from gdp_survey_dict where file ='"+mhtName+"'";
            List<String> jsonStrs = jdbcTemplate.queryForList(sql,String.class);
            if (jsonStrs.size()>0){
                LinkedHashMap jsonObject = JSON.parseObject(jsonStrs.get(0),LinkedHashMap.class, Feature.SortFeidFastMatch);// JSONObject.parseObject(jsonStrs.get(0));
                Iterator iter = jsonObject.entrySet().iterator();
                int i=0;
                List<String> header = new ArrayList<>();
                JSONObject objEntity = JSONObject.parseObject(objJsonStr);
                JSONObject detailedObjEntity = objEntity.getJSONObject("detailed");
                List<String> content = new ArrayList<>();
                while (iter.hasNext()) {
                    Map.Entry entry = (Map.Entry) iter.next();
                    header.add(entry.getValue().toString());
                    String key = entry.getKey().toString();
                    String value = "";
                    if ("reportDate".equals(key)){
                        value = DateUtil.dateToStr(objEntity.getDate("reportDate"), "yyyy-MM-dd");
                    }else{
                        value = objEntity.containsKey(key)?
                                    objEntity.getString(entry.getKey().toString()):
                                    detailedObjEntity.containsKey(key)?detailedObjEntity.getString(entry.getKey().toString()):"";
                    }
                    content.add(value);
                }
                i = 0;
                for (String h : header) {
                    addCell(ws, 0, i, h);//表名，行，列，header
                    i++;
                }
                i = 0;
                for (String h : content) {
                    addCell(ws, 1, i, h);//表名，行，列，header
                    i++;
                }

            }
//            String html = doc.toString();
//            String jsonStr = record.getDetailed();
//            JSONObject jsonObject = JSONObject.parseObject(jsonStr);
//            Iterator iter = jsonObject.entrySet().iterator();
//            while (iter.hasNext()) {
//                Map.Entry entry = (Map.Entry) iter.next();
//                html = html.replace("${"+entry.getKey().toString()+"}", null==entry.getValue()?"":entry.getValue().toString());
//            }
//
//            html = html.replace("${unifiedSocialCreditCode}", record.getUnifiedSocialCreditCode());
//            html = html.replace("${companyName}",record.getCompanyName());
//            html = html.replace("${address}",record.getAddress());
//
//            html = html.replace("${companyLeader}",record.getCompanyLeader());
//            html = html.replace("${statisticalLeader}",record.getStatisticalLeader());
//            html = html.replace("${preparer}",record.getPreparer());
//            html = html.replace("${preparerPhone}",record.getPreparerPhone());
//            html = html.replace("${reportDate}",DateUtil.dateToStrShort(record.getReportDate()));
        }
            return null;
    }

    //添加单元格内容
    public void addCell(WritableSheet ws, int row, int column, String data) throws WriteException {
        Label label = new Label(column, row, data);
        ws.addCell(label);
    }

    //添加单元格内容
    public void addCell(WritableSheet ws, int row, int column, String data, String memo) throws WriteException {
        Label label = new Label(column, row, data);
        if (!org.springframework.util.StringUtils.isEmpty(memo)) {
            WritableCellFeatures cellFeatures = new WritableCellFeatures();
            cellFeatures.setComment(memo);
            label.setCellFeatures(cellFeatures);
        }
        ws.addCell(label);
    }


}
