package com.yihu.customer.service.httplog;

import  com.yihu.customer.entity.PayLog;
import  com.yihu.customer.repository.PayLogDao;
import com.yihu.customer.util.query.BaseJpaService;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.PageRequest;
import org.springframework.jdbc.core.BeanPropertyRowMapper;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.List;

/**
 * Created by humingfen on 2018/7/16.
 * 日志服务
 */
@Service
public class ManagePayLogService extends BaseJpaService<PayLog,PayLogDao> {
    @Autowired
    private PayLogDao payLogDao;
    @Autowired
    private JdbcTemplate jdbcTemplate;

    public Page<PayLog> searchList(String params, String startDate, String endDate, String status, Integer page, Integer pageSize) throws Exception{
        List<PayLog> payLogList = new ArrayList<>();
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        if(page == null){
            page = 1;
        }
        if(pageSize == null){
            pageSize = 15;
        }
        PageRequest pageRequest = PageRequest.of(page - 1, pageSize);
        String sql = "select * from ylz_pay_log p where 1=1 ";
        String countSql = "select count(1) from ylz_pay_log p where 1=1 ";
        StringBuilder filters = new StringBuilder();
        if(!StringUtils.isEmpty(params)){
            filters.append("and params like '%"+params+"%' ");
        }
        if(!StringUtils.isEmpty(startDate)){
            filters.append("and create_time > '"+startDate+"' ");
        }
        if(!StringUtils.isEmpty(endDate)){
            filters.append("and create_time < '"+endDate+"' ");
        }
        if(!StringUtils.isEmpty(status)){
            filters.append("and status = '"+status+"' ");
        }
        payLogList = jdbcTemplate.query(sql+filters.toString()+" order by p.create_time desc"+" limit "+(page-1)*pageSize+","+pageSize, new BeanPropertyRowMapper<>(PayLog.class));
        if(payLogList.size()<=0){
            return new PageImpl<PayLog>(new ArrayList<>(), pageRequest, 0);
        }
        Long count = jdbcTemplate.queryForObject(countSql+filters.toString(),Long.class);
        return new PageImpl<PayLog>(payLogList,pageRequest,count);
    }

    public PayLog findById(Long id) {
        return payLogDao.findById(id).get();
    }
}
