package com.yihu.customer.service.jw;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.stereotype.Service;

/**
 * @author huangwenjie
 * @date 2017/12/22 09:43
 */
@Service
public class Icd10DictServcie {
	private final String keyIcd10 = "wlyy:dict:icd:Icd10:";
	private final String keyHealthProblem = "wlyy:dict:icd:HealthProblem:";
	private final String keyDict2healthProblem = "wlyy:dict:icd:Icd10ToHealthProblem:";
	private final String keyHealthProblem2Dict = "wlyy:dict:icd:HealthProblemToIcd10:";
	private final String ok = "wlyy:dict:icd:init";
	
	
	@Autowired
	private StringRedisTemplate redisTemplate;
	/**
	 * 根据icd10的 code 获取全部的健康问题
	 *
	 * @param Icd10Code
	 * @return
	 */
	public String getHealthProblemsByIcd10Code(String Icd10Code) {
		return redisTemplate.opsForValue().get(keyDict2healthProblem + Icd10Code);
	}
}
