package com.yihu.customer.service.jw;

import com.yihu.customer.util.HttpManageClientUtil;
import org.apache.http.NameValuePair;
import org.apache.http.message.BasicNameValuePair;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * 基位长处方接口
 * Created by yeshijie on 2017/8/3.
 */
@Service
public class JwPrescriptionService {
	
	private static final Logger logger = LoggerFactory.getLogger(JwPrescriptionService.class);
	//基卫服务地址
	@Value("${sign.check_upload}")
	private String jwUrl;
	@Autowired
	private HttpManageClientUtil httpManageClientUtil;
	
	/**
	 * 获取单条历史处方
	 * @param recipeNo
	 * @param cardNo
	 * @return
	 */
	public String getRecipe(String recipeNo,String cardNo){
		String url = jwUrl + "/third/prescription/getRecipe";
		List<NameValuePair> params = new ArrayList<>();
		params.add(new BasicNameValuePair("recipeNo", recipeNo));
		params.add(new BasicNameValuePair("cardNo", cardNo));
		
		String response = httpManageClientUtil.post(url, params, "UTF-8");
		
		return response;
	}
	
}