package com.yihu.customer.service.manager.account;

import com.alibaba.fastjson.JSONArray;

import com.yihu.customer.service.BaseService;
import com.yihu.customer.service.common.PatientService;
import com.yihu.customer.service.manager.family.FamilyMemberService;
import com.yihu.customer.service.manager.hos.HosDoctorService;
import com.yihu.customer.service.manager.sign.FamilyContractService;
import com.yihu.customer.service.manager.sign.SignFamilyService;
import com.yihu.customer.util.DateUtil;
import com.yihu.customer.util.SpringManageContextUtil;
import com.yihu.customer.util.file.FileUtil;
import  com.yihu.customer.entity.*;
import  com.yihu.customer.entity.call.CallRecord;
import  com.yihu.customer.entity.call.CallService;
import  com.yihu.customer.entity.call.ManageCallRecordVideoDo;
import  com.yihu.customer.entity.call.ManageFollowupRecord;
import  com.yihu.customer.entity.synergy.ManageSynergyWorkorderDO;
import  com.yihu.customer.entity.synergy.ManageSynergyWorkorderExecutorDO;
import  com.yihu.customer.entity.synergy.ManageSynergyWorkorderReserveConsultDO;
import  com.yihu.customer.entity.synergy.ManageSynergyWorkorderServicerDO;
 
import  com.yihu.customer.repository.*;
import com.yihu.customer.util.HttpManageClientUtil;
import com.yihu.customer.util.WorkbookUtil;
import  com.yihu.customer.repository.call.CallRecordDao;
import  com.yihu.customer.repository.call.CallServiceDao;
import  com.yihu.customer.repository.call.ManageCallRecordVideoDao;
import  com.yihu.customer.repository.call.ManageFollowupRecordDao;
import  com.yihu.customer.repository.synergy.ManageSynergyWorkOrderDao;
import  com.yihu.customer.repository.synergy.ManageSynergyWorkorderExecutorDao;
import  com.yihu.customer.repository.synergy.ManageSynergyWorkorderReserveConsultDao;
import  com.yihu.customer.repository.synergy.ManageSynergyWorkorderServicerDao;
import com.yihu.customer.service.synergy.SynergyManageService;
import jxl.Workbook;
import org.apache.commons.collections.map.HashedMap;
import org.apache.commons.lang3.StringUtils;
import org.apache.http.NameValuePair;
import org.apache.http.message.BasicNameValuePair;
import org.json.JSONObject;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.jdbc.core.BeanPropertyRowMapper;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;

import javax.annotation.PostConstruct;
import javax.servlet.http.HttpServletResponse;
import javax.transaction.Transactional;
import java.io.*;
import java.net.URLEncoder;
import java.util.*;
import java.util.concurrent.TimeUnit;

@Service
@Transactional
public class CustomerService extends BaseService {

	@Autowired
	private FamilyMemberService familyMemberService;
	@Autowired
	private FamilyContractService contractService;
	@Autowired
	private HosDoctorService hosDoctorService;
	@Autowired
	private CallRecordDao callRecordDao;
	@Autowired
	private CallServiceDao callServiceDao;
	@Autowired
	private PatientDao patientDao;
	@Autowired
	private SignFamilyService familyService;
	@Autowired
	private UserDao userDao;
	@Autowired
	private JdbcTemplate jdbcTemplate;
	@Autowired
	private MessageDao messageDao;
	@Autowired
	private DoctorDao doctorDao;
	@Autowired
	private PatientReservationDao patientReservationDao;
	@Autowired
	private SignFamilyDao signFamilyDao;
	@Autowired
	private ManageSynergyWorkOrderDao manageSynergyWorkOrderDao;
	@Autowired
	private ManageSynergyWorkorderServicerDao manageSynergyWorkorderServicerDao;
	@Autowired
	private ManageSynergyWorkorderExecutorDao manageSynergyWorkorderExecutorDao;
	@Autowired
	private ManageSynergyWorkorderReserveConsultDao manageSynergyWorkorderReserveConsultDao;
	@Autowired
	private SynergyManageService synergyManageService;
	@Autowired
	private ManageCallRecordVideoDao manageCallRecordVideoDao;
	@Autowired
	private ManageFollowupRecordDao manageFollowupRecordDao;
	
	@Autowired
	private StringRedisTemplate redisTemplate;
	
	@Autowired
	private PatientService patientService;
	enum profile{
		dev,devtest,test,prod
	}
	@Value("${fastDFS.fastdfs_file_url}")
	private String fastdfs_file_url;

	@Value(("${doctorAssistant.api}")+"/wlyygc/doctor/message")
	private String messageApi;

	private Logger logger = LoggerFactory.getLogger(CustomerService.class);
	//业务编号及名称
	Map<Integer, String> relations = new HashMap<>();
	@PostConstruct
	public void init() {
		relations.put(1, "政策咨询");
		relations.put(2, "查询指导");
		relations.put(3, "投诉建议");
		relations.put(4, "家医呼叫");
	}



	public Map<String,Object> findServerInfo(Patient patient) throws Exception {
		Map<String, Object> resp = new HashMap<>();

		//查找家庭成员关系
		List<Map<String, Object>> familyMembers = familyMemberService.getAllFamilyMembers(patient.getCode());
		resp.put("family",familyMembers);

		//查询签约信息
		SignFamily signInfo = contractService.findSignInfo(patient.getCode());

		//查询家庭成员的每个签约信息    以及签约医生
		List doctors = new ArrayList<Doctor>();
		if(signInfo!=null){
			signInfo.setStatusName("已签约");
			//查找全科医生
			String doctorCode = signInfo.getDoctor();
			if(StringUtils.isNotBlank(doctorCode)){
				Doctor doctor = hosDoctorService.getDoctorByCode(doctorCode);
				doctors.add(doctor);
			}
			//查找健康管理师
			String doctorHealthCode = signInfo.getDoctorHealth();
			if(StringUtils.isNotBlank(doctorHealthCode)){
				Doctor doctor = hosDoctorService.getDoctorByCode(doctorHealthCode);
				doctors.add(doctor);
			}
		}
		String labelSql="SELECT DISTINCT" +
				" CASE call_label" +
				" WHEN '1' THEN" +
				" '有待跟踪'" +
				" WHEN '2' THEN" +
				" '电话骚扰'" +
				" WHEN '3' THEN" +
				" '态度恶劣'" +
				" END call_label" +
				" FROM" +
				" manage_call_record" +
				" WHERE" +
				" caller_number = '"+patient.getMobile()+"'" +
				" AND type = 1" +
				" AND call_label IS NOT NULL" +
				" AND call_label != ''" +
				" AND call_label != 'null'";
		List<Map<String,Object>> labelInfo = jdbcTemplate.queryForList(labelSql);
		resp.put("signInfo",signInfo);
		resp.put("doctors",doctors);
		resp.put("labelInfo",labelInfo);

		return resp;
	}


	public Map<String,Object> findServerInfo(String patientCode) throws Exception {
		Map<String, Object> resp = new HashMap<>();

		//查找家庭成员关系
		List<Map<String, Object>> familyMembers = familyMemberService.getAllFamilyMembers(patientCode);
		resp.put("family",familyMembers);

		//查询签约信息
		SignFamily signInfo = contractService.findSignInfo(patientCode);

		//查询家庭成员的每个签约信息    以及签约医生
		List doctors = new ArrayList<Doctor>();
		if(signInfo!=null){
			signInfo.setStatusName("已签约");
			//查找全科医生
			String doctorCode = signInfo.getDoctor();
			if(StringUtils.isNotBlank(doctorCode)){
				Doctor doctor = hosDoctorService.getDoctorByCode(doctorCode);
				doctors.add(doctor);
			}
			//查找健康管理师
			String doctorHealthCode = signInfo.getDoctorHealth();
			if(StringUtils.isNotBlank(doctorHealthCode)){
				Doctor doctor = hosDoctorService.getDoctorByCode(doctorHealthCode);
				doctors.add(doctor);
			}
		}

		resp.put("signInfo",signInfo);
		resp.put("doctors",doctors);

		return resp;
	}

	/**
	 *
	 * @param doctor
	 * @param msg
	 * @param type  1发送短信   2发送微信   3短信微信都发送
	 * @return
	 */
	public Map<String, Object> sendMsg(Doctor doctor,String msg,String type) {
		Map<String, Object> resp = new HashMap<String, Object>();

		//发送微信消息
		String openId = doctor.getOpenid();
		if(!StringUtils.isBlank(openId)&&!"1".equals(type)){
			List<NameValuePair> par = new ArrayList<NameValuePair>();
			par.add(new BasicNameValuePair("openIds", openId));
			par.add(new BasicNameValuePair("content", msg));
			try {
				logger.info("====================================================================");
				String result = HttpManageClientUtil.post(messageApi+"/sendWechatMessage", par,"UTF-8");
				logger.info("微信发送消息返回结果:"+result);
				logger.info("====================================================================");
				JSONObject resultJson = new JSONObject(result);
				if(1!=resultJson.getInt("successNum")){
					resp.put("wechat","-1");//-1代表发送失败
				}
			}catch (Exception e){
				resp.put("wechat","-1");//-1代表发送失败
			}
		}

		//发送短信消息啦
		String mobile = doctor.getMobile();
		if(!StringUtils.isBlank(mobile)&&!"2".equals(type)){
			msg+=" 您可通过微信关注\"i健康智能助手\"公众号更快更便捷的获取服务信息。";
			List<NameValuePair> par = new ArrayList<NameValuePair>();
			par.add(new BasicNameValuePair("mobiles", mobile));
			par.add(new BasicNameValuePair("content", msg));
			try {
				logger.info("====================================================================");
				String result = HttpManageClientUtil.post(messageApi+"/sendMessage",par,"UTF-8");
				logger.info("发送短信消息返回结果:"+result);
				logger.info("======================================================================");
				JSONObject resultJson = new JSONObject(result);
				if(1!=resultJson.getInt("successNum")){
					resp.put("mobile","-1");//-1代表发送失败
				}
			}catch (Exception e){
				resp.put("mobile","-1");//-1代表发送失败
			}
		}
		return resp;
	}

	public Map<String,Object> sendCallServiceWXMes(String openid,String doctorName,String patientName,String typeName,String mobile,String remark){

		Map<String, Object> resp = new HashMap<String, Object>();
		List<NameValuePair> par = new ArrayList<NameValuePair>();
		par.add(new BasicNameValuePair("openIds", openid));
		par.add(new BasicNameValuePair("doctorName", doctorName));
		par.add(new BasicNameValuePair("patientName", patientName));
		par.add(new BasicNameValuePair("typeName", typeName));
		par.add(new BasicNameValuePair("mobile", mobile));
		par.add(new BasicNameValuePair("remark", remark));
		try {
			logger.info("====================================================================");
			String result = HttpManageClientUtil.post(messageApi+"/sendCallServerWechatMessage", par,"UTF-8");
			logger.info("微信发送消息返回结果:"+result);
			logger.info("====================================================================");
			JSONObject resultJson = new JSONObject(result);
			if(1!=resultJson.getInt("successNum")){
				resp.put("wechat","-1");//-1代表发送失败
			}
		}catch (Exception e){
			resp.put("wechat","-1");//-1代表发送失败
		}
		return resp;
	}

	public Map<String,Object> addCallRecord(String user,Integer type,String callerNumber,String recipientNumber,Integer status,Integer businessCode,String callId){


		Map<String,Object> rs = new HashedMap();

		User u = userDao.findByCode(user);

		CallRecord callRecord = new CallRecord();
		callRecord.setType(type);
		callRecord.setCode(getCode());
		callRecord.setCallerNumber(callerNumber);
		callRecord.setRecipientNumber(recipientNumber);
		callRecord.setAnswerStatus(status);
		callRecord.setCreateTime(new Date());
		callRecord.setCallTime(new Date());
		callRecord.setUserCode(user);
		callRecord.setUserName(u.getName());
		callRecord.setBusinessCode(businessCode);
		callRecord.setBusinessName(relations.get(businessCode));
		callRecord.setCallId(callId);
		CallRecord temp = callRecordDao.save(callRecord);

		rs.put("state",1);
		rs.put("mes","保存成功");
		rs.put("callRecord",temp);

		return rs;
	}



	public String  updateCallRecord(String jsonString){
		net.sf.json.JSONObject json = net.sf.json.JSONObject.fromObject(jsonString);
		CallRecord callRecord =(CallRecord)net.sf.json.JSONObject.toBean(json,CallRecord.class);
		callRecordDao.save(callRecord);
		return "1";
	}

	public Map<String,Object> updateCallRecordService(String code,String phone,String serviceType,String serviceContent,Integer transferState){
		CallRecord callRecord = callRecordDao.findByCode(code);

		List<Patient> list =  patientDao.findByMobile(phone);
		Map<String,Object> rs = new HashedMap();
		Patient p ;
		if(list==null&&list.size()==0){
			rs.put("state",-1);
			rs.put("mes","未找到患者信息");
			rs.put("callRecord",null);
			return rs;
		}else{
			p = list.get(0);
		}

		SignFamily sf = familyService.findByPatientCode(p.getCode());
		if(sf==null){
			rs.put("state",-2);
			rs.put("mes","未找到患者签约信息");
			rs.put("callRecord",null);
			return rs;
		}
		//存储患者信息信息
		callRecord.setPatient(p.getCode());
		callRecord.setPatientName(p.getName());
		callRecord.setIdcard(p.getIdcard());
		callRecord.setSsc(p.getSsc());
		//存储医生信息
		callRecord.setDoctor(sf.getDoctor());
		callRecord.setDoctorName(sf.getDoctorName());
		callRecord.setServiceType(serviceType);
		callRecord.setServiceContent(serviceContent);
		callRecord.setAdminTeamCode(sf.getAdminTeamId());
		callRecord.setTransferState(transferState);
		CallRecord call = callRecordDao.save(callRecord);

		rs.put("state",1);
		rs.put("mes","保存成功");
		rs.put("callRecord",call);
		return rs;
	}

	public String  updateCallRecordEndTime(String code,String patientCode){
		CallRecord callRecord = callRecordDao.findByCode(code);
		Patient patient = patientDao.findByCode(patientCode);
		if (patient!=null){
			callRecord.setPatient(patientCode);
			callRecord.setPatientName(patient.getName());
			SignFamily signFamily = signFamilyDao.findByPatient(patientCode);
			if (signFamily!=null){
				callRecord.setDoctor(signFamily.getDoctor());
				callRecord.setDoctorName(signFamily.getDoctorName());
				callRecord.setAdminTeamCode(signFamily.getAdminTeamId());
			}
		}
		callRecord.setEndTime(new Date());
		callRecord.setTalkTime(DateUtil.getTimeDifference(callRecord.getCreateTime(),callRecord.getEndTime()));
		callRecordDao.save(callRecord);
		return "1";
	}

	public Map<String,Object> getCallRecords(String callerNumber,String recipientNumber,String seat, Integer answerStatus,Integer serviceType ,String userName,String jobNo,String startDate,String endDate,Integer page,Integer size,Integer followup){

		Map<String,Object> map = new HashedMap();

		String sqltotal = "SELECT count(1) as total" +
				" FROM " +
				" manage_call_record r " +
				" WHERE " +
				" 1 = 1 ";
		sqltotal = setCallRecordSql( sqltotal, callerNumber,seat,recipientNumber, answerStatus, serviceType ,userName,jobNo, startDate, endDate,followup);
		List<Map<String,Object>> rsTotal = jdbcTemplate.queryForList(sqltotal);
		Long total = (Long)rsTotal.get(0).get("total");

		if(total==0){
			map.put("callRecords",null);
			map.put("page",page);
			map.put("total",0);
			map.put("records",0);
			return map;
		}

		String sql = "SELECT " +
				" r.type, " +
				" r.caller_number AS callerNumber, " +
				" r.recipient_number AS recipientNumber, " +
				" r.call_time AS callTime, " +
				" r.talk_time AS talkTime, " +
				" r.answer_status AS answerStatus, " +
				" r.type AS type, " +
				" r.user_name AS userName, " +
				" r.user_code AS userCode," +
				" r.code," +
				" r.service_type AS serviceType," +
				" r.patient_name AS patientName," +
				" r.follow_up AS followUp " +
				" FROM " +
				" manage_call_record r " +
				" WHERE " +
				" 1 = 1 ";
		sql = setCallRecordSql( sql, callerNumber,seat,recipientNumber, answerStatus, serviceType ,userName,jobNo, startDate, endDate,followup);
		sql += " ORDER BY r.call_time DESC LIMIT "+(page-1)*size+","+size;
		List<Map<String,Object>> rs = jdbcTemplate.queryForList(sql);

		map.put("page",page);
		map.put("records",total);
		map.put("callRecords",rs);
		double t = (double)total;
		map.put("total",Math.ceil(t/size));

		return map;
	}

	public String setCallRecordSql(String sql,String callerNumber,String seat,String recipientNumber,Integer answerStatus,Integer serviceType ,String userName,String jobNo,String startDate,String endDate,Integer followup){
		if(StringUtils.isNotBlank(callerNumber)){
			sql +=" AND r.caller_number = '"+callerNumber+"'";
		}
		if(answerStatus!=null){
			sql += " AND r.answer_status = "+answerStatus ;
		}
		if(StringUtils.isNotBlank(seat)){
			List<User> us = userDao.findBySeatAndType(seat,4);
			if(us!=null&&us.size()>0){
				User u = us.get(0);
				sql += " AND r.user_code = '"+u.getCode()+"'";
			}
		}
		if(serviceType!=null){
			sql += " AND r.service_type = " +serviceType;
		}
		if(StringUtils.isNotBlank(startDate)){
			sql +=" AND r.call_time >='"+startDate+" 00:00:00'";
		}
		if(StringUtils.isNotBlank(endDate)){
			sql +=" AND r.call_time <='"+endDate+" 23:59:59'";
		}
		if(StringUtils.isNotBlank(userName)){
			sql +=" AND r.user_name LIKE '%"+userName+"%'";
		}
		if(StringUtils.isNotBlank(jobNo)){
			User u = userDao.findByJobNo(jobNo);
			sql +=" AND r.user_code = '"+u.getCode()+"'";
		}
		if(StringUtils.isNotBlank(recipientNumber)){
			sql +=" AND r.recipient_number = '"+recipientNumber+" '";
		}

		if(followup !=null){
			sql +=" AND r.follow_up = "+followup +" ";
		}
		return sql;
	}

	public Map<String,Object> getCallRecordInfo(String code){
		CallRecord callRecord = callRecordDao.findByCode(code);
		String sql ="SELECT " +
				" w.`code`, " +
				" w.`status` AS wordStatus, " +
				" s.service_patient_code, " +
				" s.service_patient_name, " +
				" w.content, " +
				" l.remark, " +
				" s.relation_code, " +
				" s.relation_code_name, " +
				" w.type, " +
				" s.`status` AS serviceStatus " +
				" FROM " +
				" manage_synergy_workorder_servicer_log l " +
				" LEFT JOIN manage_synergy_workorder w ON l.workorder_code = w.`code` " +
				" LEFT JOIN manage_synergy_workorder_servicer s ON l.workorder_service_code = s.`code` " +
				" WHERE " +
				" l.call_code = '"+code+"'";

		List<Map<String,Object>> list = jdbcTemplate.queryForList(sql);
		List<Map<String,Object>> consultList = new ArrayList<>();
		List<Map<String,Object>> followList = new ArrayList<>();
		List<PatientReservation> patientReservation = new ArrayList<>();
		List<Map<String,Object>> surveyList = new ArrayList<>();
		List<Map<String,Object>> screenList = new ArrayList<>();

		for (Map<String,Object> map : list){
			String type = String.valueOf(map.get("type"));
			String relationCode = String.valueOf(map.get("relation_code"));
			//获取家庭医生姓名
			SignFamily signFamily = signFamilyDao.findByPatient(String.valueOf(map.get("service_patient_code")));
			if (signFamily!=null){
				map.put("familyDoctorName",signFamily.getDoctorName());
			}
			map.put("mobile",callRecord.getCallerNumber());
			//咨询
			if ("0".equals(type)){
				String consultSql ="SELECT deal_type,deal_content FROM `manage_synergy_workorder_reserve_consult` WHERE call_code='"+code+"'";
				List<Map<String,Object>> clist = jdbcTemplate.queryForList(consultSql);
				for (Map<String,Object> cmap : clist){
					map.putAll(cmap);
				}
				consultList.add(map);
			}
			//健康教育
			if ("1".equals(type)){

			}
			//预约
		    if ("2".equals(type)){
				patientReservation = patientReservationDao.findByCallCode(code);
			}
			//随访
			if ("3".equals(type)){
				String followSql ="SELECT followup_class FROM wlyy_followup where id="+relationCode;
				List<Map<String,Object>> flist = jdbcTemplate.queryForList(followSql);
				for (Map<String,Object> fmap : flist){
					map.putAll(fmap);
				}
				followList.add(map);
			}
			//问卷调查
			if ("4".equals(type)){
				String qsql="SELECT template_title FROM `wlyy_survey_question_result` WHERE `code`='"+relationCode+"'";
				List<Map<String,Object>> flist = jdbcTemplate.queryForList(qsql);
				for (Map<String,Object> fmap : flist){
					map.putAll(fmap);
				}
				surveyList.add(map);
			}
			//疾病筛查
			if ("5".equals(type)){
				String ssql="SELECT template_title,screen_result_score FROM `wlyy_survey_screen_result` WHERE `code`='"+relationCode+"'";
				List<Map<String,Object>> flist = jdbcTemplate.queryForList(ssql);
				for (Map<String,Object> fmap : flist){
					map.putAll(fmap);
				}
				screenList.add(map);
			}
		}
		//TODO 根据通话记录获取录音 通过主叫号 工号
		//获取客服工号
		User user = userDao.findByCode(callRecord.getUserCode());
		String jobNumber=null==user?"":user.getJobNo();
		String date=DateUtil.dateToStr(callRecord.getCallTime(),DateUtil.YYYYMMDDHH);
		String sqlVideo="select  m.* from wlyy.manage_call_record_video m where m.serial_number like '"+date+"%' and m.job_number='"+jobNumber+"' and m.caller='"+callRecord.getCallerNumber()+"'  and m.status=1";
		List<ManageCallRecordVideoDo> manageCallRecordVideoDos=jdbcTemplate.query(sqlVideo,new BeanPropertyRowMapper(ManageCallRecordVideoDo.class));

		Map<String,Object> rs = new HashedMap();
		//录音文件列表
		callRecord.setManageCallRecordVideoDos(manageCallRecordVideoDos);
		SignFamily signFamily = signFamilyDao.findByPatient(callRecord.getPatient());
		com.alibaba.fastjson.JSONObject object = new com.alibaba.fastjson.JSONObject();

		if (signFamily!=null){
			Doctor doctor = doctorDao.findByCode(signFamily.getDoctor());
			if (signFamily.getDoctorHealth()!=null&&signFamily.getDoctorHealth()!=""){
				Doctor doctorHealth = doctorDao.findByCode(signFamily.getDoctorHealth());
				object.put("doctorHealthPhone",doctorHealth.getMobile());
			}else {
				object.put("doctorHealthPhone","");
			}

			object.put("hospitalName",signFamily.getHospitalName());
			object.put("doctorName",signFamily.getDoctorName());
			object.put("doctorPhone",doctor.getMobile());
			object.put("doctorHealthName",signFamily.getDoctorHealthName());
		}else {
			object=null;
		}
		rs.put("signFamily",object);//家签信息
		rs.put("callRecord",callRecord);
		rs.put("patientReservation",patientReservation);
		rs.put("consult",consultList);
		rs.put("follow",followList);
		rs.put("survey",surveyList);
		rs.put("screen",screenList);

		return rs;
	}

	public String getCallServiceCode(String type){
		/**
		 * 服务编号规则：协同服务类型编号+YYMMddhhmmss+编号
		 * 协同服务类型编号：01预约挂号，02咨询医生
		 * YYMMDDHHMMSS：创建时间，例子20170901010101
		 * 编号：4位，当天累计协同服务数，按顺序+1
		 */
		String head ;
		if("1".equals(type)){
			head = "01";
		}else{
			head = "02";
		}
		String time = DateUtil.getStringDate("YYYYMMDDHHmmss");
		String sql = "SElECT count(1) AS total FROM manage_call_service s WHERE s.create_time >='"+DateUtil.getStringDate("yyyy-MM-ss")+" 00:00:00'";
		List<Map<String,Object>> list = jdbcTemplate.queryForList(sql);
		String count ;
		if(list!=null&&list.size()>0){
			Map<String,Object> map = list.get(0);
			Long c = (Long) map.get("total");
			count =c.toString();
		}else{
			count = "0000";
		}
		if(count.length()==1){
			count = "000"+count;
		}else if(count.length()==2){
			count = "00"+count;
		}else if(count.length()==3){
			count = "0"+count;
		}else if(count.length()==4){
			count = count;
		}else{
			count = count.substring(0,3);
		}
		return head+time+count;

	}

	/**
	 * 保存协同服务
	 * @param callServiceJson
	 * @param user
	 * @return
     */
	public String saveCallService(String callServiceJson,String user){
		net.sf.json.JSONObject jsonObject = net.sf.json.JSONObject.fromObject(callServiceJson);
		CallService callService =  (CallService)net.sf.json.JSONObject.toBean(jsonObject,CallService.class);

		if(!checkCallServiceCount(callService)){
			return "-1";
		}
		callService.setCode(getCallServiceCode(callService.getType()+""));
		callService.setUser(user);
		User u = userDao.findByCode(user);
		callService.setUserName(u.getName());
		//存储患者信息
		Patient p = patientDao.findByCode(callService.getPatient());
		callService.setIdcard(p.getIdcard());
		callService.setSsc(p.getSsc());
		//存储医生
		SignFamily sf = familyService.findByPatientCode(callService.getPatient());
		callService.setAdminTeamCode(sf.getAdminTeamId());
		callService.setCreateTime(new Date());
		callService.setOrderHospital(sf.getHospital());
		callService.setOrderHospitalName(sf.getHospitalName());
		callService = callServiceDao.save(callService);
		//待处理发送消息给医生
		sendCallServiceMes(callService);
		String activeProfile = SpringManageContextUtil.getActiveProfile();
		if(profile.prod.name().equals(activeProfile)){//正式环境才推送
			//发送消息
			sendWxMes(callService);
		}

		//将旧数据存储到新表---------START
		ManageSynergyWorkorderDO manageSynergyWorkorderDO = new ManageSynergyWorkorderDO();
		// 协同服务工单的服务对象表
		ManageSynergyWorkorderServicerDO manageSynergyWorkorderServicerDO = new ManageSynergyWorkorderServicerDO();
		// 协同服务执行人表
		ManageSynergyWorkorderExecutorDO manageSynergyWorkorderExecutorDO = new ManageSynergyWorkorderExecutorDO();
		// 咨询、预约操作日志表
		ManageSynergyWorkorderReserveConsultDO manageSynergyWorkorderReserveConsultDO = new ManageSynergyWorkorderReserveConsultDO();
		
		manageSynergyWorkorderDO.setDel(1);
		//咨询
		if(0 == callService.getType()){
			manageSynergyWorkorderDO.setType(0);
			manageSynergyWorkorderServicerDO.setWorkorderType(0);
		}else if (1 == callService.getType()){
			manageSynergyWorkorderDO.setType(2);
			manageSynergyWorkorderServicerDO.setWorkorderType(2);
		}
		//服务时间
		manageSynergyWorkorderDO.setServiceTime(callService.getDealTime());
		//工单状态
		if( 0 == callService.getState()){
			manageSynergyWorkorderDO.setStatus(0);
			manageSynergyWorkorderServicerDO.setStatus(0);
		}else if (1 == callService.getState()){
			manageSynergyWorkorderDO.setStatus(2);
			manageSynergyWorkorderServicerDO.setStatus(2);
		}else if(2 == callService.getState()){
			manageSynergyWorkorderDO.setStatus(3);
			manageSynergyWorkorderServicerDO.setStatus(3);
		}
		
		
		manageSynergyWorkorderDO.setPriority(0);//默认普通
		manageSynergyWorkorderDO.setCreateTime(new Date());
		manageSynergyWorkorderDO.setCreateUser(callService.getUser());
		manageSynergyWorkorderDO.setCreateUserName(callService.getUserName());
		manageSynergyWorkorderDO.setCreateUserType(2);//默认为客服
		manageSynergyWorkorderDO.setRemark(callService.getRemark());
		manageSynergyWorkorderDO.setContent(callService.getDealContent());
		manageSynergyWorkorderDO.setServicerCount(1);
		manageSynergyWorkorderDO.setReceiverCode(callService.getDoctor());
		manageSynergyWorkorderDO.setReceiverName(callService.getDoctorName());
		manageSynergyWorkorderDO.setReceiverType(1);
		manageSynergyWorkorderDO.setRelationCode(callService.getCode());
		manageSynergyWorkorderDO.setHospital(sf.getHospital());
		manageSynergyWorkorderDO.setHospitalName(sf.getHospitalName());
		manageSynergyWorkorderDO.setCode(synergyManageService.getWorkorderNo());
		manageSynergyWorkorderDO.setServicerKey(callService.getPatientName());
		
		//优先级
		if(jsonObject.containsKey("priority")){
			Integer priority = jsonObject.getInt("priority");
			manageSynergyWorkorderDO.setPriority(priority);
		}
		
		manageSynergyWorkorderDO = manageSynergyWorkOrderDao.save(manageSynergyWorkorderDO);
		

		manageSynergyWorkorderServicerDO.setWorkorderCode(manageSynergyWorkorderDO.getCode());
		manageSynergyWorkorderServicerDO.setCreateTime(new Date());
		manageSynergyWorkorderServicerDO.setCode(UUID.randomUUID().toString());
		manageSynergyWorkorderServicerDO.setServicePatientCode(callService.getPatient());
		manageSynergyWorkorderServicerDO.setServicePatientName(callService.getPatientName());
		manageSynergyWorkorderServicerDO.setIdcard(callService.getIdcard());
		manageSynergyWorkorderServicerDO.setSsc(callService.getSsc());
		manageSynergyWorkorderServicerDO.setMobile(callService.getPhone());
		manageSynergyWorkorderServicerDO.setHospital(callService.getOrderHospital());
		manageSynergyWorkorderServicerDO.setHospitalName(callService.getOrderHospitalName());
		manageSynergyWorkorderServicerDO.setExecutorType(1);
		manageSynergyWorkorderServicerDao.save(manageSynergyWorkorderServicerDO);
		
		manageSynergyWorkorderExecutorDO.setWorkorderCode(manageSynergyWorkorderDO.getCode());
		manageSynergyWorkorderExecutorDO.setDel(1);
		manageSynergyWorkorderExecutorDO.setExecutorType(3);
		manageSynergyWorkorderExecutorDO.setExecutorCode(callService.getUser());
		manageSynergyWorkorderExecutorDO.setExecutorName(callService.getUserName());
		manageSynergyWorkorderExecutorDO.setCode(UUID.randomUUID().toString());
		manageSynergyWorkorderExecutorDao.save(manageSynergyWorkorderExecutorDO);
		
		manageSynergyWorkorderReserveConsultDO.setCode(UUID.randomUUID().toString());
		manageSynergyWorkorderReserveConsultDO.setWorkorderCode(manageSynergyWorkorderDO.getCode());
		manageSynergyWorkorderReserveConsultDO.setWorkorderServiceCode(manageSynergyWorkorderServicerDO.getCode());
		manageSynergyWorkorderReserveConsultDO.setDealType(callService.getDealType());
		manageSynergyWorkorderReserveConsultDO.setDealTime(new Date());
		manageSynergyWorkorderReserveConsultDO.setDealState(callService.getDealState());
		manageSynergyWorkorderReserveConsultDO.setDealContent(callService.getDealContent());
		manageSynergyWorkorderReserveConsultDO.setDealReason(callService.getDealReason());
		manageSynergyWorkorderReserveConsultDO.setOrderHospital(callService.getOrderHospital());
		manageSynergyWorkorderReserveConsultDO.setOrderHospitalName(callService.getOrderHospitalName());
		manageSynergyWorkorderReserveConsultDO.setOrderDept(callService.getOrderDept());
		manageSynergyWorkorderReserveConsultDO.setOrderDeptName(callService.getOrderDeptName());
		manageSynergyWorkorderReserveConsultDO.setOrderDoctor(callService.getOrderDoctor());
		manageSynergyWorkorderReserveConsultDO.setOrderDoctorName(callService.getOrderDoctorName());
		manageSynergyWorkorderReserveConsultDO.setOrderTime(callService.getOrderTime());
		manageSynergyWorkorderReserveConsultDO.setRegisterTime(callService.getRegisterTime());
		manageSynergyWorkorderReserveConsultDO.setUser(callService.getUser());
		manageSynergyWorkorderReserveConsultDO.setUserName(callService.getUserName());
		manageSynergyWorkorderReserveConsultDO.setCreateTime(callService.getCreateTime());
		manageSynergyWorkorderReserveConsultDO.setCallCode(callService.getCallCode());
		manageSynergyWorkorderReserveConsultDao.save(manageSynergyWorkorderReserveConsultDO);
		
		return "1";
	}


	public String updateCallService(String callServiceJson,String user){
		net.sf.json.JSONObject jsonObject = net.sf.json.JSONObject.fromObject(callServiceJson);
		CallService callService =  (CallService)net.sf.json.JSONObject.toBean(jsonObject,CallService.class);
		callService.setUser(user);
		User u = userDao.findByCode(user);
		callService.setUserName(u.getName());
		callServiceDao.save(callService);
		//待处理发送消息给医生
		sendCallServiceMes(callService);

		//发送消息
		String activeProfile = SpringManageContextUtil.getActiveProfile();
		if(profile.prod.name().equals(activeProfile)){//正式环境才推送
			//发送消息
			sendWxMes(callService);
		}
		
		//将旧数据存储到新表---------START
		ManageSynergyWorkorderDO manageSynergyWorkorderDO = manageSynergyWorkOrderDao.findByRelationCode(callService.getCode());
		// 协同服务工单的服务对象表
		ManageSynergyWorkorderServicerDO manageSynergyWorkorderServicerDO = manageSynergyWorkorderServicerDao.findByWorkorderCode(manageSynergyWorkorderDO.getCode()).get(0);
		// 协同服务执行人表
		ManageSynergyWorkorderExecutorDO manageSynergyWorkorderExecutorDO = manageSynergyWorkorderExecutorDao.findByWorkorderCode(manageSynergyWorkorderDO.getCode(),3).get(0);
		// 咨询、预约操作日志表
		ManageSynergyWorkorderReserveConsultDO manageSynergyWorkorderReserveConsultDO = manageSynergyWorkorderReserveConsultDao.findByWorkorderCode(manageSynergyWorkorderDO.getCode());
		
		manageSynergyWorkorderDO.setDel(1);
		//咨询
		if(0 == callService.getType()){
			manageSynergyWorkorderDO.setType(0);
			manageSynergyWorkorderServicerDO.setWorkorderType(0);
		}else if (1 == callService.getType()){
			manageSynergyWorkorderDO.setType(2);
			manageSynergyWorkorderServicerDO.setWorkorderType(2);
		}
		//服务时间
		manageSynergyWorkorderDO.setServiceTime(callService.getDealTime());
		//工单状态
		if( 0 == callService.getState()){
			manageSynergyWorkorderDO.setStatus(0);
			manageSynergyWorkorderServicerDO.setStatus(0);
		}else if (1 == callService.getState()){
			manageSynergyWorkorderDO.setStatus(2);
			manageSynergyWorkorderServicerDO.setStatus(2);
		}else if(2 == callService.getState()){
			manageSynergyWorkorderDO.setStatus(3);
			manageSynergyWorkorderServicerDO.setStatus(3);
		}
		//优先级
		manageSynergyWorkorderDO.setPriority(0);//默认普通
		manageSynergyWorkorderDO.setCreateTime(new Date());
		manageSynergyWorkorderDO.setCreateUser(callService.getUser());
		manageSynergyWorkorderDO.setCreateUserName(callService.getUserName());
		manageSynergyWorkorderDO.setCreateUserType(2);//默认为客服
		manageSynergyWorkorderDO.setRemark(callService.getRemark());
		manageSynergyWorkorderDO.setContent(callService.getDealContent());
		manageSynergyWorkorderDO.setServicerCount(1);
		manageSynergyWorkorderDO.setReceiverCode(callService.getDoctor());
		manageSynergyWorkorderDO.setReceiverName(callService.getDoctorName());
		manageSynergyWorkorderDO.setReceiverType(1);
		manageSynergyWorkorderDO.setRelationCode(callService.getCode());
		manageSynergyWorkorderDO.setServicerKey(callService.getUserName());
		manageSynergyWorkorderDO.setHospital(callService.getOrderHospital());
		manageSynergyWorkorderDO.setHospitalName(callService.getOrderHospitalName());
		if(jsonObject.containsKey("priority")){
			Integer priority = jsonObject.getInt("priority");
			manageSynergyWorkorderDO.setPriority(priority);
		}
		manageSynergyWorkorderDO = manageSynergyWorkOrderDao.save(manageSynergyWorkorderDO);
		
		
		manageSynergyWorkorderServicerDO.setWorkorderCode(manageSynergyWorkorderDO.getCode());
		manageSynergyWorkorderServicerDO.setServicePatientCode(callService.getPatient());
		manageSynergyWorkorderServicerDO.setServicePatientName(callService.getPatientName());
		manageSynergyWorkorderServicerDO.setHospital(callService.getOrderHospital());
		manageSynergyWorkorderServicerDO.setHospitalName(callService.getOrderHospitalName());
		manageSynergyWorkorderServicerDO.setCreateTime(new Date());
		manageSynergyWorkorderServicerDO.setExecutorType(1);
		manageSynergyWorkorderServicerDao.save(manageSynergyWorkorderServicerDO);
		
		manageSynergyWorkorderExecutorDO.setWorkorderCode(manageSynergyWorkorderDO.getCode());
		manageSynergyWorkorderExecutorDO.setDel(1);
		manageSynergyWorkorderExecutorDO.setExecutorType(3);
		manageSynergyWorkorderExecutorDO.setExecutorCode(callService.getUser());
		manageSynergyWorkorderExecutorDO.setExecutorName(callService.getUserName());
		manageSynergyWorkorderExecutorDao.save(manageSynergyWorkorderExecutorDO);
		
		manageSynergyWorkorderReserveConsultDO.setWorkorderCode(manageSynergyWorkorderDO.getCode());
		manageSynergyWorkorderReserveConsultDO.setWorkorderServiceCode(manageSynergyWorkorderServicerDO.getCode());
		manageSynergyWorkorderReserveConsultDO.setDealType(callService.getDealType());
		manageSynergyWorkorderReserveConsultDO.setDealTime(new Date());
		manageSynergyWorkorderReserveConsultDO.setDealState(callService.getDealState());
		manageSynergyWorkorderReserveConsultDO.setDealContent(callService.getDealContent());
		manageSynergyWorkorderReserveConsultDO.setDealReason(callService.getDealReason());
		manageSynergyWorkorderReserveConsultDO.setOrderHospital(callService.getOrderHospital());
		manageSynergyWorkorderReserveConsultDO.setOrderHospitalName(callService.getOrderHospitalName());
		manageSynergyWorkorderReserveConsultDO.setOrderDept(callService.getOrderDept());
		manageSynergyWorkorderReserveConsultDO.setOrderDeptName(callService.getOrderDeptName());
		manageSynergyWorkorderReserveConsultDO.setOrderDoctor(callService.getOrderDoctor());
		manageSynergyWorkorderReserveConsultDO.setOrderDoctorName(callService.getOrderDoctorName());
		manageSynergyWorkorderReserveConsultDO.setOrderTime(callService.getOrderTime());
		manageSynergyWorkorderReserveConsultDO.setRegisterTime(callService.getRegisterTime());
		manageSynergyWorkorderReserveConsultDO.setUser(callService.getUser());
		manageSynergyWorkorderReserveConsultDO.setUserName(callService.getUserName());
		manageSynergyWorkorderReserveConsultDO.setCreateTime(callService.getCreateTime());
		manageSynergyWorkorderReserveConsultDO.setCallCode(callService.getCallCode());
		manageSynergyWorkorderReserveConsultDao.save(manageSynergyWorkorderReserveConsultDO);
		
		
		return "1";
	}
	
	
	public boolean checkCallServiceCount(CallService callService ){
		String sql = "SELECT count(1) AS total FROM manage_call_service s WHERE s.call_code ='"+callService.getCallCode() +"' AND s.type = "+callService.getType();
		List<Map<String,Object>> list = jdbcTemplate.queryForList(sql);
		if(list!=null&&list.size()>0){
			Map<String,Object> map = list.get(0);
			Long total = (Long)map.get("total");
			if(total>=5){
				return false;
			}
		}
		return true;
		
	}

	public void sendWxMes(CallService callService){
		Doctor d = doctorDao.findByCode(callService.getDoctor());
		CallRecord r = callRecordDao.findByCode(callService.getCallCode());
		if("0".equals(callService.getType())){
			sendCallServiceWXMes(d.getOpenid(),callService.getDoctorName(),callService.getPatientName(),"咨询",r.getCallerNumber(),callService.getServerContent());
		}else{
			sendCallServiceWXMes(d.getOpenid(),callService.getDoctorName(),callService.getPatientName(),"待预约",r.getCallerNumber(),callService.getServerContent());
		}
	}

	public void sendCallServiceMes(CallService callService){
		//待处理发送消息给医生
		if(callService.getState()==1){
			Patient p = patientDao.findByCode(callService.getPatient());
			// 添加签约消息
			Message message = new Message();
			message.setCzrq(new Date());
			message.setCreateTime(new Date());
			if(callService.getType()==1){
				message.setContent(callService.getPatientName()+"需要预约挂号");
			}else{
				message.setContent(callService.getPatientName()+"发起咨询");
			}

			message.setRead(1);//设置未读
			message.setReceiver(callService.getDoctor());//设置接受医生的code
			message.setSender(callService.getPatient());//设置发送的用户
			message.setSenderName(callService.getPatientName());
			message.setCode(getCode());
			message.setSenderPhoto(p.getPhoto());
			message.setTitle("协同服务消息");
			message.setType(12);//协同服务消息
			message.setReadonly(1);//是否只读消息
			message.setSex(p.getSex());
			message.setOver("1");//未处理
			message.setDel("1");
			message.setState(1);
			message.setRelationCode(callService.getCode());
			messageDao.save(message);
		}
	}

	public Map<String,Object> getCallServices(String keyword, Integer serverType,Integer state,String patientName,String ssc,String idCard,String doctorName,String code,Integer adminTeamCode ,String startDate,String endDate,Integer page,Integer size){

		Map<String,Object> map = new HashedMap();

		String sqltotal = "SELECT count(1) AS total" +
				" FROM " +
				" manage_call_service s " +
				" WHERE " +
				" 1 = 1";
		sqltotal = setCallServiceSql( sqltotal, keyword,  serverType, state, patientName, ssc, idCard, doctorName, code, adminTeamCode , startDate, endDate);
		List<Map<String,Object>> totallist = jdbcTemplate.queryForList(sqltotal);
		Long total = (Long)totallist.get(0).get("total");

		if(total==0){
			map.put("callServices",null);
			map.put("page",page);
			map.put("total",0);
			map.put("records",0);
			return map;
		}

		String sql = "SELECT " +
				" s.`code`, " +
				" s.patient, " +
				" s.patient_name AS patientName, " +
				" s.doctor, " +
				" s.doctor_name AS doctorName, " +
				" s.type As type, " +
				" s.state, " +
				" s.server_content AS serverContent, " +
				" s.create_time AS createTime, " +
				" s.user, " +
				" s.user_name AS userName " +
				" FROM " +
				" manage_call_service s " +
				" WHERE " +
				" 1 = 1";
		sql = setCallServiceSql( sql, keyword,  serverType, state, patientName, ssc, idCard, doctorName, code, adminTeamCode , startDate, endDate);
		sql += "  ORDER BY s.create_time DESC LIMIT "+(page-1)*size+","+size ;

		List<Map<String,Object>> list = jdbcTemplate.queryForList(sql);

		map.put("page",page);
		map.put("records",total);
		map.put("callRecords",list);
		double t = (double)total;
		map.put("total",Math.ceil(t/size));

		return map;
	}

	public String setCallServiceSql(String sql,String keyword, Integer serverType,Integer state,String patientName,String ssc,String idCard,String doctorName,String code,Integer adminTeamCode ,String startDate,String endDate){

		if(StringUtils.isNotBlank(keyword)){
			sql +=" AND (s.patient_name = '"+keyword+"' OR s.ssc ='"+keyword+"' OR s.Idcard ='"+keyword+"')";
		}
		if(serverType!=null){
			sql += " AND s.type ='"+serverType+"' " ;
		}
		if(state != null){
			sql +=" AND s.state ='"+state+"'";
		}
		if(StringUtils.isNotBlank(patientName)){
			sql +=" AND s.patient_name ='"+patientName+"'" ;
		}
		if(StringUtils.isNotBlank(ssc)){
			sql +=" AND s.ssc ='"+ssc+"'" ;
		}
		if(StringUtils.isNotBlank(idCard)){
			sql +=" AND s.IdCard ='"+idCard+"'" ;
		}
		if(StringUtils.isNotBlank(doctorName)){
			sql +=" AND s.doctor_name ='"+doctorName+"'" ;
		}
		if(StringUtils.isNotBlank(code)){
			sql +=" AND s.code ='"+code+"'" ;
		}
		if(StringUtils.isNotBlank(startDate)){
			sql +=" AND s.create_time >='"+startDate+" 00:00:00'" ;
		}
		if(StringUtils.isNotBlank(endDate)){
			sql +=" AND s.create_time <='"+endDate+" 23:59:59'" ;
		}
		if(adminTeamCode!=null) {
			sql += " AND s.admin_team_code =" + adminTeamCode;
		}
		return sql;
	}

	public Map<String,Object> getCallServiceInfo(String code){
		CallService callService = callServiceDao.findByCode(code);
		CallRecord callRecord = callRecordDao.findByCode(callService.getCallCode());
		ManageSynergyWorkorderDO manageSynergyWorkorderDO = manageSynergyWorkOrderDao.findByRelationCode(callService.getCode());
		Map<String,Object> rs = new HashedMap();
		rs.put("callService",callService);
		rs.put("callRecord",callRecord);
		if(manageSynergyWorkorderDO != null){
			rs.put("priority",manageSynergyWorkorderDO.getPriority());
		}else{
			rs.put("priority",0);
		}
		
		return rs;
	}

	public String delCallService(String code){
		//旧代码
//		CallService c = callServiceDao.findByCode(code);
//		callServiceDao.delete(c);
		//新代码--根据CODE逻辑删除工单表
		ManageSynergyWorkorderDO manageSynergyWorkorderDO = manageSynergyWorkOrderDao.findByCode(code);
		manageSynergyWorkorderDO.setDel(0);
		manageSynergyWorkOrderDao.save(manageSynergyWorkorderDO);
		return "1";
	}


	public Integer updateFollowUpById(String code,Integer followup){
		CallRecord callRecord = callRecordDao.findByCode(code);
		long nd = 1000 * 24 * 60 * 60;
		long nh = 1000 * 60 * 60;
		Date d2=DateUtil.getNowDate();
		Date d1 = callRecord.getCreateTime();
		System.out.println("time"+d2.getTime()+"   time2"+d1.getTime());
		long diff = d2.getTime() - d1.getTime();
		long hours =  diff/1000/3600%3600;
		if (hours>24){
			if (callRecord.getFollowUp()!=null&&callRecord.getFollowUp()==0){
				return -1;
			}
		}
		callRecord.setFollowUp(followup);
		CallRecord callRecord1 = callRecordDao.save(callRecord);
		if (callRecord1!=null){
			return 1;
		}else {
			return 0;
		}

	}
	
	/**
	 * 根据身份证号换取居民请求秘钥
	 * @param  idcard
	 * @return
	 */
	public com.alibaba.fastjson.JSONObject  getPatientAccetokenByIdcard(String idcard) throws Exception {
		Patient patient = patientService.findByIdcard(idcard);
		if(patient == null){
			throw  new Exception( "该身份证查询不到居民");
		}else{
			String uuid = UUID.randomUUID().toString();
			redisTemplate.opsForValue().set("patient_"+uuid,idcard, 3600, TimeUnit.SECONDS);
			com.alibaba.fastjson.JSONObject result = new com.alibaba.fastjson.JSONObject();
			result.put("patientCode",uuid);
			result.put("create_time", DateUtil.dateToStrLong(new Date()));
			result.put("expires_in", 3600);
			return result;
		}
	}


	/**
	 * 查询通话跟进记录
	 * @param callCode 通话code
	 * @return
	 */
	public List<ManageFollowupRecord> selectByCode(String callCode){
		return manageFollowupRecordDao.selectByCode(callCode);
	}

	/**
	 * 保存跟进记录
	 *
	 * @param followupRecord
	 * @return
	 */
	public ManageFollowupRecord saveFollowupRecord(ManageFollowupRecord followupRecord){
		CallRecord callRecord = callRecordDao.findByCode(followupRecord.getCallCode());
		followupRecord.setCode(getCode());
		followupRecord.setCzrq(new Date());
		followupRecord = manageFollowupRecordDao.save(followupRecord);
		callRecord.setFollowUp(followupRecord.getFollowUp());
		callRecordDao.save(callRecord);
		return followupRecord;
	}

	/**
	 * 查询所有客服
	 * @param callCode
	 * @return
	 */
	public JSONArray selectUser(String callCode,Integer flag){
		List<User> users = userDao.findAllCustomer();
		com.alibaba.fastjson.JSONArray array= new com.alibaba.fastjson.JSONArray();
		CallRecord callRecord = callRecordDao.findByCode(callCode);
		List<ManageFollowupRecord> followupRecords = manageFollowupRecordDao.selectByCode(callCode);
		if (followupRecords!=null&&followupRecords.size()!=0){
			ManageFollowupRecord manageFollowupRecord = followupRecords.get(0);
			for (User user:users){
				com.alibaba.fastjson.JSONObject object = new com.alibaba.fastjson.JSONObject();
				object.put("code",user.getCode());
				object.put("name",user.getName());
				object.put("type",user.getType());
				object.put("typeName",user.getTypeName());
				if (user.getCode().equalsIgnoreCase(manageFollowupRecord.getUser())){
					object.put("isFlag","1");
				}else {
					object.put("isFlag","0");
				}
				array.add(object);
			}
		}else {
			if (flag==1){
				for (User user:users){
					com.alibaba.fastjson.JSONObject object = new com.alibaba.fastjson.JSONObject();
					if (user.getCode().equalsIgnoreCase(callRecord.getUserCode())){
						object.put("code",user.getCode());
						object.put("name",user.getName());
						object.put("type",user.getType());
						object.put("typeName",user.getTypeName());
						object.put("isFlag","1");
					}else {
						object.put("code",user.getCode());
						object.put("name",user.getName());
						object.put("type",user.getType());
						object.put("typeName",user.getTypeName());
						object.put("isFlag","0");
					}
					array.add(object);
				}
			}else if (flag==0){
				com.alibaba.fastjson.JSONObject object = new com.alibaba.fastjson.JSONObject();
				object.put("code",callRecord.getUserCode());
				object.put("name",callRecord.getUserName());
				object.put("isFlag","1");
				array.add(object);
			}

		}
		return array;
	}


		public Integer updateCallRecordAndFollowupRecord(String callCode,Integer followUp,String serviceType,String serviceContent,ManageFollowupRecord followupRecord){
			CallRecord callRecord = callRecordDao.findByCode(callCode);
			if (callRecord!=null){
				callRecord.setServiceType(serviceType);
				callRecord.setServiceContent(serviceContent);
				callRecordDao.save(callRecord);
				long nd = 1000 * 24 * 60 * 60;
				long nh = 1000 * 60 * 60;
				Date d2=DateUtil.getNowDate();
				Date d1 = callRecord.getCreateTime();
				System.out.println("time"+d2.getTime()+"   time2"+d1.getTime());
				long diff = d2.getTime() - d1.getTime();
				long hours =  diff/1000/3600%3600;
				if (hours>24){
					if (callRecord.getFollowUp()!=null&&callRecord.getFollowUp()==0){
						return -1;
					}
				}
				followupRecord.setCode(getCode());
				followupRecord.setCzrq(new Date());
				followupRecord.setFollowUp(followUp);
				followupRecord.setCallCode(callCode);
				followupRecord = manageFollowupRecordDao.save(followupRecord);
				callRecord.setFollowUp(followupRecord.getFollowUp());
				CallRecord callRecord1 = callRecordDao.save(callRecord);
				if (callRecord1!=null){
					return 1;
				}else {
					return 0;
				}
			}else {
				return -2;
			}

		}

	public Map<String,Object> getVoiceRecord(String callerNumber,String recipientNumber,String startDate,String endDate,Integer page,Integer size){

		Map<String,Object> map = new HashedMap();

		String sqltotal = "SELECT count(distinct s.id) AS total" +
				" FROM " +
				" manage_call_record s inner join manage_call_record_video vi on s.call_id = vi.serial_number " +
				" WHERE " +
				" 1 = 1";
		String sqlWhere = " " ;
		if(StringUtils.isNotBlank(callerNumber)){
			sqlWhere +=" AND s.caller_number = '"+callerNumber+"'";
		}
		if(StringUtils.isNotBlank(recipientNumber)){
			sqlWhere +=" AND s.recipient_number = '"+recipientNumber+" '";
		}
		if(StringUtils.isNotBlank(startDate)){
			sqlWhere +=" AND s.create_time >='"+startDate+" 00:00:00'" ;
		}
		if(StringUtils.isNotBlank(endDate)){
			sqlWhere +=" AND s.create_time <='"+endDate+" 23:59:59'" ;
		}

		List<Map<String,Object>> totallist = jdbcTemplate.queryForList(sqltotal+sqlWhere);
		Long total = (Long)totallist.get(0).get("total");

		if(total==0){
			map.put("callServices",null);
			map.put("page",page);
			map.put("total",0);
			map.put("records",0);
			return map;
		}

		String sqlList = " select vi.id,vi.serial_number,vi.job_number,vi.caller,vi.called,date_format(s.call_time, '%Y-%m-%d %H:%i:%s') call_time,s.talk_time,s.type,s.patient_name patientName,vi.video_path videoPath " +
				" FROM " +
				" manage_call_record s inner join manage_call_record_video vi on s.call_id = vi.serial_number  " +
				" WHERE " +
				" 1 = 1" +sqlWhere;

		sqlList += " GROUP BY s.id  ORDER BY s.id DESC LIMIT "+(page-1)*size+","+size ;

		List<Map<String,Object>> list = jdbcTemplate.queryForList(sqlList);

		map.put("page",page);
		map.put("records",total);
		map.put("callRecords",list);
		double t = (double)total;
		map.put("total",Math.ceil(t/size));
		return map;
	}

	public void exportVoiceRecord(String serialNumber,String callerNumber, String recipientNumber, String startDate, String endDate, HttpServletResponse response) throws Exception {
		String sqlList = " select vi.video_path,vi.caller,vi.called,serial_number " +
				" FROM " +
				" manage_call_record s inner join manage_call_record_video vi on s.call_id = vi.serial_number   " +
				" WHERE " +
				" 1 = 1 " ;
		if (StringUtils.isNotBlank(serialNumber)){
			sqlList +=" AND vi.serial_number in ('"+serialNumber.replace(",","','")+"') ";
		}
		if(StringUtils.isNotBlank(callerNumber)){
			sqlList +=" AND s.caller_number = '"+callerNumber+"'";
		}
		if(StringUtils.isNotBlank(recipientNumber)){
			sqlList +=" AND s.recipient_number = '"+recipientNumber+" '";
		}
		if(StringUtils.isNotBlank(startDate)){
			sqlList +=" AND s.create_time >='"+startDate+" 00:00:00'" ;
		}
		if(StringUtils.isNotBlank(endDate)){
			sqlList +=" AND s.create_time <='"+endDate+" 23:59:59'" ;
		}

		sqlList += " group by s.id ORDER BY s.id DESC " ;
		List<Map<String,Object>> list = jdbcTemplate.queryForList(sqlList);

		String zipFileName = "语音文件";
		long time = System.currentTimeMillis();
		String exportConclusionList = time+"voiceExport";
		String path = this.getClass().getResource("/").getPath()+File.separator+exportConclusionList;
		File fileFolder = new File(path);
		if (fileFolder.exists()) {
			if (fileFolder != null){
				FileUtil.deleteFolder(fileFolder);
				fileFolder.mkdir();
			}else {
				fileFolder.delete();
				fileFolder.mkdir();
			}
		}else {
			fileFolder.mkdir();
		}
		for (Map<String,Object>tmp:list){
			try {
				String fileName = tmp.get("caller").toString()+"_"+tmp.get("called").toString()+"_"+tmp.get("serial_number").toString();
				FileUtil.download(fastdfs_file_url+tmp.get("video_path").toString(),path, fileName+".mp3");
				File file = new File( path+ File.separator+fileName+".mp3");
			}catch (Exception e){
				e.printStackTrace();
			}
		}
		// 打包文件夹
		File zipFile = null;
		if (FileUtil.fileToZip(path, path.replace(exportConclusionList, ""), zipFileName)) {
			zipFile =  new File(path.replace(exportConclusionList, "") + zipFileName + ".zip");
		} else {
			zipFile = null;
		}
		if (zipFile != null) {
			response.setCharacterEncoding("utf-8");
			response.setContentType("multipart/form-data");
			response.setHeader("Content-Disposition", "attachment; filename=" + new String(URLEncoder.encode("语音文件")+".zip"));
			InputStream inputStream = new FileInputStream(zipFile);
			OutputStream outputStream = response.getOutputStream();
			byte[] b = new byte[2048];
			int length = 0;
			while ((length = inputStream.read(b)) > 0) {
				outputStream.write(b, 0, length);
			}
			outputStream.flush();
			outputStream.close();
			inputStream.close();
		} else {
			response.setStatus(500);
		}
		zipFile.delete();
	}

	public Map<String,Object> getCallSatisfaction(String callerNumber,String recipientNumber,String startDate,String endDate,String satisfaction,Integer page,Integer size){

		Map<String,Object> map = new HashedMap();

		String sqltotal = "SELECT count(distinct s.id) AS total" +
				" FROM " +
				" manage_call_record s inner join manage_call_record_video vi on s.call_id = vi.serial_number  " +
				" WHERE " +
				" s.satisfaction is not null and s.satisfaction<>'' ";
		String sqlWhere = " " ;
		if(StringUtils.isNotBlank(callerNumber)){
			sqlWhere +=" AND s.caller_number = '"+callerNumber+"'";
		}
		if(StringUtils.isNotBlank(recipientNumber)){
			sqlWhere +=" AND s.recipient_number = '"+recipientNumber+" '";
		}
		if(StringUtils.isNotBlank(startDate)){
			sqlWhere +=" AND s.create_time >='"+startDate+" 00:00:00'" ;
		}
		if(StringUtils.isNotBlank(endDate)){
			sqlWhere +=" AND s.create_time <='"+endDate+" 23:59:59'" ;
		}
		if(StringUtils.isNotBlank(satisfaction)){
			sqlWhere +=" AND s.satisfaction ='"+satisfaction+"' " ;
		}

		List<Map<String,Object>> totallist = jdbcTemplate.queryForList(sqltotal+sqlWhere);
		Long total = (Long)totallist.get(0).get("total");

		if(total==0){
			map.put("callServices",null);
			map.put("page",page);
			map.put("total",0);
			map.put("records",0);
			return map;
		}

		String sqlList = " select vi.id,vi.serial_number,vi.job_number,vi.caller,vi.called,date_format(s.call_time, '%Y-%m-%d %H:%i:%s') call_time,s.talk_time,s.type,s.satisfaction,s.patient_name patientName " +
				" FROM " +
				" manage_call_record s inner join manage_call_record_video vi on s.call_id = vi.serial_number " +
				" WHERE " +
				" s.satisfaction is not null and s.satisfaction<>'' " +sqlWhere;

		sqlList += " group by s.id ORDER BY s.id DESC LIMIT "+(page-1)*size+","+size ;

		List<Map<String,Object>> list = jdbcTemplate.queryForList(sqlList);

		map.put("page",page);
		map.put("records",total);
		map.put("callRecords",list);
		double t = (double)total;
		map.put("total",Math.ceil(t/size));
		return map;
	}

	public void exportCallSatisfaction(String serialNumber,String callerNumber,String recipientNumber,String startDate,String endDate,String satisfaction,HttpServletResponse response) throws Exception {


		String sqlList = " select vi.id,vi.serial_number,vi.job_number,vi.caller,vi.called,date_format(s.call_time, '%Y-%m-%d %H:%i:%s') call_time,s.talk_time," +
				" CASE s.type WHEN 1 THEN '呼入' WHEN 2 THEN '呼出' else '' END as type ,s.satisfaction,s.patient_name patientName " +
				" FROM " +
				" manage_call_record s inner join manage_call_record_video vi on s.call_id = vi.serial_number  " +
				" WHERE " +
				" s.satisfaction is not null and s.satisfaction<>'' ";
		if (StringUtils.isNotBlank(serialNumber)){
			sqlList +=" AND vi.serial_number in ('"+serialNumber.replace(",","','")+"') ";
		}
		if(StringUtils.isNotBlank(callerNumber)){
			sqlList +=" AND s.caller_number = '"+callerNumber+"'";
		}
		if(StringUtils.isNotBlank(recipientNumber)){
			sqlList +=" AND s.recipient_number = '"+recipientNumber+" '";
		}
		if(StringUtils.isNotBlank(startDate)){
			sqlList +=" AND s.create_time >='"+startDate+" 00:00:00'" ;
		}
		if(StringUtils.isNotBlank(endDate)){
			sqlList +=" AND s.create_time <='"+endDate+" 23:59:59'" ;
		}
		if(StringUtils.isNotBlank(satisfaction)){
			sqlList +=" AND s.satisfaction ='"+satisfaction+"' " ;
		}
		sqlList += " group by s.id  ORDER BY s.id DESC " ;
		List<Map<String,Object>> list = jdbcTemplate.queryForList(sqlList);
		String fileName = "满意度评价导出";
		response.setContentType("octets/stream");
		response.setCharacterEncoding("utf-8");
		fileName = URLEncoder.encode(fileName, "utf-8");
		response.setHeader("Content-Disposition", "attachment; filename="+ fileName + new String(".xls"));
		OutputStream os = response.getOutputStream();
		WorkbookUtil workbookUtil = new WorkbookUtil();
		Map<Integer, String> columnMap = new HashMap<>();
		columnMap.put(0, "job_number");
		columnMap.put(1, "patientName");
		columnMap.put(2, "called");
		columnMap.put(3, "call_time");
		columnMap.put(4, "talk_time");
		columnMap.put(5, "type");
		columnMap.put(6, "satisfaction");
		String[] header = {"工号", "姓名", "被叫号码","通话时间","通话时长","通话类型","评价结果"};
		workbookUtil.write(Workbook.createWorkbook(os), list, columnMap, header);

	}
}
