package com.yihu.customer.service.manager.basedata;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.yihu.customer.service.BaseService;
import  com.yihu.customer.entity.Patient;
import  com.yihu.customer.entity.SignDict;
import  com.yihu.customer.entity.SignPatientLabel;
import  com.yihu.customer.repository.PatientDao;
import  com.yihu.customer.repository.SignPatientLabelDao;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.BeanPropertyRowMapper;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Map;

/**
 * Created by wangpeiqiang on 2018/11/21.
 */
@Service
public class BaseDataImportService extends BaseService {

    @Autowired
    private JdbcTemplate jdbcTemplate;
    @Autowired
    private SignPatientLabelDao labelDao;
    @Autowired
    private PatientDao patientDao;

    public JSONObject selectLabel(){
        JSONObject object = new JSONObject();
        //服务类型

        //家医服务类型
        String sql = "select * from wlyy_sign_dict where year = 2018";
        List<SignDict> signDicts = jdbcTemplate.query(sql,new BeanPropertyRowMapper<>(SignDict.class));
//        //专科服务类型
//        String specialSql = "select * from wlyy_special_disease where del=1";
//        List<SpecialDisease> specialDiseases = jdbcTemplate.query(specialSql,new BeanPropertyRowMapper<>(SpecialDisease.class));
        JSONArray array = new JSONArray();
        List<String> list = new ArrayList<>();
        for (SignDict signDict:signDicts){
            JSONObject jsonObject = new JSONObject();
            jsonObject.put("label",signDict.getCode());
            jsonObject.put("labelName",signDict.getName());
            list.add(signDict.getName());
            array.add(jsonObject);
        }
//        for (SpecialDisease disease:specialDiseases){
//            JSONObject object1 = new JSONObject();
//            object1.put("label",disease.getCode());
//            object1.put("labelName",disease.getName());
//            if (!list.contains(disease.getName())){
//                array.add(object1);
//            }
//        }
        object.put("serverType",array);
        //健康情况
        List<SignPatientLabel> labels = labelDao.findByLabelTypeAndStatus("2",1);
        object.put("healthType",labels);
        //疾病类型
        String diseaseSql = "SELECT DISTINCT label_name AS labelName, label_code AS labelCode,label_type AS labelType FROM wlyy_sign_patient_label where label_type IN(3,7) and `status`=1";
        List<Map<String,Object>> maps = jdbcTemplate.queryForList(diseaseSql);
        object.put("diseaseType",maps);
        return object;
    }


    public void syncLabelByWx(JSONObject object){
        //服务类型
        JSONArray array = object.getJSONArray("serverTypes");
        StringBuffer buffer = new StringBuffer();
        buffer.append("(");
        for (int i=0;i<array.size();i++){
            buffer.append(array.getString(i)+",");
        }
        buffer.deleteCharAt(buffer.length()-1);
        buffer.append(")");
        String sql = "SELECT sf.patient AS patient," +
                " sfs1.server_type AS serverType, " +
                " sfs1.server_type_name AS serverTypeName " +
                "FROM " +
                " ( " +
                " SELECT " +
                " sfs.sign_code, " +
                " server_type_name, " +
                " server_type " +
                " FROM " +
                " wlyy_sign_family_server sfs " +
                " WHERE " +
                " sfs.server_type_name IN " +buffer +
                " ) sfs1 " +
                "LEFT JOIN wlyy_sign_family sf ON " +
                "sfs1.sign_code = sf.`code` " +
                "WHERE sf.`status`>0";
        List<Map<String,Object>> maps = jdbcTemplate.queryForList(sql);
        for (Map<String,Object> map:maps){
            Patient patient = patientDao.findByCode(map.get("patient").toString());
        }

    }

    /**
     * 1 服务类型
     * 2 健康疾病类型
     * 3地区
     * @param type
     * @param tag
     */
    public List<String> getLabelWeixinOpenId(int type,String tag,List<String> openIdList,String townCode){
        List<String> openIds = new ArrayList<>();
        String lableSql = "";
        if(type == 1){
            StringBuilder sql = new StringBuilder("SELECT DISTINCT(openid) openId from wlyy_sign_family sf LEFT JOIN(");
            sql.append(" select DISTINCT(sign_code) signCode from wlyy_sign_family_server where create_time >='2018-01-01' and create_time <'2019-01-01'");
            sql.append(" and server_type_name='").append(tag).append("'");
            sql.append(" )t on sf.`code` =  t.signCode ");
            sql.append( " where sf.hospital like '").append(townCode).append("%'");
            lableSql = sql.toString();
        }else if(type == 2){
            StringBuilder diseasesql = new StringBuilder("SELECT DISTINCT(openid) openId from wlyy_sign_family where admin_team_code in ");
            diseasesql.append("(SELECT DISTINCT(team_code) FROM  wlyy_sign_patient_label where label_type IN(2,3,7) and `status`=1 ");
            diseasesql.append(" and label_name = '").append(tag).append("'");
            diseasesql.append(")");
            diseasesql.append(" and hospital like '").append(townCode).append("%'");
            lableSql = diseasesql.toString();
        }else if (type == 3){
            StringBuffer buffer = new StringBuffer();
            List idList = Arrays.asList(tag.split(","));
            for (int i=0;i<idList.size();i++){
                buffer.append("'"+idList.get(i)+"',");
            }
            buffer.deleteCharAt(buffer.length()-1);
            StringBuilder townSql = new StringBuilder("SELECT DISTINCT p.openid FROM wlyy_patient p ");
            townSql.append("RIGHT JOIN wlyy_sign_family sf ON sf.patient = p.`code` AND sf.`status` = 1 ");
            townSql.append("AND sf.hospital IN (SELECT h.code FROM dm_hospital h WHERE h.town IN ("+buffer+"))");
            lableSql = townSql.toString();
        }
        List<Map<String,Object>> maps = jdbcTemplate.queryForList(lableSql);
        for (Map<String,Object> map:maps){
            if(map.get("openId") != null ){
                String openId = map.get("openId").toString();
                if(openIdList.contains(openId.trim())){
                    openIds.add(openId);
                }
            }
        }
        return openIds;
    }

    public List<String> getLabelWeixinOpenId1(String tag,List<String> openIdList){
        List<String> openIds = new ArrayList<>();
        String lableSql = "";
        StringBuffer buffer = new StringBuffer();
        List idList = Arrays.asList(tag.split(","));
        for (int i=0;i<idList.size();i++){
            buffer.append("'"+idList.get(i)+"',");
        }
        buffer.deleteCharAt(buffer.length()-1);
        StringBuilder townSql = new StringBuilder("SELECT DISTINCT d.openid FROM wlyy_doctor d ");
        townSql.append(" WHERE d.town IN ("+buffer+") and d.status=1 and d.del=1");
        lableSql = townSql.toString();
        List<Map<String,Object>> maps = jdbcTemplate.queryForList(lableSql);
        for (Map<String,Object> map:maps){
            if(map.get("openId") != null ){
                String openId = map.get("openId").toString();
                if(openIdList.contains(openId.trim())){
                    openIds.add(openId);
                }
            }
        }
        return openIds;
    }





}
