package com.yihu.customer.service.manager.consult;

import  com.yihu.customer.entity.WlyyConsultTeam;
import  com.yihu.customer.entity.consult.WlyyConsultTeamExportVO;
import  com.yihu.customer.repository.WlyyConsultTeamDao;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.BeanPropertyRowMapper;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by Administrator on 2016/12/19.
 */
@Service
public class WlyyConsultTeamService {
    @Autowired
    private WlyyConsultTeamDao consultTeamDao;
    @Autowired
    JdbcTemplate jdbcTemplate;

    public int isExistUnfinished(String patient){
        return consultTeamDao.searchUnfinished(patient);
    }
    public WlyyConsultTeam getConsultContent(String consult){
       WlyyConsultTeam wlyyConsultTeam =  consultTeamDao.findByCode(consult);
        return wlyyConsultTeam;
    }

    /**
     * 导出咨询未及时回复数据
     * @param town
     * @param hospital
     * @return
     */
    public List<WlyyConsultTeamExportVO> exportReplyDelayList(String town, String hospital, String createTime) {
        List<WlyyConsultTeamExportVO> list = new ArrayList<>();
        String sql  = "SELECT " +
                "c.symptoms," +
                "c.name," +
                "t.create_time," +
                "t.reply_time," +
                "m.content," +
                "a.`name` as team_name," +
                "f.doctor_name," +
                "f.doctor_health_name "+
                " FROM wlyy_consult_team c, im.topics t, wlyy_admin_team a, wlyy_sign_family f, im.muc_messages m " +
                "WHERE c.admin_team_code = a.id AND c.type=2 "+
                "and c.consult = t.id and (TIMESTAMPDIFF(HOUR,t.create_time,t.reply_time)>=24 )  and f.patient = c.patient and f.`status`>0 " +
                "and t.reply_message_id=m.id ORDER BY t.create_time";

        if(StringUtils.isNotBlank(hospital)){
            sql = sql.replace("c.admin_team_code = a.id", "c.admin_team_code = a.id and a.org_code = '"+hospital+"' ");
        }
        if(StringUtils.isNotBlank(createTime)) {
            sql = sql.replace("c.admin_team_code = a.id", "c.admin_team_code = a.id and t.create_time >= '"+createTime +"'");
        }
        list =  jdbcTemplate.query(sql,new BeanPropertyRowMapper(WlyyConsultTeamExportVO.class));
        return list ;
    }
}
