package com.yihu.customer.service.manager.consult;

import com.yihu.customer.util.DateUtil;
import com.yihu.customer.util.query.BaseJpaService;
import  com.yihu.customer.entity.WlyyConsultTeam;
import  com.yihu.customer.entity.consult.WlyyReplyConsult;
import org.apache.commons.lang3.StringUtils;
import org.hibernate.Query;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.PageRequest;
import org.springframework.stereotype.Service;

import java.util.*;

/**
 * Created by 卓 on 2017/5/15.
 */
@Service
public class WlyyReplyConsultService  extends BaseJpaService<WlyyReplyConsult,Long> {
    @Autowired
    private WlyyConsultRemindLogService wlyyConsultRemindLogService;
    @Autowired
    private WlyyConsultTeamService wlyyConsultTeamService;

    public PageImpl<WlyyReplyConsult> list(String city, String town, String hospital, String teamCode, String doctorName, String doctor, Integer reply, Integer status, Date beginDate, Date endDate, int page, int pageSize){
        if (page <= 0) {
            page = 1;
        }
        if (pageSize <= 0) {
            pageSize = 15;
        }
        // 分页信息
        PageRequest pageRequest = PageRequest.of(page - 1, pageSize);
        //过滤条件
        StringBuffer filters = new StringBuffer();
        if(StringUtils.isNotBlank(city)){
            filters.append("and city =:city ");
        }
        if(StringUtils.isNotBlank(town)){
            filters.append("and town =:town ");
        }
        if(StringUtils.isNotBlank(hospital)){
            filters.append("and hospital =:hospital ");
        }
        if(StringUtils.isNotBlank(teamCode)){
            filters.append("and teamCode like :teamCode ");
        }
        if(StringUtils.isNotBlank(doctorName)){
            filters.append("and (doctorName  like :doctorName or healthDoctorName like :healthDoctorName) ");
        }
         if(StringUtils.isNotBlank(doctor)){
             filters.append("and (doctorCode  = :doctorCode or healthDoctorCode = :healthDoctorCode) ");
         }
        if(beginDate!=null){
            filters.append("and createTime>=:beginDate ");
        }
        if(endDate!=null){
            filters.append("and createTime<=:endDate ");
        }
        if(reply!=null){
            filters.append("and reply=:reply ");
        }
         if(status!=null){
             filters.append("and status=:status ");
         }
        filters.append(" order by p.status asc,p.reply asc ,p.id desc ");
        Query queryCount = currentSession().createQuery("select count(1) from WlyyReplyConsult p where 1=1 " +filters.toString());
        Query queryList = currentSession().createQuery("select p from WlyyReplyConsult p where 1=1  " +filters.toString());
        if (!org.springframework.util.StringUtils.isEmpty(city)) {
            queryCount.setString("city",city);
            queryList.setString("city",city);
        }
        if (!org.springframework.util.StringUtils.isEmpty(town)) {
            queryCount.setString("town",town);
            queryList.setString("town", town);        }
        if (!org.springframework.util.StringUtils.isEmpty(hospital)) {
            queryCount.setString("hospital",hospital);
            queryList.setString("hospital", hospital);
        }
        if (!org.springframework.util.StringUtils.isEmpty(teamCode)) {
            queryCount.setString("teamCode",teamCode);
            queryList.setString("teamCode", teamCode);
        }
        if (!org.springframework.util.StringUtils.isEmpty(doctorName)) {
            queryCount.setString("doctorName","%"+doctorName+"%");
            queryList.setString("doctorName","%"+doctorName+"%");
            queryCount.setString("healthDoctorName","%"+doctorName+"%");
            queryList.setString("healthDoctorName","%"+doctorName+"%");
        }
         if (!org.springframework.util.StringUtils.isEmpty(doctor)) {
             queryCount.setString("doctorCode",doctor);
             queryList.setString("doctorCode",doctor);
             queryCount.setString("healthDoctorCode",doctor);
             queryList.setString("healthDoctorCode",doctor);
         }
        if (!org.springframework.util.StringUtils.isEmpty(beginDate)) {
            queryCount.setString("beginDate", DateUtil.dateToStr(beginDate,DateUtil.YYYY_MM_DD_HH_MM_SS));
            queryList.setString("beginDate", DateUtil.dateToStr(beginDate,DateUtil.YYYY_MM_DD_HH_MM_SS));
        }
        if (!org.springframework.util.StringUtils.isEmpty(endDate)) {
            queryCount.setString("endDate",DateUtil.dateToStr(endDate,DateUtil.YYYY_MM_DD_HH_MM_SS));
            queryList.setString("endDate", DateUtil.dateToStr(endDate,DateUtil.YYYY_MM_DD_HH_MM_SS));
        }
        if (!org.springframework.util.StringUtils.isEmpty(reply)) {
            queryCount.setInteger("reply",reply);
            queryList.setInteger("reply", reply);
        }
         if (!org.springframework.util.StringUtils.isEmpty(status)) {
             queryCount.setInteger("status",status);
             queryList.setInteger("status", status);
         }
        //获取总条数
        int count = ((Number) queryCount.iterate().next()).intValue();
        queryList.setFirstResult(pageSize * (page - 1));
        queryList.setMaxResults(pageSize);
        List<WlyyReplyConsult> list = queryList.list();
         Map<String,Integer> remindStatusMap = new HashMap<>();
         Calendar c1 = new GregorianCalendar();
         c1.set(Calendar.HOUR_OF_DAY, 0);
         c1.set(Calendar.MINUTE, 0);
         c1.set(Calendar.SECOND, 0);
         Calendar c2 = new GregorianCalendar();
         c2.set(Calendar.HOUR_OF_DAY, 23);
         c2.set(Calendar.MINUTE, 59);
         c2.set(Calendar.SECOND, 59);
        for(WlyyReplyConsult wlyyReplyConsult:list){
             WlyyConsultTeam wlyyConsultTeam  =  wlyyConsultTeamService.getConsultContent(wlyyReplyConsult.getCode());
            if(wlyyConsultTeam!=null){
                 wlyyReplyConsult.setConsultContent(wlyyConsultTeam.getSymptoms());
            }
            if(wlyyReplyConsult.getStatus()==null||wlyyReplyConsult.getStatus()==10)continue;
            if(remindStatusMap.get(wlyyReplyConsult.getDoctorCode())!=null){
                wlyyReplyConsult.setIsRemindDoctor(remindStatusMap.get(wlyyReplyConsult.getDoctorCode()));
            }else{
                Calendar calendar = Calendar.getInstance();
                Date begin = new Date();
                calendar.setTime(begin);
                int remindCount  = wlyyConsultRemindLogService.countByFilter(null,null,null,null,null,wlyyReplyConsult.getDoctorCode(),c1.getTime(),c2.getTime());
                if(remindCount>0){
                    remindStatusMap.put(wlyyReplyConsult.getDoctorCode(),1);
                    wlyyReplyConsult.setIsRemindDoctor(1);
                }else{
                    remindStatusMap.put(wlyyReplyConsult.getDoctorCode(),0);
                    wlyyReplyConsult.setIsRemindDoctor(0);
                }
            }
            if(remindStatusMap.get(wlyyReplyConsult.getHealthDoctorCode())!=null){
                 wlyyReplyConsult.setIsRemindHealthDoctor(remindStatusMap.get(wlyyReplyConsult.getHealthDoctorCode()));
            }else{
                int remindCount  = wlyyConsultRemindLogService.countByFilter(null,null,null,null,null,wlyyReplyConsult.getHealthDoctorCode(),c1.getTime(),c2.getTime());
                if(remindCount>0){
                    remindStatusMap.put(wlyyReplyConsult.getHealthDoctorCode(),1);
                    wlyyReplyConsult.setIsRemindHealthDoctor(1);
                }else{
                    remindStatusMap.put(wlyyReplyConsult.getHealthDoctorCode(),0);
                    wlyyReplyConsult.setIsRemindHealthDoctor(0);
                }
            }
        }
        return new PageImpl<WlyyReplyConsult>(list,pageRequest,count);
    }


    public int getCountByFilter(String city, String town, String hospital, String teamCode, String doctorName,String doctor, Integer reply,Integer status, Date beginDate, Date endDate){
        //过滤条件
        StringBuffer filters = new StringBuffer();
        if(StringUtils.isNotBlank(city)){
            filters.append("and city =:city ");
        }
        if(StringUtils.isNotBlank(town)){
            filters.append("and town =:town ");
        }
        if(StringUtils.isNotBlank(hospital)){
            filters.append("and hospital =:hospital ");
        }
        if(StringUtils.isNotBlank(teamCode)){
            filters.append("and teamCode like :teamCode ");
        }
        if(StringUtils.isNotBlank(doctorName)){
            filters.append("and (doctorName  like :doctorName or healthDoctorName like :healthDoctorName) ");
        }
        if(StringUtils.isNotBlank(doctor)){
            filters.append("and (doctorCode  = :doctorCode or healthDoctorCode = :healthDoctorCode) ");
        }

        if(beginDate!=null){
            filters.append("and createTime>=:beginDate ");
        }
        if(endDate!=null){
            filters.append("and createTime<=:endDate ");
        }
        if(reply!=null){
            filters.append("and reply=:reply ");
        }
        if(status!=null){
            filters.append("and status=:status ");
        }
        if(filters.length()==0){
            Query queryCount = currentSession().createQuery("select count(1) from WlyyConsultTeam p where p.type =2 and p.adminTeamCode is not null ");
            return ((Number) queryCount.iterate().next()).intValue();
        }else{
            Query queryCount = currentSession().createQuery("select count(1) from WlyyReplyConsult p where 1=1 " +filters.toString());
            if (!org.springframework.util.StringUtils.isEmpty(city)) {
                queryCount.setString("city",city);
            }
            if (!org.springframework.util.StringUtils.isEmpty(town)) {
                queryCount.setString("town", town);
            }
            if (!org.springframework.util.StringUtils.isEmpty(hospital)) {
                queryCount.setString("hospital",hospital);
            }
            if (!org.springframework.util.StringUtils.isEmpty(teamCode)) {
                queryCount.setString("teamCode",teamCode);
            }
            if (!org.springframework.util.StringUtils.isEmpty(doctorName)) {
                queryCount.setString("doctorName","%"+doctorName+"%");
                queryCount.setString("healthDoctorName","%"+doctorName+"%");
            }
            if (!org.springframework.util.StringUtils.isEmpty(doctor)) {
                queryCount.setString("doctorCode",doctor);
                queryCount.setString("healthDoctorCode",doctor);
            }
            if (!org.springframework.util.StringUtils.isEmpty(beginDate)) {
                queryCount.setString("beginDate",DateUtil.dateToStr(beginDate,DateUtil.YYYY_MM_DD_HH_MM_SS));
            }
            if (!org.springframework.util.StringUtils.isEmpty(endDate)) {
                queryCount.setString("endDate",DateUtil.dateToStr(endDate,DateUtil.YYYY_MM_DD_HH_MM_SS));
            }
            if (!org.springframework.util.StringUtils.isEmpty(reply)) {
                queryCount.setInteger("reply",reply);
            }
            if (!org.springframework.util.StringUtils.isEmpty(status)) {
                queryCount.setInteger("status",status);
            }
            //获取总条数
            int count = ((Number) queryCount.iterate().next()).intValue();
            return count;
        }
    }

    public List<WlyyReplyConsult> getListByFilter(String city, String town, String hospital, String teamCode, String doctorName,String doctor, Integer reply,Integer status, Date beginDate, Date endDate){
        //过滤条件
        StringBuffer filters = new StringBuffer();
        if(StringUtils.isNotBlank(city)){
            filters.append("and city =:city ");
        }
        if(StringUtils.isNotBlank(town)){
            filters.append("and town =:town ");
        }
        if(StringUtils.isNotBlank(hospital)){
            filters.append("and hospital =:hospital ");
        }
        if(StringUtils.isNotBlank(teamCode)){
            filters.append("and teamCode like :teamCode ");
        }
        if(StringUtils.isNotBlank(doctorName)){
            filters.append("and (doctorName  like :doctorName or healthDoctorName like :healthDoctorName) ");
        }
        if(StringUtils.isNotBlank(doctor)){
            filters.append("and (doctorCode  = :doctorCode or healthDoctorCode = :healthDoctorCode) ");
        }

        if(beginDate!=null){
            filters.append("and createTime>=:beginDate ");
        }
        if(endDate!=null){
            filters.append("and createTime<=:endDate ");
        }
        if(reply!=null){
            filters.append("and reply=:reply ");
        }
        if(status!=null){
            filters.append("and status=:status ");
        }

        Query queryCount = currentSession().createQuery("select p from WlyyReplyConsult p where 1=1 " +filters.toString());
        if (!org.springframework.util.StringUtils.isEmpty(city)) {
            queryCount.setString("city",city);
        }
        if (!org.springframework.util.StringUtils.isEmpty(town)) {
            queryCount.setString("town", town);
        }
        if (!org.springframework.util.StringUtils.isEmpty(hospital)) {
            queryCount.setString("hospital",hospital);
        }
        if (!org.springframework.util.StringUtils.isEmpty(teamCode)) {
            queryCount.setString("teamCode",teamCode);
        }
        if (!org.springframework.util.StringUtils.isEmpty(doctorName)) {
            queryCount.setString("doctorName","%"+doctorName+"%");
            queryCount.setString("healthDoctorName","%"+doctorName+"%");
        }
        if (!org.springframework.util.StringUtils.isEmpty(doctor)) {
            queryCount.setString("doctorCode",doctor);
            queryCount.setString("healthDoctorCode",doctor);
        }
        if (!org.springframework.util.StringUtils.isEmpty(beginDate)) {
            queryCount.setString("beginDate",DateUtil.dateToStr(beginDate,DateUtil.YYYY_MM_DD_HH_MM_SS));
        }
        if (!org.springframework.util.StringUtils.isEmpty(endDate)) {
            queryCount.setString("endDate",DateUtil.dateToStr(endDate,DateUtil.YYYY_MM_DD_HH_MM_SS));
        }
        if (!org.springframework.util.StringUtils.isEmpty(reply)) {
            queryCount.setInteger("reply",reply);
        }
        if (!org.springframework.util.StringUtils.isEmpty(status)) {
            queryCount.setInteger("status",status);
        }
        //获取总条数
        return queryCount.list();

    }
}
