package com.yihu.customer.service.manager.device;

import com.yihu.customer.service.BaseService;
import  com.yihu.customer.device.entity.WlyyDevice;
import  com.yihu.customer.device.repository.WlyyDeviceDao;
import com.yihu.customer.util.HttpManageClientUtil;
import org.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;
import org.springside.modules.utils.Clock;

import java.util.HashMap;
import java.util.Map;

@Component
@Transactional(rollbackFor = Exception.class)
public class PatientDeviceService extends BaseService {
    
    private Clock clock = Clock.DEFAULT;
    
    @Autowired
    private HttpManageClientUtil HttpManageClientUtil;
    @Value("${yihu.yihu_OpenPlatform_url}")
    private String url;
    @Value("${yihu.yihu_OpenPlatform_appId}")
    private String appid;
    @Value("${yihu.yihu_OpenPlatform_secret}")
    private String secret;
    private String registerDevice = "DeviceGateway/DeviceApi/registerDevice";//注册设备
    @Autowired
    private WlyyDeviceDao wlyyDeviceDao;
    
    /**
     * 验证sn码 先调总部接口 未注册才查询本地数据库，如果也没有才不能绑定
     * @param deviceSn
     * @return
     * @throws Exception
     */
    public Boolean checkDeviceSn(String deviceSn) throws Exception{
        Boolean flag = false;
        Map<String, String> params = new HashMap<>();
        params.put("deviceSn", deviceSn);
        
        //调用服务
        String response = HttpManageClientUtil.httpPost(url + registerDevice, HttpManageClientUtil.getSecretParams(params, appid, secret));
        System.out.println("注册设备=" + response);
        JSONObject json = new JSONObject(response);
        String code = json.get("Code").toString();
        //10000注册成功 10001已注册 -10000参数不通过(没传参数) -10001设备不存在 -10002设备未出库
        if ("10000".equals(code) || "10001".equals(code)) {
            flag = true;
        } else {
            WlyyDevice deviceDetail = wlyyDeviceDao.findBySn(deviceSn);
            if(deviceDetail != null){
                flag = true;
            }
        }
        /*DeviceDetail deviceDetail = deviceDetailDao.findBySn(deviceSn);
        if(deviceDetail != null){
            flag = true;
        }*/
        return flag;
    }
    
}
