package com.yihu.customer.service.manager.device;

import com.yihu.customer.util.query.BaseJpaService;
import  com.yihu.customer.entity.WlyyPatientDevice;
import  com.yihu.customer.entity.WlyyPatientDeviceLog;
import  com.yihu.customer.repository.WlyyPatientDeviceDao;
import  com.yihu.customer.repository.WlyyPatientDeviceLogDao;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.Date;

/**
 * Created by zd on 2018/6/21.
 * 居民设备日志表，wlyy数据库
 */
@Service
public class WlyyPatientDeviceLogService extends BaseJpaService<WlyyPatientDeviceLog,WlyyPatientDeviceLogDao> {
   @Autowired
   private WlyyPatientDeviceDao wlyyPatientDeviceDao;

   @Autowired
   private WlyyPatientDeviceLogDao wlyyPatientDeviceLogDao;


    /**
     * 绑定和解绑的时候会保存一条数据
     * @param patientDevice
     * @param role
     * @param operateCode
     * @throws Exception
     */
    @Transactional
    public void savePatientDeviceLog(WlyyPatientDevice patientDevice, String deviceSn, int role, int operateCode)throws Exception{
        if (patientDevice==null){
            patientDevice = wlyyPatientDeviceDao.findByDeviceSn(deviceSn).get(0);
        }
        WlyyPatientDeviceLog patientDeviceLog = new WlyyPatientDeviceLog();
        patientDeviceLog.setDeviceId(patientDevice.getDeviceId());
        patientDeviceLog.setPatient(patientDevice.getUser());
        patientDeviceLog.setCategoryCode(patientDevice.getCategoryCode());
        patientDeviceLog.setDeviceName(patientDevice.getDeviceName());
        patientDeviceLog.setDeviceSn(patientDevice.getDeviceSn());
        patientDeviceLog.setRole(role);
        patientDeviceLog.setOperateCode(operateCode);
        //patientDeviceLog.setAgreementPhoto(patientDevice.getAgreementPhoto());
        patientDeviceLog.setOperatorName("admin");
        patientDeviceLog.setOperator("admin");
        patientDeviceLog.setCreateTime(new Date());
        patientDeviceLog.setIsDel(1);
        wlyyPatientDeviceLogDao.save(patientDeviceLog);
    }

}
