package com.yihu.customer.service.manager.dict;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import  com.yihu.customer.entity.ManageDict;
import  com.yihu.customer.entity.reservation.ReservationHospital;
import  com.yihu.customer.entity.reservation.ReservationHospitalDept;
import  com.yihu.customer.repository.ManageDictDao;
import  com.yihu.customer.repository.ManageDictEntryDao;
import  com.yihu.customer.repository.reservation.ReservationHospitalDao;
import  com.yihu.customer.repository.reservation.ReservationHospitalDeptDao;
import com.yihu.customer.util.HttpManageClientUtil;
import com.yihu.customer.util.query.BaseJpaService;
import org.apache.http.NameValuePair;
import org.apache.http.message.BasicNameValuePair;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * Created by Administrator on 2017/1/24.
 */
@Service
public class ManageDictService extends BaseJpaService<ManageDict, ManageDictDao> {

    //基卫服务地址
    @Value("${sign.check_upload}")
    private String jwUrl;
    @Value("${testPattern.sign}")
    private String testPattern;
    @Autowired
    private HttpManageClientUtil httpManageClientUtil;
    @Autowired
    private ReservationHospitalDao reservationHospitalDao;
    @Autowired
    private ReservationHospitalDeptDao reservationHospitalDeptDo;
    @Autowired
    private JdbcTemplate jdbcTemplate;


    @Autowired
    private ManageDictDao dictDao;

    @Autowired
    private ManageDictEntryDao entryDao;

    public ManageDict createDict(ManageDict dict) {
        dict.setCreateDate(new Date());
        dict.setName(dict.getName());
        dictDao.save(dict);
        return dict;
    }

    public void updateDict(ManageDict dict) {
        dictDao.save(dict);
    }

    @Transactional
    public void deleteDict(long dictId) throws Exception {
        entryDao.deleteByDictId(dictId);
        dictDao.deleteById(dictId);
    }

    public boolean isDictNameExists(String name) {
        ManageDict systemDict = dictDao.findByName(name);

        return systemDict != null;
    }

    public Page<ManageDict> searchDict(String name, String phoneticCode, int page, int size) {
        return dictDao.findByNameOrPhoneticCodeOrderByNameAsc(name, phoneticCode, PageRequest.of(page, size));
    }

    public long getNextId() {
        long id = dictDao.getNextId() + 1;
        return id;
    }

    @Transactional
    public boolean syncZyReservationOrgAndDept(){
        try {
            synData();
            Date date = new Date();
            SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            String runTime = df.format(date);
            String sql = "update wlyy.system_dict SET `value` ='"+runTime+"' where dict_name='SYNC_ZY_RESERVATION_ORGANDDEPT';";
            jdbcTemplate.execute(sql);
            return true;
        }catch (Exception e){
            e.printStackTrace();
            return false;
        }

    }

    public void synData() throws Exception {
        //获取医院接口
        String url = jwUrl + "/third/guahao/GetOrgList";
        List<NameValuePair> params = new ArrayList<>();
        params.add(new BasicNameValuePair("type", "1"));
        //获取社区接口
        List<NameValuePair> params1 = new ArrayList<>();
        params1.add(new BasicNameValuePair("type", "2"));
        String response =null;
        String response1 = null;
        if (testPattern.equalsIgnoreCase("1")){
            response = "{\n" +
                    "    \"status\":200,\n" +
                    "    \"msg\":\"获取医院列表成功！\",\n" +
                    "    \"data\":[\n" +
                    "        {\n" +
                    "            \"address\":\"厦门大学附属心血管病医院\",\n" +
                    "            \"name\":\"厦门大学附属心血管病医院\",\n" +
                    "            \"photo\":\"https://www.xmtyw.cn/res/images/2016/08/22/hospital/xiamenshixinxueguanyiyuan.png\",\n" +
                    "            \"id\":\"350211A5010\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"address\":\"厦门大学附属翔安医院\",\n" +
                    "            \"name\":\"厦门大学附属翔安医院\",\n" +
                    "            \"photo\":null,\n" +
                    "            \"id\":\"350211A1176\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"address\":\"复旦中山厦门医院\",\n" +
                    "            \"name\":\"复旦中山厦门医院\",\n" +
                    "            \"photo\":null,\n" +
                    "            \"id\":\"350211A1162\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"address\":\"厦门大学附属第一医院\",\n" +
                    "            \"name\":\"第一医院\",\n" +
                    "            \"photo\":\"https://www.xmtyw.cn/res/images/2016/08/22/hospital/xiamendaxuefushudiyiyiyuan.png\",\n" +
                    "            \"id\":\"350211A1001\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"address\":\"厦门大学附属中山医院\",\n" +
                    "            \"name\":\"厦门大学附属中山医院\",\n" +
                    "            \"photo\":\"https://www.xmtyw.cn/res/images/2016/08/22/hospital/xiamendaxuefushuzhongshanyiyuan.png\",\n" +
                    "            \"id\":\"350211A1002\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"address\":\"解放军第一七四医院\",\n" +
                    "            \"name\":\"一七四医院\",\n" +
                    "            \"photo\":\"https://www.xmtyw.cn/res/images/2016/08/22/hospital/jiefangjundiyiqisiyiyuan.png\",\n" +
                    "            \"id\":\"350211A1005\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"address\":\"厦门医学院附属第二医院\",\n" +
                    "            \"name\":\"厦门医学院附属第二医院\",\n" +
                    "            \"photo\":\"https://www.xmtyw.cn/res/images/2016/08/22/hospital/xiamenshidieryiyuan.png\",\n" +
                    "            \"id\":\"350211A1003\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"address\":\"厦门市中医院\",\n" +
                    "            \"name\":\"厦门市中医院\",\n" +
                    "            \"photo\":\"https://www.xmtyw.cn/res/images/2016/08/22/hospital/xiamenshizhongyiyuan.png\",\n" +
                    "            \"id\":\"350211A2001\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"address\":\"厦门市妇幼保健院\",\n" +
                    "            \"name\":\"妇幼保健院\",\n" +
                    "            \"photo\":\"https://www.xmtyw.cn/res/images/2016/08/22/hospital/xiamenshifuyoubaojianyuan.png\",\n" +
                    "            \"id\":\"350211G1001\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"address\":\"厦门市儿童医院\",\n" +
                    "            \"name\":\"厦门市儿童医院\",\n" +
                    "            \"photo\":null,\n" +
                    "            \"id\":\"350211A1017\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"address\":\"厦门市海沧医院\",\n" +
                    "            \"name\":\"厦门市海沧医院\",\n" +
                    "            \"photo\":\"https://www.xmtyw.cn/res/images/2016/08/22/hospital/xiamenshihaicangyiyuan.png\",\n" +
                    "            \"id\":\"350211A1049\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"address\":\"第一医院思明分院\",\n" +
                    "            \"name\":\"第一医院思明分院\",\n" +
                    "            \"photo\":\"https://www.xmtyw.cn/res/images/2016/08/22/hospital/diyiyiyuansimingfengyuan.png\",\n" +
                    "            \"id\":\"350211A1008\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"address\":\"第一医院杏林分院\",\n" +
                    "            \"name\":\"第一医院杏林分院\",\n" +
                    "            \"photo\":\"https://www.xmtyw.cn/res/images/2016/08/22/hospital/diyiyiyuanxinlinfengyuan.png\",\n" +
                    "            \"id\":\"350211A1001A\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"address\":\"厦门市第三医院\",\n" +
                    "            \"name\":\"厦门市第三医院\",\n" +
                    "            \"photo\":\"https://www.xmtyw.cn/res/images/2016/08/22/hospital/xiamendisanyiyuan.png\",\n" +
                    "            \"id\":\"350211A1004\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"address\":\"厦门市第五医院\",\n" +
                    "            \"name\":\"厦门市第五医院\",\n" +
                    "            \"photo\":\"https://www.xmtyw.cn/res/images/2016/08/22/hospital/xiamendiwuyiyuan.png\",\n" +
                    "            \"id\":\"350211A1016\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"address\":\"厦门医学院附属口腔医院\",\n" +
                    "            \"name\":\"厦门市口腔医院\",\n" +
                    "            \"photo\":\"https://www.xmtyw.cn/res/images/2016/08/22/hospital/xiamenshikouqianyiyuan.png\",\n" +
                    "            \"id\":\"350211A5002\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"address\":\"厦门市仙岳医院\",\n" +
                    "            \"name\":\"厦门市仙岳医院\",\n" +
                    "            \"photo\":\"https://www.xmtyw.cn/res/images/2016/08/22/hospital/xiamenshixianyueyiyuan.png\",\n" +
                    "            \"id\":\"350211A5001\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"address\":\"厦门弘爱医院\",\n" +
                    "            \"name\":\"厦门弘爱医院\",\n" +
                    "            \"photo\":null,\n" +
                    "            \"id\":\"350211A1174\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"address\":\"湖里区妇幼保健院\",\n" +
                    "            \"name\":\"湖里区妇幼保健院\",\n" +
                    "            \"photo\":\"https://www.xmtyw.cn/res/images/2016/08/22/hospital/huliqufuyoubaojianyuan.png\",\n" +
                    "            \"id\":\"350211G1102\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"address\":\"厦门市同安区中医医院\",\n" +
                    "            \"name\":\"厦门市同安区中医医院\",\n" +
                    "            \"photo\":null,\n" +
                    "            \"id\":\"350211A2003\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"address\":\"厦门市海沧区妇幼保健院\",\n" +
                    "            \"name\":\"厦门市海沧区妇幼保健院\",\n" +
                    "            \"photo\":null,\n" +
                    "            \"id\":\"350211G1104\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"address\":\"厦门大学附属厦门眼科中心\",\n" +
                    "            \"name\":\"厦门大学附属厦门眼科中心\",\n" +
                    "            \"photo\":\"https://www.xmtyw.cn/res/images/2016/08/22/hospital/xiamenshiyankezhongxin.png\",\n" +
                    "            \"id\":\"350211A5004\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"address\":\"厦门新开元医院\",\n" +
                    "            \"name\":\"厦门新开元医院\",\n" +
                    "            \"photo\":\"https://www.xmtyw.cn/res/images/2016/08/22/hospital/897273291284833894342.png\",\n" +
                    "            \"id\":\"350211A1031\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"address\":\"厦门科宏眼科医院\",\n" +
                    "            \"name\":\"厦门科宏眼科医院\",\n" +
                    "            \"photo\":null,\n" +
                    "            \"id\":\"350211A5121\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"address\":\"厦门莲花医院\",\n" +
                    "            \"name\":\"厦门莲花医院\",\n" +
                    "            \"photo\":null,\n" +
                    "            \"id\":\"350211A1012\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"address\":\"厦门市长庚医院\",\n" +
                    "            \"name\":\"厦门市长庚医院\",\n" +
                    "            \"photo\":null,\n" +
                    "            \"id\":\"350211A1020\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"address\":\"厦门弘爱康复医院\",\n" +
                    "            \"name\":\"厦门弘爱康复医院\",\n" +
                    "            \"photo\":null,\n" +
                    "            \"id\":\"350211A1177\"\n" +
                    "        }\n" +
                    "    ]\n" +
                    "}";
            response1 ="{\"status\":200,\"msg\":\"获取医院列表成功！\",\"data\":[{\"address\":\"思明区鼓浪屿街道社区卫生服务中心\",\"name\":\"思明区鼓浪屿街道社区卫生服务中心\",\"photo\":null,\"id\":\"350211B1010\"},{\"address\":\"翔安区新店镇卫生院\",\"name\":\"翔安区新店镇卫生院\",\"photo\":null,\"id\":\"350211C1004\"},{\"address\":\"翔安区马巷镇卫生院\",\"name\":\"翔安区马巷镇卫生院\",\"photo\":\"\",\"id\":\"350211C1005\"},{\"address\":\"翔安区内厝镇卫生院\",\"name\":\"翔安区内厝镇卫生院\",\"photo\":null,\"id\":\"350211C1010\"},{\"address\":\"翔安区新圩镇卫生院\",\"name\":\"翔安区新圩镇卫生院\",\"photo\":null,\"id\":\"350211C1011\"},{\"address\":\"同安区洪塘镇卫生院\",\"name\":\"同安区洪塘镇卫生院\",\"photo\":null,\"id\":\"350211C1016\"},{\"address\":\"同安区五显镇卫生院\",\"name\":\"同安区五显镇卫生院\",\"photo\":null,\"id\":\"350211C1017\"},{\"address\":\"翔安区大嶝街道社区卫生服务中心\",\"name\":\"翔安区大嶝街道社区卫生服务中心\",\"photo\":null,\"id\":\"350211C1012\"},{\"address\":\"思明区鹭江街道社区卫生服务中心\",\"name\":\"思明区鹭江街道社区卫生服务中心\",\"photo\":\"\",\"id\":\"350211B1009\"},{\"address\":\"思明区筼筜街道社区卫生服务中心\",\"name\":\"思明区筼筜街道社区卫生服务中心\",\"photo\":null,\"id\":\"350211B1008\"},{\"address\":\"思明区梧村街道社区卫生服务中心\",\"name\":\"思明区梧村街道社区卫生服务中心\",\"photo\":null,\"id\":\"350211B1007\"},{\"address\":\"思明区滨海街道社区卫生服务中心\",\"name\":\"思明区滨海街道社区卫生服务中心\",\"photo\":\"\",\"id\":\"350211B1005\"},{\"address\":\"思明区嘉莲街道社区卫生服务中心\",\"name\":\"思明区嘉莲街道社区卫生服务中心\",\"photo\":null,\"id\":\"350211B1006\"},{\"address\":\"思明区开元街道社区卫生服务中心\",\"name\":\"思明区开元街道社区卫生服务中心\",\"photo\":null,\"id\":\"350211B1003\"},{\"address\":\"思明区厦港街道社区卫生服务中心\",\"name\":\"思明区厦港街道社区卫生服务中心\",\"photo\":\"\",\"id\":\"350211B1002\"},{\"address\":\"思明区中华街道社区卫生服务中心\",\"name\":\"思明区中华街道社区卫生服务中心\",\"photo\":\"\",\"id\":\"350211B1012\"},{\"address\":\"湖里区殿前街道社区卫生服务中心\",\"name\":\"湖里区殿前街道社区卫生服务中心\",\"photo\":null,\"id\":\"350211B1018\"},{\"address\":\"湖里区金山街道社区卫生服务中心\",\"name\":\"湖里区金山街道社区卫生服务中心\",\"photo\":\"\",\"id\":\"350211B1040\"},{\"address\":\"湖里区禾山街道社区卫生服务中心\",\"name\":\"湖里区禾山街道社区卫生服务中心\",\"photo\":null,\"id\":\"350211B1017\"},{\"address\":\"湖里区江头街道社区卫生服务中心\",\"name\":\"湖里区江头街道社区卫生服务中心\",\"photo\":null,\"id\":\"350211B1016\"},{\"address\":\"湖里区湖里街道社区卫生服务中心\",\"name\":\"湖里区湖里街道社区卫生服务中心\",\"photo\":null,\"id\":\"350211B1015\"},{\"address\":\"海沧区新阳街道社区卫生服务中心\",\"name\":\"海沧区新阳街道社区卫生服务中心\",\"photo\":null,\"id\":\"350211B1039\"},{\"address\":\"海沧区东孚镇卫生院\",\"name\":\"海沧区东孚镇卫生院\",\"photo\":\"\",\"id\":\"350211C1001\"},{\"address\":\"海沧区海沧街道石塘社区卫生服务中心\",\"name\":\"海沧区海沧街道石塘社区卫生服务中心\",\"photo\":\"\",\"id\":\"350211B1038\"},{\"address\":\"海沧区嵩屿街道社区卫生服务中心\",\"name\":\"海沧区嵩屿街道社区卫生服务中心\",\"photo\":\"\",\"id\":\"350211B1013\"},{\"address\":\"同安区工业集中区社区卫生服务中心\",\"name\":\"同安区工业集中区社区卫生服务中心\",\"photo\":null,\"id\":\"350211A1166\"},{\"address\":\"同安区莲花镇卫生院\",\"name\":\"同安区莲花镇卫生院\",\"photo\":null,\"id\":\"350211C1002\"},{\"address\":\"同安区西柯镇卫生院\",\"name\":\"同安区西柯镇卫生院\",\"photo\":null,\"id\":\"350211C1003\"},{\"address\":\"同安区新民镇卫生院\",\"name\":\"同安区新民镇卫生院\",\"photo\":null,\"id\":\"350211C1014\"},{\"address\":\"同安区大同街道社区卫生服务中心\",\"name\":\"同安区大同街道社区卫生服务中心\",\"photo\":null,\"id\":\"350211B1042\"},{\"address\":\"同安区祥平街道社区卫生服务中心\",\"name\":\"同安区祥平街道社区卫生服务中心\",\"photo\":\"\",\"id\":\"350211B1026\"},{\"address\":\"同安区汀溪镇卫生院\",\"name\":\"同安区汀溪镇卫生院\",\"photo\":null,\"id\":\"350211C1013\"},{\"address\":\"集美街道社区卫生服务中心\",\"name\":\"集美街道社区卫生服务中心\",\"photo\":\"https://www.xmtyw.cn/res/images/2016/08/22/hospital/230300892923023114.png\",\"id\":\"350211B1019\"},{\"address\":\"杏滨街道社区卫生服务中心\",\"name\":\"杏滨街道社区卫生服务中心\",\"photo\":\"https://www.xmtyw.cn/res/images/2016/08/22/hospital/xinbinjjiedaoshequweishenfuwuzhongxin.png\",\"id\":\"350211B1021\"},{\"address\":\"侨英街道社区卫生服务中心\",\"name\":\"侨英街道社区卫生服务中心\",\"photo\":\"https://www.xmtyw.cn/res/images/2016/08/22/hospital/qiaoyinjiedaoshequweishenfuwuzhongxin.png\",\"id\":\"350211B1024\"},{\"address\":\"杏林街道社区卫生服务中心\",\"name\":\"杏林街道社区卫生服务中心\",\"photo\":\"\",\"id\":\"350211B1020\"},{\"address\":\"集美区后溪镇卫生院\",\"name\":\"集美区后溪镇卫生院\",\"photo\":\"https://www.xmtyw.cn/res/images/2016/08/22/hospital/jimeiquhouxizhenweishengyuan.png\",\"id\":\"350211C1006\"},{\"address\":\"思明区莲前街道社区卫生服务中心\",\"name\":\"思明区莲前街道社区卫生服务中心\",\"photo\":\"\",\"id\":\"350211B1004\"},{\"address\":\"集美区灌口镇卫生院\",\"name\":\"集美区灌口镇卫生院\",\"photo\":\"\",\"id\":\"350211A1025\"}]}";
        }else {
            response = httpManageClientUtil.post(url, params, "UTF-8");
            response1 = httpManageClientUtil.post(url, params1, "UTF-8");
        }
        reservationHospitalDao.deleteReservationHospital();
        if (response!=null){
            JSONObject jsonObject = JSONObject.parseObject(response);
            if (jsonObject!=null&&jsonObject.getInteger("status")==200){
                JSONArray array = jsonObject.getJSONArray("data");
                for (int i=0;i<array.size();i++){
                    JSONObject object = array.getJSONObject(i);
                    synDept(object.getString("id"));
                    ReservationHospital reservationHospital = new ReservationHospital();
                    reservationHospital.setType(1);
                    reservationHospital.setCode(object.getString("id"));
                    reservationHospital.setName(object.getString("name"));
                    reservationHospital.setAddress(object.getString("address"));
                    reservationHospital.setPhoto(object.getString("photo"));
                    reservationHospitalDao.save(reservationHospital);
                }
            }
        }

        if (response1!=null){
            JSONObject jsonObject = JSONObject.parseObject(response1);
            if (jsonObject!=null&&jsonObject.getInteger("status")==200){
                JSONArray array = jsonObject.getJSONArray("data");
                for (int i=0;i<array.size();i++){
                    JSONObject object = array.getJSONObject(i);
                    synDept(object.getString("id"));
                    ReservationHospital reservationHospital = new ReservationHospital();
                    reservationHospital.setType(2);
                    reservationHospital.setCode(object.getString("id"));
                    reservationHospital.setName(object.getString("name"));
                    reservationHospital.setAddress(object.getString("address"));
                    reservationHospital.setPhoto(object.getString("photo"));
                    reservationHospitalDao.save(reservationHospital);
                }
            }
        }
    }


    public void synDept(String hospitalCode) throws Exception{
        reservationHospitalDeptDo.deleteReservationHospitalDept(hospitalCode);
        String url = jwUrl + "/third/guahao/GetOrgDepList";
        List<NameValuePair> params = new ArrayList<>();
        params.add(new BasicNameValuePair("hospitalId", hospitalCode));
        String response = null;
        if (testPattern.equalsIgnoreCase("1")){
            response="{\n" +
                    "    \"status\":200,\n" +
                    "    \"msg\":\"获取科室列表成功！\",\n" +
                    "    \"data\":[\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"康复医学科门诊\",\n" +
                    "            \"id\":\"1140004\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"心血管内科门诊\",\n" +
                    "            \"id\":\"1010310\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"眼科门诊\",\n" +
                    "            \"id\":\"1070210\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"小儿心血管门诊\",\n" +
                    "            \"id\":\"1040623\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"风湿免疫科门诊\",\n" +
                    "            \"id\":\"1010810\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"小儿神经门诊\",\n" +
                    "            \"id\":\"1040615\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"血液科门诊\",\n" +
                    "            \"id\":\"1010610\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"高血压门诊\",\n" +
                    "            \"id\":\"1010312\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"难治性乳腺炎门诊\",\n" +
                    "            \"id\":\"1021312\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"小儿血液病门诊\",\n" +
                    "            \"id\":\"1040618\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"肿瘤心理\",\n" +
                    "            \"id\":\"1080704\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"脂肪肝专科门诊\",\n" +
                    "            \"id\":\"1011340\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"先心病门诊\",\n" +
                    "            \"id\":\"1010313\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"遗传咨询门诊\",\n" +
                    "            \"id\":\"1030160\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"儿外科门诊\",\n" +
                    "            \"id\":\"1020710\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"肝胆胰血管外科门诊\",\n" +
                    "            \"id\":\"1020610\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"核医学科\",\n" +
                    "            \"id\":\"2030000\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"肿瘤诊断与分期门诊\",\n" +
                    "            \"id\":\"1080702\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"肺结节专科门诊\",\n" +
                    "            \"id\":\"1080707\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"小儿遗传代谢门诊\",\n" +
                    "            \"id\":\"1040626\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"乳房整形再造门诊\",\n" +
                    "            \"id\":\"1021311\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"耳鼻喉头颈外科门诊\",\n" +
                    "            \"id\":\"1070110\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"胃肠肿瘤外科三区门诊\",\n" +
                    "            \"id\":\"1080113\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"中医科门诊\",\n" +
                    "            \"id\":\"1050100\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"皮肤科门诊\",\n" +
                    "            \"id\":\"1060100\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"骨伤门诊\",\n" +
                    "            \"id\":\"1140005\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"针灸门诊\",\n" +
                    "            \"id\":\"1140006\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"产科门诊\",\n" +
                    "            \"id\":\"1030120\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"胸外科门诊\",\n" +
                    "            \"id\":\"32900\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"肿瘤中医\",\n" +
                    "            \"id\":\"1080703\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"乳腺外科门诊\",\n" +
                    "            \"id\":\"1021310\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"介入门诊\",\n" +
                    "            \"id\":\"2020280\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"骨科门诊\",\n" +
                    "            \"id\":\"1020210\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"小儿消化门诊\",\n" +
                    "            \"id\":\"1040619\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"小儿内分泌门诊\",\n" +
                    "            \"id\":\"1040617\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"肥胖脂肪肝专病门诊\",\n" +
                    "            \"id\":\"1011613\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"血液骨髓移植门诊\",\n" +
                    "            \"id\":\"71100\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"小儿肾脏门诊\",\n" +
                    "            \"id\":\"1040616\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"脑卒中康复门诊\",\n" +
                    "            \"id\":\"1140007\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"慢性肾脏病咨询室\",\n" +
                    "            \"id\":\"1010550\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"营养科\",\n" +
                    "            \"id\":\"23900\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"小儿心理行为保健门诊\",\n" +
                    "            \"id\":\"1040622\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"全科医学门诊\",\n" +
                    "            \"id\":\"1110101\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"胸部肿瘤内科\",\n" +
                    "            \"id\":\"1080115\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"小儿风湿免疫门诊\",\n" +
                    "            \"id\":\"1040625\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"血液淋巴瘤专病门诊\",\n" +
                    "            \"id\":\"70800\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"糖尿病健康教育门诊\",\n" +
                    "            \"id\":\"1011630\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"泌尿外科门诊\",\n" +
                    "            \"id\":\"1020410\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"感染性疾病科门诊\",\n" +
                    "            \"id\":\"1011310\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"神经外科门诊\",\n" +
                    "            \"id\":\"1090210\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"胃肠肿瘤外科二区门诊\",\n" +
                    "            \"id\":\"1080111\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"小儿骨科门诊\",\n" +
                    "            \"id\":\"1020213\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"癫痫门诊\",\n" +
                    "            \"id\":\"1090310\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"生殖男科门诊\",\n" +
                    "            \"id\":\"7030002\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"新生儿区门诊\",\n" +
                    "            \"id\":\"1040624\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"胸部肿瘤放疗科\",\n" +
                    "            \"id\":\"1080308\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"产前诊断门诊\",\n" +
                    "            \"id\":\"1030150\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"记忆门诊\",\n" +
                    "            \"id\":\"1090160\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"神经内科门诊\",\n" +
                    "            \"id\":\"1090110\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"疼痛科门诊\",\n" +
                    "            \"id\":\"1080401\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"结核病门诊\",\n" +
                    "            \"id\":\"1011400\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"内分泌糖尿病科门诊\",\n" +
                    "            \"id\":\"1011610\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"鼻咽癌及其他头颈肿瘤放疗科\",\n" +
                    "            \"id\":\"1080307\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"腹部、乳腺肿瘤放疗科\",\n" +
                    "            \"id\":\"1080309\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"内镜门诊\",\n" +
                    "            \"id\":\"1010114\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"脑血管性病变介入门诊\",\n" +
                    "            \"id\":\"1090112\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"中医适宜技术门诊\",\n" +
                    "            \"id\":\"1050300\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"高尿酸血症与痛风专病门诊\",\n" +
                    "            \"id\":\"1011614\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"肿瘤内科门诊\",\n" +
                    "            \"id\":\"1080117\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"心理科门诊\",\n" +
                    "            \"id\":\"70500\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"伤口造口门诊\",\n" +
                    "            \"id\":\"33000\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"神经免疫专病门诊\",\n" +
                    "            \"id\":\"1090111\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"妇科门诊\",\n" +
                    "            \"id\":\"1030110\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"口腔科门诊\",\n" +
                    "            \"id\":\"1070310\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"儿科门诊\",\n" +
                    "            \"id\":\"32800\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"心脏外科门诊\",\n" +
                    "            \"id\":\"20300\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"肾内科门诊\",\n" +
                    "            \"id\":\"1010510\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"普外科门诊\",\n" +
                    "            \"id\":\"1020110\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"呼吸内科门诊\",\n" +
                    "            \"id\":\"1010210\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"整形美容烧伤科门诊\",\n" +
                    "            \"id\":\"1020510\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"小儿呼吸哮喘门诊\",\n" +
                    "            \"id\":\"1040613\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"泌尿男科门诊\",\n" +
                    "            \"id\":\"1020411\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"肺癌多学科联合诊治(MDT)门诊\",\n" +
                    "            \"id\":\"1080601\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"消化道肿瘤内科\",\n" +
                    "            \"id\":\"1080118\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"助产士专科门诊\",\n" +
                    "            \"id\":\"1030141\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"胃肠肿瘤多学科联合诊治(MDT)门诊\",\n" +
                    "            \"id\":\"1080604\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"肝病专科门诊\",\n" +
                    "            \"id\":\"1011311\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"不孕不育门诊\",\n" +
                    "            \"id\":\"7030001\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"消化内科门诊\",\n" +
                    "            \"id\":\"1010110\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"PICC专科门诊\",\n" +
                    "            \"id\":\"1010660\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"麻醉门诊\",\n" +
                    "            \"id\":\"1020840\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"乳腺肿瘤内科\",\n" +
                    "            \"id\":\"1080114\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"帕金森氏病-神经内科\",\n" +
                    "            \"id\":\"1090150\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"高压氧科\",\n" +
                    "            \"id\":\"2070000\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"肿瘤早期诊疗门诊\",\n" +
                    "            \"id\":\"1080510\"\n" +
                    "        },\n" +
                    "        {\n" +
                    "            \"hospitalId\":\"350211A1001\",\n" +
                    "            \"name\":\"炎症性肠病门诊\",\n" +
                    "            \"id\":\"1010115\"\n" +
                    "        }\n" +
                    "    ]\n" +
                    "}";
        }else {
            response = httpManageClientUtil.post(url, params, "UTF-8");
        }
        if (response!=null){
            JSONObject jsonObject = JSONObject.parseObject(response);
            if (jsonObject!=null&&jsonObject.getInteger("status")==200){
                JSONArray array = jsonObject.getJSONArray("data");
                for (int i=0;i<array.size();i++){
                    JSONObject object = array.getJSONObject(i);
                    ReservationHospitalDept reservationHospitalDept=new ReservationHospitalDept();
                    reservationHospitalDept.setCode(object.getString("id"));
                    reservationHospitalDept.setHospitalCode(object.getString("hospitalId"));
                    reservationHospitalDept.setName(object.getString("name"));
                    reservationHospitalDeptDo.save(reservationHospitalDept);
                }
            }
        }
    }
}
