package com.yihu.customer.service.manager.healthbank;

import com.alibaba.fastjson.JSONObject;
import com.yihu.customer.util.HttpManageClientUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.Map;

/**
 * Created by humingfen on 2018/6/22.
 * wlyy_health_bank_task_rule数据库
 */
@Service
public class TaskRuleService {
    @Value("${healthbank.url}")
    private String baseUrl;
    @Autowired
    private HttpManageClientUtil httpManageClientUtil;

    /**
     * 查看活动列表
     * @param taskRule
     * @param page
     * @param pageSize
     * @return
     */
    public JSONObject searchList(String taskRule, Integer page, Integer pageSize) {
        String url = baseUrl + "findTaskRule";
        String response = "";
        Map<String,String> params = new HashMap<>();
        params.put("taskRule",taskRule);
        params.put("page",page.toString());
        params.put("size",pageSize.toString());
        try {
            response = httpManageClientUtil.httpPost(url,params);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return JSONObject.parseObject(response);
    }

    public JSONObject update(String jsonData) {
        String url = baseUrl + "updateTaskRule";
        String response = "";
        Map<String,String> params = new HashMap<>();
        params.put("taskRule",jsonData);
        try {
            response = httpManageClientUtil.httpPost(url,params);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return JSONObject.parseObject(response);
    }

    public JSONObject create(String jsonData) {
        String url = baseUrl + "createTaskRule";
        String response = "";
        Map<String,String> params = new HashMap<>();
        params.put("taskRule",jsonData);
        try {
            response = httpManageClientUtil.httpPost(url,params);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return JSONObject.parseObject(response);
    }

    public JSONObject delete(String ids) {
        String url = baseUrl + "batchTaskRule";
        String response = "";
        Map<String,String> params = new HashMap<>();
        params.put("ids",ids);
        try {
            response = httpManageClientUtil.httpPost(url,params);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return JSONObject.parseObject(response);
    }
}
