package com.yihu.customer.service.manager.healthbank;

import com.alibaba.fastjson.JSONObject;
import com.yihu.customer.util.HttpManageClientUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.Map;

/**
 * Created by humingfen on 2018/6/21.
 * wlyy_health_bank_task数据库
 */
@Service
public class TaskService {
    @Value("${healthbank.url}")
    private String baseUrl;
    @Autowired
    private HttpManageClientUtil httpManageClientUtil;

    /**
     * 查看活动列表
     * @param task
     * @param page
     * @param pageSize
     * @return
     */
    public JSONObject searchList(String task, Integer page, Integer pageSize) {
        String url = baseUrl + "findTask";
        String response = "";
        Map<String,String> params = new HashMap<>();
        params.put("task",task);
        params.put("page",page.toString());
        params.put("size",pageSize.toString());
        try {
            response = httpManageClientUtil.httpPost(url,params);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return JSONObject.parseObject(response);
    }

    public JSONObject update(String jsonData) {
        String url = baseUrl + "updateTask";
        String response = "";
        Map<String,String> params = new HashMap<>();
        params.put("task",jsonData);
        try {
            response = httpManageClientUtil.httpPost(url,params);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return JSONObject.parseObject(response);
    }

    public JSONObject create(String jsonData) {
        String url = baseUrl + "createTask";
        String response = "";
        Map<String,String> params = new HashMap<>();
        params.put("task",jsonData);
        try {
            response = httpManageClientUtil.httpPost(url,params);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return JSONObject.parseObject(response);
    }

    public JSONObject delete(String ids) {
        String url = baseUrl + "batchTask";
        String response = "";
        Map<String,String> params = new HashMap<>();
        params.put("ids",ids);
        try {
            response = httpManageClientUtil.httpPost(url,params);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return JSONObject.parseObject(response);
    }
}
