package com.yihu.customer.service.manager.hos;

import com.alibaba.fastjson.JSONArray;
import com.fasterxml.jackson.core.type.TypeReference;
import com.fasterxml.jackson.databind.ObjectMapper;
import  com.yihu.customer.entity.Hospital;
import  com.yihu.customer.entity.WlyyOrgAddress;
import  com.yihu.customer.entity.WlyyOrgAddressDoctor;
import  com.yihu.customer.repository.HospitalDao;
import  com.yihu.customer.repository.WlyyOrgAddressDao;
import  com.yihu.customer.repository.WlyyOrgAddressDoctorDao;
import com.yihu.customer.util.AesEncryptUtils;
import com.yihu.customer.util.HttpManageClientUtil;
import com.yihu.customer.util.query.BaseJpaService;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.PageRequest;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.io.IOException;
import java.text.ParseException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**ong
 * Created by Bing on 2021/5/27.
 */
@Service
public class HosPharmacyService extends BaseJpaService<WlyyOrgAddress, WlyyOrgAddressDao> {

    @Autowired
    private JdbcTemplate jdbcTemplate;
    @Autowired
    private WlyyOrgAddressDao wlyyOrgAddressDao;
    @Autowired
    private HospitalDao hospitalDao;
    @Autowired
    private WlyyOrgAddressDoctorDao wlyyOrgAddressDoctorDao;
    @Autowired
    private HttpManageClientUtil httpManageClientUtil;
    @Autowired
    private ObjectMapper objectMapper;

    public Page<WlyyOrgAddress> pharmacyList(String hospitalCode, String name, int page, int rows) throws ParseException {
        //对数据先进行更新
        String sql = " select ads.id,dept.org_code,dept.dept_code,dept.dept_name from wlyy_hospital_mapping hos INNER JOIN " +
                " zy_iv_dept_dict dept on hos.mapping_code = dept.org_code and hos.type=1 left join wlyy_org_address ads " +
                " on ads.org_code = dept.org_code and dept.dept_code = ads.dept_code where  dept.dept_type=5 and hos.code = '"+hospitalCode+"' ";
        Hospital hospital = hospitalDao.findByCode(hospitalCode);
        List<Map<String,Object>> tmpList = jdbcTemplate.queryForList(sql);
        List<WlyyOrgAddress> listDelete = wlyyOrgAddressDao.findByHospitalCode(hospitalCode);
        List<WlyyOrgAddress> list = new ArrayList<>();
        for (Map<String,Object>tmp :tmpList){
            WlyyOrgAddress wlyyOrgAddress = new WlyyOrgAddress();
            if (tmp.get("id")!=null){
                wlyyOrgAddress = wlyyOrgAddressDao.findById(Long.parseLong(tmp.get("id").toString())).get();
                if (null == wlyyOrgAddress){
                    wlyyOrgAddress = wlyyOrgAddressDao.findByHospitalCodeAndOrgCodeAndDeptCode(hospitalCode,tmp.get("org_code").toString(),tmp.get("dept_code").toString());
                }
            }else {
                wlyyOrgAddress.setOrgAddress(hospital.getAddress());
            }
            wlyyOrgAddress.setHospitalCode(hospitalCode);
            wlyyOrgAddress.setOrgCode(tmp.get("org_code").toString());
            wlyyOrgAddress.setDeptCode(tmp.get("dept_code").toString());
            wlyyOrgAddress.setDeptName(tmp.get("dept_name").toString());
            if (StringUtils.isBlank(wlyyOrgAddress.getDel()+"")||wlyyOrgAddress.getDel()==null){
                wlyyOrgAddress.setDel(1);
            }
            list.add(wlyyOrgAddress);
        }
        wlyyOrgAddressDao.deleteAll(listDelete);//删除原有数据
        wlyyOrgAddressDao.saveAll(list);
        if (page <= 0) {
            page = 1;
        }
        rows = rows<0?0:rows;
        PageRequest pageRequest = PageRequest.of(page-1 , rows);
        sql ="hospitalCode="+hospitalCode+";";
        if (StringUtils.isNotBlank(name)){
            sql += "deptName?"+name+";";
        }
        long count = 0;
        if (list != null && list.size() > 0) {
            count = getCount(sql);
            list = search("", sql, "", page, rows);
        }else {
            list = new ArrayList<>();
        }
        return new PageImpl<WlyyOrgAddress>(list, pageRequest, count);
    }

    @Transactional
    public void updateOrgAddress(WlyyOrgAddress wlyyOrgAddress){
        WlyyOrgAddress tmp = this.findOne(wlyyOrgAddress.getId());
        if (tmp==null){

        }else {
            tmp.setDeptName(wlyyOrgAddress.getDeptName());
            tmp.setOrgAddress(wlyyOrgAddress.getOrgAddress());
            tmp.setDel(wlyyOrgAddress.getDel());
            tmp.setPhone(wlyyOrgAddress.getPhone());
            this.save(tmp);
            wlyyOrgAddressDoctorDao.deleteByDeptCodeAndHospitalCode(wlyyOrgAddress.getHospitalCode(),wlyyOrgAddress.getDeptCode());
            if (StringUtils.isNotBlank(wlyyOrgAddress.getDoctor())){
                WlyyOrgAddressDoctor wlyyOrgAddressDoctor = new WlyyOrgAddressDoctor();
                wlyyOrgAddressDoctor.setHospitalCode(wlyyOrgAddress.getHospitalCode());
                wlyyOrgAddressDoctor.setOrgCode(wlyyOrgAddress.getOrgCode());
                wlyyOrgAddressDoctor.setDeptCode(wlyyOrgAddress.getDeptCode());
                wlyyOrgAddressDoctor.setDoctor(wlyyOrgAddress.getDoctor());
                wlyyOrgAddressDoctor.setDoctorName(wlyyOrgAddress.getDoctorName());
                wlyyOrgAddressDoctor.setPrepayDepp(wlyyOrgAddress.getPrepayDepp());
                wlyyOrgAddressDoctor.setOperatorId(wlyyOrgAddress.getOperatorId());
                wlyyOrgAddressDoctor.setEquNums(wlyyOrgAddress.getEquNums());

                wlyyOrgAddressDoctorDao.save(wlyyOrgAddressDoctor);
            }
        }
    }

    @Transactional
    public boolean updateDel(Integer del, Long Id) {
        int sum = wlyyOrgAddressDao.updateDel(del, Id);
        return sum > 0 ? true : false;
    }

    public WlyyOrgAddress findOne(Long id){
        WlyyOrgAddress wlyyOrgAddress = wlyyOrgAddressDao.findById(id).get();
        if (null!=wlyyOrgAddress){
           WlyyOrgAddressDoctor wlyyOrgAddressDoctor =  wlyyOrgAddressDoctorDao.findByHospitalCodeAndDeptCode(wlyyOrgAddress.getHospitalCode(),wlyyOrgAddress.getDeptCode());
           if (null != wlyyOrgAddressDoctor){
               wlyyOrgAddress.setDoctor(wlyyOrgAddressDoctor.getDoctor());
               wlyyOrgAddress.setDoctorName(wlyyOrgAddressDoctor.getDoctorName());
               wlyyOrgAddress.setPrepayDepp(wlyyOrgAddressDoctor.getPrepayDepp());
               wlyyOrgAddress.setOperatorId(wlyyOrgAddressDoctor.getOperatorId());
               wlyyOrgAddress.setEquNums(wlyyOrgAddressDoctor.getEquNums());
           }
        }
        return wlyyOrgAddress;
    }

    public List<Map<String,Object>> getHlwDevices(String orgCode) throws IOException {
        List<Map<String,Object>> list = new ArrayList<>();

        String sql = " select code from system_dict where dict_name ='hlwJumiaiUrl'  ";

        List<String> urls = jdbcTemplate.queryForList(sql,String.class);

        if (urls.size()>0){
            String url = urls.get(0)+"/base/open/noLogin/getDeviceListWlyy";
            Map map = new HashMap<String, String>();
            map.put("orgCode",orgCode);
            String content = com.alibaba.fastjson.JSONObject.toJSONString(map);
            String params = AesEncryptUtils.encrypt(content,"46A61629A19AE04C");

            String response = httpManageClientUtil.getBodyRawForm(url,params);
            com.alibaba.fastjson.JSONObject resultObject = com.alibaba.fastjson.JSONObject.parseObject(response);
            if (resultObject.get("status").equals("200")) {
                com.alibaba.fastjson.JSONObject jsonObjectData = com.alibaba.fastjson.JSONObject.parseObject(AesEncryptUtils.decrypt(resultObject.get("data").toString(),"46A61629A19AE04C"));
                if (jsonObjectData.getJSONArray("detailModelList")!=null){
                    JSONArray roleList = jsonObjectData.getJSONArray("detailModelList");
                    list = objectMapper.readValue(roleList.toString(), new TypeReference<List<Map<String,Object>>>(){});
                    for (Map<String,Object> tmp:list){
                        tmp.put("equ_nameStr",tmp.get("equ_name").toString()+"<br/>"+tmp.get("equ_num").toString());
                    }
                }
            }

        }
        return list;
    }
}
