package com.yihu.customer.service.manager.medicine;

import com.yihu.customer.util.query.BasemedicineJpaService;
import  com.yihu.customer.medicine.entity.WlyyMedicineKey;
import  com.yihu.customer.medicine.repository.WlyyMedicineKeyDao;
import com.yihu.customer.util.HttpManageClientUtil;
import org.json.JSONException;
import org.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import org.springside.modules.utils.Clock;

import java.util.List;

/**
 * Created by Administrator on 2017/8/14.
 */
@Service
public class WlyyMedicineKeyService extends BasemedicineJpaService<WlyyMedicineKey, WlyyMedicineKeyDao> {

    @Value("${yueren.api}")
    private String api;

    @Autowired
    private WlyyMedicineKeyDao wlyyMedicineKeyDao;

    private Clock clock = Clock.DEFAULT;

    public void saveKey(String key) {
        WlyyMedicineKey medicineKey = new WlyyMedicineKey();
        medicineKey.setAccessKey(key);
        medicineKey.setAddTimestamp(System.currentTimeMillis());
        medicineKey.setExpiresIn(Long.valueOf(14400));
        medicineKey.setCreataTime(clock.getCurrentDate());
        wlyyMedicineKeyDao.save(medicineKey);
    }

    public String getKey() throws JSONException {
        String key="";
        List<WlyyMedicineKey> wlyyMedicineKeys = wlyyMedicineKeyDao.findAll();
        if(wlyyMedicineKeys!=null && wlyyMedicineKeys.size()>0){
            for (WlyyMedicineKey wlyyMedicineKey : wlyyMedicineKeys) {
                if ((System.currentTimeMillis() - wlyyMedicineKey.getAddTimestamp()) < (wlyyMedicineKey.getExpiresIn() * 1000)) {
                    return wlyyMedicineKey.getAccessKey();
                } else {
                    wlyyMedicineKeyDao.delete(wlyyMedicineKey);
                }
            }
        }
        String postStr = HttpManageClientUtil.postBody(api + "/yueren/phonekey", new JSONObject());
        JSONObject jsonObject = new JSONObject(postStr);
        String status = jsonObject.get("status").toString();
        if ("200".equals(status)) {
            JSONObject recordset = jsonObject.getJSONObject("recordset");
            key = recordset.getString("key");
            this.saveKey(key);
        }
        return key;
    }

}
