package com.yihu.customer.service.manager.patient;

import com.yihu.customer.util.MD5;
import com.yihu.customer.util.query.BaseJpaService;
import  com.yihu.customer.entity.Patient;
import  com.yihu.customer.entity.SignFamily;
import  com.yihu.customer.entity.SocialSecurityInfo;
import  com.yihu.customer.repository.PatientDao;
import  com.yihu.customer.repository.SignFamilyDao;
import  com.yihu.customer.repository.SocialSecurityInfoDao;
import org.hibernate.Query;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.jdbc.core.BeanPropertyRowMapper;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.util.StringUtils;

import java.util.Date;
import java.util.List;
import java.util.UUID;

/**
 * Created by yww on 2016/10/8.
 */
@Service
public class AdminPatientService extends BaseJpaService<Patient,Long> {
    @Autowired
    private PatientDao patientDao;
    @Autowired
    private SignFamilyDao signFamilyDao;

    @Autowired
    private SocialSecurityInfoDao socialSecurityInfoDao;
    @Autowired
    private JdbcTemplate jdbcTemplate;
    @Autowired
    StringRedisTemplate redisTemplate;

    public Page<Patient> searchPatientList(String name, String idcard, String ssc, String mobile, Integer openIdStatus, String openid, int page, int pageSize) throws Exception{
        /*Patient patient = new Patient();
        patient.setName(name);
        patient.setIdcard(idcard);
        patient.setSsc(ssc);
        patient.setMobile(mobile);
        PageRequest pageRequest = PageRequest.of(page - 1, pageSize);
        String sql = ISqlUtils.getSql(patient,page,pageSize,"*",openIdStatus);
        List<Patient> patients = jdbcTemplate.query(sql,new BeanPropertyRowMapper(Patient.class));
        String sqlcount = new ISqlUtils().getSql(patient,0,0,"count",openIdStatus);
        List<Map<String,Object>> rstotal = jdbcTemplate.queryForList(sqlcount);
        Long count = 0L;
        if(rstotal!=null&&rstotal.size()>0){
            count = (Long) rstotal.get(0).get("total");
        }*/
        if (page <= 0) {
            page = 1;
        }
        if (pageSize <= 0) {
            pageSize = 15;
        }
        // 分页信息
        PageRequest pageRequest = PageRequest.of(page - 1, pageSize);
        //过滤条件
        StringBuffer filters = new StringBuffer();
        if (!StringUtils.isEmpty(idcard)) {
            filters.append(" and p.idcard like :idcard ");
        }
        if (!StringUtils.isEmpty(ssc)) {
            filters.append(" and p.ssc like :ssc ");
        }
        if (!StringUtils.isEmpty(name)) {
            filters.append(" and p.name like :name ");
        }
        if (!StringUtils.isEmpty(mobile)) {
            filters.append("and p.mobile like :mobile ");
        }
        if(openIdStatus != null && openIdStatus== 2){
            filters.append(" and (p.openid = '' or p.openid is null)");
        }
        if(openIdStatus != null && openIdStatus == 3){
            filters.append(" and (p.openid != '' and p.openid is not null) ");
        }
        if(!StringUtils.isEmpty(openid)){
            filters.append(" and p.openid like '%" + openid + "%' ");
        }
        Query queryCount = currentSession().createQuery("select count(1) from Patient p where 1=1 " +filters.toString());
        Query queryList = currentSession().createQuery("select p from Patient p where 1=1  " +filters.toString());
        if (!StringUtils.isEmpty(idcard)) {
            queryCount.setString("idcard","%"+idcard+"%");
            queryList.setString("idcard","%"+idcard+"%");
        }
        if (!StringUtils.isEmpty(ssc)) {
            queryCount.setString("ssc","%"+ssc+"%");
            queryList.setString("ssc", "%"+ssc+"%");        }
        if (!StringUtils.isEmpty(name)) {
            queryCount.setString("name","%"+name+"%");
            queryList.setString("name", "%"+name+"%");
        }
        if (!StringUtils.isEmpty(mobile)) {
            queryCount.setString("mobile","%"+mobile+"%");
            queryList.setString("mobile", "%"+mobile+"%");
        }
        //获取总条数
        int count = ((Number) queryCount.iterate().next()).intValue();
        queryList.setFirstResult(pageSize * (page - 1));
        queryList.setMaxResults(pageSize);
        List<Patient> list = queryList.list();
        return new PageImpl<Patient>(list,pageRequest,count);
//        return new PageImpl<Patient>(patients,pageRequest,count);
    }

    //列表查询-分页
//    public Page<Patient> searchPatientList(String name,String idcard,String ssc,String mobile,Integer openIdStatus,int page,int pageSize) throws Exception{
//        if (page <= 0) {
//            page = 1;
//        }
//        if (pageSize <= 0) {
//            pageSize = 15;
//        }
//        // 分页信息
//        PageRequest pageRequest = PageRequest.of(page - 1, pageSize);
//        //过滤条件
//        String hql = "";
//        StringBuffer filters = new StringBuffer();
//        if (!StringUtils.isEmpty(idcard)) {
//            filters.append("idcard?"+idcard+";");
//        }
//        if (!StringUtils.isEmpty(ssc)) {
//            filters.append("ssc?"+ssc+";");
//        }
//        if (!StringUtils.isEmpty(name)) {
//            filters.append("name?"+name+";");
//        }
//        if (!StringUtils.isEmpty(mobile)) {
//            filters.append("mobile?"+mobile+";");
//        }
//        if(openIdStatus != null && openIdStatus== 2){
//            filters.append("openid!45645646;");
//        }
//        if(openIdStatus != null && openIdStatus == 3){
//            filters.append("openid!45645646;");
//        }
//        List<Patient> list = search("", filters.toString(), "+name", page, pageSize);
//        long count = 0;
//        if(list.size()>0){
//            count = getCount(filters.toString());
//        }
//        return new PageImpl<Patient>(list,pageRequest,count);
//
//    }

    //根据id获取
    public Patient getPatient(Long id){
        Patient patient = patientDao.findById(id).get();
        return patient;
    }

    @Transactional(rollbackFor = Exception.class)
    public String updatePatientBaseInfo2(String id,String name,String idcard,String ssc){
        Patient patient = patientDao.findById(Long.parseLong(id)).get();
        if (null!=patient){
            String oldIdcard= patient.getIdcard();
            if (org.apache.commons.lang3.StringUtils.isNotBlank(oldIdcard)){
                String patientSql = " UPDATE wlyy_patient set ";
                String signInfoSql = " UPDATE wlyy_sign_family set ";
                String breastScreenSql = " UPDATE breast_cervical_screen set ";
                String breastBaseInfoSql = " UPDATE breast_cervical_patient_baseinfo set ";
                String reservationSql = " UPDATE breast_cervical_reservation set ";
                Boolean updateFlag=false;
                if (org.apache.commons.lang3.StringUtils.isNotBlank(name)){
                    patientSql += " name='"+name+"' ";
                    signInfoSql += " name='"+name+"' ";
                    breastScreenSql += " patient_name='"+name+"' ";
                    breastBaseInfoSql += " sick_name='"+name+"' ";
                    reservationSql += " patient_name='"+name+"' ";
                    updateFlag=true;

                }
                if (org.apache.commons.lang3.StringUtils.isNotBlank(idcard)){
                    String splitFlag = " ";
                    if (updateFlag){
                        splitFlag =",";
                    }
                    patientSql += splitFlag+" idcard='"+idcard+"' ";
                    signInfoSql += splitFlag+" idcard='"+idcard+"' ";
                    breastScreenSql +=splitFlag+ " idcard='"+idcard+"' ";
                    breastBaseInfoSql +=splitFlag+ " id_card_no='"+idcard+"' ";
                    reservationSql +=splitFlag+ " idcard='"+idcard+"' ";
                    updateFlag=true;
                }
                if (updateFlag){
                    jdbcTemplate.execute(breastScreenSql+" where idcard='"+oldIdcard+"' ");
                    jdbcTemplate.execute(breastBaseInfoSql+" where id_card_no='"+oldIdcard+"' ");
                }
                if (org.apache.commons.lang3.StringUtils.isNotBlank(ssc)){
                    String splitFlag = " ";
                    if (updateFlag){
                        splitFlag =",";
                    }
                    patientSql += splitFlag+" ssc='"+ssc+"' ";
                    signInfoSql += splitFlag+" ssc='"+ssc+"' ";
                    reservationSql += splitFlag+" ssc='"+ssc+"' ";
                    updateFlag=true;
                }
                if (updateFlag){
                    jdbcTemplate.execute(patientSql+" where idcard='"+oldIdcard+"' ");
                    jdbcTemplate.execute(signInfoSql+" where idcard='"+oldIdcard+"' ");
                    jdbcTemplate.execute(reservationSql+" where idcard='"+oldIdcard+"' ");
                }
            }

        }
        return "success";
    }

    //根据id删除
    public void deletePatient(Long id){
        patientDao.deleteById(id);
    }

    //死亡操作
    /*public void death(Long id) throws Exception{
        Patient patient = patientDao.findById(id).get();
        if(patient!=null)
        {
            patient.setStatus(0);
            patientDao.save(patient);    //居民无效

            //家庭签约转死亡
            SignFamily sign = signFamilyDao.findByIdcard(patient.getIdcard());
            if(sign!=null) {
                sign.setStatus(-3);
                sign.setReleaseSpeak("死亡");
                signFamilyDao.save(sign);
            }

        }
        else{
            throw new Exception("不存在该居民！");
        }

    }*/

    //死亡操作
    public void death(Long id) throws Exception{
        Patient patient = patientDao.findById(id).get();
        if(patient!=null)
        {
            patient.setArchiveStatus(2);
            patient.setOpenid(null);
            patientDao.save(patient);    //同步智业居民状态并清空openid

            //家庭签约转死亡
            SignFamily sign = signFamilyDao.findByIdcard(patient.getIdcard());
            if(sign!=null) {
                sign.setOpenid(null);
                signFamilyDao.save(sign);
            }

        }
        else{
            throw new Exception("不存在该居民！");
        }

    }


    //验证名字+身份证+社保卡是否与sb_info 表里一致
    public SocialSecurityInfo findSocialSecurityInfo(String idcard){
        if(idcard.length() == 18){
           return socialSecurityInfoDao.findBySfzh18Max(idcard);
        }
        if(idcard.length() ==15){
            return socialSecurityInfoDao.findBySfzh15Max(idcard);
        }
        return null;
    }


    //新增
    @Transactional
    public void createPatient(Patient patient){
        patient.setCode(getCode());
        patient.setCzrq(new Date());
        patient.setPoints(0);
        patient.setRecordAmount(0);
        String password=patient.getIdcard().substring(patient.getIdcard().length()-6);
        String salt= UUID.randomUUID().toString().replace("-","");
        patient.setSalt(salt);
        patient.setPassword(MD5.GetMD5Code("a"+password+"*" + salt));
        patient.setPhoto("../../../images/p-female.png");

        patientDao.save(patient);
    }
    //修改
    @Transactional
    public void updatePatient(Patient patient){
        Patient patientNew = patientDao.findById(patient.getId()).get();
        SignFamily signFamily = signFamilyDao.findByIdcard(patient.getIdcard());
        //未修改的字段
        patient.setArchiveStatus(patient.getArchiveStatus());
        patient.setCzrq(new Date());
        patient.setPoints(patientNew.getPoints());
        patient.setRecordAmount(patientNew.getRecordAmount());
        patient.setSalt(patientNew.getSalt());
        patient.setPassword(patientNew.getPassword());
        if(!StringUtils.isEmpty(patientNew.getPhoto())){
            patient.setPhoto(patientNew.getPhoto());
        }else {
            patient.setPhoto("../../../images/p-female.png");
        }
        if(patient.getOpenid().equals("")){
            patient.setOpenid(null);
        }
        //同步更新签约管理居民基本信息
        if(signFamily != null){
            signFamily.setMobile(patient.getMobile());
            signFamily.setOpenid(patient.getOpenid());
            signFamily.setSsc(patient.getSsc());
            signFamilyDao.save(signFamily);
        }
        patientDao.save(patient);
        //删除redis openid
        if (!StringUtils.isEmpty(patient.getSsc()) && redisTemplate.hasKey("settle:" + patient.getSsc())) {
            redisTemplate.delete("settle:" + patient.getSsc());
        }
    }

    //根据手机号查找
    public List<Patient> findByMobile(String mobile){
        return  patientDao.findByMobile(mobile);
    }
    //根据身份证号查找
    public Patient findByIdcard(String idcard){
        return patientDao.findByIdcard(idcard);
    }
    //根据社保卡号查找
    public Patient findBySsc(String ssc){
        return patientDao.findBySsc(ssc);
    }

    /**
     * 通过输入的社保卡号或者身份证字符串查找居民列表
     *
     * @param ssc
     * @param idCard
     * @return
     */
    public List<Patient> findPatientListBySscOrIdCard(String idCard,String ssc) {
        String sql = null;
        if (org.apache.commons.lang3.StringUtils.isNoneBlank(idCard)) {
            sql = "SELECT idcard,name from (SELECT t.idcard,t.name FROM wlyy_patient t WHERE t.idcard LIKE '%"+idCard+"%' ORDER BY t.idcard asc) b LIMIT 0,10";
        } else if(org.apache.commons.lang3.StringUtils.isNoneBlank(ssc)){
            sql = "SELECT * from (SELECT * FROM wlyy_patient t WHERE t.ssc LIKE '%"+ssc+"%' ORDER BY t.ssc asc) b LIMIT 0,10;";
        }
        List<Patient> patientList = jdbcTemplate.query(sql,new BeanPropertyRowMapper(Patient.class));
        return patientList;
    }

    public Patient findByIdcardAndSsc(String idcard,String ssc){
        return patientDao.findByIdcardAndSsc(idcard,ssc);
    }
    //修改状态
    @Transactional
    public boolean updataStatus(Integer status, Long patientId){
        int sum = patientDao.updateStatus(status, patientId);
        return sum>0?true:false;
    }

    //初始密码
    @Transactional
    public boolean initPassword(Long id, String idCard){
        String password=idCard.substring(idCard.length() - 6);
        String salt= UUID.randomUUID().toString().replace("-","");
        password = MD5.GetMD5Code("a"+password+"*"+salt);
        int sum = patientDao.initPassword(password,salt,id);
        return sum>0?true:false;
    }

    //判断手机号唯一性
    public String isMobileExist(String mobile){
        int num = patientDao.isMobileExist(mobile);
        return num >0 ?"true":"false";

    }
    //判断身份证号唯一性
    public String isIdCardExist(String idcard){
        int num = patientDao.isIdCardExist(idcard);
        return num >0 ?"true":"false";    }
    //判断社保卡号唯一性
    public String  isSscExist(String ssc){
        int num = patientDao.isSscExist(ssc);
        return num >0 ?"true":"false";    }



}
