package com.yihu.customer.service.manager.sign;

import com.yihu.customer.service.BaseService;
import  com.yihu.customer.entity.SignFamily;
import  com.yihu.customer.entity.SignFamilyServer;
import  com.yihu.customer.repository.SignFamilyDao;
import  com.yihu.customer.repository.SignFamilyServerDao;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;

/**
 * 家庭签约业务处理类
 *
 * @author George
 */
@Component
@Transactional
public class FamilyContractService extends BaseService {

    @Autowired
    private SignFamilyDao signFamilyDao;
    @Autowired
    private SignFamilyServerDao signFamilyServerDao;
    /**
     * 查询居民的所有签约
     *
     * @param patient
     * @return
     */
    public List<SignFamily> findAllSignByPatient(String patient) {
        return signFamilyDao.findAllSignByPatient(patient);
    }

    /**
     * 查询当前生效的签约
     * @param patient
     * @return
     */
    public SignFamily findSignByPatient(String patient){
        return signFamilyDao.findSignByPatient(patient);
    }


    /**
     * 查询已签约,已缴费的签约信息
     * 若没有已缴费的--->>返回已签约的最新一条信息,否则返回null
     *
     * @param patient
     * @return
     */
    public SignFamily findSignInfo(String patient){
        SignFamily signFamily = findSignByPatient(patient);
        if(signFamily==null){
            List<SignFamily> signFamilies = signFamilyDao.findSignInfo(patient);
            if(signFamilies!=null && signFamilies.size()>0){
                signFamily = signFamilies.get(0);
            }
        }
        List<SignFamilyServer> servers = new ArrayList<>();
        if (signFamily!=null){
            servers = signFamilyServerDao.findBySignCode(signFamily.getCode());

        }
        StringBuffer buffer = new StringBuffer();
        if (servers!=null&&servers.size()!=0){
            for (SignFamilyServer signFamilyServer:servers){
                buffer.append(signFamilyServer.getServerTypeName()+",");
            }
            buffer.deleteCharAt(buffer.length()-1);
        }
        System.out.println(buffer);
        if (buffer!=null&&signFamily!=null){
            signFamily.setServerTypeName(buffer.toString());
        }
        return signFamily;
    }
}