package com.yihu.customer.service.manager.survey;

import com.yihu.customer.service.common.excel.ExcelData;
import com.yihu.customer.util.query.BaseJpaService;
import  com.yihu.customer.entity.survey.QuestionnairePrize;
import  com.yihu.customer.entity.survey.QuestionnaireWinning;
import  com.yihu.customer.repository.survey.QuestionnairePrizeDao;
import com.yihu.customer.util.ReadExcelUtil;
import com.yihu.customer.util.RivaEDCode;
import jxl.Sheet;
import jxl.Workbook;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.jdbc.core.BeanPropertyRowMapper;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * Created by yww on 2016/12/13.
 */
@Service
public class QuestionnaireService extends BaseJpaService {
    @Autowired
    private JdbcTemplate jdbcTemplate;
    @Autowired
    private QuestionnairePrizeDao prizeDao;
    //双层对称加密使用到的KEY
    @Value("${Riva.RIVAED_KEY1}")
    private String key1;//key1值
    @Value("${Riva.RIVAED_KEY2}")
    private String key2;//key2值

    public List<QuestionnaireWinning> searchList(Integer type,String name,String idCard,Integer page,Integer pageSize) throws Exception{
        if(page <= 0){
            page = 1;
        }
        if(pageSize <= 0){
            pageSize = 15;
        }
    String sql = "SELECT " +
            " w.`code`, " +
            " w.user_code," +
            " CONCAT(LEFT (w.user_idcard,6),'**********',RIGHT (w.user_idcard,2)) user_idcard, " +
            " w.user_name, " +
            " CONCAT(LEFT (w.user_openid,6),'**********',RIGHT (w.user_openid,2)) user_openid, " +
            " w.prize_type, " +
            " w.prize_code, "+
            " w.winning, " +
            " w.del, " +
            " w.create_time, " +
            " w.update_time, " +
            " w.validity, " +
            " w.address " +
            " FROM wlyy_questionnaire_winning w WHERE w.winning = 1 and w.del = 0  " +
            " and w.prize_type = " + type;
        if (StringUtils.isNotEmpty(name) && StringUtils.isNotEmpty(idCard)){
            sql += " and w.user_name = '" + name + "' and w.user_idcard = " + idCard;
        }else if (StringUtils.isEmpty(name) && StringUtils.isNotEmpty(idCard)){
            sql += " and w.user_idcard = " + idCard;
        }else if (StringUtils.isNotEmpty(name) && StringUtils.isEmpty(idCard)){
            sql += " and w.user_name = '" + name +"' ";
        }
        sql += " order by w.update_time desc limit " + (page-1)*pageSize +"," +pageSize;
        List<QuestionnaireWinning> userPrizeVOList = jdbcTemplate.query(sql,new BeanPropertyRowMapper(QuestionnaireWinning.class));
        return userPrizeVOList;
    }

    public List<QuestionnaireWinning> searchListCount(Integer type, String name, String idCard) throws Exception{

        String sql = "SELECT " +
                " w.`code`, " +
                " w.user_code," +
                " w.user_idcard, " +
                " w.user_name, " +
                " w.user_openid, " +
                " w.prize_type, " +
                " w.prize_code, "+
                " w.winning, " +
                " w.del, " +
                " w.create_time, " +
                " w.update_time, " +
                " w.validity, " +
                " w.address " +
                " FROM wlyy_questionnaire_winning w WHERE w.winning = 1 and w.del = 0  " +
                "and w.prize_type = " + type;
        if (StringUtils.isNotEmpty(name) && StringUtils.isNotEmpty(idCard)){
            sql += " and w.user_name = '" + name + "' and w.user_idcard = " + idCard;
        }else if (StringUtils.isEmpty(name) && StringUtils.isNotEmpty(idCard)){
            sql += " and w.user_idcard = " + idCard;
        }else if (StringUtils.isNotEmpty(name) && StringUtils.isEmpty(idCard)){
            sql += " and w.user_name = '" + name +"' ";
        }
        sql += " order by w.update_time desc ";
        List<QuestionnaireWinning> userPrizeVOList = jdbcTemplate.query(sql,new BeanPropertyRowMapper(QuestionnaireWinning.class));
        return userPrizeVOList;
    }

    /**
     *  导入奖品信息Excel表格
     * @param workbook
     * @return
     * @throws ParseException
     */
    public boolean importData(Workbook workbook) throws ParseException {
        Sheet[] sheets = workbook.getSheets();
        Sheet sheet = sheets[0];
        int rows = ReadExcelUtil.getRightRows(sheet);

        List<QuestionnairePrize> prizeList = new ArrayList<>();
        for (int row = 1; row < rows; row++) {  //索引从0开始，第一行为标题
            //读取单行数据并取单元格数据保存到实体类部分字段中（单元格从0开始）
            QuestionnairePrize prize = new QuestionnairePrize();
            //映射实体类部分字段
            Map<Integer, ExcelData> mappingPrize = mappingQuestionnairePrize(prize);
            int finalRow = row;
            mappingPrize.forEach((index, excelData) -> {
                String value = sheet.getCell(index, finalRow).getContents().trim();
                excelData.transform(value);
            });

            //判断导入的奖品资源是否存在,不存在则保存
            QuestionnairePrize existPrize = prizeDao.findByPrizeType(prize.getType(),prize.getPrizeCode(),prize.getPrizePsw());
            if(existPrize == null){
                //                需要从表格取值
                prize.setCode(getCode());
                prize.setUsed(0);
                prize.setDel(0);
                prize.setCreateTime(new Date());
                prize.setUpdateTime(new Date());
                prizeList.add(prize);
            }
        }
        prizeDao.saveAll(prizeList);
        return true;
    }

    /**
     * //映射实体类部分字段
     * @param prize 奖品资源
     * @return
     */
    private Map<Integer, ExcelData> mappingQuestionnairePrize(QuestionnairePrize prize) {
        Map<Integer, ExcelData> dataMap = new HashMap<>();

        //奖品名称
        dataMap.put(0, new ExcelData() {
            @Override
            public void transform(String data) {
                prize.setPrizeName(data);
            }
        });

        //奖品类型(不能为空)
        dataMap.put(1, new ExcelData() {
            @Override
            public void transform(String data) {
                //加密
                Integer type = Integer.valueOf(data);
                prize.setType(type);

            }
        });

        //兑奖码（不能为空）
        dataMap.put(2, new ExcelData() {
            @Override
            public void transform(String data) {
                //加密
                String prizeCode = RivaEDCode.passEncode(key1,key2,data);
                prize.setPrizeCode(prizeCode);

            }
        });

        //兑奖密码（不能为空）
        dataMap.put(3, new ExcelData() {
            @Override
            public void transform(String data) {
                //加密
                String prizePsw = RivaEDCode.passEncode(key1,key2,data);
                prize.setPrizePsw(prizePsw);

            }
        });

        //有效期
        dataMap.put(4, new ExcelData() {
            @Override
            public void transform(String data) {
                try {
                    if (StringUtils.isNotEmpty(data)){
                        SimpleDateFormat format = new SimpleDateFormat("yyyy/MM/dd HH:mm");
                        Date validity = format.parse(data);
                        prize.setValidity(validity);
                    }else {
                        prize.setValidity(null);
                    }
                } catch (ParseException e) {
                    e.printStackTrace();
                }
            }
        });

        //领取地址
        dataMap.put(5, new ExcelData() {
            @Override
            public void transform(String data) {
                prize.setAddress(data);
            }
        });
        return dataMap;
    }
}
