package com.yihu.customer.service.manager.survey;

import com.yihu.customer.util.query.BaseJpaService;
import  com.yihu.customer.entity.survey.SurveyAdvice;
import  com.yihu.customer.entity.survey.SurveyTemplateAdvice;
import  com.yihu.customer.repository.survey.SurveyAdviceDao;
import com.yihu.customer.util.ClazzReflect;
import org.json.JSONException;
import org.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * 问卷调查指导建议表
 * Created by hmf on 2018/7/5.
 */
@Service
public class SurveyAdviceService extends BaseJpaService<SurveyAdvice,Long> {

    @Autowired
    private SurveyAdviceDao surveyAdviceDao;
    public SurveyAdvice saveOrUpdate(String jsonData) throws JSONException {
        JSONObject jsonObject = new JSONObject(jsonData);
        ClazzReflect clazzReflect = new ClazzReflect();
        SurveyAdvice surveyAdvice = new SurveyAdvice();
        surveyAdvice.setCode(getCode());
        surveyAdvice.setCzrq(new Date());
        clazzReflect.formatToClazz(surveyAdvice,jsonObject);
        surveyAdviceDao.save(surveyAdvice);
        return surveyAdvice;
    }

    public SurveyAdvice findById(Long id){
        return  surveyAdviceDao.findById(id).get();
    }

    public List<SurveyAdvice> findAdvice(Integer diseaseType, String templateCode) {
        return surveyAdviceDao.findAdvice(diseaseType, templateCode);
    }

    public List<SurveyAdvice> findByCode(List<SurveyTemplateAdvice> templateAdviceList) {
        List<SurveyAdvice> surveyAdviceList = new ArrayList<>();
        for(SurveyTemplateAdvice templateAdvice : templateAdviceList){
            SurveyAdvice surveyAdvice = new SurveyAdvice();
            surveyAdvice = surveyAdviceDao.findByCode(templateAdvice.getAdviceCode());
            surveyAdviceList.add(surveyAdvice);
        }
        return surveyAdviceList;
    }

    public List<SurveyAdvice> findAdviceByTemplateCode(String templateCode) {
        return surveyAdviceDao.findAdviceByTemplateCode(templateCode);
    }
}
