package com.yihu.customer.service.manager.survey;

import com.yihu.customer.util.query.BaseJpaService;
import  com.yihu.customer.entity.survey.SurveyTemplateAdvice;
import  com.yihu.customer.repository.survey.SurveyTemplateAdviceDao;
import com.yihu.customer.util.ClazzReflect;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * 问卷调查建议关联表
 * Created by hmf on 2018/7/5.
 */
@Service
public class SurveyTemplateAdviceService extends BaseJpaService<SurveyTemplateAdvice,Long> {
    @Autowired
    private SurveyTemplateAdviceDao templateAdviceDao;

    public void saveOrUpdate(String jsonData, String templateCode) throws JSONException {
        JSONArray array = new JSONArray(jsonData);
        List<SurveyTemplateAdvice> templateAdviceList = new ArrayList<>();
        templateAdviceDao.deleteByTemplateCode(templateCode);
        for(int i=0;i<array.length()-1;i++) {
            JSONObject jsonObject = array.getJSONObject(i);
            ClazzReflect clazzReflect = new ClazzReflect();
            SurveyTemplateAdvice templateAdvice = new SurveyTemplateAdvice();
            templateAdvice.setCzrq(new Date());
            clazzReflect.formatToClazz(templateAdvice,jsonObject);
            templateAdviceList.add(templateAdvice);
        }
        templateAdviceDao.saveAll(templateAdviceList);
    }

    public SurveyTemplateAdvice findById(Long id){
        return  templateAdviceDao.findById(id).get();
    }

    public List<SurveyTemplateAdvice> findByTemplateCode(String templateCode) {
        return templateAdviceDao.findByTemplateCode(templateCode);
    }

}
