package com.yihu.customer.service.manager.survey;

import com.yihu.customer.util.query.BaseJpaService;
import  com.yihu.customer.entity.survey.SurveyTemplateOption;
import  com.yihu.customer.repository.survey.SurveyTemplateOptionDao;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 问卷调查模板选项表
 * Created by ysj on 2017/3/3.
 */
@Service
public class SurveyTemplateOptionService extends BaseJpaService<SurveyTemplateOption,Long> {
    @Autowired
    SurveyTemplateOptionDao surveyTemplateOptionDao;

    public void deleteByTemplateCode(String templateCode,Boolean del){
        if(del){
             surveyTemplateOptionDao.deleteByTemplateCode(templateCode);
        }else{
            surveyTemplateOptionDao.updateDelByTemplateCode(templateCode);
        }
    }

    /**
     * 根据问题code获取选项表有效的集合
     * @param templateCode
     * @return
     */
    public List<SurveyTemplateOption> findByTemplateCodeAndDelAndQuestionCode(String templateCode,String questionCode){
        return surveyTemplateOptionDao.findByTemplateCodeAndDelAndQuestionCode(templateCode,"1",questionCode);
    }


    public void save(List<SurveyTemplateOption> surveyTemplateOptions){
         surveyTemplateOptionDao.saveAll(surveyTemplateOptions);
    }

    public SurveyTemplateOption save(SurveyTemplateOption surveyTemplateOptions){
        return  surveyTemplateOptionDao.save(surveyTemplateOptions);
    }

}
