package com.yihu.customer.service.manager.survey;

import com.yihu.customer.util.query.BaseJpaService;
import  com.yihu.customer.entity.survey.SurveyTemplateQuestions;
import  com.yihu.customer.repository.survey.SurveyTemplateQuestionsDao;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 问卷调查模板题目表
 * Created by ysj on 2017/3/3.
 */
@Service
public class SurveyTemplateQuestionService extends BaseJpaService<SurveyTemplateQuestions,Long> {
    @Autowired
    SurveyTemplateQuestionsDao surveyTemplateQuestionDao;

    /**
     * 根据模板code删除数据
     * @param templateCode
     */
    public void deleteByTemplateCode(String templateCode,Boolean del){
        if(del){
            surveyTemplateQuestionDao.deleteByTemplateCode(templateCode);
        }else{
            surveyTemplateQuestionDao.updateDelByTemplateCode(templateCode);
        }

    }

    /**
     * 根据模板CODE获取数据
     * @param templateCode
     * @return
     */
    public List<SurveyTemplateQuestions> findByTemplateCode(String templateCode){
        return surveyTemplateQuestionDao.findByTemplateCodeAndDel(templateCode,"1");
    }

    public void save(List<SurveyTemplateQuestions> surveyTemplateQuestions){
        surveyTemplateQuestionDao.saveAll(surveyTemplateQuestions);
    }

    public SurveyTemplateQuestions save(SurveyTemplateQuestions surveyTemplateQuestions){
       return surveyTemplateQuestionDao.save(surveyTemplateQuestions);
    }

    public SurveyTemplateQuestions findByCode(String code){
        return  surveyTemplateQuestionDao.findByCode(code);
    }
}
