package com.yihu.customer.service.manager.survey;

import com.yihu.customer.util.query.BaseJpaService;
import  com.yihu.customer.entity.survey.SurveyTemplateResult;
import  com.yihu.customer.repository.survey.SurveyTemplateResultDao;
import com.yihu.customer.util.ClazzReflect;
import org.apache.commons.lang3.StringUtils;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * 问卷调查模板评分筛查表
 * Created by hmf on 2018/7/5.
 */
@Service
public class SurveyTemplateResultService extends BaseJpaService<SurveyTemplateResult,Long> {
    @Autowired
    private SurveyTemplateResultDao resultDao;

    public void saveOrUpdate(String jsonData, String templateCode, String loginUserId) throws JSONException {
        JSONArray array = new JSONArray(jsonData);
        List<SurveyTemplateResult> resultList = new ArrayList<>();
        resultDao.deleteByTemplateCode(templateCode);
        for(int i=0;i<array.length()-1;i++) {
            JSONObject jsonObject = array.getJSONObject(i);
            ClazzReflect clazzReflect = new ClazzReflect();
            SurveyTemplateResult result = new SurveyTemplateResult();
            if(!jsonObject.isNull("id")&&StringUtils.isNotBlank(jsonObject.getString("id"))){
                result = this.findById(jsonObject.getLong("id"));
                if(result.getDel() == 0){
                    result.setDel(1);
                }
            }else {
                result.setCode(getCode());
                result.setCreateUserName(loginUserId + "");
                result.setCreateTime(new Date());
                result.setDel(1);
            }
            result.setUpdateTime(new Date());
            if(jsonObject.getString("highScore").equals("null")){
                jsonObject.remove("highScore");
            }
            clazzReflect.formatToClazz(result,jsonObject);
            resultList.add(result);
        }
        resultDao.saveAll(resultList);
    }

    public SurveyTemplateResult findById(Long id){
        return  resultDao.findById(id).get();
    }

    public List<SurveyTemplateResult> findByTemplateCode(String templateCode) {
        return resultDao.findByTemplateCode(templateCode);
    }
}
