package com.yihu.customer.service.manager.team;

import  com.yihu.customer.entity.Doctor;
import  com.yihu.customer.entity.WlyyAdminTeamMember;
import  com.yihu.customer.repository.DoctorDao;
import  com.yihu.customer.repository.WlyyAdminTeamMemberDao;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * Created by yww on 2016/11/15.
 */
@Service
public class ManageWlyyAdminTeamMemberService {
    @Autowired
    private WlyyAdminTeamMemberDao teamMemberDao;

    @Autowired
    private DoctorDao doctorDao;

    //团队列表
    public List<WlyyAdminTeamMember> searchTeamMembers(Long teamId, String doctorCode){
        List<WlyyAdminTeamMember> teamMembers = teamMemberDao.findByTeamId(teamId);
        if(teamMembers != null && teamMembers.size()>0){
            for(WlyyAdminTeamMember member:teamMembers){
                Doctor doctor = doctorDao.findByCode(member.getDoctorCode());
                if(doctor == null){ continue;}
                member.setDoctorName(doctor.getName());
                member.setJobName(doctor.getJobName());
                member.setMobile(doctor.getMobile());
                if(doctor.getLevel()==null){
                    doctor.setLevel(0);
                }
                Integer level = doctor.getLevel();
                member.setLevel(level);
                member.setLevelName(level==1?"专科医生":(level == 2?"全科医生":(level == 3)?"健康管理师":""));
            }
        }
        return teamMembers;
//        return teamMemberDao.findByTeamIdAndDoctorCode(teamId,doctorCode);
    }

    //获取团队列表用于下拉框（分全部、全科医生、健管师）
    public List<Doctor> searchTeamMemberCodes(Long teamId, Integer[] doctorLevel){
        List<WlyyAdminTeamMember> teamMembers = teamMemberDao.findByTeamId(teamId);
        List<Doctor> doctorList = new ArrayList<>();
        if(teamMembers != null && teamMembers.size()>0){
            String[] doctorCodes = new String[teamMembers.size()];
            for(int i= 0;i<teamMembers.size();i++){
                doctorCodes[i] = teamMembers.get(i).getDoctorCode();
            }
            doctorList = doctorDao.findByCodesAndLevel(doctorCodes, doctorLevel);
        }
        return doctorList;
    }
}
