package com.yihu.customer.service.manager.team;

 
 
import com.yihu.customer.service.common.excel.ExcelData;
import  com.yihu.customer.entity.*;
import  com.yihu.customer.repository.*;

import com.yihu.customer.util.ReadExcelUtil;
import jxl.Sheet;
import jxl.Workbook;
import org.apache.commons.lang3.StringUtils;
import org.hibernate.Query;
import org.hibernate.Session;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.PageRequest;
import org.springframework.jdbc.core.BeanPropertyRowMapper;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import java.util.*;

/**
 * Created by yww on 2016/11/15.
 */
@Service
@Transactional
public class ManageWlyyAdminTeamService {
    //分页查询（单表）
//    @PersistenceContext
    @PersistenceContext(
            name = "entityManager"
    )
    protected EntityManager entityManager;
    @Autowired
    private WlyyAdminTeamDao teamDao;
    @Autowired
    private WlyyAdminTeamMemberDao teamMemberDao;
    @Autowired
    private HospitalDao hospitalDao;
    @Autowired
    private ManageWlyyAdminTeamMemberService teamMemberService;
    @Autowired
    private SpecialDiseaseDao specialDiseaseDao;
    @Autowired
    private JdbcTemplate jdbcTemplate;


    //------医生团队信息查询开始------
//    public List<WlyyAdminTeam> searchTeamByDoctorCode(String doctorCode){
//        WlyyAdminTeamMember teamMember = teamMemberDao.findByDoctorCode(doctorCode);
//        WlyyAdminTeam team = teamDao.findOne(teamMember.getTeamId());
//        List<WlyyAdminTeam> teamList = new ArrayList<>();
//        if(team == null){
//            return teamList;
//        }
//        team = searchOrgName(team);
//        teamList.add(team);
//        return teamList;
//    }
    @Autowired
    private DoctorDao doctorDao;

    /**
     * @param orgName
     * @param teamName
     * @param leaderName
     * @param memberName
     * @param memberMobile
     * @param teamType     0 全部 1专科  2家庭
     * @param page
     * @param pageSize
     * @return
     * @throws Exception
     */
    public Page<WlyyAdminTeam> searchTeams(String orgName, String teamName, String leaderName, String memberName, String memberMobile, Integer teamType, Integer page, Integer pageSize) throws Exception {
        if (page == null) {
            page = 1;
        }
        if (pageSize == null) {
            pageSize = 15;
        }
        PageRequest pageRequest = PageRequest.of(page - 1, pageSize);
        StringBuilder builder = new StringBuilder();
        builder.append("from WlyyAdminTeam as t,Hospital as h,Doctor as d where t.orgCode = h.code and t.leaderCode = d.code ");

        if (!StringUtils.isEmpty(orgName) && !StringUtils.isEmpty(leaderName)) {
            builder.append(" and h.name like :orgName and d.name like :doctorName ");
        }
        if (!StringUtils.isEmpty(orgName) && StringUtils.isEmpty(leaderName)) {
            builder.append(" and h.name like :orgName ");
        }
        if (StringUtils.isEmpty(orgName) && !StringUtils.isEmpty(leaderName)) {
            builder.append("and d.name like :doctorName ");
        }
//        if (StringUtils.isEmpty(orgName) && StringUtils.isEmpty(leaderName)) {
//            builder.append(" where 1=1 ");
//        }
        if (teamType != 0) {
            builder.append(" and  h.level= " + teamType);
        }
        //根据团队成员名搜索团队
        Long[] teamIds = null;
        if (!StringUtils.isEmpty(memberName) || !StringUtils.isEmpty(memberMobile)) {
            if (memberName == null) {
                memberName = "";
            }
            if (memberMobile == null) {
                memberMobile = "";
            }
            teamIds = teamMemberDao.findByMemberNameAndMobileLike("%" + memberName + "%", "%" + memberMobile + "%");
        }
        if (teamIds != null) {
            builder.append(" and t.id in :teamIds");

        }
        if (!StringUtils.isEmpty(teamName)) {
            builder.append(" and t.name like :teamName ");
        }
        String hql = "select t " + builder.toString();
        String hqlCount = "select count(1) " + builder.toString();
        Query queryCount = currentSession().createQuery(hqlCount);
        Query query = currentSession().createQuery(hql);
        if (!StringUtils.isEmpty(orgName)) {
            query.setString("orgName", "%" + orgName + "%");
            queryCount.setString("orgName", "%" + orgName + "%");
        }
        if (teamIds != null) {
            query.setParameterList("teamIds", teamIds);
            queryCount.setParameterList("teamIds", teamIds);
        }
        if (!StringUtils.isEmpty(teamName)) {
            query.setString("teamName", "%" + teamName + "%");
            queryCount.setString("teamName", "%" + teamName + "%");
        }
        if (!StringUtils.isEmpty(leaderName)) {
            query.setString("doctorName", "%" + leaderName + "%");
            queryCount.setString("doctorName", "%" + leaderName + "%");
        }
        //获取总条数
        int count = ((Number) queryCount.iterate().next()).intValue();
        query.setFirstResult(pageSize * (page - 1));
        query.setMaxResults(pageSize);
        List<WlyyAdminTeam> list = query.list();
        return new PageImpl<WlyyAdminTeam>(list, pageRequest, count);

    }


    //查询机构名称
    public WlyyAdminTeam searchOrgName(WlyyAdminTeam adminTeam) {
        if (adminTeam != null) {
            Hospital hospital = hospitalDao.findByCode(adminTeam.getOrgCode());
            if (hospital != null) {
                adminTeam.setOrgName(hospital.getName());
            }
            Doctor doctor = doctorDao.findByCode(adminTeam.getLeaderCode());
            if (hospital != null) {
                adminTeam.setLeaderName(doctor.getName());
            }
        }
        return adminTeam;
    }

    public List<WlyyAdminTeam> getByOrgCode(String orgCode) {
        return teamDao.findByOrgCode(orgCode);
    }

    public List<WlyyAdminTeam> getByOrgCode(String orgCode,String town) {
        String sql = " select te.* from wlyy_admin_team te inner JOIN dm_hospital dh on te.org_code = dh.`code` " +
                "and dh.`level`=2 and dh.del=1 and te.available=1 and dh.center_site='00'   ";
        if (StringUtils.isNotBlank(town)){
            sql += " and dh.town='"+town+"' ";
        }
        if (StringUtils.isNotBlank(orgCode)){
            sql += " and dh.code='"+orgCode+"' ";
        }
        List<WlyyAdminTeam> teams = jdbcTemplate.query(sql,new BeanPropertyRowMapper(WlyyAdminTeam.class));
        return teams;
    }

    public List<WlyyAdminTeam> getTeamsByDoctor(String doctor) {
        List<WlyyAdminTeamMember> teamMembers = teamMemberDao.findByDoctorCode(doctor);
        List<WlyyAdminTeam> wlyyAdminTeams = new ArrayList<>();
        for (WlyyAdminTeamMember wlyyAdminTeamMember : teamMembers) {
            WlyyAdminTeam wlyyAdminTeam = teamDao.findById(wlyyAdminTeamMember.getTeamId()).get();
            wlyyAdminTeams.add(wlyyAdminTeam);
        }
        return wlyyAdminTeams;
    }

    //更新状态
    @Transactional
    public boolean updateStatus(String available, Long id) {
        int i = teamDao.updateAvailable(available, id);
        return i > 0;

    }


    //团队信息
    public WlyyAdminTeam findById(Long id) {
        WlyyAdminTeam team = teamDao.findById(id).get();//id查询team
        if (team != null) {
            team = searchOrgName(team);//获取机构名称
            Doctor doctor = doctorDao.findByCode(team.getLeaderCode());
            team.setLeaderName(doctor == null ? "" : doctor.getName());//团队长
            List<WlyyAdminTeamMember> teamMembers = teamMemberService.searchTeamMembers(id, "");//团队成员 未过滤
            for (WlyyAdminTeamMember member : teamMembers) {//显示为作废成员
                if ("1".equals(member.getAvailable())) {
                    team.getMemberList().add(member);
                }
            }
            //专病列表
            List<SpecialDisease> specialDiseasesList = specialDiseaseDao.findDisByDel("1");
            team.setSpecialDiseasesList(specialDiseasesList);
        }
        return team;
    }


    //----居民团队信息查询开始------------
    //根据居民姓名、编码查询
    public WlyyAdminTeam getSignTeamInfo(Long id) {
        WlyyAdminTeam team = teamDao.findById(id).get();
        if (team != null) {
            //获取团队成员集合
            team = searchOrgName(team);
            team.setLeaderName(doctorDao.findByCode(team.getLeaderCode()).getName());
            List<WlyyAdminTeamMember> teamMemberList = teamMemberDao.findByTeamId(id);
            if (teamMemberList != null && teamMemberList.size() > 0) {
                for (WlyyAdminTeamMember member : teamMemberList) {
                    Doctor doctor = doctorDao.findByCode(member.getDoctorCode());
                    if (doctor != null) {
                        member.setJobName(doctor.getJobName());
                        member.setMobile(doctor.getMobile());
                    }
                }
            }
            team.setMemberList(teamMemberList);
        }
        return team;
    }

    public boolean importData(Workbook workbook) {
        Sheet[] sheets = workbook.getSheets();
        Sheet sheet = sheets[0];
        int rows = ReadExcelUtil.getRightRows(sheet);
        Map<String, WlyyAdminTeam> teamList = new HashMap<>();
//        List<WlyyAdminTeamMember> teamMemberList = new ArrayList<>();
        for (int row = 1; row < rows; row++) {  //索引从0开始，第一行为标题
            WlyyAdminTeam team = new WlyyAdminTeam();
            Map<Integer, ExcelData> teamMap = mappingTeam(team);
            int finalRow = row;
            teamMap.forEach(((index, excelData) -> {
                String value = sheet.getCell(index, finalRow).getContents().trim();
                excelData.transform(value);
            }));
            if (teamList.get(team.getName()) == null) {
                //判断team是否已经存在
                String orgCode = team.getOrgCode();
                String name = team.getName();
                WlyyAdminTeam team2 = teamDao.findByNameAndOrgCode(name, orgCode);
                if (team2 != null) {
                    team = team2;
                } else {
                    team = teamDao.save(team);
                }
                teamList.put(team.getName(), team);
            } else {
                team = teamList.get(team.getName());
            }
            WlyyAdminTeamMember teamMember = new WlyyAdminTeamMember();
            Map<Integer, ExcelData> teamMemberMap = mappingTeamMember(teamMember, team);
            teamMemberMap.forEach(((index, excelData) -> {
                String value = sheet.getCell(index, finalRow).getContents().trim();
                excelData.transform(value);
            }));
            teamMemberDao.save(teamMember);
            if (teamMember.isTeamLeader()) {
                team.setLeaderCode(teamMember.getDoctorCode());
                teamDao.save(team);
            }
        }

        return true;
    }

    protected Session currentSession() {
        return entityManager.unwrap(Session.class);
    }

    private Map<Integer, ExcelData> mappingTeam(WlyyAdminTeam team) {
        Map<Integer, ExcelData> mapping = new HashMap<>();


        //医生身份证号
        mapping.put(2, new ExcelData() {
            @Override
            public void transform(String data) {
                Doctor doctor = doctorDao.findByIdCard(data);
                if (doctor != null) {
                    team.setLeaderCode(doctor.getCode());
                }
            }
        });

        //机构名称
        mapping.put(8, new ExcelData() {
            @Override
            public void transform(String data) {
                Hospital hospital = hospitalDao.findByName(data);
                if (hospital != null) {
                    team.setOrgCode(hospital.getCode());
                }
            }
        });

        //团队名称
        mapping.put(13, new ExcelData() {
            @Override
            public void transform(String data) {
                team.setName(data);
            }
        });

        team.setCreateTime(new Date());
        team.setLastModified(new Date());
        team.setAvailable("1");

        return mapping;
    }

    private Map<Integer, ExcelData> mappingTeamMember(WlyyAdminTeamMember teamMember, WlyyAdminTeam team) {
        Map<Integer, ExcelData> mapping = new HashMap<>();

        //医生身份证号
        mapping.put(2, new ExcelData() {
            @Override
            public void transform(String data) {
                Doctor doctor = doctorDao.findByIdCard(data);
                if (doctor != null) {
                    teamMember.setDoctorCode(doctor.getCode());
                }
            }
        });

        //团队长
        mapping.put(14, new ExcelData() {
            @Override
            public void transform(String data) {
                if (data.equals("是")) {
                    teamMember.setTeamLeader(true);
                } else {
                    teamMember.setTeamLeader(false);
                }
            }
        });

        teamMember.setTeamId(team.getId());
        teamMember.setJoinTime(new Date());
        teamMember.setLastModified(new Date());
        teamMember.setAvailable("1");
        //TODO:

        return mapping;
    }

    //修改团队信息
    public Boolean updateTeamAcceptInfor(Long teamId, String leaderCode, String specialCode, String specialName, Integer acceptType) {
        WlyyAdminTeam team = teamDao.findById(teamId).get();//id查询team
        if (team != null) {
            team.setLeaderCode(leaderCode);
            team.setSpecialCode(specialCode);
            team.setSpecialName(specialName);
            team.setAcceptType(acceptType);
        }
        if (acceptType == 1) {//接受状态为拒绝
            teamDao.updateTeamAcceptInfor(leaderCode, specialCode, specialName, acceptType, teamId);
            return true;
        } else {
            WlyyAdminTeam team1 = teamDao.findByDisAndAcceptTypeAndOrgCode(team.getSpecialCode(), 0, team.getOrgCode(), teamId);
            if (team1 != null && acceptType == 0) {//已存在团队
                teamDao.updateTeamAcceptInfor(leaderCode, specialCode, specialName, 1, teamId);
                return false;
            }
            if (team1 == null) {
                teamDao.updateTeamAcceptInfor(leaderCode, specialCode, specialName, acceptType, teamId);
                return true;
            }
        }
        return false;
    }

}
