package com.yihu.customer.service.manager.user;

import  com.yihu.customer.entity.ManageRoleUser;
import  com.yihu.customer.entity.User;
import  com.yihu.customer.repository.ManageRoleUserDao;
import  com.yihu.customer.repository.UserDao;
import com.yihu.customer.util.query.BaseJpaService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.PageRequest;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * Created by yww on 2016/12/28.
 */
@Service
public class ManageRoleUserService extends BaseJpaService<ManageRoleUser, ManageRoleUserDao> {
    @Autowired
    private UserDao userDao;

    @Autowired
    private ManageRoleUserDao roleUserDao;

    @Transactional
    public boolean create(String userCode, long id) {
        ManageRoleUser roleUser = new ManageRoleUser();
        roleUser.setUserCode(userCode);
        roleUser.setRoleId(id);
        roleUserDao.save(roleUser);
        return true;
    }

    @Transactional
    public boolean delete(String userCode, long id) {
        int count = roleUserDao.deleteByUserCodeAndRoleId(userCode, id);
        return count > 0 ? true : false;
    }

    public Page<ManageRoleUser> searchRoleUser(String roleId, int page, int pageSize) throws Exception {
        String filters = "roleId=" + roleId + ";";
        if (page <= 0) {
            page = 1;
        }
        if (pageSize <= 0) {
            pageSize = 15;
        }
        PageRequest pageRequest = PageRequest.of(page - 1, pageSize);
        List<ManageRoleUser> list = search("", filters, "+userCode", page, pageSize);
        long total = 0;
        if (list.size() > 0) {
            total = getCount(filters);
            for (ManageRoleUser roleUser : list) {
                User user = userDao.findByCode(roleUser.getUserCode());
                roleUser.setUserName(user == null ? "" : user.getName());
            }
        }
        return new PageImpl<ManageRoleUser>(list, pageRequest, total);
    }

//    public Page<ManageRoleUser> getRoleUserList(String sorts, int page, int size) {
//        Pageable pageable = PageRequest.of(page, size, parseSorts(sorts));
//        return roleUserDao.findAll(pageable);
//    }

    //根据用户code角色roleId查找（是否存在）
    public ManageRoleUser findRelation(String userCode, long roleId) {
        return roleUserDao.findRelation(userCode, roleId);
    }

    //判断角色组是否有配置人员
    public boolean isRoleExistUser(long roleId) {
        int bo = roleUserDao.isRoleExistUser(roleId);
        return bo > 0 ? true : false;

    }


//    public boolean batchDeleteRoleUserRelation(String userCode,String roleIds) throws Exception{
//        List<ManageRoleUser> roleUsers = this.search("userCode=" + userCode + ",roleId=" + roleIds);
//        for(ManageRoleUser roleUser : roleUsers){
//            delete(roleUser.getId());
//        }
//        return true;
//    }

//    public boolean batchCreateRoleUsersRelation(String userCode,String roleIds){
//        for(String roleId : roleIds.split(",")){
//            ManageRoleUser roleUser = new ManageRoleUser();
//            roleUser.setUserCode(userCode);
//            roleUser.setRoleId(Long.parseLong(roleId));
//            save(roleUser);
//        }
//        return true;
//    }

//    public boolean batchUpdateRoleUsersRelation(String userCode,String roleIds) throws Exception {
//        List<ManageRoleUser> roleUsers = search("userCode=" + userCode + ";roleId<>" + roleIds);
//        for (ManageRoleUser roleUser : roleUsers) {
//            delete(roleUser.getId());
//        }
//        List<ManageRoleUser> roleUserList = search("userCode=" + userCode + ";roleId=" + roleIds);
//        List<Long> ids = new ArrayList<>();
//        for (int i = 0; i < roleUserList.size(); i++) {
//            ids.add(roleUserList.get(i).getRoleId());
//        }
//        for (String roleId : roleIds.split(",")) {
//            if (ids.contains(Long.parseLong(roleId))) {
//                continue;
//            }
//            ManageRoleUser roleUser = new ManageRoleUser();
//            roleUser.setUserCode(userCode);
//            roleUser.setRoleId(Long.parseLong(roleId));
//            save(roleUser);
//        }
//        return true;
//    }

}
