package com.yihu.customer.service.messager;


import  com.yihu.customer.entity.consult.WlyyConsultTeamExportVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.BeanPropertyRowMapper;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;

import javax.transaction.Transactional;
import java.util.ArrayList;
import java.util.List;

@Service
@Transactional
public class MessagerServer {

    @Autowired
    private JdbcTemplate jdbcTemplate;

    /**
     * 咨询未及时回复数据
     *
     * @param hospital
     * @return
     */
    public List<WlyyConsultTeamExportVO> exportReplyDelayList(String startDate, String endDate, String team, String area, String hospital, String range, Integer page, Integer size) {
        List<WlyyConsultTeamExportVO> list = new ArrayList<>();
        String sql = "SELECT " +
                "c.symptoms," +
                "c.name," +
                "t.create_time," +
                "t.reply_time," +
                "m.content," +
                "m.content_type," +
                "a.`name` as team_name," +
                "f.doctor_name," +
                "f.doctor_health_name, " +
                "f.mobile " +
                " FROM wlyy_consult_team c, im.topics t, wlyy_admin_team a, wlyy_sign_family f, im.muc_messages m,wlyy_doctor d " +
                "WHERE c.admin_team_code = a.id AND c.type=2 " +
                "and c.consult = t.id and (TIMESTAMPDIFF(HOUR,t.create_time,t.reply_time)>=24 )  and f.patient = c.patient and f.`status`>0 " +
                "and t.reply_message_id=m.id and f.doctor=d.code";


        if ("team".equals(range)) {
            sql = sql.replace("c.admin_team_code = a.id", "c.admin_team_code = a.id and a.id = '" + team + "' ");
        } else if ("hospital".equals(range)) {
            sql = sql.replace("c.admin_team_code = a.id", "c.admin_team_code = a.id and a.org_code = '" + hospital + "' ");
        } else {
            sql = sql.replace("c.admin_team_code = a.id", "c.admin_team_code = a.id and a.org_code like '%" + area + "%' ");
        }
        if (org.apache.commons.lang3.StringUtils.isNotBlank(startDate)) {
            sql = sql.replace("c.admin_team_code = a.id", "c.admin_team_code = a.id and t.create_time >= '" + startDate + "' and t.create_time <= '" + endDate + "'");
        }
        if (size > 0) {
            sql += " ORDER BY t.create_time DESC limit " + (page - 1) * size + "," + size + " ";
        }
        list = jdbcTemplate.query(sql, new BeanPropertyRowMapper(WlyyConsultTeamExportVO.class));
        return list;
    }
}
