package com.yihu.customer.service.pneumonia;

import com.yihu.customer.service.BaseService;
import  com.yihu.customer.entity.pneumonia.PneumoniaAttackArea;
import  com.yihu.customer.repository.pneumonia.PneumoniaAttackAreaDao;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.PageRequest;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.Date;
import java.util.List;

/**
 * Created by Bing on 2021/9/22.
 */
@Service
public class PneumoniaAttackAreaService extends BaseService {
    @Autowired
    private PneumoniaAttackAreaDao pneumoniaAttackAreaDao;

    public Page<PneumoniaAttackArea> areaList(Integer page, Integer rows){
        page=page>0?page-1:0;
        rows = rows<0?0:rows;
        PageRequest pageRequest = PageRequest.of(page , rows);
        List<PneumoniaAttackArea> list = pneumoniaAttackAreaDao.findByDel(1,pageRequest);
        Integer count = pneumoniaAttackAreaDao.findCountByDel(1);
        return new PageImpl(list, pageRequest, count);
    }

    @Transactional
    public boolean areaUpdateDel(Integer del, Long Id) {
        int sum = pneumoniaAttackAreaDao.updateDelById(Id,del);
        return sum > 0 ? true : false;
    }

    public PneumoniaAttackArea areaFindOne(Long id){
        return pneumoniaAttackAreaDao.findById(id).get();
    }

    public PneumoniaAttackArea areaModify(PneumoniaAttackArea tmp){
        if (0==tmp.getId()){
            //新增
            tmp.setId(null);
            tmp.setCode(getCode());
            tmp.setDel(1);
        }
        tmp.setPublishTime(new Date());
        tmp.setCreateTime(new Date());
        pneumoniaAttackAreaDao.save(tmp);
        return tmp;
    }
}
