package com.yihu.customer.service.pneumonia;

import com.yihu.customer.service.BaseService;
import  com.yihu.customer.entity.pneumonia.PneumoniaAttackAddress;
import  com.yihu.customer.entity.pneumonia.PneumoniaDataNew;
import  com.yihu.customer.repository.pneumonia.PneumoniaAttackAddressDao;
import  com.yihu.customer.repository.pneumonia.PneumoniaDataDao;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.PageRequest;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.Date;
import java.util.List;

/**
 * Created by Bing on 2021/8/2.
 */
@Service
public class PneumoniaService extends BaseService {

    @Autowired
    private PneumoniaAttackAddressDao addressDao;
    @Autowired
    private PneumoniaDataDao dataDao;



    public Page<PneumoniaAttackAddress> addressList(Integer page,Integer rows){
        page=page>0?page-1:0;
        rows = rows<0?0:rows;
        PageRequest pageRequest = PageRequest.of(page , rows);
        List<PneumoniaAttackAddress> list = addressDao.findByDel(1,pageRequest);
        Integer count = addressDao.findCountByDel(1);
        return new PageImpl(list, pageRequest, count);
    }

    public PneumoniaAttackAddress addressModify(PneumoniaAttackAddress tmp){
        if (0==tmp.getId()){
            //新增
            tmp.setId(null);
            tmp.setCode(getCode());
            tmp.setDel(1);
        }
        tmp.setPublishTime(new Date());
        tmp.setCreateTime(new Date());
        addressDao.save(tmp);
        return tmp;
    }

    @Transactional
    public boolean addressUpdateDel(Integer del, Long Id) {
        int sum = addressDao.updateDelById(Id,del);
        return sum > 0 ? true : false;
    }

    public PneumoniaAttackAddress addressFindOne(Long id){
        return addressDao.findById(id).get();
    }

    public PneumoniaDataNew dataInfo(){

        List<PneumoniaDataNew> list = (List<PneumoniaDataNew>) dataDao.findAll();
        if (0==list.size()){
            return new PneumoniaDataNew();
        }
        return list.get(0);
    }

    public void updateDataInfo(PneumoniaDataNew tmp){
        if (tmp==null){

        }else {
            tmp.setUpdateTime(new Date());
            dataDao.save(tmp);
        }
    }
}
