package com.yihu.customer.service.refinement;


import com.yihu.customer.service.BaseService;
import  com.yihu.customer.entity.refinement.RefinementConsultCategory;
import  com.yihu.customer.repository.refinement.RefinementConsultCategoryDao;
import org.apache.commons.lang3.StringUtils;
import org.json.JSONException;
import org.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.PageRequest;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;

/**
 * Created by zhangdan on 2019/02/20.
 */
@Service
@Transactional
public class RefinementService extends BaseService {

    @Autowired
    private JdbcTemplate jdbcTemplate;
    @Autowired
    private RefinementConsultCategoryDao refinementConsultCategoryDao;

    public JSONObject getRefinnementList(String title, String doctorName, String firstLevelCategoryId, String secondLevelCategoryId, Integer scopeOfApplication, Integer page, Integer pageSize) throws JSONException {
        List<Map<String,Object>> list = new ArrayList<>();
        JSONObject jsonObject = new JSONObject();
        String sql ="SELECT" +
                " c.`code`," +
                " c.consult_code," +
                " c.consult_title," +
                " c.consult_symptoms," +
                " c.first_level_category_code," +
                " c.first_level_category_name," +
                " c.second_level_category_name," +
                " c.second_level_category_code," +
                " c.doctor," +
                " c.doctor_name," +
                " d.hospital_name," +
                " d.hospital," +
                " c.apply_time" +
                " FROM" +
                " wlyy_refinement_consult c" +
                " LEFT JOIN wlyy_doctor d ON c.doctor = d.`code`" +
                " WHERE" +
                " c.del = 1 and c.is_authentication=1 and c.is_free=1" ;

        String countSql ="SELECT" +
                " count(1)" +
                " FROM" +
                "  wlyy_refinement_consult c" +
                " LEFT JOIN wlyy_doctor d ON c.doctor = d.`code`" +
                " WHERE" +
                " c.del = 1 and c.is_authentication=1 and c.is_free=1" ;


        if (page == null) {
            page = 1;
        }
        if (pageSize == null) {
            pageSize = 15;
        }
        PageRequest pageRequest = PageRequest.of(page - 1, pageSize);
        StringBuilder filters = new StringBuilder();
        if (StringUtils.isNotEmpty(title)){
            filters.append(" AND c.consult_symptoms LIKE '%"+title+"%'");
        }
        if (StringUtils.isNotEmpty(doctorName)){
            filters.append(" AND c.doctor_name LIKE '%"+doctorName+"%'");
        }
        if (StringUtils.isNotEmpty(firstLevelCategoryId)){
            filters.append(" AND c.first_level_category_code = '"+firstLevelCategoryId+"'");
        }
        if (StringUtils.isNotEmpty(secondLevelCategoryId)){
            filters.append(" AND c.second_level_category_code = '"+secondLevelCategoryId+"'");
        }
        if (scopeOfApplication!=null){
            filters.append(" AND c.use_scope = "+scopeOfApplication);
        }
        list = jdbcTemplate.queryForList(sql+filters.toString() + " order by c.apply_time desc" + " limit " + (page - 1) * pageSize + "," + pageSize);
        jsonObject.put("data",list);
        if (list.size() <= 0) {
            jsonObject.put("count",0);
            jsonObject.put("totalPage", 0);
        }else {
            Long count = jdbcTemplate.queryForObject(countSql + filters.toString(), Long.class);
            jsonObject.put("count",count);
            jsonObject.put("totalPage", count % pageSize > 0 ? (count / pageSize) + 1 : (count / pageSize));
        }
        return jsonObject;
    }

    public Map<String,Object> findCategory(String code,Integer isChild){
        Map<String,Object> map = new HashMap<>();
        RefinementConsultCategory refinementConsultCategory = refinementConsultCategoryDao.findByCodeAndStauts(code,1);
        List<RefinementConsultCategory> secondList = new ArrayList<>();
        if (isChild==1){
            secondList = refinementConsultCategoryDao.findByParentCodeAndStauts(code,1);
        }
        map.put("mainCategory",refinementConsultCategory);
        map.put("childCategory",secondList);
        return map;
    }
}
