package com.yihu.customer.service.statistic;

import  com.yihu.customer.repository.DoorServiceOrderDao;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.PageRequest;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

@Service
public class DoorService {
    @Autowired
    private DoorServiceOrderDao doorServiceOrderDao;
    @Autowired
    private JdbcTemplate jdbcTemplate;

    public Page searchList(String number, String town, String hospital,String name, String idcard,String startDate, String endDate, String type, Integer page, Integer pageSize) {
        String sql = "SELECT o.id,o.number,o.patient,o.patient_name patientName,o.`status`,o.remark,o.hospital,h.name hospitalName, p.idcard,p.mobile,GROUP_CONCAT(DISTINCT v.type_value) typeValue,GROUP_CONCAT(DISTINCT d.doctor_name) doctorName from wlyy_door_service_order o  " +
                "LEFT JOIN wlyy_door_service_voucher v on o.patient = v.patient_code and v.`status`=1  " +
                "LEFT JOIN wlyy_door_doctor d on o.id = d.order_id  LEFT JOIN dm_hospital h on o.hospital = h.code and h.del = 1 " +
                "LEFT JOIN wlyy_patient p on o.patient = p.`code` and p.`status`=1 where o.status != -1 ";
        if(StringUtils.isNotBlank(number)){
            sql +="and o.number = '" + number +"' ";
        }
        if (StringUtils.isNotBlank(name)){
            sql += " and o.patient_name like '%"+name+"%' ";
        }
        if (StringUtils.isNotBlank(idcard)){
            sql += " and p.idcard like '%"+idcard+"%' ";
        }
        if (StringUtils.isNotBlank(hospital)) {
            sql += "and o.hospital = '" + hospital + "' ";
        } else if (StringUtils.isNotBlank(town)) {
            sql += "and o.hospital like '" + town + "%' ";
        }
        if (StringUtils.isNotBlank(startDate)) {
            sql += "and o.create_time>'" + startDate + "' ";
        }
        if (StringUtils.isNotBlank(endDate)) {
            sql += "and o.create_time<'" + endDate + " 59:59:59' ";
        }
        if (StringUtils.isNotBlank(type)) {
            sql += "and v.type = '" + type + "' ";
        }
        sql += " GROUP BY o.id order by o.create_time desc ";
        int count = jdbcTemplate.queryForList(sql).size();
        sql += " limit " + (page - 1) * pageSize + ", " + pageSize;
        List<Map<String, Object>> list = jdbcTemplate.queryForList(sql);
        for(Map<String, Object> map : list ){
            String patient = map.get("patient")+"";
            Integer times = this.countPatientDoorTimes(patient);
            map.put("count", times);
        }
        PageRequest pageRequest = PageRequest.of(page - 1, pageSize);
        return new PageImpl(list, pageRequest, count);
    }

    public void deleteById(String id) {
        doorServiceOrderDao.deleteById(id);
    }

    /**
     * 统计居民已经服务的次数
     * @param patient
     * @return
     */
    public Integer countPatientDoorTimes(String patient){
        Integer count = 0;
        String sql = "SELECT count(d.id) as count FROM wlyy_door_service_order o, wlyy_door_doctor d  where o.id = d.order_id and o.patient = '" + patient + "'";
        count = jdbcTemplate.queryForObject(sql,Integer.class);
        return count;
    }

    public List<Map<String,Object>> exportList(String town, String hospital,String name,String idcard,String startDate, String endDate, String type) {
        String sql = "SELECT o.id,o.number,o.patient,o.patient_name patientName,o.`status`,o.remark,o.hospital,h.name hospitalName,p.idcard,p.mobile,GROUP_CONCAT(DISTINCT v.type_value) typeValue,GROUP_CONCAT(DISTINCT d.doctor_name) doctorName from wlyy_door_service_order o  " +
                "LEFT JOIN wlyy_door_service_voucher v on o.patient = v.patient_code and v.`status`=1  " +
                "LEFT JOIN wlyy_door_doctor d on o.id = d.order_id LEFT JOIN dm_hospital h on o.hospital = h.code and h.del = 1 " +
                "LEFT JOIN wlyy_patient p on o.patient = p.`code` and p.`status`=1 where o.status != -1 ";

        if (StringUtils.isNotBlank(hospital)) {
            sql += "and o.hospital = '" + hospital + "' ";
        } else if (StringUtils.isNotBlank(town)) {
            sql += "and o.hospital like '" + town + "%' ";
        }
        if (StringUtils.isNotBlank(name)){
            sql += " and o.patient_name like '%"+name+"%' ";
        }
        if (StringUtils.isNotBlank(idcard)){
            sql += " and p.idcard like '%"+idcard+"%' ";
        }
        if (StringUtils.isNotBlank(startDate)) {
            sql += "and o.create_time>'" + startDate + "' ";
        }
        if (StringUtils.isNotBlank(endDate)) {
            sql += "and o.create_time<'" + endDate + " 59:59:59' ";
        }
        if (StringUtils.isNotBlank(type)) {
            sql += "and v.type = '" + type + "' ";
        }
        sql += " GROUP BY o.id order by o.create_time desc ";
        List<Map<String, Object>> list = jdbcTemplate.queryForList(sql);
        for(Map<String, Object> map : list ){
            String patient = map.get("patient")+"";
            Integer times = this.countPatientDoorTimes(patient);
            map.put("count", times);
        }
        return list;
    }
}
