package com.yihu.customer.service.statistic;

import com.yihu.customer.util.TransforSqlUtl;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.PageRequest;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Map;

@Service
public class RehabilitationPatientService {

    @Autowired
    private JdbcTemplate jdbcTemplate;

    public Page searchList(String id, String town, String hospital, String startDate, String endDate, String disease, Integer isManage, Integer page, Integer pageSize) {
        String sql = "SELECT distinct p.id,p.patient,p.name,p.disease,p.disease_name diseaseName,p.`status`,p.create_user specialist,p.create_user_name specialistName,DATE_FORMAT(p.create_time,'%Y-%m-%d') createTime," +
                "d.hospital sHospital,d.hospital_name sHospitalName,r.is_manage isManage,f.idcard,f.doctor,f.doctor_name doctorName,f.hospital,f.hospital_name hospitalName,IF(pd.id is null,0,1) served  " +
                "FROM wlyy_specialist.`wlyy_patient_rehabilitation_plan` p  JOIN wlyy_specialist.wlyy_specialist_patient_relation r on p.patient=r.patient and p.team_code = r.team_code and r.`status`>0 and r.sign_status=1  " +
                "LEFT JOIN wlyy_sign_family f on p.patient = f.patient and f.`status`= 1 and f.expenses_status=1 and f.hospital != 'ac02a9b87a3611e69f7c005056850d66' LEFT JOIN wlyy_doctor d on p.create_user = d.`code` and d.del=1 " +
                "LEFT JOIN wlyy_specialist.wlyy_rehabilitation_plan_detail pd on p.id = pd.plan_id and pd.`status`=1 "+
                "where p.`status` != 0 and d.hospital<>'ac02a9b87a3611e69f7c005056850d66' ";
        if (StringUtils.isNotBlank(id)) {
            sql += "and p.id='" + id + "' ";
        } else {
            if (StringUtils.isNotBlank(hospital)) {
                sql += "and f.hospital = '" + hospital + "' ";
            } else if (StringUtils.isNotBlank(town)) {
                sql += "and f.hospital like '" + town + "%' ";
            }
            if (StringUtils.isNotBlank(startDate)) {
                sql += "and p.create_time>'" + startDate + "' ";
            }
            if (StringUtils.isNotBlank(endDate)) {
                sql += "and p.create_time<'" + endDate + " 59:59:59' ";
            }
            if (StringUtils.isNotBlank(disease)) {
                sql += "and p.disease in (" + disease + " ) ";
            }
            if (isManage != null) {
                if(isManage ==  1) {
                    sql += " and r.is_manage = " + isManage;
                }else {
                    sql += " and (r.is_manage = " + isManage + " or r.is_manage is null) ";
                }
            }
        }
        int count = jdbcTemplate.queryForList(sql).size();
        sql += " ORDER BY p.create_time desc limit " + (page - 1) * pageSize + ", " + pageSize;
        sql = TransforSqlUtl.wlyy_patient_rehabilitation_planName(sql);
        sql = TransforSqlUtl.wlyy_patient_rehabilitation_planCreateName2(sql);
        List<Map<String, Object>> list = jdbcTemplate.queryForList(sql);
        PageRequest pageRequest = PageRequest.of(page - 1, pageSize);
        return new PageImpl(list, pageRequest, count);
    }

    public List<Map<String, Object>> exportList(String town, String hospital, String startDate, String endDate, String disease, Integer isManage) {
        String sql = "SELECT distinct p.id,p.patient,p.name,p.disease,p.disease_name diseaseName,p.`status`,p.create_user specialist,p.create_user_name specialistName,DATE_FORMAT(p.create_time,'%Y-%m-%d') createTime," +
                "d.hospital sHospital,d.hospital_name sHospitalName,r.is_manage isManage,f.idcard,f.doctor,f.doctor_name doctorName,f.hospital,f.hospital_name hospitalName,IF(pd.id is null,0,1) served  " +
                "FROM wlyy_specialist.`wlyy_patient_rehabilitation_plan` p  JOIN wlyy_specialist.wlyy_specialist_patient_relation r on p.patient=r.patient and p.team_code = r.team_code and r.`status`>0 and r.sign_status=1  " +
                "LEFT JOIN wlyy_sign_family f on p.patient = f.patient and f.`status`= 1 and f.expenses_status=1 and f.hospital != 'ac02a9b87a3611e69f7c005056850d66' LEFT JOIN wlyy_doctor d on p.create_user = d.`code` and d.del=1 " +
                "LEFT JOIN wlyy_specialist.wlyy_rehabilitation_plan_detail pd on p.id = pd.plan_id and pd.`status`=1 "+
                "where p.`status` != 0 and d.hospital<>'ac02a9b87a3611e69f7c005056850d66' ";
        if (StringUtils.isNotBlank(hospital)) {
            sql += "and f.hospital = '" + hospital + "' ";
        } else if (StringUtils.isNotBlank(town)) {
            sql += "and f.hospital like '" + town + "%' ";
        }
        if (StringUtils.isNotBlank(startDate)) {
            sql += "and p.create_time>'" + startDate + "' ";
        }
        if (StringUtils.isNotBlank(endDate)) {
            sql += "and p.create_time<'" + endDate + " 59:59:59' ";
        }
        if (StringUtils.isNotBlank(disease)) {
            sql += "and p.disease='" + disease + "' ";
        }
        if (isManage != null) {
            if(isManage ==  1) {
                sql += " and r.is_manage = " + isManage;
            }else {
                sql += " and (r.is_manage = " + isManage + " or r.is_manage is null) ";
            }
        }
        sql += " ORDER BY p.create_time desc  ";
        sql = TransforSqlUtl.wlyy_patient_rehabilitation_planName(sql);
        sql = TransforSqlUtl.wlyy_patient_rehabilitation_planCreateName(sql);
        List<Map<String, Object>> list = jdbcTemplate.queryForList(sql);
        return list;
    }
}
