package com.yihu.customer.service.synergy;

import com.fasterxml.jackson.databind.ObjectMapper;
import com.yihu.customer.util.query.BaseJpaService;
import  com.yihu.customer.entity.synergy.KnowledgeArticleDO;
import  com.yihu.customer.entity.synergy.KnowledgeCategoryDO;
import  com.yihu.customer.repository.synergy.KnowledgeArticleDao;
import  com.yihu.customer.repository.synergy.KnowledgeCategoryDao;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.net.URLDecoder;
import java.util.Date;
import java.util.List;
import java.util.UUID;

/**
 * Created by wxw on 2018/12/26.
 *
 * @author wxw.
 */
@Service
@Transactional
public class KnowledgeCategoryService extends BaseJpaService<KnowledgeCategoryDO, KnowledgeCategoryDao> {
    @Autowired
    private KnowledgeCategoryDao knowledgeCategoryDao;
    @Autowired
    private ObjectMapper objectMapper;
    @Autowired
    private KnowledgeArticleDao articleDao;

    /**
     * 新增、修改分类
     * @param json
     * @return
     * @throws Exception
     */
    public KnowledgeCategoryDO saveCategory(String json) throws Exception {
        json = URLDecoder.decode(json,"utf-8");
        KnowledgeCategoryDO knowledgeCategoryDO = objectMapper.readValue(json, KnowledgeCategoryDO.class);
        if (null == knowledgeCategoryDO.getPid()) {
            knowledgeCategoryDO.setPid(0l);
        }
        if (null == knowledgeCategoryDO.getId()) {
            // 新增
            knowledgeCategoryDO.setCode(UUID.randomUUID().toString().replace("-", ""));
            knowledgeCategoryDO.setCzrq(new Date());
            knowledgeCategoryDO.setDel(1);
        } else {
            KnowledgeCategoryDO one = knowledgeCategoryDao.findById(knowledgeCategoryDO.getId()).get();
            knowledgeCategoryDO.setId(one.getId());
            knowledgeCategoryDO.setCode(one.getCode());
            knowledgeCategoryDO.setCzrq(one.getCzrq());
            knowledgeCategoryDO.setDel(one.getDel());
            knowledgeCategoryDO.setUpdateTime(new Date());
        }
        return knowledgeCategoryDao.save(knowledgeCategoryDO);
    }

    public Boolean hasExistCode(String code) {
        KnowledgeCategoryDO byCode = knowledgeCategoryDao.findByCode(code);
        if (null != byCode) {
            return true;
        }
        return false;
    }

    public Boolean updateDel(String code) {
        List<KnowledgeArticleDO> byCategory = articleDao.findByCategory(code);
        if (null != byCategory && byCategory.size() > 0) {
            return false;
        }
        knowledgeCategoryDao.updateDel(code);
        return true;
    }

    public KnowledgeCategoryDO queryByCode(String code) {
        return knowledgeCategoryDao.findByCode(code);
    }
}
