package com.yihu.customer.service.synergy;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.yihu.customer.util.HttpManageClientUtil;
import com.yihu.customer.util.query.BaseJpaService;
import  com.yihu.customer.entity.survey.SurveyQuestionResult;
import  com.yihu.customer.entity.survey.SurveyQuestionnaire;
import  com.yihu.customer.entity.survey.SurveyQuestionnaireOptions;
import  com.yihu.customer.entity.synergy.ManageSynergyWorkorderDO;
import  com.yihu.customer.entity.synergy.ManageSynergyWorkorderServicerDO;
import  com.yihu.customer.repository.survey.SurveyQuestionResultDao;
import  com.yihu.customer.repository.survey.SurveyQuestionnaireDao;
import  com.yihu.customer.repository.survey.SurveyQuestionnaireOptionsDao;
import  com.yihu.customer.repository.synergy.ManageSynergyWorkOrderDao;
import  com.yihu.customer.repository.synergy.ManageSynergyWorkorderServicerDao;
import org.apache.commons.collections.map.HashedMap;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;

/**
 * Created by humingfen on 2018/09/27.
 */
@Service
@Transactional
public class QuestionnaireManageService extends BaseJpaService {

    @Value("${wlyy.url}")
    private String wlyyUrl;
    @Autowired
    private HttpManageClientUtil httpManageClientUtil;
    @Autowired
    private JdbcTemplate jdbcTemplate;
    @Autowired
    private ManageSynergyWorkOrderDao workOrderDao;
    @Autowired
    private ManageSynergyWorkorderServicerDao workorderServicerDao;
    @Autowired
    private SurveyQuestionnaireDao surveyQuestionnaireDao;
    @Autowired
    private SurveyQuestionnaireOptionsDao surveyQuestionnaireOptionsDao;
    @Autowired
    private SurveyQuestionResultDao questionResultDao;
    @Autowired
    private SynergyManageService synergyManageService;


    /**
     * 创建协同服务
     * @param workorderDO
     * @param workorderServicerDOS
     * @return
     */
    public boolean createWorkOrder(ManageSynergyWorkorderDO workorderDO, List<ManageSynergyWorkorderServicerDO> workorderServicerDOS) {
        String servicer = "";
        int size = workorderServicerDOS.size();
        int len = 0;
        if(size > 3){
            len = 3;
        }else {
            len = size;
        }
        //获取服务对象最多五个人
        for(int i = 0; i < len; i++){
            servicer += workorderServicerDOS.get(i).getServicePatientName() + ",";
        }
        servicer = servicer.substring(0, servicer.length()-1);
        //保存协同服务工单
        workorderDO.setCode(synergyManageService.getWorkorderNo());
        workorderDO.setStatus(1);
        workorderDO.setCreateTime(new Date());
        workorderDO.setDel(1);
        workorderDO.setServicerCount(size);
        workorderDO.setServicerKey(servicer);
        workOrderDao.save(workorderDO);

        //保存协同服务工单的服务对象
        List<ManageSynergyWorkorderServicerDO> list = new ArrayList<>();
        for(ManageSynergyWorkorderServicerDO servicerDO : workorderServicerDOS){
            servicerDO.setCode(getCode());
            servicerDO.setWorkorderType(workorderDO.getType());
            servicerDO.setWorkorderCode(workorderDO.getCode());
            servicerDO.setStatus(1);
            servicerDO.setCreateTime(new Date());
            list.add(servicerDO);
        }
        workorderServicerDao.saveAll(list);
        return true;
    }

    /**
     * 保存问卷结果
     * @param patientCode
     * @param labelType
     * @param customerCode
     * @param source
     * @param jsonData
     * @param serviceCode
     */
    public String saveResultAndAnswer(String patientCode, Integer labelType, String customerCode, Integer source, String jsonData, String serviceCode) throws Exception {
        String url = wlyyUrl + "third/synergy/questionnaire/saveResultAndAnswer";
        //查找发放问卷的医生
        String sql = "SELECT w.create_user, s.relation_code from manage_synergy_workorder_servicer s, manage_synergy_workorder w " +
                "where s.workorder_code = w.`code` and s.`code`= '" + serviceCode + "'";
        Map<String, Object> map = jdbcTemplate.queryForList(sql).get(0);
        String doctor = (String) map.get("create_user");
        String resultCode = (String) map.get("relation_code");
        String response = "";
        Map<String, Object> params = new HashMap<>();
        params.put("labelType", labelType);
        params.put("patientCode", patientCode);
        params.put("jsonData", jsonData);
        params.put("customerCode", customerCode);
        params.put("source", source);
        params.put("isAgain", 0);
        params.put("doctor", doctor);
        if(StringUtils.isNotBlank(resultCode)) {
            params.put("resultCode", resultCode);
        }
        try {
            response = httpManageClientUtil.post(url, params);
        } catch (Exception e) {
            e.printStackTrace();
        }
        JSONObject object = JSONObject.parseObject(response);
        if(object.getInteger("status") == 200) {
            String questionResultCode = object.getString("data");
            workorderServicerDao.updateRelationCodeByCode(serviceCode, questionResultCode);
            return questionResultCode;
        }
        throw new Exception("保存失败");
    }

    /**
     * 查看调查问卷统计结果
     * @param surveyCode
     * @return
     */
    public JSONObject getAnswers(String surveyCode) throws Exception {
        String url = wlyyUrl + "third/synergy/questionnaire/getAnswers?id=" + surveyCode;
        String  response = httpManageClientUtil.get(url, "UTF-8");
        JSONObject jsonObject = JSONObject.parseObject(response);
        if(jsonObject.getInteger("status") == 200){
            return JSONObject.parseObject(jsonObject.getString("data"));
        }
        throw new Exception("请求失败");
    }

    /**
     * 根据问卷结果code查看居民填写问卷详情
     * @param code
     * @return
     */
    public JSONObject getReuslt(String code){
        JSONObject json = new JSONObject();
        //查找问卷结果信息
        SurveyQuestionResult questionResult = questionResultDao.findByCode(code);
        String patient = questionResult.getPatientCode();
        String surverCode = questionResult.getSurveyCode();
        //获取单选、多选问题
        List<SurveyQuestionnaire> questionList = surveyQuestionnaireDao.findBySurveyCode(surverCode);
        //查找单选、多选选项和答案
        Map<String, Object> answerMap = new HashMap<>();
        String sql = "SELECT soa.*, sqo.content FROM wlyy_survey_option_answers soa LEFT JOIN wlyy_survey_questionnaire_options sqo ON soa.options_code= sqo.code AND soa.survey_code = sqo.survey_code AND sqo.del=1 WHERE soa.screen_result_code = ? AND soa.patient=? AND soa.survey_code=?";
        List<Map<String, Object>> optionAnswersList = jdbcTemplate.queryForList(sql, new Object[]{code, patient, surverCode});
        for (SurveyQuestionnaire question : questionList) {
            List<Map<String, Object>> optionList = new ArrayList<>();
            Map<String, Object> map = new HashMap<>();
            map.put("question", question);
            String qusCode = question.getCode();
            for (Map<String, Object> option : optionAnswersList) {
                if (option.get("question_code").equals(qusCode)) {
                    optionList.add(option);
                }
            }
            map.put("option", optionList);
            answerMap.put(question.getSort() + "", map);
        }
        //获取问答题列表
        List<SurveyQuestionnaire> essayQuestionList = surveyQuestionnaireDao.findEssayQuestionBySurveyCode(surverCode);
        String s = "SELECT a.*, q.title " +
                "FROM wlyy_survey_answers a  " +
                "LEFT JOIN wlyy_survey_questionnaire q ON a.question_code= q.code AND a.survey_code = q.survey_code AND q.del=1 AND q.question_type = 2 " +
                "WHERE a.question_result_code = ? AND a.patient= ? AND a.survey_code= ?";
        List<Map<String, Object>> questionAnswersList = jdbcTemplate.queryForList(s, new Object[]{code, patient, surverCode});
        for (SurveyQuestionnaire essayQuestion : essayQuestionList) {
            List<Map<String, Object>> list = new ArrayList<>();
            Map<String, Object> map = new HashMap<>();
            map.put("question", essayQuestion);
            String qusCode = essayQuestion.getCode();
            for (Map<String, Object> question : questionAnswersList) {
                if (question.get("question_code").equals(qusCode)) {
                    list.add(question);
                }
            }
            map.put("option", list);
            answerMap.put(essayQuestion.getSort() + "", map);
        }
        json.put("answer", answerMap);
        return json;
    }

    public JSONObject getQuestionnaireDetail(String surveyCode) throws Exception {
        String url = wlyyUrl + "third/synergy/questionnaire/getQuestionnaireDetail?id=" + surveyCode;
        String response = httpManageClientUtil.get(url, "UTF-8");
        JSONObject jsonObject = JSONObject.parseObject(response);
        if(jsonObject.getInteger("status") == 200){
            return JSONObject.parseObject(jsonObject.getString("data"));
        }
        throw new Exception("请求失败");
    }

    public JSONObject getOptionsComment(String surveyCode, String questionCode, String optionCode, int pageNo, int pageSize) throws Exception {
        String url = wlyyUrl + "third/synergy/questionnaire/getOptionsComment?id=" + surveyCode +"&questionId=" + questionCode + "&optionId=" +
                optionCode + "&pageNo=" + pageNo + "&pageSize=" + pageSize;
        String  response = httpManageClientUtil.get(url, "UTF-8");
        JSONObject jsonObject = JSONObject.parseObject(response);
        if(jsonObject.getInteger("status") == 200){
            return JSONObject.parseObject(jsonObject.getString("data"));
        }
        throw new Exception("请求失败");
    }




    public Map<String, Object> getQuestionOption(String code){
        Map<String,Object> object = new HashedMap();
        List<SurveyQuestionnaire> questionnaireList = surveyQuestionnaireDao.findAllBySurveyCode(code);
        JSONArray array = new JSONArray();
        for (SurveyQuestionnaire surveyQuestionnaire:questionnaireList){
            List<SurveyQuestionnaireOptions> options = surveyQuestionnaireOptionsDao.findByIdAndQstCode(code,surveyQuestionnaire.getCode());
            JSONObject jsonObject = new JSONObject();
            jsonObject.put("code",surveyQuestionnaire.getCode());
            jsonObject.put("type",surveyQuestionnaire.getQuestionType());//问题类型（0单选 1多选 2问答）
            JSONArray jsonArray = new JSONArray();
            StringBuffer buffer = new StringBuffer();
            buffer.append("(");
            for (SurveyQuestionnaireOptions questionnaireOptions:options){
                JSONObject object1 = new JSONObject();
                object1.put("code",questionnaireOptions.getCode());//选项编码
                object1.put("title",questionnaireOptions.getContent());//选项内容
                object1.put("sort",questionnaireOptions.getSort());//选项排序
                buffer.append(questionnaireOptions.getSort()+"、"+questionnaireOptions.getContent()+",");
                jsonArray.add(object1);
            }
            buffer.deleteCharAt(buffer.length()-1);
            buffer.append(")");
            String type = null;
            if (surveyQuestionnaire.getQuestionType()==0){
                type="[单选]";
            }else if (surveyQuestionnaire.getQuestionType() ==1){
                type="[多选]";
            }else if (surveyQuestionnaire.getQuestionType()==2){
                type ="[问答]";
            }
            jsonObject.put("title",surveyQuestionnaire.getTitle()+type+buffer);
            array.add(jsonObject);
        }
        object.put("title",array);
        //单选，多选
        String sql ="SELECT soa.question_code, soa.survey_code, soa.options_code, soa.answer_type, " +
                "soa.patient, GROUP_CONCAT(sqo.sort) as sort FROM wlyy_survey_option_answers soa " +
                "LEFT JOIN wlyy_survey_questionnaire_options sqo ON soa.options_code = sqo.code " +
                "WHERE soa.survey_code = '"+code+"' " +
                "AND sqo.questionnaire_code = soa.question_code AND sqo.survey_code = soa.survey_code " +
                "GROUP BY soa.patient,soa.question_code ";
        List<Map<String,Object>> maps = jdbcTemplate.queryForList(sql);
        //问答
        String sql1 = "SELECT sa.content, sa.survey_code, sa.question_code, sa.patient,GROUP_CONCAT(sa.content) AS content " +
                " FROM wlyy_survey_answers sa WHERE sa.survey_code = '"+code+"' GROUP BY sa.patient,sa.question_code ";
        List<Map<String,Object>> maps1 = jdbcTemplate.queryForList(sql1);
        List<String> list = new ArrayList<>();
        JSONArray jsonArray = new JSONArray();
        //选项
        for (Map<String,Object> map:maps){
            JSONObject object1 = new JSONObject();
            object1.put("questionCode",map.get("question_code"));
            object1.put("patient",map.get("patient"));
            object1.put("sort",map.get("sort"));
            String sql2 = "SELECT f.`name`, CASE ( CASE LENGTH(f.idcard) WHEN 18 THEN substr(f.idcard, 17, 1)" +
                    " WHEN 15 THEN substr(f.idcard, 15, 1) END ) % 2 WHEN 0 THEN '女' WHEN 1 THEN '男' " +
                    "END AS sex,  f.mobile,  f.hospital_name,  f.doctor_name,  GROUP_CONCAT(SERVER .server_type_name) AS server_type " +
                    "FROM wlyy_sign_family f, wlyy_sign_family_server SERVER WHERE f.patient = '"+map.get("patient")+"' " +
                    "AND f.`status`=1 AND f. CODE = SERVER .sign_code GROUP BY SERVER .sign_code";
            List<Map<String,Object>> maps2 = jdbcTemplate.queryForList(sql2);
            if (maps!=null&&maps.size()!=0){
                Map<String,Object> map1 = maps2.get(0);
                object1.put("name",map1.get("name"));
                object1.put("sex",map1.get("sex"));
                object1.put("mobile",map1.get("mobile"));
                object1.put("hospitalName",map1.get("hospital_name"));
                object1.put("doctorName",map1.get("doctor_name"));
                object1.put("serverType",map1.get("server_type"));
            }
            jsonArray.add(object1);
        }
        //问答
        for (Map<String,Object> map:maps1){
            JSONObject object1 = new JSONObject();
            object1.put("questionCode",map.get("question_code"));
            object1.put("patient",map.get("patient"));
            object1.put("sort",map.get("content"));
            String sql2 = "SELECT f.`name`, CASE ( CASE LENGTH(f.idcard) WHEN 18 THEN substr(f.idcard, 17, 1)" +
                    " WHEN 15 THEN substr(f.idcard, 15, 1) END ) % 2 WHEN 0 THEN '女' WHEN 1 THEN '男' " +
                    "END AS sex,  f.mobile,  f.hospital_name,  f.doctor_name,  GROUP_CONCAT(SERVER .server_type_name) AS server_type " +
                    "FROM wlyy_sign_family f, wlyy_sign_family_server SERVER WHERE f.patient = '"+map.get("patient")+"' " +
                    "AND f.`status`=1 AND f. CODE = SERVER .sign_code GROUP BY SERVER .sign_code";
            List<Map<String,Object>> maps2 = jdbcTemplate.queryForList(sql2);
            if (maps!=null&&maps.size()!=0){
                Map<String,Object> map1 = maps2.get(0);
                object1.put("name",map1.get("name"));
                object1.put("sex",map1.get("sex"));
                object1.put("mobile",map1.get("mobile"));
                object1.put("hospitalName",map1.get("hospital_name"));
                object1.put("doctorName",map1.get("doctor_name"));
                object1.put("serverType",map1.get("server_type"));
            }
            jsonArray.add(object1);
        }
        JSONArray array1 = new JSONArray();
        List<String> patients = new ArrayList<>();
        for (int i=0;i<jsonArray.size();i++){
            JSONObject jsonObject = jsonArray.getJSONObject(i);
            if (array1 == null|| array1.size()==0){
                JSONArray array2 = new JSONArray();
                JSONObject object1 = new JSONObject();
                object1.put("questionCode",jsonObject.getString("questionCode"));
                object1.put("sort",jsonObject.getString("sort"));
                array2.add(object1);
                jsonObject.put("questions",array2);
                patients.add(jsonObject.getString("patient"));
                array1.add(jsonObject);
            }else {
                if (patients.contains(jsonObject.getString("patient"))){
                    for (int j=0;j<array1.size();j++){
                        JSONObject object1 = array1.getJSONObject(j);
                        if (object1.getString("patient").equalsIgnoreCase(jsonObject.getString("patient"))){
                            JSONArray jsonArray1 = object1.getJSONArray("questions");
                            JSONObject jsonObject1 = new JSONObject();
                            jsonObject1.put("questionCode",jsonObject.getString("questionCode"));
                            jsonObject1.put("sort",jsonObject.getString("sort"));
                            jsonArray1.add(jsonObject1);
                        }
                    }
                }else {
                    JSONArray array2 = new JSONArray();
                    JSONObject object1 = new JSONObject();
                    object1.put("questionCode",jsonObject.getString("questionCode"));
                    object1.put("sort",jsonObject.getString("sort"));
                    array2.add(object1);
                    jsonObject.put("questions",array2);
                    patients.add(jsonObject.getString("patient"));
                    array1.add(jsonObject);
                }
            }
        }
        patients.clear();
        jsonArray.clear();
        object.put("jsonArray",array1);
        return object;
    }
}
