package com.yihu.customer.service.synergy;

import com.alibaba.fastjson.JSONObject;
import com.yihu.customer.util.HttpManageClientUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 * Created by humingfen on 2018/09/29.
 */
@Service
@Transactional
public class ScreenResultManageService {

    @Value("${wlyy.url}")
    private String wlyyUrl;
    @Autowired
    private HttpManageClientUtil httpManageClientUtil;

    /**
     * 获取筛查结果详情
     * @param code
     * @return
     */
    public JSONObject getScreenResultDetail(String code) throws Exception {
        String url = wlyyUrl + "third/synergy/screen/getScreenResultDetail?code=" + code;
        String response = httpManageClientUtil.get(url, "UTF-8");
        JSONObject jsonObject = JSONObject.parseObject(response);
        if(jsonObject.getInteger("status") == 200){
            return JSONObject.parseObject(jsonObject.getString("data"));
        }
        throw new Exception("请求失败");
    }

    /**
     * 获取筛查问卷详情
     * @param templateCode
     * @return
     */
    public JSONObject getScreenDetail(String templateCode) throws Exception {
        String url = wlyyUrl + "third/synergy/questionnaire/getAllQuestions?surveyTemplateCode=" + templateCode;
        String response = httpManageClientUtil.get(url, "UTF-8");
        JSONObject jsonObject = JSONObject.parseObject(response);
        if(jsonObject.getInteger("status") == 200){
            return JSONObject.parseObject(jsonObject.getString("data"));
        }
        throw new Exception("请求失败");
    }
}
