package com.yihu.customer.service.synergy;

import com.alibaba.fastjson.JSON;

import com.yihu.customer.util.DateUtil;
import com.yihu.customer.util.IdCardUtil;
import com.yihu.customer.util.query.BaseJpaService;
import  com.yihu.customer.entity.*;
import  com.yihu.customer.entity.call.CallRecord;
import  com.yihu.customer.entity.call.CallService;
 
 
 
import  com.yihu.customer.entity.synergy.*;
import  com.yihu.customer.repository.*;
import  com.yihu.customer.repository.call.CallRecordDao;
import  com.yihu.customer.repository.call.CallServiceDao;
import  com.yihu.customer.repository.survey.SurveyTemplateDao;
import  com.yihu.customer.repository.synergy.*;
import com.yihu.customer.util.HttpManageClientUtil;
import jxl.Workbook;
import jxl.write.*;
import org.apache.commons.lang3.StringUtils;
import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.ContentType;
import org.apache.http.entity.mime.MultipartEntityBuilder;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClientBuilder;
import org.apache.http.util.EntityUtils;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.jdbc.core.BeanPropertyRowMapper;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.multipart.MultipartFile;
import org.springframework.web.multipart.MultipartHttpServletRequest;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.OutputStream;
import java.nio.charset.Charset;
import java.text.SimpleDateFormat;
import java.util.*;

/**
 * Created by 刘文彬 on 2018/9/27.
 */
@Service
@Transactional
public class SynergyManageService extends BaseJpaService {

    @Value("${wlyy.url}")
    private String wlyyUrl;
    @Autowired
    private HttpManageClientUtil httpManageClientUtil;
    @Autowired
    JdbcTemplate jdbcTemplate;
    @Autowired
    private ManageSynergyWorkOrderDao workOrderDao;
    @Autowired
    private ManageSynergyWorkorderServicerDao workorderServicerDao;
    @Autowired
    private ManageSynergyWorkorderExecutorDao workorderExecutorDao;
    @Autowired
    private UserDao userDao;
    @Autowired
    private PatientDao patientDao;
    @Autowired
    private SignFamilyDao signFamilyDao;
    @Autowired
    private SignPatientLabelInfoDao signPatientLabelInfoDao;
    @Autowired
    private ManageSynergyWorkorderCustomerLogDao customerLogDao;
    @Autowired
    private DoctorDao doctorDao;
    @Autowired
    private ManageSynergyWorkorderReminderDao manageSynergyWorkorderReminderDao;
    @Autowired
    private ManageSynergyWorkorderServicerLogDao manageSynergyWorkorderServicerLogDao;
    @Autowired
    private SurveyTemplateDao surveyTemplateDao;
    @Autowired
    private ManageSynergyAccessoryDao manageSynergyAccessoryDao;
    @Autowired
    private CallServiceDao callServiceDao;
    @Autowired
    private CallRecordDao callRecordDao;
    @Autowired
    private ManageSynergyWorkorderTestInstructionsDao manageSynergyWorkorderTestInstructionsDao;
    @Autowired
    private ManageSynergyWorkorderArticleDao manageSynergyWorkorderArticleDao;
    @Autowired
    private MessageDao messageDao;
    @Autowired
    private ManageSynergyServerRecordDao manageSynergyServerRecordDao;

    /**
     * 根据服务编码获取工单
     * @param workorderCode
     * @return
     */
    public ManageSynergyWorkorderDO findWorkOrderByCode(String workorderCode) {
        return workOrderDao.findByCode(workorderCode);
    }

    /**
     * 我接收到的任务
     * @param code
     * @param keywords
     * @param workorderType
     * @param isMyTask 是否由我负责
     * @param status
     * @param priority
     * @param timeout
     * @param workorderCode
     * @param principal
     * @param serviceStartTime
     * @param serviceEndTime
     * @param patientName
     * @param ssc 社保卡号
     * @param idcard 身份证
     * @param userType 1、医生，2、客服，3、客服管理员，4、医生管理员
     * @param isAcceptTask 1、我接收到的任务，2、我派发的任务，3、待接收（客服管理员），4、已接收（客服管理员）
     * @return
     * @throws Exception
     */
    public Map<String,Object> workorderList(String code,String keywords,Integer workorderType,
                               Integer isMyTask,Integer status,Integer priority,Integer timeout,String workorderCode,
                               String principal,String serviceStartTime,String serviceEndTime,String patientName,String ssc,String idcard,
                               Integer userType,Integer isAcceptTask,String userName,String hospitalName,Integer page, Integer pageSize,Integer isRead,Integer isOne,String customerCode) throws Exception{

        String servicerTable = " left join wlyy.manage_synergy_workorder_executor e on e.workorder_code=w.code AND e.del = 1  " ;
        String whereSql = "";
        if(userType==3){//客服管理员
            whereSql +=" and w.create_user_type=1 ";//创建人为医生
            if(isAcceptTask==3){//待接收
                whereSql +=" and w.status =1 ";
                servicerTable ="";
            }else if(isAcceptTask==4){//已接收
                whereSql +=" and w.status in (2,3) ";
            }
        }else if(userType==2){//客服
            if(isAcceptTask==1){//我接收
                whereSql +=" and w.create_user_type=1 ";//创建人为医生
                whereSql += " and e.executor_code ='"+code+"' ";
            }else if(isAcceptTask==2){//我派发
                whereSql +=" and w.create_user_type=2 ";//创建人为客服
                if (isOne!=null){
                    if (isOne==1){
                        whereSql += " and w.create_user ='"+code+"' ";
                    }
                }
                if (customerCode!=null&&customerCode!=""){
                    whereSql +=" and w.create_user ='"+customerCode+"'";
                }
            }
        }else if(userType==1){//医生
            if(isAcceptTask==1){//我接收
                whereSql +=" and w.create_user_type=2 ";//创建人为客服
                whereSql += " and e.executor_code ='"+code+"' ";
            }else if(isAcceptTask==2){//我派发
                whereSql += " and w.create_user_type=1 ";//创建人为医生
                whereSql += " and w.create_user ='"+code+"' ";
                whereSql += " and w.create_user_role=1 ";
            }
        }else if(userType==4){//医生管理员
            if(isAcceptTask==2){
                whereSql += " and w.create_user_type=1 ";//创建人为医生
                whereSql += " and w.create_user ='"+code+"' ";
                whereSql += " and w.create_user_role=2 ";
            }
        }

        //关键字查询
        servicerTable +=" left join wlyy.manage_synergy_workorder_servicer s on s.workorder_code=w.code ";
        if(StringUtils.isNotEmpty(keywords)){
//            whereSql += " and w.servicer_count<=10  ";
            whereSql += " and (w.create_user_name like '%"+keywords+"%' or s.service_patient_name like '%"+keywords+"%' " +
                    " or s.ssc like '%"+keywords+"%' or s.idcard like '%"+keywords+"%' ) ";
        }
        //服务类型
        if(workorderType!=null){
            whereSql += " and w.type ="+workorderType+" ";
        }
        //是否是我负责的
        if(isMyTask!=null){
            whereSql += " and e.executor_code ='"+code+"' and e.executor_type=1 ";
        }
        //工单状态
        if(status!=null){
            whereSql +=" and w.status ="+status+" ";
        }
        if (isRead!=null){
            whereSql +=" and w.is_read ="+isRead+" ";
        }
        //优先级
        if(priority!=null){
            whereSql+= " and w.priority="+priority+" ";
        }
        //是否超时
        if(timeout!=null){
            if(timeout==1){
                whereSql +=" and w.service_time >'"+ DateUtil.dateToStrLong(new Date())+"' ";
            }else if(timeout==2){
                whereSql +=" and w.service_time <='"+DateUtil.dateToStrLong(new Date())+"' ";
            }
        }
        //服务编码
        if(StringUtils.isNotEmpty(workorderCode)){
            whereSql+=" and w.code like '%"+workorderCode+"%' ";
        }
        //服务时间
        if(StringUtils.isNotEmpty(serviceStartTime)){
            whereSql+=" and w.service_time>='"+serviceStartTime+"' ";
        }
        if(StringUtils.isNotEmpty(serviceEndTime)){
            whereSql+=" and w.service_time<='"+serviceEndTime+"' ";
        }
        //服务对象
        if(StringUtils.isNotEmpty(patientName)){
            whereSql+=" and s.service_patient_name like '%"+patientName+"%' ";
        }
        //社保卡号
        if(StringUtils.isNotEmpty(ssc)){
            whereSql+=" and s.ssc like '%"+ssc+"%' ";
        }
        //身份证号
        if(StringUtils.isNotEmpty(idcard)){
            whereSql+=" and s.idcard like '%"+idcard+"%' ";
        }
        //需求方
        if(StringUtils.isNotEmpty(userName)){
            whereSql+=" and w.create_user_name like '%"+userName+"%' ";
        }
        if(StringUtils.isNotEmpty(hospitalName)){
            whereSql+=" and w.hospital_name like '%"+hospitalName+"%' ";
        }

        String sql =" select DISTINCT w.* from wlyy.manage_synergy_workorder w  " +servicerTable+

                " where w.del=1  " +
                " and 1=1 "+whereSql+ " order by w.status asc,w.create_time DESC ";
        List<Map<String,Object>> rstotal = jdbcTemplate.queryForList(sql);
        int count = 0;
        if(rstotal!=null&&rstotal.size()>0&&rstotal.get(0).get("id")!=null){
            count = rstotal.size();
        }
        String finalSql = sql+" LIMIT "+(page-1)*pageSize+","+pageSize;
        List<Map<String,Object>> resultWorkorderList = jdbcTemplate.queryForList(finalSql);
        List<Map<String,Object>> resultList = new ArrayList<>();
        ManageSynergyWorkorderServicerDO servicerDO = null;
        Patient patient =null;
        List<ManageSynergyWorkorderServicerDO> servicerList = null;
        for(Map<String,Object> one : resultWorkorderList){
            Map<String,Object> map = new HashMap<>();
            map.put("workorderCode",one.get("code"));//服务编码
            Integer workorderTypeR = (Integer) one.get("type");
            String workorderTypeName = "";
            map.put("type",workorderTypeR);//服务类型
            switch (workorderTypeR){
                case 0: workorderTypeName="咨询";break;
                case 1: workorderTypeName="健康教育";break;
                case 2: workorderTypeName="预约";break;
                case 3: workorderTypeName="随访";break;
                case 4: workorderTypeName="问卷调查";break;
                case 5: workorderTypeName="疾病筛查";break;
                case 6: workorderTypeName="健康教育";break;
                case 7: workorderTypeName="体检提醒（65岁以上老人）";break;
                case 8: workorderTypeName="体征测量";break;
                case 9: workorderTypeName="自定义";break;
            }
            if(workorderTypeR==0||workorderTypeR==2||workorderTypeR==3){
                List<ManageSynergyWorkorderServicerDO> ls = workorderServicerDao.findByWorkorderCode(workorderCode);
                map.put("patientCode",ls.size()>0?ls.get(0):null);//1对1服务工单，服务对象code
            }
            map.put("isRead",one.get("is_read"));//工单状态 0已读、1未读
            map.put("typeName",workorderTypeName);//服务类型名称
            map.put("serviceTime", one.get("service_time")!=null?DateUtil.dateToStr((Date)one.get("service_time"),"yyyy-MM-dd HH:mm"):"");//服务时间
            map.put("createTime",one.get("create_time")!=null?DateUtil.dateToStr((Date)one.get("create_time"),"yyyy-MM-dd HH:mm"):"");
            map.put("priority",one.get("priority"));//工单优先级
            map.put("priorityName",((Integer)one.get("priority"))==1?"加急":"普通");
            map.put("createUser",one.get("create_user"));//创建人
            map.put("createUserName",one.get("create_user_name"));//创建人名字
            if(one.get("service_time")!=null){//咨询、随访、预约的服务时间是null

                Integer overTime = isServiceOverTime((Date)one.get("service_time"));
                map.put("overTime",overTime);//是否超时
            }
            String[] servicer = (one.get("servicer_key")+"").split(",");
            map.put("servicer",servicer[0]);//服务对象
            map.put("servicerCount",one.get("servicer_count"));//服务对象人数
            Integer statusR = (Integer) one.get("status");
            map.put("status",statusR);//工单状态
            String statusName="";
            switch (statusR){
                case 0:statusName="草稿";break;
                case 1:statusName="未接受";break;
                case 2:statusName="处理中";break;
                case 3:statusName="处理完成";break;
                case 4:statusName="退回";break;
            }
            map.put("statusName",statusName);
            List<ManageSynergyWorkorderExecutorDO> managerList = workorderExecutorDao.findByWorkorderCode(one.get("code")+"",1);
            String managerName = managerList.size()>0?managerList.get(0).getExecutorName():"";
            map.put("managerName",managerName);//负责人的名称
            Integer finishedServicerCount = workorderServicerDao.findByWorkorderCodeCount(one.get("code")+"",3);
            map.put("finishedServicerCount",finishedServicerCount);//服务完成人数
            String reminderTypeName="";
            //提醒类型：1体征异常、2体征未测量
            if(null!=one.get("reminder_type")){
                Integer reminderType=(Integer)one.get("reminder_type");
                switch (reminderType){
                    case 1:reminderTypeName="体征异常";break;
                    case 2:reminderTypeName="体征未测量";break;
                }
            }
            map.put("reminderTypeName",reminderTypeName);//服务完成人数
            //预约或者咨询取接收人
            if( 0 == workorderTypeR || 2 == workorderTypeR){
                map.put("userName",one.get("receiver_name"));
            }else{
                map.put("userName",one.get("create_user_name"));
            }
            map.put("hospital",one.get("hospital"));
            map.put("hospitalName",one.get("hospital_name"));
            map.put("servicerKey",one.get("servicer_key"));
            map.put("remark",one.get("remark"));
            map.put("relationCode",one.get("relation_code"));
            map.put("relationCodeName",one.get("relation_code_name"));
            if(workorderTypeR==0||workorderTypeR==2||workorderTypeR==3){
                servicerList = workorderServicerDao.findByWorkorderCode(one.get("code")+"");
                if(servicerList.size()>0){
                    servicerDO = servicerList.get(0);
                    patient = patientDao.findByCode(servicerDO.getServicePatientCode());
                }
                Integer age = IdCardUtil.getAgeForIdcard(patient.getIdcard());
                String sex = IdCardUtil.getSexForIdcard_new(patient.getIdcard());
                map.put("age",age);
                map.put("sex","1".equals(sex)?"男":("2".equals(sex)?"女":"未知"));
            }
            resultList.add(map);
        }
        List<Map<String,Object>> mapList = new ArrayList<>();
        //负责人
        if(StringUtils.isNotEmpty(principal)){
            for (int i=0;i<resultList.size();i++){
                Map<String,Object> map = resultList.get(i);
                String managerName = map.get("managerName").toString();
                if (managerName.contains(principal)){
                    mapList.add(map);
                }
            }
        }else {
            mapList=resultList;
        }
        Map<String,Object> resultMap = new HashMap<>();
        resultMap.put("currPage",page);
        resultMap.put("pageSize",pageSize);
        resultMap.put("totalCount",count);
        resultMap.put("detailModelList",mapList);
        double t = (double)count;
        resultMap.put("total",Math.ceil(t/pageSize));
        return resultMap;
    }



    public Map<String,Object> workorderListTotal(String code,Integer userType) throws Exception{
        Map<String,Object> resultMap = new HashMap<>();
        String whereSql = null;
        if(userType==3){//客服管理员
            /*whereSql +=" and w.create_user_type=1 ";//创建人为医生*/
            //待接收
            String sql2 =" select count(1) as total from wlyy.manage_synergy_workorder w " +
                    " where w.del=1  " +
                    " and 1=1 and w.create_user_type=1 and w.is_read=0 and w.status =1 ";
            List<Map<String,Object>> rstotal2 = jdbcTemplate.queryForList(sql2);
            Long count2 = 0L;
            if(rstotal2!=null&&rstotal2.size()>0){
                count2 = (Long) rstotal2.get(0).get("total");
            }
            resultMap.put("waitReceiverUnReadTotal",count2);//未读

            String sql7 =" select count(1) as total from wlyy.manage_synergy_workorder w " +
                    " where w.del=1  " +
                    " and 1=1 and w.create_user_type=1 and w.status =1 ";
            List<Map<String,Object>> rstotal7 = jdbcTemplate.queryForList(sql7);
            Long count7 = 0L;
            if(rstotal7!=null&&rstotal7.size()>0){
                count7 = (Long) rstotal7.get(0).get("total");
            }
            resultMap.put("waitReceiverTotal",count7);
            //已接收
           /* whereSql +=" and w.status in (2,3) ";*/
            String sql3 =" select count(1) as total from wlyy.manage_synergy_workorder w " +
                    " where w.del=1  " +
                    " and 1=1 and w.create_user_type=1 and w.is_read=0 and w.status in (2)";
            List<Map<String,Object>> rstotal3 = jdbcTemplate.queryForList(sql3);
            Long count3 = 0L;
            if(rstotal3!=null&&rstotal3.size()>0){
                count3 = (Long) rstotal3.get(0).get("total");
            }
            resultMap.put("useReceiverUnReadTotal",count3);
            String sql8 =" select count(1) as total from wlyy.manage_synergy_workorder w " +
                    " where w.del=1  " +
                    " and 1=1 and w.create_user_type=1 and w.status in (2)";
            List<Map<String,Object>> rstotal8 = jdbcTemplate.queryForList(sql8);
            Long count8 = 0L;
            if(rstotal8!=null&&rstotal8.size()>0){
                count8 = (Long) rstotal8.get(0).get("total");
            }
            resultMap.put("useReceiverTotal",count8);

            //我接收
            String sql =" select COUNT(DISTINCT w.`code`) as total from wlyy.manage_synergy_workorder w " +
                    " LEFT JOIN wlyy.manage_synergy_workorder_executor e ON e.workorder_code = w. CODE " +
                    "AND e.del = 1 " +
                    "LEFT JOIN wlyy.manage_synergy_workorder_servicer s ON s.workorder_code = w. CODE " +
                    " where w.del=1  " +
                    " and 1=1 and w.create_user_type=1 and e.executor_code ='"+code+"' and w.is_read=0 AND w.status=2";
            List<Map<String,Object>> rstotal = jdbcTemplate.queryForList(sql);
            Long count = 0L;
            if(rstotal!=null&&rstotal.size()>0){
                count = (Long) rstotal.get(0).get("total");
            }
            resultMap.put("receiverUnReadTotal",count);
            String sql9 =" select COUNT(DISTINCT w.`code`) as total from wlyy.manage_synergy_workorder w " +
                    " LEFT JOIN wlyy.manage_synergy_workorder_executor e ON e.workorder_code = w. CODE " +
                    "AND e.del = 1 " +
                    "LEFT JOIN wlyy.manage_synergy_workorder_servicer s ON s.workorder_code = w. CODE " +
                    " where w.del=1  " +
                    " and 1=1 and w.create_user_type=1 and e.executor_code ='"+code+"' AND w.status=2 ";
            List<Map<String,Object>> rstotal9 = jdbcTemplate.queryForList(sql9);
            Long count9 = 0L;
            if(rstotal9!=null&&rstotal9.size()>0){
                count9 = (Long) rstotal9.get(0).get("total");
            }
            resultMap.put("receiverTotal",count9);
            //我派发
            String sql1 =" select count(1) as total from wlyy.manage_synergy_workorder w " +
                    " where w.del=1  " +
                    " and 1=1 and w.create_user_type=2 and w.create_user ='"+code+"' and w.is_read=0 AND w.status=2 ";
            List<Map<String,Object>> rstotal1 = jdbcTemplate.queryForList(sql1);
            Long count1 = 0L;
            if(rstotal1!=null&&rstotal1.size()>0){
                count1 = (Long) rstotal1.get(0).get("total");
            }
            resultMap.put("distributeUnReadTotal",count1);
            String sql10 =" select count(1) as total from wlyy.manage_synergy_workorder w " +
                    " where w.del=1  " +
                    " and 1=1 and w.create_user_type=2 and w.create_user ='"+code+"' AND w.status=2";
            List<Map<String,Object>> rstotal10 = jdbcTemplate.queryForList(sql10);
            Long count10 = 0L;
            if(rstotal10!=null&&rstotal10.size()>0){
                count10 = (Long) rstotal10.get(0).get("total");
            }
            resultMap.put("distributeTotal",count1);
            //催单数目
            String sql5 =" select r.* from manage_synergy_workorder_reminder r " +
                    " LEFT JOIN manage_synergy_workorder w on r.workorder_code=w.code where w.status=1 and r.deal_with=0 ";
            List<Map<String,Object>> rstotal5 = jdbcTemplate.queryForList(sql5);
            int count5 = 0;
            if(rstotal5!=null&&rstotal5.size()>0&&rstotal5.get(0).get("id")!=null){
                count5 = rstotal5.size();
            }
            resultMap.put("reminderTotal",count5);
            //催单未读数目
            String sql6 =" select r.* from manage_synergy_workorder_reminder r " +
                        " LEFT JOIN manage_synergy_workorder w on r.workorder_code=w.code where w.status =1 and r.deal_with=0 and r.is_read=0";
            List<Map<String,Object>> rstotal6 = jdbcTemplate.queryForList(sql6);
            int count6 = 0;
            if(rstotal6!=null&&rstotal6.size()>0&&rstotal6.get(0).get("id")!=null){
                count6 = rstotal6.size();
            }
            resultMap.put("reminderUnReadTotal",count6);
        }else if(userType==2){//客服
            //我接收
            String sql =" select COUNT(DISTINCT w.`code`) as total from wlyy.manage_synergy_workorder w " +
                    " LEFT JOIN wlyy.manage_synergy_workorder_executor e ON e.workorder_code = w. CODE " +
                    "AND e.del = 1 " +
                    "LEFT JOIN wlyy.manage_synergy_workorder_servicer s ON s.workorder_code = w. CODE " +
                    " where w.del=1  " +
                    " and 1=1 and w.create_user_type=1 and e.executor_code ='"+code+"' and w.is_read=0 AND w.status=2";
            List<Map<String,Object>> rstotal = jdbcTemplate.queryForList(sql);
            Long count = 0L;
            if(rstotal!=null&&rstotal.size()>0){
                count = (Long) rstotal.get(0).get("total");
            }
            resultMap.put("receiverUnReadTotal",count);
            String sql9 =" select COUNT(DISTINCT w.`code`) as total from wlyy.manage_synergy_workorder w " +
                    " LEFT JOIN wlyy.manage_synergy_workorder_executor e ON e.workorder_code = w. CODE " +
                    "AND e.del = 1 " +
                    "LEFT JOIN wlyy.manage_synergy_workorder_servicer s ON s.workorder_code = w. CODE " +
                    " where w.del=1  " +
                    " and 1=1 and w.create_user_type=1 and e.executor_code ='"+code+"' AND w.status=2 ";
            List<Map<String,Object>> rstotal9 = jdbcTemplate.queryForList(sql9);
            Long count9 = 0L;
            if(rstotal9!=null&&rstotal9.size()>0){
                count9 = (Long) rstotal9.get(0).get("total");
            }
            resultMap.put("receiverTotal",count9);
            //我派发
            String sql1 =" select count(1) as total from wlyy.manage_synergy_workorder w " +
                    " where w.del=1  " +
                    " and 1=1 and w.create_user_type=2 and w.create_user ='"+code+"' and w.is_read=0 AND w.status=2 ";
            List<Map<String,Object>> rstotal1 = jdbcTemplate.queryForList(sql1);
            Long count1 = 0L;
            if(rstotal1!=null&&rstotal1.size()>0){
                count1 = (Long) rstotal1.get(0).get("total");
            }
            resultMap.put("distributeUnReadTotal",count1);
            String sql10 =" select count(1) as total from wlyy.manage_synergy_workorder w " +
                    " where w.del=1  " +
                    " and 1=1 and w.create_user_type=2 and w.create_user ='"+code+"' AND w.status=2";
            List<Map<String,Object>> rstotal10 = jdbcTemplate.queryForList(sql10);
            Long count10 = 0L;
            if(rstotal10!=null&&rstotal10.size()>0){
                count10 = (Long) rstotal10.get(0).get("total");
            }
            resultMap.put("distributeTotal",count1);
            //催单数目
            String sql5 =" select DISTINCT r.* from manage_synergy_workorder_reminder r " +
                    " LEFT JOIN manage_synergy_workorder_executor e on r.workorder_code=e.workorder_code " +
                    " where e.executor_code='"+code+"' and e.del=1 and r.deal_with=0 " ;
            List<Map<String,Object>> rstotal5 = jdbcTemplate.queryForList(sql5);
            int count5 = 0;
            if(rstotal5!=null&&rstotal5.size()>0&&rstotal5.get(0).get("id")!=null){
                count5 = rstotal5.size();
            }
            resultMap.put("reminderTotal",count5);
            //催单未读数据
            String sql6 =" select DISTINCT r.* from manage_synergy_workorder_reminder r " +
                    " LEFT JOIN manage_synergy_workorder_executor e on r.workorder_code=e.workorder_code " +
                    " where e.executor_code='"+code+"' and e.del=1 and r.deal_with=0 AND  r.is_read=0" ;

            List<Map<String,Object>> rstotal6 = jdbcTemplate.queryForList(sql6);
            int count6 = 0;
            if(rstotal6!=null&&rstotal6.size()>0&&rstotal6.get(0).get("id")!=null){
                count6 = rstotal6.size();
            }
            resultMap.put("reminderUnReadTotal",count6);
        }
        return resultMap;
    }

    /**
     * 获取服务编码
     * @return
     */
    public synchronized String getWorkorderNo(){
        String orderNo = "" ;
        String trandNo = String.valueOf((Math.random() * 9 + 1) * 1000);
        String sdf = new SimpleDateFormat("yyMMdd").format(new Date());
        orderNo = trandNo.toString().substring(0, 4);
        orderNo = sdf + orderNo ;
        return orderNo ;
    }

    /**
     * 获取超时级别
     * @param serviceTime
     * @return
     */
    public Integer isServiceOverTime(Date serviceTime){
        //当前时间 > 服务时间+4小时（已超时）3
        //服务时间+4小时 > 当前时间 > 服务时间（红色超时）2
        //服务时间 HH:mm:59()> 当前时间 > 服务时间 HH:mm:00（黄色超时）1
        //服务时间 HH:mm:00 > 当前时间 （正常）0
        Integer serviceStatus = null;
        String serviceTimeStart = DateUtil.dateToStr(serviceTime,"yyyy-MM-dd HH:mm")+":00";
        String serviceTimeEnd = DateUtil.dateToStr(serviceTime,"yyyy-MM-dd HH:mm")+":59";
        Long serviceTimeStartLong = DateUtil.strToDate(serviceTimeStart,"yyyy-MM-dd HH:mm:ss").getTime();
        Long serviceTimeEndLong = DateUtil.strToDate(serviceTimeEnd,"yyyy-MM-dd HH:mm:ss").getTime();
        Long serviceTimeAfter4Long = serviceTimeEndLong+4*60*60*1000;
        Long currentTime = new Date().getTime();
        if(currentTime<serviceTimeStartLong){//正常
            serviceStatus=0;
        }else if(currentTime>=serviceTimeStartLong&&currentTime<=serviceTimeEndLong){//黄色超时
            serviceStatus=1;
        }else if(currentTime>serviceTimeEndLong&&currentTime<=serviceTimeAfter4Long){//红色超时
            serviceStatus=2;
        }else if(currentTime>serviceTimeAfter4Long){//已超时
            serviceStatus=3;
        }
        return serviceStatus;
    }

    /**
     * 获取系统服务详情
     * @param workorderCode
     * @param patient
     * @param role
     * @return
     */
    public Map<String, Object> getWorkOrderInfo(String workorderCode, String patient, Integer role,String reminderCode) {
        Map<String, Object> map = new HashMap<>();
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        SimpleDateFormat s = new SimpleDateFormat("yyyy-MM-dd HH:mm");
        ManageSynergyWorkorderDO workorderDO = workOrderDao.findByCode(workorderCode);
        workorderDO.setRead(1);
        workOrderDao.save(workorderDO);
        if (StringUtils.isNoneBlank(reminderCode)){
            ManageSynergyWorkordeReminderDO reminderDO = manageSynergyWorkorderReminderDao.findByCode(reminderCode);
            reminderDO.setRead(1);
            manageSynergyWorkorderReminderDao.save(reminderDO);
        }
        Integer status = workorderDO.getStatus();
        //存入协同服务工单信息
        map.put("code", workorderCode);
        map.put("type", workorderDO.getType());
        map.put("priority", workorderDO.getPriority());
        if(workorderDO.getServiceTime() != null) {
            map.put("serviceTime", s.format(workorderDO.getServiceTime()));
            //超时标签
            map.put("delayStatus", this.isServiceOverTime(workorderDO.getServiceTime()));
        }
        map.put("status", status);
        map.put("title", workorderDO.getRelationCodeName());
        map.put("relationCode", workorderDO.getRelationCode());
        map.put("remark", workorderDO.getRemark());
        map.put("createTime", sdf.format(workorderDO.getCreateTime()));
        map.put("createUserName", workorderDO.getCreateUserName());
        map.put("hospitalName", workorderDO.getHospitalName());
        map.put("servicerKey", workorderDO.getServicerKey());
        map.put("servicerCount", workorderDO.getServicerCount());

        map.put("reason",workorderDO.getReason());//关闭说明
        map.put("closeUser",workorderDO.getCloseUser());//关闭客服code
        map.put("closeUserName",workorderDO.getCloseUserName());//关闭客服名字
        map.put("closeTime",workorderDO.getCloseTime());//关闭时间


        //获取退回原因
        if(status == 4){
            map.put("returnedRemark", workorderDO.getReturnedRemark());
        }else if(status == 2 || status == 3){
            //获取工单完成人数
            int count = workorderServicerDao.findByWorkorderCodeCount(workorderCode, 3);
            map.put("count", count);
            //接收者
            map.put("receiverName", workorderDO.getReceiverName());
            if(workorderDO.getReceiverTime() != null) {
                map.put("receiverTime", sdf.format(workorderDO.getReceiverTime()));
            }
            //获取负责人信息
            List<ManageSynergyWorkorderExecutorDO> managerList = workorderExecutorDao.findByWorkorderCode(workorderCode,1);
            List<ManageSynergyWorkorderExecutorDO> collaboratorList = workorderExecutorDao.findByWorkorderCode(workorderCode,2);
            //获取负责人信息
            for(ManageSynergyWorkorderExecutorDO m : managerList){
                User manager = userDao.findByCode(m.getExecutorCode());
                map.put("managerName", manager.getName());
                map.put("managerJobNo", manager.getJobNo());
                map.put("managerPhone", manager.getMobile());
            }
            String collaborator = "";
            for(ManageSynergyWorkorderExecutorDO one : collaboratorList){
                collaborator += "、" + one.getExecutorName();
            }
            map.put("collaboratorList", StringUtils.isNotEmpty(collaborator) ? collaborator.substring(1) : "");//参与人可能有多个

            //获取单个服务对象
            if(StringUtils.isNotBlank(patient)){
                //获取单个居民处理完成的工单信息
                ManageSynergyWorkorderServicerDO workorderServicerDO = workorderServicerDao.findByWorkOrderCodeAndPatientCode(workorderCode, patient);
                map.put("patientName", workorderServicerDO.getServicePatientName());
                map.put("mobile",workorderServicerDO.getMobile());
                map.put("idcard", workorderServicerDO.getIdcard());
                map.put("ssc", workorderServicerDO.getSsc());
                map.put("completeTime", sdf.format(workorderServicerDO.getCompleteTime()));
            }
            //获取处理结果
            if(status == 3) {
                map.put("resultRemark", workorderDO.getDealResultRemark());
                map.put("completeTime", sdf.format(workorderDO.getCompleteTime()));
                List<ManageSynergyAccessoryDO> accessoryList = accessoryList(workorderCode);
                map.put("accessoryList",accessoryList);//附件列表
                CallService callService = callServiceDao.findByCode(workorderDO.getRelationCode());
                if(callService!=null){
                    map.put("dealState",callService.getDealState());//处理结果
                    map.put("dealContent",callService.getDealContent());//处理内容
                    map.put("dealReason",callService.getDealReason());//预约失败原因
                    map.put("dealType",callService.getDealType());//
                }
            }
        }

        //如果是随访，查出对象的信息
        if(workorderDO.getType() == 3){
            List<ManageSynergyWorkorderServicerDO> workorderServicerDO = workorderServicerDao.findByWorkorderCode(workorderCode);
            map.put("patientName", workorderServicerDO.get(0).getServicePatientName());
            map.put("patient", workorderServicerDO.get(0).getServicePatientCode());
            map.put("mobile",workorderServicerDO.get(0).getMobile());
            map.put("idcard", workorderServicerDO.get(0).getIdcard());
            map.put("ssc", workorderServicerDO.get(0).getSsc());
        }else if(workorderDO.getType() == 5) {
            //如果是疾病筛查添加疾病类型
            String diseaseType = surveyTemplateDao.findByCode(workorderDO.getRelationCode());
            map.put("diseaseType", diseaseType);
        }else if(workorderDO.getType() == 0 || workorderDO.getType() == 2) {
            CallService callService = callServiceDao.findByCode(workorderDO.getRelationCode());
            CallRecord callRecord = callRecordDao.findByCode(callService.getCallCode());
            map.put("phone", callService.getPhone());
            map.put("serverContent", callService.getServerContent());
            map.put("callTime",DateUtil.dateToStrLong(callRecord.getCreateTime()));
        }else if (workorderDO.getType()==9){
            ManageSynergyWorkorderArticleDo articleDo = manageSynergyWorkorderArticleDao.findById(Long.parseLong(workorderDO.getRelationCode())).get();
            map.put("title",articleDo.getTitle());//任务标题
            map.put("content",articleDo.getContent());//任务内容
        }
        List<ManageSynergyServerRecordDO> recordDOS = manageSynergyServerRecordDao.selectByWorkorderCode(workorderCode);
        map.put("serverRecords",recordDOS);
        return map;
    }

    /**
     * 协同服务取号（客服）
     * @param workorderCode
     * @param townCode
     * @param hospitalCode
     */
    public Map<String,Object> takeWorkorderNum(String workorderCode,String townCode,String hospitalCode,
                                               String diseaseCode,String healthCode,String serveCode,Integer isFollow) throws Exception{
        String whereSql ="";
        String leftSql ="";
        String orderBySql =" l.id desc";
        if(StringUtils.isNotEmpty(townCode)){
            whereSql+=" and s.town='"+townCode+"' ";
        }
        if(StringUtils.isNotEmpty(hospitalCode)){
            whereSql+=" and s.hospital='"+hospitalCode+"' ";
        }
        String labelSql ="";
//        if(StringUtils.isNotEmpty(diseaseCode)||StringUtils.isNotEmpty(healthCode)||StringUtils.isNotEmpty(serveCode)){
//            leftSql +=" LEFT JOIN wlyy_sign_patient_label_info i on i.patient=s.service_patient_code and i.status=1 " ;
//            if(StringUtils.isNotEmpty(diseaseCode)){
//                labelSql+=" or (i.label='"+diseaseCode+"' and i.label_type='3') ";//疾病类型
//            }
//            if(StringUtils.isNotEmpty(healthCode)){
//                labelSql+=" or (i.label='"+healthCode+"' and i.label_type='2') ";//健康情况
//            }
//            if(StringUtils.isNotEmpty(serveCode)){
//                labelSql+=" or (i.label='"+serveCode+"' and i.label_type='1') ";//服务类型
//            }
//        }
//        if(StringUtils.isNotEmpty(labelSql)){
//            whereSql+= " and ( "+labelSql.substring(3)+" )";
//        }
        if(StringUtils.isNotEmpty(serveCode)){
            leftSql+=" JOIN wlyy_sign_family f on f.patient=s.service_patient_code and f.status=1 " +
                    " JOIN wlyy_sign_family_server r on r.sign_code=f.code ";
            whereSql+=" and r.server_type='"+serveCode+"' ";
        }
        if(StringUtils.isNotEmpty(healthCode)||StringUtils.isNotEmpty(diseaseCode)){
            leftSql+=" JOIN (SELECT t.patient,GROUP_CONCAT(',',t.label_type,t.label,',') label FROM wlyy_sign_patient_label_info t " +
                    "JOIN manage_synergy_workorder_servicer v on v.service_patient_code=t.patient and v.workorder_code = '"+workorderCode+"' where t. STATUS = 1 GROUP BY t.patient ) aa on aa.patient=s.service_patient_code  ";
        }
        if(StringUtils.isNotEmpty(healthCode)){
            whereSql+=" and aa.label LIKE '%,2"+healthCode+",%' ";
        }
        if(StringUtils.isNotEmpty(diseaseCode)){
            whereSql+=" and aa.label LIKE '%,3"+diseaseCode+",%' ";
        }
        if(isFollow!=null&&isFollow==1){//跟进
            leftSql+=" LEFT JOIN manage_synergy_workorder_servicer_log ll on ll.workorder_service_code=s.code ";
            whereSql+=" and ll.follow_up=2 and ll.workorder_service_code not in (select DISTINCT lll.workorder_service_code from manage_synergy_workorder_servicer_log lll where lll.follow_up=1 and lll.workorder_code='"+workorderCode+"') ";
            orderBySql=" ll.id desc";
            whereSql+=" and s.status=3 ";
        }else{
            whereSql+=" and s.status=1 ";
        }
        String sql =" select DISTINCT w.*,s.mobile,s.service_patient_name,s.service_patient_code,s.code as servicerCode,s.town_name,s.hospital_name, " +
                " w.create_user_name ,s.relation_code as serviserRelationCode " ;
        String sqlCenter = " from manage_synergy_workorder_servicer s " +
                " LEFT JOIN manage_synergy_workorder w on s.workorder_code=w.code " +
                " LEFT JOIN manage_synergy_workorder_executor e on e.workorder_code=w.code " + leftSql+
                " LEFT JOIN manage_synergy_workorder_customer_log l on l.workorder_service_code=s.service_patient_code " +
                " where s.workorder_code='"+workorderCode+"' " +
                " and w.del=1 and w.status=2 and e.del=1 "+
                whereSql;
        String orderSql =" order by "+orderBySql;
        String sql1=" select count(1) as num ";
        String whereSql1=whereSql+" and l.id is not null ";
        List<Map<String,Object>> resultWorkorderListCount = jdbcTemplate.queryForList(sql1+sqlCenter+whereSql1);
        int count = resultWorkorderListCount.get(0).get("num")!=null?Integer.valueOf(resultWorkorderListCount.get(0).get("num")+""):0;
        List<Map<String,Object>> resultWorkorderList = jdbcTemplate.queryForList(sql+sqlCenter+orderSql);
        Map<String,Object> resultMap = new HashMap<>();
        if(resultWorkorderList.size()>0){
            Integer ra = 0;
            if(count>0){
                ra = getRandom(0,count-1);
            }else{
                ra = getRandom(0,resultWorkorderList.size()-1);
            }
            Map<String,Object> workorderMap = resultWorkorderList.get(ra);
            //居民信息
            resultMap.put("mobile",workorderMap.get("mobile"));//电话号码
            resultMap.put("patientName",workorderMap.get("service_patient_name"));//居民姓名
            Integer callNum = customerLogDao.callNumByWorkorder(workorderMap.get("servicerCode")+"");
            resultMap.put("callNum",callNum);//已呼叫次数
            resultMap.putAll(this.getPatientInfo(workorderMap.get("service_patient_code") + ""));
            Patient patient =patientDao.findByCode(workorderMap.get("service_patient_code")+"");
            Integer sex = patient.getSex();
            String sexName ="";
            if(sex==1){
                sexName="男";
            }else if(sex==2){
                sexName="女";
            }else{
                sexName="未知";
            }
            resultMap.put("sex",sexName);//性别
            Integer age = IdCardUtil.getAgeForIdcard(patient.getIdcard());
            resultMap.put("age",age);//年龄
            resultMap.put("townName",workorderMap.get("town_name"));//所属区县
            resultMap.put("hospitalName",workorderMap.get("hospital_name"));//所属社区
            SignFamily signFamily = signFamilyDao.findSignByPatient(workorderMap.get("service_patient_code")+"");
            resultMap.put("signDoctor",signFamily.getDoctorName());//签约医生（即：工单创建医生）
            resultMap.put("healthDoctor",signFamily.getDoctorHealthName());//健管师
            List<SignPatientLabelInfo> labelDiseaseType = signPatientLabelInfoDao.findByPatientAndLabelTypeAndStatus(workorderMap.get("service_patient_code")+"",  "3", 1);
            String diseaseType="";
            List<String> diseaseTypeList= new ArrayList<>();
            for(SignPatientLabelInfo one:labelDiseaseType){
                diseaseType+=","+one.getLabelName();
                diseaseTypeList.add(one.getLabel());
            }
            resultMap.put("diseaseType",StringUtils.isNotEmpty(diseaseType)?diseaseType.substring(1):"");//疾病类型
            resultMap.put("diseaseTypeCode",diseaseTypeList);//疾病类型code
            List<SignPatientLabelInfo> labelHealthType = signPatientLabelInfoDao.findByPatientAndLabelTypeAndStatus(workorderMap.get("service_patient_code")+"",  "2", 1);
            String healthType="";
            for(SignPatientLabelInfo one:labelHealthType){
                healthType+=","+one.getLabelName();
            }
            resultMap.put("healthType",StringUtils.isNotEmpty(healthType)?healthType.substring(1):"");//健康情况
            String serveType="";
//            List<SignPatientLabelInfo> labelServeType = signPatientLabelInfoDao.findByPatientAndLabelTypeAndStatus(workorderMap.get("service_patient_code")+"",  "2", 1);
//            for(SignPatientLabelInfo one:labelServeType){
//                serveType+=","+one.getLabelName();
//            }
            List<Map<String,Object>> signTypes = jdbcTemplate.queryForList("SELECT s.server_type_name,s.server_type FROM wlyy_sign_family_server s right join wlyy_sign_family f on s.sign_code=f.code WHERE f.patient='"+workorderMap.get("service_patient_code")+"' and f.status=1 and f.expenses_status='1' ");
            for(Map<String,Object> one:signTypes){
                serveType+=","+(one.get("server_type_name")!=null?one.get("server_type_name"):"");
            }
            resultMap.put("serveType",StringUtils.isNotEmpty(serveType)?serveType.substring(1):"");
//            resultMap.put("serveType",StringUtils.isNotEmpty(serveType)?serveType.substring(1):"");//服务类型
            resultMap.put("workorder",workorderMap.get("code"));//工单编号
            resultMap.put("patientCode",workorderMap.get("service_patient_code"));//居民code
            resultMap.put("doctorCode",workorderMap.get("create_user"));//创建人（医生）code
            //获取提交记录
            String servicerCode = workorderMap.get("servicerCode")+"";
            resultMap.put("servicerCode", servicerCode);
            List<ManageSynergyWorkorderServicerLogDO> list = manageSynergyWorkorderServicerLogDao.findByWorkorderServiceCode(servicerCode);
            if(list.size()>0){
                ManageSynergyWorkorderServicerLogDO log = list.get(0);
                Map<String,Object> m = new HashMap<>();
                m.put("personal",log.getPersonal());//是否为本人
                m.put("callCode",log.getCallCode());//通话记录code
                m.put("callStatus",log.getCallStatus());//通话状态（1、正常通话，2、无人接听，3、拒接，4、占线，5、关机，6、停机，7、无法接通，8、空号错号）
                m.put("emphasis",log.getEmphasis());//是否重点患者（1、重点患者，2、非重点患者）
                m.put("followUp",log.getFollowUp());//是否跟进（1、无需跟进，2、待跟进）
                m.put("remark",log.getRemark());//备注
                m.put("returnVisit",log.getReturnVisit());//回访（1、有效回访，2、无效回访）
                resultMap.put("servicerLog",m);
                resultMap.put("haveNum",1);
            }
            resultMap.put("serviserRelationCode",workorderMap.get("serviserRelationCode"));
        }else{
            resultMap.put("haveNum",0);
        }
        return resultMap;
    }

    public int getRandom(int min, int max){
        if(max==0){
            return 0;
        }
        if (max==1){
            max=2;
        }
        Random random = new Random();
        int s = random.nextInt(max) % (max - min + 1) + min;
        return s;

    }


    /**
     *  获取取号信息
     *
     * @param workorderCode
     * @param townCode
     * @param hospitalCode
     * @param diseaseCode
     * @param healthCode
     * @param serveCode
     * @param isFollow
     * @return
     * @throws Exception
     */
    public JSONObject getWorkorderNum(String workorderCode,String townCode,String hospitalCode,
                                               String diseaseCode,String healthCode,String serveCode,Integer isFollow,Integer page,Integer pageSize) throws Exception{
        String whereSql ="";
        String leftSql ="";
        String orderBySql =" l.id desc";
        if(StringUtils.isNotEmpty(townCode)){
            whereSql+=" and s.town='"+townCode+"' ";
        }
        if(StringUtils.isNotEmpty(hospitalCode)){
            whereSql+=" and s.hospital='"+hospitalCode+"' ";
        }
        String labelSql ="";
//        if(StringUtils.isNotEmpty(diseaseCode)||StringUtils.isNotEmpty(healthCode)||StringUtils.isNotEmpty(serveCode)){
//            leftSql +=" LEFT JOIN wlyy_sign_patient_label_info i on i.patient=s.service_patient_code and i.status=1 " ;
//            if(StringUtils.isNotEmpty(diseaseCode)){
//                labelSql+=" or (i.label='"+diseaseCode+"' and i.label_type='3') ";//疾病类型
//            }
//            if(StringUtils.isNotEmpty(healthCode)){
//                labelSql+=" or (i.label='"+healthCode+"' and i.label_type='2') ";//健康情况
//            }
//            if(StringUtils.isNotEmpty(serveCode)){
//                labelSql+=" or (i.label='"+serveCode+"' and i.label_type='1') ";//服务类型
//            }
//        }
//        if(StringUtils.isNotEmpty(labelSql)){
//            whereSql+= " and ( "+labelSql.substring(3)+" )";
//        }
        if(StringUtils.isNotEmpty(serveCode)){
            leftSql+=" JOIN wlyy_sign_family f on f.patient=s.service_patient_code and f.status=1 " +
                    " JOIN wlyy_sign_family_server r on r.sign_code=f.code ";
            whereSql+=" and r.server_type='"+serveCode+"' ";
        }
        if(StringUtils.isNotEmpty(healthCode)||StringUtils.isNotEmpty(diseaseCode)){
            leftSql+=" JOIN (SELECT t.patient,GROUP_CONCAT(',',t.label_type,t.label,',') label FROM wlyy_sign_patient_label_info t " +
                    "JOIN manage_synergy_workorder_servicer v on v.service_patient_code=t.patient and v.workorder_code = '"+workorderCode+"' where t. STATUS = 1 GROUP BY t.patient ) aa on aa.patient=s.service_patient_code  ";
        }
        if(StringUtils.isNotEmpty(healthCode)){
            whereSql+=" and aa.label LIKE '%,2"+healthCode+",%' ";
        }
        if(StringUtils.isNotEmpty(diseaseCode)){
            whereSql+=" and aa.label LIKE '%,3"+diseaseCode+",%' ";
        }
        if(isFollow!=null&&isFollow==1){//跟进
            leftSql+=" LEFT JOIN manage_synergy_workorder_servicer_log ll on ll.workorder_service_code=s.code ";
            whereSql+=" and ll.follow_up=2 and ll.workorder_service_code not in (select DISTINCT lll.workorder_service_code from manage_synergy_workorder_servicer_log lll where lll.follow_up=1 and lll.workorder_code='"+workorderCode+"') ";
            orderBySql=" ll.id desc";
            whereSql+=" and s.status=3 ";
        }else{
            if (isFollow==0){
                whereSql+=" and s.status=1";
            }

        }
        String sql =" select DISTINCT w.*,s.mobile,s.service_patient_name,s.service_patient_code,s.code as servicerCode,s.town_name,s.hospital_name,s.status," +
                " w.create_user_name ,s.relation_code as serviserRelationCode " ;
        String sqlCenter = " from manage_synergy_workorder_servicer s " +
                " LEFT JOIN manage_synergy_workorder w on s.workorder_code=w.code " +
                " LEFT JOIN manage_synergy_workorder_executor e on e.workorder_code=w.code " + leftSql+
                " LEFT JOIN manage_synergy_workorder_customer_log l on l.workorder_service_code=s.service_patient_code " +
                " where s.workorder_code='"+workorderCode+"' " +
                " and w.del=1 and w.status=2 and e.del=1 "+
                whereSql;
        String orderSql =" order by s.status ASC,"+orderBySql;
        String sql1=" select count(1) as num ";
        String whereSql1=whereSql+" and l.id is not null ";
        List<Map<String,Object>> resultWorkorderListCount = jdbcTemplate.queryForList(sql1+sqlCenter+whereSql1);
        int count = resultWorkorderListCount.get(0).get("num")!=null?Integer.valueOf(resultWorkorderListCount.get(0).get("num")+""):0;
        List<Map<String,Object>> resultCount = jdbcTemplate.queryForList(sql1+sqlCenter+orderSql);
        int count1 = resultCount.get(0).get("num")!=null?Integer.valueOf(resultCount.get(0).get("num")+""):0;
        List<Map<String,Object>> resultWorkorderList = jdbcTemplate.queryForList(sql+sqlCenter+orderSql+"  LIMIT "+(page-1)*pageSize+","+pageSize);
        List<Map<String,Object>> resultMapList = new ArrayList<>();
        if(resultWorkorderList.size()>0){
            for (int i =0;i<resultWorkorderList.size();i++){
                Map<String,Object> resultMap = new HashMap<>();
                Map<String,Object> workorderMap = resultWorkorderList.get(i);
                //居民信息
                resultMap.put("mobile",workorderMap.get("mobile"));//电话号码
                resultMap.put("patientName",workorderMap.get("service_patient_name"));//居民姓名
                Integer callNum = customerLogDao.callNumByWorkorder(workorderMap.get("servicerCode")+"");
                resultMap.put("callNum",callNum);//已呼叫次数
                String mSql = "SELECT r.server_type_name,r.server_type FROM wlyy_sign_family f JOIN wlyy_sign_family_server r ON r.sign_code = f. CODE " +
                        "WHERE f.patient = '"+workorderMap.get("service_patient_code")+"'AND f. STATUS = 1";
                List<Map<String,Object>> mapList = jdbcTemplate.queryForList(mSql);
                StringBuffer buffer = new StringBuffer();
                for (int j=0;j<mapList.size();j++){
                    Map<String,Object> map = mapList.get(j);
                    String str = map.get("server_type_name").toString().substring(0,1);
                    if (str.contains("0")||str.contains("儿")){
                        str="幼";
                    }
                    if (str.contains("6")){
                        str="老";
                    }
                    buffer.append(str+" ");
                }
                resultMap.put("labelName",buffer);//疾病类型
                resultMap.put("status",workorderMap.get("status"));//是否跟进
                resultMap.putAll(this.getPatientInfo(workorderMap.get("service_patient_code") + ""));
                Patient patient =patientDao.findByCode(workorderMap.get("service_patient_code")+"");
                Integer sex = patient.getSex();
                String sexName ="";
                if(sex==1){
                    sexName="男";
                }else if(sex==2){
                    sexName="女";
                }else{
                    sexName="未知";
                }
                resultMap.put("sex",sexName);//性别
                Integer age = IdCardUtil.getAgeForIdcard(patient.getIdcard());
                resultMap.put("age",age);//年龄
                resultMap.put("townName",workorderMap.get("town_name"));//所属区县
                resultMap.put("hospital",null==workorderMap.get("hospital")?"":workorderMap.get("hospital")+"");//所属社区
                resultMap.put("reminder_type",null==workorderMap.get("reminder_type")?"":workorderMap.get("reminder_type")+"");//所属社区
                resultMap.put("hospitalName",workorderMap.get("hospital_name"));//所属社区
                SignFamily signFamily = signFamilyDao.findSignByPatient(workorderMap.get("service_patient_code")+"");
                resultMap.put("signDoctor",signFamily.getDoctorName());//签约医生（即：工单创建医生）
                resultMap.put("healthDoctor",signFamily.getDoctorHealthName());//健管师
                List<SignPatientLabelInfo> labelDiseaseType = signPatientLabelInfoDao.findByPatientAndLabelTypeAndStatus(workorderMap.get("service_patient_code")+"",  "3", 1);
                String diseaseType="";
                List<String> diseaseTypeList= new ArrayList<>();
                for(SignPatientLabelInfo one:labelDiseaseType){
                    diseaseType+=","+one.getLabelName();
                    diseaseTypeList.add(one.getLabel());
                }
                resultMap.put("diseaseType",StringUtils.isNotEmpty(diseaseType)?diseaseType.substring(1):"");//疾病类型
                resultMap.put("diseaseTypeCode",diseaseTypeList);//疾病类型code
                List<SignPatientLabelInfo> labelHealthType = signPatientLabelInfoDao.findByPatientAndLabelTypeAndStatus(workorderMap.get("service_patient_code")+"",  "2", 1);
                String healthType="";
                for(SignPatientLabelInfo one:labelHealthType){
                    healthType+=","+one.getLabelName();
                }
                resultMap.put("healthType",StringUtils.isNotEmpty(healthType)?healthType.substring(1):"");//健康情况
                String serveType="";
//            List<SignPatientLabelInfo> labelServeType = signPatientLabelInfoDao.findByPatientAndLabelTypeAndStatus(workorderMap.get("service_patient_code")+"",  "2", 1);
//            for(SignPatientLabelInfo one:labelServeType){
//                serveType+=","+one.getLabelName();
//            }
                List<Map<String,Object>> signTypes = jdbcTemplate.queryForList("SELECT s.server_type_name,s.server_type FROM wlyy_sign_family_server s right join wlyy_sign_family f on s.sign_code=f.code WHERE f.patient='"+workorderMap.get("service_patient_code")+"' and f.status=1 and f.expenses_status='1' ");
                for(Map<String,Object> one:signTypes){
                    serveType+=","+(one.get("server_type_name")!=null?one.get("server_type_name"):"");
                }
                resultMap.put("serveType",StringUtils.isNotEmpty(serveType)?serveType.substring(1):"");
//            resultMap.put("serveType",StringUtils.isNotEmpty(serveType)?serveType.substring(1):"");//服务类型
                resultMap.put("workorder",workorderMap.get("code"));//工单编号
                resultMap.put("patientCode",workorderMap.get("service_patient_code"));//居民code
                resultMap.put("doctorCode",workorderMap.get("create_user"));//创建人（医生）code
                //获取提交记录
                String servicerCode = workorderMap.get("servicerCode")+"";
                resultMap.put("servicerCode", servicerCode);
                List<ManageSynergyWorkorderServicerLogDO> list = manageSynergyWorkorderServicerLogDao.findByWorkorderServiceCode(servicerCode);
                if(list.size()>0){
                    ManageSynergyWorkorderServicerLogDO log = list.get(0);
                    Map<String,Object> m = new HashMap<>();
                    m.put("personal",log.getPersonal());//是否为本人
                    m.put("callCode",log.getCallCode());//通话记录code
                    m.put("callStatus",log.getCallStatus());//通话状态（1、正常通话，2、无人接听，3、拒接，4、占线，5、关机，6、停机，7、无法接通，8、空号错号）
                    m.put("emphasis",log.getEmphasis());//是否重点患者（1、重点患者，2、非重点患者）
                    m.put("followUp",log.getFollowUp());//是否跟进（1、无需跟进，2、待跟进）
                    m.put("remark",log.getRemark());//备注
                    m.put("returnVisit",log.getReturnVisit());//回访（1、有效回访，2、无效回访）
                    resultMap.put("servicerLog",m);
                    resultMap.put("haveNum",1);
                }
                resultMap.put("serviserRelationCode",workorderMap.get("serviserRelationCode"));
                resultMapList.add(resultMap);
            }
        }
        JSONObject object = new JSONObject();
        object.put("detailModelList",resultMapList);
        object.put("currPage",page);
        object.put("pageSize",pageSize);
        object.put("totalCount",count1);
        Integer totalPage = 0;
        if (count1 % pageSize == 0) {
            totalPage = count1 / pageSize;
        } else {
            totalPage = count1 / pageSize + 1;
        }
        object.put("totalPage",totalPage);
        return object;
    }

    /**
     * 将管理员接收或者退回操作存入数据库
     * @param code
     * @param user
     * @param jsonData
     * @param status 2、接收，4、退回
     */
    public void dealWorkOrder(String code, User user, String jsonData, Integer status) throws JSONException {
        ManageSynergyWorkorderDO workorderDO = workOrderDao.findByCode(code);
        workorderDO.setStatus(status);
        workorderDO.setReceiverType(user.getType());
        workorderDO.setReceiverCode(user.getCode());
        workorderDO.setReceiverName(user.getName());

        JSONObject jsonObject = new JSONObject(jsonData);
        if(status == 4){
            workorderDO.setReturnedRemark(jsonObject.getString("returnedRemark"));
            this.sendMessage(workorderDO, null, 26);
        }else if(status == 2){
            //设置接收时间
            workorderDO.setReceiverTime(new Date());
            //创建负责人信息
            List<ManageSynergyWorkorderExecutorDO> list = new ArrayList<>();
            String manager = jsonObject.getString("manager");
            String[] managers = manager.split(",");
            for(String m : managers){
                List<ManageSynergyWorkorderExecutorDO> workorderExecutorDOList = workorderExecutorDao.findByWorkorderCode(code,1);
                User managerUser = userDao.findByCode(m);
                if (workorderExecutorDOList == null||workorderExecutorDOList.size()==0){
                    ManageSynergyWorkorderExecutorDO executorDO = new ManageSynergyWorkorderExecutorDO();
                    executorDO.setCode(getCode());
                    executorDO.setWorkorderCode(code);
                    executorDO.setExecutorType(1);
                    executorDO.setExecutorCode(m);
                    executorDO.setExecutorName(managerUser.getName());
                    executorDO.setDel(1);
                    list.add(executorDO);
                }else {
                    ManageSynergyWorkorderExecutorDO executorDO = workorderExecutorDOList.get(0);
                    executorDO.setExecutorCode(m);
                    executorDO.setExecutorName(managerUser.getName());
                    list.add(executorDO);
                }
                this.sendMessage(workorderDO, managerUser, 25);
            }

            //保存协作者信息
            String collaborator = jsonObject.getString("collaborator");
            if(StringUtils.isNotBlank(collaborator)) {
                String[] collaborators = collaborator.split(",");
                List<ManageSynergyWorkorderExecutorDO> workorderExecutorDOS = workorderExecutorDao.findByWorkorderCode(code,2);
                for (ManageSynergyWorkorderExecutorDO workorderExecutorDO:workorderExecutorDOS){
                    if (!collaborator.contains(workorderExecutorDO.getExecutorCode())){
                        workorderExecutorDO.setDel(0);
                        list.add(workorderExecutorDO);
                    }
                }
                for (String c : collaborators) {
                    ManageSynergyWorkorderExecutorDO workorderExecutorDO  = workorderExecutorDao.findByWorkorderCodeAndExecutorCode(code,c,2);
                    if (workorderExecutorDO == null){
                        ManageSynergyWorkorderExecutorDO executorDO = new ManageSynergyWorkorderExecutorDO();
                        User u = userDao.findByCode(c);
                        executorDO.setCode(getCode());
                        executorDO.setWorkorderCode(code);
                        executorDO.setExecutorType(2);
                        executorDO.setExecutorCode(c);
                        executorDO.setExecutorName(u.getName());
                        executorDO.setDel(1);
                        list.add(executorDO);
                    }
                }
            }else {
                List<ManageSynergyWorkorderExecutorDO> workorderExecutorDOS = workorderExecutorDao.findByWorkorderCode(code,2);
                for (ManageSynergyWorkorderExecutorDO workorderExecutorDO:workorderExecutorDOS){
                    if (!collaborator.contains(workorderExecutorDO.getExecutorCode())){
                        workorderExecutorDO.setDel(0);
                        list.add(workorderExecutorDO);
                    }
                }
            }
            workorderExecutorDao.saveAll(list);
        }
        workOrderDao.save(workorderDO);
        //接受或者退回操作
        manageSynergyWorkorderReminderDao.updateDealWith(code);
    }


    public void batchDealWorkOrder(String code, User user, String jsonData, Integer status) throws JSONException {
        List<String> result = Arrays.asList(code.split(","));
        for (int i=0;i<result.size();i++){
            String code1 = result.get(i);
            ManageSynergyWorkorderDO workorderDO = workOrderDao.findByCode(code1);
            workorderDO.setStatus(status);
            workorderDO.setReceiverType(user.getType());
            workorderDO.setReceiverCode(user.getCode());
            workorderDO.setReceiverName(user.getName());

            JSONObject jsonObject = new JSONObject(jsonData);
            if(status == 4){
                workorderDO.setReturnedRemark(jsonObject.getString("returnedRemark"));
                this.sendMessage(workorderDO, null, 26);
            }else if(status == 2){
                //设置接收时间
                workorderDO.setReceiverTime(new Date());
                //创建负责人信息
                List<ManageSynergyWorkorderExecutorDO> list = new ArrayList<>();
                String manager = jsonObject.getString("manager");
                String[] managers = manager.split(",");
                for(String m : managers){
                    List<ManageSynergyWorkorderExecutorDO> workorderExecutorDOList = workorderExecutorDao.findByWorkorderCode(code1,1);
                    User managerUser = userDao.findByCode(m);
                    if (workorderExecutorDOList == null||workorderExecutorDOList.size()==0){
                        ManageSynergyWorkorderExecutorDO executorDO = new ManageSynergyWorkorderExecutorDO();
                        executorDO.setCode(getCode());
                        executorDO.setWorkorderCode(code1);
                        executorDO.setExecutorType(1);
                        executorDO.setExecutorCode(m);
                        executorDO.setExecutorName(managerUser.getName());
                        executorDO.setDel(1);
                        list.add(executorDO);
                    }else {
                        ManageSynergyWorkorderExecutorDO executorDO = workorderExecutorDOList.get(0);
                        executorDO.setExecutorCode(m);
                        executorDO.setExecutorName(managerUser.getName());
                        list.add(executorDO);
                    }
                    this.sendMessage(workorderDO, managerUser, 25);
                }

                //保存协作者信息
                String collaborator = jsonObject.getString("collaborator");
                if(StringUtils.isNotBlank(collaborator)) {
                    String[] collaborators = collaborator.split(",");
                    List<ManageSynergyWorkorderExecutorDO> workorderExecutorDOS = workorderExecutorDao.findByWorkorderCode(code1,2);
                    for (ManageSynergyWorkorderExecutorDO workorderExecutorDO:workorderExecutorDOS){
                        if (!collaborator.contains(workorderExecutorDO.getExecutorCode())){
                            workorderExecutorDO.setDel(0);
                            list.add(workorderExecutorDO);
                        }
                    }
                    for (String c : collaborators) {
                        ManageSynergyWorkorderExecutorDO workorderExecutorDO  = workorderExecutorDao.findByWorkorderCodeAndExecutorCode(code1,c,2);
                        if (workorderExecutorDO == null){
                            ManageSynergyWorkorderExecutorDO executorDO = new ManageSynergyWorkorderExecutorDO();
                            User u = userDao.findByCode(c);
                            executorDO.setCode(getCode());
                            executorDO.setWorkorderCode(code1);
                            executorDO.setExecutorType(2);
                            executorDO.setExecutorCode(c);
                            executorDO.setExecutorName(u.getName());
                            executorDO.setDel(1);
                            list.add(executorDO);
                        }
                    }
                }else {
                    List<ManageSynergyWorkorderExecutorDO> workorderExecutorDOS = workorderExecutorDao.findByWorkorderCode(code1,2);
                    for (ManageSynergyWorkorderExecutorDO workorderExecutorDO:workorderExecutorDOS){
                        if (!collaborator.contains(workorderExecutorDO.getExecutorCode())){
                            workorderExecutorDO.setDel(0);
                            list.add(workorderExecutorDO);
                        }
                    }
                }
                workorderExecutorDao.saveAll(list);
            }
            workOrderDao.save(workorderDO);
            //接受或者退回操作
            manageSynergyWorkorderReminderDao.updateDealWith(code1);
        }

    }


    /**
     * 获取上一次分配的信息
     *
     * @param code
     * @return
     */
    public Map<String,Object>  selectByWorkorder(String code){
        Map<String,Object> map = new  HashMap<>();
        List<ManageSynergyWorkorderExecutorDO> workorderExecutorDOS = workorderExecutorDao.findByWorkorderCode(code,1);
        map.put("managers",workorderExecutorDOS);
        List<ManageSynergyWorkorderExecutorDO> workorderExecutorDOS1 = workorderExecutorDao.findByWorkorderCode(code,2);
        map.put("collaborators",workorderExecutorDOS1);
        return map;
    }

    /**
     * 发送消息
     * @param workorderDO
     * @param user
     * @param type
     */
    public void sendMessage(ManageSynergyWorkorderDO workorderDO, User user, Integer type) throws JSONException {
        String url = wlyyUrl + "third/synergy/sendMessage";
        //组装message内容
        JSONObject message = new JSONObject();
        if(type == 24){
            message.put("receiver", workorderDO.getReceiverCode());
            message.put("sender", workorderDO.getCreateUser());
            message.put("type", type);
            message.put("relationCode", workorderDO.getCode());
        }else {
            message.put("sender", workorderDO.getReceiverCode());
            message.put("receiver", workorderDO.getCreateUser());
            message.put("type", type);
            message.put("relationCode", workorderDO.getCode());
        }
        //组装jsonObject内容
        JSONObject jsonObject = new JSONObject();
        Integer servicerType = workorderDO.getType();
        //协同服务类型
        if(servicerType == 1 || servicerType == 6){
            jsonObject.put("type", "健康教育");
        }else if(servicerType == 3){
            jsonObject.put("type", "随访");
        }else if(servicerType == 4){
            jsonObject.put("type", "调查问卷");
        }else if(servicerType == 5){
            jsonObject.put("type", "疾病筛查");
        }else if (servicerType == 7){
            jsonObject.put("type", "体检提醒");
        }else if(servicerType == 8){
            jsonObject.put("type", "体征测量");
        }else if (servicerType==9){
            jsonObject.put("type", "自定义");
        }
        if(type == 26){
            jsonObject.put("returnedRemark", workorderDO.getReturnedRemark());
        }else if(type == 25){
            jsonObject.put("customerName", user.getName());
            jsonObject.put("phone", user.getMobile());
        }
        Map<String, Object> params = new HashMap<>();
        params.put("message", message.toString());
        params.put("jsonObject", jsonObject.toString());
        try {
            String response = httpManageClientUtil.post(url, params);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    /**
     * 查找该客服该工单是否有异常工单
     * @param workorderCode
     * @param customerCode
     * @return
     */
    public Object isNotException(String workorderCode, String customerCode) {
        String sql = "SELECT cl.workorder_service_code  from manage_synergy_workorder_customer_log cl " +
                "where cl.workorder_service_code not in (SELECT l.workorder_service_code from manage_synergy_workorder_customer_log l where l.`status` = 1) " +
                "and cl.workorder_code = '" + workorderCode + "' and cl.create_user_code= '" + customerCode + "' " +
                "GROUP BY cl.workorder_code, cl.create_user_code " +
                "ORDER BY cl.create_time LIMIT 0, 1";
        List<Map<String, Object>> list = jdbcTemplate.queryForList(sql);
        if(list.size() > 0){
            return list.get(0).get("workorder_service_code");
        }
        return null;
    }

    public Map<String, Object> loadingInfo(String workorderServiceCode) {
        Map<String,Object> resultMap = new HashMap<>();
        ManageSynergyWorkorderServicerDO workorderServicerDO = workorderServicerDao.findByCode(workorderServiceCode);
        /*String sql = "SELECT s.service_patient_name, s.service_patient_code, s.`code`, s.s.hospital_name,s.town_name " +
                "from (SELECT DISTINCT r.patient,cl.workorder_code from manage_synergy_workorder_customer_log cl " +
                "LEFT JOIN manage_call_record r on cl.call_code = r.`code` " +
                "where cl.workorder_code = '" + workorderCode + "' and cl.create_user_code = '" + customerCode + "' and cl.`status` = 0 ORDER BY cl.create_time LIMIT 0,1) p " +
                "LEFT JOIN manage_synergy_workorder_servicer s on p.workorder_code = s.workorder_code and s.service_patient_code = p.patient and s.`status`=1";

        Map<String, Object> result = (Map<String, Object>) jdbcTemplate.queryForList(sql);
        String patientCode = (String) result.get("service_patient_name");
        */
        String patientCode = workorderServicerDO.getServicePatientCode();
        resultMap.put("patientName", workorderServicerDO.getServicePatientName());
        resultMap.put("townName", workorderServicerDO.getTownName());//所属区县
        resultMap.put("hospitalName", workorderServicerDO.getHospitalName());//所属社区
        Integer callNum = customerLogDao.callNumByWorkorder(workorderServiceCode);
        resultMap.put("callNum",callNum);//已呼叫次数
        resultMap.putAll(this.getPatientInfo(patientCode));
        return resultMap;
    }

    public Map<String,Object> getPatientInfo(String patientCode){
        Map<String, Object> resultMap = new HashMap<>();
        Patient patient = patientDao.findByCode(patientCode);
        Integer sex = patient.getSex();
        String sexName = "";
        if(sex == 1){
            sexName = "男";
        }else if(sex == 2){
            sexName = "女";
        }else{
            sexName = "未知";
        }
        resultMap.put("sex", sexName);//性别
        Integer age = IdCardUtil.getAgeForIdcard(patient.getIdcard());
        resultMap.put("age",age);//年龄
        SignFamily signFamily = signFamilyDao.findSignByPatient(patientCode);
        resultMap.put("signDoctor", signFamily.getDoctorName());//签约医生（即：工单创建医生）
        resultMap.put("healthDoctor", signFamily.getDoctorHealthName());//健管师
        List<SignPatientLabelInfo> labelDiseaseType = signPatientLabelInfoDao.findByPatientAndLabelTypeAndStatus(patientCode,  "3", 1);
        String diseaseType="";
        for(SignPatientLabelInfo one:labelDiseaseType){
            diseaseType+=","+one.getLabelName();
        }
        resultMap.put("diseaseType", StringUtils.isNotEmpty(diseaseType) ? diseaseType.substring(1) : "");//疾病类型
        List<SignPatientLabelInfo> labelHealthType = signPatientLabelInfoDao.findByPatientAndLabelTypeAndStatus(patientCode,  "2", 1);
        String healthType="";
        for(SignPatientLabelInfo one:labelHealthType){
            healthType += ","+one.getLabelName();
        }
        resultMap.put("healthType", StringUtils.isNotEmpty(healthType) ? healthType.substring(1) : "");//健康情况
        List<SignPatientLabelInfo> labelServeType = signPatientLabelInfoDao.findByPatientAndLabelTypeAndStatus(patientCode,  "1", 1);
        String serveType="";
        for(SignPatientLabelInfo one:labelServeType){
            serveType+=","+one.getLabelName();
        }
        resultMap.put("serveType", StringUtils.isNotEmpty(serveType)?serveType.substring(1) : "");//服务类型
        return resultMap;
    }

    /**
     * 任务进度
     * @param workorderCode
     * @param userCode
     */
    public Map<String,Object> workorderRate(String workorderCode,String userCode){
        Map<String,Object> resultMap = new HashMap<>();
        //完成情况
        //1、有效
//        Integer validCount = workorderServicerDao.findByWorkorderCodeCount(workorderCode,3);
        Integer validCount = manageSynergyWorkorderServicerLogDao.findByWorkorderCodeAndReturnVisit(workorderCode);
        resultMap.put("validCount",validCount);
        //2、无效
        Integer allCount = manageSynergyWorkorderServicerLogDao.findByWorkorderCode(workorderCode);
        resultMap.put("invalidCount",allCount-validCount);
        //3、总数
        ManageSynergyWorkorderDO manageSynergyWorkorder = workOrderDao.findByCode(workorderCode);
        resultMap.put("allCount",manageSynergyWorkorder.getServicerCount());
        //我已完成
        Integer myFinishedCount = workorderServicerDao.countByWorkorderCodeAndExecutorCodeAndStatus(workorderCode,userCode,3);
        resultMap.put("myFinishedCount",myFinishedCount);
        //待跟进
        Integer followCount = manageSynergyWorkorderServicerLogDao.findByWorkorderCodeAndFollowUp(workorderCode);
        resultMap.put("followCount",followCount);
        return resultMap;
    }

    /**
     * 催单
     * @param workorderCode
     * @param userCode
     * @param userType
     * @throws Exception
     */
    @Transactional
    public Integer reminder(String workorderCode,String userCode,Integer userType) throws Exception{

        Integer reminderStatus = reminderStatus(workorderCode);
        if(reminderStatus==3||reminderStatus==4){
            return reminderStatus;
        }
        ManageSynergyWorkorderDO manageSynergyWorkorderDO = workOrderDao.findByCode(workorderCode);
        if(manageSynergyWorkorderDO==null){
            throw new Exception();
        }
        ManageSynergyWorkordeReminderDO workordeReminderDO = new ManageSynergyWorkordeReminderDO();
        workordeReminderDO.setCode(getCode());
        workordeReminderDO.setWorkorderCode(workorderCode);
        workordeReminderDO.setCreateUser(userCode);
        //创建人类型（1、医生，2、客服，3、客服负责人）
        if(userType==1){
            Doctor doctor = doctorDao.findByCode(userCode);
            workordeReminderDO.setCreateUserName(doctor.getName());
        }else if(userType==2||userType==3){
            User user = userDao.findByCode(userCode);
            workordeReminderDO.setCreateUserName(user.getName());
        }
        workordeReminderDO.setCreateUserType(userType);
        workordeReminderDO.setHospital(manageSynergyWorkorderDO.getHospital());
        workordeReminderDO.setHospitalName(manageSynergyWorkorderDO.getHospitalName());
        workordeReminderDO.setCreateTime(new Date());
        List<ManageSynergyWorkorderExecutorDO> list = workorderExecutorDao.findByWorkorderCode(workorderCode,1);
        if(list!=null&&list.size()>0){
            workordeReminderDO.setPrincipalCode(list.get(0).getExecutorCode());
            workordeReminderDO.setPrincipalName(list.get(0).getExecutorName());
        }
        workordeReminderDO.setWorkorderType(manageSynergyWorkorderDO.getType());
        workordeReminderDO.setRelationCode(manageSynergyWorkorderDO.getRelationCode());
        workordeReminderDO.setRelationCodeName(manageSynergyWorkorderDO.getRelationCodeName());

        workordeReminderDO.setServiceTime(manageSynergyWorkorderDO!=null?manageSynergyWorkorderDO.getServiceTime():null);
        workordeReminderDO.setServicerKey(manageSynergyWorkorderDO!=null?manageSynergyWorkorderDO.getServicerKey():null);
        workordeReminderDO.setWorkorderRemark(manageSynergyWorkorderDO!=null?manageSynergyWorkorderDO.getRemark():null);
        workordeReminderDO.setDealWith(0);
        workordeReminderDO.setPriority(manageSynergyWorkorderDO.getPriority());
        manageSynergyWorkorderReminderDao.save(workordeReminderDO);
        return reminderStatus;
    }

    public Integer reminderStatus(String workorderCode) throws Exception{
        Integer reminderStatus=4;//默认是不满足催单条件
        ManageSynergyWorkorderDO workorderDO = workOrderDao.findByCode(workorderCode);
        //工单状态（0、草稿，1、未接受，2、处理中，3、处理完成，4、退回）
        //1、当单子超过1小时扔未被接收或退回时
        //2、当单子被接收后，如果距离服务时间小于4小时，则允许用户进行催单操作。
        //3、当已催促过客服时，再次催单
        //4、不满足催单条件时
        List<ManageSynergyWorkordeReminderDO> list = manageSynergyWorkorderReminderDao.findByWorkorderCodeAndDealWith(workorderCode,0);
        if(workorderDO.getStatus()==1){
            if(list.size()>0){
                reminderStatus=3;
            }else{
                //单子超过1小时
                long h1= 60*60*1000L;
                if(new Date().getTime()-workorderDO.getCreateTime().getTime()>h1){
                    reminderStatus=1;
                }
            }
        }else if(workorderDO.getStatus()==2){
            if(list.size()>0){
                reminderStatus=3;
            }else{
                //距离服务时间小于4小时
                long h4= 4*60*60*1000L;
                if(workorderDO.getServiceTime().getTime()-new Date().getTime()<h4){
                    reminderStatus=2;
                }
            }
        }
        return reminderStatus;
    }

    /**
     * 催单列表
     * @param userCode
     * @param receiveType 1、客服，2、客服负责人
     * @param sortType 1、升序，2、降序
     */
    public Map<String,Object> reminderList(String userCode,Integer receiveType,Integer sortType,Integer page,Integer pageSize){
        String sql ="";
        String sort ="";
        if(sortType==1){
            sort=" order by r.create_time asc ";
        }else if(sortType==2){
            sort=" order by r.create_time desc ";
        }
        if(receiveType==1){
            sql =" select DISTINCT r.* from manage_synergy_workorder_reminder r " +
                 " LEFT JOIN manage_synergy_workorder_executor e on r.workorder_code=e.workorder_code " +
                 " where e.executor_code='"+userCode+"' and e.del=1 and r.deal_with=0 " +sort;
        }else if(receiveType==2){
            sql =" select r.* from manage_synergy_workorder_reminder r " +
                 " LEFT JOIN manage_synergy_workorder w on r.workorder_code=w.code where w.status=1 and r.deal_with=0 "+sort;
        }
        List<Map<String,Object>> rstotal = jdbcTemplate.queryForList(sql);
        int count = 0;
        if(rstotal!=null&&rstotal.size()>0&&rstotal.get(0).get("id")!=null){
            count = rstotal.size();
        }
        String finalSql = sql+" LIMIT "+(page-1)*pageSize+","+pageSize;
        List<Map<String,Object>> List = jdbcTemplate.queryForList(finalSql);
        List<Map<String,Object>> resultList = new ArrayList<>();
        for(Map<String,Object> one:List){
            Map<String,Object> resultMap = new HashMap<>();
            resultMap.put("workorderCode",one.get("workorder_code"));
            resultMap.put("title","来自"+one.get("create_user_name")+"医生（"+one.get("hospital_name")+"）催单，请尽快处理（服务编号："+one.get("workorder_code")+"）");//标题
            String workorderTypeName ="";
            Integer workorderType = (Integer) one.get("workorder_type");
            switch (workorderType){
                case 0: workorderTypeName="咨询";break;
                case 1: workorderTypeName="健康教育";break;
                case 2: workorderTypeName="预约";break;
                case 3: workorderTypeName="随访";break;
                case 4: workorderTypeName="问卷调查";break;
                case 5: workorderTypeName="疾病筛查";break;
                case 9:workorderTypeName="自定义";break;
            }
            resultMap.put("workorderTypeName",workorderTypeName);
            resultMap.put("workorderType",one.get("workorder_type"));
            resultMap.put("priority",one.get("priority"));
            resultMap.put("relationCode",one.get("relation_code"));
            resultMap.put("relationCodeName",one.get("relation_code_name"));
            resultMap.put("serviceTime",DateUtil.dateToStr((Date)one.get("service_time"),"yyyy-MM-dd HH:mm:ss"));
            resultMap.put("reminderTime",DateUtil.dateToStr((Date)one.get("create_time"),"yyyy-MM-dd HH:mm:ss"));
            resultMap.put("servicerKey",one.get("servicer_key"));
            resultMap.put("workorderRemark",one.get("workorder_remark"));
            resultMap.put("isRead",one.get("is_read"));
            resultMap.put("code",one.get("code"));
            Integer overTimeFlag = isServiceOverTime((Date)one.get("service_time"));
            resultMap.put("overTimeFlag",overTimeFlag);
            resultList.add(resultMap);
        }
        Map<String,Object> resultMap = new HashMap<>();
        resultMap.put("currPage",page);
        resultMap.put("pageSize",pageSize);
        resultMap.put("totalCount",count);
        resultMap.put("detailModelList",resultList);
        return resultMap;
    }

    /**
     * 创建工单
     *
     * @param manageSynergyWorkorderDO
     * @param manageSynergyWorkorderServicerDOS
     */
    public void createWorkorder(ManageSynergyWorkorderDO manageSynergyWorkorderDO,List<ManageSynergyWorkorderServicerDO> manageSynergyWorkorderServicerDOS){
        manageSynergyWorkorderDO.setCode(getWorkorderNo());
        manageSynergyWorkorderDO.setDel(1);
        manageSynergyWorkorderDO.setCreateTime(new Date());
        manageSynergyWorkorderDO.setStatus(1);
        ManageSynergyWorkorderDO manageSynergyWorkorderDO1 = workOrderDao.save(manageSynergyWorkorderDO);
        for (ManageSynergyWorkorderServicerDO servicerDO:manageSynergyWorkorderServicerDOS){
            servicerDO.setWorkorderType(manageSynergyWorkorderDO1.getType());
            servicerDO.setWorkorderCode(manageSynergyWorkorderDO1.getCode());
            servicerDO.setRelationCode(manageSynergyWorkorderDO1.getRelationCode());
            servicerDO.setCreateTime(new Date());
            servicerDO.setStatus(1);
            servicerDO.setCode(getCode());
            servicerDO.setRelationCodeName(manageSynergyWorkorderDO1.getRelationCodeName());
            workorderServicerDao.save(servicerDO);
        }
    }


    /**
     * 更新工单
     *
     * @param manageSynergyWorkorderDO
     */
    public void updateWorkorder(ManageSynergyWorkorderDO manageSynergyWorkorderDO){
        ManageSynergyWorkorderDO  manageSynergyWorkorderDO1 = workOrderDao.findByCode(manageSynergyWorkorderDO.getCode());
        if(StringUtils.isNoneBlank(manageSynergyWorkorderDO.getRelationCodeName())){
            manageSynergyWorkorderDO1.setRelationCodeName(manageSynergyWorkorderDO.getRelationCodeName());
        }
        manageSynergyWorkorderDO1.setPriority(manageSynergyWorkorderDO.getPriority());
        manageSynergyWorkorderDO1.setServiceTime(manageSynergyWorkorderDO.getServiceTime());
        manageSynergyWorkorderDO1.setRemark(manageSynergyWorkorderDO.getRemark());
        manageSynergyWorkorderDO1.setStatus(1);
        workOrderDao.save(manageSynergyWorkorderDO1);
        if (manageSynergyWorkorderDO1.getType()==9){
            ManageSynergyWorkorderArticleDo articleDo = manageSynergyWorkorderArticleDao.findById(Long.parseLong(manageSynergyWorkorderDO1.getRelationCode())).get();
            articleDo.setTitle(manageSynergyWorkorderDO.getRelationCodeName());
            articleDo.setContent(manageSynergyWorkorderDO.getArticleContent());
            manageSynergyWorkorderArticleDao.save(articleDo);
        }
    }

    public String findByPatient(String patient){
        String response = null;
        String url = wlyyUrl + "third/synergy/findByPatient";
        Map<String,String> params = new HashMap<>();
        params.put("patient",patient);
        try {
            response = httpManageClientUtil.httpPost(url, params);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return response;
    }


    /**
     * 获取随访数据
     *
     * @param id
     * @param followupProject
     * @return
     */
    public String getFollowupProjectData(String id,String followupProject){
        String response = null;
        String url = wlyyUrl + "third/synergy/getFollowupProjectData";
        Map<String,String> params = new HashMap<>();
        params.put("id",id);
        params.put("followupProject",followupProject);
        String data = null;
        try {
            response = httpManageClientUtil.httpPost(url, params);
            com.alibaba.fastjson.JSONObject object = JSON.parseObject(response);
            if(object.getInteger("status")==200){
                data = object.getJSONObject("data").toJSONString();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return data;
    }

    /**
     * 药品列表
     *
     * @param name
     * @param isinsulin
     * @return
     */
    public String findDictByName(String name,String isinsulin,String doctor){
        String response = null;
        String url = wlyyUrl + "third/synergy/findDictByName";
        Map<String,String> params = new HashMap<>();
        params.put("name",name);
        params.put("isinsulin",isinsulin);
        params.put("doctor",doctor);
        String data = null;
        try {
            response = httpManageClientUtil.httpPost(url, params);
            com.alibaba.fastjson.JSONObject object = JSON.parseObject(response);
            if(object.getInteger("status")==200){
                data = object.getJSONArray("data").toJSONString();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return data;
    }


    /**
     * 保存药品
     *
     * @param id
     * @param drugsData
     * @return
     */
    public String saveFollowupDrugs(String id,String drugsData){
        String response = null;
        String url = wlyyUrl + "third/synergy/saveFollowupDrugs";
        Map<String,String> params = new HashMap<>();
        params.put("id",id);
        params.put("drugsData",drugsData);
        String data = null;
        try {
            response = httpManageClientUtil.httpPost(url, params);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return data;
    }



    /**
     * 添加随访计划
     *
     * @param doctor
     * @param patient
     * @param date
     * @param followupType
     * @param followupClass
     * @param followupManagerStatus
     * @param plandate
     */
    public String addFollowup(String doctor,String patient, String date, String followupType,String followupClass,String followupManagerStatus,String plandate){
        String response = null;
        String url = wlyyUrl + "third/synergy/addFollowup";
        Map<String, Object> params = new HashMap<>();
        params.put("doctor",doctor);
        params.put("patient",patient);
        params.put("date",date);
        params.put("followupType",followupType);
        params.put("followupClass",followupClass);
        params.put("plandate",plandate);
        try {
            response = httpManageClientUtil.post(url, params);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return response;
    }

    public com.alibaba.fastjson.JSONObject getFollowup(String id){
        String response = null;
        String url = wlyyUrl + "third/synergy/getFollowup";
        Map<String, Object> params = new HashMap<>();
        params.put("id",id);
        com.alibaba.fastjson.JSONObject object = new com.alibaba.fastjson.JSONObject();
        try {
            response = httpManageClientUtil.post(url, params);
            com.alibaba.fastjson.JSONObject jsonObject = com.alibaba.fastjson.JSONObject.parseObject(response);
            if (jsonObject != null){
                if (jsonObject.getInteger("status") == 200){
                    object = jsonObject.getJSONObject("data");
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return object;
    }

    public com.alibaba.fastjson.JSONObject getLastFollowup(String doctor, String patient, String followClass){
        String response = null;
        String url = wlyyUrl + "third/synergy/getLastFollowup";
        Map<String, Object> params = new HashMap<>();
        params.put("doctor",doctor);
        params.put("patient",patient);
        params.put("followClass",followClass);
        com.alibaba.fastjson.JSONObject object = new com.alibaba.fastjson.JSONObject();
        try {
            response = httpManageClientUtil.post(url, params);
            com.alibaba.fastjson.JSONObject jsonObject = com.alibaba.fastjson.JSONObject.parseObject(response);
            if (jsonObject != null){
                if (jsonObject.getInteger("status") == 200){
                    object = jsonObject.getJSONObject("data");
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return object;
    }

    public String copyFollowup(Long id, Long fromId){
        String response = null;
        String url = wlyyUrl + "third/synergy/copyFollowup";
        Map<String, Object> params = new HashMap<>();
        params.put("id",id);
        params.put("fromId",fromId);
        try {
            response = httpManageClientUtil.post(url, params);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return response;
    }

    /**
     * 保存随访数据
     * @param id
     * @param followup
     * @return
     */
    public String saveFollowupProjectData(String id,String followup){
        String response = null;
        String url = wlyyUrl + "third/synergy/saveFollowupProjectData";
        Map<String, Object> params = new HashMap<>();
        params.put("id",id);
        params.put("followup",followup);
        try {
            response = httpManageClientUtil.post(url, params);
        } catch (Exception e) {
            e.printStackTrace();
        }
        return response;
    }


    @Transactional
    public void taskSubmit(String userCode,String workorderCode,String dealResultRemark,String accessoryJson) throws Exception{
        JSONArray jsonArray = new JSONArray(accessoryJson);
        String fileName;
        String url;
        List<ManageSynergyAccessoryDO> accessoryList = new ArrayList<>();
        for(int i=0;i<jsonArray.length();i++){
            fileName = jsonArray.getJSONObject(i).get("name")+"";
            url = jsonArray.getJSONObject(i).get("url")+"";
            String[] fs = fileName.split("\\.");
            String format = fs[1];
            //图片常见格式：bmp,jpg,png,tif,gif,pcx,tga,exif,fpx,svg,psd,cdr,pcd,dxf,ufo,eps,ai,raw,WMF,webp
            List img = new ArrayList(Arrays.asList("bmp","jpg","png","tif","gif","pcx","tga","exif","fpx","svg","psd","cdr","pcd","dxf","ufo","eps","ai","raw","WMF","webp"));
            Integer type =null;
            if(img.contains(format)){
                type=3;
            }else if("docx".equals(format)||"doc".equals(format)){
                type=2;
            }else if("xls".equals(format)||"xlsx".equals(format)){
                type=1;
            }
            ManageSynergyAccessoryDO manageSynergyAccessoryDO = new ManageSynergyAccessoryDO();
            manageSynergyAccessoryDO.setCode(getCode());
            manageSynergyAccessoryDO.setDel(0);
            manageSynergyAccessoryDO.setName(fileName);
            manageSynergyAccessoryDO.setUrl(url);
            manageSynergyAccessoryDO.setWorkorderCode(workorderCode);
            manageSynergyAccessoryDO.setType(type);
            accessoryList.add(manageSynergyAccessoryDO);
        }
        manageSynergyAccessoryDao.saveAll(accessoryList);
        User user = userDao.findByCode(userCode);
        workorderServicerDao.updateWorkorderServicer(workorderCode,userCode,user.getName(),1);
        ManageSynergyWorkorderDO manageSynergyWorkorderDO = workOrderDao.findByCode(workorderCode);
        manageSynergyWorkorderDO.setDealResultRemark(dealResultRemark);
        manageSynergyWorkorderDO.setStatus(3);
        manageSynergyWorkorderDO.setCompleteTime(new Date());
        workOrderDao.save(manageSynergyWorkorderDO);
        sendMessage(manageSynergyWorkorderDO ,user, 27);
        //提交操作，更新催单状态
        manageSynergyWorkorderReminderDao.updateDealWith(workorderCode);
    }

    public JSONObject getLabels(String labelType) throws JSONException {
        String url = wlyyUrl + "/wlyygc/doctor/label/labels?labelType=" + labelType;
        String response = httpManageClientUtil.get(url, "UTF-8");
        JSONObject jsonObject = new JSONObject(response);
        return  jsonObject;
    }

    public JSONObject getUnitLabels(String currentRoleCode, String currentRoleLevel) throws JSONException {
        String url = wlyyUrl + "/wlyygc/doctor/label/unitLabels?currentRoleCode=" + currentRoleCode + "&currentRoleLevel=" + currentRoleLevel;
        String response = httpManageClientUtil.get(url, "UTF-8");
        JSONObject jsonObject = new JSONObject(response);
        return  jsonObject;
    }

    /**
     * 到处Excel表
     * @param code
     * @param keywords
     * @param workorderType
     * @param isMyTask
     * @param status
     * @param priority
     * @param timeout
     * @param workorderCode
     * @param principal
     * @param serviceStartTime
     * @param serviceEndTime
     * @param patientName
     * @param ssc
     * @param idcard
     * @param userType
     * @param isAcceptTask
     * @param response
     * @throws Exception
     */
    public void exportWorkorder(String code,String keywords,Integer workorderType,
                                Integer isMyTask,Integer status,Integer priority,Integer timeout,String workorderCode,
                                String principal,String serviceStartTime,String serviceEndTime,
                                String patientName,String ssc,String idcard,Integer userType,Integer isAcceptTask,String userName,String hospitalName,Integer isRead,
                                HttpServletResponse response) throws Exception{
        WritableWorkbook wwb = null;
        OutputStream os = null;
        try{

            String servicerTable = " left join wlyy.manage_synergy_workorder_executor e on e.workorder_code=w.code AND e.del = 1  " ;
            String whereSql = "";
            if(userType==3){//客服管理员
                whereSql +=" and w.create_user_type=1 ";//创建人为医生
                if(isAcceptTask==3){//待接收
                    whereSql +=" and w.status =1 ";
                    servicerTable ="";
                }else if(isAcceptTask==4){//已接收
                    whereSql +=" and w.status in (2,3) ";
                }
            }else if(userType==2){//客服
                if(isAcceptTask==1){//我接收
                    whereSql +=" and w.create_user_type=1 ";//创建人为医生
                    whereSql += " and e.executor_code ='"+code+"' ";
                }else if(isAcceptTask==2){//我派发
                    whereSql +=" and w.create_user_type=2 ";//创建人为客服
                    whereSql += " and w.create_user ='"+code+"' ";
                }
            }else if(userType==1){//医生
                if(isAcceptTask==1){//我接收
                    whereSql +=" and w.create_user_type=2 ";//创建人为客服
                    whereSql += " and e.executor_code ='"+code+"' ";
                }else if(isAcceptTask==2){//我派发
                    whereSql += " and w.create_user_type=1 ";//创建人为医生
                    whereSql += " and w.create_user ='"+code+"' ";
                    whereSql += " and w.create_user_role=1 ";
                }
            }else if(userType==4){//医生管理员
                if(isAcceptTask==2){
                    whereSql += " and w.create_user_type=1 ";//创建人为医生
                    whereSql += " and w.create_user ='"+code+"' ";
                    whereSql += " and w.create_user_role=2 ";
                }
            }

            //关键字查询
            servicerTable +=" left join wlyy.manage_synergy_workorder_servicer s on s.workorder_code=w.code ";
            if(StringUtils.isNotEmpty(keywords)){
                whereSql += " and w.servicer_count<=10  ";
                whereSql += " and (w.create_user_name like '%"+keywords+"%' or s.service_patient_name like '%"+keywords+"%' " +
                        " or s.ssc like '%"+keywords+"%' or s.idcard like '%"+keywords+"%' ) ";
            }
            //判断是否未读
            if(isRead!=null){
                whereSql += " and w.is_read ="+isRead+" ";
            }
            //服务类型
            if(workorderType!=null){
                whereSql += " and w.type ="+workorderType+" ";
            }
            //是否是我负责的
            if(isMyTask!=null){
                whereSql += " and e.executor_code ='"+code+"' and e.executor_type=1 ";
            }
            //工单状态
            if(status!=null){
                whereSql +=" and w.status ="+status+" ";
            }
            //优先级
            if(priority!=null){
                whereSql+= " and w.priority="+priority+" ";
            }
            //是否超时
            if(timeout!=null){
                if(timeout==1){
                    whereSql +=" and w.service_time >'"+DateUtil.dateToStrLong(new Date())+"' ";
                }else if(timeout==2){
                    whereSql +=" and w.service_time <='"+DateUtil.dateToStrLong(new Date())+"' ";
                }
            }
            //服务编码
            if(StringUtils.isNotEmpty(workorderCode)){
                whereSql+=" and w.code like '%"+workorderCode+"%' ";
            }
            //负责人
            if(StringUtils.isNotEmpty(principal)){
                whereSql+=" and e.code like '%"+principal+"%' and e.executor_type=1 ";
            }
            //服务时间
            if(StringUtils.isNotEmpty(serviceStartTime)){
                whereSql+=" and w.service_time>='"+serviceStartTime+"' ";
            }
            if(StringUtils.isNotEmpty(serviceEndTime)){
                whereSql+=" and w.service_time<='"+serviceEndTime+"' ";
            }
            //服务对象
            if(StringUtils.isNotEmpty(patientName)){
                whereSql+=" and s.service_patient_name like '%"+keywords+"%' ";
            }
            //社保卡号
            if(StringUtils.isNotEmpty(ssc)){
                whereSql+=" and s.ssc like '%"+keywords+"%' ";
            }
            //身份证号
            if(StringUtils.isNotEmpty(idcard)){
                whereSql+=" and s.idcard like '%"+keywords+"%' ";
            }
            //需求方
            if(StringUtils.isNotEmpty(userName)){
                whereSql+=" and w.create_user_name like '%"+userName+"%' ";
            }
            if(StringUtils.isNotEmpty(hospitalName)){
                whereSql+=" and w.hospital_name like '%"+hospitalName+"%' ";
            }
            String sql =" select DISTINCT w.* from wlyy.manage_synergy_workorder w  " +servicerTable+

                    " where w.del=1  " +
                    " and 1=1 "+whereSql+ " order by w.priority desc,w.service_time desc";
            List<Map<String,Object>> list = jdbcTemplate.queryForList(sql);

            //生成excel
            response.setCharacterEncoding("utf-8");
            response.setContentType("octets/stream");
            response.setHeader("Content-Disposition", "attachment; filename="+ new String( "synergyManageList.xls"));
            os = response.getOutputStream();
            wwb = Workbook.createWorkbook(os);
            WritableSheet ws = wwb.createSheet("sheet",1);
            List<String> header = null;
            if(isAcceptTask==1||isAcceptTask==4){//我接收的任务
                header = new ArrayList<>(Arrays.asList("服务编号","服务类型","创建时间","服务对象","工单状态","需求方","负责人"));
            }else if(isAcceptTask==2){//我派发的任务
                header = new ArrayList<>(Arrays.asList("服务编号","服务类型","创建时间","服务对象","工单状态","家庭医生","所属机构"));
            }else if(isAcceptTask==3){
                header = new ArrayList<>(Arrays.asList("服务编号","服务类型","服务时间","服务对象","备注","需求方"));
            }
            int i = 0;
            for (String h : header) {
                addCell(ws, 0, i, h);//表名，行，列，header
                i++;
            }
            Integer workorderTypeR = null;
            String workorderTypeName = null;
            Date createTime = null;
            Date serviceTime =null;
            i=1;
            for(Map<String,Object> one:list){
                workorderTypeR = (Integer) one.get("type");
                createTime = (Date)one.get("create_time");
                serviceTime = (Date)one.get("service_time");
                addCell(ws, i, 0, one.get("code")+"","");
                switch (workorderTypeR){
                    case 0: workorderTypeName="咨询";break;
                    case 1: workorderTypeName="健康教育";break;
                    case 2: workorderTypeName="预约";break;
                    case 3: workorderTypeName="随访";break;
                    case 4: workorderTypeName="问卷调查";break;
                    case 5: workorderTypeName="疾病筛查";break;
                }
                addCell(ws, i, 1, workorderTypeName,"");
                if(isAcceptTask==3){
                    addCell(ws, i, 2, DateUtil.dateToStr(serviceTime,"yyyy--MM-dd HH:mm:ss"),"");
                }else{
                    addCell(ws, i, 2, DateUtil.dateToStr(createTime,"yyyy--MM-dd HH:mm:ss"),"");
                }
                if(isAcceptTask==1||isAcceptTask==3||isAcceptTask==4){//我接收的任务
                    String[] servicer = (one.get("servicer_key")+"").split(",");
                    Integer servicerCount = (Integer) one.get("servicer_count");
                    addCell(ws, i, 3, servicer[0]+"等"+servicerCount+"人","");
                }else if(isAcceptTask==2){//我派发的任务
                    String[] servicer = (one.get("servicer_key")+"").split(",");
                    addCell(ws, i, 3, servicer[0],"");
                }
//                addCell(ws, i, 4, statusName,"");
                String statusName="";
                Integer statusR = (Integer) one.get("status");
                switch (statusR){
                    case 0:statusName="草稿";break;
                    case 1:statusName="未接受";break;
                    case 2:statusName="处理中";break;
                    case 3:statusName="处理完成";break;
                    case 4:statusName="退回";break;
                }
                if(isAcceptTask==3){
                    addCell(ws, i, 4, one.get("remark")+"","");
                }else{
                    addCell(ws, i, 4, statusName,"");
                }
                addCell(ws, i, 5, one.get("create_user_name")+"","");//需求方
                if(isAcceptTask==1||isAcceptTask==4){//我接收的任务
                    List<ManageSynergyWorkorderExecutorDO> managerList = workorderExecutorDao.findByWorkorderCode(one.get("code")+"",1);
                    String managerName = managerList.size()>0?managerList.get(0).getExecutorName():"";
                    addCell(ws, i, 6, managerName,"");//负责人
                }else if(isAcceptTask==2) {//我派发的任务
                    addCell(ws, i, 6, one.get("hospital_name")+"","");//所属机构
                }
//                if(isAcceptTask!=3){
//
//                    addCell(ws, i, 7, one.get("content")+"","");//服务内容
//                }
                i++;
            }
            wwb.write();
            os.flush();
        }catch (Exception e) {
            e.printStackTrace();
            if(os!=null)os.close();
            throw e;
        }finally {

            if (wwb != null) wwb.close();
        }
    }

    //添加单元格内容
    public void addCell(WritableSheet ws, int row, int column, String data, String memo) throws WriteException {
        Label label = new Label(column ,row, data);
        if(!org.springframework.util.StringUtils.isEmpty(memo)){
            WritableCellFeatures cellFeatures = new WritableCellFeatures();
            cellFeatures.setComment(memo);
            label.setCellFeatures(cellFeatures);
        }
        ws.addCell(label);
    }
    //添加单元格内容
    public void addCell(WritableSheet ws, int row, int column,  String data) throws WriteException {
        Label label = new Label(column ,row, data);
        ws.addCell(label);
    }

    public JSONObject getDealList(String idcard) throws JSONException {
        Patient patient = patientDao.findByIdcard(idcard);
        if (patient==null){
            return null;
        }
        String sql ="SELECT" +
                " s.create_time," +
                " s.service_patient_name," +
                " s.workorder_code,"+
                " s.workorder_type,"+
                " w.priority," +
                " w.relation_code," +
                " w.relation_code_name," +
                " w.create_user_type," +
                " w.create_user_name," +
                " w.create_user," +
                " w.remark," +
                " w.service_time" +
                " FROM" +
                " `manage_synergy_workorder_servicer` s" +
                " LEFT JOIN manage_synergy_workorder w ON s.workorder_code = w.`code`" +
                " WHERE" +
                " s.service_patient_code = '"+patient.getCode()+"'" +
                " AND w.`status` = 2" +
                " AND w.type NOT IN (0,2) "+
                " ORDER BY" +
                " s.create_time" +
                " LIMIT 2";
        String sqlCount ="SELECT count(1) as total"+
                " FROM" +
                " `manage_synergy_workorder_servicer` s" +
                " LEFT JOIN manage_synergy_workorder w ON s.workorder_code = w.`code`" +
                " WHERE" +
                " s.service_patient_code = '"+patient.getCode()+"'" +
                " AND w.`status` = 2" +
                " AND w.type NOT IN (0,2) "+
                " ORDER BY" +
                " s.create_time ";
        List<Map<String,Object>> rstotal = jdbcTemplate.queryForList(sqlCount);
        Long count = 0L;
        if(rstotal!=null&&rstotal.size()>0){
            count = (Long) rstotal.get(0).get("total");
        }
        List<Map<String,Object>> list = jdbcTemplate.queryForList(sql);
        for (Map<String,Object> map : list){
            int isOver = 0;
            if (map.get("service_time")!=null){
                isOver = isServiceOverTime(DateUtil.strToDate(String.valueOf(map.get("service_time")),DateUtil.YYYY_MM_DD_HH_MM_SS));
            }
            map.put("isOver",isOver);

        }
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("count",count);
        jsonObject.put("list",list);
        return jsonObject;
    }

    public int saveCallLabel(String callLabels,String callCode){
        String sql ="UPDATE manage_call_record SET call_label='"+callLabels+"' WHERE `code`='"+callCode+"'";
        return  jdbcTemplate.update(sql);
    }

    public int saveCallInfo(String serviceType,String serviceContent,String callCode,String patientName,Integer followUp){
    
        String sql = "";
        if(StringUtils.isNoneBlank(patientName)){
            sql ="UPDATE manage_call_record SET service_type='"+serviceType+"',service_content='"+serviceContent+"',patient_name='"+patientName+"',follow_up='"+followUp+"' WHERE `code`='"+callCode+"'";
    
        }else{
            sql ="UPDATE manage_call_record SET service_type='"+serviceType+"',service_content='"+serviceContent+"',follow_up='"+followUp+"' WHERE `code`='"+callCode+"'";
    
        }
    
        return  jdbcTemplate.update(sql);

    }

    public Map<String,Object> customerIndex(String userCode){
        String today = DateUtil.dateToStrShort(new Date());
        String startTime=today+" 00:00:00";
        String endTime = today+" 23:59:59";
        Map<String,Object> map = new HashMap<>();
        String callSql ="SELECT * FROM manage_call_record WHERE user_code='"+userCode+"' and create_time>='"+startTime+"' and create_time<='"+endTime+"'";
        //--------------今日外呼量-----------------//
        List<CallRecord> waihudList = jdbcTemplate.query(callSql+" and type=2",new BeanPropertyRowMapper<>(CallRecord.class));
        int customerNoCount = 0;
        for(CallRecord callRecord : waihudList){
            //获取客户未接通数量
            if(callRecord.getAnswerStatus()==3){
                customerNoCount++;
            }
        }
        //求总时长
        if (waihudList.size()>0){
            int seconds = totalTaklTime(waihudList);
            //求平均时长
            map.put("waihuAvgTalkTime",getAvgTime(seconds,waihudList.size()));
        }else {
            map.put("waihuAvgTalkTime",0);
        }

        map.put("waihuCount",waihudList.size());
        map.put("waihuCustomerNoCount",customerNoCount);

        //--------------今日在线时长-----------------//

        String lineSql="SELECT" +
                " *" +
                " FROM" +
                " `manage_customer_online_record`" +
                " WHERE" +
                " customer_code ='"+userCode+"'" +
                " AND create_time >='"+startTime+"'" +
                " AND create_time <='"+endTime+"'" +
                " ORDER BY" +
                " create_time";
        List<ManageCustomerOnlineRecordDO> manageCustomerOnlineRecordDOList = jdbcTemplate.query(lineSql,new BeanPropertyRowMapper<>(ManageCustomerOnlineRecordDO.class));
        //如果最新一条是离线则直接获取总在线时长就是在线时间，
        // 如果最新一条是在线，则用当前时间减去上一条登录时间加上之前的在线时长为总的在线时长
        Map<String,Object> lineMap = getOnlineAndNotOnlineAndNowOnline(manageCustomerOnlineRecordDOList);
        map.putAll(lineMap);

        //--------------今日接入量-----------------//
        List<CallRecord> jieruList = jdbcTemplate.query(callSql+" and type=1",new BeanPropertyRowMapper<>(CallRecord.class));
        //求总时长
        int jieruTotalSecond = totalTaklTime(jieruList);
        //求平均时长
        if (jieruList.size()>0){
            map.put("jieruAvgTalkTime",getAvgTime(jieruTotalSecond,jieruList.size()));
        }else {
            map.put("jieruAvgTalkTime",0);
        }
        map.put("jieruCount",jieruList.size());

        //--------------今日协同任务完成数-----------------//
        String wanchenSql="SELECT" +
                " count(*) as wanchengCount" +
                " FROM" +
                " `manage_synergy_workorder_servicer`" +
                " WHERE" +
                " executor_code = '"+userCode+"'" +
                " AND executor_type = 2" +
                " AND `status`=3" +
                " AND complete_time >='"+startTime+"'" +
                " AND complete_time<='"+endTime+"'";
        Map<String,Object> wanchenMap = jdbcTemplate.queryForMap(wanchenSql);
        String weiwanchenSql ="SELECT" +
                " COUNT(*) AS weiwanchengCount" +
                " FROM" +
                " `manage_synergy_workorder_servicer`" +
                " WHERE" +
                " executor_code = '"+userCode+"'" +
                " AND executor_type = 2" +
                " AND `status`<3";
        Map<String,Object> weiwanchenMap = jdbcTemplate.queryForMap(weiwanchenSql);
        String fasongSql="SELECT" +
                " COUNT(*) AS fasongCount" +
                " FROM" +
                " manage_synergy_workorder" +
                " WHERE" +
                " create_user = '"+userCode+"'" +
                " AND create_user_type = 2" +
                " AND del = 1" +
                " AND create_time>='"+startTime+"'" +
                " AND create_time<='"+endTime+"'";
        Map<String,Object> fasongMap = jdbcTemplate.queryForMap(fasongSql);
        map.putAll(wanchenMap);
        map.putAll(weiwanchenMap);
        map.putAll(fasongMap);
        return map;

    }

    public Map<String,Object> getOnlineAndNotOnlineAndNowOnline(List<ManageCustomerOnlineRecordDO> list){
        Map<String,Object> map = new HashMap<>();
        if (list!=null && list.size()>0){
            //如果最新一条是离线则直接获取总在线时长就是在线时间，
            // 如果最新一条是在线，则用当前时间减去上一条登录时间加上之前的在线时长为总的在线时长
            int status = list.get(list.size()-1).getStatus();
            String firstOnlineTime  = DateUtil.dateToStr(list.get(0).getCreateTime(),DateUtil.YYYY_MM_DD_HH_MM_SS);
            int totalOnlineMinute=0;
            int totalNotOnlineMinute =0;
            int toMinute = 0;
            //离线status==2
            if (status==2){
                totalOnlineMinute =list.get(list.size()-1).getTotalOnlineTime();
                long allTime = list.get(list.size()-1).getCreateTime().getTime()-list.get(0).getCreateTime().getTime();
                totalNotOnlineMinute= Integer.valueOf(String.valueOf(allTime/1000/60))-totalOnlineMinute;
            }
            //在线status==1
            if (status==1){
                //只有一条在线的数据，用当前时间减去数据创建时间
                long onlineDate = 0L;
                long allDateTime = 0L;
                int lastOnlineTime =0;
                Date now = new Date();
                onlineDate = now.getTime()-list.get(list.size()-1).getCreateTime().getTime();
                allDateTime = now.getTime()-list.get(0).getCreateTime().getTime();
                toMinute = Integer.valueOf(String.valueOf(onlineDate/1000/60));
                //多条数据,要加上上一次记录的在线时长
                if(list.size()>1){
                    int notOnlineCount=0;
                    for (ManageCustomerOnlineRecordDO m : list){
                        if (m.getStatus()==2 && notOnlineCount<1){
                            notOnlineCount++;
                            lastOnlineTime = m.getTotalOnlineTime();
                        }
                    }
                }
                totalOnlineMinute=toMinute+lastOnlineTime;
                totalNotOnlineMinute = Integer.valueOf(String.valueOf(allDateTime/1000/60))-totalOnlineMinute;
            }
            map.put("notOnline",totalNotOnlineMinute);
            map.put("online",totalOnlineMinute);
            map.put("nowOnline",toMinute);
            map.put("firstOnlineTime",firstOnlineTime);
        }else {
            map.put("notOnline",0);
            map.put("online",0);
            map.put("nowOnline",0);
            map.put("firstOnlineTime","");
        }

        return map;
    }

    /**
     * 返回总的秒数
     * @param list
     * @return
     */
    public int totalTaklTime(List<CallRecord> list){
        int hours = 0;
        int minutes = 0;
        int seconds = 0;
        for(CallRecord callRecord : list){
            if (callRecord.getAnswerStatus()==1){
                String talkTime = callRecord.getTalkTime();
                if (StringUtils.isNotBlank(talkTime)){
                    String[] talkTimeStr = talkTime.split(":");
                    for (int i=0;i<talkTimeStr.length;i++){
                        if (i==0){
                            hours += Integer.valueOf(talkTimeStr[i]);
                        }
                        if (i==1){
                            minutes += Integer.valueOf(talkTimeStr[i]);
                        }
                        if (i==2){
                            seconds += Integer.valueOf(talkTimeStr[i]);
                        }
                    }
                }
            }
        }
        seconds = hours*3600+minutes*60+seconds;
        return seconds;
    }

    public String getAvgTime(int totalSeconds,int count){
        if (totalSeconds==0 || count==0){
            return "0时0分0秒";
        }
        int avgSeconds = totalSeconds/count;
        String avgTalkTime = "";
        avgTalkTime =avgSeconds/3600+"时";
        if (avgSeconds%3600==0){
            avgTalkTime +="0分0秒";
        }else {
            if (avgSeconds%3600%60==0){
                avgTalkTime +=avgSeconds%3600/60+"分0秒";
            }else {
                avgTalkTime +=avgSeconds%3600/60+"分"+avgSeconds%3600%60+"秒";
            }
        }
        return avgTalkTime;
    }
    /**
     * 添加客户操作记录
     * @param workorderCode
     * @param workorderServiceCode
     * @param userCode
     * @param callCode
     * @param status
     */
    @Transactional
    public void addWorkorderCustomerLog(String workorderCode,String workorderServiceCode,String userCode,String callCode,Integer status) throws  Exception{

        ManageSynergyWorkorderCustomerLogDO workorderCustomerLogDO = new ManageSynergyWorkorderCustomerLogDO();
        workorderCustomerLogDO.setCode(getCode());
        workorderCustomerLogDO.setCallCode(callCode);
        workorderCustomerLogDO.setCreateTime(new Date());
        workorderCustomerLogDO.setCreateUserCode(userCode);
        User user = userDao.findByCode(userCode);
        workorderCustomerLogDO.setCreateUserName(user.getName());
        workorderCustomerLogDO.setStatus(status);
        workorderCustomerLogDO.setWorkorderCode(workorderCode);
        workorderCustomerLogDO.setWorkorderServiceCode(workorderServiceCode);
        customerLogDao.save(workorderCustomerLogDO);
    }

//    public static void main(String[] args) {
//        String a ="group1/M00/0E/FB/rBFuWlubh7SACz32AAAde0sVAJk899.png";
//        int aa = a.lastIndexOf("/");
//        System.out.println(aa);
//        System.out.println(a.substring(0,aa));
//    }
//    public void wordToPDF(String path) throws Exception{
//        String groupName = path.substring(0,path.lastIndexOf("/"));
//        String remoteFileName =path.substring(path.lastIndexOf("/"),path.length()-1);
//        byte[] bb =FastDFSUtil.download(groupName,remoteFileName);
//
//    }

    @Transactional
    public Map<String,Object> uploadAccessory(HttpServletRequest request) throws Exception{
        Map<String,Object> map = new HashMap<>();
        MultipartHttpServletRequest multipartRequest = (MultipartHttpServletRequest) request;
        MultipartFile multipartFile = multipartRequest.getFile("file");
        long size = multipartFile.getSize();
        if(size<=0){
            map.put("uploadStatus",1);//size小于0
            map.put("accessoryUrl",null);//
            return map;
        }
        String fileName = multipartFile.getOriginalFilename();
        String[] fs = fileName.split("\\.");
        String type = fs[1];
        //图片常见格式：bmp,jpg,png,tif,gif,pcx,tga,exif,fpx,svg,psd,cdr,pcd,dxf,ufo,eps,ai,raw,WMF,webp
        List img = new ArrayList(Arrays.asList("bmp","jpg","png","tif","gif","pcx","tga","exif","fpx","svg","psd","cdr","pcd","dxf","ufo","eps","ai","raw","WMF","webp"));
        if(!("doc".equals(type)||"docx".equals(type)||"xls".equals(type)||"xlsx".equals(type)||img.contains(type))){
            map.put("uploadStatus",2);//文件类型不对
            map.put("accessoryUrl",null);//
            return map;
        }
        String response = request(wlyyUrl + "/upload/chat", multipartFile, null);
        JSONObject rs = new JSONObject(response);
        Integer status =(Integer)rs.get("status");
        if(status==200){
            String url = rs.get("urls")+"";
            map.put("uploadStatus",0);//文件类型正确
            map.put("accessory",url);//
            return map;
        }
        throw new Exception();
    }

    public List<ManageSynergyAccessoryDO> accessoryList(String workorderCode){

        List<ManageSynergyAccessoryDO> list = manageSynergyAccessoryDao.findByWorkorderCode(workorderCode);
        return list;
    }


    public String request(String remote_url, MultipartFile file, String type) {
        CloseableHttpClient httpClient = HttpClientBuilder.create().build();
        String result = "";
        try {
            String fileName = file.getOriginalFilename();
            HttpPost httpPost = new HttpPost(remote_url);
            MultipartEntityBuilder builder = MultipartEntityBuilder.create();
            builder.addBinaryBody("file", file.getInputStream(), ContentType.MULTIPART_FORM_DATA, fileName);// 文件流
            builder.addTextBody("filename", fileName);// 类似浏览器表单提交，对应input的name和value
            if (!org.springframework.util.StringUtils.isEmpty(type)) {
                builder.addTextBody("type", type); //发送类型
            }
            HttpEntity entity = builder.build();
            httpPost.setEntity(entity);
            HttpResponse response = httpClient.execute(httpPost);// 执行提交
            HttpEntity responseEntity = response.getEntity();
            if (responseEntity != null) {
                // 将响应内容转换为字符串
                result = EntityUtils.toString(responseEntity, Charset.forName("UTF-8"));
            }
        } catch (IOException e) {
            e.printStackTrace();
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            try {
                httpClient.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
        return result;
    }

    public Map<String,Object> adminIndex(){
        List<User> userList = userDao.findByOnline(4,"2");

        Map<String,Object> map = new HashMap<>();
        String today = DateUtil.dateToStrShort(new Date());
        String startTime=today+" 00:00:00";
        String endTime = today+" 23:59:59";
//" u.type = 4" +
        String callSql ="SELECT" +
                " r.*" +
                " FROM" +
                " manage_call_record r" +
                " LEFT JOIN wlyy_user u ON r.user_code = u.`code`" +
                " WHERE " +
                " r.create_time >= '"+startTime+"'" +
                " AND r.create_time <= '"+endTime+"'";

        //正在咨询人数
        String consultSql="SELECT COUNT(*) consultNum FROM manage_call_record WHERE answer_status=1 AND (end_time IS NULL or end_time ='')";
        map.put("consultNum",jdbcTemplate.queryForMap(consultSql).get("consultNum"));

        //当前客服人数
        map.put("onlineNowCount",userList.size());

        //今日会话总量  今日平均会话时长
        List<CallRecord> allCallRecordList = jdbcTemplate.query(callSql+" and r.answer_status=1",new BeanPropertyRowMapper<>(CallRecord.class));
        map.put("allCallCount",allCallRecordList.size());
        if (allCallRecordList.size()>0){
            int totalSeconds = totalTaklTime(allCallRecordList);
            map.put("allAvgTaklTime",getAvgTime(totalSeconds,allCallRecordList.size()));
        }else {
            map.put("allAvgTaklTime",0);
        }


        //今日外呼量 今日平均会话时长
        List<CallRecord> waihuCallRecordList = jdbcTemplate.query(callSql+" and r.answer_status=1 and r.type=2 ",new BeanPropertyRowMapper<>(CallRecord.class));
        map.put("waihuCallCount",waihuCallRecordList.size());
        if (waihuCallRecordList.size()>0){
            int waihuTotalSeconds = totalTaklTime(waihuCallRecordList);
            map.put("waihuAvgTaklTime",getAvgTime(waihuTotalSeconds,waihuCallRecordList.size()));
        }else {
            map.put("waihuAvgTaklTime",0);
        }


        //--------------今日协同任务外呼数-----------------//
        String wanchenSql="SELECT" +
                " count(*) AS wanchengCount" +
                " FROM" +
                " `manage_synergy_workorder_servicer` s" +
                " LEFT JOIN wlyy_user u ON s.executor_code = u.`code`" +
                " WHERE" +
                " s.executor_type = 2" +
                " AND s.`status` = 3" +
                " AND s.complete_time >= '"+startTime+"'" +
                " AND s.complete_time <= '"+endTime+"'";
        Map<String,Object> wanchenMap = jdbcTemplate.queryForMap(wanchenSql);
        String weiwanchenSql ="SELECT" +
                " COUNT(*) AS weiwanchengCount" +
                " FROM" +
                " `manage_synergy_workorder_servicer` s" +
                " LEFT JOIN wlyy_user u ON s.executor_code = u.`code`" +
                " WHERE" +
                " executor_type = 2" +
                " AND s.`status`<3";
        Map<String,Object> weiwanchenMap = jdbcTemplate.queryForMap(weiwanchenSql);
        String fasongSql="SELECT" +
                " COUNT(*) AS fasongCount" +
                " FROM" +
                " (" +
                "  SELECT" +
                "   s.*, w.create_user," +
                "   w.create_user_name" +
                "  FROM" +
                "  manage_synergy_workorder_servicer s" +
                "  LEFT JOIN manage_synergy_workorder w ON s.workorder_code = w.`code`" +
                "  WHERE" +
                "   w.create_user_type = 2" +
                "  AND w.del = 1" +
                "  AND w.create_time >= '"+startTime+"'" +
                "  AND w.create_time <= '"+endTime+"'" +
                " ) a" +
                " LEFT JOIN wlyy_user u ON a.create_user = u.`code`";
        Map<String,Object> fasongMap = jdbcTemplate.queryForMap(fasongSql);
        map.putAll(wanchenMap);
        map.putAll(weiwanchenMap);
        map.putAll(fasongMap);
        return map;

    }

    public Map<String,Object> intervalOnLine(){
        Map<String,Object> map = new HashMap<>();
        String today = DateUtil.dateToStrShort(new Date());
        String startTime=today+" 00:00:00";
        String endTime = today+" 23:59:59";
        String allSql="SELECT " +
                " HOUR (r.create_time) AS HOUR, " +
                " count(*) AS Count " +
                " FROM " +
                " manage_call_record r " +
                " LEFT JOIN wlyy_user u ON r.user_code = u.`code` " +
                " WHERE " +
                " r.create_time BETWEEN '"+startTime+"' " +
                " AND '"+endTime+"' " +
                " AND r.answer_status = 1 " +
                " AND u.type IN(3,4) "+
                " GROUP BY " +
                " HOUR (r.create_time) " +
                " ORDER BY " +
                " HOUR (r.create_time)";
    List<Map<String,Object>> allList = jdbcTemplate.queryForList(allSql);
    String jieruSql ="SELECT " +
            " HOUR (r.create_time) AS HOUR, " +
            " count(*) AS Count " +
            " FROM " +
            " manage_call_record r " +
            " LEFT JOIN wlyy_user u ON r.user_code = u.`code` " +
            " WHERE " +
            " r.create_time BETWEEN '"+startTime+"' " +
            " AND '"+endTime+"' " +
            " AND r.answer_status = 1 " +
            " AND r.type in(3,4)  " +
            " GROUP BY " +
            " HOUR (r.create_time) " +
            " ORDER BY " +
            " HOUR (r.create_time)";
        List<Map<String,Object>> jieruList = jdbcTemplate.queryForList(allSql);
        map.put("all",allList);
        map.put("jieru",jieruList);
        return  map;
    }

    public List<Map<String,Object>> TodayCustomerActivy(){
        List<Map<String,Object>> resultList =  new ArrayList<>();
        String today = DateUtil.dateToStrShort(new Date());
        String startTime=today+" 00:00:00";
        String endTime = today+" 23:59:59";
        /*startTime="2017-11-15 00:00:00";
        endTime="2017-11-22 23:59:59";*/
        /*String sql="SELECT" +
                " u.`code`,"+
                " u.`name`," +
                " u.`online` as onlineType," +
                " r.type," +
                " COUNT(*) as num"+
                " FROM" +
                " wlyy_user u" +
                " LEFT JOIN manage_call_record r ON u.`code` = r.user_code" +
                " WHERE" +
                " u.type = 4" +
                " AND r.create_time>='"+startTime+"'" +
                " AND r.create_time<='"+endTime+"'" +
                " AND r.answer_status=1"+
                " GROUP BY" +
                " u.`code`," +
                " r.type";*/
        String sql="SELECT" +
                " u.`code`," +
                " u.`name`," +
                " u.`online` AS onlineType," +
                " r.type," +
                " IF (r.type IS NOT NULL, COUNT(*), 0) AS num" +
                " FROM" +
                " wlyy_user u" +
                " LEFT JOIN (" +
                " SELECT" +
                "  type," +
                "  user_code," +
                "  user_name" +
                "  FROM" +
                "  manage_call_record" +
                "  WHERE" +
                "  create_time >= '"+startTime+"'" +
                "  AND create_time <= '"+endTime+"'" +
                "  AND answer_status = 1" +
                " ) r ON u.`code` = r.user_code" +
                " WHERE" +
                " u.type IN(3,4) " +
                " GROUP BY" +
                " u.`code`," +
                " r.type";
        List<Map<String,Object>> list = jdbcTemplate.queryForList(sql);
        List<Map<String,Object>> toList =  new ArrayList<>();
        for (Map<String,Object> map : list){
            String userCode = String.valueOf(map.get("code"));
            String type = String.valueOf(map.get("type"));
            if (resultList.size()==0){
                Map<String,Object> resultMap = new HashMap<>();
                resultMap.put("userCode",userCode);
                resultMap.put("userName",map.get("name"));
                resultMap.put("onlineType",map.get("online"));
                if ("1".equals(type)){
                    resultMap.put("jieruCount",map.get("num"));
                    resultMap.put("waihuCount",0);
                }
                if ("2".equals(type)){
                    resultMap.put("jieruCount",0);
                    resultMap.put("waihuCount",map.get("num"));
                }
                if ("null".equals(type) || StringUtils.isEmpty(type)){
                    resultMap.put("jieruCount",0);
                    resultMap.put("waihuCount",0);
                }
                toList.add(resultMap);
            }else {
                int count =0;
                for (Map<String,Object> map1 : resultList){
                    count++;
                    if(userCode.equals(String.valueOf(map1.get("userCode")))){
                        if ("1".equals(type)){
                            map1.put("jieruCount",map.get("num"));
                        }
                        if ("2".equals(type)){
                            map1.put("waihuCount",map.get("num"));
                        }
                    }
                    if (count==resultList.size() && !userCode.equals(String.valueOf(map1.get("userCode")))){
                        Map<String,Object> resultMap = new HashMap<>();
                        resultMap.put("userCode",userCode);
                        resultMap.put("userName",map.get("name"));
                        resultMap.put("onlineType",map.get("onlineType"));
                        if ("1".equals(type)){
                            resultMap.put("jieruCount",map.get("num"));
                            resultMap.put("waihuCount",0);
                        }
                        if ("2".equals(type)){
                            resultMap.put("jieruCount",0);
                            resultMap.put("waihuCount",map.get("num"));
                        }
                        if ("null".equals(type)  || StringUtils.isEmpty(type)){
                            resultMap.put("jieruCount",0);
                            resultMap.put("waihuCount",0);
                        }
                        toList.add(resultMap);
                    }
                }
            }
            resultList.addAll(toList);
            toList.clear();
        }
        for (Map<String,Object> reMap : resultList){
            String userCode = String.valueOf(reMap.get("userCode"));
            String lineSql="SELECT" +
                    " *" +
                    " FROM" +
                    " `manage_customer_online_record`" +
                    " WHERE" +
                    " customer_code ='"+userCode+"'" +
                    " AND create_time >='"+startTime+"'" +
                    " AND create_time <='"+endTime+"'" +
                    " ORDER BY" +
                    " create_time";
            List<ManageCustomerOnlineRecordDO> manageCustomerOnlineRecordDOList = jdbcTemplate.query(lineSql,new BeanPropertyRowMapper<>(ManageCustomerOnlineRecordDO.class));
            //如果最新一条是离线则直接获取总在线时长就是在线时间
            // 如果最新一条是在线，则用当前时间减去上一条登录时间加上之前的在线时长为总的在线时长
            Map<String,Object> lineMap = getOnlineAndNotOnlineAndNowOnline(manageCustomerOnlineRecordDOList);
            reMap.putAll(lineMap);
        }
        return resultList;
    }

    public List<User> getCustomers() {
        return userDao.findAllCustomer();
    }

    public void deleteFile(String storagePath) throws Exception{
        Map<String,Object> params = new HashMap<>();
        params.put("storagePath",storagePath);
        String response = httpManageClientUtil.post(wlyyUrl + "/upload/deleteFile", params);
        JSONObject jsonObject = new JSONObject(response);
        Integer status = (Integer) jsonObject.get("status");
        if(status!=200){
            throw new Exception();
        }
    }

    public JSONObject getArticalById(String articalId) throws Exception{
        String response = httpManageClientUtil.get(wlyyUrl + "/third/synergy/getArticalById?articleId="+articalId,"UTF-8");
        JSONObject jsonObject = new JSONObject(response);
        Integer status = (Integer) jsonObject.get("status");
        if(status==200){
            return jsonObject.getJSONObject("data");
        }
        throw new Exception();

    }

    @Transactional
    public void deleteWorkorder(String workorderCode) throws Exception{
        int a  = workOrderDao.deleteByCode(workorderCode);
        if(a<0){
            throw new Exception("删除失败");
        }
    }

    public ManageSynergyWorkorderDO getWorkorderInfo(String workorderCode){

        return workOrderDao.findByCode(workorderCode);
    }

    public Map<String,Object> getTaskByIdcard(String workorderCode,String idcard){
        String sql=" select w.*,s.mobile,s.service_patient_name,s.service_patient_code,s.code as servicerCode,s.town_name,s.hospital_name,w.create_user_name"+
                " from manage_synergy_workorder_servicer s "+
                " LEFT JOIN manage_synergy_workorder w on s.workorder_code=w.code " +
                " where w.code='"+workorderCode+"' and s.idcard='"+idcard+"'" ;
        List<Map<String,Object>> workorderList = jdbcTemplate.queryForList(sql);
        Map<String,Object> resultMap = new HashMap<>();
        Map<String,Object> workorderMap = workorderList.get(0);
        //居民信息
        resultMap.put("mobile",workorderMap.get("mobile"));//电话号码
        resultMap.put("patientName",workorderMap.get("service_patient_name"));//居民姓名
        Integer callNum = customerLogDao.callNumByWorkorder(workorderMap.get("servicerCode")+"");
        resultMap.put("callNum",callNum);//已呼叫次数
        resultMap.putAll(this.getPatientInfo(workorderMap.get("service_patient_code") + ""));
        Patient patient =patientDao.findByCode(workorderMap.get("service_patient_code")+"");
        Integer sex = patient.getSex();
        String sexName ="";
        if(sex==1){
            sexName="男";
        }else if(sex==2){
            sexName="女";
        }else{
            sexName="未知";
        }
        resultMap.put("sex",sexName);//性别
        Integer age = IdCardUtil.getAgeForIdcard(patient.getIdcard());
        resultMap.put("age",age);//年龄
        resultMap.put("townName",workorderMap.get("town_name"));//所属区县
        resultMap.put("hospitalName",workorderMap.get("hospital_name"));//所属社区
        SignFamily signFamily = signFamilyDao.findSignByPatient(workorderMap.get("service_patient_code")+"");
        resultMap.put("signDoctor",signFamily.getDoctorName());//签约医生（即：工单创建医生）
        resultMap.put("healthDoctor",signFamily.getDoctorHealthName());//健管师
        List<SignPatientLabelInfo> labelDiseaseType = signPatientLabelInfoDao.findByPatientAndLabelTypeAndStatus(workorderMap.get("service_patient_code")+"",  "3", 1);
        String diseaseType="";
        List<String> diseaseTypeList= new ArrayList<>();
        for(SignPatientLabelInfo one:labelDiseaseType){
            diseaseType+=","+one.getLabelName();
            diseaseTypeList.add(one.getLabel());
        }
        resultMap.put("diseaseType",StringUtils.isNotEmpty(diseaseType)?diseaseType.substring(1):"");//疾病类型
        resultMap.put("diseaseTypeCode",diseaseTypeList);//疾病类型code
        List<SignPatientLabelInfo> labelHealthType = signPatientLabelInfoDao.findByPatientAndLabelTypeAndStatus(workorderMap.get("service_patient_code")+"",  "2", 1);
        String healthType="";
        for(SignPatientLabelInfo one:labelHealthType){
            healthType+=","+one.getLabelName();
        }
        resultMap.put("healthType",StringUtils.isNotEmpty(healthType)?healthType.substring(1):"");//健康情况
        String serveType="";
//            List<SignPatientLabelInfo> labelServeType = signPatientLabelInfoDao.findByPatientAndLabelTypeAndStatus(workorderMap.get("service_patient_code")+"",  "2", 1);
//            for(SignPatientLabelInfo one:labelServeType){
//                serveType+=","+one.getLabelName();
//            }
        List<Map<String,Object>> signTypes = jdbcTemplate.queryForList("SELECT s.server_type_name,s.server_type FROM wlyy_sign_family_server s right join wlyy_sign_family f on s.sign_code=f.code WHERE f.patient='"+workorderMap.get("service_patient_code")+"' and f.status=1 and f.expenses_status='1' ");
        for(Map<String,Object> one:signTypes){
            serveType+=","+(one.get("server_type_name")!=null?one.get("server_type_name"):"");
        }
        resultMap.put("serveType",StringUtils.isNotEmpty(serveType)?serveType.substring(1):"");
//            resultMap.put("serveType",StringUtils.isNotEmpty(serveType)?serveType.substring(1):"");//服务类型
        resultMap.put("workorder",workorderMap.get("code"));//工单编号
        resultMap.put("patientCode",workorderMap.get("service_patient_code"));//居民code
        resultMap.put("doctorCode",workorderMap.get("create_user"));//创建人（医生）code
        //获取提交记录
        String servicerCode = workorderMap.get("servicerCode")+"";
        resultMap.put("servicerCode", servicerCode);
        List<ManageSynergyWorkorderServicerLogDO> list = manageSynergyWorkorderServicerLogDao.findByWorkorderServiceCode(servicerCode);
        if(list.size()>0){
            ManageSynergyWorkorderServicerLogDO log = list.get(0);
            Map<String,Object> m = new HashMap<>();
            m.put("personal",log.getPersonal());//是否为本人
            m.put("callCode",log.getCallCode());//通话记录code
            m.put("callStatus",log.getCallStatus());//通话状态（1、正常通话，2、无人接听，3、拒接，4、占线，5、关机，6、停机，7、无法接通，8、空号错号）
            m.put("emphasis",log.getEmphasis());//是否重点患者（1、重点患者，2、非重点患者）
            m.put("followUp",log.getFollowUp());//是否跟进（1、无需跟进，2、待跟进）
            m.put("remark",log.getRemark());//备注
            m.put("returnVisit",log.getReturnVisit());//回访（1、有效回访，2、无效回访）
            resultMap.put("servicerLog",m);
            resultMap.put("haveNum",1);
        }
        return resultMap;
    }

    /**
     *
     * @param orgCode 机构编码
     * @param orgName 机构名称
     * @param testCrowd 体检人群
     * @param testPrepare 体检前准备
     * @param testMaterial 提供证件、材料
     * @param testContent 体检内容
     * @param testRelatedServices 家庭医生相关服务
     * @param testAreaTime 地点、时间
     * @return
     */
    public ManageSynergyWorkorderTestInstructionsDo createManageSynergyWorkorderTestInstructions(String orgCode, String orgName, String testCrowd, String testPrepare, String testMaterial, String testContent, String testRelatedServices, String testAreaTime){
        ManageSynergyWorkorderTestInstructionsDo mswtiDo=new ManageSynergyWorkorderTestInstructionsDo();
        mswtiDo.setOrgCode(orgCode);
        mswtiDo.setOrgName(orgName);
        mswtiDo.setTestAreaTime(testAreaTime);
        mswtiDo.setTestContent(testContent);
        mswtiDo.setTestCrowd(testCrowd);
        mswtiDo.setTestMaterial(testMaterial);
        mswtiDo.setTestPrepare(testPrepare);
        mswtiDo.setTestRelatedServices(testRelatedServices);
        mswtiDo.setStatus("1");
        return manageSynergyWorkorderTestInstructionsDao.save(mswtiDo);
    }

    /**
     * 健康教育-根据客服健康教育文案id获取内容
     * @param id 文案id
     * @return
     */
    public JSONObject findManageSynergyWorkorderArticleById(Long id) throws Exception{
        JSONObject jsonObject = new JSONObject();
        ManageSynergyWorkorderArticleDo manageSynergyWorkorderArticleDo=manageSynergyWorkorderArticleDao.findById(id).get();
        jsonObject.put("articleTitle",null==manageSynergyWorkorderArticleDo?"":manageSynergyWorkorderArticleDo.getTitle());
        jsonObject.put("articleContent",null==manageSynergyWorkorderArticleDo?"":manageSynergyWorkorderArticleDo.getContent());
        return jsonObject;
    }

    /**
     * 体检提醒-根据机构编码获取体检说明
     * @param orgCode 机构编码
     * @return
     */
    public ManageSynergyWorkorderTestInstructionsDo findByorgCode(String orgCode){
        return manageSynergyWorkorderTestInstructionsDao.findByOrgCode(orgCode);
    }

    public JSONArray findIndexByPatient(String patient, int type, String begin, String end, int page, int pagesize)throws Exception{
        Map<String,Object> params = new HashMap<>();
        params.put("patient",patient);
        params.put("type",type);
        params.put("begin",begin);
        params.put("end",end);
        params.put("page",page);
        params.put("pagesize",pagesize);
        String response = httpManageClientUtil.post(wlyyUrl + "/third/synergy/health_index/list", params);
        JSONObject jsonObject = new JSONObject(response);
        Integer status = (Integer) jsonObject.get("status");
        if(status==200){
            return jsonObject.getJSONArray("list");
        }
        return null;
    }

    /**
     * 患者健康指标预警值查询
     * @param patient
     * @return
     * @throws Exception
     */
    public JSONObject standard(String patient)throws Exception{
        //http://localhost:8080/doctor/health_index/list?patient=0fab4dd67e074e16ac86db6b6c15233e&type=1&begin=2013-07-23%2000%3A00%3A00&end=2019-08-23%2000%3A00%3A00&page=1&pagesize=10
        String response = HttpManageClientUtil.get(wlyyUrl + "/third/synergy/health_index/standard?patient="+patient,"utf-8");
        JSONObject jsonObject = new JSONObject(response);
        Integer status = (Integer) jsonObject.get("status");
        if(status==200){
            return jsonObject.getJSONObject("data");
        }
        return null;
    }
    
    public List<Map<String, Object>> findAllCallRecord(String startTime,String endTime) {
        String sql = "SELECT a.create_time," +
                "a.caller_number," +
                "a.recipient_number," +
                "a.patient_name," +
                "b.mobile," +
                "b.hospital_name," +
                "b.doctor_name," +
                "c.mobile AS doctorMobile," +
                "a.service_type as server_type_name," +
                "CASE a.answer_status WHEN 1 THEN '接通' WHEN 2 THEN '失败' END answer_status_name," +
                "a.service_content," +
                "a.user_name," +
                "a.follow_up,"+
                "CASE a.transfer_state WHEN 1 THEN '成功' WHEN 2 THEN '失败' END transfer_state_name " +
                "FROM manage_call_record a " +
                "LEFT JOIN wlyy_sign_family b ON a.user_code=b.patient AND `status`=1 " +
                "LEFT JOIN wlyy_doctor c ON c.`code`=b.doctor" +
                " where 1=1   ";
        if (StringUtils.isNotBlank(startTime)&&StringUtils.isNotBlank(endTime)) {
            sql += " and a.create_time >='"+startTime+"' and a.create_time<= '"+endTime+"'";
        }

        List<Map<String, Object>> list = jdbcTemplate.queryForList(sql);
        return list;
    }


    /**
     * 关闭工单
     * @param workorderCode
     * @param reason
     * @return
     */
    public void closeWorkorder(String workorderCode,String reason,String userCode) throws Exception {
        User user =  userDao.findByCode(userCode);
        ManageSynergyWorkorderDO workorderDO = workOrderDao.findByCode(workorderCode);
        if (workorderDO==null){
            throw new Exception("该工单找不到！");
        }
        workorderDO.setReason(reason);
        workorderDO.setStatus(5);
        workorderDO.setCloseUser(userCode);
        workorderDO.setCloseUserName(user.getName());
        workorderDO.setCloseTime(new Date());
        workOrderDao.save(workorderDO);
        CallService callService = callServiceDao.findByCode(workorderDO.getRelationCode());
        callService.setState(3);
        callServiceDao.save(callService);
        Message message = new Message();
        message.setCzrq(new Date());
        message.setCreateTime(new Date());
        if(callService.getType()==1){
            message.setContent("客服"+user.getName()+"("+user.getSeat()+")已关闭:"+callService.getPatientName()+"需要预约挂号。"+"关闭说明:"+reason);
        }else{
            message.setContent("客服"+user.getName()+"("+user.getSeat()+")已关闭:"+callService.getPatientName()+"发起咨询。"+"关闭说明:"+reason);
        }
        if( 0 == workorderDO.getType() || 2 == workorderDO.getType()){
            message.setReceiver(workorderDO.getReceiverCode());
            message.setReceiverName(workorderDO.getReceiverName());
        }else{
            message.setReceiver(workorderDO.getCreateUser());
            message.setReceiverName(workorderDO.getCreateUserName());
        }
        message.setRead(1);//设置未读

        message.setSender(user.getCode());//设置发送的用户
        message.setSenderName(user.getName());
        message.setCode(getCode());
        message.setTitle("协同服务已关闭");
        message.setType(32);//协同服务消息
        message.setReadonly(1);//是否只读消息
        message.setOver("1");//未处理
        message.setDel("1");
        message.setState(1);
        message.setRelationCode(workorderDO.getRelationCode());
        messageDao.save(message);
    }

}
