package com.yihu.customer.service.synergy;/**
 * Created by nature of king on 2018/10/9.
 */

import com.alibaba.fastjson.JSONObject;
import com.yihu.customer.util.query.BaseJpaService;
import  com.yihu.customer.entity.Patient;
import  com.yihu.customer.entity.User;
import  com.yihu.customer.entity.synergy.ManageSynergyWorkorderServicerDO;
import  com.yihu.customer.entity.synergy.ManageSynergyWorkorderServicerLogDO;
import  com.yihu.customer.repository.PatientDao;
import  com.yihu.customer.repository.UserDao;
import  com.yihu.customer.repository.synergy.ManageSynergyWorkOrderDao;
import  com.yihu.customer.repository.synergy.ManageSynergyWorkorderServicerDao;
import  com.yihu.customer.repository.synergy.ManageSynergyWorkorderServicerLogDao;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.BeanPropertyRowMapper;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * @author wangzhinan
 * @create 2018-10-09 15:58
 * @desc 协同服务处理操作日志
 **/
@Service

public class SynergyWorkorderServicerLogService extends BaseJpaService {
    @Autowired
    private ManageSynergyWorkorderServicerLogDao manageSynergyWorkorderServicerLogDao;
    @Autowired
    private ManageSynergyWorkOrderDao manageSynergyWorkOrderDao;
    @Autowired
    private ManageSynergyWorkorderServicerDao workorderServicerDao;
    @Autowired
    private PatientDao patientDao;
    @Autowired
    private JdbcTemplate jdbcTemplate;
    @Autowired
    private UserDao userDao;



    /**
     * 添加协同服务处理操作日志
     *
     * @param synergyWorkorderServicerLogDO
     */
    @Transactional
    public void create(ManageSynergyWorkorderServicerLogDO synergyWorkorderServicerLogDO,String userCode){
        ManageSynergyWorkorderServicerDO workorderServicerDO = workorderServicerDao.findByWorkOrderCodeAndPatientCode1(synergyWorkorderServicerLogDO.getWorkorderCode(),synergyWorkorderServicerLogDO.getWorkorderServiceCode());
        synergyWorkorderServicerLogDO.setCreateTime(new Date());
        synergyWorkorderServicerLogDO.setCode(getCode());
        synergyWorkorderServicerLogDO.setWorkorderServiceCode(workorderServicerDO.getCode());
        ManageSynergyWorkorderServicerLogDO workorderServicerLogDO = manageSynergyWorkorderServicerLogDao.save(synergyWorkorderServicerLogDO);
        User user = userDao.findByCode(userCode);
        workorderServicerDO.setStatus(3);
        workorderServicerDO.setExecutorCode(user.getCode());
        workorderServicerDO.setExecutorName(user.getName());
        workorderServicerDO.setExecutorType(2);
        workorderServicerDO.setCompleteTime(new Date());
        workorderServicerDao.save(workorderServicerDO);
    }


    /**
     * 根据工单code获取服务对象
     *
     * @param workorderCode 工单code
     * @return
     */
    public JSONObject selectByWorkorderCode(String workorderCode, Integer page, Integer size){
        JSONObject object = new JSONObject();
        String sql = "select * from manage_synergy_workorder_servicer where workorder_code = '"+workorderCode+"' LIMIT "+(page-1)*size+","+size;
        List<ManageSynergyWorkorderServicerDO> workorderServicerDOS = jdbcTemplate.query(sql,new BeanPropertyRowMapper(ManageSynergyWorkorderServicerDO.class));
        String sqlCount = "select count(1) as total from manage_synergy_workorder_servicer where workorder_code = '"+workorderCode+"'";
        List<Map<String,Object>> rstotal = jdbcTemplate.queryForList(sqlCount);
        Long count = 0L;
        if(rstotal!=null&&rstotal.size()>0){
            count = (Long) rstotal.get(0).get("total");
        }
        List<Patient> patients = new ArrayList<>();
        for (ManageSynergyWorkorderServicerDO workorderServicerDO:workorderServicerDOS){
            Patient patient = patientDao.findByCode(workorderServicerDO.getServicePatientCode());
            patients.add(patient);
        }
        object.put("currPage",page);
        object.put("pageSize",size);
        object.put("totalCount",count);
        object.put("detailModelList",patients);
        return object;
    }
}
