package com.yihu.customer.service.wechat;

import com.yihu.customer.service.BaseService;
import  com.yihu.customer.entity.wechat.WechatSignVO;
import  com.yihu.customer.entity.wechat.WechatTotalVO;
import com.yihu.customer.util.DateUtil;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.BeanPropertyRowMapper;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

/**
 * 微信相关业务层方法
 * @author huangwenjie
 * @date 2017/12/11 21:16
 */
@Service
public class WechatService extends BaseService {
	
	@Autowired
	JdbcTemplate jdbcTemplate;
	
	/**
	 * 根据社区和关注状态查找微信关注量详情
	 * @param hospital
	 * @param attention
	 * @return
	 */
	public List<WechatSignVO> geSignWechatDataList(String hospital,String attention, String signSource) {
		Calendar a = Calendar.getInstance();
		int year = a.get(Calendar.YEAR)-1;
		int month = a.get(Calendar.MONTH)+1;
		if(month >= 7){
			year = a.get(Calendar.YEAR);
		}
		List<WechatSignVO> list = new ArrayList<>();
		String sql  = "";
		Boolean atten = false;
		if(StringUtils.isBlank(attention)){
			attention = "0";
			atten = true;
		}
		if("1".equals(attention)){
			sql = "SELECT m.*,n.tcount FROM (" +
					"SELECT t.openid," +
					"t.CODE as patientcode," +
					"t.NAME as patientname," +
					"t.birthday, " +
					"case  t.sex when 1 then '男' when 2 then '女' end  as sex ," +
					"a.mobile," +
					"t.openid_time," +
					"t.medicare_number,"+
//					"CONCAT(LEFT (a.idcard,6),'**********',RIGHT (a.idcard,2)) idcard," +
					"a.idcard, " +
					"a.doctor_name," +
					"a.doctor_health_name," +
					"t.sick_village_name," +
					"t.address," +
					"a.hospital_name,"+
					"t.street_name,a.sign_source,a.apply_date FROM (" +
					"SELECT b.patient,b.mobile,b.idcard,b.doctor_name,b.doctor_health_name,b.hospital_name,b.sign_source,b.apply_date FROM wlyy_sign_family b WHERE b.hospital='"+hospital+"' AND b.sign_year='"+year+"' AND b.STATUS=1 AND b.expenses_status=1) a,wlyy_patient t WHERE t.CODE=a.patient and t.openid is not null) m," +
					"(SELECT t.openid,count(t.openid) tcount FROM wlyy_patient t WHERE t.`code` IN (" +
					"SELECT patient FROM wlyy_sign_family s WHERE s.hospital='"+hospital+"' AND s.sign_year='"+year+"' AND s.expenses_status=1 AND s.STATUS=1 AND s.sign_source = '"+signSource+"') GROUP BY t.openid) n WHERE m.openid=n.openid";
			if(StringUtils.isBlank(signSource)){
				sql = sql.replace("AND s.sign_source = ''","");
			}
		}else if("0".equals(attention)){
			sql = "SELECT m.* FROM (" +
					"SELECT a.mobile," +
					"a.code as patientcode ," +
					"a.NAME as patientname ," +
					"a.birthday, " +
					"case  a.sex when 1 then '男' when 2 then '女' end  as sex ," +
					"a.openid_time," +
					"a.openid, " +
					"a.medicare_number," +
//					"CONCAT(LEFT (a.idcard,6),'**********',RIGHT (a.idcard,2)) idcard," +
					"a.idcard, " +
					"b.doctor_name," +
					"b.doctor_health_name," +
					"b.hospital_name," +
					"a.address," +
					"a.sick_village_name," +
					"a.street_name,b.sign_source,b.apply_date FROM (" +
					"SELECT t.CODE,t.NAME,t.address,t.sick_village_name,t.street_name,t.medicare_number,t.sex,t.birthday,idcard,mobile,openid_time,t.openid FROM wlyy_patient t WHERE t.`code` IN (" +
					"SELECT patient FROM wlyy_sign_family s WHERE s.hospital='"+hospital+"' AND s.sign_year='"+year+"' AND s.expenses_status=1 AND s.STATUS=1 AND s.expenses_time IS NOT NULL) AND t.openid IS NULL ORDER BY t.openid desc) a,wlyy_sign_family b WHERE b.hospital='"+hospital+"' AND b.sign_year='"+year+"' AND b.STATUS=1 AND b.expenses_status=1 AND a.CODE=b.patient AND b.expenses_time IS NOT NULL AND b.sign_source ='"+signSource+"') m";
			if(StringUtils.isBlank(signSource)){
				sql = sql.replace("AND b.sign_source =''","");
			}
			if(atten){
				sql = sql.replace("AND t.openid IS NULL", "");
			}
		}
		
		list =  jdbcTemplate.query(sql,new BeanPropertyRowMapper(WechatSignVO.class));
		return list ;
	}
	
	/**
	 *获取社区关注率
	 *@author huangwenjie
	 *@date 2017/12/11 22:17
	 */
	public List<WechatTotalVO> hosipitaTotalData() {
		List<WechatTotalVO> list = new ArrayList<>();
		Calendar a = Calendar.getInstance();
		int year = a.get(Calendar.YEAR)-1;
		int month = a.get(Calendar.MONTH)+1;
		if(month >= 7){
			year = a.get(Calendar.YEAR);
		}
		String sql  = "SELECT " +
				"a1.hospital_name as name," +
				"(a1.count/a2.count) as attRate," +
				"a1.count as attNumber," +
				"a2.count as signNumber from (" +
				"SELECT sf.hospital hospital,sf.hospital_name hospital_name,count(sf.id) count " +
				"FROM wlyy_patient p,wlyy_sign_family sf WHERE p.idcard=sf.idcard AND sf.type=2 " +
				"AND sf.STATUS> 0 AND LENGTH(sf.hospital)=10 " +
				"AND sf.admin_team_code IS NOT NULL AND p.openid IS NOT NULL " +
				"AND p.openid_time<= '"+ DateUtil.dateToStrShort(new Date())+"' AND sf.sign_year='"+year+"' GROUP BY sf.hospital ORDER BY count desc) a1," +
				"(SELECT a.hospital hospital,count(a.id) count,a.hospital_name hospital_name " +
				"FROM wlyy_sign_family a WHERE STATUS IN (1,2) AND a.type=2 AND expenses_status=1 " +
				"AND a.expenses_time<= '"+ DateUtil.dateToStrShort(new Date())+"' AND a.sign_year='"+year+"' GROUP BY a.hospital ORDER BY count desc) a2 WHERE a1.hospital=a2.hospital";
	
		list =  jdbcTemplate.query(sql,new BeanPropertyRowMapper(WechatTotalVO.class));
		return list ;
	}
	
	/**
	 *获取行政区关注率
	 *@author huangwenjie
	 *@date 2017/12/11 22:18
	 */
	public List<WechatTotalVO> townTotalData() {
		List<WechatTotalVO> list = new ArrayList<>();
		Calendar a = Calendar.getInstance();
		int year = a.get(Calendar.YEAR)-1;
		int month = a.get(Calendar.MONTH)+1;
		if(month >= 7){
			year = a.get(Calendar.YEAR);
		}
		String sql  = "SELECT " +
				"a1.town_name as name," +
				"(a1.count/a2.count) as attRate," +
				"a1.count as attNumber," +
				"a2.count as signNumber " +
				"from (" +
				"SELECT count(sf.id) count,h.town_name town_name,h.town town " +
				"FROM wlyy_patient p,wlyy_sign_family sf,dm_hospital h WHERE p.idcard=sf.idcard " +
				"AND sf.type=2 AND sf.STATUS> 0 AND LENGTH(sf.hospital)=10 AND sf.hospital=h.CODE " +
				"AND sf.admin_team_code IS NOT NULL AND p.openid IS NOT NULL " +
				"AND p.openid_time< '"+ DateUtil.dateToStrShort(new Date())+"' AND sf.sign_year='"+year+"' GROUP BY h.town ORDER BY count desc) a1,(" +
				"SELECT count(a.id) count,h.town_name town_name,h.town town FROM wlyy_sign_family a,dm_hospital h" +
				" WHERE STATUS IN (1,2) AND a.type=2 AND expenses_status=1 AND a.hospital=h.CODE " +
				"AND a.expenses_time< '"+ DateUtil.dateToStrShort(new Date())+"' AND a.sign_year='"+year+"' GROUP BY h.town) a2 WHERE a1.town=a2.town";
		
		list =  jdbcTemplate.query(sql,new BeanPropertyRowMapper(WechatTotalVO.class));
		return list ;
	}
}
