package com.yihu.customer.vaccin;

import  com.yihu.customer.entity.vaccin.Vaccin;
import  com.yihu.customer.entity.vaccin.VaccinPlan;
import  com.yihu.customer.repository.vaccin.VaccinDao;
import com.yihu.customer.util.query.BaseJpaService;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageImpl;
import org.springframework.data.domain.PageRequest;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

/**
 * Created by wxw on 2019/1/14.
 *
 * @author wxw.
 */
@Service
@Transactional
public class VaccinService extends BaseJpaService<Vaccin, VaccinDao> {

    @Autowired
    private VaccinPlanService vaccinPlanService;

    public Page searchPageList(String discriminateCode, String name, String subtitle, String type, Integer page,
                                       Integer pageSize)  throws Exception {
        StringBuffer sb = new StringBuffer();
        if (StringUtils.isNotEmpty(discriminateCode)) {
            sb.append("discriminateCode=").append(discriminateCode).append(";");
        }
        if (StringUtils.isNotEmpty(name)) {
            sb.append("name?").append(name).append(";");
        }
        if (StringUtils.isNotEmpty(subtitle)) {
            sb.append("subtitle?").append(subtitle).append(";");
        }
        if (StringUtils.isNotEmpty(type)) {
            sb.append("type=").append(type).append(";");
        }
        PageRequest pageRequest = PageRequest.of(page - 1, pageSize);
        List<Vaccin> search = this.search("", sb.toString(), "+id", page, pageSize);
        List<Vaccin> searchCount = this.search(sb.toString());
        Page result = new PageImpl(search, pageRequest, null != searchCount && searchCount.size() > 0 ? searchCount.size() : 0);
        return result;
    }

    public List<Vaccin> getVaccinPlans(List<Vaccin> vaccinList) {
        vaccinList.stream().forEach(item -> {
            List<VaccinPlan> vaccinPlans = vaccinPlanService.findByVaccinCode(item.getCode());
            item.setVaccinPlans(vaccinPlans);
        });
        return vaccinList;
    }

}
