package com.yihu.rehabilitation.controller.doctor;

import com.netflix.discovery.converters.Auto;
import com.yihu.jw.doctor.dao.BaseDoctorDao;
import com.yihu.jw.entity.rehabilitation.RehabilitationguidancePatientDO;
import com.yihu.jw.entity.specialist.rehabilitation.PatientMedicalRecordsDO;
import com.yihu.jw.entity.specialist.rehabilitation.RehabilitationOperateRecordsDO;
import com.yihu.jw.im.util.ImUtil;
import com.yihu.jw.patient.dao.BasePatientDao;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.MixEnvelop;
import com.yihu.jw.restmodel.web.ObjEnvelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import com.yihu.jw.rm.rehabilitation.RehabilitationRequestMapping;
import com.yihu.jw.rm.specialist.SpecialistMapping;
import com.yihu.jw.util.date.DateUtil;
import com.yihu.rehabilitation.aop.ObserverRequired;
import com.yihu.rehabilitation.service.RehabilitationGuidanceService;
import com.yihu.rehabilitation.service.RehabilitationManageService;
import com.yihu.rehabilitation.service.RehabilitationPlanService;
import com.yihu.rehabilitation.service.message.RehabilitationMessageService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.apache.commons.lang3.StringUtils;
import org.json.JSONArray;
import org.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.web.bind.annotation.*;

import java.util.*;

/**
 * Created by 刘文彬 on 2018/8/30.
 */
@RestController
@RequestMapping(value = RehabilitationRequestMapping.DoctorRehabilitationManage.perfix)
@Api(description = "医生端-康复管理")
public class DoctorRehabilitationManageController extends EnvelopRestEndpoint {

    @Autowired
    private RehabilitationManageService rehabilitationManageService;
    @Autowired
    private ImUtil imUtill;
    @Autowired
    private RehabilitationPlanService rehabilitationPlanService;
    @Autowired
    private BasePatientDao basePatientDao;
    @Autowired
    private BaseDoctorDao baseDoctorDao;
    @Autowired
    private JdbcTemplate jdbcTemplate;
    @Autowired
    private RehabilitationMessageService rehabilitationMessageService;
    @Autowired
    private RehabilitationGuidanceService rehabilitationGuidanceService;

    @RequestMapping(value = RehabilitationRequestMapping.DoctorRehabilitationManage.findRehabilitationPlanList, method = RequestMethod.GET)
    @ApiOperation("康复管理-康复计划列表")
    public MixEnvelop findRehabilitationPlanList(@ApiParam(name = "doctorCode", value = "医生code", required = false)
                                             @RequestParam(value = "doctorCode", required = false)String doctorCode,
//                                             @ApiParam(name = "doctorType", value = "医生类型（1、专科医生，2、家庭医生）", required = true)
//                                             @RequestParam(value = "doctorType", required = true)Integer doctorType,
                                                 @ApiParam(name = "patientCondition", value = "居民条件，可以按身份证或者居民名称模糊匹配", required = false)
                                             @RequestParam(value = "patientCondition", required = false)String patientCondition,
                                                 @ApiParam(name = "diseaseCode", value = "疾病类型code", required = false)
                                             @RequestParam(value = "diseaseCode", required = false)String diseaseCode,
                                                 @ApiParam(name = "planType", value = "安排类型（1康复计划，2转社区医院，3转家庭病床）", required = false)
                                             @RequestParam(value = "planType", required = false)Integer planType,
                                                 @ApiParam(name = "todaybacklog", value = "今日待办（1、今日待办，2、全部）", required = false)
                                             @RequestParam(value = "todaybacklog", required = false,defaultValue = "1")Integer todaybacklog,
                                                 @ApiParam(name = "page", value = "第几页，从1开始", required = true)
                                             @RequestParam(value = "page", required = false,defaultValue = "1")Integer page,
                                                 @ApiParam(name = "pageSize", value = "每页分页大小", required = true)
                                             @RequestParam(value = "pageSize", required = false,defaultValue = "10")Integer pageSize) {
        try {
            if(!StringUtils.isNotEmpty(doctorCode)){
                doctorCode = getUID();
            }

            return  rehabilitationManageService.findRehabilitationPlan(doctorCode,diseaseCode,planType,todaybacklog,patientCondition,page,pageSize);
        } catch (Exception e) {
            return MixEnvelop.getError(e.getMessage());
        }
    }

    @RequestMapping(value = RehabilitationRequestMapping.DoctorRehabilitationManage.findRehabilitationPlanDetailList, method = RequestMethod.GET)
    @ApiOperation("康复管理-康复计划详情列表")
    public ObjEnvelop findRehabilitationPlanDetailList(@ApiParam(name = "doctorCode", value = "医生code", required = false)
                                                   @RequestParam(value = "doctorCode", required = false)String doctorCode,
                                                       @ApiParam(name = "patientCode", value = "居民code", required = true)
                                                   @RequestParam(value = "patientCode", required = true)String patientCode){

        try {
            if(!StringUtils.isNotEmpty(doctorCode)){
                doctorCode = getUID();
            }

            return rehabilitationManageService.findRehabilitationPlanDetailList(doctorCode,patientCode);
        } catch (Exception e) {
            e.printStackTrace();
            return ObjEnvelop.getError("请求失败");
        }
    }

    @RequestMapping(value = RehabilitationRequestMapping.DoctorRehabilitationManage.calendarPlanDetail, method = RequestMethod.GET)
    @ApiOperation("康复管理-康复计划按日历展示")
    public ObjEnvelop calendarPlanDetail(@ApiParam(name = "executeStartTime", value = "日历开始时间（格式：yyyy-MM-dd HH:mm:ss）")
                                     @RequestParam(value = "executeStartTime", required = false)String executeStartTime,
                                     @ApiParam(name = "executeEndTime", value = "日历结束时间（格式：yyyy-MM-dd HH:mm:ss）")
                                     @RequestParam(value = "executeEndTime", required = false)String executeEndTime,
                                     @ApiParam(name = "planId", value = "计划id", required = true)
                                     @RequestParam(value = "planId")String planId,
                                     @ApiParam(name = "searchTask", value = "快速查找任务：（1、我的任务，2、健康教育，3、健康指导，4、随访，5、复诊）", required = false)
                                     @RequestParam(value = "searchTask", required = false)Integer searchTask,
                                     @ApiParam(name = "doctorCode", value = "医生code（专科医生、家庭医生）", required = false)
                                     @RequestParam(value = "doctorCode", required = false)String doctorCode,
                                         @ApiParam(name = "taskExecutor", value = "1是本人任务", required = false)
                                             @RequestParam(value = "taskExecutor", required = false)String taskExecutor,
                                     @ApiParam(name = "status", value = "任务状态（0未完成，1已完成，2已预约）", required = false)
                                     @RequestParam(value = "status", required = false)Integer status){
        try {
            if(!StringUtils.isNotEmpty(doctorCode)){
                doctorCode = getUID();
            }
            return rehabilitationManageService.calendarPlanDetail(executeStartTime,executeEndTime,planId,searchTask,status,doctorCode,taskExecutor);
        } catch (Exception e) {

            return ObjEnvelop.getError(e.getMessage());
        }
    }
    @GetMapping("calendarPlanDetailBypatient")
    @ApiOperation("康复管理-康复计划按日历展示")
    public ObjEnvelop calendarPlanDetailBypatient(@ApiParam(name = "executeStartTime", value = "日历开始时间（格式：yyyy-MM-dd HH:mm:ss）", required = false)
                                                      @RequestParam(value = "executeStartTime", required = false)String executeStartTime,
                                                  @ApiParam(name = "executeEndTime", value = "日历结束时间（格式：yyyy-MM-dd HH:mm:ss）", required = false)
                                                      @RequestParam(value = "executeEndTime", required = false)String executeEndTime,
                                                  @ApiParam(name = "patient", value = "患者code", required = true)
                                                      @RequestParam(value = "patient", required = true)String patient,
                                                  @ApiParam(name = "searchTask", value = "快速查找任务：（1电话/短信关怀,2康复咨询,3健康监测,4上门服务,5康复指导,6康复随访,7康复复诊）", required = false)
                                                      @RequestParam(value = "searchTask", required = false)Integer searchTask,
                                                  @ApiParam(name = "doctorCode", value = "医生code（专科医生、家庭医生）", required = false)
                                                      @RequestParam(value = "doctorCode", required = false)String doctorCode,
                                                  @ApiParam(name = "status", value = "任务状态（0未完成，1已完成，2已预约）", required = false)
                                                      @RequestParam(value = "status", required = false)Integer status,
                                                  @ApiParam(name="taskExecutor",value = "任务执行人：0全部；1我的任务：2他人任务",required = false)
                                                      @RequestParam(value = "taskExecutor",required = false,defaultValue = "0")String taskExecutor){
        try {
            if(!StringUtils.isNotEmpty(doctorCode)){
                doctorCode = getUID();
            }
            return rehabilitationManageService.calendarPlanDetailByPatient(executeStartTime,executeEndTime,patient,searchTask,status,doctorCode,"1");
        } catch (Exception e) {

            return ObjEnvelop.getError(e.getMessage());
        }
    }
    @RequestMapping(value = "calendarPlanDetailListBypatient", method = RequestMethod.GET)
    @ApiOperation("康复管理--某患者的康复计划按列表展示")
    public ObjEnvelop calendarPlanDetailListBypatient(@ApiParam(name = "executeStartTime", value = "日历开始时间（格式：yyyy-MM-dd HH:mm:ss）", required = false)
                                                  @RequestParam(value = "executeStartTime", required = false)String executeStartTime,
                                                  @ApiParam(name = "executeEndTime", value = "日历结束时间（格式：yyyy-MM-dd HH:mm:ss）", required = false)
                                                  @RequestParam(value = "executeEndTime", required = false)String executeEndTime,
                                                  @ApiParam(name = "patient", value = "患者code", required = true)
                                                  @RequestParam(value = "patient", required = true)String patient,
                                                  @ApiParam(name = "searchTask", value = "快速查找任务：（1电话/短信关怀,2康复咨询,3健康监测,4上门服务,5康复指导,6康复随访,7康复复诊）", required = false)
                                                  @RequestParam(value = "searchTask", required = false)Integer searchTask,
                                                  @ApiParam(name = "doctorCode", value = "医生code（专科医生、家庭医生）", required = false)
                                                  @RequestParam(value = "doctorCode", required = false)String doctorCode,
                                                  @ApiParam(name = "status", value = "任务状态（0未完成，1已完成，2已预约）", required = false)
                                                  @RequestParam(value = "status", required = false)Integer status,
                                                  @ApiParam(name="taskExecutor",value = "任务执行人：0全部；1我的任务：2他人任务",required = false)
                                                  @RequestParam(value = "taskExecutor",required = false,defaultValue = "0")String taskExecutor){
        try {
            if(!StringUtils.isNotEmpty(doctorCode)){
                doctorCode = getUID();
            }
            return rehabilitationManageService.calendarPlanDetailListByPatient(executeStartTime,executeEndTime,patient,searchTask,status,doctorCode,taskExecutor);

        } catch (Exception e) {
            e.printStackTrace();
            return ObjEnvelop.getError( "请求失败");
        }
    }
    @RequestMapping(value = RehabilitationRequestMapping.DoctorRehabilitationManage.calendarPlanDetailList, method = RequestMethod.GET)
    @ApiOperation("康复管理-康复计划按列表展示")
    public ObjEnvelop calendarPlanDetailList(@ApiParam(name = "executeStartTime", value = "日历开始时间（格式：yyyy-MM-dd HH:mm:ss）", required = true)
                                     @RequestParam(value = "executeStartTime", required = true)String executeStartTime,
                                     @ApiParam(name = "executeEndTime", value = "日历结束时间（格式：yyyy-MM-dd HH:mm:ss）", required = true)
                                     @RequestParam(value = "executeEndTime", required = true)String executeEndTime,
                                     @ApiParam(name = "planId", value = "计划id", required = true)
                                     @RequestParam(value = "planId", required = true)String planId,
                                     @ApiParam(name = "searchTask", value = "快速查找任务：（1、我的任务，2、健康教育，3、健康指导，4、随访，5、复诊）", required = false)
                                     @RequestParam(value = "searchTask", required = false)Integer searchTask,
                                     @ApiParam(name = "doctorCode", value = "医生code（专科医生、家庭医生）", required = false)
                                     @RequestParam(value = "doctorCode", required = false)String doctorCode,
                                     @ApiParam(name = "status", value = "任务状态（0未完成，1已完成，2已预约）", required = false)
                                     @RequestParam(value = "status", required = false)Integer status,
                                         @ApiParam(name = "taskExecutor", value = "", required = false)
                                             @RequestParam(value = "taskExecutor", required = false)String taskExecutor){
        try {
            if(!StringUtils.isNotEmpty(doctorCode)){
                doctorCode = getUID();
            }
            return rehabilitationManageService.calendarPlanDetailList( planId, searchTask, status, doctorCode, executeStartTime, executeEndTime,taskExecutor);
        } catch (Exception e) {
            return ObjEnvelop.getError(e.getMessage());
        }
    }

    @RequestMapping(value = RehabilitationRequestMapping.DoctorRehabilitationManage.serviceItemList, method = RequestMethod.GET)
    @ApiOperation("康复管理-多个康复计划服务项目内容列表")
    public ObjEnvelop serviceItemList(@ApiParam(name = "planDetailIds", value = "康复计划多个服务项目id（多个‘，’分隔）", required = true)
                                                   @RequestParam(value = "planDetailIds", required = true)String planDetailIds,
                                  @ApiParam(name = "doctorCode", value = "医生code", required = false)
                                  @RequestParam(value = "doctorCode", required = false)String doctorCode){

        try {
            if(!StringUtils.isNotEmpty(doctorCode)){
                doctorCode = getUID();
            }
            return  rehabilitationManageService.serviceItemList(planDetailIds,doctorCode);
        } catch (Exception e) {
            e.printStackTrace();
            return ObjEnvelop.getError(e.getMessage());
        }
    }

    @RequestMapping(value = RehabilitationRequestMapping.DoctorRehabilitationManage.serviceItem, method = RequestMethod.GET)
    @ApiOperation("康复管理-康复计划服务项目确认详情页")
    public ObjEnvelop serviceItem(@ApiParam(name = "planDetailId", value = "康复计划服务项目id", required = true)
                              @RequestParam(value = "planDetailId", required = true)String planDetailId,
                              @ApiParam(name = "doctorCode", value = "医生code", required = false)
                              @RequestParam(value = "doctorCode", required = false)String doctorCode,
                              @ApiParam(name = "recordId", value = "记录id", required = false)
                                  @RequestParam(value = "recordId", required = false)String recordId){

        try {
            if(!StringUtils.isNotEmpty(doctorCode)){
                doctorCode = getUID();
            }

            return rehabilitationManageService.serviceItem(planDetailId,doctorCode,recordId);
        } catch (Exception e) {
          e.printStackTrace();
            return ObjEnvelop.getError(e.getMessage());
        }
    }

    @RequestMapping(value = RehabilitationRequestMapping.DoctorRehabilitationManage.saveGuidanceMessage, method = RequestMethod.POST)
    @ApiOperation("康复管理-保存指导留言")
    public Envelop saveGuidanceMessage(@ApiParam(name = "messageId", value = "消息id", required = true)
                                      @RequestParam(value = "messageId", required = true)String messageId,
//                                      @ApiParam(name = "patientCode", value = "居民code", required = true)
//                                      @RequestParam(value = "patientCode", required = false)String patientCode,
                                      @ApiParam(name = "doctorCode", value = "医生code", required = false)
                                      @RequestParam(value = "doctorCode", required = false)String doctorCode,
//                                      @ApiParam(name = "doctorType", value = "医生类型（1、专科医生，2、家庭医生）", required = true)
//                                      @RequestParam(value = "doctorType", required = true)Integer doctorType,
                                      @ApiParam(name = "content", value = "聊天内容", required = true)
                                      @RequestParam(value = "content", required = true)String content,
                                      @ApiParam(name = "planDetailId", value = "服务项目id", required = true)
                                      @RequestParam(value = "planDetailId", required = true)String planDetailId,
                                      @ApiParam(name = "contentType", value = "内容类型(1,6,8 - 文本， 2，9- 图片， 3 - 语音， 4-文章， 5,7系统消息。12-语音 18-居民名片， 19-聊天记录)", required = true)
                                      @RequestParam(value = "contentType", required = true)Integer contentType){

        try {
            if(!StringUtils.isNotEmpty(doctorCode)){
                doctorCode = getUID();
            }

            return  rehabilitationManageService.saveGuidanceMessage(messageId,doctorCode,content,planDetailId,contentType);
        } catch (Exception e) {
          e.printStackTrace();
            return Envelop.getError(e.getMessage());
        }
    }

    @RequestMapping(value = RehabilitationRequestMapping.DoctorRehabilitationManage.updateStatusRehabilitationOperate, method = RequestMethod.POST)
    @ApiOperation("康复管理-更新康复计划操作完成日志状态")
    public Envelop updateStatusRehabilitationOperate(@ApiParam(name = "planDetailId", value = "服务项目id", required = true)
                                                    @RequestParam(value = "planDetailId", required = true)String planDetailId,
                                                    @ApiParam(name = "status", value = "状态", required = true)
                                                    @RequestParam(value = "status", required = true)Integer status){

        return rehabilitationManageService.updateStatusRehabilitationOperate(status,planDetailId);

    }

    @RequestMapping(value = RehabilitationRequestMapping.DoctorRehabilitationManage.patientRehabilitationDetail, method = RequestMethod.GET)
    @ApiOperation("康复管理-居民详情页")
    public ObjEnvelop patientRehabilitationDetail(@ApiParam(name = "patientCode", value = "居民code", required = true)
                                              @RequestParam(value = "patientCode", required = true)String patientCode){

        return rehabilitationManageService.patientRehabilitationDetail(patientCode);

    }

    @RequestMapping(value = RehabilitationRequestMapping.DoctorRehabilitationManage.recentPlanDetailRecord, method = RequestMethod.GET)
    @ApiOperation("康复管理-近期康复相关记录")
    public ObjEnvelop recentPlanDetailRecord(@ApiParam(name = "patientCode", value = "居民code", required = true)
                                         @RequestParam(value = "patientCode", required = true)String patientCode,
                                         @ApiParam(name = "startTime", value = "开始时间（格式：yyyy-MM-dd HH:mm:ss）", required = false)
                                         @RequestParam(value = "startTime", required = false)String startTime,
                                         @ApiParam(name = "endTime", value = "结束时间（格式：yyyy-MM-dd HH:mm:ss）", required = false)
                                         @RequestParam(value = "endTime", required = false)String endTime,
                                         @ApiParam(name = "page", value = "第几页，从1开始", required = true)
                                         @RequestParam(value = "page", required = false,defaultValue = "1")Integer page,
                                         @ApiParam(name = "pageSize", value = "每页分页大小", required = true)
                                        @RequestParam(value = "pageSize", required = false,defaultValue = "10")Integer pageSize){

        try {

            return  rehabilitationManageService.recentPlanDetailRecord(patientCode,startTime,endTime,page,pageSize);
        } catch (Exception e) {
            e.printStackTrace();
            return ObjEnvelop.getError(e.getMessage());
        }
    }



    @RequestMapping(value = RehabilitationRequestMapping.DoctorRehabilitationManage.serviceDoctorList, method = RequestMethod.GET)
    @ApiOperation("康复管理-医生端居民详情服务医生列表")
    public ObjEnvelop serviceDoctorList(@ApiParam(name = "patientCode", value = "居民code", required = true)
                                    @RequestParam(value = "patientCode", required = true)String patientCode){

        try {

            return  rehabilitationManageService.serviceDoctorList(patientCode);
        } catch (Exception e) {
           e.printStackTrace();
            return ObjEnvelop.getError(e.getMessage());
        }
    }

    @RequestMapping(value = RehabilitationRequestMapping.DoctorRehabilitationManage.appCalendarPlanDetailList, method = RequestMethod.GET)
    @ApiOperation("康复管理-app端、微信端计划的服务项目列表")
    public ObjEnvelop appCalendarPlanDetailList(@ApiParam(name = "executeStartTime", value = "日历开始时间（格式：yyyy-MM-dd HH:mm:ss）", required = true)
                                            @RequestParam(value = "executeStartTime", required = true)String executeStartTime,
                                            @ApiParam(name = "executeEndTime", value = "日历结束时间（格式：yyyy-MM-dd HH:mm:ss）", required = true)
                                            @RequestParam(value = "executeEndTime", required = true)String executeEndTime,
                                            @ApiParam(name = "planId", value = "计划id", required = true)
                                            @RequestParam(value = "planId", required = true)String planId,
                                            @ApiParam(name = "searchTask", value = "快速查找任务：（1、我的任务，2、随访，3、复诊，4、健康教育）", required = false)
                                            @RequestParam(value = "searchTask", required = false)Integer searchTask,
                                            @ApiParam(name = "status", value = "任务状态（0未完成，1已完成，2已预约）", required = false)
                                            @RequestParam(value = "status", required = false)Integer status){
        try {

            return  rehabilitationManageService.appCalendarPlanDetailList(planId,searchTask,status,executeStartTime,executeEndTime);
        } catch (Exception e) {
           e.printStackTrace();
            return ObjEnvelop.getError(e.getMessage());
        }
    }



    @PostMapping(value = RehabilitationRequestMapping.DoctorRehabilitationManage.updateNoteAndImageRehabilitationOperate)
    @ApiOperation(value = "康复计划完成时更新服务完成笔记和图片接口并且确认完成")
    public ObjEnvelop updateNoteAndImageRehabilitationOperate(@ApiParam(name = "planDetailId", value = "服务项目id", required = true)@RequestParam(value = "planDetailId", required = true)String planDetailId,
                                                              @ApiParam(name = "node", value = "服务完成笔记", required = true)@RequestParam(value = "node", required = false)String node,
                                                              @ApiParam(name = "image", value = "相关记录图片，json格式", required = true)@RequestParam(value = "image", required = false)String image,
                                                              @ApiParam(name = "relationCode", value = "业务code", required = true)@RequestParam(value = "relationCode", required = false)String relationCode,
                                                              @ApiParam(name = "status", value = "是否确认完成 0未确认 1确认", required = true)@RequestParam(value = "status", required = false)String status){
        try {
            Map<String,Object> map = rehabilitationManageService.updateNodeAndRelationRecordImg(node,image,status,planDetailId,relationCode);
            return ObjEnvelop.getSuccess(SpecialistMapping.api_success,map);

        }catch (Exception e){
            e.printStackTrace();
            return ObjEnvelop.getError(e.getMessage());
        }
    }

    @PostMapping(value =  RehabilitationRequestMapping.DoctorRehabilitationManage.updatePlanDetailStatusById)
    @ApiOperation(value = "康复管理-更新康复计划项目状态")
    public Envelop updatePlanDetailStatusById(@ApiParam(name = "planDetailId", value = "服务项目id", required = true)
                                              @RequestParam(value = "planDetailId", required = true)String planDetailId,
                                              @ApiParam(name = "status", value = "状态", required = true)
                                              @RequestParam(value = "status", required = true)Integer status){
        try {
            return rehabilitationManageService.updatePlanDetailStatusById(status,planDetailId);
        }catch (Exception e){
            e.printStackTrace();
            return Envelop.getError(e.getMessage());
        }
    }

    @PostMapping(value =  RehabilitationRequestMapping.DoctorRehabilitationManage.updatePlanDetailExecuteTimeById)
    @ApiOperation(value = "康复管理-修改康复计划项目执行时间")
    public Envelop updatePlanDetailExecuteTimeById(@ApiParam(name = "planDetailId", value = "服务项目id", required = true)
                                                   @RequestParam(value = "planDetailId", required = true)String planDetailId,
                                                   @ApiParam(name = "executeTime", value = "状态", required = true)
                                                   @RequestParam(value = "executeTime", required = true)String executeTime){
        try {
            Date date = DateUtil.strToDateLong(executeTime);
            return rehabilitationManageService.updatePlanDetailExecuteTimeById(date,planDetailId);
        }catch (Exception e){
            e.printStackTrace();
            return Envelop.getError(e.getMessage());
        }
    }



    @RequestMapping(value =  RehabilitationRequestMapping.DoctorRehabilitationManage.planSchedule, method = RequestMethod.GET)
    @ApiOperation("康复管理-计划总进度")
    public ObjEnvelop planSchedule(@ApiParam(name = "planId", value = "计划id", required = true)
                               @RequestParam(value = "planId", required = true)String planId,
                               @ApiParam(name = "patientCode", value = "居民code", required = true)
                               @RequestParam(value = "patientCode", required = true)String patientCode){

        try {
            return rehabilitationManageService.planSchedule(planId,patientCode);
        }catch (Exception e){
            e.printStackTrace();
            return ObjEnvelop.getError(e.getMessage());
        }
    }

    @GetMapping(value =  RehabilitationRequestMapping.DoctorRehabilitationManage.patientCount)
    @ApiOperation(value = "医生已计划数，已完成计划数（居民数）")
    public ObjEnvelop patientCount(@ApiParam(name = "doctorCode", value = "医生code", required = true)
                                   @RequestParam(value = "doctorCode", required = true)String doctorCode){
        try {
            return rehabilitationManageService.patientCount(doctorCode);
        }catch (Exception e){
            e.printStackTrace();
            return ObjEnvelop.getError(e.getMessage());
        }
    }

    @PostMapping(value =  RehabilitationRequestMapping.DoctorRehabilitationManage.sendToFamilyDoctor)
    @ApiOperation(value = "给家医发送居民的康复计划")
    public Envelop sendBusinessCard(@ApiParam(name = "doctorCode", value = "专医code")
                                    @RequestParam(value = "doctorCode", required = true) String doctorCode,
                                    @ApiParam(name = "doctorName", value = "专医名字")
                                    @RequestParam(value = "doctorName", required = true) String doctorName,
                                    @ApiParam(name = "sessionId", value = "会话id", defaultValue = "")
                                    @RequestParam(value = "sessionId", required = true) String sessionId,
                                    @ApiParam(name = "businessType", value = "businessType", defaultValue = "1")
                                    @RequestParam(value = "businessType", required = true) String businessType,
                                    @ApiParam(name = "contentJsonStr", value = "contentJsonStr")
                                    @RequestParam(value = "contentJsonStr", required = true) String contentJsonStr){
        try {
            imUtill.sendImMsg(doctorCode,doctorName,sessionId,ImUtil.ContentType.Rehabilitation.getValue(),contentJsonStr,businessType,"");
            return Envelop.getSuccess(SpecialistMapping.api_success);
        }catch (Exception e){
            e.printStackTrace();
            return Envelop.getError(e.getMessage());
        }
    }

    @GetMapping(value =  RehabilitationRequestMapping.DoctorRehabilitationManage.getServiceItemsAfterStop)
    @ApiOperation(value = "康复管理-中止康复计划结算项目清单")
    public ObjEnvelop getServiceItemsAfterStop(@ApiParam(name = "planId", value = "康复计划id", required = true)
                                               @RequestParam(value = "planId", required = true)String planId){
        try {
            return ObjEnvelop.getSuccess("操作成功",rehabilitationManageService.getServiceItemsAfterStop(planId));
        }catch (Exception e){
            e.printStackTrace();
            return ObjEnvelop.getError(e.getMessage());
        }
    }


    /**
     * 康复管理-频次列表
     *
     * @return
     */
    @RequestMapping(value =  RehabilitationRequestMapping.DoctorRehabilitationManage.selectFrequencys, method = RequestMethod.GET)
    @ApiOperation("康复管理-频次列表")
    public MixEnvelop selectFrequencys(){

        try {
            return MixEnvelop.getSuccess("操作成功",rehabilitationManageService.selectFrequences());
        } catch (Exception e) {
            return MixEnvelop.getError( e.getMessage());
        }
    }

    @RequestMapping(value = "selectAllPlaneByPatient",method = RequestMethod.GET)
    @ApiOperation("获取居民所有康复计划")
    public Envelop getPatientAllRehabilitationPlan(@ApiParam(name = "patient",value = "居民Code", required = true)
                                                  @RequestParam(value = "patient",required = true)String patient){
        try {
            return success("获取成功",  rehabilitationManageService.getPatientAllRehabilitationPlan(patient));
        }catch (Exception e){
            return failed( "请求失败");
        }
    }

    @RequestMapping(value = "selectByGuidance", method = RequestMethod.GET)
    @ApiOperation("康复管理-根据计划查询指导留言")
    public Envelop selectByGuidance(@ApiParam(name = "planId", value = "计划id", required = false)
                                   @RequestParam(value = "planId", required = true)String planId,
                                   @ApiParam(name = "itemCode", value = "服务项目code", required = true)
                                   @RequestParam(value = "itemCode", required = true)String itemCode){

        try {
            List<Map<String,Object>> mapList = rehabilitationManageService.selectByGuidance(planId,itemCode);
            return success("获取成功",  mapList);
        } catch (Exception e) {
            return failed( "请求失败");
        }
    }


    @RequestMapping(value = "manageAllPlanByPatient",method = RequestMethod.POST)
    @ApiOperation("一键确认管理居民所有的康复计划")
    public Envelop manageAllPlanByPatient(@ApiParam(name="patient",value = "患者code",required = true)
                                         @RequestParam(value = "patient",required = true)String patient){
        try {
            return  success("操作成功",rehabilitationManageService.manageAllPlanByPatient(patient,getUID()));
        }catch (Exception e){
            return failed( "请求失败");
        }
    }


    @PostMapping(value = "planDetailAfterCall")
    @ApiOperation(value = "康复管理-电话关怀拨打后生成记录对应怪坏记录")
    public MixEnvelop<RehabilitationOperateRecordsDO,RehabilitationOperateRecordsDO> planDetailAfterCall(
            @ApiParam(name = "planDetailId", value = "planDetailId", required = false)
            @RequestParam(value = "planDetailId", required = false)String planDetailId,
            @ApiParam(name = "doctorCode", value = "doctorCode", required = false)
            @RequestParam(value = "doctorCode", required = false)String doctorCode,
            @ApiParam(name = "doctorName", value = "doctorName", required = false)
            @RequestParam(value = "doctorName", required = false)String  doctorName){
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("doctorCode",doctorCode);
        jsonObject.put("doctorName",doctorName);
        jsonObject.put("rehabilitationDetailId",planDetailId);
        try {
            return MixEnvelop.getSuccess(SpecialistMapping.api_success,rehabilitationManageService.planDetailAfterCall(jsonObject.toString()));
        }catch (Exception e){
            e.printStackTrace();
            return MixEnvelop.getError(e.getMessage());
        }
    }


    @RequestMapping(value = "/dailyJobSendMessage", method = RequestMethod.POST)
    @ApiOperation("康复管理-康复计划每天8点,16点发送服务进展的job")
    @ObserverRequired
    public Envelop dailyJobSendMessage(@ApiParam(name = "startTime", value = "开始时间（格式：yyyy-MM-dd HH:mm:ss）", required = true)
                                      @RequestParam(value = "startTime", required = true)String startTime,
                                      @ApiParam(name = "endTime", value = "结束时间（格式：yyyy-MM-dd HH:mm:ss）", required = true)
                                      @RequestParam(value = "endTime", required = true)String endTime,
                                      @ApiParam(name = "type", value = "8点：23,16点：22", required = true)
                                      @RequestParam(value = "type", required = true)Integer type){

        try {
            rehabilitationManageService.dailyJobSendMessage(startTime,endTime,type);
            return success( "发送成功");
        } catch (Exception e) {

            return failed( "发送失败");
        }
    }


    @RequestMapping(value = "/tomorrowJobSendMessage", method = RequestMethod.POST)
    @ApiOperation("康复管理-康复计划每天15点发送明天服务定时提醒的job")
    @ObserverRequired
    public Envelop tomorrowJobSendMessage(@ApiParam(name = "startTime", value = "开始时间（格式：yyyy-MM-dd HH:mm:ss）", required = true)
                                         @RequestParam(value = "startTime", required = true)String startTime,
                                         @ApiParam(name = "endTime", value = "结束时间（格式：yyyy-MM-dd HH:mm:ss）", required = true)
                                         @RequestParam(value = "endTime", required = true)String endTime,
                                         @ApiParam(name = "type", value = "15点：23", required = true)
                                         @RequestParam(value = "type", required = true)Integer type){

        try {
            rehabilitationManageService.tomorrowJobSendMessage(startTime,endTime,type);
            return success( "发送成功");
        } catch (Exception e) {

            return failed( "发送失败");
        }
    }

    @RequestMapping(value = "/dailyByJobSendMessage", method = RequestMethod.POST)
    @ApiOperation("康复管理-康复计划每15分钟服务进展提醒")
    @ObserverRequired
    public Envelop dailyByJobSendMessage(@ApiParam(name = "startTime", value = "开始时间（格式：yyyy-MM-dd HH:mm:ss）", required = true)
                                        @RequestParam(value = "startTime", required = true)String startTime,
                                        @ApiParam(name = "endTime", value = "结束时间（格式：yyyy-MM-dd HH:mm:ss）", required = true)
                                        @RequestParam(value = "endTime", required = true)String endTime,
                                        @ApiParam(name = "type", value = "15分钟，22", required = true)
                                        @RequestParam(value = "type", required = true)Integer type){

        try {
            rehabilitationManageService.dailyByJobSendMessage(startTime,endTime,type);
            return success( "发送成功");
        } catch (Exception e) {

            return failed( "发送失败");
        }
    }

    @RequestMapping(value = "/dailyJobReserve", method = RequestMethod.POST)
    @ApiOperation("康复管理-10天、7天、5天、当天(0)康复服务预约复诊通知")
    @ObserverRequired
    public Envelop dailyJobReserve(@ApiParam(name = "num", value = "10天、7天、5天、当天康复服务预约复诊通知", required = false)
                                  @RequestParam(value = "num", required = false)Integer num){

        try {
            if(num!=null){
                rehabilitationManageService.dailyJobReserve(num,20);
            }else{
                Integer[] days = {10,7,5,0};
                for(Integer one : days){
                    rehabilitationManageService.dailyJobReserve(one,20);
                }
            }
            return success( "发送成功");
        } catch (Exception e) {

            return failed( "发送失败");
        }
    }


    @RequestMapping(value = "selectByMedicalCode", method = RequestMethod.GET)
    @ApiOperation("获取医院病历")
    public Envelop selectByMedicalCode(@ApiParam(name = "medical", value = "住院code", required = true)
                                      @RequestParam(value = "medical", required = true)String medical){

        try {
            List<PatientMedicalRecordsDO> result = rehabilitationManageService.selectByMedicalCode(medical);
            try {
                String sql = "UPDATE `wlyy_patient_medical_records_rehabilitation` SET `doctor_read_status`='1' WHERE (`code`='"+medical+"') ";
                jdbcTemplate.update(sql);
            }catch (Exception e){
                e.printStackTrace();
            }
            return success("操作成功", result);
        } catch (Exception e) {
            return failed( "请求失败");
        }
    }

    @RequestMapping(value = "getPlanDetailForModifing",method = RequestMethod.GET)
    @ApiOperation(value = "根据planId、模板id获取计划列表")
    public Envelop getPlanDetailForModifing(@ApiParam(name = "planId",value = "康复计划id",required = true)
                                           @RequestParam(value = "planId",required = true) String planId,
                                           @ApiParam(name = "templateId",value = "模板Id,不传默认为系统模板",required = false)
                                           @RequestParam(value = "templateId",required = false) String templateId){
        try {
            return success("查询成功",rehabilitationManageService.getPlanDetailForModifing(planId, templateId));
        }catch (Exception e){
            return failed("查询失败");
        }
    }

    @RequestMapping(value = "selectPlanServerDoctor", method = RequestMethod.POST)
    @ApiOperation("康复管理-康复计划的服务医生")
    public Envelop selectPlanServerDoctor(@ApiParam(name = "planId", value = "康复计划ID")@RequestParam(value = "planId", required = true)String planId){

        try {
            String doctorCode = getUID();
            return success("查询成功",rehabilitationManageService.selectPlanServerDoctor(planId,doctorCode));
        } catch (Exception e) {
            e.printStackTrace();
            return failed( "查询失败");
        }
    }


    @RequestMapping(value = "selectBySpecialistDoctor", method = RequestMethod.GET)
    @ApiOperation("康复管理-获取专科居民")
    public String selectBySpecialistDoctor(@ApiParam(name = "doctorCode", value = "医生code", required = false)
                                           @RequestParam(value = "doctorCode", required = false)String doctorCode,
                                           @ApiParam(name = "doctorType", value = "医生类型（1专科2家医）", required = false)
                                           @RequestParam(value = "doctorType", required = false)String doctorType,
                                           @ApiParam(name = "patientInfo", value = "身份证或者姓名", required = false)
                                           @RequestParam(value = "patientInfo", required = false)String patientInfo,
                                           @ApiParam(name = "diseaseCode", value = "疾病类型code", required = false)
                                           @RequestParam(value = "diseaseCode", required = false)String diseaseCode,
                                           @ApiParam(name = "level", value = "1市2区3社区", required = false)
                                           @RequestParam(value = "level", required = false)String level,
                                           @ApiParam(name = "area", value = "区域", required = false)
                                           @RequestParam(value = "area", required = false)String area,
                                           @ApiParam(name = "page", value = "第几页，从1开始", required = true)
                                           @RequestParam(value = "page", required = false,defaultValue = "1")Integer page,
                                           @ApiParam(name = "pageSize", value = "每页分页大小", required = true)
                                           @RequestParam(value = "pageSize", required = false,defaultValue = "10")Integer pageSize,
                                           @ApiParam(name = "filterPlan", value = "是否过滤康复计划，1过滤，0或者放空不过滤", required = false)
                                           @RequestParam(value = "filterPlan", required = false)String filterPlan,
                                           @ApiParam(name = "turnDownState", value = "下转状态 0全部;1已下转;2已接受;3未下转", required = false)
                                           @RequestParam(value="turnDownState", required = false,defaultValue = "0")String turnDownState
    ) {
        try {
            if(!StringUtils.isNotEmpty(doctorCode)){
                doctorCode = getUID();
            }
            JSONObject result = rehabilitationManageService.selectBySpecialistDoctor1(level,area,doctorCode,diseaseCode,page,pageSize,doctorType,patientInfo,filterPlan,turnDownState);
            JSONArray showList = result.getJSONArray("showList");
            JSONObject turnDownStateObj = result.getJSONObject("turnDownState");
            JSONObject json = new JSONObject();
            json.put("status", 200);
            json.put("msg", "获取成功");
            json.put("data",showList);
            json.put("data2",turnDownStateObj);
            return json.toString();
        } catch (Exception e) {
            e.printStackTrace();
            return "请求失败";
        }
    }
    @RequestMapping(value = "createSpecialDoctorQrCode", method = RequestMethod.POST)
    @ApiOperation("康复管理-生成康复下转专科医生二维码")
    @ObserverRequired
    public Envelop createSpecialDoctorQrCode(
            @ApiParam(name = "doctorCode", value = "医生code")@RequestParam(value = "doctorCode", required = true)String doctorCode,
            @ApiParam(name = "teamCode", value = "团队CODE")@RequestParam(value = "teamCode", required = true)String teamCode,
            @ApiParam(name = "teamName", value = "团队名称")@RequestParam(value = "teamName", required = true)String teamName
    ){

        try {
            return success("获取二维码成功！", rehabilitationManageService.createSpecialDoctorQrCode(doctorCode,teamCode,teamName));
        } catch (Exception e) {
            return failed( "请求二维码失败");
        }
    }


    @RequestMapping(value = "selectAllCompleteServiceItemsByPatient",method = RequestMethod.GET)
    @ApiOperation("康复计划主页动态")
    public Envelop selectAllCompleteServiceItemsByPatient(@ApiParam(name = "patient",value = "居民Code", required = true)
                                                         @RequestParam(value = "patient",required = true)String patient){
        try {
            return success("获取成功", rehabilitationManageService.selectAllCompleteServiceItemsByPatient(patient));
        }catch (Exception e){
            return failed("请求失败");
        }
    }
    @RequestMapping(value = "calendarPlanDetailItems", method = RequestMethod.GET)
    @ApiOperation("康复管理-康复计划服务项目按列表展示")
    public Envelop calendarPlanDetailItems(@ApiParam(name = "executeStartTime", value = "日历开始时间（格式：yyyy-MM-dd HH:mm:ss）", required = false)
                                          @RequestParam(value = "executeStartTime", required = false)String executeStartTime,
                                          @ApiParam(name = "executeEndTime", value = "日历结束时间（格式：yyyy-MM-dd HH:mm:ss）", required = false)
                                          @RequestParam(value = "executeEndTime", required = false)String executeEndTime,
                                          @ApiParam(name = "planId", value = "计划id", required = true)
                                          @RequestParam(value = "planId", required = true)String planId,
                                          @ApiParam(name = "searchTask", value = "快速查找任务：（1、我的任务，2、健康教育，3、健康指导，4、随访，5、复诊）", required = false)
                                          @RequestParam(value = "searchTask", required = false)Integer searchTask,
                                          @ApiParam(name = "doctorCode", value = "医生code（专科医生、家庭医生）", required = false)
                                          @RequestParam(value = "doctorCode", required = false)String doctorCode,
                                          @ApiParam(name = "status", value = "任务状态（0未完成，1已完成，2已预约）", required = false)
                                          @RequestParam(value = "status", required = false)Integer status){
        try {
            if(!StringUtils.isNotEmpty(doctorCode)){
                doctorCode = getUID();
            }
            List<Map<String,Object>> result = rehabilitationManageService.calendarPlanDetailItems(executeStartTime,executeEndTime,planId,searchTask,status,doctorCode);
            return success( "获取成功", result);
        } catch (Exception e) {
            e.printStackTrace();
            return failed( "请求失败");
        }
    }


    @RequestMapping(value = "confirmManage", method = RequestMethod.GET)
    @ApiOperation("康复管理-确认管理")
    public Envelop confirmManage(@ApiParam(name = "doctor", value = "签约医生code", required = true)
                                @RequestParam(value = "doctor", required = true) String signDoctor,
                                @ApiParam(name = "patient", value = "居民code", required = true)
                                @RequestParam(value = "patient", required = true) String patient,
                                @ApiParam(name = "specialist", value = "专医code", required = true)
                                @RequestParam(value = "specialist", required = true) String specialist,
                                @ApiParam(name = "relationId", value = "签约关系id", required = true)
                                @RequestParam(value = "relationId", required = false) String relationId,
                                @ApiParam(name = "planId", value = "计划id", required = true)
                                @RequestParam(value = "planId", required = false) String planId) {

        try {
            rehabilitationManageService.confirmManage(patient,signDoctor,specialist,relationId,planId);
            return success("请求成功！");
        } catch (Exception e) {
            e.printStackTrace();
            return failed( "请求失败");
        }
    }


    @RequestMapping(value = "selectByPlanDetaiId", method = RequestMethod.GET)
    @ApiOperation("康复管理-获取操作记录")
    public Envelop selectByPlanDetaiId(@ApiParam(name = "patient", value = "居民code", required = true)
                                      @RequestParam(value = "patient", required = false)String patient,
                                      @ApiParam(name = "planId", value = "计划id", required = true)
                                      @RequestParam(value = "planId", required = true)String planId,
                                      @ApiParam(name = "code", value = "服务项目code", required = true)
                                      @RequestParam(value = "code", required = true)String code,
                                      @ApiParam(name = "page", value = "", required = false)
                                      @RequestParam(value = "page", required = false)Integer page,
                                      @ApiParam(name = "pagesize", value = "", required = false)
                                      @RequestParam(value = "pagesize", required = false)Integer pagesize){
        try {

            return success("获取成功",  rehabilitationManageService.selectByPlanDetaiId(patient,planId,code,page,pagesize).toString());
        } catch (Exception e) {
            e.printStackTrace();
            return failed("请求失败");
        }
    }


    /*@GetMapping(value = "selectRelationCode")
    @ResponseBody
    @ApiOperation("业务关联code")
    public Envelop selectRelationCode(@ApiParam(name = "relationCode", value = "业务关联code",required = true)
                                     @RequestParam String relationCode) {
        try {
            return success("请求成功！",wlyyDoorServiceOrderService.selectRelationCode(relationCode));
        } catch (Exception e) {
            e.printStackTrace();
            return failed( "请求失败");
        }
    }*/

    @RequestMapping(value = "getServiceItemList", method = RequestMethod.GET)
    @ApiOperation("康复管理-获取服务项目列表")
    public Envelop getServiceItemList(@ApiParam(name = "name", value = "服务项目名称", required = false)
                                     @RequestParam(value = "name", required = false) String name) {

        try {
            return success( "请求成功！", rehabilitationManageService.getServiceItemList(name));
        } catch (Exception e) {
            e.printStackTrace();
            return failed("请求失败");
        }
    }
    @ApiOperation("获取居民最近的一次住院病历")//wlyy_patient_medical_records_rehabilitation
    @RequestMapping(value = "getNewRehabilitation", method = RequestMethod.GET)
    public Envelop getNewRehabilitation(
            @ApiParam(name = "patientCode", value = "居民code", required = true)
            @RequestParam(value = "patientCode", required = true)String patientCode){
        try {
            List<PatientMedicalRecordsDO> result = rehabilitationManageService.getNewRehabilitation(patientCode,getUID());
            return success("获取成功", result);
        } catch (Exception e) {
            e.printStackTrace();
            return failed( "请求失败");
        }
    }

    @RequestMapping(value = "selectPlanByPatient", method = RequestMethod.GET)
    @ApiOperation("康复管理-根据居民code查找康复计划")
    public Envelop calendarPlanDetailItems(@ApiParam(name = "patient", value = "居民code", required = false)
                                          @RequestParam(value = "patient", required = false)String patient,
                                          @ApiParam(name = "status", value = "任务状态（0未完成，1已完成，2已预约）", required = false)
                                          @RequestParam(value = "status", required = false)Integer status,
                                          @ApiParam(name = "planId", value = "计划id", required = false)
                                          @RequestParam(value = "planId", required = false)String planId){
        try {
            List<Map<String,Object>> result = rehabilitationManageService.selectPlanByPatient(patient,status,planId,getUID());
            return success("获取成功",  result);
        } catch (Exception e) {
            e.printStackTrace();
            return failed( "请求失败");
        }
    }


    /**
     *
     * @param patient 居民code
     * @param doctor 专科医生code
     * @param type 1康复指导2康复下转3复诊提醒4上门服务提醒5家签提醒
     * @param relationCode 业务关联code
     * @param planId 计划id
     * @return
     */
    @RequestMapping(value = "sendSpecialistWeixinMessage", method = RequestMethod.GET)
    @ApiOperation("康复管理-发送微信模板消息")
    @ObserverRequired
    public Envelop sendSpecialistWeixinMessage(@ApiParam(name = "patient", value = "居民code", required = true)
                                              @RequestParam(value = "patient", required = true) String patient,
                                              @ApiParam(name = "doctor", value = "医生code", required = true)
                                              @RequestParam(value = "doctor", required = true) String doctor,
                                              @ApiParam(name = "type", value = "发送类型", required = true)
                                              @RequestParam(value = "type", required = true) Integer type,
                                              @ApiParam(name = "relationCode", value = "业务code", required = false)
                                              @RequestParam(value = "relationCode", required = true) String relationCode,
                                              @ApiParam(name = "planId", value = "计划id", required = false)
                                              @RequestParam(value = "planId", required = true) String planId,
                                              @ApiParam(name = "reservationType", value = "复诊类型:1线上，2线下，3远程", required = false)
                                              @RequestParam(value = "reservationType", required = false) String reservationType) {

        try {
            rehabilitationMessageService.sendSpecialistWeixinMessage(patient,doctor,type,relationCode,planId,reservationType);
            return success("请求成功！");
        } catch (Exception e) {
            e.printStackTrace();
            return failed("请求失败");
        }
    }


    @RequestMapping(value = "selectType", method = RequestMethod.GET)
    @ApiOperation("康复管理-查看指导列表标题")
    public Envelop selectType(@ApiParam(name="planId",value = "根据计划id取该计划对应疾病的指导",required = false)
                             @RequestParam(value = "planId",required = false)String planId) {
        try {
            return success("请求成功！",  rehabilitationGuidanceService.selectType(planId));
        } catch (Exception e) {
            e.printStackTrace();
            return failed("请求失败");
        }
    }


    @RequestMapping(value = "sendGuidance", method = RequestMethod.POST)
    @ApiOperation("康复管理-发送康复指导")
    public Envelop selectType(@ApiParam(name = "json", value = "康复指导json", required = true)
                             @RequestParam(value = "json", required = true) String json,
                             @ApiParam(name = "planId", value = "计划ID", required = true)
                             @RequestParam(value = "planId", required = true) String planId) {

        try {
            com.alibaba.fastjson.JSONArray array = com.alibaba.fastjson.JSONArray.parseArray(json);
            List<RehabilitationguidancePatientDO> rehabilitationguidancePatientDOS = new ArrayList<>();
            for (int i=0;i<array.size();i++){
                com.alibaba.fastjson.JSONObject object = array.getJSONObject(i);
                RehabilitationguidancePatientDO rehabilitationguidancePatientDO = objectMapper.readValue(object.toJSONString(),RehabilitationguidancePatientDO.class);
                rehabilitationguidancePatientDOS.add(rehabilitationguidancePatientDO);
            }

            return success( "请求成功！",  rehabilitationGuidanceService.sendGuidanceToPatient(rehabilitationguidancePatientDOS,planId));
        } catch (Exception e) {
           e.printStackTrace();
            return failed( "请求失败");
        }
    }
    @RequestMapping(value = "selectGuidances", method = RequestMethod.GET)
    @ApiOperation("康复管理-查看指导列表")
    public Envelop selectType(@ApiParam(name = "type", value = "康复指导类型", required = false)
                             @RequestParam(value = "type", required = false) Integer type,
                             @ApiParam(name = "id", value = "康复指导模板id", required = false)
                             @RequestParam(value = "id", required = false) String id,
                             @ApiParam(name = "title", value = "康复指导名称", required = false)
                             @RequestParam(value = "title", required = false) String title,
                             @ApiParam(name = "planId", value = "计划id", required = false)
                             @RequestParam(value = "planId", required = false) String planId,
                             @ApiParam(name = "page", value = "页码", required = false)
                             @RequestParam(value = "page", required = false, defaultValue ="1") Integer page,
                             @ApiParam(name = "pagesize", value = "每页大小", required = false)
                             @RequestParam(value = "pagesize", required = false,defaultValue = "15") Integer pagesize) {

        try {
            return success( "请求成功！", rehabilitationGuidanceService.select(title,type,id,planId,page,pagesize));
        } catch (Exception e) {
           e.printStackTrace();
            return failed("请求失败");
        }
    }

    @RequestMapping(value = "selectPatientGuidances", method = RequestMethod.GET)
    @ApiOperation("康复管理-查看指导列表")
    public Envelop selectPatientGuidances(@ApiParam(name = "patient", value = "居民code", required = false)
                                         @RequestParam(value = "patient", required = false) String patient,
                                         @ApiParam(name = "code", value = "康复指导模板code", required = false)
                                         @RequestParam(value = "code", required = false) String code,
                                         @ApiParam(name = "doctor", value = "医生code", required = false)
                                         @RequestParam(value = "doctor", required = false) String doctor,
                                         @ApiParam(name = "page", value = "页码", required = false)
                                         @RequestParam(value = "page", required = false) Integer page,
                                         @ApiParam(name = "pagesize", value = "每页大小", required = false)
                                         @RequestParam(value = "pagesize", required = false) Integer pagesize) {

        try {
            return success( "请求成功！", rehabilitationGuidanceService.selectPatientGuidances(patient,doctor,code,page,pagesize));
        } catch (Exception e) {
            e.printStackTrace();
            return failed( "请求失败");
        }
    }


    @RequestMapping(value = "selectByRelationCode", method = RequestMethod.GET)
    @ApiOperation("康复管理-根据业务code查找康复指导")
    public Envelop selectByRelationCode(@ApiParam(name = "relationCode", value = "业务关联code", required = false)
                                       @RequestParam(value = "relationCode", required = false) String relationCode,
                                       @ApiParam(name = "patient", value = "居民code", required = false)
                                       @RequestParam(value = "patient", required = false) String patient,
                                       @ApiParam(name = "doctor", value = "医生code", required = false)
                                       @RequestParam(value = "doctor", required = false) String doctor) {

        try {
            return success( "请求成功！", rehabilitationGuidanceService.selectByRelationCode(patient,doctor,relationCode));
        } catch (Exception e) {
          e.printStackTrace();
            return failed( "请求失败");
        }
    }
    @RequestMapping(value = "selectPlanDetailByPlanId", method = RequestMethod.GET)
    @ApiOperation("康复管理-查看其它服务计划")
    public Envelop selectPlanDetailByPlanId(@ApiParam(name = "planId", value = "计划id", required = true)
                                            @RequestParam(value = "planId", required = true) String planId,
                                            @ApiParam(name = "planDetailId", value = "计划详情id", required = true)
                                            @RequestParam(value = "planDetailId", required = true) String planDetailId,
                                            @ApiParam(name = "itemId", value = "服务项目code", required = true)
                                            @RequestParam(value = "itemId", required = true) String itemId) {

        try {
            return success( "请求成功！",rehabilitationManageService.selectPlanDetailByPlan(planId,planDetailId,itemId));
        } catch (Exception e) {
            e.printStackTrace();
            return failed( "请求失败");
        }
    }


    @PostMapping(value = "appointmentConsultation")
    @ApiOperation("预约协诊")
    public ObjEnvelop appointmentConsultation(@ApiParam(name = "patient", value = "居民code", required = true)
                                          @RequestParam(value = "patient", required = true) String patient,
                                          @ApiParam(name = "doctor", value = "医生code-家医", required = true)
                                          @RequestParam(value = "doctor", required = true) String doctor,
                                          @ApiParam(name = "doctorName", value = "医生姓名-家医", required = true)
                                          @RequestParam(value = "doctorName", required = true) String doctorName,
                                          @ApiParam(name = "appointmentDoctor", value = "医生code-专科", required = true)
                                          @RequestParam(value = "appointmentDoctor", required = true) String appointmentDoctor,
                                          @ApiParam(name = "appointmentDoctorName", value = "医生姓名-专科", required = true)
                                          @RequestParam(value = "appointmentDoctorName", required = true) String appointmentDoctorName,
                                          @ApiParam(name = "sendTime", value = "发送时间", required = true)
                                          @RequestParam(value = "sendTime", required = true) String sendTime,
                                          @ApiParam(name = "planDetailId", value = "计划明细id", required = true)
                                          @RequestParam(value = "planDetailId", required = true) String planDetailId){
        try {

            return rehabilitationManageService.appointmentConsultation(patient,doctor,doctorName,appointmentDoctor,appointmentDoctorName,sendTime,planDetailId,getUID());
        } catch (Exception e) {
            e.printStackTrace();
            return ObjEnvelop.getError( "请求失败");
        }
    }

    @RequestMapping(value = "updateRelationCodeByDetailId", method = RequestMethod.POST)
    @ApiOperation("康复管理-服务项目关联关系")
    @ObserverRequired
    public Envelop updateRelationCodeByDetailId(@ApiParam(name = "planDetailId", value = "康复计划项目明细ID")@RequestParam(value = "planDetailId", required = true)String planDetailId,
                                               @ApiParam(name = "relationCode", value = "业务关联code", required = false)@RequestParam(value = "relationCode", required = false)String relationCode){

        try {
            Integer result = rehabilitationManageService.updateRelationCodeByDetailId(planDetailId,relationCode);
            if (result==1){
                return success( "更新日志成功！");
            }else {
                return failed( "更新日志失败");
            }
        } catch (Exception e) {
            e.printStackTrace();
            return failed( "更新日志失败");
        }
    }


}
