package com.yihu.rehabilitation.controller.patient;

/**
 * Created by 刘文彬 on 2018/8/31.
 */


import com.yihu.jw.doctor.dao.BaseDoctorDao;
import com.yihu.jw.entity.base.doctor.BaseDoctorDO;
import com.yihu.jw.entity.base.patient.BasePatientDO;
import com.yihu.jw.entity.specialist.rehabilitation.PatientMedicalRecordsDO;
import com.yihu.jw.entity.specialist.rehabilitation.RehabilitationOperateRecordsDO;
import com.yihu.jw.im.util.ImUtil;
import com.yihu.jw.patient.dao.BasePatientDao;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.MixEnvelop;
import com.yihu.jw.restmodel.web.ObjEnvelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import com.yihu.jw.rm.rehabilitation.RehabilitationRequestMapping;
import com.yihu.jw.rm.specialist.SpecialistMapping;
import com.yihu.rehabilitation.service.RehabilitationManageService;
import com.yihu.rehabilitation.service.RehabilitationPlanService;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.apache.commons.lang3.StringUtils;
import org.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Map;

/**
 * Created by 刘文彬 on 2018/8/30.
 */
@RestController
@RequestMapping(value =  RehabilitationRequestMapping.PatientRehabilitationManage.Perfix, produces = MediaType.APPLICATION_JSON_UTF8_VALUE)
@Api(description = "居民端-康复管理")
public class PatientRehabilitationManageController extends EnvelopRestEndpoint {

    @Autowired
    private RehabilitationManageService rehabilitationManageService;
    @Autowired
    private ImUtil imUtill;
    @Autowired
    private RehabilitationPlanService rehabilitationPlanService;
    @Autowired
    private BaseDoctorDao baseDoctorDao;
    @Autowired
    private BasePatientDao basePatientDao;
    @Autowired
    private JdbcTemplate jdbcTemplate;

    @RequestMapping(value = RehabilitationRequestMapping.PatientRehabilitationManage.patientRehabilitationDetail, method = RequestMethod.GET)
    @ApiOperation("康复管理-微信端-居民详情页")
    public ObjEnvelop patientRehabilitationDetail(){

        try {

            return  rehabilitationManageService.patientRehabilitationDetail(getUID());
        } catch (Exception e) {

            return ObjEnvelop.getError(e.getMessage());
        }
    }

    @RequestMapping(value = RehabilitationRequestMapping.PatientRehabilitationManage.calendarPlanDetail, method = RequestMethod.GET)
    @ApiOperation("康复管理-康复计划按日历展示")
    public ObjEnvelop calendarPlanDetail(@ApiParam(name = "executeStartTime", value = "日历开始时间（格式：yyyy-MM-dd HH:mm:ss）", required = true)
                                     @RequestParam(value = "executeStartTime", required = true)String executeStartTime,
                                     @ApiParam(name = "executeEndTime", value = "日历结束时间（格式：yyyy-MM-dd HH:mm:ss）", required = true)
                                     @RequestParam(value = "executeEndTime", required = true)String executeEndTime,
                                     @ApiParam(name = "planId", value = "计划id", required = true)
                                     @RequestParam(value = "planId", required = true)String planId,
                                     @ApiParam(name = "searchTask", value = "快速查找任务：（1、我的任务，2、健康教育，3、复诊，4、随访）", required = false)
                                     @RequestParam(value = "searchTask", required = false)Integer searchTask,
                                     @ApiParam(name = "status", value = "任务状态（0未完成，1已完成，2已预约）", required = false)
                                     @RequestParam(value = "status", required = false)Integer status){
        try {
            return rehabilitationManageService.calendarPlanDetail(executeStartTime,executeEndTime,planId,searchTask,status,null,null);
        } catch (Exception e) {
            return ObjEnvelop.getError(e.getMessage());
        }
    }

    @RequestMapping(value = RehabilitationRequestMapping.PatientRehabilitationManage.serviceDoctorList, method = RequestMethod.GET)
    @ApiOperation("康复管理-微信端居民服务医生列表")
    public ObjEnvelop serviceDoctorList(){

        try {

            return rehabilitationManageService.serviceDoctorList(getUID());
        } catch (Exception e) {
           e.printStackTrace();
            return ObjEnvelop.getError(e.getMessage());
        }
    }

    @RequestMapping(value = RehabilitationRequestMapping.PatientRehabilitationManage.calendarPlanDetailList, method = RequestMethod.GET)
    @ApiOperation("康复管理-康复计划按列表展示")
    public ObjEnvelop calendarPlanDetailList(@ApiParam(name = "executeStartTime", value = "日历开始时间（格式：yyyy-MM-dd HH:mm:ss）", required = true)
                                         @RequestParam(value = "executeStartTime", required = true)String executeStartTime,
                                         @ApiParam(name = "executeEndTime", value = "日历结束时间（格式：yyyy-MM-dd HH:mm:ss）", required = true)
                                         @RequestParam(value = "executeEndTime", required = true)String executeEndTime,
                                         @ApiParam(name = "planId", value = "计划id", required = true)
                                         @RequestParam(value = "planId", required = true)String planId,
                                         @ApiParam(name = "searchTask", value = "快速查找任务：（1、我的任务，2、健康教育，3、复诊，4、随访）", required = false)
                                         @RequestParam(value = "searchTask", required = false)Integer searchTask,
                                         @ApiParam(name = "status", value = "任务状态（0未完成，1已完成，2已预约）", required = false)
                                         @RequestParam(value = "status", required = false)Integer status){
        try {

            return rehabilitationManageService.calendarPlanDetailList( planId, searchTask, status, null, executeStartTime, executeEndTime, null);
        } catch (Exception e) {
           e.printStackTrace();
            return ObjEnvelop.getError(e.getMessage());
        }
    }

    @RequestMapping(value = RehabilitationRequestMapping.PatientRehabilitationManage.sendMessageIm, method = RequestMethod.POST)
    @ApiOperation("康复管理-扫描二维码发送消息")
    public Envelop sendMessageIm(@ApiParam(name = "sendId", value = "发送者id")@RequestParam(value = "sendId", required = true)String sendId,
                                @ApiParam(name = "receiverId", value = "接受者id", required = true)@RequestParam(value = "receiverId", required = true)String receiverId,
                                @ApiParam(name = "content", value = "内容", required = true)@RequestParam(value = "content", required = true)String content){

        try {
            imUtill.sendMessage(sendId,receiverId,"1",content);
            return success("发送成功");
        } catch (Exception e) {
            e.printStackTrace();
            return failed("发送失败");
        }
    }

    @RequestMapping(value = RehabilitationRequestMapping.PatientRehabilitationManage.checkAfterQrCode, method = RequestMethod.POST)
    @ApiOperation("康复管理-居民扫码后验证是否是关联的居民扫码")
    public ObjEnvelop checkAfterQrCode(@ApiParam(name = "planDetailId", value = "康复计划项目明细ID")@RequestParam(value = "planDetailId", required = true)String planDetailId,
                                    @ApiParam(name = "patientCode", value = "居民端登录的居民code")@RequestParam(value = "patientCode", required = true)String patientCode){

        try {

            return ObjEnvelop.getSuccess( "操作成功",rehabilitationPlanService.checkAfterQrCode(planDetailId,patientCode));
        } catch (Exception e) {
            return ObjEnvelop.getError(e.getMessage());
        }
    }

    @RequestMapping(value = RehabilitationRequestMapping.PatientRehabilitationManage.saveRehabilitationOperateRecord, method = RequestMethod.POST)
    @ApiOperation("康复管理-新增operateRecord")
    public MixEnvelop saveRehabilitationOperateRecord(@ApiParam(name = "dataJson", value = "实体json",defaultValue = "{\"rehabilitationDetailId\":\"402803f6657f195301657f4fbd3c0001\",\"patientCode\":\"00\",\"patientName\":\"11\",\"doctorCode\":\"22\",\"doctorName\":\"33\",\"node\":\"jjjjjj\",\"relationRecordType\":\"4\",\"relation_record_code\":\"55\",\"relationRecordImg\":\"666666\",\"status\":\"0\"}")@RequestParam(value = "dataJson", required = true)String dataJson){
        try {
            JSONObject json = new JSONObject(dataJson);
            if(json.has("patientCode")){
                BasePatientDO patient = basePatientDao.findById(json.get("patientCode")+"");
                json.put("patientName",patient!=null?patient.getName():"");
            }
            if(json.has("doctorCode")){
                BaseDoctorDO doctor = baseDoctorDao.findById(json.get("doctorCode")+"");
                json.put("doctorName",doctor!=null?doctor.getName():"");
            }
            RehabilitationOperateRecordsDO rehabilitationOperateRecordsDO= toEntity(json.toString(), RehabilitationOperateRecordsDO.class);
            return MixEnvelop.getSuccess(SpecialistMapping.api_success,rehabilitationPlanService.saveRehabilitationRecord(rehabilitationOperateRecordsDO));
        }catch (Exception e){
            e.printStackTrace();
            return MixEnvelop.getError(e.getMessage());
        }
    }

    @RequestMapping(value = RehabilitationRequestMapping.PatientRehabilitationManage.recentPlanDetailRecord, method = RequestMethod.GET)
    @ApiOperation("康复管理-近期康复相关记录")
    public ObjEnvelop recentPlanDetailRecord(@ApiParam(name = "patientCode", value = "居民code", required = false)
                                         @RequestParam(value = "patientCode", required = false)String patientCode,
                                         @ApiParam(name = "startTime", value = "开始时间（格式：yyyy-MM-dd HH:mm:ss）", required = false)
                                         @RequestParam(value = "startTime", required = false)String startTime,
                                         @ApiParam(name = "endTime", value = "结束时间（格式：yyyy-MM-dd HH:mm:ss）", required = false)
                                         @RequestParam(value = "endTime", required = false)String endTime,
                                         @ApiParam(name = "page", value = "第几页，从1开始", required = true)
                                         @RequestParam(value = "page", required = false,defaultValue = "1")Integer page,
                                         @ApiParam(name = "pageSize", value = "每页分页大小", required = true)
                                         @RequestParam(value = "pageSize", required = false,defaultValue = "10")Integer pageSize){

        try {
            if(!StringUtils.isNotEmpty(patientCode)){
                patientCode = getUID();
            }

            return rehabilitationManageService.recentPlanDetailRecord(patientCode,startTime,endTime,page,pageSize);
        } catch (Exception e) {
           e.printStackTrace();
            return ObjEnvelop.getError(e.getMessage());
        }
    }

    @RequestMapping(value = RehabilitationRequestMapping.PatientRehabilitationManage.serviceItemList, method = RequestMethod.GET)
    @ApiOperation("康复管理-多个康复计划服务项目内容列表")
    public ObjEnvelop serviceItemList(@ApiParam(name = "planDetailIds", value = "康复计划多个服务项目id（多个‘，’分隔）", required = true)
                                  @RequestParam(value = "planDetailIds", required = true)String planDetailIds){

        try {
            return rehabilitationManageService.serviceItemList(planDetailIds,null);
        } catch (Exception e) {
            e.printStackTrace();
            return ObjEnvelop.getError(e.getMessage());
        }
    }

    @RequestMapping(value = RehabilitationRequestMapping.PatientRehabilitationManage.serviceItem, method = RequestMethod.GET)
    @ApiOperation("康复管理-康复计划服务项目确认详情页")
    public ObjEnvelop serviceItem(@ApiParam(name = "planDetailId", value = "康复计划服务项目id", required = true)
                              @RequestParam(value = "planDetailId", required = true)String planDetailId){

        try {

            return rehabilitationManageService.serviceItem(planDetailId,null,"");
        } catch (Exception e) {
           e.printStackTrace();
            return ObjEnvelop.getError(e.getMessage());
        }
    }

    @RequestMapping(value = RehabilitationRequestMapping.PatientRehabilitationManage.planSchedule, method = RequestMethod.GET)
    @ApiOperation("康复管理-计划总进度")
    public ObjEnvelop planSchedule(@ApiParam(name = "planId", value = "计划id", required = true)
                               @RequestParam(value = "planId", required = true)String planId,
                               @ApiParam(name = "patientCode", value = "居民code", required = false)
                               @RequestParam(value = "patientCode", required = false)String patientCode){

        try {
            if(!StringUtils.isNotEmpty(patientCode)){
                patientCode = getUID();
            }

            return rehabilitationManageService.planSchedule(planId,patientCode);
        } catch (Exception e) {
           e.printStackTrace();
            return ObjEnvelop.getError(e.getMessage());
        }
    }

    @RequestMapping(value =RehabilitationRequestMapping.PatientRehabilitationManage.updatePatientImgById, method = RequestMethod.POST)
    @ApiOperation("更新康复计划居民签名照/证件照")
    public Envelop updatePatientImgById(@ApiParam(name = "planId", value = "康复计划id", required = true)
                                       @RequestParam(value = "planId")String planId,
                                       @ApiParam(name = "patientImg", value = "居民签名/证件照地址")
                                       @RequestParam(value = "patientImg")String patientImg){

        try {
            rehabilitationPlanService.updatePatientImgById(planId, patientImg);
            return success("操作成功");
        } catch (Exception e) {
            e.printStackTrace();
            return failed(e.getMessage());
        }
    }

    @GetMapping(value = RehabilitationRequestMapping.PatientRehabilitationManage.getServiceItemsAfterStop)
    @ApiOperation(value = "康复管理-中止康复计划结算项目清单")
    public ObjEnvelop getServiceItemsAfterStop(@ApiParam(name = "planId", value = "康复计划id", required = true)
                                               @RequestParam(value = "planId", required = true)String planId){
        try {
            return ObjEnvelop.getSuccess("操作成功",rehabilitationManageService.getServiceItemsAfterStop(planId));
        }catch (Exception e){
            e.printStackTrace();
            return ObjEnvelop.getError(e.getMessage());
        }
    }

    @RequestMapping(value = "selectPlanDetailByPlanId", method = RequestMethod.GET)
    @ApiOperation("康复管理-查看其它服务计划")
    public Envelop selectPlanDetailByPlanId(@ApiParam(name = "planId", value = "计划id", required = true)
                                           @RequestParam(value = "planId", required = true) String planId,
                                           @ApiParam(name = "planDetailId", value = "计划详情id", required = true)
                                           @RequestParam(value = "planDetailId", required = true) String planDetailId,
                                           @ApiParam(name = "itemId", value = "服务项目code", required = true)
                                           @RequestParam(value = "itemId", required = true) String itemId) {

        try {
            return success( "请求成功！",rehabilitationManageService.selectPlanDetailByPlan(planId,planDetailId,itemId));
        } catch (Exception e) {
            e.printStackTrace();
            return failed( "请求失败");
        }
    }

    @RequestMapping(value = "selectPlanByPatient", method = RequestMethod.GET)
    @ApiOperation("康复管理-根据居民code查找康复计划")
    public Envelop calendarPlanDetailItems(@ApiParam(name = "patient", value = "居民code", required = false)
                                           @RequestParam(value = "patient", required = false)String patient,
                                           @ApiParam(name = "status", value = "任务状态（0未完成，1已完成，2已预约）", required = false)
                                           @RequestParam(value = "status", required = false)Integer status,
                                           @ApiParam(name = "planId", value = "计划id", required = false)
                                           @RequestParam(value = "planId", required = false)String planId){
        try {
            List<Map<String,Object>> result = rehabilitationManageService.selectPlanByPatient(patient,status,planId,"");
            return success("获取成功",  result);
        } catch (Exception e) {
            e.printStackTrace();
            return failed( "请求失败");
        }
    }


    @RequestMapping(value = "calendarPlanDetailItems", method = RequestMethod.GET)
    @ApiOperation("康复管理-康复计划服务项目按列表展示")
    public Envelop calendarPlanDetailItems(@ApiParam(name = "executeStartTime", value = "日历开始时间（格式：yyyy-MM-dd HH:mm:ss）", required = false)
                                           @RequestParam(value = "executeStartTime", required = false)String executeStartTime,
                                           @ApiParam(name = "executeEndTime", value = "日历结束时间（格式：yyyy-MM-dd HH:mm:ss）", required = false)
                                           @RequestParam(value = "executeEndTime", required = false)String executeEndTime,
                                           @ApiParam(name = "planId", value = "计划id", required = true)
                                           @RequestParam(value = "planId", required = true)String planId,
                                           @ApiParam(name = "searchTask", value = "快速查找任务：（1、我的任务，2、健康教育，3、健康指导，4、随访，5、复诊）", required = false)
                                           @RequestParam(value = "searchTask", required = false)Integer searchTask,
                                           @ApiParam(name = "doctorCode", value = "医生code（专科医生、家庭医生）", required = false)
                                           @RequestParam(value = "doctorCode", required = false)String doctorCode,
                                           @ApiParam(name = "status", value = "任务状态（0未完成，1已完成，2已预约）", required = false)
                                           @RequestParam(value = "status", required = false)Integer status){
        try {

            List<Map<String,Object>> result = rehabilitationManageService.calendarPlanDetailItems(executeStartTime,executeEndTime,planId,searchTask,status,"");
            return success( "获取成功", result);
        } catch (Exception e) {
            e.printStackTrace();
            return failed( "请求失败");
        }
    }
    @RequestMapping(value = "selectByMedicalCode", method = RequestMethod.GET)
    @ApiOperation("获取医院病历")
    public Envelop selectByMedicalCode(@ApiParam(name = "medical", value = "住院code", required = true)
                                       @RequestParam(value = "medical", required = true)String medical){

        try {
            List<PatientMedicalRecordsDO> result = rehabilitationManageService.selectByMedicalCode(medical);
            try {
                String sql = "UPDATE `wlyy_patient_medical_records_rehabilitation` SET `patient_read_status`='1' WHERE (`code`='"+medical+"') ";
                jdbcTemplate.update(sql);
            }catch (Exception e){
                e.printStackTrace();
            }
            return success("操作成功", result);
        } catch (Exception e) {
            return failed( "请求失败");
        }
    }
}
