package com.yihu.rehabilitation.dao.consult;

import com.yihu.jw.entity.base.score.BaseEvaluateDO;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;

import java.util.List;


/**
 * Created by 卓 on 2017/5/10.
 */
public interface EvaluateDao extends PagingAndSortingRepository<BaseEvaluateDO, Long>, JpaSpecificationExecutor<BaseEvaluateDO> {
    /**
     * 获取某个咨询的评分
     * @param consult
     * @return
     */
    List<BaseEvaluateDO> findByConsult(String consult);

    /**
     * 根据咨询获取实名或者匿名评分
     * @param consult
     * @return
     */
    List<BaseEvaluateDO> findByConsultAndType(String consult, int type);

    /**
     * 根据医生获取实名或者匿名评分
     * @param doctor
     * @return
     */
    List<BaseEvaluateDO> findByDoctorAndType(String doctor, int type);

    /**
     * 查找所有分数为零的接口
     */
    @Query("select a from Evaluate a where a.score =0")
    List<BaseEvaluateDO> findByScoreZero();

}
