package com.yihu.rehabilitation.service;


import com.yihu.jw.entity.specialist.rehabilitation.PatientDiagnosisInformationDO;
import com.yihu.jw.mysql.query.BaseJpaService;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.ObjEnvelop;
import com.yihu.jw.restmodel.web.PageEnvelop;
import com.yihu.jw.rm.specialist.SpecialistMapping;
import com.yihu.rehabilitation.dao.PatientDiagnosisInformationDao;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.Date;

/**
 * Created by humingfen on 2019/1/11.
 */
@Service
@Transactional
public class DiagnosisInformationService extends BaseJpaService<PatientDiagnosisInformationDO, PatientDiagnosisInformationDao> {

    @Autowired
    private PatientDiagnosisInformationDao diagnosisInformationDao;

    /**
     * 保存诊疗信息
     * @param diagnosisInformationDO
     * @return
     */
    public Envelop createDiagnosisInformation(PatientDiagnosisInformationDO diagnosisInformationDO) {
        Date date = new Date();
        diagnosisInformationDO.setCreateTime(date);
        diagnosisInformationDao.save(diagnosisInformationDO);
        return Envelop.getSuccess(SpecialistMapping.api_success);
    }

    /**
     * 根据康复计划查找诊疗信息
     * @param planId
     * @return
     */
    public ObjEnvelop findDiagnosisInformationByPlanId(String planId) {
        return ObjEnvelop.getSuccess(SpecialistMapping.api_success, diagnosisInformationDao.findByPlanId(planId));
    }

    /**
     * 获取居民诊疗信息记录
     * @param patient
     * @param page
     * @param size
     * @return
     */
    public PageEnvelop findDiagnosisInformationByPatient(String patient, Integer page, Integer size) {
        PageRequest pageRequest = PageRequest.of(page, size);
        Page<PatientDiagnosisInformationDO> list = diagnosisInformationDao.findByPatient(patient,pageRequest);
        return PageEnvelop.getSuccessListWithPage(SpecialistMapping.api_success, list.getContent(), page, size,list.getTotalElements());
    }
}
