package com.yihu.rehabilitation.service;/**
 * Created by nature of king on 2018/8/28.
 */

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.yihu.jw.doctor.dao.BaseDoctorDao;
import com.yihu.jw.entity.base.doctor.BaseDoctorDO;
import com.yihu.jw.entity.base.org.BaseOrgDO;
import com.yihu.jw.entity.base.patient.BasePatientDO;
import com.yihu.jw.entity.hospital.message.SystemMessageDO;
import com.yihu.jw.hospital.message.dao.SystemMessageDao;
import com.yihu.jw.im.dao.ConsultTeamDoctorDao;
import com.yihu.jw.im.util.ImUtil;
import com.yihu.jw.org.dao.BaseOrgDao;
import com.yihu.jw.patient.dao.BasePatientDao;
import com.yihu.jw.util.common.IdCardUtil;
import com.yihu.jw.util.http.HttpClientUtil;
import com.yihu.rehabilitation.dao.consult.EvaluateDao;
import com.yihu.rehabilitation.dao.consult.EvaluateScoreDao;
import com.yihu.rehabilitation.service.consult.ConsultTeamService;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import java.util.UUID;

/**
 * @author wangzhinan
 * @create 2018-08-28 9:09
 * @desc 服务项目评论
 **/
@Service
@Transactional
public class SpecialistEvaluateSevice {
    private static org.slf4j.Logger logger = LoggerFactory.getLogger(SpecialistEvaluateSevice.class);
    @Autowired
    private SystemMessageDao messageDao;

    @Value("${specialist.url}")
    private String specialistUrl;
    @Autowired
    private HttpClientUtil httpClientUtil;
    @Autowired
    private BasePatientDao patientDao;
    @Autowired
    private BaseOrgDao hospitalDao;
    @Autowired
    private BaseDoctorDao doctorDao;
    @Autowired
    EvaluateDao evaluateDao;
    @Autowired
    ConsultTeamService consultTeamService;
    @Autowired
    JdbcTemplate jdbcTemplate;
    @Autowired
    ConsultTeamDoctorDao consultTeamDoctorDao;
    @Autowired
    EvaluateScoreDao evaluateScoreDao;
    @Autowired
    private ImUtil ImUtill;

    /**
     * 添加评论
     *
     * @param object
     * @return
     */
    public JSONObject insert(JSONObject object){
        String response = null;
        String url =specialistUrl + "svr-specialist/createEvaluate";
        Map<String,String> params = new HashMap<>();
        params.put("evaluate",object.toJSONString());
        try {
            response = httpClientUtil.httpPost(url,params);
        }catch (Exception e){
            e.printStackTrace();
            logger.error(e.getMessage());
        }
        return JSONObject.parseObject(response);
    }


    /**
     * 更新评论
     *
     * @param object
     * @return
     */
    public JSONObject update(JSONObject object){
        String response = null;
        String url =specialistUrl + "svr-specialist/updateEvaluate";
        Map<String,String> params = new HashMap<>();
        params.put("evaluate",object.toJSONString());
        try {
            response = httpClientUtil.httpPost(url,params);
        }catch (Exception e){
            e.printStackTrace();
            logger.error(e.getMessage());
        }
        return JSONObject.parseObject(response);
    }


    /**
     * 获取评论
     *
     * @param object
     * @return
     */
    public JSONObject select(JSONObject object){
        String response = null;
        String url =specialistUrl + "svr-specialist/getEvaluate";
        Map<String,String> params = new HashMap<>();
        params.put("evaluate",object.toJSONString());
        try {
            response = httpClientUtil.httpPost(url,params);
        }catch (Exception e){
            e.printStackTrace();
            logger.error(e.getMessage());
        }
        return JSONObject.parseObject(response);
    }


    /**
     * 医生获取评分
     *
     * @param doctor
     * @return
     */
    public JSONObject selectByDoctor(String doctor){
        String response = null;
        String url =/*"http://localhost:10051/"*/specialistUrl + "svr-specialist/selectByDoctor";
        Map<String,String> params = new HashMap<>();
        params.put("doctor",doctor);
        try {
            response = httpClientUtil.httpPost(url,params);
            JSONObject object = JSONObject.parseObject(response);
            if (object.getInteger("status")==200){
                JSONObject jsonObject4 = object.getJSONObject("obj");
                JSONObject jsonObject = jsonObject4.getJSONObject("4");
                JSONObject jsonObject1 = jsonObject4.getJSONObject("5");
                JSONObject jsonObject2 = jsonObject4.getJSONObject("6");
                JSONObject jsonObject3 = jsonObject4.getJSONObject("7");
                JSONArray array = jsonObject.getJSONArray("evaluate");
                JSONArray array1 = jsonObject1.getJSONArray("evaluate");
                JSONArray array2 = jsonObject2.getJSONArray("evaluate");
                JSONArray array3 = jsonObject3.getJSONArray("evaluate");
                //全部
                for (int i=0;i<array.size();i++){
                    JSONObject object1 = array.getJSONObject(i);
                    String patient = object1.getJSONArray("patient").getString(0);
                    BasePatientDO patient1 = patientDao.findById(patient).orElse(null);
                    Integer age = IdCardUtil.getAgeForIdcard(patient1.getIdcard());
                    object1.put("patient1",patient1);
                    object1.put("age",age);
                }
                //好评
                for (int i=0;i<array1.size();i++){
                    JSONObject object1 = array1.getJSONObject(i);
                    String patient = object1.getJSONArray("patient").getString(0);
                    BasePatientDO patient1 = patientDao.findById(patient).orElse(null);
                    Integer age = IdCardUtil.getAgeForIdcard(patient1.getIdcard());
                    object1.put("patient1",patient1);
                    object1.put("age",age);
                }
                //中评
                for (int i=0;i<array2.size();i++){
                    JSONObject object1 = array2.getJSONObject(i);
                    String patient = object1.getJSONArray("patient").getString(0);
                    BasePatientDO patient1 = patientDao.findById(patient).orElse(null);
                    Integer age = IdCardUtil.getAgeForIdcard(patient1.getIdcard());
                    object1.put("patient1",patient1);
                    object1.put("age",age);
                }
                //差评
                for (int i=0;i<array3.size();i++){
                    JSONObject object1 = array3.getJSONObject(i);
                    String patient = object1.getJSONArray("patient").getString(0);
                    BasePatientDO patient1 = patientDao.findById(patient).orElse(null);
                    Integer age = IdCardUtil.getAgeForIdcard(patient1.getIdcard());
                    object1.put("patient1",patient1);
                    object1.put("age",age);
                }
            }
            return object;
        }catch (Exception e){
            e.printStackTrace();
            logger.error(e.getMessage());
            return null;
        }

    }

    /**
     * 发送消息 type:19 受理提醒，20 待办工作提醒 21 服务进展提醒-已完成 22 服务进展提醒-未完成 23 服务进展提醒-待完成 24 收到协同任务 25 在线助手已接收 26 在线助手已退回 27 协同服务已完成
     */

    public JSONObject sendMessage(SystemMessageDO message, String hospitalCode, String patientCode, Integer num, JSONObject jsonObject){
        JSONObject object = new JSONObject();
        try {
            BaseOrgDO hospital = null;
            if(StringUtils.isNotEmpty(hospitalCode)){
                hospital = hospitalDao.findByCode(hospitalCode);
            }
            BasePatientDO patient = null;
            if (StringUtils.isNoneBlank(patientCode)){
                patient  = patientDao.findById(patientCode).orElse(null);
            }
//            Doctor sendDoctor = doctorDao.findByCode(message.getSender());
            BaseDoctorDO receiverDoctor = doctorDao.findById(message.getReceiver()).orElse(null);
            if (  "19".equalsIgnoreCase(message.getType()) ){
                message.setOver("0");//未处理
                message.setType("19");
                message.setTitle("康复计划-受理提醒");
                message.setContent("您的居民"+patient.getName()+"已出院，"+/*(hospital!=null?hospital.getName():"")*/message.getReason()+"为他制定了新康复计划，请查看");
            }else if ("20".equalsIgnoreCase(message.getType()) ){
                message.setOver("1");//未处理
                message.setType("20");
                message.setTitle("康复计划-待办工作提醒");
                if(num==0){
                    message.setContent("您的居民"+patient.getName()+"今天计划到"+(hospital!=null?hospital.getName():"")+"复诊，请查看");
                }else{
                    message.setContent("您的居民"+patient.getName()+num+"天后计划到"+(hospital!=null?hospital.getName():"")+"复诊，请查看");
                }
            }else if ("21".equalsIgnoreCase(message.getType()) ){
                message.setOver("0");//未处理
                message.setType("21");
                message.setTitle("康复计划-服务进展提醒");
                message.setContent("您的居民"+patient.getName()+"已完成康复计划今日项目，请查看");
            }else if ("22".equalsIgnoreCase(message.getType())){
                message.setOver("1");//未处理
                message.setType("22");
                message.setTitle("康复计划-服务进展提醒");
                message.setContent("服务时间提醒！您的居民"+patient.getName()+"该进行"+message.getData()+"了。");
            }else if ("23".equalsIgnoreCase(message.getType())){
                message.setOver("1");//未处理
                message.setType("23");
                message.setTitle("康复计划-服务定时提醒");
                message.setContent("您的居民"+patient.getName()+"明天有"+num+"个康复项目需完成，您可以修改定时提醒!");
            }else if ("24".equalsIgnoreCase(message.getType())){
                message.setOver("1");
                message.setType("24");
                message.setTitle("收到协同任务");
                message.setContent("您接收到“"+jsonObject.getString("type")+"”协同服务:"+jsonObject.getString("content").substring(0,19));
            }else if ("25".equalsIgnoreCase(message.getType())){
                message.setOver("1");
                message.setType("25");
                message.setTitle("在线助手已接收");
                message.setContent("您发起的“"+jsonObject.getString("type")+"”协同服务，已被在线助手接收，负责人："+jsonObject.getString("customerName")+"，联系方式："+jsonObject.getString("phone")+"。");
            }else if ("26".equalsIgnoreCase(message.getType())){
                message.setOver("1");
                message.setType("26");
                message.setTitle("在线助手已退回");
                message.setContent("您发起的“"+jsonObject.getString("type")+"”协同服务，已被在线助手退回。原因："+jsonObject.getString("returnedRemark"));
            }else if ("27".equalsIgnoreCase(message.getType())){
                message.setOver("1");
                message.setType("27");
                message.setTitle("协同服务已完成");
                message.setContent("您发起的“"+jsonObject.getString("type")+"”协同服务，已完成。");
            }
            message.setCode(UUID.randomUUID().toString().replaceAll("-", ""));
//            message.setSenderName(sendDoctor.getName());
//            message.setSenderPhoto(sendDoctor.getPhoto());
//            message.setSex(sendDoctor.getSex());
            message.setReadonly(1);//是否只读消息

            message.setDel("1");
            message.setState(1);
            message.setIsRead("1");
            message.setReceiverName(receiverDoctor.getName());
            message.setData(patientCode);
            message.setCreateTime(new Date());
            messageDao.save(message);
        }catch (Exception e){
            e.printStackTrace();
            logger.error(e.getMessage());
        }
        return object;
    }

    /*public void saveByJson(String jsonData, String patient) {
        org.json.JSONObject jsonObject = new org.json.JSONObject(jsonData);
        String consult = jsonObject.getString("consult");
        ConsultTeamDo consultTeam = consultTeamService.findByCode(consult);
        //评价的分数
        org.json.JSONArray evaluateArray = jsonObject.getJSONArray("evaluate");
        //标签
        org.json.JSONArray labelArray = jsonObject.getJSONArray("label");

        org.json.JSONArray doctorArray = jsonObject.getJSONArray("evaluateScore");

        List<BaseEvaluateDO> evaluateList = null;
        List<SpecialistEvaluateLabelDO> evaluateLabelList = new ArrayList<>();
        Map<String, List<BaseEvaluateDO>> docEvaMap = new HashMap<>();
        //反射生成评价对象
        for (Object evaluateObj : evaluateArray) {
            BaseEvaluateDO evaluate = new BaseEvaluateDO();
            org.json.JSONObject obj = (org.json.JSONObject) evaluateObj;
            ClazzReflect clazzReflect = new ClazzReflect();
            evaluate = (BaseEvaluateDO) clazzReflect.formatToClazz(evaluate, obj);
            evaluate.setConsult(consult);
            evaluate.setPatient(patient);
            //把分数放入map中 给参与此次咨询的医生都评分
            if (docEvaMap.get(evaluate.getDoctor()) == null) {
                evaluateList = new ArrayList<>();
                evaluateList.add(evaluate);
                docEvaMap.put(evaluate.getDoctor(), evaluateList);
            } else {
                docEvaMap.get(evaluate.getDoctor()).add(evaluate);
            }
        }
        //反射得到标签内容
        for (Object labelObj : labelArray) {
            EvaluateLabel evaluateLabel = new EvaluateLabel();
            org.json.JSONObject obj = (org.json.JSONObject) labelObj;
            ClazzReflect clazzReflect = new ClazzReflect();
            evaluateLabel = (EvaluateLabel) clazzReflect.formatToClazz(evaluateLabel, obj);
            evaluateLabel.setConsult(consult);
            evaluateLabel.setPatient(patient);
            evaluateLabelList.add(evaluateLabel);
        }
        Map<String, org.json.JSONObject> doctorMap = new HashMap<>();
        //生成医生信息
        for(Object doctor : doctorArray){
            org.json.JSONObject d = (org.json.JSONObject) doctor;
            doctorMap.put((String)d.get("doctor"),d);
        }

        //计算单条得分
        evaluateScoreC(docEvaMap, consult,doctorMap);
        this.save(docEvaMap);
        evaluateLabelService.save(evaluateLabelList);
        consultTeam.setEvaluate(1);
        consultTeam.setEvaluateTime(new Date());
        org.json.JSONObject topicObject = new org.json.JSONObject();
        topicObject.put("evaluate", 1);
        topicObject.put("evaluate_time", new Date());
        ImUtill.updateTopics(consult, topicObject.toString());
        this.consultTeamService.save(consultTeam);
    }*/
}
