package com.yihu.rehabilitation.service.message;

import com.yihu.jw.doctor.dao.BaseDoctorDao;
import com.yihu.jw.entity.base.doctor.BaseDoctorDO;
import com.yihu.jw.entity.base.patient.BasePatientDO;
import com.yihu.jw.entity.hospital.message.SystemMessageDO;
import com.yihu.jw.entity.rehabilitation.RehabilitationguidanceDO;
import com.yihu.jw.entity.specialist.rehabilitation.RehabilitationDetailDO;
import com.yihu.jw.entity.util.TransforSqlUtl;
import com.yihu.jw.hospital.message.dao.SystemMessageDao;
import com.yihu.jw.im.util.ImUtil;
import com.yihu.jw.patient.dao.BasePatientDao;
import com.yihu.jw.restmodel.web.ObjEnvelop;
import com.yihu.jw.util.date.DateUtil;
import com.yihu.rehabilitation.dao.RehabilitationGuidanceDao;
import com.yihu.rehabilitation.service.RehabilitationInfoService;
import org.apache.commons.lang3.StringUtils;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.jdbc.core.BeanPropertyRowMapper;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Component;

import javax.transaction.Transactional;
import java.util.Arrays;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * 消息业务处理类
 *
 * @author George
 */
@Component
@Transactional(rollbackOn = Exception.class)
public class RehabilitationMessageService {

    private static org.slf4j.Logger logger = LoggerFactory.getLogger(RehabilitationMessageService.class);

    @Autowired
    private SystemMessageDao messageDao;
    @Autowired
    private JdbcTemplate jdbcTemplate;
    @Autowired
    private BasePatientDao patientDao;
    @Autowired
    private RehabilitationGuidanceDao rehabilitationGuidanceDao;

    @Autowired
    private StringRedisTemplate redisTemplate;
    @Autowired
    private RehabilitationInfoService rehabilitationInfoService;

    @Autowired
    private RehabilitationMessageService messageService;
    /*@Value("${doctorAssistant.api}")
    private String doctorAssistant;
    @Value("${doctorAssistant.target_url}")
    private String targetUrl;*/
    /*@Value("${hlwyy.url}")
    private String hlwyyUrl;*/

   /* @Value("${im.im_list_get}")
    private String im_list_get;

    @Value("${specialist.url}")
    private String specialistUrl;*/
    @Autowired
    private BaseDoctorDao doctorDao;
    @Autowired
    private ImUtil imUtill;
    /**
     * 设置待办消息已处理
     *
     * @param id
     * @param type
     */
    public int setSpecialistOver(String id,Integer type){
        if (type == 22 || type==23){
            int result = 0;
            SystemMessageDO message = messageDao.findById(id).orElse(null);
            List<RehabilitationDetailDO>  list =selectByIds(message.getRelationCode());
            Integer count = 0;
            if (list!=null){
                for (int i =0;i<list.size();i++){
                    if (list.get(i).getStatus() == 1){
                        count = count+1;
                    }
                }
                if (count == list.size()){
                    result = messageDao.setSpecialistById(id);
                }else {
                    result = messageDao.setSpecialistReadById(id);
                }
            }


            return result;
        } else if (type == 16) {
            //16.专科医生申请签约消息，点击处理时只改变只读状态，处理状态在调消息审批时处理
            return messageDao.setSpecialistReadById(id);
        } else if (type == 35) {
            //35  疾病筛查通知
            return messageDao.setSpecialistById(id);
        }else if (type == 36) {
            //36  康复下转居民推送提醒
            return messageDao.setSpecialistById(id);
        }else {
            return messageDao.setSpecialistById(id);
        }
    }

    public List<RehabilitationDetailDO> selectByIds(String ids){
        ObjEnvelop envelop = new ObjEnvelop();
        List idList = Arrays.asList(ids.split(","));
        StringBuffer buffer = new StringBuffer();
        for (int i =0;i<idList.size();i++){
            buffer.append("'"+idList.get(i)+"'").append(",");
        }
        buffer.deleteCharAt(buffer.length()-1);
        String sql = "select * from wlyy_rehabilitation_plan_detail where id in("+buffer+")";
        sql = TransforSqlUtl.wlyy_rehabilitation_plan_detailAll(sql);
        List<RehabilitationDetailDO> rehabilitationDetailDOS = jdbcTemplate.query(sql,new BeanPropertyRowMapper(RehabilitationDetailDO.class));
        return rehabilitationDetailDOS;
    }



    /**
      * 康复计划-微信模板发送
     * @param patientCode 居民code
     * @param doctorCode 专科医生code
     * @param type 1康复指导2康复下转3复诊提醒4上门服务提醒5家签提醒
     * @param relationCode 业务关联code
     * @param planId 计划id
     * @throws Exception
     */
    public void sendSpecialistWeixinMessage(String patientCode,String doctorCode,Integer type,String relationCode,String planId,String reservationType) throws Exception {
        //康复指导
        BasePatientDO patient = patientDao.findById(patientCode).orElse(null);
        BaseDoctorDO doctor = doctorDao.findById(doctorCode).orElse(null);
        String name = "";
        String doctorName="";
        String familyDoctorName = "";
        String first="";
        String content="";
        String remarl="";
        String url="";
        org.json.JSONObject json = new org.json.JSONObject();
        if (patient!=null){
            name=patient.getName();
        }
        if (doctor!=null){
            doctorName = doctor.getName();
        }
        Integer sendType = null;
        if (type==1){
            RehabilitationguidanceDO rehabilitationguidanceDO = rehabilitationGuidanceDao.findByCode(relationCode);
            first=patient.getName() + "，您好！您的家庭医生发来一篇健康文章！";
            content= "《" + rehabilitationguidanceDO.getTitle() + "》";
            remarl="请及时阅读";
            url="kfgl/html/plan-item-detail.html?planIds="+planId+"";
            json.put("toUser", patientCode);
            json.put("first", patient.getName() + "，您好！您的家庭医生发来一篇健康文章！");
            json.put("represented",patientCode);//被代理人
            json.put("id", planId);
            json.put("date", DateUtil.getStringDate());
            json.put("doctorName", doctor.getName());
            json.put("content", "《" + rehabilitationguidanceDO.getTitle() + "》");
            json.put("remark", "请及时阅读");
            json.put("url",  "kfgl/html/plan-item-detail.html?planIds="+planId+"");
            sendType = 36;
        }else if (type==2){
            //反馈处理30
            sendType=30;
            String sql = "SELECT pr.manage_time as manageTime,pr.is_manage as isManage " +
                    "FROM wlyy_specialist.`wlyy_specialist_patient_relation` pr " +
                    "where pr.doctor = '"+doctorCode+"' and pr.patient = '"+patientCode+"' and pr.sign_status=1 and pr.`status`=1";
            List<Map<String,Object>> mapList = jdbcTemplate.queryForList(sql);
            String manageTime = "";
            for (Map<String,Object> map:mapList){
                manageTime = DateUtil.dateToStrLong((Date)map.get("manageTime"));
            }
            json.put("first", patient.getName() + "，您好！您已成功签约专科医生“"+doctorName+"”，"+doctorName+"医生（专科医生）和"+familyDoctorName+"（全科医生）将为您提供康复管理服务");
            json.put("toUser", patientCode);
            json.put("represented",patientCode);//被代理人
            json.put("keyword1", manageTime);
            json.put("keyword2", "康复下转");
            json.put("remark", "请及时阅读");
            json.put("relationCode",1);
            json.put("url",  "kfgl/html/recover_manage.html");
            first=patient.getName() + "，您好！您已成功签约专科医生“"+doctorName+"”，"+doctorName+"医生（专科医生）和"+familyDoctorName+"（全科医生）将为您提供康复管理服务";
            remarl="请及时阅读";
            url="kfgl/html/recover_manage.html";
            json.put("toUser", patientCode);
        }else if (type==3){
            //复诊提醒3
            //更新复诊类型
            if(StringUtils.isNoneBlank(reservationType)){
                String updSql = "update wlyy_rehabilitation_plan_detail set reservation_type = "+reservationType +" where id = '"+relationCode+"'";
                jdbcTemplate.execute(updSql);
            }
            sendType=11;//待办事项
            String sql = "select pd.id,pd.execute_time as executeTime from wlyy_rehabilitation_plan_detail pd " +
                    "where pd.id ='"+relationCode+"' and pd.hospital_service_item_id='7' and pd.status <>1 order by pd.execute_time desc ";
            List<Map<String,Object>> mapList = jdbcTemplate.queryForList(sql);
            String excuteTime="";
            if (mapList!=null&&mapList.size()!=0){
                excuteTime = DateUtil.dateToStrLong((Date)mapList.get(0).get("executeTime"));
            }
            if (StringUtils.isNoneBlank(excuteTime)){
                json.put("first", patient.getName() + "，您好！您的下次复诊时间是["+excuteTime+"]，请按时安排就诊。您可点击“查看详情”，提前预约就诊");
                first=patient.getName() + "，您好！您的下次复诊时间是["+excuteTime+"]，请按时安排就诊。您可点击“查看详情”，提前预约就诊";
            }else {
                json.put("first", patient.getName()+"，您好！"+doctor.getName()+"医生提醒您预约复诊。您可点击“查看详情”，提前预约就诊");
                first=patient.getName()+"，您好！"+doctor.getName()+"医生提醒您预约复诊。您可点击“查看详情”，提前预约就诊";
            }
            json.put("toUser", patientCode);
            json.put("represented",patientCode);//被代理人
            json.put("keyword1", "复诊预约");
            json.put("keyword2", ""+DateUtil.getStringDate()+"");
            json.put("remark", "请及时阅读");
            json.put("url",  "wdyy/html/appointment-register.html");
            remarl="请及时阅读";
            url="wdyy/html/appointment-register.html";
        }else if (type==4){
            //上门服务提醒 4
            sendType=11;//待办事项
            String sql = "select pd.id,pd.execute_time as executeTime from wlyy_rehabilitation_plan_detail pd " +
                    "where pd.id ='"+relationCode+"' and pd.hospital_service_item_id='4' and pd.status <>1 order by pd.execute_time desc ";
            List<Map<String,Object>> mapList = jdbcTemplate.queryForList(sql);
            String excuteTime="";
            String detailId = "";
            if (mapList!=null&&mapList.size()!=0){
                excuteTime = DateUtil.dateToStrLong((Date)mapList.get(0).get("executeTime"));

            }
            if(StringUtils.isNoneBlank(excuteTime)){
                json.put("first", patient.getName() + "，您好！您的下次上门诊疗服务时间是["+excuteTime+"]，请按时预约上门诊疗服务。您可点击“查看详情”，提前预约就诊");
                first=patient.getName() + "，您好！您的下次上门诊疗服务时间是["+excuteTime+"]，请按时预约上门诊疗服务。您可点击“查看详情”，提前预约就诊";
            }else {
                json.put("first", patient.getName()+"，您好！"+doctor.getName()+"医生提醒您预约上门服务。您可点击“查看详情”，提前预约就诊");
                first=patient.getName()+"，您好！"+doctor.getName()+"医生提醒您预约上门服务。您可点击“查看详情”，提前预约就诊";
            }

            json.put("toUser", patientCode);
            json.put("represented",patientCode);//被代理人
            json.put("keyword1", "上门诊疗服务预约");
            json.put("keyword2",DateUtil.getStringDate());
            json.put("remark", "请及时阅读");
            json.put("url",  "smfw/html/toAppointment.html?relationCode="+relationCode+"");
            remarl="请及时阅读";
            url="smfw/html/toAppointment.html?relationCode="+relationCode+"";
        }else if (type==5){
            //家签提醒 5
            sendType=11;//待办事项
            String sql = "select pd.id,pd.execute_time as executeTime from wlyy_rehabilitation_plan_detail pd " +
                    "where pd.plan_id ='"+planId+"' and pd.hospital_service_item_id='4' and pd.status <>1 order by pd.execute_time desc ";
            List<Map<String,Object>> mapList = jdbcTemplate.queryForList(sql);
            String excuteTime="";
            if (mapList!=null&&mapList.size()!=0){
                excuteTime = DateUtil.dateToStrLong((Date)mapList.get(0).get("executeTime"));
            }
            json.put("first", patient.getName() + "，您好！为方便为您提供康复管理服务，请先选择合适的社区和家庭医生进行签约");
            json.put("toUser", patientCode);
            json.put("represented",patientCode);//被代理人
            json.put("keyword1", "家庭医生签约");
            json.put("keyword2",  DateUtil.getStringDate());
            json.put("remark", "请及时阅读");
            json.put("url",  "qygl/html/signing-welcome.html");
            first= patient.getName() + "，您好！为方便为您提供康复管理服务，请先选择合适的社区和家庭医生进行签约";
            remarl="请及时阅读";
            url= "qygl/html/signing-welcome.html";
        }
        logger.info("微信模板入参:"+sendType+"=="+json.toString());
        rehabilitationInfoService.sendWechatMessage(patient.getId(),first,content,remarl,url);

    }

}
