package com.yihu.rehabilitation.vo.entity;

import com.alibaba.fastjson.annotation.JSONField;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.searchbox.annotations.JestId;

import java.util.Date;

/**
 * 生日祝福为推送表
 * Created by humingfen on 2019/03/11.
 */
public class BirthDayWishesNotPushES {
    @JestId
    private String id;

    private String patientCode; // 患者标识（ES）
    private String patientName; // 患者名称（ES）
    private String openid;       //患者openid
    private String idcard;       //患者身份证
    private String doctorCode;  //全科code(doctor表中的code)（ES：必填）
    private String doctorName;  //全科名称(doctor表中的name)（ES：必填）
    private String doctorHealth;  //健管师code(doctor表中的code)（ES：必填）
    private String doctorHealthName;  //健管师code(doctor表中的code)（ES：必填）

    private Long adminTeamCode;// 行政团队（ES）
    private String adminTeamName;// 行政团队（ES）
    private String hospital; // 所属机构（ES）
    private String hospitalName; // 所属机构（ES）
    private String town; // 所属区划（ES）
    private String townName; // 所属区划（ES）
    private String city;// 所属市区
    private String cityName;//市名称
    private String province;//所属省
    private String provinceName;//省名称

    //生日祝福
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "MM-dd")
    @JSONField(format = "MM-dd")
    private String birthday;  // 居民生日（ES:必填）

    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd'T'HH:mm:ssXX")
    @JSONField(format = "yyyy-MM-dd'T'HH:mm:ssXX")
    private Date createTime;  // 创建时间（ES:必填）

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getPatientCode() {
        return patientCode;
    }

    public void setPatientCode(String patientCode) {
        this.patientCode = patientCode;
    }

    public String getPatientName() {
        return patientName;
    }

    public void setPatientName(String patientName) {
        this.patientName = patientName;
    }

    public String getDoctorCode() {
        return doctorCode;
    }

    public void setDoctorCode(String doctorCode) {
        this.doctorCode = doctorCode;
    }

    public String getDoctorName() {
        return doctorName;
    }

    public void setDoctorName(String doctorName) {
        this.doctorName = doctorName;
    }

    public String getDoctorHealth() {
        return doctorHealth;
    }

    public void setDoctorHealth(String doctorHealth) {
        this.doctorHealth = doctorHealth;
    }

    public String getDoctorHealthName() {
        return doctorHealthName;
    }

    public void setDoctorHealthName(String doctorHealthName) {
        this.doctorHealthName = doctorHealthName;
    }

    public Long getAdminTeamCode() {
        return adminTeamCode;
    }

    public void setAdminTeamCode(Long adminTeamCode) {
        this.adminTeamCode = adminTeamCode;
    }

    public String getAdminTeamName() {
        return adminTeamName;
    }

    public void setAdminTeamName(String adminTeamName) {
        this.adminTeamName = adminTeamName;
    }

    public String getHospital() {
        return hospital;
    }

    public void setHospital(String hospital) {
        this.hospital = hospital;
    }

    public String getHospitalName() {
        return hospitalName;
    }

    public void setHospitalName(String hospitalName) {
        this.hospitalName = hospitalName;
    }

    public String getTown() {
        return town;
    }

    public void setTown(String town) {
        this.town = town;
    }

    public String getTownName() {
        return townName;
    }

    public void setTownName(String townName) {
        this.townName = townName;
    }

    public String getBirthday() {
        return birthday;
    }

    public void setBirthday(String birthday) {
        this.birthday = birthday;
    }

    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    public String getOpenid() {
        return openid;
    }

    public void setOpenid(String openid) {
        this.openid = openid;
    }

    public String getIdcard() {
        return idcard;
    }

    public void setIdcard(String idcard) {
        this.idcard = idcard;
    }

    public String getCity() {
        return city;
    }

    public void setCity(String city) {
        this.city = city;
    }

    public String getProvince() {
        return province;
    }

    public void setProvince(String province) {
        this.province = province;
    }

    public String getCityName() {
        return cityName;
    }

    public void setCityName(String cityName) {
        this.cityName = cityName;
    }

    public String getProvinceName() {
        return provinceName;
    }

    public void setProvinceName(String provinceName) {
        this.provinceName = provinceName;
    }
}
