package com.yihu.rehabilitation.vo.entity;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.searchbox.annotations.JestId;
import org.springframework.data.annotation.CreatedDate;

import java.util.Date;

/**
 * 严重精神障碍患者随访服务记录表
 * create by hmf on 2019/4/17
 */
public class FollowupSevereMentalDisorderES {
    @JestId
    private String id;
    private String followup_id;             //随访记录ID
    private String followup_project;        //随访详情分类ID
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyyMMdd'T'HHmmss.SSS'Z'")
    @CreatedDate
    private Date create_time;
    private String create_user;
    private String create_user_name;
    private String version;//版本号

    private String name;//患者姓名
    private String number;//编号
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+08:00")
    private Date followup_date;//随访日期
    private Integer followup_type;//随访形式（1门诊 2家庭访视 3电话 4视频）
    private String followup_object;//随访对象（1患者本人 2患者家属、监护人 3其他知情人，多选用逗号隔开）
    private String followup_null_reason;//失访原因（1外出务工 2迁居他处 3走失 4连续三次未访到 5其他）

    /********** 如果死亡，日期和原因 **********/
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+08:00")
    private Date death_date;//死亡日期
    private Integer death_reason_type;//死亡原因（1躯体疾病 2自杀 3他杀 4意外 5精神疾病相关并发症 6其他）
    private String physical_disease_type;//躯体疾病类型（1传染病和寄生虫病 2 肿瘤 3心脏病 4脑血管病 5呼吸系统疾病 6消化系统疾病 7其他疾病 8不详）

    private Integer dangerous_level;//危险性评估（0、0级 1、1级 2、2级 3、3级 4、4级 5、5级）

    /********** 目前症状 **********/
    private Integer illusion;//幻觉(1有，0无)
    private Integer communication_difficulty;//交流困难(1有，0无)
    private Integer suspicious;//猜疑(1有，0无)
    private Integer moods;//喜怒无常(1有，0无)
    private Integer weird;//行为怪异(1有，0无)
    private Integer talkative;//兴奋话多(1有，0无)
    private Integer smashing_objects;//伤人毁物(1有，0无)
    private Integer profoundly_pessimistic;//悲观厌世(1有，0无)
    private Integer outside_without_cause;//无故外走(1有，0无)
    private Integer to_myself_from_laughing;//自语自笑(1有，0无)
    private Integer withdrawn_lazy;//孤僻懒散(1有，0无)
    private Integer other_symptom;//其他症状(1有，0无)
    private String other_symptom_description;//其他症状说明

    private Integer intelligence;//自知力（1自知力完全 2不全 3缺失)
    private Integer sleep_condition;//睡眠情况（1良好 2一般 3较差）
    private Integer dietary_status;//饮食情况（1良好 2一般 3较差）

    /********** 社会功能情况 **********/
    private Integer selfcare_ability;//个人生活料理(1良好 2一般 3较差)
    private Integer housework;//家务劳动(1良好 2一般 3较差)
    private Integer work;//生产活动 及工作(1良好 2一般 3较差 9此项不可用)
    private Integer learning_ability;//学习能力(1良好 2一般 3较差)
    private Integer sociability;//社会人际交往(1良好 2一般 3较差)

    /********** 危险行为 **********/
    private Integer dangerous_behavior_1;//轻度滋事次数，次
    private Integer dangerous_behavior_2;//肇事次数，次
    private Integer dangerous_behavior_3;//肇祸次数，次
    private Integer dangerous_behavior_4;//其他危害行为次数，次
    private Integer dangerous_behavior_5;//自伤次数，次
    private Integer dangerous_behavior_6;//自杀未遂次数，次
    private Integer dangerous_behavior_7;//无危险行为（1是 0否）

    private Integer captivity_case;//两次随访期间关锁情况（1无关锁 2关锁 3关锁已清除）
    private Integer in_hospital_case;//两次随访期间住院情况（0未住院 1目前正在住院 2曾住院，现未住院）
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+08:00")
    private Date last_discharged_date;//末次出院日期
    private Integer laboratory_examination;//实验室检查(1无 2有)
    private String laboratory_examination_description;//实验室有检查描述
    private Integer compliance;//用药依从性（1按医嘱规律服药 2间断服药 3不服药 4医嘱无须服药）

    private Integer adverse_drug_reaction;//药物不良反应（1无 2有 9此项不适用）
    private String adverse_drug_reaction_description;//有药物不良反应说明

    private Integer treatment_effects;//治疗效果（1痊愈 2好转 3无变化 4加重 9此项不适用）

    /******** 转诊情况 ********/
    private Integer referral;//转诊建议（1否 2是）
    private String referral_reason;//转诊建议（原因）
    private Integer is_referral;//是否已转诊（1否 2是）
    private String organization_org;//转诊机构(智业机构code)
    private String organization_org_name;//转诊机构名称
    private String organization_hospital;//转诊机构code(dm_hospital表的code)
    private String organization;//转诊科室

    /******** 用药情况 ********/
    private String medicine1_name;//药物1名称
    private String medicine2_name;//药物2名称
    private String medicine3_name;//药物3名称
    private Integer medicine1_dosage_early;//药物1早剂量，mg
    private Integer medicine2_dosage_early;//药物2早剂量，mg
    private Integer medicine3_dosage_early;//药物3早剂量，mg
    private Integer medicine1_dosage_noon;//药物1中剂量，mg
    private Integer medicine2_dosage_noon;//药物2中剂量，mg
    private Integer medicine3_dosage_noon;//药物3中剂量，mg
    private Integer medicine1_dosage_night;//药物1晚剂量，mg
    private Integer medicine2_dosage_night;//药物2晚剂量，mg
    private Integer medicine3_dosage_night;//药物3晚剂量，mg
    private Integer medicine1_frequency;//药物1长效药，次/周
    private Integer medicine1_dosage;//药物1长效药，mg/次
    private Integer medicine2_frequency;//药物1长效药，次/周
    private Integer medicine2_dosage;//药物1长效药，mg/次
    private Integer medicine3_frequency;//药物1长效药，次/周
    private Integer medicine3_dosage;//药物1长效药，mg/次

    /******** 用药指导 ********/
    private String guide_medicine1_name;//药物1名称
    private Integer guide_medicine1_dosage_early;//药物1早上用量，mg
    private Integer guide_medicine1_dosage_noon;//药物1中午用量，mg
    private Integer guide_medicine1_dosage_night;//药物1晚用量，mg
    private Integer guide_sustained_medicine1_frequency;//长效药，次/周
    private Integer guide_sustained_meidicine1_dosage;//长效药，mg/次

    private String guide_medicine2_name;//药物2名称
    private Integer guide_medicine2_dosage_early;//早上用量，mg
    private Integer guide_medicine2_dosage_noon;//中午用量，mg
    private Integer guide_medicine2_dosage_night;//晚用量，mg
    private Integer guide_sustained_medicine2_frequency;//长效药，次/周
    private Integer guide_sustained_meidicine2_dosage;//长效药，mg/次

    private String guide_medicine3_name;//药物3名称
    private Integer guide_medicine3_dosage_early;//早上用量，mg
    private Integer guide_medicine3_dosage_noon;//中午用量，mg
    private Integer guide_medicine3_dosage_night;//晚用量，mg
    private Integer guide_sustained_medicine3_frequency;//长效药，次/周
    private Integer guide_sustained_meidicine3_dosage;//长效药，mg/次

    /******** 康复措施 ********/
    private Integer rehabilitation_work_ability;//生活劳动能力（1有 0无）
    private Integer rehabilitation_training;//职业训练（1有 0无）
    private Integer rehabilitation_learning_ability;//学习能力（1有 0无）
    private Integer rehabilitation_sociability;//社会交往（1有 0无）
    private Integer rehabilitation_other;//其他康复措施（1有 0无）
    private String rehabilitation_other_description;//其他康复措施描述

    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+08:00")
    private Date followup_next_date;//随访日期
    private Integer followup_class;//随访分类
    private String doctor_name;//随访医生名字




    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getFollowup_id() {
        return followup_id;
    }

    public void setFollowup_id(String followup_id) {
        this.followup_id = followup_id;
    }

    public String getFollowup_project() {
        return followup_project;
    }

    public void setFollowup_project(String followup_project) {
        this.followup_project = followup_project;
    }

    public Date getCreate_time() {
        return create_time;
    }

    public void setCreate_time(Date create_time) {
        this.create_time = create_time;
    }

    public String getCreate_user() {
        return create_user;
    }

    public void setCreate_user(String create_user) {
        this.create_user = create_user;
    }

    public String getCreate_user_name() {
        return create_user_name;
    }

    public void setCreate_user_name(String create_user_name) {
        this.create_user_name = create_user_name;
    }

    public String getVersion() {
        return version;
    }

    public void setVersion(String version) {
        this.version = version;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getNumber() {
        return number;
    }

    public void setNumber(String number) {
        this.number = number;
    }

    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+08:00")
    public Date getFollowup_date() {
        return followup_date;
    }

    public void setFollowup_date(Date followup_date) {
        this.followup_date = followup_date;
    }

    public Integer getFollowup_type() {
        return followup_type;
    }

    public void setFollowup_type(Integer followup_type) {
        this.followup_type = followup_type;
    }

    public String getFollowup_object() {
        return followup_object;
    }

    public void setFollowup_object(String followup_object) {
        this.followup_object = followup_object;
    }

    public String getFollowup_null_reason() {
        return followup_null_reason;
    }

    public void setFollowup_null_reason(String followup_null_reason) {
        this.followup_null_reason = followup_null_reason;
    }

    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+08:00")
    public Date getDeath_date() {
        return death_date;
    }

    public void setDeath_date(Date death_date) {
        this.death_date = death_date;
    }

    public Integer getDeath_reason_type() {
        return death_reason_type;
    }

    public void setDeath_reason_type(Integer death_reason_type) {
        this.death_reason_type = death_reason_type;
    }

    public String getPhysical_disease_type() {
        return physical_disease_type;
    }

    public void setPhysical_disease_type(String physical_disease_type) {
        this.physical_disease_type = physical_disease_type;
    }

    public Integer getDangerous_level() {
        return dangerous_level;
    }

    public void setDangerous_level(Integer dangerous_level) {
        this.dangerous_level = dangerous_level;
    }

    public Integer getIllusion() {
        return illusion;
    }

    public void setIllusion(Integer illusion) {
        this.illusion = illusion;
    }

    public Integer getCommunication_difficulty() {
        return communication_difficulty;
    }

    public void setCommunication_difficulty(Integer communication_difficulty) {
        this.communication_difficulty = communication_difficulty;
    }

    public Integer getSuspicious() {
        return suspicious;
    }

    public void setSuspicious(Integer suspicious) {
        this.suspicious = suspicious;
    }

    public Integer getMoods() {
        return moods;
    }

    public void setMoods(Integer moods) {
        this.moods = moods;
    }

    public Integer getWeird() {
        return weird;
    }

    public void setWeird(Integer weird) {
        this.weird = weird;
    }

    public Integer getTalkative() {
        return talkative;
    }

    public void setTalkative(Integer talkative) {
        this.talkative = talkative;
    }

    public Integer getSmashing_objects() {
        return smashing_objects;
    }

    public void setSmashing_objects(Integer smashing_objects) {
        this.smashing_objects = smashing_objects;
    }

    public Integer getProfoundly_pessimistic() {
        return profoundly_pessimistic;
    }

    public void setProfoundly_pessimistic(Integer profoundly_pessimistic) {
        this.profoundly_pessimistic = profoundly_pessimistic;
    }

    public Integer getOutside_without_cause() {
        return outside_without_cause;
    }

    public void setOutside_without_cause(Integer outside_without_cause) {
        this.outside_without_cause = outside_without_cause;
    }

    public Integer getTo_myself_from_laughing() {
        return to_myself_from_laughing;
    }

    public void setTo_myself_from_laughing(Integer to_myself_from_laughing) {
        this.to_myself_from_laughing = to_myself_from_laughing;
    }

    public Integer getWithdrawn_lazy() {
        return withdrawn_lazy;
    }

    public void setWithdrawn_lazy(Integer withdrawn_lazy) {
        this.withdrawn_lazy = withdrawn_lazy;
    }

    public Integer getOther_symptom() {
        return other_symptom;
    }

    public void setOther_symptom(Integer other_symptom) {
        this.other_symptom = other_symptom;
    }

    public String getOther_symptom_description() {
        return other_symptom_description;
    }

    public void setOther_symptom_description(String other_symptom_description) {
        this.other_symptom_description = other_symptom_description;
    }

    public Integer getIntelligence() {
        return intelligence;
    }

    public void setIntelligence(Integer intelligence) {
        this.intelligence = intelligence;
    }

    public Integer getSleep_condition() {
        return sleep_condition;
    }

    public void setSleep_condition(Integer sleep_condition) {
        this.sleep_condition = sleep_condition;
    }

    public Integer getDietary_status() {
        return dietary_status;
    }

    public void setDietary_status(Integer dietary_status) {
        this.dietary_status = dietary_status;
    }

    public Integer getSelfcare_ability() {
        return selfcare_ability;
    }

    public void setSelfcare_ability(Integer selfcare_ability) {
        this.selfcare_ability = selfcare_ability;
    }

    public Integer getHousework() {
        return housework;
    }

    public void setHousework(Integer housework) {
        this.housework = housework;
    }

    public Integer getWork() {
        return work;
    }

    public void setWork(Integer work) {
        this.work = work;
    }

    public Integer getLearning_ability() {
        return learning_ability;
    }

    public void setLearning_ability(Integer learning_ability) {
        this.learning_ability = learning_ability;
    }

    public Integer getSociability() {
        return sociability;
    }

    public void setSociability(Integer sociability) {
        this.sociability = sociability;
    }

    public Integer getDangerous_behavior_1() {
        return dangerous_behavior_1;
    }

    public void setDangerous_behavior_1(Integer dangerous_behavior_1) {
        this.dangerous_behavior_1 = dangerous_behavior_1;
    }

    public Integer getDangerous_behavior_2() {
        return dangerous_behavior_2;
    }

    public void setDangerous_behavior_2(Integer dangerous_behavior_2) {
        this.dangerous_behavior_2 = dangerous_behavior_2;
    }

    public Integer getDangerous_behavior_3() {
        return dangerous_behavior_3;
    }

    public void setDangerous_behavior_3(Integer dangerous_behavior_3) {
        this.dangerous_behavior_3 = dangerous_behavior_3;
    }

    public Integer getDangerous_behavior_4() {
        return dangerous_behavior_4;
    }

    public void setDangerous_behavior_4(Integer dangerous_behavior_4) {
        this.dangerous_behavior_4 = dangerous_behavior_4;
    }

    public Integer getDangerous_behavior_5() {
        return dangerous_behavior_5;
    }

    public void setDangerous_behavior_5(Integer dangerous_behavior_5) {
        this.dangerous_behavior_5 = dangerous_behavior_5;
    }

    public Integer getDangerous_behavior_6() {
        return dangerous_behavior_6;
    }

    public void setDangerous_behavior_6(Integer dangerous_behavior_6) {
        this.dangerous_behavior_6 = dangerous_behavior_6;
    }

    public Integer getDangerous_behavior_7() {
        return dangerous_behavior_7;
    }

    public void setDangerous_behavior_7(Integer dangerous_behavior_7) {
        this.dangerous_behavior_7 = dangerous_behavior_7;
    }

    public Integer getCaptivity_case() {
        return captivity_case;
    }

    public void setCaptivity_case(Integer captivity_case) {
        this.captivity_case = captivity_case;
    }

    public Integer getIn_hospital_case() {
        return in_hospital_case;
    }

    public void setIn_hospital_case(Integer in_hospital_case) {
        this.in_hospital_case = in_hospital_case;
    }

    public Date getLast_discharged_date() {
        return last_discharged_date;
    }

    public void setLast_discharged_date(Date last_discharged_date) {
        this.last_discharged_date = last_discharged_date;
    }

    public Integer getLaboratory_examination() {
        return laboratory_examination;
    }

    public void setLaboratory_examination(Integer laboratory_examination) {
        this.laboratory_examination = laboratory_examination;
    }

    public String getLaboratory_examination_description() {
        return laboratory_examination_description;
    }

    public void setLaboratory_examination_description(String laboratory_examination_description) {
        this.laboratory_examination_description = laboratory_examination_description;
    }

    public Integer getCompliance() {
        return compliance;
    }

    public void setCompliance(Integer compliance) {
        this.compliance = compliance;
    }

    public Integer getAdverse_drug_reaction() {
        return adverse_drug_reaction;
    }

    public void setAdverse_drug_reaction(Integer adverse_drug_reaction) {
        this.adverse_drug_reaction = adverse_drug_reaction;
    }

    public String getAdverse_drug_reaction_description() {
        return adverse_drug_reaction_description;
    }

    public void setAdverse_drug_reaction_description(String adverse_drug_reaction_description) {
        this.adverse_drug_reaction_description = adverse_drug_reaction_description;
    }

    public Integer getTreatment_effects() {
        return treatment_effects;
    }

    public void setTreatment_effects(Integer treatment_effects) {
        this.treatment_effects = treatment_effects;
    }

    public Integer getReferral() {
        return referral;
    }

    public void setReferral(Integer referral) {
        this.referral = referral;
    }

    public String getReferral_reason() {
        return referral_reason;
    }

    public void setReferral_reason(String referral_reason) {
        this.referral_reason = referral_reason;
    }

    public Integer getIs_referral() {
        return is_referral;
    }

    public void setIs_referral(Integer is_referral) {
        this.is_referral = is_referral;
    }

    public String getOrganization_org() {
        return organization_org;
    }

    public void setOrganization_org(String organization_org) {
        this.organization_org = organization_org;
    }

    public String getOrganization_org_name() {
        return organization_org_name;
    }

    public void setOrganization_org_name(String organization_org_name) {
        this.organization_org_name = organization_org_name;
    }

    public String getOrganization_hospital() {
        return organization_hospital;
    }

    public void setOrganization_hospital(String organization_hospital) {
        this.organization_hospital = organization_hospital;
    }

    public String getOrganization() {
        return organization;
    }

    public void setOrganization(String organization) {
        this.organization = organization;
    }

    public String getMedicine1_name() {
        return medicine1_name;
    }

    public void setMedicine1_name(String medicine1_name) {
        this.medicine1_name = medicine1_name;
    }

    public String getMedicine2_name() {
        return medicine2_name;
    }

    public void setMedicine2_name(String medicine2_name) {
        this.medicine2_name = medicine2_name;
    }

    public String getMedicine3_name() {
        return medicine3_name;
    }

    public void setMedicine3_name(String medicine3_name) {
        this.medicine3_name = medicine3_name;
    }

    public Integer getMedicine1_dosage_early() {
        return medicine1_dosage_early;
    }

    public void setMedicine1_dosage_early(Integer medicine1_dosage_early) {
        this.medicine1_dosage_early = medicine1_dosage_early;
    }

    public Integer getMedicine2_dosage_early() {
        return medicine2_dosage_early;
    }

    public void setMedicine2_dosage_early(Integer medicine2_dosage_early) {
        this.medicine2_dosage_early = medicine2_dosage_early;
    }

    public Integer getMedicine3_dosage_early() {
        return medicine3_dosage_early;
    }

    public void setMedicine3_dosage_early(Integer medicine3_dosage_early) {
        this.medicine3_dosage_early = medicine3_dosage_early;
    }

    public Integer getMedicine1_dosage_noon() {
        return medicine1_dosage_noon;
    }

    public void setMedicine1_dosage_noon(Integer medicine1_dosage_noon) {
        this.medicine1_dosage_noon = medicine1_dosage_noon;
    }

    public Integer getMedicine2_dosage_noon() {
        return medicine2_dosage_noon;
    }

    public void setMedicine2_dosage_noon(Integer medicine2_dosage_noon) {
        this.medicine2_dosage_noon = medicine2_dosage_noon;
    }

    public Integer getMedicine3_dosage_noon() {
        return medicine3_dosage_noon;
    }

    public void setMedicine3_dosage_noon(Integer medicine3_dosage_noon) {
        this.medicine3_dosage_noon = medicine3_dosage_noon;
    }

    public Integer getMedicine1_dosage_night() {
        return medicine1_dosage_night;
    }

    public void setMedicine1_dosage_night(Integer medicine1_dosage_night) {
        this.medicine1_dosage_night = medicine1_dosage_night;
    }

    public Integer getMedicine2_dosage_night() {
        return medicine2_dosage_night;
    }

    public void setMedicine2_dosage_night(Integer medicine2_dosage_night) {
        this.medicine2_dosage_night = medicine2_dosage_night;
    }

    public Integer getMedicine3_dosage_night() {
        return medicine3_dosage_night;
    }

    public void setMedicine3_dosage_night(Integer medicine3_dosage_night) {
        this.medicine3_dosage_night = medicine3_dosage_night;
    }

    public Integer getMedicine1_frequency() {
        return medicine1_frequency;
    }

    public void setMedicine1_frequency(Integer medicine1_frequency) {
        this.medicine1_frequency = medicine1_frequency;
    }

    public Integer getMedicine1_dosage() {
        return medicine1_dosage;
    }

    public void setMedicine1_dosage(Integer medicine1_dosage) {
        this.medicine1_dosage = medicine1_dosage;
    }

    public Integer getMedicine2_frequency() {
        return medicine2_frequency;
    }

    public void setMedicine2_frequency(Integer medicine2_frequency) {
        this.medicine2_frequency = medicine2_frequency;
    }

    public Integer getMedicine2_dosage() {
        return medicine2_dosage;
    }

    public void setMedicine2_dosage(Integer medicine2_dosage) {
        this.medicine2_dosage = medicine2_dosage;
    }

    public Integer getMedicine3_frequency() {
        return medicine3_frequency;
    }

    public void setMedicine3_frequency(Integer medicine3_frequency) {
        this.medicine3_frequency = medicine3_frequency;
    }

    public Integer getMedicine3_dosage() {
        return medicine3_dosage;
    }

    public void setMedicine3_dosage(Integer medicine3_dosage) {
        this.medicine3_dosage = medicine3_dosage;
    }

    public String getGuide_medicine1_name() {
        return guide_medicine1_name;
    }

    public void setGuide_medicine1_name(String guide_medicine1_name) {
        this.guide_medicine1_name = guide_medicine1_name;
    }

    public Integer getGuide_medicine1_dosage_early() {
        return guide_medicine1_dosage_early;
    }

    public void setGuide_medicine1_dosage_early(Integer guide_medicine1_dosage_early) {
        this.guide_medicine1_dosage_early = guide_medicine1_dosage_early;
    }

    public Integer getGuide_medicine1_dosage_noon() {
        return guide_medicine1_dosage_noon;
    }

    public void setGuide_medicine1_dosage_noon(Integer guide_medicine1_dosage_noon) {
        this.guide_medicine1_dosage_noon = guide_medicine1_dosage_noon;
    }

    public Integer getGuide_medicine1_dosage_night() {
        return guide_medicine1_dosage_night;
    }

    public void setGuide_medicine1_dosage_night(Integer guide_medicine1_dosage_night) {
        this.guide_medicine1_dosage_night = guide_medicine1_dosage_night;
    }

    public Integer getGuide_sustained_medicine1_frequency() {
        return guide_sustained_medicine1_frequency;
    }

    public void setGuide_sustained_medicine1_frequency(Integer guide_sustained_medicine1_frequency) {
        this.guide_sustained_medicine1_frequency = guide_sustained_medicine1_frequency;
    }

    public Integer getGuide_sustained_meidicine1_dosage() {
        return guide_sustained_meidicine1_dosage;
    }

    public void setGuide_sustained_meidicine1_dosage(Integer guide_sustained_meidicine1_dosage) {
        this.guide_sustained_meidicine1_dosage = guide_sustained_meidicine1_dosage;
    }

    public String getGuide_medicine2_name() {
        return guide_medicine2_name;
    }

    public void setGuide_medicine2_name(String guide_medicine2_name) {
        this.guide_medicine2_name = guide_medicine2_name;
    }

    public Integer getGuide_medicine2_dosage_early() {
        return guide_medicine2_dosage_early;
    }

    public void setGuide_medicine2_dosage_early(Integer guide_medicine2_dosage_early) {
        this.guide_medicine2_dosage_early = guide_medicine2_dosage_early;
    }

    public Integer getGuide_medicine2_dosage_noon() {
        return guide_medicine2_dosage_noon;
    }

    public void setGuide_medicine2_dosage_noon(Integer guide_medicine2_dosage_noon) {
        this.guide_medicine2_dosage_noon = guide_medicine2_dosage_noon;
    }

    public Integer getGuide_medicine2_dosage_night() {
        return guide_medicine2_dosage_night;
    }

    public void setGuide_medicine2_dosage_night(Integer guide_medicine2_dosage_night) {
        this.guide_medicine2_dosage_night = guide_medicine2_dosage_night;
    }

    public Integer getGuide_sustained_medicine2_frequency() {
        return guide_sustained_medicine2_frequency;
    }

    public void setGuide_sustained_medicine2_frequency(Integer guide_sustained_medicine2_frequency) {
        this.guide_sustained_medicine2_frequency = guide_sustained_medicine2_frequency;
    }

    public Integer getGuide_sustained_meidicine2_dosage() {
        return guide_sustained_meidicine2_dosage;
    }

    public void setGuide_sustained_meidicine2_dosage(Integer guide_sustained_meidicine2_dosage) {
        this.guide_sustained_meidicine2_dosage = guide_sustained_meidicine2_dosage;
    }

    public String getGuide_medicine3_name() {
        return guide_medicine3_name;
    }

    public void setGuide_medicine3_name(String guide_medicine3_name) {
        this.guide_medicine3_name = guide_medicine3_name;
    }

    public Integer getGuide_medicine3_dosage_early() {
        return guide_medicine3_dosage_early;
    }

    public void setGuide_medicine3_dosage_early(Integer guide_medicine3_dosage_early) {
        this.guide_medicine3_dosage_early = guide_medicine3_dosage_early;
    }

    public Integer getGuide_medicine3_dosage_noon() {
        return guide_medicine3_dosage_noon;
    }

    public void setGuide_medicine3_dosage_noon(Integer guide_medicine3_dosage_noon) {
        this.guide_medicine3_dosage_noon = guide_medicine3_dosage_noon;
    }

    public Integer getGuide_medicine3_dosage_night() {
        return guide_medicine3_dosage_night;
    }

    public void setGuide_medicine3_dosage_night(Integer guide_medicine3_dosage_night) {
        this.guide_medicine3_dosage_night = guide_medicine3_dosage_night;
    }

    public Integer getGuide_sustained_medicine3_frequency() {
        return guide_sustained_medicine3_frequency;
    }

    public void setGuide_sustained_medicine3_frequency(Integer guide_sustained_medicine3_frequency) {
        this.guide_sustained_medicine3_frequency = guide_sustained_medicine3_frequency;
    }

    public Integer getGuide_sustained_meidicine3_dosage() {
        return guide_sustained_meidicine3_dosage;
    }

    public void setGuide_sustained_meidicine3_dosage(Integer guide_sustained_meidicine3_dosage) {
        this.guide_sustained_meidicine3_dosage = guide_sustained_meidicine3_dosage;
    }

    public Integer getRehabilitation_work_ability() {
        return rehabilitation_work_ability;
    }

    public void setRehabilitation_work_ability(Integer rehabilitation_work_ability) {
        this.rehabilitation_work_ability = rehabilitation_work_ability;
    }

    public Integer getRehabilitation_training() {
        return rehabilitation_training;
    }

    public void setRehabilitation_training(Integer rehabilitation_training) {
        this.rehabilitation_training = rehabilitation_training;
    }

    public Integer getRehabilitation_learning_ability() {
        return rehabilitation_learning_ability;
    }

    public void setRehabilitation_learning_ability(Integer rehabilitation_learning_ability) {
        this.rehabilitation_learning_ability = rehabilitation_learning_ability;
    }

    public Integer getRehabilitation_sociability() {
        return rehabilitation_sociability;
    }

    public void setRehabilitation_sociability(Integer rehabilitation_sociability) {
        this.rehabilitation_sociability = rehabilitation_sociability;
    }

    public Integer getRehabilitation_other() {
        return rehabilitation_other;
    }

    public void setRehabilitation_other(Integer rehabilitation_other) {
        this.rehabilitation_other = rehabilitation_other;
    }

    public String getRehabilitation_other_description() {
        return rehabilitation_other_description;
    }

    public void setRehabilitation_other_description(String rehabilitation_other_description) {
        this.rehabilitation_other_description = rehabilitation_other_description;
    }

    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+08:00")
    public Date getFollowup_next_date() {
        return followup_next_date;
    }

    public void setFollowup_next_date(Date followup_next_date) {
        this.followup_next_date = followup_next_date;
    }

    public Integer getFollowup_class() {
        return followup_class;
    }

    public void setFollowup_class(Integer followup_class) {
        this.followup_class = followup_class;
    }

    public String getDoctor_name() {
        return doctor_name;
    }

    public void setDoctor_name(String doctor_name) {
        this.doctor_name = doctor_name;
    }
}
