package com.yihu.rehabilitation.vo.entity;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.searchbox.annotations.JestId;
import org.springframework.data.annotation.CreatedDate;

import java.util.Date;

/**
 * 妇科炎症日常随访表
 * @author hmf
 * @date 2020/3/12
 */
public class GynecologicalInflammationDailyFollowupES {
    @JestId
    private String id;
    private String followup_id;             //随访记录ID
    private String followup_project;        //随访详情分类ID
    private String version;//版本号
    private String followClass;//随访类别【1.阴道炎 2.盆腔炎 3.宫颈炎4.其他】
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyyMMdd'T'HHmmss.SSS'Z'")
    @CreatedDate
    private Date createTime;//创建时间
    private String createOperator;//创建人
    private String createOperatorName;//创建人
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyyMMdd'T'HHmmss.SSS'Z'")
    @CreatedDate
    private Date modifyTime;//修改时间
    private String modifyOperator;//修改人
    private String modifyOperatorName;//修改人
    private String problemId;//健康问题id(肺癌1001 慢性胃肠病1002 冠心病1003 慢性前列腺疾病1004 慢性乳腺疾病1005  慢性阻塞性肺病1006 脂肪肝1007 慢性妇科炎症1008 脑卒中1009 慢性肾病1010)
    private String referralHospital;//是否已经转诊上级医院 1是 0否
    private String hospitalOrg;//就诊机构
    private String hospitalOrgName;//就诊机构
    private String illnessBetter;//该院治疗后病情是否好转 1是 0否
    private String currentStatus;//目前情况（1还在治疗中 2还在治疗中、暂未就诊 3还在治疗中、拒绝管理 4还在治疗中、失访 5已结束治疗）
    private String validFlag;//有效标志
    private String remark;//备注

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getFollowup_id() {
        return followup_id;
    }

    public void setFollowup_id(String followup_id) {
        this.followup_id = followup_id;
    }

    public String getFollowup_project() {
        return followup_project;
    }

    public void setFollowup_project(String followup_project) {
        this.followup_project = followup_project;
    }

    public String getProblemId() {
        return problemId;
    }

    public void setProblemId(String problemId) {
        this.problemId = problemId;
    }

    public String getReferralHospital() {
        return referralHospital;
    }

    public void setReferralHospital(String referralHospital) {
        this.referralHospital = referralHospital;
    }

    public String getHospitalOrg() {
        return hospitalOrg;
    }

    public void setHospitalOrg(String hospitalOrg) {
        this.hospitalOrg = hospitalOrg;
    }

    public String getIllnessBetter() {
        return illnessBetter;
    }

    public void setIllnessBetter(String illnessBetter) {
        this.illnessBetter = illnessBetter;
    }

    public String getCurrentStatus() {
        return currentStatus;
    }

    public void setCurrentStatus(String currentStatus) {
        this.currentStatus = currentStatus;
    }

    public String getValidFlag() {
        return validFlag;
    }

    public void setValidFlag(String validFlag) {
        this.validFlag = validFlag;
    }

    public String getRemark() {
        return remark;
    }

    public void setRemark(String remark) {
        this.remark = remark;
    }

    public String getFollowClass() {
        return followClass;
    }

    public void setFollowClass(String followClass) {
        this.followClass = followClass;
    }

    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    public String getCreateOperator() {
        return createOperator;
    }

    public void setCreateOperator(String createOperator) {
        this.createOperator = createOperator;
    }

    public String getCreateOperatorName() {
        return createOperatorName;
    }

    public void setCreateOperatorName(String createOperatorName) {
        this.createOperatorName = createOperatorName;
    }

    public Date getModifyTime() {
        return modifyTime;
    }

    public void setModifyTime(Date modifyTime) {
        this.modifyTime = modifyTime;
    }

    public String getModifyOperator() {
        return modifyOperator;
    }

    public void setModifyOperator(String modifyOperator) {
        this.modifyOperator = modifyOperator;
    }

    public String getModifyOperatorName() {
        return modifyOperatorName;
    }

    public void setModifyOperatorName(String modifyOperatorName) {
        this.modifyOperatorName = modifyOperatorName;
    }

    public String getHospitalOrgName() {
        return hospitalOrgName;
    }

    public void setHospitalOrgName(String hospitalOrgName) {
        this.hospitalOrgName = hospitalOrgName;
    }

    public String getVersion() {
        return version;
    }

    public void setVersion(String version) {
        this.version = version;
    }
}
