package com.yihu.rehabilitation.vo.entity;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.searchbox.annotations.JestId;
import org.springframework.data.annotation.CreatedDate;
import org.springframework.data.annotation.Transient;

import java.util.Date;
import java.util.List;

/**
 * 推送记录表
 * Created by chenweida on 2017/9/7.
 */
public class HealthEduArticlePatient {
    @JestId
    private String id;
    @Transient
    private String patient; // 患者标识
    @Transient
    private String patientName;    // 患者标识
    private String doctorCode;  //推送的医生code（包括医生本人、卫计委）
    private String doctorName;  //推送的医生名称（包括医生本人、卫计委）
//    private String sendCode;   // 发送人code
    private String sendName;   // 发送人名称
    private String sendPic;   // 发送人头像
    private String sendSex;   // 发送人性别
    private String sendLevel;   // 发送人级别  1专科医生，2全科医生，3健康管理师 4 管理员

    private Integer sendType;//发送类型 1医生发送 2卫纪委发送
    private Long adminTeamCode;// 行政团队
    private String adminTeamName;// 行政团队
    private String hospital; // 所属机构
    private String hospitalName; // 所属机构
    private String town; // 所属区划
    private String townName; // 所属区划
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyyMMdd'T'HHmmss.SSS'Z'")
    @CreatedDate
    private Date createTime;  // 创建时间
    private String batchNo;//批次号记录发送所属批次

    private String articleId;  //文章id
    private String attachedTitle;  //文章标题
    private String attachedPic;//文章封面
    private String attachedContent; //文章内容
    private String attachedMessage; //文章附加文件
    private String articleType;//文章类别
    private String level1Type;//1级类别
    private String level2Type;//2级类别
    private String level;//等级
    private Integer allCount;//所有的推送数目
    private String type;//推送类型 1：文章 2：健康课程
    private String articleUrl;//集美宣教，文章的url
    private List<Patient> patients;//被推送文章的患者
    private String operatorId;//文章作者Id
    private List<RoleVo> roleList;//发送者角色
    private String leaveWords;//医生留言
    private String currentUserRoleCode;//当前登录的角色code
    private String currentUserRoleLevel;//当前登录的角色级别
    private String isread;//1已读，0未读

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }


//    public String getSendCode() {
//        return sendCode;
//    }
//
//    public void setSendCode(String sendCode) {
//        this.sendCode = sendCode;
//    }

    public String getSendName() {
        return sendName;
    }

    public void setSendName(String sendName) {
        this.sendName = sendName;
    }

    public Integer getSendType() {
        return sendType;
    }

    public void setSendType(Integer sendType) {
        this.sendType = sendType;
    }

    public Long getAdminTeamCode() {
        return adminTeamCode;
    }

    public void setAdminTeamCode(Long adminTeamCode) {
        this.adminTeamCode = adminTeamCode;
    }

    public String getHospital() {
        return hospital;
    }

    public void setHospital(String hospital) {
        this.hospital = hospital;
    }

    public String getTown() {
        return town;
    }

    public void setTown(String town) {
        this.town = town;
    }

    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    public String getBatchNo() {
        return batchNo;
    }

    public void setBatchNo(String batchNo) {
        this.batchNo = batchNo;
    }

    public String getArticleId() {
        return articleId;
    }

    public void setArticleId(String articleId) {
        this.articleId = articleId;
    }

    public String getAttachedTitle() {
        return attachedTitle;
    }

    public void setAttachedTitle(String attachedTitle) {
        this.attachedTitle = attachedTitle;
    }

    public String getAttachedPic() {
        return attachedPic;
    }

    public void setAttachedPic(String attachedPic) {
        this.attachedPic = attachedPic;
    }

    public String getAttachedContent() {
        return attachedContent;
    }

    public void setAttachedContent(String attachedContent) {
        this.attachedContent = attachedContent;
    }

    public String getAttachedMessage() {
        return attachedMessage;
    }

    public void setAttachedMessage(String attachedMessage) {
        this.attachedMessage = attachedMessage;
    }

    public String getAdminTeamName() {
        return adminTeamName;
    }

    public void setAdminTeamName(String adminTeamName) {
        this.adminTeamName = adminTeamName;
    }

    public String getHospitalName() {
        return hospitalName;
    }

    public void setHospitalName(String hospitalName) {
        this.hospitalName = hospitalName;
    }

    public String getTownName() {
        return townName;
    }

    public void setTownName(String townName) {
        this.townName = townName;
    }

    public String getArticleType() {
        return articleType;
    }

    public void setArticleType(String articleType) {
        this.articleType = articleType;
    }

    public String getLevel1Type() {
        return level1Type;
    }

    public void setLevel1Type(String level1Type) {
        this.level1Type = level1Type;
    }

    public String getLevel2Type() {
        return level2Type;
    }

    public void setLevel2Type(String level2Type) {
        this.level2Type = level2Type;
    }

    public String getLevel() {
        return level;
    }

    public void setLevel(String level) {
        this.level = level;
    }

    public Integer getAllCount() {
        return allCount;
    }

    public void setAllCount(Integer allCount) {
        this.allCount = allCount;
    }

    public String getSendPic() {
        return sendPic;
    }

    public void setSendPic(String sendPic) {
        this.sendPic = sendPic;
    }

    public String getSendSex() {
        return sendSex;
    }

    public void setSendSex(String sendSex) {
        this.sendSex = sendSex;
    }

    public String getSendLevel() {
        return sendLevel;
    }

    public void setSendLevel(String sendLevel) {
        this.sendLevel = sendLevel;
    }

    public String getType() {
        return type;
    }

    public void setType(String type) {
        this.type = type;
    }

    public String getArticleUrl() {
        return articleUrl;
    }

    public void setArticleUrl(String articleUrl) {
        this.articleUrl = articleUrl;
    }

    public String getPatient() {
        return patient;
    }

    public void setPatient(String patient) {
        this.patient = patient;
    }

    public String getPatientName() {
        return patientName;
    }

    public void setPatientName(String patientName) {
        this.patientName = patientName;
    }

    public List<Patient> getPatients() {
        return patients;
    }

    public void setPatients(List<Patient> patients) {
        this.patients = patients;
    }

    public String getDoctorCode() {
        return doctorCode;
    }

    public void setDoctorCode(String doctorCode) {
        this.doctorCode = doctorCode;
    }

    public String getDoctorName() {
        return doctorName;
    }

    public void setDoctorName(String doctorName) {
        this.doctorName = doctorName;
    }

    public String getOperatorId() {
        return operatorId;
    }

    public void setOperatorId(String operatorId) {
        this.operatorId = operatorId;
    }

    public List<RoleVo> getRoleList() {
        return roleList;
    }

    public void setRoleList(List<RoleVo> roleList) {
        this.roleList = roleList;
    }

    public String getLeaveWords() {
        return leaveWords;
    }

    public void setLeaveWords(String leaveWords) {
        this.leaveWords = leaveWords;
    }

    public String getCurrentUserRoleCode() {
        return currentUserRoleCode;
    }

    public void setCurrentUserRoleCode(String currentUserRoleCode) {
        this.currentUserRoleCode = currentUserRoleCode;
    }

    public String getCurrentUserRoleLevel() {
        return currentUserRoleLevel;
    }

    public void setCurrentUserRoleLevel(String currentUserRoleLevel) {
        this.currentUserRoleLevel = currentUserRoleLevel;
    }
    
    public String getIsread() {
        return isread;
    }
    
    public void setIsread(String isread) {
        this.isread = isread;
    }
}
