package com.yihu.rehabilitation.vo.entity;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.searchbox.annotations.JestId;
import org.springframework.data.annotation.CreatedDate;

import java.util.Date;

/**
 * 新生儿家庭访视记录表
 * create by hmf on 2019/4/17
 */
public class NewbornFamilyVisitRecordES {
    @JestId
    private String id;
    private String followup_id;             //随访记录ID
    private String followup_project;        //随访详情分类ID
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyyMMdd'T'HHmmss.SSS'Z'")
    @CreatedDate
    private Date create_time;
    private String create_user;
    private String create_user_name;
    private String version;//版本号

    private String SICK_NAME;//儿童姓名
    private Integer HELP_ORGANIZATION_FLAG;//本地外地标志【1本地，2省内 3省外】
    private String PREGNANCY_NO;//妊娠编号
    private String NUMBER_NO;//建册编号
    private String HOME_REMARK;//家庭访视备注
    private String BIRTH_NO;//出生证号

    //第一次随访新生儿家庭基本信息
    private Integer SICK_SEX;//儿童性别(0未知 1男 2 女 9 未说明的性别)
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+08:00")
    private Date BIRTHDAY;//出生日期

    private String PERMANENT_RESIDENCE_ADDRESS;//户籍地址

    /******** 母亲信息 ********/
    private String MOTHER_IDENTITY_CARD_NO;//母亲身份证号
    private String MOTHER_ADDRESS;//母亲住址
    private String MOTHER_NAME;//母亲名字
    private String MOTHER_OCCUPATION;//母亲职业
    private String MOTHER_PHONE;//母亲电话
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+08:00")
    private Date MOTHER_BIRTHDAY;//母亲出生日期

    /******** 父亲信息 ********/
    private String FATHER_NAME;//父亲名字
    private String FATHER_OCCUPATION;//父亲职业
    private String FATHER_PHONE;//父亲电话
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+08:00")
    private Date FATHER_BIRTHDAY;//父亲出生日期

    /******** 新生儿信息 ********/
    private Integer BIRTH_PREGNANCY_WEEK;//出生孕周

    private Integer PREGNANCY_SICK;//母亲妊娠期患病情况(1无 2糖尿病  3妊娠期高血压 4其他）
    private String PREGNANCY_SICK_CIRCS;//母亲妊娠期其他患病情况

    private String HELP_ORGANIZATION_NAME;//助产机构名称
    private String HELP_HOSPITAL;//助产机构code（dm_hospital表的code）
    private String HELP_ORGANIZATION;//助产机构mapping_code (智业机构编码)
    private String HELP_OUT_ORGANIZATION;//外地转诊机构
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+08:00")
    private Date DISCHARGED_DATE;//出院日期
    private String DELIVERY_WAY;//出生情况（1顺产 2胎头吸引 3产钳 4剖宫 5双多胎 6臀位 7其他，多个用逗号隔开 ）
    private String BIRTH_OTHER;//出生情况-其他内容
    private Integer SUFFOCATION;//新生儿窒息【1无，2有】
    private Integer APGAR_O;//APGAR评分（1分钟）(1否 2是)
    private Integer APGAR_F;//APGAR评分（5分钟）(1否 2是)
    private Integer APGAR_N;//APGAR评分（不详）(1否 2是)
    private String BLESSEDEVENT_MEDICAL_HISTORY;// 新生儿期病史
    private Integer PLAN_IMMUNE;//计划免疫情况（1卡介苗 2乙肝疫苗 3以上两种 4未种 ）
    private Double BLESSEDEVENT_BIRTH_WEIGHT;//新生儿出生体重，kg
    private Double BIRTH_BODY_LENGTH;//出生身长 cm
    private Integer DEFORMITY_NULL;//畸形异常（1无2有）

    /******** 新生儿疾病筛查 ********/
    private Integer SCREENING_1;//新生儿疾病筛查-甲低【1是，0否】
    private Integer SCREENING_2;//新生儿疾病筛查-苯丙酮尿症【1是，0否】
    private Integer SCREENING_3;//新生儿疾病筛查-其他遗传代谢病【1是，0否】
    private String SCREENING_ABNORMAL;//新生儿疾病筛查-其他遗传代谢病-内容
    private Integer SCREENING_4;//新生儿疾病筛查-未进行【1是，0否】
    private Integer SCREENING_5;//新生儿疾病筛查-检查均阴性【1是，0否】
    private Integer SCREENING_6;//新生儿疾病筛查-已查无结果【1是，0否】

    private Integer HEARING;//新生儿听力筛查(1通过 2未通过 3未筛查 4 不详 5已查无结果)
    private Double NOW_WEIGHT; //现在体重 kg
    private Integer FEED_TYPE;//喂奶方式【1纯母乳，2混合，3人工】
    private Integer EAT_MILE_TIME;//吃奶次数 次/日
    private Double EAT_MILE_AMOUNT;//吃奶量ml/次
    private Integer VOMIT;//呕吐【1无，2有】
    private Integer VULNUS;//大便【1糊状，2稀 3其他】
    private String VULNUS_OTHER;//大便其他说明
    private String VULNUS_TIME;//大便次数

    private Double BODY_TEMPERATURE;//体温
    private String PULSE_FREQUENCY;//心率 次/分钟
    private String BREATH_FREQUENCY;//呼吸频率 次/分钟

    private Integer COMPLEXION;//面色【1红润，2黄染，3其他】
    private String COMPLEXION_NULL;//面色异常表现
    private Integer FACE;//黄疸部位-面部
    private Integer TRUNK;//黄疸部位-躯干【1有，0无】
    private Integer LIMB;//黄疸部位-四肢【1是，0否】
    private Integer EXTREMITY;//黄疸部位-手足 【1是，0否】
    private Double BREGMA_FRONT;//前囟1 CM
    private Double BREGMA_BACK;//前囟2 CM
    private String BREGMA_PERFORMANCE;//前囟 其他表现
    private Integer BREGMA;//前囟 单选【1正常，2膨隆，3凹陷，4其他】

    private Integer EYE;//眼外观【1未见异常，2异常】
    private String EYE_NULL;//眼外观异常
    private Integer EAR;//耳外观异常【1未见异常，2异常】
    private String EAR_FACE;//耳外观

    private Integer LIMBS;//四肢活动度异常【1未见异常，2异常】
    private String LIMBS_NULL;//四肢活动度异常说明

    private Integer NECK_PACK;//颈部包块【1无，2有】
    private String NECK_PACK_NULL;//颈部包块异常说明

    private Integer NOSE;//鼻【1未见异常，2异常】
    private String NOSE_PERFORMANCE;//鼻异常说明

    private Integer ORAL;//口腔【1未见异常，2异常】
    private String ORAL_PERFORMANCE;//口腔异常

    private Integer ABDOMEN;//腹部触诊异常【1未见异常，2异常】
    private String ABDOMEN_NULL;//腹部触诊

    private Integer GENITALIA;//外生殖器异常【1未见异常，2异常】
    private String GENITALIA_NULL;//外生殖器

    private Integer VERTEBRAL;//脊柱异常【1未见异常，2异常】
    private String VERTEBRAL_NULL;//脊柱

    private Integer SKIN;//皮肤【1未见异常，2湿疹，3糜烂，4其他】
    private String SKIN_PERFORMANCE;//皮肤异常

    private Integer ANUS;//肛门【1未见异常，2异常】
    private String ANUS_PERFORMANCE;//肛门异常说明

    private Integer HEART;//心肺听诊【1未见异常，2异常】
    private String HEART_PERFORMANCE;//心肺听诊异常

    private Integer UMBILICAL;//脐带(1未脱落 2脱落 3脐带有渗出 4 其他)
    private String UMBILICAL_NULL;//脐带异常

    private String other;//其他

    private Integer referral;//转诊建议（1有，0无）
    private String referral_reason;//转诊建议（原因）

    private String organization_org;//转诊机构(智业机构code)
    private String organization_org_name;//转诊机构名称
    private String organization_hospital;//转诊机构code(dm_hospital表的code)
    private String organization;//转诊科室

    /******** 指导 ********/
    private Integer FEED_GUID ;//喂养指导【1有，0无】
    private Integer PREVENTION_HURT_GUID;//预防伤害指导【1有，0无】
    private Integer ORAL_CAVITY_GUID;//口腔保健指导【1有，0无】
    private Integer GROWUP_GUID;//发育指导【1是，0否】
    private Integer PREVENTION_DEFORMITY_GUID;//防残指导【1是，0否】
    private Integer OTHER_GUIDE;//其他指导
    private String OTHER_GUIDE_CONTENT;//其他指导内容

    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+08:00")
    private Date THIS_INTERVIEW_DATE;//本次访视日期
    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+08:00")
    private Date NEXT_VISITING_DATE;//下次随访日期
    private String  NEXT_VISITING_ADDRESS;//下次随访地点
    private String VISITING_DOCTOR;//随访医生
    private String FAMILY_SIGN;//签字家属

    //智业多余字段
    private String ORG_ID;//随访机构
    private String PHYSICLAL_STATUS;//两次访视间患者情况
    private String IDENTITY_CARD_NO;//身份证号
    private Integer IS_CHILD_WEAK;//是否高危儿

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getFollowup_id() {
        return followup_id;
    }

    public void setFollowup_id(String followup_id) {
        this.followup_id = followup_id;
    }

    public String getFollowup_project() {
        return followup_project;
    }

    public void setFollowup_project(String followup_project) {
        this.followup_project = followup_project;
    }

    public Date getCreate_time() {
        return create_time;
    }

    public void setCreate_time(Date create_time) {
        this.create_time = create_time;
    }

    public String getCreate_user() {
        return create_user;
    }

    public void setCreate_user(String create_user) {
        this.create_user = create_user;
    }

    public String getCreate_user_name() {
        return create_user_name;
    }

    public void setCreate_user_name(String create_user_name) {
        this.create_user_name = create_user_name;
    }

    public String getVersion() {
        return version;
    }

    public void setVersion(String version) {
        this.version = version;
    }

    public String getSICK_NAME() {
        return SICK_NAME;
    }

    public void setSICK_NAME(String SICK_NAME) {
        this.SICK_NAME = SICK_NAME;
    }

    public Integer getHELP_ORGANIZATION_FLAG() {
        return HELP_ORGANIZATION_FLAG;
    }

    public void setHELP_ORGANIZATION_FLAG(Integer HELP_ORGANIZATION_FLAG) {
        this.HELP_ORGANIZATION_FLAG = HELP_ORGANIZATION_FLAG;
    }

    public String getPREGNANCY_NO() {
        return PREGNANCY_NO;
    }

    public void setPREGNANCY_NO(String PREGNANCY_NO) {
        this.PREGNANCY_NO = PREGNANCY_NO;
    }

    public String getNUMBER_NO() {
        return NUMBER_NO;
    }

    public void setNUMBER_NO(String NUMBER_NO) {
        this.NUMBER_NO = NUMBER_NO;
    }

    public String getHOME_REMARK() {
        return HOME_REMARK;
    }

    public void setHOME_REMARK(String HOME_REMARK) {
        this.HOME_REMARK = HOME_REMARK;
    }

    public String getBIRTH_NO() {
        return BIRTH_NO;
    }

    public void setBIRTH_NO(String BIRTH_NO) {
        this.BIRTH_NO = BIRTH_NO;
    }

    public Integer getSICK_SEX() {
        return SICK_SEX;
    }

    public void setSICK_SEX(Integer SICK_SEX) {
        this.SICK_SEX = SICK_SEX;
    }

    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+08:00")
    public Date getBIRTHDAY() {
        return BIRTHDAY;
    }

    public void setBIRTHDAY(Date BIRTHDAY) {
        this.BIRTHDAY = BIRTHDAY;
    }

    public String getPERMANENT_RESIDENCE_ADDRESS() {
        return PERMANENT_RESIDENCE_ADDRESS;
    }

    public void setPERMANENT_RESIDENCE_ADDRESS(String PERMANENT_RESIDENCE_ADDRESS) {
        this.PERMANENT_RESIDENCE_ADDRESS = PERMANENT_RESIDENCE_ADDRESS;
    }

    public String getMOTHER_IDENTITY_CARD_NO() {
        return MOTHER_IDENTITY_CARD_NO;
    }

    public void setMOTHER_IDENTITY_CARD_NO(String MOTHER_IDENTITY_CARD_NO) {
        this.MOTHER_IDENTITY_CARD_NO = MOTHER_IDENTITY_CARD_NO;
    }

    public String getMOTHER_ADDRESS() {
        return MOTHER_ADDRESS;
    }

    public void setMOTHER_ADDRESS(String MOTHER_ADDRESS) {
        this.MOTHER_ADDRESS = MOTHER_ADDRESS;
    }

    public String getMOTHER_NAME() {
        return MOTHER_NAME;
    }

    public void setMOTHER_NAME(String MOTHER_NAME) {
        this.MOTHER_NAME = MOTHER_NAME;
    }

    public String getMOTHER_OCCUPATION() {
        return MOTHER_OCCUPATION;
    }

    public void setMOTHER_OCCUPATION(String MOTHER_OCCUPATION) {
        this.MOTHER_OCCUPATION = MOTHER_OCCUPATION;
    }

    public String getMOTHER_PHONE() {
        return MOTHER_PHONE;
    }

    public void setMOTHER_PHONE(String MOTHER_PHONE) {
        this.MOTHER_PHONE = MOTHER_PHONE;
    }

    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+08:00")
    public Date getMOTHER_BIRTHDAY() {
        return MOTHER_BIRTHDAY;
    }

    public void setMOTHER_BIRTHDAY(Date MOTHER_BIRTHDAY) {
        this.MOTHER_BIRTHDAY = MOTHER_BIRTHDAY;
    }

    public String getFATHER_NAME() {
        return FATHER_NAME;
    }

    public void setFATHER_NAME(String FATHER_NAME) {
        this.FATHER_NAME = FATHER_NAME;
    }

    public String getFATHER_OCCUPATION() {
        return FATHER_OCCUPATION;
    }

    public void setFATHER_OCCUPATION(String FATHER_OCCUPATION) {
        this.FATHER_OCCUPATION = FATHER_OCCUPATION;
    }

    public String getFATHER_PHONE() {
        return FATHER_PHONE;
    }

    public void setFATHER_PHONE(String FATHER_PHONE) {
        this.FATHER_PHONE = FATHER_PHONE;
    }

    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+08:00")
    public Date getFATHER_BIRTHDAY() {
        return FATHER_BIRTHDAY;
    }

    public void setFATHER_BIRTHDAY(Date FATHER_BIRTHDAY) {
        this.FATHER_BIRTHDAY = FATHER_BIRTHDAY;
    }

    public Integer getBIRTH_PREGNANCY_WEEK() {
        return BIRTH_PREGNANCY_WEEK;
    }

    public void setBIRTH_PREGNANCY_WEEK(Integer BIRTH_PREGNANCY_WEEK) {
        this.BIRTH_PREGNANCY_WEEK = BIRTH_PREGNANCY_WEEK;
    }

    public Integer getPREGNANCY_SICK() {
        return PREGNANCY_SICK;
    }

    public void setPREGNANCY_SICK(Integer PREGNANCY_SICK) {
        this.PREGNANCY_SICK = PREGNANCY_SICK;
    }

    public String getPREGNANCY_SICK_CIRCS() {
        return PREGNANCY_SICK_CIRCS;
    }

    public void setPREGNANCY_SICK_CIRCS(String PREGNANCY_SICK_CIRCS) {
        this.PREGNANCY_SICK_CIRCS = PREGNANCY_SICK_CIRCS;
    }

    public String getHELP_ORGANIZATION_NAME() {
        return HELP_ORGANIZATION_NAME;
    }

    public void setHELP_ORGANIZATION_NAME(String HELP_ORGANIZATION_NAME) {
        this.HELP_ORGANIZATION_NAME = HELP_ORGANIZATION_NAME;
    }

    public String getHELP_HOSPITAL() {
        return HELP_HOSPITAL;
    }

    public void setHELP_HOSPITAL(String HELP_HOSPITAL) {
        this.HELP_HOSPITAL = HELP_HOSPITAL;
    }

    public String getHELP_ORGANIZATION() {
        return HELP_ORGANIZATION;
    }

    public void setHELP_ORGANIZATION(String HELP_ORGANIZATION) {
        this.HELP_ORGANIZATION = HELP_ORGANIZATION;
    }

    public String getHELP_OUT_ORGANIZATION() {
        return HELP_OUT_ORGANIZATION;
    }

    public void setHELP_OUT_ORGANIZATION(String HELP_OUT_ORGANIZATION) {
        this.HELP_OUT_ORGANIZATION = HELP_OUT_ORGANIZATION;
    }

    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+08:00")
    public Date getDISCHARGED_DATE() {
        return DISCHARGED_DATE;
    }

    public void setDISCHARGED_DATE(Date DISCHARGED_DATE) {
        this.DISCHARGED_DATE = DISCHARGED_DATE;
    }

    public String getDELIVERY_WAY() {
        return DELIVERY_WAY;
    }

    public void setDELIVERY_WAY(String DELIVERY_WAY) {
        this.DELIVERY_WAY = DELIVERY_WAY;
    }

    public String getBIRTH_OTHER() {
        return BIRTH_OTHER;
    }

    public void setBIRTH_OTHER(String BIRTH_OTHER) {
        this.BIRTH_OTHER = BIRTH_OTHER;
    }

    public Integer getSUFFOCATION() {
        return SUFFOCATION;
    }

    public void setSUFFOCATION(Integer SUFFOCATION) {
        this.SUFFOCATION = SUFFOCATION;
    }

    public Integer getAPGAR_O() {
        return APGAR_O;
    }

    public void setAPGAR_O(Integer APGAR_O) {
        this.APGAR_O = APGAR_O;
    }

    public Integer getAPGAR_F() {
        return APGAR_F;
    }

    public void setAPGAR_F(Integer APGAR_F) {
        this.APGAR_F = APGAR_F;
    }

    public Integer getAPGAR_N() {
        return APGAR_N;
    }

    public void setAPGAR_N(Integer APGAR_N) {
        this.APGAR_N = APGAR_N;
    }

    public String getBLESSEDEVENT_MEDICAL_HISTORY() {
        return BLESSEDEVENT_MEDICAL_HISTORY;
    }

    public void setBLESSEDEVENT_MEDICAL_HISTORY(String BLESSEDEVENT_MEDICAL_HISTORY) {
        this.BLESSEDEVENT_MEDICAL_HISTORY = BLESSEDEVENT_MEDICAL_HISTORY;
    }

    public Integer getPLAN_IMMUNE() {
        return PLAN_IMMUNE;
    }

    public void setPLAN_IMMUNE(Integer PLAN_IMMUNE) {
        this.PLAN_IMMUNE = PLAN_IMMUNE;
    }

    public Double getBLESSEDEVENT_BIRTH_WEIGHT() {
        return BLESSEDEVENT_BIRTH_WEIGHT;
    }

    public void setBLESSEDEVENT_BIRTH_WEIGHT(Double BLESSEDEVENT_BIRTH_WEIGHT) {
        this.BLESSEDEVENT_BIRTH_WEIGHT = BLESSEDEVENT_BIRTH_WEIGHT;
    }

    public Double getBIRTH_BODY_LENGTH() {
        return BIRTH_BODY_LENGTH;
    }

    public void setBIRTH_BODY_LENGTH(Double BIRTH_BODY_LENGTH) {
        this.BIRTH_BODY_LENGTH = BIRTH_BODY_LENGTH;
    }

    public Integer getDEFORMITY_NULL() {
        return DEFORMITY_NULL;
    }

    public void setDEFORMITY_NULL(Integer DEFORMITY_NULL) {
        this.DEFORMITY_NULL = DEFORMITY_NULL;
    }

    public Integer getSCREENING_1() {
        return SCREENING_1;
    }

    public void setSCREENING_1(Integer SCREENING_1) {
        this.SCREENING_1 = SCREENING_1;
    }

    public Integer getSCREENING_2() {
        return SCREENING_2;
    }

    public void setSCREENING_2(Integer SCREENING_2) {
        this.SCREENING_2 = SCREENING_2;
    }

    public Integer getSCREENING_3() {
        return SCREENING_3;
    }

    public void setSCREENING_3(Integer SCREENING_3) {
        this.SCREENING_3 = SCREENING_3;
    }

    public String getSCREENING_ABNORMAL() {
        return SCREENING_ABNORMAL;
    }

    public void setSCREENING_ABNORMAL(String SCREENING_ABNORMAL) {
        this.SCREENING_ABNORMAL = SCREENING_ABNORMAL;
    }

    public Integer getSCREENING_4() {
        return SCREENING_4;
    }

    public void setSCREENING_4(Integer SCREENING_4) {
        this.SCREENING_4 = SCREENING_4;
    }

    public Integer getSCREENING_5() {
        return SCREENING_5;
    }

    public void setSCREENING_5(Integer SCREENING_5) {
        this.SCREENING_5 = SCREENING_5;
    }

    public Integer getSCREENING_6() {
        return SCREENING_6;
    }

    public void setSCREENING_6(Integer SCREENING_6) {
        this.SCREENING_6 = SCREENING_6;
    }

    public Integer getHEARING() {
        return HEARING;
    }

    public void setHEARING(Integer HEARING) {
        this.HEARING = HEARING;
    }

    public Double getNOW_WEIGHT() {
        return NOW_WEIGHT;
    }

    public void setNOW_WEIGHT(Double NOW_WEIGHT) {
        this.NOW_WEIGHT = NOW_WEIGHT;
    }

    public Integer getFEED_TYPE() {
        return FEED_TYPE;
    }

    public void setFEED_TYPE(Integer FEED_TYPE) {
        this.FEED_TYPE = FEED_TYPE;
    }

    public Integer getEAT_MILE_TIME() {
        return EAT_MILE_TIME;
    }

    public void setEAT_MILE_TIME(Integer EAT_MILE_TIME) {
        this.EAT_MILE_TIME = EAT_MILE_TIME;
    }

    public Double getEAT_MILE_AMOUNT() {
        return EAT_MILE_AMOUNT;
    }

    public void setEAT_MILE_AMOUNT(Double EAT_MILE_AMOUNT) {
        this.EAT_MILE_AMOUNT = EAT_MILE_AMOUNT;
    }

    public Integer getVOMIT() {
        return VOMIT;
    }

    public void setVOMIT(Integer VOMIT) {
        this.VOMIT = VOMIT;
    }

    public Integer getVULNUS() {
        return VULNUS;
    }

    public void setVULNUS(Integer VULNUS) {
        this.VULNUS = VULNUS;
    }

    public String getVULNUS_OTHER() {
        return VULNUS_OTHER;
    }

    public void setVULNUS_OTHER(String VULNUS_OTHER) {
        this.VULNUS_OTHER = VULNUS_OTHER;
    }

    public String getVULNUS_TIME() {
        return VULNUS_TIME;
    }

    public void setVULNUS_TIME(String VULNUS_TIME) {
        this.VULNUS_TIME = VULNUS_TIME;
    }

    public Double getBODY_TEMPERATURE() {
        return BODY_TEMPERATURE;
    }

    public void setBODY_TEMPERATURE(Double BODY_TEMPERATURE) {
        this.BODY_TEMPERATURE = BODY_TEMPERATURE;
    }

    public String getPULSE_FREQUENCY() {
        return PULSE_FREQUENCY;
    }

    public void setPULSE_FREQUENCY(String PULSE_FREQUENCY) {
        this.PULSE_FREQUENCY = PULSE_FREQUENCY;
    }

    public String getBREATH_FREQUENCY() {
        return BREATH_FREQUENCY;
    }

    public void setBREATH_FREQUENCY(String BREATH_FREQUENCY) {
        this.BREATH_FREQUENCY = BREATH_FREQUENCY;
    }

    public Integer getCOMPLEXION() {
        return COMPLEXION;
    }

    public void setCOMPLEXION(Integer COMPLEXION) {
        this.COMPLEXION = COMPLEXION;
    }

    public String getCOMPLEXION_NULL() {
        return COMPLEXION_NULL;
    }

    public void setCOMPLEXION_NULL(String COMPLEXION_NULL) {
        this.COMPLEXION_NULL = COMPLEXION_NULL;
    }

    public Integer getFACE() {
        return FACE;
    }

    public void setFACE(Integer FACE) {
        this.FACE = FACE;
    }

    public Integer getTRUNK() {
        return TRUNK;
    }

    public void setTRUNK(Integer TRUNK) {
        this.TRUNK = TRUNK;
    }

    public Integer getLIMB() {
        return LIMB;
    }

    public void setLIMB(Integer LIMB) {
        this.LIMB = LIMB;
    }

    public Integer getEXTREMITY() {
        return EXTREMITY;
    }

    public void setEXTREMITY(Integer EXTREMITY) {
        this.EXTREMITY = EXTREMITY;
    }

    public Double getBREGMA_FRONT() {
        return BREGMA_FRONT;
    }

    public void setBREGMA_FRONT(Double BREGMA_FRONT) {
        this.BREGMA_FRONT = BREGMA_FRONT;
    }

    public Double getBREGMA_BACK() {
        return BREGMA_BACK;
    }

    public void setBREGMA_BACK(Double BREGMA_BACK) {
        this.BREGMA_BACK = BREGMA_BACK;
    }

    public String getBREGMA_PERFORMANCE() {
        return BREGMA_PERFORMANCE;
    }

    public void setBREGMA_PERFORMANCE(String BREGMA_PERFORMANCE) {
        this.BREGMA_PERFORMANCE = BREGMA_PERFORMANCE;
    }

    public Integer getBREGMA() {
        return BREGMA;
    }

    public void setBREGMA(Integer BREGMA) {
        this.BREGMA = BREGMA;
    }

    public Integer getEYE() {
        return EYE;
    }

    public void setEYE(Integer EYE) {
        this.EYE = EYE;
    }

    public String getEYE_NULL() {
        return EYE_NULL;
    }

    public void setEYE_NULL(String EYE_NULL) {
        this.EYE_NULL = EYE_NULL;
    }

    public Integer getEAR() {
        return EAR;
    }

    public void setEAR(Integer EAR) {
        this.EAR = EAR;
    }

    public String getEAR_FACE() {
        return EAR_FACE;
    }

    public void setEAR_FACE(String EAR_FACE) {
        this.EAR_FACE = EAR_FACE;
    }

    public Integer getLIMBS() {
        return LIMBS;
    }

    public void setLIMBS(Integer LIMBS) {
        this.LIMBS = LIMBS;
    }

    public String getLIMBS_NULL() {
        return LIMBS_NULL;
    }

    public void setLIMBS_NULL(String LIMBS_NULL) {
        this.LIMBS_NULL = LIMBS_NULL;
    }

    public Integer getNECK_PACK() {
        return NECK_PACK;
    }

    public void setNECK_PACK(Integer NECK_PACK) {
        this.NECK_PACK = NECK_PACK;
    }

    public String getNECK_PACK_NULL() {
        return NECK_PACK_NULL;
    }

    public void setNECK_PACK_NULL(String NECK_PACK_NULL) {
        this.NECK_PACK_NULL = NECK_PACK_NULL;
    }

    public Integer getNOSE() {
        return NOSE;
    }

    public void setNOSE(Integer NOSE) {
        this.NOSE = NOSE;
    }

    public String getNOSE_PERFORMANCE() {
        return NOSE_PERFORMANCE;
    }

    public void setNOSE_PERFORMANCE(String NOSE_PERFORMANCE) {
        this.NOSE_PERFORMANCE = NOSE_PERFORMANCE;
    }

    public Integer getORAL() {
        return ORAL;
    }

    public void setORAL(Integer ORAL) {
        this.ORAL = ORAL;
    }

    public String getORAL_PERFORMANCE() {
        return ORAL_PERFORMANCE;
    }

    public void setORAL_PERFORMANCE(String ORAL_PERFORMANCE) {
        this.ORAL_PERFORMANCE = ORAL_PERFORMANCE;
    }

    public Integer getABDOMEN() {
        return ABDOMEN;
    }

    public void setABDOMEN(Integer ABDOMEN) {
        this.ABDOMEN = ABDOMEN;
    }

    public String getABDOMEN_NULL() {
        return ABDOMEN_NULL;
    }

    public void setABDOMEN_NULL(String ABDOMEN_NULL) {
        this.ABDOMEN_NULL = ABDOMEN_NULL;
    }

    public Integer getGENITALIA() {
        return GENITALIA;
    }

    public void setGENITALIA(Integer GENITALIA) {
        this.GENITALIA = GENITALIA;
    }

    public String getGENITALIA_NULL() {
        return GENITALIA_NULL;
    }

    public void setGENITALIA_NULL(String GENITALIA_NULL) {
        this.GENITALIA_NULL = GENITALIA_NULL;
    }

    public Integer getVERTEBRAL() {
        return VERTEBRAL;
    }

    public void setVERTEBRAL(Integer VERTEBRAL) {
        this.VERTEBRAL = VERTEBRAL;
    }

    public String getVERTEBRAL_NULL() {
        return VERTEBRAL_NULL;
    }

    public void setVERTEBRAL_NULL(String VERTEBRAL_NULL) {
        this.VERTEBRAL_NULL = VERTEBRAL_NULL;
    }

    public Integer getSKIN() {
        return SKIN;
    }

    public void setSKIN(Integer SKIN) {
        this.SKIN = SKIN;
    }

    public String getSKIN_PERFORMANCE() {
        return SKIN_PERFORMANCE;
    }

    public void setSKIN_PERFORMANCE(String SKIN_PERFORMANCE) {
        this.SKIN_PERFORMANCE = SKIN_PERFORMANCE;
    }

    public Integer getANUS() {
        return ANUS;
    }

    public void setANUS(Integer ANUS) {
        this.ANUS = ANUS;
    }

    public String getANUS_PERFORMANCE() {
        return ANUS_PERFORMANCE;
    }

    public void setANUS_PERFORMANCE(String ANUS_PERFORMANCE) {
        this.ANUS_PERFORMANCE = ANUS_PERFORMANCE;
    }

    public Integer getHEART() {
        return HEART;
    }

    public void setHEART(Integer HEART) {
        this.HEART = HEART;
    }

    public String getHEART_PERFORMANCE() {
        return HEART_PERFORMANCE;
    }

    public void setHEART_PERFORMANCE(String HEART_PERFORMANCE) {
        this.HEART_PERFORMANCE = HEART_PERFORMANCE;
    }

    public Integer getUMBILICAL() {
        return UMBILICAL;
    }

    public void setUMBILICAL(Integer UMBILICAL) {
        this.UMBILICAL = UMBILICAL;
    }

    public String getUMBILICAL_NULL() {
        return UMBILICAL_NULL;
    }

    public void setUMBILICAL_NULL(String UMBILICAL_NULL) {
        this.UMBILICAL_NULL = UMBILICAL_NULL;
    }

    public String getOther() {
        return other;
    }

    public void setOther(String other) {
        this.other = other;
    }

    public Integer getReferral() {
        return referral;
    }

    public void setReferral(Integer referral) {
        this.referral = referral;
    }

    public String getReferral_reason() {
        return referral_reason;
    }

    public void setReferral_reason(String referral_reason) {
        this.referral_reason = referral_reason;
    }

    public String getOrganization_org() {
        return organization_org;
    }

    public void setOrganization_org(String organization_org) {
        this.organization_org = organization_org;
    }

    public String getOrganization_org_name() {
        return organization_org_name;
    }

    public void setOrganization_org_name(String organization_org_name) {
        this.organization_org_name = organization_org_name;
    }

    public String getOrganization_hospital() {
        return organization_hospital;
    }

    public void setOrganization_hospital(String organization_hospital) {
        this.organization_hospital = organization_hospital;
    }

    public String getOrganization() {
        return organization;
    }

    public void setOrganization(String organization) {
        this.organization = organization;
    }

    public Integer getFEED_GUID() {
        return FEED_GUID;
    }

    public void setFEED_GUID(Integer FEED_GUID) {
        this.FEED_GUID = FEED_GUID;
    }

    public Integer getPREVENTION_HURT_GUID() {
        return PREVENTION_HURT_GUID;
    }

    public void setPREVENTION_HURT_GUID(Integer PREVENTION_HURT_GUID) {
        this.PREVENTION_HURT_GUID = PREVENTION_HURT_GUID;
    }

    public Integer getORAL_CAVITY_GUID() {
        return ORAL_CAVITY_GUID;
    }

    public void setORAL_CAVITY_GUID(Integer ORAL_CAVITY_GUID) {
        this.ORAL_CAVITY_GUID = ORAL_CAVITY_GUID;
    }

    public Integer getGROWUP_GUID() {
        return GROWUP_GUID;
    }

    public void setGROWUP_GUID(Integer GROWUP_GUID) {
        this.GROWUP_GUID = GROWUP_GUID;
    }

    public Integer getPREVENTION_DEFORMITY_GUID() {
        return PREVENTION_DEFORMITY_GUID;
    }

    public void setPREVENTION_DEFORMITY_GUID(Integer PREVENTION_DEFORMITY_GUID) {
        this.PREVENTION_DEFORMITY_GUID = PREVENTION_DEFORMITY_GUID;
    }

    public Integer getOTHER_GUIDE() {
        return OTHER_GUIDE;
    }

    public void setOTHER_GUIDE(Integer OTHER_GUIDE) {
        this.OTHER_GUIDE = OTHER_GUIDE;
    }

    public String getOTHER_GUIDE_CONTENT() {
        return OTHER_GUIDE_CONTENT;
    }

    public void setOTHER_GUIDE_CONTENT(String OTHER_GUIDE_CONTENT) {
        this.OTHER_GUIDE_CONTENT = OTHER_GUIDE_CONTENT;
    }

    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+08:00")
    public Date getTHIS_INTERVIEW_DATE() {
        return THIS_INTERVIEW_DATE;
    }

    public void setTHIS_INTERVIEW_DATE(Date THIS_INTERVIEW_DATE) {
        this.THIS_INTERVIEW_DATE = THIS_INTERVIEW_DATE;
    }

    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+08:00")
    public Date getNEXT_VISITING_DATE() {
        return NEXT_VISITING_DATE;
    }

    public void setNEXT_VISITING_DATE(Date NEXT_VISITING_DATE) {
        this.NEXT_VISITING_DATE = NEXT_VISITING_DATE;
    }

    public String getNEXT_VISITING_ADDRESS() {
        return NEXT_VISITING_ADDRESS;
    }

    public void setNEXT_VISITING_ADDRESS(String NEXT_VISITING_ADDRESS) {
        this.NEXT_VISITING_ADDRESS = NEXT_VISITING_ADDRESS;
    }

    public String getVISITING_DOCTOR() {
        return VISITING_DOCTOR;
    }

    public void setVISITING_DOCTOR(String VISITING_DOCTOR) {
        this.VISITING_DOCTOR = VISITING_DOCTOR;
    }

    public String getFAMILY_SIGN() {
        return FAMILY_SIGN;
    }

    public void setFAMILY_SIGN(String FAMILY_SIGN) {
        this.FAMILY_SIGN = FAMILY_SIGN;
    }

    public String getORG_ID() {
        return ORG_ID;
    }

    public void setORG_ID(String ORG_ID) {
        this.ORG_ID = ORG_ID;
    }

    public String getPHYSICLAL_STATUS() {
        return PHYSICLAL_STATUS;
    }

    public void setPHYSICLAL_STATUS(String PHYSICLAL_STATUS) {
        this.PHYSICLAL_STATUS = PHYSICLAL_STATUS;
    }

    public String getIDENTITY_CARD_NO() {
        return IDENTITY_CARD_NO;
    }

    public void setIDENTITY_CARD_NO(String IDENTITY_CARD_NO) {
        this.IDENTITY_CARD_NO = IDENTITY_CARD_NO;
    }

    public Integer getIS_CHILD_WEAK() {
        return IS_CHILD_WEAK;
    }

    public void setIS_CHILD_WEAK(Integer IS_CHILD_WEAK) {
        this.IS_CHILD_WEAK = IS_CHILD_WEAK;
    }
}
