package com.yihu.rehabilitation.vo.entity;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.searchbox.annotations.JestId;
import org.springframework.data.annotation.CreatedDate;

import java.util.Date;

/**
 * 产后访视记录表
 * create by hmf on 2019/4/17
 */
public class PostpartumVisitRecordES {
    @JestId
    private String id;
    private String followup_id;             //随访记录ID
    private String followup_project;        //随访详情分类ID
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyyMMdd'T'HHmmss.SSS'Z'")
    @CreatedDate
    private Date create_time;
    private String create_user;
    private String create_user_name;
    private String version;//版本号

    private String name;//产妇姓名
    private String number;//编号
    private Date followup_date;//随访日期
    private Date parturition_date;//分娩日期
    private Date discharged_date;//出院日期
    private Double body_temperature;//体温
    private String healthy_condition;//一般健康情况
    private String psychologic_status;//一般心理状况
    private Integer blood_pressure_low;//血压低值
    private Integer blood_pressure_high;//血压高值
    private Integer breast_status;//乳房(1未见异常 2异常)
    private Integer lochia_status;//恶露(1未见异常 2异常)
    private Integer uterus_status;//子宫(1未见异常 2异常)
    private Integer wound_status;//伤口(1未见异常 2异常)
    private String other;//其他
    private Integer category;//分类(1未见异常 2异常)

    /******** 指导 ********/
    private Integer personal_hygiene ;//个人卫生【1有，0无】
    private Integer mentality;//心理指导【1有，0无】
    private Integer nutrition;//营养指导【1有，0无】
    private Integer breast_feeding;//母乳喂养指导【1是，0否】
    private Integer newborn_care_and_feeding;//新生儿护理与喂养指导【1有，0无】
    private Integer other_guide;//是否有其他指导【1有，0无】
    private String other_guide_content;//其他指导内容

    /******** 转诊 ********/
    private Integer REFERRAL;//转诊建议（1有，0无）
    private String REFERRAL_REASON;//转诊建议（原因）

    private String ORGANIZATION_ORG;//转诊机构(智业机构code)
    private String ORGANIZATION_ORG_NAME;//转诊机构名称
    private String ORGANIZATION_HOSPITAL;//转诊机构code(dm_hospital表的code)
    private String ORGANIZATION;//转诊科室

    private Date next_visiting_date;//下次随访日期
    private String visiting_doctor_name;//随访医生名称
    private String visiting_doctor_code;//随访医生code

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getFollowup_id() {
        return followup_id;
    }

    public void setFollowup_id(String followup_id) {
        this.followup_id = followup_id;
    }

    public String getFollowup_project() {
        return followup_project;
    }

    public void setFollowup_project(String followup_project) {
        this.followup_project = followup_project;
    }

    public Date getCreate_time() {
        return create_time;
    }

    public void setCreate_time(Date create_time) {
        this.create_time = create_time;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    public String getNumber() {
        return number;
    }

    public void setNumber(String number) {
        this.number = number;
    }

    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+08:00")
    public Date getFollowup_date() {
        return followup_date;
    }

    public void setFollowup_date(Date followup_date) {
        this.followup_date = followup_date;
    }

    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+08:00")
    public Date getParturition_date() {
        return parturition_date;
    }

    public void setParturition_date(Date parturition_date) {
        this.parturition_date = parturition_date;
    }

    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+08:00")
    public Date getDischarged_date() {
        return discharged_date;
    }

    public void setDischarged_date(Date discharged_date) {
        this.discharged_date = discharged_date;
    }

    public Double getBody_temperature() {
        return body_temperature;
    }

    public void setBody_temperature(Double body_temperature) {
        this.body_temperature = body_temperature;
    }

    public String getHealthy_condition() {
        return healthy_condition;
    }

    public void setHealthy_condition(String healthy_condition) {
        this.healthy_condition = healthy_condition;
    }

    public String getPsychologic_status() {
        return psychologic_status;
    }

    public void setPsychologic_status(String psychologic_status) {
        this.psychologic_status = psychologic_status;
    }

    public Integer getBlood_pressure_low() {
        return blood_pressure_low;
    }

    public void setBlood_pressure_low(Integer blood_pressure_low) {
        this.blood_pressure_low = blood_pressure_low;
    }

    public Integer getBlood_pressure_high() {
        return blood_pressure_high;
    }

    public void setBlood_pressure_high(Integer blood_pressure_high) {
        this.blood_pressure_high = blood_pressure_high;
    }

    public Integer getBreast_status() {
        return breast_status;
    }

    public void setBreast_status(Integer breast_status) {
        this.breast_status = breast_status;
    }

    public Integer getLochia_status() {
        return lochia_status;
    }

    public void setLochia_status(Integer lochia_status) {
        this.lochia_status = lochia_status;
    }

    public Integer getUterus_status() {
        return uterus_status;
    }

    public void setUterus_status(Integer uterus_status) {
        this.uterus_status = uterus_status;
    }

    public Integer getWound_status() {
        return wound_status;
    }

    public void setWound_status(Integer wound_status) {
        this.wound_status = wound_status;
    }

    public String getOther() {
        return other;
    }

    public void setOther(String other) {
        this.other = other;
    }

    public Integer getCategory() {
        return category;
    }

    public void setCategory(Integer category) {
        this.category = category;
    }

    public Integer getPersonal_hygiene() {
        return personal_hygiene;
    }

    public void setPersonal_hygiene(Integer personal_hygiene) {
        this.personal_hygiene = personal_hygiene;
    }

    public Integer getMentality() {
        return mentality;
    }

    public void setMentality(Integer mentality) {
        this.mentality = mentality;
    }

    public Integer getNutrition() {
        return nutrition;
    }

    public void setNutrition(Integer nutrition) {
        this.nutrition = nutrition;
    }

    public Integer getBreast_feeding() {
        return breast_feeding;
    }

    public void setBreast_feeding(Integer breast_feeding) {
        this.breast_feeding = breast_feeding;
    }

    public Integer getNewborn_care_and_feeding() {
        return newborn_care_and_feeding;
    }

    public void setNewborn_care_and_feeding(Integer newborn_care_and_feeding) {
        this.newborn_care_and_feeding = newborn_care_and_feeding;
    }

    public Integer getOther_guide() {
        return other_guide;
    }

    public void setOther_guide(Integer other_guide) {
        this.other_guide = other_guide;
    }

    public String getOther_guide_content() {
        return other_guide_content;
    }

    public void setOther_guide_content(String other_guide_content) {
        this.other_guide_content = other_guide_content;
    }

    public Integer getREFERRAL() {
        return REFERRAL;
    }

    public void setREFERRAL(Integer REFERRAL) {
        this.REFERRAL = REFERRAL;
    }

    public String getREFERRAL_REASON() {
        return REFERRAL_REASON;
    }

    public void setREFERRAL_REASON(String REFERRAL_REASON) {
        this.REFERRAL_REASON = REFERRAL_REASON;
    }

    public String getORGANIZATION_ORG() {
        return ORGANIZATION_ORG;
    }

    public void setORGANIZATION_ORG(String ORGANIZATION_ORG) {
        this.ORGANIZATION_ORG = ORGANIZATION_ORG;
    }

    public String getORGANIZATION_ORG_NAME() {
        return ORGANIZATION_ORG_NAME;
    }

    public void setORGANIZATION_ORG_NAME(String ORGANIZATION_ORG_NAME) {
        this.ORGANIZATION_ORG_NAME = ORGANIZATION_ORG_NAME;
    }

    public String getORGANIZATION_HOSPITAL() {
        return ORGANIZATION_HOSPITAL;
    }

    public void setORGANIZATION_HOSPITAL(String ORGANIZATION_HOSPITAL) {
        this.ORGANIZATION_HOSPITAL = ORGANIZATION_HOSPITAL;
    }

    public String getORGANIZATION() {
        return ORGANIZATION;
    }

    public void setORGANIZATION(String ORGANIZATION) {
        this.ORGANIZATION = ORGANIZATION;
    }

    @JsonFormat(pattern = "yyyy-MM-dd", timezone = "GMT+08:00")
    public Date getNext_visiting_date() {
        return next_visiting_date;
    }

    public void setNext_visiting_date(Date next_visiting_date) {
        this.next_visiting_date = next_visiting_date;
    }

    public String getVisiting_doctor_name() {
        return visiting_doctor_name;
    }

    public void setVisiting_doctor_name(String visiting_doctor_name) {
        this.visiting_doctor_name = visiting_doctor_name;
    }

    public String getVisiting_doctor_code() {
        return visiting_doctor_code;
    }

    public void setVisiting_doctor_code(String visiting_doctor_code) {
        this.visiting_doctor_code = visiting_doctor_code;
    }

    public String getCreate_user() {
        return create_user;
    }

    public void setCreate_user(String create_user) {
        this.create_user = create_user;
    }

    public String getCreate_user_name() {
        return create_user_name;
    }

    public void setCreate_user_name(String create_user_name) {
        this.create_user_name = create_user_name;
    }

    public String getVersion() {
        return version;
    }

    public void setVersion(String version) {
        this.version = version;
    }
}
