package com.yihu.jw.standard.feignclient;


import com.yihu.jw.constants.ApiVersion;
import com.yihu.jw.constants.MicroServices;
import com.yihu.jw.constants.ServiceApi;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import springfox.documentation.annotations.ApiIgnore;

import java.util.Map;

/**
 * Created by AndyCai on 2016/3/3.
 */
@FeignClient(name = MicroServices.Adaption)
@ApiIgnore
public interface StandardDispatchClient {

    @RequestMapping(value = ApiVersion.Version1_0+ ServiceApi.Standards.Dispatches, method = RequestMethod.POST)
    @ApiOperation(value = "生成适配方案摘要", produces = "application/json", notes = "")
    Map createSchemeInfo(
            @ApiParam(required = true, name = "version", value = "要生成的目标版本")
            @RequestParam(value = "version", required = true) String version) throws Exception;
}
