package com.yihu.jw.statistics.job.business;


import com.yihu.jw.statistics.service.JobService;
import com.yihu.jw.statistics.util.DateUtil;
import org.quartz.DisallowConcurrentExecution;
import org.quartz.Job;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;



/**
 * 排班统计
 * Created by Reece on 2017/8/29/029.
 */
@DisallowConcurrentExecution//解决执行频率和间隔时间的问题。到了执行时间点前一任务还在执行中，不会执行下一次任务，直至该次任务完成
public class ScheduleStatictisJob implements Job {

    private static final Logger logger = LoggerFactory.getLogger(ScheduleStatictisJob.class);
    @Autowired
    private JobService jobService;


    @Override
    public void execute(JobExecutionContext context) throws JobExecutionException {
        logger.info("ScheduleStatictisJob start ..........");
        try {
            String startDate = DateUtil.getStringDate("yyyy-MM-dd");
            String endTime = DateUtil.getNextDay(startDate,10);
            jobService.productDataByDayToDayAndIdNoSleep(startDate,endTime,"10",0L);
            logger.info("ScheduleStatictisJob end ..........");
        } catch (Exception e) {
            e.printStackTrace();
            logger.info("ScheduleStatictisJob error ..........,message:" + e.getMessage());
        }
    }

}
