
package com.yihu.jw.hospital.module.consult.service;

import com.yihu.jw.doctor.dao.BaseDoctorDao;
import com.yihu.jw.entity.base.im.ConsultDo;
import com.yihu.jw.im.dao.ConsultTeamDao;
import com.yihu.jw.im.util.ImUtil;
import com.yihu.jw.order.dao.ConsultOrderDao;
import com.yihu.jw.util.http.HttpClientUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Component;
import org.springframework.transaction.annotation.Transactional;

import java.util.Date;

@Component
@Transactional
public class ConsultService {


    @Autowired
    public ConsultOrderDao consultDao;

    //    @Autowired
//    public BasePatientDao patientDao;
    @Autowired
    public BaseDoctorDao doctorDao;
    @Autowired
    public ConsultTeamDao consultTeamDao;
    @Autowired
    private ImUtil imUtill;

    //    @Value("${hlwyy.url}")
//    private String hlwyyUrl;
//    @Value("${im.data_base_name}")
////    private String ImDbName;
    @Autowired
    private HttpClientUtil httpClientUtil;

    @Autowired
    private JdbcTemplate jdbcTemplate;


//    @Autowired
//    public ConsultMoViDao consultMoViDao;
//    @Autowired
//    public ConsultPublicDao consultPublicDao;
//    @Autowired
//    public ConsultPublicReplyDao consultPublicReplyDao;
//    @Autowired
//    public ConsultCommunicationDao consultCommunicationDao;
//    @Autowired
//    public ConsultCommunicationReplyDao consultCommunicationReplyDao;
//    @Autowired
//    private SignFamilyDao signFamilyDao;
//    @Autowired
//    private PatientService patientService;


    /**
     * 添加一条咨询记录
     *
     * @param patient 患者信息
     * @param title   咨询标题
     * @param type    咨询类型：1三师咨询，2视频咨询，3图文咨询，4公共咨询，5病友圈，9在线复诊，11上门服务
     * @return
     */
    public ConsultDo addConsult(
            String patient, String title, String symptoms, String images, int type
    ) throws Exception {
        ConsultDo consult = new ConsultDo();
//        consult.setCode(UUID.randomUUID().toString().replaceAll("-", ""));//UUID
        consult.setCzrq(new Date());
        consult.setDel("1");
        consult.setPatient(patient);
        consult.setTitle(title);
        consult.setSymptoms(symptoms);
        consult.setImages(images);
        consult.setType(type);
        return consultDao.save(consult);
    }

    /**
     * 查询患者所有的咨询记录
     *
     * @param patient  患者标识
     * @param id
     * @param pagesize 分页大小
     * @return
     */
//    public Page<Object> findConsultRecordByPatient(String patient, long id, int pagesize, String title) {
//        if (id < 0) {
//            id = 0;
//        }
//        if (pagesize <= 0) {
//            pagesize = 10;
//        }
//        // 排序
//        Sort sort = new Sort(Direction.DESC, "id");
//        // 分页信息
//        PageRequest pageRequest = new PageRequest(0, pagesize, sort);
//        if (!StringUtils.isEmpty(title)) {
//            title = "%" + title + "%";
//            if (id > 0) {
//                return consultDao.findByPatient(patient, title, id, pageRequest);
//            } else {
//                return consultDao.findByPatient(patient, title, pageRequest);
//            }
//        } else {
//            if (id > 0) {
//                return consultDao.findByPatient(patient, id, pageRequest);
//            } else {
//                return consultDao.findByPatient(patient, pageRequest);
//            }
//        }
//    }

    /**
     * 按类型查找居民的咨询记录
     *
     * @return
     */
//    public Page<Object> findConsultRecordByType(String patient, long id, int pagesize, Integer type, String title) {
//        if (id < 0) {
//            id = 0;
//        }
//        if (pagesize <= 0) {
//            pagesize = 10;
//        }
//        // 排序
//        Sort sort = new Sort(Direction.DESC, "id");
//        // 分页信息
//        PageRequest pageRequest = new PageRequest((int) id, pagesize, sort);
//        if (!StringUtils.isEmpty(title)) {
//            title = "%" + title + "%";
//            return consultDao.findByPatientAndType(patient, title, type, pageRequest);
//        } else {
//            return consultDao.findByPatientAndType(patient, type, pageRequest);
//        }
//
//    }

//    public Consult findOneConsult(String consult) {
//        return consultDao.findByCode(consult);
//    }


//    public void sendMucMessageBySingnType(String doctor, String doctorName, String patient, String content, String contentType, String title) {
//        Doctor d = doctorDao.findByCode(doctor);
//        SignFamily signFamily = signFamilyDao.findByPatient(patient);//当前签约团队
//        if (signFamily == null) {
//            List<SignFamily> signFamilys = signFamilyDao.findLastJySignByPatient(patient, 2);//获取旧的家庭签约关系
//            if (signFamilys != null && signFamilys.size() > 0) {
//                signFamily = signFamilys.get(0);
//            }
//        }
//        if (signFamily != null) {
//            new SendPatientUtil(doctor, doctorName, patient, contentType, content, title, signFamily.getType() + "", signFamily.getTeamCode(), imUtill).start();
//        } else {
//            throw new RuntimeException("无法找到签约关系！");
//        }
//    }

//    public JSONArray getDoctorConsultSessions(String user_id, String business_type, String status, String page, String size) {
//        BaseDoctorDODO doctor = doctorDao.findById(user_id).orElse(null);user_id);
//        String zbDoctorId = "";
//        if (doctor == null) {
//            return new JSONArray();
//        } else {
//            try {
//                String url = hlwyyUrl + "/open/noLogin/findDoctorByIdCard";
//                Map map = new HashMap<String, String>();
//                map.put("idCard", doctor.getIdcard());
//                String content = com.alibaba.fastjson.JSONObject.toJSONString(map);
//                String params = AesEncryptUtils.encrypt1(content);
//                String response = httpClientUtil.getBodyRawForm(url, params);
//                com.alibaba.fastjson.JSONObject resultObject = com.alibaba.fastjson.JSONObject.parseObject(response);
//                if (resultObject.get("status").equals("200")) {
//                    com.alibaba.fastjson.JSONObject jsonObjectData = com.alibaba.fastjson.JSONObject.parseObject(AesEncryptUtils.decrypt1(resultObject.get("data").toString()));
//                    if (jsonObjectData.getJSONObject("obj") != null) {
//                        zbDoctorId = jsonObjectData.getJSONObject("obj").getString("id");
//                    }
//                }
//            } catch (RuntimeException se) {
//                se.printStackTrace();
//            } catch (Exception e) {
//                e.printStackTrace();
//            }
//        }
//        List<JSONObject> result = new ArrayList<>();
//        JSONArray patientConsult = imUtill.getSessions(user_id, business_type, status, "0", "9999");
//        for (int i = 0; i < patientConsult.length(); i++) {
//            JSONObject tmp = patientConsult.getJSONObject(i);
//            tmp.put("dataFrom", "wlyy");
//            result.add(tmp);
//        }
//        //获取专家咨询数据
//        if ("1".equals(status) && org.apache.commons.lang3.StringUtils.isNotBlank(zbDoctorId)) {//历史咨询 hlwyy
//            try {
//                String urlTmp;
//                if (hlwyyUrl.equals("http://192.168.120.210:9660/hospital")) {
//                    urlTmp = "http://192.168.120.32:16000/";
//                } else {
//                    urlTmp = "http://172.26.0.105:3000/";
//                }
//
//                String url = urlTmp + "api/v2/sessions/sessionListByType?user_id=" + zbDoctorId + "&page=1&size=9999&business_type=2&type=1";
//                String response = httpClientUtil.get(url, "UTF-8");
//                com.alibaba.fastjson.JSONArray resultObject = com.alibaba.fastjson.JSONArray.parseArray(response);
//                int arrLength = resultObject.size();
//                for (int i = 0; i < arrLength; i++) {
//                    com.alibaba.fastjson.JSONObject jsonObject = resultObject.getJSONObject(i);
//                    jsonObject.put("dataFrom", "hlwyy");
//                    String sessionIdTmp = jsonObject.getString("id");
//                    url = urlTmp + "api/v2/sessions/" + sessionIdTmp + "/participants/avatars";
//                    response = httpClientUtil.get(url, "UTF-8");
//                    jsonObject.put("hlwyy_user_avatars", response);
//                    String tmp = JSON.toJSONString(jsonObject);
//                    result.add(new JSONObject(tmp));
//                }
//            } catch (Exception e) {
//                e.printStackTrace();
//            }
//        }
//        if ("0".equals(status) && org.apache.commons.lang3.StringUtils.isNotBlank(zbDoctorId)) {//进行中咨询
//            try {
//                String urlTmp;
//                if (hlwyyUrl.equals("http://192.168.120.210:9660/hospital")) {
//                    urlTmp = "http://192.168.120.32:16000/";
//                } else {
//                    urlTmp = "http://172.26.0.105:3000/";
//                }
//
//                String url = urlTmp + "api/v2/sessions/sessionListByType?user_id=" + zbDoctorId + "&page=1&size=9999&business_type=2&status=0&type=1";
//                String response = httpClientUtil.get(url, "UTF-8");
//                com.alibaba.fastjson.JSONArray resultObject = com.alibaba.fastjson.JSONArray.parseArray(response);
//                int arrLength = resultObject.size();
//                for (int i = 0; i < arrLength; i++) {
//                    com.alibaba.fastjson.JSONObject jsonObject = resultObject.getJSONObject(i);
//                    jsonObject.put("dataFrom", "hlwyy");
//                    String sessionIdTmp = jsonObject.getString("id");
//                    url = urlTmp + "api/v2/sessions/" + sessionIdTmp + "/participants/avatars";
//                    response = httpClientUtil.get(url, "UTF-8");
//                    jsonObject.put("hlwyy_user_avatars", response);
//                    String tmp = JSON.toJSONString(jsonObject);
//                    result.add(new JSONObject(tmp));
//                }
//            } catch (Exception e) {
//                e.printStackTrace();
//            }
//        }
//        //咨询历史未读消息数量统计
//        Collections.sort(result, new Comparator<JSONObject>() {
//            public int compare(JSONObject o1, JSONObject o2) {
//                Long map1value = Long.parseLong(o1.get("create_date").toString());
//                Long map2value = Long.parseLong(o2.get("create_date").toString());
//                Long unRead1 = Long.parseLong(o1.get("unread_count").toString());
//                Long unRead2 = Long.parseLong(o2.get("unread_count").toString());
//                if (unRead1 != 0 || unRead2 != 0) {//未读排前面，再根据时间排序
//                    if (unRead1 != 0 && unRead2 != 0) {
//                        if (map1value - map2value > 0) {
//                            return -1;
//                        } else if (map1value - map2value < 0) {
//                            return 1;
//                        } else {
//                            return 0;
//                        }
//                    } else {
//                        if (unRead1 - unRead2 > 0) {
//                            return -1;
//                        } else if (unRead1 - unRead2 < 0) {
//                            return 1;
//                        } else {
//                            return 0;
//                        }
//                    }
//                } else {
//                    if (map1value - map2value > 0) {
//                        return -1;
//                    } else if (map1value - map2value < 0) {
//                        return 1;
//                    } else {
//                        return 0;
//                    }
//                }
//            }
//        });
//
//        Integer count = result.size();
//        Integer pageTmp = Integer.parseInt(page);
//        Integer sizeTmp = Integer.parseInt(size);
//        if (pageTmp == 0) {
//            pageTmp += 1;
//        }
//        if (count > 0) {
//            Integer pageCount = 0;
//            if (count % sizeTmp == 0) {
//                pageCount = count / sizeTmp;
//            } else {
//                pageCount = count / sizeTmp + 1;
//            }
//            int fromIndex = 0;
//            int toIndex = 0;
//            if (pageTmp != pageCount) {
//                fromIndex = (pageTmp - 1) * sizeTmp;
//                toIndex = fromIndex + sizeTmp;
//            } else {
//                fromIndex = (pageTmp - 1) * sizeTmp;
//                toIndex = count;
//            }
//            if (fromIndex < 0) {
//                fromIndex = 0;
//            }
//            if (toIndex > count) {
//                toIndex = count;
//            }
//            ;
//            return new JSONArray(result.subList(fromIndex, toIndex));
//        }
//        return new JSONArray();
//    }

//    public JSONArray getIMkangFuConsultSessions(String user_id, String type, String status, String page, String size, String name) {
//        List<JSONObject> result = new ArrayList<>();
//        JSONArray patientConsult = imUtill.getSessionListByType(user_id, page, size, type, status, name);
//
//        return patientConsult;
//    }

//    public JSONObject getSpecialAndKangFuConsultUnreadInfo(String user_id) {
//        JSONObject result = new JSONObject();
//        try {
//            BaseDoctorDO doctor = doctorDao.findById(user_id).orElse(null));
//
//            JSONObject specialistObj = new JSONObject();
//            JSONObject kangfuObj = new JSONObject();
//            kangfuObj.put("unReplyCount", 0);
//            kangfuObj.put("UnreadMessageCount", 0);
//            specialistObj.put("zjCount", 0);
//            specialistObj.put("zjUnreadMessageCount", 0);
//            if (doctor != null) {
//                String url = hlwyyUrl + "/open/noLogin/doctorReviewConsultCount";
//                Map map = new HashMap<String, String>();
//                map.put("doctorIdcard", doctor.getIdcard());
//                String content = com.alibaba.fastjson.JSONObject.toJSONString(map);
//                String params = AesEncryptUtils.encrypt1(content);
//                String response = httpClientUtil.getBodyRawForm(url, params);
//
//                com.alibaba.fastjson.JSONObject json = com.alibaba.fastjson.JSONObject.parseObject(response);
//                if (json != null && json.getInteger("status") == 200) {
//                    com.alibaba.fastjson.JSONObject jsonTmp = com.alibaba.fastjson.JSONObject.parseObject(AesEncryptUtils.decrypt1(json.getString("data")));
//                    if (jsonTmp.getInteger("status") == 200) {
//                        com.alibaba.fastjson.JSONObject tmp = jsonTmp.getJSONObject("obj");
//                        specialistObj.put("zjCount", tmp.getInteger("imgConsultCount") + specialistObj.getInt("zjCount"));
//                        specialistObj.put("zjUnreadMessageCount", tmp.getInteger("zjUnreadMessageCount") + specialistObj.getInt("zjUnreadMessageCount"));
//                    }
//                }
//                result.put("specialist", specialistObj);
//                //康复未回复
//                String sql = "SELECT count(t.id) count FROM " + ImDbName + ".topics t," + ImDbName + ".participants p," + ImDbName + ".doctors d," + ImDbName + ".wlyy_consults c," +
//                        ImDbName + ".patients s WHERE d.id = p.participant_id AND c.id = t.id AND c.patient = s.id AND p.session_id = t.session_id AND d.id in ('" + user_id + "') AND t. STATUS =0 and t.reply=0 AND c.type = 18 ";
//                Integer notReplayCount = jdbcTemplate.queryForObject(sql, Integer.class);
//                kangfuObj.put("unReplyCount", notReplayCount + kangfuObj.getInt("unReplyCount"));
//                //康复未读
//                org.json.JSONObject jsonObject = imUtill.getSessionUnreadMessageCountByType(user_id, "18", "");
//                kangfuObj.put("UnreadMessageCount", jsonObject.getInt("count") + kangfuObj.getInt("UnreadMessageCount"));
//                result.put("kangfuConsult", kangfuObj);
//                return result;
//            }
//            return null;
//        } catch (RuntimeException se) {
//            se.printStackTrace();
//            return null;
//        } catch (Exception e) {
//            e.printStackTrace();
//            return null;
//        }
//    }
}
