//package com.yihu.jw.hospital.module.door.service;
//
//
//import jxl.Workbook;
//import jxl.format.UnderlineStyle;
//import jxl.write.*;
//import org.apache.commons.lang3.StringUtils;
//import org.json.JSONArray;
//import org.json.JSONObject;
//import org.springframework.beans.factory.annotation.Autowired;
//import org.springframework.beans.factory.annotation.Value;
//import org.springframework.jdbc.core.JdbcTemplate;
//import org.springframework.stereotype.Service;
//
//import javax.servlet.http.HttpServletResponse;
//import java.io.IOException;
//import java.io.OutputStream;
//import java.math.BigDecimal;
//import java.text.DecimalFormat;
//import java.text.SimpleDateFormat;
//import java.util.*;
//import java.util.stream.Collectors;
//
///**
// * @author liuwenbin on 2019/3/21.
// */
//@Service
//public class DoorStatisticAnalyzeService extends BaseService {
//    @Autowired
//    private ElasticsearchUtil elasticsearchUtil;
//    @Value("${es.type.Statistics}")
//    private String esType;
//    @Value("${es.index.Statistics}")
//    private String esIndex;
//    @Autowired
//    private TownDao townDao;
//    @Autowired
//    private HospitalDao hospitalDao;
//    @Autowired
//    DoctorAdminTeamDao adminTeamDao;
//    @Autowired
//    private JdbcTemplate jdbcTemplate;
//    @Autowired
//    private StatisticsAllService statisticsAllService;
//    @Autowired
//    private StatisticsESService statisticsESService;
//    @Autowired
//    private DoctorDao doctorDao;
//    @Autowired
//    private StatisticsUtilService statisticsUtilService;
//
//    public List<Map<String,Object>> doorQualificationAnalyzeList(String area,String startDate,String endDate,Integer level,String lowLevel)throws Exception{
//        List<Map<String, Object>> resultList = new ArrayList<>();
//        if(StringUtils.isNotEmpty(lowLevel)){
//            lowLevel = elasticsearchUtil.changeLevel(Integer.parseInt(lowLevel))+"";
//        }else{
//            lowLevel = String.valueOf(level + 1);
//        }
//        List<SaveModel> esModelList = findDateQuotaLevel1(startDate, endDate, area, level, "120", "1", lowLevel, null);
//        Map<String, List<SaveModel>> map = null;
//
//        if (esModelList != null && esModelList.size() > 0) {
//            if (lowLevel.equals("3")) {
//                map = esModelList.stream().collect(Collectors.groupingBy(SaveModel::getTown));
//            } else if (lowLevel.equals("4")) {
//                map = esModelList.stream().collect(Collectors.groupingBy(SaveModel::getHospital));
//            } else if (lowLevel.equals("5")) {
//                map = esModelList.stream().collect(Collectors.groupingBy(SaveModel::getTeam));
//            }
//            for (String one1 : map.keySet()) {
//                Map<String, Object> resultMap = new HashMap();
//                List<SaveModel> list1 = map.get(one1);
//                resultMap.put("code", one1);
//                if (lowLevel.equals("3")) {
//                    resultMap.put("name", list1.get(0).getTownName());
//                } else if (lowLevel.equals("4")) {
//                    resultMap.put("name", list1.get(0).getHospitalName());
//                } else if (lowLevel.equals("5")) {
//                    Doctor doctor = doctorDao.findByAdminTeamId(Long.parseLong(list1.get(0).getTeam()));
//                    if (doctor!=null){
//                        resultMap.put("name", doctor.getName());
//                    }else {
//                        resultMap.put("name", null);
//                    }
//                }
//                Map<String, List<SaveModel>> map2 = list1.stream().collect(Collectors.groupingBy(SaveModel::getSlaveKey1));
//                //0、审核中，1、未通过，2、已通过
//                resultMap.put("examine", map2.get("0").get(0).getResult2().intValue());
//                resultMap.put("nopass", map2.get("1").get(0).getResult2().intValue());
//                resultMap.put("pass", map2.get("2").get(0).getResult2().intValue());
//                resultMap.put("all", (Integer) resultMap.get("examine") + (Integer) resultMap.get("nopass") + (Integer) resultMap.get("pass"));
//                resultList.add(resultMap);
//            }
//
//            resultList.sort(new Comparator<Map<String, Object>>() {
//                @Override
//                public int compare(Map<String, Object> o1, Map<String, Object> o2) {
//                    if ( (Integer) o1.get("all") > (Integer) o2.get("all")) {
//                        return -1;
//                    } else if ((Integer) o1.get("all") < (Integer) o2.get("all")) {
//                        return 1;
//                    } else {
//                        return 0;
//                    }
//                }
//            });
//        }
//
//        return resultList;
//    }
//
//    public Map<String,Object> doorQualificationAnalyzeHead(String area,String startDate,String endDate,Integer level)throws Exception{
//        Map<String, Object> resultMap = new HashMap();
//        String low_level = String.valueOf(level + 1);
//        List<SaveModel> esModelList = findDateQuotaLevel1(startDate, endDate, area, level, "120", "1", low_level, null);
//
//        if (esModelList != null && esModelList.size() > 0) {
//            Map<String, List<SaveModel>> map = esModelList.stream().collect(Collectors.groupingBy(SaveModel::getSlaveKey1));
//            resultMap.put("examine", map.get("0").get(0).getResult2().intValue());
//            resultMap.put("nopass", map.get("1").get(0).getResult2().intValue());
//            resultMap.put("pass", map.get("2").get(0).getResult2().intValue());
//            resultMap.put("all", (Integer) resultMap.get("examine") + (Integer) resultMap.get("nopass") + (Integer) resultMap.get("pass"));
//        }
//
//        return resultMap;
//    }
//
//
//    /**
//     * 资质分析
//     * @param area
//     * @param startDate
//     * @param endDate
//     * @throws Exception
//     */
//    public List<Map<String,Object>> doorQualificationAnalyze(String area,String startDate,String endDate)throws Exception{
//
//        List<Town> areaCode = new ArrayList<>();
//        if(StringUtils.isEmpty(area)){
//            areaCode = townDao.findByCityCode("350200");
//        }else{
//            areaCode.add(townDao.findByCode(area));
//        }
//        List<Map<String,Object>> result = new ArrayList<>();
//        for(Town one:areaCode) {
//            List<SaveModel> townList = findDateQuotaLevel1(startDate, endDate, one.getCode(), 3, "120", "1", null, null);//区
//            List<SaveModel> orgList = findDateQuotaLevel1(startDate, endDate, one.getCode(), 3, "120", "1", "4", null);//区
//
//            Map<String, List<SaveModel>> map = townList.stream().collect(Collectors.groupingBy(SaveModel::getSlaveKey1));
//            Map<String, List<SaveModel>> map1 = orgList.stream().collect(Collectors.groupingBy(SaveModel::getHospital));
//
//            Map<String, Object> parentResultMap = new HashMap<>();
//            parentResultMap.put("level", 1);
//            parentResultMap.put("area", one.getName());
//            parentResultMap.put("examine", map.get("0").get(0).getResult2().intValue());
//            parentResultMap.put("nopass", map.get("1").get(0).getResult2().intValue());
//            parentResultMap.put("pass", map.get("2").get(0).getResult2().intValue());
//            parentResultMap.put("all", (Integer) parentResultMap.get("examine") + (Integer) parentResultMap.get("nopass") + (Integer) parentResultMap.get("pass"));
//
//            List<Map<String, Object>> childrenResultList = new LinkedList<>();
//            for (String one1 : map1.keySet()) {
//                Map<String, Object> childrenResultMap = new HashMap();
//                List<SaveModel> list1 = map1.get(one1);//机构
//                childrenResultMap.put("level", 2);
//                childrenResultMap.put("area", hospitalDao.findByCode(one1).getName());
//                Map<String, List<SaveModel>> map2 = list1.stream().collect(Collectors.groupingBy(SaveModel::getSlaveKey1));
//                //0、审核中，1、未通过，2、已通过
//                childrenResultMap.put("examine", map2.get("0").get(0).getResult2().intValue());
//                childrenResultMap.put("nopass", map2.get("1").get(0).getResult2().intValue());
//                childrenResultMap.put("pass", map2.get("2").get(0).getResult2().intValue());
//                childrenResultMap.put("all", (Integer) childrenResultMap.get("examine") + (Integer) childrenResultMap.get("nopass") + (Integer) childrenResultMap.get("pass"));
//                childrenResultList.add(childrenResultMap);
//            }
//            parentResultMap.put("children", childrenResultList);
//            result.add(parentResultMap);
//        }
//        return result;
//    }
//
//    /**
//     * 服务工单分析
//     * @param area
//     * @param startDate
//     * @param endDate
//     * @throws Exception
//     */
//    public List<Map<String,Object>> doorServiceOrderAnalyze(String area,String startDate,String endDate, Integer type)throws Exception{
//        DecimalFormat df = new DecimalFormat("0.00");
//        List<Town> areaCode = new ArrayList<>();
//        if(StringUtils.isEmpty(area)){
//            areaCode = townDao.findByCityCode("350200");
//        }else{
//            areaCode.add(townDao.findByCode(area));
//        }
//        List<Map<String,Object>> result = new ArrayList<>();
//        for(Town one:areaCode) {
//            List<SaveModel> townList = findDateQuotaLevel1(startDate, endDate, one.getCode(), 3, "121", "1", null, type);//区
//            List<SaveModel> orgList = findDateQuotaLevel1(startDate, endDate, one.getCode(), 3, "121", "1", "4", type);//机构
//
//            Map<String, List<SaveModel>> map = townList.stream().collect(Collectors.groupingBy(SaveModel::getSlaveKey1));
//            Map<String, List<SaveModel>> map1 = orgList.stream().collect(Collectors.groupingBy(SaveModel::getHospital));
//
//            Map<String, Object> parentResultMap = new HashMap<>();
//            parentResultMap.put("level", 1);
//            parentResultMap.put("area", one.getName());
//            parentResultMap.put("cancelled", map.get("-1").get(0).getResult2().intValue());
//            parentResultMap.put("waitinglist", map.get("1").get(0).getResult2().intValue());
//            parentResultMap.put("waitingorder", map.get("2").get(0).getResult2().intValue());
//            parentResultMap.put("waitingservice", map.get("3").get(0).getResult2().intValue());
//            parentResultMap.put("waitingpay", map.get("4").get(0).getResult2().intValue());
//            parentResultMap.put("waitingcomment", map.get("5").get(0).getResult2().intValue());
//            parentResultMap.put("completed", map.get("6").get(0).getResult2().intValue());
//            /*Double parentResult1= 0.0;
//            Double parentResult2 = 0.0;
//            for(SaveModel saveModel:townList){
//                parentResult1 +=saveModel.getResult1();
//                parentResult2 +=saveModel.getResult2();
//            }
//            BigDecimal decimalParent1 = new BigDecimal(Double.toString(parentResult1));
//            BigDecimal decimalParent2 = new BigDecimal(Double.toString(parentResult2));
//
//            BigDecimal evaluateSplitParent = null;
//            if(decimalParent2.toString().equals("0.0")){
//                evaluateSplitParent = new BigDecimal("0.0");
//            }else{
//                evaluateSplitParent = decimalParent1.divide(decimalParent2,2,BigDecimal.ROUND_HALF_UP);
//            }*/
//            String evaluateSplitParent = "0.0";
//            evaluateSplitParent = df.format(map.get("6").get(0).getResult2()> 0 ? map.get("6").get(0).getResult1()/(map.get("6").get(0).getResult2() *1.000) : 0.00);
//            parentResultMap.put("evaluateSplit", evaluateSplitParent);
//            parentResultMap.put("all", (Integer) parentResultMap.get("cancelled") + (Integer) parentResultMap.get("waitinglist") + (Integer) parentResultMap.get("waitingorder")
//                    + (Integer) parentResultMap.get("waitingservice")+ (Integer) parentResultMap.get("waitingpay")+ (Integer) parentResultMap.get("waitingcomment")
//                    + (Integer) parentResultMap.get("completed")
//            );
//
//            List<Map<String, Object>> childrenResultList = new LinkedList<>();
//            for (String one1 : map1.keySet()) {
//                Map<String, Object> childrenResultMap = new HashMap();
//                List<SaveModel> list1 = map1.get(one1);//机构
//                childrenResultMap.put("level", 2);
//                childrenResultMap.put("area", hospitalDao.findByCode(one1).getName());
//                Map<String, List<SaveModel>> map2 = list1.stream().collect(Collectors.groupingBy(SaveModel::getSlaveKey1));
//                //工单状态：-1-已取消，1-待（调度员）派单，2-待（医生）接单，3-待服务，4-待付款，5-待评价，6-已完成,评价均分-evaluateSplit
//                childrenResultMap.put("cancelled", map2.get("-1").get(0).getResult2().intValue());
//                childrenResultMap.put("waitinglist", map2.get("1").get(0).getResult2().intValue());
//                childrenResultMap.put("waitingorder", map2.get("2").get(0).getResult2().intValue());
//                childrenResultMap.put("waitingservice", map2.get("3").get(0).getResult2().intValue());
//                childrenResultMap.put("waitingpay", map2.get("4").get(0).getResult2().intValue());
//                childrenResultMap.put("waitingcomment", map2.get("5").get(0).getResult2().intValue());
//                childrenResultMap.put("completed", map2.get("6").get(0).getResult2().intValue());
//                /*Double childrenResult1 = 0.0;
//                Double childrenResult2 = 0.0;
//                for(SaveModel saveModel:list1){
//                    childrenResult1 +=saveModel.getResult1();
//                    childrenResult2 +=saveModel.getResult2();
//                }
//                BigDecimal decimalChildren1 = new BigDecimal(Double.toString(childrenResult1));
//                BigDecimal decimalChildren2 = new BigDecimal(Double.toString(childrenResult2));
//                BigDecimal evaluateSplitChildren = null;
//                if(decimalChildren2.toString().equals("0.0")){
//                    evaluateSplitChildren = new BigDecimal("0.0");
//                }else{
//                    evaluateSplitChildren = decimalChildren1.divide(decimalChildren2,2,BigDecimal.ROUND_HALF_UP);
//                }*/
//                String evaluateSplitChildren = "0.0";
//                evaluateSplitChildren = df.format(map2.get("6").get(0).getResult2()> 0 ? map2.get("6").get(0).getResult1()/(map2.get("6").get(0).getResult2() *1.000) : 0.00);
//                childrenResultMap.put("evaluateSplit", evaluateSplitChildren);
//                childrenResultMap.put("all", (Integer) childrenResultMap.get("cancelled") + (Integer) childrenResultMap.get("waitinglist") + (Integer) childrenResultMap.get("waitingorder")
//                        + (Integer) childrenResultMap.get("waitingservice")+ (Integer) childrenResultMap.get("waitingpay")+ (Integer) childrenResultMap.get("waitingcomment")
//                        + (Integer) childrenResultMap.get("completed")
//                );
//                childrenResultList.add(childrenResultMap);
//            }
//            parentResultMap.put("children", childrenResultList);
//            result.add(parentResultMap);
//        }
//        return result;
//    }
//
//    /**
//     * 服务工单分析
//     * @param area
//     * @param startDate
//     * @param endDate
//     * @throws Exception
//     */
//    public Map<String,Object> doorServiceOrderAnalyzeHead(String area,String startDate,String endDate, Integer type,Integer level)throws Exception{
//        Map<String, Object> resultMap = new HashMap();
//        String low_level = String.valueOf(level + 1);
//        List<SaveModel> esModelList = findDateQuotaLevel1(startDate, endDate, area, level, "121", "1", low_level, type);
//        DecimalFormat df = new DecimalFormat("0.00");
//        if (esModelList != null && esModelList.size() > 0) {
//        Map<String, List<SaveModel>> map2 = esModelList.stream().collect(Collectors.groupingBy(SaveModel::getSlaveKey1));
//        //工单状态：-1-已取消，1-待（调度员）派单，2-待（医生）接单，3-待服务，4-待付款，5-待评价，6-已完成,评价均分-evaluateSplit
//        resultMap.put("cancelled", map2.get("-1").get(0).getResult2().intValue());
//        resultMap.put("waitinglist", map2.get("1").get(0).getResult2().intValue());
//        resultMap.put("waitingorder", map2.get("2").get(0).getResult2().intValue());
//        resultMap.put("waitingservice", map2.get("3").get(0).getResult2().intValue());
//        resultMap.put("waitingpay", map2.get("4").get(0).getResult2().intValue());
//        resultMap.put("waitingcomment", map2.get("5").get(0).getResult2().intValue());
//        resultMap.put("completed", map2.get("6").get(0).getResult2().intValue());
//
//        String evaluateSplitChildren = "0.0";
//        evaluateSplitChildren = df.format(map2.get("6").get(0).getResult2()> 0 ? map2.get("6").get(0).getResult1()/(map2.get("6").get(0).getResult2() *1.000) : 0.00);
//        resultMap.put("evaluateSplit", evaluateSplitChildren);
//        resultMap.put("all", (Integer) resultMap.get("cancelled") + (Integer) resultMap.get("waitinglist") + (Integer) resultMap.get("waitingorder")
//                + (Integer) resultMap.get("waitingservice")+ (Integer) resultMap.get("waitingpay")+ (Integer) resultMap.get("waitingcomment")
//                + (Integer) resultMap.get("completed"));
//        }
//        return resultMap;
//    }
//
//    /**
//     * 服务工单分析
//     * @param area
//     * @param startDate
//     * @param endDate
//     * @throws Exception
//     */
//    public List<Map<String,Object>> doorServiceOrderAnalyzeList(String area,String startDate,String endDate, Integer type,Integer level,String lowLevel)throws Exception{
//        List<Map<String, Object>> resultList = new ArrayList<>();
//        if(StringUtils.isNotEmpty(lowLevel)){
//            lowLevel = elasticsearchUtil.changeLevel(Integer.parseInt(lowLevel))+"";
//        }else{
//            lowLevel = String.valueOf(level + 1);
//        }
//        List<SaveModel> esModelList = findDateQuotaLevel1(startDate, endDate, area, level, "121", "1", lowLevel, type);
//        Map<String, List<SaveModel>> map = null;
//        DecimalFormat df = new DecimalFormat("0.00");
//        if (esModelList != null && esModelList.size() > 0) {
//            if (lowLevel.equals("3")) {
//                map = esModelList.stream().collect(Collectors.groupingBy(SaveModel::getTown));
//            } else if (lowLevel.equals("4")) {
//                map = esModelList.stream().collect(Collectors.groupingBy(SaveModel::getHospital));
//            } else if (lowLevel.equals("5")) {
//                map = esModelList.stream().collect(Collectors.groupingBy(SaveModel::getTeam));
//            }
//            for (String one1 : map.keySet()) {
//                Map<String, Object> resultMap = new HashMap();
//                List<SaveModel> list1 = map.get(one1);
//                resultMap.put("code", one1);
//                if (lowLevel.equals("3")) {
//                    resultMap.put("name", list1.get(0).getTownName());
//                } else if (lowLevel.equals("4")) {
//                    resultMap.put("name", list1.get(0).getHospitalName());
//                } else if (lowLevel.equals("5")) {
//                    Doctor doctor = doctorDao.findByAdminTeamId(Long.parseLong(list1.get(0).getTeam()));
//                    if (doctor!=null){
//                        resultMap.put("name", doctor.getName());
//                    }else {
//                        resultMap.put("name", null);
//                    }
//                }
//                Map<String, List<SaveModel>> map2 = list1.stream().collect(Collectors.groupingBy(SaveModel::getSlaveKey1));
//                //工单状态：-1-已取消，1-待（调度员）派单，2-待（医生）接单，3-待服务，4-待付款，5-待评价，6-已完成,评价均分-evaluateSplit
//                resultMap.put("cancelled", map2.get("-1").get(0).getResult2().intValue());
//                resultMap.put("waitinglist", map2.get("1").get(0).getResult2().intValue());
//                resultMap.put("waitingorder", map2.get("2").get(0).getResult2().intValue());
//                resultMap.put("waitingservice", map2.get("3").get(0).getResult2().intValue());
//                resultMap.put("waitingpay", map2.get("4").get(0).getResult2().intValue());
//                resultMap.put("waitingcomment", map2.get("5").get(0).getResult2().intValue());
//                resultMap.put("completed", map2.get("6").get(0).getResult2().intValue());
//
//                String evaluateSplitChildren = "0.0";
//                evaluateSplitChildren = df.format(map2.get("6").get(0).getResult2()> 0 ? map2.get("6").get(0).getResult1()/(map2.get("6").get(0).getResult2() *1.000) : 0.00);
//                resultMap.put("evaluateSplit", evaluateSplitChildren);
//                resultMap.put("all", (Integer) resultMap.get("cancelled") + (Integer) resultMap.get("waitinglist") + (Integer) resultMap.get("waitingorder")
//                                + (Integer) resultMap.get("waitingservice")+ (Integer) resultMap.get("waitingpay")+ (Integer) resultMap.get("waitingcomment")
//                                + (Integer) resultMap.get("completed"));
//                resultList.add(resultMap);
//            }
//
//            resultList.sort(new Comparator<Map<String, Object>>() {
//                @Override
//                public int compare(Map<String, Object> o1, Map<String, Object> o2) {
//                    if ( (Integer) o1.get("all") > (Integer) o2.get("all")) {
//                        return -1;
//                    } else if ((Integer) o1.get("all") < (Integer) o2.get("all")) {
//                        return 1;
//                    } else {
//                        return 0;
//                    }
//                }
//            });
//        }
//
//        return resultList;
//    }
//
//    /**
//     * 响应时间分析
//     * @param area
//     * @param startDate
//     * @param endDate
//     * @param roleType
//     * @return
//     */
//    public Map<String,Object> doorResponseAnalyzeHead(String area,String startDate,String endDate,Integer roleType,Integer level)throws Exception{
//        String index;
//        if(roleType==1){
//            index = "119";
//        }else{
//            index = "122";
//        }
//
//        Map<String, Object> resultMap = new HashMap();
//        String low_level = String.valueOf(level + 1);
//        List<SaveModel> esModelList = findDateQuotaLevel1(startDate, endDate, area, level, index, "1", low_level, null);
//        Map<String, List<SaveModel>> map = null;
//        if (esModelList != null && esModelList.size() > 0) {
//            Map<String, List<SaveModel>> map2 = esModelList.stream().collect(Collectors.groupingBy(SaveModel::getSlaveKey1));
//            resultMap.put("h01", map2.get("1").get(0).getResult2().intValue());
//            resultMap.put("h12", map2.get("2").get(0).getResult2().intValue());
//            resultMap.put("h23", map2.get("3").get(0).getResult2().intValue());
//            resultMap.put("h34", map2.get("4").get(0).getResult2().intValue());
//            resultMap.put("h45", map2.get("5").get(0).getResult2().intValue());
//            resultMap.put("h5more", map2.get("6").get(0).getResult2().intValue());
//            Integer childrenAll = map2.get("1").get(0).getResult2().intValue()+map2.get("2").get(0).getResult2().intValue()+map2.get("3").get(0).getResult2().intValue()+
//                    map2.get("4").get(0).getResult2().intValue()+map2.get("5").get(0).getResult2().intValue()+map2.get("6").get(0).getResult2().intValue();
//            resultMap.put("all", childrenAll);
//
//        }
//        return resultMap;
//    }
//
//    /**
//     * 响应时间分析
//     * @param area
//     * @param startDate
//     * @param endDate
//     * @param roleType
//     * @return
//     */
//    public List<Map<String,Object>> doorResponseAnalyzeList(String area,String startDate,String endDate,Integer roleType,Integer level,String lowLevel)throws Exception{
//        String index;
//        if(roleType==1){
//            index = "119";
//        }else{
//            index = "122";
//        }
//
//        List<Map<String, Object>> resultList = new ArrayList<>();
//        if(StringUtils.isNotEmpty(lowLevel)){
//            lowLevel = elasticsearchUtil.changeLevel(Integer.parseInt(lowLevel))+"";
//        }else{
//            lowLevel = String.valueOf(level + 1);
//        }
//        List<SaveModel> esModelList = findDateQuotaLevel1(startDate, endDate, area, level, index, "1", lowLevel, null);
//        Map<String, List<SaveModel>> map = null;
//        if (esModelList != null && esModelList.size() > 0) {
//            if (lowLevel.equals("3")) {
//                map = esModelList.stream().collect(Collectors.groupingBy(SaveModel::getTown));
//            } else if (lowLevel.equals("4")) {
//                map = esModelList.stream().collect(Collectors.groupingBy(SaveModel::getHospital));
//            } else if (lowLevel.equals("5")) {
//                map = esModelList.stream().collect(Collectors.groupingBy(SaveModel::getTeam));
//            }
//            for (String one1 : map.keySet()) {
//                Map<String, Object> resultMap = new HashMap();
//                List<SaveModel> list1 = map.get(one1);
//                resultMap.put("code", one1);
//                if (lowLevel.equals("3")) {
//                    resultMap.put("name", list1.get(0).getTownName());
//                } else if (lowLevel.equals("4")) {
//                    resultMap.put("name", list1.get(0).getHospitalName());
//                } else if (lowLevel.equals("5")) {
//                    Doctor doctor = doctorDao.findByAdminTeamId(Long.parseLong(list1.get(0).getTeam()));
//                    if (doctor!=null){
//                        resultMap.put("name", doctor.getName());
//                    }else {
//                        resultMap.put("name", null);
//                    }
//                }
//                Map<String, List<SaveModel>> map2 = list1.stream().collect(Collectors.groupingBy(SaveModel::getSlaveKey1));
//                resultMap.put("h01", map2.get("1").get(0).getResult2().intValue());
//                resultMap.put("h12", map2.get("2").get(0).getResult2().intValue());
//                resultMap.put("h23", map2.get("3").get(0).getResult2().intValue());
//                resultMap.put("h34", map2.get("4").get(0).getResult2().intValue());
//                resultMap.put("h45", map2.get("5").get(0).getResult2().intValue());
//                resultMap.put("h5more", map2.get("6").get(0).getResult2().intValue());
//                Integer childrenAll = map2.get("1").get(0).getResult2().intValue()+map2.get("2").get(0).getResult2().intValue()+map2.get("3").get(0).getResult2().intValue()+
//                        map2.get("4").get(0).getResult2().intValue()+map2.get("5").get(0).getResult2().intValue()+map2.get("6").get(0).getResult2().intValue();
//                resultMap.put("all", childrenAll);
//                resultList.add(resultMap);
//            }
//            resultList.sort(new Comparator<Map<String, Object>>() {
//                @Override
//                public int compare(Map<String, Object> o1, Map<String, Object> o2) {
//                    if ( (Integer) o1.get("all") > (Integer) o2.get("all")) {
//                        return -1;
//                    } else if ((Integer) o1.get("all") < (Integer) o2.get("all")) {
//                        return 1;
//                    } else {
//                        return 0;
//                    }
//                }
//            });
//        }
//        return resultList;
//    }
//
//    /**
//     * 响应时间分析
//     * @param area
//     * @param startDate
//     * @param endDate
//     * @param roleType
//     * @return
//     */
//    public List<Map<String,Object>> doorResponseAnalyze(String area,String startDate,String endDate,Integer roleType, Integer type)throws Exception{
//
//        String index = "";
//        if(roleType==1){
//            index = "119";
//        }else{
//            index = "122";
//        }
//
//        List<Town> areaCode = new ArrayList<>();
//        if(StringUtils.isEmpty(area)){
//            areaCode = townDao.findByCityCode("350200");
//        }else{
//            areaCode.add(townDao.findByCode(area));
//        }
//        List<Map<String,Object>> result = new ArrayList<>();
//        for(Town one:areaCode) {
//            List<SaveModel> townList = findDateQuotaLevel1(startDate, endDate, one.getCode(), 3, index, "1", null, type);//区
//            List<SaveModel> orgList = findDateQuotaLevel1(startDate, endDate, one.getCode(), 3, index, "1", "4", type);//机构
//
//            Map<String, List<SaveModel>> map = townList.stream().collect(Collectors.groupingBy(SaveModel::getSlaveKey1));
//            Map<String, List<SaveModel>> map1 = orgList.stream().collect(Collectors.groupingBy(SaveModel::getHospital));
//            Map<String, Object> parentResultMap = new HashMap<>();
//            parentResultMap.put("level", 1);
//            parentResultMap.put("area", one.getName());
//            parentResultMap.put("h01", map.get("1").get(0).getResult2().intValue());
//            parentResultMap.put("h12", map.get("2").get(0).getResult2().intValue());
//            parentResultMap.put("h23", map.get("3").get(0).getResult2().intValue());
//            parentResultMap.put("h34", map.get("4").get(0).getResult2().intValue());
//            parentResultMap.put("h45", map.get("5").get(0).getResult2().intValue());
//            parentResultMap.put("h5more", map.get("6").get(0).getResult2().intValue());
//            Integer parentAll = map.get("1").get(0).getResult2().intValue()+map.get("2").get(0).getResult2().intValue()+map.get("3").get(0).getResult2().intValue()+
//                    map.get("4").get(0).getResult2().intValue()+map.get("5").get(0).getResult2().intValue()+map.get("6").get(0).getResult2().intValue();
//            parentResultMap.put("all", parentAll);
//            List<Map<String, Object>> childrenResultList = new LinkedList<>();
//            for (String one1 : map1.keySet()) {
//                Map<String, Object> childrenResultMap = new HashMap();
//                List<SaveModel> list1 = map1.get(one1);//机构
//                childrenResultMap.put("level", 2);
//                childrenResultMap.put("area", hospitalDao.findByCode(one1).getName());
//                Map<String, List<SaveModel>> map2 = list1.stream().collect(Collectors.groupingBy(SaveModel::getSlaveKey1));
//
//                childrenResultMap.put("h01", map2.get("1").get(0).getResult2().intValue());
//                childrenResultMap.put("h12", map2.get("2").get(0).getResult2().intValue());
//                childrenResultMap.put("h23", map2.get("3").get(0).getResult2().intValue());
//                childrenResultMap.put("h34", map2.get("4").get(0).getResult2().intValue());
//                childrenResultMap.put("h45", map2.get("5").get(0).getResult2().intValue());
//                childrenResultMap.put("h5more", map2.get("6").get(0).getResult2().intValue());
//                Integer childrenAll = map2.get("1").get(0).getResult2().intValue()+map2.get("2").get(0).getResult2().intValue()+map2.get("3").get(0).getResult2().intValue()+
//                        map2.get("4").get(0).getResult2().intValue()+map2.get("5").get(0).getResult2().intValue()+map2.get("6").get(0).getResult2().intValue();
//                childrenResultMap.put("all", childrenAll);
//                childrenResultList.add(childrenResultMap);
//            }
//            parentResultMap.put("children", childrenResultList);
//            result.add(parentResultMap);
//        }
//
//        return result;
//    }
//
//    /**
//     * 补助费用
//     * @param area
//     * @param startDate
//     * @param endDate
//     * @return
//     * @throws Exception
//     */
//    public Map<String,Object> subsidyExpenseHead(String area,String startDate,String endDate,Integer level)throws Exception{
//        Map<String, Object> resultMap = new HashMap<>();
//        String low_level = String.valueOf(level + 1);
//        List<SaveModel> esModelList = findDateQuotaLevel1(startDate, endDate, area, level, "118", "1", low_level, null);
//        if (esModelList != null && esModelList.size() > 0) {
//            Map<String, List<SaveModel>> map2 = esModelList.stream().collect(Collectors.groupingBy(SaveModel::getSlaveKey1));
//            //上门出诊人次
//            resultMap.put("outcalls_senior", map2.get("1").get(0).getResult2().intValue());//副高及以上
//            resultMap.put("outcalls_attending", map2.get("2").get(0).getResult2().intValue());//主治医师
//            resultMap.put("outcalls_nurse", map2.get("3").get(0).getResult2().intValue());//护士
//            Integer subsidyChildrenAll = (Integer) resultMap.get("outcalls_senior")+(Integer) resultMap.get("outcalls_attending")+(Integer) resultMap.get("outcalls_nurse");
//            resultMap.put("outcalls_all", subsidyChildrenAll);
//            //补助费用
//            resultMap.put("subsidy_senior", (Integer) resultMap.get("outcalls_senior")*150);//副高及以上
//            resultMap.put("subsidy_attending", (Integer) resultMap.get("outcalls_attending")*120);//主治医师
//            resultMap.put("subsidy_nurse", (Integer) resultMap.get("outcalls_nurse")*80);//护士
//            Integer outcallsChildrenAll = (Integer) resultMap.get("subsidy_senior")+(Integer) resultMap.get("subsidy_attending")+(Integer) resultMap.get("subsidy_nurse");
//            resultMap.put("subsidy_all", outcallsChildrenAll);
//        }
//        return resultMap;
//    }
//
//    /**
//     * 补助费用
//     * @param area
//     * @param startDate
//     * @param endDate
//     * @return
//     * @throws Exception
//     */
//    public List<Map<String,Object>> subsidyExpenseList(String area,String startDate,String endDate,Integer level,String lowLevel)throws Exception{
//        List<Map<String, Object>> resultList = new ArrayList<>();
//        if(StringUtils.isNotEmpty(lowLevel)){
//            lowLevel = elasticsearchUtil.changeLevel(Integer.parseInt(lowLevel))+"";
//        }else{
//            lowLevel = String.valueOf(level + 1);
//        }
//        Map<String, List<SaveModel>> map = null;
//                List<SaveModel> esModelList = findDateQuotaLevel1(startDate, endDate, area, level, "118", "1", lowLevel, null);
//        if (esModelList != null && esModelList.size() > 0) {
//
//            if (lowLevel.equals("3")) {
//                map = esModelList.stream().collect(Collectors.groupingBy(SaveModel::getTown));
//            } else if (lowLevel.equals("4")) {
//                map = esModelList.stream().collect(Collectors.groupingBy(SaveModel::getHospital));
//            } else if (lowLevel.equals("5")) {
//                map = esModelList.stream().collect(Collectors.groupingBy(SaveModel::getTeam));
//            }
//            for (String one1 : map.keySet()) {
//                Map<String, Object> resultMap = new HashMap();
//                List<SaveModel> list1 = map.get(one1);
//                resultMap.put("code", one1);
//                if (lowLevel.equals("3")) {
//                    resultMap.put("name", list1.get(0).getTownName());
//                } else if (lowLevel.equals("4")) {
//                    resultMap.put("name", list1.get(0).getHospitalName());
//                } else if (lowLevel.equals("5")) {
//                    Doctor doctor = doctorDao.findByAdminTeamId(Long.parseLong(list1.get(0).getTeam()));
//                    if (doctor!=null){
//                        resultMap.put("name", doctor.getName());
//                    }else {
//                        resultMap.put("name", null);
//                    }
//                }
//                //上门出诊人次
//                Map<String, List<SaveModel>> map2 = list1.stream().collect(Collectors.groupingBy(SaveModel::getSlaveKey1));
//                resultMap.put("outcalls_senior", map2.get("1").get(0).getResult2().intValue());//副高及以上
//                resultMap.put("outcalls_attending", map2.get("2").get(0).getResult2().intValue());//主治医师
//                resultMap.put("outcalls_nurse", map2.get("3").get(0).getResult2().intValue());//护士
//                Integer subsidyChildrenAll = (Integer) resultMap.get("outcalls_senior")+(Integer) resultMap.get("outcalls_attending")+(Integer) resultMap.get("outcalls_nurse");
//                resultMap.put("outcalls_all", subsidyChildrenAll);
//                //补助费用
//                resultMap.put("subsidy_senior", (Integer) resultMap.get("outcalls_senior")*150);//副高及以上
//                resultMap.put("subsidy_attending", (Integer) resultMap.get("outcalls_attending")*120);//主治医师
//                resultMap.put("subsidy_nurse", (Integer) resultMap.get("outcalls_nurse")*80);//护士
//                Integer outcallsChildrenAll = (Integer) resultMap.get("subsidy_senior")+(Integer) resultMap.get("subsidy_attending")+(Integer) resultMap.get("subsidy_nurse");
//                resultMap.put("subsidy_all", outcallsChildrenAll);
//                resultList.add(resultMap);
//            }
//            resultList.sort(new Comparator<Map<String, Object>>() {
//                @Override
//                public int compare(Map<String, Object> o1, Map<String, Object> o2) {
//                    if ( (Integer) o1.get("outcalls_all") > (Integer) o2.get("outcalls_all")) {
//                        return -1;
//                    } else if ((Integer) o1.get("outcalls_all") < (Integer) o2.get("outcalls_all")) {
//                        return 1;
//                    } else {
//                        return 0;
//                    }
//                }
//            });
//        }
//        return resultList;
//    }
//
//    /**
//     * 补助费用
//     * @param area
//     * @param startDate
//     * @param endDate
//     * @return
//     * @throws Exception
//     */
//    public List<Map<String,Object>> subsidyExpense(String area,String startDate,String endDate)throws Exception{
//
//        List<Town> areaCode = new ArrayList<>();
//        if(StringUtils.isEmpty(area)){
//            areaCode = townDao.findByCityCode("350200");
//        }else{
//            areaCode.add(townDao.findByCode(area));
//        }
//        List<Map<String,Object>> result = new ArrayList<>();
//        for(Town one:areaCode) {
//            List<SaveModel> townList = findDateQuotaLevel1(startDate, endDate, one.getCode(), 3, "118", "1", null, null);//区
//            List<SaveModel> orgList = findDateQuotaLevel1(startDate, endDate, one.getCode(), 3, "118", "1", "4", null);//机构
//            Map<String, List<SaveModel>> map = townList.stream().collect(Collectors.groupingBy(SaveModel::getSlaveKey1));
//            Map<String, List<SaveModel>> map1 = orgList.stream().collect(Collectors.groupingBy(SaveModel::getHospital));
//            Map<String, Object> parentResultMap = new HashMap<>();
//            parentResultMap.put("level", 1);
//            parentResultMap.put("area", one.getName());
//            //医生、护士80/人次；主治医师120/人次；副高及以上150/人次
//            //上门出诊人次
//            parentResultMap.put("outcalls_senior", map.get("1").get(0).getResult2().intValue());//副高及以上
//            parentResultMap.put("outcalls_attending", map.get("2").get(0).getResult2().intValue());//主治医师
//            parentResultMap.put("outcalls_nurse", map.get("3").get(0).getResult2().intValue());//护士
//            Integer subsidyParentAll = (Integer) parentResultMap.get("outcalls_senior")+(Integer) parentResultMap.get("outcalls_attending")+(Integer) parentResultMap.get("outcalls_nurse");
//            parentResultMap.put("outcalls_all", subsidyParentAll);
//            //补助费用
//            parentResultMap.put("subsidy_senior", (Integer) parentResultMap.get("outcalls_senior")*150);//副高及以上
//            parentResultMap.put("subsidy_attending", (Integer) parentResultMap.get("outcalls_attending")*120);//主治医师
//            parentResultMap.put("subsidy_nurse", (Integer) parentResultMap.get("outcalls_nurse")*80);//护士
//            Integer outcallsParentAll = (Integer) parentResultMap.get("subsidy_senior")+(Integer) parentResultMap.get("subsidy_attending")+(Integer) parentResultMap.get("subsidy_nurse");
//            parentResultMap.put("subsidy_all", outcallsParentAll);
//
//            List<Map<String, Object>> childrenResultList = new LinkedList<>();
//            for (String one1 : map1.keySet()) {
//                Map<String, Object> childrenResultMap = new HashMap();
//                List<SaveModel> list1 = map1.get(one1);//机构
//                childrenResultMap.put("level", 2);
//                childrenResultMap.put("area", hospitalDao.findByCode(one1).getName());
//                Map<String, List<SaveModel>> map2 = list1.stream().collect(Collectors.groupingBy(SaveModel::getSlaveKey1));
//                childrenResultMap.put("outcalls_senior", map2.get("1").get(0).getResult2().intValue());//副高及以上
//                childrenResultMap.put("outcalls_attending", map2.get("2").get(0).getResult2().intValue());//主治医师
//                childrenResultMap.put("outcalls_nurse", map2.get("3").get(0).getResult2().intValue());//护士
//                Integer subsidyChildrenAll = (Integer) childrenResultMap.get("outcalls_senior")+(Integer) childrenResultMap.get("outcalls_attending")+(Integer) childrenResultMap.get("outcalls_nurse");
//                childrenResultMap.put("outcalls_all", subsidyChildrenAll);
//                //补助费用
//                childrenResultMap.put("subsidy_senior", (Integer) childrenResultMap.get("outcalls_senior")*150);//副高及以上
//                childrenResultMap.put("subsidy_attending", (Integer) childrenResultMap.get("outcalls_attending")*120);//主治医师
//                childrenResultMap.put("subsidy_nurse", (Integer) childrenResultMap.get("outcalls_nurse")*80);//护士
//                Integer outcallsChildrenAll = (Integer) childrenResultMap.get("subsidy_senior")+(Integer) childrenResultMap.get("subsidy_attending")+(Integer) childrenResultMap.get("subsidy_nurse");
//                childrenResultMap.put("subsidy_all", outcallsChildrenAll);
//                childrenResultList.add(childrenResultMap);
//
//            }
//            parentResultMap.put("children", childrenResultList);
//            result.add(parentResultMap);
//        }
//
//        return result;
//    }
//
//    /*****************************************************export Excel start**************************************************************************************/
//    /**
//     * 资质分析导出excel
//     * @param area
//     * @param startDate
//     * @param endDate
//     * @param response
//     * @throws Exception
//     */
//    public void doorQualificationAnalyzeExport(String area,String startDate,String endDate, HttpServletResponse response)throws Exception{
//        WritableWorkbook book = null;
//        OutputStream os = null;
//        try{
//            List<Map<String,Object>> list = doorQualificationAnalyze(area,startDate,endDate);
//            response.setCharacterEncoding("utf-8");
//            response.setContentType("octets/stream");
//            Date date = new Date();
//            SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMdd");
//            String fileName = "上门服务资质分析统计";
//            response.setHeader("Content-Disposition", "attachment; filename="
//                    + new String(fileName.getBytes("UTF-8"), "ISO8859-1") + "_" + sdf.format(date) + ".xls");
//            os = response.getOutputStream();
//            book = Workbook.createWorkbook(os);
//            WritableSheet sheet = book.createSheet("上门服务资质分析统计", 0);
//            WritableFont headerFont = new WritableFont(WritableFont.ARIAL, 12, WritableFont.BOLD,
//                    false, UnderlineStyle.NO_UNDERLINE, jxl.format.Colour.BLACK);
//            WritableCellFormat headerFormat = new WritableCellFormat(headerFont);
//            sheet.addCell(new Label(0, 0, "地区/机构",headerFormat));
//            sheet.addCell(new Label(1, 0, "合计（人）",headerFormat));
//            sheet.addCell(new Label(2, 0, "待审核（人）",headerFormat));
//            sheet.addCell(new Label(3, 0, "已通过（人）",headerFormat));
//            sheet.addCell(new Label(4, 0, "未通过（人）",headerFormat));
//            Integer a = 0;
//            for (int i = 0; i < list.size(); i++) {
//                sheet.addCell(new Label(0, i + a + 1,list.get(i).get("area")+"",headerFormat));
//                sheet.addCell(new Label(1, i + a + 1,list.get(i).get("all")+"",headerFormat));
//                sheet.addCell(new Label(2, i + a + 1,list.get(i).get("examine")+"",headerFormat));
//                sheet.addCell(new Label(3, i + a + 1,list.get(i).get("pass")+"",headerFormat));
//                sheet.addCell(new Label(4, i + a + 1,list.get(i).get("nopass")+"",headerFormat));
//                List<Map<String,Object>> childrenList = (List<Map<String,Object>>)list.get(i).get("children");
//                for(int j = 0; j < childrenList.size(); j++){
//                    sheet.addCell(new Label(0, i + 1 + a + 1+j,childrenList.get(j).get("area")+""));
//                    sheet.addCell(new Label(1, i + 1 + a + 1+j,childrenList.get(j).get("all")+""));
//                    sheet.addCell(new Label(2, i + 1 + a + 1+j,childrenList.get(j).get("examine")+""));
//                    sheet.addCell(new Label(3, i + 1 + a + 1+j,childrenList.get(j).get("pass")+""));
//                    sheet.addCell(new Label(4, i + 1 + a + 1+j,childrenList.get(j).get("nopass")+""));
//                }
//                a+=childrenList.size();
//            }
//        }catch (IOException e){
//            e.printStackTrace();
//        }catch (WriteException e) {
//            e.printStackTrace();
//        }finally {
//            if(book!=null){
//                book.write();
//                book.close();
//            }
//            if(os!=null){
//                os.flush();
//                os.close();
//            }
//        }
//    }
//
//    /**
//     * 响应速度导出excel
//     * @param area
//     * @param startDate
//     * @param endDate
//     * @param roleType
//     * @param response
//     * @throws Exception
//     */
//    public void doorResponseAnalyzeExport(String area, String startDate, String endDate, Integer roleType, HttpServletResponse response, Integer type)throws Exception{
//        WritableWorkbook book = null;
//        OutputStream os = null;
//        try{
//            List<Map<String,Object>> list = doorResponseAnalyze(area,startDate,endDate,roleType, type);
//            response.setCharacterEncoding("utf-8");
//            response.setContentType("octets/stream");
//            Date date = new Date();
//            SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMdd");
//            String fileName = "上门服务响应速度分析统计";
//            response.setHeader("Content-Disposition", "attachment; filename="
//                    + new String(fileName.getBytes("UTF-8"), "ISO8859-1") + "_" + sdf.format(date) + ".xls");
//            os = response.getOutputStream();
//            book = Workbook.createWorkbook(os);
//            WritableSheet sheet = book.createSheet("上门服务响应速度分析统计", 0);
//            WritableFont headerFont = new WritableFont(WritableFont.ARIAL, 12, WritableFont.BOLD,
//                    false, UnderlineStyle.NO_UNDERLINE, jxl.format.Colour.BLACK);
//            WritableCellFormat headerFormat = new WritableCellFormat(headerFont);
//            sheet.addCell(new Label(0, 0, "地区/机构",headerFormat));
//            sheet.addCell(new Label(1, 0, "0-1h（个）",headerFormat));
//            sheet.addCell(new Label(2, 0, "1-2h（个）",headerFormat));
//            sheet.addCell(new Label(3, 0, "2-3h（个）",headerFormat));
//            sheet.addCell(new Label(4, 0, "3-4h（个）",headerFormat));
//            sheet.addCell(new Label(5, 0, "4-5h（个）",headerFormat));
//            sheet.addCell(new Label(6, 0, "5h以上（个）",headerFormat));
//            Integer a = 0;
//            for (int i = 0; i < list.size(); i++) {
//                sheet.addCell(new Label(0, i + a + 1,list.get(i).get("area")+"",headerFormat));
//                sheet.addCell(new Label(1, i + a + 1,list.get(i).get("h01")+"",headerFormat));
//                sheet.addCell(new Label(2, i + a + 1,list.get(i).get("h12")+"",headerFormat));
//                sheet.addCell(new Label(3, i + a + 1,list.get(i).get("h23")+"",headerFormat));
//                sheet.addCell(new Label(4, i + a + 1,list.get(i).get("h34")+"",headerFormat));
//                sheet.addCell(new Label(5, i + a + 1,list.get(i).get("h45")+"",headerFormat));
//                sheet.addCell(new Label(6, i + a + 1,list.get(i).get("h5more")+"",headerFormat));
//                List<Map<String,Object>> childrenList = (List<Map<String,Object>>)list.get(i).get("children");
//                for(int j = 0; j < childrenList.size(); j++){
//                    sheet.addCell(new Label(0, i + 1 + a + 1 + j,childrenList.get(j).get("area")+""));
//                    sheet.addCell(new Label(1, i + 1 + a + 1 + j,childrenList.get(j).get("h01")+""));
//                    sheet.addCell(new Label(2, i + 1 + a + 1 + j,childrenList.get(j).get("h12")+""));
//                    sheet.addCell(new Label(3, i + 1 + a + 1 + j,childrenList.get(j).get("h23")+""));
//                    sheet.addCell(new Label(4, i + 1 + a + 1 + j,childrenList.get(j).get("h34")+""));
//                    sheet.addCell(new Label(5, i + 1 + a + 1 + j,childrenList.get(j).get("h45")+""));
//                    sheet.addCell(new Label(6, i + 1 + a + 1 + j,childrenList.get(j).get("h5more")+""));
//                }
//                a+=childrenList.size();
//            }
//        }catch (IOException e){
//            e.printStackTrace();
//        }catch (WriteException e) {
//            e.printStackTrace();
//        }finally {
//            if(book!=null){
//                book.write();
//                book.close();
//            }
//            if(os!=null){
//                os.flush();
//                os.close();
//            }
//        }
//    }
//
//    /**
//     * 补助费用导出excel
//     * @param area
//     * @param startDate
//     * @param endDate
//     * @param response
//     * @throws Exception
//     */
//    public void subsidyExpenseExport(String area,String startDate,String endDate, HttpServletResponse response)throws Exception{
//        WritableWorkbook book = null;
//        OutputStream os = null;
//        try{
//            List<Map<String,Object>> list = subsidyExpense(area,startDate,endDate);
//            response.setCharacterEncoding("utf-8");
//            response.setContentType("octets/stream");
//            Date date = new Date();
//            SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMdd");
//            String fileName = "上门服务补助费用分析统计";
//            response.setHeader("Content-Disposition", "attachment; filename="
//                    + new String(fileName.getBytes("UTF-8"), "ISO8859-1") + "_" + sdf.format(date) + ".xls");
//            os = response.getOutputStream();
//            book = Workbook.createWorkbook(os);
//            WritableSheet sheet = book.createSheet("上门服务补助费用分析统计", 0);
//            WritableFont headerFont = new WritableFont(WritableFont.ARIAL, 12, WritableFont.BOLD,
//                    false, UnderlineStyle.NO_UNDERLINE, jxl.format.Colour.BLACK);
//            WritableCellFormat headerFormat = new WritableCellFormat(headerFont);
//            sheet.mergeCells(0,0,0,1);
//            sheet.mergeCells(1,0,4,0);
//            sheet.mergeCells(5,0,8,0);
//            sheet.addCell(new Label(0, 0, "地区/机构",headerFormat));
//            sheet.addCell(new Label(1, 0, "补助费用",headerFormat));
//            sheet.addCell(new Label(5, 0, "上门出诊人次",headerFormat));
//            sheet.addCell(new Label(1, 1, "合计（元）",headerFormat));
//            sheet.addCell(new Label(2, 1, "医生/护士（元）",headerFormat));
//            sheet.addCell(new Label(3, 1, "主治医师（元）",headerFormat));
//            sheet.addCell(new Label(4, 1, "副高及以上（元",headerFormat));
//            sheet.addCell(new Label(5, 1, "合计（人次）",headerFormat));
//            sheet.addCell(new Label(6, 1, "医生/护士（人次）",headerFormat));
//            sheet.addCell(new Label(7, 1, "主治医师（人次）",headerFormat));
//            sheet.addCell(new Label(8, 1, "副高及以上（人次）",headerFormat));
//            Integer a = 0;
//            for (int i = 0; i < list.size(); i++) {
//                sheet.addCell(new Label(0, i + a + 2,list.get(i).get("area")+"",headerFormat));
//                sheet.addCell(new Label(1, i + a + 2,list.get(i).get("subsidy_all")+"",headerFormat));
//                sheet.addCell(new Label(2, i + a + 2,list.get(i).get("subsidy_nurse")+"",headerFormat));
//                sheet.addCell(new Label(3, i + a + 2,list.get(i).get("subsidy_attending")+"",headerFormat));
//                sheet.addCell(new Label(4, i + a + 2,list.get(i).get("subsidy_senior")+"",headerFormat));
//                sheet.addCell(new Label(5, i + a + 2,list.get(i).get("outcalls_all")+"",headerFormat));
//                sheet.addCell(new Label(6, i + a + 2,list.get(i).get("outcalls_nurse")+"",headerFormat));
//                sheet.addCell(new Label(7, i + a + 2,list.get(i).get("outcalls_attending")+"",headerFormat));
//                sheet.addCell(new Label(8, i + a + 2,list.get(i).get("outcalls_senior")+"",headerFormat));
//                List<Map<String,Object>> childrenList = (List<Map<String,Object>>)list.get(i).get("children");
//                for(int j = 0; j < childrenList.size(); j++){
//                    sheet.addCell(new Label(0, i + 2 + a + 1 + j,childrenList.get(j).get("area")+""));
//                    sheet.addCell(new Label(1, i + 2 + a + 1 + j,childrenList.get(j).get("subsidy_all")+""));
//                    sheet.addCell(new Label(2, i + 2 + a + 1 + j,childrenList.get(j).get("subsidy_nurse")+""));
//                    sheet.addCell(new Label(3, i + 2 + a + 1 + j,childrenList.get(j).get("subsidy_attending")+""));
//                    sheet.addCell(new Label(4, i + 2 + a + 1 + j,childrenList.get(j).get("subsidy_senior")+""));
//                    sheet.addCell(new Label(5, i + 2 + a + 1 + j,childrenList.get(j).get("outcalls_all")+""));
//                    sheet.addCell(new Label(6, i + 2 + a + 1 + j,childrenList.get(j).get("outcalls_nurse")+""));
//                    sheet.addCell(new Label(7, i + 2 + a + 1 + j,childrenList.get(j).get("outcalls_attending")+""));
//                    sheet.addCell(new Label(8, i + 2 + a + 1 + j,childrenList.get(j).get("outcalls_senior")+""));
//                }
//                a+=childrenList.size();
//            }
//
//        }catch (IOException e){
//            e.printStackTrace();
//        }catch (WriteException e) {
//            e.printStackTrace();
//        }finally {
//            if(book!=null){
//                book.write();
//                book.close();
//            }
//            if(os!=null){
//                os.flush();
//                os.close();
//            }
//        }
//
//    }
//
//    /**
//     * 服务工单分析导出excel
//     * @param area
//     * @param startDate
//     * @param endDate
//     * @param response
//     * @param type
//     * @throws Exception
//     */
//    public void doorServiceOrderAnalyzeExport(String area, String startDate, String endDate, HttpServletResponse response, Integer type)throws Exception{
//        WritableWorkbook book = null;
//        OutputStream os = null;
//        try{
//            List<Map<String,Object>> list = doorServiceOrderAnalyze(area,startDate,endDate, type);
//            response.setCharacterEncoding("utf-8");
//            response.setContentType("octets/stream");
//            Date date = new Date();
//            SimpleDateFormat sdf = new SimpleDateFormat("yyyyMMdd");
//            String fileName = "上门服务工单分析统计";
//            response.setHeader("Content-Disposition", "attachment; filename="
//                    + new String(fileName.getBytes("UTF-8"), "ISO8859-1") + "_" + sdf.format(date) + ".xls");
//            os = response.getOutputStream();
//            book = Workbook.createWorkbook(os);
//            WritableSheet sheet = book.createSheet("上门服务工单分析统计", 0);
//            WritableFont headerFont = new WritableFont(WritableFont.ARIAL, 12, WritableFont.BOLD,
//                    false, UnderlineStyle.NO_UNDERLINE, jxl.format.Colour.BLACK);
//            WritableCellFormat headerFormat = new WritableCellFormat(headerFont);
//            sheet.addCell(new Label(0, 0, "地区/机构",headerFormat));
//            sheet.addCell(new Label(1, 0, "合计（个）",headerFormat));
//            sheet.addCell(new Label(2, 0, "待派单（个）",headerFormat));
//            sheet.addCell(new Label(3, 0, "待接单（个）",headerFormat));
//            sheet.addCell(new Label(4, 0, "待服务（个）",headerFormat));
//            sheet.addCell(new Label(5, 0, "待付款（个）",headerFormat));
//            sheet.addCell(new Label(6, 0, "待评价（个）",headerFormat));
//            sheet.addCell(new Label(7, 0, "已完成（个）",headerFormat));
//            sheet.addCell(new Label(8, 0, "已取消（个）",headerFormat));
//            sheet.addCell(new Label(9, 0, "评价均分（分）",headerFormat));
//            Integer a = 0;
//            for (int i = 0; i < list.size(); i++) {
//                sheet.addCell(new Label(0, i + a + 1,list.get(i).get("area")+"",headerFormat));
//                sheet.addCell(new Label(1, i + a + 1,list.get(i).get("all")+"",headerFormat));
//                sheet.addCell(new Label(2, i + a + 1,list.get(i).get("waitinglist")+"",headerFormat));
//                sheet.addCell(new Label(3, i + a + 1,list.get(i).get("waitingorder")+"",headerFormat));
//                sheet.addCell(new Label(4, i + a + 1,list.get(i).get("waitingservice")+"",headerFormat));
//                sheet.addCell(new Label(5, i + a + 1,list.get(i).get("waitingpay")+"",headerFormat));
//                sheet.addCell(new Label(6, i + a + 1,list.get(i).get("waitingcomment")+"",headerFormat));
//                sheet.addCell(new Label(7, i + a + 1,list.get(i).get("completed")+"",headerFormat));
//                sheet.addCell(new Label(8, i + a + 1,list.get(i).get("cancelled")+"",headerFormat));
//                sheet.addCell(new Label(9, i + a + 1,list.get(i).get("evaluateSplit")+"",headerFormat));
//                List<Map<String,Object>> childrenList = (List<Map<String,Object>>)list.get(i).get("children");
//                for(int j = 0; j < childrenList.size(); j++){
//                    sheet.addCell(new Label(0, i + 2 + a + 1 + j,childrenList.get(j).get("area")+""));
//                    sheet.addCell(new Label(1, i + 2 + a + 1 + j,childrenList.get(j).get("all")+""));
//                    sheet.addCell(new Label(2, i + 2 + a + 1 + j,childrenList.get(j).get("waitinglist")+""));
//                    sheet.addCell(new Label(3, i + 2 + a + 1 + j,childrenList.get(j).get("waitingorder")+""));
//                    sheet.addCell(new Label(4, i + 2 + a + 1 + j,childrenList.get(j).get("waitingservice")+""));
//                    sheet.addCell(new Label(5, i + 2 + a + 1 + j,childrenList.get(j).get("waitingpay")+""));
//                    sheet.addCell(new Label(6, i + 2 + a + 1 + j,childrenList.get(j).get("waitingcomment")+""));
//                    sheet.addCell(new Label(7, i + 2 + a + 1 + j,childrenList.get(j).get("completed")+""));
//                    sheet.addCell(new Label(8, i + 2 + a + 1 + j,childrenList.get(j).get("cancelled")+""));
//                    sheet.addCell(new Label(9, i + 2 + a + 1 + j,childrenList.get(j).get("evaluateSplit")+""));
//                }
//                a+=childrenList.size();
//            }
//        }catch (IOException e){
//            e.printStackTrace();
//        }catch (WriteException e) {
//            e.printStackTrace();
//        }finally {
//            if(book!=null){
//                book.write();
//                book.close();
//            }
//            if(os!=null){
//                os.flush();
//                os.close();
//            }
//        }
//
//
//    }
//
//    /*****************************************************export Excel end**************************************************************************************/
//
//    private List findDateQuotaLevel1(String startDate, String endDate, String area, int level, String index, String timeLevel, String lowLevel, Integer type) throws Exception {
//
//        //时间格式转换  yyyy-MM-dd转成 2017-07-17T00:00:00+0800
//        if (StringUtils.isNotEmpty(startDate)) {
//            if (startDate.length() > 10) {
//                startDate = elasticsearchUtil.changeTime(startDate);
//            } else {
//                startDate = elasticsearchUtil.changeDate(startDate);
//            }
//        }
//        if (StringUtils.isNotEmpty(endDate)) {
//            if (endDate.length() > 10) {
//                endDate = elasticsearchUtil.changeTime(endDate);
//            } else {
//                endDate = elasticsearchUtil.changeDate(endDate);
//            }
//        }
//        StringBuffer sql = new StringBuffer();
//        StringBuffer groupBy = new StringBuffer();
//        String low_level = level + "";
//        if (StringUtils.isNotEmpty(lowLevel)) {
//            low_level = lowLevel;
//        }
//        if (SaveModel.teamLevel.equals(low_level)) {
//            sql.append("select team,teamName,slaveKey1,slaveKey1Name,sum(result1) result1, sum(result2) result2,quotaDate from " + esIndex + " where ");
//            groupBy.append("  group by team,teamName");
//            groupBy.append(",slaveKey1,slaveKey1Name");
//        } else if (SaveModel.OrgLevel.equals(low_level)) {
//            sql.append("select hospital,hospitalName,slaveKey1,slaveKey1Name,sum(result1) result1,sum(result2) result2,quotaDate from " + esIndex + " where ");
//            groupBy.append("  group by hospital,hospitalName");
//            groupBy.append(",slaveKey1,slaveKey1Name");
//        } else if (SaveModel.townLevel.equals(low_level)) {
//            sql.append("select town,townName,slaveKey1,slaveKey1Name,sum(result1) result1,sum(result2) result2,quotaDate from " + esIndex + " where ");
//            groupBy.append("  group by town,townName");
//            groupBy.append(",slaveKey1,slaveKey1Name");
//        } else if (SaveModel.cityLevel.equals(low_level)) {
//            sql.append("select city,cityName,slaveKey1,slaveKey1Name,sum(result1) result1,sum(result2) result2,quotaDate from " + esIndex + " where ");
//            groupBy.append("  group by city,cityName");
//            groupBy.append(",slaveKey1,slaveKey1Name");
//        }
//
//        if (StringUtils.isNotEmpty(area)) {
//            if (SaveModel.teamLevel.equals(level + "")) {
//                sql.append(" team='" + area + "'");
//            } else if (SaveModel.OrgLevel.equals(level + "")) {
//                sql.append(" hospital='" + area + "'");
//            } else if (SaveModel.townLevel.equals(level + "")) {
//                sql.append(" town='" + area + "'");
//            } else if (SaveModel.cityLevel.equals(level + "")) {
//                sql.append(" city='" + area + "'");
//            }
//            sql.append(" and ");
//        }
////        sql.append(" quotaCode='" + index + "'  ");
//        sql.append(" quotaCode in(" + index + ")  ");
//        sql.append(" and timeLevel='" + timeLevel + "'  ");
//        sql.append(" and areaLevel='5'");
//        if (StringUtils.isNotEmpty(startDate)) {
//            sql.append(" and quotaDate>='" + startDate + "'");
//        }
//        if (StringUtils.isNotEmpty(endDate)) {
//            sql.append(" and quotaDate<='" + endDate + "'");
//        }
//        if(type != null){
//            if(type == 3) {
//                sql.append(" and slaveKey2 = 3 ");
//            }else {
//                sql.append(" and (slaveKey2 is null or slaveKey2 in (1,2))");
//            }
//
//        }
//
//        sql.append(groupBy);
//        sql.append(" order by slaveKey1 desc,slaveKey2 desc");
//        return elasticsearchUtil.excute(sql.toString(), SaveModel.class, "", "");
//    }
//
//    public List findDateQuotaLevelByPage(String startDate, String endDate, String area, int level, String index, String timeLevel, String lowLevel, Integer page, Integer pageSize) throws Exception {
//
//        //时间格式转换  yyyy-MM-dd转成 2017-07-17T00:00:00+0800
//        if (StringUtils.isNotEmpty(startDate)) {
//            if (startDate.length() > 10) {
//                startDate = elasticsearchUtil.changeTime(startDate);
//            } else {
//                startDate = elasticsearchUtil.changeDate(startDate);
//            }
//        }
//        if (StringUtils.isNotEmpty(endDate)) {
//            if (endDate.length() > 10) {
//                endDate = elasticsearchUtil.changeTime(endDate);
//            } else {
//                endDate = elasticsearchUtil.changeDate(endDate);
//            }
//        }
//        StringBuffer sql = new StringBuffer();
//        StringBuffer groupBy = new StringBuffer();
//        String low_level = level + "";
//        if (StringUtils.isNotEmpty(lowLevel)) {
//            low_level = lowLevel;
//        }
//        if (SaveModel.teamLevel.equals(low_level)) {
//            sql.append("select team,teamName,slaveKey1,slaveKey1Name,sum(result1) result1, sum(result2) result2,quotaDate from " + esIndex + " where ");
//            groupBy.append("  group by team,teamName");
//            groupBy.append(",slaveKey1,slaveKey1Name");
//        } else if (SaveModel.OrgLevel.equals(low_level)) {
//            sql.append("select hospital,hospitalName,slaveKey1,slaveKey1Name,sum(result1) result1,sum(result2) result2,quotaDate from " + esIndex + " where ");
//            groupBy.append("  group by hospital,hospitalName");
//            groupBy.append(",slaveKey1,slaveKey1Name");
//        } else if (SaveModel.townLevel.equals(low_level)) {
//            sql.append("select town,townName,slaveKey1,slaveKey1Name,sum(result1) result1,sum(result2) result2,quotaDate from " + esIndex + " where ");
//            groupBy.append("  group by town,townName");
//            groupBy.append(",slaveKey1,slaveKey1Name");
//        } else if (SaveModel.cityLevel.equals(low_level)) {
//            sql.append("select city,cityName,slaveKey1,slaveKey1Name,sum(result1) result1,sum(result2) result2,quotaDate from " + esIndex + " where ");
//            groupBy.append("  group by city,cityName");
//            groupBy.append(",slaveKey1,slaveKey1Name");
//        }
//
//        if (StringUtils.isNotEmpty(area)) {
//            if (SaveModel.teamLevel.equals(level + "")) {
//                sql.append(" team='" + area + "'");
//            } else if (SaveModel.OrgLevel.equals(level + "")) {
//                sql.append(" hospital='" + area + "'");
//            } else if (SaveModel.townLevel.equals(level + "")) {
//                sql.append(" town='" + area + "'");
//            } else if (SaveModel.cityLevel.equals(level + "")) {
//                sql.append(" city='" + area + "'");
//            }
//            sql.append(" and ");
//        }
//        sql.append(" quotaCode in(" + index + ")  ");
//        sql.append(" and timeLevel='" + timeLevel + "'  ");
//        sql.append(" and areaLevel='5' and result1 > 0 ");
//        if (StringUtils.isNotEmpty(startDate)) {
//            sql.append(" and quotaDate>='" + startDate + "'");
//        }
//        if (StringUtils.isNotEmpty(endDate)) {
//            sql.append(" and quotaDate<='" + endDate + "'");
//        }
//        sql.append(groupBy);
//        sql.append(" order by result1 desc,result2 desc limit " + (page-1) * pageSize + "," + pageSize);
//        return elasticsearchUtil.excute(sql.toString(), SaveModel.class, "", "");
//    }
//
//    public Map<String,Object> doorAggregateAnalysis(String area, int level, String startDate, String endDate) throws Exception {
//        Map<String,Object> resMap = new HashMap<>();
//        String whereSql = "";
//        //计算上门服务已服务居民
//        String sql = "SELECT count(DISTINCT o.patient) count FROM `wlyy_door_service_order` o LEFT JOIN wlyy.wlyy_sign_family f ON f.patient = o.patient " +
//                "WHERE o.`status` != -1 and f. STATUS = 1 AND f.expenses_status = 1 AND o.create_time >= '" +startDate +"' AND o.create_time <= '" + endDate + "' ";
//        if(level == 3){
//            whereSql += "and f.hospital like '" + area + "%' ";
//        }else if(level == 4){
//            whereSql += "and f.hospital = '" + area + "' ";
//        }else if(level == 5){
//            whereSql += "and f.admin_team_code='" + area + "' ";
//        }
//        Integer doorPatientService = jdbcTemplate.queryForObject(sql + whereSql, Integer.class);
//        resMap.put("doorPatientServiceCount", doorPatientService);
//
//        //获取上门服务资质服务人群分析,到达量
//        List<SaveModel> voucherList = findDateQuotaLevel1(endDate, endDate, area, level, "133", "2", level + "", null);
//        resMap.put("voucherList", voucherList);
//
//        //获取上门服务处方主诊断疾病分析
//        List<Map<String, Object>> diagnosisList = getOrderByDiagnosis(area, level, startDate, endDate, 1, 5);
////        List<SaveModel> diagnosisList = findDateQuotaLevelByPage(endDate, endDate, area, level, "134", "2", level + "", 1, 5);
//        resMap.put("diagnosisList", diagnosisList);
//
//        //获取服务项目和药品分析
//        List<Map<String, Object>> drugList = getGroupbyDrugCodeList(area, level, "010", 1, 5, startDate, endDate);
//        List<Map<String, Object>> itemList = getGroupbyDrugCodeList(area, level, "020", 1, 5, startDate, endDate);
//        resMap.put("drugList", drugList);
//        resMap.put("itemList", itemList);
//
//        //获取服务工单排行
//        List<SaveModel> orderList = elasticsearchUtil.findDateQuotaLevel0(startDate, endDate, area, level, "121", "1", null, level + "");
//        List<SaveModel> slaveList = findDateQuotaLevel1(startDate, endDate, area, level, "121", "1", level + "", null);
//        Map<String, List<SaveModel>> map = slaveList.stream().collect(Collectors.groupingBy(SaveModel::getSlaveKey1));
////        resMap.put("orderList", orderList);
//        //计算服务评价均分
//        Double parentResult1= 0.0;
//        Double parentResult2 = 0.0;
//        for(SaveModel saveModel : orderList){
//            parentResult1 +=saveModel.getResult1();
//            parentResult2 +=saveModel.getResult2();
//        }
//        BigDecimal decimalParent1 = new BigDecimal(Double.toString(parentResult1));
//        BigDecimal decimalParent2 = new BigDecimal(Double.toString(parentResult2));
//        DecimalFormat df = new DecimalFormat("0.00");
//        String evaluateSplitParent = "0.0";
//        evaluateSplitParent = df.format(map.get("6").get(0).getResult2()> 0 ? map.get("6").get(0).getResult1()/(map.get("6").get(0).getResult2() *1.000) : 0.00);
//        resMap.put("evaluateSplit", evaluateSplitParent);
//        return resMap;
//    }
//
//    public List<Map<String,Object>> getOrderByDiagnosis(String area, int level, String startDate, String endDate, Integer page, Integer pageSize) {
//        String sql = "SELECT p.diagnosis_code code,p.diagnosis_name name,count(p.order_id) as orderCount " +
//                "FROM `wlyy_door_prescription` p LEFT JOIN wlyy.wlyy_sign_family f ON f.patient = p.patient " +
//                "WHERE p.`status`>=50 and f. STATUS = 1 AND f.expenses_status = 1 ";
//        if(level == 3){
//            sql += "and f.hospital like '" + area + "%' ";
//        }else if(level == 4){
//            sql += "and f.hospital = '" + area + "' ";
//        }else if(level == 5){
//            sql += "and f.admin_team_code='" + area + "' ";
//        }
//        if(StringUtils.isNotBlank(startDate)){
//            sql += "and p.create_time >= '" + startDate + "' ";
//        }
//        if(StringUtils.isNotBlank(endDate)){
//            sql += "and p.create_time <= '" + endDate + "' ";
//        }
//        List<Map<String, Object>> diagnosisList = jdbcTemplate.queryForList(sql + " GROUP BY p.diagnosis_code limit " + (page-1) * pageSize + "," + pageSize);
//        return diagnosisList;
//    }
//
//    /**
//     * 获取服务项目和药品分析
//     * @param area 对应等级机构
//     * @param level 机构等级 3区 4机构 5团队
//     * @param subjectClass 科目类别，010开头为药品，020为服务项目
//     * @param page
//     * @param pageSize
//     * @param startDate
//     * @param endDate
//     * @return
//     */
//    public List<Map<String,Object>> getGroupbyDrugCodeList(String area, int level, String subjectClass, int page, int pageSize, String startDate, String endDate) {
//        String drugSql="SELECT d.drug_code code,d.drug_name name,count(DISTINCT p.order_id) orderCount,count(DISTINCT p.patient) patientCount " +
//                "FROM `wlyy_door_prescription_drug` d , wlyy_door_prescription p LEFT JOIN wlyy.wlyy_sign_family f ON f.patient = p.patient  " +
//                "where d.prescription_code = p.code and p.`status`>=50  and f. STATUS = 1 AND f.expenses_status = 1 AND p.create_time >= '" +startDate +"' AND p.create_time <= '" + endDate + "'  ";
//        if(StringUtils.isNotBlank(subjectClass)){
//            drugSql += "and d.subject_class like '" + subjectClass + "%' ";
//        }
//        if(level == 3){
//            drugSql += "and f.hospital like '" + area + "%' ";
//        }else if(level == 4){
//            drugSql += "and f.hospital = '" + area + "' ";
//        }else if(level == 5){
//            drugSql += "and f.admin_team_code='" + area + "' ";
//        }
//        drugSql += "GROUP BY d.drug_code order by orderCount desc, patientCount desc limit " + (page-1) * pageSize + "," + pageSize;
//        List<Map<String, Object>> list = jdbcTemplate.queryForList(drugSql);
//        return list;
//    }
//
//    /**
//     * 获取上门服务合计工单排行
//     * @param endDate
//     * @param area
//     * @param level
//     * @param sort
//     * @param lowLevel
//     * @param year
//     * @return
//     * @throws Exception
//     */
//    public JSONArray getOrderLowlevelAll(String startDate, String endDate, String area, int level, int sort, String lowLevel, String year) throws Exception {
//        List<Map<String, Object>> resultList = new ArrayList<>();
//        //工单状态列表
//        List<SaveModel> slaveList = findDateQuotaLevel1(startDate, endDate, area, level, "121", "1", lowLevel, null);
//        Map<String, List<SaveModel>> map1 = new HashMap<>();
//        if (SaveModel.OrgLevel.equals(lowLevel)) {
//            map1 = slaveList.stream().collect(Collectors.groupingBy(SaveModel::getHospital));
//        } else if (SaveModel.townLevel.equals(lowLevel)) {
//            map1 = slaveList.stream().collect(Collectors.groupingBy(SaveModel::getTown));
//        } else if (SaveModel.teamLevel.equals(lowLevel)) {
//            map1 = slaveList.stream().collect(Collectors.groupingBy(SaveModel::getTeam));
//        }
////        Map<String, List<SaveModel>> map1 = slaveList.stream().collect(Collectors.groupingBy(SaveModel::getHospital));
//        for (String one1 : map1.keySet()) {
//            Map<String, Object> childrenResultMap = new HashMap();
//            List<SaveModel> list1 = map1.get(one1);//机构
//            childrenResultMap.put("code", one1);
//            if (SaveModel.OrgLevel.equals(lowLevel)) {
//                childrenResultMap.put("name", list1.get(0).getHospitalName());
//            } else if (SaveModel.townLevel.equals(lowLevel)) {
//                childrenResultMap.put("name", list1.get(0).getTownName());
//            } else if (SaveModel.teamLevel.equals(lowLevel)) {
//                childrenResultMap.put("name", list1.get(0).getTeamName());
//            }
//            Map<String, List<SaveModel>> map2 = list1.stream().collect(Collectors.groupingBy(SaveModel::getSlaveKey1));
//            //工单状态：-1-已取消，1-待（调度员）派单，2-待（医生）接单，3-待服务，4-待服务，5-待评价，6-已完成,评价均分-evaluateSplit
//            childrenResultMap.put("cancelled", map2.get("-1").get(0).getResult2().intValue());
//            childrenResultMap.put("waitinglist", map2.get("1").get(0).getResult2().intValue());
//            childrenResultMap.put("waitingorder", map2.get("2").get(0).getResult2().intValue());
//            childrenResultMap.put("waitingservice", map2.get("3").get(0).getResult2().intValue());
//            childrenResultMap.put("waitingpay", map2.get("4").get(0).getResult2().intValue());
//            childrenResultMap.put("waitingcomment", map2.get("5").get(0).getResult2().intValue());
//            childrenResultMap.put("completed", map2.get("6").get(0).getResult2().intValue());
//            /*Double childrenResult1 = 0.0;
//            Double childrenResult2 = 0.0;
//            for(SaveModel saveModel:list1){
//                childrenResult1 +=saveModel.getResult1();
//                childrenResult2 +=saveModel.getResult2();
//            }
//            BigDecimal decimalChildren1 = new BigDecimal(Double.toString(childrenResult1));
//            BigDecimal decimalChildren2 = new BigDecimal(Double.toString(childrenResult2));*/
//            DecimalFormat df = new DecimalFormat("0.00");
//            String evaluateSplitChildren = "";
//            evaluateSplitChildren = df.format(map2.get("6").get(0).getResult2()> 0 ? map2.get("6").get(0).getResult1()/(map2.get("6").get(0).getResult2() *1.000) : 0.00);
//            /*BigDecimal evaluateSplitChildren = null;
//            if(decimalChildren2.toString().equals("0.0")){
//                evaluateSplitChildren = new BigDecimal("0.0");
//            }else{
//                evaluateSplitChildren = decimalChildren1.divide(decimalChildren2,2,BigDecimal.ROUND_HALF_UP);
//            }*/
//            childrenResultMap.put("evaluateSplit", evaluateSplitChildren);
//            childrenResultMap.put("all", (Integer) childrenResultMap.get("cancelled") + (Integer) childrenResultMap.get("waitinglist") + (Integer) childrenResultMap.get("waitingorder")
//                    + (Integer) childrenResultMap.get("waitingservice")+ (Integer) childrenResultMap.get("waitingpay")+ (Integer) childrenResultMap.get("waitingcomment")
//                    + (Integer) childrenResultMap.get("completed")
//            );
//            resultList.add(childrenResultMap);
//        }
//        // 结果为空时,自建结果集
//        if (resultList == null || resultList.size() < 1) {
//            resultList = new ArrayList<>();
//            if (SaveModel.townLevel.equals(lowLevel)) {
//                List<Town> towns = townDao.findByCityCode(area);
//                if (towns != null) {
//                    for (Town town : towns) {
//                        Map<String, Object> obj = new HashMap<>();
//                        obj.put("code", town.getCode());
//                        obj.put("name", town.getName());
//                        obj.put("all", "0");
//                        resultList.add(obj);
//                    }
//                }
//            } else if (SaveModel.OrgLevel.equals(lowLevel)) {
//                List<Town> towns = new ArrayList<>();
//                if (SaveModel.cityLevel.equals(level + "")) {
//                    towns = townDao.findByCityCode(area);
//                } else if (SaveModel.townLevel.equals(level + "")) {
//                    Town town = townDao.findByCode(area);
//                    towns.add(town);
//                }
//                if (towns != null && towns.size() > 0) {
//                    for (Town town : towns) {
//                        List<Hospital> hospitals = hospitalDao.findByTownCode(town.getCode());
//
//                        for (Hospital hos : hospitals) {
//                            Map<String, Object> obj = new HashMap<>();
//                            obj.put("code", hos.getCode());
//                            obj.put("name", hos.getName());
//                            obj.put("all", "0");
//                            resultList.add(obj);
//                        }
//                    }
//                }
//            } else if (SaveModel.teamLevel.equals(lowLevel)) {
//                List<Hospital> hospitals = new ArrayList<>();
//                if (SaveModel.cityLevel.equals(level + "")) {
//                    hospitals = hospitalDao.findByCity(area);
//                } else if (SaveModel.townLevel.equals(level + "")) {
//                    hospitals = hospitalDao.findByTownCode(area);
//                } else {
//                    Hospital hos = hospitalDao.findByCode(area);
//                    if (hos != null) {
//                        hospitals.add(hos);
//                    }
//                }
//                if (hospitals != null && hospitals.size() > 0) {
//                    for (Hospital hos : hospitals) {
//                        List<AdminTeam> teams = adminTeamDao.findByOrgCode(hos.getCode());
//                        for (AdminTeam team : teams) {
//                            Map<String, Object> obj = new HashMap<>();
//                            obj.put("code", String.valueOf(team.getId()));
//                            obj.put("name", team.getName());
//                            obj.put("all", "0");
//                            resultList.add(obj);
//                        }
//                    }
//                }
//            }
//        }
//        if (SaveModel.OrgLevel.equals(level + "") || SaveModel.teamLevel.equals(lowLevel)) {
//            statisticsAllService.translateTeamLeaderName(resultList);
//        }
//        Collections.sort(resultList, new Comparator<Map<String, Object>>() {
//            @Override
//            public int compare(Map<String, Object> o1, Map<String, Object> o2) {
//                Integer map1value = 0;
//                Integer map2value = 0;
//                if (o1.get("all") != null && o1.get("all") + "" != "") {
//                    map1value = (Integer) o1.get("all");
//                }
//                if (o2.get("all") != null && o2.get("all") + "" != "") {
//                    map2value = (Integer) o2.get("all");
//                }
//                if (map1value - map2value > 0) {
//                    return sort == 1 ? -1 : 1;
//                } else if (map1value - map2value < 0) {
//                    return sort == 1 ? 1 : -1;
//                } else {
//                    return 0;
//                }
//            }
//        });
//
//        return new JSONArray(resultList);
//    }
//
//
//
//
//    /**
//     * 上门服务统计 1.6.8.3 版本
//     * @param area
//     * @param level
//     * @param startDate
//     * @param endDate
//     * @return
//     * @throws Exception
//     */
//    public Map<String,Object> doorServiceAnalysis(String area, int level, String startDate, String endDate) throws Exception {
//        Map<String,Object> resMap = new HashMap<>();
//
//        startDate = statisticsUtilService.getStartDate(startDate,endDate);
//
//        //已服务居民
//        long servedPatientNum = statisticsUtilService.getTotalAmountDDLOrZL(startDate,endDate,area,level,"178",null);
//        //服务工单
//        long serviceOrderNum = statisticsUtilService.getTotalAmountDDLOrZL(startDate,endDate,area,level,"121","5,6");
//        //开具处方
//        long doorPrescriptionNum = statisticsUtilService.getTotalAmountDDLOrZL(startDate,endDate,area,level,"134",null);
//        resMap.put("serviceOrderNum", serviceOrderNum);
//        resMap.put("doorPrescriptionNum", doorPrescriptionNum);
//        resMap.put("servedPatientNum", servedPatientNum);
//
//        String ddlOrZl = statisticsUtilService.getDDLOrZL(startDate,endDate);
//
//        //服务费用：上门服务的开单以及处方收入费用
//        List<SaveModel> priceList = elasticsearchUtil.findDateQuotaLevel2(startDate, endDate, area, level, "177", ddlOrZl, null, "020", null, null);
////        resMap.put("totalPrice", priceList.get(0).getResult1());
//        resMap.put("totalPrice", String.format("%.2f",priceList.get(0).getResult1()));
//
//        //服务类型
//        List<SaveModel> doorServiceTypeList = elasticsearchUtil.findDateQuotaLevel2(startDate, endDate, area, level, "121", ddlOrZl, null, statisticsUtilService.commonParams, null, null);
//        List<Map<String,Object>> doorServiceTypeList2 = new ArrayList<>();
//        long patientOrderNum = 0;
//        for(SaveModel saveModel:doorServiceTypeList){
//            if("3".equals(saveModel.getSlaveKey2())){
//                doorServiceTypeList2.add(statisticsUtilService.slaveKay2ToMapLong(saveModel));
//            }else{
//                patientOrderNum += saveModel.getResult2().longValue();
//            }
//        }
//        Map<String, Object> map = new HashMap<>(16);
//        map.put("code", "1");
//        map.put("name", "居民自主预约");
//        map.put("num", patientOrderNum);
//        doorServiceTypeList2.add(map);
//        resMap.put("doorServiceTypeList", doorServiceTypeList2);
//
//        //服务人群分析,到达量
//        List<SaveModel> voucherList = findDateQuotaLevel1(endDate, endDate, area, level, "133", ddlOrZl, level + "", null);
//        List<Map<String,Object>> voucherList2 = new ArrayList<>();
//        voucherList.forEach(one->voucherList2.add(statisticsUtilService.slaveKay1ToMapLong(one)));
//        resMap.put("voucherList", voucherList2);
//        return resMap;
//    }
//
//    /**
//     * 新增服务工单趋势-v1.6.8.3
//     * @param area
//     * @param level
//     * @param startDate
//     * @param endDate
//     * @param interval
//     * @return
//     * @throws Exception
//     */
//    public List<Map<String,Object>> serviceOrderTrend(String area, int level, String startDate, String endDate,String interval) throws Exception {
//        List<Map<String,Object>> list = new ArrayList<>();
//        //新增服务工单趋势
//        List<SaveModel> serviceOrderList = elasticsearchUtil.findDateQuotaLevel0(startDate, endDate, area, level, "121", SaveModel.timeLevel_ZL, interval, null);
//        serviceOrderList.forEach(one->list.add(statisticsUtilService.saveModelToMap(one)));
//        return list;
//    }
//
//
//    /**
//     * 获取上门服务服务项目分析-v1.6.8.3
//     * @param area
//     * @param level
//     * @param pageSize
//     * @param startDate
//     * @param endDate
//     * @return
//     */
//    public List<Map<String,Object>> doorServiceItemAnalysis(String area, int level , Integer pageSize, String startDate, String endDate) {
//        List<Map<String,Object>> list = new ArrayList<>();
//        startDate = statisticsUtilService.getStartDate(startDate,endDate);
//        String ddlOrZl = statisticsUtilService.getDDLOrZL(startDate,endDate);
//        List<SaveModel> doorServiceTypeList = elasticsearchUtil.findDateQuotaLevel2(startDate, endDate, area, level, "177", ddlOrZl, "xmijk_quota","020", null, null);
//        for (SaveModel saveModel:doorServiceTypeList){
//            if(StringUtils.isNoneBlank(saveModel.getSlaveKey1())){
//                Map<String, Object> tmp = statisticsUtilService.slaveKay1ToMapLong2(saveModel);
//                tmp.put("price", String.format("%.2f",Double.parseDouble(tmp.get("price").toString())));
//                list.add(tmp);
//            }
//        }
//
//        statisticsUtilService.sortDoubleList(list,"num");
//        if(pageSize == 999){
//            return list;
//        }else{
//            int total = list.size();
//            int fromIndex = 0;
//            if (pageSize >= total) {
//                pageSize = total;
//            }
//            list =list.subList(fromIndex, pageSize);
//        }
//
//        return list;
//    }
//
//    /**
//     * 获取上门服务合计工单排行
//     * @param endDate
//     * @param area
//     * @param level
//     * @param lowLevel
//     * @return
//     * @throws Exception
//     */
//    public JSONArray doorServiceOrderLowlevelAll(String startDate, String endDate, String area, int level, String slaveKey1, String lowLevel) throws Exception {
//        List<Map<String, Object>> resultList = new ArrayList<>();
//
//        startDate = statisticsUtilService.getStartDate(startDate,endDate);
//        String ddlOrZl = statisticsUtilService.getDDLOrZL(startDate,endDate);
//
//        List<SaveModel> slaveList2 = new ArrayList<>();//增量时  两个到达量相减
//        //服务工单数
//        List<SaveModel> slaveList1 = elasticsearchUtil.findDateQuotaLevel0BySlaveKey1(endDate, endDate, area, level, "121", "2",null, lowLevel,"5,6");
//        if ("1".equals(ddlOrZl)){
//            slaveList2 = elasticsearchUtil.findDateQuotaLevel0BySlaveKey1(startDate, startDate, area, level, "121", "2",null, lowLevel,"5,6");
//        }
//
//        //服务费用
//        List<SaveModel> slaveList = elasticsearchUtil.findDateQuotaLevel2(startDate, endDate, area, level, "177", ddlOrZl, slaveKey1,"020", null, lowLevel);
//        for (int i=0;i<slaveList1.size();i++){
//            SaveModel saveModel = slaveList1.get(i);
//            Map<String, Object> map = statisticsUtilService.getMapTurnDownResult2(saveModel,lowLevel,"num");
//            if ("1".equals(ddlOrZl)){
//                SaveModel saveModel2 = slaveList2.get(i);
//                map.put("num",saveModel.getResult2().longValue()-saveModel2.getResult2().longValue());
//            }
//            for (SaveModel one:slaveList){
//                if(statisticsUtilService.compareSaveModel(saveModel,one,lowLevel)){
//                    map.put("price",String.format("%.2f",one.getResult1()));
////                    map.put("price",one.getResult1());
//                    break;
//                }
//            }
//            resultList.add(map);
//        }
//
//        if (SaveModel.OrgLevel.equals(level + "") || SaveModel.teamLevel.equals(lowLevel)) {
//            statisticsAllService.translateTeamLeaderName(resultList);
//        }
//
//        statisticsUtilService.sortLongList(resultList,"num");
//
//        return new JSONArray(resultList);
//    }
//
//    /**
//     * 入户访视统计-获取总量头部-v1.6.8.3
//     * @param startDate
//     * @param endDate
//     * @param area
//     * @param level
//     * @param slaveKey1
//     * @return
//     * @throws Exception
//     */
//    public JSONObject getHomeVisitTotalHead(String startDate, String endDate, String area, Integer level, String slaveKey1) throws Exception {
//        JSONObject object = new JSONObject();
//        startDate = statisticsUtilService.getStartDate(startDate, endDate);
//        //人数
//        long numTotal =  statisticsUtilService.getTotalAmountDDLOrZL(startDate,endDate,area,level,"151",slaveKey1);
//        //人次
//        long timesTotal =  statisticsUtilService.getTotalAmountDDLOrZL(startDate,endDate,area,level,"150",slaveKey1);
//        object.put("numTotal",numTotal);
//        object.put("timesTotal",timesTotal);
//        return object;
//    }
//
//    /**
//     * 通用单条折线图趋势-v1.6.8.3
//     * @param area
//     * @param level
//     * @param index 上门服务150
//     * @param startDate
//     * @param endDate
//     * @param interval
//     * @return
//     * @throws Exception
//     */
//    public List<Map<String,Object>> generalSingleLineChartTrend(String area, int level,String index, String startDate, String endDate,String interval,String slaveKey1) throws Exception {
//        List<Map<String,Object>> list = new ArrayList<>();
//        //新增服务工单趋势
//        List<SaveModel> serviceOrderList = statisticsUtilService.findDateQuotaLevel0BySlaveKey1(startDate,endDate,area,level,index,SaveModel.timeLevel_ZL,interval,slaveKey1);
//        serviceOrderList.forEach(one->list.add(statisticsUtilService.saveModelToMap(one)));
//        return list;
//    }
//
//    /**
//     * 通用饼图-v1.6.8.3
//     * @param area
//     * @param level
//     * @param index 上门服务150
//     * @param startDate
//     * @param endDate
//     * @param slaveKey1
//     * @return
//     * @throws Exception
//     */
//    public List<Map<String,Object>> generalPieChartTrend(String area, int level,String index, String startDate, String endDate,String slaveKey1) throws Exception {
//        List<Map<String,Object>> list = new ArrayList<>();
//
//        startDate = statisticsUtilService.getStartDate(startDate, endDate);
//        String ddlOrZl = statisticsUtilService.getDDLOrZL(startDate,endDate);
//        slaveKey1 = statisticsUtilService.returnSlaveKey(slaveKey1);
//
//        List<SaveModel> serviceOrderList = statisticsUtilService.findDateQuotaLevel1(startDate,endDate,area,level,index,ddlOrZl, slaveKey1,null,null);
//        serviceOrderList.forEach(one->list.add(statisticsUtilService.slaveKay1ToMapLong(one)));
//        return list;
//    }
//
//    /**
//     * 通用下砖接口 区-社区-团队-v1.6.8.3
//     * @param endDate
//     * @param area
//     * @param level
//     * @param lowLevel
//     * @return
//     * @throws Exception
//     */
//    public List<Map<String, Object>> generalLowlevelAll(String startDate, String endDate, String area, int level,String index,String slaveKey1,  String lowLevel) throws Exception {
//        List<Map<String, Object>> resultList = new ArrayList<>();
//
//        startDate = statisticsUtilService.getStartDate(startDate,endDate);
//        String ddlOrZl = statisticsUtilService.getDDLOrZL(startDate,endDate);
//
//        //工单状态列表
//        List<SaveModel> slaveList = elasticsearchUtil.findDateQuotaLevel0BySlaveKey1(startDate,endDate,area,level,index,ddlOrZl,null,lowLevel, slaveKey1);
//        for (SaveModel saveModel:slaveList){
//            resultList.add(statisticsUtilService.getMapTurnDownResult2(saveModel,lowLevel,"num"));
//        }
//
//        if (SaveModel.OrgLevel.equals(level + "") || SaveModel.teamLevel.equals(lowLevel)) {
//            statisticsAllService.translateTeamLeaderName(resultList);
//        }
//
//        statisticsUtilService.sortLongList(resultList,"num");
//
//        return resultList;
//    }
//
//}
