package com.yihu.jw.hospital.module.door.service;

import com.alibaba.fastjson.JSONObject;
import com.yihu.jw.entity.door.WlyyDoorConclusionDO;
import com.yihu.jw.hospital.module.door.dao.WlyyDoorConclusionDao;
import com.yihu.jw.hospital.utils.EntityUtils;
import com.yihu.jw.restmodel.ResponseContant;
import com.yihu.mysql.query.BaseJpaService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.BeanPropertyRowMapper;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;

/**
 * 
 * 工单服务小结服务service
 * 
 * @version 
 * <pre>
 * Author	Version		Date		Changes
 * Administrator    1.0  2019年03月20日 Created
 *
 * </pre>
 * @since 1.
 */
@Service
public class WlyyDoorConclusionService extends BaseJpaService<WlyyDoorConclusionDO, WlyyDoorConclusionDao> {

    private Logger logger = LoggerFactory.getLogger(WlyyDoorConclusionService.class);

    @Autowired
    private JdbcTemplate jdbcTemplate;


    //工单服务小结服务基本信息
    private WlyyDoorConclusionDO jsonToWlyyDoorConclusion(JSONObject result, JSONObject jsonObjectParam,String jsonData) {
        WlyyDoorConclusionDO wlyyDoorConclusion;
        try {
            wlyyDoorConclusion = EntityUtils.jsonToEntity(jsonObjectParam.get("wlyyDoorConclusion").toString(),WlyyDoorConclusionDO.class);
        } catch (Exception e) {
            result.put(ResponseContant.resultFlag,ResponseContant.fail);
            String failMsg = "工单服务小结服务基本信息："  + e.getMessage();
            result.put(ResponseContant.resultMsg,failMsg);
            logger.error(failMsg);
            return new WlyyDoorConclusionDO();
        }

        this.save(wlyyDoorConclusion);
        return wlyyDoorConclusion;
    }

     /**
     * 创建工单服务小结
     * @param jsonData
     * @return
     */
    @Transactional(rollbackFor = Exception.class)
    public JSONObject create(String jsonData){
        JSONObject result = new JSONObject();
        JSONObject jsonObjectParam ;

        try {
            jsonObjectParam = JSONObject.parseObject(jsonData);
        } catch (Exception e) {
            result.put(ResponseContant.resultFlag,ResponseContant.fail);
            String failMsg = "参数转换成JSON对象异常：" + e.getMessage();
            result.put(ResponseContant.resultMsg,failMsg);
            logger.error(failMsg);
            return result;
        }

        WlyyDoorConclusionDO wlyyDoorConclusion = new WlyyDoorConclusionDO();
        wlyyDoorConclusion = jsonToWlyyDoorConclusion(result, jsonObjectParam,jsonData);

         /*
        //新增#######关联关系
        if (roleWithMenu(result, jsonObjectParam, wlyyDoorConclusion)) return result;

        //新增#######关联关系
        if (roleWithFunction(result, jsonObjectParam, wlyyDoorConclusion)) return result;
        */
        result.put(ResponseContant.resultFlag,ResponseContant.success);
        result.put(ResponseContant.resultMsg,wlyyDoorConclusion);
        return result;
    }

    /**
     * 工单服务小结（包括角色分配的菜单，模块等）
     * @param jsonData
     * @return
     */
    @Transactional(rollbackFor = Exception.class)
    public JSONObject update(String jsonData){
        JSONObject result = new JSONObject();
        JSONObject jsonObjectParam ;

        try {
            jsonObjectParam = JSONObject.parseObject(jsonData);
        } catch (Exception e) {
            result.put(ResponseContant.resultFlag,ResponseContant.fail);
            String failMsg = "参数转换成JSON对象异常：" + e.getMessage();
            result.put(ResponseContant.resultMsg,failMsg);
            logger.error(failMsg);
            return result;
        }

        WlyyDoorConclusionDO wlyyDoorConclusion = new WlyyDoorConclusionDO();
        wlyyDoorConclusion = jsonToWlyyDoorConclusion(result, jsonObjectParam,jsonData);



        result.put(ResponseContant.resultFlag,ResponseContant.success);
        result.put(ResponseContant.resultMsg,wlyyDoorConclusion);
        return result;
    }


   /**
     * 查询工单服务小结列表
     *
     * @return
     */
    public JSONObject queryInfoList(String fields, String filters, String sorts, int page, int size) {
        JSONObject result = new JSONObject();

        int start = 0 == page ? page++ : (page - 1) * size;
        int end = 0 == size ? 15 : page * size;

        String sql = "";

        String finalSql = sql.replace("{fields}", fields)
                .replace("{start}", String.valueOf(start))
                .replace("{end}", String.valueOf(end));

        String countSql = "";

        String finqlCountSql = countSql.replace("{filters}", filters)
                .replace("{start}", String.valueOf(start));

        List<WlyyDoorConclusionDO> sqlResultlist = new ArrayList<>();
    try {
        sqlResultlist = jdbcTemplate.query(finalSql, new BeanPropertyRowMapper<>(WlyyDoorConclusionDO.class));
    } catch (Exception e) {
        result.put(ResponseContant.resultFlag, ResponseContant.fail);
        result.put(ResponseContant.resultMsg, "从数据库工单服务小结列表信息失败：" + e.getMessage());
        return result;
    }

    Integer count = 0;
    try {
        count = jdbcTemplate.queryForObject(finqlCountSql, Integer.class);
    } catch (Exception e) {
        result.put(ResponseContant.resultFlag, ResponseContant.fail);
        result.put(ResponseContant.resultMsg, "从数据库统计工单服务小结数量失败：" + e.getMessage());
        return result;
    }

    result.put(ResponseContant.resultFlag, ResponseContant.success);
    result.put(ResponseContant.resultMsg, sqlResultlist);
    JSONObject countItem = new JSONObject();
    countItem.put("count", count);
    result.putAll(countItem);

    return result;
    }
}
