package com.yihu.jw.hospital.module.patient.service;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.yihu.jw.entity.patient.PatientRestTime;
import com.yihu.jw.hospital.module.patient.dao.PatientRestTimeDao;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * Created by yeshijie on 2023/3/23.
 */
@Service
public class PatientRestTimeService {

    @Autowired
    private JdbcTemplate jdbcTemplate;
    @Autowired
    private PatientRestTimeDao patientRestTimeDao;

    //获取居民作息时间
    public Map<String,String> getPatientRestTimeMap(String patient){
        synchronized (patient.intern()){
            List<PatientRestTime> restTimeList = patientRestTimeDao.findByPatient(patient);
            if(restTimeList.size()==0){
                //按默认的生成
                List<PatientRestTime> systemList = patientRestTimeDao.findByPatient("system");
                systemList.forEach(one->{
                    PatientRestTime restTime = new PatientRestTime();
                    restTime.setPatient(patient);
                    restTime.setCreateTime(new Date());
                    restTime.setRestTime(one.getRestTime());
                    restTime.setType(one.getType());
                    restTimeList.add(restTime);
                });
                patientRestTimeDao.saveAll(restTimeList);
            }
            Map<String,String> map = restTimeList.stream().collect(Collectors.toMap(PatientRestTime::getType,PatientRestTime::getRestTime));
            return map;
        }
    }

    //修改居民作息时间
    public void updRestTime(String patient,String jsonData){
        List<PatientRestTime> restTimeList = patientRestTimeDao.findByPatient(patient);
        JSONObject json = JSON.parseObject(jsonData);
        for (PatientRestTime restTime:restTimeList){
            restTime.setRestTime(json.getString(restTime.getType()));
        }
        patientRestTimeDao.saveAll(restTimeList);
    }
}
