package com.yihu.jw.hospital.module.rehabilitation.controller;

/**
 * Created by 刘文彬 on 2018/8/31.
 */

import com.yihu.jw.entity.specialist.rehabilitation.PatientMedicalRecordsDO;
import com.yihu.jw.hospital.module.door.service.WlyyDoorServiceOrderService;
import com.yihu.jw.hospital.module.patient.service.PatientRestTimeService;
import com.yihu.jw.hospital.module.rehabilitation.service.RehabilitationGuidanceService;
import com.yihu.jw.hospital.module.rehabilitation.service.RehabilitationManageService;
import com.yihu.jw.hospital.module.rehabilitation.service.RehabilitationPlanService;
import com.yihu.jw.hospital.prescription.service.DrugsPlanService;
import com.yihu.jw.im.util.ImUtil;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.apache.commons.lang3.StringUtils;
import org.json.JSONArray;
import org.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;
import java.util.Map;

/**
 * Created by 刘文彬 on 2018/8/30.
 */
@RestController
@RequestMapping(value = "/patient/specialist/rehabilitation", produces = MediaType.APPLICATION_JSON_UTF8_VALUE)
@Api(description = "居民端-康复管理")
public class PatientRehabilitationManageController extends EnvelopRestEndpoint {

    @Autowired
    private RehabilitationManageService rehabilitationManageService;
    @Autowired
    private ImUtil imUtill;
    @Autowired
    private RehabilitationPlanService rehabilitationPlanService;
    @Autowired
    private RehabilitationGuidanceService rehabilitationGuidanceService;
    @Autowired
    private WlyyDoorServiceOrderService wlyyDoorServiceOrderService;

    @Autowired
    private JdbcTemplate jdbcTemplate;
    @Resource
    private PatientRestTimeService patientRestTimeService;
    @Autowired
    private DrugsPlanService drugsPlanService;
//    @Autowired
//    private GuahaoXMService guahaoXM;//挂号


    @RequestMapping(value = "selectPlanByPatient", method = RequestMethod.GET)
    @ApiOperation("康复管理-根据居民code查找康复计划")
    public String selectPlanByPatient(@ApiParam(name = "patient", value = "居民code", required = false)
                                          @RequestParam(value = "patient", required = false) String patient,
                                          @ApiParam(name = "status", value = "任务状态（0未完成，1已完成，2已预约）", required = false)
                                          @RequestParam(value = "status", required = false) Integer status) {
        try {
            List<Map<String, Object>> result = rehabilitationManageService.selectPlanByPatient(patient, status, null, null);
            return write(200, "获取成功", "data", result);
        } catch (Exception e) {
            return error(-1, "请求失败");
        }
    }


    @RequestMapping(value = "calendarPlanDetailItems", method = RequestMethod.GET)
    @ApiOperation("康复管理-康复计划服务项目按列表展示")
    public String calendarPlanDetailItems(
            @ApiParam(name = "executeStartTime", value = "日历开始时间（格式：yyyy-MM-dd HH:mm:ss）", required = false) @RequestParam(value = "executeStartTime", required = false) String executeStartTime,
            @ApiParam(name = "executeEndTime", value = "日历结束时间（格式：yyyy-MM-dd HH:mm:ss）", required = false) @RequestParam(value = "executeEndTime", required = false) String executeEndTime,
            @ApiParam(name = "planId", value = "计划id", required = true) @RequestParam(value = "planId", required = true) String planId,
            @ApiParam(name = "searchTask", value = "快速查找任务：（1、我的任务，2、健康教育，3、健康指导，4、随访，5、复诊）", required = false) @RequestParam(value = "searchTask", required = false) Integer searchTask,
            @ApiParam(name = "doctorCode", value = "医生code（专科医生、家庭医生）", required = false) @RequestParam(value = "doctorCode", required = false) String doctorCode,
            @ApiParam(name = "status", value = "任务状态（0未完成，1已完成，2已预约）", required = false) @RequestParam(value = "status", required = false) Integer status
    ) {
        try {
            if (!StringUtils.isNotEmpty(doctorCode)) {
                doctorCode = getRepUID();
            }
            List<Map<String, Object>> result = rehabilitationManageService.calendarPlanDetailItems(executeStartTime, executeEndTime, planId, searchTask, status, doctorCode);
            return write(200, "获取成功", "data", result);
        } catch (Exception e) {
            return error(-1, "请求失败");
        }
    }


    @RequestMapping(value = "patientRehabilitationDetail", method = RequestMethod.GET)
    @ApiOperation("康复管理-微信端-居民详情页")
    public String patientRehabilitationDetail(
            @ApiParam(name = "patient", value = "居民", required = true) @RequestParam(value = "patient", required = false) String patient
    ) {
        try {
            if (StringUtils.isNotBlank(patient)) {
                if (StringUtils.isNoneBlank(getRepresentedUID())) {
                    patient = getRepresentedUID();
                } else {
                    patient = getUID();
                }
            }
            JSONObject result = rehabilitationManageService.patientRehabilitationDetail(patient);
            return write(200, "获取成功！", "data", result);
        } catch (Exception e) {
            return error(-1, "请求失败");
        }
    }


    /**
     * doctorCode: 361aef4891de492cb0e6a47cf9fe31f3
     * patientInfo:
     * level: 1
     * area: 350200
     * diseaseCode:
     * turnDownState: 0
     * page: 1
     * pageSize: 10
     * doctorType: 2
     * filterPlan: 1
     */
    @RequestMapping(value = "selectBySpecialistDoctor", method = RequestMethod.GET)
    @ApiOperation("康复管理-获取签约专科居民")
    public String selectBySpecialistDoctor(
            @ApiParam(name = "doctorCode", value = "医生code", required = false) @RequestParam(value = "doctorCode", required = false) String doctorCode,
            @ApiParam(name = "doctorType", value = "医生类型（1专科2家医）", required = false) @RequestParam(value = "doctorType", required = false) String doctorType,
            @ApiParam(name = "patientInfo", value = "身份证或者姓名", required = false) @RequestParam(value = "patientInfo", required = false) String patientInfo,
            @ApiParam(name = "diseaseCode", value = "疾病类型code", required = false) @RequestParam(value = "diseaseCode", required = false) String diseaseCode,
            @ApiParam(name = "level", value = "1市2区3社区", required = false) @RequestParam(value = "level", required = false) String level,
            @ApiParam(name = "area", value = "区域", required = false) @RequestParam(value = "area", required = false) String area,
            @ApiParam(name = "page", value = "第几页，从1开始", required = true) @RequestParam(value = "page", required = false, defaultValue = "1") Integer page,
            @ApiParam(name = "pageSize", value = "每页分页大小", required = true) @RequestParam(value = "pageSize", required = false, defaultValue = "10") Integer pageSize,
            @ApiParam(name = "filterPlan", value = "是否过滤康复计划，1过滤，0或者放空不过滤", required = false) @RequestParam(value = "filterPlan", required = false) String filterPlan,
            @ApiParam(name = "turnDownState", value = "下转状态 0全部;1已下转;2已接受;3未下转", required = false) @RequestParam(value = "turnDownState", required = false, defaultValue = "0") String turnDownState
    ) {
        try {
            if (!StringUtils.isNotEmpty(doctorCode)) {
                doctorCode = getRepUID();
            }
            JSONObject result = rehabilitationManageService.selectBySpecialistDoctor(level, area, doctorCode, diseaseCode, page, pageSize, doctorType, patientInfo, filterPlan, turnDownState);
            JSONArray showList = result.getJSONArray("showList");
            JSONObject turnDownStateObj = result.getJSONObject("turnDownState");
            return write(200, "获取成功", "data", showList, "data2", turnDownStateObj);
        } catch (Exception e) {
            return error(-1, e.getMessage());
        }
    }

    /**
     * 获取为某患者创建康复计划的专科医生列表,家庭医生，
     *
     * @param patientCode 患者code
     * @return
     */
    @RequestMapping(value = "getPatientSpecialAndFamilyDoctor", method = RequestMethod.GET)
    @ApiOperation("获取为某患者创建康复计划的医生专科列表、家庭医生")
    public String getConsultDoctorForConsulting(@RequestParam("patientCode") String patientCode) {
        try {
            return write(200, "查询成功", "data", rehabilitationManageService.getPatientSpecialAndFamilyDoctor(patientCode));
        } catch (Exception e) {
            return error(-1, e.getMessage());
        }
    }


    @RequestMapping(value = "selectAllCompleteServiceItemsByPatient", method = RequestMethod.GET)
    @ApiOperation("康复计划主页动态")
    public String selectAllCompleteServiceItemsByPatient(@ApiParam(name = "patient", value = "居民Code", required = true)
                                                         @RequestParam(value = "patient", required = true) String patient) {
        try {
            return write(200, "获取成功", "data", rehabilitationManageService.selectAllCompleteServiceItemsByPatient(patient));
        } catch (Exception e) {
            return error(-1, e.getMessage());
        }
    }

    @RequestMapping(value = "selectAllPlaneByPatient", method = RequestMethod.GET)
    @ApiOperation("获取居民所有康复计划")
    public String getPatientAllRehabilitationPlan(@ApiParam(name = "patient", value = "居民Code", required = true)
                                                  @RequestParam(value = "patient", required = true) String patient) {
        try {
            return write(200, "获取成功", "data", rehabilitationManageService.getPatientAllRehabilitationPlan(patient, getUID()));
        } catch (Exception e) {
            return error(-1, e.getMessage());
        }
    }

    @RequestMapping(value = "calendarPlanDetailListBypatient", method = RequestMethod.GET)
    @ApiOperation("康复管理--某患者的康复计划按列表展示")
    public String calendarPlanDetailListBypatient(
            @ApiParam(name = "executeStartTime", value = "日历开始时间（格式：yyyy-MM-dd HH:mm:ss）", required = false) @RequestParam(value = "executeStartTime", required = false) String executeStartTime,
            @ApiParam(name = "executeEndTime", value = "日历结束时间（格式：yyyy-MM-dd HH:mm:ss）", required = false) @RequestParam(value = "executeEndTime", required = false) String executeEndTime,
            @ApiParam(name = "patient", value = "患者code", required = true) @RequestParam(value = "patient", required = true) String patient,
            @ApiParam(name = "searchTask", value = "快速查找任务：（1电话/短信关怀,2康复咨询,3健康监测,4上门服务,5康复指导,6康复随访,7康复复诊）", required = false) @RequestParam(value = "searchTask", required = false) Integer searchTask,
            @ApiParam(name = "doctorCode", value = "医生code（专科医生、家庭医生）", required = false) @RequestParam(value = "doctorCode", required = false) String doctorCode,
            @ApiParam(name = "status", value = "任务状态（0未完成，1已完成，2已预约）", required = false) @RequestParam(value = "status", required = false) Integer status,
            @ApiParam(name = "taskExecutor", value = "任务执行人：0全部；1我的任务：2他人任务", required = false) @RequestParam(value = "taskExecutor", required = false, defaultValue = "0") String taskExecutor
    ) {
        try {
            if (!StringUtils.isNotEmpty(doctorCode)) {
                doctorCode = getRepUID();
            }
            JSONArray result = rehabilitationManageService.calendarPlanDetailListBypatient(executeStartTime, executeEndTime, patient, searchTask, status, doctorCode, taskExecutor);
            return write(200, "获取成功", "data", result);
        } catch (Exception e) {
            return error(-1, e.getMessage());
        }
    }

    @RequestMapping(value = "selectPlanServerDoctor", method = RequestMethod.POST)
    @ApiOperation("康复管理-康复计划的服务医生")
    public String selectPlanServerDoctor(@ApiParam(name = "planId", value = "康复计划ID") @RequestParam(value = "planId", required = true) String planId) {

        try {
            String doctorCode = getRepUID();
            return write(200, "查询成功！", "data", rehabilitationManageService.selectPlanServerDoctor(planId, doctorCode));
        } catch (Exception e) {
            return error(-1, e.getMessage());
        }
    }


//    @RequestMapping(value = "getPatientInfo", method = RequestMethod.GET)
//    @ApiOperation("康复管理-获取居民信息")
//    public String getPatientInfo(@ApiParam(name = "patient", value = "居民信息", required = true)
//                                 @RequestParam(value = "patient", required = true) String patient,
//                                 @ApiParam(name = "planId", value = "计划id", required = true)
//                                 @RequestParam(value = "planId", required = true) String planId) {
//        try {
//            return write(200, "获取成功", "data", rehabilitationManageService.getPatientInfo(planId, patient));
//        } catch (Exception e) {
//            return error(-1, "请求失败");
//        }
//    }

    @RequestMapping(value = "selectByMedicalCode", method = RequestMethod.GET)
    @ApiOperation("获取医院病历")
    public String selectByMedicalCode(@ApiParam(name = "medical", value = "住院code", required = true)
                                      @RequestParam(value = "medical", required = true) String medical) {

        try {
            List<PatientMedicalRecordsDO> result = rehabilitationManageService.selectByMedicalCode(medical);
            try {
                String sql = "UPDATE `wlyy_patient_medical_records_rehabilitation` SET `patient_read_status`='1' WHERE (`code`='" + medical + "') ";
                jdbcTemplate.update(sql);
            } catch (Exception e) {
                e.printStackTrace();
            }
            return write(200, "获取成功！", "data", result);
        } catch (Exception e) {

            return error(-1, "请求失败");
        }
    }

    @RequestMapping(value = "selectByPatient", method = RequestMethod.GET)
    @ApiOperation("获取居民医院病历列表")
    public String selectByPatient(@ApiParam(name = "patient", value = "居民code", required = true)
                                  @RequestParam(value = "patient", required = true) String patient) {

        try {
            List<PatientMedicalRecordsDO> result = rehabilitationManageService.findByPatient(patient);
            return write(200, "获取成功！", "data", result);
        } catch (Exception e) {
            return error(-1, "请求失败");
        }
    }

//    @RequestMapping(value = "getPlantCodeByMedicalRecordsCode", method = RequestMethod.GET)
//    @ApiOperation("根据住院病历获取计划CODE")
//    public String getPlantCodeByMedicalRecordsCode(@ApiParam(name = "code", value = "住院病历CODE", required = true)
//                                                   @RequestParam(value = "code", required = true) String code) {
//        try {
//            return write(200, "获取成功！", "data", rehabilitationManageService.getPlantCodeByMedicalRecordsCode(code));
//        } catch (Exception e) {
//
//            return error(-1, "请求失败");
//        }
//    }


//    @RequestMapping(value = "calendarPlanDetail", method = RequestMethod.GET)
//    @ApiOperation("康复管理-康复计划按日历展示")
//    public String calendarPlanDetail(
//            @ApiParam(name = "executeStartTime", value = "日历开始时间（格式：yyyy-MM-dd HH:mm:ss）", required = true) @RequestParam(value = "executeStartTime", required = true) String executeStartTime,
//            @ApiParam(name = "executeEndTime", value = "日历结束时间（格式：yyyy-MM-dd HH:mm:ss）", required = true) @RequestParam(value = "executeEndTime", required = true) String executeEndTime,
//            @ApiParam(name = "planId", value = "计划id", required = true) @RequestParam(value = "planId", required = true) String planId,
//            @ApiParam(name = "searchTask", value = "快速查找任务：（1、我的任务，2、健康教育，3、复诊，4、随访）", required = false) @RequestParam(value = "searchTask", required = false) Integer searchTask,
//            @ApiParam(name = "status", value = "任务状态（0未完成，1已完成，2已预约）", required = false) @RequestParam(value = "status", required = false) Integer status) {
//        try {
//            ObjEnvelop objEnvelop = rehabilitationManageService.calendarPlanDetail(executeStartTime, executeEndTime, planId, searchTask, status, null);
//            return write(200, "获取成功", "data",objEnvelop );
//        } catch (Exception e) {
//            return error(-1, "请求失败");
//        }
//    }

    @RequestMapping(value = "serviceDoctorList", method = RequestMethod.GET)
    @ApiOperation("康复管理-微信端居民服务医生列表")
    public String serviceDoctorList() {
        try {
            String loginUserCode = getUID();
            JSONArray result = rehabilitationManageService.serviceDoctorList(loginUserCode);
            return write(200, "获取成功！", "data", result);
        } catch (Exception e) {
            return error(-1, "请求失败");
        }
    }


    @RequestMapping(value = "calendarPlanDetailList", method = RequestMethod.GET)
    @ApiOperation("康复管理-康复计划按列表展示-限定频次")
    public Envelop calendarPlanDetailList(
            @ApiParam(name = "executeStartTime", value = "日历开始时间（格式：yyyy-MM-dd HH:mm:ss）", required = true)
            @RequestParam(value = "executeStartTime", required = false)String executeStartTime,
            @ApiParam(name = "executeEndTime", value = "日历结束时间（格式：yyyy-MM-dd HH:mm:ss）", required = true)
            @RequestParam(value = "executeEndTime", required = false)String executeEndTime,
            @ApiParam(name = "planId", value = "计划id", required = true)
            @RequestParam(value = "planId", required = true)String planId,
            @ApiParam(name = "searchTask", value = "快速查找任务：（1电话/短信关怀,2康复咨询,3健康监测,4上门服务,5康复指导,6康复随访,7康复复诊 8全部）", required = false)
            @RequestParam(value = "searchTask", required = false)Integer searchTask,
            @ApiParam(name = "doctorCode", value = "医生code（专科医生、家庭医生）", required = false)
            @RequestParam(value = "doctorCode", required = false)String doctorCode,
            @ApiParam(name = "status", value = "任务状态（0未完成，1已完成，2已预约）", required = false)
            @RequestParam(value = "status", required = false)Integer status,
            @ApiParam(name="taskExecutor",value = "任务执行人：0全部；1我的任务：2他人任务",required = false)
            @RequestParam(value = "taskExecutor",required = false,defaultValue = "0")String taskExecutor
    ){
        try {
            if(!StringUtils.isNotEmpty(doctorCode)){
                doctorCode = getRepUID();
            }
            return rehabilitationManageService.calendarPlanDetailList(planId, searchTask, status, doctorCode, executeStartTime, executeEndTime, taskExecutor);
        }  catch (Exception e) {
            e.printStackTrace();
            return Envelop.getError("查询失败");
        }
    }


//    @RequestMapping(value = "calendarPlanDetailItems", method = RequestMethod.GET)
//    @ApiOperation("康复管理-康复计划服务项目按列表展示")
//    public String calendarPlanDetailItems(@ApiParam(name = "executeStartTime", value = "日历开始时间（格式：yyyy-MM-dd HH:mm:ss）", required = false)
//                                          @RequestParam(value = "executeStartTime", required = true) String executeStartTime,
//                                          @ApiParam(name = "executeEndTime", value = "日历结束时间（格式：yyyy-MM-dd HH:mm:ss）", required = false)
//                                          @RequestParam(value = "executeEndTime", required = true) String executeEndTime,
//                                          @ApiParam(name = "planId", value = "计划id", required = true)
//                                          @RequestParam(value = "planId", required = true) String planId,
//                                          @ApiParam(name = "searchTask", value = "快速查找任务：（1、我的任务，2、健康教育，3、健康指导，4、随访，5、复诊）", required = false)
//                                          @RequestParam(value = "searchTask", required = false) Integer searchTask,
//                                          @ApiParam(name = "status", value = "任务状态（0未完成，1已完成，2已预约）", required = false)
//                                          @RequestParam(value = "status", required = false) Integer status) {
//        try {
//            List<Map<String, Object>> result = rehabilitationManageService.calendarPlanDetailItems(executeStartTime, executeEndTime, planId, searchTask, status, null);
//            return write(200, "获取成功", "data", result);
//        } catch (Exception e) {
//
//            return error(-1, "请求失败");
//        }
//    }

//    @RequestMapping(value = "selectByGuidance", method = RequestMethod.GET)
//    @ApiOperation("康复管理-根据计划查询指导留言")
//    public String selectByGuidance(@ApiParam(name = "planId", value = "计划id", required = false)
//                                   @RequestParam(value = "planId", required = true) String planId,
//                                   @ApiParam(name = "itemCode", value = "服务项目code", required = true)
//                                   @RequestParam(value = "itemCode", required = true) String itemCode) {
//
//        try {
//            List<Map<String, Object>> mapList = rehabilitationManageService.selectByGuidance(planId, itemCode);
//            return write(200, "获取成功", "data", mapList);
//        } catch (Exception e) {
//            return error(-1, "请求失败");
//        }
//    }

//    @RequestMapping(value = "selectByPlanDetaiId", method = RequestMethod.GET)
//    @ApiOperation("康复管理-获取操作记录")
//    public String selectByPlanDetaiId(
//            @ApiParam(name = "planId", value = "计划id", required = true) @RequestParam(value = "planId", required = true) String planId,
//            @ApiParam(name = "code", value = "服务项目code", required = true) @RequestParam(value = "code", required = true) String code,
//            @ApiParam(name = "page", value = "", required = false) @RequestParam(value = "page", required = false) Integer page,
//            @ApiParam(name = "pagesize", value = "", required = false) @RequestParam(value = "pagesize", required = false) Integer pagesize) {
//        try {
//            return write(200, "获取成功", "data", rehabilitationManageService.selectByPlanDetaiId(null, planId, code, page, pagesize));//patient,
//        } catch (Exception e) {
//
//            return error(-1, "请求失败");
//        }
//    }


//    @GetMapping(value = "getPatientDrugsPlan")
//    @ApiOperation("获取居民用药计划")
//    public String getPatientDrugsPlan(
//            @ApiParam(name = "patient", value = "居民code", required = true) @RequestParam(value = "patient", required = true) String patient,
//            @ApiParam(name = "startTime", value = "开始时间", required = false) @RequestParam(value = "startTime", required = false) String startTime,
//            @ApiParam(name = "endTime", value = "结束时间", required = false) @RequestParam(value = "endTime", required = false) String endTime
//    ) {
//        try {
//            Map<String, List<Map<String, Object>>> result = drugsPlanService.getPatientDrugsPlan(patient, startTime, endTime);
//            return write(200, "获取成功", "data", result);
//        } catch (Exception e) {
//            return error(-1, e.getMessage());
//        }
//    }

    @GetMapping(value = "getPatientRestTime")
    @ApiOperation("获取居民作息时间")
    public String getPatientRestTime(
            @ApiParam(name = "patient", value = "居民code", required = true) @RequestParam(value = "patient", required = true) String patient
    ) {
        try {
            return write(200, "获取成功", "data", patientRestTimeService.getPatientRestTimeMap(patient));
        } catch (Exception e) {

            return error(-1, "请求失败");
        }
    }

    @PostMapping(value = "updRestTime")
    @ApiOperation("修改居民作息时间")
    public String updRestTime(
            @ApiParam(name = "patient", value = "居民code", required = true) @RequestParam(value = "patient", required = true) String patient,
            @ApiParam(name = "jsonData", value = "作息", required = true) @RequestParam(value = "jsonData", required = true) String jsonData) {
        try {
            patientRestTimeService.updRestTime(patient, jsonData);
            return write(200, "修改成功");
        } catch (Exception e) {
            return error(-1, "请求失败");
        }
    }

//    @RequestMapping(value = "getPatientDrugList", method = RequestMethod.GET)
//    @ApiOperation("获取居民出院带药列表")
//    public String getPatientDrugList(@ApiParam(name = "patient", value = "居民Code", required = true)
//                                     @RequestParam(value = "patient", required = true) String patient) {
//        try {
//            return write(200, "获取成功", "data", rehabilitationManageService.getPatientDrugList(patient));
//        } catch (Exception e) {
//            return error(-1,e.getMessage());
//        }
//    }

//    @RequestMapping(value = "sendMessageIm", method = RequestMethod.POST)
//    @ApiOperation("康复管理-扫描二维码发送消息")
//    public String sendMessageIm(@ApiParam(name = "sendId", value = "发送者id") @RequestParam(value = "sendId", required = true) String sendId,
//                                @ApiParam(name = "receiverId", value = "接受者id", required = true) @RequestParam(value = "receiverId", required = true) String receiverId,
//                                @ApiParam(name = "content", value = "内容", required = true) @RequestParam(value = "content", required = true) String content) {
//        try {
//            imUtill.sendMessage(sendId, receiverId, "1", content);
//            rehabilitationManageService.sendMessage(sendId, receiverId, content);//发送康复下转邀请
//            return write(200, "发送成功！");
//        } catch (Exception e) {
//            return error(-1, "发送失败！");
//        }
//    }

//    @RequestMapping(value = "checkAfterQrCode", method = RequestMethod.POST)
//    @ApiOperation("康复管理-居民扫码后验证是否是关联的居民扫码")
//    public String checkAfterQrCode(@ApiParam(name = "planDetailId", value = "康复计划项目明细ID") @RequestParam(value = "planDetailId", required = true) String planDetailId,
//                                   @ApiParam(name = "patientCode", value = "居民端登录的居民code") @RequestParam(value = "patientCode", required = true) String patientCode) {
//        try {
//            JSONObject result = rehabilitationManageService.checkAfterQrCode(planDetailId, patientCode);
//            return write(200, String.valueOf(result.get("message")), "data", result.getJSONObject("obj"));
//        } catch (Exception e) {
//
//            return error(-1, "验证失败");
//        }
//    }

//    @RequestMapping(value = "saveRehabilitationOperateRecord", method = RequestMethod.POST)
//    @ApiOperation("康复管理-新增operateRecord")
//    public String saveRehabilitationOperateRecord(@ApiParam(name = "dataJson", value = "实体json", defaultValue = "{\"rehabilitationDetailId\":\"402803f6657f195301657f4fbd3c0001\",\"patientCode\":\"00\",\"patientName\":\"11\",\"doctorCode\":\"22\",\"doctorName\":\"33\",\"node\":\"jjjjjj\",\"relationRecordType\":\"4\",\"relation_record_code\":\"55\",\"relationRecordImg\":\"666666\",\"status\":\"0\"}") @RequestParam(value = "dataJson", required = true) String dataJson) {
//
//        try {
//            JSONObject result = rehabilitationManageService.saveRehabilitationOperateRecord(dataJson);
//            if (result.getInt("status") == 200) {
//                return write(200, "新增康复计划日志成功！", "data", result.getJSONObject("obj"));
//            } else {
//                return error(-1, result.getString("message"));
//            }
//        } catch (Exception e) {
//
//            return error(-1, "新增康复计划日志失败！");
//        }
//    }

//    @RequestMapping(value = "recentPlanDetailRecord", method = RequestMethod.GET)
//    @ApiOperation("康复管理-近期康复相关记录")
//    public String recentPlanDetailRecord(@ApiParam(name = "patientCode", value = "居民code", required = false)
//                                         @RequestParam(value = "patientCode", required = false) String patientCode,
//                                         @ApiParam(name = "startTime", value = "开始时间（格式：yyyy-MM-dd HH:mm:ss）", required = false)
//                                         @RequestParam(value = "startTime", required = false) String startTime,
//                                         @ApiParam(name = "endTime", value = "结束时间（格式：yyyy-MM-dd HH:mm:ss）", required = false)
//                                         @RequestParam(value = "endTime", required = false) String endTime,
//                                         @ApiParam(name = "page", value = "第几页，从1开始", required = true)
//                                         @RequestParam(value = "page", required = false, defaultValue = "1") Integer page,
//                                         @ApiParam(name = "pageSize", value = "每页分页大小", required = true)
//                                         @RequestParam(value = "pageSize", required = false, defaultValue = "10") Integer pageSize) {
//
//        try {
//            if (!StringUtils.isNotEmpty(patientCode)) {
//                patientCode = getUID();
//            }
//            JSONObject result = rehabilitationManageService.recentPlanDetailRecord(patientCode, startTime, endTime, page, pageSize);
//            return write(200, "获取成功！", "data", result);
//        } catch (Exception e) {
//
//            return error(-1, "请求失败");
//        }
//    }

//    @RequestMapping(value = "serviceItemList", method = RequestMethod.GET)
//    @ApiOperation("康复管理-多个康复计划服务项目内容列表")
//    public String serviceItemList(@ApiParam(name = "planDetailIds", value = "康复计划多个服务项目id（多个‘，’分隔）", required = true)
//                                  @RequestParam(value = "planDetailIds", required = true) String planDetailIds) {
//
//        try {
//            JSONArray result = rehabilitationManageService.serviceItemList(planDetailIds, null);
//            return write(200, "获取成功", "data", result);
//        } catch (Exception e) {
//            return error(-1, "请求失败");
//        }
//    }

//    @RequestMapping(value = "serviceItem", method = RequestMethod.GET)
//    @ApiOperation("康复管理-康复计划服务项目确认详情页")
//    public String serviceItem(@ApiParam(name = "planDetailId", value = "康复计划服务项目id", required = true)
//                              @RequestParam(value = "planDetailId", required = true) String planDetailId,
//                              @ApiParam(name = "recordId", value = "记录id", required = false)
//                              @RequestParam(value = "recordId", required = false) String recordId) {
//
//        try {
//            JSONObject result = rehabilitationManageService.serviceItem(planDetailId, null, recordId);
//            return write(200, "获取成功", "data", result);
//        } catch (Exception e) {
//            return error(-1, "请求失败");
//        }
//    }

    @RequestMapping(value = "planSchedule", method = RequestMethod.GET)
    @ApiOperation("康复管理-计划总进度")
    public String planSchedule(@ApiParam(name = "planId", value = "计划id", required = true)
                               @RequestParam(value = "planId", required = true) String planId,
                               @ApiParam(name = "patientCode", value = "居民code", required = false)
                               @RequestParam(value = "patientCode", required = false) String patientCode) {

        try {
            if (!StringUtils.isNotEmpty(patientCode)) {
                patientCode = getRepUID();
            }
            JSONObject result = rehabilitationManageService.planSchedule(planId, patientCode);
            try {
                String sql = "UPDATE `wlyy_specialist`.`wlyy_patient_rehabilitation_plan` SET `patient_read_status`='1' WHERE (`id`='" + planId + "') ";
                jdbcTemplate.update(sql);
            } catch (Exception e) {
                e.printStackTrace();
            }
            return write(200, "获取成功！", "data", result);
        } catch (Exception e) {
            return error(-1, "请求失败");
        }
    }

//    @RequestMapping(value = "updatePatientImgById", method = RequestMethod.POST)
//    @ApiOperation("更新康复计划居民签名照/证件照")
//    public String updatePatientImgById(@ApiParam(name = "planId", value = "康复计划id", required = true)
//                                       @RequestParam(value = "planId") String planId,
//                                       @ApiParam(name = "patientImg", value = "居民签名/证件照地址")
//                                       @RequestParam(value = "patientImg") String patientImg) {
//
//        try {
//            rehabilitationPlanService.updatePatientImgById(planId, patientImg);
//            return write(200, "更新成功！");
//        } catch (Exception e) {
//
//            return error(-1, "更新失败");
//        }
//    }

//    @RequestMapping(value = "getServiceItemsAfterStop", method = RequestMethod.GET)
//    @ApiOperation("康复管理-已执行项目清单")
//    public String getServiceItemsAfterStop(@ApiParam(name = "planId", value = "康复计划id", required = true)
//                                           @RequestParam(value = "planId", required = true) String planId) {
//
//        try {
//            return write(200, "操作成功！", "data", rehabilitationPlanService.getServiceItemsAfterStop(planId));
//        } catch (Exception e) {
//            return error(-1, "请求失败");
//        }
//    }

//    @RequestMapping(value = "selectByRelationCodeAndGuidance", method = RequestMethod.GET)
//    @ApiOperation("康复管理-根据业务code查找康复指导")
//    public String selectByRelationCodeAndGuidance(@ApiParam(name = "relationCode", value = "业务关联code", required = false)
//                                                  @RequestParam(value = "relationCode", required = false) String relationCode,
//                                                  @ApiParam(name = "patient", value = "居民code", required = false)
//                                                  @RequestParam(value = "patient", required = false) String patient,
//                                                  @ApiParam(name = "doctor", value = "医生code", required = false)
//                                                  @RequestParam(value = "doctor", required = false) String doctor) {
//
//        try {
//            return write(200, "请求成功！", "data", rehabilitationGuidanceService.selectByRelationCode(patient, doctor, relationCode));
//        } catch (Exception e) {
//            return error(-1, "请求失败");
//        }
//    }

//    @GetMapping(value = "selectRelationCodeAndDoor")
//    @ResponseBody
//    @ApiOperation("业务关联code--上门服务")
//    public String selectRelationCodeAndDoor(@ApiParam(name = "relationCode", value = "业务关联code", required = true)
//                                            @RequestParam String relationCode) {
//        try {
//            return write(200, "请求成功！", "data", wlyyDoorServiceOrderService.selectRelationCode(relationCode));
//        } catch (Exception e) {
//            return error(-1, "请求失败");
//        }
//    }


    @RequestMapping(value = "selectGuidances", method = RequestMethod.GET)
    @ApiOperation("康复管理-查看指导列表")
    public String selectType(
            @ApiParam(name = "type", value = "康复指导类型", required = false) @RequestParam(value = "type", required = false) Integer type,
            @ApiParam(name = "id", value = "康复指导模板id", required = false) @RequestParam(value = "id", required = false) String id,
            @ApiParam(name = "title", value = "康复指导名称", required = false) @RequestParam(value = "title", required = false) String title,
            @ApiParam(name = "planId", value = "计划id", required = false) @RequestParam(value = "planId", required = false) String planId,
            @ApiParam(name = "page", value = "页码", required = false) @RequestParam(value = "page", required = false) Integer page,
            @ApiParam(name = "pagesize", value = "每页大小", required = false) @RequestParam(value = "pagesize", required = false) Integer pagesize
    ) {

        try {
            return write(200, "请求成功！", "data", rehabilitationGuidanceService.select(title, type, id, planId, page, pagesize));
        } catch (Exception e) {
            return error(-1, "请求失败");
        }
    }

//    @RequestMapping(value = "selectPlanDetailByPlanId", method = RequestMethod.GET)
//    @ApiOperation("康复管理-查看其它服务计划")
//    public String selectPlanDetailByPlanId(
//            @ApiParam(name = "planId", value = "计划id", required = true) @RequestParam(value = "planId", required = true) String planId,
//            @ApiParam(name = "planDetailId", value = "计划详情id", required = true) @RequestParam(value = "planDetailId", required = true) String planDetailId,
//            @ApiParam(name = "itemId", value = "服务项目code", required = true) @RequestParam(value = "itemId", required = true) String itemId
//    ) {
//
//        try {
//            return write(200, "请求成功！", "data", rehabilitationManageService.selectPlanDetailByPlan(planId, planDetailId, itemId));
//        } catch (Exception e) {
//            return error(-1, "请求失败");
//        }
//    }

    @GetMapping(value = "selectRelationCode")
    @ResponseBody
    @ApiOperation("业务关联code")
    public String selectRelationCode(
            @ApiParam(name = "relationCode", value = "业务关联code", required = true) @RequestParam String relationCode
    ) {
        try {
            return write(200, "请求成功！", "data", wlyyDoorServiceOrderService.selectRelationCode(relationCode));
        } catch (Exception e) {
            return error(-1, "请求失败");
        }
    }


    @RequestMapping(value = "selectByRelationCode", method = RequestMethod.GET)
    @ApiOperation("康复管理-根据业务code查找康复指导")
    public String selectByRelationCode(
            @ApiParam(name = "relationCode", value = "业务关联code", required = false) @RequestParam(value = "relationCode", required = false) String relationCode,
            @ApiParam(name = "patient", value = "居民code", required = false) @RequestParam(value = "patient", required = false) String patient,
            @ApiParam(name = "doctor", value = "医生code", required = false) @RequestParam(value = "doctor", required = false) String doctor
    ) {
        try {
            return write(200, "请求成功！", "data", rehabilitationGuidanceService.selectByRelationCode(patient, doctor, relationCode));
        } catch (Exception e) {
            return error(-1, "请求失败");
        }
    }

//    @RequestMapping(value = "getDiseaseTopicInfo", method = RequestMethod.GET)
//    @ApiOperation("获取居民疾病专题首页相关数据")
//    public String getDiseaseTopicInfo(@ApiParam(name = "patientCode", value = "住院病历CODE", required = true)
//                                      @RequestParam(value = "patientCode", required = true) String patientCode,
//                                      @ApiParam(name = "diseaseType", value = "疾病类型", required = true)
//                                      @RequestParam(value = "diseaseType", required = true) String diseaseType) {
//        try {
//            com.alibaba.fastjson.JSONObject object = new com.alibaba.fastjson.JSONObject();
//            object.put("patientId", getUID());
//            return write(200, "获取成功！", "data", rehabilitationManageService.getDiseaseTopicInfo(object, patientCode, diseaseType));
//        } catch (Exception e) {
//
//            return error(-1, "请求失败");
//        }
//    }

//    @RequestMapping(value = "getDiseaseHospital", method = RequestMethod.GET)
//    @ApiOperation("获取入住疾病的医院列表")
//    public String getDiseaseHospital(
//            @ApiParam(name = "diseaseType", value = "疾病类型", required = true) @RequestParam(value = "diseaseType", required = true) String diseaseType,
//            @ApiParam(name = "name", value = "医院名称", required = false) @RequestParam(value = "name", required = false) String name,
//            @ApiParam(name = "page", value = "页码", required = false) @RequestParam(value = "page", required = false) Integer page,
//            @ApiParam(name = "pagesize", value = "每页大小", required = false) @RequestParam(value = "pagesize", required = false) Integer pagesize
//    ) {
//        try {
//            if (page == null) {
//                page = 1;
//            }
//            if (pagesize == null) {
//                pagesize = 15;
//            }
//            return write(200, "获取成功！", "data", rehabilitationManageService.getDiseaseHospital(diseaseType, name, page, pagesize));
//        } catch (Exception e) {
//            return error(-1, "请求失败");
//        }
//    }

}
