package com.yihu.jw.hospital.module.rehabilitation.dao;


import com.yihu.jw.entity.rehabilitation.PatientDischargeDO;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;

import java.util.List;

/**
 * Created by liub on 2020/9/16.
 */
public interface PatientDischargeDao extends PagingAndSortingRepository<PatientDischargeDO, Long>, JpaSpecificationExecutor<PatientDischargeDO> {

    List<PatientDischargeDO> findAllByCreateUser(String createUser);

    List<PatientDischargeDO> queryByCreateUserAndPatientIn(String createUser,String[] patient);
    // //查询下转是否存在该患者 :sign_status=1（包括type==null,type==2） 1.6.8后新增未家签的也能添加患者判断条件(d.type=2 and sign_status=0)
    @Query(value = "select count(1) from PatientDischargeDO p where p.idcard = ?1 and p.createUser=?2 and (p.signStatus=1 and ( p.type is null or p.type=2) or (p.type=2 and p.signStatus=0))")
    int isPatientExist(String idcard, String createUser);
}
