package com.yihu.jw.hospital.module.rehabilitation.dao;

import com.yihu.jw.entity.specialist.rehabilitation.RehabilitationPatientInfoDO;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;

import java.util.Date;
import java.util.List;

/**
 * Created by liub on 2020/11/4.
 */
public interface RehabilitationPatientInfoDao extends PagingAndSortingRepository<RehabilitationPatientInfoDO, Long>,
        JpaSpecificationExecutor<RehabilitationPatientInfoDO> {

    @Query(value = "select r from RehabilitationPatientInfoDO r where (r.status =0 or r.status is null )")
    List<RehabilitationPatientInfoDO> findUnDispation();

    @Query(value = "select r from RehabilitationPatientInfoDO r where r.status =?1")
    List<RehabilitationPatientInfoDO> findUnDispationByStatus(Integer status);

    @Modifying
    @Query(value = "update RehabilitationPatientInfoDO r set r.status=?1 where r.code = ?2")
    int updateState(Integer state, String code);


    @Query(value="select r.* from wlyy_rehabilitation_patient_info r where (r.status =0 or r.status is null ) " +
            " and r.create_time>=?1 group by r.idcard,DATE_FORMAT(r.create_time,'%Y-%m-%d')  ",nativeQuery = true)
    List<RehabilitationPatientInfoDO> findUnDispation(Date preTime);

    @Query(value="select r.* from wlyy_rehabilitation_patient_info r where (r.status =0 or r.status is null ) " +
            " and r.hospital_code=?2 and r.create_time>=?1 group by r.idcard,DATE_FORMAT(r.create_time,'%Y-%m-%d')  ",nativeQuery = true)
    List<RehabilitationPatientInfoDO> findUnDispation(Date preTime,String hospital);

    @Query(value="select r.* from wlyy_rehabilitation_patient_info r where r.status =?1 " +
            " and r.create_time>=?2 group by r.idcard,DATE_FORMAT(r.create_time,'%Y-%m-%d') ",nativeQuery = true)
    List<RehabilitationPatientInfoDO> findUnDispationByStatus(Integer status,Date preTime);

    @Query(value="select r.* from wlyy_rehabilitation_patient_info r where r.status =?1 " +
            " and r.hospital_code=?3 and r.create_time>=?2 group by r.idcard,DATE_FORMAT(r.create_time,'%Y-%m-%d') ",nativeQuery = true)
    List<RehabilitationPatientInfoDO> findUnDispationByStatus(Integer status,Date preTime,String hospital);

    @Query(value="select r from RehabilitationPatientInfoDO r where r.idcard=?1 and r.createTime>=?2 and r.createTime<=?3 ")
    List<RehabilitationPatientInfoDO> findByIdcardAndCreateTime(String status,Date preTimeStart,Date preTimeEnd);

    @Query(value="select r from RehabilitationPatientInfoDO r where r.code=?1 ")
    RehabilitationPatientInfoDO findByCode(String code);
//    @Modifying
//    @Query(value="update RehabilitationPatientInfoDO r set r.status=?1 where r.code = ?2")
//    int updateState(Integer state, String code);


}

