package com.yihu.jw.hospital.module.rehabilitation.service;



import com.yihu.jw.entity.specialist.rehabilitation.PatientDiagnosisInformationDO;
import com.yihu.jw.hospital.module.rehabilitation.dao.PatientDiagnosisInformationDao;
import com.yihu.jw.mysql.query.BaseJpaService;
import com.yihu.jw.restmodel.web.Envelop;
import com.yihu.jw.restmodel.web.ObjEnvelop;
import com.yihu.jw.restmodel.web.PageEnvelop;
import com.yihu.jw.rm.specialist.SpecialistMapping;
import org.apache.commons.collections.map.HashedMap;
import org.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * Created by humingfen on 2019/1/11.
 */
@Service
@Transactional
public class DiagnosisInformationService extends BaseJpaService<PatientDiagnosisInformationDO, PatientDiagnosisInformationDao> {

    @Autowired
    private PatientDiagnosisInformationDao diagnosisInformationDao;

    /**
     * 保存诊疗信息
     * @param diagnosisInformationDO
     * @return
     */
    public Envelop createDiagnosisInformation(PatientDiagnosisInformationDO diagnosisInformationDO) {

//        JSONObject json = new JSONObject();
//        json.put("patient", patient);
//        json.put("patientName", patientName);
//        json.put("hospital", hospital);
//        json.put("hospitalName", hospitalName);
//        json.put("planId", planId);
//        json.put("department", department);
//        json.put("attendingDoctorName", attendingDoctorName);
//        List<Doctor> d = doctorDao.findDoctorByName(attendingDoctorName);
//        if(d != null && d.size() == 1){
//            json.put("attendingDoctorCode", d.get(0).getCode());
//        }
//        json.put("admittingDiagnosis", admittingDiagnosis);
//        json.put("dischargeDiagnosis", dischargeDiagnosis);
//        json.put("advice", advice);
//        json.put("createUser", doctor.getCode());
//        json.put("createUserName", doctor.getName());
//        json.put("dischargeTime", dischargeTime);
//        Map<String, Object> param = new HashedMap();
//        param.put("diagnosisInformationJson", json.toString());
//        PatientDiagnosisInformationDO diagnosisInformationDO = objectMapper.readValue(diagnosisInformationJson, PatientDiagnosisInformationDO.class);


        Date date = new Date();
        diagnosisInformationDO.setCreateTime(date);
        diagnosisInformationDao.save(diagnosisInformationDO);
        return Envelop.getSuccess(SpecialistMapping.api_success);
    }

    /**
     * 根据康复计划查找诊疗信息
     * @param planId
     * @return
     */
    public ObjEnvelop findDiagnosisInformationByPlanId(String planId) {
        return ObjEnvelop.getSuccess(SpecialistMapping.api_success, diagnosisInformationDao.findByPlanId(planId));
    }

    /**
     * 获取居民诊疗信息记录
     * @param patient
     * @param page
     * @param size
     * @return
     */
    public PageEnvelop findDiagnosisInformationByPatient(String patient, Integer page, Integer size) {
        PageRequest pageRequest = PageRequest.of(page, size);
        Page<PatientDiagnosisInformationDO> list = diagnosisInformationDao.findByPatient(patient,pageRequest);
        return PageEnvelop.getSuccessListWithPage(SpecialistMapping.api_success, list.getContent(), page, size,list.getTotalElements());
    }
}
