package com.yihu.jw.hospital.module.rehabilitation.service;

import com.yihu.jw.entity.base.patient.BasePatientDO;
import com.yihu.jw.entity.hospital.DmHospitalDO;
import com.yihu.jw.entity.patient.PatientEvent;
import com.yihu.jw.hospital.HospitalDao;
import com.yihu.jw.hospital.module.jw.service.JwArchivesService;
import com.yihu.jw.hospital.module.jw.service.JwSmjkService;
import com.yihu.jw.patient.dao.BasePatientDao;
import com.yihu.jw.patient.dao.PatientEventDao;
import com.yihu.jw.patient.service.BasePatientService;
import com.yihu.jw.util.date.DateUtil;
import com.yihu.jw.util.security.MD5;
import org.apache.commons.lang3.StringUtils;
import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.transform.Transformers;
import org.json.JSONArray;
import org.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.io.ClassPathResource;
import org.springframework.core.io.Resource;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import java.io.*;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.text.SimpleDateFormat;
import java.util.*;
import java.util.stream.Collectors;


/**
 * Created by hzp on 2016/11/24.
 * 市民健康档案服务
 */
@Service
public class PatientRecordService {


    @Autowired
    private JdbcTemplate jdbcTemplate;

    @Autowired
    private BasePatientService patientService;

    @Autowired
    private StringRedisTemplate redisTemplate;
    @Autowired
    private RehabilitationInfoService rehabilitationInfoService;
    @Autowired
    private BasePatientDao patientDao;
    @Autowired
    private PatientEventDao patientEventDao;
    @Autowired
    private PatientRecordService patientRecordService;

    @Autowired
    private HospitalDao hospitalDao;

    @Autowired
    private JwSmjkService jwSmjkService;

    @Autowired
    private JwArchivesService jwArchivesService;
    
//    @Autowired
//    private MedicalDao medicalDao;
//
//    @Autowired
//    private MedicalDetailDao medicalDetailDao;

//    import com.yihu.wlyy.service.service.ArchivesService;
//    @Autowired
//    private ArchivesService archivesService;

    @PersistenceContext
    private EntityManager entityManager;


    /**
     * 获取本地示例返参
     *
     * @param fid 服务id
     * @return
     * @throws Exception
     */
    public String getJosnFileResullt(String fid) throws Exception {
        if("event2".equals(fid)){
            return "{\"msg\":\"获取就诊记录成功！\",\"data\":[{\"orgName\":\"厦门大学附属中山医院\",\"createTime\":\"2014-11-03 00:00:00\",\"patient\":\"386a35b8d17a47cbab6174ae7952b9b6\",\"orgCode\":\"3\",\"dataFrom\":\"1\",\"id\":\"7cbc0159-3a6a-48e6-8a4b-fc085885be32\",\"eventType\":\"2\",\"dianosis\":\"结肠多发腺瘤尼龙绳结扎＋电切术\",\"eventDate\":\"2014-11-03 00:00:00\"},{\"orgName\":\"厦门大学附属心血管病医院\",\"createTime\":\"2013-09-26 10:13:38\",\"patient\":\"386a35b8d17a47cbab6174ae7952b9b6\",\"orgCode\":\"182\",\"dataFrom\":\"1\",\"id\":\"9f35ff1f-f683-4f3c-a0a5-7ff8ef3df89e\",\"eventType\":\"2\",\"dianosis\":\"高血压2级\",\"eventDate\":\"2013-09-26 10:13:38\"}],\"status\":200}";
        }
        String contentStr = null;
        Resource resource = new ClassPathResource("mqConfig/mqdata/" + fid + ".json");
        if (resource.exists()) {
            InputStream is = resource.getInputStream();
            contentStr = new BufferedReader(new InputStreamReader(is, "utf-8"))
                    .lines().collect(Collectors.joining(System.lineSeparator()));
//            contentStr =  replaceSpecialStr(contentStr);
        } else {
            throw new RuntimeException("文件不存在");
        }
        return contentStr;
    }


    /**
     * 字符串List排序
     */
    public List<Map<String, String>> sortMapList(List<Map<String, String>> mapList, final String sort, final String order) {
        Collections.sort(mapList, new Comparator<Map<String, String>>() {
            @Override
            public int compare(Map<String, String> o1, Map<String, String> o2) {
                String map1value = o1.get(sort);
                String map2value = o2.get(sort);
                if ("DESC".equals(order.toUpperCase())) {
                    return map2value.compareTo(map1value);
                } else {
                    return map1value.compareTo(map2value);
                }
            }
        });
        return mapList;
    }
    /******************************************************************************************************************/
    /**
     * 新的住院记录接口
     *
     * @param patientCode
     * @param type
     * @param page
     * @param pageSize
     * @param lastTime
     * @param hospital
     * @return
     * @throws Exception
     */
    @Transactional(propagation = Propagation.NOT_SUPPORTED)
    public List<Map<String, String>> getAllEvent_new(String patientCode, String type, String page, String pageSize, String lastTime, String hospital) throws Exception {
        //获取患者
        BasePatientDO patient = patientDao.findById(patientCode).orElse(null);
        DmHospitalDO hos = hospitalDao.findByCode(hospital);


        //获取基卫数据--
        List hlsit = new ArrayList();
        hlsit.add("922b91b8-5aff-11e6-8344-fa163e8aee56");//厦门市中医院
        hlsit.add("0a0b4ec0-5b04-11e6-8344-fa163e8aee56");//厦门大学附属第一医院
        hlsit.add("97fbc7707643471b8458-6def1ff92496");//厦门大学附属心血管病医院
        hlsit.add("0a11148d-5b04-11e6-8344-fa163e8aee56");//厦门市海沧医院
        hlsit.add("8d94ce907e4d4356b68f6c5d4d0d6bc9");//厦门市妇幼保健院
        hlsit.add("922b8fa9-5aff-11e6-8344-fa163e8aee56");//厦门大学附属中山医院
        if (hlsit.contains(hospital)) {
            List<Map<String, String>> map = rehabilitationInfoService.getEmrList(patient.getIdcard(), null, null, Integer.parseInt(page), Integer.parseInt(pageSize));
            if (map.size() > 0) {
                return map;
            }
        }

        return new ArrayList<>();
    }


    /**
     * 获取门/急诊记录 + 住院记录
     */
    public List<Map<String, String>> getAllEvent(String patientCode, String type, String page, String pageSize, String lastTime) throws Exception {
        List<Map<String, String>> re = new ArrayList<>();

        //获取患者
        BasePatientDO patient = patientDao.findById(patientCode).orElse(null);
        //获取基卫数据
        String response = jwSmjkService.getResidentEventListJson(patient.getSsc(), type, page, pageSize);

        //获取app数据
        List<PatientEvent> eventList = new ArrayList<>();

        if (StringUtils.isEmpty(type)) {
            eventList = patientEventDao.findByPatient(patientCode);
        } else {
            eventList = patientEventDao.findByPatientAndEventType(patientCode, type);
        }

        if (!StringUtils.isEmpty(response)) {
            JSONArray array = new JSONArray(response);
            String max = "";
            String min = "";
            if (!"[{}]".equals(response)) {
                for (int i = 0; i < array.length(); i++) {
                    JSONObject item = array.getJSONObject(i);
                    if (i == 0) //最大值
                    {
                        max = item.optString("END_TIME");
                    } else if (i == array.length() - 1) //最小值
                    {
                        min = item.optString("END_TIME");
                    }

                    Map<String, String> map = new HashMap<>();
                    map.put("id", item.optString("EVENT"));
                    map.put("patient", patientCode);
                    map.put("eventDate", item.optString("END_TIME"));
                    map.put("eventType", item.optString("TYPE"));
                    map.put("orgName", item.optString("ORG_NAME"));
                    map.put("orgCode", item.optString("ORG_ID"));
                    map.put("dianosis", item.optString("DIAGNOSIS"));
                    map.put("createTime", item.optString("END_TIME"));
                    map.put("dataFrom", "1");//基卫数据
                    re.add(map);
                }
            }

            //过滤
            for (PatientEvent item : eventList) {
                String eventDate = DateUtil.dateToStrLong(item.getEventDate());
                int maxCompare = eventDate.compareTo(max);
                int minCompare = eventDate.compareTo(min);
                Boolean contain = false;
                if (maxCompare < 0 && minCompare >= 0)       //时间范围内
                {
                    contain = true;
                }

                //第一页特殊处理
                if ("1".equals(page) && maxCompare >= 0) {
                    contain = true;
                }

                //最后一页特殊处理
                if (!"1".equals(page) && (array.length() == 0 || "[{}]".equals(response)) && !StringUtils.isEmpty(lastTime)) {
                    int lastTimeCompare = eventDate.compareTo(lastTime);
                    if (lastTimeCompare < 0) {
                        contain = true;
                    }
                }

                if (contain) {
                    Map<String, String> map = new HashMap<>();
                    map.put("id", item.getId().toString());
                    map.put("patient", item.getPatient());
                    map.put("eventDate", DateUtil.dateToStrLong(item.getEventDate()));
                    map.put("eventType", item.getEventType());
                    map.put("orgName", item.getOrgName());
                    map.put("orgCode", item.getOrgCode());
                    map.put("dianosis", item.getDianosis());
                    map.put("createTime", DateUtil.dateToStrLong(item.getCreateTime()));
                    map.put("dataFrom", "2");   //APP数据
                    re.add(map);
                }
            }

            //排序
            re = sortMapList(re, "eventDate", "DESC");
        } else {
            if ("1".equals(page)) {
                for (PatientEvent item : eventList) {
                    Map<String, String> map = new HashMap<>();
                    map.put("id", item.getId().toString());
                    map.put("patient", item.getPatient());
                    map.put("eventDate", DateUtil.dateToStrLong(item.getEventDate()));
                    map.put("eventType", item.getEventType());
                    map.put("orgName", item.getOrgName());
                    map.put("orgCode", item.getOrgCode());
                    map.put("dianosis", item.getDianosis());
                    map.put("createTime", DateUtil.dateToStrLong(item.getCreateTime()));
                    map.put("dataFrom", "2");   //APP数据
                    re.add(map);
                }
            }
        }

        return re;
    }

    /**
     * 基卫通过event获取档案类型列表
     */
    public List<Map<String, String>> getEventCatalog(String patientCode, String strEvent) throws Exception {
        //获取患者
        BasePatientDO patient = patientDao.findById(patientCode).orElse(null);
        List<Map<String, String>> re = new ArrayList<>();

        String response = jwSmjkService.getEventCatalog(patient.getSsc(), strEvent);   //【基卫接口】
        JSONObject json = new JSONObject(response);
        JSONArray array = json.getJSONArray("RecordList");

        if (array != null && array.length() > 0) {
            for (int i = 0; i < array.length(); i++) {
                JSONObject item = array.getJSONObject(i);
                Map<String, String> map = new HashMap<>();
                map.put("catalog", item.optString("CATALOG_CODE"));
                map.put("title", item.optString("TITLE"));
                map.put("serial", item.optString("SERIAL"));
                re.add(map);
            }
        }
        return re;
    }

    /**
     * 获取健康档案信息详情
     */
//    public String getHealthData(String patientCode, String strEvent, String strCatalog, String strSerial) throws Exception {
//        //获取患者
//        BasePatientDO patient = patientDao.findById(patientCode).orElse(null);
//
//        String respon = jwSmjkService.getHealthData(patient.getSsc(), strEvent, strCatalog, strSerial);  //【基卫接口】
//
//
//        return respon;
//    }


    /**
     * 获取检查检验列表
     */
    public List<Map<String, String>> getExamAndLabReport(String patientCode, String page, String pageSize, String lastTime) throws Exception {
        List<Map<String, String>> re = new ArrayList<>();

        //获取患者
        BasePatientDO patient = patientDao.findById(patientCode).orElse(null);

        //获取基卫数据
        String response = jwSmjkService.getExamAndLabReport(patient.getSsc(), page, pageSize);     //【基卫接口】


        int pageInt = Integer.parseInt(page);
        int pageSizeInt = Integer.parseInt(pageSize);
        pageInt = pageInt > 0 ? pageInt - 1 : 0;
        //获取app数据
        String sql = "select a.*,b.img_type as catalog,GROUP_CONCAT(b.img_label) as label \n" +
                "from wlyy_patient_event a,wlyy_patient_event_img b\n" +
                "where a.patient='" + patientCode + "' and b.event_id=a.id and b.img_type in ('检查报告','检验报告')  \n" +
                "group by b.event_id,b.img_type order by a.event_date desc";

        List<Map<String, Object>> appList = jdbcTemplate.queryForList(sql);

        if (!StringUtils.isEmpty(response) && !"[{}]".equals(response)) {
            JSONArray array = new JSONArray(response);
            String max = "";
            String min = "";

            for (int i = 0; i < array.length(); i++) {
                JSONObject item = array.getJSONObject(i);
                Map<String, String> map = new HashMap<>();
                if (i == 0) //最大值
                {
                    max = item.optString("END_TIME");
                } else if (i == array.length() - 1) //最小值
                {
                    min = item.optString("END_TIME");
                }

                map.put("id", item.optString("EVENT"));
                map.put("patient", patientCode);
                map.put("eventDate", item.optString("END_TIME"));
                String type = "";
                if ("0221".equals(item.optString("CATALOG_CODE"))) {
                    type = "检验";
                } else if ("0231".equals(item.optString("CATALOG_CODE"))) {
                    type = "检查";
                } else if ("0121".equals(item.optString("CATALOG_CODE"))) {
                    type = "检验";
                } else if ("0131".equals(item.optString("CATALOG_CODE"))) {
                    type = "检查";
                }
                map.put("type", type);
                map.put("catalogCode", item.optString("CATALOG_CODE")); //【基卫】档案类型
                map.put("serial", item.optString("SERIAL")); //【基卫】档案序号
                map.put("orgName", item.optString("ORG_NAME"));
                map.put("label", item.optString("ITEM")); //检测项目
                map.put("dataFrom", "1");//基卫数据
                re.add(map);
            }

            //过滤
            for (Map<String, Object> item : appList) {
                String eventDate = DateUtil.dateToStrLong((Date) item.get("event_date"));
                int maxCompare = eventDate.compareTo(max);
                int minCompare = eventDate.compareTo(min);
                Boolean contain = false;
                if (maxCompare < 0 && minCompare >= 0)       //时间范围内
                {
                    contain = true;
                }

                //第一页特殊处理
                if ("1".equals(page) && maxCompare >= 0) {
                    contain = true;
                }

                //最后一页特殊处理
                if (!"1".equals(page) && (array.length() == 0 || "[{}]".equals(response)) && !StringUtils.isEmpty(lastTime)) {
                    int lastTimeCompare = eventDate.compareTo(lastTime);
                    if (lastTimeCompare < 0) {
                        contain = true;
                    }
                }

                if (contain) {
                    Map<String, String> map = new HashMap<>();
                    map.put("id", item.get("id").toString());
                    map.put("patient", patientCode);
                    map.put("eventDate", eventDate);
                    String type = "";
                    if ("检验报告".equals(item.get("catalog"))) {
                        type = "检验";
                    } else if ("检查报告".equals(item.get("catalog"))) {
                        type = "检查";
                    }
                    map.put("type", type);
                    map.put("catalogCode", "");
                    map.put("serial", "");
                    map.put("orgName", String.valueOf(item.get("org_name")));
                    map.put("label", String.valueOf(item.get("label"))); //检测项目
                    map.put("dataFrom", "2");//基卫数据
                    re.add(map);
                }
            }

            //排序
            re = sortMapList(re, "eventDate", "DESC");
        } else {
            if ("1".equals(page)) {
                for (Map<String, Object> item : appList) {
                    Map<String, String> map = new HashMap<>();
                    map.put("id", String.valueOf(item.get("id")));
                    map.put("patient", patientCode);
                    map.put("eventDate", DateUtil.dateToStrLong((Date) item.get("event_date")));
                    String type = "";
                    if ("检验报告".equals(item.get("catalog"))) {
                        type = "检验";
                    } else if ("检查报告".equals(item.get("catalog"))) {
                        type = "检查";
                    }
                    map.put("type", type);
                    map.put("catalogCode", "");
                    map.put("serial", "");
                    map.put("orgName", String.valueOf(item.get("org_name")));
                    map.put("label", String.valueOf(item.get("label"))); //检测项目
                    map.put("dataFrom", "2");//基卫数据
                    re.add(map);
                }
            }
        }

        return re;

    }

    /**
     * 获取用药列表
     */
    public String getDrugsListPage(String patientCode, String page, String pageSize) throws Exception {
        //获取患者
        BasePatientDO patient = patientDao.findById(patientCode).orElse(null);
        String response = jwSmjkService.getDrugsListPage(patient.getSsc(), page, pageSize);


        return response;
    }


    /**
     * 获取（中山医院）门/急诊记录 + 住院记录
     */
    public List<Map<String, String>> getZhongShanAllEvent(String patientCode, String type, String page, String pageSize, String lastTime) throws Exception {
        List<Map<String, String>> re = new ArrayList<>();

        //获取患者
        BasePatientDO patient = patientDao.findById(patientCode).orElse(null);
        //获取基卫数据
        String response = jwSmjkService.getResidentEventListJson(patient.getSsc(), type, page, pageSize);

        //获取app数据
        List<PatientEvent> eventList = new ArrayList<>();

        if (StringUtils.isEmpty(type)) {
            eventList = patientEventDao.findByPatient(patientCode);
        } else {
            eventList = patientEventDao.findByPatientAndEventType(patientCode, type);
        }

        if (!StringUtils.isEmpty(response)) {
            JSONArray array = new JSONArray(response);
            String max = "";
            String min = "";
            if (!"[{}]".equals(response)) {
                for (int i = 0; i < array.length(); i++) {
                    JSONObject item = array.getJSONObject(i);
                    if (i == 0) //最大值
                    {
                        max = item.optString("END_TIME");
                    } else if (i == array.length() - 1) //最小值
                    {
                        min = item.optString("END_TIME");
                    }

                    Map<String, String> map = new HashMap<>();
                    //过滤只取中山医院的记录
                    if (!"厦门大学附属中山医院".equals(item.optString("ORG_NAME"))) {
                        continue;
                    }
                    map.put("id", item.optString("EVENT"));
                    map.put("patient", patientCode);
                    map.put("eventDate", item.optString("END_TIME"));
                    map.put("eventType", item.optString("TYPE"));
                    map.put("orgName", item.optString("ORG_NAME"));
                    map.put("orgCode", item.optString("ORG_ID"));
                    map.put("dianosis", item.optString("DIAGNOSIS"));
                    map.put("createTime", item.optString("END_TIME"));
                    map.put("dataFrom", "1");//基卫数据
                    re.add(map);
                }
            }

            //过滤
            for (PatientEvent item : eventList) {
                String eventDate = DateUtil.dateToStrLong(item.getEventDate());
                int maxCompare = eventDate.compareTo(max);
                int minCompare = eventDate.compareTo(min);
                Boolean contain = false;
                if (maxCompare < 0 && minCompare >= 0)       //时间范围内
                {
                    contain = true;
                }

                //第一页特殊处理
                if ("1".equals(page) && maxCompare >= 0) {
                    contain = true;
                }

                //最后一页特殊处理
                if (!"1".equals(page) && (array.length() == 0 || "[{}]".equals(response)) && !StringUtils.isEmpty(lastTime)) {
                    int lastTimeCompare = eventDate.compareTo(lastTime);
                    if (lastTimeCompare < 0) {
                        contain = true;
                    }
                }

                if (contain) {
                    Map<String, String> map = new HashMap<>();
                    //过滤只取中山医院的记录
                    if (!"厦门大学附属中山医院".equals(item.getOrgName())) {
                        continue;
                    }
                    map.put("id", item.getId().toString());
                    map.put("patient", item.getPatient());
                    map.put("eventDate", DateUtil.dateToStrLong(item.getEventDate()));
                    map.put("eventType", item.getEventType());
                    map.put("orgName", item.getOrgName());
                    map.put("orgCode", item.getOrgCode());
                    map.put("dianosis", item.getDianosis());
                    map.put("createTime", DateUtil.dateToStrLong(item.getCreateTime()));
                    map.put("dataFrom", "2");   //APP数据
                    re.add(map);
                }
            }

            //排序
            re = sortMapList(re, "eventDate", "DESC");
        } else {
            if ("1".equals(page)) {
                for (PatientEvent item : eventList) {
                    Map<String, String> map = new HashMap<>();
                    //过滤只取中山医院的记录
                    if (!"厦门大学附属中山医院".equals(item.getOrgName())) {
                        continue;
                    }
                    map.put("id", item.getId().toString());
                    map.put("patient", item.getPatient());
                    map.put("eventDate", DateUtil.dateToStrLong(item.getEventDate()));
                    map.put("eventType", item.getEventType());
                    map.put("orgName", item.getOrgName());
                    map.put("orgCode", item.getOrgCode());
                    map.put("dianosis", item.getDianosis());
                    map.put("createTime", DateUtil.dateToStrLong(item.getCreateTime()));
                    map.put("dataFrom", "2");   //APP数据
                    re.add(map);
                }
            }
        }

        return re;
    }

//    /**
//     * 根据身份证号换取居民请求秘钥
//     *
//     * @param idcard
//     * @return
//     */
//    public com.alibaba.fastjson.JSONObject getPatientAccetokenByIdcard(String idcard) throws Exception {
//        BasePatientDO patient = patientService.findInfoByIdCard(idcard);
//        if (patient == null) {
//            if (patientService.addPaitentByIdcard(idcard) == null) {
//                throw new Exception("该身份证查询不到居民");
//            }
//            List<BasePatientDO>  patientList = patientDao.getPatientByIdcardOrSsc(idcard);//重新获取该患者信息
//            patient = patientList.get(0);
//        }
//        if (null != patient) {
//            String uuid = UUID.randomUUID().toString();
//            redisTemplate.opsForValue().set("patient_" + uuid, idcard, 3600, TimeUnit.SECONDS);
//            com.alibaba.fastjson.JSONObject result = new com.alibaba.fastjson.JSONObject();
//            result.put("patientCode", uuid);
//            result.put("create_time", DateUtil.dateToStrLong(new Date()));
//            result.put("expires_in", 3600);
//            return result;
//        }
//        return null;
//    }

    /**
     * 根据居民缓存TOKEN换取居民CODE
     *
     * @return
     */
    public String getPatientCodeFromRedisByPatientAccestoken(String uuid) throws RuntimeException {
        String result = "";
        String idcard = redisTemplate.opsForValue().get("patient_" + uuid);
        if (StringUtils.isBlank(idcard)) {
            throw new RuntimeException("未登录或授权凭证已过期！");
        } else {
            BasePatientDO patient = patientDao.findByIdcard(idcard);
            if (patient != null && StringUtils.isNoneBlank(patient.getId())) {
                result = patient.getId();
            }
        }

        return result;
    }

    /**
     * 根据Scc查找账户信息
     *
     * @param ssc
     * @return
     */
    public BasePatientDO findPatientBySsc(String ssc, String name, String idCard, String sex, String phone, String birthday) {
        BasePatientDO patient = patientDao.findBySsc(ssc);
        if (patient == null) {
            BasePatientDO newPatient = new BasePatientDO();
//            newPatient.setCode(UUID.randomUUID().toString().replaceAll("-", ""));
            newPatient.setName(name);
            newPatient.setIdcard(idCard);
            newPatient.setSex(Integer.valueOf(sex));
            newPatient.setMobile(phone);
            newPatient.setSsc(ssc);
            newPatient.setBirthday(DateUtil.strToDate(birthday));
            String password = "a" + idCard.substring(idCard.length() - 6) + "*";
            String salt = UUID.randomUUID().toString().replace("-", "");
            newPatient.setSalt(salt);
            newPatient.setPassword(MD5.GetMD5Code(password + salt));
//            newPatient.setStatus(1);
            newPatient.setCreateTime(new Date());
            patientDao.save(newPatient);
            return newPatient;
        }
        return patient;
    }

//    public String areaMedicalDetail(String areaCode, String patientId, Boolean demoFlag) throws Exception {
//        SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
//        SimpleDateFormat shortFormat = new SimpleDateFormat("yyyyMMdd");
//        if (demoFlag) {
//            String json = patientRecordService.getJosnFileResullt("list_medical");
//            com.alibaba.fastjson.JSONObject jsonObject = JSON.parseObject(json);
//            com.alibaba.fastjson.JSONArray list = jsonObject.getJSONArray("list");
//
//            List<MedicalVo> medicalList = com.alibaba.fastjson.JSONObject.parseArray(JSON.toJSONString(list), MedicalVo.class);
//            for (MedicalVo medicalVo : medicalList) {
//                String medicalId = findMedicalId(medicalVo.getMedicalNo());
//                if (StringUtils.isNotBlank(medicalId)) {
//                    medicalDao.delete(medicalId);
//                }
//                String detailJsonStr = patientRecordService.getJosnFileResullt("medical_detail");
//                String medicalTime = medicalVo.getMedicalTime();
//                MedicalInfo resultVo = new MedicalInfo();
//                resultVo.setOrgName(medicalVo.getOrgName());
//                resultVo.setName("测试");
//                resultVo.setIdcard("8888888888888888");
//                resultVo.setMedicalTime(dateFormat.parse(medicalTime));
//                resultVo.setMedicalTimeShot(shortFormat.format(dateFormat.parse(medicalTime)));
//                resultVo.setMedicalNo(medicalVo.getMedicalNo());
//                resultVo.setDetailJson(detailJsonStr);
//                resultVo.setCjsj(new Date());
//                resultVo.setXgsj(new Date());
//                medicalDao.save(resultVo);
//                saveMedicalDetail(detailJsonStr, resultVo.getMedicalNo(), medicalId, "2");
//            }
//        } else {
//            List<SignPatientVo> patientList = findPatientByAreaCode(patientId, areaCode);
//            if (patientList.isEmpty()) {
//                return "没有查询到签约居民";
//            }
//            for (SignPatientVo vo : patientList) {
//                try {
//                    String idCard = vo.getIdcard();
//                    JSONArray medicalArray = jwArchivesService.getEhrSickMedicalList(idCard, 0, 0);
//                    for (int i = 0; i < medicalArray.length(); i++) {
//                        JSONObject object = medicalArray.getJSONObject(i);
//                        //是否存在
//                        String medicalId = findMedicalId(object.getString("medicalNo"));
//                        if (StringUtils.isNotBlank(medicalId)) {
//                            medicalDao.delete(medicalId);
//                        }
//                        JSONObject jsonObject = jwArchivesService.getEhrSickMedicalRecord(object.getString("medicalNo"));
//                        String detailJsonStr = jsonObject.toString();
//                        String medicalTime = object.getString("medicalTime");
//                        MedicalInfo resultVo = new MedicalInfo();
//                        resultVo.setOrgName(object.getString("orgName"));
//                        resultVo.setName(vo.getName());
//                        resultVo.setIdcard(idCard);
//                        resultVo.setMedicalTime(DateUtil.strToDateLong(medicalTime));
//                        resultVo.setMedicalTimeShot(DateUtil.strToDateShort(medicalTime).getTime() + "");
//                        resultVo.setDetailJson(detailJsonStr);
//                        resultVo.setMedicalNo(object.getString("medicalNo"));
//                        resultVo.setCjsj(new Date());
//                        resultVo.setXgsj(new Date());
//                        medicalDao.save(resultVo);
//                        saveMedicalDetail(detailJsonStr, resultVo.getMedicalNo(), medicalId, "2");
//                    }
//                } catch (Exception e) {
//                    writeFile(vo.getIdcard(), e.getMessage());
//                    e.printStackTrace();
//                }
//            }
//        }
//        return "保存完成";
//    }


    /**
     * 保存详情数据
     */
//    public String saveMedicalDetail(String json, String MedicalNo, String medicalId, String findType) throws Exception {
//        if (StringUtils.isBlank(MedicalNo)) {
//            return "参数为空";
//        }
//        MedicalDetailVo detailVo = null;
//        MedicalDetail detailEntity = new MedicalDetail();
//        String drugListJson = null;
//        String inhospitalListJson = null;
//        String niVaccinationListJson = null;
//
//        if (StringUtils.isNotBlank(json)) {
//            detailVo = com.alibaba.fastjson.JSONObject.parseObject(json, MedicalDetailVo.class);
//        } else {
//            if ("1".equals(findType)) {
//                //查库
//                MedicalInfo info = medicalDao.findInfoByMedicalNo(MedicalNo);
//                if (info != null) {
//                    drugListJson = JSON.parseObject(info.getDetailJson()).getString("drugList");
//                    inhospitalListJson = JSON.parseObject(info.getDetailJson()).getString("inhospitalList");
//                    niVaccinationListJson = JSON.parseObject(info.getDetailJson()).getString("niVaccinationList");
//                    detailVo = com.alibaba.fastjson.JSONObject.parseObject(info.getDetailJson(), MedicalDetailVo.class);
//                } else {
//                    return "查无数据,请核对体检号";
//                }
//            } else {
//                //远程
//                JSONObject jsonObject = jwArchivesService.getEhrSickMedicalRecord(MedicalNo);
//                System.out.println("medical_detail==>" + JSON.toJSONString(jsonObject));
//                drugListJson = jsonObject.getString("drugList");
//                inhospitalListJson = jsonObject.getString("inhospitalList");
//                niVaccinationListJson = jsonObject.getString("niVaccinationList");
//                detailVo = com.alibaba.fastjson.JSONObject.parseObject(JSON.toJSONString(jsonObject), MedicalDetailVo.class);
//            }
//        }
//        if (StringUtils.isBlank(medicalId)) {
//            medicalId = findMedicalId(MedicalNo);
//        }
//        String medicalDetailId = findMedicalDetailId(medicalId);
//        if (StringUtils.isNotBlank(medicalDetailId)) {
//            medicalDetailDao.delete(medicalDetailId);
//        }
//        BeanUtils.copyProperties(detailVo, detailEntity);
//
//        detailEntity.setMedicalInfoId(medicalId);
//        detailEntity.setMedicalNo(MedicalNo);
//        detailEntity.setDrugList(drugListJson);
//        detailEntity.setInhospitalList(inhospitalListJson);
//        detailEntity.setNiVaccinationList(niVaccinationListJson);
//        detailEntity.setFpList(detailVo.getFpList().isEmpty() ? null : JSON.toJSONString(detailVo.getFpList()));
//        detailEntity.setExaminationList(detailVo.getExaminationList().isEmpty() ? null : JSON.toJSONString(detailVo.getExaminationList()));
//        medicalDetailDao.save(detailEntity);
//        return "保存成功";
//    }

//    public String saveMedicalDetailMethod(String findType, String findAll) throws Exception {
//        if ("yes".equals(findAll)) {
//            //查全部
//            List<MedicalInfo> infoList = medicalDao.findAllMedicalInfo();
//            int q = 0;
//            for (MedicalInfo info : infoList) {
//                try {
//                    if ("1".equals(findType) && StringUtils.isNotBlank(info.getDetailJson())) {
//                        saveMedicalDetail(info.getDetailJson(), info.getMedicalNo(), info.getId(), findType);
//                    } else {
//                        saveMedicalDetail(null, info.getMedicalNo(), info.getId(), findType);
//                    }
//                    q++;
//                    System.out.println("进度:" + q + "/" + infoList.size());
//                } catch (Exception e) {
//                    e.printStackTrace();
//                }
//            }
//        } else {
//            List<MedicalVo> list = findMedicalTemp();
//            int q = 0;
//            for (MedicalVo vo : list) {
//                try {
//                    patientRecordService.saveMedicalDetail(null, vo.getMedicalNo(), null, findType);
//                } catch (Exception e) {
//                    e.printStackTrace();
//                }
//            }
//        }
//
//        return "执行完成";
//    }


//    private MedicalDetail medicalDicCodeToValue(MedicalDetail detailEntity) throws Exception {
//        //查出字典表进行替换
//        Field[] fields = detailEntity.getClass().getDeclaredFields();
//        for (Field field : fields) {
//            field.setAccessible(true);
//        }
//        return detailEntity;
//    }


    /**
     * 查询区域的签约人
     */
//    public List<SignPatientVo> findPatientByAreaCode(String patient, String areaCode) throws Exception {
//        HashMap<String, Object> map = new HashMap<>();
//        String sql = "SELECT DISTINCT q.patient,q.`name`,q.idcard,q.ssc,q.mobile,q.hospital_name as hospitalName " +
//                "FROM wlyy_sign_family q " +
//                "WHERE 1=1 " +
//                "AND q.`status`>0  ";
//        if (StringUtils.isNotBlank(patient)) {
//            sql += "AND  q.patient=:patientId ";
//            map.put("patientId", patient);
//        }
//
//        if (StringUtils.isNotBlank(areaCode)) {
//            sql += "AND q.hospital IN(SELECT dm.`code` from dm_hospital dm where dm.town=:areaCode  and dm.`level`=2) ";
//            map.put("areaCode", areaCode);
//        }
//        List<SignPatientVo> list = findSqlMapRvo(sql, map, SignPatientVo.class);
//        if (list.isEmpty()) {
//            return null;
//        } else {
//            return list;
//        }
//    }

    /**
     * 查根据medicalNo查询 wlyy_medical_info 主键
     */
    public String findMedicalId(String medicalNo) throws Exception {
        String sql = "SELECT q.id FROM wlyy_medical_info q WHERE q.medical_no=:medicalNo ";
        HashMap<String, Object> map = new HashMap<>();
        map.put("medicalNo", medicalNo);
        String result = (String) findSqlObject(sql, map);
        return result;
    }


//    public MedicalInfo findMedicalInfo(String medicalNo) throws Exception {
//        String sql = "SELECT q.* FROM wlyy_medical_info q WHERE q.medical_no=:medicalNo ";
//        HashMap<String, Object> map = new HashMap<>();
//        map.put("medicalNo", medicalNo);
//        MedicalInfo info = (MedicalInfo) findSqlObject(sql, map);
//        return info;
//    }

    /**
     * 查出temp表
     */
//    public List<MedicalVo> findMedicalTemp() throws Exception {
//        HashMap<String, Object> map = new HashMap<>();
//        String sql = "SELECT medical_no \"medicalNo\" FROM medical_temp ";
//        List<MedicalVo> list = findSqlMapRvo(sql, map, MedicalVo.class);
//        return list;
//    }


    /**
     * 查根据medicalNo查询wlyy_medical_info 主键
     */
    public String findMedicalDetailId(String medicalInfoId) throws Exception {
        String sql = "SELECT q.id FROM wlyy_medical_detail q WHERE q.medical_info_id=:medicalInfoId ";
        HashMap<String, Object> map = new HashMap<>();
        map.put("medicalInfoId", medicalInfoId);
        String result = (String) findSqlObject(sql, map);
        return result;
    }


    /**
     * 封装成占位符sql
     */
    public <T> List<T> findSqlMapRvo(String sql, Map<String, Object> map, Class clazz) {
        Session session = (Session) entityManager.getDelegate();
        Query query = session.createSQLQuery(sql).setResultTransformer(Transformers.aliasToBean(clazz)).setProperties(map);
//        query.setFirstResult().setMaxResults();
        List list = query.list();
        return list;
    }

    /**
     * 查找一个
     */
    public Object findSqlObject(String sql, Map<String, Object> map) {
        Session session = (Session) entityManager.getDelegate();
        Query query = session.createSQLQuery(sql).setProperties(map);
        return query.uniqueResult();
    }

    /**
     * 查找list
     */
    public List<Map> findSqlList(String sql, Map<String, Object> map) {
        Session session = (Session) entityManager.getDelegate();
        Query query = session.createSQLQuery(sql).setProperties(map).setResultTransformer(Transformers.ALIAS_TO_ENTITY_MAP);
        return query.list();
    }


    public static void writeFile(String param, String content) {
        try {
            SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy/MM/dd");
            SimpleDateFormat dateFormatDetail = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            final String FOLDER_PATH = "log_txt_dir/";
            String fileName = "areaMedicalDetail_error.txt";
            content = "时间==>" + dateFormatDetail.format(new Date()) + "  ==>参数:" + param + "  原因==>" + content + "\n";

            String folderName = dateFormat.format(new Date());
            File folder = new File(FOLDER_PATH + folderName);
            if (!folder.exists()) {
                folder.mkdirs();
            }

            String filePath = FOLDER_PATH + folderName + "/" + fileName;
            if (Files.exists(Paths.get(filePath))) {
                content = new String(Files.readAllBytes(Paths.get(filePath))) + content;
            }
            FileWriter writer = new FileWriter(filePath);
            writer.write(content);
            writer.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

//    public static void main(String[] args) throws Exception {
//        ObjectMapper objectMapper = new ObjectMapper();//这个版本的jackson的有bug
//        String json = "{\"skinOthers\":\"\",\"renalOthers\":\"\",\"fastingPlasmaGlucoseDL\":\"\",\"abdoShiftingDull\":\"1\",\"eyegroundException\":\"\",\"abdoHepatomegalyOth\":\"\",\"electrocardiogram\":\"2\",\"typeBUltrasonic\":\"1\",\"height\":\"149\",\"abdoMassesOthers\":\"\",\"liverFunctionTotalBilirubin\":\"7.22\",\"bloodFatHdlc\":\"0.91\",\"heartChf\":\"\",\"renalDn\":\"\",\"bloodRoutineOthers\":\"\",\"eyeDiseaseCataract\":\"\",\"vulvaException\":\"\",\"poisonOthers\":\"\",\"cardiacSouffle\":\"1\",\"heartPrecordialpain\":\"\",\"isDryOut\":\"\",\"poisonPhysicalfactor\":\"\",\"healthGuidanceOther\":\"\",\"hazardLoseWeight\":\"\",\"poisonDustPreStr\":\"\",\"breastOthersStr\":\"\",\"angiosisUndiscovered\":\"1\",\"bloodPressureLeftD\":\"72\",\"inhospitalList\":[],\"vulva\":\"\",\"renalFunctionBun\":\"5.35\",\"cvdSah\":\"\",\"sclera\":\"正常\",\"ket\":\"阴性(-)\",\"renalFunctionCreatinine\":\"57\",\"audition\":\"听见\",\"miniMentalStateExamination\":\"\",\"drinkOthers\":\"\",\"hardeningFrequency\":\"每周一次以上\",\"occupationalDiseaseWorkTime\":\"\",\"asymptomatic\":\"1\",\"abdoHepatomegaly\":\"1\",\"fastingPlasmaGlucoseL\":\"5.08\",\"visionRightEye\":\"4.6\",\"symptomBreastBursting\":\"\",\"poisonChemicalPreStr\":\"\",\"eatHobbySugar\":\"\",\"lips\":\"1\",\"vaginaException\":\"\",\"everyHardeningTime\":\"60\",\"upcr\":\"0.672\",\"angiosisOthers\":\"\",\"occupationalDisease\":\"1\",\"motorFunction\":\"可顺利完成\",\"corporeityQiDepression\":\"\",\"heartOthers\":\"\",\"cvdOthers\":\"\",\"poisonChemical\":\"\",\"lungBreathSoundExcep\":\"\",\"angiosisDa\":\"\",\"corpus\":\"\",\"cervicalPapSmears\":\"\",\"breastOthers\":\"\",\"elderlyAffectiveState\":\"1\",\"cvdIschemicStroke\":\"\",\"lymphNodeRrmprt\":\"\",\"isExaminationExcep\":\"1\",\"symptomPalpitation\":\"\",\"heartOthersStr\":\"\",\"hardeningMode\":\"散步,广场舞\",\"cxr\":\"1\",\"lymphNodeNotTouch\":\"1\",\"lymphNodeClavicle\":\"\",\"elderlyHealthStatus\":\"满意\",\"othersSystemDisease\":\"1\",\"symptomDazzle\":\"\",\"symptomJointGall\":\"\",\"lungBarrelChest\":\"1\",\"symptomChestPain\":\"\",\"abdoPressPain\":\"1\",\"symptomWeightLoss\":\"\",\"occDiseaseTrades\":\"\",\"fundamentFingerpOth\":\"\",\"weight\":\"50.90\",\"symptomUrinaryUrgency\":\"\",\"drinkFrequency\":\"从不\",\"poisonOthersPreStr\":\"\",\"dentitiondentureNormal\":\"\",\"glycolatedHemoglobin\":\"\",\"bloodFatLdlc\":\"2.71\",\"hazardHealthDrink\":\"\",\"othersSystemDiseaseStr\":\"\",\"poisonOthersIspre\":\"\",\"dorsumOfFootArteriopalmus\":\"触及双侧对称\",\"renalFunctionNatremia\":\"\",\"breastMastectomy\":\"\",\"proteinuria\":\"弱阳性(+-)\",\"symptomDysuria\":\"\",\"corporeityTeBing\":\"\",\"bloodFatTriglyceride\":\"1.39\",\"urinaryOccultBlood\":\"+2\",\"doctorName\":\"杜爱玲\",\"symptomDiarrhea\":\"\",\"poisonRadiogenPreStr\":\"\",\"abdoSplenomegalyOth\":\"\",\"breastAbnormalLactation\":\"\",\"fpList\":[],\"dentitiondentureDentalCaries\":\"\",\"symptomChronicCough\":\"\",\"symptomOther\":\"\",\"stoolOccultBlood\":\"\",\"renalFailure\":\"\",\"symptomDizziness\":\"\",\"respiratoryRate\":\"18\",\"lungRhonchusException\":\"\",\"beginSmokingAge\":\"\",\"abdoMasses\":\"1\",\"eatMeatdietFlash\":\"\",\"poisonPhysicalPreStr\":\"\",\"renalFunctionBloodPotassium\":\"\",\"platelet\":\"214\",\"liverFunctionSgot\":\"17.0\",\"uricAcid\":\"346\",\"renalCgn\":\"\",\"assistantInvesOth\":\"2022-06-21 体检\",\"examinationList\":[\"心电图异常\",\"尿检异常\"],\"niVaccinationList\":[],\"symptomHandFootNumbness\":\"\",\"papilledema\":\"\",\"eatHobbyOil\":\"\",\"symptomTinnitus\":\"\",\"abdoSplenomegaly\":\"1\",\"retinalHemorrhage\":\"\",\"corporeityYangDeficiency\":\"\",\"liverFunctionCb\":\"1.51\",\"healthGuidanceOtherStr\":\"\",\"pulseFrequency\":\"59\",\"elderlyDepressionCheck\":\"\",\"dryOutAge\":\"\",\"smokingCircumstance\":\"1\",\"heartUndiscovered\":\"1\",\"cvdUndiscovered\":\"1\",\"drinkRedWine\":\"\",\"eyeDiseaseOthers\":\"\",\"quitSmokingAge\":\"\",\"cardiacSouffleOthers\":\"\",\"hazardOthersStr\":\"1、低盐饮食，每天少于6克。2、低脂饮食，每天少于25克（2汤勺）多吃蔬菜。3、每天快走或慢跑30分钟，每周不少于150分钟。\",\"scleraOthers\":\"\",\"lungRhonchus\":\"无\",\"urineRoutineOthers\":\"白细胞+3\",\"symptomHeadache\":\"\",\"eatVegetarianFlash\":\"\",\"cvdOthersStr\":\"\",\"symptomConstipation\":\"\",\"breastNotTroubleFind\":\"\",\"poisonRadiogen\":\"\",\"leukocyte\":\"7.84\",\"waist\":\"78\",\"cvdCerebralHemorrhage\":\"\",\"corpusException\":\"\",\"abdoShiftingDullOth\":\"\",\"nervousSystemDiseaseStr\":\"\",\"drinkOthersStr\":\"\",\"skin\":\"正常\",\"cervicalPapSmearsExcep\":\"\",\"healthGuidanceInhospital\":\"1\",\"hazardOthers\":\"1\",\"healthRegularFollowUp\":\"\",\"hazardVaccination\":\"\",\"poisonChemicalIspre\":\"\",\"abdoPressPainOth\":\"\",\"healthGuidanceSlowDisease\":\"\",\"bloodPressureRigthD\":\"73\",\"cervix\":\"\",\"poisonDustIspre\":\"\",\"breastMasses\":\"\",\"attachmentException\":\"\",\"nervousSystemDisease\":\"1\",\"hazardHardening\":\"1\",\"cervixException\":\"\",\"symptomPolyuria\":\"\",\"lungBreathSound\":\"1\",\"symptomDyspnea\":\"\",\"cxrException\":\"\",\"everyAlcohol_tolerance\":\"\",\"microalbuminuria\":\"\",\"corporeityYinDeficiency\":\"1\",\"fundamentFingerp\":\"\",\"elderlyCognitiveFun\":\"1\",\"dentitiondentureMissTeeth\":\"\",\"hbsag\":\"\",\"eyeground\":\"\",\"renalAgn\":\"\",\"cardiacRhythm\":\"齐\",\"bmi\":\"22.9270\",\"oneYearIsTemulentia\":\"\",\"corporeityQiAsthenia\":\"\",\"pharyngealportionYes\":\"\",\"straightenVisionRightEye\":\"\",\"symptomExpectoration\":\"\",\"hazardVaccinationStr\":\"\",\"bloodFatTc\":\"4.22\",\"symptomChestStuffiness\":\"\",\"lymphNodeOthers\":\"\",\"bodyTemperature\":\"36.50\",\"typeBUltrasonicExcep\":\"\",\"immersionFoot\":\"无\",\"renalOthersStr\":\"\",\"beginDrinkAge\":\"\",\"symptomNauseaVomiting\":\"\",\"corporeityGentle\":\"\",\"corporeityDampHeat\":\"\",\"orgName\":\"海沧区嵩屿街道社区卫生服务中心\",\"vagina\":\"\",\"heartAnginaPectoris\":\"\",\"urineSugar\":\"阴性(-)\",\"poisonRadiogenIspre\":\"\",\"drugList\":[],\"drinkWhiteSpirits\":\"\",\"bloodPressureRigthU\":\"95\",\"liverFunctionAlbumin\":\"38.3\",\"visionLeftEye\":\"4.5\",\"straightenVisionLeftEye\":\"\",\"heartRate\":\"59\",\"symptomPolydipsia\":\"\",\"bloodPressureLeftU\":\"95\",\"physicalExaminationOth\":\"\",\"dailySmokingQuantity\":\"\",\"drinkYellowWine\":\"\",\"drinkBeer\":\"\",\"eatHobbySalt\":\"\",\"pharyngealportionAdd\":\"\",\"symptomOtherStr\":\"\",\"elderlySelfCare\":\"可自理（0～3分）\",\"dentitiondentureDenture\":\"1\",\"angiosisOthersStr\":\"\",\"eyeDiseaseOthersStr\":\"\",\"hazardQuitSmocking\":\"\",\"symptomLackOfPower\":\"\",\"lymphNode\":\"\",\"angiosisOcclusionArteries\":\"\",\"hemoglobin\":\"115\",\"eyeDiseaseUndiscovered\":\"1\",\"insistHardeningTime\":\"10\",\"renalUndiscovered\":\"1\",\"attachment\":\"\",\"healthGuidanceReview\":\"\",\"liverFunctionSalt\":\"13.0\",\"cvdTia\":\"\",\"medicalTime\":\"2022-07-08 08:22:00\",\"hazardFood\":\"1\",\"symptomBlurredVision\":\"\",\"corporeityPhlegmDamp\":\"\",\"hazardLoseWeightTarget\":\"\",\"poisonPhysicalIspre\":\"\",\"corporeityHaemostasis\":\"\",\"heartCoronaryArtery\":\"\",\"poisonDust\":\"\",\"pharyngealportionNo\":\"1\",\"eatClitocybineEqualization\":\"1\",\"heartMyocardialInfarction\":\"\",\"electrocardiogramExcep\":\"1.窦性心动过缓,2.部分ST-T改变,3.QT间期延长\"}";
////        MedicalDetailVo detail = objectMapper.readValue(json, MedicalDetailVo.class);
//
//        MedicalDetailVo detail = com.alibaba.fastjson.JSONObject.parseObject(json, MedicalDetailVo.class);
//        System.out.println("entity=>" + JSON.toJSONString(detail));
//        Field[] fields = detail.getClass().getDeclaredFields();
//        for (Field field : fields) {
//            field.setAccessible(true);
//            System.out.println("字段名称" + field.getName() + "=字段值" + field.get(detail));
//        }
//    }

    /**
     * 保存健康档案信息
     */
//    public String saveHealthRecord(String idcard) throws Exception {
//        String sql = " SELECT a.idcard,a.`code` FROM wlyy_patient a WHERE 1=1 AND a.status='1'  AND a.idcard IS NOT NULL AND a.idcard <> '' ";
//        if (StringUtils.isNotBlank(idcard)) {
//            sql += " AND a.idcard ='" + idcard + "'";
//        }
//        //查出所以的居民信息
//        List<Map<String, Object>> patientList = jdbcTemplate.queryForList(sql);
//        healthRecord healthRecord;
//        for (Map<String, Object> map : patientList) {
//            JSONArray array = jwArchivesService.getSickArchiveRecord(String.valueOf(map.get("idcard")));
//            for (int i = 0; i < array.length(); i++) {
//                JSONObject jsonObject = array.getJSONObject(i);
//                healthRecord = new healthRecord();
//                healthRecord.setArchiveId(jsonObject.getString("archiveId"));
//                healthRecord.setSickName(jsonObject.getString("sickName"));
//                healthRecord.setSickSex(jsonObject.getString("sickSex"));
//                healthRecord.setBirthday(jsonObject.getString("birthday"));
//                healthRecord.setIdentityCardNo(jsonObject.getString("identityCardNo"));
//                healthRecord.setZoneCode(jsonObject.getString("zoneCode"));
//                healthRecord.setHomeAddress(jsonObject.getString("homeAddress"));
//                healthRecord.setInsurCardNo(jsonObject.getString("insurCardNo"));
//                healthRecord.setArchiveStatus(jsonObject.getString("archiveStatus"));
//                //执行保存操作
//
//            }
//        }
//
//
//        return null;
//    }


}
