package com.yihu.jw.hospital.module.specialist.controller;

import com.yihu.jw.hospital.appointment.dao.SpecialDiseaseDao;
import com.yihu.jw.hospital.module.specialist.service.SpecialistService;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.MediaType;
import org.springframework.web.bind.annotation.*;

/**
 * Created by Trick on 2018/7/3.
 */
@RestController
@RequestMapping(value = "/patient/specialist", produces = MediaType.APPLICATION_JSON_UTF8_VALUE)
@Api(description = "患者端-专病管理")
public class PatientSpecialistController extends EnvelopRestEndpoint {

    @Autowired
    private SpecialistService specialistService;
    @Autowired
    private SpecialDiseaseDao specialDiseaseDao;
//    @Autowired
//    private ServerPackageService serverPackageService;


    @RequestMapping(value = "/findPatientTeamList", method = RequestMethod.GET)
    @ApiOperation(value = "获取居民所有专科医生签约信息")
    public String findPatientTeamList(@ApiParam(name = "patient", value = "居民code") @RequestParam(required = true) String patient) {
        try {
            return write(200, "获取成功", "data", specialistService.findPatientTeamList(patient));
        } catch (Exception e) {
            error(e);
            return error(-1, "请求失败");
        }
    }



//    @RequestMapping(value = "/findSpecialistTeamInfo", method = RequestMethod.GET)
//    @ApiOperation(value = "获取专科医生所在团队信息")
//    public String findSpecialistTeamInfo(@ApiParam(name = "doctor", value = "医生code") @RequestParam(required = true)String doctor,
//                                         @ApiParam(name = "teamCode", value = "团队code") @RequestParam(required = true)Long teamCode){
//        try {
//            return write(200, "获取成功", "data", specialistService.findSpecialistTeamInfo(doctor,teamCode));
//        } catch (Exception e) {
//            error(e);
//            return error(-1, "请求失败");
//        }
//    }


//    @RequestMapping(value = "/findTeamDiseaseRelation", method = RequestMethod.GET)
//    @ApiOperation(value = "获取团队专病服务信息")
//    public String findTeamDiseaseRelation(@ApiParam(name = "teamCode", value = "团队code") @RequestParam(required = true)Long teamCode) {
//        try {
//            return write(200, "获取成功", "data", specialistService.findTeamDiseaseRelation(teamCode));
//        } catch (Exception e) {
//            error(e);
//            return error(-1, "请求失败");
//        }
//    }

//    @RequestMapping(value = "/findPatientDiseaseServerList", method = RequestMethod.GET)
//    @ApiOperation(value = "获取居民专病服务信息")
//    public String findPatientDiseaseServerList(@ApiParam(name = "patient", value = "患者code") @RequestParam(required = true)String patient) {
//        try {
//            return write(200, "获取成功", "data", specialistService.findPatientDiseaseServerList(patient));
//        } catch (Exception e) {
//            error(e);
//            return error(-1, "请求失败");
//        }
//    }

//    @RequestMapping(value = "/signSpecialist", method = RequestMethod.POST)
//    @ApiOperation(value = "居民提交专科医生团队签约申请")
//    public String signSpecialist(@ApiParam(name = "patient", value = "患者code") @RequestParam(required = true)String patient,
//                                 @ApiParam(name = "doctor", value = "医生code") @RequestParam(required = true)String doctor,
//                                 @ApiParam(name = "disease", value = "疾病code") @RequestParam(required = true)String disease,
//                                 @ApiParam(name = "teamCode", value = "团队code") @RequestParam(required = true)Long teamCode) throws Exception {
//        try {
//            return write(200, "获取成功", "data", specialistService.signSpecialist(patient,doctor,disease,teamCode));
//        } catch (Exception e) {
//            error(e);
//            return error(-1, "请求失败");
//        }
//    }

//    @RequestMapping(value = "/agreeSpecialistTeam", method = RequestMethod.GET)
//    @ApiOperation(value = "医生审核")
//    public String agreeSpecialistTeam(String state,String relationCode,String remark,Long mesId)throws Exception {
//        try {
//            return write(200, "获取成功", "data", specialistService.agreeSpecialistTeam(getAccessToken(),state, relationCode, remark, mesId, labelcode, doctorcode));
//        } catch (Exception e) {
//            error(e);
//            return error(-1, "请求失败");
//        }
//    }



    /**
     * 根据机构code获取本机构服务项目
     * hospital
     */
//    @RequestMapping(value = "selectHospital1", method = RequestMethod.POST)
//    @ResponseBody
//    @ApiOperation(value = "根据机构code获取本机构服务项目")
//    public String selectHospital1(@RequestParam(name = "hospital",required = false) String hospital){
//        try {
//            return write(200, "查询成功", "data",serverPackageService.selectByHospital1(hospital));
//        } catch (Exception ex) {
//            error(ex);
//            return error(-1, "查询失败");
//        }
//    }

    /**
     * 根据机构code获取本机构服务项目-上门服务
     * hospital
     */
//    @RequestMapping(value = "selectServiceByHospital", method = RequestMethod.POST)
//    @ResponseBody
//    @ApiOperation(value = "根据机构code获取本机构服务项目-上门服务")
//    public String selectServiceByHospital(
//            @RequestParam(name = "hospital",required = false) String hospital,
//            @ApiParam(value = "服务项目名称", name = "serverItemName") @RequestParam(value = "serverItemName", required = false) String serverItemName,
//            @ApiParam(value = "类型", name = "type") @RequestParam(value = "type", required = false) String type,
//            @ApiParam(value = "医生", name = "doctor") @RequestParam(value = "doctor", required = false) String doctor
//    ){
//        try {
//            return write(200, "查询成功", "data",serverPackageService.selectServiceByHospital(hospital,serverItemName,type,getRepUID(),doctor));
//        } catch (Exception ex) {
//            error(ex);
//            return error(-1, "查询失败");
//        }
//    }

//    @RequestMapping(value = "selectServiceTypes", method = RequestMethod.POST)
//    @ResponseBody
//    @ApiOperation(value = "获取服务项目类型-上门服务")
//    public String selectServiceTypes(){
//        try {
//            return write(200, "查询成功", "data",serverPackageService.selectTypes());
//        } catch (Exception ex) {
//            error(ex);
//            return error(-1, "查询失败");
//        }
//    }

//    @RequestMapping(value = "getSpecialDisease", method = RequestMethod.GET)
//    @ApiOperation(value = "获取专科疾病类型")
//    @ResponseBody
//    public String getSpecialDisease() {
//        try {
//            return write(200, "查询成功!", "data", specialDiseaseDao.findByDel("1"));
//        } catch (Exception e) {
//            e.printStackTrace();
//            return write(-1, "查询失败!");
//        }
//    }

}
