package com.yihu.jw.hospital.module.specialist.controller;


import com.yihu.jw.hospital.module.specialist.service.SpecialistScreenResultService;
import com.yihu.jw.hospital.module.specialist.service.SpecialistService;
import com.yihu.jw.restmodel.specialist.SurveyScreenResultVo;
import com.yihu.jw.restmodel.web.MixEnvelop;
import com.yihu.jw.restmodel.web.endpoint.EnvelopRestEndpoint;
import com.yihu.jw.rm.specialist.SpecialistMapping;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Map;

/**
 * Created by zhangdan on 2018/7/6.
 */
@RestController
@RequestMapping(SpecialistMapping.api_specialist_common)
@Api(tags = "专科医生疾病筛查相关操作", description = "专科医生疾病筛查相关操作")
public class SpecialistScreenResultController extends EnvelopRestEndpoint {

    @Autowired
    private SpecialistService specialistService;
    //    @Autowired
//    private Tracer tracer;
    @Autowired
    private SpecialistScreenResultService specialistScreenResultService;


    @RequestMapping(value = "/getList", method = RequestMethod.GET)
    @ApiOperation(value = "专科医生获取筛查记录列表")
    public String createSpecialistPatientRelation(@ApiParam(name = "doctor", value = "专科医生ID") @RequestParam(value = "doctor", required = false) String doctor,
                                                  @ApiParam(value = "当前页") @RequestParam(value = "pageNo") int pageNo,
                                                  @ApiParam(value = "显示记录数") @RequestParam(value = "pageSize") int pageSize,
                                                  @ApiParam(value = "处理方式(1已预约 2已跟踪 3已接诊 4待处理)，多个用逗号隔开") @RequestParam(value = "type", required = false) Integer type,
                                                  @ApiParam(value = "搜索居民的姓名或身份证") @RequestParam(value = "patientName", required = false) String patientName,
                                                  @ApiParam(value = "是否高危预警(0否 1是)") @RequestParam(value = "isDanger", required = false) String isDanger,
                                                  @ApiParam(value = "疾病类型，多个用逗号隔开") @RequestParam(value = "diseaseType", required = false) String diseaseType,
                                                  @ApiParam(value = "传1则根据类型查一条数据") @RequestParam(value = "filterType", required = false, defaultValue = "0") Integer filterType,
                                                  @ApiParam(value = "居民code") @RequestParam(value = "patientCode", required = false) String patientCode) {
        try {
            return write(200, "获取成功！", "data", specialistScreenResultService.getScreenList(doctor, type, pageNo, pageSize, patientName, isDanger, diseaseType, filterType, patientCode));
        } catch (Exception e) {
            return error(-1, e.getMessage());
        }
    }


    @GetMapping(value = SpecialistMapping.screen.getScreenResult)
    @ApiOperation(value = "专科医生获取筛查记录列表")
    public MixEnvelop<SurveyScreenResultVo, SurveyScreenResultVo> createSpecialistPatientRelation(@ApiParam(name = "doctor", value = "专科医生ID") @RequestParam(value = "doctor", required = false) String doctor,
                                                                                                  @ApiParam(value = "当前页") @RequestParam(value = "pageNo") int pageNo,
                                                                                                  @ApiParam(value = "显示记录数") @RequestParam(value = "pageSize") int pageSize,
                                                                                                  @ApiParam(value = "搜索居民的姓名或身份证") @RequestParam(value = "patientName", required = false) String patientName,
                                                                                                  @ApiParam(value = "1已跟踪 2已预约 3已接诊 4待处理") @RequestParam(value = "type", required = false) Integer type,
                                                                                                  @ApiParam(value = "是否高危预警(0否 1是)") @RequestParam(value = "isDanger", required = false) String isDanger,
                                                                                                  @ApiParam(value = "疾病类型") @RequestParam(value = "diseaseType", required = false) String diseaseType,
                                                                                                  @ApiParam(value = "传1则根据类型查一条数据") @RequestParam(value = "filterType", required = false, defaultValue = "0") Integer filterType,
                                                                                                  @ApiParam(value = "居民code") @RequestParam(required = false) String patientCode) {
        try {
            return specialistScreenResultService.getScreenList(doctor, type, pageNo, pageSize, patientName, isDanger, diseaseType, filterType, patientCode);
        } catch (Exception e) {
            e.printStackTrace();
            // tracer.getCurrentSpan().logEvent(e.getMessage())
            return MixEnvelop.getError(e.getMessage());
        }
    }

    @GetMapping(value = SpecialistMapping.screen.getScreenCount)
    @ApiOperation(value = "专科医生首页--筛查已跟踪和已预约的数目")
    public MixEnvelop<Map<String, Object>, Map<String, Object>> findSpecialistPatientRelation(@ApiParam(name = "doctor", value = "专科医生ID") @RequestParam(value = "doctor") String doctor) {
        try {
            return specialistScreenResultService.getResultCount(doctor);
        } catch (Exception e) {
            e.printStackTrace();
            // tracer.getCurrentSpan().logEvent(e.getMessage())
            return MixEnvelop.getError(e.getMessage());
        }
    }

    @GetMapping(value = SpecialistMapping.screen.getScreenResultDetail)
    @ApiOperation(value = "查看筛查结果记录详情.")
    public MixEnvelop<Map<String, Object>, Map<String, Object>> getScreenResultDetail(@ApiParam(value = "筛查结果唯一code") @RequestParam(value = "code") String code) {
        try {
            return specialistScreenResultService.getScreenResultDetail(code);
        } catch (Exception e) {
            e.printStackTrace();
            // tracer.getCurrentSpan().logEvent(e.getMessage())
            return MixEnvelop.getError(e.getMessage());
        }
    }


}
