package com.yihu.jw.hospital.module.specialist.dao;

import com.yihu.jw.entity.specialist.rehabilitation.PatientDiseaseServer;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;

import java.util.List;

/**
 * Created by Trick on 2018/7/4.
 */
public interface PatientDiseaseServerDao extends
        PagingAndSortingRepository<PatientDiseaseServer, Long>,
        JpaSpecificationExecutor<PatientDiseaseServer> {

    List<PatientDiseaseServer> findByPatientAndDel(String patient, String del);
    List<PatientDiseaseServer> findBySpecialistRelationCodeAndDel(String code, String del);

    @Query(value = "select  p from PatientDiseaseServer p where p.specialistRelationCode=?1 and p.disease=?2 and p.del=?3")
    PatientDiseaseServer findBySpecialistRelationCodeAndDiseaseAndCode(String specialistRelationCode, String disease, String del);

    @Modifying
    @Query("update PatientDiseaseServer pds set pds.del=0 where pds.specialistRelationCode=?1")
    void updateBySpecialistRelationCodeAndDel(String code);


}
