package com.yihu.jw.hospital.module.system.dao;

import com.yihu.jw.entity.base.system.SystemDictDO;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;

import java.util.List;

/**
 * Created by Administrator on 2016/8/13.
 */
public interface SystemDictDao extends PagingAndSortingRepository<SystemDictDO, Long>, JpaSpecificationExecutor<SystemDictDO> {

    @Query("from SystemDictDO s where s.dictName=?1 order by s.sort asc ")
    List<SystemDictDO> findByDictName(String name);

    @Query("select s.name from SystemDictDO s where s.dictName=?1 and s.code =?2")
    String findByDictNameAndCode(String dictName, String code);

    @Query(" from SystemDictDO s where s.dictName=?1 and s.name =?2")
    SystemDictDO findByDictNameAndValue(String dictName, String value);

    @Query(" from SystemDictDO s where s.pyCode=?1 ")
    SystemDictDO findByPyCode(String pyCode);

    @Query("select s from SystemDictDO s where s.name like ?1 ")
    List<SystemDictDO> findByLikeName(String name);

    @Query("select s from SystemDictDO s where s.dictName like ?1 ")
    List<SystemDictDO> findByLikeDictName(String name);

    @Modifying
    @Query("delete SystemDictDO s where s.dictName = ?1")
    int delete(String dictName);

    @Query(" from SystemDictDO s where s.code=?1 and s.dictName=?2 ")
    SystemDictDO findByCodeAndName(String code, String dictName);
}
