package com.yihu.jw.hospital.module.system.service;

import com.yihu.jw.entity.base.system.SystemDictDO;
import com.yihu.jw.hospital.module.system.dao.SystemDictDao;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.data.redis.core.StringRedisTemplate;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.Map;
import java.util.stream.Collectors;

/**
 * Created by Administrator on 2016/8/13.
 */
@Service
@Transactional
public class SystemDictService {
    @Autowired
    private SystemDictDao systemDictDao;
    @Autowired
    private StringRedisTemplate redisTemplate;

    public Map<String,String> getDictMap(String dictName){
        List<SystemDictDO> dictList = systemDictDao.findByDictName(dictName);
//        Map<String,String> map = dictList.stream().collect(Collectors.toMap(SystemDictDO::getCode,SystemDict::getValue));
        Map<String,String> map = dictList.stream().collect(Collectors.toMap(SystemDictDO::getCode,SystemDictDO::getName));
        return map;
    }

    public List<SystemDictDO> getDictByDictName(String name) {
        return systemDictDao.findByDictName(name);
    }

    private String dictName = "SYSTEM_PARAMS";

    public String getDictValueNoRedis(String dictName, String code) {
        String re = systemDictDao.findByDictNameAndCode(dictName, code);
        return re;
    }

    /**
     * 字典转译
     *
     * @param dictName
     * @param code
     * @return
     */
    public String getDictValue(String dictName, String code) {
        String re = "";
        try {
            if (!StringUtils.isEmpty(code)) {
                //判断该字典redis是否存在
                String exit = redisTemplate.opsForValue().get("systemDict:" + dictName);
                if (!StringUtils.isEmpty(exit)) {
                    re = redisTemplate.opsForValue().get("systemDict:" + dictName + ":" + code);
                    if(StringUtils.isEmpty(re)){
                        re = systemDictDao.findByDictNameAndCode(dictName,code);
//                        if (!StringUtils.isEmpty(re)) {
//                            redisTemplate.opsForValue().set("systemDict:" + dictName + ":" + code, re);
//                        }
                    }
                } else {
                    List<SystemDictDO> list = systemDictDao.findByDictName(dictName);
                    if (list != null && list.size() > 0) {
                        redisTemplate.opsForValue().set("systemDict:" + dictName, "1");
                        for (SystemDictDO item : list) {
//                            redisTemplate.opsForValue().set("systemDict:" + dictName + ":" + item.getCode(), item.getValue());
                            redisTemplate.opsForValue().set("systemDict:" + dictName + ":" + item.getCode(), item.getName());
                            if (code.equals(item.getCode())) {
//                                re = item.getValue();
                                re = item.getName();
                            }
                        }
                    }
                }
            }
        } catch (Exception ex) {
            ex.printStackTrace();
            re = systemDictDao.findByDictNameAndCode(dictName, code);
        }
        return re;
    }

    /************************************** 其他参数 ****************************************/
    /**
     * http_log是否记录成功消息
     *
     * @return
     */
    public Boolean getSaveSuccessLog() {
        try {
            String re = systemDictDao.findByDictNameAndCode(dictName, "SAVE_SUCCESS_LOG");
            if ("1".equals(re)) {
                return true;
            } else {
                return false;
            }
        } catch (Exception ex) {
            ex.printStackTrace();
            return false;
        }
    }

    public int delete(String dictName) {
        return systemDictDao.delete(dictName);
    }

}
