/*******************************************************************************
 * Copyright (c) 2005, 2014 springside.github.io
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 *******************************************************************************/
package com.yihu.jw.hospital.module.wx.dao;


import com.yihu.jw.entity.base.wx.WxAccessTokenDO;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;

public interface AccessTokenDao extends PagingAndSortingRepository<WxAccessTokenDO, String> {
	
	@Query("select p from WxAccessTokenDO p where p.acc_id = ?1 order by p.addTimestamp desc")
	Iterable<WxAccessTokenDO> findAccessToken(String accId);

	@Modifying
	@Query("delete from WxAccessTokenDO p where p.acc_id=?1 ")
	void deleteByAccId(String accId);
}
