package com.yihu.jw.hospital.module.wx.dao;


import com.yihu.jw.entity.wechat.WechatPushLog;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.PagingAndSortingRepository;

import java.util.Date;
import java.util.List;

/**
 * Created by yeshijie on 2017/10/18.
 */
public interface WechatPushLogDao extends PagingAndSortingRepository<WechatPushLog, Long>, JpaSpecificationExecutor<WechatPushLog> {

    @Query("SELECT DISTINCT l.patient from WechatPushLog l where l.type =26 and l.status = 1 and l.createTime > ?1 ")
    List<String> findBwSendPeople(Date date);
    
    @Query("select a from Message a where  a.receiver = ?1 and a.state = 1 and a.over = ?2 and a.type in (?3) order by a.czrq desc")
    List<WechatPushLog> findWaitingMessages(String receiver, String over, List<Integer> typeList, Pageable pageable);
    
    @Query("select a from WechatPushLog a where a.patient=?1 and a.type=?2 order by  a.createTime desc")
    List<WechatPushLog> getWechatMessageByPatientAndType(String code, int type, Pageable pageRequest);
}
