package com.yihu.jw.hospital.utils;

import com.yihu.jw.util.http.HttpClientUtil;
import org.apache.http.NameValuePair;
import org.apache.http.message.BasicNameValuePair;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.ArrayList;
import java.util.List;

/**
 * 医生助手工具类
 * Created by yeshijie on 2021/7/9.
 */
@Component
public class DoctorAssistantUtil {

//    @Value("${doctorAssistant.api}")
    private String doctorAssistant;
//    @Value("${doctorAssistant.target_url}")
    private String targetUrl;
    @Autowired
    private HttpClientUtil httpClientUtil;


    /**
     * 发送医生助手通用方法
     * @param type
     * @param openId
     * @param first
     * @param remark
     * @param keywords
     */
    public void sendWXTemplate(int type,String openId,String cid,String first,String remark,String ... keywords){
        try{
            String doctorAssistantUrl = doctorAssistant + "/wlyy/feldsher/sendDoctorTemplates";
            List<NameValuePair> params = new ArrayList<>();
            params.add(new BasicNameValuePair("type", type+""));
            params.add(new BasicNameValuePair("openId", openId));
            params.add(new BasicNameValuePair("cid", cid));
            params.add(new BasicNameValuePair("url", targetUrl));
            params.add(new BasicNameValuePair("first", first));
            params.add(new BasicNameValuePair("remark", remark));
            params.add(new BasicNameValuePair("keywords", String.join(",",keywords)));

            httpClientUtil.post(doctorAssistantUrl, params, "UTF-8");
        }catch (Exception e){
            e.printStackTrace();
        }

    }


}
